#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 674
#define LARGE_STATE_COUNT 15
#define SYMBOL_COUNT 175
#define ALIAS_COUNT 10
#define TOKEN_COUNT 89
#define EXTERNAL_TOKEN_COUNT 4
#define FIELD_COUNT 7
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 27

enum ts_symbol_identifiers {
  anon_sym_ATimport = 1,
  anon_sym_COMMA = 2,
  anon_sym_SEMI = 3,
  anon_sym_ATmedia = 4,
  anon_sym_ATcharset = 5,
  anon_sym_ATnamespace = 6,
  anon_sym_ATkeyframes = 7,
  aux_sym_keyframes_statement_token1 = 8,
  anon_sym_LBRACE = 9,
  anon_sym_RBRACE = 10,
  anon_sym_from = 11,
  sym_to = 12,
  anon_sym_ATsupports = 13,
  sym_nesting_selector = 14,
  anon_sym_STAR = 15,
  anon_sym_DOT = 16,
  anon_sym_COLON_COLON = 17,
  anon_sym_POUND = 18,
  anon_sym_LBRACK = 19,
  anon_sym_EQ = 20,
  anon_sym_TILDE_EQ = 21,
  anon_sym_CARET_EQ = 22,
  anon_sym_PIPE_EQ = 23,
  anon_sym_STAR_EQ = 24,
  anon_sym_DOLLAR_EQ = 25,
  anon_sym_RBRACK = 26,
  anon_sym_GT = 27,
  anon_sym_TILDE = 28,
  anon_sym_PLUS = 29,
  anon_sym_PIPE = 30,
  anon_sym_LPAREN = 31,
  anon_sym_RPAREN = 32,
  anon_sym_COLON = 33,
  sym_important = 34,
  anon_sym_LPAREN2 = 35,
  anon_sym_and = 36,
  anon_sym_or = 37,
  anon_sym_not = 38,
  anon_sym_only = 39,
  anon_sym_selector = 40,
  aux_sym_color_value_token1 = 41,
  anon_sym_SQUOTE = 42,
  aux_sym_string_value_token1 = 43,
  anon_sym_DQUOTE = 44,
  aux_sym_string_value_token2 = 45,
  aux_sym_integer_value_token1 = 46,
  aux_sym_float_value_token1 = 47,
  sym_unit = 48,
  anon_sym_DASH = 49,
  anon_sym_SLASH = 50,
  anon_sym_EQ_EQ = 51,
  anon_sym_LT = 52,
  anon_sym_BANG_EQ = 53,
  anon_sym_LT_EQ = 54,
  anon_sym_GT_EQ = 55,
  sym_identifier = 56,
  sym_at_keyword = 57,
  sym_js_comment = 58,
  sym_comment = 59,
  sym_plain_value = 60,
  anon_sym_ATuse = 61,
  anon_sym_ATforward = 62,
  anon_sym_ATmixin = 63,
  anon_sym_ATinclude = 64,
  anon_sym_RPAREN2 = 65,
  anon_sym_ATfunction = 66,
  anon_sym_ATreturn = 67,
  anon_sym_ATextend = 68,
  anon_sym_ATerror = 69,
  anon_sym_ATwarn = 70,
  anon_sym_ATdebug = 71,
  anon_sym_ATat_DASHroot = 72,
  anon_sym_ATif = 73,
  anon_sym_ATelse = 74,
  anon_sym_if = 75,
  anon_sym_ATeach = 76,
  anon_sym_in = 77,
  anon_sym_ATfor = 78,
  anon_sym_through = 79,
  anon_sym_ATwhile = 80,
  anon_sym_POUND_LBRACE = 81,
  anon_sym_PERCENT = 82,
  anon_sym_DASH2 = 83,
  sym_variable = 84,
  sym__descendant_operator = 85,
  sym__pseudo_class_selector_colon = 86,
  sym___error_recovery = 87,
  sym__concat = 88,
  sym_stylesheet = 89,
  sym_import_statement = 90,
  sym_media_statement = 91,
  sym_charset_statement = 92,
  sym_namespace_statement = 93,
  sym_keyframes_statement = 94,
  sym_keyframe_block_list = 95,
  sym_keyframe_block = 96,
  sym_from = 97,
  sym_supports_statement = 98,
  sym_postcss_statement = 99,
  sym_at_rule = 100,
  sym_rule_set = 101,
  sym_selectors = 102,
  sym_block = 103,
  sym__selector = 104,
  sym_universal_selector = 105,
  sym_class_selector = 106,
  sym_pseudo_class_selector = 107,
  sym_pseudo_element_selector = 108,
  sym_id_selector = 109,
  sym_attribute_selector = 110,
  sym_child_selector = 111,
  sym_descendant_selector = 112,
  sym_sibling_selector = 113,
  sym_adjacent_sibling_selector = 114,
  sym_namespace_selector = 115,
  sym_pseudo_class_arguments = 116,
  sym_pseudo_element_arguments = 117,
  sym_declaration = 118,
  sym_last_declaration = 119,
  sym__query = 120,
  sym_feature_query = 121,
  sym_parenthesized_query = 122,
  sym_binary_query = 123,
  sym_unary_query = 124,
  sym_selector_query = 125,
  sym__value = 126,
  sym_parenthesized_value = 127,
  sym_color_value = 128,
  sym_string_value = 129,
  sym_integer_value = 130,
  sym_float_value = 131,
  sym_grid_value = 132,
  sym_call_expression = 133,
  sym_binary_expression = 134,
  sym_arguments = 135,
  sym_use_statement = 136,
  sym_forward_statement = 137,
  sym_mixin_statement = 138,
  sym_include_statement = 139,
  sym__include_arguments = 140,
  sym__include_argument = 141,
  sym_function_statement = 142,
  sym_parameters = 143,
  sym_parameter = 144,
  sym_return_statement = 145,
  sym_extend_statement = 146,
  sym_error_statement = 147,
  sym_warn_statement = 148,
  sym_debug_statement = 149,
  sym_at_root_statement = 150,
  sym_if_statement = 151,
  sym_else_if_clause = 152,
  sym_else_clause = 153,
  sym_each_statement = 154,
  sym_for_statement = 155,
  sym_while_statement = 156,
  sym_list_value = 157,
  sym_interpolation = 158,
  sym_placeholder = 159,
  sym__concatenated_identifier = 160,
  aux_sym_stylesheet_repeat1 = 161,
  aux_sym_import_statement_repeat1 = 162,
  aux_sym_keyframe_block_list_repeat1 = 163,
  aux_sym_postcss_statement_repeat1 = 164,
  aux_sym_selectors_repeat1 = 165,
  aux_sym_block_repeat1 = 166,
  aux_sym_pseudo_class_arguments_repeat1 = 167,
  aux_sym_declaration_repeat1 = 168,
  aux_sym_grid_value_repeat1 = 169,
  aux_sym_arguments_repeat1 = 170,
  aux_sym__include_arguments_repeat1 = 171,
  aux_sym_parameters_repeat1 = 172,
  aux_sym_if_statement_repeat1 = 173,
  aux_sym__concatenated_identifier_repeat1 = 174,
  alias_sym_attribute_name = 175,
  alias_sym_class_name = 176,
  alias_sym_feature_name = 177,
  alias_sym_function_name = 178,
  alias_sym_id_name = 179,
  alias_sym_keyframes_name = 180,
  alias_sym_keyword_query = 181,
  alias_sym_namespace_name = 182,
  alias_sym_property_name = 183,
  alias_sym_tag_name = 184,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_ATimport] = "@import",
  [anon_sym_COMMA] = ",",
  [anon_sym_SEMI] = ";",
  [anon_sym_ATmedia] = "@media",
  [anon_sym_ATcharset] = "@charset",
  [anon_sym_ATnamespace] = "@namespace",
  [anon_sym_ATkeyframes] = "@keyframes",
  [aux_sym_keyframes_statement_token1] = "at_keyword",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_from] = "from",
  [sym_to] = "to",
  [anon_sym_ATsupports] = "@supports",
  [sym_nesting_selector] = "nesting_selector",
  [anon_sym_STAR] = "*",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_POUND] = "#",
  [anon_sym_LBRACK] = "[",
  [anon_sym_EQ] = "=",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_DOLLAR_EQ] = "$=",
  [anon_sym_RBRACK] = "]",
  [anon_sym_GT] = ">",
  [anon_sym_TILDE] = "~",
  [anon_sym_PLUS] = "+",
  [anon_sym_PIPE] = "|",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COLON] = ":",
  [sym_important] = "important",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_not] = "not",
  [anon_sym_only] = "only",
  [anon_sym_selector] = "selector",
  [aux_sym_color_value_token1] = "color_value_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_value_token1] = "string_value_token1",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_value_token2] = "string_value_token2",
  [aux_sym_integer_value_token1] = "integer_value_token1",
  [aux_sym_float_value_token1] = "float_value_token1",
  [sym_unit] = "unit",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_LT] = "<",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [sym_identifier] = "identifier",
  [sym_at_keyword] = "at_keyword",
  [sym_js_comment] = "js_comment",
  [sym_comment] = "comment",
  [sym_plain_value] = "plain_value",
  [anon_sym_ATuse] = "@use",
  [anon_sym_ATforward] = "@forward",
  [anon_sym_ATmixin] = "@mixin",
  [anon_sym_ATinclude] = "@include",
  [anon_sym_RPAREN2] = ")",
  [anon_sym_ATfunction] = "@function",
  [anon_sym_ATreturn] = "@return",
  [anon_sym_ATextend] = "@extend",
  [anon_sym_ATerror] = "@error",
  [anon_sym_ATwarn] = "@warn",
  [anon_sym_ATdebug] = "@debug",
  [anon_sym_ATat_DASHroot] = "@at-root",
  [anon_sym_ATif] = "@if",
  [anon_sym_ATelse] = "@else",
  [anon_sym_if] = "if",
  [anon_sym_ATeach] = "@each",
  [anon_sym_in] = "in",
  [anon_sym_ATfor] = "@for",
  [anon_sym_through] = "through",
  [anon_sym_ATwhile] = "@while",
  [anon_sym_POUND_LBRACE] = "#{",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DASH2] = "identifier",
  [sym_variable] = "variable",
  [sym__descendant_operator] = "_descendant_operator",
  [sym__pseudo_class_selector_colon] = ":",
  [sym___error_recovery] = "__error_recovery",
  [sym__concat] = "_concat",
  [sym_stylesheet] = "stylesheet",
  [sym_import_statement] = "import_statement",
  [sym_media_statement] = "media_statement",
  [sym_charset_statement] = "charset_statement",
  [sym_namespace_statement] = "namespace_statement",
  [sym_keyframes_statement] = "keyframes_statement",
  [sym_keyframe_block_list] = "keyframe_block_list",
  [sym_keyframe_block] = "keyframe_block",
  [sym_from] = "from",
  [sym_supports_statement] = "supports_statement",
  [sym_postcss_statement] = "postcss_statement",
  [sym_at_rule] = "at_rule",
  [sym_rule_set] = "rule_set",
  [sym_selectors] = "selectors",
  [sym_block] = "block",
  [sym__selector] = "_selector",
  [sym_universal_selector] = "universal_selector",
  [sym_class_selector] = "class_selector",
  [sym_pseudo_class_selector] = "pseudo_class_selector",
  [sym_pseudo_element_selector] = "pseudo_element_selector",
  [sym_id_selector] = "id_selector",
  [sym_attribute_selector] = "attribute_selector",
  [sym_child_selector] = "child_selector",
  [sym_descendant_selector] = "descendant_selector",
  [sym_sibling_selector] = "sibling_selector",
  [sym_adjacent_sibling_selector] = "adjacent_sibling_selector",
  [sym_namespace_selector] = "namespace_selector",
  [sym_pseudo_class_arguments] = "arguments",
  [sym_pseudo_element_arguments] = "arguments",
  [sym_declaration] = "declaration",
  [sym_last_declaration] = "declaration",
  [sym__query] = "_query",
  [sym_feature_query] = "feature_query",
  [sym_parenthesized_query] = "parenthesized_query",
  [sym_binary_query] = "binary_query",
  [sym_unary_query] = "unary_query",
  [sym_selector_query] = "selector_query",
  [sym__value] = "_value",
  [sym_parenthesized_value] = "parenthesized_value",
  [sym_color_value] = "color_value",
  [sym_string_value] = "string_value",
  [sym_integer_value] = "integer_value",
  [sym_float_value] = "float_value",
  [sym_grid_value] = "grid_value",
  [sym_call_expression] = "call_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_arguments] = "arguments",
  [sym_use_statement] = "use_statement",
  [sym_forward_statement] = "forward_statement",
  [sym_mixin_statement] = "mixin_statement",
  [sym_include_statement] = "include_statement",
  [sym__include_arguments] = "arguments",
  [sym__include_argument] = "argument",
  [sym_function_statement] = "function_statement",
  [sym_parameters] = "parameters",
  [sym_parameter] = "parameter",
  [sym_return_statement] = "return_statement",
  [sym_extend_statement] = "extend_statement",
  [sym_error_statement] = "error_statement",
  [sym_warn_statement] = "warn_statement",
  [sym_debug_statement] = "debug_statement",
  [sym_at_root_statement] = "at_root_statement",
  [sym_if_statement] = "if_statement",
  [sym_else_if_clause] = "else_if_clause",
  [sym_else_clause] = "else_clause",
  [sym_each_statement] = "each_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_list_value] = "list_value",
  [sym_interpolation] = "interpolation",
  [sym_placeholder] = "placeholder",
  [sym__concatenated_identifier] = "_concatenated_identifier",
  [aux_sym_stylesheet_repeat1] = "stylesheet_repeat1",
  [aux_sym_import_statement_repeat1] = "import_statement_repeat1",
  [aux_sym_keyframe_block_list_repeat1] = "keyframe_block_list_repeat1",
  [aux_sym_postcss_statement_repeat1] = "postcss_statement_repeat1",
  [aux_sym_selectors_repeat1] = "selectors_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_pseudo_class_arguments_repeat1] = "pseudo_class_arguments_repeat1",
  [aux_sym_declaration_repeat1] = "declaration_repeat1",
  [aux_sym_grid_value_repeat1] = "grid_value_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym__include_arguments_repeat1] = "_include_arguments_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym__concatenated_identifier_repeat1] = "_concatenated_identifier_repeat1",
  [alias_sym_attribute_name] = "attribute_name",
  [alias_sym_class_name] = "class_name",
  [alias_sym_feature_name] = "feature_name",
  [alias_sym_function_name] = "function_name",
  [alias_sym_id_name] = "id_name",
  [alias_sym_keyframes_name] = "keyframes_name",
  [alias_sym_keyword_query] = "keyword_query",
  [alias_sym_namespace_name] = "namespace_name",
  [alias_sym_property_name] = "property_name",
  [alias_sym_tag_name] = "tag_name",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_ATimport] = anon_sym_ATimport,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_ATmedia] = anon_sym_ATmedia,
  [anon_sym_ATcharset] = anon_sym_ATcharset,
  [anon_sym_ATnamespace] = anon_sym_ATnamespace,
  [anon_sym_ATkeyframes] = anon_sym_ATkeyframes,
  [aux_sym_keyframes_statement_token1] = sym_at_keyword,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_from] = anon_sym_from,
  [sym_to] = sym_to,
  [anon_sym_ATsupports] = anon_sym_ATsupports,
  [sym_nesting_selector] = sym_nesting_selector,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_DOLLAR_EQ] = anon_sym_DOLLAR_EQ,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_important] = sym_important,
  [anon_sym_LPAREN2] = anon_sym_LPAREN,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_only] = anon_sym_only,
  [anon_sym_selector] = anon_sym_selector,
  [aux_sym_color_value_token1] = aux_sym_color_value_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_value_token1] = aux_sym_string_value_token1,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_value_token2] = aux_sym_string_value_token2,
  [aux_sym_integer_value_token1] = aux_sym_integer_value_token1,
  [aux_sym_float_value_token1] = aux_sym_float_value_token1,
  [sym_unit] = sym_unit,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [sym_identifier] = sym_identifier,
  [sym_at_keyword] = sym_at_keyword,
  [sym_js_comment] = sym_js_comment,
  [sym_comment] = sym_comment,
  [sym_plain_value] = sym_plain_value,
  [anon_sym_ATuse] = anon_sym_ATuse,
  [anon_sym_ATforward] = anon_sym_ATforward,
  [anon_sym_ATmixin] = anon_sym_ATmixin,
  [anon_sym_ATinclude] = anon_sym_ATinclude,
  [anon_sym_RPAREN2] = anon_sym_RPAREN,
  [anon_sym_ATfunction] = anon_sym_ATfunction,
  [anon_sym_ATreturn] = anon_sym_ATreturn,
  [anon_sym_ATextend] = anon_sym_ATextend,
  [anon_sym_ATerror] = anon_sym_ATerror,
  [anon_sym_ATwarn] = anon_sym_ATwarn,
  [anon_sym_ATdebug] = anon_sym_ATdebug,
  [anon_sym_ATat_DASHroot] = anon_sym_ATat_DASHroot,
  [anon_sym_ATif] = anon_sym_ATif,
  [anon_sym_ATelse] = anon_sym_ATelse,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_ATeach] = anon_sym_ATeach,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_ATfor] = anon_sym_ATfor,
  [anon_sym_through] = anon_sym_through,
  [anon_sym_ATwhile] = anon_sym_ATwhile,
  [anon_sym_POUND_LBRACE] = anon_sym_POUND_LBRACE,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_DASH2] = sym_identifier,
  [sym_variable] = sym_variable,
  [sym__descendant_operator] = sym__descendant_operator,
  [sym__pseudo_class_selector_colon] = anon_sym_COLON,
  [sym___error_recovery] = sym___error_recovery,
  [sym__concat] = sym__concat,
  [sym_stylesheet] = sym_stylesheet,
  [sym_import_statement] = sym_import_statement,
  [sym_media_statement] = sym_media_statement,
  [sym_charset_statement] = sym_charset_statement,
  [sym_namespace_statement] = sym_namespace_statement,
  [sym_keyframes_statement] = sym_keyframes_statement,
  [sym_keyframe_block_list] = sym_keyframe_block_list,
  [sym_keyframe_block] = sym_keyframe_block,
  [sym_from] = sym_from,
  [sym_supports_statement] = sym_supports_statement,
  [sym_postcss_statement] = sym_postcss_statement,
  [sym_at_rule] = sym_at_rule,
  [sym_rule_set] = sym_rule_set,
  [sym_selectors] = sym_selectors,
  [sym_block] = sym_block,
  [sym__selector] = sym__selector,
  [sym_universal_selector] = sym_universal_selector,
  [sym_class_selector] = sym_class_selector,
  [sym_pseudo_class_selector] = sym_pseudo_class_selector,
  [sym_pseudo_element_selector] = sym_pseudo_element_selector,
  [sym_id_selector] = sym_id_selector,
  [sym_attribute_selector] = sym_attribute_selector,
  [sym_child_selector] = sym_child_selector,
  [sym_descendant_selector] = sym_descendant_selector,
  [sym_sibling_selector] = sym_sibling_selector,
  [sym_adjacent_sibling_selector] = sym_adjacent_sibling_selector,
  [sym_namespace_selector] = sym_namespace_selector,
  [sym_pseudo_class_arguments] = sym_arguments,
  [sym_pseudo_element_arguments] = sym_arguments,
  [sym_declaration] = sym_declaration,
  [sym_last_declaration] = sym_declaration,
  [sym__query] = sym__query,
  [sym_feature_query] = sym_feature_query,
  [sym_parenthesized_query] = sym_parenthesized_query,
  [sym_binary_query] = sym_binary_query,
  [sym_unary_query] = sym_unary_query,
  [sym_selector_query] = sym_selector_query,
  [sym__value] = sym__value,
  [sym_parenthesized_value] = sym_parenthesized_value,
  [sym_color_value] = sym_color_value,
  [sym_string_value] = sym_string_value,
  [sym_integer_value] = sym_integer_value,
  [sym_float_value] = sym_float_value,
  [sym_grid_value] = sym_grid_value,
  [sym_call_expression] = sym_call_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_arguments] = sym_arguments,
  [sym_use_statement] = sym_use_statement,
  [sym_forward_statement] = sym_forward_statement,
  [sym_mixin_statement] = sym_mixin_statement,
  [sym_include_statement] = sym_include_statement,
  [sym__include_arguments] = sym_arguments,
  [sym__include_argument] = sym__include_argument,
  [sym_function_statement] = sym_function_statement,
  [sym_parameters] = sym_parameters,
  [sym_parameter] = sym_parameter,
  [sym_return_statement] = sym_return_statement,
  [sym_extend_statement] = sym_extend_statement,
  [sym_error_statement] = sym_error_statement,
  [sym_warn_statement] = sym_warn_statement,
  [sym_debug_statement] = sym_debug_statement,
  [sym_at_root_statement] = sym_at_root_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_else_if_clause] = sym_else_if_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_each_statement] = sym_each_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_list_value] = sym_list_value,
  [sym_interpolation] = sym_interpolation,
  [sym_placeholder] = sym_placeholder,
  [sym__concatenated_identifier] = sym__concatenated_identifier,
  [aux_sym_stylesheet_repeat1] = aux_sym_stylesheet_repeat1,
  [aux_sym_import_statement_repeat1] = aux_sym_import_statement_repeat1,
  [aux_sym_keyframe_block_list_repeat1] = aux_sym_keyframe_block_list_repeat1,
  [aux_sym_postcss_statement_repeat1] = aux_sym_postcss_statement_repeat1,
  [aux_sym_selectors_repeat1] = aux_sym_selectors_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_pseudo_class_arguments_repeat1] = aux_sym_pseudo_class_arguments_repeat1,
  [aux_sym_declaration_repeat1] = aux_sym_declaration_repeat1,
  [aux_sym_grid_value_repeat1] = aux_sym_grid_value_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym__include_arguments_repeat1] = aux_sym__include_arguments_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym__concatenated_identifier_repeat1] = aux_sym__concatenated_identifier_repeat1,
  [alias_sym_attribute_name] = alias_sym_attribute_name,
  [alias_sym_class_name] = alias_sym_class_name,
  [alias_sym_feature_name] = alias_sym_feature_name,
  [alias_sym_function_name] = alias_sym_function_name,
  [alias_sym_id_name] = alias_sym_id_name,
  [alias_sym_keyframes_name] = alias_sym_keyframes_name,
  [alias_sym_keyword_query] = alias_sym_keyword_query,
  [alias_sym_namespace_name] = alias_sym_namespace_name,
  [alias_sym_property_name] = alias_sym_property_name,
  [alias_sym_tag_name] = alias_sym_tag_name,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_ATimport] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATmedia] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATcharset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATnamespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATkeyframes] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_keyframes_statement_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [sym_to] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_ATsupports] = {
    .visible = true,
    .named = false,
  },
  [sym_nesting_selector] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_important] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_only] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_selector] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_color_value_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_value_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_value_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_value_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_value_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_unit] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_at_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym_js_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_plain_value] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_ATuse] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATforward] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATmixin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATinclude] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATfunction] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATextend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATerror] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATwarn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATdebug] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATat_DASHroot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATelse] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATeach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATfor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_through] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATwhile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH2] = {
    .visible = true,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__descendant_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__pseudo_class_selector_colon] = {
    .visible = true,
    .named = false,
  },
  [sym___error_recovery] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_stylesheet] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_media_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_charset_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_keyframes_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_keyframe_block_list] = {
    .visible = true,
    .named = true,
  },
  [sym_keyframe_block] = {
    .visible = true,
    .named = true,
  },
  [sym_from] = {
    .visible = true,
    .named = true,
  },
  [sym_supports_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_postcss_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_at_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_set] = {
    .visible = true,
    .named = true,
  },
  [sym_selectors] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__selector] = {
    .visible = false,
    .named = true,
  },
  [sym_universal_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_class_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_pseudo_class_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_pseudo_element_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_id_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_child_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_descendant_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_sibling_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_adjacent_sibling_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_namespace_selector] = {
    .visible = true,
    .named = true,
  },
  [sym_pseudo_class_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_pseudo_element_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_last_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__query] = {
    .visible = false,
    .named = true,
  },
  [sym_feature_query] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_query] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_query] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_query] = {
    .visible = true,
    .named = true,
  },
  [sym_selector_query] = {
    .visible = true,
    .named = true,
  },
  [sym__value] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_value] = {
    .visible = true,
    .named = true,
  },
  [sym_color_value] = {
    .visible = true,
    .named = true,
  },
  [sym_string_value] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_value] = {
    .visible = true,
    .named = true,
  },
  [sym_float_value] = {
    .visible = true,
    .named = true,
  },
  [sym_grid_value] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_use_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_forward_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_mixin_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_include_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__include_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym__include_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_function_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_extend_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_error_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_warn_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debug_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_at_root_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_each_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_list_value] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_placeholder] = {
    .visible = true,
    .named = true,
  },
  [sym__concatenated_identifier] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_stylesheet_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_keyframe_block_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_postcss_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_selectors_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pseudo_class_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_grid_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__include_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__concatenated_identifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_attribute_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_class_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_feature_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_function_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_id_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_keyframes_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_keyword_query] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_tag_name] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_condition = 1,
  field_default = 2,
  field_from = 3,
  field_key = 4,
  field_name = 5,
  field_through = 6,
  field_value = 7,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_condition] = "condition",
  [field_default] = "default",
  [field_from] = "from",
  [field_key] = "key",
  [field_name] = "name",
  [field_through] = "through",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [10] = {.index = 0, .length = 1},
  [11] = {.index = 1, .length = 1},
  [17] = {.index = 2, .length = 1},
  [19] = {.index = 3, .length = 2},
  [20] = {.index = 5, .length = 1},
  [22] = {.index = 6, .length = 1},
  [23] = {.index = 7, .length = 2},
  [24] = {.index = 9, .length = 1},
  [25] = {.index = 10, .length = 2},
  [26] = {.index = 12, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_condition, 1},
  [2] =
    {field_value, 0},
  [3] =
    {field_name, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [5] =
    {field_value, 1},
  [6] =
    {field_default, 2},
  [7] =
    {field_name, 0},
    {field_value, 2},
  [9] =
    {field_condition, 2},
  [10] =
    {field_key, 1},
    {field_value, 3},
  [12] =
    {field_from, 3},
    {field_through, 5},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_tag_name,
  },
  [2] = {
    [1] = alias_sym_class_name,
  },
  [3] = {
    [0] = sym_plain_value,
  },
  [4] = {
    [0] = alias_sym_keyword_query,
  },
  [5] = {
    [1] = alias_sym_tag_name,
  },
  [6] = {
    [1] = alias_sym_id_name,
  },
  [7] = {
    [0] = alias_sym_function_name,
  },
  [8] = {
    [1] = alias_sym_keyframes_name,
  },
  [9] = {
    [1] = alias_sym_attribute_name,
  },
  [12] = {
    [2] = alias_sym_class_name,
  },
  [13] = {
    [2] = alias_sym_tag_name,
  },
  [14] = {
    [2] = alias_sym_id_name,
  },
  [15] = {
    [1] = alias_sym_namespace_name,
  },
  [16] = {
    [0] = alias_sym_property_name,
  },
  [18] = {
    [2] = alias_sym_attribute_name,
  },
  [21] = {
    [1] = alias_sym_feature_name,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_namespace_selector, 2,
    sym_namespace_selector,
    alias_sym_attribute_name,
  sym__concatenated_identifier, 4,
    sym__concatenated_identifier,
    alias_sym_class_name,
    alias_sym_property_name,
    alias_sym_tag_name,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 4,
  [6] = 6,
  [7] = 6,
  [8] = 6,
  [9] = 6,
  [10] = 4,
  [11] = 6,
  [12] = 4,
  [13] = 4,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 19,
  [21] = 18,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 22,
  [26] = 23,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 24,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 30,
  [36] = 29,
  [37] = 37,
  [38] = 38,
  [39] = 34,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 32,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 33,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 32,
  [83] = 28,
  [84] = 33,
  [85] = 34,
  [86] = 69,
  [87] = 45,
  [88] = 53,
  [89] = 38,
  [90] = 71,
  [91] = 73,
  [92] = 47,
  [93] = 48,
  [94] = 49,
  [95] = 74,
  [96] = 51,
  [97] = 75,
  [98] = 77,
  [99] = 64,
  [100] = 62,
  [101] = 70,
  [102] = 81,
  [103] = 79,
  [104] = 32,
  [105] = 76,
  [106] = 60,
  [107] = 66,
  [108] = 72,
  [109] = 63,
  [110] = 61,
  [111] = 58,
  [112] = 33,
  [113] = 65,
  [114] = 57,
  [115] = 115,
  [116] = 56,
  [117] = 54,
  [118] = 78,
  [119] = 50,
  [120] = 52,
  [121] = 67,
  [122] = 80,
  [123] = 46,
  [124] = 55,
  [125] = 37,
  [126] = 40,
  [127] = 44,
  [128] = 34,
  [129] = 43,
  [130] = 130,
  [131] = 130,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 144,
  [146] = 144,
  [147] = 147,
  [148] = 144,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 133,
  [153] = 134,
  [154] = 138,
  [155] = 155,
  [156] = 132,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 138,
  [161] = 136,
  [162] = 132,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 134,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 166,
  [176] = 176,
  [177] = 133,
  [178] = 176,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 141,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 184,
  [187] = 187,
  [188] = 188,
  [189] = 138,
  [190] = 190,
  [191] = 191,
  [192] = 191,
  [193] = 184,
  [194] = 194,
  [195] = 195,
  [196] = 184,
  [197] = 136,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 135,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 226,
  [232] = 232,
  [233] = 233,
  [234] = 219,
  [235] = 235,
  [236] = 226,
  [237] = 237,
  [238] = 219,
  [239] = 226,
  [240] = 240,
  [241] = 220,
  [242] = 242,
  [243] = 219,
  [244] = 220,
  [245] = 242,
  [246] = 226,
  [247] = 242,
  [248] = 214,
  [249] = 220,
  [250] = 220,
  [251] = 233,
  [252] = 237,
  [253] = 230,
  [254] = 229,
  [255] = 215,
  [256] = 226,
  [257] = 257,
  [258] = 258,
  [259] = 227,
  [260] = 216,
  [261] = 261,
  [262] = 242,
  [263] = 226,
  [264] = 264,
  [265] = 265,
  [266] = 225,
  [267] = 226,
  [268] = 228,
  [269] = 232,
  [270] = 258,
  [271] = 257,
  [272] = 218,
  [273] = 223,
  [274] = 221,
  [275] = 222,
  [276] = 226,
  [277] = 277,
  [278] = 141,
  [279] = 115,
  [280] = 277,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 142,
  [288] = 139,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 134,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 133,
  [307] = 307,
  [308] = 132,
  [309] = 309,
  [310] = 143,
  [311] = 311,
  [312] = 143,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 138,
  [318] = 318,
  [319] = 319,
  [320] = 136,
  [321] = 321,
  [322] = 322,
  [323] = 138,
  [324] = 159,
  [325] = 134,
  [326] = 133,
  [327] = 159,
  [328] = 134,
  [329] = 133,
  [330] = 132,
  [331] = 132,
  [332] = 332,
  [333] = 333,
  [334] = 200,
  [335] = 335,
  [336] = 291,
  [337] = 337,
  [338] = 141,
  [339] = 136,
  [340] = 285,
  [341] = 168,
  [342] = 342,
  [343] = 169,
  [344] = 344,
  [345] = 286,
  [346] = 346,
  [347] = 347,
  [348] = 138,
  [349] = 136,
  [350] = 195,
  [351] = 201,
  [352] = 183,
  [353] = 194,
  [354] = 199,
  [355] = 198,
  [356] = 169,
  [357] = 201,
  [358] = 200,
  [359] = 181,
  [360] = 195,
  [361] = 168,
  [362] = 316,
  [363] = 187,
  [364] = 185,
  [365] = 198,
  [366] = 180,
  [367] = 141,
  [368] = 190,
  [369] = 180,
  [370] = 183,
  [371] = 194,
  [372] = 187,
  [373] = 199,
  [374] = 141,
  [375] = 322,
  [376] = 181,
  [377] = 190,
  [378] = 185,
  [379] = 379,
  [380] = 321,
  [381] = 147,
  [382] = 379,
  [383] = 383,
  [384] = 143,
  [385] = 344,
  [386] = 159,
  [387] = 346,
  [388] = 337,
  [389] = 333,
  [390] = 390,
  [391] = 347,
  [392] = 392,
  [393] = 392,
  [394] = 394,
  [395] = 395,
  [396] = 132,
  [397] = 133,
  [398] = 134,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 136,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 138,
  [409] = 406,
  [410] = 407,
  [411] = 406,
  [412] = 412,
  [413] = 405,
  [414] = 406,
  [415] = 405,
  [416] = 169,
  [417] = 405,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 399,
  [422] = 168,
  [423] = 423,
  [424] = 200,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 425,
  [436] = 169,
  [437] = 437,
  [438] = 433,
  [439] = 201,
  [440] = 141,
  [441] = 181,
  [442] = 195,
  [443] = 434,
  [444] = 432,
  [445] = 429,
  [446] = 426,
  [447] = 190,
  [448] = 185,
  [449] = 198,
  [450] = 180,
  [451] = 428,
  [452] = 199,
  [453] = 194,
  [454] = 183,
  [455] = 427,
  [456] = 187,
  [457] = 168,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 458,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 460,
  [469] = 465,
  [470] = 462,
  [471] = 458,
  [472] = 472,
  [473] = 463,
  [474] = 474,
  [475] = 472,
  [476] = 464,
  [477] = 458,
  [478] = 458,
  [479] = 479,
  [480] = 479,
  [481] = 474,
  [482] = 458,
  [483] = 458,
  [484] = 458,
  [485] = 485,
  [486] = 458,
  [487] = 487,
  [488] = 488,
  [489] = 488,
  [490] = 487,
  [491] = 491,
  [492] = 491,
  [493] = 493,
  [494] = 494,
  [495] = 494,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 138,
  [502] = 502,
  [503] = 502,
  [504] = 504,
  [505] = 497,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 508,
  [512] = 509,
  [513] = 510,
  [514] = 514,
  [515] = 515,
  [516] = 514,
  [517] = 517,
  [518] = 518,
  [519] = 515,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 522,
  [525] = 515,
  [526] = 526,
  [527] = 515,
  [528] = 528,
  [529] = 523,
  [530] = 515,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 517,
  [535] = 523,
  [536] = 526,
  [537] = 34,
  [538] = 33,
  [539] = 532,
  [540] = 515,
  [541] = 523,
  [542] = 542,
  [543] = 531,
  [544] = 32,
  [545] = 515,
  [546] = 546,
  [547] = 520,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 548,
  [558] = 558,
  [559] = 553,
  [560] = 560,
  [561] = 550,
  [562] = 551,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 550,
  [568] = 568,
  [569] = 551,
  [570] = 570,
  [571] = 551,
  [572] = 550,
  [573] = 573,
  [574] = 555,
  [575] = 575,
  [576] = 168,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 578,
  [582] = 575,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 586,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 591,
  [593] = 585,
  [594] = 580,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 596,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 602,
  [605] = 596,
  [606] = 606,
  [607] = 596,
  [608] = 602,
  [609] = 609,
  [610] = 602,
  [611] = 611,
  [612] = 603,
  [613] = 603,
  [614] = 614,
  [615] = 601,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 599,
  [624] = 601,
  [625] = 596,
  [626] = 602,
  [627] = 606,
  [628] = 596,
  [629] = 629,
  [630] = 603,
  [631] = 631,
  [632] = 632,
  [633] = 601,
  [634] = 634,
  [635] = 602,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 620,
  [640] = 619,
  [641] = 629,
  [642] = 616,
  [643] = 617,
  [644] = 618,
  [645] = 645,
  [646] = 617,
  [647] = 616,
  [648] = 617,
  [649] = 616,
  [650] = 650,
  [651] = 651,
  [652] = 616,
  [653] = 617,
  [654] = 632,
  [655] = 616,
  [656] = 617,
  [657] = 657,
  [658] = 616,
  [659] = 617,
  [660] = 602,
  [661] = 614,
  [662] = 606,
  [663] = 596,
  [664] = 597,
  [665] = 606,
  [666] = 603,
  [667] = 622,
  [668] = 668,
  [669] = 638,
  [670] = 657,
  [671] = 601,
  [672] = 668,
  [673] = 637,
};

static inline bool sym_js_comment_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < 11
        ? c == '\t'
        : c <= '\r')
      : (c <= '!' || (c < ','
        ? (c >= '(' && c <= '*')
        : c <= ',')))
    : (c <= ';' || (c < '{'
      ? (c < ']'
        ? c == '['
        : c <= ']')
      : (c <= '{' || c == '}'))));
}

static inline bool sym_plain_value_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : c <= '\r')
      : (c <= '!' || (c < ','
        ? (c >= '(' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '{'
      ? (c < ']'
        ? c == '['
        : c <= ']')
      : (c <= '{' || c == '}'))));
}

static inline bool sym_plain_value_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : c <= '\r')
      : (c <= '!' || (c < ','
        ? (c >= '(' && c <= '*')
        : c <= ',')))
    : (c <= ';' || (c < '{'
      ? (c < ']'
        ? c == '['
        : c <= ']')
      : (c <= '{' || c == '}'))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(114);
      if (lookahead == '!') ADVANCE(51);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(52);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == ')') ADVANCE(402);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(422);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ':') ADVANCE(156);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '@') ADVANCE(56);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == 'a') ADVANCE(76);
      if (lookahead == 'f') ADVANCE(89);
      if (lookahead == 'i') ADVANCE(65);
      if (lookahead == 'n') ADVANCE(79);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 's') ADVANCE(64);
      if (lookahead == 't') ADVANCE(68);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == '~') ADVANCE(148);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('b' <= lookahead && lookahead <= 'e')) ADVANCE(105);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(51);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(150);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(236);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(239);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '_') ADVANCE(245);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(225);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(226);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(51);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(150);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(236);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(239);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '_') ADVANCE(245);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == '~') ADVANCE(147);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(246);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(51);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(150);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(236);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(239);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '_') ADVANCE(245);
      if (lookahead == 'a') ADVANCE(256);
      if (lookahead == 'o') ADVANCE(260);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(246);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(51);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(150);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(236);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(239);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '_') ADVANCE(245);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == '~') ADVANCE(147);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(246);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(51);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(150);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(236);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(239);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '_') ADVANCE(245);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(246);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(51);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(150);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(236);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(239);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '_') ADVANCE(245);
      if (lookahead == 'a') ADVANCE(256);
      if (lookahead == 'o') ADVANCE(260);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(246);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(70);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(43);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(99);
      if (lookahead == '.') ADVANCE(132);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '_') ADVANCE(245);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(246);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(70);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == '+') ADVANCE(43);
      if (lookahead == '-') ADVANCE(99);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '_') ADVANCE(245);
      if (lookahead == 'n') ADVANCE(257);
      if (lookahead == 'o') ADVANCE(255);
      if (lookahead == 's') ADVANCE(252);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(246);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(237);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(134);
      if (lookahead == '$') ADVANCE(52);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '~') ADVANCE(148);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(134);
      if (lookahead == '$') ADVANCE(52);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '~') ADVANCE(148);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11);
      END_STATE();
    case 12:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(134);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ':') ADVANCE(156);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'o') ADVANCE(86);
      if (lookahead == 't') ADVANCE(67);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13);
      END_STATE();
    case 13:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(134);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ':') ADVANCE(156);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'o') ADVANCE(86);
      if (lookahead == 't') ADVANCE(67);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13);
      END_STATE();
    case 14:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(98);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == '-') ADVANCE(237);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '_') ADVANCE(282);
      if (lookahead == 'n') ADVANCE(218);
      if (lookahead == 'o') ADVANCE(217);
      if (lookahead == 's') ADVANCE(214);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(17);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(98);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == '-') ADVANCE(237);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == 'n') ADVANCE(274);
      if (lookahead == 'o') ADVANCE(273);
      if (lookahead == 's') ADVANCE(270);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(17);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(98);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == '-') ADVANCE(237);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == 'n') ADVANCE(274);
      if (lookahead == 'o') ADVANCE(273);
      if (lookahead == 's') ADVANCE(270);
      if (lookahead == '{') ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(16);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '#') ADVANCE(98);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == '-') ADVANCE(237);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == 'n') ADVANCE(274);
      if (lookahead == 'o') ADVANCE(273);
      if (lookahead == 's') ADVANCE(270);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(17);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 18:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == ')') ADVANCE(402);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ':') ADVANCE(155);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 19:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '}') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      END_STATE();
    case 20:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '}') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 21:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ':') ADVANCE(155);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      END_STATE();
    case 22:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == 't') ADVANCE(229);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 23:
      if (lookahead == '!') ADVANCE(50);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(54);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == 't') ADVANCE(67);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      END_STATE();
    case 24:
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == ')') ADVANCE(402);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == '@') ADVANCE(59);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '}') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(25);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(248);
      END_STATE();
    case 25:
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == '@') ADVANCE(59);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '}') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(25);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(248);
      END_STATE();
    case 26:
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == '@') ADVANCE(57);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '}') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(248);
      END_STATE();
    case 27:
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(423);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == '>') ADVANCE(145);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 28:
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == '>') ADVANCE(145);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 29:
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == '-') ADVANCE(100);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == '_') ADVANCE(265);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 30:
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '-') ADVANCE(100);
      if (lookahead == '/') ADVANCE(37);
      if (lookahead == '_') ADVANCE(265);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 31:
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(52);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(53);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '=') ADVANCE(137);
      if (lookahead == '>') ADVANCE(145);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '~') ADVANCE(148);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 32:
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(52);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(53);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '=') ADVANCE(137);
      if (lookahead == '>') ADVANCE(145);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '~') ADVANCE(148);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(32);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 33:
      if (lookahead == '#') ADVANCE(98);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == 'n') ADVANCE(274);
      if (lookahead == 'o') ADVANCE(273);
      if (lookahead == 's') ADVANCE(270);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 34:
      if (lookahead == '$') ADVANCE(106);
      END_STATE();
    case 35:
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(103);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(155);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'f') ADVANCE(88);
      if (lookahead == 'i') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(86);
      if (lookahead == 't') ADVANCE(80);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '}') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(208);
      END_STATE();
    case 36:
      if (lookahead == '*') ADVANCE(39);
      if (lookahead == '/') ADVANCE(391);
      END_STATE();
    case 37:
      if (lookahead == '*') ADVANCE(39);
      if (lookahead == '/') ADVANCE(388);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(48);
      END_STATE();
    case 38:
      if (lookahead == '*') ADVANCE(38);
      if (lookahead == '/') ADVANCE(392);
      if (lookahead != 0) ADVANCE(39);
      END_STATE();
    case 39:
      if (lookahead == '*') ADVANCE(38);
      if (lookahead != 0) ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '/') ADVANCE(36);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(105);
      if (('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(281);
      if (('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 41:
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '/') ADVANCE(36);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 42:
      if (lookahead == '-') ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(211);
      END_STATE();
    case 43:
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 44:
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == '{') ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      END_STATE();
    case 45:
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == '{') ADVANCE(123);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 46:
      if (lookahead == '/') ADVANCE(36);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      END_STATE();
    case 47:
      if (lookahead == '/') ADVANCE(36);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(105);
      END_STATE();
    case 48:
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == '-' ||
          lookahead == '_') ADVANCE(48);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(396);
      END_STATE();
    case 49:
      if (lookahead == ':') ADVANCE(133);
      END_STATE();
    case 50:
      if (lookahead == '=') ADVANCE(242);
      END_STATE();
    case 51:
      if (lookahead == '=') ADVANCE(242);
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 52:
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 53:
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 54:
      if (lookahead == '=') ADVANCE(240);
      END_STATE();
    case 55:
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(371);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'd') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(284);
      if (lookahead == 'f') ADVANCE(339);
      if (lookahead == 'i') ADVANCE(318);
      if (lookahead == 'k') ADVANCE(304);
      if (lookahead == 'm') ADVANCE(305);
      if (lookahead == 'n') ADVANCE(286);
      if (lookahead == 'r') ADVANCE(312);
      if (lookahead == 's') ADVANCE(380);
      if (lookahead == 'u') ADVANCE(368);
      if (lookahead == 'w') ADVANCE(288);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(371);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'd') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(284);
      if (lookahead == 'f') ADVANCE(346);
      if (lookahead == 'i') ADVANCE(318);
      if (lookahead == 'k') ADVANCE(304);
      if (lookahead == 'm') ADVANCE(305);
      if (lookahead == 'n') ADVANCE(286);
      if (lookahead == 'r') ADVANCE(312);
      if (lookahead == 's') ADVANCE(380);
      if (lookahead == 'w') ADVANCE(288);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(371);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'd') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(285);
      if (lookahead == 'f') ADVANCE(339);
      if (lookahead == 'i') ADVANCE(318);
      if (lookahead == 'k') ADVANCE(304);
      if (lookahead == 'm') ADVANCE(305);
      if (lookahead == 'n') ADVANCE(286);
      if (lookahead == 'r') ADVANCE(312);
      if (lookahead == 's') ADVANCE(380);
      if (lookahead == 'u') ADVANCE(368);
      if (lookahead == 'w') ADVANCE(288);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(371);
      if (lookahead == 'c') ADVANCE(323);
      if (lookahead == 'd') ADVANCE(303);
      if (lookahead == 'e') ADVANCE(285);
      if (lookahead == 'f') ADVANCE(346);
      if (lookahead == 'i') ADVANCE(318);
      if (lookahead == 'k') ADVANCE(304);
      if (lookahead == 'm') ADVANCE(305);
      if (lookahead == 'n') ADVANCE(286);
      if (lookahead == 'r') ADVANCE(312);
      if (lookahead == 's') ADVANCE(380);
      if (lookahead == 'w') ADVANCE(288);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 61:
      if (lookahead == 'c') ADVANCE(95);
      END_STATE();
    case 62:
      if (lookahead == 'd') ADVANCE(159);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 65:
      if (lookahead == 'f') ADVANCE(412);
      if (lookahead == 'n') ADVANCE(414);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(69);
      END_STATE();
    case 67:
      if (lookahead == 'h') ADVANCE(90);
      END_STATE();
    case 68:
      if (lookahead == 'h') ADVANCE(90);
      if (lookahead == 'o') ADVANCE(126);
      END_STATE();
    case 69:
      if (lookahead == 'h') ADVANCE(417);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(73);
      END_STATE();
    case 71:
      if (lookahead == 'l') ADVANCE(97);
      END_STATE();
    case 72:
      if (lookahead == 'l') ADVANCE(63);
      END_STATE();
    case 73:
      if (lookahead == 'm') ADVANCE(85);
      END_STATE();
    case 74:
      if (lookahead == 'm') ADVANCE(125);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(62);
      END_STATE();
    case 76:
      if (lookahead == 'n') ADVANCE(62);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 77:
      if (lookahead == 'n') ADVANCE(71);
      if (lookahead == 'r') ADVANCE(161);
      END_STATE();
    case 78:
      if (lookahead == 'n') ADVANCE(94);
      END_STATE();
    case 79:
      if (lookahead == 'o') ADVANCE(92);
      END_STATE();
    case 80:
      if (lookahead == 'o') ADVANCE(126);
      END_STATE();
    case 81:
      if (lookahead == 'o') ADVANCE(96);
      END_STATE();
    case 82:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 83:
      if (lookahead == 'o') ADVANCE(91);
      END_STATE();
    case 84:
      if (lookahead == 'o') ADVANCE(87);
      END_STATE();
    case 85:
      if (lookahead == 'p') ADVANCE(83);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(161);
      END_STATE();
    case 87:
      if (lookahead == 'r') ADVANCE(171);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(82);
      END_STATE();
    case 89:
      if (lookahead == 'r') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 90:
      if (lookahead == 'r') ADVANCE(81);
      END_STATE();
    case 91:
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 92:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 93:
      if (lookahead == 't') ADVANCE(60);
      END_STATE();
    case 94:
      if (lookahead == 't') ADVANCE(157);
      END_STATE();
    case 95:
      if (lookahead == 't') ADVANCE(84);
      END_STATE();
    case 96:
      if (lookahead == 'u') ADVANCE(66);
      END_STATE();
    case 97:
      if (lookahead == 'y') ADVANCE(167);
      END_STATE();
    case 98:
      if (lookahead == '{') ADVANCE(420);
      END_STATE();
    case 99:
      if (lookahead == '-' ||
          lookahead == '_') ADVANCE(265);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(247);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 100:
      if (lookahead == '-' ||
          lookahead == '_') ADVANCE(265);
      if (lookahead == '/') ADVANCE(108);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 101:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(210);
      END_STATE();
    case 102:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(211);
      END_STATE();
    case 103:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(208);
      END_STATE();
    case 104:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(184);
      END_STATE();
    case 105:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 106:
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(424);
      END_STATE();
    case 107:
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 108:
      if (!sym_plain_value_character_set_2(lookahead)) ADVANCE(48);
      END_STATE();
    case 109:
      if (!sym_plain_value_character_set_2(lookahead)) ADVANCE(396);
      END_STATE();
    case 110:
      if (eof) ADVANCE(114);
      if (lookahead == '!') ADVANCE(51);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(52);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(158);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(235);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(238);
      if (lookahead == ':') ADVANCE(156);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '<') ADVANCE(241);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(146);
      if (lookahead == '@') ADVANCE(56);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '^') ADVANCE(55);
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'f') ADVANCE(88);
      if (lookahead == 'i') ADVANCE(65);
      if (lookahead == 'n') ADVANCE(79);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 's') ADVANCE(64);
      if (lookahead == 't') ADVANCE(68);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(152);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == '~') ADVANCE(148);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(110);
      END_STATE();
    case 111:
      if (eof) ADVANCE(114);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '(') ADVANCE(153);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(156);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '>') ADVANCE(145);
      if (lookahead == '@') ADVANCE(58);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(248);
      END_STATE();
    case 112:
      if (eof) ADVANCE(114);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == ')') ADVANCE(154);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == ',') ADVANCE(116);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(156);
      if (lookahead == ';') ADVANCE(117);
      if (lookahead == '>') ADVANCE(145);
      if (lookahead == '@') ADVANCE(58);
      if (lookahead == '[') ADVANCE(136);
      if (lookahead == ']') ADVANCE(144);
      if (lookahead == '{') ADVANCE(123);
      if (lookahead == '|') ADVANCE(151);
      if (lookahead == '}') ADVANCE(124);
      if (lookahead == '~') ADVANCE(147);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(248);
      END_STATE();
    case 113:
      if (eof) ADVANCE(114);
      if (lookahead == '"') ADVANCE(197);
      if (lookahead == '#') ADVANCE(135);
      if (lookahead == '$') ADVANCE(106);
      if (lookahead == '%') ADVANCE(421);
      if (lookahead == '&') ADVANCE(128);
      if (lookahead == '\'') ADVANCE(187);
      if (lookahead == '*') ADVANCE(129);
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(131);
      if (lookahead == '/') ADVANCE(36);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == '@') ADVANCE(56);
      if (lookahead == '[') ADVANCE(136);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(113);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(248);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_ATimport);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_ATmedia);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_ATcharset);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_ATnamespace);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_ATkeyframes);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(aux_sym_keyframes_statement_token1);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_to);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_ATsupports);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_nesting_selector);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(210);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_POUND);
      if (lookahead == '{') ADVANCE(420);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(240);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DOLLAR_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(244);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(133);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_important);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_and);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_only);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_only);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_only);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_only);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_selector);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_selector);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_selector);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_selector);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(175);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(186);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(176);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(177);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(178);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(179);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(180);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(181);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(182);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(183);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(aux_sym_color_value_token1);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(aux_sym_string_value_token1);
      if (lookahead == '\n') ADVANCE(193);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(194);
      if (lookahead == '\\') ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(aux_sym_string_value_token1);
      if (lookahead == '*') ADVANCE(191);
      if (lookahead == '/') ADVANCE(194);
      if (lookahead == '\\') ADVANCE(196);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(193);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_string_value_token1);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '/') ADVANCE(193);
      if (lookahead == '\\') ADVANCE(195);
      if (lookahead == '\n' ||
          lookahead == '\'') ADVANCE(39);
      if (lookahead != 0) ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_string_value_token1);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '\\') ADVANCE(195);
      if (lookahead == '\n' ||
          lookahead == '\'') ADVANCE(39);
      if (lookahead != 0) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym_string_value_token1);
      if (lookahead == '/') ADVANCE(189);
      if (lookahead == '\\') ADVANCE(196);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(192);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(193);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_string_value_token1);
      if (lookahead == '\\') ADVANCE(196);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_string_value_token1);
      if (lookahead == '\\') ADVANCE(188);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'') ADVANCE(194);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(aux_sym_string_value_token1);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '\\') ADVANCE(191);
      if (lookahead == '*') ADVANCE(190);
      if (lookahead == '\\') ADVANCE(195);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(aux_sym_string_value_token1);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(193);
      if (lookahead == '\\') ADVANCE(196);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(aux_sym_string_value_token2);
      if (lookahead == '\n') ADVANCE(203);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(204);
      if (lookahead == '\\') ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(aux_sym_string_value_token2);
      if (lookahead == '*') ADVANCE(201);
      if (lookahead == '/') ADVANCE(204);
      if (lookahead == '\\') ADVANCE(206);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"') ADVANCE(203);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(aux_sym_string_value_token2);
      if (lookahead == '*') ADVANCE(200);
      if (lookahead == '/') ADVANCE(203);
      if (lookahead == '\\') ADVANCE(205);
      if (lookahead == '\n' ||
          lookahead == '"') ADVANCE(39);
      if (lookahead != 0) ADVANCE(201);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(aux_sym_string_value_token2);
      if (lookahead == '*') ADVANCE(200);
      if (lookahead == '\\') ADVANCE(205);
      if (lookahead == '\n' ||
          lookahead == '"') ADVANCE(39);
      if (lookahead != 0) ADVANCE(201);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(aux_sym_string_value_token2);
      if (lookahead == '/') ADVANCE(199);
      if (lookahead == '\\') ADVANCE(206);
      if (lookahead == '\t' ||
          (11 <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"') ADVANCE(203);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym_string_value_token2);
      if (lookahead == '\\') ADVANCE(206);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"') ADVANCE(203);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(aux_sym_string_value_token2);
      if (lookahead == '\\') ADVANCE(198);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"') ADVANCE(204);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(aux_sym_string_value_token2);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '\\') ADVANCE(201);
      if (lookahead == '*') ADVANCE(200);
      if (lookahead == '\\') ADVANCE(205);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(aux_sym_string_value_token2);
      if (lookahead != 0 &&
          lookahead != '\\') ADVANCE(203);
      if (lookahead == '\\') ADVANCE(206);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(aux_sym_integer_value_token1);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym_integer_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(208);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(aux_sym_float_value_token1);
      if (lookahead == '/') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(aux_sym_float_value_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(210);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(aux_sym_float_value_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'c') ADVANCE(222);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(212);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'e') ADVANCE(216);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(223);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'l') ADVANCE(213);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'n') ADVANCE(215);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(221);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'o') ADVANCE(220);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'r') ADVANCE(172);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 't') ADVANCE(164);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 't') ADVANCE(219);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == 'y') ADVANCE(168);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(234);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(224);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(227);
      if (lookahead == '-') ADVANCE(266);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == '_') ADVANCE(264);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(226);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%') ADVANCE(227);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == '_') ADVANCE(264);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(226);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(227);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == 'g') ADVANCE(230);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == 'h') ADVANCE(232);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == 'h') ADVANCE(418);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == 'o') ADVANCE(233);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == 'r') ADVANCE(231);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == 'u') ADVANCE(228);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(sym_unit);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-' ||
          lookahead == '_') ADVANCE(265);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(247);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(207);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(39);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(39);
      if (lookahead == '/') ADVANCE(388);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(48);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(243);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(265);
      if (lookahead == '.') ADVANCE(34);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == '_') ADVANCE(245);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(266);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(266);
      if (lookahead == '/') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(34);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(248);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'c') ADVANCE(262);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'd') ADVANCE(160);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'e') ADVANCE(249);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'e') ADVANCE(254);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'l') ADVANCE(263);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'l') ADVANCE(251);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'n') ADVANCE(253);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'n') ADVANCE(250);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'o') ADVANCE(261);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'o') ADVANCE(259);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'r') ADVANCE(173);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'r') ADVANCE(162);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 't') ADVANCE(165);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 't') ADVANCE(258);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == 'y') ADVANCE(169);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(393);
      if (lookahead == '/') ADVANCE(109);
      if (('-' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(264);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '/') ADVANCE(108);
      if (lookahead == '-' ||
          lookahead == '_') ADVANCE(265);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(282);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '/') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(209);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(267);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(278);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(268);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(272);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(279);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(269);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(271);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(277);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(276);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(174);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(166);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(275);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(170);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(185);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(280);
      if (lookahead == '-' ||
          ('G' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('g' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == '-') ADVANCE(356);
      if (lookahead == 'k') ADVANCE(317);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(296);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'l') ADVANCE(369);
      if (lookahead == 'r') ADVANCE(351);
      if (lookahead == 'x') ADVANCE(378);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(296);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(351);
      if (lookahead == 'x') ADVANCE(378);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(330);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(118);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(355);
      if (lookahead == 'h') ADVANCE(324);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(298);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(361);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(357);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(331);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'a') ADVANCE(332);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'b') ADVANCE(379);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'c') ADVANCE(328);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'c') ADVANCE(322);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'c') ADVANCE(377);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'c') ADVANCE(310);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'd') ADVANCE(405);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'd') ADVANCE(399);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'd') ADVANCE(325);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'd') ADVANCE(309);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(294);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(384);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(301);
      if (lookahead == 'i') ADVANCE(383);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(398);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(411);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(419);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(401);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(120);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(367);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(375);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(337);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(365);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(366);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(374);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'e') ADVANCE(385);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'f') ADVANCE(410);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'm') ADVANCE(348);
      if (lookahead == 'n') ADVANCE(295);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'f') ADVANCE(362);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'f') ADVANCE(363);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'g') ADVANCE(408);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'h') ADVANCE(413);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'h') ADVANCE(290);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'i') ADVANCE(329);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'i') ADVANCE(287);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'i') ADVANCE(334);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'i') ADVANCE(344);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'l') ADVANCE(381);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'l') ADVANCE(308);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'm') ADVANCE(311);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'm') ADVANCE(314);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'm') ADVANCE(315);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'n') ADVANCE(407);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'n') ADVANCE(400);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'n') ADVANCE(404);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'n') ADVANCE(403);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'n') ADVANCE(299);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'n') ADVANCE(297);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(352);
      if (lookahead == 'u') ADVANCE(338);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(342);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(353);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(373);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(358);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(336);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(360);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(354);
      if (lookahead == 'u') ADVANCE(338);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'p') ADVANCE(289);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'p') ADVANCE(343);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'p') ADVANCE(345);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'p') ADVANCE(349);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(341);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(415);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(406);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(416);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(333);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(340);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(300);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(372);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(335);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(376);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(370);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(292);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'r') ADVANCE(293);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 's') ADVANCE(127);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 's') ADVANCE(121);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 's') ADVANCE(122);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 's') ADVANCE(347);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 's') ADVANCE(306);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 's') ADVANCE(307);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 's') ADVANCE(316);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 't') ADVANCE(283);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 't') ADVANCE(115);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 't') ADVANCE(409);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 't') ADVANCE(119);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 't') ADVANCE(382);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 't') ADVANCE(364);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 't') ADVANCE(327);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 't') ADVANCE(313);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'u') ADVANCE(321);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'u') ADVANCE(350);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'u') ADVANCE(302);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'u') ADVANCE(359);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'x') ADVANCE(326);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'y') ADVANCE(319);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'y') ADVANCE(320);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(sym_at_keyword);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(387);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(sym_js_comment);
      if (lookahead == '/') ADVANCE(389);
      if (lookahead == '-' ||
          lookahead == '_') ADVANCE(388);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(397);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(391);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_js_comment);
      if (sym_js_comment_character_set_1(lookahead)) ADVANCE(391);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(388);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_js_comment);
      if (sym_js_comment_character_set_1(lookahead)) ADVANCE(391);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(397);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_js_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(391);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_plain_value);
      if (lookahead == '$') ADVANCE(394);
      if (lookahead == '/') ADVANCE(109);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_plain_value);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(395);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_plain_value);
      if (lookahead == '/') ADVANCE(109);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(395);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_plain_value);
      if (lookahead == '/') ADVANCE(109);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(396);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_plain_value);
      if (lookahead == '/') ADVANCE(390);
      if (!sym_plain_value_character_set_1(lookahead)) ADVANCE(397);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(anon_sym_ATuse);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(anon_sym_ATforward);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_ATmixin);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_ATinclude);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_RPAREN2);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_ATfunction);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_ATreturn);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_ATextend);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_ATerror);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_ATwarn);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_ATdebug);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_ATat_DASHroot);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_ATif);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym_ATelse);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym_ATeach);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_ATfor);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == 'w') ADVANCE(291);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_ATfor);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_through);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_through);
      if (lookahead == '%' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(234);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_ATwhile);
      if (lookahead == 'k') ADVANCE(317);
      if (lookahead == '-' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(386);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_') ADVANCE(387);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_DASH2);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_DASH2);
      if (lookahead == '-' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(282);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(sym_variable);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(424);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 111, .external_lex_state = 2},
  [2] = {.lex_state = 111, .external_lex_state = 2},
  [3] = {.lex_state = 111, .external_lex_state = 2},
  [4] = {.lex_state = 24, .external_lex_state = 2},
  [5] = {.lex_state = 24, .external_lex_state = 2},
  [6] = {.lex_state = 24, .external_lex_state = 2},
  [7] = {.lex_state = 24, .external_lex_state = 2},
  [8] = {.lex_state = 24, .external_lex_state = 2},
  [9] = {.lex_state = 24, .external_lex_state = 2},
  [10] = {.lex_state = 24, .external_lex_state = 2},
  [11] = {.lex_state = 24, .external_lex_state = 2},
  [12] = {.lex_state = 24, .external_lex_state = 2},
  [13] = {.lex_state = 24, .external_lex_state = 2},
  [14] = {.lex_state = 24, .external_lex_state = 2},
  [15] = {.lex_state = 7, .external_lex_state = 2},
  [16] = {.lex_state = 7, .external_lex_state = 2},
  [17] = {.lex_state = 7, .external_lex_state = 2},
  [18] = {.lex_state = 7, .external_lex_state = 2},
  [19] = {.lex_state = 7, .external_lex_state = 2},
  [20] = {.lex_state = 7, .external_lex_state = 2},
  [21] = {.lex_state = 7, .external_lex_state = 2},
  [22] = {.lex_state = 113, .external_lex_state = 2},
  [23] = {.lex_state = 113, .external_lex_state = 2},
  [24] = {.lex_state = 113, .external_lex_state = 2},
  [25] = {.lex_state = 26, .external_lex_state = 2},
  [26] = {.lex_state = 26, .external_lex_state = 2},
  [27] = {.lex_state = 4},
  [28] = {.lex_state = 113, .external_lex_state = 2},
  [29] = {.lex_state = 8},
  [30] = {.lex_state = 4},
  [31] = {.lex_state = 26, .external_lex_state = 2},
  [32] = {.lex_state = 113, .external_lex_state = 2},
  [33] = {.lex_state = 113, .external_lex_state = 2},
  [34] = {.lex_state = 113, .external_lex_state = 2},
  [35] = {.lex_state = 4},
  [36] = {.lex_state = 8},
  [37] = {.lex_state = 111, .external_lex_state = 2},
  [38] = {.lex_state = 111, .external_lex_state = 2},
  [39] = {.lex_state = 111, .external_lex_state = 2},
  [40] = {.lex_state = 111, .external_lex_state = 2},
  [41] = {.lex_state = 111, .external_lex_state = 2},
  [42] = {.lex_state = 111, .external_lex_state = 2},
  [43] = {.lex_state = 111, .external_lex_state = 2},
  [44] = {.lex_state = 111, .external_lex_state = 2},
  [45] = {.lex_state = 111, .external_lex_state = 2},
  [46] = {.lex_state = 111, .external_lex_state = 2},
  [47] = {.lex_state = 111, .external_lex_state = 2},
  [48] = {.lex_state = 111, .external_lex_state = 2},
  [49] = {.lex_state = 111, .external_lex_state = 2},
  [50] = {.lex_state = 111, .external_lex_state = 2},
  [51] = {.lex_state = 111, .external_lex_state = 2},
  [52] = {.lex_state = 111, .external_lex_state = 2},
  [53] = {.lex_state = 111, .external_lex_state = 2},
  [54] = {.lex_state = 111, .external_lex_state = 2},
  [55] = {.lex_state = 111, .external_lex_state = 2},
  [56] = {.lex_state = 111, .external_lex_state = 2},
  [57] = {.lex_state = 111, .external_lex_state = 2},
  [58] = {.lex_state = 111, .external_lex_state = 2},
  [59] = {.lex_state = 111, .external_lex_state = 2},
  [60] = {.lex_state = 111, .external_lex_state = 2},
  [61] = {.lex_state = 111, .external_lex_state = 2},
  [62] = {.lex_state = 111, .external_lex_state = 2},
  [63] = {.lex_state = 111, .external_lex_state = 2},
  [64] = {.lex_state = 111, .external_lex_state = 2},
  [65] = {.lex_state = 111, .external_lex_state = 2},
  [66] = {.lex_state = 111, .external_lex_state = 2},
  [67] = {.lex_state = 111, .external_lex_state = 2},
  [68] = {.lex_state = 111, .external_lex_state = 2},
  [69] = {.lex_state = 111, .external_lex_state = 2},
  [70] = {.lex_state = 111, .external_lex_state = 2},
  [71] = {.lex_state = 111, .external_lex_state = 2},
  [72] = {.lex_state = 111, .external_lex_state = 2},
  [73] = {.lex_state = 111, .external_lex_state = 2},
  [74] = {.lex_state = 111, .external_lex_state = 2},
  [75] = {.lex_state = 111, .external_lex_state = 2},
  [76] = {.lex_state = 111, .external_lex_state = 2},
  [77] = {.lex_state = 111, .external_lex_state = 2},
  [78] = {.lex_state = 111, .external_lex_state = 2},
  [79] = {.lex_state = 111, .external_lex_state = 2},
  [80] = {.lex_state = 111, .external_lex_state = 2},
  [81] = {.lex_state = 111, .external_lex_state = 2},
  [82] = {.lex_state = 26, .external_lex_state = 2},
  [83] = {.lex_state = 26, .external_lex_state = 2},
  [84] = {.lex_state = 26, .external_lex_state = 2},
  [85] = {.lex_state = 26, .external_lex_state = 2},
  [86] = {.lex_state = 24, .external_lex_state = 2},
  [87] = {.lex_state = 24, .external_lex_state = 2},
  [88] = {.lex_state = 24, .external_lex_state = 2},
  [89] = {.lex_state = 24, .external_lex_state = 2},
  [90] = {.lex_state = 24, .external_lex_state = 2},
  [91] = {.lex_state = 24, .external_lex_state = 2},
  [92] = {.lex_state = 24, .external_lex_state = 2},
  [93] = {.lex_state = 24, .external_lex_state = 2},
  [94] = {.lex_state = 24, .external_lex_state = 2},
  [95] = {.lex_state = 24, .external_lex_state = 2},
  [96] = {.lex_state = 24, .external_lex_state = 2},
  [97] = {.lex_state = 24, .external_lex_state = 2},
  [98] = {.lex_state = 24, .external_lex_state = 2},
  [99] = {.lex_state = 24, .external_lex_state = 2},
  [100] = {.lex_state = 24, .external_lex_state = 2},
  [101] = {.lex_state = 24, .external_lex_state = 2},
  [102] = {.lex_state = 24, .external_lex_state = 2},
  [103] = {.lex_state = 24, .external_lex_state = 2},
  [104] = {.lex_state = 24, .external_lex_state = 2},
  [105] = {.lex_state = 24, .external_lex_state = 2},
  [106] = {.lex_state = 24, .external_lex_state = 2},
  [107] = {.lex_state = 24, .external_lex_state = 2},
  [108] = {.lex_state = 24, .external_lex_state = 2},
  [109] = {.lex_state = 24, .external_lex_state = 2},
  [110] = {.lex_state = 24, .external_lex_state = 2},
  [111] = {.lex_state = 24, .external_lex_state = 2},
  [112] = {.lex_state = 24, .external_lex_state = 2},
  [113] = {.lex_state = 24, .external_lex_state = 2},
  [114] = {.lex_state = 24, .external_lex_state = 2},
  [115] = {.lex_state = 2, .external_lex_state = 3},
  [116] = {.lex_state = 24, .external_lex_state = 2},
  [117] = {.lex_state = 24, .external_lex_state = 2},
  [118] = {.lex_state = 24, .external_lex_state = 2},
  [119] = {.lex_state = 24, .external_lex_state = 2},
  [120] = {.lex_state = 24, .external_lex_state = 2},
  [121] = {.lex_state = 24, .external_lex_state = 2},
  [122] = {.lex_state = 24, .external_lex_state = 2},
  [123] = {.lex_state = 24, .external_lex_state = 2},
  [124] = {.lex_state = 24, .external_lex_state = 2},
  [125] = {.lex_state = 24, .external_lex_state = 2},
  [126] = {.lex_state = 24, .external_lex_state = 2},
  [127] = {.lex_state = 24, .external_lex_state = 2},
  [128] = {.lex_state = 24, .external_lex_state = 2},
  [129] = {.lex_state = 24, .external_lex_state = 2},
  [130] = {.lex_state = 8},
  [131] = {.lex_state = 8},
  [132] = {.lex_state = 4, .external_lex_state = 3},
  [133] = {.lex_state = 4, .external_lex_state = 3},
  [134] = {.lex_state = 4, .external_lex_state = 3},
  [135] = {.lex_state = 4, .external_lex_state = 4},
  [136] = {.lex_state = 4, .external_lex_state = 3},
  [137] = {.lex_state = 3, .external_lex_state = 5},
  [138] = {.lex_state = 4, .external_lex_state = 3},
  [139] = {.lex_state = 4, .external_lex_state = 4},
  [140] = {.lex_state = 10, .external_lex_state = 3},
  [141] = {.lex_state = 4, .external_lex_state = 4},
  [142] = {.lex_state = 4, .external_lex_state = 4},
  [143] = {.lex_state = 2, .external_lex_state = 5},
  [144] = {.lex_state = 7},
  [145] = {.lex_state = 7},
  [146] = {.lex_state = 7},
  [147] = {.lex_state = 6, .external_lex_state = 5},
  [148] = {.lex_state = 7},
  [149] = {.lex_state = 7},
  [150] = {.lex_state = 7},
  [151] = {.lex_state = 7},
  [152] = {.lex_state = 4, .external_lex_state = 5},
  [153] = {.lex_state = 4, .external_lex_state = 5},
  [154] = {.lex_state = 6, .external_lex_state = 5},
  [155] = {.lex_state = 7},
  [156] = {.lex_state = 4, .external_lex_state = 5},
  [157] = {.lex_state = 7},
  [158] = {.lex_state = 7},
  [159] = {.lex_state = 2},
  [160] = {.lex_state = 4, .external_lex_state = 5},
  [161] = {.lex_state = 4, .external_lex_state = 5},
  [162] = {.lex_state = 12, .external_lex_state = 3},
  [163] = {.lex_state = 27, .external_lex_state = 2},
  [164] = {.lex_state = 27, .external_lex_state = 2},
  [165] = {.lex_state = 27, .external_lex_state = 2},
  [166] = {.lex_state = 27, .external_lex_state = 2},
  [167] = {.lex_state = 27, .external_lex_state = 2},
  [168] = {.lex_state = 1},
  [169] = {.lex_state = 1},
  [170] = {.lex_state = 27, .external_lex_state = 2},
  [171] = {.lex_state = 12, .external_lex_state = 3},
  [172] = {.lex_state = 7},
  [173] = {.lex_state = 27, .external_lex_state = 2},
  [174] = {.lex_state = 27, .external_lex_state = 2},
  [175] = {.lex_state = 27, .external_lex_state = 2},
  [176] = {.lex_state = 7},
  [177] = {.lex_state = 12, .external_lex_state = 3},
  [178] = {.lex_state = 7},
  [179] = {.lex_state = 27, .external_lex_state = 2},
  [180] = {.lex_state = 4},
  [181] = {.lex_state = 4},
  [182] = {.lex_state = 4},
  [183] = {.lex_state = 4},
  [184] = {.lex_state = 7},
  [185] = {.lex_state = 4},
  [186] = {.lex_state = 7},
  [187] = {.lex_state = 4},
  [188] = {.lex_state = 7},
  [189] = {.lex_state = 12, .external_lex_state = 3},
  [190] = {.lex_state = 4},
  [191] = {.lex_state = 7},
  [192] = {.lex_state = 7},
  [193] = {.lex_state = 7},
  [194] = {.lex_state = 4},
  [195] = {.lex_state = 4},
  [196] = {.lex_state = 7},
  [197] = {.lex_state = 12, .external_lex_state = 3},
  [198] = {.lex_state = 4},
  [199] = {.lex_state = 4},
  [200] = {.lex_state = 4},
  [201] = {.lex_state = 4},
  [202] = {.lex_state = 7},
  [203] = {.lex_state = 7},
  [204] = {.lex_state = 4},
  [205] = {.lex_state = 7},
  [206] = {.lex_state = 4},
  [207] = {.lex_state = 4},
  [208] = {.lex_state = 9, .external_lex_state = 4},
  [209] = {.lex_state = 4},
  [210] = {.lex_state = 7},
  [211] = {.lex_state = 4},
  [212] = {.lex_state = 7},
  [213] = {.lex_state = 7},
  [214] = {.lex_state = 7},
  [215] = {.lex_state = 7},
  [216] = {.lex_state = 7},
  [217] = {.lex_state = 7},
  [218] = {.lex_state = 7},
  [219] = {.lex_state = 7},
  [220] = {.lex_state = 7},
  [221] = {.lex_state = 7},
  [222] = {.lex_state = 7},
  [223] = {.lex_state = 7},
  [224] = {.lex_state = 7},
  [225] = {.lex_state = 7},
  [226] = {.lex_state = 7},
  [227] = {.lex_state = 7},
  [228] = {.lex_state = 7},
  [229] = {.lex_state = 4},
  [230] = {.lex_state = 7},
  [231] = {.lex_state = 7},
  [232] = {.lex_state = 7},
  [233] = {.lex_state = 7},
  [234] = {.lex_state = 7},
  [235] = {.lex_state = 7},
  [236] = {.lex_state = 7},
  [237] = {.lex_state = 4},
  [238] = {.lex_state = 7},
  [239] = {.lex_state = 7},
  [240] = {.lex_state = 7},
  [241] = {.lex_state = 7},
  [242] = {.lex_state = 7},
  [243] = {.lex_state = 7},
  [244] = {.lex_state = 7},
  [245] = {.lex_state = 7},
  [246] = {.lex_state = 7},
  [247] = {.lex_state = 7},
  [248] = {.lex_state = 7},
  [249] = {.lex_state = 7},
  [250] = {.lex_state = 7},
  [251] = {.lex_state = 7},
  [252] = {.lex_state = 4},
  [253] = {.lex_state = 7},
  [254] = {.lex_state = 4},
  [255] = {.lex_state = 7},
  [256] = {.lex_state = 7},
  [257] = {.lex_state = 7},
  [258] = {.lex_state = 7},
  [259] = {.lex_state = 7},
  [260] = {.lex_state = 7},
  [261] = {.lex_state = 7},
  [262] = {.lex_state = 7},
  [263] = {.lex_state = 7},
  [264] = {.lex_state = 7},
  [265] = {.lex_state = 7},
  [266] = {.lex_state = 7},
  [267] = {.lex_state = 7},
  [268] = {.lex_state = 7},
  [269] = {.lex_state = 7},
  [270] = {.lex_state = 7},
  [271] = {.lex_state = 7},
  [272] = {.lex_state = 7},
  [273] = {.lex_state = 7},
  [274] = {.lex_state = 7},
  [275] = {.lex_state = 7},
  [276] = {.lex_state = 7},
  [277] = {.lex_state = 16},
  [278] = {.lex_state = 12, .external_lex_state = 4},
  [279] = {.lex_state = 12, .external_lex_state = 3},
  [280] = {.lex_state = 16},
  [281] = {.lex_state = 31, .external_lex_state = 4},
  [282] = {.lex_state = 31, .external_lex_state = 4},
  [283] = {.lex_state = 31, .external_lex_state = 4},
  [284] = {.lex_state = 31, .external_lex_state = 4},
  [285] = {.lex_state = 31, .external_lex_state = 4},
  [286] = {.lex_state = 31, .external_lex_state = 3},
  [287] = {.lex_state = 12, .external_lex_state = 4},
  [288] = {.lex_state = 12, .external_lex_state = 4},
  [289] = {.lex_state = 31, .external_lex_state = 4},
  [290] = {.lex_state = 31, .external_lex_state = 4},
  [291] = {.lex_state = 31, .external_lex_state = 3},
  [292] = {.lex_state = 31, .external_lex_state = 4},
  [293] = {.lex_state = 31, .external_lex_state = 4},
  [294] = {.lex_state = 31, .external_lex_state = 4},
  [295] = {.lex_state = 31, .external_lex_state = 4},
  [296] = {.lex_state = 31, .external_lex_state = 4},
  [297] = {.lex_state = 31, .external_lex_state = 4},
  [298] = {.lex_state = 31, .external_lex_state = 4},
  [299] = {.lex_state = 31, .external_lex_state = 4},
  [300] = {.lex_state = 31, .external_lex_state = 4},
  [301] = {.lex_state = 31, .external_lex_state = 4},
  [302] = {.lex_state = 31, .external_lex_state = 3},
  [303] = {.lex_state = 31, .external_lex_state = 4},
  [304] = {.lex_state = 31, .external_lex_state = 4},
  [305] = {.lex_state = 31, .external_lex_state = 4},
  [306] = {.lex_state = 31, .external_lex_state = 3},
  [307] = {.lex_state = 31, .external_lex_state = 4},
  [308] = {.lex_state = 31, .external_lex_state = 3},
  [309] = {.lex_state = 31, .external_lex_state = 4},
  [310] = {.lex_state = 12, .external_lex_state = 5},
  [311] = {.lex_state = 31, .external_lex_state = 4},
  [312] = {.lex_state = 15, .external_lex_state = 5},
  [313] = {.lex_state = 31, .external_lex_state = 4},
  [314] = {.lex_state = 31, .external_lex_state = 4},
  [315] = {.lex_state = 31, .external_lex_state = 4},
  [316] = {.lex_state = 31, .external_lex_state = 3},
  [317] = {.lex_state = 31, .external_lex_state = 3},
  [318] = {.lex_state = 31, .external_lex_state = 3},
  [319] = {.lex_state = 31, .external_lex_state = 3},
  [320] = {.lex_state = 31, .external_lex_state = 3},
  [321] = {.lex_state = 31, .external_lex_state = 3},
  [322] = {.lex_state = 31, .external_lex_state = 3},
  [323] = {.lex_state = 12, .external_lex_state = 5},
  [324] = {.lex_state = 12},
  [325] = {.lex_state = 16, .external_lex_state = 5},
  [326] = {.lex_state = 12, .external_lex_state = 5},
  [327] = {.lex_state = 15},
  [328] = {.lex_state = 12, .external_lex_state = 5},
  [329] = {.lex_state = 16, .external_lex_state = 5},
  [330] = {.lex_state = 12, .external_lex_state = 5},
  [331] = {.lex_state = 16, .external_lex_state = 5},
  [332] = {.lex_state = 12, .external_lex_state = 5},
  [333] = {.lex_state = 31, .external_lex_state = 4},
  [334] = {.lex_state = 16},
  [335] = {.lex_state = 31, .external_lex_state = 4},
  [336] = {.lex_state = 111, .external_lex_state = 3},
  [337] = {.lex_state = 31, .external_lex_state = 4},
  [338] = {.lex_state = 31, .external_lex_state = 4},
  [339] = {.lex_state = 12, .external_lex_state = 5},
  [340] = {.lex_state = 27, .external_lex_state = 4},
  [341] = {.lex_state = 14},
  [342] = {.lex_state = 31, .external_lex_state = 4},
  [343] = {.lex_state = 14},
  [344] = {.lex_state = 31, .external_lex_state = 4},
  [345] = {.lex_state = 111, .external_lex_state = 3},
  [346] = {.lex_state = 31, .external_lex_state = 4},
  [347] = {.lex_state = 31, .external_lex_state = 4},
  [348] = {.lex_state = 16, .external_lex_state = 5},
  [349] = {.lex_state = 16, .external_lex_state = 5},
  [350] = {.lex_state = 16},
  [351] = {.lex_state = 16},
  [352] = {.lex_state = 12},
  [353] = {.lex_state = 12},
  [354] = {.lex_state = 12},
  [355] = {.lex_state = 16},
  [356] = {.lex_state = 20},
  [357] = {.lex_state = 12},
  [358] = {.lex_state = 12},
  [359] = {.lex_state = 12},
  [360] = {.lex_state = 12},
  [361] = {.lex_state = 20},
  [362] = {.lex_state = 111, .external_lex_state = 3},
  [363] = {.lex_state = 12},
  [364] = {.lex_state = 16},
  [365] = {.lex_state = 12},
  [366] = {.lex_state = 16},
  [367] = {.lex_state = 16},
  [368] = {.lex_state = 16},
  [369] = {.lex_state = 12},
  [370] = {.lex_state = 16},
  [371] = {.lex_state = 16},
  [372] = {.lex_state = 16},
  [373] = {.lex_state = 16},
  [374] = {.lex_state = 12},
  [375] = {.lex_state = 111, .external_lex_state = 3},
  [376] = {.lex_state = 16},
  [377] = {.lex_state = 12},
  [378] = {.lex_state = 12},
  [379] = {.lex_state = 111, .external_lex_state = 3},
  [380] = {.lex_state = 111, .external_lex_state = 3},
  [381] = {.lex_state = 12, .external_lex_state = 5},
  [382] = {.lex_state = 111, .external_lex_state = 3},
  [383] = {.lex_state = 111, .external_lex_state = 3},
  [384] = {.lex_state = 18, .external_lex_state = 5},
  [385] = {.lex_state = 111, .external_lex_state = 4},
  [386] = {.lex_state = 18},
  [387] = {.lex_state = 111, .external_lex_state = 4},
  [388] = {.lex_state = 111, .external_lex_state = 4},
  [389] = {.lex_state = 111, .external_lex_state = 4},
  [390] = {.lex_state = 111, .external_lex_state = 4},
  [391] = {.lex_state = 111, .external_lex_state = 4},
  [392] = {.lex_state = 111, .external_lex_state = 4},
  [393] = {.lex_state = 111, .external_lex_state = 4},
  [394] = {.lex_state = 111, .external_lex_state = 4},
  [395] = {.lex_state = 111, .external_lex_state = 4},
  [396] = {.lex_state = 18, .external_lex_state = 5},
  [397] = {.lex_state = 18, .external_lex_state = 5},
  [398] = {.lex_state = 18, .external_lex_state = 5},
  [399] = {.lex_state = 33},
  [400] = {.lex_state = 12},
  [401] = {.lex_state = 33},
  [402] = {.lex_state = 33},
  [403] = {.lex_state = 18, .external_lex_state = 5},
  [404] = {.lex_state = 111, .external_lex_state = 4},
  [405] = {.lex_state = 12},
  [406] = {.lex_state = 12},
  [407] = {.lex_state = 33},
  [408] = {.lex_state = 18, .external_lex_state = 5},
  [409] = {.lex_state = 12},
  [410] = {.lex_state = 33},
  [411] = {.lex_state = 12},
  [412] = {.lex_state = 18},
  [413] = {.lex_state = 12},
  [414] = {.lex_state = 12},
  [415] = {.lex_state = 12},
  [416] = {.lex_state = 18},
  [417] = {.lex_state = 12},
  [418] = {.lex_state = 111, .external_lex_state = 4},
  [419] = {.lex_state = 33},
  [420] = {.lex_state = 33},
  [421] = {.lex_state = 33},
  [422] = {.lex_state = 18},
  [423] = {.lex_state = 18},
  [424] = {.lex_state = 18},
  [425] = {.lex_state = 12},
  [426] = {.lex_state = 12},
  [427] = {.lex_state = 12},
  [428] = {.lex_state = 12},
  [429] = {.lex_state = 12},
  [430] = {.lex_state = 111, .external_lex_state = 4},
  [431] = {.lex_state = 18},
  [432] = {.lex_state = 111, .external_lex_state = 4},
  [433] = {.lex_state = 12},
  [434] = {.lex_state = 12},
  [435] = {.lex_state = 12},
  [436] = {.lex_state = 22},
  [437] = {.lex_state = 12},
  [438] = {.lex_state = 12},
  [439] = {.lex_state = 18},
  [440] = {.lex_state = 18},
  [441] = {.lex_state = 18},
  [442] = {.lex_state = 18},
  [443] = {.lex_state = 12},
  [444] = {.lex_state = 111, .external_lex_state = 4},
  [445] = {.lex_state = 12},
  [446] = {.lex_state = 12},
  [447] = {.lex_state = 18},
  [448] = {.lex_state = 18},
  [449] = {.lex_state = 18},
  [450] = {.lex_state = 18},
  [451] = {.lex_state = 12},
  [452] = {.lex_state = 18},
  [453] = {.lex_state = 18},
  [454] = {.lex_state = 18},
  [455] = {.lex_state = 12},
  [456] = {.lex_state = 18},
  [457] = {.lex_state = 22},
  [458] = {.lex_state = 12},
  [459] = {.lex_state = 12},
  [460] = {.lex_state = 12},
  [461] = {.lex_state = 12},
  [462] = {.lex_state = 111, .external_lex_state = 4},
  [463] = {.lex_state = 12},
  [464] = {.lex_state = 12},
  [465] = {.lex_state = 12},
  [466] = {.lex_state = 12},
  [467] = {.lex_state = 12},
  [468] = {.lex_state = 12},
  [469] = {.lex_state = 12},
  [470] = {.lex_state = 111, .external_lex_state = 4},
  [471] = {.lex_state = 12},
  [472] = {.lex_state = 12},
  [473] = {.lex_state = 12},
  [474] = {.lex_state = 12},
  [475] = {.lex_state = 12},
  [476] = {.lex_state = 12},
  [477] = {.lex_state = 12},
  [478] = {.lex_state = 12},
  [479] = {.lex_state = 12},
  [480] = {.lex_state = 12},
  [481] = {.lex_state = 12},
  [482] = {.lex_state = 12},
  [483] = {.lex_state = 12},
  [484] = {.lex_state = 12},
  [485] = {.lex_state = 12},
  [486] = {.lex_state = 12},
  [487] = {.lex_state = 29},
  [488] = {.lex_state = 35},
  [489] = {.lex_state = 35},
  [490] = {.lex_state = 29},
  [491] = {.lex_state = 35},
  [492] = {.lex_state = 35},
  [493] = {.lex_state = 35},
  [494] = {.lex_state = 35},
  [495] = {.lex_state = 35},
  [496] = {.lex_state = 35},
  [497] = {.lex_state = 35},
  [498] = {.lex_state = 35},
  [499] = {.lex_state = 35},
  [500] = {.lex_state = 35},
  [501] = {.lex_state = 35},
  [502] = {.lex_state = 29},
  [503] = {.lex_state = 29},
  [504] = {.lex_state = 35},
  [505] = {.lex_state = 35},
  [506] = {.lex_state = 35},
  [507] = {.lex_state = 35},
  [508] = {.lex_state = 35},
  [509] = {.lex_state = 111},
  [510] = {.lex_state = 111},
  [511] = {.lex_state = 35},
  [512] = {.lex_state = 111},
  [513] = {.lex_state = 111},
  [514] = {.lex_state = 35},
  [515] = {.lex_state = 27},
  [516] = {.lex_state = 35},
  [517] = {.lex_state = 27},
  [518] = {.lex_state = 27},
  [519] = {.lex_state = 27},
  [520] = {.lex_state = 27},
  [521] = {.lex_state = 111},
  [522] = {.lex_state = 27},
  [523] = {.lex_state = 111},
  [524] = {.lex_state = 27},
  [525] = {.lex_state = 27},
  [526] = {.lex_state = 111},
  [527] = {.lex_state = 27},
  [528] = {.lex_state = 35},
  [529] = {.lex_state = 111},
  [530] = {.lex_state = 27},
  [531] = {.lex_state = 24},
  [532] = {.lex_state = 24},
  [533] = {.lex_state = 111},
  [534] = {.lex_state = 27},
  [535] = {.lex_state = 111},
  [536] = {.lex_state = 111},
  [537] = {.lex_state = 35},
  [538] = {.lex_state = 35},
  [539] = {.lex_state = 24},
  [540] = {.lex_state = 27},
  [541] = {.lex_state = 111},
  [542] = {.lex_state = 111},
  [543] = {.lex_state = 24},
  [544] = {.lex_state = 35},
  [545] = {.lex_state = 27},
  [546] = {.lex_state = 35},
  [547] = {.lex_state = 27},
  [548] = {.lex_state = 111},
  [549] = {.lex_state = 111},
  [550] = {.lex_state = 111},
  [551] = {.lex_state = 111},
  [552] = {.lex_state = 111},
  [553] = {.lex_state = 35},
  [554] = {.lex_state = 35},
  [555] = {.lex_state = 111},
  [556] = {.lex_state = 111},
  [557] = {.lex_state = 111},
  [558] = {.lex_state = 24},
  [559] = {.lex_state = 35},
  [560] = {.lex_state = 111},
  [561] = {.lex_state = 111},
  [562] = {.lex_state = 111},
  [563] = {.lex_state = 111},
  [564] = {.lex_state = 111},
  [565] = {.lex_state = 24},
  [566] = {.lex_state = 111},
  [567] = {.lex_state = 111},
  [568] = {.lex_state = 111},
  [569] = {.lex_state = 111},
  [570] = {.lex_state = 24},
  [571] = {.lex_state = 111},
  [572] = {.lex_state = 111},
  [573] = {.lex_state = 111},
  [574] = {.lex_state = 111},
  [575] = {.lex_state = 111},
  [576] = {.lex_state = 45},
  [577] = {.lex_state = 111},
  [578] = {.lex_state = 35},
  [579] = {.lex_state = 111},
  [580] = {.lex_state = 111},
  [581] = {.lex_state = 35},
  [582] = {.lex_state = 111},
  [583] = {.lex_state = 111},
  [584] = {.lex_state = 111},
  [585] = {.lex_state = 111},
  [586] = {.lex_state = 111},
  [587] = {.lex_state = 111},
  [588] = {.lex_state = 24},
  [589] = {.lex_state = 111},
  [590] = {.lex_state = 111},
  [591] = {.lex_state = 40},
  [592] = {.lex_state = 40},
  [593] = {.lex_state = 111},
  [594] = {.lex_state = 111},
  [595] = {.lex_state = 111},
  [596] = {.lex_state = 111},
  [597] = {.lex_state = 111},
  [598] = {.lex_state = 27},
  [599] = {.lex_state = 111},
  [600] = {.lex_state = 111},
  [601] = {.lex_state = 111},
  [602] = {.lex_state = 111},
  [603] = {.lex_state = 111},
  [604] = {.lex_state = 111},
  [605] = {.lex_state = 111},
  [606] = {.lex_state = 47},
  [607] = {.lex_state = 111},
  [608] = {.lex_state = 111},
  [609] = {.lex_state = 111},
  [610] = {.lex_state = 111},
  [611] = {.lex_state = 111},
  [612] = {.lex_state = 111},
  [613] = {.lex_state = 111},
  [614] = {.lex_state = 27},
  [615] = {.lex_state = 111},
  [616] = {.lex_state = 192},
  [617] = {.lex_state = 202},
  [618] = {.lex_state = 27},
  [619] = {.lex_state = 27},
  [620] = {.lex_state = 27},
  [621] = {.lex_state = 24},
  [622] = {.lex_state = 35},
  [623] = {.lex_state = 111},
  [624] = {.lex_state = 111},
  [625] = {.lex_state = 111},
  [626] = {.lex_state = 111},
  [627] = {.lex_state = 47},
  [628] = {.lex_state = 111},
  [629] = {.lex_state = 35},
  [630] = {.lex_state = 111},
  [631] = {.lex_state = 27},
  [632] = {.lex_state = 111},
  [633] = {.lex_state = 111},
  [634] = {.lex_state = 111},
  [635] = {.lex_state = 111},
  [636] = {.lex_state = 27},
  [637] = {.lex_state = 111},
  [638] = {.lex_state = 111},
  [639] = {.lex_state = 27},
  [640] = {.lex_state = 27},
  [641] = {.lex_state = 35},
  [642] = {.lex_state = 192},
  [643] = {.lex_state = 202},
  [644] = {.lex_state = 27},
  [645] = {.lex_state = 111},
  [646] = {.lex_state = 202},
  [647] = {.lex_state = 192},
  [648] = {.lex_state = 202},
  [649] = {.lex_state = 192},
  [650] = {.lex_state = 27},
  [651] = {.lex_state = 27},
  [652] = {.lex_state = 192},
  [653] = {.lex_state = 202},
  [654] = {.lex_state = 111},
  [655] = {.lex_state = 192},
  [656] = {.lex_state = 202},
  [657] = {.lex_state = 111},
  [658] = {.lex_state = 192},
  [659] = {.lex_state = 202},
  [660] = {.lex_state = 111},
  [661] = {.lex_state = 27},
  [662] = {.lex_state = 47},
  [663] = {.lex_state = 111},
  [664] = {.lex_state = 111},
  [665] = {.lex_state = 47},
  [666] = {.lex_state = 111},
  [667] = {.lex_state = 35},
  [668] = {.lex_state = 35},
  [669] = {.lex_state = 111},
  [670] = {.lex_state = 111},
  [671] = {.lex_state = 111},
  [672] = {.lex_state = 35},
  [673] = {.lex_state = 111},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_ATimport] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_ATmedia] = ACTIONS(1),
    [anon_sym_ATcharset] = ACTIONS(1),
    [anon_sym_ATnamespace] = ACTIONS(1),
    [anon_sym_ATkeyframes] = ACTIONS(1),
    [aux_sym_keyframes_statement_token1] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [sym_to] = ACTIONS(1),
    [anon_sym_ATsupports] = ACTIONS(1),
    [sym_nesting_selector] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [sym_important] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_only] = ACTIONS(1),
    [anon_sym_selector] = ACTIONS(1),
    [aux_sym_color_value_token1] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [sym_at_keyword] = ACTIONS(1),
    [sym_js_comment] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATuse] = ACTIONS(1),
    [anon_sym_ATforward] = ACTIONS(1),
    [anon_sym_ATmixin] = ACTIONS(1),
    [anon_sym_ATinclude] = ACTIONS(1),
    [anon_sym_RPAREN2] = ACTIONS(1),
    [anon_sym_ATfunction] = ACTIONS(1),
    [anon_sym_ATreturn] = ACTIONS(1),
    [anon_sym_ATextend] = ACTIONS(1),
    [anon_sym_ATerror] = ACTIONS(1),
    [anon_sym_ATwarn] = ACTIONS(1),
    [anon_sym_ATdebug] = ACTIONS(1),
    [anon_sym_ATat_DASHroot] = ACTIONS(1),
    [anon_sym_ATif] = ACTIONS(1),
    [anon_sym_ATelse] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_ATeach] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_ATfor] = ACTIONS(1),
    [anon_sym_through] = ACTIONS(1),
    [anon_sym_ATwhile] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DASH2] = ACTIONS(1),
    [sym__descendant_operator] = ACTIONS(1),
    [sym__pseudo_class_selector_colon] = ACTIONS(1),
    [sym___error_recovery] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
  },
  [1] = {
    [sym_stylesheet] = STATE(634),
    [sym_import_statement] = STATE(3),
    [sym_media_statement] = STATE(3),
    [sym_charset_statement] = STATE(3),
    [sym_namespace_statement] = STATE(3),
    [sym_keyframes_statement] = STATE(3),
    [sym_supports_statement] = STATE(3),
    [sym_postcss_statement] = STATE(3),
    [sym_at_rule] = STATE(3),
    [sym_rule_set] = STATE(3),
    [sym_selectors] = STATE(575),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(3),
    [sym_string_value] = STATE(395),
    [sym_use_statement] = STATE(3),
    [sym_forward_statement] = STATE(3),
    [sym_mixin_statement] = STATE(3),
    [sym_include_statement] = STATE(3),
    [sym_function_statement] = STATE(3),
    [sym_return_statement] = STATE(3),
    [sym_extend_statement] = STATE(3),
    [sym_error_statement] = STATE(3),
    [sym_warn_statement] = STATE(3),
    [sym_debug_statement] = STATE(3),
    [sym_at_root_statement] = STATE(3),
    [sym_if_statement] = STATE(3),
    [sym_each_statement] = STATE(3),
    [sym_for_statement] = STATE(3),
    [sym_while_statement] = STATE(3),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(393),
    [aux_sym_stylesheet_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(7),
    [anon_sym_ATimport] = ACTIONS(9),
    [anon_sym_ATmedia] = ACTIONS(11),
    [anon_sym_ATcharset] = ACTIONS(13),
    [anon_sym_ATnamespace] = ACTIONS(15),
    [anon_sym_ATkeyframes] = ACTIONS(17),
    [aux_sym_keyframes_statement_token1] = ACTIONS(17),
    [anon_sym_ATsupports] = ACTIONS(19),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(37),
    [sym_at_keyword] = ACTIONS(39),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATuse] = ACTIONS(41),
    [anon_sym_ATforward] = ACTIONS(43),
    [anon_sym_ATmixin] = ACTIONS(45),
    [anon_sym_ATinclude] = ACTIONS(47),
    [anon_sym_ATfunction] = ACTIONS(49),
    [anon_sym_ATreturn] = ACTIONS(51),
    [anon_sym_ATextend] = ACTIONS(53),
    [anon_sym_ATerror] = ACTIONS(55),
    [anon_sym_ATwarn] = ACTIONS(57),
    [anon_sym_ATdebug] = ACTIONS(59),
    [anon_sym_ATat_DASHroot] = ACTIONS(61),
    [anon_sym_ATif] = ACTIONS(63),
    [anon_sym_ATeach] = ACTIONS(65),
    [anon_sym_ATfor] = ACTIONS(67),
    [anon_sym_ATwhile] = ACTIONS(69),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(75),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [2] = {
    [sym_import_statement] = STATE(2),
    [sym_media_statement] = STATE(2),
    [sym_charset_statement] = STATE(2),
    [sym_namespace_statement] = STATE(2),
    [sym_keyframes_statement] = STATE(2),
    [sym_supports_statement] = STATE(2),
    [sym_postcss_statement] = STATE(2),
    [sym_at_rule] = STATE(2),
    [sym_rule_set] = STATE(2),
    [sym_selectors] = STATE(575),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(2),
    [sym_string_value] = STATE(395),
    [sym_use_statement] = STATE(2),
    [sym_forward_statement] = STATE(2),
    [sym_mixin_statement] = STATE(2),
    [sym_include_statement] = STATE(2),
    [sym_function_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_extend_statement] = STATE(2),
    [sym_error_statement] = STATE(2),
    [sym_warn_statement] = STATE(2),
    [sym_debug_statement] = STATE(2),
    [sym_at_root_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_each_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_while_statement] = STATE(2),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(393),
    [aux_sym_stylesheet_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(79),
    [anon_sym_ATimport] = ACTIONS(81),
    [anon_sym_ATmedia] = ACTIONS(84),
    [anon_sym_ATcharset] = ACTIONS(87),
    [anon_sym_ATnamespace] = ACTIONS(90),
    [anon_sym_ATkeyframes] = ACTIONS(93),
    [aux_sym_keyframes_statement_token1] = ACTIONS(93),
    [anon_sym_ATsupports] = ACTIONS(96),
    [sym_nesting_selector] = ACTIONS(99),
    [anon_sym_STAR] = ACTIONS(102),
    [anon_sym_DOT] = ACTIONS(105),
    [anon_sym_COLON_COLON] = ACTIONS(108),
    [anon_sym_POUND] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(114),
    [anon_sym_SQUOTE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(120),
    [sym_identifier] = ACTIONS(123),
    [sym_at_keyword] = ACTIONS(126),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATuse] = ACTIONS(129),
    [anon_sym_ATforward] = ACTIONS(132),
    [anon_sym_ATmixin] = ACTIONS(135),
    [anon_sym_ATinclude] = ACTIONS(138),
    [anon_sym_ATfunction] = ACTIONS(141),
    [anon_sym_ATreturn] = ACTIONS(144),
    [anon_sym_ATextend] = ACTIONS(147),
    [anon_sym_ATerror] = ACTIONS(150),
    [anon_sym_ATwarn] = ACTIONS(153),
    [anon_sym_ATdebug] = ACTIONS(156),
    [anon_sym_ATat_DASHroot] = ACTIONS(159),
    [anon_sym_ATif] = ACTIONS(162),
    [anon_sym_ATeach] = ACTIONS(165),
    [anon_sym_ATfor] = ACTIONS(168),
    [anon_sym_ATwhile] = ACTIONS(171),
    [anon_sym_POUND_LBRACE] = ACTIONS(174),
    [anon_sym_PERCENT] = ACTIONS(177),
    [sym_variable] = ACTIONS(180),
    [sym__pseudo_class_selector_colon] = ACTIONS(183),
  },
  [3] = {
    [sym_import_statement] = STATE(2),
    [sym_media_statement] = STATE(2),
    [sym_charset_statement] = STATE(2),
    [sym_namespace_statement] = STATE(2),
    [sym_keyframes_statement] = STATE(2),
    [sym_supports_statement] = STATE(2),
    [sym_postcss_statement] = STATE(2),
    [sym_at_rule] = STATE(2),
    [sym_rule_set] = STATE(2),
    [sym_selectors] = STATE(575),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(2),
    [sym_string_value] = STATE(395),
    [sym_use_statement] = STATE(2),
    [sym_forward_statement] = STATE(2),
    [sym_mixin_statement] = STATE(2),
    [sym_include_statement] = STATE(2),
    [sym_function_statement] = STATE(2),
    [sym_return_statement] = STATE(2),
    [sym_extend_statement] = STATE(2),
    [sym_error_statement] = STATE(2),
    [sym_warn_statement] = STATE(2),
    [sym_debug_statement] = STATE(2),
    [sym_at_root_statement] = STATE(2),
    [sym_if_statement] = STATE(2),
    [sym_each_statement] = STATE(2),
    [sym_for_statement] = STATE(2),
    [sym_while_statement] = STATE(2),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(393),
    [aux_sym_stylesheet_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(186),
    [anon_sym_ATimport] = ACTIONS(9),
    [anon_sym_ATmedia] = ACTIONS(11),
    [anon_sym_ATcharset] = ACTIONS(13),
    [anon_sym_ATnamespace] = ACTIONS(15),
    [anon_sym_ATkeyframes] = ACTIONS(17),
    [aux_sym_keyframes_statement_token1] = ACTIONS(17),
    [anon_sym_ATsupports] = ACTIONS(19),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(37),
    [sym_at_keyword] = ACTIONS(39),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATuse] = ACTIONS(41),
    [anon_sym_ATforward] = ACTIONS(43),
    [anon_sym_ATmixin] = ACTIONS(45),
    [anon_sym_ATinclude] = ACTIONS(47),
    [anon_sym_ATfunction] = ACTIONS(49),
    [anon_sym_ATreturn] = ACTIONS(51),
    [anon_sym_ATextend] = ACTIONS(53),
    [anon_sym_ATerror] = ACTIONS(55),
    [anon_sym_ATwarn] = ACTIONS(57),
    [anon_sym_ATdebug] = ACTIONS(59),
    [anon_sym_ATat_DASHroot] = ACTIONS(61),
    [anon_sym_ATif] = ACTIONS(63),
    [anon_sym_ATeach] = ACTIONS(65),
    [anon_sym_ATfor] = ACTIONS(67),
    [anon_sym_ATwhile] = ACTIONS(69),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(75),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [4] = {
    [sym_import_statement] = STATE(14),
    [sym_media_statement] = STATE(14),
    [sym_charset_statement] = STATE(14),
    [sym_namespace_statement] = STATE(14),
    [sym_keyframes_statement] = STATE(14),
    [sym_supports_statement] = STATE(14),
    [sym_postcss_statement] = STATE(14),
    [sym_at_rule] = STATE(14),
    [sym_rule_set] = STATE(14),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(14),
    [sym_last_declaration] = STATE(613),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(14),
    [sym_include_statement] = STATE(14),
    [sym_function_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_extend_statement] = STATE(14),
    [sym_error_statement] = STATE(14),
    [sym_warn_statement] = STATE(14),
    [sym_debug_statement] = STATE(14),
    [sym_at_root_statement] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_each_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(14),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(198),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [5] = {
    [sym_import_statement] = STATE(14),
    [sym_media_statement] = STATE(14),
    [sym_charset_statement] = STATE(14),
    [sym_namespace_statement] = STATE(14),
    [sym_keyframes_statement] = STATE(14),
    [sym_supports_statement] = STATE(14),
    [sym_postcss_statement] = STATE(14),
    [sym_at_rule] = STATE(14),
    [sym_rule_set] = STATE(14),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(14),
    [sym_last_declaration] = STATE(666),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(14),
    [sym_include_statement] = STATE(14),
    [sym_function_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_extend_statement] = STATE(14),
    [sym_error_statement] = STATE(14),
    [sym_warn_statement] = STATE(14),
    [sym_debug_statement] = STATE(14),
    [sym_at_root_statement] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_each_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(14),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(234),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [6] = {
    [sym_import_statement] = STATE(5),
    [sym_media_statement] = STATE(5),
    [sym_charset_statement] = STATE(5),
    [sym_namespace_statement] = STATE(5),
    [sym_keyframes_statement] = STATE(5),
    [sym_supports_statement] = STATE(5),
    [sym_postcss_statement] = STATE(5),
    [sym_at_rule] = STATE(5),
    [sym_rule_set] = STATE(5),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(5),
    [sym_last_declaration] = STATE(671),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(5),
    [sym_include_statement] = STATE(5),
    [sym_function_statement] = STATE(5),
    [sym_return_statement] = STATE(5),
    [sym_extend_statement] = STATE(5),
    [sym_error_statement] = STATE(5),
    [sym_warn_statement] = STATE(5),
    [sym_debug_statement] = STATE(5),
    [sym_at_root_statement] = STATE(5),
    [sym_if_statement] = STATE(5),
    [sym_each_statement] = STATE(5),
    [sym_for_statement] = STATE(5),
    [sym_while_statement] = STATE(5),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(5),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(236),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [7] = {
    [sym_import_statement] = STATE(10),
    [sym_media_statement] = STATE(10),
    [sym_charset_statement] = STATE(10),
    [sym_namespace_statement] = STATE(10),
    [sym_keyframes_statement] = STATE(10),
    [sym_supports_statement] = STATE(10),
    [sym_postcss_statement] = STATE(10),
    [sym_at_rule] = STATE(10),
    [sym_rule_set] = STATE(10),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(10),
    [sym_last_declaration] = STATE(633),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(10),
    [sym_include_statement] = STATE(10),
    [sym_function_statement] = STATE(10),
    [sym_return_statement] = STATE(10),
    [sym_extend_statement] = STATE(10),
    [sym_error_statement] = STATE(10),
    [sym_warn_statement] = STATE(10),
    [sym_debug_statement] = STATE(10),
    [sym_at_root_statement] = STATE(10),
    [sym_if_statement] = STATE(10),
    [sym_each_statement] = STATE(10),
    [sym_for_statement] = STATE(10),
    [sym_while_statement] = STATE(10),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(10),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(238),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [8] = {
    [sym_import_statement] = STATE(12),
    [sym_media_statement] = STATE(12),
    [sym_charset_statement] = STATE(12),
    [sym_namespace_statement] = STATE(12),
    [sym_keyframes_statement] = STATE(12),
    [sym_supports_statement] = STATE(12),
    [sym_postcss_statement] = STATE(12),
    [sym_at_rule] = STATE(12),
    [sym_rule_set] = STATE(12),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(12),
    [sym_last_declaration] = STATE(624),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(12),
    [sym_include_statement] = STATE(12),
    [sym_function_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_extend_statement] = STATE(12),
    [sym_error_statement] = STATE(12),
    [sym_warn_statement] = STATE(12),
    [sym_debug_statement] = STATE(12),
    [sym_at_root_statement] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_each_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(12),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(240),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [9] = {
    [sym_import_statement] = STATE(4),
    [sym_media_statement] = STATE(4),
    [sym_charset_statement] = STATE(4),
    [sym_namespace_statement] = STATE(4),
    [sym_keyframes_statement] = STATE(4),
    [sym_supports_statement] = STATE(4),
    [sym_postcss_statement] = STATE(4),
    [sym_at_rule] = STATE(4),
    [sym_rule_set] = STATE(4),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(4),
    [sym_last_declaration] = STATE(615),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(4),
    [sym_include_statement] = STATE(4),
    [sym_function_statement] = STATE(4),
    [sym_return_statement] = STATE(4),
    [sym_extend_statement] = STATE(4),
    [sym_error_statement] = STATE(4),
    [sym_warn_statement] = STATE(4),
    [sym_debug_statement] = STATE(4),
    [sym_at_root_statement] = STATE(4),
    [sym_if_statement] = STATE(4),
    [sym_each_statement] = STATE(4),
    [sym_for_statement] = STATE(4),
    [sym_while_statement] = STATE(4),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(4),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(242),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [10] = {
    [sym_import_statement] = STATE(14),
    [sym_media_statement] = STATE(14),
    [sym_charset_statement] = STATE(14),
    [sym_namespace_statement] = STATE(14),
    [sym_keyframes_statement] = STATE(14),
    [sym_supports_statement] = STATE(14),
    [sym_postcss_statement] = STATE(14),
    [sym_at_rule] = STATE(14),
    [sym_rule_set] = STATE(14),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(14),
    [sym_last_declaration] = STATE(630),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(14),
    [sym_include_statement] = STATE(14),
    [sym_function_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_extend_statement] = STATE(14),
    [sym_error_statement] = STATE(14),
    [sym_warn_statement] = STATE(14),
    [sym_debug_statement] = STATE(14),
    [sym_at_root_statement] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_each_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(14),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(244),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [11] = {
    [sym_import_statement] = STATE(13),
    [sym_media_statement] = STATE(13),
    [sym_charset_statement] = STATE(13),
    [sym_namespace_statement] = STATE(13),
    [sym_keyframes_statement] = STATE(13),
    [sym_supports_statement] = STATE(13),
    [sym_postcss_statement] = STATE(13),
    [sym_at_rule] = STATE(13),
    [sym_rule_set] = STATE(13),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(13),
    [sym_last_declaration] = STATE(601),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(13),
    [sym_include_statement] = STATE(13),
    [sym_function_statement] = STATE(13),
    [sym_return_statement] = STATE(13),
    [sym_extend_statement] = STATE(13),
    [sym_error_statement] = STATE(13),
    [sym_warn_statement] = STATE(13),
    [sym_debug_statement] = STATE(13),
    [sym_at_root_statement] = STATE(13),
    [sym_if_statement] = STATE(13),
    [sym_each_statement] = STATE(13),
    [sym_for_statement] = STATE(13),
    [sym_while_statement] = STATE(13),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(13),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(246),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [12] = {
    [sym_import_statement] = STATE(14),
    [sym_media_statement] = STATE(14),
    [sym_charset_statement] = STATE(14),
    [sym_namespace_statement] = STATE(14),
    [sym_keyframes_statement] = STATE(14),
    [sym_supports_statement] = STATE(14),
    [sym_postcss_statement] = STATE(14),
    [sym_at_rule] = STATE(14),
    [sym_rule_set] = STATE(14),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(14),
    [sym_last_declaration] = STATE(612),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(14),
    [sym_include_statement] = STATE(14),
    [sym_function_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_extend_statement] = STATE(14),
    [sym_error_statement] = STATE(14),
    [sym_warn_statement] = STATE(14),
    [sym_debug_statement] = STATE(14),
    [sym_at_root_statement] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_each_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(14),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(248),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [13] = {
    [sym_import_statement] = STATE(14),
    [sym_media_statement] = STATE(14),
    [sym_charset_statement] = STATE(14),
    [sym_namespace_statement] = STATE(14),
    [sym_keyframes_statement] = STATE(14),
    [sym_supports_statement] = STATE(14),
    [sym_postcss_statement] = STATE(14),
    [sym_at_rule] = STATE(14),
    [sym_rule_set] = STATE(14),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(14),
    [sym_last_declaration] = STATE(603),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(14),
    [sym_include_statement] = STATE(14),
    [sym_function_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_extend_statement] = STATE(14),
    [sym_error_statement] = STATE(14),
    [sym_warn_statement] = STATE(14),
    [sym_debug_statement] = STATE(14),
    [sym_at_root_statement] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_each_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(14),
    [anon_sym_ATimport] = ACTIONS(188),
    [anon_sym_ATmedia] = ACTIONS(190),
    [anon_sym_ATcharset] = ACTIONS(192),
    [anon_sym_ATnamespace] = ACTIONS(194),
    [anon_sym_ATkeyframes] = ACTIONS(196),
    [aux_sym_keyframes_statement_token1] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_ATsupports] = ACTIONS(200),
    [sym_nesting_selector] = ACTIONS(21),
    [anon_sym_STAR] = ACTIONS(23),
    [anon_sym_DOT] = ACTIONS(25),
    [anon_sym_COLON_COLON] = ACTIONS(27),
    [anon_sym_POUND] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE] = ACTIONS(35),
    [sym_identifier] = ACTIONS(202),
    [sym_at_keyword] = ACTIONS(204),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(206),
    [anon_sym_ATinclude] = ACTIONS(208),
    [anon_sym_ATfunction] = ACTIONS(210),
    [anon_sym_ATreturn] = ACTIONS(212),
    [anon_sym_ATextend] = ACTIONS(214),
    [anon_sym_ATerror] = ACTIONS(216),
    [anon_sym_ATwarn] = ACTIONS(218),
    [anon_sym_ATdebug] = ACTIONS(220),
    [anon_sym_ATat_DASHroot] = ACTIONS(222),
    [anon_sym_ATif] = ACTIONS(224),
    [anon_sym_ATeach] = ACTIONS(226),
    [anon_sym_ATfor] = ACTIONS(228),
    [anon_sym_ATwhile] = ACTIONS(230),
    [anon_sym_POUND_LBRACE] = ACTIONS(71),
    [anon_sym_PERCENT] = ACTIONS(73),
    [sym_variable] = ACTIONS(232),
    [sym__pseudo_class_selector_colon] = ACTIONS(77),
  },
  [14] = {
    [sym_import_statement] = STATE(14),
    [sym_media_statement] = STATE(14),
    [sym_charset_statement] = STATE(14),
    [sym_namespace_statement] = STATE(14),
    [sym_keyframes_statement] = STATE(14),
    [sym_supports_statement] = STATE(14),
    [sym_postcss_statement] = STATE(14),
    [sym_at_rule] = STATE(14),
    [sym_rule_set] = STATE(14),
    [sym_selectors] = STATE(582),
    [sym__selector] = STATE(395),
    [sym_universal_selector] = STATE(395),
    [sym_class_selector] = STATE(395),
    [sym_pseudo_class_selector] = STATE(395),
    [sym_pseudo_element_selector] = STATE(395),
    [sym_id_selector] = STATE(395),
    [sym_attribute_selector] = STATE(395),
    [sym_child_selector] = STATE(395),
    [sym_descendant_selector] = STATE(395),
    [sym_sibling_selector] = STATE(395),
    [sym_adjacent_sibling_selector] = STATE(395),
    [sym_namespace_selector] = STATE(395),
    [sym_declaration] = STATE(14),
    [sym_string_value] = STATE(395),
    [sym_mixin_statement] = STATE(14),
    [sym_include_statement] = STATE(14),
    [sym_function_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_extend_statement] = STATE(14),
    [sym_error_statement] = STATE(14),
    [sym_warn_statement] = STATE(14),
    [sym_debug_statement] = STATE(14),
    [sym_at_root_statement] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_each_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_interpolation] = STATE(171),
    [sym_placeholder] = STATE(395),
    [sym__concatenated_identifier] = STATE(392),
    [aux_sym_block_repeat1] = STATE(14),
    [anon_sym_ATimport] = ACTIONS(252),
    [anon_sym_ATmedia] = ACTIONS(255),
    [anon_sym_ATcharset] = ACTIONS(258),
    [anon_sym_ATnamespace] = ACTIONS(261),
    [anon_sym_ATkeyframes] = ACTIONS(264),
    [aux_sym_keyframes_statement_token1] = ACTIONS(264),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_ATsupports] = ACTIONS(269),
    [sym_nesting_selector] = ACTIONS(272),
    [anon_sym_STAR] = ACTIONS(275),
    [anon_sym_DOT] = ACTIONS(278),
    [anon_sym_COLON_COLON] = ACTIONS(281),
    [anon_sym_POUND] = ACTIONS(284),
    [anon_sym_LBRACK] = ACTIONS(287),
    [anon_sym_SQUOTE] = ACTIONS(290),
    [anon_sym_DQUOTE] = ACTIONS(293),
    [sym_identifier] = ACTIONS(296),
    [sym_at_keyword] = ACTIONS(299),
    [sym_js_comment] = ACTIONS(5),
    [sym_comment] = ACTIONS(5),
    [anon_sym_ATmixin] = ACTIONS(302),
    [anon_sym_ATinclude] = ACTIONS(305),
    [anon_sym_ATfunction] = ACTIONS(308),
    [anon_sym_ATreturn] = ACTIONS(311),
    [anon_sym_ATextend] = ACTIONS(314),
    [anon_sym_ATerror] = ACTIONS(317),
    [anon_sym_ATwarn] = ACTIONS(320),
    [anon_sym_ATdebug] = ACTIONS(323),
    [anon_sym_ATat_DASHroot] = ACTIONS(326),
    [anon_sym_ATif] = ACTIONS(329),
    [anon_sym_ATeach] = ACTIONS(332),
    [anon_sym_ATfor] = ACTIONS(335),
    [anon_sym_ATwhile] = ACTIONS(338),
    [anon_sym_POUND_LBRACE] = ACTIONS(341),
    [anon_sym_PERCENT] = ACTIONS(344),
    [sym_variable] = ACTIONS(347),
    [sym__pseudo_class_selector_colon] = ACTIONS(350),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(353), 1,
      sym_nesting_selector,
    ACTIONS(355), 1,
      anon_sym_DOT,
    ACTIONS(357), 1,
      anon_sym_POUND,
    ACTIONS(359), 1,
      anon_sym_LBRACK,
    ACTIONS(361), 1,
      anon_sym_RPAREN,
    ACTIONS(363), 1,
      sym_important,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(367), 1,
      anon_sym_SQUOTE,
    ACTIONS(369), 1,
      anon_sym_DQUOTE,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(375), 1,
      sym_identifier,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(379), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(381), 1,
      sym_variable,
    STATE(134), 1,
      sym_interpolation,
    STATE(139), 1,
      sym_string_value,
    STATE(142), 1,
      sym__concatenated_identifier,
    STATE(157), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(209), 9,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
    STATE(394), 13,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_placeholder,
  [102] = 27,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(353), 1,
      sym_nesting_selector,
    ACTIONS(355), 1,
      anon_sym_DOT,
    ACTIONS(357), 1,
      anon_sym_POUND,
    ACTIONS(359), 1,
      anon_sym_LBRACK,
    ACTIONS(363), 1,
      sym_important,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(367), 1,
      anon_sym_SQUOTE,
    ACTIONS(369), 1,
      anon_sym_DQUOTE,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(375), 1,
      sym_identifier,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(379), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(383), 1,
      anon_sym_RPAREN,
    STATE(134), 1,
      sym_interpolation,
    STATE(139), 1,
      sym_string_value,
    STATE(142), 1,
      sym__concatenated_identifier,
    STATE(155), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(209), 9,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
    STATE(390), 13,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_placeholder,
  [204] = 26,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(353), 1,
      sym_nesting_selector,
    ACTIONS(355), 1,
      anon_sym_DOT,
    ACTIONS(357), 1,
      anon_sym_POUND,
    ACTIONS(359), 1,
      anon_sym_LBRACK,
    ACTIONS(363), 1,
      sym_important,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(367), 1,
      anon_sym_SQUOTE,
    ACTIONS(369), 1,
      anon_sym_DQUOTE,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(375), 1,
      sym_identifier,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(379), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(381), 1,
      sym_variable,
    STATE(134), 1,
      sym_interpolation,
    STATE(139), 1,
      sym_string_value,
    STATE(142), 1,
      sym__concatenated_identifier,
    STATE(172), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(209), 9,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
    STATE(404), 13,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_placeholder,
  [303] = 26,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(355), 1,
      anon_sym_DOT,
    ACTIONS(385), 1,
      sym_nesting_selector,
    ACTIONS(387), 1,
      anon_sym_POUND,
    ACTIONS(389), 1,
      anon_sym_LBRACK,
    ACTIONS(391), 1,
      sym_important,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(399), 1,
      sym_identifier,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(403), 1,
      sym_variable,
    STATE(171), 1,
      sym_interpolation,
    STATE(287), 1,
      sym__concatenated_identifier,
    STATE(288), 1,
      sym_string_value,
    STATE(335), 1,
      sym_namespace_selector,
    STATE(405), 9,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
    STATE(470), 12,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_placeholder,
  [401] = 26,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(355), 1,
      anon_sym_DOT,
    ACTIONS(385), 1,
      sym_nesting_selector,
    ACTIONS(387), 1,
      anon_sym_POUND,
    ACTIONS(389), 1,
      anon_sym_LBRACK,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(405), 1,
      sym_important,
    ACTIONS(407), 1,
      sym_identifier,
    ACTIONS(409), 1,
      sym_variable,
    STATE(171), 1,
      sym_interpolation,
    STATE(287), 1,
      sym__concatenated_identifier,
    STATE(288), 1,
      sym_string_value,
    STATE(432), 1,
      sym_class_selector,
    STATE(468), 9,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
    STATE(462), 12,
      sym__selector,
      sym_universal_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_placeholder,
  [499] = 26,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(355), 1,
      anon_sym_DOT,
    ACTIONS(385), 1,
      sym_nesting_selector,
    ACTIONS(387), 1,
      anon_sym_POUND,
    ACTIONS(389), 1,
      anon_sym_LBRACK,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(407), 1,
      sym_identifier,
    ACTIONS(411), 1,
      sym_important,
    ACTIONS(413), 1,
      sym_variable,
    STATE(171), 1,
      sym_interpolation,
    STATE(287), 1,
      sym__concatenated_identifier,
    STATE(288), 1,
      sym_string_value,
    STATE(444), 1,
      sym_class_selector,
    STATE(460), 9,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
    STATE(462), 12,
      sym__selector,
      sym_universal_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_placeholder,
  [597] = 26,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(355), 1,
      anon_sym_DOT,
    ACTIONS(385), 1,
      sym_nesting_selector,
    ACTIONS(387), 1,
      anon_sym_POUND,
    ACTIONS(389), 1,
      anon_sym_LBRACK,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(399), 1,
      sym_identifier,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(415), 1,
      sym_important,
    ACTIONS(417), 1,
      sym_variable,
    STATE(171), 1,
      sym_interpolation,
    STATE(287), 1,
      sym__concatenated_identifier,
    STATE(288), 1,
      sym_string_value,
    STATE(335), 1,
      sym_namespace_selector,
    STATE(415), 9,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
    STATE(470), 12,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_placeholder,
  [695] = 6,
    ACTIONS(423), 1,
      anon_sym_ATelse,
    STATE(57), 1,
      sym_else_clause,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(24), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(419), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(421), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [751] = 6,
    ACTIONS(423), 1,
      anon_sym_ATelse,
    STATE(79), 1,
      sym_else_clause,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(22), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(425), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(427), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [807] = 5,
    ACTIONS(433), 1,
      anon_sym_ATelse,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(24), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(429), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(431), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [860] = 6,
    ACTIONS(436), 1,
      anon_sym_ATelse,
    STATE(114), 1,
      sym_else_clause,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(31), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(419), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(421), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [914] = 6,
    ACTIONS(436), 1,
      anon_sym_ATelse,
    STATE(103), 1,
      sym_else_clause,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(25), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(425), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(427), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [968] = 23,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(438), 1,
      anon_sym_COMMA,
    ACTIONS(440), 1,
      anon_sym_SEMI,
    ACTIONS(442), 1,
      anon_sym_RBRACE,
    ACTIONS(444), 1,
      sym_nesting_selector,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(454), 1,
      sym_important,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(464), 1,
      sym_variable,
    STATE(151), 1,
      aux_sym_declaration_repeat1,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(446), 5,
      anon_sym_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(452), 5,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    STATE(206), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [1056] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(466), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(468), 26,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATelse,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1103] = 23,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(470), 1,
      anon_sym_SEMI,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(474), 1,
      anon_sym_LPAREN2,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(480), 1,
      sym_identifier,
    ACTIONS(482), 1,
      anon_sym_POUND_LBRACE,
    STATE(78), 1,
      sym_block,
    STATE(147), 1,
      sym_interpolation,
    STATE(192), 1,
      aux_sym_postcss_statement_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(495), 6,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [1190] = 22,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(438), 1,
      anon_sym_COMMA,
    ACTIONS(444), 1,
      sym_nesting_selector,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(464), 1,
      sym_variable,
    ACTIONS(484), 1,
      anon_sym_SEMI,
    ACTIONS(486), 1,
      sym_important,
    STATE(153), 1,
      sym_interpolation,
    STATE(176), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(446), 5,
      anon_sym_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(452), 5,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    STATE(206), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [1275] = 5,
    ACTIONS(488), 1,
      anon_sym_ATelse,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(31), 2,
      sym_else_if_clause,
      aux_sym_if_statement_repeat1,
    ACTIONS(429), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(431), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1326] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(491), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(493), 26,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATelse,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1373] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(495), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(497), 26,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATelse,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1420] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(499), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(501), 26,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATelse,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1467] = 22,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(438), 1,
      anon_sym_COMMA,
    ACTIONS(440), 1,
      anon_sym_SEMI,
    ACTIONS(444), 1,
      sym_nesting_selector,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(464), 1,
      sym_variable,
    ACTIONS(503), 1,
      sym_important,
    STATE(153), 1,
      sym_interpolation,
    STATE(178), 1,
      aux_sym_declaration_repeat1,
    ACTIONS(446), 5,
      anon_sym_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(452), 5,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    STATE(206), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [1552] = 23,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(474), 1,
      anon_sym_LPAREN2,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(480), 1,
      sym_identifier,
    ACTIONS(482), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(505), 1,
      anon_sym_SEMI,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(118), 1,
      sym_block,
    STATE(147), 1,
      sym_interpolation,
    STATE(191), 1,
      aux_sym_postcss_statement_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(494), 6,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [1639] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(509), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(511), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1685] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(513), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(515), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1731] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(499), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(501), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1777] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(517), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(519), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1823] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(521), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(523), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1869] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(525), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(527), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1915] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(529), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(531), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [1961] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(533), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(535), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2007] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(537), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(539), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2053] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(541), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(543), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2099] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(545), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(547), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2145] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(549), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(551), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2191] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(553), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(555), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2237] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(557), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(559), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2283] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(561), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(563), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2329] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(565), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(567), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2375] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(569), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(571), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2421] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(573), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(575), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2467] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(577), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(579), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2513] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(581), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(583), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2559] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(585), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(587), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2605] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(589), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(591), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2651] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(491), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(493), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2697] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(593), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(595), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2743] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(597), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(599), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2789] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(601), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(603), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2835] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(605), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(607), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2881] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(609), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(611), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2927] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(613), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(615), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [2973] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(617), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(619), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3019] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(621), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(623), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3065] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(495), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(497), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3111] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(625), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(627), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3157] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(629), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(631), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3203] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(633), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(635), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3249] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(637), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(639), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3295] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(641), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(643), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3341] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(645), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(647), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3387] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(649), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(651), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3433] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(653), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(655), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3479] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(657), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(659), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3525] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(621), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(623), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3571] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(419), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(421), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3617] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(661), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(663), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3663] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(665), 12,
      sym__pseudo_class_selector_colon,
      ts_builtin_sym_end,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(667), 25,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATuse,
      anon_sym_ATforward,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3709] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(491), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(493), 24,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATelse,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3754] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(466), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(468), 24,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATelse,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3799] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(495), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(497), 24,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATelse,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3844] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(499), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(501), 24,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATelse,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3889] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(625), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(627), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3933] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(537), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(539), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [3977] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(569), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(571), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4021] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(513), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(515), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4065] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(633), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(635), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4109] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(641), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(643), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4153] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(545), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(547), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4197] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(549), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(551), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4241] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(553), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(555), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4285] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(645), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(647), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4329] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(561), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(563), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4373] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(649), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(651), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4417] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(657), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(659), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4461] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(609), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(611), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4505] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(601), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(603), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4549] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(629), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(631), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4593] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(665), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(667), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4637] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(419), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(421), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4681] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(491), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(493), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4725] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(653), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(655), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4769] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(593), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(595), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4813] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(617), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(619), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4857] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(637), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(639), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4901] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(605), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(607), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4945] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(597), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(599), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [4989] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(589), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(591), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5033] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(495), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(497), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5077] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(613), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(615), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5121] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(585), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(587), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5165] = 10,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LPAREN,
    ACTIONS(679), 1,
      sym__concat,
    STATE(133), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(195), 1,
      sym_arguments,
    ACTIONS(673), 4,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
    ACTIONS(669), 9,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
    ACTIONS(671), 9,
      anon_sym_STAR,
      sym_important,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
    ACTIONS(677), 9,
      anon_sym_LPAREN2,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
  [5223] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(581), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(583), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5267] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(573), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(575), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5311] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(621), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(623), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5355] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(557), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(559), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5399] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(565), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(567), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5443] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(621), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(623), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5487] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(661), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(663), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5531] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(541), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(543), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5575] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(577), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(579), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5619] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(509), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(511), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5663] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(517), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(519), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5707] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(533), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(535), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5751] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(499), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(501), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5795] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(529), 12,
      sym__pseudo_class_selector_colon,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
      anon_sym_PERCENT,
      sym_variable,
    ACTIONS(531), 23,
      anon_sym_ATimport,
      anon_sym_ATmedia,
      anon_sym_ATcharset,
      anon_sym_ATnamespace,
      anon_sym_ATkeyframes,
      aux_sym_keyframes_statement_token1,
      anon_sym_ATsupports,
      anon_sym_POUND,
      sym_identifier,
      sym_at_keyword,
      anon_sym_ATmixin,
      anon_sym_ATinclude,
      anon_sym_ATfunction,
      anon_sym_ATreturn,
      anon_sym_ATextend,
      anon_sym_ATerror,
      anon_sym_ATwarn,
      anon_sym_ATdebug,
      anon_sym_ATat_DASHroot,
      anon_sym_ATif,
      anon_sym_ATeach,
      anon_sym_ATfor,
      anon_sym_ATwhile,
  [5839] = 19,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(687), 1,
      anon_sym_LPAREN2,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(693), 1,
      sym_identifier,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(697), 1,
      sym_variable,
    STATE(381), 1,
      sym_interpolation,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    ACTIONS(681), 2,
      sym_nesting_selector,
      sym_important,
    STATE(554), 6,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
    STATE(414), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [5914] = 19,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(687), 1,
      anon_sym_LPAREN2,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(693), 1,
      sym_identifier,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(701), 1,
      sym_variable,
    STATE(381), 1,
      sym_interpolation,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    ACTIONS(699), 2,
      sym_nesting_selector,
      sym_important,
    STATE(554), 6,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
    STATE(406), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [5989] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(707), 1,
      sym__concat,
    STATE(132), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(705), 12,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(703), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6037] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(679), 1,
      sym__concat,
    STATE(132), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(712), 12,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(710), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6085] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(679), 1,
      sym__concat,
    STATE(133), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(716), 12,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(714), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6133] = 10,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(726), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(289), 1,
      sym__concatenated_identifier,
    ACTIONS(722), 4,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
    ACTIONS(724), 7,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_plain_value,
      sym_variable,
    ACTIONS(718), 9,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
    ACTIONS(720), 9,
      anon_sym_STAR,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [6189] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(705), 12,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(703), 20,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym__concat,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6232] = 10,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LPAREN,
    ACTIONS(732), 1,
      sym__concat,
    STATE(152), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(195), 1,
      sym_arguments,
    ACTIONS(730), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(728), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(671), 11,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
    ACTIONS(677), 12,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
  [6287] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(736), 12,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(734), 20,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym__concat,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6330] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(722), 4,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
    ACTIONS(724), 8,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(718), 9,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
    ACTIONS(720), 10,
      anon_sym_STAR,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6376] = 13,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(738), 1,
      anon_sym_EQ,
    ACTIONS(742), 1,
      anon_sym_RBRACK,
    ACTIONS(744), 1,
      anon_sym_LPAREN,
    ACTIONS(746), 1,
      sym__concat,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(360), 1,
      sym_arguments,
    ACTIONS(673), 3,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(677), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(740), 5,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
    ACTIONS(671), 6,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(669), 8,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_PLUS,
  [6436] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(750), 12,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(748), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6478] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(673), 4,
      anon_sym_DOT,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
    ACTIONS(724), 8,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(669), 9,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_RPAREN,
    ACTIONS(720), 10,
      anon_sym_STAR,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6524] = 8,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LPAREN,
    ACTIONS(732), 1,
      sym__concat,
    STATE(152), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(195), 1,
      sym_arguments,
    ACTIONS(677), 12,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(671), 15,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6574] = 20,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(754), 1,
      anon_sym_RPAREN,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(523), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    ACTIONS(752), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [6647] = 20,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(756), 1,
      anon_sym_RPAREN,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(529), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    ACTIONS(752), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [6720] = 20,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(758), 1,
      anon_sym_RPAREN,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(535), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    ACTIONS(752), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [6793] = 8,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(732), 1,
      sym__concat,
    STATE(152), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(760), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
    ACTIONS(762), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(716), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(714), 13,
      anon_sym_SEMI,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [6842] = 20,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(764), 1,
      anon_sym_RPAREN,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(541), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    ACTIONS(752), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [6915] = 19,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(766), 1,
      anon_sym_COMMA,
    ACTIONS(774), 1,
      anon_sym_POUND,
    ACTIONS(777), 1,
      anon_sym_LBRACK,
    ACTIONS(780), 1,
      anon_sym_LPAREN2,
    ACTIONS(783), 1,
      anon_sym_SQUOTE,
    ACTIONS(786), 1,
      anon_sym_DQUOTE,
    ACTIONS(789), 1,
      aux_sym_integer_value_token1,
    ACTIONS(792), 1,
      aux_sym_float_value_token1,
    ACTIONS(795), 1,
      sym_identifier,
    ACTIONS(798), 1,
      sym_plain_value,
    ACTIONS(801), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(804), 1,
      sym_variable,
    STATE(149), 1,
      aux_sym_declaration_repeat1,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(769), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(771), 2,
      sym_nesting_selector,
      sym_important,
    STATE(206), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [6985] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    ACTIONS(807), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [7053] = 21,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(438), 1,
      anon_sym_COMMA,
    ACTIONS(444), 1,
      sym_nesting_selector,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(464), 1,
      sym_variable,
    ACTIONS(809), 1,
      anon_sym_SEMI,
    ACTIONS(811), 1,
      anon_sym_RBRACE,
    ACTIONS(813), 1,
      sym_important,
    STATE(149), 1,
      aux_sym_declaration_repeat1,
    STATE(153), 1,
      sym_interpolation,
    STATE(206), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [7127] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(732), 1,
      sym__concat,
    STATE(156), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(712), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(710), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [7171] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(732), 1,
      sym__concat,
    STATE(152), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(716), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(714), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [7215] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(736), 13,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_and,
      anon_sym_or,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(734), 16,
      sym__concat,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [7255] = 20,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(815), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_RPAREN,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(560), 1,
      aux_sym_pseudo_class_arguments_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [7327] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(819), 1,
      sym__concat,
    STATE(156), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(705), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(703), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [7371] = 20,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(815), 1,
      anon_sym_COMMA,
    ACTIONS(822), 1,
      anon_sym_RPAREN,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(563), 1,
      aux_sym_pseudo_class_arguments_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [7443] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(829), 1,
      anon_sym_POUND,
    ACTIONS(832), 1,
      anon_sym_LBRACK,
    ACTIONS(835), 1,
      anon_sym_LPAREN2,
    ACTIONS(838), 1,
      anon_sym_SQUOTE,
    ACTIONS(841), 1,
      anon_sym_DQUOTE,
    ACTIONS(844), 1,
      aux_sym_integer_value_token1,
    ACTIONS(847), 1,
      aux_sym_float_value_token1,
    ACTIONS(850), 1,
      sym_identifier,
    ACTIONS(853), 1,
      sym_plain_value,
    ACTIONS(856), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(859), 1,
      sym_variable,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    ACTIONS(826), 2,
      sym_nesting_selector,
      sym_important,
    ACTIONS(824), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [7511] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(675), 1,
      anon_sym_LPAREN,
    STATE(195), 1,
      sym_arguments,
    ACTIONS(724), 12,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(720), 15,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [7555] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(736), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(734), 17,
      sym__concat,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [7594] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(705), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(703), 17,
      sym__concat,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [7633] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(862), 1,
      sym__concat,
    STATE(162), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(705), 4,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(703), 22,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [7676] = 16,
    ACTIONS(21), 1,
      sym_nesting_selector,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(865), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(295), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(385), 14,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_string_value,
      sym_placeholder,
  [7739] = 16,
    ACTIONS(21), 1,
      sym_nesting_selector,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(865), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(295), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(387), 14,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_string_value,
      sym_placeholder,
  [7802] = 16,
    ACTIONS(21), 1,
      sym_nesting_selector,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(865), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(295), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(388), 14,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_string_value,
      sym_placeholder,
  [7865] = 16,
    ACTIONS(21), 1,
      sym_nesting_selector,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(865), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(295), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(389), 14,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_string_value,
      sym_placeholder,
  [7928] = 16,
    ACTIONS(21), 1,
      sym_nesting_selector,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(865), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(295), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(418), 14,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_string_value,
      sym_placeholder,
  [7991] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(871), 1,
      sym_unit,
    ACTIONS(869), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(867), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [8032] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(877), 1,
      sym_unit,
    ACTIONS(875), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(873), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [8073] = 17,
    ACTIONS(21), 1,
      sym_nesting_selector,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(879), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(295), 1,
      sym__concatenated_identifier,
    STATE(335), 1,
      sym_namespace_selector,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(470), 13,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_string_value,
      sym_placeholder,
  [8138] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(746), 1,
      sym__concat,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(716), 4,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(714), 22,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [8181] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    ACTIONS(881), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [8248] = 16,
    ACTIONS(21), 1,
      sym_nesting_selector,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(865), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(295), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(391), 14,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_string_value,
      sym_placeholder,
  [8311] = 17,
    ACTIONS(21), 1,
      sym_nesting_selector,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(883), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(295), 1,
      sym__concatenated_identifier,
    STATE(342), 1,
      sym_namespace_selector,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(470), 13,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_string_value,
      sym_placeholder,
  [8376] = 16,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(885), 1,
      sym_nesting_selector,
    ACTIONS(887), 1,
      anon_sym_DOT,
    ACTIONS(889), 1,
      anon_sym_SQUOTE,
    ACTIONS(891), 1,
      anon_sym_DQUOTE,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(897), 1,
      sym__pseudo_class_selector_colon,
    STATE(295), 1,
      sym__concatenated_identifier,
    STATE(302), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(333), 14,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_string_value,
      sym_placeholder,
  [8439] = 20,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(438), 1,
      anon_sym_COMMA,
    ACTIONS(444), 1,
      sym_nesting_selector,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(464), 1,
      sym_variable,
    ACTIONS(899), 1,
      anon_sym_SEMI,
    ACTIONS(901), 1,
      sym_important,
    STATE(149), 1,
      aux_sym_declaration_repeat1,
    STATE(153), 1,
      sym_interpolation,
    STATE(206), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [8510] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(746), 1,
      sym__concat,
    STATE(162), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(712), 4,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(710), 22,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [8553] = 20,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(438), 1,
      anon_sym_COMMA,
    ACTIONS(444), 1,
      sym_nesting_selector,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(464), 1,
      sym_variable,
    ACTIONS(809), 1,
      anon_sym_SEMI,
    ACTIONS(903), 1,
      sym_important,
    STATE(149), 1,
      aux_sym_declaration_repeat1,
    STATE(153), 1,
      sym_interpolation,
    STATE(206), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [8624] = 16,
    ACTIONS(21), 1,
      sym_nesting_selector,
    ACTIONS(23), 1,
      anon_sym_STAR,
    ACTIONS(25), 1,
      anon_sym_DOT,
    ACTIONS(27), 1,
      anon_sym_COLON_COLON,
    ACTIONS(29), 1,
      anon_sym_POUND,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_SQUOTE,
    ACTIONS(35), 1,
      anon_sym_DQUOTE,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(73), 1,
      anon_sym_PERCENT,
    ACTIONS(77), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(865), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(295), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(430), 14,
      sym__selector,
      sym_universal_selector,
      sym_class_selector,
      sym_pseudo_class_selector,
      sym_pseudo_element_selector,
      sym_id_selector,
      sym_attribute_selector,
      sym_child_selector,
      sym_descendant_selector,
      sym_sibling_selector,
      sym_adjacent_sibling_selector,
      sym_namespace_selector,
      sym_string_value,
      sym_placeholder,
  [8687] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(907), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(905), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [8725] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(911), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(909), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [8763] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(750), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(748), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [8801] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(915), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(913), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [8839] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(917), 1,
      anon_sym_RPAREN,
    STATE(144), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [8905] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(921), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(919), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [8943] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(923), 1,
      anon_sym_RPAREN,
    STATE(146), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [9009] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(927), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(925), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [9047] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(929), 1,
      anon_sym_RPAREN,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [9113] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(736), 4,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(734), 23,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym__concat,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [9151] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(933), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(931), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [9189] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(935), 1,
      anon_sym_SEMI,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [9255] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(937), 1,
      anon_sym_SEMI,
    STATE(153), 1,
      sym_interpolation,
    STATE(158), 1,
      aux_sym_postcss_statement_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [9321] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(939), 1,
      anon_sym_RPAREN,
    STATE(148), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [9387] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(943), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(941), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [9425] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(947), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(945), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [9463] = 18,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(949), 1,
      anon_sym_RPAREN,
    STATE(145), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [9529] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(705), 4,
      anon_sym_GT,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(703), 23,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym__concat,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [9567] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(953), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(951), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [9605] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(957), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(955), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [9643] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(961), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(959), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [9681] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(965), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(963), 16,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [9719] = 17,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    STATE(153), 1,
      sym_interpolation,
    STATE(188), 1,
      aux_sym_postcss_statement_repeat1,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [9782] = 17,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_POUND,
    ACTIONS(971), 1,
      anon_sym_LBRACK,
    ACTIONS(973), 1,
      anon_sym_LPAREN2,
    ACTIONS(975), 1,
      anon_sym_SQUOTE,
    ACTIONS(977), 1,
      anon_sym_DQUOTE,
    ACTIONS(979), 1,
      aux_sym_integer_value_token1,
    ACTIONS(981), 1,
      aux_sym_float_value_token1,
    ACTIONS(983), 1,
      sym_identifier,
    ACTIONS(985), 1,
      sym_plain_value,
    ACTIONS(987), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(989), 1,
      sym_variable,
    STATE(398), 1,
      sym_interpolation,
    STATE(558), 1,
      sym__include_argument,
    ACTIONS(967), 2,
      sym_nesting_selector,
      sym_important,
    STATE(423), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [9845] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_SEMI,
    ACTIONS(811), 1,
      anon_sym_RBRACE,
    ACTIONS(724), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(720), 13,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [9886] = 17,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_POUND,
    ACTIONS(971), 1,
      anon_sym_LBRACK,
    ACTIONS(973), 1,
      anon_sym_LPAREN2,
    ACTIONS(975), 1,
      anon_sym_SQUOTE,
    ACTIONS(977), 1,
      anon_sym_DQUOTE,
    ACTIONS(979), 1,
      aux_sym_integer_value_token1,
    ACTIONS(981), 1,
      aux_sym_float_value_token1,
    ACTIONS(983), 1,
      sym_identifier,
    ACTIONS(985), 1,
      sym_plain_value,
    ACTIONS(987), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(989), 1,
      sym_variable,
    STATE(398), 1,
      sym_interpolation,
    STATE(588), 1,
      sym__include_argument,
    ACTIONS(967), 2,
      sym_nesting_selector,
      sym_important,
    STATE(423), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [9949] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(446), 5,
      anon_sym_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(452), 5,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(993), 6,
      anon_sym_POUND,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(991), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
  [9990] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(446), 5,
      anon_sym_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(452), 5,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(995), 6,
      anon_sym_POUND,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(769), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      sym_nesting_selector,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
  [10031] = 10,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(997), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(289), 1,
      sym__concatenated_identifier,
    ACTIONS(722), 2,
      anon_sym_POUND,
      anon_sym_GT,
    ACTIONS(724), 3,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(720), 8,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(718), 9,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [10080] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(446), 5,
      anon_sym_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(452), 5,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1001), 6,
      anon_sym_POUND,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(999), 10,
      anon_sym_COMMA,
      anon_sym_SEMI,
      sym_nesting_selector,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_POUND_LBRACE,
  [10121] = 17,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(381), 1,
      sym_variable,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    STATE(150), 1,
      aux_sym_postcss_statement_repeat1,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(363), 2,
      sym_nesting_selector,
      sym_important,
    STATE(209), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10184] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_SEMI,
    ACTIONS(1005), 1,
      anon_sym_RBRACE,
    ACTIONS(724), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(720), 13,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [10225] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1009), 1,
      sym_variable,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(1007), 2,
      sym_nesting_selector,
      sym_important,
    STATE(27), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10285] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1015), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1011), 2,
      sym_nesting_selector,
      sym_important,
    STATE(459), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10345] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1019), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1017), 2,
      sym_nesting_selector,
      sym_important,
    STATE(443), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10405] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1023), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1021), 2,
      sym_nesting_selector,
      sym_important,
    STATE(446), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10465] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1027), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1025), 2,
      sym_nesting_selector,
      sym_important,
    STATE(451), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10525] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1031), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1029), 2,
      sym_nesting_selector,
      sym_important,
    STATE(400), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10585] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1035), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1033), 2,
      sym_nesting_selector,
      sym_important,
    STATE(473), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10645] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(701), 1,
      sym_variable,
    ACTIONS(1013), 1,
      sym_identifier,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(699), 2,
      sym_nesting_selector,
      sym_important,
    STATE(406), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10705] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1039), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1037), 2,
      sym_nesting_selector,
      sym_important,
    STATE(369), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10765] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1043), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1041), 2,
      sym_nesting_selector,
      sym_important,
    STATE(469), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10825] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1047), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1045), 2,
      sym_nesting_selector,
      sym_important,
    STATE(475), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10885] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1051), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1049), 2,
      sym_nesting_selector,
      sym_important,
    STATE(481), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [10945] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1055), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1053), 2,
      sym_nesting_selector,
      sym_important,
    STATE(485), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11005] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1059), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1057), 2,
      sym_nesting_selector,
      sym_important,
    STATE(425), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11065] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1063), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1061), 2,
      sym_nesting_selector,
      sym_important,
    STATE(471), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11125] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1067), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1065), 2,
      sym_nesting_selector,
      sym_important,
    STATE(429), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11185] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1071), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1069), 2,
      sym_nesting_selector,
      sym_important,
    STATE(455), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11245] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1073), 1,
      anon_sym_SEMI,
    ACTIONS(724), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(720), 13,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [11283] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1077), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1075), 2,
      sym_nesting_selector,
      sym_important,
    STATE(438), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11343] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1081), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1079), 2,
      sym_nesting_selector,
      sym_important,
    STATE(478), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11403] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_POUND,
    ACTIONS(1087), 1,
      anon_sym_LBRACK,
    ACTIONS(1089), 1,
      anon_sym_LPAREN2,
    ACTIONS(1091), 1,
      anon_sym_SQUOTE,
    ACTIONS(1093), 1,
      anon_sym_DQUOTE,
    ACTIONS(1095), 1,
      aux_sym_integer_value_token1,
    ACTIONS(1097), 1,
      aux_sym_float_value_token1,
    ACTIONS(1099), 1,
      sym_identifier,
    ACTIONS(1101), 1,
      sym_plain_value,
    ACTIONS(1103), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1105), 1,
      sym_variable,
    STATE(325), 1,
      sym_interpolation,
    ACTIONS(1083), 2,
      sym_nesting_selector,
      sym_important,
    STATE(277), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11463] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1109), 1,
      sym_variable,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(1107), 2,
      sym_nesting_selector,
      sym_important,
    STATE(35), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11523] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1113), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1111), 2,
      sym_nesting_selector,
      sym_important,
    STATE(409), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11583] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1117), 1,
      sym_variable,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(1115), 2,
      sym_nesting_selector,
      sym_important,
    STATE(207), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11643] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1121), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1119), 2,
      sym_nesting_selector,
      sym_important,
    STATE(461), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11703] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(899), 1,
      anon_sym_SEMI,
    ACTIONS(724), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(720), 13,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [11741] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(697), 1,
      sym_variable,
    ACTIONS(1013), 1,
      sym_identifier,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(681), 2,
      sym_nesting_selector,
      sym_important,
    STATE(414), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11801] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1125), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1123), 2,
      sym_nesting_selector,
      sym_important,
    STATE(482), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11861] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1129), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1127), 2,
      sym_nesting_selector,
      sym_important,
    STATE(466), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11921] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_POUND,
    ACTIONS(971), 1,
      anon_sym_LBRACK,
    ACTIONS(973), 1,
      anon_sym_LPAREN2,
    ACTIONS(975), 1,
      anon_sym_SQUOTE,
    ACTIONS(977), 1,
      anon_sym_DQUOTE,
    ACTIONS(979), 1,
      aux_sym_integer_value_token1,
    ACTIONS(981), 1,
      aux_sym_float_value_token1,
    ACTIONS(983), 1,
      sym_identifier,
    ACTIONS(985), 1,
      sym_plain_value,
    ACTIONS(987), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1133), 1,
      sym_variable,
    STATE(398), 1,
      sym_interpolation,
    ACTIONS(1131), 2,
      sym_nesting_selector,
      sym_important,
    STATE(450), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [11981] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1137), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1135), 2,
      sym_nesting_selector,
      sym_important,
    STATE(417), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12041] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1141), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1139), 2,
      sym_nesting_selector,
      sym_important,
    STATE(411), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12101] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1039), 1,
      sym_variable,
    ACTIONS(1143), 1,
      aux_sym_integer_value_token1,
    ACTIONS(1145), 1,
      aux_sym_float_value_token1,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1037), 2,
      sym_nesting_selector,
      sym_important,
    STATE(369), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12161] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(417), 1,
      sym_variable,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(415), 2,
      sym_nesting_selector,
      sym_important,
    STATE(415), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12221] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1149), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1147), 2,
      sym_nesting_selector,
      sym_important,
    STATE(486), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12281] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1153), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1151), 2,
      sym_nesting_selector,
      sym_important,
    STATE(413), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12341] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1157), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1155), 2,
      sym_nesting_selector,
      sym_important,
    STATE(434), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12401] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1161), 1,
      sym_variable,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(1159), 2,
      sym_nesting_selector,
      sym_important,
    STATE(180), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12461] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_POUND,
    ACTIONS(1087), 1,
      anon_sym_LBRACK,
    ACTIONS(1089), 1,
      anon_sym_LPAREN2,
    ACTIONS(1091), 1,
      anon_sym_SQUOTE,
    ACTIONS(1093), 1,
      anon_sym_DQUOTE,
    ACTIONS(1095), 1,
      aux_sym_integer_value_token1,
    ACTIONS(1097), 1,
      aux_sym_float_value_token1,
    ACTIONS(1099), 1,
      sym_identifier,
    ACTIONS(1101), 1,
      sym_plain_value,
    ACTIONS(1103), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1165), 1,
      sym_variable,
    STATE(325), 1,
      sym_interpolation,
    ACTIONS(1163), 2,
      sym_nesting_selector,
      sym_important,
    STATE(366), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12521] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(365), 1,
      anon_sym_LPAREN2,
    ACTIONS(371), 1,
      aux_sym_integer_value_token1,
    ACTIONS(373), 1,
      aux_sym_float_value_token1,
    ACTIONS(377), 1,
      sym_plain_value,
    ACTIONS(448), 1,
      anon_sym_POUND,
    ACTIONS(450), 1,
      anon_sym_LBRACK,
    ACTIONS(456), 1,
      anon_sym_SQUOTE,
    ACTIONS(458), 1,
      anon_sym_DQUOTE,
    ACTIONS(460), 1,
      sym_identifier,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1169), 1,
      sym_variable,
    STATE(153), 1,
      sym_interpolation,
    ACTIONS(1167), 2,
      sym_nesting_selector,
      sym_important,
    STATE(30), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12581] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(809), 1,
      anon_sym_SEMI,
    ACTIONS(724), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(720), 13,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [12619] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1173), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1171), 2,
      sym_nesting_selector,
      sym_important,
    STATE(433), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12679] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_SEMI,
    ACTIONS(724), 11,
      anon_sym_POUND,
      anon_sym_GT,
      anon_sym_PLUS,
      aux_sym_integer_value_token1,
      aux_sym_float_value_token1,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
      sym_plain_value,
      sym_variable,
    ACTIONS(720), 13,
      anon_sym_COMMA,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_LBRACK,
      sym_important,
      anon_sym_LPAREN2,
      anon_sym_SQUOTE,
      anon_sym_DQUOTE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [12717] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1177), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1175), 2,
      sym_nesting_selector,
      sym_important,
    STATE(426), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12777] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1181), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1179), 2,
      sym_nesting_selector,
      sym_important,
    STATE(477), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12837] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1185), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1183), 2,
      sym_nesting_selector,
      sym_important,
    STATE(479), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12897] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1143), 1,
      aux_sym_integer_value_token1,
    ACTIONS(1145), 1,
      aux_sym_float_value_token1,
    ACTIONS(1189), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1187), 2,
      sym_nesting_selector,
      sym_important,
    STATE(464), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [12957] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1193), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1191), 2,
      sym_nesting_selector,
      sym_important,
    STATE(445), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13017] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1197), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1195), 2,
      sym_nesting_selector,
      sym_important,
    STATE(428), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13077] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1201), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1199), 2,
      sym_nesting_selector,
      sym_important,
    STATE(467), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13137] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(403), 1,
      sym_variable,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(391), 2,
      sym_nesting_selector,
      sym_important,
    STATE(405), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13197] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1205), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1203), 2,
      sym_nesting_selector,
      sym_important,
    STATE(483), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13257] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(969), 1,
      anon_sym_POUND,
    ACTIONS(971), 1,
      anon_sym_LBRACK,
    ACTIONS(973), 1,
      anon_sym_LPAREN2,
    ACTIONS(975), 1,
      anon_sym_SQUOTE,
    ACTIONS(977), 1,
      anon_sym_DQUOTE,
    ACTIONS(979), 1,
      aux_sym_integer_value_token1,
    ACTIONS(981), 1,
      aux_sym_float_value_token1,
    ACTIONS(983), 1,
      sym_identifier,
    ACTIONS(985), 1,
      sym_plain_value,
    ACTIONS(987), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1209), 1,
      sym_variable,
    STATE(398), 1,
      sym_interpolation,
    ACTIONS(1207), 2,
      sym_nesting_selector,
      sym_important,
    STATE(431), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13317] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1213), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1211), 2,
      sym_nesting_selector,
      sym_important,
    STATE(437), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13377] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1217), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1215), 2,
      sym_nesting_selector,
      sym_important,
    STATE(435), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13437] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1221), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1219), 2,
      sym_nesting_selector,
      sym_important,
    STATE(458), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13497] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1225), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1223), 2,
      sym_nesting_selector,
      sym_important,
    STATE(427), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13557] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1085), 1,
      anon_sym_POUND,
    ACTIONS(1087), 1,
      anon_sym_LBRACK,
    ACTIONS(1089), 1,
      anon_sym_LPAREN2,
    ACTIONS(1091), 1,
      anon_sym_SQUOTE,
    ACTIONS(1093), 1,
      anon_sym_DQUOTE,
    ACTIONS(1095), 1,
      aux_sym_integer_value_token1,
    ACTIONS(1097), 1,
      aux_sym_float_value_token1,
    ACTIONS(1099), 1,
      sym_identifier,
    ACTIONS(1101), 1,
      sym_plain_value,
    ACTIONS(1103), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1229), 1,
      sym_variable,
    STATE(325), 1,
      sym_interpolation,
    ACTIONS(1227), 2,
      sym_nesting_selector,
      sym_important,
    STATE(280), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13617] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1143), 1,
      aux_sym_integer_value_token1,
    ACTIONS(1145), 1,
      aux_sym_float_value_token1,
    ACTIONS(1233), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1231), 2,
      sym_nesting_selector,
      sym_important,
    STATE(476), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13677] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1237), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1235), 2,
      sym_nesting_selector,
      sym_important,
    STATE(480), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13737] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1241), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1239), 2,
      sym_nesting_selector,
      sym_important,
    STATE(463), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13797] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1245), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1243), 2,
      sym_nesting_selector,
      sym_important,
    STATE(474), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13857] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1249), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1247), 2,
      sym_nesting_selector,
      sym_important,
    STATE(465), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13917] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1253), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1251), 2,
      sym_nesting_selector,
      sym_important,
    STATE(472), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [13977] = 16,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_LPAREN2,
    ACTIONS(395), 1,
      aux_sym_integer_value_token1,
    ACTIONS(397), 1,
      aux_sym_float_value_token1,
    ACTIONS(401), 1,
      sym_plain_value,
    ACTIONS(683), 1,
      anon_sym_POUND,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_SQUOTE,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1013), 1,
      sym_identifier,
    ACTIONS(1257), 1,
      sym_variable,
    STATE(328), 1,
      sym_interpolation,
    ACTIONS(1255), 2,
      sym_nesting_selector,
      sym_important,
    STATE(484), 11,
      sym__value,
      sym_parenthesized_value,
      sym_color_value,
      sym_string_value,
      sym_integer_value,
      sym_float_value,
      sym_grid_value,
      sym_call_expression,
      sym_binary_expression,
      sym_list_value,
      sym__concatenated_identifier,
  [14037] = 11,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1259), 1,
      anon_sym_SEMI,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1267), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    ACTIONS(1263), 4,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1261), 6,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    STATE(511), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [14086] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(750), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(748), 21,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_STAR,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [14121] = 10,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_GT,
    ACTIONS(744), 1,
      anon_sym_LPAREN,
    ACTIONS(746), 1,
      sym__concat,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(360), 1,
      sym_arguments,
    ACTIONS(677), 2,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(671), 7,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(669), 10,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [14168] = 11,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1267), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1271), 1,
      anon_sym_SEMI,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    ACTIONS(1263), 4,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1261), 6,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    STATE(508), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [14217] = 5,
    ACTIONS(1277), 1,
      anon_sym_LPAREN,
    STATE(314), 1,
      sym_pseudo_element_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1275), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1273), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14253] = 5,
    ACTIONS(1283), 1,
      anon_sym_LPAREN,
    STATE(313), 1,
      sym_pseudo_class_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1281), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1279), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14289] = 5,
    ACTIONS(1277), 1,
      anon_sym_LPAREN,
    STATE(298), 1,
      sym_pseudo_element_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1287), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1285), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14325] = 5,
    ACTIONS(1283), 1,
      anon_sym_LPAREN,
    STATE(294), 1,
      sym_pseudo_class_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1291), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1289), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14361] = 7,
    ACTIONS(895), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1293), 1,
      sym_identifier,
    STATE(289), 1,
      sym__concatenated_identifier,
    STATE(302), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(722), 3,
      anon_sym_POUND,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(718), 15,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [14400] = 7,
    ACTIONS(1283), 1,
      anon_sym_LPAREN,
    ACTIONS(1295), 1,
      sym__concat,
    STATE(306), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(313), 1,
      sym_pseudo_class_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1281), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1279), 16,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [14439] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(673), 1,
      anon_sym_GT,
    ACTIONS(724), 2,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(720), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(669), 10,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [14476] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(722), 1,
      anon_sym_GT,
    ACTIONS(724), 2,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(720), 9,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(718), 10,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [14513] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1299), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1297), 20,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14544] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1303), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1301), 20,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14575] = 7,
    ACTIONS(1283), 1,
      anon_sym_LPAREN,
    ACTIONS(1295), 1,
      sym__concat,
    STATE(294), 1,
      sym_pseudo_class_arguments,
    STATE(306), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1291), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1289), 16,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [14614] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1307), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1305), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14644] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1311), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1309), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14674] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1315), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1313), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14704] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(673), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(669), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14734] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1319), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1317), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14764] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1323), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1321), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14794] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1327), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1325), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14824] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1331), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1329), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14854] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1335), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1333), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14884] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1339), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1337), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14914] = 5,
    ACTIONS(1295), 1,
      sym__concat,
    STATE(306), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(716), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(714), 17,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_LPAREN,
  [14948] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1343), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1341), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [14978] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1347), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1345), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [15008] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1351), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1349), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [15038] = 5,
    ACTIONS(1295), 1,
      sym__concat,
    STATE(308), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(712), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(710), 17,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_LPAREN,
  [15072] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1355), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1353), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [15102] = 5,
    ACTIONS(1357), 1,
      sym__concat,
    STATE(308), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(705), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(703), 17,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_LPAREN,
  [15136] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1362), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1360), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [15166] = 8,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(744), 1,
      anon_sym_LPAREN,
    ACTIONS(1364), 1,
      sym__concat,
    STATE(326), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(360), 1,
      sym_arguments,
    ACTIONS(677), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(671), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [15206] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1368), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1366), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [15236] = 8,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1370), 1,
      anon_sym_LPAREN,
    ACTIONS(1372), 1,
      sym__concat,
    STATE(329), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(350), 1,
      sym_arguments,
    ACTIONS(671), 8,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
    ACTIONS(677), 9,
      anon_sym_GT,
      anon_sym_LPAREN2,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
  [15276] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1376), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1374), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [15306] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1380), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1378), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [15336] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1384), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1382), 19,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_RPAREN,
  [15366] = 5,
    ACTIONS(1295), 1,
      sym__concat,
    STATE(306), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1299), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1297), 16,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [15399] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(736), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(734), 18,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym__concat,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_LPAREN,
  [15428] = 7,
    ACTIONS(746), 1,
      sym__concat,
    ACTIONS(1388), 1,
      anon_sym_RBRACK,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(673), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1386), 6,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
    ACTIONS(669), 9,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [15465] = 7,
    ACTIONS(742), 1,
      anon_sym_RBRACK,
    ACTIONS(746), 1,
      sym__concat,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(673), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(740), 6,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
    ACTIONS(669), 9,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [15502] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(705), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(703), 18,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym__concat,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
      anon_sym_LPAREN,
  [15531] = 5,
    ACTIONS(1295), 1,
      sym__concat,
    STATE(306), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(673), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(669), 16,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [15564] = 5,
    ACTIONS(1295), 1,
      sym__concat,
    STATE(306), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1303), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1301), 16,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [15597] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(736), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(734), 17,
      sym__concat,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [15628] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(744), 1,
      anon_sym_LPAREN,
    STATE(360), 1,
      sym_arguments,
    ACTIONS(724), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(720), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [15662] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1372), 1,
      sym__concat,
    STATE(329), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(716), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(714), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [15696] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1364), 1,
      sym__concat,
    STATE(330), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(712), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(710), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [15730] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1370), 1,
      anon_sym_LPAREN,
    STATE(350), 1,
      sym_arguments,
    ACTIONS(720), 8,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
    ACTIONS(724), 9,
      anon_sym_GT,
      anon_sym_LPAREN2,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
  [15764] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1364), 1,
      sym__concat,
    STATE(326), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(716), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(714), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [15798] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1372), 1,
      sym__concat,
    STATE(331), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(712), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(710), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [15832] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1390), 1,
      sym__concat,
    STATE(330), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(705), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(703), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [15866] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1393), 1,
      sym__concat,
    STATE(331), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(705), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(703), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [15900] = 10,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(744), 1,
      anon_sym_LPAREN,
    ACTIONS(1364), 1,
      sym__concat,
    ACTIONS(1396), 1,
      anon_sym_COLON,
    STATE(326), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(360), 1,
      sym_arguments,
    ACTIONS(677), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(728), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(671), 8,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [15942] = 4,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1398), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1402), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1400), 14,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [15971] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(961), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(959), 10,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16000] = 5,
    ACTIONS(742), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(722), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(740), 6,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
    ACTIONS(718), 9,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [16031] = 6,
    ACTIONS(746), 1,
      sym__concat,
    ACTIONS(1283), 1,
      anon_sym_LPAREN,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(294), 1,
      sym_pseudo_class_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1289), 14,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [16064] = 4,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1398), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1406), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1404), 14,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [16093] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(750), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(748), 16,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [16120] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(705), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(703), 15,
      sym__concat,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16149] = 7,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(722), 1,
      anon_sym_POUND,
    ACTIONS(997), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(289), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(718), 13,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [16184] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1408), 1,
      sym_unit,
    ACTIONS(869), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(867), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16215] = 5,
    ACTIONS(1388), 1,
      anon_sym_RBRACK,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(722), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1386), 6,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
    ACTIONS(718), 9,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [16246] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1410), 1,
      sym_unit,
    ACTIONS(875), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(873), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16277] = 4,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1398), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1414), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1412), 14,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [16306] = 6,
    ACTIONS(746), 1,
      sym__concat,
    ACTIONS(1283), 1,
      anon_sym_LPAREN,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(313), 1,
      sym_pseudo_class_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1279), 14,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [16339] = 4,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1398), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1418), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1416), 14,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [16368] = 4,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1398), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1422), 2,
      anon_sym_TILDE,
      anon_sym_PIPE,
    ACTIONS(1420), 14,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_STAR_EQ,
      anon_sym_DOLLAR_EQ,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_PLUS,
  [16397] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(736), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(734), 10,
      sym__concat,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16426] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(705), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(703), 10,
      sym__concat,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16455] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(947), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(945), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16483] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(965), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(963), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16511] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(915), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(913), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16539] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(943), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(941), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16567] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(957), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(955), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16595] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(953), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(951), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16623] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1424), 1,
      sym_unit,
    ACTIONS(875), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(873), 13,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [16653] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(965), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(963), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16681] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(961), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(959), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16709] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(911), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(909), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16737] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(947), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(945), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16765] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1426), 1,
      sym_unit,
    ACTIONS(869), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(867), 13,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [16795] = 4,
    ACTIONS(746), 1,
      sym__concat,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1297), 15,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [16823] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(927), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(925), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16851] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(921), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(919), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16879] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(953), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(951), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [16907] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(907), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(905), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16935] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(750), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(748), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16963] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(933), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(931), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [16991] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(907), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(905), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [17019] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(915), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(913), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [17047] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(943), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(941), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [17075] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(927), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(925), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [17103] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(957), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(955), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [17131] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(750), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(748), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [17159] = 4,
    ACTIONS(746), 1,
      sym__concat,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1301), 15,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [17187] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(911), 8,
      anon_sym_GT,
      anon_sym_not,
      anon_sym_only,
      anon_sym_selector,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_LT,
      sym_identifier,
    ACTIONS(909), 9,
      anon_sym_SEMI,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_LPAREN2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_POUND_LBRACE,
  [17215] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(933), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(931), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [17243] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(921), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(919), 14,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_through,
  [17271] = 5,
    ACTIONS(746), 1,
      sym__concat,
    ACTIONS(1428), 1,
      anon_sym_COLON,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(669), 13,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [17300] = 4,
    ACTIONS(746), 1,
      sym__concat,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(669), 14,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [17327] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1364), 1,
      sym__concat,
    STATE(326), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(760), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(716), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(714), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_RPAREN,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [17360] = 5,
    ACTIONS(746), 1,
      sym__concat,
    ACTIONS(1430), 1,
      anon_sym_COLON,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(669), 13,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [17389] = 5,
    ACTIONS(746), 1,
      sym__concat,
    ACTIONS(1432), 1,
      anon_sym_COLON,
    STATE(177), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(669), 13,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [17418] = 8,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1434), 1,
      anon_sym_LPAREN,
    ACTIONS(1436), 1,
      sym__concat,
    STATE(397), 1,
      aux_sym__concatenated_identifier_repeat1,
    STATE(442), 1,
      sym_arguments,
    ACTIONS(677), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(671), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [17453] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1412), 12,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [17476] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1434), 1,
      anon_sym_LPAREN,
    STATE(442), 1,
      sym_arguments,
    ACTIONS(724), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(720), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [17505] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1416), 12,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [17528] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1404), 12,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [17551] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1400), 12,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [17574] = 14,
    ACTIONS(815), 1,
      anon_sym_COMMA,
    ACTIONS(817), 1,
      anon_sym_RPAREN,
    ACTIONS(1440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1442), 1,
      anon_sym_POUND,
    ACTIONS(1444), 1,
      anon_sym_LBRACK,
    ACTIONS(1446), 1,
      anon_sym_GT,
    ACTIONS(1448), 1,
      anon_sym_TILDE,
    ACTIONS(1450), 1,
      anon_sym_PLUS,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      sym__descendant_operator,
    ACTIONS(1456), 1,
      sym__pseudo_class_selector_colon,
    STATE(560), 1,
      aux_sym_pseudo_class_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
  [17619] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1420), 12,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
      anon_sym_RPAREN,
  [17642] = 3,
    ACTIONS(1428), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(669), 13,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [17665] = 3,
    ACTIONS(1430), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(669), 13,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [17688] = 14,
    ACTIONS(815), 1,
      anon_sym_COMMA,
    ACTIONS(822), 1,
      anon_sym_RPAREN,
    ACTIONS(1440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1442), 1,
      anon_sym_POUND,
    ACTIONS(1444), 1,
      anon_sym_LBRACK,
    ACTIONS(1446), 1,
      anon_sym_GT,
    ACTIONS(1448), 1,
      anon_sym_TILDE,
    ACTIONS(1450), 1,
      anon_sym_PLUS,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      sym__descendant_operator,
    ACTIONS(1456), 1,
      sym__pseudo_class_selector_colon,
    STATE(563), 1,
      aux_sym_pseudo_class_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
  [17733] = 14,
    ACTIONS(1440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1442), 1,
      anon_sym_POUND,
    ACTIONS(1444), 1,
      anon_sym_LBRACK,
    ACTIONS(1446), 1,
      anon_sym_GT,
    ACTIONS(1448), 1,
      anon_sym_TILDE,
    ACTIONS(1450), 1,
      anon_sym_PLUS,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      sym__descendant_operator,
    ACTIONS(1456), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(1458), 1,
      anon_sym_COMMA,
    ACTIONS(1460), 1,
      anon_sym_LBRACE,
    STATE(549), 1,
      aux_sym_selectors_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
  [17778] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1462), 1,
      sym__concat,
    STATE(396), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(705), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(703), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [17807] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1436), 1,
      sym__concat,
    STATE(396), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(712), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(710), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [17836] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1436), 1,
      sym__concat,
    STATE(397), 1,
      aux_sym__concatenated_identifier_repeat1,
    ACTIONS(716), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(714), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [17865] = 7,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1267), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(514), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [17895] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1465), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [17921] = 7,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1267), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(507), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [17951] = 7,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1267), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(500), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [17981] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(705), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(703), 10,
      sym__concat,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [18005] = 12,
    ACTIONS(1440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1442), 1,
      anon_sym_POUND,
    ACTIONS(1444), 1,
      anon_sym_LBRACK,
    ACTIONS(1446), 1,
      anon_sym_GT,
    ACTIONS(1448), 1,
      anon_sym_TILDE,
    ACTIONS(1450), 1,
      anon_sym_PLUS,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      sym__descendant_operator,
    ACTIONS(1456), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(881), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
  [18045] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1473), 1,
      anon_sym_RBRACK,
    STATE(571), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18075] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1475), 1,
      anon_sym_RPAREN,
    STATE(572), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18105] = 7,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1267), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(505), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [18135] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(736), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(734), 10,
      sym__concat,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [18159] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1477), 1,
      anon_sym_RPAREN,
    STATE(561), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18189] = 7,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1267), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(497), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [18219] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
    STATE(567), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18249] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1481), 1,
      anon_sym_COLON,
    ACTIONS(724), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(720), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [18275] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1483), 1,
      anon_sym_RBRACK,
    STATE(562), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18305] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
    STATE(550), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18335] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1487), 1,
      anon_sym_RBRACK,
    STATE(551), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18365] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1489), 1,
      sym_unit,
    ACTIONS(875), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(873), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [18391] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1491), 1,
      anon_sym_RBRACK,
    STATE(569), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18421] = 12,
    ACTIONS(1440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1442), 1,
      anon_sym_POUND,
    ACTIONS(1444), 1,
      anon_sym_LBRACK,
    ACTIONS(1446), 1,
      anon_sym_GT,
    ACTIONS(1448), 1,
      anon_sym_TILDE,
    ACTIONS(1450), 1,
      anon_sym_PLUS,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      sym__descendant_operator,
    ACTIONS(1456), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
    ACTIONS(1493), 2,
      anon_sym_COMMA,
      anon_sym_LBRACE,
  [18461] = 7,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1267), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(506), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [18491] = 7,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1495), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(554), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [18521] = 7,
    ACTIONS(478), 1,
      anon_sym_selector,
    ACTIONS(1265), 1,
      anon_sym_LPAREN2,
    ACTIONS(1267), 1,
      sym_identifier,
    ACTIONS(1269), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(476), 2,
      anon_sym_not,
      anon_sym_only,
    STATE(516), 7,
      sym__query,
      sym_feature_query,
      sym_parenthesized_query,
      sym_binary_query,
      sym_unary_query,
      sym_selector_query,
      sym_interpolation,
  [18551] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1497), 1,
      sym_unit,
    ACTIONS(869), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(867), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [18577] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1499), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN2,
    ACTIONS(1503), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1501), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18602] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(961), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(959), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [18625] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    STATE(53), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18652] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    STATE(52), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18679] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    STATE(56), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18706] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1505), 1,
      anon_sym_LBRACE,
    STATE(28), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18733] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1505), 1,
      anon_sym_LBRACE,
    STATE(23), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18760] = 12,
    ACTIONS(1440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1442), 1,
      anon_sym_POUND,
    ACTIONS(1444), 1,
      anon_sym_LBRACK,
    ACTIONS(1446), 1,
      anon_sym_GT,
    ACTIONS(1448), 1,
      anon_sym_TILDE,
    ACTIONS(1450), 1,
      anon_sym_PLUS,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      sym__descendant_operator,
    ACTIONS(1456), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(1507), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
  [18799] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1509), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN2,
    ACTIONS(1503), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1501), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18824] = 3,
    ACTIONS(1511), 1,
      anon_sym_SEMI,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(718), 11,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [18845] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(89), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18872] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    STATE(80), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18899] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(88), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18926] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1513), 1,
      sym_unit,
    ACTIONS(875), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_through,
    ACTIONS(873), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18951] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1515), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [18976] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    STATE(38), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19003] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(965), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(963), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19026] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(750), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(748), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19049] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(911), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(909), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19072] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(947), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(945), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19095] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(122), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19122] = 3,
    ACTIONS(1517), 1,
      anon_sym_SEMI,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(718), 11,
      sym__descendant_operator,
      sym__pseudo_class_selector_colon,
      sym_nesting_selector,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_TILDE,
      anon_sym_PLUS,
      anon_sym_PIPE,
  [19143] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1519), 1,
      anon_sym_LBRACE,
    STATE(26), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19170] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(120), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19197] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(933), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(931), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19220] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(921), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(919), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19243] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(953), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(951), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19266] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(907), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(905), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19289] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1519), 1,
      anon_sym_LBRACE,
    STATE(83), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19316] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(957), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(955), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19339] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(943), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(941), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19362] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(915), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(913), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19385] = 6,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(116), 1,
      sym_block,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19412] = 4,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(927), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(925), 9,
      anon_sym_COMMA,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_RPAREN2,
  [19435] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1521), 1,
      sym_unit,
    ACTIONS(869), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_through,
    ACTIONS(867), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19460] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1523), 1,
      anon_sym_RBRACE,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19484] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1525), 1,
      anon_sym_RBRACK,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19508] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1517), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19532] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1527), 1,
      anon_sym_RBRACE,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19556] = 11,
    ACTIONS(1440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1442), 1,
      anon_sym_POUND,
    ACTIONS(1444), 1,
      anon_sym_LBRACK,
    ACTIONS(1446), 1,
      anon_sym_GT,
    ACTIONS(1448), 1,
      anon_sym_TILDE,
    ACTIONS(1450), 1,
      anon_sym_PLUS,
    ACTIONS(1452), 1,
      anon_sym_PIPE,
    ACTIONS(1454), 1,
      sym__descendant_operator,
    ACTIONS(1456), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
  [19592] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1529), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19616] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1535), 1,
      anon_sym_through,
    ACTIONS(1533), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1531), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19640] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1537), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19664] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1539), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19688] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1541), 1,
      anon_sym_RBRACK,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19712] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1511), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19736] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1543), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19760] = 11,
    ACTIONS(1440), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1442), 1,
      anon_sym_POUND,
    ACTIONS(1444), 1,
      anon_sym_LBRACK,
    ACTIONS(1446), 1,
      anon_sym_GT,
    ACTIONS(1448), 1,
      anon_sym_TILDE,
    ACTIONS(1450), 1,
      anon_sym_PLUS,
    ACTIONS(1454), 1,
      sym__descendant_operator,
    ACTIONS(1456), 1,
      sym__pseudo_class_selector_colon,
    ACTIONS(1545), 1,
      anon_sym_PIPE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1438), 2,
      sym_nesting_selector,
      anon_sym_DOT,
  [19796] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1547), 1,
      anon_sym_RBRACE,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19820] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1549), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19844] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1551), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19868] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1553), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19892] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1555), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19916] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1557), 1,
      anon_sym_through,
    ACTIONS(1533), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1531), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19940] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1559), 1,
      anon_sym_RBRACE,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19964] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1561), 1,
      anon_sym_RBRACE,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [19988] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1563), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [20012] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1565), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [20036] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1567), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [20060] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1569), 1,
      anon_sym_RBRACE,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [20084] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1571), 1,
      anon_sym_RBRACE,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [20108] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1573), 1,
      anon_sym_RBRACE,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [20132] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1575), 1,
      anon_sym_SEMI,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [20156] = 5,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_RBRACE,
    ACTIONS(1469), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_LT,
    ACTIONS(1467), 7,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
  [20180] = 8,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym_SQUOTE,
    ACTIONS(1093), 1,
      anon_sym_DQUOTE,
    ACTIONS(1370), 1,
      anon_sym_LPAREN,
    STATE(350), 1,
      sym_arguments,
    ACTIONS(1579), 2,
      sym_identifier,
      sym_plain_value,
    STATE(599), 2,
      sym_string_value,
      sym_call_expression,
  [20207] = 7,
    ACTIONS(1581), 1,
      anon_sym_RBRACE,
    ACTIONS(1583), 1,
      anon_sym_from,
    ACTIONS(1585), 1,
      sym_to,
    ACTIONS(1587), 1,
      aux_sym_integer_value_token1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(493), 2,
      sym_keyframe_block,
      aux_sym_keyframe_block_list_repeat1,
    STATE(595), 2,
      sym_from,
      sym_integer_value,
  [20232] = 7,
    ACTIONS(1583), 1,
      anon_sym_from,
    ACTIONS(1585), 1,
      sym_to,
    ACTIONS(1587), 1,
      aux_sym_integer_value_token1,
    ACTIONS(1589), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(493), 2,
      sym_keyframe_block,
      aux_sym_keyframe_block_list_repeat1,
    STATE(595), 2,
      sym_from,
      sym_integer_value,
  [20257] = 8,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym_SQUOTE,
    ACTIONS(1093), 1,
      anon_sym_DQUOTE,
    ACTIONS(1370), 1,
      anon_sym_LPAREN,
    STATE(350), 1,
      sym_arguments,
    ACTIONS(1579), 2,
      sym_identifier,
      sym_plain_value,
    STATE(623), 2,
      sym_string_value,
      sym_call_expression,
  [20284] = 7,
    ACTIONS(1583), 1,
      anon_sym_from,
    ACTIONS(1585), 1,
      sym_to,
    ACTIONS(1587), 1,
      aux_sym_integer_value_token1,
    ACTIONS(1591), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(488), 2,
      sym_keyframe_block,
      aux_sym_keyframe_block_list_repeat1,
    STATE(595), 2,
      sym_from,
      sym_integer_value,
  [20309] = 7,
    ACTIONS(1583), 1,
      anon_sym_from,
    ACTIONS(1585), 1,
      sym_to,
    ACTIONS(1587), 1,
      aux_sym_integer_value_token1,
    ACTIONS(1593), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(489), 2,
      sym_keyframe_block,
      aux_sym_keyframe_block_list_repeat1,
    STATE(595), 2,
      sym_from,
      sym_integer_value,
  [20334] = 7,
    ACTIONS(1595), 1,
      anon_sym_RBRACE,
    ACTIONS(1597), 1,
      anon_sym_from,
    ACTIONS(1600), 1,
      sym_to,
    ACTIONS(1603), 1,
      aux_sym_integer_value_token1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    STATE(493), 2,
      sym_keyframe_block,
      aux_sym_keyframe_block_list_repeat1,
    STATE(595), 2,
      sym_from,
      sym_integer_value,
  [20359] = 7,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    ACTIONS(1608), 1,
      anon_sym_SEMI,
    STATE(125), 1,
      sym_block,
    STATE(513), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
  [20383] = 7,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    ACTIONS(1612), 1,
      anon_sym_SEMI,
    STATE(37), 1,
      sym_block,
    STATE(510), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
  [20407] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1614), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [20420] = 6,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    STATE(96), 1,
      sym_block,
    STATE(536), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
  [20441] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1616), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [20454] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1618), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [20467] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1620), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [20480] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(734), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [20493] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym_SQUOTE,
    ACTIONS(1093), 1,
      anon_sym_DQUOTE,
    ACTIONS(1579), 1,
      sym_plain_value,
    ACTIONS(1622), 1,
      sym_identifier,
    STATE(632), 2,
      sym_string_value,
      sym_call_expression,
  [20516] = 7,
    ACTIONS(3), 1,
      sym_js_comment,
    ACTIONS(5), 1,
      sym_comment,
    ACTIONS(1091), 1,
      anon_sym_SQUOTE,
    ACTIONS(1093), 1,
      anon_sym_DQUOTE,
    ACTIONS(1579), 1,
      sym_plain_value,
    ACTIONS(1624), 1,
      sym_identifier,
    STATE(654), 2,
      sym_string_value,
      sym_call_expression,
  [20539] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(728), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [20552] = 6,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    STATE(51), 1,
      sym_block,
    STATE(526), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
  [20573] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1626), 6,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [20586] = 3,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(1628), 3,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [20600] = 5,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    ACTIONS(1630), 1,
      anon_sym_SEMI,
    STATE(548), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
  [20618] = 6,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(1632), 1,
      anon_sym_SEMI,
    ACTIONS(1634), 1,
      anon_sym_LPAREN,
    STATE(44), 1,
      sym_block,
    STATE(574), 1,
      sym__include_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20638] = 6,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    ACTIONS(1636), 1,
      anon_sym_SEMI,
    STATE(69), 1,
      sym_block,
    STATE(542), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20658] = 5,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    ACTIONS(1638), 1,
      anon_sym_SEMI,
    STATE(557), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
  [20676] = 6,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(1634), 1,
      anon_sym_LPAREN,
    ACTIONS(1640), 1,
      anon_sym_SEMI,
    STATE(127), 1,
      sym_block,
    STATE(555), 1,
      sym__include_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20696] = 6,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    ACTIONS(1642), 1,
      anon_sym_SEMI,
    STATE(86), 1,
      sym_block,
    STATE(542), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20716] = 4,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(123), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
  [20731] = 5,
    ACTIONS(895), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1644), 1,
      sym_identifier,
    ACTIONS(1646), 1,
      anon_sym_DASH2,
    STATE(320), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20748] = 4,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    STATE(46), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
  [20763] = 5,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1648), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(290), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20780] = 5,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1650), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(284), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20797] = 5,
    ACTIONS(462), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1652), 1,
      sym_identifier,
    ACTIONS(1654), 1,
      anon_sym_DASH2,
    STATE(161), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20814] = 5,
    ACTIONS(895), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1656), 1,
      sym_identifier,
    STATE(282), 1,
      sym__concatenated_identifier,
    STATE(302), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20831] = 4,
    ACTIONS(807), 1,
      anon_sym_RPAREN,
    STATE(521), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1658), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [20846] = 5,
    ACTIONS(895), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1293), 1,
      sym_identifier,
    STATE(289), 1,
      sym__concatenated_identifier,
    STATE(302), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20863] = 4,
    ACTIONS(1661), 1,
      anon_sym_RPAREN,
    STATE(521), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(752), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [20878] = 5,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(997), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(289), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20895] = 5,
    ACTIONS(379), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1663), 1,
      sym_identifier,
    ACTIONS(1665), 1,
      anon_sym_DASH2,
    STATE(136), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20912] = 5,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    STATE(73), 1,
      sym_block,
    STATE(542), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20929] = 5,
    ACTIONS(695), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1667), 1,
      sym_identifier,
    ACTIONS(1669), 1,
      anon_sym_DASH2,
    STATE(339), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20946] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1671), 4,
      anon_sym_RBRACE,
      anon_sym_from,
      sym_to,
      aux_sym_integer_value_token1,
  [20957] = 4,
    ACTIONS(1673), 1,
      anon_sym_RPAREN,
    STATE(521), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(752), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [20972] = 5,
    ACTIONS(1103), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1675), 1,
      sym_identifier,
    ACTIONS(1677), 1,
      anon_sym_DASH2,
    STATE(349), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [20989] = 5,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(1679), 1,
      anon_sym_LPAREN2,
    STATE(129), 1,
      sym_block,
    STATE(594), 1,
      sym_parameters,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21006] = 5,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(1679), 1,
      anon_sym_LPAREN2,
    STATE(87), 1,
      sym_block,
    STATE(593), 1,
      sym_parameters,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21023] = 4,
    ACTIONS(1681), 1,
      anon_sym_COMMA,
    STATE(533), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1465), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [21038] = 5,
    ACTIONS(895), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1684), 1,
      sym_identifier,
    STATE(290), 1,
      sym__concatenated_identifier,
    STATE(302), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21055] = 4,
    ACTIONS(1686), 1,
      anon_sym_RPAREN,
    STATE(521), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(752), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [21070] = 5,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    STATE(91), 1,
      sym_block,
    STATE(542), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21087] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(499), 4,
      anon_sym_RBRACE,
      anon_sym_from,
      sym_to,
      aux_sym_integer_value_token1,
  [21098] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(495), 4,
      anon_sym_RBRACE,
      anon_sym_from,
      sym_to,
      aux_sym_integer_value_token1,
  [21109] = 5,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(1679), 1,
      anon_sym_LPAREN2,
    STATE(45), 1,
      sym_block,
    STATE(585), 1,
      sym_parameters,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21126] = 5,
    ACTIONS(987), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1688), 1,
      sym_identifier,
    ACTIONS(1690), 1,
      anon_sym_DASH2,
    STATE(403), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21143] = 4,
    ACTIONS(1692), 1,
      anon_sym_RPAREN,
    STATE(521), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(752), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [21158] = 4,
    ACTIONS(1694), 1,
      anon_sym_COMMA,
    STATE(542), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1628), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [21173] = 5,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(1679), 1,
      anon_sym_LPAREN2,
    STATE(43), 1,
      sym_block,
    STATE(580), 1,
      sym_parameters,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21190] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(491), 4,
      anon_sym_RBRACE,
      anon_sym_from,
      sym_to,
      aux_sym_integer_value_token1,
  [21201] = 5,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1697), 1,
      sym_identifier,
    ACTIONS(1699), 1,
      anon_sym_DASH2,
    STATE(197), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21218] = 3,
    ACTIONS(1396), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(728), 3,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [21231] = 5,
    ACTIONS(71), 1,
      anon_sym_POUND_LBRACE,
    ACTIONS(1701), 1,
      sym_identifier,
    STATE(171), 1,
      sym_interpolation,
    STATE(282), 1,
      sym__concatenated_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21248] = 4,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    ACTIONS(1703), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21262] = 4,
    ACTIONS(1458), 1,
      anon_sym_COMMA,
    ACTIONS(1705), 1,
      anon_sym_LBRACE,
    STATE(564), 1,
      aux_sym_selectors_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21276] = 4,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1707), 1,
      anon_sym_RPAREN,
    STATE(533), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21290] = 4,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1709), 1,
      anon_sym_RBRACK,
    STATE(533), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21304] = 3,
    ACTIONS(1713), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1711), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [21316] = 4,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(1715), 1,
      anon_sym_if,
    STATE(111), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21330] = 3,
    ACTIONS(1717), 1,
      anon_sym_RPAREN,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1610), 2,
      anon_sym_and,
      anon_sym_or,
  [21342] = 4,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    ACTIONS(1719), 1,
      anon_sym_SEMI,
    STATE(101), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21356] = 4,
    ACTIONS(1721), 1,
      anon_sym_COMMA,
    ACTIONS(1723), 1,
      anon_sym_RPAREN,
    STATE(568), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21370] = 4,
    ACTIONS(1606), 1,
      anon_sym_COMMA,
    ACTIONS(1725), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      aux_sym_import_statement_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21384] = 4,
    ACTIONS(1727), 1,
      anon_sym_COMMA,
    ACTIONS(1729), 1,
      anon_sym_RPAREN2,
    STATE(570), 1,
      aux_sym__include_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21398] = 4,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(1731), 1,
      anon_sym_if,
    STATE(58), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21412] = 4,
    ACTIONS(815), 1,
      anon_sym_COMMA,
    ACTIONS(1733), 1,
      anon_sym_RPAREN,
    STATE(573), 1,
      aux_sym_pseudo_class_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21426] = 4,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1735), 1,
      anon_sym_RPAREN,
    STATE(533), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21440] = 4,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1737), 1,
      anon_sym_RBRACK,
    STATE(533), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21454] = 4,
    ACTIONS(815), 1,
      anon_sym_COMMA,
    ACTIONS(1739), 1,
      anon_sym_RPAREN,
    STATE(573), 1,
      aux_sym_pseudo_class_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21468] = 4,
    ACTIONS(1493), 1,
      anon_sym_LBRACE,
    ACTIONS(1741), 1,
      anon_sym_COMMA,
    STATE(564), 1,
      aux_sym_selectors_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21482] = 4,
    ACTIONS(1744), 1,
      anon_sym_COMMA,
    ACTIONS(1747), 1,
      anon_sym_RPAREN2,
    STATE(565), 1,
      aux_sym__include_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21496] = 4,
    ACTIONS(1749), 1,
      anon_sym_COMMA,
    ACTIONS(1752), 1,
      anon_sym_RPAREN,
    STATE(566), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21510] = 4,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1754), 1,
      anon_sym_RPAREN,
    STATE(533), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21524] = 4,
    ACTIONS(1721), 1,
      anon_sym_COMMA,
    ACTIONS(1756), 1,
      anon_sym_RPAREN,
    STATE(566), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21538] = 4,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1758), 1,
      anon_sym_RBRACK,
    STATE(533), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21552] = 4,
    ACTIONS(1727), 1,
      anon_sym_COMMA,
    ACTIONS(1760), 1,
      anon_sym_RPAREN2,
    STATE(565), 1,
      aux_sym__include_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21566] = 4,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1762), 1,
      anon_sym_RBRACK,
    STATE(533), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21580] = 4,
    ACTIONS(1471), 1,
      anon_sym_COMMA,
    ACTIONS(1764), 1,
      anon_sym_RPAREN,
    STATE(533), 1,
      aux_sym_grid_value_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21594] = 4,
    ACTIONS(881), 1,
      anon_sym_RPAREN,
    ACTIONS(1766), 1,
      anon_sym_COMMA,
    STATE(573), 1,
      aux_sym_pseudo_class_arguments_repeat1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21608] = 4,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    ACTIONS(1769), 1,
      anon_sym_SEMI,
    STATE(70), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21622] = 3,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    STATE(72), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21633] = 3,
    ACTIONS(867), 1,
      anon_sym_LBRACE,
    ACTIONS(1771), 1,
      sym_unit,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21644] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1773), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [21653] = 3,
    ACTIONS(1775), 1,
      anon_sym_COMMA,
    ACTIONS(1777), 1,
      anon_sym_in,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21664] = 3,
    ACTIONS(1779), 1,
      sym_variable,
    STATE(556), 1,
      sym_parameter,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21675] = 3,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    STATE(62), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21686] = 3,
    ACTIONS(1781), 1,
      anon_sym_COMMA,
    ACTIONS(1783), 1,
      anon_sym_in,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21697] = 3,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(108), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21708] = 3,
    ACTIONS(1779), 1,
      sym_variable,
    STATE(584), 1,
      sym_parameter,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21719] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1752), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [21728] = 3,
    ACTIONS(472), 1,
      anon_sym_LBRACE,
    STATE(81), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21739] = 3,
    ACTIONS(1785), 1,
      anon_sym_LBRACE,
    STATE(92), 1,
      sym_keyframe_block_list,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21750] = 3,
    ACTIONS(1787), 1,
      anon_sym_LBRACE,
    STATE(47), 1,
      sym_keyframe_block_list,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21761] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1789), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN2,
  [21770] = 2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
    ACTIONS(1791), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [21779] = 3,
    ACTIONS(1370), 1,
      anon_sym_LPAREN,
    STATE(350), 1,
      sym_arguments,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21790] = 3,
    ACTIONS(1793), 1,
      aux_sym_color_value_token1,
    ACTIONS(1795), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21801] = 3,
    ACTIONS(1795), 1,
      sym_identifier,
    ACTIONS(1797), 1,
      aux_sym_color_value_token1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21812] = 3,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(102), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21823] = 3,
    ACTIONS(507), 1,
      anon_sym_LBRACE,
    STATE(100), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21834] = 3,
    ACTIONS(1799), 1,
      anon_sym_LBRACE,
    STATE(528), 1,
      sym_block,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21845] = 2,
    ACTIONS(1801), 1,
      anon_sym_SQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21853] = 2,
    ACTIONS(1803), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21861] = 2,
    ACTIONS(1805), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21869] = 2,
    ACTIONS(1807), 1,
      anon_sym_SEMI,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21877] = 2,
    ACTIONS(1809), 1,
      anon_sym_SQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21885] = 2,
    ACTIONS(250), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21893] = 2,
    ACTIONS(1811), 1,
      anon_sym_DQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21901] = 2,
    ACTIONS(1813), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21909] = 2,
    ACTIONS(1801), 1,
      anon_sym_DQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21917] = 2,
    ACTIONS(1811), 1,
      anon_sym_SQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21925] = 2,
    ACTIONS(1815), 1,
      aux_sym_color_value_token1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21933] = 2,
    ACTIONS(1817), 1,
      anon_sym_SQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21941] = 2,
    ACTIONS(1817), 1,
      anon_sym_DQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21949] = 2,
    ACTIONS(1819), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21957] = 2,
    ACTIONS(1809), 1,
      anon_sym_DQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21965] = 2,
    ACTIONS(1821), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21973] = 2,
    ACTIONS(1823), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21981] = 2,
    ACTIONS(1825), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21989] = 2,
    ACTIONS(1827), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [21997] = 2,
    ACTIONS(198), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22005] = 2,
    ACTIONS(1829), 1,
      aux_sym_string_value_token1,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22013] = 2,
    ACTIONS(1831), 1,
      aux_sym_string_value_token2,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22021] = 2,
    ACTIONS(1833), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22029] = 2,
    ACTIONS(1835), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22037] = 2,
    ACTIONS(1837), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22045] = 2,
    ACTIONS(1839), 1,
      anon_sym_LPAREN2,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22053] = 2,
    ACTIONS(1841), 1,
      anon_sym_in,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22061] = 2,
    ACTIONS(1843), 1,
      anon_sym_SEMI,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22069] = 2,
    ACTIONS(248), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22077] = 2,
    ACTIONS(1845), 1,
      anon_sym_SQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22085] = 2,
    ACTIONS(1847), 1,
      anon_sym_DQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22093] = 2,
    ACTIONS(1849), 1,
      aux_sym_color_value_token1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22101] = 2,
    ACTIONS(1847), 1,
      anon_sym_SQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22109] = 2,
    ACTIONS(1731), 1,
      anon_sym_if,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22117] = 2,
    ACTIONS(1851), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22125] = 2,
    ACTIONS(1853), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22133] = 2,
    ACTIONS(1855), 1,
      anon_sym_SEMI,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22141] = 2,
    ACTIONS(244), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22149] = 2,
    ACTIONS(1857), 1,
      ts_builtin_sym_end,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22157] = 2,
    ACTIONS(1845), 1,
      anon_sym_DQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22165] = 2,
    ACTIONS(1859), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22173] = 2,
    ACTIONS(1861), 1,
      sym_variable,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22181] = 2,
    ACTIONS(1863), 1,
      sym_variable,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22189] = 2,
    ACTIONS(1865), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22197] = 2,
    ACTIONS(1867), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22205] = 2,
    ACTIONS(1715), 1,
      anon_sym_if,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22213] = 2,
    ACTIONS(1869), 1,
      aux_sym_string_value_token1,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22221] = 2,
    ACTIONS(1871), 1,
      aux_sym_string_value_token2,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22229] = 2,
    ACTIONS(1873), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22237] = 2,
    ACTIONS(1875), 1,
      anon_sym_LBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22245] = 2,
    ACTIONS(1877), 1,
      aux_sym_string_value_token2,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22253] = 2,
    ACTIONS(1879), 1,
      aux_sym_string_value_token1,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22261] = 2,
    ACTIONS(1881), 1,
      aux_sym_string_value_token2,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22269] = 2,
    ACTIONS(1883), 1,
      aux_sym_string_value_token1,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22277] = 2,
    ACTIONS(1885), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22285] = 2,
    ACTIONS(1887), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22293] = 2,
    ACTIONS(1889), 1,
      aux_sym_string_value_token1,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22301] = 2,
    ACTIONS(1891), 1,
      aux_sym_string_value_token2,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22309] = 2,
    ACTIONS(1893), 1,
      anon_sym_SEMI,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22317] = 2,
    ACTIONS(1895), 1,
      aux_sym_string_value_token1,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22325] = 2,
    ACTIONS(1897), 1,
      aux_sym_string_value_token2,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22333] = 2,
    ACTIONS(1899), 1,
      sym_variable,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22341] = 2,
    ACTIONS(1901), 1,
      aux_sym_string_value_token1,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22349] = 2,
    ACTIONS(1903), 1,
      aux_sym_string_value_token2,
    ACTIONS(3), 2,
      sym_js_comment,
      sym_comment,
  [22357] = 2,
    ACTIONS(1905), 1,
      anon_sym_DQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22365] = 2,
    ACTIONS(1907), 1,
      sym_identifier,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22373] = 2,
    ACTIONS(1909), 1,
      aux_sym_color_value_token1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22381] = 2,
    ACTIONS(1905), 1,
      anon_sym_SQUOTE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22389] = 2,
    ACTIONS(1911), 1,
      anon_sym_COLON,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22397] = 2,
    ACTIONS(1913), 1,
      aux_sym_color_value_token1,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22405] = 2,
    ACTIONS(1915), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22413] = 2,
    ACTIONS(1917), 1,
      anon_sym_in,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22421] = 2,
    ACTIONS(1919), 1,
      anon_sym_from,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22429] = 2,
    ACTIONS(1921), 1,
      sym_variable,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22437] = 2,
    ACTIONS(1923), 1,
      sym_variable,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22445] = 2,
    ACTIONS(234), 1,
      anon_sym_RBRACE,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22453] = 2,
    ACTIONS(1925), 1,
      anon_sym_from,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
  [22461] = 2,
    ACTIONS(1927), 1,
      sym_variable,
    ACTIONS(5), 2,
      sym_js_comment,
      sym_comment,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(15)] = 0,
  [SMALL_STATE(16)] = 102,
  [SMALL_STATE(17)] = 204,
  [SMALL_STATE(18)] = 303,
  [SMALL_STATE(19)] = 401,
  [SMALL_STATE(20)] = 499,
  [SMALL_STATE(21)] = 597,
  [SMALL_STATE(22)] = 695,
  [SMALL_STATE(23)] = 751,
  [SMALL_STATE(24)] = 807,
  [SMALL_STATE(25)] = 860,
  [SMALL_STATE(26)] = 914,
  [SMALL_STATE(27)] = 968,
  [SMALL_STATE(28)] = 1056,
  [SMALL_STATE(29)] = 1103,
  [SMALL_STATE(30)] = 1190,
  [SMALL_STATE(31)] = 1275,
  [SMALL_STATE(32)] = 1326,
  [SMALL_STATE(33)] = 1373,
  [SMALL_STATE(34)] = 1420,
  [SMALL_STATE(35)] = 1467,
  [SMALL_STATE(36)] = 1552,
  [SMALL_STATE(37)] = 1639,
  [SMALL_STATE(38)] = 1685,
  [SMALL_STATE(39)] = 1731,
  [SMALL_STATE(40)] = 1777,
  [SMALL_STATE(41)] = 1823,
  [SMALL_STATE(42)] = 1869,
  [SMALL_STATE(43)] = 1915,
  [SMALL_STATE(44)] = 1961,
  [SMALL_STATE(45)] = 2007,
  [SMALL_STATE(46)] = 2053,
  [SMALL_STATE(47)] = 2099,
  [SMALL_STATE(48)] = 2145,
  [SMALL_STATE(49)] = 2191,
  [SMALL_STATE(50)] = 2237,
  [SMALL_STATE(51)] = 2283,
  [SMALL_STATE(52)] = 2329,
  [SMALL_STATE(53)] = 2375,
  [SMALL_STATE(54)] = 2421,
  [SMALL_STATE(55)] = 2467,
  [SMALL_STATE(56)] = 2513,
  [SMALL_STATE(57)] = 2559,
  [SMALL_STATE(58)] = 2605,
  [SMALL_STATE(59)] = 2651,
  [SMALL_STATE(60)] = 2697,
  [SMALL_STATE(61)] = 2743,
  [SMALL_STATE(62)] = 2789,
  [SMALL_STATE(63)] = 2835,
  [SMALL_STATE(64)] = 2881,
  [SMALL_STATE(65)] = 2927,
  [SMALL_STATE(66)] = 2973,
  [SMALL_STATE(67)] = 3019,
  [SMALL_STATE(68)] = 3065,
  [SMALL_STATE(69)] = 3111,
  [SMALL_STATE(70)] = 3157,
  [SMALL_STATE(71)] = 3203,
  [SMALL_STATE(72)] = 3249,
  [SMALL_STATE(73)] = 3295,
  [SMALL_STATE(74)] = 3341,
  [SMALL_STATE(75)] = 3387,
  [SMALL_STATE(76)] = 3433,
  [SMALL_STATE(77)] = 3479,
  [SMALL_STATE(78)] = 3525,
  [SMALL_STATE(79)] = 3571,
  [SMALL_STATE(80)] = 3617,
  [SMALL_STATE(81)] = 3663,
  [SMALL_STATE(82)] = 3709,
  [SMALL_STATE(83)] = 3754,
  [SMALL_STATE(84)] = 3799,
  [SMALL_STATE(85)] = 3844,
  [SMALL_STATE(86)] = 3889,
  [SMALL_STATE(87)] = 3933,
  [SMALL_STATE(88)] = 3977,
  [SMALL_STATE(89)] = 4021,
  [SMALL_STATE(90)] = 4065,
  [SMALL_STATE(91)] = 4109,
  [SMALL_STATE(92)] = 4153,
  [SMALL_STATE(93)] = 4197,
  [SMALL_STATE(94)] = 4241,
  [SMALL_STATE(95)] = 4285,
  [SMALL_STATE(96)] = 4329,
  [SMALL_STATE(97)] = 4373,
  [SMALL_STATE(98)] = 4417,
  [SMALL_STATE(99)] = 4461,
  [SMALL_STATE(100)] = 4505,
  [SMALL_STATE(101)] = 4549,
  [SMALL_STATE(102)] = 4593,
  [SMALL_STATE(103)] = 4637,
  [SMALL_STATE(104)] = 4681,
  [SMALL_STATE(105)] = 4725,
  [SMALL_STATE(106)] = 4769,
  [SMALL_STATE(107)] = 4813,
  [SMALL_STATE(108)] = 4857,
  [SMALL_STATE(109)] = 4901,
  [SMALL_STATE(110)] = 4945,
  [SMALL_STATE(111)] = 4989,
  [SMALL_STATE(112)] = 5033,
  [SMALL_STATE(113)] = 5077,
  [SMALL_STATE(114)] = 5121,
  [SMALL_STATE(115)] = 5165,
  [SMALL_STATE(116)] = 5223,
  [SMALL_STATE(117)] = 5267,
  [SMALL_STATE(118)] = 5311,
  [SMALL_STATE(119)] = 5355,
  [SMALL_STATE(120)] = 5399,
  [SMALL_STATE(121)] = 5443,
  [SMALL_STATE(122)] = 5487,
  [SMALL_STATE(123)] = 5531,
  [SMALL_STATE(124)] = 5575,
  [SMALL_STATE(125)] = 5619,
  [SMALL_STATE(126)] = 5663,
  [SMALL_STATE(127)] = 5707,
  [SMALL_STATE(128)] = 5751,
  [SMALL_STATE(129)] = 5795,
  [SMALL_STATE(130)] = 5839,
  [SMALL_STATE(131)] = 5914,
  [SMALL_STATE(132)] = 5989,
  [SMALL_STATE(133)] = 6037,
  [SMALL_STATE(134)] = 6085,
  [SMALL_STATE(135)] = 6133,
  [SMALL_STATE(136)] = 6189,
  [SMALL_STATE(137)] = 6232,
  [SMALL_STATE(138)] = 6287,
  [SMALL_STATE(139)] = 6330,
  [SMALL_STATE(140)] = 6376,
  [SMALL_STATE(141)] = 6436,
  [SMALL_STATE(142)] = 6478,
  [SMALL_STATE(143)] = 6524,
  [SMALL_STATE(144)] = 6574,
  [SMALL_STATE(145)] = 6647,
  [SMALL_STATE(146)] = 6720,
  [SMALL_STATE(147)] = 6793,
  [SMALL_STATE(148)] = 6842,
  [SMALL_STATE(149)] = 6915,
  [SMALL_STATE(150)] = 6985,
  [SMALL_STATE(151)] = 7053,
  [SMALL_STATE(152)] = 7127,
  [SMALL_STATE(153)] = 7171,
  [SMALL_STATE(154)] = 7215,
  [SMALL_STATE(155)] = 7255,
  [SMALL_STATE(156)] = 7327,
  [SMALL_STATE(157)] = 7371,
  [SMALL_STATE(158)] = 7443,
  [SMALL_STATE(159)] = 7511,
  [SMALL_STATE(160)] = 7555,
  [SMALL_STATE(161)] = 7594,
  [SMALL_STATE(162)] = 7633,
  [SMALL_STATE(163)] = 7676,
  [SMALL_STATE(164)] = 7739,
  [SMALL_STATE(165)] = 7802,
  [SMALL_STATE(166)] = 7865,
  [SMALL_STATE(167)] = 7928,
  [SMALL_STATE(168)] = 7991,
  [SMALL_STATE(169)] = 8032,
  [SMALL_STATE(170)] = 8073,
  [SMALL_STATE(171)] = 8138,
  [SMALL_STATE(172)] = 8181,
  [SMALL_STATE(173)] = 8248,
  [SMALL_STATE(174)] = 8311,
  [SMALL_STATE(175)] = 8376,
  [SMALL_STATE(176)] = 8439,
  [SMALL_STATE(177)] = 8510,
  [SMALL_STATE(178)] = 8553,
  [SMALL_STATE(179)] = 8624,
  [SMALL_STATE(180)] = 8687,
  [SMALL_STATE(181)] = 8725,
  [SMALL_STATE(182)] = 8763,
  [SMALL_STATE(183)] = 8801,
  [SMALL_STATE(184)] = 8839,
  [SMALL_STATE(185)] = 8905,
  [SMALL_STATE(186)] = 8943,
  [SMALL_STATE(187)] = 9009,
  [SMALL_STATE(188)] = 9047,
  [SMALL_STATE(189)] = 9113,
  [SMALL_STATE(190)] = 9151,
  [SMALL_STATE(191)] = 9189,
  [SMALL_STATE(192)] = 9255,
  [SMALL_STATE(193)] = 9321,
  [SMALL_STATE(194)] = 9387,
  [SMALL_STATE(195)] = 9425,
  [SMALL_STATE(196)] = 9463,
  [SMALL_STATE(197)] = 9529,
  [SMALL_STATE(198)] = 9567,
  [SMALL_STATE(199)] = 9605,
  [SMALL_STATE(200)] = 9643,
  [SMALL_STATE(201)] = 9681,
  [SMALL_STATE(202)] = 9719,
  [SMALL_STATE(203)] = 9782,
  [SMALL_STATE(204)] = 9845,
  [SMALL_STATE(205)] = 9886,
  [SMALL_STATE(206)] = 9949,
  [SMALL_STATE(207)] = 9990,
  [SMALL_STATE(208)] = 10031,
  [SMALL_STATE(209)] = 10080,
  [SMALL_STATE(210)] = 10121,
  [SMALL_STATE(211)] = 10184,
  [SMALL_STATE(212)] = 10225,
  [SMALL_STATE(213)] = 10285,
  [SMALL_STATE(214)] = 10345,
  [SMALL_STATE(215)] = 10405,
  [SMALL_STATE(216)] = 10465,
  [SMALL_STATE(217)] = 10525,
  [SMALL_STATE(218)] = 10585,
  [SMALL_STATE(219)] = 10645,
  [SMALL_STATE(220)] = 10705,
  [SMALL_STATE(221)] = 10765,
  [SMALL_STATE(222)] = 10825,
  [SMALL_STATE(223)] = 10885,
  [SMALL_STATE(224)] = 10945,
  [SMALL_STATE(225)] = 11005,
  [SMALL_STATE(226)] = 11065,
  [SMALL_STATE(227)] = 11125,
  [SMALL_STATE(228)] = 11185,
  [SMALL_STATE(229)] = 11245,
  [SMALL_STATE(230)] = 11283,
  [SMALL_STATE(231)] = 11343,
  [SMALL_STATE(232)] = 11403,
  [SMALL_STATE(233)] = 11463,
  [SMALL_STATE(234)] = 11523,
  [SMALL_STATE(235)] = 11583,
  [SMALL_STATE(236)] = 11643,
  [SMALL_STATE(237)] = 11703,
  [SMALL_STATE(238)] = 11741,
  [SMALL_STATE(239)] = 11801,
  [SMALL_STATE(240)] = 11861,
  [SMALL_STATE(241)] = 11921,
  [SMALL_STATE(242)] = 11981,
  [SMALL_STATE(243)] = 12041,
  [SMALL_STATE(244)] = 12101,
  [SMALL_STATE(245)] = 12161,
  [SMALL_STATE(246)] = 12221,
  [SMALL_STATE(247)] = 12281,
  [SMALL_STATE(248)] = 12341,
  [SMALL_STATE(249)] = 12401,
  [SMALL_STATE(250)] = 12461,
  [SMALL_STATE(251)] = 12521,
  [SMALL_STATE(252)] = 12581,
  [SMALL_STATE(253)] = 12619,
  [SMALL_STATE(254)] = 12679,
  [SMALL_STATE(255)] = 12717,
  [SMALL_STATE(256)] = 12777,
  [SMALL_STATE(257)] = 12837,
  [SMALL_STATE(258)] = 12897,
  [SMALL_STATE(259)] = 12957,
  [SMALL_STATE(260)] = 13017,
  [SMALL_STATE(261)] = 13077,
  [SMALL_STATE(262)] = 13137,
  [SMALL_STATE(263)] = 13197,
  [SMALL_STATE(264)] = 13257,
  [SMALL_STATE(265)] = 13317,
  [SMALL_STATE(266)] = 13377,
  [SMALL_STATE(267)] = 13437,
  [SMALL_STATE(268)] = 13497,
  [SMALL_STATE(269)] = 13557,
  [SMALL_STATE(270)] = 13617,
  [SMALL_STATE(271)] = 13677,
  [SMALL_STATE(272)] = 13737,
  [SMALL_STATE(273)] = 13797,
  [SMALL_STATE(274)] = 13857,
  [SMALL_STATE(275)] = 13917,
  [SMALL_STATE(276)] = 13977,
  [SMALL_STATE(277)] = 14037,
  [SMALL_STATE(278)] = 14086,
  [SMALL_STATE(279)] = 14121,
  [SMALL_STATE(280)] = 14168,
  [SMALL_STATE(281)] = 14217,
  [SMALL_STATE(282)] = 14253,
  [SMALL_STATE(283)] = 14289,
  [SMALL_STATE(284)] = 14325,
  [SMALL_STATE(285)] = 14361,
  [SMALL_STATE(286)] = 14400,
  [SMALL_STATE(287)] = 14439,
  [SMALL_STATE(288)] = 14476,
  [SMALL_STATE(289)] = 14513,
  [SMALL_STATE(290)] = 14544,
  [SMALL_STATE(291)] = 14575,
  [SMALL_STATE(292)] = 14614,
  [SMALL_STATE(293)] = 14644,
  [SMALL_STATE(294)] = 14674,
  [SMALL_STATE(295)] = 14704,
  [SMALL_STATE(296)] = 14734,
  [SMALL_STATE(297)] = 14764,
  [SMALL_STATE(298)] = 14794,
  [SMALL_STATE(299)] = 14824,
  [SMALL_STATE(300)] = 14854,
  [SMALL_STATE(301)] = 14884,
  [SMALL_STATE(302)] = 14914,
  [SMALL_STATE(303)] = 14948,
  [SMALL_STATE(304)] = 14978,
  [SMALL_STATE(305)] = 15008,
  [SMALL_STATE(306)] = 15038,
  [SMALL_STATE(307)] = 15072,
  [SMALL_STATE(308)] = 15102,
  [SMALL_STATE(309)] = 15136,
  [SMALL_STATE(310)] = 15166,
  [SMALL_STATE(311)] = 15206,
  [SMALL_STATE(312)] = 15236,
  [SMALL_STATE(313)] = 15276,
  [SMALL_STATE(314)] = 15306,
  [SMALL_STATE(315)] = 15336,
  [SMALL_STATE(316)] = 15366,
  [SMALL_STATE(317)] = 15399,
  [SMALL_STATE(318)] = 15428,
  [SMALL_STATE(319)] = 15465,
  [SMALL_STATE(320)] = 15502,
  [SMALL_STATE(321)] = 15531,
  [SMALL_STATE(322)] = 15564,
  [SMALL_STATE(323)] = 15597,
  [SMALL_STATE(324)] = 15628,
  [SMALL_STATE(325)] = 15662,
  [SMALL_STATE(326)] = 15696,
  [SMALL_STATE(327)] = 15730,
  [SMALL_STATE(328)] = 15764,
  [SMALL_STATE(329)] = 15798,
  [SMALL_STATE(330)] = 15832,
  [SMALL_STATE(331)] = 15866,
  [SMALL_STATE(332)] = 15900,
  [SMALL_STATE(333)] = 15942,
  [SMALL_STATE(334)] = 15971,
  [SMALL_STATE(335)] = 16000,
  [SMALL_STATE(336)] = 16031,
  [SMALL_STATE(337)] = 16064,
  [SMALL_STATE(338)] = 16093,
  [SMALL_STATE(339)] = 16120,
  [SMALL_STATE(340)] = 16149,
  [SMALL_STATE(341)] = 16184,
  [SMALL_STATE(342)] = 16215,
  [SMALL_STATE(343)] = 16246,
  [SMALL_STATE(344)] = 16277,
  [SMALL_STATE(345)] = 16306,
  [SMALL_STATE(346)] = 16339,
  [SMALL_STATE(347)] = 16368,
  [SMALL_STATE(348)] = 16397,
  [SMALL_STATE(349)] = 16426,
  [SMALL_STATE(350)] = 16455,
  [SMALL_STATE(351)] = 16483,
  [SMALL_STATE(352)] = 16511,
  [SMALL_STATE(353)] = 16539,
  [SMALL_STATE(354)] = 16567,
  [SMALL_STATE(355)] = 16595,
  [SMALL_STATE(356)] = 16623,
  [SMALL_STATE(357)] = 16653,
  [SMALL_STATE(358)] = 16681,
  [SMALL_STATE(359)] = 16709,
  [SMALL_STATE(360)] = 16737,
  [SMALL_STATE(361)] = 16765,
  [SMALL_STATE(362)] = 16795,
  [SMALL_STATE(363)] = 16823,
  [SMALL_STATE(364)] = 16851,
  [SMALL_STATE(365)] = 16879,
  [SMALL_STATE(366)] = 16907,
  [SMALL_STATE(367)] = 16935,
  [SMALL_STATE(368)] = 16963,
  [SMALL_STATE(369)] = 16991,
  [SMALL_STATE(370)] = 17019,
  [SMALL_STATE(371)] = 17047,
  [SMALL_STATE(372)] = 17075,
  [SMALL_STATE(373)] = 17103,
  [SMALL_STATE(374)] = 17131,
  [SMALL_STATE(375)] = 17159,
  [SMALL_STATE(376)] = 17187,
  [SMALL_STATE(377)] = 17215,
  [SMALL_STATE(378)] = 17243,
  [SMALL_STATE(379)] = 17271,
  [SMALL_STATE(380)] = 17300,
  [SMALL_STATE(381)] = 17327,
  [SMALL_STATE(382)] = 17360,
  [SMALL_STATE(383)] = 17389,
  [SMALL_STATE(384)] = 17418,
  [SMALL_STATE(385)] = 17453,
  [SMALL_STATE(386)] = 17476,
  [SMALL_STATE(387)] = 17505,
  [SMALL_STATE(388)] = 17528,
  [SMALL_STATE(389)] = 17551,
  [SMALL_STATE(390)] = 17574,
  [SMALL_STATE(391)] = 17619,
  [SMALL_STATE(392)] = 17642,
  [SMALL_STATE(393)] = 17665,
  [SMALL_STATE(394)] = 17688,
  [SMALL_STATE(395)] = 17733,
  [SMALL_STATE(396)] = 17778,
  [SMALL_STATE(397)] = 17807,
  [SMALL_STATE(398)] = 17836,
  [SMALL_STATE(399)] = 17865,
  [SMALL_STATE(400)] = 17895,
  [SMALL_STATE(401)] = 17921,
  [SMALL_STATE(402)] = 17951,
  [SMALL_STATE(403)] = 17981,
  [SMALL_STATE(404)] = 18005,
  [SMALL_STATE(405)] = 18045,
  [SMALL_STATE(406)] = 18075,
  [SMALL_STATE(407)] = 18105,
  [SMALL_STATE(408)] = 18135,
  [SMALL_STATE(409)] = 18159,
  [SMALL_STATE(410)] = 18189,
  [SMALL_STATE(411)] = 18219,
  [SMALL_STATE(412)] = 18249,
  [SMALL_STATE(413)] = 18275,
  [SMALL_STATE(414)] = 18305,
  [SMALL_STATE(415)] = 18335,
  [SMALL_STATE(416)] = 18365,
  [SMALL_STATE(417)] = 18391,
  [SMALL_STATE(418)] = 18421,
  [SMALL_STATE(419)] = 18461,
  [SMALL_STATE(420)] = 18491,
  [SMALL_STATE(421)] = 18521,
  [SMALL_STATE(422)] = 18551,
  [SMALL_STATE(423)] = 18577,
  [SMALL_STATE(424)] = 18602,
  [SMALL_STATE(425)] = 18625,
  [SMALL_STATE(426)] = 18652,
  [SMALL_STATE(427)] = 18679,
  [SMALL_STATE(428)] = 18706,
  [SMALL_STATE(429)] = 18733,
  [SMALL_STATE(430)] = 18760,
  [SMALL_STATE(431)] = 18799,
  [SMALL_STATE(432)] = 18824,
  [SMALL_STATE(433)] = 18845,
  [SMALL_STATE(434)] = 18872,
  [SMALL_STATE(435)] = 18899,
  [SMALL_STATE(436)] = 18926,
  [SMALL_STATE(437)] = 18951,
  [SMALL_STATE(438)] = 18976,
  [SMALL_STATE(439)] = 19003,
  [SMALL_STATE(440)] = 19026,
  [SMALL_STATE(441)] = 19049,
  [SMALL_STATE(442)] = 19072,
  [SMALL_STATE(443)] = 19095,
  [SMALL_STATE(444)] = 19122,
  [SMALL_STATE(445)] = 19143,
  [SMALL_STATE(446)] = 19170,
  [SMALL_STATE(447)] = 19197,
  [SMALL_STATE(448)] = 19220,
  [SMALL_STATE(449)] = 19243,
  [SMALL_STATE(450)] = 19266,
  [SMALL_STATE(451)] = 19289,
  [SMALL_STATE(452)] = 19316,
  [SMALL_STATE(453)] = 19339,
  [SMALL_STATE(454)] = 19362,
  [SMALL_STATE(455)] = 19385,
  [SMALL_STATE(456)] = 19412,
  [SMALL_STATE(457)] = 19435,
  [SMALL_STATE(458)] = 19460,
  [SMALL_STATE(459)] = 19484,
  [SMALL_STATE(460)] = 19508,
  [SMALL_STATE(461)] = 19532,
  [SMALL_STATE(462)] = 19556,
  [SMALL_STATE(463)] = 19592,
  [SMALL_STATE(464)] = 19616,
  [SMALL_STATE(465)] = 19640,
  [SMALL_STATE(466)] = 19664,
  [SMALL_STATE(467)] = 19688,
  [SMALL_STATE(468)] = 19712,
  [SMALL_STATE(469)] = 19736,
  [SMALL_STATE(470)] = 19760,
  [SMALL_STATE(471)] = 19796,
  [SMALL_STATE(472)] = 19820,
  [SMALL_STATE(473)] = 19844,
  [SMALL_STATE(474)] = 19868,
  [SMALL_STATE(475)] = 19892,
  [SMALL_STATE(476)] = 19916,
  [SMALL_STATE(477)] = 19940,
  [SMALL_STATE(478)] = 19964,
  [SMALL_STATE(479)] = 19988,
  [SMALL_STATE(480)] = 20012,
  [SMALL_STATE(481)] = 20036,
  [SMALL_STATE(482)] = 20060,
  [SMALL_STATE(483)] = 20084,
  [SMALL_STATE(484)] = 20108,
  [SMALL_STATE(485)] = 20132,
  [SMALL_STATE(486)] = 20156,
  [SMALL_STATE(487)] = 20180,
  [SMALL_STATE(488)] = 20207,
  [SMALL_STATE(489)] = 20232,
  [SMALL_STATE(490)] = 20257,
  [SMALL_STATE(491)] = 20284,
  [SMALL_STATE(492)] = 20309,
  [SMALL_STATE(493)] = 20334,
  [SMALL_STATE(494)] = 20359,
  [SMALL_STATE(495)] = 20383,
  [SMALL_STATE(496)] = 20407,
  [SMALL_STATE(497)] = 20420,
  [SMALL_STATE(498)] = 20441,
  [SMALL_STATE(499)] = 20454,
  [SMALL_STATE(500)] = 20467,
  [SMALL_STATE(501)] = 20480,
  [SMALL_STATE(502)] = 20493,
  [SMALL_STATE(503)] = 20516,
  [SMALL_STATE(504)] = 20539,
  [SMALL_STATE(505)] = 20552,
  [SMALL_STATE(506)] = 20573,
  [SMALL_STATE(507)] = 20586,
  [SMALL_STATE(508)] = 20600,
  [SMALL_STATE(509)] = 20618,
  [SMALL_STATE(510)] = 20638,
  [SMALL_STATE(511)] = 20658,
  [SMALL_STATE(512)] = 20676,
  [SMALL_STATE(513)] = 20696,
  [SMALL_STATE(514)] = 20716,
  [SMALL_STATE(515)] = 20731,
  [SMALL_STATE(516)] = 20748,
  [SMALL_STATE(517)] = 20763,
  [SMALL_STATE(518)] = 20780,
  [SMALL_STATE(519)] = 20797,
  [SMALL_STATE(520)] = 20814,
  [SMALL_STATE(521)] = 20831,
  [SMALL_STATE(522)] = 20846,
  [SMALL_STATE(523)] = 20863,
  [SMALL_STATE(524)] = 20878,
  [SMALL_STATE(525)] = 20895,
  [SMALL_STATE(526)] = 20912,
  [SMALL_STATE(527)] = 20929,
  [SMALL_STATE(528)] = 20946,
  [SMALL_STATE(529)] = 20957,
  [SMALL_STATE(530)] = 20972,
  [SMALL_STATE(531)] = 20989,
  [SMALL_STATE(532)] = 21006,
  [SMALL_STATE(533)] = 21023,
  [SMALL_STATE(534)] = 21038,
  [SMALL_STATE(535)] = 21055,
  [SMALL_STATE(536)] = 21070,
  [SMALL_STATE(537)] = 21087,
  [SMALL_STATE(538)] = 21098,
  [SMALL_STATE(539)] = 21109,
  [SMALL_STATE(540)] = 21126,
  [SMALL_STATE(541)] = 21143,
  [SMALL_STATE(542)] = 21158,
  [SMALL_STATE(543)] = 21173,
  [SMALL_STATE(544)] = 21190,
  [SMALL_STATE(545)] = 21201,
  [SMALL_STATE(546)] = 21218,
  [SMALL_STATE(547)] = 21231,
  [SMALL_STATE(548)] = 21248,
  [SMALL_STATE(549)] = 21262,
  [SMALL_STATE(550)] = 21276,
  [SMALL_STATE(551)] = 21290,
  [SMALL_STATE(552)] = 21304,
  [SMALL_STATE(553)] = 21316,
  [SMALL_STATE(554)] = 21330,
  [SMALL_STATE(555)] = 21342,
  [SMALL_STATE(556)] = 21356,
  [SMALL_STATE(557)] = 21370,
  [SMALL_STATE(558)] = 21384,
  [SMALL_STATE(559)] = 21398,
  [SMALL_STATE(560)] = 21412,
  [SMALL_STATE(561)] = 21426,
  [SMALL_STATE(562)] = 21440,
  [SMALL_STATE(563)] = 21454,
  [SMALL_STATE(564)] = 21468,
  [SMALL_STATE(565)] = 21482,
  [SMALL_STATE(566)] = 21496,
  [SMALL_STATE(567)] = 21510,
  [SMALL_STATE(568)] = 21524,
  [SMALL_STATE(569)] = 21538,
  [SMALL_STATE(570)] = 21552,
  [SMALL_STATE(571)] = 21566,
  [SMALL_STATE(572)] = 21580,
  [SMALL_STATE(573)] = 21594,
  [SMALL_STATE(574)] = 21608,
  [SMALL_STATE(575)] = 21622,
  [SMALL_STATE(576)] = 21633,
  [SMALL_STATE(577)] = 21644,
  [SMALL_STATE(578)] = 21653,
  [SMALL_STATE(579)] = 21664,
  [SMALL_STATE(580)] = 21675,
  [SMALL_STATE(581)] = 21686,
  [SMALL_STATE(582)] = 21697,
  [SMALL_STATE(583)] = 21708,
  [SMALL_STATE(584)] = 21719,
  [SMALL_STATE(585)] = 21728,
  [SMALL_STATE(586)] = 21739,
  [SMALL_STATE(587)] = 21750,
  [SMALL_STATE(588)] = 21761,
  [SMALL_STATE(589)] = 21770,
  [SMALL_STATE(590)] = 21779,
  [SMALL_STATE(591)] = 21790,
  [SMALL_STATE(592)] = 21801,
  [SMALL_STATE(593)] = 21812,
  [SMALL_STATE(594)] = 21823,
  [SMALL_STATE(595)] = 21834,
  [SMALL_STATE(596)] = 21845,
  [SMALL_STATE(597)] = 21853,
  [SMALL_STATE(598)] = 21861,
  [SMALL_STATE(599)] = 21869,
  [SMALL_STATE(600)] = 21877,
  [SMALL_STATE(601)] = 21885,
  [SMALL_STATE(602)] = 21893,
  [SMALL_STATE(603)] = 21901,
  [SMALL_STATE(604)] = 21909,
  [SMALL_STATE(605)] = 21917,
  [SMALL_STATE(606)] = 21925,
  [SMALL_STATE(607)] = 21933,
  [SMALL_STATE(608)] = 21941,
  [SMALL_STATE(609)] = 21949,
  [SMALL_STATE(610)] = 21957,
  [SMALL_STATE(611)] = 21965,
  [SMALL_STATE(612)] = 21973,
  [SMALL_STATE(613)] = 21981,
  [SMALL_STATE(614)] = 21989,
  [SMALL_STATE(615)] = 21997,
  [SMALL_STATE(616)] = 22005,
  [SMALL_STATE(617)] = 22013,
  [SMALL_STATE(618)] = 22021,
  [SMALL_STATE(619)] = 22029,
  [SMALL_STATE(620)] = 22037,
  [SMALL_STATE(621)] = 22045,
  [SMALL_STATE(622)] = 22053,
  [SMALL_STATE(623)] = 22061,
  [SMALL_STATE(624)] = 22069,
  [SMALL_STATE(625)] = 22077,
  [SMALL_STATE(626)] = 22085,
  [SMALL_STATE(627)] = 22093,
  [SMALL_STATE(628)] = 22101,
  [SMALL_STATE(629)] = 22109,
  [SMALL_STATE(630)] = 22117,
  [SMALL_STATE(631)] = 22125,
  [SMALL_STATE(632)] = 22133,
  [SMALL_STATE(633)] = 22141,
  [SMALL_STATE(634)] = 22149,
  [SMALL_STATE(635)] = 22157,
  [SMALL_STATE(636)] = 22165,
  [SMALL_STATE(637)] = 22173,
  [SMALL_STATE(638)] = 22181,
  [SMALL_STATE(639)] = 22189,
  [SMALL_STATE(640)] = 22197,
  [SMALL_STATE(641)] = 22205,
  [SMALL_STATE(642)] = 22213,
  [SMALL_STATE(643)] = 22221,
  [SMALL_STATE(644)] = 22229,
  [SMALL_STATE(645)] = 22237,
  [SMALL_STATE(646)] = 22245,
  [SMALL_STATE(647)] = 22253,
  [SMALL_STATE(648)] = 22261,
  [SMALL_STATE(649)] = 22269,
  [SMALL_STATE(650)] = 22277,
  [SMALL_STATE(651)] = 22285,
  [SMALL_STATE(652)] = 22293,
  [SMALL_STATE(653)] = 22301,
  [SMALL_STATE(654)] = 22309,
  [SMALL_STATE(655)] = 22317,
  [SMALL_STATE(656)] = 22325,
  [SMALL_STATE(657)] = 22333,
  [SMALL_STATE(658)] = 22341,
  [SMALL_STATE(659)] = 22349,
  [SMALL_STATE(660)] = 22357,
  [SMALL_STATE(661)] = 22365,
  [SMALL_STATE(662)] = 22373,
  [SMALL_STATE(663)] = 22381,
  [SMALL_STATE(664)] = 22389,
  [SMALL_STATE(665)] = 22397,
  [SMALL_STATE(666)] = 22405,
  [SMALL_STATE(667)] = 22413,
  [SMALL_STATE(668)] = 22421,
  [SMALL_STATE(669)] = 22429,
  [SMALL_STATE(670)] = 22437,
  [SMALL_STATE(671)] = 22445,
  [SMALL_STATE(672)] = 22453,
  [SMALL_STATE(673)] = 22461,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_stylesheet, .child_count = 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(230),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(232),
  [84] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(407),
  [87] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(257),
  [90] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(502),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(661),
  [96] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(421),
  [99] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(340),
  [102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(296),
  [105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(524),
  [108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(651),
  [111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(650),
  [114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(170),
  [117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(649),
  [120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(646),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(382),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(29),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(240),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(224),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(644),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(640),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(639),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(218),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(19),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(221),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(222),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(223),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(225),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(227),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(638),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(637),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(230),
  [174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(231),
  [177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(636),
  [180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(597),
  [183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_stylesheet_repeat1, .child_count = 2), SHIFT_REPEAT(547),
  [186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_stylesheet, .child_count = 1),
  [188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(620),
  [212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(269),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(410),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(271),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(503),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(614),
  [267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2),
  [269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(399),
  [272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(340),
  [275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(296),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(524),
  [281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(651),
  [284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(650),
  [287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(170),
  [290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(649),
  [293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(646),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(379),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(36),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(618),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(619),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(620),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(272),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(20),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(274),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(275),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(273),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(266),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(259),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(669),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(673),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(253),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(231),
  [344] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(636),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(664),
  [350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_block_repeat1, .child_count = 2), SHIFT_REPEAT(547),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_if_statement, .child_count = 4, .production_id = 11),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_if_statement, .child_count = 4, .production_id = 11),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_if_statement, .child_count = 3, .production_id = 11),
  [427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_if_statement, .child_count = 3, .production_id = 11),
  [429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_if_statement_repeat1, .child_count = 2),
  [431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_if_statement_repeat1, .child_count = 2),
  [433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_if_statement_repeat1, .child_count = 2), SHIFT_REPEAT(629),
  [436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_last_declaration, .child_count = 3, .production_id = 16),
  [444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(249),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_else_if_clause, .child_count = 4, .production_id = 24),
  [468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_else_if_clause, .child_count = 4, .production_id = 24),
  [470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_if_statement_repeat1, .child_count = 2), SHIFT_REPEAT(641),
  [491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block, .child_count = 4),
  [493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_block, .child_count = 4),
  [495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block, .child_count = 3),
  [497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_block, .child_count = 3),
  [499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_block, .child_count = 2),
  [501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_block, .child_count = 2),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_at_rule, .child_count = 3),
  [511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_at_rule, .child_count = 3),
  [513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_while_statement, .child_count = 3),
  [515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_while_statement, .child_count = 3),
  [517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_postcss_statement, .child_count = 3),
  [519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_postcss_statement, .child_count = 3),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_use_statement, .child_count = 3),
  [523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_use_statement, .child_count = 3),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_forward_statement, .child_count = 3),
  [527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_forward_statement, .child_count = 3),
  [529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_mixin_statement, .child_count = 3, .production_id = 10),
  [531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_mixin_statement, .child_count = 3, .production_id = 10),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_include_statement, .child_count = 3),
  [535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_include_statement, .child_count = 3),
  [537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_statement, .child_count = 3, .production_id = 10),
  [539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_statement, .child_count = 3, .production_id = 10),
  [541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_supports_statement, .child_count = 3),
  [543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_supports_statement, .child_count = 3),
  [545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_keyframes_statement, .child_count = 3, .production_id = 8),
  [547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_keyframes_statement, .child_count = 3, .production_id = 8),
  [549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_namespace_statement, .child_count = 3),
  [551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_namespace_statement, .child_count = 3),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_charset_statement, .child_count = 3),
  [555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_charset_statement, .child_count = 3),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_return_statement, .child_count = 3),
  [559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_return_statement, .child_count = 3),
  [561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_media_statement, .child_count = 3),
  [563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_media_statement, .child_count = 3),
  [565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_each_statement, .child_count = 7, .production_id = 25),
  [567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_each_statement, .child_count = 7, .production_id = 25),
  [569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_at_root_statement, .child_count = 3),
  [571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_at_root_statement, .child_count = 3),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_declaration, .child_count = 6, .production_id = 16),
  [575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_declaration, .child_count = 6, .production_id = 16),
  [577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_debug_statement, .child_count = 3),
  [579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_debug_statement, .child_count = 3),
  [581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_each_statement, .child_count = 5, .production_id = 20),
  [583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_each_statement, .child_count = 5, .production_id = 20),
  [585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_if_statement, .child_count = 5, .production_id = 11),
  [587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_if_statement, .child_count = 5, .production_id = 11),
  [589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_else_clause, .child_count = 2),
  [591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_else_clause, .child_count = 2),
  [593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_error_statement, .child_count = 3),
  [595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_error_statement, .child_count = 3),
  [597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_declaration, .child_count = 5, .production_id = 16),
  [599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_declaration, .child_count = 5, .production_id = 16),
  [601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_mixin_statement, .child_count = 4, .production_id = 10),
  [603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_mixin_statement, .child_count = 4, .production_id = 10),
  [605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_keyframe_block_list, .child_count = 3),
  [607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_keyframe_block_list, .child_count = 3),
  [609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_import_statement, .child_count = 3),
  [611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_import_statement, .child_count = 3),
  [613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_extend_statement, .child_count = 3),
  [615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_extend_statement, .child_count = 3),
  [617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_import_statement, .child_count = 5),
  [619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_import_statement, .child_count = 5),
  [621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_at_rule, .child_count = 2),
  [623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_at_rule, .child_count = 2),
  [625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_at_rule, .child_count = 4),
  [627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_at_rule, .child_count = 4),
  [629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_include_statement, .child_count = 4),
  [631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_include_statement, .child_count = 4),
  [633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_import_statement, .child_count = 4),
  [635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_import_statement, .child_count = 4),
  [637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_rule_set, .child_count = 2),
  [639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_rule_set, .child_count = 2),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_media_statement, .child_count = 4),
  [643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_media_statement, .child_count = 4),
  [645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_namespace_statement, .child_count = 4, .production_id = 15),
  [647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_namespace_statement, .child_count = 4, .production_id = 15),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_keyframe_block_list, .child_count = 2),
  [651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_keyframe_block_list, .child_count = 2),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_warn_statement, .child_count = 3),
  [655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_warn_statement, .child_count = 3),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_declaration, .child_count = 4, .production_id = 16),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_declaration, .child_count = 4, .production_id = 16),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_for_statement, .child_count = 7, .production_id = 26),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_for_statement, .child_count = 7, .production_id = 26),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_function_statement, .child_count = 4, .production_id = 10),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_function_statement, .child_count = 4, .production_id = 10),
  [669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__selector, .child_count = 1, .production_id = 1),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__value, .child_count = 1, .production_id = 3),
  [673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__selector, .child_count = 1, .production_id = 1),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__value, .child_count = 1, .production_id = 3),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym__concatenated_identifier_repeat1, .child_count = 2),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym__concatenated_identifier_repeat1, .child_count = 2),
  [707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__concatenated_identifier_repeat1, .child_count = 2), SHIFT_REPEAT(525),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__concatenated_identifier, .child_count = 2),
  [712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__concatenated_identifier, .child_count = 2),
  [714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__concatenated_identifier, .child_count = 1),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__concatenated_identifier, .child_count = 1),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__selector, .child_count = 1),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__value, .child_count = 1),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__selector, .child_count = 1),
  [724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__value, .child_count = 1),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__query, .child_count = 1, .production_id = 4),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__query, .child_count = 1, .production_id = 4),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_interpolation, .child_count = 3),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_interpolation, .child_count = 3),
  [738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_string_value, .child_count = 3),
  [750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_string_value, .child_count = 3),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__query, .child_count = 1),
  [762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym__query, .child_count = 1),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(235),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2),
  [771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(206),
  [774] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(606),
  [777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(262),
  [780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(219),
  [783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(647),
  [786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(648),
  [789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(168),
  [792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(169),
  [795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(143),
  [798] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(159),
  [801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(263),
  [804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2), SHIFT_REPEAT(206),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_arguments_repeat1, .child_count = 2),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_last_declaration, .child_count = 4, .production_id = 16),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__concatenated_identifier_repeat1, .child_count = 2), SHIFT_REPEAT(519),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2),
  [826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(209),
  [829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(606),
  [832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(262),
  [835] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(219),
  [838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(647),
  [841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(648),
  [844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(168),
  [847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(169),
  [850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(143),
  [853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(159),
  [856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(263),
  [859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 2), SHIFT_REPEAT(209),
  [862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__concatenated_identifier_repeat1, .child_count = 2), SHIFT_REPEAT(545),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_integer_value, .child_count = 1),
  [869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_integer_value, .child_count = 1),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_float_value, .child_count = 1),
  [875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_float_value, .child_count = 1),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_pseudo_class_arguments_repeat1, .child_count = 2),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_binary_expression, .child_count = 3),
  [907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_binary_expression, .child_count = 3),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_float_value, .child_count = 2),
  [911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_float_value, .child_count = 2),
  [913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_arguments, .child_count = 3),
  [915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_arguments, .child_count = 3),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parenthesized_value, .child_count = 3),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_parenthesized_value, .child_count = 3),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_arguments, .child_count = 4),
  [927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_arguments, .child_count = 4),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_grid_value, .child_count = 3),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_grid_value, .child_count = 3),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_list_value, .child_count = 4),
  [943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_list_value, .child_count = 4),
  [945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_call_expression, .child_count = 2, .production_id = 7),
  [947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_call_expression, .child_count = 2, .production_id = 7),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_arguments, .child_count = 2),
  [953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_arguments, .child_count = 2),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_grid_value, .child_count = 4),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_grid_value, .child_count = 4),
  [959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_integer_value, .child_count = 2),
  [961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_integer_value, .child_count = 2),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_color_value, .child_count = 2),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_color_value, .child_count = 2),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 1),
  [993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 1),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_declaration_repeat1, .child_count = 2),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 1),
  [1001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = aux_sym_postcss_statement_repeat1, .child_count = 1),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_last_declaration, .child_count = 5, .production_id = 16),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(480),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_element_selector, .child_count = 3, .production_id = 13),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_element_selector, .child_count = 3, .production_id = 13),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_class_selector, .child_count = 2, .production_id = 2),
  [1281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_class_selector, .child_count = 2, .production_id = 2),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_element_selector, .child_count = 2, .production_id = 5),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_element_selector, .child_count = 2, .production_id = 5),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_class_selector, .child_count = 3, .production_id = 12),
  [1291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_class_selector, .child_count = 3, .production_id = 12),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_class_selector, .child_count = 2, .production_id = 2),
  [1299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_class_selector, .child_count = 2, .production_id = 2),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_class_selector, .child_count = 3, .production_id = 12),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_class_selector, .child_count = 3, .production_id = 12),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_element_arguments, .child_count = 2),
  [1307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_element_arguments, .child_count = 2),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_class_arguments, .child_count = 3),
  [1311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_class_arguments, .child_count = 3),
  [1313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_class_selector, .child_count = 4, .production_id = 12),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_class_selector, .child_count = 4, .production_id = 12),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_universal_selector, .child_count = 1),
  [1319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_universal_selector, .child_count = 1),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_class_arguments, .child_count = 2),
  [1323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_class_arguments, .child_count = 2),
  [1325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_element_selector, .child_count = 3, .production_id = 5),
  [1327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_element_selector, .child_count = 3, .production_id = 5),
  [1329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_class_arguments, .child_count = 4),
  [1331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_class_arguments, .child_count = 4),
  [1333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_element_arguments, .child_count = 3),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_element_arguments, .child_count = 3),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_element_arguments, .child_count = 4),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_element_arguments, .child_count = 4),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute_selector, .child_count = 3, .production_id = 9),
  [1343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_attribute_selector, .child_count = 3, .production_id = 9),
  [1345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute_selector, .child_count = 4, .production_id = 18),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_attribute_selector, .child_count = 4, .production_id = 18),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute_selector, .child_count = 6, .production_id = 18),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_attribute_selector, .child_count = 6, .production_id = 18),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_placeholder, .child_count = 2),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_placeholder, .child_count = 2),
  [1357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__concatenated_identifier_repeat1, .child_count = 2), SHIFT_REPEAT(515),
  [1360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_id_selector, .child_count = 3, .production_id = 14),
  [1362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_id_selector, .child_count = 3, .production_id = 14),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_id_selector, .child_count = 2, .production_id = 6),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_id_selector, .child_count = 2, .production_id = 6),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [1374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_class_selector, .child_count = 3, .production_id = 2),
  [1376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_class_selector, .child_count = 3, .production_id = 2),
  [1378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_pseudo_element_selector, .child_count = 4, .production_id = 13),
  [1380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_pseudo_element_selector, .child_count = 4, .production_id = 13),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_attribute_selector, .child_count = 5, .production_id = 9),
  [1384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_attribute_selector, .child_count = 5, .production_id = 9),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__concatenated_identifier_repeat1, .child_count = 2), SHIFT_REPEAT(527),
  [1393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__concatenated_identifier_repeat1, .child_count = 2), SHIFT_REPEAT(530),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_namespace_selector, .child_count = 3),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_namespace_selector, .child_count = 3),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_adjacent_sibling_selector, .child_count = 3),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_adjacent_sibling_selector, .child_count = 3),
  [1408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [1410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_child_selector, .child_count = 3),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_child_selector, .child_count = 3),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_sibling_selector, .child_count = 3),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_sibling_selector, .child_count = 3),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_descendant_selector, .child_count = 3),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(.symbol = sym_descendant_selector, .child_count = 3),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [1430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_selectors, .child_count = 1),
  [1462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__concatenated_identifier_repeat1, .child_count = 2), SHIFT_REPEAT(540),
  [1465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_grid_value_repeat1, .child_count = 2),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_selectors_repeat1, .child_count = 2),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__include_argument, .child_count = 1, .production_id = 17),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__include_argument, .child_count = 3, .production_id = 23),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [1515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameter, .child_count = 3, .production_id = 22),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_keyframe_block_list_repeat1, .child_count = 2),
  [1597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_keyframe_block_list_repeat1, .child_count = 2), SHIFT_REPEAT(611),
  [1600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_keyframe_block_list_repeat1, .child_count = 2), SHIFT_REPEAT(595),
  [1603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_keyframe_block_list_repeat1, .child_count = 2), SHIFT_REPEAT(576),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_selector_query, .child_count = 4),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parenthesized_query, .child_count = 3),
  [1618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_feature_query, .child_count = 5, .production_id = 21),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_binary_query, .child_count = 3),
  [1622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_unary_query, .child_count = 2),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_import_statement_repeat1, .child_count = 2),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_arguments_repeat1, .child_count = 2), SHIFT_REPEAT(210),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_keyframe_block, .child_count = 2),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_grid_value_repeat1, .child_count = 2), SHIFT_REPEAT(217),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [1692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_import_statement_repeat1, .child_count = 2), SHIFT_REPEAT(401),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_selectors, .child_count = 2),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameter, .child_count = 1),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_selectors_repeat1, .child_count = 2), SHIFT_REPEAT(167),
  [1744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym__include_arguments_repeat1, .child_count = 2), SHIFT_REPEAT(205),
  [1747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym__include_arguments_repeat1, .child_count = 2),
  [1749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_parameters_repeat1, .child_count = 2), SHIFT_REPEAT(583),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym_parameters_repeat1, .child_count = 2),
  [1754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [1762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(.symbol = aux_sym_pseudo_class_arguments_repeat1, .child_count = 2), SHIFT_REPEAT(17),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__include_arguments, .child_count = 3, .production_id = 19),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = aux_sym__include_arguments_repeat1, .child_count = 2, .production_id = 19),
  [1791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym__include_arguments, .child_count = 4, .production_id = 19),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [1819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameters, .child_count = 3),
  [1821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_from, .child_count = 1),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1857] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(605),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(.symbol = sym_parameters, .child_count = 4),
  [1877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [1879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(635),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [1915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__descendant_operator = 0,
  ts_external_token__pseudo_class_selector_colon = 1,
  ts_external_token___error_recovery = 2,
  ts_external_token__concat = 3,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__descendant_operator] = sym__descendant_operator,
  [ts_external_token__pseudo_class_selector_colon] = sym__pseudo_class_selector_colon,
  [ts_external_token___error_recovery] = sym___error_recovery,
  [ts_external_token__concat] = sym__concat,
};

static const bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__descendant_operator] = true,
    [ts_external_token__pseudo_class_selector_colon] = true,
    [ts_external_token___error_recovery] = true,
    [ts_external_token__concat] = true,
  },
  [2] = {
    [ts_external_token__pseudo_class_selector_colon] = true,
  },
  [3] = {
    [ts_external_token__descendant_operator] = true,
    [ts_external_token__pseudo_class_selector_colon] = true,
    [ts_external_token__concat] = true,
  },
  [4] = {
    [ts_external_token__descendant_operator] = true,
    [ts_external_token__pseudo_class_selector_colon] = true,
  },
  [5] = {
    [ts_external_token__concat] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_scss_external_scanner_create(void);
void tree_sitter_scss_external_scanner_destroy(void *);
bool tree_sitter_scss_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_scss_external_scanner_serialize(void *, char *);
void tree_sitter_scss_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_scss() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_scss_external_scanner_create,
      tree_sitter_scss_external_scanner_destroy,
      tree_sitter_scss_external_scanner_scan,
      tree_sitter_scss_external_scanner_serialize,
      tree_sitter_scss_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
