#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 835
#define LARGE_STATE_COUNT 317
#define SYMBOL_COUNT 517
#define ALIAS_COUNT 3
#define TOKEN_COUNT 326
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 35
#define MAX_ALIAS_SEQUENCE_LENGTH 12
#define PRODUCTION_ID_COUNT 87

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_pragma = 2,
  anon_sym_PIPE_PIPE = 3,
  anon_sym_DASH = 4,
  anon_sym_solidity = 5,
  aux_sym_pragma_value_token1 = 6,
  sym_solidity_version = 7,
  anon_sym_LT_EQ = 8,
  anon_sym_LT = 9,
  anon_sym_CARET = 10,
  anon_sym_GT = 11,
  anon_sym_GT_EQ = 12,
  anon_sym_TILDE = 13,
  anon_sym_EQ = 14,
  anon_sym_import = 15,
  anon_sym_from = 16,
  anon_sym_STAR = 17,
  anon_sym_LBRACE = 18,
  anon_sym_COMMA = 19,
  anon_sym_RBRACE = 20,
  anon_sym_as = 21,
  anon_sym_type = 22,
  anon_sym_is = 23,
  anon_sym_constant = 24,
  anon_sym_abstract = 25,
  anon_sym_contract = 26,
  anon_sym_error = 27,
  anon_sym_LPAREN = 28,
  anon_sym_RPAREN = 29,
  anon_sym_interface = 30,
  anon_sym_library = 31,
  anon_sym_struct = 32,
  anon_sym_enum = 33,
  anon_sym_event = 34,
  anon_sym_anonymous = 35,
  anon_sym_indexed = 36,
  anon_sym_using = 37,
  anon_sym_for = 38,
  anon_sym_assembly = 39,
  anon_sym_DQUOTEevmasm_DQUOTE = 40,
  anon_sym_COLON = 41,
  sym_yul_leave = 42,
  anon_sym_break = 43,
  anon_sym_continue = 44,
  anon_sym_DOT = 45,
  sym_yul_decimal_number = 46,
  sym_yul_hex_number = 47,
  anon_sym_true = 48,
  anon_sym_false = 49,
  anon_sym_let = 50,
  anon_sym_COLON_EQ = 51,
  anon_sym_if = 52,
  anon_sym_switch = 53,
  anon_sym_default = 54,
  anon_sym_case = 55,
  anon_sym_function = 56,
  anon_sym_DASH_GT = 57,
  anon_sym_stop = 58,
  anon_sym_add = 59,
  anon_sym_sub = 60,
  anon_sym_mul = 61,
  anon_sym_div = 62,
  anon_sym_sdiv = 63,
  anon_sym_mod = 64,
  anon_sym_smod = 65,
  anon_sym_exp = 66,
  anon_sym_not = 67,
  anon_sym_lt = 68,
  anon_sym_gt = 69,
  anon_sym_slt = 70,
  anon_sym_sgt = 71,
  anon_sym_eq = 72,
  anon_sym_iszero = 73,
  anon_sym_and = 74,
  anon_sym_or = 75,
  anon_sym_xor = 76,
  anon_sym_byte = 77,
  anon_sym_shl = 78,
  anon_sym_shr = 79,
  anon_sym_sar = 80,
  anon_sym_addmod = 81,
  anon_sym_mulmod = 82,
  anon_sym_signextend = 83,
  anon_sym_keccak256 = 84,
  anon_sym_pop = 85,
  anon_sym_mload = 86,
  anon_sym_mcopy = 87,
  anon_sym_tload = 88,
  anon_sym_tstore = 89,
  anon_sym_mstore = 90,
  anon_sym_mstore8 = 91,
  anon_sym_sload = 92,
  anon_sym_sstore = 93,
  anon_sym_msize = 94,
  anon_sym_gas = 95,
  anon_sym_address = 96,
  anon_sym_balance = 97,
  anon_sym_selfbalance = 98,
  anon_sym_caller = 99,
  anon_sym_callvalue = 100,
  anon_sym_calldataload = 101,
  anon_sym_calldatasize = 102,
  anon_sym_calldatacopy = 103,
  anon_sym_extcodesize = 104,
  anon_sym_extcodecopy = 105,
  anon_sym_returndatasize = 106,
  anon_sym_returndatacopy = 107,
  anon_sym_extcodehash = 108,
  anon_sym_create = 109,
  anon_sym_create2 = 110,
  anon_sym_call = 111,
  anon_sym_callcode = 112,
  anon_sym_delegatecall = 113,
  anon_sym_staticcall = 114,
  anon_sym_return = 115,
  anon_sym_revert = 116,
  anon_sym_selfdestruct = 117,
  anon_sym_invalid = 118,
  anon_sym_log0 = 119,
  anon_sym_log1 = 120,
  anon_sym_log2 = 121,
  anon_sym_log3 = 122,
  anon_sym_log4 = 123,
  anon_sym_chainid = 124,
  anon_sym_origin = 125,
  anon_sym_gasprice = 126,
  anon_sym_blockhash = 127,
  anon_sym_blobhash = 128,
  anon_sym_basefee = 129,
  anon_sym_blobfee = 130,
  anon_sym_coinbase = 131,
  anon_sym_timestamp = 132,
  anon_sym_number = 133,
  anon_sym_difficulty = 134,
  anon_sym_gaslimit = 135,
  sym_unchecked = 136,
  anon_sym_memory = 137,
  anon_sym_storage = 138,
  anon_sym_calldata = 139,
  anon_sym_var = 140,
  anon_sym_else = 141,
  anon_sym_while = 142,
  anon_sym_do = 143,
  anon_sym_try = 144,
  anon_sym_returns = 145,
  anon_sym_catch = 146,
  anon_sym_emit = 147,
  anon_sym_public = 148,
  anon_sym_internal = 149,
  anon_sym_private = 150,
  anon_sym_external = 151,
  anon_sym_pure = 152,
  anon_sym_view = 153,
  anon_sym_payable = 154,
  sym_immutable = 155,
  anon_sym_override = 156,
  anon_sym_modifier = 157,
  anon_sym_constructor = 158,
  anon_sym_fallback = 159,
  anon_sym_receive = 160,
  sym_virtual = 161,
  anon_sym_QMARK = 162,
  anon_sym_new = 163,
  anon_sym_LBRACK = 164,
  anon_sym_RBRACK = 165,
  anon_sym_AMP_AMP = 166,
  anon_sym_GT_GT = 167,
  anon_sym_GT_GT_GT = 168,
  anon_sym_LT_LT = 169,
  anon_sym_AMP = 170,
  anon_sym_PIPE = 171,
  anon_sym_PLUS = 172,
  anon_sym_SLASH = 173,
  anon_sym_PERCENT = 174,
  anon_sym_STAR_STAR = 175,
  anon_sym_EQ_EQ = 176,
  anon_sym_BANG_EQ = 177,
  anon_sym_BANG_EQ_EQ = 178,
  anon_sym_BANG = 179,
  anon_sym_delete = 180,
  anon_sym_PLUS_PLUS = 181,
  anon_sym_DASH_DASH = 182,
  anon_sym_PLUS_EQ = 183,
  anon_sym_DASH_EQ = 184,
  anon_sym_STAR_EQ = 185,
  anon_sym_SLASH_EQ = 186,
  anon_sym_PERCENT_EQ = 187,
  anon_sym_CARET_EQ = 188,
  anon_sym_AMP_EQ = 189,
  anon_sym_PIPE_EQ = 190,
  anon_sym_GT_GT_EQ = 191,
  anon_sym_GT_GT_GT_EQ = 192,
  anon_sym_LT_LT_EQ = 193,
  anon_sym_mapping = 194,
  anon_sym_EQ_GT = 195,
  anon_sym_bool = 196,
  anon_sym_string = 197,
  anon_sym_int = 198,
  anon_sym_int8 = 199,
  anon_sym_int16 = 200,
  anon_sym_int24 = 201,
  anon_sym_int32 = 202,
  anon_sym_int40 = 203,
  anon_sym_int48 = 204,
  anon_sym_int56 = 205,
  anon_sym_int64 = 206,
  anon_sym_int72 = 207,
  anon_sym_int80 = 208,
  anon_sym_int88 = 209,
  anon_sym_int96 = 210,
  anon_sym_int104 = 211,
  anon_sym_int112 = 212,
  anon_sym_int120 = 213,
  anon_sym_int128 = 214,
  anon_sym_int136 = 215,
  anon_sym_int144 = 216,
  anon_sym_int152 = 217,
  anon_sym_int160 = 218,
  anon_sym_int168 = 219,
  anon_sym_int176 = 220,
  anon_sym_int184 = 221,
  anon_sym_int192 = 222,
  anon_sym_int200 = 223,
  anon_sym_int208 = 224,
  anon_sym_int216 = 225,
  anon_sym_int224 = 226,
  anon_sym_int232 = 227,
  anon_sym_int240 = 228,
  anon_sym_int248 = 229,
  anon_sym_int256 = 230,
  anon_sym_uint = 231,
  anon_sym_uint8 = 232,
  anon_sym_uint16 = 233,
  anon_sym_uint24 = 234,
  anon_sym_uint32 = 235,
  anon_sym_uint40 = 236,
  anon_sym_uint48 = 237,
  anon_sym_uint56 = 238,
  anon_sym_uint64 = 239,
  anon_sym_uint72 = 240,
  anon_sym_uint80 = 241,
  anon_sym_uint88 = 242,
  anon_sym_uint96 = 243,
  anon_sym_uint104 = 244,
  anon_sym_uint112 = 245,
  anon_sym_uint120 = 246,
  anon_sym_uint128 = 247,
  anon_sym_uint136 = 248,
  anon_sym_uint144 = 249,
  anon_sym_uint152 = 250,
  anon_sym_uint160 = 251,
  anon_sym_uint168 = 252,
  anon_sym_uint176 = 253,
  anon_sym_uint184 = 254,
  anon_sym_uint192 = 255,
  anon_sym_uint200 = 256,
  anon_sym_uint208 = 257,
  anon_sym_uint216 = 258,
  anon_sym_uint224 = 259,
  anon_sym_uint232 = 260,
  anon_sym_uint240 = 261,
  anon_sym_uint248 = 262,
  anon_sym_uint256 = 263,
  anon_sym_bytes = 264,
  anon_sym_bytes1 = 265,
  anon_sym_bytes2 = 266,
  anon_sym_bytes3 = 267,
  anon_sym_bytes4 = 268,
  anon_sym_bytes5 = 269,
  anon_sym_bytes6 = 270,
  anon_sym_bytes7 = 271,
  anon_sym_bytes8 = 272,
  anon_sym_bytes9 = 273,
  anon_sym_bytes10 = 274,
  anon_sym_bytes11 = 275,
  anon_sym_bytes12 = 276,
  anon_sym_bytes13 = 277,
  anon_sym_bytes14 = 278,
  anon_sym_bytes15 = 279,
  anon_sym_bytes16 = 280,
  anon_sym_bytes17 = 281,
  anon_sym_bytes18 = 282,
  anon_sym_bytes19 = 283,
  anon_sym_bytes20 = 284,
  anon_sym_bytes21 = 285,
  anon_sym_bytes22 = 286,
  anon_sym_bytes23 = 287,
  anon_sym_bytes24 = 288,
  anon_sym_bytes25 = 289,
  anon_sym_bytes26 = 290,
  anon_sym_bytes27 = 291,
  anon_sym_bytes28 = 292,
  anon_sym_bytes29 = 293,
  anon_sym_bytes30 = 294,
  anon_sym_bytes31 = 295,
  anon_sym_bytes32 = 296,
  anon_sym_fixed = 297,
  aux_sym__fixed_token1 = 298,
  anon_sym_ufixed = 299,
  aux_sym__ufixed_token1 = 300,
  sym__semicolon = 301,
  aux_sym__decimal_number_token1 = 302,
  aux_sym__decimal_number_token2 = 303,
  aux_sym__hex_number_token1 = 304,
  sym__hex_digit = 305,
  anon_sym_wei = 306,
  anon_sym_szabo = 307,
  anon_sym_finney = 308,
  anon_sym_gwei = 309,
  anon_sym_ether = 310,
  anon_sym_seconds = 311,
  anon_sym_minutes = 312,
  anon_sym_hours = 313,
  anon_sym_days = 314,
  anon_sym_weeks = 315,
  anon_sym_years = 316,
  anon_sym_hex = 317,
  anon_sym_DQUOTE = 318,
  anon_sym__ = 319,
  anon_sym_SQUOTE = 320,
  sym__escape_sequence = 321,
  aux_sym__single_quoted_unicode_char_token1 = 322,
  aux_sym__double_quoted_unicode_char_token1 = 323,
  anon_sym_unicode = 324,
  sym_comment = 325,
  sym_source_file = 326,
  sym__source_unit = 327,
  sym__directive = 328,
  sym_pragma_directive = 329,
  sym_solidity_pragma_token = 330,
  sym_any_pragma_token = 331,
  sym__solidity = 332,
  sym_pragma_value = 333,
  sym__pragma_version_constraint = 334,
  sym_solidity_version_comparison_operator = 335,
  sym_import_directive = 336,
  sym__source_import = 337,
  sym__import_clause = 338,
  sym__from_clause = 339,
  sym__single_import = 340,
  sym__multiple_import = 341,
  sym__import_declaration = 342,
  sym__import_alias = 343,
  sym__declaration = 344,
  sym_user_defined_type_definition = 345,
  sym_constant_variable_declaration = 346,
  sym_contract_declaration = 347,
  sym_error_declaration = 348,
  sym_error_parameter = 349,
  sym_interface_declaration = 350,
  sym_library_declaration = 351,
  sym__class_heritage = 352,
  sym_inheritance_specifier = 353,
  sym_contract_body = 354,
  sym__contract_member = 355,
  sym_struct_declaration = 356,
  sym_struct_member = 357,
  sym_struct_body = 358,
  sym_enum_declaration = 359,
  sym_enum_body = 360,
  sym_event_definition = 361,
  sym__event_parameter_list = 362,
  sym_event_parameter = 363,
  sym_using_directive = 364,
  sym_any_source_type = 365,
  sym_statement = 366,
  sym_assembly_statement = 367,
  sym_assembly_flags = 368,
  sym__yul_statement = 369,
  sym_yul_label = 370,
  sym_yul_break = 371,
  sym_yul_continue = 372,
  sym_yul_identifier = 373,
  sym__yul_expression = 374,
  sym_yul_path = 375,
  sym__yul_literal = 376,
  sym_yul_string_literal = 377,
  sym_yul_boolean = 378,
  sym_yul_block = 379,
  sym_yul_variable_declaration = 380,
  sym__yul_assignment_operator = 381,
  sym_yul_assignment = 382,
  sym_yul_function_call = 383,
  sym_yul_if_statement = 384,
  sym_yul_for_statement = 385,
  sym_yul_switch_statement = 386,
  sym_yul_function_definition = 387,
  sym_yul_evm_builtin = 388,
  sym_block_statement = 389,
  sym_variable_declaration_statement = 390,
  sym_variable_declaration = 391,
  sym_variable_declaration_tuple = 392,
  sym_expression_statement = 393,
  sym_if_statement = 394,
  sym_for_statement = 395,
  sym_while_statement = 396,
  sym_do_while_statement = 397,
  sym_continue_statement = 398,
  sym_break_statement = 399,
  sym_revert_statement = 400,
  sym_try_statement = 401,
  sym_catch_clause = 402,
  sym_return_statement = 403,
  sym_emit_statement = 404,
  sym_state_variable_declaration = 405,
  sym_visibility = 406,
  sym_state_mutability = 407,
  sym_override_specifier = 408,
  sym_modifier_definition = 409,
  sym_constructor_definition = 410,
  sym_fallback_receive_definition = 411,
  sym_function_definition = 412,
  sym_return_type_definition = 413,
  sym_modifier_invocation = 414,
  sym__call_arguments = 415,
  sym_call_argument = 416,
  sym_call_struct_argument = 417,
  sym_function_body = 418,
  sym_expression = 419,
  sym__primary_expression = 420,
  sym_type_cast_expression = 421,
  sym_ternary_expression = 422,
  sym_new_expression = 423,
  sym_tuple_expression = 424,
  sym_inline_array_expression = 425,
  sym_binary_expression = 426,
  sym_unary_expression = 427,
  sym_update_expression = 428,
  sym_member_expression = 429,
  sym_array_access = 430,
  sym_slice_access = 431,
  sym_struct_expression = 432,
  sym_struct_field_assignment = 433,
  sym_parenthesized_expression = 434,
  sym_assignment_expression = 435,
  sym_augmented_assignment_expression = 436,
  sym_call_expression = 437,
  sym_payable_conversion_expression = 438,
  sym_meta_type_expression = 439,
  sym_type_name = 440,
  sym__array_type = 441,
  sym__function_type = 442,
  sym__parameter_list = 443,
  sym__return_parameters = 444,
  sym__nameless_parameter = 445,
  sym_parameter = 446,
  sym__storage_location = 447,
  sym_user_defined_type = 448,
  sym__identifier_path = 449,
  sym__mapping = 450,
  sym__mapping_key = 451,
  sym_primitive_type = 452,
  sym__int = 453,
  sym__uint = 454,
  sym__bytes = 455,
  sym__fixed = 456,
  sym__ufixed = 457,
  sym__literal = 458,
  sym_string_literal = 459,
  sym_number_literal = 460,
  sym__decimal_number = 461,
  sym__hex_number = 462,
  sym_number_unit = 463,
  sym_true = 464,
  sym_false = 465,
  sym_boolean_literal = 466,
  sym_hex_string_literal = 467,
  sym__single_quoted_unicode_char = 468,
  sym__double_quoted_unicode_char = 469,
  sym_unicode_string_literal = 470,
  sym_string = 471,
  sym__string_immediate_elt_inside_double_quote = 472,
  sym__string_immediate_elt_inside_quote = 473,
  aux_sym_source_file_repeat1 = 474,
  aux_sym_solidity_pragma_token_repeat1 = 475,
  aux_sym__multiple_import_repeat1 = 476,
  aux_sym_error_declaration_repeat1 = 477,
  aux_sym__class_heritage_repeat1 = 478,
  aux_sym_contract_body_repeat1 = 479,
  aux_sym_struct_body_repeat1 = 480,
  aux_sym_enum_body_repeat1 = 481,
  aux_sym__event_parameter_list_repeat1 = 482,
  aux_sym_assembly_statement_repeat1 = 483,
  aux_sym_assembly_flags_repeat1 = 484,
  aux_sym_yul_path_repeat1 = 485,
  aux_sym_yul_variable_declaration_repeat1 = 486,
  aux_sym_yul_assignment_repeat1 = 487,
  aux_sym_yul_function_call_repeat1 = 488,
  aux_sym_yul_switch_statement_repeat1 = 489,
  aux_sym_block_statement_repeat1 = 490,
  aux_sym_variable_declaration_tuple_repeat1 = 491,
  aux_sym_variable_declaration_tuple_repeat2 = 492,
  aux_sym_try_statement_repeat1 = 493,
  aux_sym_state_variable_declaration_repeat1 = 494,
  aux_sym_override_specifier_repeat1 = 495,
  aux_sym_modifier_definition_repeat1 = 496,
  aux_sym_constructor_definition_repeat1 = 497,
  aux_sym_fallback_receive_definition_repeat1 = 498,
  aux_sym_function_definition_repeat1 = 499,
  aux_sym__call_arguments_repeat1 = 500,
  aux_sym_call_argument_repeat1 = 501,
  aux_sym_tuple_expression_repeat1 = 502,
  aux_sym_inline_array_expression_repeat1 = 503,
  aux_sym_struct_expression_repeat1 = 504,
  aux_sym__function_type_repeat1 = 505,
  aux_sym__parameter_list_repeat1 = 506,
  aux_sym__return_parameters_repeat1 = 507,
  aux_sym__identifier_path_repeat1 = 508,
  aux_sym_string_literal_repeat1 = 509,
  aux_sym_hex_string_literal_repeat1 = 510,
  aux_sym_hex_string_literal_repeat2 = 511,
  aux_sym_unicode_string_literal_repeat1 = 512,
  aux_sym_unicode_string_literal_repeat2 = 513,
  aux_sym_unicode_string_literal_repeat3 = 514,
  aux_sym_string_repeat1 = 515,
  aux_sym_string_repeat2 = 516,
  alias_sym_enum_value = 517,
  alias_sym_revert_arguments = 518,
  alias_sym_type_alias = 519,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_pragma] = "pragma",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_DASH] = "-",
  [anon_sym_solidity] = "solidity",
  [aux_sym_pragma_value_token1] = "pragma_value_token1",
  [sym_solidity_version] = "solidity_version",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_CARET] = "^",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_TILDE] = "~",
  [anon_sym_EQ] = "=",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_STAR] = "*",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_as] = "as",
  [anon_sym_type] = "type",
  [anon_sym_is] = "is",
  [anon_sym_constant] = "constant",
  [anon_sym_abstract] = "abstract",
  [anon_sym_contract] = "contract",
  [anon_sym_error] = "error",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_interface] = "interface",
  [anon_sym_library] = "library",
  [anon_sym_struct] = "struct",
  [anon_sym_enum] = "enum",
  [anon_sym_event] = "event",
  [anon_sym_anonymous] = "anonymous",
  [anon_sym_indexed] = "indexed",
  [anon_sym_using] = "using",
  [anon_sym_for] = "for",
  [anon_sym_assembly] = "assembly",
  [anon_sym_DQUOTEevmasm_DQUOTE] = "\"evmasm\"",
  [anon_sym_COLON] = ":",
  [sym_yul_leave] = "yul_leave",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_DOT] = ".",
  [sym_yul_decimal_number] = "yul_decimal_number",
  [sym_yul_hex_number] = "yul_hex_number",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_let] = "let",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_if] = "if",
  [anon_sym_switch] = "switch",
  [anon_sym_default] = "default",
  [anon_sym_case] = "case",
  [anon_sym_function] = "function",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_stop] = "stop",
  [anon_sym_add] = "add",
  [anon_sym_sub] = "sub",
  [anon_sym_mul] = "mul",
  [anon_sym_div] = "div",
  [anon_sym_sdiv] = "sdiv",
  [anon_sym_mod] = "mod",
  [anon_sym_smod] = "smod",
  [anon_sym_exp] = "exp",
  [anon_sym_not] = "not",
  [anon_sym_lt] = "lt",
  [anon_sym_gt] = "gt",
  [anon_sym_slt] = "slt",
  [anon_sym_sgt] = "sgt",
  [anon_sym_eq] = "eq",
  [anon_sym_iszero] = "iszero",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_xor] = "xor",
  [anon_sym_byte] = "byte",
  [anon_sym_shl] = "shl",
  [anon_sym_shr] = "shr",
  [anon_sym_sar] = "sar",
  [anon_sym_addmod] = "addmod",
  [anon_sym_mulmod] = "mulmod",
  [anon_sym_signextend] = "signextend",
  [anon_sym_keccak256] = "keccak256",
  [anon_sym_pop] = "pop",
  [anon_sym_mload] = "mload",
  [anon_sym_mcopy] = "mcopy",
  [anon_sym_tload] = "tload",
  [anon_sym_tstore] = "tstore",
  [anon_sym_mstore] = "mstore",
  [anon_sym_mstore8] = "mstore8",
  [anon_sym_sload] = "sload",
  [anon_sym_sstore] = "sstore",
  [anon_sym_msize] = "msize",
  [anon_sym_gas] = "gas",
  [anon_sym_address] = "address",
  [anon_sym_balance] = "balance",
  [anon_sym_selfbalance] = "selfbalance",
  [anon_sym_caller] = "caller",
  [anon_sym_callvalue] = "callvalue",
  [anon_sym_calldataload] = "calldataload",
  [anon_sym_calldatasize] = "calldatasize",
  [anon_sym_calldatacopy] = "calldatacopy",
  [anon_sym_extcodesize] = "extcodesize",
  [anon_sym_extcodecopy] = "extcodecopy",
  [anon_sym_returndatasize] = "returndatasize",
  [anon_sym_returndatacopy] = "returndatacopy",
  [anon_sym_extcodehash] = "extcodehash",
  [anon_sym_create] = "create",
  [anon_sym_create2] = "create2",
  [anon_sym_call] = "call",
  [anon_sym_callcode] = "callcode",
  [anon_sym_delegatecall] = "delegatecall",
  [anon_sym_staticcall] = "staticcall",
  [anon_sym_return] = "return",
  [anon_sym_revert] = "revert",
  [anon_sym_selfdestruct] = "selfdestruct",
  [anon_sym_invalid] = "invalid",
  [anon_sym_log0] = "log0",
  [anon_sym_log1] = "log1",
  [anon_sym_log2] = "log2",
  [anon_sym_log3] = "log3",
  [anon_sym_log4] = "log4",
  [anon_sym_chainid] = "chainid",
  [anon_sym_origin] = "origin",
  [anon_sym_gasprice] = "gasprice",
  [anon_sym_blockhash] = "blockhash",
  [anon_sym_blobhash] = "blobhash",
  [anon_sym_basefee] = "basefee",
  [anon_sym_blobfee] = "blobfee",
  [anon_sym_coinbase] = "coinbase",
  [anon_sym_timestamp] = "timestamp",
  [anon_sym_number] = "number",
  [anon_sym_difficulty] = "difficulty",
  [anon_sym_gaslimit] = "gaslimit",
  [sym_unchecked] = "unchecked",
  [anon_sym_memory] = "memory",
  [anon_sym_storage] = "storage",
  [anon_sym_calldata] = "calldata",
  [anon_sym_var] = "var",
  [anon_sym_else] = "else",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_returns] = "returns",
  [anon_sym_catch] = "catch",
  [anon_sym_emit] = "emit",
  [anon_sym_public] = "public",
  [anon_sym_internal] = "internal",
  [anon_sym_private] = "private",
  [anon_sym_external] = "external",
  [anon_sym_pure] = "pure",
  [anon_sym_view] = "view",
  [anon_sym_payable] = "payable",
  [sym_immutable] = "immutable",
  [anon_sym_override] = "override",
  [anon_sym_modifier] = "modifier",
  [anon_sym_constructor] = "constructor",
  [anon_sym_fallback] = "fallback",
  [anon_sym_receive] = "receive",
  [sym_virtual] = "virtual",
  [anon_sym_QMARK] = "\?",
  [anon_sym_new] = "new",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_BANG] = "!",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_mapping] = "mapping",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_bool] = "bool",
  [anon_sym_string] = "string",
  [anon_sym_int] = "int",
  [anon_sym_int8] = "int8",
  [anon_sym_int16] = "int16",
  [anon_sym_int24] = "int24",
  [anon_sym_int32] = "int32",
  [anon_sym_int40] = "int40",
  [anon_sym_int48] = "int48",
  [anon_sym_int56] = "int56",
  [anon_sym_int64] = "int64",
  [anon_sym_int72] = "int72",
  [anon_sym_int80] = "int80",
  [anon_sym_int88] = "int88",
  [anon_sym_int96] = "int96",
  [anon_sym_int104] = "int104",
  [anon_sym_int112] = "int112",
  [anon_sym_int120] = "int120",
  [anon_sym_int128] = "int128",
  [anon_sym_int136] = "int136",
  [anon_sym_int144] = "int144",
  [anon_sym_int152] = "int152",
  [anon_sym_int160] = "int160",
  [anon_sym_int168] = "int168",
  [anon_sym_int176] = "int176",
  [anon_sym_int184] = "int184",
  [anon_sym_int192] = "int192",
  [anon_sym_int200] = "int200",
  [anon_sym_int208] = "int208",
  [anon_sym_int216] = "int216",
  [anon_sym_int224] = "int224",
  [anon_sym_int232] = "int232",
  [anon_sym_int240] = "int240",
  [anon_sym_int248] = "int248",
  [anon_sym_int256] = "int256",
  [anon_sym_uint] = "uint",
  [anon_sym_uint8] = "uint8",
  [anon_sym_uint16] = "uint16",
  [anon_sym_uint24] = "uint24",
  [anon_sym_uint32] = "uint32",
  [anon_sym_uint40] = "uint40",
  [anon_sym_uint48] = "uint48",
  [anon_sym_uint56] = "uint56",
  [anon_sym_uint64] = "uint64",
  [anon_sym_uint72] = "uint72",
  [anon_sym_uint80] = "uint80",
  [anon_sym_uint88] = "uint88",
  [anon_sym_uint96] = "uint96",
  [anon_sym_uint104] = "uint104",
  [anon_sym_uint112] = "uint112",
  [anon_sym_uint120] = "uint120",
  [anon_sym_uint128] = "uint128",
  [anon_sym_uint136] = "uint136",
  [anon_sym_uint144] = "uint144",
  [anon_sym_uint152] = "uint152",
  [anon_sym_uint160] = "uint160",
  [anon_sym_uint168] = "uint168",
  [anon_sym_uint176] = "uint176",
  [anon_sym_uint184] = "uint184",
  [anon_sym_uint192] = "uint192",
  [anon_sym_uint200] = "uint200",
  [anon_sym_uint208] = "uint208",
  [anon_sym_uint216] = "uint216",
  [anon_sym_uint224] = "uint224",
  [anon_sym_uint232] = "uint232",
  [anon_sym_uint240] = "uint240",
  [anon_sym_uint248] = "uint248",
  [anon_sym_uint256] = "uint256",
  [anon_sym_bytes] = "bytes",
  [anon_sym_bytes1] = "bytes1",
  [anon_sym_bytes2] = "bytes2",
  [anon_sym_bytes3] = "bytes3",
  [anon_sym_bytes4] = "bytes4",
  [anon_sym_bytes5] = "bytes5",
  [anon_sym_bytes6] = "bytes6",
  [anon_sym_bytes7] = "bytes7",
  [anon_sym_bytes8] = "bytes8",
  [anon_sym_bytes9] = "bytes9",
  [anon_sym_bytes10] = "bytes10",
  [anon_sym_bytes11] = "bytes11",
  [anon_sym_bytes12] = "bytes12",
  [anon_sym_bytes13] = "bytes13",
  [anon_sym_bytes14] = "bytes14",
  [anon_sym_bytes15] = "bytes15",
  [anon_sym_bytes16] = "bytes16",
  [anon_sym_bytes17] = "bytes17",
  [anon_sym_bytes18] = "bytes18",
  [anon_sym_bytes19] = "bytes19",
  [anon_sym_bytes20] = "bytes20",
  [anon_sym_bytes21] = "bytes21",
  [anon_sym_bytes22] = "bytes22",
  [anon_sym_bytes23] = "bytes23",
  [anon_sym_bytes24] = "bytes24",
  [anon_sym_bytes25] = "bytes25",
  [anon_sym_bytes26] = "bytes26",
  [anon_sym_bytes27] = "bytes27",
  [anon_sym_bytes28] = "bytes28",
  [anon_sym_bytes29] = "bytes29",
  [anon_sym_bytes30] = "bytes30",
  [anon_sym_bytes31] = "bytes31",
  [anon_sym_bytes32] = "bytes32",
  [anon_sym_fixed] = "fixed",
  [aux_sym__fixed_token1] = "_fixed_token1",
  [anon_sym_ufixed] = "ufixed",
  [aux_sym__ufixed_token1] = "_ufixed_token1",
  [sym__semicolon] = "_semicolon",
  [aux_sym__decimal_number_token1] = "_decimal_number_token1",
  [aux_sym__decimal_number_token2] = "_decimal_number_token2",
  [aux_sym__hex_number_token1] = "_hex_number_token1",
  [sym__hex_digit] = "_hex_digit",
  [anon_sym_wei] = "wei",
  [anon_sym_szabo] = "szabo",
  [anon_sym_finney] = "finney",
  [anon_sym_gwei] = "gwei",
  [anon_sym_ether] = "ether",
  [anon_sym_seconds] = "seconds",
  [anon_sym_minutes] = "minutes",
  [anon_sym_hours] = "hours",
  [anon_sym_days] = "days",
  [anon_sym_weeks] = "weeks",
  [anon_sym_years] = "years",
  [anon_sym_hex] = "hex",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym__] = "_",
  [anon_sym_SQUOTE] = "'",
  [sym__escape_sequence] = "_escape_sequence",
  [aux_sym__single_quoted_unicode_char_token1] = "_single_quoted_unicode_char_token1",
  [aux_sym__double_quoted_unicode_char_token1] = "_double_quoted_unicode_char_token1",
  [anon_sym_unicode] = "unicode",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym__source_unit] = "_source_unit",
  [sym__directive] = "_directive",
  [sym_pragma_directive] = "pragma_directive",
  [sym_solidity_pragma_token] = "solidity_pragma_token",
  [sym_any_pragma_token] = "any_pragma_token",
  [sym__solidity] = "_solidity",
  [sym_pragma_value] = "pragma_value",
  [sym__pragma_version_constraint] = "_pragma_version_constraint",
  [sym_solidity_version_comparison_operator] = "solidity_version_comparison_operator",
  [sym_import_directive] = "import_directive",
  [sym__source_import] = "_source_import",
  [sym__import_clause] = "_import_clause",
  [sym__from_clause] = "_from_clause",
  [sym__single_import] = "_single_import",
  [sym__multiple_import] = "_multiple_import",
  [sym__import_declaration] = "_import_declaration",
  [sym__import_alias] = "_import_alias",
  [sym__declaration] = "_declaration",
  [sym_user_defined_type_definition] = "user_defined_type_definition",
  [sym_constant_variable_declaration] = "constant_variable_declaration",
  [sym_contract_declaration] = "contract_declaration",
  [sym_error_declaration] = "error_declaration",
  [sym_error_parameter] = "error_parameter",
  [sym_interface_declaration] = "interface_declaration",
  [sym_library_declaration] = "library_declaration",
  [sym__class_heritage] = "_class_heritage",
  [sym_inheritance_specifier] = "inheritance_specifier",
  [sym_contract_body] = "contract_body",
  [sym__contract_member] = "_contract_member",
  [sym_struct_declaration] = "struct_declaration",
  [sym_struct_member] = "struct_member",
  [sym_struct_body] = "struct_body",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym_event_definition] = "event_definition",
  [sym__event_parameter_list] = "_event_parameter_list",
  [sym_event_parameter] = "event_parameter",
  [sym_using_directive] = "using_directive",
  [sym_any_source_type] = "any_source_type",
  [sym_statement] = "statement",
  [sym_assembly_statement] = "assembly_statement",
  [sym_assembly_flags] = "assembly_flags",
  [sym__yul_statement] = "_yul_statement",
  [sym_yul_label] = "yul_label",
  [sym_yul_break] = "yul_break",
  [sym_yul_continue] = "yul_continue",
  [sym_yul_identifier] = "yul_identifier",
  [sym__yul_expression] = "_yul_expression",
  [sym_yul_path] = "yul_path",
  [sym__yul_literal] = "_yul_literal",
  [sym_yul_string_literal] = "yul_string_literal",
  [sym_yul_boolean] = "yul_boolean",
  [sym_yul_block] = "yul_block",
  [sym_yul_variable_declaration] = "yul_variable_declaration",
  [sym__yul_assignment_operator] = "_yul_assignment_operator",
  [sym_yul_assignment] = "yul_assignment",
  [sym_yul_function_call] = "yul_function_call",
  [sym_yul_if_statement] = "yul_if_statement",
  [sym_yul_for_statement] = "yul_for_statement",
  [sym_yul_switch_statement] = "yul_switch_statement",
  [sym_yul_function_definition] = "yul_function_definition",
  [sym_yul_evm_builtin] = "yul_evm_builtin",
  [sym_block_statement] = "block_statement",
  [sym_variable_declaration_statement] = "variable_declaration_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_variable_declaration_tuple] = "variable_declaration_tuple",
  [sym_expression_statement] = "expression_statement",
  [sym_if_statement] = "if_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_while_statement] = "do_while_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_break_statement] = "break_statement",
  [sym_revert_statement] = "revert_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_return_statement] = "return_statement",
  [sym_emit_statement] = "emit_statement",
  [sym_state_variable_declaration] = "state_variable_declaration",
  [sym_visibility] = "visibility",
  [sym_state_mutability] = "state_mutability",
  [sym_override_specifier] = "override_specifier",
  [sym_modifier_definition] = "modifier_definition",
  [sym_constructor_definition] = "constructor_definition",
  [sym_fallback_receive_definition] = "fallback_receive_definition",
  [sym_function_definition] = "function_definition",
  [sym_return_type_definition] = "return_type_definition",
  [sym_modifier_invocation] = "modifier_invocation",
  [sym__call_arguments] = "_call_arguments",
  [sym_call_argument] = "call_argument",
  [sym_call_struct_argument] = "call_struct_argument",
  [sym_function_body] = "function_body",
  [sym_expression] = "expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym_new_expression] = "new_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_inline_array_expression] = "inline_array_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_member_expression] = "member_expression",
  [sym_array_access] = "array_access",
  [sym_slice_access] = "slice_access",
  [sym_struct_expression] = "struct_expression",
  [sym_struct_field_assignment] = "struct_field_assignment",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym_call_expression] = "call_expression",
  [sym_payable_conversion_expression] = "payable_conversion_expression",
  [sym_meta_type_expression] = "meta_type_expression",
  [sym_type_name] = "type_name",
  [sym__array_type] = "_array_type",
  [sym__function_type] = "_function_type",
  [sym__parameter_list] = "_parameter_list",
  [sym__return_parameters] = "_return_parameters",
  [sym__nameless_parameter] = "return_parameter",
  [sym_parameter] = "parameter",
  [sym__storage_location] = "_storage_location",
  [sym_user_defined_type] = "user_defined_type",
  [sym__identifier_path] = "_identifier_path",
  [sym__mapping] = "_mapping",
  [sym__mapping_key] = "_mapping_key",
  [sym_primitive_type] = "primitive_type",
  [sym__int] = "_int",
  [sym__uint] = "_uint",
  [sym__bytes] = "_bytes",
  [sym__fixed] = "_fixed",
  [sym__ufixed] = "_ufixed",
  [sym__literal] = "_literal",
  [sym_string_literal] = "string_literal",
  [sym_number_literal] = "number_literal",
  [sym__decimal_number] = "_decimal_number",
  [sym__hex_number] = "_hex_number",
  [sym_number_unit] = "number_unit",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_boolean_literal] = "boolean_literal",
  [sym_hex_string_literal] = "hex_string_literal",
  [sym__single_quoted_unicode_char] = "_single_quoted_unicode_char",
  [sym__double_quoted_unicode_char] = "_double_quoted_unicode_char",
  [sym_unicode_string_literal] = "unicode_string_literal",
  [sym_string] = "string",
  [sym__string_immediate_elt_inside_double_quote] = "_string_immediate_elt_inside_double_quote",
  [sym__string_immediate_elt_inside_quote] = "_string_immediate_elt_inside_quote",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_solidity_pragma_token_repeat1] = "solidity_pragma_token_repeat1",
  [aux_sym__multiple_import_repeat1] = "_multiple_import_repeat1",
  [aux_sym_error_declaration_repeat1] = "error_declaration_repeat1",
  [aux_sym__class_heritage_repeat1] = "_class_heritage_repeat1",
  [aux_sym_contract_body_repeat1] = "contract_body_repeat1",
  [aux_sym_struct_body_repeat1] = "struct_body_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym__event_parameter_list_repeat1] = "_event_parameter_list_repeat1",
  [aux_sym_assembly_statement_repeat1] = "assembly_statement_repeat1",
  [aux_sym_assembly_flags_repeat1] = "assembly_flags_repeat1",
  [aux_sym_yul_path_repeat1] = "yul_path_repeat1",
  [aux_sym_yul_variable_declaration_repeat1] = "yul_variable_declaration_repeat1",
  [aux_sym_yul_assignment_repeat1] = "yul_assignment_repeat1",
  [aux_sym_yul_function_call_repeat1] = "yul_function_call_repeat1",
  [aux_sym_yul_switch_statement_repeat1] = "yul_switch_statement_repeat1",
  [aux_sym_block_statement_repeat1] = "block_statement_repeat1",
  [aux_sym_variable_declaration_tuple_repeat1] = "variable_declaration_tuple_repeat1",
  [aux_sym_variable_declaration_tuple_repeat2] = "variable_declaration_tuple_repeat2",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_state_variable_declaration_repeat1] = "state_variable_declaration_repeat1",
  [aux_sym_override_specifier_repeat1] = "override_specifier_repeat1",
  [aux_sym_modifier_definition_repeat1] = "modifier_definition_repeat1",
  [aux_sym_constructor_definition_repeat1] = "constructor_definition_repeat1",
  [aux_sym_fallback_receive_definition_repeat1] = "fallback_receive_definition_repeat1",
  [aux_sym_function_definition_repeat1] = "function_definition_repeat1",
  [aux_sym__call_arguments_repeat1] = "_call_arguments_repeat1",
  [aux_sym_call_argument_repeat1] = "call_argument_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_inline_array_expression_repeat1] = "inline_array_expression_repeat1",
  [aux_sym_struct_expression_repeat1] = "struct_expression_repeat1",
  [aux_sym__function_type_repeat1] = "_function_type_repeat1",
  [aux_sym__parameter_list_repeat1] = "_parameter_list_repeat1",
  [aux_sym__return_parameters_repeat1] = "_return_parameters_repeat1",
  [aux_sym__identifier_path_repeat1] = "_identifier_path_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_hex_string_literal_repeat1] = "hex_string_literal_repeat1",
  [aux_sym_hex_string_literal_repeat2] = "hex_string_literal_repeat2",
  [aux_sym_unicode_string_literal_repeat1] = "unicode_string_literal_repeat1",
  [aux_sym_unicode_string_literal_repeat2] = "unicode_string_literal_repeat2",
  [aux_sym_unicode_string_literal_repeat3] = "unicode_string_literal_repeat3",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [alias_sym_enum_value] = "enum_value",
  [alias_sym_revert_arguments] = "revert_arguments",
  [alias_sym_type_alias] = "type_alias",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_pragma] = anon_sym_pragma,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_solidity] = anon_sym_solidity,
  [aux_sym_pragma_value_token1] = aux_sym_pragma_value_token1,
  [sym_solidity_version] = sym_solidity_version,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_constant] = anon_sym_constant,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_contract] = anon_sym_contract,
  [anon_sym_error] = anon_sym_error,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_library] = anon_sym_library,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_anonymous] = anon_sym_anonymous,
  [anon_sym_indexed] = anon_sym_indexed,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_DQUOTEevmasm_DQUOTE] = anon_sym_DQUOTEevmasm_DQUOTE,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_yul_leave] = sym_yul_leave,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_yul_decimal_number] = sym_yul_decimal_number,
  [sym_yul_hex_number] = sym_yul_hex_number,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_stop] = anon_sym_stop,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_sub] = anon_sym_sub,
  [anon_sym_mul] = anon_sym_mul,
  [anon_sym_div] = anon_sym_div,
  [anon_sym_sdiv] = anon_sym_sdiv,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_smod] = anon_sym_smod,
  [anon_sym_exp] = anon_sym_exp,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_lt] = anon_sym_lt,
  [anon_sym_gt] = anon_sym_gt,
  [anon_sym_slt] = anon_sym_slt,
  [anon_sym_sgt] = anon_sym_sgt,
  [anon_sym_eq] = anon_sym_eq,
  [anon_sym_iszero] = anon_sym_iszero,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_xor] = anon_sym_xor,
  [anon_sym_byte] = anon_sym_byte,
  [anon_sym_shl] = anon_sym_shl,
  [anon_sym_shr] = anon_sym_shr,
  [anon_sym_sar] = anon_sym_sar,
  [anon_sym_addmod] = anon_sym_addmod,
  [anon_sym_mulmod] = anon_sym_mulmod,
  [anon_sym_signextend] = anon_sym_signextend,
  [anon_sym_keccak256] = anon_sym_keccak256,
  [anon_sym_pop] = anon_sym_pop,
  [anon_sym_mload] = anon_sym_mload,
  [anon_sym_mcopy] = anon_sym_mcopy,
  [anon_sym_tload] = anon_sym_tload,
  [anon_sym_tstore] = anon_sym_tstore,
  [anon_sym_mstore] = anon_sym_mstore,
  [anon_sym_mstore8] = anon_sym_mstore8,
  [anon_sym_sload] = anon_sym_sload,
  [anon_sym_sstore] = anon_sym_sstore,
  [anon_sym_msize] = anon_sym_msize,
  [anon_sym_gas] = anon_sym_gas,
  [anon_sym_address] = anon_sym_address,
  [anon_sym_balance] = anon_sym_balance,
  [anon_sym_selfbalance] = anon_sym_selfbalance,
  [anon_sym_caller] = anon_sym_caller,
  [anon_sym_callvalue] = anon_sym_callvalue,
  [anon_sym_calldataload] = anon_sym_calldataload,
  [anon_sym_calldatasize] = anon_sym_calldatasize,
  [anon_sym_calldatacopy] = anon_sym_calldatacopy,
  [anon_sym_extcodesize] = anon_sym_extcodesize,
  [anon_sym_extcodecopy] = anon_sym_extcodecopy,
  [anon_sym_returndatasize] = anon_sym_returndatasize,
  [anon_sym_returndatacopy] = anon_sym_returndatacopy,
  [anon_sym_extcodehash] = anon_sym_extcodehash,
  [anon_sym_create] = anon_sym_create,
  [anon_sym_create2] = anon_sym_create2,
  [anon_sym_call] = anon_sym_call,
  [anon_sym_callcode] = anon_sym_callcode,
  [anon_sym_delegatecall] = anon_sym_delegatecall,
  [anon_sym_staticcall] = anon_sym_staticcall,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_revert] = anon_sym_revert,
  [anon_sym_selfdestruct] = anon_sym_selfdestruct,
  [anon_sym_invalid] = anon_sym_invalid,
  [anon_sym_log0] = anon_sym_log0,
  [anon_sym_log1] = anon_sym_log1,
  [anon_sym_log2] = anon_sym_log2,
  [anon_sym_log3] = anon_sym_log3,
  [anon_sym_log4] = anon_sym_log4,
  [anon_sym_chainid] = anon_sym_chainid,
  [anon_sym_origin] = anon_sym_origin,
  [anon_sym_gasprice] = anon_sym_gasprice,
  [anon_sym_blockhash] = anon_sym_blockhash,
  [anon_sym_blobhash] = anon_sym_blobhash,
  [anon_sym_basefee] = anon_sym_basefee,
  [anon_sym_blobfee] = anon_sym_blobfee,
  [anon_sym_coinbase] = anon_sym_coinbase,
  [anon_sym_timestamp] = anon_sym_timestamp,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_difficulty] = anon_sym_difficulty,
  [anon_sym_gaslimit] = anon_sym_gaslimit,
  [sym_unchecked] = sym_unchecked,
  [anon_sym_memory] = anon_sym_memory,
  [anon_sym_storage] = anon_sym_storage,
  [anon_sym_calldata] = anon_sym_calldata,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_returns] = anon_sym_returns,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_emit] = anon_sym_emit,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_external] = anon_sym_external,
  [anon_sym_pure] = anon_sym_pure,
  [anon_sym_view] = anon_sym_view,
  [anon_sym_payable] = anon_sym_payable,
  [sym_immutable] = sym_immutable,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_modifier] = anon_sym_modifier,
  [anon_sym_constructor] = anon_sym_constructor,
  [anon_sym_fallback] = anon_sym_fallback,
  [anon_sym_receive] = anon_sym_receive,
  [sym_virtual] = sym_virtual,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_mapping] = anon_sym_mapping,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_int8] = anon_sym_int8,
  [anon_sym_int16] = anon_sym_int16,
  [anon_sym_int24] = anon_sym_int24,
  [anon_sym_int32] = anon_sym_int32,
  [anon_sym_int40] = anon_sym_int40,
  [anon_sym_int48] = anon_sym_int48,
  [anon_sym_int56] = anon_sym_int56,
  [anon_sym_int64] = anon_sym_int64,
  [anon_sym_int72] = anon_sym_int72,
  [anon_sym_int80] = anon_sym_int80,
  [anon_sym_int88] = anon_sym_int88,
  [anon_sym_int96] = anon_sym_int96,
  [anon_sym_int104] = anon_sym_int104,
  [anon_sym_int112] = anon_sym_int112,
  [anon_sym_int120] = anon_sym_int120,
  [anon_sym_int128] = anon_sym_int128,
  [anon_sym_int136] = anon_sym_int136,
  [anon_sym_int144] = anon_sym_int144,
  [anon_sym_int152] = anon_sym_int152,
  [anon_sym_int160] = anon_sym_int160,
  [anon_sym_int168] = anon_sym_int168,
  [anon_sym_int176] = anon_sym_int176,
  [anon_sym_int184] = anon_sym_int184,
  [anon_sym_int192] = anon_sym_int192,
  [anon_sym_int200] = anon_sym_int200,
  [anon_sym_int208] = anon_sym_int208,
  [anon_sym_int216] = anon_sym_int216,
  [anon_sym_int224] = anon_sym_int224,
  [anon_sym_int232] = anon_sym_int232,
  [anon_sym_int240] = anon_sym_int240,
  [anon_sym_int248] = anon_sym_int248,
  [anon_sym_int256] = anon_sym_int256,
  [anon_sym_uint] = anon_sym_uint,
  [anon_sym_uint8] = anon_sym_uint8,
  [anon_sym_uint16] = anon_sym_uint16,
  [anon_sym_uint24] = anon_sym_uint24,
  [anon_sym_uint32] = anon_sym_uint32,
  [anon_sym_uint40] = anon_sym_uint40,
  [anon_sym_uint48] = anon_sym_uint48,
  [anon_sym_uint56] = anon_sym_uint56,
  [anon_sym_uint64] = anon_sym_uint64,
  [anon_sym_uint72] = anon_sym_uint72,
  [anon_sym_uint80] = anon_sym_uint80,
  [anon_sym_uint88] = anon_sym_uint88,
  [anon_sym_uint96] = anon_sym_uint96,
  [anon_sym_uint104] = anon_sym_uint104,
  [anon_sym_uint112] = anon_sym_uint112,
  [anon_sym_uint120] = anon_sym_uint120,
  [anon_sym_uint128] = anon_sym_uint128,
  [anon_sym_uint136] = anon_sym_uint136,
  [anon_sym_uint144] = anon_sym_uint144,
  [anon_sym_uint152] = anon_sym_uint152,
  [anon_sym_uint160] = anon_sym_uint160,
  [anon_sym_uint168] = anon_sym_uint168,
  [anon_sym_uint176] = anon_sym_uint176,
  [anon_sym_uint184] = anon_sym_uint184,
  [anon_sym_uint192] = anon_sym_uint192,
  [anon_sym_uint200] = anon_sym_uint200,
  [anon_sym_uint208] = anon_sym_uint208,
  [anon_sym_uint216] = anon_sym_uint216,
  [anon_sym_uint224] = anon_sym_uint224,
  [anon_sym_uint232] = anon_sym_uint232,
  [anon_sym_uint240] = anon_sym_uint240,
  [anon_sym_uint248] = anon_sym_uint248,
  [anon_sym_uint256] = anon_sym_uint256,
  [anon_sym_bytes] = anon_sym_bytes,
  [anon_sym_bytes1] = anon_sym_bytes1,
  [anon_sym_bytes2] = anon_sym_bytes2,
  [anon_sym_bytes3] = anon_sym_bytes3,
  [anon_sym_bytes4] = anon_sym_bytes4,
  [anon_sym_bytes5] = anon_sym_bytes5,
  [anon_sym_bytes6] = anon_sym_bytes6,
  [anon_sym_bytes7] = anon_sym_bytes7,
  [anon_sym_bytes8] = anon_sym_bytes8,
  [anon_sym_bytes9] = anon_sym_bytes9,
  [anon_sym_bytes10] = anon_sym_bytes10,
  [anon_sym_bytes11] = anon_sym_bytes11,
  [anon_sym_bytes12] = anon_sym_bytes12,
  [anon_sym_bytes13] = anon_sym_bytes13,
  [anon_sym_bytes14] = anon_sym_bytes14,
  [anon_sym_bytes15] = anon_sym_bytes15,
  [anon_sym_bytes16] = anon_sym_bytes16,
  [anon_sym_bytes17] = anon_sym_bytes17,
  [anon_sym_bytes18] = anon_sym_bytes18,
  [anon_sym_bytes19] = anon_sym_bytes19,
  [anon_sym_bytes20] = anon_sym_bytes20,
  [anon_sym_bytes21] = anon_sym_bytes21,
  [anon_sym_bytes22] = anon_sym_bytes22,
  [anon_sym_bytes23] = anon_sym_bytes23,
  [anon_sym_bytes24] = anon_sym_bytes24,
  [anon_sym_bytes25] = anon_sym_bytes25,
  [anon_sym_bytes26] = anon_sym_bytes26,
  [anon_sym_bytes27] = anon_sym_bytes27,
  [anon_sym_bytes28] = anon_sym_bytes28,
  [anon_sym_bytes29] = anon_sym_bytes29,
  [anon_sym_bytes30] = anon_sym_bytes30,
  [anon_sym_bytes31] = anon_sym_bytes31,
  [anon_sym_bytes32] = anon_sym_bytes32,
  [anon_sym_fixed] = anon_sym_fixed,
  [aux_sym__fixed_token1] = aux_sym__fixed_token1,
  [anon_sym_ufixed] = anon_sym_ufixed,
  [aux_sym__ufixed_token1] = aux_sym__ufixed_token1,
  [sym__semicolon] = sym__semicolon,
  [aux_sym__decimal_number_token1] = aux_sym__decimal_number_token1,
  [aux_sym__decimal_number_token2] = aux_sym__decimal_number_token2,
  [aux_sym__hex_number_token1] = aux_sym__hex_number_token1,
  [sym__hex_digit] = sym__hex_digit,
  [anon_sym_wei] = anon_sym_wei,
  [anon_sym_szabo] = anon_sym_szabo,
  [anon_sym_finney] = anon_sym_finney,
  [anon_sym_gwei] = anon_sym_gwei,
  [anon_sym_ether] = anon_sym_ether,
  [anon_sym_seconds] = anon_sym_seconds,
  [anon_sym_minutes] = anon_sym_minutes,
  [anon_sym_hours] = anon_sym_hours,
  [anon_sym_days] = anon_sym_days,
  [anon_sym_weeks] = anon_sym_weeks,
  [anon_sym_years] = anon_sym_years,
  [anon_sym_hex] = anon_sym_hex,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym__] = anon_sym__,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [sym__escape_sequence] = sym__escape_sequence,
  [aux_sym__single_quoted_unicode_char_token1] = aux_sym__single_quoted_unicode_char_token1,
  [aux_sym__double_quoted_unicode_char_token1] = aux_sym__double_quoted_unicode_char_token1,
  [anon_sym_unicode] = anon_sym_unicode,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym__source_unit] = sym__source_unit,
  [sym__directive] = sym__directive,
  [sym_pragma_directive] = sym_pragma_directive,
  [sym_solidity_pragma_token] = sym_solidity_pragma_token,
  [sym_any_pragma_token] = sym_any_pragma_token,
  [sym__solidity] = sym__solidity,
  [sym_pragma_value] = sym_pragma_value,
  [sym__pragma_version_constraint] = sym__pragma_version_constraint,
  [sym_solidity_version_comparison_operator] = sym_solidity_version_comparison_operator,
  [sym_import_directive] = sym_import_directive,
  [sym__source_import] = sym__source_import,
  [sym__import_clause] = sym__import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym__single_import] = sym__single_import,
  [sym__multiple_import] = sym__multiple_import,
  [sym__import_declaration] = sym__import_declaration,
  [sym__import_alias] = sym__import_alias,
  [sym__declaration] = sym__declaration,
  [sym_user_defined_type_definition] = sym_user_defined_type_definition,
  [sym_constant_variable_declaration] = sym_constant_variable_declaration,
  [sym_contract_declaration] = sym_contract_declaration,
  [sym_error_declaration] = sym_error_declaration,
  [sym_error_parameter] = sym_error_parameter,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_library_declaration] = sym_library_declaration,
  [sym__class_heritage] = sym__class_heritage,
  [sym_inheritance_specifier] = sym_inheritance_specifier,
  [sym_contract_body] = sym_contract_body,
  [sym__contract_member] = sym__contract_member,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_struct_member] = sym_struct_member,
  [sym_struct_body] = sym_struct_body,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_enum_body] = sym_enum_body,
  [sym_event_definition] = sym_event_definition,
  [sym__event_parameter_list] = sym__event_parameter_list,
  [sym_event_parameter] = sym_event_parameter,
  [sym_using_directive] = sym_using_directive,
  [sym_any_source_type] = sym_any_source_type,
  [sym_statement] = sym_statement,
  [sym_assembly_statement] = sym_assembly_statement,
  [sym_assembly_flags] = sym_assembly_flags,
  [sym__yul_statement] = sym__yul_statement,
  [sym_yul_label] = sym_yul_label,
  [sym_yul_break] = sym_yul_break,
  [sym_yul_continue] = sym_yul_continue,
  [sym_yul_identifier] = sym_yul_identifier,
  [sym__yul_expression] = sym__yul_expression,
  [sym_yul_path] = sym_yul_path,
  [sym__yul_literal] = sym__yul_literal,
  [sym_yul_string_literal] = sym_yul_string_literal,
  [sym_yul_boolean] = sym_yul_boolean,
  [sym_yul_block] = sym_yul_block,
  [sym_yul_variable_declaration] = sym_yul_variable_declaration,
  [sym__yul_assignment_operator] = sym__yul_assignment_operator,
  [sym_yul_assignment] = sym_yul_assignment,
  [sym_yul_function_call] = sym_yul_function_call,
  [sym_yul_if_statement] = sym_yul_if_statement,
  [sym_yul_for_statement] = sym_yul_for_statement,
  [sym_yul_switch_statement] = sym_yul_switch_statement,
  [sym_yul_function_definition] = sym_yul_function_definition,
  [sym_yul_evm_builtin] = sym_yul_evm_builtin,
  [sym_block_statement] = sym_block_statement,
  [sym_variable_declaration_statement] = sym_variable_declaration_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_variable_declaration_tuple] = sym_variable_declaration_tuple,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_do_while_statement] = sym_do_while_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_revert_statement] = sym_revert_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_return_statement] = sym_return_statement,
  [sym_emit_statement] = sym_emit_statement,
  [sym_state_variable_declaration] = sym_state_variable_declaration,
  [sym_visibility] = sym_visibility,
  [sym_state_mutability] = sym_state_mutability,
  [sym_override_specifier] = sym_override_specifier,
  [sym_modifier_definition] = sym_modifier_definition,
  [sym_constructor_definition] = sym_constructor_definition,
  [sym_fallback_receive_definition] = sym_fallback_receive_definition,
  [sym_function_definition] = sym_function_definition,
  [sym_return_type_definition] = sym_return_type_definition,
  [sym_modifier_invocation] = sym_modifier_invocation,
  [sym__call_arguments] = sym__call_arguments,
  [sym_call_argument] = sym_call_argument,
  [sym_call_struct_argument] = sym_call_struct_argument,
  [sym_function_body] = sym_function_body,
  [sym_expression] = sym_expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_inline_array_expression] = sym_inline_array_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_array_access] = sym_array_access,
  [sym_slice_access] = sym_slice_access,
  [sym_struct_expression] = sym_struct_expression,
  [sym_struct_field_assignment] = sym_struct_field_assignment,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_payable_conversion_expression] = sym_payable_conversion_expression,
  [sym_meta_type_expression] = sym_meta_type_expression,
  [sym_type_name] = sym_type_name,
  [sym__array_type] = sym__array_type,
  [sym__function_type] = sym__function_type,
  [sym__parameter_list] = sym__parameter_list,
  [sym__return_parameters] = sym__return_parameters,
  [sym__nameless_parameter] = sym__nameless_parameter,
  [sym_parameter] = sym_parameter,
  [sym__storage_location] = sym__storage_location,
  [sym_user_defined_type] = sym_user_defined_type,
  [sym__identifier_path] = sym__identifier_path,
  [sym__mapping] = sym__mapping,
  [sym__mapping_key] = sym__mapping_key,
  [sym_primitive_type] = sym_primitive_type,
  [sym__int] = sym__int,
  [sym__uint] = sym__uint,
  [sym__bytes] = sym__bytes,
  [sym__fixed] = sym__fixed,
  [sym__ufixed] = sym__ufixed,
  [sym__literal] = sym__literal,
  [sym_string_literal] = sym_string_literal,
  [sym_number_literal] = sym_number_literal,
  [sym__decimal_number] = sym__decimal_number,
  [sym__hex_number] = sym__hex_number,
  [sym_number_unit] = sym_number_unit,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_hex_string_literal] = sym_hex_string_literal,
  [sym__single_quoted_unicode_char] = sym__single_quoted_unicode_char,
  [sym__double_quoted_unicode_char] = sym__double_quoted_unicode_char,
  [sym_unicode_string_literal] = sym_unicode_string_literal,
  [sym_string] = sym_string,
  [sym__string_immediate_elt_inside_double_quote] = sym__string_immediate_elt_inside_double_quote,
  [sym__string_immediate_elt_inside_quote] = sym__string_immediate_elt_inside_quote,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_solidity_pragma_token_repeat1] = aux_sym_solidity_pragma_token_repeat1,
  [aux_sym__multiple_import_repeat1] = aux_sym__multiple_import_repeat1,
  [aux_sym_error_declaration_repeat1] = aux_sym_error_declaration_repeat1,
  [aux_sym__class_heritage_repeat1] = aux_sym__class_heritage_repeat1,
  [aux_sym_contract_body_repeat1] = aux_sym_contract_body_repeat1,
  [aux_sym_struct_body_repeat1] = aux_sym_struct_body_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym__event_parameter_list_repeat1] = aux_sym__event_parameter_list_repeat1,
  [aux_sym_assembly_statement_repeat1] = aux_sym_assembly_statement_repeat1,
  [aux_sym_assembly_flags_repeat1] = aux_sym_assembly_flags_repeat1,
  [aux_sym_yul_path_repeat1] = aux_sym_yul_path_repeat1,
  [aux_sym_yul_variable_declaration_repeat1] = aux_sym_yul_variable_declaration_repeat1,
  [aux_sym_yul_assignment_repeat1] = aux_sym_yul_assignment_repeat1,
  [aux_sym_yul_function_call_repeat1] = aux_sym_yul_function_call_repeat1,
  [aux_sym_yul_switch_statement_repeat1] = aux_sym_yul_switch_statement_repeat1,
  [aux_sym_block_statement_repeat1] = aux_sym_block_statement_repeat1,
  [aux_sym_variable_declaration_tuple_repeat1] = aux_sym_variable_declaration_tuple_repeat1,
  [aux_sym_variable_declaration_tuple_repeat2] = aux_sym_variable_declaration_tuple_repeat2,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_state_variable_declaration_repeat1] = aux_sym_state_variable_declaration_repeat1,
  [aux_sym_override_specifier_repeat1] = aux_sym_override_specifier_repeat1,
  [aux_sym_modifier_definition_repeat1] = aux_sym_modifier_definition_repeat1,
  [aux_sym_constructor_definition_repeat1] = aux_sym_constructor_definition_repeat1,
  [aux_sym_fallback_receive_definition_repeat1] = aux_sym_fallback_receive_definition_repeat1,
  [aux_sym_function_definition_repeat1] = aux_sym_function_definition_repeat1,
  [aux_sym__call_arguments_repeat1] = aux_sym__call_arguments_repeat1,
  [aux_sym_call_argument_repeat1] = aux_sym_call_argument_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_inline_array_expression_repeat1] = aux_sym_inline_array_expression_repeat1,
  [aux_sym_struct_expression_repeat1] = aux_sym_struct_expression_repeat1,
  [aux_sym__function_type_repeat1] = aux_sym__function_type_repeat1,
  [aux_sym__parameter_list_repeat1] = aux_sym__parameter_list_repeat1,
  [aux_sym__return_parameters_repeat1] = aux_sym__return_parameters_repeat1,
  [aux_sym__identifier_path_repeat1] = aux_sym__identifier_path_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_hex_string_literal_repeat1] = aux_sym_hex_string_literal_repeat1,
  [aux_sym_hex_string_literal_repeat2] = aux_sym_hex_string_literal_repeat2,
  [aux_sym_unicode_string_literal_repeat1] = aux_sym_unicode_string_literal_repeat1,
  [aux_sym_unicode_string_literal_repeat2] = aux_sym_unicode_string_literal_repeat2,
  [aux_sym_unicode_string_literal_repeat3] = aux_sym_unicode_string_literal_repeat3,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [alias_sym_enum_value] = alias_sym_enum_value,
  [alias_sym_revert_arguments] = alias_sym_revert_arguments,
  [alias_sym_type_alias] = alias_sym_type_alias,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_pragma] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_solidity] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pragma_value_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_solidity_version] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constant] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_contract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_error] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_library] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anonymous] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_indexed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTEevmasm_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_yul_leave] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_yul_decimal_number] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_hex_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mul] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_div] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sdiv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_smod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_slt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sgt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_eq] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_iszero] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_xor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_byte] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_shr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sar] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_addmod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mulmod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signextend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keccak256] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mcopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tstore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mstore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mstore8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sstore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_msize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_address] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_balance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_selfbalance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_caller] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callvalue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldataload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldatasize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldatacopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extcodesize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extcodecopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returndatasize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returndatacopy] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extcodehash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_create] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_create2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_call] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_callcode] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegatecall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_staticcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_revert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_selfdestruct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_invalid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_log4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_chainid] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_origin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gasprice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blockhash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blobhash] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_basefee] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_blobfee] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_coinbase] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_timestamp] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_difficulty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gaslimit] = {
    .visible = true,
    .named = false,
  },
  [sym_unchecked] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_memory] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_storage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_calldata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_returns] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_emit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_external] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_view] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_payable] = {
    .visible = true,
    .named = false,
  },
  [sym_immutable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_modifier] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_constructor] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fallback] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_receive] = {
    .visible = true,
    .named = false,
  },
  [sym_virtual] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mapping] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int24] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int40] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int48] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int56] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int72] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int80] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int88] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int96] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int104] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int112] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int120] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int136] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int144] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int152] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int160] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int168] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int176] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int184] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int208] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int216] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int224] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int232] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int240] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int248] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int256] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint24] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint40] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint48] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint56] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint72] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint80] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint88] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint96] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint104] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint112] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint120] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint136] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint144] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint152] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint160] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint168] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint176] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint184] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint192] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint200] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint208] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint216] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint224] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint232] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint240] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint248] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_uint256] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes9] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes10] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes11] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes12] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes13] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes14] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes15] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes17] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes18] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes19] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes20] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes21] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes22] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes23] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes24] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes25] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes26] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes27] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes28] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes29] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes30] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes31] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bytes32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fixed] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__fixed_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_ufixed] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__ufixed_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__decimal_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__decimal_number_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__hex_number_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__hex_digit] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_wei] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_szabo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finney] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gwei] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ether] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_seconds] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_minutes] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hours] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_days] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_weeks] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_years] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hex] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__single_quoted_unicode_char_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__double_quoted_unicode_char_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_unicode] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__source_unit] = {
    .visible = false,
    .named = true,
  },
  [sym__directive] = {
    .visible = false,
    .named = true,
  },
  [sym_pragma_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_solidity_pragma_token] = {
    .visible = true,
    .named = true,
  },
  [sym_any_pragma_token] = {
    .visible = true,
    .named = true,
  },
  [sym__solidity] = {
    .visible = false,
    .named = true,
  },
  [sym_pragma_value] = {
    .visible = true,
    .named = true,
  },
  [sym__pragma_version_constraint] = {
    .visible = false,
    .named = true,
  },
  [sym_solidity_version_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_import_directive] = {
    .visible = true,
    .named = true,
  },
  [sym__source_import] = {
    .visible = false,
    .named = true,
  },
  [sym__import_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__single_import] = {
    .visible = false,
    .named = true,
  },
  [sym__multiple_import] = {
    .visible = false,
    .named = true,
  },
  [sym__import_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__import_alias] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_user_defined_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_contract_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_error_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_error_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_library_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__class_heritage] = {
    .visible = false,
    .named = true,
  },
  [sym_inheritance_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_contract_body] = {
    .visible = true,
    .named = true,
  },
  [sym__contract_member] = {
    .visible = false,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_member] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_event_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__event_parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym_event_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_using_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_any_source_type] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assembly_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assembly_flags] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_label] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_break] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_continue] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_path] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_block] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__yul_assignment_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_yul_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_yul_evm_builtin] = {
    .visible = true,
    .named = true,
  },
  [sym_block_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_revert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_emit_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_state_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility] = {
    .visible = true,
    .named = true,
  },
  [sym_state_mutability] = {
    .visible = true,
    .named = true,
  },
  [sym_override_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_fallback_receive_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_return_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym__call_arguments] = {
    .visible = false,
    .named = true,
  },
  [sym_call_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_call_struct_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_function_body] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_array_access] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_access] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_field_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_payable_conversion_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym__array_type] = {
    .visible = false,
    .named = true,
  },
  [sym__function_type] = {
    .visible = false,
    .named = true,
  },
  [sym__parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__return_parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__nameless_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__storage_location] = {
    .visible = false,
    .named = true,
  },
  [sym_user_defined_type] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_path] = {
    .visible = false,
    .named = true,
  },
  [sym__mapping] = {
    .visible = false,
    .named = true,
  },
  [sym__mapping_key] = {
    .visible = false,
    .named = true,
  },
  [sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [sym__int] = {
    .visible = false,
    .named = true,
  },
  [sym__uint] = {
    .visible = false,
    .named = true,
  },
  [sym__bytes] = {
    .visible = false,
    .named = true,
  },
  [sym__fixed] = {
    .visible = false,
    .named = true,
  },
  [sym__ufixed] = {
    .visible = false,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__decimal_number] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_number] = {
    .visible = false,
    .named = true,
  },
  [sym_number_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_hex_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__single_quoted_unicode_char] = {
    .visible = false,
    .named = true,
  },
  [sym__double_quoted_unicode_char] = {
    .visible = false,
    .named = true,
  },
  [sym_unicode_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__string_immediate_elt_inside_double_quote] = {
    .visible = false,
    .named = true,
  },
  [sym__string_immediate_elt_inside_quote] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_solidity_pragma_token_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__multiple_import_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_error_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__class_heritage_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_contract_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__event_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assembly_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assembly_flags_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_assignment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_function_call_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_yul_switch_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_tuple_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_state_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_override_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_modifier_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructor_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fallback_receive_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__call_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_argument_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inline_array_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__function_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__return_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__identifier_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hex_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_hex_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unicode_string_literal_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_enum_value] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_revert_arguments] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_alias] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_ancestor = 2,
  field_ancestor_arguments = 3,
  field_argument = 4,
  field_attempt = 5,
  field_base = 6,
  field_body = 7,
  field_condition = 8,
  field_else = 9,
  field_error = 10,
  field_from = 11,
  field_function = 12,
  field_import_name = 13,
  field_index = 14,
  field_initial = 15,
  field_key_identifier = 16,
  field_key_type = 17,
  field_left = 18,
  field_location = 19,
  field_name = 20,
  field_object = 21,
  field_operator = 22,
  field_parameters = 23,
  field_property = 24,
  field_return_type = 25,
  field_right = 26,
  field_source = 27,
  field_to = 28,
  field_type = 29,
  field_update = 30,
  field_value = 31,
  field_value_identifier = 32,
  field_value_type = 33,
  field_version_constraint = 34,
  field_visibility = 35,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_ancestor] = "ancestor",
  [field_ancestor_arguments] = "ancestor_arguments",
  [field_argument] = "argument",
  [field_attempt] = "attempt",
  [field_base] = "base",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_else] = "else",
  [field_error] = "error",
  [field_from] = "from",
  [field_function] = "function",
  [field_import_name] = "import_name",
  [field_index] = "index",
  [field_initial] = "initial",
  [field_key_identifier] = "key_identifier",
  [field_key_type] = "key_type",
  [field_left] = "left",
  [field_location] = "location",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_property] = "property",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_source] = "source",
  [field_to] = "to",
  [field_type] = "type",
  [field_update] = "update",
  [field_value] = "value",
  [field_value_identifier] = "value_identifier",
  [field_value_type] = "value_type",
  [field_version_constraint] = "version_constraint",
  [field_visibility] = "visibility",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 4},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 2},
  [5] = {.index = 8, .length = 1},
  [6] = {.index = 9, .length = 1},
  [7] = {.index = 10, .length = 1},
  [8] = {.index = 11, .length = 1},
  [9] = {.index = 12, .length = 1},
  [10] = {.index = 13, .length = 2},
  [11] = {.index = 15, .length = 2},
  [12] = {.index = 17, .length = 2},
  [13] = {.index = 19, .length = 2},
  [14] = {.index = 21, .length = 1},
  [15] = {.index = 22, .length = 2},
  [16] = {.index = 24, .length = 1},
  [17] = {.index = 25, .length = 2},
  [18] = {.index = 27, .length = 1},
  [19] = {.index = 28, .length = 3},
  [20] = {.index = 31, .length = 2},
  [21] = {.index = 33, .length = 1},
  [22] = {.index = 34, .length = 2},
  [23] = {.index = 36, .length = 1},
  [24] = {.index = 37, .length = 2},
  [25] = {.index = 39, .length = 2},
  [26] = {.index = 41, .length = 2},
  [27] = {.index = 43, .length = 2},
  [28] = {.index = 45, .length = 1},
  [29] = {.index = 46, .length = 4},
  [30] = {.index = 50, .length = 4},
  [31] = {.index = 54, .length = 2},
  [32] = {.index = 56, .length = 1},
  [33] = {.index = 57, .length = 2},
  [35] = {.index = 59, .length = 3},
  [36] = {.index = 62, .length = 2},
  [37] = {.index = 64, .length = 3},
  [38] = {.index = 67, .length = 2},
  [39] = {.index = 69, .length = 2},
  [40] = {.index = 71, .length = 3},
  [41] = {.index = 74, .length = 2},
  [42] = {.index = 76, .length = 1},
  [43] = {.index = 77, .length = 1},
  [44] = {.index = 78, .length = 2},
  [45] = {.index = 80, .length = 2},
  [46] = {.index = 82, .length = 2},
  [47] = {.index = 84, .length = 3},
  [48] = {.index = 87, .length = 2},
  [49] = {.index = 89, .length = 2},
  [50] = {.index = 91, .length = 3},
  [51] = {.index = 94, .length = 2},
  [52] = {.index = 96, .length = 1},
  [53] = {.index = 97, .length = 3},
  [55] = {.index = 100, .length = 1},
  [56] = {.index = 101, .length = 2},
  [57] = {.index = 103, .length = 3},
  [58] = {.index = 106, .length = 3},
  [59] = {.index = 109, .length = 2},
  [60] = {.index = 111, .length = 2},
  [61] = {.index = 113, .length = 2},
  [62] = {.index = 115, .length = 1},
  [63] = {.index = 116, .length = 3},
  [64] = {.index = 119, .length = 1},
  [65] = {.index = 100, .length = 1},
  [66] = {.index = 120, .length = 2},
  [67] = {.index = 122, .length = 1},
  [68] = {.index = 123, .length = 4},
  [69] = {.index = 127, .length = 3},
  [70] = {.index = 130, .length = 4},
  [71] = {.index = 134, .length = 2},
  [72] = {.index = 136, .length = 2},
  [73] = {.index = 138, .length = 1},
  [74] = {.index = 139, .length = 3},
  [75] = {.index = 142, .length = 3},
  [76] = {.index = 145, .length = 2},
  [77] = {.index = 147, .length = 2},
  [78] = {.index = 149, .length = 4},
  [79] = {.index = 153, .length = 4},
  [80] = {.index = 157, .length = 3},
  [81] = {.index = 160, .length = 4},
  [82] = {.index = 164, .length = 2},
  [83] = {.index = 166, .length = 4},
  [84] = {.index = 170, .length = 5},
  [85] = {.index = 175, .length = 5},
  [86] = {.index = 180, .length = 6},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_parameters, 0, .inherited = true},
  [1] =
    {field_key_identifier, 0, .inherited = true},
    {field_key_type, 0, .inherited = true},
    {field_value_identifier, 0, .inherited = true},
    {field_value_type, 0, .inherited = true},
  [5] =
    {field_import_name, 0},
  [6] =
    {field_alias, 0, .inherited = true},
    {field_import_name, 0, .inherited = true},
  [8] =
    {field_source, 0},
  [9] =
    {field_parameters, 1},
  [10] =
    {field_version_constraint, 0},
  [11] =
    {field_version_constraint, 1, .inherited = true},
  [12] =
    {field_alias, 1, .inherited = true},
  [13] =
    {field_alias, 1, .inherited = true},
    {field_import_name, 0},
  [15] =
    {field_alias, 1, .inherited = true},
    {field_source, 1, .inherited = true},
  [17] =
    {field_alias, 1, .inherited = true},
    {field_source, 0},
  [19] =
    {field_body, 2},
    {field_name, 1},
  [21] =
    {field_type, 0},
  [22] =
    {field_version_constraint, 0, .inherited = true},
    {field_version_constraint, 1, .inherited = true},
  [24] =
    {field_alias, 1},
  [25] =
    {field_alias, 1, .inherited = true},
    {field_import_name, 1, .inherited = true},
  [27] =
    {field_source, 1},
  [28] =
    {field_alias, 1, .inherited = true},
    {field_import_name, 1, .inherited = true},
    {field_source, 2, .inherited = true},
  [31] =
    {field_body, 3},
    {field_name, 2},
  [33] =
    {field_ancestor, 0},
  [34] =
    {field_body, 3},
    {field_name, 1},
  [36] =
    {field_name, 1},
  [37] =
    {field_name, 1},
    {field_type, 0},
  [39] =
    {field_location, 1},
    {field_type, 0},
  [41] =
    {field_argument, 1},
    {field_operator, 0},
  [43] =
    {field_argument, 0},
    {field_operator, 1},
  [45] =
    {field_function, 0},
  [46] =
    {field_alias, 1, .inherited = true},
    {field_alias, 2, .inherited = true},
    {field_import_name, 1, .inherited = true},
    {field_import_name, 2, .inherited = true},
  [50] =
    {field_alias, 0, .inherited = true},
    {field_alias, 1, .inherited = true},
    {field_import_name, 0, .inherited = true},
    {field_import_name, 1, .inherited = true},
  [54] =
    {field_body, 4},
    {field_name, 2},
  [56] =
    {field_visibility, 0},
  [57] =
    {field_ancestor, 0},
    {field_ancestor_arguments, 1},
  [59] =
    {field_location, 1},
    {field_name, 2},
    {field_type, 0},
  [62] =
    {field_name, 1},
    {field_return_type, 3},
  [64] =
    {field_body, 4},
    {field_name, 1},
    {field_return_type, 3},
  [67] =
    {field_body, 4},
    {field_name, 1},
  [69] =
    {field_object, 0},
    {field_property, 2},
  [71] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [74] =
    {field_left, 0},
    {field_right, 2},
  [76] =
    {field_base, 0},
  [77] =
    {field_body, 2},
  [78] =
    {field_visibility, 0, .inherited = true},
    {field_visibility, 1, .inherited = true},
  [80] =
    {field_name, 2},
    {field_type, 0},
  [82] =
    {field_name, 1},
    {field_return_type, 4},
  [84] =
    {field_body, 5},
    {field_name, 1},
    {field_return_type, 4},
  [87] =
    {field_location, 2, .inherited = true},
    {field_type, 2, .inherited = true},
  [89] =
    {field_key_type, 2},
    {field_value_type, 4},
  [91] =
    {field_name, 2},
    {field_type, 0},
    {field_value, 4},
  [94] =
    {field_base, 0},
    {field_index, 2},
  [96] =
    {field_body, 3},
  [97] =
    {field_name, 2},
    {field_type, 0},
    {field_visibility, 1, .inherited = true},
  [100] =
    {field_error, 1},
  [101] =
    {field_location, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [103] =
    {field_key_type, 2},
    {field_value_identifier, 5},
    {field_value_type, 4},
  [106] =
    {field_key_identifier, 3},
    {field_key_type, 2},
    {field_value_type, 5},
  [109] =
    {field_name, 0},
    {field_value, 2},
  [111] =
    {field_base, 0},
    {field_to, 3},
  [113] =
    {field_base, 0},
    {field_from, 2},
  [115] =
    {field_source, 3},
  [116] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 3},
  [119] =
    {field_left, 1},
  [120] =
    {field_attempt, 1},
    {field_body, 2},
  [122] =
    {field_value, 2},
  [123] =
    {field_key_identifier, 3},
    {field_key_type, 2},
    {field_value_identifier, 6},
    {field_value_type, 5},
  [127] =
    {field_base, 0},
    {field_from, 2},
    {field_to, 4},
  [130] =
    {field_name, 2},
    {field_type, 0},
    {field_value, 4},
    {field_visibility, 1, .inherited = true},
  [134] =
    {field_left, 1},
    {field_left, 2},
  [136] =
    {field_body, 4},
    {field_condition, 2},
  [138] =
    {field_body, 1},
  [139] =
    {field_body, 5},
    {field_condition, 3},
    {field_initial, 2},
  [142] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
  [145] =
    {field_left, 1},
    {field_right, 3},
  [147] =
    {field_attempt, 1},
    {field_body, 4},
  [149] =
    {field_body, 6},
    {field_condition, 3},
    {field_initial, 2},
    {field_update, 4},
  [153] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
  [157] =
    {field_left, 1},
    {field_left, 2},
    {field_right, 4},
  [160] =
    {field_body, 4},
    {field_body, 6},
    {field_condition, 2},
    {field_else, 5},
  [164] =
    {field_body, 1},
    {field_condition, 4},
  [166] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_right, 5},
  [170] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
    {field_left, 5},
  [175] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
    {field_right, 6},
  [180] =
    {field_left, 1},
    {field_left, 2},
    {field_left, 3},
    {field_left, 4},
    {field_left, 5},
    {field_right, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [34] = {
    [1] = alias_sym_enum_value,
  },
  [54] = {
    [1] = alias_sym_revert_arguments,
  },
  [62] = {
    [1] = alias_sym_type_alias,
  },
  [65] = {
    [2] = alias_sym_revert_arguments,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__call_arguments, 2,
    sym__call_arguments,
    alias_sym_revert_arguments,
  sym_user_defined_type, 2,
    sym_user_defined_type,
    alias_sym_type_alias,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 7,
  [10] = 10,
  [11] = 8,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 107,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 112,
  [117] = 117,
  [118] = 111,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 119,
  [124] = 124,
  [125] = 125,
  [126] = 121,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 172,
  [175] = 161,
  [176] = 157,
  [177] = 155,
  [178] = 178,
  [179] = 154,
  [180] = 150,
  [181] = 135,
  [182] = 182,
  [183] = 136,
  [184] = 184,
  [185] = 137,
  [186] = 186,
  [187] = 140,
  [188] = 188,
  [189] = 189,
  [190] = 144,
  [191] = 191,
  [192] = 192,
  [193] = 168,
  [194] = 194,
  [195] = 149,
  [196] = 158,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 152,
  [201] = 201,
  [202] = 202,
  [203] = 170,
  [204] = 167,
  [205] = 169,
  [206] = 206,
  [207] = 207,
  [208] = 141,
  [209] = 139,
  [210] = 210,
  [211] = 138,
  [212] = 133,
  [213] = 163,
  [214] = 173,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 225,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 320,
  [321] = 321,
  [322] = 322,
  [323] = 323,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 266,
  [343] = 276,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 398,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 436,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 341,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 443,
  [446] = 444,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 484,
  [490] = 485,
  [491] = 481,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 492,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 543,
  [562] = 562,
  [563] = 552,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 551,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 574,
  [575] = 575,
  [576] = 576,
  [577] = 577,
  [578] = 541,
  [579] = 550,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 546,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 630,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 635,
  [636] = 636,
  [637] = 637,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 657,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 660,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 680,
  [686] = 686,
  [687] = 686,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 673,
  [693] = 693,
  [694] = 694,
  [695] = 695,
  [696] = 655,
  [697] = 697,
  [698] = 698,
  [699] = 699,
  [700] = 654,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 705,
  [706] = 706,
  [707] = 707,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 726,
  [727] = 727,
  [728] = 728,
  [729] = 670,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 750,
  [751] = 751,
  [752] = 752,
  [753] = 753,
  [754] = 754,
  [755] = 755,
  [756] = 756,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 763,
  [764] = 764,
  [765] = 765,
  [766] = 766,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 775,
  [776] = 776,
  [777] = 777,
  [778] = 778,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 784,
  [785] = 785,
  [786] = 786,
  [787] = 787,
  [788] = 788,
  [789] = 789,
  [790] = 790,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 794,
  [795] = 795,
  [796] = 796,
  [797] = 797,
  [798] = 798,
  [799] = 799,
  [800] = 800,
  [801] = 801,
  [802] = 802,
  [803] = 802,
  [804] = 790,
  [805] = 805,
  [806] = 806,
  [807] = 784,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 759,
  [812] = 812,
  [813] = 813,
  [814] = 814,
  [815] = 815,
  [816] = 812,
  [817] = 817,
  [818] = 762,
  [819] = 750,
  [820] = 751,
  [821] = 821,
  [822] = 822,
  [823] = 823,
  [824] = 824,
  [825] = 825,
  [826] = 826,
  [827] = 827,
  [828] = 828,
  [829] = 829,
  [830] = 754,
  [831] = 773,
  [832] = 815,
  [833] = 827,
  [834] = 814,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(51);
      ADVANCE_MAP(
        '!', 111,
        '"', 140,
        '%', 105,
        '&', 100,
        '\'', 143,
        '(', 82,
        ')', 83,
        '*', 78,
        '+', 103,
        ',', 80,
        '-', 55,
        '.', 87,
        '/', 104,
        '0', 88,
        ':', 86,
        ';', 126,
        '<', 67,
        '=', 77,
        '>', 72,
        '?', 93,
        '[', 94,
        '\\', 31,
        ']', 95,
        '^', 70,
        '_', 142,
        '{', 79,
        '|', 101,
        '}', 81,
        '~', 74,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(49);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(15);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '\\') ADVANCE(2);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(154);
      if (lookahead != 0) ADVANCE(155);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(149);
      if (lookahead == '\r') ADVANCE(145);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      if (lookahead != 0) ADVANCE(144);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(13);
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\\') ADVANCE(4);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(161);
      if (lookahead != 0) ADVANCE(162);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(156);
      if (lookahead == '\r') ADVANCE(146);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      if (lookahead != 0) ADVANCE(144);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        ' ', 5,
        '"', 6,
        '-', 53,
        '.', 7,
        '/', 17,
        ';', 126,
        '<', 68,
        '=', 75,
        '>', 71,
        '^', 69,
        '|', 34,
        '~', 74,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(5);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 6:
      if (lookahead == ' ') ADVANCE(36);
      if (lookahead == '.') ADVANCE(7);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 7:
      if (lookahead == ' ') ADVANCE(36);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 8:
      if (lookahead == ' ') ADVANCE(37);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 23,
        '"', 140,
        '%', 105,
        '&', 100,
        '\'', 143,
        '(', 82,
        ')', 83,
        '*', 78,
        '+', 103,
        ',', 80,
        '-', 55,
        '.', 87,
        '/', 104,
        ':', 85,
        ';', 126,
        '<', 67,
        '=', 76,
        '>', 72,
        '?', 93,
        '[', 94,
        ']', 95,
        '^', 70,
        '{', 79,
        '|', 101,
        '}', 81,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(9);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 23,
        '"', 27,
        '%', 105,
        '&', 100,
        '(', 82,
        ')', 83,
        '*', 78,
        '+', 103,
        ',', 80,
        '-', 55,
        '.', 87,
        '/', 104,
        ':', 85,
        ';', 126,
        '<', 67,
        '=', 77,
        '>', 72,
        '?', 93,
        '[', 94,
        ']', 95,
        '^', 70,
        '{', 79,
        '|', 101,
        '}', 81,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(10);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 110,
        '"', 140,
        '\'', 143,
        '(', 82,
        ')', 83,
        '+', 102,
        ',', 80,
        '-', 54,
        '.', 39,
        '/', 17,
        '0', 131,
        ':', 85,
        ';', 126,
        '=', 24,
        '[', 94,
        ']', 95,
        '_', 128,
        '{', 79,
        '}', 81,
        '~', 74,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(132);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(11);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '/') ADVANCE(17);
      if (lookahead == '_') ADVANCE(141);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(12);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(140);
      if (lookahead == '/') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(13);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(84);
      END_STATE();
    case 15:
      if (lookahead == '\'') ADVANCE(143);
      if (lookahead == '/') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(15);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '(', 82,
        ')', 83,
        ',', 80,
        '-', 25,
        '.', 87,
        '/', 17,
        ';', 126,
        '=', 24,
        '[', 94,
        '{', 79,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(16);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(165);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead != 0) ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead != 0) ADVANCE(19);
      END_STATE();
    case 20:
      if (lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(134);
      END_STATE();
    case 21:
      if (lookahead == '-') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(136);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(56);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(60);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 24:
      if (lookahead == '>') ADVANCE(125);
      END_STATE();
    case 25:
      if (lookahead == '>') ADVANCE(92);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(30);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(32);
      END_STATE();
    case 28:
      if (lookahead == 'm') ADVANCE(26);
      END_STATE();
    case 29:
      if (lookahead == 'm') ADVANCE(14);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(29);
      END_STATE();
    case 31:
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(148);
      if (lookahead != 0) ADVANCE(144);
      END_STATE();
    case 32:
      if (lookahead == 'v') ADVANCE(28);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 34:
      if (lookahead == '|') ADVANCE(52);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(144);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 37:
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(135);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(133);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(134);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(136);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(144);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(139);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 49:
      if (eof) ADVANCE(51);
      ADVANCE_MAP(
        '!', 111,
        '"', 140,
        '%', 105,
        '&', 100,
        '\'', 143,
        '(', 82,
        ')', 83,
        '*', 78,
        '+', 103,
        ',', 80,
        '-', 55,
        '.', 87,
        '/', 104,
        '0', 88,
        ':', 86,
        ';', 126,
        '<', 67,
        '=', 77,
        '>', 72,
        '?', 93,
        '[', 94,
        ']', 95,
        '^', 70,
        '_', 142,
        '{', 79,
        '|', 101,
        '}', 81,
        '~', 74,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(49);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 50:
      if (eof) ADVANCE(51);
      ADVANCE_MAP(
        '!', 23,
        '"', 140,
        '%', 105,
        '&', 100,
        '\'', 143,
        '(', 82,
        ')', 83,
        '*', 78,
        '+', 103,
        ',', 80,
        '-', 55,
        '.', 87,
        '/', 104,
        '0', 88,
        ':', 86,
        ';', 126,
        '<', 67,
        '=', 76,
        '>', 72,
        '?', 93,
        '[', 94,
        ']', 95,
        '^', 70,
        '{', 79,
        '|', 101,
        '}', 81,
      );
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(89);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(50);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(113);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(113);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '*') ADVANCE(58);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(60);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '*') ADVANCE(57);
      if (lookahead == '/') ADVANCE(163);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead != 0) ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '*') ADVANCE(57);
      if (lookahead == ';') ADVANCE(19);
      if (lookahead != 0) ADVANCE(58);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead == '/') ADVANCE(56);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym_pragma_value_token1);
      if (lookahead != 0 &&
          lookahead != ';') ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_solidity_version);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == ' ') ADVANCE(64);
      if (lookahead == '"') ADVANCE(61);
      if (lookahead == '.') ADVANCE(38);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == '"') ADVANCE(61);
      if (lookahead == '.') ADVANCE(8);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == '"') ADVANCE(61);
      if (lookahead == '.') ADVANCE(38);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_solidity_version);
      if (lookahead == '"') ADVANCE(61);
      if (lookahead == '*' ||
          ('0' <= lookahead && lookahead <= '9')) ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(99);
      if (lookahead == '=') ADVANCE(66);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(66);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(73);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(97);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(107);
      if (lookahead == '>') ADVANCE(125);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(106);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_DQUOTEevmasm_DQUOTE);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(91);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_yul_decimal_number);
      if (lookahead == 'x') ADVANCE(90);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_yul_decimal_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_yul_hex_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(122);
      if (lookahead == '>') ADVANCE(98);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(96);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '|') ADVANCE(52);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(112);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(112);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(19);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(129);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '.') ADVANCE(40);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(128);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(129);
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == '.') ADVANCE(40);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == '.') ADVANCE(40);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(aux_sym__decimal_number_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(aux_sym__decimal_number_token2);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(aux_sym__decimal_number_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym__hex_number_token1);
      if (lookahead == '_') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym__hex_number_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(137);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym__hex_digit);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym__escape_sequence);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (lookahead == '\n') ADVANCE(149);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (lookahead == '\n') ADVANCE(156);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(144);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym__escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(147);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '\r') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(153);
      if (lookahead == '/') ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead == '/') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(153);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(154);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym__single_quoted_unicode_char_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '\r') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(157);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(160);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead == '/') ADVANCE(162);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '*') ADVANCE(159);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(161);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym__double_quoted_unicode_char_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ';') ADVANCE(165);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(165);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'g', 7,
        'h', 8,
        'i', 9,
        'k', 10,
        'l', 11,
        'm', 12,
        'n', 13,
        'o', 14,
        'p', 15,
        'r', 16,
        's', 17,
        't', 18,
        'u', 19,
        'v', 20,
        'w', 21,
        'x', 22,
        'y', 23,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          lookahead == 0xa0 ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(24);
      if (lookahead == 'd') ADVANCE(25);
      if (lookahead == 'n') ADVANCE(26);
      if (lookahead == 's') ADVANCE(27);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(29);
      if (lookahead == 'o') ADVANCE(30);
      if (lookahead == 'r') ADVANCE(31);
      if (lookahead == 'y') ADVANCE(32);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'h') ADVANCE(34);
      if (lookahead == 'o') ADVANCE(35);
      if (lookahead == 'r') ADVANCE(36);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(37);
      if (lookahead == 'e') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        'l', 41,
        'm', 42,
        'n', 43,
        'q', 44,
        'r', 45,
        't', 46,
        'v', 47,
        'x', 48,
      );
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'i') ADVANCE(50);
      if (lookahead == 'o') ADVANCE(51);
      if (lookahead == 'r') ADVANCE(52);
      if (lookahead == 'u') ADVANCE(53);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(54);
      if (lookahead == 't') ADVANCE(55);
      if (lookahead == 'w') ADVANCE(56);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 'o') ADVANCE(58);
      END_STATE();
    case 9:
      if (lookahead == 'f') ADVANCE(59);
      if (lookahead == 'm') ADVANCE(60);
      if (lookahead == 'n') ADVANCE(61);
      if (lookahead == 's') ADVANCE(62);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 11:
      if (lookahead == 'e') ADVANCE(64);
      if (lookahead == 'i') ADVANCE(65);
      if (lookahead == 'o') ADVANCE(66);
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        'a', 68,
        'c', 69,
        'e', 70,
        'i', 71,
        'l', 72,
        'o', 73,
        's', 74,
        'u', 75,
      );
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(77);
      if (lookahead == 'u') ADVANCE(78);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(79);
      if (lookahead == 'v') ADVANCE(80);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(81);
      if (lookahead == 'o') ADVANCE(82);
      if (lookahead == 'r') ADVANCE(83);
      if (lookahead == 'u') ADVANCE(84);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(85);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        'a', 86,
        'd', 87,
        'e', 88,
        'g', 89,
        'h', 90,
        'i', 91,
        'l', 92,
        'm', 93,
        'o', 94,
        's', 95,
        't', 96,
        'u', 97,
        'w', 98,
        'z', 99,
      );
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(100);
      if (lookahead == 'l') ADVANCE(101);
      if (lookahead == 'r') ADVANCE(102);
      if (lookahead == 's') ADVANCE(103);
      if (lookahead == 'y') ADVANCE(104);
      END_STATE();
    case 19:
      if (lookahead == 'f') ADVANCE(105);
      if (lookahead == 'i') ADVANCE(106);
      if (lookahead == 'n') ADVANCE(107);
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(109);
      if (lookahead == 'i') ADVANCE(110);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(111);
      if (lookahead == 'h') ADVANCE(112);
      END_STATE();
    case 22:
      if (lookahead == 'o') ADVANCE(113);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(114);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(115);
      END_STATE();
    case 25:
      if (lookahead == 'd') ADVANCE(116);
      END_STATE();
    case 26:
      if (lookahead == 'd') ADVANCE(117);
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(119);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(120);
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 29:
      if (lookahead == 'o') ADVANCE(122);
      END_STATE();
    case 30:
      if (lookahead == 'o') ADVANCE(123);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(125);
      END_STATE();
    case 33:
      if (lookahead == 'l') ADVANCE(126);
      if (lookahead == 's') ADVANCE(127);
      if (lookahead == 't') ADVANCE(128);
      END_STATE();
    case 34:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(130);
      if (lookahead == 'n') ADVANCE(131);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 37:
      if (lookahead == 'y') ADVANCE(133);
      END_STATE();
    case 38:
      if (lookahead == 'f') ADVANCE(134);
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 39:
      if (lookahead == 'f') ADVANCE(136);
      if (lookahead == 'v') ADVANCE(137);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 41:
      if (lookahead == 's') ADVANCE(138);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 43:
      if (lookahead == 'u') ADVANCE(140);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_eq);
      END_STATE();
    case 45:
      if (lookahead == 'r') ADVANCE(141);
      END_STATE();
    case 46:
      if (lookahead == 'h') ADVANCE(142);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 48:
      if (lookahead == 'p') ADVANCE(144);
      if (lookahead == 't') ADVANCE(145);
      END_STATE();
    case 49:
      if (lookahead == 'l') ADVANCE(146);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(147);
      if (lookahead == 'x') ADVANCE(148);
      END_STATE();
    case 51:
      if (lookahead == 'r') ADVANCE(149);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(150);
      END_STATE();
    case 53:
      if (lookahead == 'n') ADVANCE(151);
      END_STATE();
    case 54:
      if (lookahead == 's') ADVANCE(152);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_gt);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 57:
      if (lookahead == 'x') ADVANCE(154);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(155);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 60:
      if (lookahead == 'm') ADVANCE(156);
      if (lookahead == 'p') ADVANCE(157);
      END_STATE();
    case 61:
      if (lookahead == 'd') ADVANCE(158);
      if (lookahead == 't') ADVANCE(159);
      if (lookahead == 'v') ADVANCE(160);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_is);
      if (lookahead == 'z') ADVANCE(161);
      END_STATE();
    case 63:
      if (lookahead == 'c') ADVANCE(162);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(163);
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 65:
      if (lookahead == 'b') ADVANCE(165);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(166);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_lt);
      END_STATE();
    case 68:
      if (lookahead == 'p') ADVANCE(167);
      END_STATE();
    case 69:
      if (lookahead == 'o') ADVANCE(168);
      END_STATE();
    case 70:
      if (lookahead == 'm') ADVANCE(169);
      END_STATE();
    case 71:
      if (lookahead == 'n') ADVANCE(170);
      END_STATE();
    case 72:
      if (lookahead == 'o') ADVANCE(171);
      END_STATE();
    case 73:
      if (lookahead == 'd') ADVANCE(172);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(173);
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 75:
      if (lookahead == 'l') ADVANCE(175);
      END_STATE();
    case 76:
      if (lookahead == 'w') ADVANCE(176);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 78:
      if (lookahead == 'm') ADVANCE(178);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'i') ADVANCE(179);
      END_STATE();
    case 80:
      if (lookahead == 'e') ADVANCE(180);
      END_STATE();
    case 81:
      if (lookahead == 'y') ADVANCE(181);
      END_STATE();
    case 82:
      if (lookahead == 'p') ADVANCE(182);
      END_STATE();
    case 83:
      if (lookahead == 'a') ADVANCE(183);
      if (lookahead == 'i') ADVANCE(184);
      END_STATE();
    case 84:
      if (lookahead == 'b') ADVANCE(185);
      if (lookahead == 'r') ADVANCE(186);
      END_STATE();
    case 85:
      if (lookahead == 'c') ADVANCE(187);
      if (lookahead == 't') ADVANCE(188);
      if (lookahead == 'v') ADVANCE(189);
      END_STATE();
    case 86:
      if (lookahead == 'r') ADVANCE(190);
      END_STATE();
    case 87:
      if (lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 88:
      if (lookahead == 'c') ADVANCE(192);
      if (lookahead == 'l') ADVANCE(193);
      END_STATE();
    case 89:
      if (lookahead == 't') ADVANCE(194);
      END_STATE();
    case 90:
      if (lookahead == 'l') ADVANCE(195);
      if (lookahead == 'r') ADVANCE(196);
      END_STATE();
    case 91:
      if (lookahead == 'g') ADVANCE(197);
      END_STATE();
    case 92:
      if (lookahead == 'o') ADVANCE(198);
      if (lookahead == 't') ADVANCE(199);
      END_STATE();
    case 93:
      if (lookahead == 'o') ADVANCE(200);
      END_STATE();
    case 94:
      if (lookahead == 'l') ADVANCE(201);
      END_STATE();
    case 95:
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 96:
      if (lookahead == 'a') ADVANCE(203);
      if (lookahead == 'o') ADVANCE(204);
      if (lookahead == 'r') ADVANCE(205);
      END_STATE();
    case 97:
      if (lookahead == 'b') ADVANCE(206);
      END_STATE();
    case 98:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 99:
      if (lookahead == 'a') ADVANCE(208);
      END_STATE();
    case 100:
      if (lookahead == 'm') ADVANCE(209);
      END_STATE();
    case 101:
      if (lookahead == 'o') ADVANCE(210);
      END_STATE();
    case 102:
      if (lookahead == 'u') ADVANCE(211);
      if (lookahead == 'y') ADVANCE(212);
      END_STATE();
    case 103:
      if (lookahead == 't') ADVANCE(213);
      END_STATE();
    case 104:
      if (lookahead == 'p') ADVANCE(214);
      END_STATE();
    case 105:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 106:
      if (lookahead == 'n') ADVANCE(216);
      END_STATE();
    case 107:
      if (lookahead == 'c') ADVANCE(217);
      if (lookahead == 'i') ADVANCE(218);
      END_STATE();
    case 108:
      if (lookahead == 'i') ADVANCE(219);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(220);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(221);
      if (lookahead == 'r') ADVANCE(222);
      END_STATE();
    case 111:
      if (lookahead == 'e') ADVANCE(223);
      if (lookahead == 'i') ADVANCE(224);
      END_STATE();
    case 112:
      if (lookahead == 'i') ADVANCE(225);
      END_STATE();
    case 113:
      if (lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 114:
      if (lookahead == 'a') ADVANCE(227);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(228);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_add);
      if (lookahead == 'm') ADVANCE(229);
      if (lookahead == 'r') ADVANCE(230);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 118:
      if (lookahead == 'n') ADVANCE(231);
      END_STATE();
    case 119:
      if (lookahead == 'e') ADVANCE(232);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(233);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 122:
      if (lookahead == 'b') ADVANCE(235);
      if (lookahead == 'c') ADVANCE(236);
      END_STATE();
    case 123:
      if (lookahead == 'l') ADVANCE(237);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(238);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 126:
      if (lookahead == 'l') ADVANCE(240);
      END_STATE();
    case 127:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 128:
      if (lookahead == 'c') ADVANCE(242);
      END_STATE();
    case 129:
      if (lookahead == 'i') ADVANCE(243);
      END_STATE();
    case 130:
      if (lookahead == 'n') ADVANCE(244);
      END_STATE();
    case 131:
      if (lookahead == 's') ADVANCE(245);
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 132:
      if (lookahead == 'a') ADVANCE(247);
      END_STATE();
    case 133:
      if (lookahead == 's') ADVANCE(248);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(249);
      END_STATE();
    case 135:
      if (lookahead == 'e') ADVANCE(250);
      END_STATE();
    case 136:
      if (lookahead == 'f') ADVANCE(251);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_div);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(252);
      END_STATE();
    case 139:
      if (lookahead == 't') ADVANCE(253);
      END_STATE();
    case 140:
      if (lookahead == 'm') ADVANCE(254);
      END_STATE();
    case 141:
      if (lookahead == 'o') ADVANCE(255);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(256);
      END_STATE();
    case 143:
      if (lookahead == 'n') ADVANCE(257);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_exp);
      END_STATE();
    case 145:
      if (lookahead == 'c') ADVANCE(258);
      if (lookahead == 'e') ADVANCE(259);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(260);
      if (lookahead == 's') ADVANCE(261);
      END_STATE();
    case 147:
      if (lookahead == 'n') ADVANCE(262);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 150:
      if (lookahead == 'm') ADVANCE(264);
      END_STATE();
    case 151:
      if (lookahead == 'c') ADVANCE(265);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_gas);
      if (lookahead == 'l') ADVANCE(266);
      if (lookahead == 'p') ADVANCE(267);
      END_STATE();
    case 153:
      if (lookahead == 'i') ADVANCE(268);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_hex);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(269);
      END_STATE();
    case 156:
      if (lookahead == 'u') ADVANCE(270);
      END_STATE();
    case 157:
      if (lookahead == 'o') ADVANCE(271);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_int);
      ADVANCE_MAP(
        '1', 273,
        '2', 274,
        '3', 275,
        '4', 276,
        '5', 277,
        '6', 278,
        '7', 279,
        '8', 280,
        '9', 281,
        'e', 282,
      );
      END_STATE();
    case 160:
      if (lookahead == 'a') ADVANCE(283);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(284);
      END_STATE();
    case 162:
      if (lookahead == 'c') ADVANCE(285);
      END_STATE();
    case 163:
      if (lookahead == 'v') ADVANCE(286);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 165:
      if (lookahead == 'r') ADVANCE(287);
      END_STATE();
    case 166:
      if (lookahead == '0') ADVANCE(288);
      if (lookahead == '1') ADVANCE(289);
      if (lookahead == '2') ADVANCE(290);
      if (lookahead == '3') ADVANCE(291);
      if (lookahead == '4') ADVANCE(292);
      END_STATE();
    case 167:
      if (lookahead == 'p') ADVANCE(293);
      END_STATE();
    case 168:
      if (lookahead == 'p') ADVANCE(294);
      END_STATE();
    case 169:
      if (lookahead == 'o') ADVANCE(295);
      END_STATE();
    case 170:
      if (lookahead == 'u') ADVANCE(296);
      END_STATE();
    case 171:
      if (lookahead == 'a') ADVANCE(297);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_mod);
      if (lookahead == 'i') ADVANCE(298);
      END_STATE();
    case 173:
      if (lookahead == 'z') ADVANCE(299);
      END_STATE();
    case 174:
      if (lookahead == 'o') ADVANCE(300);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_mul);
      if (lookahead == 'm') ADVANCE(301);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 178:
      if (lookahead == 'b') ADVANCE(302);
      END_STATE();
    case 179:
      if (lookahead == 'g') ADVANCE(303);
      END_STATE();
    case 180:
      if (lookahead == 'r') ADVANCE(304);
      END_STATE();
    case 181:
      if (lookahead == 'a') ADVANCE(305);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_pop);
      END_STATE();
    case 183:
      if (lookahead == 'g') ADVANCE(306);
      END_STATE();
    case 184:
      if (lookahead == 'v') ADVANCE(307);
      END_STATE();
    case 185:
      if (lookahead == 'l') ADVANCE(308);
      END_STATE();
    case 186:
      if (lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 187:
      if (lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 188:
      if (lookahead == 'u') ADVANCE(311);
      END_STATE();
    case 189:
      if (lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_sar);
      END_STATE();
    case 191:
      if (lookahead == 'v') ADVANCE(313);
      END_STATE();
    case 192:
      if (lookahead == 'o') ADVANCE(314);
      END_STATE();
    case 193:
      if (lookahead == 'f') ADVANCE(315);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_sgt);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_shl);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_shr);
      END_STATE();
    case 197:
      if (lookahead == 'n') ADVANCE(316);
      END_STATE();
    case 198:
      if (lookahead == 'a') ADVANCE(317);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_slt);
      END_STATE();
    case 200:
      if (lookahead == 'd') ADVANCE(318);
      END_STATE();
    case 201:
      if (lookahead == 'i') ADVANCE(319);
      END_STATE();
    case 202:
      if (lookahead == 'o') ADVANCE(320);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(321);
      END_STATE();
    case 204:
      if (lookahead == 'p') ADVANCE(322);
      if (lookahead == 'r') ADVANCE(323);
      END_STATE();
    case 205:
      if (lookahead == 'i') ADVANCE(324);
      if (lookahead == 'u') ADVANCE(325);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_sub);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(326);
      END_STATE();
    case 208:
      if (lookahead == 'b') ADVANCE(327);
      END_STATE();
    case 209:
      if (lookahead == 'e') ADVANCE(328);
      END_STATE();
    case 210:
      if (lookahead == 'a') ADVANCE(329);
      END_STATE();
    case 211:
      if (lookahead == 'e') ADVANCE(330);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 213:
      if (lookahead == 'o') ADVANCE(331);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(332);
      END_STATE();
    case 215:
      if (lookahead == 'x') ADVANCE(333);
      END_STATE();
    case 216:
      if (lookahead == 't') ADVANCE(334);
      END_STATE();
    case 217:
      if (lookahead == 'h') ADVANCE(335);
      END_STATE();
    case 218:
      if (lookahead == 'c') ADVANCE(336);
      END_STATE();
    case 219:
      if (lookahead == 'n') ADVANCE(337);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 221:
      if (lookahead == 'w') ADVANCE(338);
      END_STATE();
    case 222:
      if (lookahead == 't') ADVANCE(339);
      END_STATE();
    case 223:
      if (lookahead == 'k') ADVANCE(340);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_wei);
      END_STATE();
    case 225:
      if (lookahead == 'l') ADVANCE(341);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_xor);
      END_STATE();
    case 227:
      if (lookahead == 'r') ADVANCE(342);
      END_STATE();
    case 228:
      if (lookahead == 'r') ADVANCE(343);
      END_STATE();
    case 229:
      if (lookahead == 'o') ADVANCE(344);
      END_STATE();
    case 230:
      if (lookahead == 'e') ADVANCE(345);
      END_STATE();
    case 231:
      if (lookahead == 'y') ADVANCE(346);
      END_STATE();
    case 232:
      if (lookahead == 'm') ADVANCE(347);
      END_STATE();
    case 233:
      if (lookahead == 'n') ADVANCE(348);
      END_STATE();
    case 234:
      if (lookahead == 'f') ADVANCE(349);
      END_STATE();
    case 235:
      if (lookahead == 'f') ADVANCE(350);
      if (lookahead == 'h') ADVANCE(351);
      END_STATE();
    case 236:
      if (lookahead == 'k') ADVANCE(352);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 238:
      if (lookahead == 'k') ADVANCE(353);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_byte);
      if (lookahead == 's') ADVANCE(354);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_call);
      if (lookahead == 'c') ADVANCE(355);
      if (lookahead == 'd') ADVANCE(356);
      if (lookahead == 'e') ADVANCE(357);
      if (lookahead == 'v') ADVANCE(358);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 242:
      if (lookahead == 'h') ADVANCE(359);
      END_STATE();
    case 243:
      if (lookahead == 'n') ADVANCE(360);
      END_STATE();
    case 244:
      if (lookahead == 'b') ADVANCE(361);
      END_STATE();
    case 245:
      if (lookahead == 't') ADVANCE(362);
      END_STATE();
    case 246:
      if (lookahead == 'i') ADVANCE(363);
      if (lookahead == 'r') ADVANCE(364);
      END_STATE();
    case 247:
      if (lookahead == 't') ADVANCE(365);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_days);
      END_STATE();
    case 249:
      if (lookahead == 'u') ADVANCE(366);
      END_STATE();
    case 250:
      if (lookahead == 'g') ADVANCE(367);
      if (lookahead == 't') ADVANCE(368);
      END_STATE();
    case 251:
      if (lookahead == 'i') ADVANCE(369);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_emit);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 255:
      if (lookahead == 'r') ADVANCE(370);
      END_STATE();
    case 256:
      if (lookahead == 'r') ADVANCE(371);
      END_STATE();
    case 257:
      if (lookahead == 't') ADVANCE(372);
      END_STATE();
    case 258:
      if (lookahead == 'o') ADVANCE(373);
      END_STATE();
    case 259:
      if (lookahead == 'r') ADVANCE(374);
      END_STATE();
    case 260:
      if (lookahead == 'b') ADVANCE(375);
      END_STATE();
    case 261:
      if (lookahead == 'e') ADVANCE(376);
      END_STATE();
    case 262:
      if (lookahead == 'e') ADVANCE(377);
      END_STATE();
    case 263:
      if (lookahead == 'd') ADVANCE(378);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 265:
      if (lookahead == 't') ADVANCE(379);
      END_STATE();
    case 266:
      if (lookahead == 'i') ADVANCE(380);
      END_STATE();
    case 267:
      if (lookahead == 'r') ADVANCE(381);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_gwei);
      END_STATE();
    case 269:
      if (lookahead == 's') ADVANCE(382);
      END_STATE();
    case 270:
      if (lookahead == 't') ADVANCE(383);
      END_STATE();
    case 271:
      if (lookahead == 'r') ADVANCE(384);
      END_STATE();
    case 272:
      if (lookahead == 'x') ADVANCE(385);
      END_STATE();
    case 273:
      ADVANCE_MAP(
        '0', 386,
        '1', 387,
        '2', 388,
        '3', 389,
        '4', 390,
        '5', 391,
        '6', 392,
        '7', 393,
        '8', 394,
        '9', 395,
      );
      END_STATE();
    case 274:
      if (lookahead == '0') ADVANCE(396);
      if (lookahead == '1') ADVANCE(397);
      if (lookahead == '2') ADVANCE(398);
      if (lookahead == '3') ADVANCE(399);
      if (lookahead == '4') ADVANCE(400);
      if (lookahead == '5') ADVANCE(401);
      END_STATE();
    case 275:
      if (lookahead == '2') ADVANCE(402);
      END_STATE();
    case 276:
      if (lookahead == '0') ADVANCE(403);
      if (lookahead == '8') ADVANCE(404);
      END_STATE();
    case 277:
      if (lookahead == '6') ADVANCE(405);
      END_STATE();
    case 278:
      if (lookahead == '4') ADVANCE(406);
      END_STATE();
    case 279:
      if (lookahead == '2') ADVANCE(407);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_int8);
      if (lookahead == '0') ADVANCE(408);
      if (lookahead == '8') ADVANCE(409);
      END_STATE();
    case 281:
      if (lookahead == '6') ADVANCE(410);
      END_STATE();
    case 282:
      if (lookahead == 'r') ADVANCE(411);
      END_STATE();
    case 283:
      if (lookahead == 'l') ADVANCE(412);
      END_STATE();
    case 284:
      if (lookahead == 'r') ADVANCE(413);
      END_STATE();
    case 285:
      if (lookahead == 'a') ADVANCE(414);
      END_STATE();
    case 286:
      if (lookahead == 'e') ADVANCE(415);
      END_STATE();
    case 287:
      if (lookahead == 'a') ADVANCE(416);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_log0);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_log1);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_log2);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_log3);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_log4);
      END_STATE();
    case 293:
      if (lookahead == 'i') ADVANCE(417);
      END_STATE();
    case 294:
      if (lookahead == 'y') ADVANCE(418);
      END_STATE();
    case 295:
      if (lookahead == 'r') ADVANCE(419);
      END_STATE();
    case 296:
      if (lookahead == 't') ADVANCE(420);
      END_STATE();
    case 297:
      if (lookahead == 'd') ADVANCE(421);
      END_STATE();
    case 298:
      if (lookahead == 'f') ADVANCE(422);
      END_STATE();
    case 299:
      if (lookahead == 'e') ADVANCE(423);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(424);
      END_STATE();
    case 301:
      if (lookahead == 'o') ADVANCE(425);
      END_STATE();
    case 302:
      if (lookahead == 'e') ADVANCE(426);
      END_STATE();
    case 303:
      if (lookahead == 'i') ADVANCE(427);
      END_STATE();
    case 304:
      if (lookahead == 'r') ADVANCE(428);
      END_STATE();
    case 305:
      if (lookahead == 'b') ADVANCE(429);
      END_STATE();
    case 306:
      if (lookahead == 'm') ADVANCE(430);
      END_STATE();
    case 307:
      if (lookahead == 'a') ADVANCE(431);
      END_STATE();
    case 308:
      if (lookahead == 'i') ADVANCE(432);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_pure);
      END_STATE();
    case 310:
      if (lookahead == 'i') ADVANCE(433);
      END_STATE();
    case 311:
      if (lookahead == 'r') ADVANCE(434);
      END_STATE();
    case 312:
      if (lookahead == 'r') ADVANCE(435);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym_sdiv);
      END_STATE();
    case 314:
      if (lookahead == 'n') ADVANCE(436);
      END_STATE();
    case 315:
      if (lookahead == 'b') ADVANCE(437);
      if (lookahead == 'd') ADVANCE(438);
      END_STATE();
    case 316:
      if (lookahead == 'e') ADVANCE(439);
      END_STATE();
    case 317:
      if (lookahead == 'd') ADVANCE(440);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_smod);
      END_STATE();
    case 319:
      if (lookahead == 'd') ADVANCE(441);
      END_STATE();
    case 320:
      if (lookahead == 'r') ADVANCE(442);
      END_STATE();
    case 321:
      if (lookahead == 'i') ADVANCE(443);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_stop);
      END_STATE();
    case 323:
      if (lookahead == 'a') ADVANCE(444);
      END_STATE();
    case 324:
      if (lookahead == 'n') ADVANCE(445);
      END_STATE();
    case 325:
      if (lookahead == 'c') ADVANCE(446);
      END_STATE();
    case 326:
      if (lookahead == 'c') ADVANCE(447);
      END_STATE();
    case 327:
      if (lookahead == 'o') ADVANCE(448);
      END_STATE();
    case 328:
      if (lookahead == 's') ADVANCE(449);
      END_STATE();
    case 329:
      if (lookahead == 'd') ADVANCE(450);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 331:
      if (lookahead == 'r') ADVANCE(451);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 333:
      if (lookahead == 'e') ADVANCE(452);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_uint);
      ADVANCE_MAP(
        '1', 453,
        '2', 454,
        '3', 455,
        '4', 456,
        '5', 457,
        '6', 458,
        '7', 459,
        '8', 460,
        '9', 461,
      );
      END_STATE();
    case 335:
      if (lookahead == 'e') ADVANCE(462);
      END_STATE();
    case 336:
      if (lookahead == 'o') ADVANCE(463);
      END_STATE();
    case 337:
      if (lookahead == 'g') ADVANCE(464);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(anon_sym_view);
      END_STATE();
    case 339:
      if (lookahead == 'u') ADVANCE(465);
      END_STATE();
    case 340:
      if (lookahead == 's') ADVANCE(466);
      END_STATE();
    case 341:
      if (lookahead == 'e') ADVANCE(467);
      END_STATE();
    case 342:
      if (lookahead == 's') ADVANCE(468);
      END_STATE();
    case 343:
      if (lookahead == 'a') ADVANCE(469);
      END_STATE();
    case 344:
      if (lookahead == 'd') ADVANCE(470);
      END_STATE();
    case 345:
      if (lookahead == 's') ADVANCE(471);
      END_STATE();
    case 346:
      if (lookahead == 'm') ADVANCE(472);
      END_STATE();
    case 347:
      if (lookahead == 'b') ADVANCE(473);
      END_STATE();
    case 348:
      if (lookahead == 'c') ADVANCE(474);
      END_STATE();
    case 349:
      if (lookahead == 'e') ADVANCE(475);
      END_STATE();
    case 350:
      if (lookahead == 'e') ADVANCE(476);
      END_STATE();
    case 351:
      if (lookahead == 'a') ADVANCE(477);
      END_STATE();
    case 352:
      if (lookahead == 'h') ADVANCE(478);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(anon_sym_bytes);
      ADVANCE_MAP(
        '1', 479,
        '2', 480,
        '3', 481,
        '4', 482,
        '5', 483,
        '6', 484,
        '7', 485,
        '8', 486,
        '9', 487,
      );
      END_STATE();
    case 355:
      if (lookahead == 'o') ADVANCE(488);
      END_STATE();
    case 356:
      if (lookahead == 'a') ADVANCE(489);
      END_STATE();
    case 357:
      if (lookahead == 'r') ADVANCE(490);
      END_STATE();
    case 358:
      if (lookahead == 'a') ADVANCE(491);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 360:
      if (lookahead == 'i') ADVANCE(492);
      END_STATE();
    case 361:
      if (lookahead == 'a') ADVANCE(493);
      END_STATE();
    case 362:
      if (lookahead == 'a') ADVANCE(494);
      if (lookahead == 'r') ADVANCE(495);
      END_STATE();
    case 363:
      if (lookahead == 'n') ADVANCE(496);
      END_STATE();
    case 364:
      if (lookahead == 'a') ADVANCE(497);
      END_STATE();
    case 365:
      if (lookahead == 'e') ADVANCE(498);
      END_STATE();
    case 366:
      if (lookahead == 'l') ADVANCE(499);
      END_STATE();
    case 367:
      if (lookahead == 'a') ADVANCE(500);
      END_STATE();
    case 368:
      if (lookahead == 'e') ADVANCE(501);
      END_STATE();
    case 369:
      if (lookahead == 'c') ADVANCE(502);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_error);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_ether);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 373:
      if (lookahead == 'd') ADVANCE(503);
      END_STATE();
    case 374:
      if (lookahead == 'n') ADVANCE(504);
      END_STATE();
    case 375:
      if (lookahead == 'a') ADVANCE(505);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 377:
      if (lookahead == 'y') ADVANCE(506);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_fixed);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(507);
      END_STATE();
    case 379:
      if (lookahead == 'i') ADVANCE(508);
      END_STATE();
    case 380:
      if (lookahead == 'm') ADVANCE(509);
      END_STATE();
    case 381:
      if (lookahead == 'i') ADVANCE(510);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_hours);
      END_STATE();
    case 383:
      if (lookahead == 'a') ADVANCE(511);
      END_STATE();
    case 384:
      if (lookahead == 't') ADVANCE(512);
      END_STATE();
    case 385:
      if (lookahead == 'e') ADVANCE(513);
      END_STATE();
    case 386:
      if (lookahead == '4') ADVANCE(514);
      END_STATE();
    case 387:
      if (lookahead == '2') ADVANCE(515);
      END_STATE();
    case 388:
      if (lookahead == '0') ADVANCE(516);
      if (lookahead == '8') ADVANCE(517);
      END_STATE();
    case 389:
      if (lookahead == '6') ADVANCE(518);
      END_STATE();
    case 390:
      if (lookahead == '4') ADVANCE(519);
      END_STATE();
    case 391:
      if (lookahead == '2') ADVANCE(520);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(anon_sym_int16);
      if (lookahead == '0') ADVANCE(521);
      if (lookahead == '8') ADVANCE(522);
      END_STATE();
    case 393:
      if (lookahead == '6') ADVANCE(523);
      END_STATE();
    case 394:
      if (lookahead == '4') ADVANCE(524);
      END_STATE();
    case 395:
      if (lookahead == '2') ADVANCE(525);
      END_STATE();
    case 396:
      if (lookahead == '0') ADVANCE(526);
      if (lookahead == '8') ADVANCE(527);
      END_STATE();
    case 397:
      if (lookahead == '6') ADVANCE(528);
      END_STATE();
    case 398:
      if (lookahead == '4') ADVANCE(529);
      END_STATE();
    case 399:
      if (lookahead == '2') ADVANCE(530);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_int24);
      if (lookahead == '0') ADVANCE(531);
      if (lookahead == '8') ADVANCE(532);
      END_STATE();
    case 401:
      if (lookahead == '6') ADVANCE(533);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_int32);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_int40);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_int48);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(anon_sym_int56);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(anon_sym_int64);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(anon_sym_int72);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(anon_sym_int80);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(anon_sym_int88);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym_int96);
      END_STATE();
    case 411:
      if (lookahead == 'f') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(535);
      END_STATE();
    case 412:
      if (lookahead == 'i') ADVANCE(536);
      END_STATE();
    case 413:
      if (lookahead == 'o') ADVANCE(537);
      END_STATE();
    case 414:
      if (lookahead == 'k') ADVANCE(538);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_yul_leave);
      END_STATE();
    case 416:
      if (lookahead == 'r') ADVANCE(539);
      END_STATE();
    case 417:
      if (lookahead == 'n') ADVANCE(540);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_mcopy);
      END_STATE();
    case 419:
      if (lookahead == 'y') ADVANCE(541);
      END_STATE();
    case 420:
      if (lookahead == 'e') ADVANCE(542);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_mload);
      END_STATE();
    case 422:
      if (lookahead == 'i') ADVANCE(543);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_msize);
      END_STATE();
    case 424:
      if (lookahead == 'e') ADVANCE(544);
      END_STATE();
    case 425:
      if (lookahead == 'd') ADVANCE(545);
      END_STATE();
    case 426:
      if (lookahead == 'r') ADVANCE(546);
      END_STATE();
    case 427:
      if (lookahead == 'n') ADVANCE(547);
      END_STATE();
    case 428:
      if (lookahead == 'i') ADVANCE(548);
      END_STATE();
    case 429:
      if (lookahead == 'l') ADVANCE(549);
      END_STATE();
    case 430:
      if (lookahead == 'a') ADVANCE(550);
      END_STATE();
    case 431:
      if (lookahead == 't') ADVANCE(551);
      END_STATE();
    case 432:
      if (lookahead == 'c') ADVANCE(552);
      END_STATE();
    case 433:
      if (lookahead == 'v') ADVANCE(553);
      END_STATE();
    case 434:
      if (lookahead == 'n') ADVANCE(554);
      END_STATE();
    case 435:
      if (lookahead == 't') ADVANCE(555);
      END_STATE();
    case 436:
      if (lookahead == 'd') ADVANCE(556);
      END_STATE();
    case 437:
      if (lookahead == 'a') ADVANCE(557);
      END_STATE();
    case 438:
      if (lookahead == 'e') ADVANCE(558);
      END_STATE();
    case 439:
      if (lookahead == 'x') ADVANCE(559);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(anon_sym_sload);
      END_STATE();
    case 441:
      if (lookahead == 'i') ADVANCE(560);
      END_STATE();
    case 442:
      if (lookahead == 'e') ADVANCE(561);
      END_STATE();
    case 443:
      if (lookahead == 'c') ADVANCE(562);
      END_STATE();
    case 444:
      if (lookahead == 'g') ADVANCE(563);
      END_STATE();
    case 445:
      if (lookahead == 'g') ADVANCE(564);
      END_STATE();
    case 446:
      if (lookahead == 't') ADVANCE(565);
      END_STATE();
    case 447:
      if (lookahead == 'h') ADVANCE(566);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_szabo);
      END_STATE();
    case 449:
      if (lookahead == 't') ADVANCE(567);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_tload);
      END_STATE();
    case 451:
      if (lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 452:
      if (lookahead == 'd') ADVANCE(569);
      END_STATE();
    case 453:
      ADVANCE_MAP(
        '0', 570,
        '1', 571,
        '2', 572,
        '3', 573,
        '4', 574,
        '5', 575,
        '6', 576,
        '7', 577,
        '8', 578,
        '9', 579,
      );
      END_STATE();
    case 454:
      if (lookahead == '0') ADVANCE(580);
      if (lookahead == '1') ADVANCE(581);
      if (lookahead == '2') ADVANCE(582);
      if (lookahead == '3') ADVANCE(583);
      if (lookahead == '4') ADVANCE(584);
      if (lookahead == '5') ADVANCE(585);
      END_STATE();
    case 455:
      if (lookahead == '2') ADVANCE(586);
      END_STATE();
    case 456:
      if (lookahead == '0') ADVANCE(587);
      if (lookahead == '8') ADVANCE(588);
      END_STATE();
    case 457:
      if (lookahead == '6') ADVANCE(589);
      END_STATE();
    case 458:
      if (lookahead == '4') ADVANCE(590);
      END_STATE();
    case 459:
      if (lookahead == '2') ADVANCE(591);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_uint8);
      if (lookahead == '0') ADVANCE(592);
      if (lookahead == '8') ADVANCE(593);
      END_STATE();
    case 461:
      if (lookahead == '6') ADVANCE(594);
      END_STATE();
    case 462:
      if (lookahead == 'c') ADVANCE(595);
      END_STATE();
    case 463:
      if (lookahead == 'd') ADVANCE(596);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 465:
      if (lookahead == 'a') ADVANCE(597);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(anon_sym_weeks);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(anon_sym_years);
      END_STATE();
    case 469:
      if (lookahead == 'c') ADVANCE(598);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_addmod);
      END_STATE();
    case 471:
      if (lookahead == 's') ADVANCE(599);
      END_STATE();
    case 472:
      if (lookahead == 'o') ADVANCE(600);
      END_STATE();
    case 473:
      if (lookahead == 'l') ADVANCE(601);
      END_STATE();
    case 474:
      if (lookahead == 'e') ADVANCE(602);
      END_STATE();
    case 475:
      if (lookahead == 'e') ADVANCE(603);
      END_STATE();
    case 476:
      if (lookahead == 'e') ADVANCE(604);
      END_STATE();
    case 477:
      if (lookahead == 's') ADVANCE(605);
      END_STATE();
    case 478:
      if (lookahead == 'a') ADVANCE(606);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(anon_sym_bytes1);
      ADVANCE_MAP(
        '0', 607,
        '1', 608,
        '2', 609,
        '3', 610,
        '4', 611,
        '5', 612,
        '6', 613,
        '7', 614,
        '8', 615,
        '9', 616,
      );
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_bytes2);
      ADVANCE_MAP(
        '0', 617,
        '1', 618,
        '2', 619,
        '3', 620,
        '4', 621,
        '5', 622,
        '6', 623,
        '7', 624,
        '8', 625,
        '9', 626,
      );
      END_STATE();
    case 481:
      ACCEPT_TOKEN(anon_sym_bytes3);
      if (lookahead == '0') ADVANCE(627);
      if (lookahead == '1') ADVANCE(628);
      if (lookahead == '2') ADVANCE(629);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(anon_sym_bytes4);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(anon_sym_bytes5);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_bytes6);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(anon_sym_bytes7);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_bytes8);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_bytes9);
      END_STATE();
    case 488:
      if (lookahead == 'd') ADVANCE(630);
      END_STATE();
    case 489:
      if (lookahead == 't') ADVANCE(631);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_caller);
      END_STATE();
    case 491:
      if (lookahead == 'l') ADVANCE(632);
      END_STATE();
    case 492:
      if (lookahead == 'd') ADVANCE(633);
      END_STATE();
    case 493:
      if (lookahead == 's') ADVANCE(634);
      END_STATE();
    case 494:
      if (lookahead == 'n') ADVANCE(635);
      END_STATE();
    case 495:
      if (lookahead == 'u') ADVANCE(636);
      END_STATE();
    case 496:
      if (lookahead == 'u') ADVANCE(637);
      END_STATE();
    case 497:
      if (lookahead == 'c') ADVANCE(638);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_create);
      if (lookahead == '2') ADVANCE(639);
      END_STATE();
    case 499:
      if (lookahead == 't') ADVANCE(640);
      END_STATE();
    case 500:
      if (lookahead == 't') ADVANCE(641);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 502:
      if (lookahead == 'u') ADVANCE(642);
      END_STATE();
    case 503:
      if (lookahead == 'e') ADVANCE(643);
      END_STATE();
    case 504:
      if (lookahead == 'a') ADVANCE(644);
      END_STATE();
    case 505:
      if (lookahead == 'c') ADVANCE(645);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_finney);
      END_STATE();
    case 507:
      if (lookahead == 'x') ADVANCE(646);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(507);
      END_STATE();
    case 508:
      if (lookahead == 'o') ADVANCE(647);
      END_STATE();
    case 509:
      if (lookahead == 'i') ADVANCE(648);
      END_STATE();
    case 510:
      if (lookahead == 'c') ADVANCE(649);
      END_STATE();
    case 511:
      if (lookahead == 'b') ADVANCE(650);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 513:
      if (lookahead == 'd') ADVANCE(651);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(anon_sym_int104);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_int112);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_int120);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_int128);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_int136);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_int144);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_int152);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_int160);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_int168);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_int176);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_int184);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_int192);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_int200);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(anon_sym_int208);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(anon_sym_int216);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(anon_sym_int224);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_int232);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(anon_sym_int240);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_int248);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(anon_sym_int256);
      END_STATE();
    case 534:
      if (lookahead == 'a') ADVANCE(652);
      END_STATE();
    case 535:
      if (lookahead == 'a') ADVANCE(653);
      END_STATE();
    case 536:
      if (lookahead == 'd') ADVANCE(654);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_iszero);
      END_STATE();
    case 538:
      if (lookahead == '2') ADVANCE(655);
      END_STATE();
    case 539:
      if (lookahead == 'y') ADVANCE(656);
      END_STATE();
    case 540:
      if (lookahead == 'g') ADVANCE(657);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(anon_sym_memory);
      END_STATE();
    case 542:
      if (lookahead == 's') ADVANCE(658);
      END_STATE();
    case 543:
      if (lookahead == 'e') ADVANCE(659);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_mstore);
      if (lookahead == '8') ADVANCE(660);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_mulmod);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_origin);
      END_STATE();
    case 548:
      if (lookahead == 'd') ADVANCE(661);
      END_STATE();
    case 549:
      if (lookahead == 'e') ADVANCE(662);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_pragma);
      END_STATE();
    case 551:
      if (lookahead == 'e') ADVANCE(663);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 553:
      if (lookahead == 'e') ADVANCE(664);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_return);
      if (lookahead == 'd') ADVANCE(665);
      if (lookahead == 's') ADVANCE(666);
      END_STATE();
    case 555:
      ACCEPT_TOKEN(anon_sym_revert);
      END_STATE();
    case 556:
      if (lookahead == 's') ADVANCE(667);
      END_STATE();
    case 557:
      if (lookahead == 'l') ADVANCE(668);
      END_STATE();
    case 558:
      if (lookahead == 's') ADVANCE(669);
      END_STATE();
    case 559:
      if (lookahead == 't') ADVANCE(670);
      END_STATE();
    case 560:
      if (lookahead == 't') ADVANCE(671);
      END_STATE();
    case 561:
      ACCEPT_TOKEN(anon_sym_sstore);
      END_STATE();
    case 562:
      if (lookahead == 'c') ADVANCE(672);
      END_STATE();
    case 563:
      if (lookahead == 'e') ADVANCE(673);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 565:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 567:
      if (lookahead == 'a') ADVANCE(674);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_tstore);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_ufixed);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(675);
      END_STATE();
    case 570:
      if (lookahead == '4') ADVANCE(676);
      END_STATE();
    case 571:
      if (lookahead == '2') ADVANCE(677);
      END_STATE();
    case 572:
      if (lookahead == '0') ADVANCE(678);
      if (lookahead == '8') ADVANCE(679);
      END_STATE();
    case 573:
      if (lookahead == '6') ADVANCE(680);
      END_STATE();
    case 574:
      if (lookahead == '4') ADVANCE(681);
      END_STATE();
    case 575:
      if (lookahead == '2') ADVANCE(682);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_uint16);
      if (lookahead == '0') ADVANCE(683);
      if (lookahead == '8') ADVANCE(684);
      END_STATE();
    case 577:
      if (lookahead == '6') ADVANCE(685);
      END_STATE();
    case 578:
      if (lookahead == '4') ADVANCE(686);
      END_STATE();
    case 579:
      if (lookahead == '2') ADVANCE(687);
      END_STATE();
    case 580:
      if (lookahead == '0') ADVANCE(688);
      if (lookahead == '8') ADVANCE(689);
      END_STATE();
    case 581:
      if (lookahead == '6') ADVANCE(690);
      END_STATE();
    case 582:
      if (lookahead == '4') ADVANCE(691);
      END_STATE();
    case 583:
      if (lookahead == '2') ADVANCE(692);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_uint24);
      if (lookahead == '0') ADVANCE(693);
      if (lookahead == '8') ADVANCE(694);
      END_STATE();
    case 585:
      if (lookahead == '6') ADVANCE(695);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_uint32);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_uint40);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_uint48);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_uint56);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_uint64);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_uint72);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_uint80);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_uint88);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_uint96);
      END_STATE();
    case 595:
      if (lookahead == 'k') ADVANCE(696);
      END_STATE();
    case 596:
      if (lookahead == 'e') ADVANCE(697);
      END_STATE();
    case 597:
      if (lookahead == 'l') ADVANCE(698);
      END_STATE();
    case 598:
      if (lookahead == 't') ADVANCE(699);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_address);
      END_STATE();
    case 600:
      if (lookahead == 'u') ADVANCE(700);
      END_STATE();
    case 601:
      if (lookahead == 'y') ADVANCE(701);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym_balance);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_basefee);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_blobfee);
      END_STATE();
    case 605:
      if (lookahead == 'h') ADVANCE(702);
      END_STATE();
    case 606:
      if (lookahead == 's') ADVANCE(703);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(anon_sym_bytes10);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym_bytes11);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(anon_sym_bytes12);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(anon_sym_bytes13);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(anon_sym_bytes14);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(anon_sym_bytes15);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(anon_sym_bytes16);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(anon_sym_bytes17);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(anon_sym_bytes18);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(anon_sym_bytes19);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(anon_sym_bytes20);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(anon_sym_bytes21);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(anon_sym_bytes22);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(anon_sym_bytes23);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(anon_sym_bytes24);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(anon_sym_bytes25);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(anon_sym_bytes26);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(anon_sym_bytes27);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(anon_sym_bytes28);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(anon_sym_bytes29);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(anon_sym_bytes30);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(anon_sym_bytes31);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(anon_sym_bytes32);
      END_STATE();
    case 630:
      if (lookahead == 'e') ADVANCE(704);
      END_STATE();
    case 631:
      if (lookahead == 'a') ADVANCE(705);
      END_STATE();
    case 632:
      if (lookahead == 'u') ADVANCE(706);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(anon_sym_chainid);
      END_STATE();
    case 634:
      if (lookahead == 'e') ADVANCE(707);
      END_STATE();
    case 635:
      if (lookahead == 't') ADVANCE(708);
      END_STATE();
    case 636:
      if (lookahead == 'c') ADVANCE(709);
      END_STATE();
    case 637:
      if (lookahead == 'e') ADVANCE(710);
      END_STATE();
    case 638:
      if (lookahead == 't') ADVANCE(711);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(anon_sym_create2);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 641:
      if (lookahead == 'e') ADVANCE(712);
      END_STATE();
    case 642:
      if (lookahead == 'l') ADVANCE(713);
      END_STATE();
    case 643:
      if (lookahead == 'c') ADVANCE(714);
      if (lookahead == 'h') ADVANCE(715);
      if (lookahead == 's') ADVANCE(716);
      END_STATE();
    case 644:
      if (lookahead == 'l') ADVANCE(717);
      END_STATE();
    case 645:
      if (lookahead == 'k') ADVANCE(718);
      END_STATE();
    case 646:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(719);
      END_STATE();
    case 647:
      if (lookahead == 'n') ADVANCE(720);
      END_STATE();
    case 648:
      if (lookahead == 't') ADVANCE(721);
      END_STATE();
    case 649:
      if (lookahead == 'e') ADVANCE(722);
      END_STATE();
    case 650:
      if (lookahead == 'l') ADVANCE(723);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(anon_sym_indexed);
      END_STATE();
    case 652:
      if (lookahead == 'c') ADVANCE(724);
      END_STATE();
    case 653:
      if (lookahead == 'l') ADVANCE(725);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(anon_sym_invalid);
      END_STATE();
    case 655:
      if (lookahead == '5') ADVANCE(726);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(anon_sym_library);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(anon_sym_mapping);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(anon_sym_minutes);
      END_STATE();
    case 659:
      if (lookahead == 'r') ADVANCE(727);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(anon_sym_mstore8);
      END_STATE();
    case 661:
      if (lookahead == 'e') ADVANCE(728);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(anon_sym_payable);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(anon_sym_receive);
      END_STATE();
    case 665:
      if (lookahead == 'a') ADVANCE(729);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(anon_sym_returns);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(anon_sym_seconds);
      END_STATE();
    case 668:
      if (lookahead == 'a') ADVANCE(730);
      END_STATE();
    case 669:
      if (lookahead == 't') ADVANCE(731);
      END_STATE();
    case 670:
      if (lookahead == 'e') ADVANCE(732);
      END_STATE();
    case 671:
      if (lookahead == 'y') ADVANCE(733);
      END_STATE();
    case 672:
      if (lookahead == 'a') ADVANCE(734);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(anon_sym_storage);
      END_STATE();
    case 674:
      if (lookahead == 'm') ADVANCE(735);
      END_STATE();
    case 675:
      if (lookahead == 'x') ADVANCE(736);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(675);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(anon_sym_uint104);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(anon_sym_uint112);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(anon_sym_uint120);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(anon_sym_uint128);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(anon_sym_uint136);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(anon_sym_uint144);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(anon_sym_uint152);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(anon_sym_uint160);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(anon_sym_uint168);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(anon_sym_uint176);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(anon_sym_uint184);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(anon_sym_uint192);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(anon_sym_uint200);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(anon_sym_uint208);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(anon_sym_uint216);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(anon_sym_uint224);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(anon_sym_uint232);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(anon_sym_uint240);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(anon_sym_uint248);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(anon_sym_uint256);
      END_STATE();
    case 696:
      if (lookahead == 'e') ADVANCE(737);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(anon_sym_unicode);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(sym_virtual);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 700:
      if (lookahead == 's') ADVANCE(738);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(anon_sym_blobhash);
      END_STATE();
    case 703:
      if (lookahead == 'h') ADVANCE(739);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(anon_sym_callcode);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(anon_sym_calldata);
      if (lookahead == 'c') ADVANCE(740);
      if (lookahead == 'l') ADVANCE(741);
      if (lookahead == 's') ADVANCE(742);
      END_STATE();
    case 706:
      if (lookahead == 'e') ADVANCE(743);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(anon_sym_coinbase);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(anon_sym_constant);
      END_STATE();
    case 709:
      if (lookahead == 't') ADVANCE(744);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(anon_sym_contract);
      END_STATE();
    case 712:
      if (lookahead == 'c') ADVANCE(745);
      END_STATE();
    case 713:
      if (lookahead == 't') ADVANCE(746);
      END_STATE();
    case 714:
      if (lookahead == 'o') ADVANCE(747);
      END_STATE();
    case 715:
      if (lookahead == 'a') ADVANCE(748);
      END_STATE();
    case 716:
      if (lookahead == 'i') ADVANCE(749);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(anon_sym_external);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(anon_sym_fallback);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(aux_sym__fixed_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(719);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(anon_sym_gaslimit);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(anon_sym_gasprice);
      END_STATE();
    case 723:
      if (lookahead == 'e') ADVANCE(750);
      END_STATE();
    case 724:
      if (lookahead == 'e') ADVANCE(751);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 726:
      if (lookahead == '6') ADVANCE(752);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(anon_sym_modifier);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 729:
      if (lookahead == 't') ADVANCE(753);
      END_STATE();
    case 730:
      if (lookahead == 'n') ADVANCE(754);
      END_STATE();
    case 731:
      if (lookahead == 'r') ADVANCE(755);
      END_STATE();
    case 732:
      if (lookahead == 'n') ADVANCE(756);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(anon_sym_solidity);
      END_STATE();
    case 734:
      if (lookahead == 'l') ADVANCE(757);
      END_STATE();
    case 735:
      if (lookahead == 'p') ADVANCE(758);
      END_STATE();
    case 736:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(759);
      END_STATE();
    case 737:
      if (lookahead == 'd') ADVANCE(760);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(anon_sym_anonymous);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(anon_sym_blockhash);
      END_STATE();
    case 740:
      if (lookahead == 'o') ADVANCE(761);
      END_STATE();
    case 741:
      if (lookahead == 'o') ADVANCE(762);
      END_STATE();
    case 742:
      if (lookahead == 'i') ADVANCE(763);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(anon_sym_callvalue);
      END_STATE();
    case 744:
      if (lookahead == 'o') ADVANCE(764);
      END_STATE();
    case 745:
      if (lookahead == 'a') ADVANCE(765);
      END_STATE();
    case 746:
      if (lookahead == 'y') ADVANCE(766);
      END_STATE();
    case 747:
      if (lookahead == 'p') ADVANCE(767);
      END_STATE();
    case 748:
      if (lookahead == 's') ADVANCE(768);
      END_STATE();
    case 749:
      if (lookahead == 'z') ADVANCE(769);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(sym_immutable);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(anon_sym_keccak256);
      END_STATE();
    case 753:
      if (lookahead == 'a') ADVANCE(770);
      END_STATE();
    case 754:
      if (lookahead == 'c') ADVANCE(771);
      END_STATE();
    case 755:
      if (lookahead == 'u') ADVANCE(772);
      END_STATE();
    case 756:
      if (lookahead == 'd') ADVANCE(773);
      END_STATE();
    case 757:
      if (lookahead == 'l') ADVANCE(774);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(anon_sym_timestamp);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(aux_sym__ufixed_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(759);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(sym_unchecked);
      END_STATE();
    case 761:
      if (lookahead == 'p') ADVANCE(775);
      END_STATE();
    case 762:
      if (lookahead == 'a') ADVANCE(776);
      END_STATE();
    case 763:
      if (lookahead == 'z') ADVANCE(777);
      END_STATE();
    case 764:
      if (lookahead == 'r') ADVANCE(778);
      END_STATE();
    case 765:
      if (lookahead == 'l') ADVANCE(779);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(anon_sym_difficulty);
      END_STATE();
    case 767:
      if (lookahead == 'y') ADVANCE(780);
      END_STATE();
    case 768:
      if (lookahead == 'h') ADVANCE(781);
      END_STATE();
    case 769:
      if (lookahead == 'e') ADVANCE(782);
      END_STATE();
    case 770:
      if (lookahead == 'c') ADVANCE(783);
      if (lookahead == 's') ADVANCE(784);
      END_STATE();
    case 771:
      if (lookahead == 'e') ADVANCE(785);
      END_STATE();
    case 772:
      if (lookahead == 'c') ADVANCE(786);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(anon_sym_signextend);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(anon_sym_staticcall);
      END_STATE();
    case 775:
      if (lookahead == 'y') ADVANCE(787);
      END_STATE();
    case 776:
      if (lookahead == 'd') ADVANCE(788);
      END_STATE();
    case 777:
      if (lookahead == 'e') ADVANCE(789);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(anon_sym_constructor);
      END_STATE();
    case 779:
      if (lookahead == 'l') ADVANCE(790);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(anon_sym_extcodecopy);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(anon_sym_extcodehash);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(anon_sym_extcodesize);
      END_STATE();
    case 783:
      if (lookahead == 'o') ADVANCE(791);
      END_STATE();
    case 784:
      if (lookahead == 'i') ADVANCE(792);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(anon_sym_selfbalance);
      END_STATE();
    case 786:
      if (lookahead == 't') ADVANCE(793);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(anon_sym_calldatacopy);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(anon_sym_calldataload);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(anon_sym_calldatasize);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(anon_sym_delegatecall);
      END_STATE();
    case 791:
      if (lookahead == 'p') ADVANCE(794);
      END_STATE();
    case 792:
      if (lookahead == 'z') ADVANCE(795);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(anon_sym_selfdestruct);
      END_STATE();
    case 794:
      if (lookahead == 'y') ADVANCE(796);
      END_STATE();
    case 795:
      if (lookahead == 'e') ADVANCE(797);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(anon_sym_returndatacopy);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(anon_sym_returndatasize);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 50},
  [2] = {.lex_state = 11},
  [3] = {.lex_state = 11},
  [4] = {.lex_state = 11},
  [5] = {.lex_state = 11},
  [6] = {.lex_state = 11},
  [7] = {.lex_state = 11},
  [8] = {.lex_state = 11},
  [9] = {.lex_state = 11},
  [10] = {.lex_state = 11},
  [11] = {.lex_state = 11},
  [12] = {.lex_state = 11},
  [13] = {.lex_state = 11},
  [14] = {.lex_state = 11},
  [15] = {.lex_state = 11},
  [16] = {.lex_state = 11},
  [17] = {.lex_state = 11},
  [18] = {.lex_state = 11},
  [19] = {.lex_state = 11},
  [20] = {.lex_state = 11},
  [21] = {.lex_state = 11},
  [22] = {.lex_state = 11},
  [23] = {.lex_state = 11},
  [24] = {.lex_state = 11},
  [25] = {.lex_state = 11},
  [26] = {.lex_state = 11},
  [27] = {.lex_state = 11},
  [28] = {.lex_state = 11},
  [29] = {.lex_state = 11},
  [30] = {.lex_state = 11},
  [31] = {.lex_state = 11},
  [32] = {.lex_state = 11},
  [33] = {.lex_state = 11},
  [34] = {.lex_state = 11},
  [35] = {.lex_state = 11},
  [36] = {.lex_state = 11},
  [37] = {.lex_state = 11},
  [38] = {.lex_state = 11},
  [39] = {.lex_state = 11},
  [40] = {.lex_state = 11},
  [41] = {.lex_state = 11},
  [42] = {.lex_state = 11},
  [43] = {.lex_state = 11},
  [44] = {.lex_state = 11},
  [45] = {.lex_state = 11},
  [46] = {.lex_state = 11},
  [47] = {.lex_state = 11},
  [48] = {.lex_state = 11},
  [49] = {.lex_state = 11},
  [50] = {.lex_state = 11},
  [51] = {.lex_state = 11},
  [52] = {.lex_state = 11},
  [53] = {.lex_state = 11},
  [54] = {.lex_state = 11},
  [55] = {.lex_state = 11},
  [56] = {.lex_state = 11},
  [57] = {.lex_state = 11},
  [58] = {.lex_state = 11},
  [59] = {.lex_state = 11},
  [60] = {.lex_state = 11},
  [61] = {.lex_state = 11},
  [62] = {.lex_state = 11},
  [63] = {.lex_state = 11},
  [64] = {.lex_state = 11},
  [65] = {.lex_state = 11},
  [66] = {.lex_state = 11},
  [67] = {.lex_state = 11},
  [68] = {.lex_state = 50},
  [69] = {.lex_state = 50},
  [70] = {.lex_state = 11},
  [71] = {.lex_state = 11},
  [72] = {.lex_state = 11},
  [73] = {.lex_state = 11},
  [74] = {.lex_state = 11},
  [75] = {.lex_state = 11},
  [76] = {.lex_state = 11},
  [77] = {.lex_state = 11},
  [78] = {.lex_state = 11},
  [79] = {.lex_state = 11},
  [80] = {.lex_state = 11},
  [81] = {.lex_state = 11},
  [82] = {.lex_state = 11},
  [83] = {.lex_state = 11},
  [84] = {.lex_state = 11},
  [85] = {.lex_state = 11},
  [86] = {.lex_state = 11},
  [87] = {.lex_state = 11},
  [88] = {.lex_state = 11},
  [89] = {.lex_state = 11},
  [90] = {.lex_state = 11},
  [91] = {.lex_state = 11},
  [92] = {.lex_state = 11},
  [93] = {.lex_state = 11},
  [94] = {.lex_state = 11},
  [95] = {.lex_state = 11},
  [96] = {.lex_state = 11},
  [97] = {.lex_state = 50},
  [98] = {.lex_state = 11},
  [99] = {.lex_state = 50},
  [100] = {.lex_state = 11},
  [101] = {.lex_state = 11},
  [102] = {.lex_state = 11},
  [103] = {.lex_state = 11},
  [104] = {.lex_state = 50},
  [105] = {.lex_state = 50},
  [106] = {.lex_state = 50},
  [107] = {.lex_state = 50},
  [108] = {.lex_state = 50},
  [109] = {.lex_state = 50},
  [110] = {.lex_state = 50},
  [111] = {.lex_state = 50},
  [112] = {.lex_state = 50},
  [113] = {.lex_state = 50},
  [114] = {.lex_state = 50},
  [115] = {.lex_state = 50},
  [116] = {.lex_state = 50},
  [117] = {.lex_state = 50},
  [118] = {.lex_state = 50},
  [119] = {.lex_state = 50},
  [120] = {.lex_state = 50},
  [121] = {.lex_state = 50},
  [122] = {.lex_state = 50},
  [123] = {.lex_state = 50},
  [124] = {.lex_state = 50},
  [125] = {.lex_state = 50},
  [126] = {.lex_state = 50},
  [127] = {.lex_state = 50},
  [128] = {.lex_state = 50},
  [129] = {.lex_state = 50},
  [130] = {.lex_state = 50},
  [131] = {.lex_state = 50},
  [132] = {.lex_state = 50},
  [133] = {.lex_state = 50},
  [134] = {.lex_state = 50},
  [135] = {.lex_state = 50},
  [136] = {.lex_state = 50},
  [137] = {.lex_state = 50},
  [138] = {.lex_state = 50},
  [139] = {.lex_state = 50},
  [140] = {.lex_state = 50},
  [141] = {.lex_state = 50},
  [142] = {.lex_state = 50},
  [143] = {.lex_state = 50},
  [144] = {.lex_state = 50},
  [145] = {.lex_state = 50},
  [146] = {.lex_state = 50},
  [147] = {.lex_state = 50},
  [148] = {.lex_state = 50},
  [149] = {.lex_state = 50},
  [150] = {.lex_state = 50},
  [151] = {.lex_state = 50},
  [152] = {.lex_state = 50},
  [153] = {.lex_state = 50},
  [154] = {.lex_state = 50},
  [155] = {.lex_state = 50},
  [156] = {.lex_state = 50},
  [157] = {.lex_state = 50},
  [158] = {.lex_state = 50},
  [159] = {.lex_state = 50},
  [160] = {.lex_state = 50},
  [161] = {.lex_state = 50},
  [162] = {.lex_state = 50},
  [163] = {.lex_state = 50},
  [164] = {.lex_state = 50},
  [165] = {.lex_state = 50},
  [166] = {.lex_state = 50},
  [167] = {.lex_state = 50},
  [168] = {.lex_state = 50},
  [169] = {.lex_state = 50},
  [170] = {.lex_state = 50},
  [171] = {.lex_state = 50},
  [172] = {.lex_state = 50},
  [173] = {.lex_state = 50},
  [174] = {.lex_state = 50},
  [175] = {.lex_state = 50},
  [176] = {.lex_state = 50},
  [177] = {.lex_state = 50},
  [178] = {.lex_state = 50},
  [179] = {.lex_state = 50},
  [180] = {.lex_state = 50},
  [181] = {.lex_state = 50},
  [182] = {.lex_state = 50},
  [183] = {.lex_state = 50},
  [184] = {.lex_state = 50},
  [185] = {.lex_state = 50},
  [186] = {.lex_state = 50},
  [187] = {.lex_state = 50},
  [188] = {.lex_state = 50},
  [189] = {.lex_state = 50},
  [190] = {.lex_state = 50},
  [191] = {.lex_state = 50},
  [192] = {.lex_state = 50},
  [193] = {.lex_state = 50},
  [194] = {.lex_state = 50},
  [195] = {.lex_state = 50},
  [196] = {.lex_state = 50},
  [197] = {.lex_state = 50},
  [198] = {.lex_state = 50},
  [199] = {.lex_state = 50},
  [200] = {.lex_state = 50},
  [201] = {.lex_state = 50},
  [202] = {.lex_state = 50},
  [203] = {.lex_state = 50},
  [204] = {.lex_state = 50},
  [205] = {.lex_state = 50},
  [206] = {.lex_state = 50},
  [207] = {.lex_state = 50},
  [208] = {.lex_state = 50},
  [209] = {.lex_state = 50},
  [210] = {.lex_state = 50},
  [211] = {.lex_state = 50},
  [212] = {.lex_state = 50},
  [213] = {.lex_state = 50},
  [214] = {.lex_state = 50},
  [215] = {.lex_state = 50},
  [216] = {.lex_state = 50},
  [217] = {.lex_state = 50},
  [218] = {.lex_state = 50},
  [219] = {.lex_state = 50},
  [220] = {.lex_state = 50},
  [221] = {.lex_state = 50},
  [222] = {.lex_state = 50},
  [223] = {.lex_state = 50},
  [224] = {.lex_state = 50},
  [225] = {.lex_state = 50},
  [226] = {.lex_state = 50},
  [227] = {.lex_state = 50},
  [228] = {.lex_state = 50},
  [229] = {.lex_state = 50},
  [230] = {.lex_state = 50},
  [231] = {.lex_state = 50},
  [232] = {.lex_state = 50},
  [233] = {.lex_state = 50},
  [234] = {.lex_state = 50},
  [235] = {.lex_state = 50},
  [236] = {.lex_state = 50},
  [237] = {.lex_state = 50},
  [238] = {.lex_state = 50},
  [239] = {.lex_state = 50},
  [240] = {.lex_state = 50},
  [241] = {.lex_state = 50},
  [242] = {.lex_state = 50},
  [243] = {.lex_state = 50},
  [244] = {.lex_state = 50},
  [245] = {.lex_state = 50},
  [246] = {.lex_state = 50},
  [247] = {.lex_state = 50},
  [248] = {.lex_state = 50},
  [249] = {.lex_state = 50},
  [250] = {.lex_state = 50},
  [251] = {.lex_state = 50},
  [252] = {.lex_state = 50},
  [253] = {.lex_state = 50},
  [254] = {.lex_state = 50},
  [255] = {.lex_state = 50},
  [256] = {.lex_state = 50},
  [257] = {.lex_state = 50},
  [258] = {.lex_state = 50},
  [259] = {.lex_state = 50},
  [260] = {.lex_state = 50},
  [261] = {.lex_state = 50},
  [262] = {.lex_state = 50},
  [263] = {.lex_state = 50},
  [264] = {.lex_state = 50},
  [265] = {.lex_state = 50},
  [266] = {.lex_state = 50},
  [267] = {.lex_state = 50},
  [268] = {.lex_state = 50},
  [269] = {.lex_state = 50},
  [270] = {.lex_state = 50},
  [271] = {.lex_state = 50},
  [272] = {.lex_state = 50},
  [273] = {.lex_state = 50},
  [274] = {.lex_state = 50},
  [275] = {.lex_state = 50},
  [276] = {.lex_state = 50},
  [277] = {.lex_state = 50},
  [278] = {.lex_state = 50},
  [279] = {.lex_state = 50},
  [280] = {.lex_state = 50},
  [281] = {.lex_state = 50},
  [282] = {.lex_state = 50},
  [283] = {.lex_state = 50},
  [284] = {.lex_state = 50},
  [285] = {.lex_state = 50},
  [286] = {.lex_state = 50},
  [287] = {.lex_state = 50},
  [288] = {.lex_state = 50},
  [289] = {.lex_state = 50},
  [290] = {.lex_state = 50},
  [291] = {.lex_state = 50},
  [292] = {.lex_state = 50},
  [293] = {.lex_state = 50},
  [294] = {.lex_state = 50},
  [295] = {.lex_state = 50},
  [296] = {.lex_state = 50},
  [297] = {.lex_state = 50},
  [298] = {.lex_state = 50},
  [299] = {.lex_state = 50},
  [300] = {.lex_state = 50},
  [301] = {.lex_state = 50},
  [302] = {.lex_state = 50},
  [303] = {.lex_state = 50},
  [304] = {.lex_state = 50},
  [305] = {.lex_state = 50},
  [306] = {.lex_state = 9},
  [307] = {.lex_state = 10},
  [308] = {.lex_state = 10},
  [309] = {.lex_state = 9},
  [310] = {.lex_state = 9},
  [311] = {.lex_state = 9},
  [312] = {.lex_state = 9},
  [313] = {.lex_state = 9},
  [314] = {.lex_state = 9},
  [315] = {.lex_state = 9},
  [316] = {.lex_state = 9},
  [317] = {.lex_state = 10},
  [318] = {.lex_state = 10},
  [319] = {.lex_state = 10},
  [320] = {.lex_state = 10},
  [321] = {.lex_state = 9},
  [322] = {.lex_state = 9},
  [323] = {.lex_state = 9},
  [324] = {.lex_state = 9},
  [325] = {.lex_state = 9},
  [326] = {.lex_state = 9},
  [327] = {.lex_state = 9},
  [328] = {.lex_state = 9},
  [329] = {.lex_state = 9},
  [330] = {.lex_state = 9},
  [331] = {.lex_state = 9},
  [332] = {.lex_state = 9},
  [333] = {.lex_state = 9},
  [334] = {.lex_state = 9},
  [335] = {.lex_state = 9},
  [336] = {.lex_state = 9},
  [337] = {.lex_state = 9},
  [338] = {.lex_state = 9},
  [339] = {.lex_state = 9},
  [340] = {.lex_state = 9},
  [341] = {.lex_state = 9},
  [342] = {.lex_state = 9},
  [343] = {.lex_state = 9},
  [344] = {.lex_state = 9},
  [345] = {.lex_state = 9},
  [346] = {.lex_state = 9},
  [347] = {.lex_state = 9},
  [348] = {.lex_state = 9},
  [349] = {.lex_state = 9},
  [350] = {.lex_state = 9},
  [351] = {.lex_state = 9},
  [352] = {.lex_state = 9},
  [353] = {.lex_state = 9},
  [354] = {.lex_state = 9},
  [355] = {.lex_state = 9},
  [356] = {.lex_state = 9},
  [357] = {.lex_state = 9},
  [358] = {.lex_state = 9},
  [359] = {.lex_state = 9},
  [360] = {.lex_state = 9},
  [361] = {.lex_state = 9},
  [362] = {.lex_state = 9},
  [363] = {.lex_state = 9},
  [364] = {.lex_state = 9},
  [365] = {.lex_state = 9},
  [366] = {.lex_state = 9},
  [367] = {.lex_state = 9},
  [368] = {.lex_state = 9},
  [369] = {.lex_state = 9},
  [370] = {.lex_state = 9},
  [371] = {.lex_state = 9},
  [372] = {.lex_state = 9},
  [373] = {.lex_state = 9},
  [374] = {.lex_state = 9},
  [375] = {.lex_state = 9},
  [376] = {.lex_state = 9},
  [377] = {.lex_state = 9},
  [378] = {.lex_state = 9},
  [379] = {.lex_state = 9},
  [380] = {.lex_state = 9},
  [381] = {.lex_state = 9},
  [382] = {.lex_state = 9},
  [383] = {.lex_state = 9},
  [384] = {.lex_state = 9},
  [385] = {.lex_state = 9},
  [386] = {.lex_state = 9},
  [387] = {.lex_state = 9},
  [388] = {.lex_state = 9},
  [389] = {.lex_state = 9},
  [390] = {.lex_state = 9},
  [391] = {.lex_state = 9},
  [392] = {.lex_state = 9},
  [393] = {.lex_state = 9},
  [394] = {.lex_state = 9},
  [395] = {.lex_state = 9},
  [396] = {.lex_state = 9},
  [397] = {.lex_state = 9},
  [398] = {.lex_state = 9},
  [399] = {.lex_state = 9},
  [400] = {.lex_state = 50},
  [401] = {.lex_state = 9},
  [402] = {.lex_state = 9},
  [403] = {.lex_state = 9},
  [404] = {.lex_state = 9},
  [405] = {.lex_state = 50},
  [406] = {.lex_state = 9},
  [407] = {.lex_state = 50},
  [408] = {.lex_state = 50},
  [409] = {.lex_state = 50},
  [410] = {.lex_state = 50},
  [411] = {.lex_state = 50},
  [412] = {.lex_state = 50},
  [413] = {.lex_state = 50},
  [414] = {.lex_state = 50},
  [415] = {.lex_state = 50},
  [416] = {.lex_state = 50},
  [417] = {.lex_state = 9},
  [418] = {.lex_state = 50},
  [419] = {.lex_state = 50},
  [420] = {.lex_state = 50},
  [421] = {.lex_state = 50},
  [422] = {.lex_state = 9},
  [423] = {.lex_state = 50},
  [424] = {.lex_state = 50},
  [425] = {.lex_state = 50},
  [426] = {.lex_state = 50},
  [427] = {.lex_state = 50},
  [428] = {.lex_state = 50},
  [429] = {.lex_state = 50},
  [430] = {.lex_state = 50},
  [431] = {.lex_state = 50},
  [432] = {.lex_state = 50},
  [433] = {.lex_state = 50},
  [434] = {.lex_state = 50},
  [435] = {.lex_state = 50},
  [436] = {.lex_state = 50},
  [437] = {.lex_state = 50},
  [438] = {.lex_state = 50},
  [439] = {.lex_state = 50},
  [440] = {.lex_state = 16},
  [441] = {.lex_state = 16},
  [442] = {.lex_state = 50},
  [443] = {.lex_state = 50},
  [444] = {.lex_state = 50},
  [445] = {.lex_state = 50},
  [446] = {.lex_state = 50},
  [447] = {.lex_state = 50},
  [448] = {.lex_state = 50},
  [449] = {.lex_state = 50},
  [450] = {.lex_state = 50},
  [451] = {.lex_state = 50},
  [452] = {.lex_state = 50},
  [453] = {.lex_state = 50},
  [454] = {.lex_state = 50},
  [455] = {.lex_state = 50},
  [456] = {.lex_state = 50},
  [457] = {.lex_state = 50},
  [458] = {.lex_state = 5},
  [459] = {.lex_state = 5},
  [460] = {.lex_state = 50},
  [461] = {.lex_state = 5},
  [462] = {.lex_state = 5},
  [463] = {.lex_state = 5},
  [464] = {.lex_state = 50},
  [465] = {.lex_state = 50},
  [466] = {.lex_state = 50},
  [467] = {.lex_state = 50},
  [468] = {.lex_state = 50},
  [469] = {.lex_state = 50},
  [470] = {.lex_state = 50},
  [471] = {.lex_state = 5},
  [472] = {.lex_state = 50},
  [473] = {.lex_state = 50},
  [474] = {.lex_state = 50},
  [475] = {.lex_state = 50},
  [476] = {.lex_state = 50},
  [477] = {.lex_state = 50},
  [478] = {.lex_state = 50},
  [479] = {.lex_state = 50},
  [480] = {.lex_state = 50},
  [481] = {.lex_state = 1},
  [482] = {.lex_state = 50},
  [483] = {.lex_state = 12},
  [484] = {.lex_state = 1},
  [485] = {.lex_state = 3},
  [486] = {.lex_state = 3},
  [487] = {.lex_state = 50},
  [488] = {.lex_state = 1},
  [489] = {.lex_state = 1},
  [490] = {.lex_state = 3},
  [491] = {.lex_state = 1},
  [492] = {.lex_state = 3},
  [493] = {.lex_state = 50},
  [494] = {.lex_state = 50},
  [495] = {.lex_state = 3},
  [496] = {.lex_state = 50},
  [497] = {.lex_state = 0},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 50},
  [500] = {.lex_state = 50},
  [501] = {.lex_state = 50},
  [502] = {.lex_state = 1},
  [503] = {.lex_state = 3},
  [504] = {.lex_state = 50},
  [505] = {.lex_state = 12},
  [506] = {.lex_state = 12},
  [507] = {.lex_state = 50},
  [508] = {.lex_state = 0},
  [509] = {.lex_state = 1},
  [510] = {.lex_state = 50},
  [511] = {.lex_state = 0},
  [512] = {.lex_state = 0},
  [513] = {.lex_state = 0},
  [514] = {.lex_state = 50},
  [515] = {.lex_state = 50},
  [516] = {.lex_state = 50},
  [517] = {.lex_state = 0},
  [518] = {.lex_state = 50},
  [519] = {.lex_state = 50},
  [520] = {.lex_state = 50},
  [521] = {.lex_state = 0},
  [522] = {.lex_state = 50},
  [523] = {.lex_state = 50},
  [524] = {.lex_state = 0},
  [525] = {.lex_state = 50},
  [526] = {.lex_state = 50},
  [527] = {.lex_state = 0},
  [528] = {.lex_state = 50},
  [529] = {.lex_state = 10},
  [530] = {.lex_state = 0},
  [531] = {.lex_state = 50},
  [532] = {.lex_state = 0},
  [533] = {.lex_state = 12},
  [534] = {.lex_state = 1},
  [535] = {.lex_state = 3},
  [536] = {.lex_state = 3},
  [537] = {.lex_state = 12},
  [538] = {.lex_state = 12},
  [539] = {.lex_state = 0},
  [540] = {.lex_state = 50},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 50},
  [543] = {.lex_state = 0},
  [544] = {.lex_state = 0},
  [545] = {.lex_state = 0},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 50},
  [550] = {.lex_state = 0},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 0},
  [554] = {.lex_state = 0},
  [555] = {.lex_state = 0},
  [556] = {.lex_state = 50},
  [557] = {.lex_state = 50},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 50},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 50},
  [563] = {.lex_state = 0},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 50},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 50},
  [571] = {.lex_state = 50},
  [572] = {.lex_state = 50},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 50},
  [581] = {.lex_state = 16},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 50},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 50},
  [586] = {.lex_state = 16},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 16},
  [590] = {.lex_state = 50},
  [591] = {.lex_state = 50},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 50},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 50},
  [597] = {.lex_state = 50},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 50},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 50},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 50},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 50},
  [607] = {.lex_state = 50},
  [608] = {.lex_state = 50},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 50},
  [612] = {.lex_state = 50},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 50},
  [615] = {.lex_state = 50},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 50},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 50},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 16},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 50},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 50},
  [632] = {.lex_state = 50},
  [633] = {.lex_state = 50},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 0},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 50},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 50},
  [644] = {.lex_state = 50},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 50},
  [649] = {.lex_state = 50},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 50},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 50},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 22},
  [666] = {.lex_state = 50},
  [667] = {.lex_state = 50},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 50},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 50},
  [677] = {.lex_state = 50},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 50},
  [681] = {.lex_state = 50},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 50},
  [685] = {.lex_state = 50},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 50},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 50},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 50},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
  [705] = {.lex_state = 50},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 12},
  [708] = {.lex_state = 12},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 50},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 0},
  [716] = {.lex_state = 50},
  [717] = {.lex_state = 50},
  [718] = {.lex_state = 50},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 50},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 50},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 50},
  [729] = {.lex_state = 50},
  [730] = {.lex_state = 50},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 50},
  [733] = {.lex_state = 50},
  [734] = {.lex_state = 16},
  [735] = {.lex_state = 0},
  [736] = {.lex_state = 0},
  [737] = {.lex_state = 0},
  [738] = {.lex_state = 50},
  [739] = {.lex_state = 50},
  [740] = {.lex_state = 12},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 0},
  [743] = {.lex_state = 50},
  [744] = {.lex_state = 50},
  [745] = {.lex_state = 50},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 50},
  [750] = {.lex_state = 50},
  [751] = {.lex_state = 50},
  [752] = {.lex_state = 0},
  [753] = {.lex_state = 0},
  [754] = {.lex_state = 50},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 50},
  [758] = {.lex_state = 0},
  [759] = {.lex_state = 0},
  [760] = {.lex_state = 0},
  [761] = {.lex_state = 50},
  [762] = {.lex_state = 0},
  [763] = {.lex_state = 50},
  [764] = {.lex_state = 50},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 50},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0},
  [769] = {.lex_state = 50},
  [770] = {.lex_state = 5},
  [771] = {.lex_state = 50},
  [772] = {.lex_state = 50},
  [773] = {.lex_state = 50},
  [774] = {.lex_state = 50},
  [775] = {.lex_state = 0},
  [776] = {.lex_state = 50},
  [777] = {.lex_state = 50},
  [778] = {.lex_state = 11},
  [779] = {.lex_state = 50},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 50},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0},
  [788] = {.lex_state = 11},
  [789] = {.lex_state = 0},
  [790] = {.lex_state = 0},
  [791] = {.lex_state = 50},
  [792] = {.lex_state = 5},
  [793] = {.lex_state = 50},
  [794] = {.lex_state = 50},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 50},
  [797] = {.lex_state = 11},
  [798] = {.lex_state = 0},
  [799] = {.lex_state = 50},
  [800] = {.lex_state = 0},
  [801] = {.lex_state = 50},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 0},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 50},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 0},
  [808] = {.lex_state = 50},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 50},
  [814] = {.lex_state = 50},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 50},
  [820] = {.lex_state = 50},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 50},
  [825] = {.lex_state = 50},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 50},
  [828] = {.lex_state = 50},
  [829] = {.lex_state = 50},
  [830] = {.lex_state = 50},
  [831] = {.lex_state = 50},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 50},
  [834] = {.lex_state = 50},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_pragma] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_solidity] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_constant] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_contract] = ACTIONS(1),
    [anon_sym_error] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_library] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_anonymous] = ACTIONS(1),
    [anon_sym_indexed] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [sym_yul_leave] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [sym_yul_decimal_number] = ACTIONS(1),
    [sym_yul_hex_number] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_stop] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_sub] = ACTIONS(1),
    [anon_sym_mul] = ACTIONS(1),
    [anon_sym_div] = ACTIONS(1),
    [anon_sym_sdiv] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_smod] = ACTIONS(1),
    [anon_sym_exp] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_lt] = ACTIONS(1),
    [anon_sym_gt] = ACTIONS(1),
    [anon_sym_slt] = ACTIONS(1),
    [anon_sym_sgt] = ACTIONS(1),
    [anon_sym_eq] = ACTIONS(1),
    [anon_sym_iszero] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_xor] = ACTIONS(1),
    [anon_sym_byte] = ACTIONS(1),
    [anon_sym_shl] = ACTIONS(1),
    [anon_sym_shr] = ACTIONS(1),
    [anon_sym_sar] = ACTIONS(1),
    [anon_sym_addmod] = ACTIONS(1),
    [anon_sym_mulmod] = ACTIONS(1),
    [anon_sym_signextend] = ACTIONS(1),
    [anon_sym_keccak256] = ACTIONS(1),
    [anon_sym_pop] = ACTIONS(1),
    [anon_sym_mload] = ACTIONS(1),
    [anon_sym_mcopy] = ACTIONS(1),
    [anon_sym_tload] = ACTIONS(1),
    [anon_sym_tstore] = ACTIONS(1),
    [anon_sym_mstore] = ACTIONS(1),
    [anon_sym_mstore8] = ACTIONS(1),
    [anon_sym_sload] = ACTIONS(1),
    [anon_sym_sstore] = ACTIONS(1),
    [anon_sym_msize] = ACTIONS(1),
    [anon_sym_gas] = ACTIONS(1),
    [anon_sym_address] = ACTIONS(1),
    [anon_sym_balance] = ACTIONS(1),
    [anon_sym_selfbalance] = ACTIONS(1),
    [anon_sym_caller] = ACTIONS(1),
    [anon_sym_callvalue] = ACTIONS(1),
    [anon_sym_calldataload] = ACTIONS(1),
    [anon_sym_calldatasize] = ACTIONS(1),
    [anon_sym_calldatacopy] = ACTIONS(1),
    [anon_sym_extcodesize] = ACTIONS(1),
    [anon_sym_extcodecopy] = ACTIONS(1),
    [anon_sym_returndatasize] = ACTIONS(1),
    [anon_sym_returndatacopy] = ACTIONS(1),
    [anon_sym_extcodehash] = ACTIONS(1),
    [anon_sym_create] = ACTIONS(1),
    [anon_sym_create2] = ACTIONS(1),
    [anon_sym_call] = ACTIONS(1),
    [anon_sym_callcode] = ACTIONS(1),
    [anon_sym_delegatecall] = ACTIONS(1),
    [anon_sym_staticcall] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_revert] = ACTIONS(1),
    [anon_sym_selfdestruct] = ACTIONS(1),
    [anon_sym_invalid] = ACTIONS(1),
    [anon_sym_log0] = ACTIONS(1),
    [anon_sym_log1] = ACTIONS(1),
    [anon_sym_log2] = ACTIONS(1),
    [anon_sym_log3] = ACTIONS(1),
    [anon_sym_log4] = ACTIONS(1),
    [anon_sym_chainid] = ACTIONS(1),
    [anon_sym_origin] = ACTIONS(1),
    [anon_sym_gasprice] = ACTIONS(1),
    [anon_sym_blockhash] = ACTIONS(1),
    [anon_sym_blobhash] = ACTIONS(1),
    [anon_sym_basefee] = ACTIONS(1),
    [anon_sym_blobfee] = ACTIONS(1),
    [anon_sym_coinbase] = ACTIONS(1),
    [anon_sym_timestamp] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_difficulty] = ACTIONS(1),
    [anon_sym_gaslimit] = ACTIONS(1),
    [sym_unchecked] = ACTIONS(1),
    [anon_sym_memory] = ACTIONS(1),
    [anon_sym_storage] = ACTIONS(1),
    [anon_sym_calldata] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_returns] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_emit] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_external] = ACTIONS(1),
    [anon_sym_pure] = ACTIONS(1),
    [anon_sym_view] = ACTIONS(1),
    [anon_sym_payable] = ACTIONS(1),
    [sym_immutable] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_modifier] = ACTIONS(1),
    [anon_sym_constructor] = ACTIONS(1),
    [anon_sym_fallback] = ACTIONS(1),
    [anon_sym_receive] = ACTIONS(1),
    [sym_virtual] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_mapping] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_int8] = ACTIONS(1),
    [anon_sym_int16] = ACTIONS(1),
    [anon_sym_int24] = ACTIONS(1),
    [anon_sym_int32] = ACTIONS(1),
    [anon_sym_int40] = ACTIONS(1),
    [anon_sym_int48] = ACTIONS(1),
    [anon_sym_int56] = ACTIONS(1),
    [anon_sym_int64] = ACTIONS(1),
    [anon_sym_int72] = ACTIONS(1),
    [anon_sym_int80] = ACTIONS(1),
    [anon_sym_int88] = ACTIONS(1),
    [anon_sym_int96] = ACTIONS(1),
    [anon_sym_int104] = ACTIONS(1),
    [anon_sym_int112] = ACTIONS(1),
    [anon_sym_int120] = ACTIONS(1),
    [anon_sym_int128] = ACTIONS(1),
    [anon_sym_int136] = ACTIONS(1),
    [anon_sym_int144] = ACTIONS(1),
    [anon_sym_int152] = ACTIONS(1),
    [anon_sym_int160] = ACTIONS(1),
    [anon_sym_int168] = ACTIONS(1),
    [anon_sym_int176] = ACTIONS(1),
    [anon_sym_int184] = ACTIONS(1),
    [anon_sym_int192] = ACTIONS(1),
    [anon_sym_int200] = ACTIONS(1),
    [anon_sym_int208] = ACTIONS(1),
    [anon_sym_int216] = ACTIONS(1),
    [anon_sym_int224] = ACTIONS(1),
    [anon_sym_int232] = ACTIONS(1),
    [anon_sym_int240] = ACTIONS(1),
    [anon_sym_int248] = ACTIONS(1),
    [anon_sym_int256] = ACTIONS(1),
    [anon_sym_uint] = ACTIONS(1),
    [anon_sym_uint8] = ACTIONS(1),
    [anon_sym_uint16] = ACTIONS(1),
    [anon_sym_uint24] = ACTIONS(1),
    [anon_sym_uint32] = ACTIONS(1),
    [anon_sym_uint40] = ACTIONS(1),
    [anon_sym_uint48] = ACTIONS(1),
    [anon_sym_uint56] = ACTIONS(1),
    [anon_sym_uint64] = ACTIONS(1),
    [anon_sym_uint72] = ACTIONS(1),
    [anon_sym_uint80] = ACTIONS(1),
    [anon_sym_uint88] = ACTIONS(1),
    [anon_sym_uint96] = ACTIONS(1),
    [anon_sym_uint104] = ACTIONS(1),
    [anon_sym_uint112] = ACTIONS(1),
    [anon_sym_uint120] = ACTIONS(1),
    [anon_sym_uint128] = ACTIONS(1),
    [anon_sym_uint136] = ACTIONS(1),
    [anon_sym_uint144] = ACTIONS(1),
    [anon_sym_uint152] = ACTIONS(1),
    [anon_sym_uint160] = ACTIONS(1),
    [anon_sym_uint168] = ACTIONS(1),
    [anon_sym_uint176] = ACTIONS(1),
    [anon_sym_uint184] = ACTIONS(1),
    [anon_sym_uint192] = ACTIONS(1),
    [anon_sym_uint200] = ACTIONS(1),
    [anon_sym_uint208] = ACTIONS(1),
    [anon_sym_uint216] = ACTIONS(1),
    [anon_sym_uint224] = ACTIONS(1),
    [anon_sym_uint232] = ACTIONS(1),
    [anon_sym_uint240] = ACTIONS(1),
    [anon_sym_uint248] = ACTIONS(1),
    [anon_sym_uint256] = ACTIONS(1),
    [anon_sym_bytes] = ACTIONS(1),
    [anon_sym_bytes1] = ACTIONS(1),
    [anon_sym_bytes2] = ACTIONS(1),
    [anon_sym_bytes3] = ACTIONS(1),
    [anon_sym_bytes4] = ACTIONS(1),
    [anon_sym_bytes5] = ACTIONS(1),
    [anon_sym_bytes6] = ACTIONS(1),
    [anon_sym_bytes7] = ACTIONS(1),
    [anon_sym_bytes8] = ACTIONS(1),
    [anon_sym_bytes9] = ACTIONS(1),
    [anon_sym_bytes10] = ACTIONS(1),
    [anon_sym_bytes11] = ACTIONS(1),
    [anon_sym_bytes12] = ACTIONS(1),
    [anon_sym_bytes13] = ACTIONS(1),
    [anon_sym_bytes14] = ACTIONS(1),
    [anon_sym_bytes15] = ACTIONS(1),
    [anon_sym_bytes16] = ACTIONS(1),
    [anon_sym_bytes17] = ACTIONS(1),
    [anon_sym_bytes18] = ACTIONS(1),
    [anon_sym_bytes19] = ACTIONS(1),
    [anon_sym_bytes20] = ACTIONS(1),
    [anon_sym_bytes21] = ACTIONS(1),
    [anon_sym_bytes22] = ACTIONS(1),
    [anon_sym_bytes23] = ACTIONS(1),
    [anon_sym_bytes24] = ACTIONS(1),
    [anon_sym_bytes25] = ACTIONS(1),
    [anon_sym_bytes26] = ACTIONS(1),
    [anon_sym_bytes27] = ACTIONS(1),
    [anon_sym_bytes28] = ACTIONS(1),
    [anon_sym_bytes29] = ACTIONS(1),
    [anon_sym_bytes30] = ACTIONS(1),
    [anon_sym_bytes31] = ACTIONS(1),
    [anon_sym_bytes32] = ACTIONS(1),
    [anon_sym_fixed] = ACTIONS(1),
    [aux_sym__fixed_token1] = ACTIONS(1),
    [anon_sym_ufixed] = ACTIONS(1),
    [aux_sym__ufixed_token1] = ACTIONS(1),
    [sym__semicolon] = ACTIONS(1),
    [anon_sym_wei] = ACTIONS(1),
    [anon_sym_szabo] = ACTIONS(1),
    [anon_sym_finney] = ACTIONS(1),
    [anon_sym_gwei] = ACTIONS(1),
    [anon_sym_ether] = ACTIONS(1),
    [anon_sym_seconds] = ACTIONS(1),
    [anon_sym_minutes] = ACTIONS(1),
    [anon_sym_hours] = ACTIONS(1),
    [anon_sym_days] = ACTIONS(1),
    [anon_sym_weeks] = ACTIONS(1),
    [anon_sym_years] = ACTIONS(1),
    [anon_sym_hex] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym__escape_sequence] = ACTIONS(1),
    [anon_sym_unicode] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(809),
    [sym__source_unit] = STATE(69),
    [sym__directive] = STATE(69),
    [sym_pragma_directive] = STATE(69),
    [sym_import_directive] = STATE(69),
    [sym__declaration] = STATE(69),
    [sym_user_defined_type_definition] = STATE(69),
    [sym_constant_variable_declaration] = STATE(69),
    [sym_contract_declaration] = STATE(69),
    [sym_error_declaration] = STATE(69),
    [sym_interface_declaration] = STATE(69),
    [sym_library_declaration] = STATE(69),
    [sym_struct_declaration] = STATE(69),
    [sym_enum_declaration] = STATE(69),
    [sym_event_definition] = STATE(69),
    [sym_function_definition] = STATE(69),
    [sym_type_name] = STATE(677),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_source_file_repeat1] = STATE(69),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_pragma] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_contract] = ACTIONS(17),
    [anon_sym_error] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_library] = ACTIONS(23),
    [anon_sym_struct] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_event] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [2] = {
    [sym_statement] = STATE(4),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_struct_field_assignment] = STATE(626),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(4),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(39),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(47),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_statement] = STATE(6),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(6),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_statement] = STATE(5),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(5),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_statement] = STATE(5),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(5),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(114),
    [anon_sym_TILDE] = ACTIONS(117),
    [anon_sym_LBRACE] = ACTIONS(120),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_type] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(128),
    [anon_sym_for] = ACTIONS(131),
    [anon_sym_assembly] = ACTIONS(134),
    [anon_sym_break] = ACTIONS(137),
    [anon_sym_continue] = ACTIONS(140),
    [anon_sym_true] = ACTIONS(143),
    [anon_sym_false] = ACTIONS(146),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_function] = ACTIONS(152),
    [anon_sym_byte] = ACTIONS(155),
    [anon_sym_address] = ACTIONS(158),
    [anon_sym_return] = ACTIONS(161),
    [anon_sym_revert] = ACTIONS(164),
    [sym_unchecked] = ACTIONS(167),
    [anon_sym_var] = ACTIONS(170),
    [anon_sym_while] = ACTIONS(173),
    [anon_sym_do] = ACTIONS(176),
    [anon_sym_try] = ACTIONS(179),
    [anon_sym_emit] = ACTIONS(182),
    [anon_sym_payable] = ACTIONS(185),
    [anon_sym_new] = ACTIONS(188),
    [anon_sym_LBRACK] = ACTIONS(191),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_BANG] = ACTIONS(117),
    [anon_sym_delete] = ACTIONS(194),
    [anon_sym_PLUS_PLUS] = ACTIONS(197),
    [anon_sym_DASH_DASH] = ACTIONS(197),
    [anon_sym_mapping] = ACTIONS(200),
    [anon_sym_bool] = ACTIONS(155),
    [anon_sym_string] = ACTIONS(155),
    [anon_sym_int] = ACTIONS(155),
    [anon_sym_int8] = ACTIONS(155),
    [anon_sym_int16] = ACTIONS(155),
    [anon_sym_int24] = ACTIONS(155),
    [anon_sym_int32] = ACTIONS(155),
    [anon_sym_int40] = ACTIONS(155),
    [anon_sym_int48] = ACTIONS(155),
    [anon_sym_int56] = ACTIONS(155),
    [anon_sym_int64] = ACTIONS(155),
    [anon_sym_int72] = ACTIONS(155),
    [anon_sym_int80] = ACTIONS(155),
    [anon_sym_int88] = ACTIONS(155),
    [anon_sym_int96] = ACTIONS(155),
    [anon_sym_int104] = ACTIONS(155),
    [anon_sym_int112] = ACTIONS(155),
    [anon_sym_int120] = ACTIONS(155),
    [anon_sym_int128] = ACTIONS(155),
    [anon_sym_int136] = ACTIONS(155),
    [anon_sym_int144] = ACTIONS(155),
    [anon_sym_int152] = ACTIONS(155),
    [anon_sym_int160] = ACTIONS(155),
    [anon_sym_int168] = ACTIONS(155),
    [anon_sym_int176] = ACTIONS(155),
    [anon_sym_int184] = ACTIONS(155),
    [anon_sym_int192] = ACTIONS(155),
    [anon_sym_int200] = ACTIONS(155),
    [anon_sym_int208] = ACTIONS(155),
    [anon_sym_int216] = ACTIONS(155),
    [anon_sym_int224] = ACTIONS(155),
    [anon_sym_int232] = ACTIONS(155),
    [anon_sym_int240] = ACTIONS(155),
    [anon_sym_int248] = ACTIONS(155),
    [anon_sym_int256] = ACTIONS(155),
    [anon_sym_uint] = ACTIONS(155),
    [anon_sym_uint8] = ACTIONS(155),
    [anon_sym_uint16] = ACTIONS(155),
    [anon_sym_uint24] = ACTIONS(155),
    [anon_sym_uint32] = ACTIONS(155),
    [anon_sym_uint40] = ACTIONS(155),
    [anon_sym_uint48] = ACTIONS(155),
    [anon_sym_uint56] = ACTIONS(155),
    [anon_sym_uint64] = ACTIONS(155),
    [anon_sym_uint72] = ACTIONS(155),
    [anon_sym_uint80] = ACTIONS(155),
    [anon_sym_uint88] = ACTIONS(155),
    [anon_sym_uint96] = ACTIONS(155),
    [anon_sym_uint104] = ACTIONS(155),
    [anon_sym_uint112] = ACTIONS(155),
    [anon_sym_uint120] = ACTIONS(155),
    [anon_sym_uint128] = ACTIONS(155),
    [anon_sym_uint136] = ACTIONS(155),
    [anon_sym_uint144] = ACTIONS(155),
    [anon_sym_uint152] = ACTIONS(155),
    [anon_sym_uint160] = ACTIONS(155),
    [anon_sym_uint168] = ACTIONS(155),
    [anon_sym_uint176] = ACTIONS(155),
    [anon_sym_uint184] = ACTIONS(155),
    [anon_sym_uint192] = ACTIONS(155),
    [anon_sym_uint200] = ACTIONS(155),
    [anon_sym_uint208] = ACTIONS(155),
    [anon_sym_uint216] = ACTIONS(155),
    [anon_sym_uint224] = ACTIONS(155),
    [anon_sym_uint232] = ACTIONS(155),
    [anon_sym_uint240] = ACTIONS(155),
    [anon_sym_uint248] = ACTIONS(155),
    [anon_sym_uint256] = ACTIONS(155),
    [anon_sym_bytes] = ACTIONS(155),
    [anon_sym_bytes1] = ACTIONS(155),
    [anon_sym_bytes2] = ACTIONS(155),
    [anon_sym_bytes3] = ACTIONS(155),
    [anon_sym_bytes4] = ACTIONS(155),
    [anon_sym_bytes5] = ACTIONS(155),
    [anon_sym_bytes6] = ACTIONS(155),
    [anon_sym_bytes7] = ACTIONS(155),
    [anon_sym_bytes8] = ACTIONS(155),
    [anon_sym_bytes9] = ACTIONS(155),
    [anon_sym_bytes10] = ACTIONS(155),
    [anon_sym_bytes11] = ACTIONS(155),
    [anon_sym_bytes12] = ACTIONS(155),
    [anon_sym_bytes13] = ACTIONS(155),
    [anon_sym_bytes14] = ACTIONS(155),
    [anon_sym_bytes15] = ACTIONS(155),
    [anon_sym_bytes16] = ACTIONS(155),
    [anon_sym_bytes17] = ACTIONS(155),
    [anon_sym_bytes18] = ACTIONS(155),
    [anon_sym_bytes19] = ACTIONS(155),
    [anon_sym_bytes20] = ACTIONS(155),
    [anon_sym_bytes21] = ACTIONS(155),
    [anon_sym_bytes22] = ACTIONS(155),
    [anon_sym_bytes23] = ACTIONS(155),
    [anon_sym_bytes24] = ACTIONS(155),
    [anon_sym_bytes25] = ACTIONS(155),
    [anon_sym_bytes26] = ACTIONS(155),
    [anon_sym_bytes27] = ACTIONS(155),
    [anon_sym_bytes28] = ACTIONS(155),
    [anon_sym_bytes29] = ACTIONS(155),
    [anon_sym_bytes30] = ACTIONS(155),
    [anon_sym_bytes31] = ACTIONS(155),
    [anon_sym_bytes32] = ACTIONS(155),
    [anon_sym_fixed] = ACTIONS(155),
    [aux_sym__fixed_token1] = ACTIONS(155),
    [anon_sym_ufixed] = ACTIONS(155),
    [aux_sym__ufixed_token1] = ACTIONS(155),
    [aux_sym__decimal_number_token1] = ACTIONS(203),
    [aux_sym__decimal_number_token2] = ACTIONS(206),
    [aux_sym__hex_number_token1] = ACTIONS(206),
    [anon_sym_hex] = ACTIONS(209),
    [anon_sym_DQUOTE] = ACTIONS(212),
    [anon_sym_SQUOTE] = ACTIONS(215),
    [anon_sym_unicode] = ACTIONS(218),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_statement] = STATE(5),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(5),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(221),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [7] = {
    [sym_statement] = STATE(5),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(5),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_statement] = STATE(7),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(7),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_statement] = STATE(5),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(5),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(227),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_statement] = STATE(4),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(4),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(229),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_statement] = STATE(9),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_block_statement_repeat1] = STATE(9),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(231),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [12] = {
    [sym_statement] = STATE(91),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_statement] = STATE(828),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_statement] = STATE(101),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_statement] = STATE(100),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_statement] = STATE(84),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_statement] = STATE(94),
    [sym_assembly_statement] = STATE(95),
    [sym_block_statement] = STATE(95),
    [sym_variable_declaration_statement] = STATE(95),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(95),
    [sym_if_statement] = STATE(95),
    [sym_for_statement] = STATE(95),
    [sym_while_statement] = STATE(95),
    [sym_do_while_statement] = STATE(95),
    [sym_continue_statement] = STATE(95),
    [sym_break_statement] = STATE(95),
    [sym_revert_statement] = STATE(95),
    [sym_try_statement] = STATE(95),
    [sym_return_statement] = STATE(95),
    [sym_emit_statement] = STATE(95),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_assembly] = ACTIONS(55),
    [anon_sym_break] = ACTIONS(57),
    [anon_sym_continue] = ACTIONS(59),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_if] = ACTIONS(65),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_return] = ACTIONS(69),
    [anon_sym_revert] = ACTIONS(71),
    [sym_unchecked] = ACTIONS(73),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_try] = ACTIONS(81),
    [anon_sym_emit] = ACTIONS(83),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_variable_declaration] = STATE(641),
    [sym_expression] = STATE(410),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_variable_declaration_tuple_repeat1] = STATE(640),
    [aux_sym_tuple_expression_repeat1] = STATE(569),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(233),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_variable_declaration_statement] = STATE(29),
    [sym_variable_declaration] = STATE(725),
    [sym_variable_declaration_tuple] = STATE(763),
    [sym_expression_statement] = STATE(29),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(75),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym__semicolon] = ACTIONS(239),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_variable_declaration] = STATE(731),
    [sym_expression] = STATE(416),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(405),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(400),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(244),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_call_argument] = STATE(619),
    [sym_expression] = STATE(411),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_tuple_expression_repeat1] = STATE(569),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_COMMA] = ACTIONS(248),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(250),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_call_argument] = STATE(653),
    [sym_expression] = STATE(413),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(252),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_call_argument] = STATE(653),
    [sym_expression] = STATE(413),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_expression] = STATE(410),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_tuple_expression_repeat1] = STATE(569),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(248),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(256),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [25] = {
    [sym_call_argument] = STATE(619),
    [sym_expression] = STATE(413),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(258),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_expression] = STATE(416),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(262),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_call_argument] = STATE(653),
    [sym_expression] = STATE(413),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(246),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_expression] = STATE(416),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(264),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_expression_statement] = STATE(38),
    [sym_expression] = STATE(425),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym__semicolon] = ACTIONS(266),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_expression] = STATE(416),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(268),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym__call_arguments] = STATE(826),
    [sym_expression] = STATE(421),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(270),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym__semicolon] = ACTIONS(272),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_expression] = STATE(416),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_COMMA] = ACTIONS(260),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(260),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [33] = {
    [sym_expression] = STATE(417),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COLON] = ACTIONS(274),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(276),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_expression] = STATE(423),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(278),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_expression] = STATE(415),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(280),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_expression] = STATE(419),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym__semicolon] = ACTIONS(282),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_expression] = STATE(409),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(284),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_expression] = STATE(429),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(286),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_expression] = STATE(415),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(288),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_expression] = STATE(433),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_expression] = STATE(432),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_RBRACK] = ACTIONS(292),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_expression] = STATE(439),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_expression] = STATE(424),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_expression] = STATE(352),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_expression] = STATE(361),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_expression] = STATE(363),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_expression] = STATE(370),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_expression] = STATE(371),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_expression] = STATE(415),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [50] = {
    [sym_expression] = STATE(414),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_expression] = STATE(366),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_expression] = STATE(422),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_expression] = STATE(369),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_expression] = STATE(408),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_expression] = STATE(358),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_expression] = STATE(431),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [57] = {
    [sym_expression] = STATE(353),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_expression] = STATE(420),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_expression] = STATE(430),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_expression] = STATE(428),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_expression] = STATE(367),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_expression] = STATE(426),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_expression] = STATE(357),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_expression] = STATE(418),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_expression] = STATE(427),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_expression] = STATE(368),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_expression] = STATE(359),
    [sym__primary_expression] = STATE(394),
    [sym_type_cast_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_tuple_expression] = STATE(394),
    [sym_inline_array_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_member_expression] = STATE(394),
    [sym_array_access] = STATE(394),
    [sym_slice_access] = STATE(394),
    [sym_struct_expression] = STATE(394),
    [sym_parenthesized_expression] = STATE(394),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_payable_conversion_expression] = STATE(394),
    [sym_meta_type_expression] = STATE(394),
    [sym_user_defined_type] = STATE(394),
    [sym__identifier_path] = STATE(318),
    [sym_primitive_type] = STATE(356),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym__literal] = STATE(394),
    [sym_string_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym__decimal_number] = STATE(334),
    [sym__hex_number] = STATE(334),
    [sym_true] = STATE(392),
    [sym_false] = STATE(392),
    [sym_boolean_literal] = STATE(394),
    [sym_hex_string_literal] = STATE(394),
    [sym_unicode_string_literal] = STATE(394),
    [sym_string] = STATE(347),
    [aux_sym_string_literal_repeat1] = STATE(347),
    [aux_sym_hex_string_literal_repeat2] = STATE(349),
    [aux_sym_unicode_string_literal_repeat3] = STATE(351),
    [sym_identifier] = ACTIONS(107),
    [anon_sym_DASH] = ACTIONS(41),
    [anon_sym_TILDE] = ACTIONS(43),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_true] = ACTIONS(61),
    [anon_sym_false] = ACTIONS(63),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_payable] = ACTIONS(85),
    [anon_sym_new] = ACTIONS(87),
    [anon_sym_LBRACK] = ACTIONS(89),
    [anon_sym_PLUS] = ACTIONS(41),
    [anon_sym_BANG] = ACTIONS(43),
    [anon_sym_delete] = ACTIONS(91),
    [anon_sym_PLUS_PLUS] = ACTIONS(93),
    [anon_sym_DASH_DASH] = ACTIONS(93),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [aux_sym__decimal_number_token1] = ACTIONS(95),
    [aux_sym__decimal_number_token2] = ACTIONS(97),
    [aux_sym__hex_number_token1] = ACTIONS(97),
    [anon_sym_hex] = ACTIONS(99),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [anon_sym_unicode] = ACTIONS(105),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym__source_unit] = STATE(68),
    [sym__directive] = STATE(68),
    [sym_pragma_directive] = STATE(68),
    [sym_import_directive] = STATE(68),
    [sym__declaration] = STATE(68),
    [sym_user_defined_type_definition] = STATE(68),
    [sym_constant_variable_declaration] = STATE(68),
    [sym_contract_declaration] = STATE(68),
    [sym_error_declaration] = STATE(68),
    [sym_interface_declaration] = STATE(68),
    [sym_library_declaration] = STATE(68),
    [sym_struct_declaration] = STATE(68),
    [sym_enum_declaration] = STATE(68),
    [sym_event_definition] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_type_name] = STATE(677),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_source_file_repeat1] = STATE(68),
    [ts_builtin_sym_end] = ACTIONS(294),
    [sym_identifier] = ACTIONS(296),
    [anon_sym_pragma] = ACTIONS(299),
    [anon_sym_import] = ACTIONS(302),
    [anon_sym_type] = ACTIONS(305),
    [anon_sym_abstract] = ACTIONS(308),
    [anon_sym_contract] = ACTIONS(311),
    [anon_sym_error] = ACTIONS(314),
    [anon_sym_interface] = ACTIONS(317),
    [anon_sym_library] = ACTIONS(320),
    [anon_sym_struct] = ACTIONS(323),
    [anon_sym_enum] = ACTIONS(326),
    [anon_sym_event] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(332),
    [anon_sym_byte] = ACTIONS(335),
    [anon_sym_address] = ACTIONS(338),
    [anon_sym_var] = ACTIONS(335),
    [anon_sym_mapping] = ACTIONS(341),
    [anon_sym_bool] = ACTIONS(335),
    [anon_sym_string] = ACTIONS(335),
    [anon_sym_int] = ACTIONS(335),
    [anon_sym_int8] = ACTIONS(335),
    [anon_sym_int16] = ACTIONS(335),
    [anon_sym_int24] = ACTIONS(335),
    [anon_sym_int32] = ACTIONS(335),
    [anon_sym_int40] = ACTIONS(335),
    [anon_sym_int48] = ACTIONS(335),
    [anon_sym_int56] = ACTIONS(335),
    [anon_sym_int64] = ACTIONS(335),
    [anon_sym_int72] = ACTIONS(335),
    [anon_sym_int80] = ACTIONS(335),
    [anon_sym_int88] = ACTIONS(335),
    [anon_sym_int96] = ACTIONS(335),
    [anon_sym_int104] = ACTIONS(335),
    [anon_sym_int112] = ACTIONS(335),
    [anon_sym_int120] = ACTIONS(335),
    [anon_sym_int128] = ACTIONS(335),
    [anon_sym_int136] = ACTIONS(335),
    [anon_sym_int144] = ACTIONS(335),
    [anon_sym_int152] = ACTIONS(335),
    [anon_sym_int160] = ACTIONS(335),
    [anon_sym_int168] = ACTIONS(335),
    [anon_sym_int176] = ACTIONS(335),
    [anon_sym_int184] = ACTIONS(335),
    [anon_sym_int192] = ACTIONS(335),
    [anon_sym_int200] = ACTIONS(335),
    [anon_sym_int208] = ACTIONS(335),
    [anon_sym_int216] = ACTIONS(335),
    [anon_sym_int224] = ACTIONS(335),
    [anon_sym_int232] = ACTIONS(335),
    [anon_sym_int240] = ACTIONS(335),
    [anon_sym_int248] = ACTIONS(335),
    [anon_sym_int256] = ACTIONS(335),
    [anon_sym_uint] = ACTIONS(335),
    [anon_sym_uint8] = ACTIONS(335),
    [anon_sym_uint16] = ACTIONS(335),
    [anon_sym_uint24] = ACTIONS(335),
    [anon_sym_uint32] = ACTIONS(335),
    [anon_sym_uint40] = ACTIONS(335),
    [anon_sym_uint48] = ACTIONS(335),
    [anon_sym_uint56] = ACTIONS(335),
    [anon_sym_uint64] = ACTIONS(335),
    [anon_sym_uint72] = ACTIONS(335),
    [anon_sym_uint80] = ACTIONS(335),
    [anon_sym_uint88] = ACTIONS(335),
    [anon_sym_uint96] = ACTIONS(335),
    [anon_sym_uint104] = ACTIONS(335),
    [anon_sym_uint112] = ACTIONS(335),
    [anon_sym_uint120] = ACTIONS(335),
    [anon_sym_uint128] = ACTIONS(335),
    [anon_sym_uint136] = ACTIONS(335),
    [anon_sym_uint144] = ACTIONS(335),
    [anon_sym_uint152] = ACTIONS(335),
    [anon_sym_uint160] = ACTIONS(335),
    [anon_sym_uint168] = ACTIONS(335),
    [anon_sym_uint176] = ACTIONS(335),
    [anon_sym_uint184] = ACTIONS(335),
    [anon_sym_uint192] = ACTIONS(335),
    [anon_sym_uint200] = ACTIONS(335),
    [anon_sym_uint208] = ACTIONS(335),
    [anon_sym_uint216] = ACTIONS(335),
    [anon_sym_uint224] = ACTIONS(335),
    [anon_sym_uint232] = ACTIONS(335),
    [anon_sym_uint240] = ACTIONS(335),
    [anon_sym_uint248] = ACTIONS(335),
    [anon_sym_uint256] = ACTIONS(335),
    [anon_sym_bytes] = ACTIONS(335),
    [anon_sym_bytes1] = ACTIONS(335),
    [anon_sym_bytes2] = ACTIONS(335),
    [anon_sym_bytes3] = ACTIONS(335),
    [anon_sym_bytes4] = ACTIONS(335),
    [anon_sym_bytes5] = ACTIONS(335),
    [anon_sym_bytes6] = ACTIONS(335),
    [anon_sym_bytes7] = ACTIONS(335),
    [anon_sym_bytes8] = ACTIONS(335),
    [anon_sym_bytes9] = ACTIONS(335),
    [anon_sym_bytes10] = ACTIONS(335),
    [anon_sym_bytes11] = ACTIONS(335),
    [anon_sym_bytes12] = ACTIONS(335),
    [anon_sym_bytes13] = ACTIONS(335),
    [anon_sym_bytes14] = ACTIONS(335),
    [anon_sym_bytes15] = ACTIONS(335),
    [anon_sym_bytes16] = ACTIONS(335),
    [anon_sym_bytes17] = ACTIONS(335),
    [anon_sym_bytes18] = ACTIONS(335),
    [anon_sym_bytes19] = ACTIONS(335),
    [anon_sym_bytes20] = ACTIONS(335),
    [anon_sym_bytes21] = ACTIONS(335),
    [anon_sym_bytes22] = ACTIONS(335),
    [anon_sym_bytes23] = ACTIONS(335),
    [anon_sym_bytes24] = ACTIONS(335),
    [anon_sym_bytes25] = ACTIONS(335),
    [anon_sym_bytes26] = ACTIONS(335),
    [anon_sym_bytes27] = ACTIONS(335),
    [anon_sym_bytes28] = ACTIONS(335),
    [anon_sym_bytes29] = ACTIONS(335),
    [anon_sym_bytes30] = ACTIONS(335),
    [anon_sym_bytes31] = ACTIONS(335),
    [anon_sym_bytes32] = ACTIONS(335),
    [anon_sym_fixed] = ACTIONS(335),
    [aux_sym__fixed_token1] = ACTIONS(335),
    [anon_sym_ufixed] = ACTIONS(335),
    [aux_sym__ufixed_token1] = ACTIONS(335),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym__source_unit] = STATE(68),
    [sym__directive] = STATE(68),
    [sym_pragma_directive] = STATE(68),
    [sym_import_directive] = STATE(68),
    [sym__declaration] = STATE(68),
    [sym_user_defined_type_definition] = STATE(68),
    [sym_constant_variable_declaration] = STATE(68),
    [sym_contract_declaration] = STATE(68),
    [sym_error_declaration] = STATE(68),
    [sym_interface_declaration] = STATE(68),
    [sym_library_declaration] = STATE(68),
    [sym_struct_declaration] = STATE(68),
    [sym_enum_declaration] = STATE(68),
    [sym_event_definition] = STATE(68),
    [sym_function_definition] = STATE(68),
    [sym_type_name] = STATE(677),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_source_file_repeat1] = STATE(68),
    [ts_builtin_sym_end] = ACTIONS(344),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_pragma] = ACTIONS(9),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_contract] = ACTIONS(17),
    [anon_sym_error] = ACTIONS(19),
    [anon_sym_interface] = ACTIONS(21),
    [anon_sym_library] = ACTIONS(23),
    [anon_sym_struct] = ACTIONS(25),
    [anon_sym_enum] = ACTIONS(27),
    [anon_sym_event] = ACTIONS(29),
    [anon_sym_function] = ACTIONS(31),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_catch_clause] = STATE(71),
    [aux_sym_try_statement_repeat1] = STATE(71),
    [sym_identifier] = ACTIONS(346),
    [anon_sym_DASH] = ACTIONS(346),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_LBRACE] = ACTIONS(348),
    [anon_sym_RBRACE] = ACTIONS(348),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_LPAREN] = ACTIONS(348),
    [anon_sym_for] = ACTIONS(346),
    [anon_sym_assembly] = ACTIONS(346),
    [anon_sym_break] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(346),
    [anon_sym_true] = ACTIONS(346),
    [anon_sym_false] = ACTIONS(346),
    [anon_sym_if] = ACTIONS(346),
    [anon_sym_function] = ACTIONS(346),
    [anon_sym_byte] = ACTIONS(346),
    [anon_sym_address] = ACTIONS(346),
    [anon_sym_return] = ACTIONS(346),
    [anon_sym_revert] = ACTIONS(346),
    [sym_unchecked] = ACTIONS(346),
    [anon_sym_var] = ACTIONS(346),
    [anon_sym_else] = ACTIONS(346),
    [anon_sym_while] = ACTIONS(346),
    [anon_sym_do] = ACTIONS(346),
    [anon_sym_try] = ACTIONS(346),
    [anon_sym_catch] = ACTIONS(350),
    [anon_sym_emit] = ACTIONS(346),
    [anon_sym_payable] = ACTIONS(346),
    [anon_sym_new] = ACTIONS(346),
    [anon_sym_LBRACK] = ACTIONS(348),
    [anon_sym_PLUS] = ACTIONS(346),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_delete] = ACTIONS(346),
    [anon_sym_PLUS_PLUS] = ACTIONS(348),
    [anon_sym_DASH_DASH] = ACTIONS(348),
    [anon_sym_mapping] = ACTIONS(346),
    [anon_sym_bool] = ACTIONS(346),
    [anon_sym_string] = ACTIONS(346),
    [anon_sym_int] = ACTIONS(346),
    [anon_sym_int8] = ACTIONS(346),
    [anon_sym_int16] = ACTIONS(346),
    [anon_sym_int24] = ACTIONS(346),
    [anon_sym_int32] = ACTIONS(346),
    [anon_sym_int40] = ACTIONS(346),
    [anon_sym_int48] = ACTIONS(346),
    [anon_sym_int56] = ACTIONS(346),
    [anon_sym_int64] = ACTIONS(346),
    [anon_sym_int72] = ACTIONS(346),
    [anon_sym_int80] = ACTIONS(346),
    [anon_sym_int88] = ACTIONS(346),
    [anon_sym_int96] = ACTIONS(346),
    [anon_sym_int104] = ACTIONS(346),
    [anon_sym_int112] = ACTIONS(346),
    [anon_sym_int120] = ACTIONS(346),
    [anon_sym_int128] = ACTIONS(346),
    [anon_sym_int136] = ACTIONS(346),
    [anon_sym_int144] = ACTIONS(346),
    [anon_sym_int152] = ACTIONS(346),
    [anon_sym_int160] = ACTIONS(346),
    [anon_sym_int168] = ACTIONS(346),
    [anon_sym_int176] = ACTIONS(346),
    [anon_sym_int184] = ACTIONS(346),
    [anon_sym_int192] = ACTIONS(346),
    [anon_sym_int200] = ACTIONS(346),
    [anon_sym_int208] = ACTIONS(346),
    [anon_sym_int216] = ACTIONS(346),
    [anon_sym_int224] = ACTIONS(346),
    [anon_sym_int232] = ACTIONS(346),
    [anon_sym_int240] = ACTIONS(346),
    [anon_sym_int248] = ACTIONS(346),
    [anon_sym_int256] = ACTIONS(346),
    [anon_sym_uint] = ACTIONS(346),
    [anon_sym_uint8] = ACTIONS(346),
    [anon_sym_uint16] = ACTIONS(346),
    [anon_sym_uint24] = ACTIONS(346),
    [anon_sym_uint32] = ACTIONS(346),
    [anon_sym_uint40] = ACTIONS(346),
    [anon_sym_uint48] = ACTIONS(346),
    [anon_sym_uint56] = ACTIONS(346),
    [anon_sym_uint64] = ACTIONS(346),
    [anon_sym_uint72] = ACTIONS(346),
    [anon_sym_uint80] = ACTIONS(346),
    [anon_sym_uint88] = ACTIONS(346),
    [anon_sym_uint96] = ACTIONS(346),
    [anon_sym_uint104] = ACTIONS(346),
    [anon_sym_uint112] = ACTIONS(346),
    [anon_sym_uint120] = ACTIONS(346),
    [anon_sym_uint128] = ACTIONS(346),
    [anon_sym_uint136] = ACTIONS(346),
    [anon_sym_uint144] = ACTIONS(346),
    [anon_sym_uint152] = ACTIONS(346),
    [anon_sym_uint160] = ACTIONS(346),
    [anon_sym_uint168] = ACTIONS(346),
    [anon_sym_uint176] = ACTIONS(346),
    [anon_sym_uint184] = ACTIONS(346),
    [anon_sym_uint192] = ACTIONS(346),
    [anon_sym_uint200] = ACTIONS(346),
    [anon_sym_uint208] = ACTIONS(346),
    [anon_sym_uint216] = ACTIONS(346),
    [anon_sym_uint224] = ACTIONS(346),
    [anon_sym_uint232] = ACTIONS(346),
    [anon_sym_uint240] = ACTIONS(346),
    [anon_sym_uint248] = ACTIONS(346),
    [anon_sym_uint256] = ACTIONS(346),
    [anon_sym_bytes] = ACTIONS(346),
    [anon_sym_bytes1] = ACTIONS(346),
    [anon_sym_bytes2] = ACTIONS(346),
    [anon_sym_bytes3] = ACTIONS(346),
    [anon_sym_bytes4] = ACTIONS(346),
    [anon_sym_bytes5] = ACTIONS(346),
    [anon_sym_bytes6] = ACTIONS(346),
    [anon_sym_bytes7] = ACTIONS(346),
    [anon_sym_bytes8] = ACTIONS(346),
    [anon_sym_bytes9] = ACTIONS(346),
    [anon_sym_bytes10] = ACTIONS(346),
    [anon_sym_bytes11] = ACTIONS(346),
    [anon_sym_bytes12] = ACTIONS(346),
    [anon_sym_bytes13] = ACTIONS(346),
    [anon_sym_bytes14] = ACTIONS(346),
    [anon_sym_bytes15] = ACTIONS(346),
    [anon_sym_bytes16] = ACTIONS(346),
    [anon_sym_bytes17] = ACTIONS(346),
    [anon_sym_bytes18] = ACTIONS(346),
    [anon_sym_bytes19] = ACTIONS(346),
    [anon_sym_bytes20] = ACTIONS(346),
    [anon_sym_bytes21] = ACTIONS(346),
    [anon_sym_bytes22] = ACTIONS(346),
    [anon_sym_bytes23] = ACTIONS(346),
    [anon_sym_bytes24] = ACTIONS(346),
    [anon_sym_bytes25] = ACTIONS(346),
    [anon_sym_bytes26] = ACTIONS(346),
    [anon_sym_bytes27] = ACTIONS(346),
    [anon_sym_bytes28] = ACTIONS(346),
    [anon_sym_bytes29] = ACTIONS(346),
    [anon_sym_bytes30] = ACTIONS(346),
    [anon_sym_bytes31] = ACTIONS(346),
    [anon_sym_bytes32] = ACTIONS(346),
    [anon_sym_fixed] = ACTIONS(346),
    [aux_sym__fixed_token1] = ACTIONS(346),
    [anon_sym_ufixed] = ACTIONS(346),
    [aux_sym__ufixed_token1] = ACTIONS(346),
    [aux_sym__decimal_number_token1] = ACTIONS(346),
    [aux_sym__decimal_number_token2] = ACTIONS(348),
    [aux_sym__hex_number_token1] = ACTIONS(348),
    [anon_sym_hex] = ACTIONS(346),
    [anon_sym_DQUOTE] = ACTIONS(348),
    [anon_sym_SQUOTE] = ACTIONS(348),
    [anon_sym_unicode] = ACTIONS(346),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_catch_clause] = STATE(71),
    [aux_sym_try_statement_repeat1] = STATE(71),
    [sym_identifier] = ACTIONS(352),
    [anon_sym_DASH] = ACTIONS(352),
    [anon_sym_TILDE] = ACTIONS(354),
    [anon_sym_LBRACE] = ACTIONS(354),
    [anon_sym_RBRACE] = ACTIONS(354),
    [anon_sym_type] = ACTIONS(352),
    [anon_sym_LPAREN] = ACTIONS(354),
    [anon_sym_for] = ACTIONS(352),
    [anon_sym_assembly] = ACTIONS(352),
    [anon_sym_break] = ACTIONS(352),
    [anon_sym_continue] = ACTIONS(352),
    [anon_sym_true] = ACTIONS(352),
    [anon_sym_false] = ACTIONS(352),
    [anon_sym_if] = ACTIONS(352),
    [anon_sym_function] = ACTIONS(352),
    [anon_sym_byte] = ACTIONS(352),
    [anon_sym_address] = ACTIONS(352),
    [anon_sym_return] = ACTIONS(352),
    [anon_sym_revert] = ACTIONS(352),
    [sym_unchecked] = ACTIONS(352),
    [anon_sym_var] = ACTIONS(352),
    [anon_sym_else] = ACTIONS(352),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_do] = ACTIONS(352),
    [anon_sym_try] = ACTIONS(352),
    [anon_sym_catch] = ACTIONS(356),
    [anon_sym_emit] = ACTIONS(352),
    [anon_sym_payable] = ACTIONS(352),
    [anon_sym_new] = ACTIONS(352),
    [anon_sym_LBRACK] = ACTIONS(354),
    [anon_sym_PLUS] = ACTIONS(352),
    [anon_sym_BANG] = ACTIONS(354),
    [anon_sym_delete] = ACTIONS(352),
    [anon_sym_PLUS_PLUS] = ACTIONS(354),
    [anon_sym_DASH_DASH] = ACTIONS(354),
    [anon_sym_mapping] = ACTIONS(352),
    [anon_sym_bool] = ACTIONS(352),
    [anon_sym_string] = ACTIONS(352),
    [anon_sym_int] = ACTIONS(352),
    [anon_sym_int8] = ACTIONS(352),
    [anon_sym_int16] = ACTIONS(352),
    [anon_sym_int24] = ACTIONS(352),
    [anon_sym_int32] = ACTIONS(352),
    [anon_sym_int40] = ACTIONS(352),
    [anon_sym_int48] = ACTIONS(352),
    [anon_sym_int56] = ACTIONS(352),
    [anon_sym_int64] = ACTIONS(352),
    [anon_sym_int72] = ACTIONS(352),
    [anon_sym_int80] = ACTIONS(352),
    [anon_sym_int88] = ACTIONS(352),
    [anon_sym_int96] = ACTIONS(352),
    [anon_sym_int104] = ACTIONS(352),
    [anon_sym_int112] = ACTIONS(352),
    [anon_sym_int120] = ACTIONS(352),
    [anon_sym_int128] = ACTIONS(352),
    [anon_sym_int136] = ACTIONS(352),
    [anon_sym_int144] = ACTIONS(352),
    [anon_sym_int152] = ACTIONS(352),
    [anon_sym_int160] = ACTIONS(352),
    [anon_sym_int168] = ACTIONS(352),
    [anon_sym_int176] = ACTIONS(352),
    [anon_sym_int184] = ACTIONS(352),
    [anon_sym_int192] = ACTIONS(352),
    [anon_sym_int200] = ACTIONS(352),
    [anon_sym_int208] = ACTIONS(352),
    [anon_sym_int216] = ACTIONS(352),
    [anon_sym_int224] = ACTIONS(352),
    [anon_sym_int232] = ACTIONS(352),
    [anon_sym_int240] = ACTIONS(352),
    [anon_sym_int248] = ACTIONS(352),
    [anon_sym_int256] = ACTIONS(352),
    [anon_sym_uint] = ACTIONS(352),
    [anon_sym_uint8] = ACTIONS(352),
    [anon_sym_uint16] = ACTIONS(352),
    [anon_sym_uint24] = ACTIONS(352),
    [anon_sym_uint32] = ACTIONS(352),
    [anon_sym_uint40] = ACTIONS(352),
    [anon_sym_uint48] = ACTIONS(352),
    [anon_sym_uint56] = ACTIONS(352),
    [anon_sym_uint64] = ACTIONS(352),
    [anon_sym_uint72] = ACTIONS(352),
    [anon_sym_uint80] = ACTIONS(352),
    [anon_sym_uint88] = ACTIONS(352),
    [anon_sym_uint96] = ACTIONS(352),
    [anon_sym_uint104] = ACTIONS(352),
    [anon_sym_uint112] = ACTIONS(352),
    [anon_sym_uint120] = ACTIONS(352),
    [anon_sym_uint128] = ACTIONS(352),
    [anon_sym_uint136] = ACTIONS(352),
    [anon_sym_uint144] = ACTIONS(352),
    [anon_sym_uint152] = ACTIONS(352),
    [anon_sym_uint160] = ACTIONS(352),
    [anon_sym_uint168] = ACTIONS(352),
    [anon_sym_uint176] = ACTIONS(352),
    [anon_sym_uint184] = ACTIONS(352),
    [anon_sym_uint192] = ACTIONS(352),
    [anon_sym_uint200] = ACTIONS(352),
    [anon_sym_uint208] = ACTIONS(352),
    [anon_sym_uint216] = ACTIONS(352),
    [anon_sym_uint224] = ACTIONS(352),
    [anon_sym_uint232] = ACTIONS(352),
    [anon_sym_uint240] = ACTIONS(352),
    [anon_sym_uint248] = ACTIONS(352),
    [anon_sym_uint256] = ACTIONS(352),
    [anon_sym_bytes] = ACTIONS(352),
    [anon_sym_bytes1] = ACTIONS(352),
    [anon_sym_bytes2] = ACTIONS(352),
    [anon_sym_bytes3] = ACTIONS(352),
    [anon_sym_bytes4] = ACTIONS(352),
    [anon_sym_bytes5] = ACTIONS(352),
    [anon_sym_bytes6] = ACTIONS(352),
    [anon_sym_bytes7] = ACTIONS(352),
    [anon_sym_bytes8] = ACTIONS(352),
    [anon_sym_bytes9] = ACTIONS(352),
    [anon_sym_bytes10] = ACTIONS(352),
    [anon_sym_bytes11] = ACTIONS(352),
    [anon_sym_bytes12] = ACTIONS(352),
    [anon_sym_bytes13] = ACTIONS(352),
    [anon_sym_bytes14] = ACTIONS(352),
    [anon_sym_bytes15] = ACTIONS(352),
    [anon_sym_bytes16] = ACTIONS(352),
    [anon_sym_bytes17] = ACTIONS(352),
    [anon_sym_bytes18] = ACTIONS(352),
    [anon_sym_bytes19] = ACTIONS(352),
    [anon_sym_bytes20] = ACTIONS(352),
    [anon_sym_bytes21] = ACTIONS(352),
    [anon_sym_bytes22] = ACTIONS(352),
    [anon_sym_bytes23] = ACTIONS(352),
    [anon_sym_bytes24] = ACTIONS(352),
    [anon_sym_bytes25] = ACTIONS(352),
    [anon_sym_bytes26] = ACTIONS(352),
    [anon_sym_bytes27] = ACTIONS(352),
    [anon_sym_bytes28] = ACTIONS(352),
    [anon_sym_bytes29] = ACTIONS(352),
    [anon_sym_bytes30] = ACTIONS(352),
    [anon_sym_bytes31] = ACTIONS(352),
    [anon_sym_bytes32] = ACTIONS(352),
    [anon_sym_fixed] = ACTIONS(352),
    [aux_sym__fixed_token1] = ACTIONS(352),
    [anon_sym_ufixed] = ACTIONS(352),
    [aux_sym__ufixed_token1] = ACTIONS(352),
    [aux_sym__decimal_number_token1] = ACTIONS(352),
    [aux_sym__decimal_number_token2] = ACTIONS(354),
    [aux_sym__hex_number_token1] = ACTIONS(354),
    [anon_sym_hex] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(354),
    [anon_sym_unicode] = ACTIONS(352),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_catch_clause] = STATE(71),
    [aux_sym_try_statement_repeat1] = STATE(71),
    [sym_identifier] = ACTIONS(359),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(361),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_RBRACE] = ACTIONS(361),
    [anon_sym_type] = ACTIONS(359),
    [anon_sym_LPAREN] = ACTIONS(361),
    [anon_sym_for] = ACTIONS(359),
    [anon_sym_assembly] = ACTIONS(359),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(359),
    [anon_sym_true] = ACTIONS(359),
    [anon_sym_false] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(359),
    [anon_sym_function] = ACTIONS(359),
    [anon_sym_byte] = ACTIONS(359),
    [anon_sym_address] = ACTIONS(359),
    [anon_sym_return] = ACTIONS(359),
    [anon_sym_revert] = ACTIONS(359),
    [sym_unchecked] = ACTIONS(359),
    [anon_sym_var] = ACTIONS(359),
    [anon_sym_else] = ACTIONS(359),
    [anon_sym_while] = ACTIONS(359),
    [anon_sym_do] = ACTIONS(359),
    [anon_sym_try] = ACTIONS(359),
    [anon_sym_catch] = ACTIONS(350),
    [anon_sym_emit] = ACTIONS(359),
    [anon_sym_payable] = ACTIONS(359),
    [anon_sym_new] = ACTIONS(359),
    [anon_sym_LBRACK] = ACTIONS(361),
    [anon_sym_PLUS] = ACTIONS(359),
    [anon_sym_BANG] = ACTIONS(361),
    [anon_sym_delete] = ACTIONS(359),
    [anon_sym_PLUS_PLUS] = ACTIONS(361),
    [anon_sym_DASH_DASH] = ACTIONS(361),
    [anon_sym_mapping] = ACTIONS(359),
    [anon_sym_bool] = ACTIONS(359),
    [anon_sym_string] = ACTIONS(359),
    [anon_sym_int] = ACTIONS(359),
    [anon_sym_int8] = ACTIONS(359),
    [anon_sym_int16] = ACTIONS(359),
    [anon_sym_int24] = ACTIONS(359),
    [anon_sym_int32] = ACTIONS(359),
    [anon_sym_int40] = ACTIONS(359),
    [anon_sym_int48] = ACTIONS(359),
    [anon_sym_int56] = ACTIONS(359),
    [anon_sym_int64] = ACTIONS(359),
    [anon_sym_int72] = ACTIONS(359),
    [anon_sym_int80] = ACTIONS(359),
    [anon_sym_int88] = ACTIONS(359),
    [anon_sym_int96] = ACTIONS(359),
    [anon_sym_int104] = ACTIONS(359),
    [anon_sym_int112] = ACTIONS(359),
    [anon_sym_int120] = ACTIONS(359),
    [anon_sym_int128] = ACTIONS(359),
    [anon_sym_int136] = ACTIONS(359),
    [anon_sym_int144] = ACTIONS(359),
    [anon_sym_int152] = ACTIONS(359),
    [anon_sym_int160] = ACTIONS(359),
    [anon_sym_int168] = ACTIONS(359),
    [anon_sym_int176] = ACTIONS(359),
    [anon_sym_int184] = ACTIONS(359),
    [anon_sym_int192] = ACTIONS(359),
    [anon_sym_int200] = ACTIONS(359),
    [anon_sym_int208] = ACTIONS(359),
    [anon_sym_int216] = ACTIONS(359),
    [anon_sym_int224] = ACTIONS(359),
    [anon_sym_int232] = ACTIONS(359),
    [anon_sym_int240] = ACTIONS(359),
    [anon_sym_int248] = ACTIONS(359),
    [anon_sym_int256] = ACTIONS(359),
    [anon_sym_uint] = ACTIONS(359),
    [anon_sym_uint8] = ACTIONS(359),
    [anon_sym_uint16] = ACTIONS(359),
    [anon_sym_uint24] = ACTIONS(359),
    [anon_sym_uint32] = ACTIONS(359),
    [anon_sym_uint40] = ACTIONS(359),
    [anon_sym_uint48] = ACTIONS(359),
    [anon_sym_uint56] = ACTIONS(359),
    [anon_sym_uint64] = ACTIONS(359),
    [anon_sym_uint72] = ACTIONS(359),
    [anon_sym_uint80] = ACTIONS(359),
    [anon_sym_uint88] = ACTIONS(359),
    [anon_sym_uint96] = ACTIONS(359),
    [anon_sym_uint104] = ACTIONS(359),
    [anon_sym_uint112] = ACTIONS(359),
    [anon_sym_uint120] = ACTIONS(359),
    [anon_sym_uint128] = ACTIONS(359),
    [anon_sym_uint136] = ACTIONS(359),
    [anon_sym_uint144] = ACTIONS(359),
    [anon_sym_uint152] = ACTIONS(359),
    [anon_sym_uint160] = ACTIONS(359),
    [anon_sym_uint168] = ACTIONS(359),
    [anon_sym_uint176] = ACTIONS(359),
    [anon_sym_uint184] = ACTIONS(359),
    [anon_sym_uint192] = ACTIONS(359),
    [anon_sym_uint200] = ACTIONS(359),
    [anon_sym_uint208] = ACTIONS(359),
    [anon_sym_uint216] = ACTIONS(359),
    [anon_sym_uint224] = ACTIONS(359),
    [anon_sym_uint232] = ACTIONS(359),
    [anon_sym_uint240] = ACTIONS(359),
    [anon_sym_uint248] = ACTIONS(359),
    [anon_sym_uint256] = ACTIONS(359),
    [anon_sym_bytes] = ACTIONS(359),
    [anon_sym_bytes1] = ACTIONS(359),
    [anon_sym_bytes2] = ACTIONS(359),
    [anon_sym_bytes3] = ACTIONS(359),
    [anon_sym_bytes4] = ACTIONS(359),
    [anon_sym_bytes5] = ACTIONS(359),
    [anon_sym_bytes6] = ACTIONS(359),
    [anon_sym_bytes7] = ACTIONS(359),
    [anon_sym_bytes8] = ACTIONS(359),
    [anon_sym_bytes9] = ACTIONS(359),
    [anon_sym_bytes10] = ACTIONS(359),
    [anon_sym_bytes11] = ACTIONS(359),
    [anon_sym_bytes12] = ACTIONS(359),
    [anon_sym_bytes13] = ACTIONS(359),
    [anon_sym_bytes14] = ACTIONS(359),
    [anon_sym_bytes15] = ACTIONS(359),
    [anon_sym_bytes16] = ACTIONS(359),
    [anon_sym_bytes17] = ACTIONS(359),
    [anon_sym_bytes18] = ACTIONS(359),
    [anon_sym_bytes19] = ACTIONS(359),
    [anon_sym_bytes20] = ACTIONS(359),
    [anon_sym_bytes21] = ACTIONS(359),
    [anon_sym_bytes22] = ACTIONS(359),
    [anon_sym_bytes23] = ACTIONS(359),
    [anon_sym_bytes24] = ACTIONS(359),
    [anon_sym_bytes25] = ACTIONS(359),
    [anon_sym_bytes26] = ACTIONS(359),
    [anon_sym_bytes27] = ACTIONS(359),
    [anon_sym_bytes28] = ACTIONS(359),
    [anon_sym_bytes29] = ACTIONS(359),
    [anon_sym_bytes30] = ACTIONS(359),
    [anon_sym_bytes31] = ACTIONS(359),
    [anon_sym_bytes32] = ACTIONS(359),
    [anon_sym_fixed] = ACTIONS(359),
    [aux_sym__fixed_token1] = ACTIONS(359),
    [anon_sym_ufixed] = ACTIONS(359),
    [aux_sym__ufixed_token1] = ACTIONS(359),
    [aux_sym__decimal_number_token1] = ACTIONS(359),
    [aux_sym__decimal_number_token2] = ACTIONS(361),
    [aux_sym__hex_number_token1] = ACTIONS(361),
    [anon_sym_hex] = ACTIONS(359),
    [anon_sym_DQUOTE] = ACTIONS(361),
    [anon_sym_SQUOTE] = ACTIONS(361),
    [anon_sym_unicode] = ACTIONS(359),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_identifier] = ACTIONS(363),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_TILDE] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(365),
    [anon_sym_RBRACE] = ACTIONS(365),
    [anon_sym_type] = ACTIONS(363),
    [anon_sym_LPAREN] = ACTIONS(365),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_for] = ACTIONS(363),
    [anon_sym_assembly] = ACTIONS(363),
    [anon_sym_break] = ACTIONS(363),
    [anon_sym_continue] = ACTIONS(363),
    [anon_sym_true] = ACTIONS(363),
    [anon_sym_false] = ACTIONS(363),
    [anon_sym_if] = ACTIONS(363),
    [anon_sym_function] = ACTIONS(363),
    [anon_sym_byte] = ACTIONS(363),
    [anon_sym_address] = ACTIONS(363),
    [anon_sym_return] = ACTIONS(363),
    [anon_sym_revert] = ACTIONS(363),
    [sym_unchecked] = ACTIONS(363),
    [anon_sym_var] = ACTIONS(363),
    [anon_sym_else] = ACTIONS(363),
    [anon_sym_while] = ACTIONS(363),
    [anon_sym_do] = ACTIONS(363),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_emit] = ACTIONS(363),
    [anon_sym_payable] = ACTIONS(363),
    [anon_sym_new] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_PLUS] = ACTIONS(363),
    [anon_sym_BANG] = ACTIONS(365),
    [anon_sym_delete] = ACTIONS(363),
    [anon_sym_PLUS_PLUS] = ACTIONS(365),
    [anon_sym_DASH_DASH] = ACTIONS(365),
    [anon_sym_mapping] = ACTIONS(363),
    [anon_sym_bool] = ACTIONS(363),
    [anon_sym_string] = ACTIONS(363),
    [anon_sym_int] = ACTIONS(363),
    [anon_sym_int8] = ACTIONS(363),
    [anon_sym_int16] = ACTIONS(363),
    [anon_sym_int24] = ACTIONS(363),
    [anon_sym_int32] = ACTIONS(363),
    [anon_sym_int40] = ACTIONS(363),
    [anon_sym_int48] = ACTIONS(363),
    [anon_sym_int56] = ACTIONS(363),
    [anon_sym_int64] = ACTIONS(363),
    [anon_sym_int72] = ACTIONS(363),
    [anon_sym_int80] = ACTIONS(363),
    [anon_sym_int88] = ACTIONS(363),
    [anon_sym_int96] = ACTIONS(363),
    [anon_sym_int104] = ACTIONS(363),
    [anon_sym_int112] = ACTIONS(363),
    [anon_sym_int120] = ACTIONS(363),
    [anon_sym_int128] = ACTIONS(363),
    [anon_sym_int136] = ACTIONS(363),
    [anon_sym_int144] = ACTIONS(363),
    [anon_sym_int152] = ACTIONS(363),
    [anon_sym_int160] = ACTIONS(363),
    [anon_sym_int168] = ACTIONS(363),
    [anon_sym_int176] = ACTIONS(363),
    [anon_sym_int184] = ACTIONS(363),
    [anon_sym_int192] = ACTIONS(363),
    [anon_sym_int200] = ACTIONS(363),
    [anon_sym_int208] = ACTIONS(363),
    [anon_sym_int216] = ACTIONS(363),
    [anon_sym_int224] = ACTIONS(363),
    [anon_sym_int232] = ACTIONS(363),
    [anon_sym_int240] = ACTIONS(363),
    [anon_sym_int248] = ACTIONS(363),
    [anon_sym_int256] = ACTIONS(363),
    [anon_sym_uint] = ACTIONS(363),
    [anon_sym_uint8] = ACTIONS(363),
    [anon_sym_uint16] = ACTIONS(363),
    [anon_sym_uint24] = ACTIONS(363),
    [anon_sym_uint32] = ACTIONS(363),
    [anon_sym_uint40] = ACTIONS(363),
    [anon_sym_uint48] = ACTIONS(363),
    [anon_sym_uint56] = ACTIONS(363),
    [anon_sym_uint64] = ACTIONS(363),
    [anon_sym_uint72] = ACTIONS(363),
    [anon_sym_uint80] = ACTIONS(363),
    [anon_sym_uint88] = ACTIONS(363),
    [anon_sym_uint96] = ACTIONS(363),
    [anon_sym_uint104] = ACTIONS(363),
    [anon_sym_uint112] = ACTIONS(363),
    [anon_sym_uint120] = ACTIONS(363),
    [anon_sym_uint128] = ACTIONS(363),
    [anon_sym_uint136] = ACTIONS(363),
    [anon_sym_uint144] = ACTIONS(363),
    [anon_sym_uint152] = ACTIONS(363),
    [anon_sym_uint160] = ACTIONS(363),
    [anon_sym_uint168] = ACTIONS(363),
    [anon_sym_uint176] = ACTIONS(363),
    [anon_sym_uint184] = ACTIONS(363),
    [anon_sym_uint192] = ACTIONS(363),
    [anon_sym_uint200] = ACTIONS(363),
    [anon_sym_uint208] = ACTIONS(363),
    [anon_sym_uint216] = ACTIONS(363),
    [anon_sym_uint224] = ACTIONS(363),
    [anon_sym_uint232] = ACTIONS(363),
    [anon_sym_uint240] = ACTIONS(363),
    [anon_sym_uint248] = ACTIONS(363),
    [anon_sym_uint256] = ACTIONS(363),
    [anon_sym_bytes] = ACTIONS(363),
    [anon_sym_bytes1] = ACTIONS(363),
    [anon_sym_bytes2] = ACTIONS(363),
    [anon_sym_bytes3] = ACTIONS(363),
    [anon_sym_bytes4] = ACTIONS(363),
    [anon_sym_bytes5] = ACTIONS(363),
    [anon_sym_bytes6] = ACTIONS(363),
    [anon_sym_bytes7] = ACTIONS(363),
    [anon_sym_bytes8] = ACTIONS(363),
    [anon_sym_bytes9] = ACTIONS(363),
    [anon_sym_bytes10] = ACTIONS(363),
    [anon_sym_bytes11] = ACTIONS(363),
    [anon_sym_bytes12] = ACTIONS(363),
    [anon_sym_bytes13] = ACTIONS(363),
    [anon_sym_bytes14] = ACTIONS(363),
    [anon_sym_bytes15] = ACTIONS(363),
    [anon_sym_bytes16] = ACTIONS(363),
    [anon_sym_bytes17] = ACTIONS(363),
    [anon_sym_bytes18] = ACTIONS(363),
    [anon_sym_bytes19] = ACTIONS(363),
    [anon_sym_bytes20] = ACTIONS(363),
    [anon_sym_bytes21] = ACTIONS(363),
    [anon_sym_bytes22] = ACTIONS(363),
    [anon_sym_bytes23] = ACTIONS(363),
    [anon_sym_bytes24] = ACTIONS(363),
    [anon_sym_bytes25] = ACTIONS(363),
    [anon_sym_bytes26] = ACTIONS(363),
    [anon_sym_bytes27] = ACTIONS(363),
    [anon_sym_bytes28] = ACTIONS(363),
    [anon_sym_bytes29] = ACTIONS(363),
    [anon_sym_bytes30] = ACTIONS(363),
    [anon_sym_bytes31] = ACTIONS(363),
    [anon_sym_bytes32] = ACTIONS(363),
    [anon_sym_fixed] = ACTIONS(363),
    [aux_sym__fixed_token1] = ACTIONS(363),
    [anon_sym_ufixed] = ACTIONS(363),
    [aux_sym__ufixed_token1] = ACTIONS(363),
    [sym__semicolon] = ACTIONS(365),
    [aux_sym__decimal_number_token1] = ACTIONS(363),
    [aux_sym__decimal_number_token2] = ACTIONS(365),
    [aux_sym__hex_number_token1] = ACTIONS(365),
    [anon_sym_hex] = ACTIONS(363),
    [anon_sym_DQUOTE] = ACTIONS(365),
    [anon_sym_SQUOTE] = ACTIONS(365),
    [anon_sym_unicode] = ACTIONS(363),
    [sym_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_identifier] = ACTIONS(367),
    [anon_sym_DASH] = ACTIONS(367),
    [anon_sym_TILDE] = ACTIONS(369),
    [anon_sym_LBRACE] = ACTIONS(369),
    [anon_sym_RBRACE] = ACTIONS(369),
    [anon_sym_type] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(369),
    [anon_sym_for] = ACTIONS(367),
    [anon_sym_assembly] = ACTIONS(367),
    [anon_sym_break] = ACTIONS(367),
    [anon_sym_continue] = ACTIONS(367),
    [anon_sym_true] = ACTIONS(367),
    [anon_sym_false] = ACTIONS(367),
    [anon_sym_if] = ACTIONS(367),
    [anon_sym_function] = ACTIONS(367),
    [anon_sym_byte] = ACTIONS(367),
    [anon_sym_address] = ACTIONS(367),
    [anon_sym_return] = ACTIONS(367),
    [anon_sym_revert] = ACTIONS(367),
    [sym_unchecked] = ACTIONS(367),
    [anon_sym_var] = ACTIONS(367),
    [anon_sym_else] = ACTIONS(367),
    [anon_sym_while] = ACTIONS(367),
    [anon_sym_do] = ACTIONS(367),
    [anon_sym_try] = ACTIONS(367),
    [anon_sym_catch] = ACTIONS(367),
    [anon_sym_emit] = ACTIONS(367),
    [anon_sym_payable] = ACTIONS(367),
    [anon_sym_new] = ACTIONS(367),
    [anon_sym_LBRACK] = ACTIONS(369),
    [anon_sym_PLUS] = ACTIONS(367),
    [anon_sym_BANG] = ACTIONS(369),
    [anon_sym_delete] = ACTIONS(367),
    [anon_sym_PLUS_PLUS] = ACTIONS(369),
    [anon_sym_DASH_DASH] = ACTIONS(369),
    [anon_sym_mapping] = ACTIONS(367),
    [anon_sym_bool] = ACTIONS(367),
    [anon_sym_string] = ACTIONS(367),
    [anon_sym_int] = ACTIONS(367),
    [anon_sym_int8] = ACTIONS(367),
    [anon_sym_int16] = ACTIONS(367),
    [anon_sym_int24] = ACTIONS(367),
    [anon_sym_int32] = ACTIONS(367),
    [anon_sym_int40] = ACTIONS(367),
    [anon_sym_int48] = ACTIONS(367),
    [anon_sym_int56] = ACTIONS(367),
    [anon_sym_int64] = ACTIONS(367),
    [anon_sym_int72] = ACTIONS(367),
    [anon_sym_int80] = ACTIONS(367),
    [anon_sym_int88] = ACTIONS(367),
    [anon_sym_int96] = ACTIONS(367),
    [anon_sym_int104] = ACTIONS(367),
    [anon_sym_int112] = ACTIONS(367),
    [anon_sym_int120] = ACTIONS(367),
    [anon_sym_int128] = ACTIONS(367),
    [anon_sym_int136] = ACTIONS(367),
    [anon_sym_int144] = ACTIONS(367),
    [anon_sym_int152] = ACTIONS(367),
    [anon_sym_int160] = ACTIONS(367),
    [anon_sym_int168] = ACTIONS(367),
    [anon_sym_int176] = ACTIONS(367),
    [anon_sym_int184] = ACTIONS(367),
    [anon_sym_int192] = ACTIONS(367),
    [anon_sym_int200] = ACTIONS(367),
    [anon_sym_int208] = ACTIONS(367),
    [anon_sym_int216] = ACTIONS(367),
    [anon_sym_int224] = ACTIONS(367),
    [anon_sym_int232] = ACTIONS(367),
    [anon_sym_int240] = ACTIONS(367),
    [anon_sym_int248] = ACTIONS(367),
    [anon_sym_int256] = ACTIONS(367),
    [anon_sym_uint] = ACTIONS(367),
    [anon_sym_uint8] = ACTIONS(367),
    [anon_sym_uint16] = ACTIONS(367),
    [anon_sym_uint24] = ACTIONS(367),
    [anon_sym_uint32] = ACTIONS(367),
    [anon_sym_uint40] = ACTIONS(367),
    [anon_sym_uint48] = ACTIONS(367),
    [anon_sym_uint56] = ACTIONS(367),
    [anon_sym_uint64] = ACTIONS(367),
    [anon_sym_uint72] = ACTIONS(367),
    [anon_sym_uint80] = ACTIONS(367),
    [anon_sym_uint88] = ACTIONS(367),
    [anon_sym_uint96] = ACTIONS(367),
    [anon_sym_uint104] = ACTIONS(367),
    [anon_sym_uint112] = ACTIONS(367),
    [anon_sym_uint120] = ACTIONS(367),
    [anon_sym_uint128] = ACTIONS(367),
    [anon_sym_uint136] = ACTIONS(367),
    [anon_sym_uint144] = ACTIONS(367),
    [anon_sym_uint152] = ACTIONS(367),
    [anon_sym_uint160] = ACTIONS(367),
    [anon_sym_uint168] = ACTIONS(367),
    [anon_sym_uint176] = ACTIONS(367),
    [anon_sym_uint184] = ACTIONS(367),
    [anon_sym_uint192] = ACTIONS(367),
    [anon_sym_uint200] = ACTIONS(367),
    [anon_sym_uint208] = ACTIONS(367),
    [anon_sym_uint216] = ACTIONS(367),
    [anon_sym_uint224] = ACTIONS(367),
    [anon_sym_uint232] = ACTIONS(367),
    [anon_sym_uint240] = ACTIONS(367),
    [anon_sym_uint248] = ACTIONS(367),
    [anon_sym_uint256] = ACTIONS(367),
    [anon_sym_bytes] = ACTIONS(367),
    [anon_sym_bytes1] = ACTIONS(367),
    [anon_sym_bytes2] = ACTIONS(367),
    [anon_sym_bytes3] = ACTIONS(367),
    [anon_sym_bytes4] = ACTIONS(367),
    [anon_sym_bytes5] = ACTIONS(367),
    [anon_sym_bytes6] = ACTIONS(367),
    [anon_sym_bytes7] = ACTIONS(367),
    [anon_sym_bytes8] = ACTIONS(367),
    [anon_sym_bytes9] = ACTIONS(367),
    [anon_sym_bytes10] = ACTIONS(367),
    [anon_sym_bytes11] = ACTIONS(367),
    [anon_sym_bytes12] = ACTIONS(367),
    [anon_sym_bytes13] = ACTIONS(367),
    [anon_sym_bytes14] = ACTIONS(367),
    [anon_sym_bytes15] = ACTIONS(367),
    [anon_sym_bytes16] = ACTIONS(367),
    [anon_sym_bytes17] = ACTIONS(367),
    [anon_sym_bytes18] = ACTIONS(367),
    [anon_sym_bytes19] = ACTIONS(367),
    [anon_sym_bytes20] = ACTIONS(367),
    [anon_sym_bytes21] = ACTIONS(367),
    [anon_sym_bytes22] = ACTIONS(367),
    [anon_sym_bytes23] = ACTIONS(367),
    [anon_sym_bytes24] = ACTIONS(367),
    [anon_sym_bytes25] = ACTIONS(367),
    [anon_sym_bytes26] = ACTIONS(367),
    [anon_sym_bytes27] = ACTIONS(367),
    [anon_sym_bytes28] = ACTIONS(367),
    [anon_sym_bytes29] = ACTIONS(367),
    [anon_sym_bytes30] = ACTIONS(367),
    [anon_sym_bytes31] = ACTIONS(367),
    [anon_sym_bytes32] = ACTIONS(367),
    [anon_sym_fixed] = ACTIONS(367),
    [aux_sym__fixed_token1] = ACTIONS(367),
    [anon_sym_ufixed] = ACTIONS(367),
    [aux_sym__ufixed_token1] = ACTIONS(367),
    [aux_sym__decimal_number_token1] = ACTIONS(367),
    [aux_sym__decimal_number_token2] = ACTIONS(369),
    [aux_sym__hex_number_token1] = ACTIONS(369),
    [anon_sym_hex] = ACTIONS(367),
    [anon_sym_DQUOTE] = ACTIONS(369),
    [anon_sym_SQUOTE] = ACTIONS(369),
    [anon_sym_unicode] = ACTIONS(367),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_identifier] = ACTIONS(371),
    [anon_sym_DASH] = ACTIONS(371),
    [anon_sym_TILDE] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(373),
    [anon_sym_RBRACE] = ACTIONS(373),
    [anon_sym_type] = ACTIONS(371),
    [anon_sym_LPAREN] = ACTIONS(373),
    [anon_sym_for] = ACTIONS(371),
    [anon_sym_assembly] = ACTIONS(371),
    [anon_sym_break] = ACTIONS(371),
    [anon_sym_continue] = ACTIONS(371),
    [anon_sym_true] = ACTIONS(371),
    [anon_sym_false] = ACTIONS(371),
    [anon_sym_if] = ACTIONS(371),
    [anon_sym_function] = ACTIONS(371),
    [anon_sym_byte] = ACTIONS(371),
    [anon_sym_address] = ACTIONS(371),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_revert] = ACTIONS(371),
    [sym_unchecked] = ACTIONS(371),
    [anon_sym_var] = ACTIONS(371),
    [anon_sym_else] = ACTIONS(371),
    [anon_sym_while] = ACTIONS(371),
    [anon_sym_do] = ACTIONS(371),
    [anon_sym_try] = ACTIONS(371),
    [anon_sym_emit] = ACTIONS(371),
    [anon_sym_payable] = ACTIONS(371),
    [anon_sym_new] = ACTIONS(371),
    [anon_sym_LBRACK] = ACTIONS(373),
    [anon_sym_PLUS] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(373),
    [anon_sym_delete] = ACTIONS(371),
    [anon_sym_PLUS_PLUS] = ACTIONS(373),
    [anon_sym_DASH_DASH] = ACTIONS(373),
    [anon_sym_mapping] = ACTIONS(371),
    [anon_sym_bool] = ACTIONS(371),
    [anon_sym_string] = ACTIONS(371),
    [anon_sym_int] = ACTIONS(371),
    [anon_sym_int8] = ACTIONS(371),
    [anon_sym_int16] = ACTIONS(371),
    [anon_sym_int24] = ACTIONS(371),
    [anon_sym_int32] = ACTIONS(371),
    [anon_sym_int40] = ACTIONS(371),
    [anon_sym_int48] = ACTIONS(371),
    [anon_sym_int56] = ACTIONS(371),
    [anon_sym_int64] = ACTIONS(371),
    [anon_sym_int72] = ACTIONS(371),
    [anon_sym_int80] = ACTIONS(371),
    [anon_sym_int88] = ACTIONS(371),
    [anon_sym_int96] = ACTIONS(371),
    [anon_sym_int104] = ACTIONS(371),
    [anon_sym_int112] = ACTIONS(371),
    [anon_sym_int120] = ACTIONS(371),
    [anon_sym_int128] = ACTIONS(371),
    [anon_sym_int136] = ACTIONS(371),
    [anon_sym_int144] = ACTIONS(371),
    [anon_sym_int152] = ACTIONS(371),
    [anon_sym_int160] = ACTIONS(371),
    [anon_sym_int168] = ACTIONS(371),
    [anon_sym_int176] = ACTIONS(371),
    [anon_sym_int184] = ACTIONS(371),
    [anon_sym_int192] = ACTIONS(371),
    [anon_sym_int200] = ACTIONS(371),
    [anon_sym_int208] = ACTIONS(371),
    [anon_sym_int216] = ACTIONS(371),
    [anon_sym_int224] = ACTIONS(371),
    [anon_sym_int232] = ACTIONS(371),
    [anon_sym_int240] = ACTIONS(371),
    [anon_sym_int248] = ACTIONS(371),
    [anon_sym_int256] = ACTIONS(371),
    [anon_sym_uint] = ACTIONS(371),
    [anon_sym_uint8] = ACTIONS(371),
    [anon_sym_uint16] = ACTIONS(371),
    [anon_sym_uint24] = ACTIONS(371),
    [anon_sym_uint32] = ACTIONS(371),
    [anon_sym_uint40] = ACTIONS(371),
    [anon_sym_uint48] = ACTIONS(371),
    [anon_sym_uint56] = ACTIONS(371),
    [anon_sym_uint64] = ACTIONS(371),
    [anon_sym_uint72] = ACTIONS(371),
    [anon_sym_uint80] = ACTIONS(371),
    [anon_sym_uint88] = ACTIONS(371),
    [anon_sym_uint96] = ACTIONS(371),
    [anon_sym_uint104] = ACTIONS(371),
    [anon_sym_uint112] = ACTIONS(371),
    [anon_sym_uint120] = ACTIONS(371),
    [anon_sym_uint128] = ACTIONS(371),
    [anon_sym_uint136] = ACTIONS(371),
    [anon_sym_uint144] = ACTIONS(371),
    [anon_sym_uint152] = ACTIONS(371),
    [anon_sym_uint160] = ACTIONS(371),
    [anon_sym_uint168] = ACTIONS(371),
    [anon_sym_uint176] = ACTIONS(371),
    [anon_sym_uint184] = ACTIONS(371),
    [anon_sym_uint192] = ACTIONS(371),
    [anon_sym_uint200] = ACTIONS(371),
    [anon_sym_uint208] = ACTIONS(371),
    [anon_sym_uint216] = ACTIONS(371),
    [anon_sym_uint224] = ACTIONS(371),
    [anon_sym_uint232] = ACTIONS(371),
    [anon_sym_uint240] = ACTIONS(371),
    [anon_sym_uint248] = ACTIONS(371),
    [anon_sym_uint256] = ACTIONS(371),
    [anon_sym_bytes] = ACTIONS(371),
    [anon_sym_bytes1] = ACTIONS(371),
    [anon_sym_bytes2] = ACTIONS(371),
    [anon_sym_bytes3] = ACTIONS(371),
    [anon_sym_bytes4] = ACTIONS(371),
    [anon_sym_bytes5] = ACTIONS(371),
    [anon_sym_bytes6] = ACTIONS(371),
    [anon_sym_bytes7] = ACTIONS(371),
    [anon_sym_bytes8] = ACTIONS(371),
    [anon_sym_bytes9] = ACTIONS(371),
    [anon_sym_bytes10] = ACTIONS(371),
    [anon_sym_bytes11] = ACTIONS(371),
    [anon_sym_bytes12] = ACTIONS(371),
    [anon_sym_bytes13] = ACTIONS(371),
    [anon_sym_bytes14] = ACTIONS(371),
    [anon_sym_bytes15] = ACTIONS(371),
    [anon_sym_bytes16] = ACTIONS(371),
    [anon_sym_bytes17] = ACTIONS(371),
    [anon_sym_bytes18] = ACTIONS(371),
    [anon_sym_bytes19] = ACTIONS(371),
    [anon_sym_bytes20] = ACTIONS(371),
    [anon_sym_bytes21] = ACTIONS(371),
    [anon_sym_bytes22] = ACTIONS(371),
    [anon_sym_bytes23] = ACTIONS(371),
    [anon_sym_bytes24] = ACTIONS(371),
    [anon_sym_bytes25] = ACTIONS(371),
    [anon_sym_bytes26] = ACTIONS(371),
    [anon_sym_bytes27] = ACTIONS(371),
    [anon_sym_bytes28] = ACTIONS(371),
    [anon_sym_bytes29] = ACTIONS(371),
    [anon_sym_bytes30] = ACTIONS(371),
    [anon_sym_bytes31] = ACTIONS(371),
    [anon_sym_bytes32] = ACTIONS(371),
    [anon_sym_fixed] = ACTIONS(371),
    [aux_sym__fixed_token1] = ACTIONS(371),
    [anon_sym_ufixed] = ACTIONS(371),
    [aux_sym__ufixed_token1] = ACTIONS(371),
    [sym__semicolon] = ACTIONS(373),
    [aux_sym__decimal_number_token1] = ACTIONS(371),
    [aux_sym__decimal_number_token2] = ACTIONS(373),
    [aux_sym__hex_number_token1] = ACTIONS(373),
    [anon_sym_hex] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(373),
    [anon_sym_SQUOTE] = ACTIONS(373),
    [anon_sym_unicode] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_identifier] = ACTIONS(375),
    [anon_sym_DASH] = ACTIONS(375),
    [anon_sym_TILDE] = ACTIONS(377),
    [anon_sym_LBRACE] = ACTIONS(377),
    [anon_sym_RBRACE] = ACTIONS(377),
    [anon_sym_type] = ACTIONS(375),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_for] = ACTIONS(375),
    [anon_sym_assembly] = ACTIONS(375),
    [anon_sym_break] = ACTIONS(375),
    [anon_sym_continue] = ACTIONS(375),
    [anon_sym_true] = ACTIONS(375),
    [anon_sym_false] = ACTIONS(375),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_function] = ACTIONS(375),
    [anon_sym_byte] = ACTIONS(375),
    [anon_sym_address] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(375),
    [anon_sym_revert] = ACTIONS(375),
    [sym_unchecked] = ACTIONS(375),
    [anon_sym_var] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_try] = ACTIONS(375),
    [anon_sym_emit] = ACTIONS(375),
    [anon_sym_payable] = ACTIONS(375),
    [anon_sym_new] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(377),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_BANG] = ACTIONS(377),
    [anon_sym_delete] = ACTIONS(375),
    [anon_sym_PLUS_PLUS] = ACTIONS(377),
    [anon_sym_DASH_DASH] = ACTIONS(377),
    [anon_sym_mapping] = ACTIONS(375),
    [anon_sym_bool] = ACTIONS(375),
    [anon_sym_string] = ACTIONS(375),
    [anon_sym_int] = ACTIONS(375),
    [anon_sym_int8] = ACTIONS(375),
    [anon_sym_int16] = ACTIONS(375),
    [anon_sym_int24] = ACTIONS(375),
    [anon_sym_int32] = ACTIONS(375),
    [anon_sym_int40] = ACTIONS(375),
    [anon_sym_int48] = ACTIONS(375),
    [anon_sym_int56] = ACTIONS(375),
    [anon_sym_int64] = ACTIONS(375),
    [anon_sym_int72] = ACTIONS(375),
    [anon_sym_int80] = ACTIONS(375),
    [anon_sym_int88] = ACTIONS(375),
    [anon_sym_int96] = ACTIONS(375),
    [anon_sym_int104] = ACTIONS(375),
    [anon_sym_int112] = ACTIONS(375),
    [anon_sym_int120] = ACTIONS(375),
    [anon_sym_int128] = ACTIONS(375),
    [anon_sym_int136] = ACTIONS(375),
    [anon_sym_int144] = ACTIONS(375),
    [anon_sym_int152] = ACTIONS(375),
    [anon_sym_int160] = ACTIONS(375),
    [anon_sym_int168] = ACTIONS(375),
    [anon_sym_int176] = ACTIONS(375),
    [anon_sym_int184] = ACTIONS(375),
    [anon_sym_int192] = ACTIONS(375),
    [anon_sym_int200] = ACTIONS(375),
    [anon_sym_int208] = ACTIONS(375),
    [anon_sym_int216] = ACTIONS(375),
    [anon_sym_int224] = ACTIONS(375),
    [anon_sym_int232] = ACTIONS(375),
    [anon_sym_int240] = ACTIONS(375),
    [anon_sym_int248] = ACTIONS(375),
    [anon_sym_int256] = ACTIONS(375),
    [anon_sym_uint] = ACTIONS(375),
    [anon_sym_uint8] = ACTIONS(375),
    [anon_sym_uint16] = ACTIONS(375),
    [anon_sym_uint24] = ACTIONS(375),
    [anon_sym_uint32] = ACTIONS(375),
    [anon_sym_uint40] = ACTIONS(375),
    [anon_sym_uint48] = ACTIONS(375),
    [anon_sym_uint56] = ACTIONS(375),
    [anon_sym_uint64] = ACTIONS(375),
    [anon_sym_uint72] = ACTIONS(375),
    [anon_sym_uint80] = ACTIONS(375),
    [anon_sym_uint88] = ACTIONS(375),
    [anon_sym_uint96] = ACTIONS(375),
    [anon_sym_uint104] = ACTIONS(375),
    [anon_sym_uint112] = ACTIONS(375),
    [anon_sym_uint120] = ACTIONS(375),
    [anon_sym_uint128] = ACTIONS(375),
    [anon_sym_uint136] = ACTIONS(375),
    [anon_sym_uint144] = ACTIONS(375),
    [anon_sym_uint152] = ACTIONS(375),
    [anon_sym_uint160] = ACTIONS(375),
    [anon_sym_uint168] = ACTIONS(375),
    [anon_sym_uint176] = ACTIONS(375),
    [anon_sym_uint184] = ACTIONS(375),
    [anon_sym_uint192] = ACTIONS(375),
    [anon_sym_uint200] = ACTIONS(375),
    [anon_sym_uint208] = ACTIONS(375),
    [anon_sym_uint216] = ACTIONS(375),
    [anon_sym_uint224] = ACTIONS(375),
    [anon_sym_uint232] = ACTIONS(375),
    [anon_sym_uint240] = ACTIONS(375),
    [anon_sym_uint248] = ACTIONS(375),
    [anon_sym_uint256] = ACTIONS(375),
    [anon_sym_bytes] = ACTIONS(375),
    [anon_sym_bytes1] = ACTIONS(375),
    [anon_sym_bytes2] = ACTIONS(375),
    [anon_sym_bytes3] = ACTIONS(375),
    [anon_sym_bytes4] = ACTIONS(375),
    [anon_sym_bytes5] = ACTIONS(375),
    [anon_sym_bytes6] = ACTIONS(375),
    [anon_sym_bytes7] = ACTIONS(375),
    [anon_sym_bytes8] = ACTIONS(375),
    [anon_sym_bytes9] = ACTIONS(375),
    [anon_sym_bytes10] = ACTIONS(375),
    [anon_sym_bytes11] = ACTIONS(375),
    [anon_sym_bytes12] = ACTIONS(375),
    [anon_sym_bytes13] = ACTIONS(375),
    [anon_sym_bytes14] = ACTIONS(375),
    [anon_sym_bytes15] = ACTIONS(375),
    [anon_sym_bytes16] = ACTIONS(375),
    [anon_sym_bytes17] = ACTIONS(375),
    [anon_sym_bytes18] = ACTIONS(375),
    [anon_sym_bytes19] = ACTIONS(375),
    [anon_sym_bytes20] = ACTIONS(375),
    [anon_sym_bytes21] = ACTIONS(375),
    [anon_sym_bytes22] = ACTIONS(375),
    [anon_sym_bytes23] = ACTIONS(375),
    [anon_sym_bytes24] = ACTIONS(375),
    [anon_sym_bytes25] = ACTIONS(375),
    [anon_sym_bytes26] = ACTIONS(375),
    [anon_sym_bytes27] = ACTIONS(375),
    [anon_sym_bytes28] = ACTIONS(375),
    [anon_sym_bytes29] = ACTIONS(375),
    [anon_sym_bytes30] = ACTIONS(375),
    [anon_sym_bytes31] = ACTIONS(375),
    [anon_sym_bytes32] = ACTIONS(375),
    [anon_sym_fixed] = ACTIONS(375),
    [aux_sym__fixed_token1] = ACTIONS(375),
    [anon_sym_ufixed] = ACTIONS(375),
    [aux_sym__ufixed_token1] = ACTIONS(375),
    [sym__semicolon] = ACTIONS(377),
    [aux_sym__decimal_number_token1] = ACTIONS(375),
    [aux_sym__decimal_number_token2] = ACTIONS(377),
    [aux_sym__hex_number_token1] = ACTIONS(377),
    [anon_sym_hex] = ACTIONS(375),
    [anon_sym_DQUOTE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(377),
    [anon_sym_unicode] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_identifier] = ACTIONS(379),
    [anon_sym_DASH] = ACTIONS(379),
    [anon_sym_TILDE] = ACTIONS(381),
    [anon_sym_LBRACE] = ACTIONS(381),
    [anon_sym_RBRACE] = ACTIONS(381),
    [anon_sym_type] = ACTIONS(379),
    [anon_sym_LPAREN] = ACTIONS(381),
    [anon_sym_for] = ACTIONS(379),
    [anon_sym_assembly] = ACTIONS(379),
    [anon_sym_break] = ACTIONS(379),
    [anon_sym_continue] = ACTIONS(379),
    [anon_sym_true] = ACTIONS(379),
    [anon_sym_false] = ACTIONS(379),
    [anon_sym_if] = ACTIONS(379),
    [anon_sym_function] = ACTIONS(379),
    [anon_sym_byte] = ACTIONS(379),
    [anon_sym_address] = ACTIONS(379),
    [anon_sym_return] = ACTIONS(379),
    [anon_sym_revert] = ACTIONS(379),
    [sym_unchecked] = ACTIONS(379),
    [anon_sym_var] = ACTIONS(379),
    [anon_sym_else] = ACTIONS(379),
    [anon_sym_while] = ACTIONS(379),
    [anon_sym_do] = ACTIONS(379),
    [anon_sym_try] = ACTIONS(379),
    [anon_sym_catch] = ACTIONS(379),
    [anon_sym_emit] = ACTIONS(379),
    [anon_sym_payable] = ACTIONS(379),
    [anon_sym_new] = ACTIONS(379),
    [anon_sym_LBRACK] = ACTIONS(381),
    [anon_sym_PLUS] = ACTIONS(379),
    [anon_sym_BANG] = ACTIONS(381),
    [anon_sym_delete] = ACTIONS(379),
    [anon_sym_PLUS_PLUS] = ACTIONS(381),
    [anon_sym_DASH_DASH] = ACTIONS(381),
    [anon_sym_mapping] = ACTIONS(379),
    [anon_sym_bool] = ACTIONS(379),
    [anon_sym_string] = ACTIONS(379),
    [anon_sym_int] = ACTIONS(379),
    [anon_sym_int8] = ACTIONS(379),
    [anon_sym_int16] = ACTIONS(379),
    [anon_sym_int24] = ACTIONS(379),
    [anon_sym_int32] = ACTIONS(379),
    [anon_sym_int40] = ACTIONS(379),
    [anon_sym_int48] = ACTIONS(379),
    [anon_sym_int56] = ACTIONS(379),
    [anon_sym_int64] = ACTIONS(379),
    [anon_sym_int72] = ACTIONS(379),
    [anon_sym_int80] = ACTIONS(379),
    [anon_sym_int88] = ACTIONS(379),
    [anon_sym_int96] = ACTIONS(379),
    [anon_sym_int104] = ACTIONS(379),
    [anon_sym_int112] = ACTIONS(379),
    [anon_sym_int120] = ACTIONS(379),
    [anon_sym_int128] = ACTIONS(379),
    [anon_sym_int136] = ACTIONS(379),
    [anon_sym_int144] = ACTIONS(379),
    [anon_sym_int152] = ACTIONS(379),
    [anon_sym_int160] = ACTIONS(379),
    [anon_sym_int168] = ACTIONS(379),
    [anon_sym_int176] = ACTIONS(379),
    [anon_sym_int184] = ACTIONS(379),
    [anon_sym_int192] = ACTIONS(379),
    [anon_sym_int200] = ACTIONS(379),
    [anon_sym_int208] = ACTIONS(379),
    [anon_sym_int216] = ACTIONS(379),
    [anon_sym_int224] = ACTIONS(379),
    [anon_sym_int232] = ACTIONS(379),
    [anon_sym_int240] = ACTIONS(379),
    [anon_sym_int248] = ACTIONS(379),
    [anon_sym_int256] = ACTIONS(379),
    [anon_sym_uint] = ACTIONS(379),
    [anon_sym_uint8] = ACTIONS(379),
    [anon_sym_uint16] = ACTIONS(379),
    [anon_sym_uint24] = ACTIONS(379),
    [anon_sym_uint32] = ACTIONS(379),
    [anon_sym_uint40] = ACTIONS(379),
    [anon_sym_uint48] = ACTIONS(379),
    [anon_sym_uint56] = ACTIONS(379),
    [anon_sym_uint64] = ACTIONS(379),
    [anon_sym_uint72] = ACTIONS(379),
    [anon_sym_uint80] = ACTIONS(379),
    [anon_sym_uint88] = ACTIONS(379),
    [anon_sym_uint96] = ACTIONS(379),
    [anon_sym_uint104] = ACTIONS(379),
    [anon_sym_uint112] = ACTIONS(379),
    [anon_sym_uint120] = ACTIONS(379),
    [anon_sym_uint128] = ACTIONS(379),
    [anon_sym_uint136] = ACTIONS(379),
    [anon_sym_uint144] = ACTIONS(379),
    [anon_sym_uint152] = ACTIONS(379),
    [anon_sym_uint160] = ACTIONS(379),
    [anon_sym_uint168] = ACTIONS(379),
    [anon_sym_uint176] = ACTIONS(379),
    [anon_sym_uint184] = ACTIONS(379),
    [anon_sym_uint192] = ACTIONS(379),
    [anon_sym_uint200] = ACTIONS(379),
    [anon_sym_uint208] = ACTIONS(379),
    [anon_sym_uint216] = ACTIONS(379),
    [anon_sym_uint224] = ACTIONS(379),
    [anon_sym_uint232] = ACTIONS(379),
    [anon_sym_uint240] = ACTIONS(379),
    [anon_sym_uint248] = ACTIONS(379),
    [anon_sym_uint256] = ACTIONS(379),
    [anon_sym_bytes] = ACTIONS(379),
    [anon_sym_bytes1] = ACTIONS(379),
    [anon_sym_bytes2] = ACTIONS(379),
    [anon_sym_bytes3] = ACTIONS(379),
    [anon_sym_bytes4] = ACTIONS(379),
    [anon_sym_bytes5] = ACTIONS(379),
    [anon_sym_bytes6] = ACTIONS(379),
    [anon_sym_bytes7] = ACTIONS(379),
    [anon_sym_bytes8] = ACTIONS(379),
    [anon_sym_bytes9] = ACTIONS(379),
    [anon_sym_bytes10] = ACTIONS(379),
    [anon_sym_bytes11] = ACTIONS(379),
    [anon_sym_bytes12] = ACTIONS(379),
    [anon_sym_bytes13] = ACTIONS(379),
    [anon_sym_bytes14] = ACTIONS(379),
    [anon_sym_bytes15] = ACTIONS(379),
    [anon_sym_bytes16] = ACTIONS(379),
    [anon_sym_bytes17] = ACTIONS(379),
    [anon_sym_bytes18] = ACTIONS(379),
    [anon_sym_bytes19] = ACTIONS(379),
    [anon_sym_bytes20] = ACTIONS(379),
    [anon_sym_bytes21] = ACTIONS(379),
    [anon_sym_bytes22] = ACTIONS(379),
    [anon_sym_bytes23] = ACTIONS(379),
    [anon_sym_bytes24] = ACTIONS(379),
    [anon_sym_bytes25] = ACTIONS(379),
    [anon_sym_bytes26] = ACTIONS(379),
    [anon_sym_bytes27] = ACTIONS(379),
    [anon_sym_bytes28] = ACTIONS(379),
    [anon_sym_bytes29] = ACTIONS(379),
    [anon_sym_bytes30] = ACTIONS(379),
    [anon_sym_bytes31] = ACTIONS(379),
    [anon_sym_bytes32] = ACTIONS(379),
    [anon_sym_fixed] = ACTIONS(379),
    [aux_sym__fixed_token1] = ACTIONS(379),
    [anon_sym_ufixed] = ACTIONS(379),
    [aux_sym__ufixed_token1] = ACTIONS(379),
    [aux_sym__decimal_number_token1] = ACTIONS(379),
    [aux_sym__decimal_number_token2] = ACTIONS(381),
    [aux_sym__hex_number_token1] = ACTIONS(381),
    [anon_sym_hex] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(381),
    [anon_sym_SQUOTE] = ACTIONS(381),
    [anon_sym_unicode] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_identifier] = ACTIONS(383),
    [anon_sym_DASH] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(385),
    [anon_sym_RBRACE] = ACTIONS(385),
    [anon_sym_type] = ACTIONS(383),
    [anon_sym_LPAREN] = ACTIONS(385),
    [anon_sym_for] = ACTIONS(383),
    [anon_sym_assembly] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(383),
    [anon_sym_continue] = ACTIONS(383),
    [anon_sym_true] = ACTIONS(383),
    [anon_sym_false] = ACTIONS(383),
    [anon_sym_if] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(383),
    [anon_sym_byte] = ACTIONS(383),
    [anon_sym_address] = ACTIONS(383),
    [anon_sym_return] = ACTIONS(383),
    [anon_sym_revert] = ACTIONS(383),
    [sym_unchecked] = ACTIONS(383),
    [anon_sym_var] = ACTIONS(383),
    [anon_sym_else] = ACTIONS(383),
    [anon_sym_while] = ACTIONS(383),
    [anon_sym_do] = ACTIONS(383),
    [anon_sym_try] = ACTIONS(383),
    [anon_sym_catch] = ACTIONS(383),
    [anon_sym_emit] = ACTIONS(383),
    [anon_sym_payable] = ACTIONS(383),
    [anon_sym_new] = ACTIONS(383),
    [anon_sym_LBRACK] = ACTIONS(385),
    [anon_sym_PLUS] = ACTIONS(383),
    [anon_sym_BANG] = ACTIONS(385),
    [anon_sym_delete] = ACTIONS(383),
    [anon_sym_PLUS_PLUS] = ACTIONS(385),
    [anon_sym_DASH_DASH] = ACTIONS(385),
    [anon_sym_mapping] = ACTIONS(383),
    [anon_sym_bool] = ACTIONS(383),
    [anon_sym_string] = ACTIONS(383),
    [anon_sym_int] = ACTIONS(383),
    [anon_sym_int8] = ACTIONS(383),
    [anon_sym_int16] = ACTIONS(383),
    [anon_sym_int24] = ACTIONS(383),
    [anon_sym_int32] = ACTIONS(383),
    [anon_sym_int40] = ACTIONS(383),
    [anon_sym_int48] = ACTIONS(383),
    [anon_sym_int56] = ACTIONS(383),
    [anon_sym_int64] = ACTIONS(383),
    [anon_sym_int72] = ACTIONS(383),
    [anon_sym_int80] = ACTIONS(383),
    [anon_sym_int88] = ACTIONS(383),
    [anon_sym_int96] = ACTIONS(383),
    [anon_sym_int104] = ACTIONS(383),
    [anon_sym_int112] = ACTIONS(383),
    [anon_sym_int120] = ACTIONS(383),
    [anon_sym_int128] = ACTIONS(383),
    [anon_sym_int136] = ACTIONS(383),
    [anon_sym_int144] = ACTIONS(383),
    [anon_sym_int152] = ACTIONS(383),
    [anon_sym_int160] = ACTIONS(383),
    [anon_sym_int168] = ACTIONS(383),
    [anon_sym_int176] = ACTIONS(383),
    [anon_sym_int184] = ACTIONS(383),
    [anon_sym_int192] = ACTIONS(383),
    [anon_sym_int200] = ACTIONS(383),
    [anon_sym_int208] = ACTIONS(383),
    [anon_sym_int216] = ACTIONS(383),
    [anon_sym_int224] = ACTIONS(383),
    [anon_sym_int232] = ACTIONS(383),
    [anon_sym_int240] = ACTIONS(383),
    [anon_sym_int248] = ACTIONS(383),
    [anon_sym_int256] = ACTIONS(383),
    [anon_sym_uint] = ACTIONS(383),
    [anon_sym_uint8] = ACTIONS(383),
    [anon_sym_uint16] = ACTIONS(383),
    [anon_sym_uint24] = ACTIONS(383),
    [anon_sym_uint32] = ACTIONS(383),
    [anon_sym_uint40] = ACTIONS(383),
    [anon_sym_uint48] = ACTIONS(383),
    [anon_sym_uint56] = ACTIONS(383),
    [anon_sym_uint64] = ACTIONS(383),
    [anon_sym_uint72] = ACTIONS(383),
    [anon_sym_uint80] = ACTIONS(383),
    [anon_sym_uint88] = ACTIONS(383),
    [anon_sym_uint96] = ACTIONS(383),
    [anon_sym_uint104] = ACTIONS(383),
    [anon_sym_uint112] = ACTIONS(383),
    [anon_sym_uint120] = ACTIONS(383),
    [anon_sym_uint128] = ACTIONS(383),
    [anon_sym_uint136] = ACTIONS(383),
    [anon_sym_uint144] = ACTIONS(383),
    [anon_sym_uint152] = ACTIONS(383),
    [anon_sym_uint160] = ACTIONS(383),
    [anon_sym_uint168] = ACTIONS(383),
    [anon_sym_uint176] = ACTIONS(383),
    [anon_sym_uint184] = ACTIONS(383),
    [anon_sym_uint192] = ACTIONS(383),
    [anon_sym_uint200] = ACTIONS(383),
    [anon_sym_uint208] = ACTIONS(383),
    [anon_sym_uint216] = ACTIONS(383),
    [anon_sym_uint224] = ACTIONS(383),
    [anon_sym_uint232] = ACTIONS(383),
    [anon_sym_uint240] = ACTIONS(383),
    [anon_sym_uint248] = ACTIONS(383),
    [anon_sym_uint256] = ACTIONS(383),
    [anon_sym_bytes] = ACTIONS(383),
    [anon_sym_bytes1] = ACTIONS(383),
    [anon_sym_bytes2] = ACTIONS(383),
    [anon_sym_bytes3] = ACTIONS(383),
    [anon_sym_bytes4] = ACTIONS(383),
    [anon_sym_bytes5] = ACTIONS(383),
    [anon_sym_bytes6] = ACTIONS(383),
    [anon_sym_bytes7] = ACTIONS(383),
    [anon_sym_bytes8] = ACTIONS(383),
    [anon_sym_bytes9] = ACTIONS(383),
    [anon_sym_bytes10] = ACTIONS(383),
    [anon_sym_bytes11] = ACTIONS(383),
    [anon_sym_bytes12] = ACTIONS(383),
    [anon_sym_bytes13] = ACTIONS(383),
    [anon_sym_bytes14] = ACTIONS(383),
    [anon_sym_bytes15] = ACTIONS(383),
    [anon_sym_bytes16] = ACTIONS(383),
    [anon_sym_bytes17] = ACTIONS(383),
    [anon_sym_bytes18] = ACTIONS(383),
    [anon_sym_bytes19] = ACTIONS(383),
    [anon_sym_bytes20] = ACTIONS(383),
    [anon_sym_bytes21] = ACTIONS(383),
    [anon_sym_bytes22] = ACTIONS(383),
    [anon_sym_bytes23] = ACTIONS(383),
    [anon_sym_bytes24] = ACTIONS(383),
    [anon_sym_bytes25] = ACTIONS(383),
    [anon_sym_bytes26] = ACTIONS(383),
    [anon_sym_bytes27] = ACTIONS(383),
    [anon_sym_bytes28] = ACTIONS(383),
    [anon_sym_bytes29] = ACTIONS(383),
    [anon_sym_bytes30] = ACTIONS(383),
    [anon_sym_bytes31] = ACTIONS(383),
    [anon_sym_bytes32] = ACTIONS(383),
    [anon_sym_fixed] = ACTIONS(383),
    [aux_sym__fixed_token1] = ACTIONS(383),
    [anon_sym_ufixed] = ACTIONS(383),
    [aux_sym__ufixed_token1] = ACTIONS(383),
    [aux_sym__decimal_number_token1] = ACTIONS(383),
    [aux_sym__decimal_number_token2] = ACTIONS(385),
    [aux_sym__hex_number_token1] = ACTIONS(385),
    [anon_sym_hex] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(385),
    [anon_sym_SQUOTE] = ACTIONS(385),
    [anon_sym_unicode] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_identifier] = ACTIONS(387),
    [anon_sym_DASH] = ACTIONS(387),
    [anon_sym_TILDE] = ACTIONS(389),
    [anon_sym_LBRACE] = ACTIONS(389),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_type] = ACTIONS(387),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_for] = ACTIONS(387),
    [anon_sym_assembly] = ACTIONS(387),
    [anon_sym_break] = ACTIONS(387),
    [anon_sym_continue] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(387),
    [anon_sym_false] = ACTIONS(387),
    [anon_sym_if] = ACTIONS(387),
    [anon_sym_function] = ACTIONS(387),
    [anon_sym_byte] = ACTIONS(387),
    [anon_sym_address] = ACTIONS(387),
    [anon_sym_return] = ACTIONS(387),
    [anon_sym_revert] = ACTIONS(387),
    [sym_unchecked] = ACTIONS(387),
    [anon_sym_var] = ACTIONS(387),
    [anon_sym_else] = ACTIONS(387),
    [anon_sym_while] = ACTIONS(387),
    [anon_sym_do] = ACTIONS(387),
    [anon_sym_try] = ACTIONS(387),
    [anon_sym_catch] = ACTIONS(387),
    [anon_sym_emit] = ACTIONS(387),
    [anon_sym_payable] = ACTIONS(387),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(387),
    [anon_sym_BANG] = ACTIONS(389),
    [anon_sym_delete] = ACTIONS(387),
    [anon_sym_PLUS_PLUS] = ACTIONS(389),
    [anon_sym_DASH_DASH] = ACTIONS(389),
    [anon_sym_mapping] = ACTIONS(387),
    [anon_sym_bool] = ACTIONS(387),
    [anon_sym_string] = ACTIONS(387),
    [anon_sym_int] = ACTIONS(387),
    [anon_sym_int8] = ACTIONS(387),
    [anon_sym_int16] = ACTIONS(387),
    [anon_sym_int24] = ACTIONS(387),
    [anon_sym_int32] = ACTIONS(387),
    [anon_sym_int40] = ACTIONS(387),
    [anon_sym_int48] = ACTIONS(387),
    [anon_sym_int56] = ACTIONS(387),
    [anon_sym_int64] = ACTIONS(387),
    [anon_sym_int72] = ACTIONS(387),
    [anon_sym_int80] = ACTIONS(387),
    [anon_sym_int88] = ACTIONS(387),
    [anon_sym_int96] = ACTIONS(387),
    [anon_sym_int104] = ACTIONS(387),
    [anon_sym_int112] = ACTIONS(387),
    [anon_sym_int120] = ACTIONS(387),
    [anon_sym_int128] = ACTIONS(387),
    [anon_sym_int136] = ACTIONS(387),
    [anon_sym_int144] = ACTIONS(387),
    [anon_sym_int152] = ACTIONS(387),
    [anon_sym_int160] = ACTIONS(387),
    [anon_sym_int168] = ACTIONS(387),
    [anon_sym_int176] = ACTIONS(387),
    [anon_sym_int184] = ACTIONS(387),
    [anon_sym_int192] = ACTIONS(387),
    [anon_sym_int200] = ACTIONS(387),
    [anon_sym_int208] = ACTIONS(387),
    [anon_sym_int216] = ACTIONS(387),
    [anon_sym_int224] = ACTIONS(387),
    [anon_sym_int232] = ACTIONS(387),
    [anon_sym_int240] = ACTIONS(387),
    [anon_sym_int248] = ACTIONS(387),
    [anon_sym_int256] = ACTIONS(387),
    [anon_sym_uint] = ACTIONS(387),
    [anon_sym_uint8] = ACTIONS(387),
    [anon_sym_uint16] = ACTIONS(387),
    [anon_sym_uint24] = ACTIONS(387),
    [anon_sym_uint32] = ACTIONS(387),
    [anon_sym_uint40] = ACTIONS(387),
    [anon_sym_uint48] = ACTIONS(387),
    [anon_sym_uint56] = ACTIONS(387),
    [anon_sym_uint64] = ACTIONS(387),
    [anon_sym_uint72] = ACTIONS(387),
    [anon_sym_uint80] = ACTIONS(387),
    [anon_sym_uint88] = ACTIONS(387),
    [anon_sym_uint96] = ACTIONS(387),
    [anon_sym_uint104] = ACTIONS(387),
    [anon_sym_uint112] = ACTIONS(387),
    [anon_sym_uint120] = ACTIONS(387),
    [anon_sym_uint128] = ACTIONS(387),
    [anon_sym_uint136] = ACTIONS(387),
    [anon_sym_uint144] = ACTIONS(387),
    [anon_sym_uint152] = ACTIONS(387),
    [anon_sym_uint160] = ACTIONS(387),
    [anon_sym_uint168] = ACTIONS(387),
    [anon_sym_uint176] = ACTIONS(387),
    [anon_sym_uint184] = ACTIONS(387),
    [anon_sym_uint192] = ACTIONS(387),
    [anon_sym_uint200] = ACTIONS(387),
    [anon_sym_uint208] = ACTIONS(387),
    [anon_sym_uint216] = ACTIONS(387),
    [anon_sym_uint224] = ACTIONS(387),
    [anon_sym_uint232] = ACTIONS(387),
    [anon_sym_uint240] = ACTIONS(387),
    [anon_sym_uint248] = ACTIONS(387),
    [anon_sym_uint256] = ACTIONS(387),
    [anon_sym_bytes] = ACTIONS(387),
    [anon_sym_bytes1] = ACTIONS(387),
    [anon_sym_bytes2] = ACTIONS(387),
    [anon_sym_bytes3] = ACTIONS(387),
    [anon_sym_bytes4] = ACTIONS(387),
    [anon_sym_bytes5] = ACTIONS(387),
    [anon_sym_bytes6] = ACTIONS(387),
    [anon_sym_bytes7] = ACTIONS(387),
    [anon_sym_bytes8] = ACTIONS(387),
    [anon_sym_bytes9] = ACTIONS(387),
    [anon_sym_bytes10] = ACTIONS(387),
    [anon_sym_bytes11] = ACTIONS(387),
    [anon_sym_bytes12] = ACTIONS(387),
    [anon_sym_bytes13] = ACTIONS(387),
    [anon_sym_bytes14] = ACTIONS(387),
    [anon_sym_bytes15] = ACTIONS(387),
    [anon_sym_bytes16] = ACTIONS(387),
    [anon_sym_bytes17] = ACTIONS(387),
    [anon_sym_bytes18] = ACTIONS(387),
    [anon_sym_bytes19] = ACTIONS(387),
    [anon_sym_bytes20] = ACTIONS(387),
    [anon_sym_bytes21] = ACTIONS(387),
    [anon_sym_bytes22] = ACTIONS(387),
    [anon_sym_bytes23] = ACTIONS(387),
    [anon_sym_bytes24] = ACTIONS(387),
    [anon_sym_bytes25] = ACTIONS(387),
    [anon_sym_bytes26] = ACTIONS(387),
    [anon_sym_bytes27] = ACTIONS(387),
    [anon_sym_bytes28] = ACTIONS(387),
    [anon_sym_bytes29] = ACTIONS(387),
    [anon_sym_bytes30] = ACTIONS(387),
    [anon_sym_bytes31] = ACTIONS(387),
    [anon_sym_bytes32] = ACTIONS(387),
    [anon_sym_fixed] = ACTIONS(387),
    [aux_sym__fixed_token1] = ACTIONS(387),
    [anon_sym_ufixed] = ACTIONS(387),
    [aux_sym__ufixed_token1] = ACTIONS(387),
    [aux_sym__decimal_number_token1] = ACTIONS(387),
    [aux_sym__decimal_number_token2] = ACTIONS(389),
    [aux_sym__hex_number_token1] = ACTIONS(389),
    [anon_sym_hex] = ACTIONS(387),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_SQUOTE] = ACTIONS(389),
    [anon_sym_unicode] = ACTIONS(387),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_identifier] = ACTIONS(391),
    [anon_sym_DASH] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_LBRACE] = ACTIONS(393),
    [anon_sym_RBRACE] = ACTIONS(393),
    [anon_sym_type] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(393),
    [anon_sym_for] = ACTIONS(391),
    [anon_sym_assembly] = ACTIONS(391),
    [anon_sym_break] = ACTIONS(391),
    [anon_sym_continue] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(391),
    [anon_sym_false] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_function] = ACTIONS(391),
    [anon_sym_byte] = ACTIONS(391),
    [anon_sym_address] = ACTIONS(391),
    [anon_sym_return] = ACTIONS(391),
    [anon_sym_revert] = ACTIONS(391),
    [sym_unchecked] = ACTIONS(391),
    [anon_sym_var] = ACTIONS(391),
    [anon_sym_else] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(391),
    [anon_sym_do] = ACTIONS(391),
    [anon_sym_try] = ACTIONS(391),
    [anon_sym_catch] = ACTIONS(391),
    [anon_sym_emit] = ACTIONS(391),
    [anon_sym_payable] = ACTIONS(391),
    [anon_sym_new] = ACTIONS(391),
    [anon_sym_LBRACK] = ACTIONS(393),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_delete] = ACTIONS(391),
    [anon_sym_PLUS_PLUS] = ACTIONS(393),
    [anon_sym_DASH_DASH] = ACTIONS(393),
    [anon_sym_mapping] = ACTIONS(391),
    [anon_sym_bool] = ACTIONS(391),
    [anon_sym_string] = ACTIONS(391),
    [anon_sym_int] = ACTIONS(391),
    [anon_sym_int8] = ACTIONS(391),
    [anon_sym_int16] = ACTIONS(391),
    [anon_sym_int24] = ACTIONS(391),
    [anon_sym_int32] = ACTIONS(391),
    [anon_sym_int40] = ACTIONS(391),
    [anon_sym_int48] = ACTIONS(391),
    [anon_sym_int56] = ACTIONS(391),
    [anon_sym_int64] = ACTIONS(391),
    [anon_sym_int72] = ACTIONS(391),
    [anon_sym_int80] = ACTIONS(391),
    [anon_sym_int88] = ACTIONS(391),
    [anon_sym_int96] = ACTIONS(391),
    [anon_sym_int104] = ACTIONS(391),
    [anon_sym_int112] = ACTIONS(391),
    [anon_sym_int120] = ACTIONS(391),
    [anon_sym_int128] = ACTIONS(391),
    [anon_sym_int136] = ACTIONS(391),
    [anon_sym_int144] = ACTIONS(391),
    [anon_sym_int152] = ACTIONS(391),
    [anon_sym_int160] = ACTIONS(391),
    [anon_sym_int168] = ACTIONS(391),
    [anon_sym_int176] = ACTIONS(391),
    [anon_sym_int184] = ACTIONS(391),
    [anon_sym_int192] = ACTIONS(391),
    [anon_sym_int200] = ACTIONS(391),
    [anon_sym_int208] = ACTIONS(391),
    [anon_sym_int216] = ACTIONS(391),
    [anon_sym_int224] = ACTIONS(391),
    [anon_sym_int232] = ACTIONS(391),
    [anon_sym_int240] = ACTIONS(391),
    [anon_sym_int248] = ACTIONS(391),
    [anon_sym_int256] = ACTIONS(391),
    [anon_sym_uint] = ACTIONS(391),
    [anon_sym_uint8] = ACTIONS(391),
    [anon_sym_uint16] = ACTIONS(391),
    [anon_sym_uint24] = ACTIONS(391),
    [anon_sym_uint32] = ACTIONS(391),
    [anon_sym_uint40] = ACTIONS(391),
    [anon_sym_uint48] = ACTIONS(391),
    [anon_sym_uint56] = ACTIONS(391),
    [anon_sym_uint64] = ACTIONS(391),
    [anon_sym_uint72] = ACTIONS(391),
    [anon_sym_uint80] = ACTIONS(391),
    [anon_sym_uint88] = ACTIONS(391),
    [anon_sym_uint96] = ACTIONS(391),
    [anon_sym_uint104] = ACTIONS(391),
    [anon_sym_uint112] = ACTIONS(391),
    [anon_sym_uint120] = ACTIONS(391),
    [anon_sym_uint128] = ACTIONS(391),
    [anon_sym_uint136] = ACTIONS(391),
    [anon_sym_uint144] = ACTIONS(391),
    [anon_sym_uint152] = ACTIONS(391),
    [anon_sym_uint160] = ACTIONS(391),
    [anon_sym_uint168] = ACTIONS(391),
    [anon_sym_uint176] = ACTIONS(391),
    [anon_sym_uint184] = ACTIONS(391),
    [anon_sym_uint192] = ACTIONS(391),
    [anon_sym_uint200] = ACTIONS(391),
    [anon_sym_uint208] = ACTIONS(391),
    [anon_sym_uint216] = ACTIONS(391),
    [anon_sym_uint224] = ACTIONS(391),
    [anon_sym_uint232] = ACTIONS(391),
    [anon_sym_uint240] = ACTIONS(391),
    [anon_sym_uint248] = ACTIONS(391),
    [anon_sym_uint256] = ACTIONS(391),
    [anon_sym_bytes] = ACTIONS(391),
    [anon_sym_bytes1] = ACTIONS(391),
    [anon_sym_bytes2] = ACTIONS(391),
    [anon_sym_bytes3] = ACTIONS(391),
    [anon_sym_bytes4] = ACTIONS(391),
    [anon_sym_bytes5] = ACTIONS(391),
    [anon_sym_bytes6] = ACTIONS(391),
    [anon_sym_bytes7] = ACTIONS(391),
    [anon_sym_bytes8] = ACTIONS(391),
    [anon_sym_bytes9] = ACTIONS(391),
    [anon_sym_bytes10] = ACTIONS(391),
    [anon_sym_bytes11] = ACTIONS(391),
    [anon_sym_bytes12] = ACTIONS(391),
    [anon_sym_bytes13] = ACTIONS(391),
    [anon_sym_bytes14] = ACTIONS(391),
    [anon_sym_bytes15] = ACTIONS(391),
    [anon_sym_bytes16] = ACTIONS(391),
    [anon_sym_bytes17] = ACTIONS(391),
    [anon_sym_bytes18] = ACTIONS(391),
    [anon_sym_bytes19] = ACTIONS(391),
    [anon_sym_bytes20] = ACTIONS(391),
    [anon_sym_bytes21] = ACTIONS(391),
    [anon_sym_bytes22] = ACTIONS(391),
    [anon_sym_bytes23] = ACTIONS(391),
    [anon_sym_bytes24] = ACTIONS(391),
    [anon_sym_bytes25] = ACTIONS(391),
    [anon_sym_bytes26] = ACTIONS(391),
    [anon_sym_bytes27] = ACTIONS(391),
    [anon_sym_bytes28] = ACTIONS(391),
    [anon_sym_bytes29] = ACTIONS(391),
    [anon_sym_bytes30] = ACTIONS(391),
    [anon_sym_bytes31] = ACTIONS(391),
    [anon_sym_bytes32] = ACTIONS(391),
    [anon_sym_fixed] = ACTIONS(391),
    [aux_sym__fixed_token1] = ACTIONS(391),
    [anon_sym_ufixed] = ACTIONS(391),
    [aux_sym__ufixed_token1] = ACTIONS(391),
    [aux_sym__decimal_number_token1] = ACTIONS(391),
    [aux_sym__decimal_number_token2] = ACTIONS(393),
    [aux_sym__hex_number_token1] = ACTIONS(393),
    [anon_sym_hex] = ACTIONS(391),
    [anon_sym_DQUOTE] = ACTIONS(393),
    [anon_sym_SQUOTE] = ACTIONS(393),
    [anon_sym_unicode] = ACTIONS(391),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_identifier] = ACTIONS(395),
    [anon_sym_DASH] = ACTIONS(395),
    [anon_sym_TILDE] = ACTIONS(397),
    [anon_sym_LBRACE] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(397),
    [anon_sym_type] = ACTIONS(395),
    [anon_sym_LPAREN] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(395),
    [anon_sym_assembly] = ACTIONS(395),
    [anon_sym_break] = ACTIONS(395),
    [anon_sym_continue] = ACTIONS(395),
    [anon_sym_true] = ACTIONS(395),
    [anon_sym_false] = ACTIONS(395),
    [anon_sym_if] = ACTIONS(395),
    [anon_sym_function] = ACTIONS(395),
    [anon_sym_byte] = ACTIONS(395),
    [anon_sym_address] = ACTIONS(395),
    [anon_sym_return] = ACTIONS(395),
    [anon_sym_revert] = ACTIONS(395),
    [sym_unchecked] = ACTIONS(395),
    [anon_sym_var] = ACTIONS(395),
    [anon_sym_else] = ACTIONS(395),
    [anon_sym_while] = ACTIONS(395),
    [anon_sym_do] = ACTIONS(395),
    [anon_sym_try] = ACTIONS(395),
    [anon_sym_catch] = ACTIONS(395),
    [anon_sym_emit] = ACTIONS(395),
    [anon_sym_payable] = ACTIONS(395),
    [anon_sym_new] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_mapping] = ACTIONS(395),
    [anon_sym_bool] = ACTIONS(395),
    [anon_sym_string] = ACTIONS(395),
    [anon_sym_int] = ACTIONS(395),
    [anon_sym_int8] = ACTIONS(395),
    [anon_sym_int16] = ACTIONS(395),
    [anon_sym_int24] = ACTIONS(395),
    [anon_sym_int32] = ACTIONS(395),
    [anon_sym_int40] = ACTIONS(395),
    [anon_sym_int48] = ACTIONS(395),
    [anon_sym_int56] = ACTIONS(395),
    [anon_sym_int64] = ACTIONS(395),
    [anon_sym_int72] = ACTIONS(395),
    [anon_sym_int80] = ACTIONS(395),
    [anon_sym_int88] = ACTIONS(395),
    [anon_sym_int96] = ACTIONS(395),
    [anon_sym_int104] = ACTIONS(395),
    [anon_sym_int112] = ACTIONS(395),
    [anon_sym_int120] = ACTIONS(395),
    [anon_sym_int128] = ACTIONS(395),
    [anon_sym_int136] = ACTIONS(395),
    [anon_sym_int144] = ACTIONS(395),
    [anon_sym_int152] = ACTIONS(395),
    [anon_sym_int160] = ACTIONS(395),
    [anon_sym_int168] = ACTIONS(395),
    [anon_sym_int176] = ACTIONS(395),
    [anon_sym_int184] = ACTIONS(395),
    [anon_sym_int192] = ACTIONS(395),
    [anon_sym_int200] = ACTIONS(395),
    [anon_sym_int208] = ACTIONS(395),
    [anon_sym_int216] = ACTIONS(395),
    [anon_sym_int224] = ACTIONS(395),
    [anon_sym_int232] = ACTIONS(395),
    [anon_sym_int240] = ACTIONS(395),
    [anon_sym_int248] = ACTIONS(395),
    [anon_sym_int256] = ACTIONS(395),
    [anon_sym_uint] = ACTIONS(395),
    [anon_sym_uint8] = ACTIONS(395),
    [anon_sym_uint16] = ACTIONS(395),
    [anon_sym_uint24] = ACTIONS(395),
    [anon_sym_uint32] = ACTIONS(395),
    [anon_sym_uint40] = ACTIONS(395),
    [anon_sym_uint48] = ACTIONS(395),
    [anon_sym_uint56] = ACTIONS(395),
    [anon_sym_uint64] = ACTIONS(395),
    [anon_sym_uint72] = ACTIONS(395),
    [anon_sym_uint80] = ACTIONS(395),
    [anon_sym_uint88] = ACTIONS(395),
    [anon_sym_uint96] = ACTIONS(395),
    [anon_sym_uint104] = ACTIONS(395),
    [anon_sym_uint112] = ACTIONS(395),
    [anon_sym_uint120] = ACTIONS(395),
    [anon_sym_uint128] = ACTIONS(395),
    [anon_sym_uint136] = ACTIONS(395),
    [anon_sym_uint144] = ACTIONS(395),
    [anon_sym_uint152] = ACTIONS(395),
    [anon_sym_uint160] = ACTIONS(395),
    [anon_sym_uint168] = ACTIONS(395),
    [anon_sym_uint176] = ACTIONS(395),
    [anon_sym_uint184] = ACTIONS(395),
    [anon_sym_uint192] = ACTIONS(395),
    [anon_sym_uint200] = ACTIONS(395),
    [anon_sym_uint208] = ACTIONS(395),
    [anon_sym_uint216] = ACTIONS(395),
    [anon_sym_uint224] = ACTIONS(395),
    [anon_sym_uint232] = ACTIONS(395),
    [anon_sym_uint240] = ACTIONS(395),
    [anon_sym_uint248] = ACTIONS(395),
    [anon_sym_uint256] = ACTIONS(395),
    [anon_sym_bytes] = ACTIONS(395),
    [anon_sym_bytes1] = ACTIONS(395),
    [anon_sym_bytes2] = ACTIONS(395),
    [anon_sym_bytes3] = ACTIONS(395),
    [anon_sym_bytes4] = ACTIONS(395),
    [anon_sym_bytes5] = ACTIONS(395),
    [anon_sym_bytes6] = ACTIONS(395),
    [anon_sym_bytes7] = ACTIONS(395),
    [anon_sym_bytes8] = ACTIONS(395),
    [anon_sym_bytes9] = ACTIONS(395),
    [anon_sym_bytes10] = ACTIONS(395),
    [anon_sym_bytes11] = ACTIONS(395),
    [anon_sym_bytes12] = ACTIONS(395),
    [anon_sym_bytes13] = ACTIONS(395),
    [anon_sym_bytes14] = ACTIONS(395),
    [anon_sym_bytes15] = ACTIONS(395),
    [anon_sym_bytes16] = ACTIONS(395),
    [anon_sym_bytes17] = ACTIONS(395),
    [anon_sym_bytes18] = ACTIONS(395),
    [anon_sym_bytes19] = ACTIONS(395),
    [anon_sym_bytes20] = ACTIONS(395),
    [anon_sym_bytes21] = ACTIONS(395),
    [anon_sym_bytes22] = ACTIONS(395),
    [anon_sym_bytes23] = ACTIONS(395),
    [anon_sym_bytes24] = ACTIONS(395),
    [anon_sym_bytes25] = ACTIONS(395),
    [anon_sym_bytes26] = ACTIONS(395),
    [anon_sym_bytes27] = ACTIONS(395),
    [anon_sym_bytes28] = ACTIONS(395),
    [anon_sym_bytes29] = ACTIONS(395),
    [anon_sym_bytes30] = ACTIONS(395),
    [anon_sym_bytes31] = ACTIONS(395),
    [anon_sym_bytes32] = ACTIONS(395),
    [anon_sym_fixed] = ACTIONS(395),
    [aux_sym__fixed_token1] = ACTIONS(395),
    [anon_sym_ufixed] = ACTIONS(395),
    [aux_sym__ufixed_token1] = ACTIONS(395),
    [aux_sym__decimal_number_token1] = ACTIONS(395),
    [aux_sym__decimal_number_token2] = ACTIONS(397),
    [aux_sym__hex_number_token1] = ACTIONS(397),
    [anon_sym_hex] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(397),
    [anon_sym_unicode] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_identifier] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(401),
    [anon_sym_LBRACE] = ACTIONS(401),
    [anon_sym_RBRACE] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(399),
    [anon_sym_LPAREN] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(399),
    [anon_sym_assembly] = ACTIONS(399),
    [anon_sym_break] = ACTIONS(399),
    [anon_sym_continue] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(399),
    [anon_sym_false] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(399),
    [anon_sym_function] = ACTIONS(399),
    [anon_sym_byte] = ACTIONS(399),
    [anon_sym_address] = ACTIONS(399),
    [anon_sym_return] = ACTIONS(399),
    [anon_sym_revert] = ACTIONS(399),
    [sym_unchecked] = ACTIONS(399),
    [anon_sym_var] = ACTIONS(399),
    [anon_sym_else] = ACTIONS(399),
    [anon_sym_while] = ACTIONS(399),
    [anon_sym_do] = ACTIONS(399),
    [anon_sym_try] = ACTIONS(399),
    [anon_sym_emit] = ACTIONS(399),
    [anon_sym_payable] = ACTIONS(399),
    [anon_sym_new] = ACTIONS(399),
    [anon_sym_LBRACK] = ACTIONS(401),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_delete] = ACTIONS(399),
    [anon_sym_PLUS_PLUS] = ACTIONS(401),
    [anon_sym_DASH_DASH] = ACTIONS(401),
    [anon_sym_mapping] = ACTIONS(399),
    [anon_sym_bool] = ACTIONS(399),
    [anon_sym_string] = ACTIONS(399),
    [anon_sym_int] = ACTIONS(399),
    [anon_sym_int8] = ACTIONS(399),
    [anon_sym_int16] = ACTIONS(399),
    [anon_sym_int24] = ACTIONS(399),
    [anon_sym_int32] = ACTIONS(399),
    [anon_sym_int40] = ACTIONS(399),
    [anon_sym_int48] = ACTIONS(399),
    [anon_sym_int56] = ACTIONS(399),
    [anon_sym_int64] = ACTIONS(399),
    [anon_sym_int72] = ACTIONS(399),
    [anon_sym_int80] = ACTIONS(399),
    [anon_sym_int88] = ACTIONS(399),
    [anon_sym_int96] = ACTIONS(399),
    [anon_sym_int104] = ACTIONS(399),
    [anon_sym_int112] = ACTIONS(399),
    [anon_sym_int120] = ACTIONS(399),
    [anon_sym_int128] = ACTIONS(399),
    [anon_sym_int136] = ACTIONS(399),
    [anon_sym_int144] = ACTIONS(399),
    [anon_sym_int152] = ACTIONS(399),
    [anon_sym_int160] = ACTIONS(399),
    [anon_sym_int168] = ACTIONS(399),
    [anon_sym_int176] = ACTIONS(399),
    [anon_sym_int184] = ACTIONS(399),
    [anon_sym_int192] = ACTIONS(399),
    [anon_sym_int200] = ACTIONS(399),
    [anon_sym_int208] = ACTIONS(399),
    [anon_sym_int216] = ACTIONS(399),
    [anon_sym_int224] = ACTIONS(399),
    [anon_sym_int232] = ACTIONS(399),
    [anon_sym_int240] = ACTIONS(399),
    [anon_sym_int248] = ACTIONS(399),
    [anon_sym_int256] = ACTIONS(399),
    [anon_sym_uint] = ACTIONS(399),
    [anon_sym_uint8] = ACTIONS(399),
    [anon_sym_uint16] = ACTIONS(399),
    [anon_sym_uint24] = ACTIONS(399),
    [anon_sym_uint32] = ACTIONS(399),
    [anon_sym_uint40] = ACTIONS(399),
    [anon_sym_uint48] = ACTIONS(399),
    [anon_sym_uint56] = ACTIONS(399),
    [anon_sym_uint64] = ACTIONS(399),
    [anon_sym_uint72] = ACTIONS(399),
    [anon_sym_uint80] = ACTIONS(399),
    [anon_sym_uint88] = ACTIONS(399),
    [anon_sym_uint96] = ACTIONS(399),
    [anon_sym_uint104] = ACTIONS(399),
    [anon_sym_uint112] = ACTIONS(399),
    [anon_sym_uint120] = ACTIONS(399),
    [anon_sym_uint128] = ACTIONS(399),
    [anon_sym_uint136] = ACTIONS(399),
    [anon_sym_uint144] = ACTIONS(399),
    [anon_sym_uint152] = ACTIONS(399),
    [anon_sym_uint160] = ACTIONS(399),
    [anon_sym_uint168] = ACTIONS(399),
    [anon_sym_uint176] = ACTIONS(399),
    [anon_sym_uint184] = ACTIONS(399),
    [anon_sym_uint192] = ACTIONS(399),
    [anon_sym_uint200] = ACTIONS(399),
    [anon_sym_uint208] = ACTIONS(399),
    [anon_sym_uint216] = ACTIONS(399),
    [anon_sym_uint224] = ACTIONS(399),
    [anon_sym_uint232] = ACTIONS(399),
    [anon_sym_uint240] = ACTIONS(399),
    [anon_sym_uint248] = ACTIONS(399),
    [anon_sym_uint256] = ACTIONS(399),
    [anon_sym_bytes] = ACTIONS(399),
    [anon_sym_bytes1] = ACTIONS(399),
    [anon_sym_bytes2] = ACTIONS(399),
    [anon_sym_bytes3] = ACTIONS(399),
    [anon_sym_bytes4] = ACTIONS(399),
    [anon_sym_bytes5] = ACTIONS(399),
    [anon_sym_bytes6] = ACTIONS(399),
    [anon_sym_bytes7] = ACTIONS(399),
    [anon_sym_bytes8] = ACTIONS(399),
    [anon_sym_bytes9] = ACTIONS(399),
    [anon_sym_bytes10] = ACTIONS(399),
    [anon_sym_bytes11] = ACTIONS(399),
    [anon_sym_bytes12] = ACTIONS(399),
    [anon_sym_bytes13] = ACTIONS(399),
    [anon_sym_bytes14] = ACTIONS(399),
    [anon_sym_bytes15] = ACTIONS(399),
    [anon_sym_bytes16] = ACTIONS(399),
    [anon_sym_bytes17] = ACTIONS(399),
    [anon_sym_bytes18] = ACTIONS(399),
    [anon_sym_bytes19] = ACTIONS(399),
    [anon_sym_bytes20] = ACTIONS(399),
    [anon_sym_bytes21] = ACTIONS(399),
    [anon_sym_bytes22] = ACTIONS(399),
    [anon_sym_bytes23] = ACTIONS(399),
    [anon_sym_bytes24] = ACTIONS(399),
    [anon_sym_bytes25] = ACTIONS(399),
    [anon_sym_bytes26] = ACTIONS(399),
    [anon_sym_bytes27] = ACTIONS(399),
    [anon_sym_bytes28] = ACTIONS(399),
    [anon_sym_bytes29] = ACTIONS(399),
    [anon_sym_bytes30] = ACTIONS(399),
    [anon_sym_bytes31] = ACTIONS(399),
    [anon_sym_bytes32] = ACTIONS(399),
    [anon_sym_fixed] = ACTIONS(399),
    [aux_sym__fixed_token1] = ACTIONS(399),
    [anon_sym_ufixed] = ACTIONS(399),
    [aux_sym__ufixed_token1] = ACTIONS(399),
    [aux_sym__decimal_number_token1] = ACTIONS(399),
    [aux_sym__decimal_number_token2] = ACTIONS(401),
    [aux_sym__hex_number_token1] = ACTIONS(401),
    [anon_sym_hex] = ACTIONS(399),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [anon_sym_unicode] = ACTIONS(399),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_identifier] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(403),
    [anon_sym_TILDE] = ACTIONS(405),
    [anon_sym_LBRACE] = ACTIONS(405),
    [anon_sym_RBRACE] = ACTIONS(405),
    [anon_sym_type] = ACTIONS(403),
    [anon_sym_LPAREN] = ACTIONS(405),
    [anon_sym_for] = ACTIONS(403),
    [anon_sym_assembly] = ACTIONS(403),
    [anon_sym_break] = ACTIONS(403),
    [anon_sym_continue] = ACTIONS(403),
    [anon_sym_true] = ACTIONS(403),
    [anon_sym_false] = ACTIONS(403),
    [anon_sym_if] = ACTIONS(403),
    [anon_sym_function] = ACTIONS(403),
    [anon_sym_byte] = ACTIONS(403),
    [anon_sym_address] = ACTIONS(403),
    [anon_sym_return] = ACTIONS(403),
    [anon_sym_revert] = ACTIONS(403),
    [sym_unchecked] = ACTIONS(403),
    [anon_sym_var] = ACTIONS(403),
    [anon_sym_else] = ACTIONS(403),
    [anon_sym_while] = ACTIONS(403),
    [anon_sym_do] = ACTIONS(403),
    [anon_sym_try] = ACTIONS(403),
    [anon_sym_emit] = ACTIONS(403),
    [anon_sym_payable] = ACTIONS(403),
    [anon_sym_new] = ACTIONS(403),
    [anon_sym_LBRACK] = ACTIONS(405),
    [anon_sym_PLUS] = ACTIONS(403),
    [anon_sym_BANG] = ACTIONS(405),
    [anon_sym_delete] = ACTIONS(403),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_mapping] = ACTIONS(403),
    [anon_sym_bool] = ACTIONS(403),
    [anon_sym_string] = ACTIONS(403),
    [anon_sym_int] = ACTIONS(403),
    [anon_sym_int8] = ACTIONS(403),
    [anon_sym_int16] = ACTIONS(403),
    [anon_sym_int24] = ACTIONS(403),
    [anon_sym_int32] = ACTIONS(403),
    [anon_sym_int40] = ACTIONS(403),
    [anon_sym_int48] = ACTIONS(403),
    [anon_sym_int56] = ACTIONS(403),
    [anon_sym_int64] = ACTIONS(403),
    [anon_sym_int72] = ACTIONS(403),
    [anon_sym_int80] = ACTIONS(403),
    [anon_sym_int88] = ACTIONS(403),
    [anon_sym_int96] = ACTIONS(403),
    [anon_sym_int104] = ACTIONS(403),
    [anon_sym_int112] = ACTIONS(403),
    [anon_sym_int120] = ACTIONS(403),
    [anon_sym_int128] = ACTIONS(403),
    [anon_sym_int136] = ACTIONS(403),
    [anon_sym_int144] = ACTIONS(403),
    [anon_sym_int152] = ACTIONS(403),
    [anon_sym_int160] = ACTIONS(403),
    [anon_sym_int168] = ACTIONS(403),
    [anon_sym_int176] = ACTIONS(403),
    [anon_sym_int184] = ACTIONS(403),
    [anon_sym_int192] = ACTIONS(403),
    [anon_sym_int200] = ACTIONS(403),
    [anon_sym_int208] = ACTIONS(403),
    [anon_sym_int216] = ACTIONS(403),
    [anon_sym_int224] = ACTIONS(403),
    [anon_sym_int232] = ACTIONS(403),
    [anon_sym_int240] = ACTIONS(403),
    [anon_sym_int248] = ACTIONS(403),
    [anon_sym_int256] = ACTIONS(403),
    [anon_sym_uint] = ACTIONS(403),
    [anon_sym_uint8] = ACTIONS(403),
    [anon_sym_uint16] = ACTIONS(403),
    [anon_sym_uint24] = ACTIONS(403),
    [anon_sym_uint32] = ACTIONS(403),
    [anon_sym_uint40] = ACTIONS(403),
    [anon_sym_uint48] = ACTIONS(403),
    [anon_sym_uint56] = ACTIONS(403),
    [anon_sym_uint64] = ACTIONS(403),
    [anon_sym_uint72] = ACTIONS(403),
    [anon_sym_uint80] = ACTIONS(403),
    [anon_sym_uint88] = ACTIONS(403),
    [anon_sym_uint96] = ACTIONS(403),
    [anon_sym_uint104] = ACTIONS(403),
    [anon_sym_uint112] = ACTIONS(403),
    [anon_sym_uint120] = ACTIONS(403),
    [anon_sym_uint128] = ACTIONS(403),
    [anon_sym_uint136] = ACTIONS(403),
    [anon_sym_uint144] = ACTIONS(403),
    [anon_sym_uint152] = ACTIONS(403),
    [anon_sym_uint160] = ACTIONS(403),
    [anon_sym_uint168] = ACTIONS(403),
    [anon_sym_uint176] = ACTIONS(403),
    [anon_sym_uint184] = ACTIONS(403),
    [anon_sym_uint192] = ACTIONS(403),
    [anon_sym_uint200] = ACTIONS(403),
    [anon_sym_uint208] = ACTIONS(403),
    [anon_sym_uint216] = ACTIONS(403),
    [anon_sym_uint224] = ACTIONS(403),
    [anon_sym_uint232] = ACTIONS(403),
    [anon_sym_uint240] = ACTIONS(403),
    [anon_sym_uint248] = ACTIONS(403),
    [anon_sym_uint256] = ACTIONS(403),
    [anon_sym_bytes] = ACTIONS(403),
    [anon_sym_bytes1] = ACTIONS(403),
    [anon_sym_bytes2] = ACTIONS(403),
    [anon_sym_bytes3] = ACTIONS(403),
    [anon_sym_bytes4] = ACTIONS(403),
    [anon_sym_bytes5] = ACTIONS(403),
    [anon_sym_bytes6] = ACTIONS(403),
    [anon_sym_bytes7] = ACTIONS(403),
    [anon_sym_bytes8] = ACTIONS(403),
    [anon_sym_bytes9] = ACTIONS(403),
    [anon_sym_bytes10] = ACTIONS(403),
    [anon_sym_bytes11] = ACTIONS(403),
    [anon_sym_bytes12] = ACTIONS(403),
    [anon_sym_bytes13] = ACTIONS(403),
    [anon_sym_bytes14] = ACTIONS(403),
    [anon_sym_bytes15] = ACTIONS(403),
    [anon_sym_bytes16] = ACTIONS(403),
    [anon_sym_bytes17] = ACTIONS(403),
    [anon_sym_bytes18] = ACTIONS(403),
    [anon_sym_bytes19] = ACTIONS(403),
    [anon_sym_bytes20] = ACTIONS(403),
    [anon_sym_bytes21] = ACTIONS(403),
    [anon_sym_bytes22] = ACTIONS(403),
    [anon_sym_bytes23] = ACTIONS(403),
    [anon_sym_bytes24] = ACTIONS(403),
    [anon_sym_bytes25] = ACTIONS(403),
    [anon_sym_bytes26] = ACTIONS(403),
    [anon_sym_bytes27] = ACTIONS(403),
    [anon_sym_bytes28] = ACTIONS(403),
    [anon_sym_bytes29] = ACTIONS(403),
    [anon_sym_bytes30] = ACTIONS(403),
    [anon_sym_bytes31] = ACTIONS(403),
    [anon_sym_bytes32] = ACTIONS(403),
    [anon_sym_fixed] = ACTIONS(403),
    [aux_sym__fixed_token1] = ACTIONS(403),
    [anon_sym_ufixed] = ACTIONS(403),
    [aux_sym__ufixed_token1] = ACTIONS(403),
    [aux_sym__decimal_number_token1] = ACTIONS(403),
    [aux_sym__decimal_number_token2] = ACTIONS(405),
    [aux_sym__hex_number_token1] = ACTIONS(405),
    [anon_sym_hex] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_SQUOTE] = ACTIONS(405),
    [anon_sym_unicode] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_identifier] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(407),
    [anon_sym_TILDE] = ACTIONS(409),
    [anon_sym_LBRACE] = ACTIONS(409),
    [anon_sym_RBRACE] = ACTIONS(409),
    [anon_sym_type] = ACTIONS(407),
    [anon_sym_LPAREN] = ACTIONS(409),
    [anon_sym_for] = ACTIONS(407),
    [anon_sym_assembly] = ACTIONS(407),
    [anon_sym_break] = ACTIONS(407),
    [anon_sym_continue] = ACTIONS(407),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(407),
    [anon_sym_if] = ACTIONS(407),
    [anon_sym_function] = ACTIONS(407),
    [anon_sym_byte] = ACTIONS(407),
    [anon_sym_address] = ACTIONS(407),
    [anon_sym_return] = ACTIONS(407),
    [anon_sym_revert] = ACTIONS(407),
    [sym_unchecked] = ACTIONS(407),
    [anon_sym_var] = ACTIONS(407),
    [anon_sym_else] = ACTIONS(411),
    [anon_sym_while] = ACTIONS(407),
    [anon_sym_do] = ACTIONS(407),
    [anon_sym_try] = ACTIONS(407),
    [anon_sym_emit] = ACTIONS(407),
    [anon_sym_payable] = ACTIONS(407),
    [anon_sym_new] = ACTIONS(407),
    [anon_sym_LBRACK] = ACTIONS(409),
    [anon_sym_PLUS] = ACTIONS(407),
    [anon_sym_BANG] = ACTIONS(409),
    [anon_sym_delete] = ACTIONS(407),
    [anon_sym_PLUS_PLUS] = ACTIONS(409),
    [anon_sym_DASH_DASH] = ACTIONS(409),
    [anon_sym_mapping] = ACTIONS(407),
    [anon_sym_bool] = ACTIONS(407),
    [anon_sym_string] = ACTIONS(407),
    [anon_sym_int] = ACTIONS(407),
    [anon_sym_int8] = ACTIONS(407),
    [anon_sym_int16] = ACTIONS(407),
    [anon_sym_int24] = ACTIONS(407),
    [anon_sym_int32] = ACTIONS(407),
    [anon_sym_int40] = ACTIONS(407),
    [anon_sym_int48] = ACTIONS(407),
    [anon_sym_int56] = ACTIONS(407),
    [anon_sym_int64] = ACTIONS(407),
    [anon_sym_int72] = ACTIONS(407),
    [anon_sym_int80] = ACTIONS(407),
    [anon_sym_int88] = ACTIONS(407),
    [anon_sym_int96] = ACTIONS(407),
    [anon_sym_int104] = ACTIONS(407),
    [anon_sym_int112] = ACTIONS(407),
    [anon_sym_int120] = ACTIONS(407),
    [anon_sym_int128] = ACTIONS(407),
    [anon_sym_int136] = ACTIONS(407),
    [anon_sym_int144] = ACTIONS(407),
    [anon_sym_int152] = ACTIONS(407),
    [anon_sym_int160] = ACTIONS(407),
    [anon_sym_int168] = ACTIONS(407),
    [anon_sym_int176] = ACTIONS(407),
    [anon_sym_int184] = ACTIONS(407),
    [anon_sym_int192] = ACTIONS(407),
    [anon_sym_int200] = ACTIONS(407),
    [anon_sym_int208] = ACTIONS(407),
    [anon_sym_int216] = ACTIONS(407),
    [anon_sym_int224] = ACTIONS(407),
    [anon_sym_int232] = ACTIONS(407),
    [anon_sym_int240] = ACTIONS(407),
    [anon_sym_int248] = ACTIONS(407),
    [anon_sym_int256] = ACTIONS(407),
    [anon_sym_uint] = ACTIONS(407),
    [anon_sym_uint8] = ACTIONS(407),
    [anon_sym_uint16] = ACTIONS(407),
    [anon_sym_uint24] = ACTIONS(407),
    [anon_sym_uint32] = ACTIONS(407),
    [anon_sym_uint40] = ACTIONS(407),
    [anon_sym_uint48] = ACTIONS(407),
    [anon_sym_uint56] = ACTIONS(407),
    [anon_sym_uint64] = ACTIONS(407),
    [anon_sym_uint72] = ACTIONS(407),
    [anon_sym_uint80] = ACTIONS(407),
    [anon_sym_uint88] = ACTIONS(407),
    [anon_sym_uint96] = ACTIONS(407),
    [anon_sym_uint104] = ACTIONS(407),
    [anon_sym_uint112] = ACTIONS(407),
    [anon_sym_uint120] = ACTIONS(407),
    [anon_sym_uint128] = ACTIONS(407),
    [anon_sym_uint136] = ACTIONS(407),
    [anon_sym_uint144] = ACTIONS(407),
    [anon_sym_uint152] = ACTIONS(407),
    [anon_sym_uint160] = ACTIONS(407),
    [anon_sym_uint168] = ACTIONS(407),
    [anon_sym_uint176] = ACTIONS(407),
    [anon_sym_uint184] = ACTIONS(407),
    [anon_sym_uint192] = ACTIONS(407),
    [anon_sym_uint200] = ACTIONS(407),
    [anon_sym_uint208] = ACTIONS(407),
    [anon_sym_uint216] = ACTIONS(407),
    [anon_sym_uint224] = ACTIONS(407),
    [anon_sym_uint232] = ACTIONS(407),
    [anon_sym_uint240] = ACTIONS(407),
    [anon_sym_uint248] = ACTIONS(407),
    [anon_sym_uint256] = ACTIONS(407),
    [anon_sym_bytes] = ACTIONS(407),
    [anon_sym_bytes1] = ACTIONS(407),
    [anon_sym_bytes2] = ACTIONS(407),
    [anon_sym_bytes3] = ACTIONS(407),
    [anon_sym_bytes4] = ACTIONS(407),
    [anon_sym_bytes5] = ACTIONS(407),
    [anon_sym_bytes6] = ACTIONS(407),
    [anon_sym_bytes7] = ACTIONS(407),
    [anon_sym_bytes8] = ACTIONS(407),
    [anon_sym_bytes9] = ACTIONS(407),
    [anon_sym_bytes10] = ACTIONS(407),
    [anon_sym_bytes11] = ACTIONS(407),
    [anon_sym_bytes12] = ACTIONS(407),
    [anon_sym_bytes13] = ACTIONS(407),
    [anon_sym_bytes14] = ACTIONS(407),
    [anon_sym_bytes15] = ACTIONS(407),
    [anon_sym_bytes16] = ACTIONS(407),
    [anon_sym_bytes17] = ACTIONS(407),
    [anon_sym_bytes18] = ACTIONS(407),
    [anon_sym_bytes19] = ACTIONS(407),
    [anon_sym_bytes20] = ACTIONS(407),
    [anon_sym_bytes21] = ACTIONS(407),
    [anon_sym_bytes22] = ACTIONS(407),
    [anon_sym_bytes23] = ACTIONS(407),
    [anon_sym_bytes24] = ACTIONS(407),
    [anon_sym_bytes25] = ACTIONS(407),
    [anon_sym_bytes26] = ACTIONS(407),
    [anon_sym_bytes27] = ACTIONS(407),
    [anon_sym_bytes28] = ACTIONS(407),
    [anon_sym_bytes29] = ACTIONS(407),
    [anon_sym_bytes30] = ACTIONS(407),
    [anon_sym_bytes31] = ACTIONS(407),
    [anon_sym_bytes32] = ACTIONS(407),
    [anon_sym_fixed] = ACTIONS(407),
    [aux_sym__fixed_token1] = ACTIONS(407),
    [anon_sym_ufixed] = ACTIONS(407),
    [aux_sym__ufixed_token1] = ACTIONS(407),
    [aux_sym__decimal_number_token1] = ACTIONS(407),
    [aux_sym__decimal_number_token2] = ACTIONS(409),
    [aux_sym__hex_number_token1] = ACTIONS(409),
    [anon_sym_hex] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_SQUOTE] = ACTIONS(409),
    [anon_sym_unicode] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_identifier] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(415),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_type] = ACTIONS(413),
    [anon_sym_LPAREN] = ACTIONS(415),
    [anon_sym_for] = ACTIONS(413),
    [anon_sym_assembly] = ACTIONS(413),
    [anon_sym_break] = ACTIONS(413),
    [anon_sym_continue] = ACTIONS(413),
    [anon_sym_true] = ACTIONS(413),
    [anon_sym_false] = ACTIONS(413),
    [anon_sym_if] = ACTIONS(413),
    [anon_sym_function] = ACTIONS(413),
    [anon_sym_byte] = ACTIONS(413),
    [anon_sym_address] = ACTIONS(413),
    [anon_sym_return] = ACTIONS(413),
    [anon_sym_revert] = ACTIONS(413),
    [sym_unchecked] = ACTIONS(413),
    [anon_sym_var] = ACTIONS(413),
    [anon_sym_else] = ACTIONS(413),
    [anon_sym_while] = ACTIONS(413),
    [anon_sym_do] = ACTIONS(413),
    [anon_sym_try] = ACTIONS(413),
    [anon_sym_emit] = ACTIONS(413),
    [anon_sym_payable] = ACTIONS(413),
    [anon_sym_new] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_BANG] = ACTIONS(415),
    [anon_sym_delete] = ACTIONS(413),
    [anon_sym_PLUS_PLUS] = ACTIONS(415),
    [anon_sym_DASH_DASH] = ACTIONS(415),
    [anon_sym_mapping] = ACTIONS(413),
    [anon_sym_bool] = ACTIONS(413),
    [anon_sym_string] = ACTIONS(413),
    [anon_sym_int] = ACTIONS(413),
    [anon_sym_int8] = ACTIONS(413),
    [anon_sym_int16] = ACTIONS(413),
    [anon_sym_int24] = ACTIONS(413),
    [anon_sym_int32] = ACTIONS(413),
    [anon_sym_int40] = ACTIONS(413),
    [anon_sym_int48] = ACTIONS(413),
    [anon_sym_int56] = ACTIONS(413),
    [anon_sym_int64] = ACTIONS(413),
    [anon_sym_int72] = ACTIONS(413),
    [anon_sym_int80] = ACTIONS(413),
    [anon_sym_int88] = ACTIONS(413),
    [anon_sym_int96] = ACTIONS(413),
    [anon_sym_int104] = ACTIONS(413),
    [anon_sym_int112] = ACTIONS(413),
    [anon_sym_int120] = ACTIONS(413),
    [anon_sym_int128] = ACTIONS(413),
    [anon_sym_int136] = ACTIONS(413),
    [anon_sym_int144] = ACTIONS(413),
    [anon_sym_int152] = ACTIONS(413),
    [anon_sym_int160] = ACTIONS(413),
    [anon_sym_int168] = ACTIONS(413),
    [anon_sym_int176] = ACTIONS(413),
    [anon_sym_int184] = ACTIONS(413),
    [anon_sym_int192] = ACTIONS(413),
    [anon_sym_int200] = ACTIONS(413),
    [anon_sym_int208] = ACTIONS(413),
    [anon_sym_int216] = ACTIONS(413),
    [anon_sym_int224] = ACTIONS(413),
    [anon_sym_int232] = ACTIONS(413),
    [anon_sym_int240] = ACTIONS(413),
    [anon_sym_int248] = ACTIONS(413),
    [anon_sym_int256] = ACTIONS(413),
    [anon_sym_uint] = ACTIONS(413),
    [anon_sym_uint8] = ACTIONS(413),
    [anon_sym_uint16] = ACTIONS(413),
    [anon_sym_uint24] = ACTIONS(413),
    [anon_sym_uint32] = ACTIONS(413),
    [anon_sym_uint40] = ACTIONS(413),
    [anon_sym_uint48] = ACTIONS(413),
    [anon_sym_uint56] = ACTIONS(413),
    [anon_sym_uint64] = ACTIONS(413),
    [anon_sym_uint72] = ACTIONS(413),
    [anon_sym_uint80] = ACTIONS(413),
    [anon_sym_uint88] = ACTIONS(413),
    [anon_sym_uint96] = ACTIONS(413),
    [anon_sym_uint104] = ACTIONS(413),
    [anon_sym_uint112] = ACTIONS(413),
    [anon_sym_uint120] = ACTIONS(413),
    [anon_sym_uint128] = ACTIONS(413),
    [anon_sym_uint136] = ACTIONS(413),
    [anon_sym_uint144] = ACTIONS(413),
    [anon_sym_uint152] = ACTIONS(413),
    [anon_sym_uint160] = ACTIONS(413),
    [anon_sym_uint168] = ACTIONS(413),
    [anon_sym_uint176] = ACTIONS(413),
    [anon_sym_uint184] = ACTIONS(413),
    [anon_sym_uint192] = ACTIONS(413),
    [anon_sym_uint200] = ACTIONS(413),
    [anon_sym_uint208] = ACTIONS(413),
    [anon_sym_uint216] = ACTIONS(413),
    [anon_sym_uint224] = ACTIONS(413),
    [anon_sym_uint232] = ACTIONS(413),
    [anon_sym_uint240] = ACTIONS(413),
    [anon_sym_uint248] = ACTIONS(413),
    [anon_sym_uint256] = ACTIONS(413),
    [anon_sym_bytes] = ACTIONS(413),
    [anon_sym_bytes1] = ACTIONS(413),
    [anon_sym_bytes2] = ACTIONS(413),
    [anon_sym_bytes3] = ACTIONS(413),
    [anon_sym_bytes4] = ACTIONS(413),
    [anon_sym_bytes5] = ACTIONS(413),
    [anon_sym_bytes6] = ACTIONS(413),
    [anon_sym_bytes7] = ACTIONS(413),
    [anon_sym_bytes8] = ACTIONS(413),
    [anon_sym_bytes9] = ACTIONS(413),
    [anon_sym_bytes10] = ACTIONS(413),
    [anon_sym_bytes11] = ACTIONS(413),
    [anon_sym_bytes12] = ACTIONS(413),
    [anon_sym_bytes13] = ACTIONS(413),
    [anon_sym_bytes14] = ACTIONS(413),
    [anon_sym_bytes15] = ACTIONS(413),
    [anon_sym_bytes16] = ACTIONS(413),
    [anon_sym_bytes17] = ACTIONS(413),
    [anon_sym_bytes18] = ACTIONS(413),
    [anon_sym_bytes19] = ACTIONS(413),
    [anon_sym_bytes20] = ACTIONS(413),
    [anon_sym_bytes21] = ACTIONS(413),
    [anon_sym_bytes22] = ACTIONS(413),
    [anon_sym_bytes23] = ACTIONS(413),
    [anon_sym_bytes24] = ACTIONS(413),
    [anon_sym_bytes25] = ACTIONS(413),
    [anon_sym_bytes26] = ACTIONS(413),
    [anon_sym_bytes27] = ACTIONS(413),
    [anon_sym_bytes28] = ACTIONS(413),
    [anon_sym_bytes29] = ACTIONS(413),
    [anon_sym_bytes30] = ACTIONS(413),
    [anon_sym_bytes31] = ACTIONS(413),
    [anon_sym_bytes32] = ACTIONS(413),
    [anon_sym_fixed] = ACTIONS(413),
    [aux_sym__fixed_token1] = ACTIONS(413),
    [anon_sym_ufixed] = ACTIONS(413),
    [aux_sym__ufixed_token1] = ACTIONS(413),
    [aux_sym__decimal_number_token1] = ACTIONS(413),
    [aux_sym__decimal_number_token2] = ACTIONS(415),
    [aux_sym__hex_number_token1] = ACTIONS(415),
    [anon_sym_hex] = ACTIONS(413),
    [anon_sym_DQUOTE] = ACTIONS(415),
    [anon_sym_SQUOTE] = ACTIONS(415),
    [anon_sym_unicode] = ACTIONS(413),
    [sym_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_identifier] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_TILDE] = ACTIONS(419),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_type] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(417),
    [anon_sym_assembly] = ACTIONS(417),
    [anon_sym_break] = ACTIONS(417),
    [anon_sym_continue] = ACTIONS(417),
    [anon_sym_true] = ACTIONS(417),
    [anon_sym_false] = ACTIONS(417),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_function] = ACTIONS(417),
    [anon_sym_byte] = ACTIONS(417),
    [anon_sym_address] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(417),
    [anon_sym_revert] = ACTIONS(417),
    [sym_unchecked] = ACTIONS(417),
    [anon_sym_var] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_try] = ACTIONS(417),
    [anon_sym_emit] = ACTIONS(417),
    [anon_sym_payable] = ACTIONS(417),
    [anon_sym_new] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_BANG] = ACTIONS(419),
    [anon_sym_delete] = ACTIONS(417),
    [anon_sym_PLUS_PLUS] = ACTIONS(419),
    [anon_sym_DASH_DASH] = ACTIONS(419),
    [anon_sym_mapping] = ACTIONS(417),
    [anon_sym_bool] = ACTIONS(417),
    [anon_sym_string] = ACTIONS(417),
    [anon_sym_int] = ACTIONS(417),
    [anon_sym_int8] = ACTIONS(417),
    [anon_sym_int16] = ACTIONS(417),
    [anon_sym_int24] = ACTIONS(417),
    [anon_sym_int32] = ACTIONS(417),
    [anon_sym_int40] = ACTIONS(417),
    [anon_sym_int48] = ACTIONS(417),
    [anon_sym_int56] = ACTIONS(417),
    [anon_sym_int64] = ACTIONS(417),
    [anon_sym_int72] = ACTIONS(417),
    [anon_sym_int80] = ACTIONS(417),
    [anon_sym_int88] = ACTIONS(417),
    [anon_sym_int96] = ACTIONS(417),
    [anon_sym_int104] = ACTIONS(417),
    [anon_sym_int112] = ACTIONS(417),
    [anon_sym_int120] = ACTIONS(417),
    [anon_sym_int128] = ACTIONS(417),
    [anon_sym_int136] = ACTIONS(417),
    [anon_sym_int144] = ACTIONS(417),
    [anon_sym_int152] = ACTIONS(417),
    [anon_sym_int160] = ACTIONS(417),
    [anon_sym_int168] = ACTIONS(417),
    [anon_sym_int176] = ACTIONS(417),
    [anon_sym_int184] = ACTIONS(417),
    [anon_sym_int192] = ACTIONS(417),
    [anon_sym_int200] = ACTIONS(417),
    [anon_sym_int208] = ACTIONS(417),
    [anon_sym_int216] = ACTIONS(417),
    [anon_sym_int224] = ACTIONS(417),
    [anon_sym_int232] = ACTIONS(417),
    [anon_sym_int240] = ACTIONS(417),
    [anon_sym_int248] = ACTIONS(417),
    [anon_sym_int256] = ACTIONS(417),
    [anon_sym_uint] = ACTIONS(417),
    [anon_sym_uint8] = ACTIONS(417),
    [anon_sym_uint16] = ACTIONS(417),
    [anon_sym_uint24] = ACTIONS(417),
    [anon_sym_uint32] = ACTIONS(417),
    [anon_sym_uint40] = ACTIONS(417),
    [anon_sym_uint48] = ACTIONS(417),
    [anon_sym_uint56] = ACTIONS(417),
    [anon_sym_uint64] = ACTIONS(417),
    [anon_sym_uint72] = ACTIONS(417),
    [anon_sym_uint80] = ACTIONS(417),
    [anon_sym_uint88] = ACTIONS(417),
    [anon_sym_uint96] = ACTIONS(417),
    [anon_sym_uint104] = ACTIONS(417),
    [anon_sym_uint112] = ACTIONS(417),
    [anon_sym_uint120] = ACTIONS(417),
    [anon_sym_uint128] = ACTIONS(417),
    [anon_sym_uint136] = ACTIONS(417),
    [anon_sym_uint144] = ACTIONS(417),
    [anon_sym_uint152] = ACTIONS(417),
    [anon_sym_uint160] = ACTIONS(417),
    [anon_sym_uint168] = ACTIONS(417),
    [anon_sym_uint176] = ACTIONS(417),
    [anon_sym_uint184] = ACTIONS(417),
    [anon_sym_uint192] = ACTIONS(417),
    [anon_sym_uint200] = ACTIONS(417),
    [anon_sym_uint208] = ACTIONS(417),
    [anon_sym_uint216] = ACTIONS(417),
    [anon_sym_uint224] = ACTIONS(417),
    [anon_sym_uint232] = ACTIONS(417),
    [anon_sym_uint240] = ACTIONS(417),
    [anon_sym_uint248] = ACTIONS(417),
    [anon_sym_uint256] = ACTIONS(417),
    [anon_sym_bytes] = ACTIONS(417),
    [anon_sym_bytes1] = ACTIONS(417),
    [anon_sym_bytes2] = ACTIONS(417),
    [anon_sym_bytes3] = ACTIONS(417),
    [anon_sym_bytes4] = ACTIONS(417),
    [anon_sym_bytes5] = ACTIONS(417),
    [anon_sym_bytes6] = ACTIONS(417),
    [anon_sym_bytes7] = ACTIONS(417),
    [anon_sym_bytes8] = ACTIONS(417),
    [anon_sym_bytes9] = ACTIONS(417),
    [anon_sym_bytes10] = ACTIONS(417),
    [anon_sym_bytes11] = ACTIONS(417),
    [anon_sym_bytes12] = ACTIONS(417),
    [anon_sym_bytes13] = ACTIONS(417),
    [anon_sym_bytes14] = ACTIONS(417),
    [anon_sym_bytes15] = ACTIONS(417),
    [anon_sym_bytes16] = ACTIONS(417),
    [anon_sym_bytes17] = ACTIONS(417),
    [anon_sym_bytes18] = ACTIONS(417),
    [anon_sym_bytes19] = ACTIONS(417),
    [anon_sym_bytes20] = ACTIONS(417),
    [anon_sym_bytes21] = ACTIONS(417),
    [anon_sym_bytes22] = ACTIONS(417),
    [anon_sym_bytes23] = ACTIONS(417),
    [anon_sym_bytes24] = ACTIONS(417),
    [anon_sym_bytes25] = ACTIONS(417),
    [anon_sym_bytes26] = ACTIONS(417),
    [anon_sym_bytes27] = ACTIONS(417),
    [anon_sym_bytes28] = ACTIONS(417),
    [anon_sym_bytes29] = ACTIONS(417),
    [anon_sym_bytes30] = ACTIONS(417),
    [anon_sym_bytes31] = ACTIONS(417),
    [anon_sym_bytes32] = ACTIONS(417),
    [anon_sym_fixed] = ACTIONS(417),
    [aux_sym__fixed_token1] = ACTIONS(417),
    [anon_sym_ufixed] = ACTIONS(417),
    [aux_sym__ufixed_token1] = ACTIONS(417),
    [aux_sym__decimal_number_token1] = ACTIONS(417),
    [aux_sym__decimal_number_token2] = ACTIONS(419),
    [aux_sym__hex_number_token1] = ACTIONS(419),
    [anon_sym_hex] = ACTIONS(417),
    [anon_sym_DQUOTE] = ACTIONS(419),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_unicode] = ACTIONS(417),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_identifier] = ACTIONS(421),
    [anon_sym_DASH] = ACTIONS(421),
    [anon_sym_TILDE] = ACTIONS(423),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_type] = ACTIONS(421),
    [anon_sym_LPAREN] = ACTIONS(423),
    [anon_sym_for] = ACTIONS(421),
    [anon_sym_assembly] = ACTIONS(421),
    [anon_sym_break] = ACTIONS(421),
    [anon_sym_continue] = ACTIONS(421),
    [anon_sym_true] = ACTIONS(421),
    [anon_sym_false] = ACTIONS(421),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_function] = ACTIONS(421),
    [anon_sym_byte] = ACTIONS(421),
    [anon_sym_address] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(421),
    [anon_sym_revert] = ACTIONS(421),
    [sym_unchecked] = ACTIONS(421),
    [anon_sym_var] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_try] = ACTIONS(421),
    [anon_sym_emit] = ACTIONS(421),
    [anon_sym_payable] = ACTIONS(421),
    [anon_sym_new] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_BANG] = ACTIONS(423),
    [anon_sym_delete] = ACTIONS(421),
    [anon_sym_PLUS_PLUS] = ACTIONS(423),
    [anon_sym_DASH_DASH] = ACTIONS(423),
    [anon_sym_mapping] = ACTIONS(421),
    [anon_sym_bool] = ACTIONS(421),
    [anon_sym_string] = ACTIONS(421),
    [anon_sym_int] = ACTIONS(421),
    [anon_sym_int8] = ACTIONS(421),
    [anon_sym_int16] = ACTIONS(421),
    [anon_sym_int24] = ACTIONS(421),
    [anon_sym_int32] = ACTIONS(421),
    [anon_sym_int40] = ACTIONS(421),
    [anon_sym_int48] = ACTIONS(421),
    [anon_sym_int56] = ACTIONS(421),
    [anon_sym_int64] = ACTIONS(421),
    [anon_sym_int72] = ACTIONS(421),
    [anon_sym_int80] = ACTIONS(421),
    [anon_sym_int88] = ACTIONS(421),
    [anon_sym_int96] = ACTIONS(421),
    [anon_sym_int104] = ACTIONS(421),
    [anon_sym_int112] = ACTIONS(421),
    [anon_sym_int120] = ACTIONS(421),
    [anon_sym_int128] = ACTIONS(421),
    [anon_sym_int136] = ACTIONS(421),
    [anon_sym_int144] = ACTIONS(421),
    [anon_sym_int152] = ACTIONS(421),
    [anon_sym_int160] = ACTIONS(421),
    [anon_sym_int168] = ACTIONS(421),
    [anon_sym_int176] = ACTIONS(421),
    [anon_sym_int184] = ACTIONS(421),
    [anon_sym_int192] = ACTIONS(421),
    [anon_sym_int200] = ACTIONS(421),
    [anon_sym_int208] = ACTIONS(421),
    [anon_sym_int216] = ACTIONS(421),
    [anon_sym_int224] = ACTIONS(421),
    [anon_sym_int232] = ACTIONS(421),
    [anon_sym_int240] = ACTIONS(421),
    [anon_sym_int248] = ACTIONS(421),
    [anon_sym_int256] = ACTIONS(421),
    [anon_sym_uint] = ACTIONS(421),
    [anon_sym_uint8] = ACTIONS(421),
    [anon_sym_uint16] = ACTIONS(421),
    [anon_sym_uint24] = ACTIONS(421),
    [anon_sym_uint32] = ACTIONS(421),
    [anon_sym_uint40] = ACTIONS(421),
    [anon_sym_uint48] = ACTIONS(421),
    [anon_sym_uint56] = ACTIONS(421),
    [anon_sym_uint64] = ACTIONS(421),
    [anon_sym_uint72] = ACTIONS(421),
    [anon_sym_uint80] = ACTIONS(421),
    [anon_sym_uint88] = ACTIONS(421),
    [anon_sym_uint96] = ACTIONS(421),
    [anon_sym_uint104] = ACTIONS(421),
    [anon_sym_uint112] = ACTIONS(421),
    [anon_sym_uint120] = ACTIONS(421),
    [anon_sym_uint128] = ACTIONS(421),
    [anon_sym_uint136] = ACTIONS(421),
    [anon_sym_uint144] = ACTIONS(421),
    [anon_sym_uint152] = ACTIONS(421),
    [anon_sym_uint160] = ACTIONS(421),
    [anon_sym_uint168] = ACTIONS(421),
    [anon_sym_uint176] = ACTIONS(421),
    [anon_sym_uint184] = ACTIONS(421),
    [anon_sym_uint192] = ACTIONS(421),
    [anon_sym_uint200] = ACTIONS(421),
    [anon_sym_uint208] = ACTIONS(421),
    [anon_sym_uint216] = ACTIONS(421),
    [anon_sym_uint224] = ACTIONS(421),
    [anon_sym_uint232] = ACTIONS(421),
    [anon_sym_uint240] = ACTIONS(421),
    [anon_sym_uint248] = ACTIONS(421),
    [anon_sym_uint256] = ACTIONS(421),
    [anon_sym_bytes] = ACTIONS(421),
    [anon_sym_bytes1] = ACTIONS(421),
    [anon_sym_bytes2] = ACTIONS(421),
    [anon_sym_bytes3] = ACTIONS(421),
    [anon_sym_bytes4] = ACTIONS(421),
    [anon_sym_bytes5] = ACTIONS(421),
    [anon_sym_bytes6] = ACTIONS(421),
    [anon_sym_bytes7] = ACTIONS(421),
    [anon_sym_bytes8] = ACTIONS(421),
    [anon_sym_bytes9] = ACTIONS(421),
    [anon_sym_bytes10] = ACTIONS(421),
    [anon_sym_bytes11] = ACTIONS(421),
    [anon_sym_bytes12] = ACTIONS(421),
    [anon_sym_bytes13] = ACTIONS(421),
    [anon_sym_bytes14] = ACTIONS(421),
    [anon_sym_bytes15] = ACTIONS(421),
    [anon_sym_bytes16] = ACTIONS(421),
    [anon_sym_bytes17] = ACTIONS(421),
    [anon_sym_bytes18] = ACTIONS(421),
    [anon_sym_bytes19] = ACTIONS(421),
    [anon_sym_bytes20] = ACTIONS(421),
    [anon_sym_bytes21] = ACTIONS(421),
    [anon_sym_bytes22] = ACTIONS(421),
    [anon_sym_bytes23] = ACTIONS(421),
    [anon_sym_bytes24] = ACTIONS(421),
    [anon_sym_bytes25] = ACTIONS(421),
    [anon_sym_bytes26] = ACTIONS(421),
    [anon_sym_bytes27] = ACTIONS(421),
    [anon_sym_bytes28] = ACTIONS(421),
    [anon_sym_bytes29] = ACTIONS(421),
    [anon_sym_bytes30] = ACTIONS(421),
    [anon_sym_bytes31] = ACTIONS(421),
    [anon_sym_bytes32] = ACTIONS(421),
    [anon_sym_fixed] = ACTIONS(421),
    [aux_sym__fixed_token1] = ACTIONS(421),
    [anon_sym_ufixed] = ACTIONS(421),
    [aux_sym__ufixed_token1] = ACTIONS(421),
    [aux_sym__decimal_number_token1] = ACTIONS(421),
    [aux_sym__decimal_number_token2] = ACTIONS(423),
    [aux_sym__hex_number_token1] = ACTIONS(423),
    [anon_sym_hex] = ACTIONS(421),
    [anon_sym_DQUOTE] = ACTIONS(423),
    [anon_sym_SQUOTE] = ACTIONS(423),
    [anon_sym_unicode] = ACTIONS(421),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_identifier] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(425),
    [anon_sym_TILDE] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_type] = ACTIONS(425),
    [anon_sym_LPAREN] = ACTIONS(427),
    [anon_sym_for] = ACTIONS(425),
    [anon_sym_assembly] = ACTIONS(425),
    [anon_sym_break] = ACTIONS(425),
    [anon_sym_continue] = ACTIONS(425),
    [anon_sym_true] = ACTIONS(425),
    [anon_sym_false] = ACTIONS(425),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(425),
    [anon_sym_byte] = ACTIONS(425),
    [anon_sym_address] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(425),
    [anon_sym_revert] = ACTIONS(425),
    [sym_unchecked] = ACTIONS(425),
    [anon_sym_var] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_try] = ACTIONS(425),
    [anon_sym_emit] = ACTIONS(425),
    [anon_sym_payable] = ACTIONS(425),
    [anon_sym_new] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_delete] = ACTIONS(425),
    [anon_sym_PLUS_PLUS] = ACTIONS(427),
    [anon_sym_DASH_DASH] = ACTIONS(427),
    [anon_sym_mapping] = ACTIONS(425),
    [anon_sym_bool] = ACTIONS(425),
    [anon_sym_string] = ACTIONS(425),
    [anon_sym_int] = ACTIONS(425),
    [anon_sym_int8] = ACTIONS(425),
    [anon_sym_int16] = ACTIONS(425),
    [anon_sym_int24] = ACTIONS(425),
    [anon_sym_int32] = ACTIONS(425),
    [anon_sym_int40] = ACTIONS(425),
    [anon_sym_int48] = ACTIONS(425),
    [anon_sym_int56] = ACTIONS(425),
    [anon_sym_int64] = ACTIONS(425),
    [anon_sym_int72] = ACTIONS(425),
    [anon_sym_int80] = ACTIONS(425),
    [anon_sym_int88] = ACTIONS(425),
    [anon_sym_int96] = ACTIONS(425),
    [anon_sym_int104] = ACTIONS(425),
    [anon_sym_int112] = ACTIONS(425),
    [anon_sym_int120] = ACTIONS(425),
    [anon_sym_int128] = ACTIONS(425),
    [anon_sym_int136] = ACTIONS(425),
    [anon_sym_int144] = ACTIONS(425),
    [anon_sym_int152] = ACTIONS(425),
    [anon_sym_int160] = ACTIONS(425),
    [anon_sym_int168] = ACTIONS(425),
    [anon_sym_int176] = ACTIONS(425),
    [anon_sym_int184] = ACTIONS(425),
    [anon_sym_int192] = ACTIONS(425),
    [anon_sym_int200] = ACTIONS(425),
    [anon_sym_int208] = ACTIONS(425),
    [anon_sym_int216] = ACTIONS(425),
    [anon_sym_int224] = ACTIONS(425),
    [anon_sym_int232] = ACTIONS(425),
    [anon_sym_int240] = ACTIONS(425),
    [anon_sym_int248] = ACTIONS(425),
    [anon_sym_int256] = ACTIONS(425),
    [anon_sym_uint] = ACTIONS(425),
    [anon_sym_uint8] = ACTIONS(425),
    [anon_sym_uint16] = ACTIONS(425),
    [anon_sym_uint24] = ACTIONS(425),
    [anon_sym_uint32] = ACTIONS(425),
    [anon_sym_uint40] = ACTIONS(425),
    [anon_sym_uint48] = ACTIONS(425),
    [anon_sym_uint56] = ACTIONS(425),
    [anon_sym_uint64] = ACTIONS(425),
    [anon_sym_uint72] = ACTIONS(425),
    [anon_sym_uint80] = ACTIONS(425),
    [anon_sym_uint88] = ACTIONS(425),
    [anon_sym_uint96] = ACTIONS(425),
    [anon_sym_uint104] = ACTIONS(425),
    [anon_sym_uint112] = ACTIONS(425),
    [anon_sym_uint120] = ACTIONS(425),
    [anon_sym_uint128] = ACTIONS(425),
    [anon_sym_uint136] = ACTIONS(425),
    [anon_sym_uint144] = ACTIONS(425),
    [anon_sym_uint152] = ACTIONS(425),
    [anon_sym_uint160] = ACTIONS(425),
    [anon_sym_uint168] = ACTIONS(425),
    [anon_sym_uint176] = ACTIONS(425),
    [anon_sym_uint184] = ACTIONS(425),
    [anon_sym_uint192] = ACTIONS(425),
    [anon_sym_uint200] = ACTIONS(425),
    [anon_sym_uint208] = ACTIONS(425),
    [anon_sym_uint216] = ACTIONS(425),
    [anon_sym_uint224] = ACTIONS(425),
    [anon_sym_uint232] = ACTIONS(425),
    [anon_sym_uint240] = ACTIONS(425),
    [anon_sym_uint248] = ACTIONS(425),
    [anon_sym_uint256] = ACTIONS(425),
    [anon_sym_bytes] = ACTIONS(425),
    [anon_sym_bytes1] = ACTIONS(425),
    [anon_sym_bytes2] = ACTIONS(425),
    [anon_sym_bytes3] = ACTIONS(425),
    [anon_sym_bytes4] = ACTIONS(425),
    [anon_sym_bytes5] = ACTIONS(425),
    [anon_sym_bytes6] = ACTIONS(425),
    [anon_sym_bytes7] = ACTIONS(425),
    [anon_sym_bytes8] = ACTIONS(425),
    [anon_sym_bytes9] = ACTIONS(425),
    [anon_sym_bytes10] = ACTIONS(425),
    [anon_sym_bytes11] = ACTIONS(425),
    [anon_sym_bytes12] = ACTIONS(425),
    [anon_sym_bytes13] = ACTIONS(425),
    [anon_sym_bytes14] = ACTIONS(425),
    [anon_sym_bytes15] = ACTIONS(425),
    [anon_sym_bytes16] = ACTIONS(425),
    [anon_sym_bytes17] = ACTIONS(425),
    [anon_sym_bytes18] = ACTIONS(425),
    [anon_sym_bytes19] = ACTIONS(425),
    [anon_sym_bytes20] = ACTIONS(425),
    [anon_sym_bytes21] = ACTIONS(425),
    [anon_sym_bytes22] = ACTIONS(425),
    [anon_sym_bytes23] = ACTIONS(425),
    [anon_sym_bytes24] = ACTIONS(425),
    [anon_sym_bytes25] = ACTIONS(425),
    [anon_sym_bytes26] = ACTIONS(425),
    [anon_sym_bytes27] = ACTIONS(425),
    [anon_sym_bytes28] = ACTIONS(425),
    [anon_sym_bytes29] = ACTIONS(425),
    [anon_sym_bytes30] = ACTIONS(425),
    [anon_sym_bytes31] = ACTIONS(425),
    [anon_sym_bytes32] = ACTIONS(425),
    [anon_sym_fixed] = ACTIONS(425),
    [aux_sym__fixed_token1] = ACTIONS(425),
    [anon_sym_ufixed] = ACTIONS(425),
    [aux_sym__ufixed_token1] = ACTIONS(425),
    [aux_sym__decimal_number_token1] = ACTIONS(425),
    [aux_sym__decimal_number_token2] = ACTIONS(427),
    [aux_sym__hex_number_token1] = ACTIONS(427),
    [anon_sym_hex] = ACTIONS(425),
    [anon_sym_DQUOTE] = ACTIONS(427),
    [anon_sym_SQUOTE] = ACTIONS(427),
    [anon_sym_unicode] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_identifier] = ACTIONS(429),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(431),
    [anon_sym_RBRACE] = ACTIONS(431),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(431),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_assembly] = ACTIONS(429),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(429),
    [anon_sym_true] = ACTIONS(429),
    [anon_sym_false] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_function] = ACTIONS(429),
    [anon_sym_byte] = ACTIONS(429),
    [anon_sym_address] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_revert] = ACTIONS(429),
    [sym_unchecked] = ACTIONS(429),
    [anon_sym_var] = ACTIONS(429),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_do] = ACTIONS(429),
    [anon_sym_try] = ACTIONS(429),
    [anon_sym_emit] = ACTIONS(429),
    [anon_sym_payable] = ACTIONS(429),
    [anon_sym_new] = ACTIONS(429),
    [anon_sym_LBRACK] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_BANG] = ACTIONS(431),
    [anon_sym_delete] = ACTIONS(429),
    [anon_sym_PLUS_PLUS] = ACTIONS(431),
    [anon_sym_DASH_DASH] = ACTIONS(431),
    [anon_sym_mapping] = ACTIONS(429),
    [anon_sym_bool] = ACTIONS(429),
    [anon_sym_string] = ACTIONS(429),
    [anon_sym_int] = ACTIONS(429),
    [anon_sym_int8] = ACTIONS(429),
    [anon_sym_int16] = ACTIONS(429),
    [anon_sym_int24] = ACTIONS(429),
    [anon_sym_int32] = ACTIONS(429),
    [anon_sym_int40] = ACTIONS(429),
    [anon_sym_int48] = ACTIONS(429),
    [anon_sym_int56] = ACTIONS(429),
    [anon_sym_int64] = ACTIONS(429),
    [anon_sym_int72] = ACTIONS(429),
    [anon_sym_int80] = ACTIONS(429),
    [anon_sym_int88] = ACTIONS(429),
    [anon_sym_int96] = ACTIONS(429),
    [anon_sym_int104] = ACTIONS(429),
    [anon_sym_int112] = ACTIONS(429),
    [anon_sym_int120] = ACTIONS(429),
    [anon_sym_int128] = ACTIONS(429),
    [anon_sym_int136] = ACTIONS(429),
    [anon_sym_int144] = ACTIONS(429),
    [anon_sym_int152] = ACTIONS(429),
    [anon_sym_int160] = ACTIONS(429),
    [anon_sym_int168] = ACTIONS(429),
    [anon_sym_int176] = ACTIONS(429),
    [anon_sym_int184] = ACTIONS(429),
    [anon_sym_int192] = ACTIONS(429),
    [anon_sym_int200] = ACTIONS(429),
    [anon_sym_int208] = ACTIONS(429),
    [anon_sym_int216] = ACTIONS(429),
    [anon_sym_int224] = ACTIONS(429),
    [anon_sym_int232] = ACTIONS(429),
    [anon_sym_int240] = ACTIONS(429),
    [anon_sym_int248] = ACTIONS(429),
    [anon_sym_int256] = ACTIONS(429),
    [anon_sym_uint] = ACTIONS(429),
    [anon_sym_uint8] = ACTIONS(429),
    [anon_sym_uint16] = ACTIONS(429),
    [anon_sym_uint24] = ACTIONS(429),
    [anon_sym_uint32] = ACTIONS(429),
    [anon_sym_uint40] = ACTIONS(429),
    [anon_sym_uint48] = ACTIONS(429),
    [anon_sym_uint56] = ACTIONS(429),
    [anon_sym_uint64] = ACTIONS(429),
    [anon_sym_uint72] = ACTIONS(429),
    [anon_sym_uint80] = ACTIONS(429),
    [anon_sym_uint88] = ACTIONS(429),
    [anon_sym_uint96] = ACTIONS(429),
    [anon_sym_uint104] = ACTIONS(429),
    [anon_sym_uint112] = ACTIONS(429),
    [anon_sym_uint120] = ACTIONS(429),
    [anon_sym_uint128] = ACTIONS(429),
    [anon_sym_uint136] = ACTIONS(429),
    [anon_sym_uint144] = ACTIONS(429),
    [anon_sym_uint152] = ACTIONS(429),
    [anon_sym_uint160] = ACTIONS(429),
    [anon_sym_uint168] = ACTIONS(429),
    [anon_sym_uint176] = ACTIONS(429),
    [anon_sym_uint184] = ACTIONS(429),
    [anon_sym_uint192] = ACTIONS(429),
    [anon_sym_uint200] = ACTIONS(429),
    [anon_sym_uint208] = ACTIONS(429),
    [anon_sym_uint216] = ACTIONS(429),
    [anon_sym_uint224] = ACTIONS(429),
    [anon_sym_uint232] = ACTIONS(429),
    [anon_sym_uint240] = ACTIONS(429),
    [anon_sym_uint248] = ACTIONS(429),
    [anon_sym_uint256] = ACTIONS(429),
    [anon_sym_bytes] = ACTIONS(429),
    [anon_sym_bytes1] = ACTIONS(429),
    [anon_sym_bytes2] = ACTIONS(429),
    [anon_sym_bytes3] = ACTIONS(429),
    [anon_sym_bytes4] = ACTIONS(429),
    [anon_sym_bytes5] = ACTIONS(429),
    [anon_sym_bytes6] = ACTIONS(429),
    [anon_sym_bytes7] = ACTIONS(429),
    [anon_sym_bytes8] = ACTIONS(429),
    [anon_sym_bytes9] = ACTIONS(429),
    [anon_sym_bytes10] = ACTIONS(429),
    [anon_sym_bytes11] = ACTIONS(429),
    [anon_sym_bytes12] = ACTIONS(429),
    [anon_sym_bytes13] = ACTIONS(429),
    [anon_sym_bytes14] = ACTIONS(429),
    [anon_sym_bytes15] = ACTIONS(429),
    [anon_sym_bytes16] = ACTIONS(429),
    [anon_sym_bytes17] = ACTIONS(429),
    [anon_sym_bytes18] = ACTIONS(429),
    [anon_sym_bytes19] = ACTIONS(429),
    [anon_sym_bytes20] = ACTIONS(429),
    [anon_sym_bytes21] = ACTIONS(429),
    [anon_sym_bytes22] = ACTIONS(429),
    [anon_sym_bytes23] = ACTIONS(429),
    [anon_sym_bytes24] = ACTIONS(429),
    [anon_sym_bytes25] = ACTIONS(429),
    [anon_sym_bytes26] = ACTIONS(429),
    [anon_sym_bytes27] = ACTIONS(429),
    [anon_sym_bytes28] = ACTIONS(429),
    [anon_sym_bytes29] = ACTIONS(429),
    [anon_sym_bytes30] = ACTIONS(429),
    [anon_sym_bytes31] = ACTIONS(429),
    [anon_sym_bytes32] = ACTIONS(429),
    [anon_sym_fixed] = ACTIONS(429),
    [aux_sym__fixed_token1] = ACTIONS(429),
    [anon_sym_ufixed] = ACTIONS(429),
    [aux_sym__ufixed_token1] = ACTIONS(429),
    [aux_sym__decimal_number_token1] = ACTIONS(429),
    [aux_sym__decimal_number_token2] = ACTIONS(431),
    [aux_sym__hex_number_token1] = ACTIONS(431),
    [anon_sym_hex] = ACTIONS(429),
    [anon_sym_DQUOTE] = ACTIONS(431),
    [anon_sym_SQUOTE] = ACTIONS(431),
    [anon_sym_unicode] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_identifier] = ACTIONS(433),
    [anon_sym_DASH] = ACTIONS(433),
    [anon_sym_TILDE] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(435),
    [anon_sym_type] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(435),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_assembly] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(433),
    [anon_sym_true] = ACTIONS(433),
    [anon_sym_false] = ACTIONS(433),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_function] = ACTIONS(433),
    [anon_sym_byte] = ACTIONS(433),
    [anon_sym_address] = ACTIONS(433),
    [anon_sym_return] = ACTIONS(433),
    [anon_sym_revert] = ACTIONS(433),
    [sym_unchecked] = ACTIONS(433),
    [anon_sym_var] = ACTIONS(433),
    [anon_sym_else] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(433),
    [anon_sym_do] = ACTIONS(433),
    [anon_sym_try] = ACTIONS(433),
    [anon_sym_emit] = ACTIONS(433),
    [anon_sym_payable] = ACTIONS(433),
    [anon_sym_new] = ACTIONS(433),
    [anon_sym_LBRACK] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_BANG] = ACTIONS(435),
    [anon_sym_delete] = ACTIONS(433),
    [anon_sym_PLUS_PLUS] = ACTIONS(435),
    [anon_sym_DASH_DASH] = ACTIONS(435),
    [anon_sym_mapping] = ACTIONS(433),
    [anon_sym_bool] = ACTIONS(433),
    [anon_sym_string] = ACTIONS(433),
    [anon_sym_int] = ACTIONS(433),
    [anon_sym_int8] = ACTIONS(433),
    [anon_sym_int16] = ACTIONS(433),
    [anon_sym_int24] = ACTIONS(433),
    [anon_sym_int32] = ACTIONS(433),
    [anon_sym_int40] = ACTIONS(433),
    [anon_sym_int48] = ACTIONS(433),
    [anon_sym_int56] = ACTIONS(433),
    [anon_sym_int64] = ACTIONS(433),
    [anon_sym_int72] = ACTIONS(433),
    [anon_sym_int80] = ACTIONS(433),
    [anon_sym_int88] = ACTIONS(433),
    [anon_sym_int96] = ACTIONS(433),
    [anon_sym_int104] = ACTIONS(433),
    [anon_sym_int112] = ACTIONS(433),
    [anon_sym_int120] = ACTIONS(433),
    [anon_sym_int128] = ACTIONS(433),
    [anon_sym_int136] = ACTIONS(433),
    [anon_sym_int144] = ACTIONS(433),
    [anon_sym_int152] = ACTIONS(433),
    [anon_sym_int160] = ACTIONS(433),
    [anon_sym_int168] = ACTIONS(433),
    [anon_sym_int176] = ACTIONS(433),
    [anon_sym_int184] = ACTIONS(433),
    [anon_sym_int192] = ACTIONS(433),
    [anon_sym_int200] = ACTIONS(433),
    [anon_sym_int208] = ACTIONS(433),
    [anon_sym_int216] = ACTIONS(433),
    [anon_sym_int224] = ACTIONS(433),
    [anon_sym_int232] = ACTIONS(433),
    [anon_sym_int240] = ACTIONS(433),
    [anon_sym_int248] = ACTIONS(433),
    [anon_sym_int256] = ACTIONS(433),
    [anon_sym_uint] = ACTIONS(433),
    [anon_sym_uint8] = ACTIONS(433),
    [anon_sym_uint16] = ACTIONS(433),
    [anon_sym_uint24] = ACTIONS(433),
    [anon_sym_uint32] = ACTIONS(433),
    [anon_sym_uint40] = ACTIONS(433),
    [anon_sym_uint48] = ACTIONS(433),
    [anon_sym_uint56] = ACTIONS(433),
    [anon_sym_uint64] = ACTIONS(433),
    [anon_sym_uint72] = ACTIONS(433),
    [anon_sym_uint80] = ACTIONS(433),
    [anon_sym_uint88] = ACTIONS(433),
    [anon_sym_uint96] = ACTIONS(433),
    [anon_sym_uint104] = ACTIONS(433),
    [anon_sym_uint112] = ACTIONS(433),
    [anon_sym_uint120] = ACTIONS(433),
    [anon_sym_uint128] = ACTIONS(433),
    [anon_sym_uint136] = ACTIONS(433),
    [anon_sym_uint144] = ACTIONS(433),
    [anon_sym_uint152] = ACTIONS(433),
    [anon_sym_uint160] = ACTIONS(433),
    [anon_sym_uint168] = ACTIONS(433),
    [anon_sym_uint176] = ACTIONS(433),
    [anon_sym_uint184] = ACTIONS(433),
    [anon_sym_uint192] = ACTIONS(433),
    [anon_sym_uint200] = ACTIONS(433),
    [anon_sym_uint208] = ACTIONS(433),
    [anon_sym_uint216] = ACTIONS(433),
    [anon_sym_uint224] = ACTIONS(433),
    [anon_sym_uint232] = ACTIONS(433),
    [anon_sym_uint240] = ACTIONS(433),
    [anon_sym_uint248] = ACTIONS(433),
    [anon_sym_uint256] = ACTIONS(433),
    [anon_sym_bytes] = ACTIONS(433),
    [anon_sym_bytes1] = ACTIONS(433),
    [anon_sym_bytes2] = ACTIONS(433),
    [anon_sym_bytes3] = ACTIONS(433),
    [anon_sym_bytes4] = ACTIONS(433),
    [anon_sym_bytes5] = ACTIONS(433),
    [anon_sym_bytes6] = ACTIONS(433),
    [anon_sym_bytes7] = ACTIONS(433),
    [anon_sym_bytes8] = ACTIONS(433),
    [anon_sym_bytes9] = ACTIONS(433),
    [anon_sym_bytes10] = ACTIONS(433),
    [anon_sym_bytes11] = ACTIONS(433),
    [anon_sym_bytes12] = ACTIONS(433),
    [anon_sym_bytes13] = ACTIONS(433),
    [anon_sym_bytes14] = ACTIONS(433),
    [anon_sym_bytes15] = ACTIONS(433),
    [anon_sym_bytes16] = ACTIONS(433),
    [anon_sym_bytes17] = ACTIONS(433),
    [anon_sym_bytes18] = ACTIONS(433),
    [anon_sym_bytes19] = ACTIONS(433),
    [anon_sym_bytes20] = ACTIONS(433),
    [anon_sym_bytes21] = ACTIONS(433),
    [anon_sym_bytes22] = ACTIONS(433),
    [anon_sym_bytes23] = ACTIONS(433),
    [anon_sym_bytes24] = ACTIONS(433),
    [anon_sym_bytes25] = ACTIONS(433),
    [anon_sym_bytes26] = ACTIONS(433),
    [anon_sym_bytes27] = ACTIONS(433),
    [anon_sym_bytes28] = ACTIONS(433),
    [anon_sym_bytes29] = ACTIONS(433),
    [anon_sym_bytes30] = ACTIONS(433),
    [anon_sym_bytes31] = ACTIONS(433),
    [anon_sym_bytes32] = ACTIONS(433),
    [anon_sym_fixed] = ACTIONS(433),
    [aux_sym__fixed_token1] = ACTIONS(433),
    [anon_sym_ufixed] = ACTIONS(433),
    [aux_sym__ufixed_token1] = ACTIONS(433),
    [aux_sym__decimal_number_token1] = ACTIONS(433),
    [aux_sym__decimal_number_token2] = ACTIONS(435),
    [aux_sym__hex_number_token1] = ACTIONS(435),
    [anon_sym_hex] = ACTIONS(433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_SQUOTE] = ACTIONS(435),
    [anon_sym_unicode] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_identifier] = ACTIONS(437),
    [anon_sym_DASH] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(439),
    [anon_sym_RBRACE] = ACTIONS(439),
    [anon_sym_type] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_assembly] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(437),
    [anon_sym_continue] = ACTIONS(437),
    [anon_sym_true] = ACTIONS(437),
    [anon_sym_false] = ACTIONS(437),
    [anon_sym_if] = ACTIONS(437),
    [anon_sym_function] = ACTIONS(437),
    [anon_sym_byte] = ACTIONS(437),
    [anon_sym_address] = ACTIONS(437),
    [anon_sym_return] = ACTIONS(437),
    [anon_sym_revert] = ACTIONS(437),
    [sym_unchecked] = ACTIONS(437),
    [anon_sym_var] = ACTIONS(437),
    [anon_sym_else] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(437),
    [anon_sym_do] = ACTIONS(437),
    [anon_sym_try] = ACTIONS(437),
    [anon_sym_emit] = ACTIONS(437),
    [anon_sym_payable] = ACTIONS(437),
    [anon_sym_new] = ACTIONS(437),
    [anon_sym_LBRACK] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_delete] = ACTIONS(437),
    [anon_sym_PLUS_PLUS] = ACTIONS(439),
    [anon_sym_DASH_DASH] = ACTIONS(439),
    [anon_sym_mapping] = ACTIONS(437),
    [anon_sym_bool] = ACTIONS(437),
    [anon_sym_string] = ACTIONS(437),
    [anon_sym_int] = ACTIONS(437),
    [anon_sym_int8] = ACTIONS(437),
    [anon_sym_int16] = ACTIONS(437),
    [anon_sym_int24] = ACTIONS(437),
    [anon_sym_int32] = ACTIONS(437),
    [anon_sym_int40] = ACTIONS(437),
    [anon_sym_int48] = ACTIONS(437),
    [anon_sym_int56] = ACTIONS(437),
    [anon_sym_int64] = ACTIONS(437),
    [anon_sym_int72] = ACTIONS(437),
    [anon_sym_int80] = ACTIONS(437),
    [anon_sym_int88] = ACTIONS(437),
    [anon_sym_int96] = ACTIONS(437),
    [anon_sym_int104] = ACTIONS(437),
    [anon_sym_int112] = ACTIONS(437),
    [anon_sym_int120] = ACTIONS(437),
    [anon_sym_int128] = ACTIONS(437),
    [anon_sym_int136] = ACTIONS(437),
    [anon_sym_int144] = ACTIONS(437),
    [anon_sym_int152] = ACTIONS(437),
    [anon_sym_int160] = ACTIONS(437),
    [anon_sym_int168] = ACTIONS(437),
    [anon_sym_int176] = ACTIONS(437),
    [anon_sym_int184] = ACTIONS(437),
    [anon_sym_int192] = ACTIONS(437),
    [anon_sym_int200] = ACTIONS(437),
    [anon_sym_int208] = ACTIONS(437),
    [anon_sym_int216] = ACTIONS(437),
    [anon_sym_int224] = ACTIONS(437),
    [anon_sym_int232] = ACTIONS(437),
    [anon_sym_int240] = ACTIONS(437),
    [anon_sym_int248] = ACTIONS(437),
    [anon_sym_int256] = ACTIONS(437),
    [anon_sym_uint] = ACTIONS(437),
    [anon_sym_uint8] = ACTIONS(437),
    [anon_sym_uint16] = ACTIONS(437),
    [anon_sym_uint24] = ACTIONS(437),
    [anon_sym_uint32] = ACTIONS(437),
    [anon_sym_uint40] = ACTIONS(437),
    [anon_sym_uint48] = ACTIONS(437),
    [anon_sym_uint56] = ACTIONS(437),
    [anon_sym_uint64] = ACTIONS(437),
    [anon_sym_uint72] = ACTIONS(437),
    [anon_sym_uint80] = ACTIONS(437),
    [anon_sym_uint88] = ACTIONS(437),
    [anon_sym_uint96] = ACTIONS(437),
    [anon_sym_uint104] = ACTIONS(437),
    [anon_sym_uint112] = ACTIONS(437),
    [anon_sym_uint120] = ACTIONS(437),
    [anon_sym_uint128] = ACTIONS(437),
    [anon_sym_uint136] = ACTIONS(437),
    [anon_sym_uint144] = ACTIONS(437),
    [anon_sym_uint152] = ACTIONS(437),
    [anon_sym_uint160] = ACTIONS(437),
    [anon_sym_uint168] = ACTIONS(437),
    [anon_sym_uint176] = ACTIONS(437),
    [anon_sym_uint184] = ACTIONS(437),
    [anon_sym_uint192] = ACTIONS(437),
    [anon_sym_uint200] = ACTIONS(437),
    [anon_sym_uint208] = ACTIONS(437),
    [anon_sym_uint216] = ACTIONS(437),
    [anon_sym_uint224] = ACTIONS(437),
    [anon_sym_uint232] = ACTIONS(437),
    [anon_sym_uint240] = ACTIONS(437),
    [anon_sym_uint248] = ACTIONS(437),
    [anon_sym_uint256] = ACTIONS(437),
    [anon_sym_bytes] = ACTIONS(437),
    [anon_sym_bytes1] = ACTIONS(437),
    [anon_sym_bytes2] = ACTIONS(437),
    [anon_sym_bytes3] = ACTIONS(437),
    [anon_sym_bytes4] = ACTIONS(437),
    [anon_sym_bytes5] = ACTIONS(437),
    [anon_sym_bytes6] = ACTIONS(437),
    [anon_sym_bytes7] = ACTIONS(437),
    [anon_sym_bytes8] = ACTIONS(437),
    [anon_sym_bytes9] = ACTIONS(437),
    [anon_sym_bytes10] = ACTIONS(437),
    [anon_sym_bytes11] = ACTIONS(437),
    [anon_sym_bytes12] = ACTIONS(437),
    [anon_sym_bytes13] = ACTIONS(437),
    [anon_sym_bytes14] = ACTIONS(437),
    [anon_sym_bytes15] = ACTIONS(437),
    [anon_sym_bytes16] = ACTIONS(437),
    [anon_sym_bytes17] = ACTIONS(437),
    [anon_sym_bytes18] = ACTIONS(437),
    [anon_sym_bytes19] = ACTIONS(437),
    [anon_sym_bytes20] = ACTIONS(437),
    [anon_sym_bytes21] = ACTIONS(437),
    [anon_sym_bytes22] = ACTIONS(437),
    [anon_sym_bytes23] = ACTIONS(437),
    [anon_sym_bytes24] = ACTIONS(437),
    [anon_sym_bytes25] = ACTIONS(437),
    [anon_sym_bytes26] = ACTIONS(437),
    [anon_sym_bytes27] = ACTIONS(437),
    [anon_sym_bytes28] = ACTIONS(437),
    [anon_sym_bytes29] = ACTIONS(437),
    [anon_sym_bytes30] = ACTIONS(437),
    [anon_sym_bytes31] = ACTIONS(437),
    [anon_sym_bytes32] = ACTIONS(437),
    [anon_sym_fixed] = ACTIONS(437),
    [aux_sym__fixed_token1] = ACTIONS(437),
    [anon_sym_ufixed] = ACTIONS(437),
    [aux_sym__ufixed_token1] = ACTIONS(437),
    [aux_sym__decimal_number_token1] = ACTIONS(437),
    [aux_sym__decimal_number_token2] = ACTIONS(439),
    [aux_sym__hex_number_token1] = ACTIONS(439),
    [anon_sym_hex] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(439),
    [anon_sym_SQUOTE] = ACTIONS(439),
    [anon_sym_unicode] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_identifier] = ACTIONS(441),
    [anon_sym_DASH] = ACTIONS(441),
    [anon_sym_TILDE] = ACTIONS(443),
    [anon_sym_LBRACE] = ACTIONS(443),
    [anon_sym_RBRACE] = ACTIONS(443),
    [anon_sym_type] = ACTIONS(441),
    [anon_sym_LPAREN] = ACTIONS(443),
    [anon_sym_for] = ACTIONS(441),
    [anon_sym_assembly] = ACTIONS(441),
    [anon_sym_break] = ACTIONS(441),
    [anon_sym_continue] = ACTIONS(441),
    [anon_sym_true] = ACTIONS(441),
    [anon_sym_false] = ACTIONS(441),
    [anon_sym_if] = ACTIONS(441),
    [anon_sym_function] = ACTIONS(441),
    [anon_sym_byte] = ACTIONS(441),
    [anon_sym_address] = ACTIONS(441),
    [anon_sym_return] = ACTIONS(441),
    [anon_sym_revert] = ACTIONS(441),
    [sym_unchecked] = ACTIONS(441),
    [anon_sym_var] = ACTIONS(441),
    [anon_sym_else] = ACTIONS(441),
    [anon_sym_while] = ACTIONS(441),
    [anon_sym_do] = ACTIONS(441),
    [anon_sym_try] = ACTIONS(441),
    [anon_sym_emit] = ACTIONS(441),
    [anon_sym_payable] = ACTIONS(441),
    [anon_sym_new] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_delete] = ACTIONS(441),
    [anon_sym_PLUS_PLUS] = ACTIONS(443),
    [anon_sym_DASH_DASH] = ACTIONS(443),
    [anon_sym_mapping] = ACTIONS(441),
    [anon_sym_bool] = ACTIONS(441),
    [anon_sym_string] = ACTIONS(441),
    [anon_sym_int] = ACTIONS(441),
    [anon_sym_int8] = ACTIONS(441),
    [anon_sym_int16] = ACTIONS(441),
    [anon_sym_int24] = ACTIONS(441),
    [anon_sym_int32] = ACTIONS(441),
    [anon_sym_int40] = ACTIONS(441),
    [anon_sym_int48] = ACTIONS(441),
    [anon_sym_int56] = ACTIONS(441),
    [anon_sym_int64] = ACTIONS(441),
    [anon_sym_int72] = ACTIONS(441),
    [anon_sym_int80] = ACTIONS(441),
    [anon_sym_int88] = ACTIONS(441),
    [anon_sym_int96] = ACTIONS(441),
    [anon_sym_int104] = ACTIONS(441),
    [anon_sym_int112] = ACTIONS(441),
    [anon_sym_int120] = ACTIONS(441),
    [anon_sym_int128] = ACTIONS(441),
    [anon_sym_int136] = ACTIONS(441),
    [anon_sym_int144] = ACTIONS(441),
    [anon_sym_int152] = ACTIONS(441),
    [anon_sym_int160] = ACTIONS(441),
    [anon_sym_int168] = ACTIONS(441),
    [anon_sym_int176] = ACTIONS(441),
    [anon_sym_int184] = ACTIONS(441),
    [anon_sym_int192] = ACTIONS(441),
    [anon_sym_int200] = ACTIONS(441),
    [anon_sym_int208] = ACTIONS(441),
    [anon_sym_int216] = ACTIONS(441),
    [anon_sym_int224] = ACTIONS(441),
    [anon_sym_int232] = ACTIONS(441),
    [anon_sym_int240] = ACTIONS(441),
    [anon_sym_int248] = ACTIONS(441),
    [anon_sym_int256] = ACTIONS(441),
    [anon_sym_uint] = ACTIONS(441),
    [anon_sym_uint8] = ACTIONS(441),
    [anon_sym_uint16] = ACTIONS(441),
    [anon_sym_uint24] = ACTIONS(441),
    [anon_sym_uint32] = ACTIONS(441),
    [anon_sym_uint40] = ACTIONS(441),
    [anon_sym_uint48] = ACTIONS(441),
    [anon_sym_uint56] = ACTIONS(441),
    [anon_sym_uint64] = ACTIONS(441),
    [anon_sym_uint72] = ACTIONS(441),
    [anon_sym_uint80] = ACTIONS(441),
    [anon_sym_uint88] = ACTIONS(441),
    [anon_sym_uint96] = ACTIONS(441),
    [anon_sym_uint104] = ACTIONS(441),
    [anon_sym_uint112] = ACTIONS(441),
    [anon_sym_uint120] = ACTIONS(441),
    [anon_sym_uint128] = ACTIONS(441),
    [anon_sym_uint136] = ACTIONS(441),
    [anon_sym_uint144] = ACTIONS(441),
    [anon_sym_uint152] = ACTIONS(441),
    [anon_sym_uint160] = ACTIONS(441),
    [anon_sym_uint168] = ACTIONS(441),
    [anon_sym_uint176] = ACTIONS(441),
    [anon_sym_uint184] = ACTIONS(441),
    [anon_sym_uint192] = ACTIONS(441),
    [anon_sym_uint200] = ACTIONS(441),
    [anon_sym_uint208] = ACTIONS(441),
    [anon_sym_uint216] = ACTIONS(441),
    [anon_sym_uint224] = ACTIONS(441),
    [anon_sym_uint232] = ACTIONS(441),
    [anon_sym_uint240] = ACTIONS(441),
    [anon_sym_uint248] = ACTIONS(441),
    [anon_sym_uint256] = ACTIONS(441),
    [anon_sym_bytes] = ACTIONS(441),
    [anon_sym_bytes1] = ACTIONS(441),
    [anon_sym_bytes2] = ACTIONS(441),
    [anon_sym_bytes3] = ACTIONS(441),
    [anon_sym_bytes4] = ACTIONS(441),
    [anon_sym_bytes5] = ACTIONS(441),
    [anon_sym_bytes6] = ACTIONS(441),
    [anon_sym_bytes7] = ACTIONS(441),
    [anon_sym_bytes8] = ACTIONS(441),
    [anon_sym_bytes9] = ACTIONS(441),
    [anon_sym_bytes10] = ACTIONS(441),
    [anon_sym_bytes11] = ACTIONS(441),
    [anon_sym_bytes12] = ACTIONS(441),
    [anon_sym_bytes13] = ACTIONS(441),
    [anon_sym_bytes14] = ACTIONS(441),
    [anon_sym_bytes15] = ACTIONS(441),
    [anon_sym_bytes16] = ACTIONS(441),
    [anon_sym_bytes17] = ACTIONS(441),
    [anon_sym_bytes18] = ACTIONS(441),
    [anon_sym_bytes19] = ACTIONS(441),
    [anon_sym_bytes20] = ACTIONS(441),
    [anon_sym_bytes21] = ACTIONS(441),
    [anon_sym_bytes22] = ACTIONS(441),
    [anon_sym_bytes23] = ACTIONS(441),
    [anon_sym_bytes24] = ACTIONS(441),
    [anon_sym_bytes25] = ACTIONS(441),
    [anon_sym_bytes26] = ACTIONS(441),
    [anon_sym_bytes27] = ACTIONS(441),
    [anon_sym_bytes28] = ACTIONS(441),
    [anon_sym_bytes29] = ACTIONS(441),
    [anon_sym_bytes30] = ACTIONS(441),
    [anon_sym_bytes31] = ACTIONS(441),
    [anon_sym_bytes32] = ACTIONS(441),
    [anon_sym_fixed] = ACTIONS(441),
    [aux_sym__fixed_token1] = ACTIONS(441),
    [anon_sym_ufixed] = ACTIONS(441),
    [aux_sym__ufixed_token1] = ACTIONS(441),
    [aux_sym__decimal_number_token1] = ACTIONS(441),
    [aux_sym__decimal_number_token2] = ACTIONS(443),
    [aux_sym__hex_number_token1] = ACTIONS(443),
    [anon_sym_hex] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(443),
    [anon_sym_SQUOTE] = ACTIONS(443),
    [anon_sym_unicode] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_identifier] = ACTIONS(445),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_TILDE] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_type] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_for] = ACTIONS(445),
    [anon_sym_assembly] = ACTIONS(445),
    [anon_sym_break] = ACTIONS(445),
    [anon_sym_continue] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(445),
    [anon_sym_false] = ACTIONS(445),
    [anon_sym_if] = ACTIONS(445),
    [anon_sym_function] = ACTIONS(445),
    [anon_sym_byte] = ACTIONS(445),
    [anon_sym_address] = ACTIONS(445),
    [anon_sym_return] = ACTIONS(445),
    [anon_sym_revert] = ACTIONS(445),
    [sym_unchecked] = ACTIONS(445),
    [anon_sym_var] = ACTIONS(445),
    [anon_sym_else] = ACTIONS(445),
    [anon_sym_while] = ACTIONS(445),
    [anon_sym_do] = ACTIONS(445),
    [anon_sym_try] = ACTIONS(445),
    [anon_sym_emit] = ACTIONS(445),
    [anon_sym_payable] = ACTIONS(445),
    [anon_sym_new] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_BANG] = ACTIONS(447),
    [anon_sym_delete] = ACTIONS(445),
    [anon_sym_PLUS_PLUS] = ACTIONS(447),
    [anon_sym_DASH_DASH] = ACTIONS(447),
    [anon_sym_mapping] = ACTIONS(445),
    [anon_sym_bool] = ACTIONS(445),
    [anon_sym_string] = ACTIONS(445),
    [anon_sym_int] = ACTIONS(445),
    [anon_sym_int8] = ACTIONS(445),
    [anon_sym_int16] = ACTIONS(445),
    [anon_sym_int24] = ACTIONS(445),
    [anon_sym_int32] = ACTIONS(445),
    [anon_sym_int40] = ACTIONS(445),
    [anon_sym_int48] = ACTIONS(445),
    [anon_sym_int56] = ACTIONS(445),
    [anon_sym_int64] = ACTIONS(445),
    [anon_sym_int72] = ACTIONS(445),
    [anon_sym_int80] = ACTIONS(445),
    [anon_sym_int88] = ACTIONS(445),
    [anon_sym_int96] = ACTIONS(445),
    [anon_sym_int104] = ACTIONS(445),
    [anon_sym_int112] = ACTIONS(445),
    [anon_sym_int120] = ACTIONS(445),
    [anon_sym_int128] = ACTIONS(445),
    [anon_sym_int136] = ACTIONS(445),
    [anon_sym_int144] = ACTIONS(445),
    [anon_sym_int152] = ACTIONS(445),
    [anon_sym_int160] = ACTIONS(445),
    [anon_sym_int168] = ACTIONS(445),
    [anon_sym_int176] = ACTIONS(445),
    [anon_sym_int184] = ACTIONS(445),
    [anon_sym_int192] = ACTIONS(445),
    [anon_sym_int200] = ACTIONS(445),
    [anon_sym_int208] = ACTIONS(445),
    [anon_sym_int216] = ACTIONS(445),
    [anon_sym_int224] = ACTIONS(445),
    [anon_sym_int232] = ACTIONS(445),
    [anon_sym_int240] = ACTIONS(445),
    [anon_sym_int248] = ACTIONS(445),
    [anon_sym_int256] = ACTIONS(445),
    [anon_sym_uint] = ACTIONS(445),
    [anon_sym_uint8] = ACTIONS(445),
    [anon_sym_uint16] = ACTIONS(445),
    [anon_sym_uint24] = ACTIONS(445),
    [anon_sym_uint32] = ACTIONS(445),
    [anon_sym_uint40] = ACTIONS(445),
    [anon_sym_uint48] = ACTIONS(445),
    [anon_sym_uint56] = ACTIONS(445),
    [anon_sym_uint64] = ACTIONS(445),
    [anon_sym_uint72] = ACTIONS(445),
    [anon_sym_uint80] = ACTIONS(445),
    [anon_sym_uint88] = ACTIONS(445),
    [anon_sym_uint96] = ACTIONS(445),
    [anon_sym_uint104] = ACTIONS(445),
    [anon_sym_uint112] = ACTIONS(445),
    [anon_sym_uint120] = ACTIONS(445),
    [anon_sym_uint128] = ACTIONS(445),
    [anon_sym_uint136] = ACTIONS(445),
    [anon_sym_uint144] = ACTIONS(445),
    [anon_sym_uint152] = ACTIONS(445),
    [anon_sym_uint160] = ACTIONS(445),
    [anon_sym_uint168] = ACTIONS(445),
    [anon_sym_uint176] = ACTIONS(445),
    [anon_sym_uint184] = ACTIONS(445),
    [anon_sym_uint192] = ACTIONS(445),
    [anon_sym_uint200] = ACTIONS(445),
    [anon_sym_uint208] = ACTIONS(445),
    [anon_sym_uint216] = ACTIONS(445),
    [anon_sym_uint224] = ACTIONS(445),
    [anon_sym_uint232] = ACTIONS(445),
    [anon_sym_uint240] = ACTIONS(445),
    [anon_sym_uint248] = ACTIONS(445),
    [anon_sym_uint256] = ACTIONS(445),
    [anon_sym_bytes] = ACTIONS(445),
    [anon_sym_bytes1] = ACTIONS(445),
    [anon_sym_bytes2] = ACTIONS(445),
    [anon_sym_bytes3] = ACTIONS(445),
    [anon_sym_bytes4] = ACTIONS(445),
    [anon_sym_bytes5] = ACTIONS(445),
    [anon_sym_bytes6] = ACTIONS(445),
    [anon_sym_bytes7] = ACTIONS(445),
    [anon_sym_bytes8] = ACTIONS(445),
    [anon_sym_bytes9] = ACTIONS(445),
    [anon_sym_bytes10] = ACTIONS(445),
    [anon_sym_bytes11] = ACTIONS(445),
    [anon_sym_bytes12] = ACTIONS(445),
    [anon_sym_bytes13] = ACTIONS(445),
    [anon_sym_bytes14] = ACTIONS(445),
    [anon_sym_bytes15] = ACTIONS(445),
    [anon_sym_bytes16] = ACTIONS(445),
    [anon_sym_bytes17] = ACTIONS(445),
    [anon_sym_bytes18] = ACTIONS(445),
    [anon_sym_bytes19] = ACTIONS(445),
    [anon_sym_bytes20] = ACTIONS(445),
    [anon_sym_bytes21] = ACTIONS(445),
    [anon_sym_bytes22] = ACTIONS(445),
    [anon_sym_bytes23] = ACTIONS(445),
    [anon_sym_bytes24] = ACTIONS(445),
    [anon_sym_bytes25] = ACTIONS(445),
    [anon_sym_bytes26] = ACTIONS(445),
    [anon_sym_bytes27] = ACTIONS(445),
    [anon_sym_bytes28] = ACTIONS(445),
    [anon_sym_bytes29] = ACTIONS(445),
    [anon_sym_bytes30] = ACTIONS(445),
    [anon_sym_bytes31] = ACTIONS(445),
    [anon_sym_bytes32] = ACTIONS(445),
    [anon_sym_fixed] = ACTIONS(445),
    [aux_sym__fixed_token1] = ACTIONS(445),
    [anon_sym_ufixed] = ACTIONS(445),
    [aux_sym__ufixed_token1] = ACTIONS(445),
    [aux_sym__decimal_number_token1] = ACTIONS(445),
    [aux_sym__decimal_number_token2] = ACTIONS(447),
    [aux_sym__hex_number_token1] = ACTIONS(447),
    [anon_sym_hex] = ACTIONS(445),
    [anon_sym_DQUOTE] = ACTIONS(447),
    [anon_sym_SQUOTE] = ACTIONS(447),
    [anon_sym_unicode] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_identifier] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_type] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_assembly] = ACTIONS(449),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_continue] = ACTIONS(449),
    [anon_sym_true] = ACTIONS(449),
    [anon_sym_false] = ACTIONS(449),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(449),
    [anon_sym_byte] = ACTIONS(449),
    [anon_sym_address] = ACTIONS(449),
    [anon_sym_return] = ACTIONS(449),
    [anon_sym_revert] = ACTIONS(449),
    [sym_unchecked] = ACTIONS(449),
    [anon_sym_var] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_do] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(449),
    [anon_sym_emit] = ACTIONS(449),
    [anon_sym_payable] = ACTIONS(449),
    [anon_sym_new] = ACTIONS(449),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_BANG] = ACTIONS(451),
    [anon_sym_delete] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(451),
    [anon_sym_DASH_DASH] = ACTIONS(451),
    [anon_sym_mapping] = ACTIONS(449),
    [anon_sym_bool] = ACTIONS(449),
    [anon_sym_string] = ACTIONS(449),
    [anon_sym_int] = ACTIONS(449),
    [anon_sym_int8] = ACTIONS(449),
    [anon_sym_int16] = ACTIONS(449),
    [anon_sym_int24] = ACTIONS(449),
    [anon_sym_int32] = ACTIONS(449),
    [anon_sym_int40] = ACTIONS(449),
    [anon_sym_int48] = ACTIONS(449),
    [anon_sym_int56] = ACTIONS(449),
    [anon_sym_int64] = ACTIONS(449),
    [anon_sym_int72] = ACTIONS(449),
    [anon_sym_int80] = ACTIONS(449),
    [anon_sym_int88] = ACTIONS(449),
    [anon_sym_int96] = ACTIONS(449),
    [anon_sym_int104] = ACTIONS(449),
    [anon_sym_int112] = ACTIONS(449),
    [anon_sym_int120] = ACTIONS(449),
    [anon_sym_int128] = ACTIONS(449),
    [anon_sym_int136] = ACTIONS(449),
    [anon_sym_int144] = ACTIONS(449),
    [anon_sym_int152] = ACTIONS(449),
    [anon_sym_int160] = ACTIONS(449),
    [anon_sym_int168] = ACTIONS(449),
    [anon_sym_int176] = ACTIONS(449),
    [anon_sym_int184] = ACTIONS(449),
    [anon_sym_int192] = ACTIONS(449),
    [anon_sym_int200] = ACTIONS(449),
    [anon_sym_int208] = ACTIONS(449),
    [anon_sym_int216] = ACTIONS(449),
    [anon_sym_int224] = ACTIONS(449),
    [anon_sym_int232] = ACTIONS(449),
    [anon_sym_int240] = ACTIONS(449),
    [anon_sym_int248] = ACTIONS(449),
    [anon_sym_int256] = ACTIONS(449),
    [anon_sym_uint] = ACTIONS(449),
    [anon_sym_uint8] = ACTIONS(449),
    [anon_sym_uint16] = ACTIONS(449),
    [anon_sym_uint24] = ACTIONS(449),
    [anon_sym_uint32] = ACTIONS(449),
    [anon_sym_uint40] = ACTIONS(449),
    [anon_sym_uint48] = ACTIONS(449),
    [anon_sym_uint56] = ACTIONS(449),
    [anon_sym_uint64] = ACTIONS(449),
    [anon_sym_uint72] = ACTIONS(449),
    [anon_sym_uint80] = ACTIONS(449),
    [anon_sym_uint88] = ACTIONS(449),
    [anon_sym_uint96] = ACTIONS(449),
    [anon_sym_uint104] = ACTIONS(449),
    [anon_sym_uint112] = ACTIONS(449),
    [anon_sym_uint120] = ACTIONS(449),
    [anon_sym_uint128] = ACTIONS(449),
    [anon_sym_uint136] = ACTIONS(449),
    [anon_sym_uint144] = ACTIONS(449),
    [anon_sym_uint152] = ACTIONS(449),
    [anon_sym_uint160] = ACTIONS(449),
    [anon_sym_uint168] = ACTIONS(449),
    [anon_sym_uint176] = ACTIONS(449),
    [anon_sym_uint184] = ACTIONS(449),
    [anon_sym_uint192] = ACTIONS(449),
    [anon_sym_uint200] = ACTIONS(449),
    [anon_sym_uint208] = ACTIONS(449),
    [anon_sym_uint216] = ACTIONS(449),
    [anon_sym_uint224] = ACTIONS(449),
    [anon_sym_uint232] = ACTIONS(449),
    [anon_sym_uint240] = ACTIONS(449),
    [anon_sym_uint248] = ACTIONS(449),
    [anon_sym_uint256] = ACTIONS(449),
    [anon_sym_bytes] = ACTIONS(449),
    [anon_sym_bytes1] = ACTIONS(449),
    [anon_sym_bytes2] = ACTIONS(449),
    [anon_sym_bytes3] = ACTIONS(449),
    [anon_sym_bytes4] = ACTIONS(449),
    [anon_sym_bytes5] = ACTIONS(449),
    [anon_sym_bytes6] = ACTIONS(449),
    [anon_sym_bytes7] = ACTIONS(449),
    [anon_sym_bytes8] = ACTIONS(449),
    [anon_sym_bytes9] = ACTIONS(449),
    [anon_sym_bytes10] = ACTIONS(449),
    [anon_sym_bytes11] = ACTIONS(449),
    [anon_sym_bytes12] = ACTIONS(449),
    [anon_sym_bytes13] = ACTIONS(449),
    [anon_sym_bytes14] = ACTIONS(449),
    [anon_sym_bytes15] = ACTIONS(449),
    [anon_sym_bytes16] = ACTIONS(449),
    [anon_sym_bytes17] = ACTIONS(449),
    [anon_sym_bytes18] = ACTIONS(449),
    [anon_sym_bytes19] = ACTIONS(449),
    [anon_sym_bytes20] = ACTIONS(449),
    [anon_sym_bytes21] = ACTIONS(449),
    [anon_sym_bytes22] = ACTIONS(449),
    [anon_sym_bytes23] = ACTIONS(449),
    [anon_sym_bytes24] = ACTIONS(449),
    [anon_sym_bytes25] = ACTIONS(449),
    [anon_sym_bytes26] = ACTIONS(449),
    [anon_sym_bytes27] = ACTIONS(449),
    [anon_sym_bytes28] = ACTIONS(449),
    [anon_sym_bytes29] = ACTIONS(449),
    [anon_sym_bytes30] = ACTIONS(449),
    [anon_sym_bytes31] = ACTIONS(449),
    [anon_sym_bytes32] = ACTIONS(449),
    [anon_sym_fixed] = ACTIONS(449),
    [aux_sym__fixed_token1] = ACTIONS(449),
    [anon_sym_ufixed] = ACTIONS(449),
    [aux_sym__ufixed_token1] = ACTIONS(449),
    [aux_sym__decimal_number_token1] = ACTIONS(449),
    [aux_sym__decimal_number_token2] = ACTIONS(451),
    [aux_sym__hex_number_token1] = ACTIONS(451),
    [anon_sym_hex] = ACTIONS(449),
    [anon_sym_DQUOTE] = ACTIONS(451),
    [anon_sym_SQUOTE] = ACTIONS(451),
    [anon_sym_unicode] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_identifier] = ACTIONS(453),
    [anon_sym_DASH] = ACTIONS(453),
    [anon_sym_TILDE] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_type] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_for] = ACTIONS(453),
    [anon_sym_assembly] = ACTIONS(453),
    [anon_sym_break] = ACTIONS(453),
    [anon_sym_continue] = ACTIONS(453),
    [anon_sym_true] = ACTIONS(453),
    [anon_sym_false] = ACTIONS(453),
    [anon_sym_if] = ACTIONS(453),
    [anon_sym_function] = ACTIONS(453),
    [anon_sym_byte] = ACTIONS(453),
    [anon_sym_address] = ACTIONS(453),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_revert] = ACTIONS(453),
    [sym_unchecked] = ACTIONS(453),
    [anon_sym_var] = ACTIONS(453),
    [anon_sym_else] = ACTIONS(453),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_do] = ACTIONS(453),
    [anon_sym_try] = ACTIONS(453),
    [anon_sym_emit] = ACTIONS(453),
    [anon_sym_payable] = ACTIONS(453),
    [anon_sym_new] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_PLUS] = ACTIONS(453),
    [anon_sym_BANG] = ACTIONS(455),
    [anon_sym_delete] = ACTIONS(453),
    [anon_sym_PLUS_PLUS] = ACTIONS(455),
    [anon_sym_DASH_DASH] = ACTIONS(455),
    [anon_sym_mapping] = ACTIONS(453),
    [anon_sym_bool] = ACTIONS(453),
    [anon_sym_string] = ACTIONS(453),
    [anon_sym_int] = ACTIONS(453),
    [anon_sym_int8] = ACTIONS(453),
    [anon_sym_int16] = ACTIONS(453),
    [anon_sym_int24] = ACTIONS(453),
    [anon_sym_int32] = ACTIONS(453),
    [anon_sym_int40] = ACTIONS(453),
    [anon_sym_int48] = ACTIONS(453),
    [anon_sym_int56] = ACTIONS(453),
    [anon_sym_int64] = ACTIONS(453),
    [anon_sym_int72] = ACTIONS(453),
    [anon_sym_int80] = ACTIONS(453),
    [anon_sym_int88] = ACTIONS(453),
    [anon_sym_int96] = ACTIONS(453),
    [anon_sym_int104] = ACTIONS(453),
    [anon_sym_int112] = ACTIONS(453),
    [anon_sym_int120] = ACTIONS(453),
    [anon_sym_int128] = ACTIONS(453),
    [anon_sym_int136] = ACTIONS(453),
    [anon_sym_int144] = ACTIONS(453),
    [anon_sym_int152] = ACTIONS(453),
    [anon_sym_int160] = ACTIONS(453),
    [anon_sym_int168] = ACTIONS(453),
    [anon_sym_int176] = ACTIONS(453),
    [anon_sym_int184] = ACTIONS(453),
    [anon_sym_int192] = ACTIONS(453),
    [anon_sym_int200] = ACTIONS(453),
    [anon_sym_int208] = ACTIONS(453),
    [anon_sym_int216] = ACTIONS(453),
    [anon_sym_int224] = ACTIONS(453),
    [anon_sym_int232] = ACTIONS(453),
    [anon_sym_int240] = ACTIONS(453),
    [anon_sym_int248] = ACTIONS(453),
    [anon_sym_int256] = ACTIONS(453),
    [anon_sym_uint] = ACTIONS(453),
    [anon_sym_uint8] = ACTIONS(453),
    [anon_sym_uint16] = ACTIONS(453),
    [anon_sym_uint24] = ACTIONS(453),
    [anon_sym_uint32] = ACTIONS(453),
    [anon_sym_uint40] = ACTIONS(453),
    [anon_sym_uint48] = ACTIONS(453),
    [anon_sym_uint56] = ACTIONS(453),
    [anon_sym_uint64] = ACTIONS(453),
    [anon_sym_uint72] = ACTIONS(453),
    [anon_sym_uint80] = ACTIONS(453),
    [anon_sym_uint88] = ACTIONS(453),
    [anon_sym_uint96] = ACTIONS(453),
    [anon_sym_uint104] = ACTIONS(453),
    [anon_sym_uint112] = ACTIONS(453),
    [anon_sym_uint120] = ACTIONS(453),
    [anon_sym_uint128] = ACTIONS(453),
    [anon_sym_uint136] = ACTIONS(453),
    [anon_sym_uint144] = ACTIONS(453),
    [anon_sym_uint152] = ACTIONS(453),
    [anon_sym_uint160] = ACTIONS(453),
    [anon_sym_uint168] = ACTIONS(453),
    [anon_sym_uint176] = ACTIONS(453),
    [anon_sym_uint184] = ACTIONS(453),
    [anon_sym_uint192] = ACTIONS(453),
    [anon_sym_uint200] = ACTIONS(453),
    [anon_sym_uint208] = ACTIONS(453),
    [anon_sym_uint216] = ACTIONS(453),
    [anon_sym_uint224] = ACTIONS(453),
    [anon_sym_uint232] = ACTIONS(453),
    [anon_sym_uint240] = ACTIONS(453),
    [anon_sym_uint248] = ACTIONS(453),
    [anon_sym_uint256] = ACTIONS(453),
    [anon_sym_bytes] = ACTIONS(453),
    [anon_sym_bytes1] = ACTIONS(453),
    [anon_sym_bytes2] = ACTIONS(453),
    [anon_sym_bytes3] = ACTIONS(453),
    [anon_sym_bytes4] = ACTIONS(453),
    [anon_sym_bytes5] = ACTIONS(453),
    [anon_sym_bytes6] = ACTIONS(453),
    [anon_sym_bytes7] = ACTIONS(453),
    [anon_sym_bytes8] = ACTIONS(453),
    [anon_sym_bytes9] = ACTIONS(453),
    [anon_sym_bytes10] = ACTIONS(453),
    [anon_sym_bytes11] = ACTIONS(453),
    [anon_sym_bytes12] = ACTIONS(453),
    [anon_sym_bytes13] = ACTIONS(453),
    [anon_sym_bytes14] = ACTIONS(453),
    [anon_sym_bytes15] = ACTIONS(453),
    [anon_sym_bytes16] = ACTIONS(453),
    [anon_sym_bytes17] = ACTIONS(453),
    [anon_sym_bytes18] = ACTIONS(453),
    [anon_sym_bytes19] = ACTIONS(453),
    [anon_sym_bytes20] = ACTIONS(453),
    [anon_sym_bytes21] = ACTIONS(453),
    [anon_sym_bytes22] = ACTIONS(453),
    [anon_sym_bytes23] = ACTIONS(453),
    [anon_sym_bytes24] = ACTIONS(453),
    [anon_sym_bytes25] = ACTIONS(453),
    [anon_sym_bytes26] = ACTIONS(453),
    [anon_sym_bytes27] = ACTIONS(453),
    [anon_sym_bytes28] = ACTIONS(453),
    [anon_sym_bytes29] = ACTIONS(453),
    [anon_sym_bytes30] = ACTIONS(453),
    [anon_sym_bytes31] = ACTIONS(453),
    [anon_sym_bytes32] = ACTIONS(453),
    [anon_sym_fixed] = ACTIONS(453),
    [aux_sym__fixed_token1] = ACTIONS(453),
    [anon_sym_ufixed] = ACTIONS(453),
    [aux_sym__ufixed_token1] = ACTIONS(453),
    [aux_sym__decimal_number_token1] = ACTIONS(453),
    [aux_sym__decimal_number_token2] = ACTIONS(455),
    [aux_sym__hex_number_token1] = ACTIONS(455),
    [anon_sym_hex] = ACTIONS(453),
    [anon_sym_DQUOTE] = ACTIONS(455),
    [anon_sym_SQUOTE] = ACTIONS(455),
    [anon_sym_unicode] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_identifier] = ACTIONS(457),
    [anon_sym_DASH] = ACTIONS(457),
    [anon_sym_TILDE] = ACTIONS(459),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_type] = ACTIONS(457),
    [anon_sym_LPAREN] = ACTIONS(459),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_assembly] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_continue] = ACTIONS(457),
    [anon_sym_true] = ACTIONS(457),
    [anon_sym_false] = ACTIONS(457),
    [anon_sym_if] = ACTIONS(457),
    [anon_sym_function] = ACTIONS(457),
    [anon_sym_byte] = ACTIONS(457),
    [anon_sym_address] = ACTIONS(457),
    [anon_sym_return] = ACTIONS(457),
    [anon_sym_revert] = ACTIONS(457),
    [sym_unchecked] = ACTIONS(457),
    [anon_sym_var] = ACTIONS(457),
    [anon_sym_else] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(457),
    [anon_sym_do] = ACTIONS(457),
    [anon_sym_try] = ACTIONS(457),
    [anon_sym_emit] = ACTIONS(457),
    [anon_sym_payable] = ACTIONS(457),
    [anon_sym_new] = ACTIONS(457),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_BANG] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(457),
    [anon_sym_PLUS_PLUS] = ACTIONS(459),
    [anon_sym_DASH_DASH] = ACTIONS(459),
    [anon_sym_mapping] = ACTIONS(457),
    [anon_sym_bool] = ACTIONS(457),
    [anon_sym_string] = ACTIONS(457),
    [anon_sym_int] = ACTIONS(457),
    [anon_sym_int8] = ACTIONS(457),
    [anon_sym_int16] = ACTIONS(457),
    [anon_sym_int24] = ACTIONS(457),
    [anon_sym_int32] = ACTIONS(457),
    [anon_sym_int40] = ACTIONS(457),
    [anon_sym_int48] = ACTIONS(457),
    [anon_sym_int56] = ACTIONS(457),
    [anon_sym_int64] = ACTIONS(457),
    [anon_sym_int72] = ACTIONS(457),
    [anon_sym_int80] = ACTIONS(457),
    [anon_sym_int88] = ACTIONS(457),
    [anon_sym_int96] = ACTIONS(457),
    [anon_sym_int104] = ACTIONS(457),
    [anon_sym_int112] = ACTIONS(457),
    [anon_sym_int120] = ACTIONS(457),
    [anon_sym_int128] = ACTIONS(457),
    [anon_sym_int136] = ACTIONS(457),
    [anon_sym_int144] = ACTIONS(457),
    [anon_sym_int152] = ACTIONS(457),
    [anon_sym_int160] = ACTIONS(457),
    [anon_sym_int168] = ACTIONS(457),
    [anon_sym_int176] = ACTIONS(457),
    [anon_sym_int184] = ACTIONS(457),
    [anon_sym_int192] = ACTIONS(457),
    [anon_sym_int200] = ACTIONS(457),
    [anon_sym_int208] = ACTIONS(457),
    [anon_sym_int216] = ACTIONS(457),
    [anon_sym_int224] = ACTIONS(457),
    [anon_sym_int232] = ACTIONS(457),
    [anon_sym_int240] = ACTIONS(457),
    [anon_sym_int248] = ACTIONS(457),
    [anon_sym_int256] = ACTIONS(457),
    [anon_sym_uint] = ACTIONS(457),
    [anon_sym_uint8] = ACTIONS(457),
    [anon_sym_uint16] = ACTIONS(457),
    [anon_sym_uint24] = ACTIONS(457),
    [anon_sym_uint32] = ACTIONS(457),
    [anon_sym_uint40] = ACTIONS(457),
    [anon_sym_uint48] = ACTIONS(457),
    [anon_sym_uint56] = ACTIONS(457),
    [anon_sym_uint64] = ACTIONS(457),
    [anon_sym_uint72] = ACTIONS(457),
    [anon_sym_uint80] = ACTIONS(457),
    [anon_sym_uint88] = ACTIONS(457),
    [anon_sym_uint96] = ACTIONS(457),
    [anon_sym_uint104] = ACTIONS(457),
    [anon_sym_uint112] = ACTIONS(457),
    [anon_sym_uint120] = ACTIONS(457),
    [anon_sym_uint128] = ACTIONS(457),
    [anon_sym_uint136] = ACTIONS(457),
    [anon_sym_uint144] = ACTIONS(457),
    [anon_sym_uint152] = ACTIONS(457),
    [anon_sym_uint160] = ACTIONS(457),
    [anon_sym_uint168] = ACTIONS(457),
    [anon_sym_uint176] = ACTIONS(457),
    [anon_sym_uint184] = ACTIONS(457),
    [anon_sym_uint192] = ACTIONS(457),
    [anon_sym_uint200] = ACTIONS(457),
    [anon_sym_uint208] = ACTIONS(457),
    [anon_sym_uint216] = ACTIONS(457),
    [anon_sym_uint224] = ACTIONS(457),
    [anon_sym_uint232] = ACTIONS(457),
    [anon_sym_uint240] = ACTIONS(457),
    [anon_sym_uint248] = ACTIONS(457),
    [anon_sym_uint256] = ACTIONS(457),
    [anon_sym_bytes] = ACTIONS(457),
    [anon_sym_bytes1] = ACTIONS(457),
    [anon_sym_bytes2] = ACTIONS(457),
    [anon_sym_bytes3] = ACTIONS(457),
    [anon_sym_bytes4] = ACTIONS(457),
    [anon_sym_bytes5] = ACTIONS(457),
    [anon_sym_bytes6] = ACTIONS(457),
    [anon_sym_bytes7] = ACTIONS(457),
    [anon_sym_bytes8] = ACTIONS(457),
    [anon_sym_bytes9] = ACTIONS(457),
    [anon_sym_bytes10] = ACTIONS(457),
    [anon_sym_bytes11] = ACTIONS(457),
    [anon_sym_bytes12] = ACTIONS(457),
    [anon_sym_bytes13] = ACTIONS(457),
    [anon_sym_bytes14] = ACTIONS(457),
    [anon_sym_bytes15] = ACTIONS(457),
    [anon_sym_bytes16] = ACTIONS(457),
    [anon_sym_bytes17] = ACTIONS(457),
    [anon_sym_bytes18] = ACTIONS(457),
    [anon_sym_bytes19] = ACTIONS(457),
    [anon_sym_bytes20] = ACTIONS(457),
    [anon_sym_bytes21] = ACTIONS(457),
    [anon_sym_bytes22] = ACTIONS(457),
    [anon_sym_bytes23] = ACTIONS(457),
    [anon_sym_bytes24] = ACTIONS(457),
    [anon_sym_bytes25] = ACTIONS(457),
    [anon_sym_bytes26] = ACTIONS(457),
    [anon_sym_bytes27] = ACTIONS(457),
    [anon_sym_bytes28] = ACTIONS(457),
    [anon_sym_bytes29] = ACTIONS(457),
    [anon_sym_bytes30] = ACTIONS(457),
    [anon_sym_bytes31] = ACTIONS(457),
    [anon_sym_bytes32] = ACTIONS(457),
    [anon_sym_fixed] = ACTIONS(457),
    [aux_sym__fixed_token1] = ACTIONS(457),
    [anon_sym_ufixed] = ACTIONS(457),
    [aux_sym__ufixed_token1] = ACTIONS(457),
    [aux_sym__decimal_number_token1] = ACTIONS(457),
    [aux_sym__decimal_number_token2] = ACTIONS(459),
    [aux_sym__hex_number_token1] = ACTIONS(459),
    [anon_sym_hex] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(459),
    [anon_sym_SQUOTE] = ACTIONS(459),
    [anon_sym_unicode] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_user_defined_type_definition] = STATE(99),
    [sym_error_declaration] = STATE(99),
    [sym__contract_member] = STATE(99),
    [sym_struct_declaration] = STATE(99),
    [sym_enum_declaration] = STATE(99),
    [sym_event_definition] = STATE(99),
    [sym_using_directive] = STATE(99),
    [sym_state_variable_declaration] = STATE(99),
    [sym_modifier_definition] = STATE(99),
    [sym_constructor_definition] = STATE(99),
    [sym_fallback_receive_definition] = STATE(99),
    [sym_function_definition] = STATE(99),
    [sym_type_name] = STATE(460),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_contract_body_repeat1] = STATE(99),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(461),
    [anon_sym_type] = ACTIONS(463),
    [anon_sym_error] = ACTIONS(465),
    [anon_sym_struct] = ACTIONS(467),
    [anon_sym_enum] = ACTIONS(469),
    [anon_sym_event] = ACTIONS(471),
    [anon_sym_using] = ACTIONS(473),
    [anon_sym_function] = ACTIONS(475),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_modifier] = ACTIONS(477),
    [anon_sym_constructor] = ACTIONS(479),
    [anon_sym_fallback] = ACTIONS(481),
    [anon_sym_receive] = ACTIONS(481),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_identifier] = ACTIONS(483),
    [anon_sym_DASH] = ACTIONS(483),
    [anon_sym_TILDE] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_type] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_for] = ACTIONS(483),
    [anon_sym_assembly] = ACTIONS(483),
    [anon_sym_break] = ACTIONS(483),
    [anon_sym_continue] = ACTIONS(483),
    [anon_sym_true] = ACTIONS(483),
    [anon_sym_false] = ACTIONS(483),
    [anon_sym_if] = ACTIONS(483),
    [anon_sym_function] = ACTIONS(483),
    [anon_sym_byte] = ACTIONS(483),
    [anon_sym_address] = ACTIONS(483),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_revert] = ACTIONS(483),
    [sym_unchecked] = ACTIONS(483),
    [anon_sym_var] = ACTIONS(483),
    [anon_sym_else] = ACTIONS(483),
    [anon_sym_while] = ACTIONS(483),
    [anon_sym_do] = ACTIONS(483),
    [anon_sym_try] = ACTIONS(483),
    [anon_sym_emit] = ACTIONS(483),
    [anon_sym_payable] = ACTIONS(483),
    [anon_sym_new] = ACTIONS(483),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(483),
    [anon_sym_BANG] = ACTIONS(485),
    [anon_sym_delete] = ACTIONS(483),
    [anon_sym_PLUS_PLUS] = ACTIONS(485),
    [anon_sym_DASH_DASH] = ACTIONS(485),
    [anon_sym_mapping] = ACTIONS(483),
    [anon_sym_bool] = ACTIONS(483),
    [anon_sym_string] = ACTIONS(483),
    [anon_sym_int] = ACTIONS(483),
    [anon_sym_int8] = ACTIONS(483),
    [anon_sym_int16] = ACTIONS(483),
    [anon_sym_int24] = ACTIONS(483),
    [anon_sym_int32] = ACTIONS(483),
    [anon_sym_int40] = ACTIONS(483),
    [anon_sym_int48] = ACTIONS(483),
    [anon_sym_int56] = ACTIONS(483),
    [anon_sym_int64] = ACTIONS(483),
    [anon_sym_int72] = ACTIONS(483),
    [anon_sym_int80] = ACTIONS(483),
    [anon_sym_int88] = ACTIONS(483),
    [anon_sym_int96] = ACTIONS(483),
    [anon_sym_int104] = ACTIONS(483),
    [anon_sym_int112] = ACTIONS(483),
    [anon_sym_int120] = ACTIONS(483),
    [anon_sym_int128] = ACTIONS(483),
    [anon_sym_int136] = ACTIONS(483),
    [anon_sym_int144] = ACTIONS(483),
    [anon_sym_int152] = ACTIONS(483),
    [anon_sym_int160] = ACTIONS(483),
    [anon_sym_int168] = ACTIONS(483),
    [anon_sym_int176] = ACTIONS(483),
    [anon_sym_int184] = ACTIONS(483),
    [anon_sym_int192] = ACTIONS(483),
    [anon_sym_int200] = ACTIONS(483),
    [anon_sym_int208] = ACTIONS(483),
    [anon_sym_int216] = ACTIONS(483),
    [anon_sym_int224] = ACTIONS(483),
    [anon_sym_int232] = ACTIONS(483),
    [anon_sym_int240] = ACTIONS(483),
    [anon_sym_int248] = ACTIONS(483),
    [anon_sym_int256] = ACTIONS(483),
    [anon_sym_uint] = ACTIONS(483),
    [anon_sym_uint8] = ACTIONS(483),
    [anon_sym_uint16] = ACTIONS(483),
    [anon_sym_uint24] = ACTIONS(483),
    [anon_sym_uint32] = ACTIONS(483),
    [anon_sym_uint40] = ACTIONS(483),
    [anon_sym_uint48] = ACTIONS(483),
    [anon_sym_uint56] = ACTIONS(483),
    [anon_sym_uint64] = ACTIONS(483),
    [anon_sym_uint72] = ACTIONS(483),
    [anon_sym_uint80] = ACTIONS(483),
    [anon_sym_uint88] = ACTIONS(483),
    [anon_sym_uint96] = ACTIONS(483),
    [anon_sym_uint104] = ACTIONS(483),
    [anon_sym_uint112] = ACTIONS(483),
    [anon_sym_uint120] = ACTIONS(483),
    [anon_sym_uint128] = ACTIONS(483),
    [anon_sym_uint136] = ACTIONS(483),
    [anon_sym_uint144] = ACTIONS(483),
    [anon_sym_uint152] = ACTIONS(483),
    [anon_sym_uint160] = ACTIONS(483),
    [anon_sym_uint168] = ACTIONS(483),
    [anon_sym_uint176] = ACTIONS(483),
    [anon_sym_uint184] = ACTIONS(483),
    [anon_sym_uint192] = ACTIONS(483),
    [anon_sym_uint200] = ACTIONS(483),
    [anon_sym_uint208] = ACTIONS(483),
    [anon_sym_uint216] = ACTIONS(483),
    [anon_sym_uint224] = ACTIONS(483),
    [anon_sym_uint232] = ACTIONS(483),
    [anon_sym_uint240] = ACTIONS(483),
    [anon_sym_uint248] = ACTIONS(483),
    [anon_sym_uint256] = ACTIONS(483),
    [anon_sym_bytes] = ACTIONS(483),
    [anon_sym_bytes1] = ACTIONS(483),
    [anon_sym_bytes2] = ACTIONS(483),
    [anon_sym_bytes3] = ACTIONS(483),
    [anon_sym_bytes4] = ACTIONS(483),
    [anon_sym_bytes5] = ACTIONS(483),
    [anon_sym_bytes6] = ACTIONS(483),
    [anon_sym_bytes7] = ACTIONS(483),
    [anon_sym_bytes8] = ACTIONS(483),
    [anon_sym_bytes9] = ACTIONS(483),
    [anon_sym_bytes10] = ACTIONS(483),
    [anon_sym_bytes11] = ACTIONS(483),
    [anon_sym_bytes12] = ACTIONS(483),
    [anon_sym_bytes13] = ACTIONS(483),
    [anon_sym_bytes14] = ACTIONS(483),
    [anon_sym_bytes15] = ACTIONS(483),
    [anon_sym_bytes16] = ACTIONS(483),
    [anon_sym_bytes17] = ACTIONS(483),
    [anon_sym_bytes18] = ACTIONS(483),
    [anon_sym_bytes19] = ACTIONS(483),
    [anon_sym_bytes20] = ACTIONS(483),
    [anon_sym_bytes21] = ACTIONS(483),
    [anon_sym_bytes22] = ACTIONS(483),
    [anon_sym_bytes23] = ACTIONS(483),
    [anon_sym_bytes24] = ACTIONS(483),
    [anon_sym_bytes25] = ACTIONS(483),
    [anon_sym_bytes26] = ACTIONS(483),
    [anon_sym_bytes27] = ACTIONS(483),
    [anon_sym_bytes28] = ACTIONS(483),
    [anon_sym_bytes29] = ACTIONS(483),
    [anon_sym_bytes30] = ACTIONS(483),
    [anon_sym_bytes31] = ACTIONS(483),
    [anon_sym_bytes32] = ACTIONS(483),
    [anon_sym_fixed] = ACTIONS(483),
    [aux_sym__fixed_token1] = ACTIONS(483),
    [anon_sym_ufixed] = ACTIONS(483),
    [aux_sym__ufixed_token1] = ACTIONS(483),
    [aux_sym__decimal_number_token1] = ACTIONS(483),
    [aux_sym__decimal_number_token2] = ACTIONS(485),
    [aux_sym__hex_number_token1] = ACTIONS(485),
    [anon_sym_hex] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_SQUOTE] = ACTIONS(485),
    [anon_sym_unicode] = ACTIONS(483),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_user_defined_type_definition] = STATE(104),
    [sym_error_declaration] = STATE(104),
    [sym__contract_member] = STATE(104),
    [sym_struct_declaration] = STATE(104),
    [sym_enum_declaration] = STATE(104),
    [sym_event_definition] = STATE(104),
    [sym_using_directive] = STATE(104),
    [sym_state_variable_declaration] = STATE(104),
    [sym_modifier_definition] = STATE(104),
    [sym_constructor_definition] = STATE(104),
    [sym_fallback_receive_definition] = STATE(104),
    [sym_function_definition] = STATE(104),
    [sym_type_name] = STATE(460),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_contract_body_repeat1] = STATE(104),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(463),
    [anon_sym_error] = ACTIONS(465),
    [anon_sym_struct] = ACTIONS(467),
    [anon_sym_enum] = ACTIONS(469),
    [anon_sym_event] = ACTIONS(471),
    [anon_sym_using] = ACTIONS(473),
    [anon_sym_function] = ACTIONS(475),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_modifier] = ACTIONS(477),
    [anon_sym_constructor] = ACTIONS(479),
    [anon_sym_fallback] = ACTIONS(481),
    [anon_sym_receive] = ACTIONS(481),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_identifier] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(491),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_type] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_assembly] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_continue] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(489),
    [anon_sym_false] = ACTIONS(489),
    [anon_sym_if] = ACTIONS(489),
    [anon_sym_function] = ACTIONS(489),
    [anon_sym_byte] = ACTIONS(489),
    [anon_sym_address] = ACTIONS(489),
    [anon_sym_return] = ACTIONS(489),
    [anon_sym_revert] = ACTIONS(489),
    [sym_unchecked] = ACTIONS(489),
    [anon_sym_var] = ACTIONS(489),
    [anon_sym_else] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(489),
    [anon_sym_try] = ACTIONS(489),
    [anon_sym_emit] = ACTIONS(489),
    [anon_sym_payable] = ACTIONS(489),
    [anon_sym_new] = ACTIONS(489),
    [anon_sym_LBRACK] = ACTIONS(491),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_delete] = ACTIONS(489),
    [anon_sym_PLUS_PLUS] = ACTIONS(491),
    [anon_sym_DASH_DASH] = ACTIONS(491),
    [anon_sym_mapping] = ACTIONS(489),
    [anon_sym_bool] = ACTIONS(489),
    [anon_sym_string] = ACTIONS(489),
    [anon_sym_int] = ACTIONS(489),
    [anon_sym_int8] = ACTIONS(489),
    [anon_sym_int16] = ACTIONS(489),
    [anon_sym_int24] = ACTIONS(489),
    [anon_sym_int32] = ACTIONS(489),
    [anon_sym_int40] = ACTIONS(489),
    [anon_sym_int48] = ACTIONS(489),
    [anon_sym_int56] = ACTIONS(489),
    [anon_sym_int64] = ACTIONS(489),
    [anon_sym_int72] = ACTIONS(489),
    [anon_sym_int80] = ACTIONS(489),
    [anon_sym_int88] = ACTIONS(489),
    [anon_sym_int96] = ACTIONS(489),
    [anon_sym_int104] = ACTIONS(489),
    [anon_sym_int112] = ACTIONS(489),
    [anon_sym_int120] = ACTIONS(489),
    [anon_sym_int128] = ACTIONS(489),
    [anon_sym_int136] = ACTIONS(489),
    [anon_sym_int144] = ACTIONS(489),
    [anon_sym_int152] = ACTIONS(489),
    [anon_sym_int160] = ACTIONS(489),
    [anon_sym_int168] = ACTIONS(489),
    [anon_sym_int176] = ACTIONS(489),
    [anon_sym_int184] = ACTIONS(489),
    [anon_sym_int192] = ACTIONS(489),
    [anon_sym_int200] = ACTIONS(489),
    [anon_sym_int208] = ACTIONS(489),
    [anon_sym_int216] = ACTIONS(489),
    [anon_sym_int224] = ACTIONS(489),
    [anon_sym_int232] = ACTIONS(489),
    [anon_sym_int240] = ACTIONS(489),
    [anon_sym_int248] = ACTIONS(489),
    [anon_sym_int256] = ACTIONS(489),
    [anon_sym_uint] = ACTIONS(489),
    [anon_sym_uint8] = ACTIONS(489),
    [anon_sym_uint16] = ACTIONS(489),
    [anon_sym_uint24] = ACTIONS(489),
    [anon_sym_uint32] = ACTIONS(489),
    [anon_sym_uint40] = ACTIONS(489),
    [anon_sym_uint48] = ACTIONS(489),
    [anon_sym_uint56] = ACTIONS(489),
    [anon_sym_uint64] = ACTIONS(489),
    [anon_sym_uint72] = ACTIONS(489),
    [anon_sym_uint80] = ACTIONS(489),
    [anon_sym_uint88] = ACTIONS(489),
    [anon_sym_uint96] = ACTIONS(489),
    [anon_sym_uint104] = ACTIONS(489),
    [anon_sym_uint112] = ACTIONS(489),
    [anon_sym_uint120] = ACTIONS(489),
    [anon_sym_uint128] = ACTIONS(489),
    [anon_sym_uint136] = ACTIONS(489),
    [anon_sym_uint144] = ACTIONS(489),
    [anon_sym_uint152] = ACTIONS(489),
    [anon_sym_uint160] = ACTIONS(489),
    [anon_sym_uint168] = ACTIONS(489),
    [anon_sym_uint176] = ACTIONS(489),
    [anon_sym_uint184] = ACTIONS(489),
    [anon_sym_uint192] = ACTIONS(489),
    [anon_sym_uint200] = ACTIONS(489),
    [anon_sym_uint208] = ACTIONS(489),
    [anon_sym_uint216] = ACTIONS(489),
    [anon_sym_uint224] = ACTIONS(489),
    [anon_sym_uint232] = ACTIONS(489),
    [anon_sym_uint240] = ACTIONS(489),
    [anon_sym_uint248] = ACTIONS(489),
    [anon_sym_uint256] = ACTIONS(489),
    [anon_sym_bytes] = ACTIONS(489),
    [anon_sym_bytes1] = ACTIONS(489),
    [anon_sym_bytes2] = ACTIONS(489),
    [anon_sym_bytes3] = ACTIONS(489),
    [anon_sym_bytes4] = ACTIONS(489),
    [anon_sym_bytes5] = ACTIONS(489),
    [anon_sym_bytes6] = ACTIONS(489),
    [anon_sym_bytes7] = ACTIONS(489),
    [anon_sym_bytes8] = ACTIONS(489),
    [anon_sym_bytes9] = ACTIONS(489),
    [anon_sym_bytes10] = ACTIONS(489),
    [anon_sym_bytes11] = ACTIONS(489),
    [anon_sym_bytes12] = ACTIONS(489),
    [anon_sym_bytes13] = ACTIONS(489),
    [anon_sym_bytes14] = ACTIONS(489),
    [anon_sym_bytes15] = ACTIONS(489),
    [anon_sym_bytes16] = ACTIONS(489),
    [anon_sym_bytes17] = ACTIONS(489),
    [anon_sym_bytes18] = ACTIONS(489),
    [anon_sym_bytes19] = ACTIONS(489),
    [anon_sym_bytes20] = ACTIONS(489),
    [anon_sym_bytes21] = ACTIONS(489),
    [anon_sym_bytes22] = ACTIONS(489),
    [anon_sym_bytes23] = ACTIONS(489),
    [anon_sym_bytes24] = ACTIONS(489),
    [anon_sym_bytes25] = ACTIONS(489),
    [anon_sym_bytes26] = ACTIONS(489),
    [anon_sym_bytes27] = ACTIONS(489),
    [anon_sym_bytes28] = ACTIONS(489),
    [anon_sym_bytes29] = ACTIONS(489),
    [anon_sym_bytes30] = ACTIONS(489),
    [anon_sym_bytes31] = ACTIONS(489),
    [anon_sym_bytes32] = ACTIONS(489),
    [anon_sym_fixed] = ACTIONS(489),
    [aux_sym__fixed_token1] = ACTIONS(489),
    [anon_sym_ufixed] = ACTIONS(489),
    [aux_sym__ufixed_token1] = ACTIONS(489),
    [aux_sym__decimal_number_token1] = ACTIONS(489),
    [aux_sym__decimal_number_token2] = ACTIONS(491),
    [aux_sym__hex_number_token1] = ACTIONS(491),
    [anon_sym_hex] = ACTIONS(489),
    [anon_sym_DQUOTE] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(491),
    [anon_sym_unicode] = ACTIONS(489),
    [sym_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_identifier] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(495),
    [anon_sym_LBRACE] = ACTIONS(495),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_type] = ACTIONS(493),
    [anon_sym_LPAREN] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(493),
    [anon_sym_assembly] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(493),
    [anon_sym_continue] = ACTIONS(493),
    [anon_sym_true] = ACTIONS(493),
    [anon_sym_false] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_function] = ACTIONS(493),
    [anon_sym_byte] = ACTIONS(493),
    [anon_sym_address] = ACTIONS(493),
    [anon_sym_return] = ACTIONS(493),
    [anon_sym_revert] = ACTIONS(493),
    [sym_unchecked] = ACTIONS(493),
    [anon_sym_var] = ACTIONS(493),
    [anon_sym_else] = ACTIONS(493),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_try] = ACTIONS(493),
    [anon_sym_emit] = ACTIONS(493),
    [anon_sym_payable] = ACTIONS(493),
    [anon_sym_new] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_delete] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(495),
    [anon_sym_DASH_DASH] = ACTIONS(495),
    [anon_sym_mapping] = ACTIONS(493),
    [anon_sym_bool] = ACTIONS(493),
    [anon_sym_string] = ACTIONS(493),
    [anon_sym_int] = ACTIONS(493),
    [anon_sym_int8] = ACTIONS(493),
    [anon_sym_int16] = ACTIONS(493),
    [anon_sym_int24] = ACTIONS(493),
    [anon_sym_int32] = ACTIONS(493),
    [anon_sym_int40] = ACTIONS(493),
    [anon_sym_int48] = ACTIONS(493),
    [anon_sym_int56] = ACTIONS(493),
    [anon_sym_int64] = ACTIONS(493),
    [anon_sym_int72] = ACTIONS(493),
    [anon_sym_int80] = ACTIONS(493),
    [anon_sym_int88] = ACTIONS(493),
    [anon_sym_int96] = ACTIONS(493),
    [anon_sym_int104] = ACTIONS(493),
    [anon_sym_int112] = ACTIONS(493),
    [anon_sym_int120] = ACTIONS(493),
    [anon_sym_int128] = ACTIONS(493),
    [anon_sym_int136] = ACTIONS(493),
    [anon_sym_int144] = ACTIONS(493),
    [anon_sym_int152] = ACTIONS(493),
    [anon_sym_int160] = ACTIONS(493),
    [anon_sym_int168] = ACTIONS(493),
    [anon_sym_int176] = ACTIONS(493),
    [anon_sym_int184] = ACTIONS(493),
    [anon_sym_int192] = ACTIONS(493),
    [anon_sym_int200] = ACTIONS(493),
    [anon_sym_int208] = ACTIONS(493),
    [anon_sym_int216] = ACTIONS(493),
    [anon_sym_int224] = ACTIONS(493),
    [anon_sym_int232] = ACTIONS(493),
    [anon_sym_int240] = ACTIONS(493),
    [anon_sym_int248] = ACTIONS(493),
    [anon_sym_int256] = ACTIONS(493),
    [anon_sym_uint] = ACTIONS(493),
    [anon_sym_uint8] = ACTIONS(493),
    [anon_sym_uint16] = ACTIONS(493),
    [anon_sym_uint24] = ACTIONS(493),
    [anon_sym_uint32] = ACTIONS(493),
    [anon_sym_uint40] = ACTIONS(493),
    [anon_sym_uint48] = ACTIONS(493),
    [anon_sym_uint56] = ACTIONS(493),
    [anon_sym_uint64] = ACTIONS(493),
    [anon_sym_uint72] = ACTIONS(493),
    [anon_sym_uint80] = ACTIONS(493),
    [anon_sym_uint88] = ACTIONS(493),
    [anon_sym_uint96] = ACTIONS(493),
    [anon_sym_uint104] = ACTIONS(493),
    [anon_sym_uint112] = ACTIONS(493),
    [anon_sym_uint120] = ACTIONS(493),
    [anon_sym_uint128] = ACTIONS(493),
    [anon_sym_uint136] = ACTIONS(493),
    [anon_sym_uint144] = ACTIONS(493),
    [anon_sym_uint152] = ACTIONS(493),
    [anon_sym_uint160] = ACTIONS(493),
    [anon_sym_uint168] = ACTIONS(493),
    [anon_sym_uint176] = ACTIONS(493),
    [anon_sym_uint184] = ACTIONS(493),
    [anon_sym_uint192] = ACTIONS(493),
    [anon_sym_uint200] = ACTIONS(493),
    [anon_sym_uint208] = ACTIONS(493),
    [anon_sym_uint216] = ACTIONS(493),
    [anon_sym_uint224] = ACTIONS(493),
    [anon_sym_uint232] = ACTIONS(493),
    [anon_sym_uint240] = ACTIONS(493),
    [anon_sym_uint248] = ACTIONS(493),
    [anon_sym_uint256] = ACTIONS(493),
    [anon_sym_bytes] = ACTIONS(493),
    [anon_sym_bytes1] = ACTIONS(493),
    [anon_sym_bytes2] = ACTIONS(493),
    [anon_sym_bytes3] = ACTIONS(493),
    [anon_sym_bytes4] = ACTIONS(493),
    [anon_sym_bytes5] = ACTIONS(493),
    [anon_sym_bytes6] = ACTIONS(493),
    [anon_sym_bytes7] = ACTIONS(493),
    [anon_sym_bytes8] = ACTIONS(493),
    [anon_sym_bytes9] = ACTIONS(493),
    [anon_sym_bytes10] = ACTIONS(493),
    [anon_sym_bytes11] = ACTIONS(493),
    [anon_sym_bytes12] = ACTIONS(493),
    [anon_sym_bytes13] = ACTIONS(493),
    [anon_sym_bytes14] = ACTIONS(493),
    [anon_sym_bytes15] = ACTIONS(493),
    [anon_sym_bytes16] = ACTIONS(493),
    [anon_sym_bytes17] = ACTIONS(493),
    [anon_sym_bytes18] = ACTIONS(493),
    [anon_sym_bytes19] = ACTIONS(493),
    [anon_sym_bytes20] = ACTIONS(493),
    [anon_sym_bytes21] = ACTIONS(493),
    [anon_sym_bytes22] = ACTIONS(493),
    [anon_sym_bytes23] = ACTIONS(493),
    [anon_sym_bytes24] = ACTIONS(493),
    [anon_sym_bytes25] = ACTIONS(493),
    [anon_sym_bytes26] = ACTIONS(493),
    [anon_sym_bytes27] = ACTIONS(493),
    [anon_sym_bytes28] = ACTIONS(493),
    [anon_sym_bytes29] = ACTIONS(493),
    [anon_sym_bytes30] = ACTIONS(493),
    [anon_sym_bytes31] = ACTIONS(493),
    [anon_sym_bytes32] = ACTIONS(493),
    [anon_sym_fixed] = ACTIONS(493),
    [aux_sym__fixed_token1] = ACTIONS(493),
    [anon_sym_ufixed] = ACTIONS(493),
    [aux_sym__ufixed_token1] = ACTIONS(493),
    [aux_sym__decimal_number_token1] = ACTIONS(493),
    [aux_sym__decimal_number_token2] = ACTIONS(495),
    [aux_sym__hex_number_token1] = ACTIONS(495),
    [anon_sym_hex] = ACTIONS(493),
    [anon_sym_DQUOTE] = ACTIONS(495),
    [anon_sym_SQUOTE] = ACTIONS(495),
    [anon_sym_unicode] = ACTIONS(493),
    [sym_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_identifier] = ACTIONS(497),
    [anon_sym_DASH] = ACTIONS(497),
    [anon_sym_TILDE] = ACTIONS(499),
    [anon_sym_LBRACE] = ACTIONS(499),
    [anon_sym_RBRACE] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(497),
    [anon_sym_LPAREN] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(497),
    [anon_sym_assembly] = ACTIONS(497),
    [anon_sym_break] = ACTIONS(497),
    [anon_sym_continue] = ACTIONS(497),
    [anon_sym_true] = ACTIONS(497),
    [anon_sym_false] = ACTIONS(497),
    [anon_sym_if] = ACTIONS(497),
    [anon_sym_function] = ACTIONS(497),
    [anon_sym_byte] = ACTIONS(497),
    [anon_sym_address] = ACTIONS(497),
    [anon_sym_return] = ACTIONS(497),
    [anon_sym_revert] = ACTIONS(497),
    [sym_unchecked] = ACTIONS(497),
    [anon_sym_var] = ACTIONS(497),
    [anon_sym_else] = ACTIONS(497),
    [anon_sym_while] = ACTIONS(497),
    [anon_sym_do] = ACTIONS(497),
    [anon_sym_try] = ACTIONS(497),
    [anon_sym_emit] = ACTIONS(497),
    [anon_sym_payable] = ACTIONS(497),
    [anon_sym_new] = ACTIONS(497),
    [anon_sym_LBRACK] = ACTIONS(499),
    [anon_sym_PLUS] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_delete] = ACTIONS(497),
    [anon_sym_PLUS_PLUS] = ACTIONS(499),
    [anon_sym_DASH_DASH] = ACTIONS(499),
    [anon_sym_mapping] = ACTIONS(497),
    [anon_sym_bool] = ACTIONS(497),
    [anon_sym_string] = ACTIONS(497),
    [anon_sym_int] = ACTIONS(497),
    [anon_sym_int8] = ACTIONS(497),
    [anon_sym_int16] = ACTIONS(497),
    [anon_sym_int24] = ACTIONS(497),
    [anon_sym_int32] = ACTIONS(497),
    [anon_sym_int40] = ACTIONS(497),
    [anon_sym_int48] = ACTIONS(497),
    [anon_sym_int56] = ACTIONS(497),
    [anon_sym_int64] = ACTIONS(497),
    [anon_sym_int72] = ACTIONS(497),
    [anon_sym_int80] = ACTIONS(497),
    [anon_sym_int88] = ACTIONS(497),
    [anon_sym_int96] = ACTIONS(497),
    [anon_sym_int104] = ACTIONS(497),
    [anon_sym_int112] = ACTIONS(497),
    [anon_sym_int120] = ACTIONS(497),
    [anon_sym_int128] = ACTIONS(497),
    [anon_sym_int136] = ACTIONS(497),
    [anon_sym_int144] = ACTIONS(497),
    [anon_sym_int152] = ACTIONS(497),
    [anon_sym_int160] = ACTIONS(497),
    [anon_sym_int168] = ACTIONS(497),
    [anon_sym_int176] = ACTIONS(497),
    [anon_sym_int184] = ACTIONS(497),
    [anon_sym_int192] = ACTIONS(497),
    [anon_sym_int200] = ACTIONS(497),
    [anon_sym_int208] = ACTIONS(497),
    [anon_sym_int216] = ACTIONS(497),
    [anon_sym_int224] = ACTIONS(497),
    [anon_sym_int232] = ACTIONS(497),
    [anon_sym_int240] = ACTIONS(497),
    [anon_sym_int248] = ACTIONS(497),
    [anon_sym_int256] = ACTIONS(497),
    [anon_sym_uint] = ACTIONS(497),
    [anon_sym_uint8] = ACTIONS(497),
    [anon_sym_uint16] = ACTIONS(497),
    [anon_sym_uint24] = ACTIONS(497),
    [anon_sym_uint32] = ACTIONS(497),
    [anon_sym_uint40] = ACTIONS(497),
    [anon_sym_uint48] = ACTIONS(497),
    [anon_sym_uint56] = ACTIONS(497),
    [anon_sym_uint64] = ACTIONS(497),
    [anon_sym_uint72] = ACTIONS(497),
    [anon_sym_uint80] = ACTIONS(497),
    [anon_sym_uint88] = ACTIONS(497),
    [anon_sym_uint96] = ACTIONS(497),
    [anon_sym_uint104] = ACTIONS(497),
    [anon_sym_uint112] = ACTIONS(497),
    [anon_sym_uint120] = ACTIONS(497),
    [anon_sym_uint128] = ACTIONS(497),
    [anon_sym_uint136] = ACTIONS(497),
    [anon_sym_uint144] = ACTIONS(497),
    [anon_sym_uint152] = ACTIONS(497),
    [anon_sym_uint160] = ACTIONS(497),
    [anon_sym_uint168] = ACTIONS(497),
    [anon_sym_uint176] = ACTIONS(497),
    [anon_sym_uint184] = ACTIONS(497),
    [anon_sym_uint192] = ACTIONS(497),
    [anon_sym_uint200] = ACTIONS(497),
    [anon_sym_uint208] = ACTIONS(497),
    [anon_sym_uint216] = ACTIONS(497),
    [anon_sym_uint224] = ACTIONS(497),
    [anon_sym_uint232] = ACTIONS(497),
    [anon_sym_uint240] = ACTIONS(497),
    [anon_sym_uint248] = ACTIONS(497),
    [anon_sym_uint256] = ACTIONS(497),
    [anon_sym_bytes] = ACTIONS(497),
    [anon_sym_bytes1] = ACTIONS(497),
    [anon_sym_bytes2] = ACTIONS(497),
    [anon_sym_bytes3] = ACTIONS(497),
    [anon_sym_bytes4] = ACTIONS(497),
    [anon_sym_bytes5] = ACTIONS(497),
    [anon_sym_bytes6] = ACTIONS(497),
    [anon_sym_bytes7] = ACTIONS(497),
    [anon_sym_bytes8] = ACTIONS(497),
    [anon_sym_bytes9] = ACTIONS(497),
    [anon_sym_bytes10] = ACTIONS(497),
    [anon_sym_bytes11] = ACTIONS(497),
    [anon_sym_bytes12] = ACTIONS(497),
    [anon_sym_bytes13] = ACTIONS(497),
    [anon_sym_bytes14] = ACTIONS(497),
    [anon_sym_bytes15] = ACTIONS(497),
    [anon_sym_bytes16] = ACTIONS(497),
    [anon_sym_bytes17] = ACTIONS(497),
    [anon_sym_bytes18] = ACTIONS(497),
    [anon_sym_bytes19] = ACTIONS(497),
    [anon_sym_bytes20] = ACTIONS(497),
    [anon_sym_bytes21] = ACTIONS(497),
    [anon_sym_bytes22] = ACTIONS(497),
    [anon_sym_bytes23] = ACTIONS(497),
    [anon_sym_bytes24] = ACTIONS(497),
    [anon_sym_bytes25] = ACTIONS(497),
    [anon_sym_bytes26] = ACTIONS(497),
    [anon_sym_bytes27] = ACTIONS(497),
    [anon_sym_bytes28] = ACTIONS(497),
    [anon_sym_bytes29] = ACTIONS(497),
    [anon_sym_bytes30] = ACTIONS(497),
    [anon_sym_bytes31] = ACTIONS(497),
    [anon_sym_bytes32] = ACTIONS(497),
    [anon_sym_fixed] = ACTIONS(497),
    [aux_sym__fixed_token1] = ACTIONS(497),
    [anon_sym_ufixed] = ACTIONS(497),
    [aux_sym__ufixed_token1] = ACTIONS(497),
    [aux_sym__decimal_number_token1] = ACTIONS(497),
    [aux_sym__decimal_number_token2] = ACTIONS(499),
    [aux_sym__hex_number_token1] = ACTIONS(499),
    [anon_sym_hex] = ACTIONS(497),
    [anon_sym_DQUOTE] = ACTIONS(499),
    [anon_sym_SQUOTE] = ACTIONS(499),
    [anon_sym_unicode] = ACTIONS(497),
    [sym_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_identifier] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(501),
    [anon_sym_TILDE] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_RBRACE] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(503),
    [anon_sym_for] = ACTIONS(501),
    [anon_sym_assembly] = ACTIONS(501),
    [anon_sym_break] = ACTIONS(501),
    [anon_sym_continue] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(501),
    [anon_sym_false] = ACTIONS(501),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_function] = ACTIONS(501),
    [anon_sym_byte] = ACTIONS(501),
    [anon_sym_address] = ACTIONS(501),
    [anon_sym_return] = ACTIONS(501),
    [anon_sym_revert] = ACTIONS(501),
    [sym_unchecked] = ACTIONS(501),
    [anon_sym_var] = ACTIONS(501),
    [anon_sym_else] = ACTIONS(501),
    [anon_sym_while] = ACTIONS(501),
    [anon_sym_do] = ACTIONS(501),
    [anon_sym_try] = ACTIONS(501),
    [anon_sym_emit] = ACTIONS(501),
    [anon_sym_payable] = ACTIONS(501),
    [anon_sym_new] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(503),
    [anon_sym_PLUS] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_delete] = ACTIONS(501),
    [anon_sym_PLUS_PLUS] = ACTIONS(503),
    [anon_sym_DASH_DASH] = ACTIONS(503),
    [anon_sym_mapping] = ACTIONS(501),
    [anon_sym_bool] = ACTIONS(501),
    [anon_sym_string] = ACTIONS(501),
    [anon_sym_int] = ACTIONS(501),
    [anon_sym_int8] = ACTIONS(501),
    [anon_sym_int16] = ACTIONS(501),
    [anon_sym_int24] = ACTIONS(501),
    [anon_sym_int32] = ACTIONS(501),
    [anon_sym_int40] = ACTIONS(501),
    [anon_sym_int48] = ACTIONS(501),
    [anon_sym_int56] = ACTIONS(501),
    [anon_sym_int64] = ACTIONS(501),
    [anon_sym_int72] = ACTIONS(501),
    [anon_sym_int80] = ACTIONS(501),
    [anon_sym_int88] = ACTIONS(501),
    [anon_sym_int96] = ACTIONS(501),
    [anon_sym_int104] = ACTIONS(501),
    [anon_sym_int112] = ACTIONS(501),
    [anon_sym_int120] = ACTIONS(501),
    [anon_sym_int128] = ACTIONS(501),
    [anon_sym_int136] = ACTIONS(501),
    [anon_sym_int144] = ACTIONS(501),
    [anon_sym_int152] = ACTIONS(501),
    [anon_sym_int160] = ACTIONS(501),
    [anon_sym_int168] = ACTIONS(501),
    [anon_sym_int176] = ACTIONS(501),
    [anon_sym_int184] = ACTIONS(501),
    [anon_sym_int192] = ACTIONS(501),
    [anon_sym_int200] = ACTIONS(501),
    [anon_sym_int208] = ACTIONS(501),
    [anon_sym_int216] = ACTIONS(501),
    [anon_sym_int224] = ACTIONS(501),
    [anon_sym_int232] = ACTIONS(501),
    [anon_sym_int240] = ACTIONS(501),
    [anon_sym_int248] = ACTIONS(501),
    [anon_sym_int256] = ACTIONS(501),
    [anon_sym_uint] = ACTIONS(501),
    [anon_sym_uint8] = ACTIONS(501),
    [anon_sym_uint16] = ACTIONS(501),
    [anon_sym_uint24] = ACTIONS(501),
    [anon_sym_uint32] = ACTIONS(501),
    [anon_sym_uint40] = ACTIONS(501),
    [anon_sym_uint48] = ACTIONS(501),
    [anon_sym_uint56] = ACTIONS(501),
    [anon_sym_uint64] = ACTIONS(501),
    [anon_sym_uint72] = ACTIONS(501),
    [anon_sym_uint80] = ACTIONS(501),
    [anon_sym_uint88] = ACTIONS(501),
    [anon_sym_uint96] = ACTIONS(501),
    [anon_sym_uint104] = ACTIONS(501),
    [anon_sym_uint112] = ACTIONS(501),
    [anon_sym_uint120] = ACTIONS(501),
    [anon_sym_uint128] = ACTIONS(501),
    [anon_sym_uint136] = ACTIONS(501),
    [anon_sym_uint144] = ACTIONS(501),
    [anon_sym_uint152] = ACTIONS(501),
    [anon_sym_uint160] = ACTIONS(501),
    [anon_sym_uint168] = ACTIONS(501),
    [anon_sym_uint176] = ACTIONS(501),
    [anon_sym_uint184] = ACTIONS(501),
    [anon_sym_uint192] = ACTIONS(501),
    [anon_sym_uint200] = ACTIONS(501),
    [anon_sym_uint208] = ACTIONS(501),
    [anon_sym_uint216] = ACTIONS(501),
    [anon_sym_uint224] = ACTIONS(501),
    [anon_sym_uint232] = ACTIONS(501),
    [anon_sym_uint240] = ACTIONS(501),
    [anon_sym_uint248] = ACTIONS(501),
    [anon_sym_uint256] = ACTIONS(501),
    [anon_sym_bytes] = ACTIONS(501),
    [anon_sym_bytes1] = ACTIONS(501),
    [anon_sym_bytes2] = ACTIONS(501),
    [anon_sym_bytes3] = ACTIONS(501),
    [anon_sym_bytes4] = ACTIONS(501),
    [anon_sym_bytes5] = ACTIONS(501),
    [anon_sym_bytes6] = ACTIONS(501),
    [anon_sym_bytes7] = ACTIONS(501),
    [anon_sym_bytes8] = ACTIONS(501),
    [anon_sym_bytes9] = ACTIONS(501),
    [anon_sym_bytes10] = ACTIONS(501),
    [anon_sym_bytes11] = ACTIONS(501),
    [anon_sym_bytes12] = ACTIONS(501),
    [anon_sym_bytes13] = ACTIONS(501),
    [anon_sym_bytes14] = ACTIONS(501),
    [anon_sym_bytes15] = ACTIONS(501),
    [anon_sym_bytes16] = ACTIONS(501),
    [anon_sym_bytes17] = ACTIONS(501),
    [anon_sym_bytes18] = ACTIONS(501),
    [anon_sym_bytes19] = ACTIONS(501),
    [anon_sym_bytes20] = ACTIONS(501),
    [anon_sym_bytes21] = ACTIONS(501),
    [anon_sym_bytes22] = ACTIONS(501),
    [anon_sym_bytes23] = ACTIONS(501),
    [anon_sym_bytes24] = ACTIONS(501),
    [anon_sym_bytes25] = ACTIONS(501),
    [anon_sym_bytes26] = ACTIONS(501),
    [anon_sym_bytes27] = ACTIONS(501),
    [anon_sym_bytes28] = ACTIONS(501),
    [anon_sym_bytes29] = ACTIONS(501),
    [anon_sym_bytes30] = ACTIONS(501),
    [anon_sym_bytes31] = ACTIONS(501),
    [anon_sym_bytes32] = ACTIONS(501),
    [anon_sym_fixed] = ACTIONS(501),
    [aux_sym__fixed_token1] = ACTIONS(501),
    [anon_sym_ufixed] = ACTIONS(501),
    [aux_sym__ufixed_token1] = ACTIONS(501),
    [aux_sym__decimal_number_token1] = ACTIONS(501),
    [aux_sym__decimal_number_token2] = ACTIONS(503),
    [aux_sym__hex_number_token1] = ACTIONS(503),
    [anon_sym_hex] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(503),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [anon_sym_unicode] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_user_defined_type_definition] = STATE(104),
    [sym_error_declaration] = STATE(104),
    [sym__contract_member] = STATE(104),
    [sym_struct_declaration] = STATE(104),
    [sym_enum_declaration] = STATE(104),
    [sym_event_definition] = STATE(104),
    [sym_using_directive] = STATE(104),
    [sym_state_variable_declaration] = STATE(104),
    [sym_modifier_definition] = STATE(104),
    [sym_constructor_definition] = STATE(104),
    [sym_fallback_receive_definition] = STATE(104),
    [sym_function_definition] = STATE(104),
    [sym_type_name] = STATE(460),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_contract_body_repeat1] = STATE(104),
    [sym_identifier] = ACTIONS(505),
    [anon_sym_RBRACE] = ACTIONS(508),
    [anon_sym_type] = ACTIONS(510),
    [anon_sym_error] = ACTIONS(513),
    [anon_sym_struct] = ACTIONS(516),
    [anon_sym_enum] = ACTIONS(519),
    [anon_sym_event] = ACTIONS(522),
    [anon_sym_using] = ACTIONS(525),
    [anon_sym_function] = ACTIONS(528),
    [anon_sym_byte] = ACTIONS(531),
    [anon_sym_address] = ACTIONS(534),
    [anon_sym_var] = ACTIONS(531),
    [anon_sym_modifier] = ACTIONS(537),
    [anon_sym_constructor] = ACTIONS(540),
    [anon_sym_fallback] = ACTIONS(543),
    [anon_sym_receive] = ACTIONS(543),
    [anon_sym_mapping] = ACTIONS(546),
    [anon_sym_bool] = ACTIONS(531),
    [anon_sym_string] = ACTIONS(531),
    [anon_sym_int] = ACTIONS(531),
    [anon_sym_int8] = ACTIONS(531),
    [anon_sym_int16] = ACTIONS(531),
    [anon_sym_int24] = ACTIONS(531),
    [anon_sym_int32] = ACTIONS(531),
    [anon_sym_int40] = ACTIONS(531),
    [anon_sym_int48] = ACTIONS(531),
    [anon_sym_int56] = ACTIONS(531),
    [anon_sym_int64] = ACTIONS(531),
    [anon_sym_int72] = ACTIONS(531),
    [anon_sym_int80] = ACTIONS(531),
    [anon_sym_int88] = ACTIONS(531),
    [anon_sym_int96] = ACTIONS(531),
    [anon_sym_int104] = ACTIONS(531),
    [anon_sym_int112] = ACTIONS(531),
    [anon_sym_int120] = ACTIONS(531),
    [anon_sym_int128] = ACTIONS(531),
    [anon_sym_int136] = ACTIONS(531),
    [anon_sym_int144] = ACTIONS(531),
    [anon_sym_int152] = ACTIONS(531),
    [anon_sym_int160] = ACTIONS(531),
    [anon_sym_int168] = ACTIONS(531),
    [anon_sym_int176] = ACTIONS(531),
    [anon_sym_int184] = ACTIONS(531),
    [anon_sym_int192] = ACTIONS(531),
    [anon_sym_int200] = ACTIONS(531),
    [anon_sym_int208] = ACTIONS(531),
    [anon_sym_int216] = ACTIONS(531),
    [anon_sym_int224] = ACTIONS(531),
    [anon_sym_int232] = ACTIONS(531),
    [anon_sym_int240] = ACTIONS(531),
    [anon_sym_int248] = ACTIONS(531),
    [anon_sym_int256] = ACTIONS(531),
    [anon_sym_uint] = ACTIONS(531),
    [anon_sym_uint8] = ACTIONS(531),
    [anon_sym_uint16] = ACTIONS(531),
    [anon_sym_uint24] = ACTIONS(531),
    [anon_sym_uint32] = ACTIONS(531),
    [anon_sym_uint40] = ACTIONS(531),
    [anon_sym_uint48] = ACTIONS(531),
    [anon_sym_uint56] = ACTIONS(531),
    [anon_sym_uint64] = ACTIONS(531),
    [anon_sym_uint72] = ACTIONS(531),
    [anon_sym_uint80] = ACTIONS(531),
    [anon_sym_uint88] = ACTIONS(531),
    [anon_sym_uint96] = ACTIONS(531),
    [anon_sym_uint104] = ACTIONS(531),
    [anon_sym_uint112] = ACTIONS(531),
    [anon_sym_uint120] = ACTIONS(531),
    [anon_sym_uint128] = ACTIONS(531),
    [anon_sym_uint136] = ACTIONS(531),
    [anon_sym_uint144] = ACTIONS(531),
    [anon_sym_uint152] = ACTIONS(531),
    [anon_sym_uint160] = ACTIONS(531),
    [anon_sym_uint168] = ACTIONS(531),
    [anon_sym_uint176] = ACTIONS(531),
    [anon_sym_uint184] = ACTIONS(531),
    [anon_sym_uint192] = ACTIONS(531),
    [anon_sym_uint200] = ACTIONS(531),
    [anon_sym_uint208] = ACTIONS(531),
    [anon_sym_uint216] = ACTIONS(531),
    [anon_sym_uint224] = ACTIONS(531),
    [anon_sym_uint232] = ACTIONS(531),
    [anon_sym_uint240] = ACTIONS(531),
    [anon_sym_uint248] = ACTIONS(531),
    [anon_sym_uint256] = ACTIONS(531),
    [anon_sym_bytes] = ACTIONS(531),
    [anon_sym_bytes1] = ACTIONS(531),
    [anon_sym_bytes2] = ACTIONS(531),
    [anon_sym_bytes3] = ACTIONS(531),
    [anon_sym_bytes4] = ACTIONS(531),
    [anon_sym_bytes5] = ACTIONS(531),
    [anon_sym_bytes6] = ACTIONS(531),
    [anon_sym_bytes7] = ACTIONS(531),
    [anon_sym_bytes8] = ACTIONS(531),
    [anon_sym_bytes9] = ACTIONS(531),
    [anon_sym_bytes10] = ACTIONS(531),
    [anon_sym_bytes11] = ACTIONS(531),
    [anon_sym_bytes12] = ACTIONS(531),
    [anon_sym_bytes13] = ACTIONS(531),
    [anon_sym_bytes14] = ACTIONS(531),
    [anon_sym_bytes15] = ACTIONS(531),
    [anon_sym_bytes16] = ACTIONS(531),
    [anon_sym_bytes17] = ACTIONS(531),
    [anon_sym_bytes18] = ACTIONS(531),
    [anon_sym_bytes19] = ACTIONS(531),
    [anon_sym_bytes20] = ACTIONS(531),
    [anon_sym_bytes21] = ACTIONS(531),
    [anon_sym_bytes22] = ACTIONS(531),
    [anon_sym_bytes23] = ACTIONS(531),
    [anon_sym_bytes24] = ACTIONS(531),
    [anon_sym_bytes25] = ACTIONS(531),
    [anon_sym_bytes26] = ACTIONS(531),
    [anon_sym_bytes27] = ACTIONS(531),
    [anon_sym_bytes28] = ACTIONS(531),
    [anon_sym_bytes29] = ACTIONS(531),
    [anon_sym_bytes30] = ACTIONS(531),
    [anon_sym_bytes31] = ACTIONS(531),
    [anon_sym_bytes32] = ACTIONS(531),
    [anon_sym_fixed] = ACTIONS(531),
    [aux_sym__fixed_token1] = ACTIONS(531),
    [anon_sym_ufixed] = ACTIONS(531),
    [aux_sym__ufixed_token1] = ACTIONS(531),
    [sym_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_struct_member] = STATE(105),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_struct_body_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(549),
    [anon_sym_RBRACE] = ACTIONS(552),
    [anon_sym_function] = ACTIONS(554),
    [anon_sym_byte] = ACTIONS(557),
    [anon_sym_address] = ACTIONS(560),
    [anon_sym_var] = ACTIONS(557),
    [anon_sym_mapping] = ACTIONS(563),
    [anon_sym_bool] = ACTIONS(557),
    [anon_sym_string] = ACTIONS(557),
    [anon_sym_int] = ACTIONS(557),
    [anon_sym_int8] = ACTIONS(557),
    [anon_sym_int16] = ACTIONS(557),
    [anon_sym_int24] = ACTIONS(557),
    [anon_sym_int32] = ACTIONS(557),
    [anon_sym_int40] = ACTIONS(557),
    [anon_sym_int48] = ACTIONS(557),
    [anon_sym_int56] = ACTIONS(557),
    [anon_sym_int64] = ACTIONS(557),
    [anon_sym_int72] = ACTIONS(557),
    [anon_sym_int80] = ACTIONS(557),
    [anon_sym_int88] = ACTIONS(557),
    [anon_sym_int96] = ACTIONS(557),
    [anon_sym_int104] = ACTIONS(557),
    [anon_sym_int112] = ACTIONS(557),
    [anon_sym_int120] = ACTIONS(557),
    [anon_sym_int128] = ACTIONS(557),
    [anon_sym_int136] = ACTIONS(557),
    [anon_sym_int144] = ACTIONS(557),
    [anon_sym_int152] = ACTIONS(557),
    [anon_sym_int160] = ACTIONS(557),
    [anon_sym_int168] = ACTIONS(557),
    [anon_sym_int176] = ACTIONS(557),
    [anon_sym_int184] = ACTIONS(557),
    [anon_sym_int192] = ACTIONS(557),
    [anon_sym_int200] = ACTIONS(557),
    [anon_sym_int208] = ACTIONS(557),
    [anon_sym_int216] = ACTIONS(557),
    [anon_sym_int224] = ACTIONS(557),
    [anon_sym_int232] = ACTIONS(557),
    [anon_sym_int240] = ACTIONS(557),
    [anon_sym_int248] = ACTIONS(557),
    [anon_sym_int256] = ACTIONS(557),
    [anon_sym_uint] = ACTIONS(557),
    [anon_sym_uint8] = ACTIONS(557),
    [anon_sym_uint16] = ACTIONS(557),
    [anon_sym_uint24] = ACTIONS(557),
    [anon_sym_uint32] = ACTIONS(557),
    [anon_sym_uint40] = ACTIONS(557),
    [anon_sym_uint48] = ACTIONS(557),
    [anon_sym_uint56] = ACTIONS(557),
    [anon_sym_uint64] = ACTIONS(557),
    [anon_sym_uint72] = ACTIONS(557),
    [anon_sym_uint80] = ACTIONS(557),
    [anon_sym_uint88] = ACTIONS(557),
    [anon_sym_uint96] = ACTIONS(557),
    [anon_sym_uint104] = ACTIONS(557),
    [anon_sym_uint112] = ACTIONS(557),
    [anon_sym_uint120] = ACTIONS(557),
    [anon_sym_uint128] = ACTIONS(557),
    [anon_sym_uint136] = ACTIONS(557),
    [anon_sym_uint144] = ACTIONS(557),
    [anon_sym_uint152] = ACTIONS(557),
    [anon_sym_uint160] = ACTIONS(557),
    [anon_sym_uint168] = ACTIONS(557),
    [anon_sym_uint176] = ACTIONS(557),
    [anon_sym_uint184] = ACTIONS(557),
    [anon_sym_uint192] = ACTIONS(557),
    [anon_sym_uint200] = ACTIONS(557),
    [anon_sym_uint208] = ACTIONS(557),
    [anon_sym_uint216] = ACTIONS(557),
    [anon_sym_uint224] = ACTIONS(557),
    [anon_sym_uint232] = ACTIONS(557),
    [anon_sym_uint240] = ACTIONS(557),
    [anon_sym_uint248] = ACTIONS(557),
    [anon_sym_uint256] = ACTIONS(557),
    [anon_sym_bytes] = ACTIONS(557),
    [anon_sym_bytes1] = ACTIONS(557),
    [anon_sym_bytes2] = ACTIONS(557),
    [anon_sym_bytes3] = ACTIONS(557),
    [anon_sym_bytes4] = ACTIONS(557),
    [anon_sym_bytes5] = ACTIONS(557),
    [anon_sym_bytes6] = ACTIONS(557),
    [anon_sym_bytes7] = ACTIONS(557),
    [anon_sym_bytes8] = ACTIONS(557),
    [anon_sym_bytes9] = ACTIONS(557),
    [anon_sym_bytes10] = ACTIONS(557),
    [anon_sym_bytes11] = ACTIONS(557),
    [anon_sym_bytes12] = ACTIONS(557),
    [anon_sym_bytes13] = ACTIONS(557),
    [anon_sym_bytes14] = ACTIONS(557),
    [anon_sym_bytes15] = ACTIONS(557),
    [anon_sym_bytes16] = ACTIONS(557),
    [anon_sym_bytes17] = ACTIONS(557),
    [anon_sym_bytes18] = ACTIONS(557),
    [anon_sym_bytes19] = ACTIONS(557),
    [anon_sym_bytes20] = ACTIONS(557),
    [anon_sym_bytes21] = ACTIONS(557),
    [anon_sym_bytes22] = ACTIONS(557),
    [anon_sym_bytes23] = ACTIONS(557),
    [anon_sym_bytes24] = ACTIONS(557),
    [anon_sym_bytes25] = ACTIONS(557),
    [anon_sym_bytes26] = ACTIONS(557),
    [anon_sym_bytes27] = ACTIONS(557),
    [anon_sym_bytes28] = ACTIONS(557),
    [anon_sym_bytes29] = ACTIONS(557),
    [anon_sym_bytes30] = ACTIONS(557),
    [anon_sym_bytes31] = ACTIONS(557),
    [anon_sym_bytes32] = ACTIONS(557),
    [anon_sym_fixed] = ACTIONS(557),
    [aux_sym__fixed_token1] = ACTIONS(557),
    [anon_sym_ufixed] = ACTIONS(557),
    [aux_sym__ufixed_token1] = ACTIONS(557),
    [sym_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_variable_declaration] = STATE(731),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(568),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_struct_member] = STATE(105),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_struct_body_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(570),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_variable_declaration] = STATE(731),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(566),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_variable_declaration] = STATE(731),
    [sym_type_name] = STATE(487),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_COMMA] = ACTIONS(566),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_struct_member] = STATE(105),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_struct_body_repeat1] = STATE(105),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RBRACE] = ACTIONS(574),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_error_parameter] = STATE(672),
    [sym_type_name] = STATE(507),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_error_parameter] = STATE(672),
    [sym_type_name] = STATE(507),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_any_source_type] = STATE(765),
    [sym_type_name] = STATE(722),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_STAR] = ACTIONS(580),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_type_name] = STATE(474),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_parameter] = STATE(737),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_event_parameter] = STATE(663),
    [sym_type_name] = STATE(482),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(584),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_error_parameter] = STATE(672),
    [sym_type_name] = STATE(507),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(586),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_type_name] = STATE(478),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym__nameless_parameter] = STATE(661),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(588),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_error_parameter] = STATE(672),
    [sym_type_name] = STATE(507),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(590),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_error_parameter] = STATE(543),
    [sym_type_name] = STATE(507),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(592),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_event_parameter] = STATE(663),
    [sym_type_name] = STATE(482),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(594),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_struct_member] = STATE(107),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_struct_body_repeat1] = STATE(107),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_type_name] = STATE(474),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_parameter] = STATE(737),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(596),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_error_parameter] = STATE(561),
    [sym_type_name] = STATE(507),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(598),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_type_name] = STATE(474),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_parameter] = STATE(598),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(600),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_type_name] = STATE(478),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym__nameless_parameter] = STATE(661),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(602),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_struct_member] = STATE(110),
    [sym_type_name] = STATE(698),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [aux_sym_struct_body_repeat1] = STATE(110),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_event_parameter] = STATE(564),
    [sym_type_name] = STATE(482),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(604),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_error_parameter] = STATE(672),
    [sym_type_name] = STATE(507),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_type_name] = STATE(478),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym__nameless_parameter] = STATE(595),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_event_parameter] = STATE(663),
    [sym_type_name] = STATE(482),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_type_name] = STATE(478),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym__nameless_parameter] = STATE(661),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_type_name] = STATE(474),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_parameter] = STATE(737),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [133] = {
    [ts_builtin_sym_end] = ACTIONS(606),
    [sym_identifier] = ACTIONS(608),
    [anon_sym_pragma] = ACTIONS(608),
    [anon_sym_import] = ACTIONS(608),
    [anon_sym_type] = ACTIONS(608),
    [anon_sym_abstract] = ACTIONS(608),
    [anon_sym_contract] = ACTIONS(608),
    [anon_sym_error] = ACTIONS(608),
    [anon_sym_interface] = ACTIONS(608),
    [anon_sym_library] = ACTIONS(608),
    [anon_sym_struct] = ACTIONS(608),
    [anon_sym_enum] = ACTIONS(608),
    [anon_sym_event] = ACTIONS(608),
    [anon_sym_function] = ACTIONS(608),
    [anon_sym_byte] = ACTIONS(608),
    [anon_sym_address] = ACTIONS(608),
    [anon_sym_var] = ACTIONS(608),
    [anon_sym_mapping] = ACTIONS(608),
    [anon_sym_bool] = ACTIONS(608),
    [anon_sym_string] = ACTIONS(608),
    [anon_sym_int] = ACTIONS(608),
    [anon_sym_int8] = ACTIONS(608),
    [anon_sym_int16] = ACTIONS(608),
    [anon_sym_int24] = ACTIONS(608),
    [anon_sym_int32] = ACTIONS(608),
    [anon_sym_int40] = ACTIONS(608),
    [anon_sym_int48] = ACTIONS(608),
    [anon_sym_int56] = ACTIONS(608),
    [anon_sym_int64] = ACTIONS(608),
    [anon_sym_int72] = ACTIONS(608),
    [anon_sym_int80] = ACTIONS(608),
    [anon_sym_int88] = ACTIONS(608),
    [anon_sym_int96] = ACTIONS(608),
    [anon_sym_int104] = ACTIONS(608),
    [anon_sym_int112] = ACTIONS(608),
    [anon_sym_int120] = ACTIONS(608),
    [anon_sym_int128] = ACTIONS(608),
    [anon_sym_int136] = ACTIONS(608),
    [anon_sym_int144] = ACTIONS(608),
    [anon_sym_int152] = ACTIONS(608),
    [anon_sym_int160] = ACTIONS(608),
    [anon_sym_int168] = ACTIONS(608),
    [anon_sym_int176] = ACTIONS(608),
    [anon_sym_int184] = ACTIONS(608),
    [anon_sym_int192] = ACTIONS(608),
    [anon_sym_int200] = ACTIONS(608),
    [anon_sym_int208] = ACTIONS(608),
    [anon_sym_int216] = ACTIONS(608),
    [anon_sym_int224] = ACTIONS(608),
    [anon_sym_int232] = ACTIONS(608),
    [anon_sym_int240] = ACTIONS(608),
    [anon_sym_int248] = ACTIONS(608),
    [anon_sym_int256] = ACTIONS(608),
    [anon_sym_uint] = ACTIONS(608),
    [anon_sym_uint8] = ACTIONS(608),
    [anon_sym_uint16] = ACTIONS(608),
    [anon_sym_uint24] = ACTIONS(608),
    [anon_sym_uint32] = ACTIONS(608),
    [anon_sym_uint40] = ACTIONS(608),
    [anon_sym_uint48] = ACTIONS(608),
    [anon_sym_uint56] = ACTIONS(608),
    [anon_sym_uint64] = ACTIONS(608),
    [anon_sym_uint72] = ACTIONS(608),
    [anon_sym_uint80] = ACTIONS(608),
    [anon_sym_uint88] = ACTIONS(608),
    [anon_sym_uint96] = ACTIONS(608),
    [anon_sym_uint104] = ACTIONS(608),
    [anon_sym_uint112] = ACTIONS(608),
    [anon_sym_uint120] = ACTIONS(608),
    [anon_sym_uint128] = ACTIONS(608),
    [anon_sym_uint136] = ACTIONS(608),
    [anon_sym_uint144] = ACTIONS(608),
    [anon_sym_uint152] = ACTIONS(608),
    [anon_sym_uint160] = ACTIONS(608),
    [anon_sym_uint168] = ACTIONS(608),
    [anon_sym_uint176] = ACTIONS(608),
    [anon_sym_uint184] = ACTIONS(608),
    [anon_sym_uint192] = ACTIONS(608),
    [anon_sym_uint200] = ACTIONS(608),
    [anon_sym_uint208] = ACTIONS(608),
    [anon_sym_uint216] = ACTIONS(608),
    [anon_sym_uint224] = ACTIONS(608),
    [anon_sym_uint232] = ACTIONS(608),
    [anon_sym_uint240] = ACTIONS(608),
    [anon_sym_uint248] = ACTIONS(608),
    [anon_sym_uint256] = ACTIONS(608),
    [anon_sym_bytes] = ACTIONS(608),
    [anon_sym_bytes1] = ACTIONS(608),
    [anon_sym_bytes2] = ACTIONS(608),
    [anon_sym_bytes3] = ACTIONS(608),
    [anon_sym_bytes4] = ACTIONS(608),
    [anon_sym_bytes5] = ACTIONS(608),
    [anon_sym_bytes6] = ACTIONS(608),
    [anon_sym_bytes7] = ACTIONS(608),
    [anon_sym_bytes8] = ACTIONS(608),
    [anon_sym_bytes9] = ACTIONS(608),
    [anon_sym_bytes10] = ACTIONS(608),
    [anon_sym_bytes11] = ACTIONS(608),
    [anon_sym_bytes12] = ACTIONS(608),
    [anon_sym_bytes13] = ACTIONS(608),
    [anon_sym_bytes14] = ACTIONS(608),
    [anon_sym_bytes15] = ACTIONS(608),
    [anon_sym_bytes16] = ACTIONS(608),
    [anon_sym_bytes17] = ACTIONS(608),
    [anon_sym_bytes18] = ACTIONS(608),
    [anon_sym_bytes19] = ACTIONS(608),
    [anon_sym_bytes20] = ACTIONS(608),
    [anon_sym_bytes21] = ACTIONS(608),
    [anon_sym_bytes22] = ACTIONS(608),
    [anon_sym_bytes23] = ACTIONS(608),
    [anon_sym_bytes24] = ACTIONS(608),
    [anon_sym_bytes25] = ACTIONS(608),
    [anon_sym_bytes26] = ACTIONS(608),
    [anon_sym_bytes27] = ACTIONS(608),
    [anon_sym_bytes28] = ACTIONS(608),
    [anon_sym_bytes29] = ACTIONS(608),
    [anon_sym_bytes30] = ACTIONS(608),
    [anon_sym_bytes31] = ACTIONS(608),
    [anon_sym_bytes32] = ACTIONS(608),
    [anon_sym_fixed] = ACTIONS(608),
    [aux_sym__fixed_token1] = ACTIONS(608),
    [anon_sym_ufixed] = ACTIONS(608),
    [aux_sym__ufixed_token1] = ACTIONS(608),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [ts_builtin_sym_end] = ACTIONS(610),
    [sym_identifier] = ACTIONS(612),
    [anon_sym_pragma] = ACTIONS(612),
    [anon_sym_import] = ACTIONS(612),
    [anon_sym_type] = ACTIONS(612),
    [anon_sym_abstract] = ACTIONS(612),
    [anon_sym_contract] = ACTIONS(612),
    [anon_sym_error] = ACTIONS(612),
    [anon_sym_interface] = ACTIONS(612),
    [anon_sym_library] = ACTIONS(612),
    [anon_sym_struct] = ACTIONS(612),
    [anon_sym_enum] = ACTIONS(612),
    [anon_sym_event] = ACTIONS(612),
    [anon_sym_function] = ACTIONS(612),
    [anon_sym_byte] = ACTIONS(612),
    [anon_sym_address] = ACTIONS(612),
    [anon_sym_var] = ACTIONS(612),
    [anon_sym_mapping] = ACTIONS(612),
    [anon_sym_bool] = ACTIONS(612),
    [anon_sym_string] = ACTIONS(612),
    [anon_sym_int] = ACTIONS(612),
    [anon_sym_int8] = ACTIONS(612),
    [anon_sym_int16] = ACTIONS(612),
    [anon_sym_int24] = ACTIONS(612),
    [anon_sym_int32] = ACTIONS(612),
    [anon_sym_int40] = ACTIONS(612),
    [anon_sym_int48] = ACTIONS(612),
    [anon_sym_int56] = ACTIONS(612),
    [anon_sym_int64] = ACTIONS(612),
    [anon_sym_int72] = ACTIONS(612),
    [anon_sym_int80] = ACTIONS(612),
    [anon_sym_int88] = ACTIONS(612),
    [anon_sym_int96] = ACTIONS(612),
    [anon_sym_int104] = ACTIONS(612),
    [anon_sym_int112] = ACTIONS(612),
    [anon_sym_int120] = ACTIONS(612),
    [anon_sym_int128] = ACTIONS(612),
    [anon_sym_int136] = ACTIONS(612),
    [anon_sym_int144] = ACTIONS(612),
    [anon_sym_int152] = ACTIONS(612),
    [anon_sym_int160] = ACTIONS(612),
    [anon_sym_int168] = ACTIONS(612),
    [anon_sym_int176] = ACTIONS(612),
    [anon_sym_int184] = ACTIONS(612),
    [anon_sym_int192] = ACTIONS(612),
    [anon_sym_int200] = ACTIONS(612),
    [anon_sym_int208] = ACTIONS(612),
    [anon_sym_int216] = ACTIONS(612),
    [anon_sym_int224] = ACTIONS(612),
    [anon_sym_int232] = ACTIONS(612),
    [anon_sym_int240] = ACTIONS(612),
    [anon_sym_int248] = ACTIONS(612),
    [anon_sym_int256] = ACTIONS(612),
    [anon_sym_uint] = ACTIONS(612),
    [anon_sym_uint8] = ACTIONS(612),
    [anon_sym_uint16] = ACTIONS(612),
    [anon_sym_uint24] = ACTIONS(612),
    [anon_sym_uint32] = ACTIONS(612),
    [anon_sym_uint40] = ACTIONS(612),
    [anon_sym_uint48] = ACTIONS(612),
    [anon_sym_uint56] = ACTIONS(612),
    [anon_sym_uint64] = ACTIONS(612),
    [anon_sym_uint72] = ACTIONS(612),
    [anon_sym_uint80] = ACTIONS(612),
    [anon_sym_uint88] = ACTIONS(612),
    [anon_sym_uint96] = ACTIONS(612),
    [anon_sym_uint104] = ACTIONS(612),
    [anon_sym_uint112] = ACTIONS(612),
    [anon_sym_uint120] = ACTIONS(612),
    [anon_sym_uint128] = ACTIONS(612),
    [anon_sym_uint136] = ACTIONS(612),
    [anon_sym_uint144] = ACTIONS(612),
    [anon_sym_uint152] = ACTIONS(612),
    [anon_sym_uint160] = ACTIONS(612),
    [anon_sym_uint168] = ACTIONS(612),
    [anon_sym_uint176] = ACTIONS(612),
    [anon_sym_uint184] = ACTIONS(612),
    [anon_sym_uint192] = ACTIONS(612),
    [anon_sym_uint200] = ACTIONS(612),
    [anon_sym_uint208] = ACTIONS(612),
    [anon_sym_uint216] = ACTIONS(612),
    [anon_sym_uint224] = ACTIONS(612),
    [anon_sym_uint232] = ACTIONS(612),
    [anon_sym_uint240] = ACTIONS(612),
    [anon_sym_uint248] = ACTIONS(612),
    [anon_sym_uint256] = ACTIONS(612),
    [anon_sym_bytes] = ACTIONS(612),
    [anon_sym_bytes1] = ACTIONS(612),
    [anon_sym_bytes2] = ACTIONS(612),
    [anon_sym_bytes3] = ACTIONS(612),
    [anon_sym_bytes4] = ACTIONS(612),
    [anon_sym_bytes5] = ACTIONS(612),
    [anon_sym_bytes6] = ACTIONS(612),
    [anon_sym_bytes7] = ACTIONS(612),
    [anon_sym_bytes8] = ACTIONS(612),
    [anon_sym_bytes9] = ACTIONS(612),
    [anon_sym_bytes10] = ACTIONS(612),
    [anon_sym_bytes11] = ACTIONS(612),
    [anon_sym_bytes12] = ACTIONS(612),
    [anon_sym_bytes13] = ACTIONS(612),
    [anon_sym_bytes14] = ACTIONS(612),
    [anon_sym_bytes15] = ACTIONS(612),
    [anon_sym_bytes16] = ACTIONS(612),
    [anon_sym_bytes17] = ACTIONS(612),
    [anon_sym_bytes18] = ACTIONS(612),
    [anon_sym_bytes19] = ACTIONS(612),
    [anon_sym_bytes20] = ACTIONS(612),
    [anon_sym_bytes21] = ACTIONS(612),
    [anon_sym_bytes22] = ACTIONS(612),
    [anon_sym_bytes23] = ACTIONS(612),
    [anon_sym_bytes24] = ACTIONS(612),
    [anon_sym_bytes25] = ACTIONS(612),
    [anon_sym_bytes26] = ACTIONS(612),
    [anon_sym_bytes27] = ACTIONS(612),
    [anon_sym_bytes28] = ACTIONS(612),
    [anon_sym_bytes29] = ACTIONS(612),
    [anon_sym_bytes30] = ACTIONS(612),
    [anon_sym_bytes31] = ACTIONS(612),
    [anon_sym_bytes32] = ACTIONS(612),
    [anon_sym_fixed] = ACTIONS(612),
    [aux_sym__fixed_token1] = ACTIONS(612),
    [anon_sym_ufixed] = ACTIONS(612),
    [aux_sym__ufixed_token1] = ACTIONS(612),
    [sym_comment] = ACTIONS(3),
  },
  [135] = {
    [ts_builtin_sym_end] = ACTIONS(614),
    [sym_identifier] = ACTIONS(616),
    [anon_sym_pragma] = ACTIONS(616),
    [anon_sym_import] = ACTIONS(616),
    [anon_sym_type] = ACTIONS(616),
    [anon_sym_abstract] = ACTIONS(616),
    [anon_sym_contract] = ACTIONS(616),
    [anon_sym_error] = ACTIONS(616),
    [anon_sym_interface] = ACTIONS(616),
    [anon_sym_library] = ACTIONS(616),
    [anon_sym_struct] = ACTIONS(616),
    [anon_sym_enum] = ACTIONS(616),
    [anon_sym_event] = ACTIONS(616),
    [anon_sym_function] = ACTIONS(616),
    [anon_sym_byte] = ACTIONS(616),
    [anon_sym_address] = ACTIONS(616),
    [anon_sym_var] = ACTIONS(616),
    [anon_sym_mapping] = ACTIONS(616),
    [anon_sym_bool] = ACTIONS(616),
    [anon_sym_string] = ACTIONS(616),
    [anon_sym_int] = ACTIONS(616),
    [anon_sym_int8] = ACTIONS(616),
    [anon_sym_int16] = ACTIONS(616),
    [anon_sym_int24] = ACTIONS(616),
    [anon_sym_int32] = ACTIONS(616),
    [anon_sym_int40] = ACTIONS(616),
    [anon_sym_int48] = ACTIONS(616),
    [anon_sym_int56] = ACTIONS(616),
    [anon_sym_int64] = ACTIONS(616),
    [anon_sym_int72] = ACTIONS(616),
    [anon_sym_int80] = ACTIONS(616),
    [anon_sym_int88] = ACTIONS(616),
    [anon_sym_int96] = ACTIONS(616),
    [anon_sym_int104] = ACTIONS(616),
    [anon_sym_int112] = ACTIONS(616),
    [anon_sym_int120] = ACTIONS(616),
    [anon_sym_int128] = ACTIONS(616),
    [anon_sym_int136] = ACTIONS(616),
    [anon_sym_int144] = ACTIONS(616),
    [anon_sym_int152] = ACTIONS(616),
    [anon_sym_int160] = ACTIONS(616),
    [anon_sym_int168] = ACTIONS(616),
    [anon_sym_int176] = ACTIONS(616),
    [anon_sym_int184] = ACTIONS(616),
    [anon_sym_int192] = ACTIONS(616),
    [anon_sym_int200] = ACTIONS(616),
    [anon_sym_int208] = ACTIONS(616),
    [anon_sym_int216] = ACTIONS(616),
    [anon_sym_int224] = ACTIONS(616),
    [anon_sym_int232] = ACTIONS(616),
    [anon_sym_int240] = ACTIONS(616),
    [anon_sym_int248] = ACTIONS(616),
    [anon_sym_int256] = ACTIONS(616),
    [anon_sym_uint] = ACTIONS(616),
    [anon_sym_uint8] = ACTIONS(616),
    [anon_sym_uint16] = ACTIONS(616),
    [anon_sym_uint24] = ACTIONS(616),
    [anon_sym_uint32] = ACTIONS(616),
    [anon_sym_uint40] = ACTIONS(616),
    [anon_sym_uint48] = ACTIONS(616),
    [anon_sym_uint56] = ACTIONS(616),
    [anon_sym_uint64] = ACTIONS(616),
    [anon_sym_uint72] = ACTIONS(616),
    [anon_sym_uint80] = ACTIONS(616),
    [anon_sym_uint88] = ACTIONS(616),
    [anon_sym_uint96] = ACTIONS(616),
    [anon_sym_uint104] = ACTIONS(616),
    [anon_sym_uint112] = ACTIONS(616),
    [anon_sym_uint120] = ACTIONS(616),
    [anon_sym_uint128] = ACTIONS(616),
    [anon_sym_uint136] = ACTIONS(616),
    [anon_sym_uint144] = ACTIONS(616),
    [anon_sym_uint152] = ACTIONS(616),
    [anon_sym_uint160] = ACTIONS(616),
    [anon_sym_uint168] = ACTIONS(616),
    [anon_sym_uint176] = ACTIONS(616),
    [anon_sym_uint184] = ACTIONS(616),
    [anon_sym_uint192] = ACTIONS(616),
    [anon_sym_uint200] = ACTIONS(616),
    [anon_sym_uint208] = ACTIONS(616),
    [anon_sym_uint216] = ACTIONS(616),
    [anon_sym_uint224] = ACTIONS(616),
    [anon_sym_uint232] = ACTIONS(616),
    [anon_sym_uint240] = ACTIONS(616),
    [anon_sym_uint248] = ACTIONS(616),
    [anon_sym_uint256] = ACTIONS(616),
    [anon_sym_bytes] = ACTIONS(616),
    [anon_sym_bytes1] = ACTIONS(616),
    [anon_sym_bytes2] = ACTIONS(616),
    [anon_sym_bytes3] = ACTIONS(616),
    [anon_sym_bytes4] = ACTIONS(616),
    [anon_sym_bytes5] = ACTIONS(616),
    [anon_sym_bytes6] = ACTIONS(616),
    [anon_sym_bytes7] = ACTIONS(616),
    [anon_sym_bytes8] = ACTIONS(616),
    [anon_sym_bytes9] = ACTIONS(616),
    [anon_sym_bytes10] = ACTIONS(616),
    [anon_sym_bytes11] = ACTIONS(616),
    [anon_sym_bytes12] = ACTIONS(616),
    [anon_sym_bytes13] = ACTIONS(616),
    [anon_sym_bytes14] = ACTIONS(616),
    [anon_sym_bytes15] = ACTIONS(616),
    [anon_sym_bytes16] = ACTIONS(616),
    [anon_sym_bytes17] = ACTIONS(616),
    [anon_sym_bytes18] = ACTIONS(616),
    [anon_sym_bytes19] = ACTIONS(616),
    [anon_sym_bytes20] = ACTIONS(616),
    [anon_sym_bytes21] = ACTIONS(616),
    [anon_sym_bytes22] = ACTIONS(616),
    [anon_sym_bytes23] = ACTIONS(616),
    [anon_sym_bytes24] = ACTIONS(616),
    [anon_sym_bytes25] = ACTIONS(616),
    [anon_sym_bytes26] = ACTIONS(616),
    [anon_sym_bytes27] = ACTIONS(616),
    [anon_sym_bytes28] = ACTIONS(616),
    [anon_sym_bytes29] = ACTIONS(616),
    [anon_sym_bytes30] = ACTIONS(616),
    [anon_sym_bytes31] = ACTIONS(616),
    [anon_sym_bytes32] = ACTIONS(616),
    [anon_sym_fixed] = ACTIONS(616),
    [aux_sym__fixed_token1] = ACTIONS(616),
    [anon_sym_ufixed] = ACTIONS(616),
    [aux_sym__ufixed_token1] = ACTIONS(616),
    [sym_comment] = ACTIONS(3),
  },
  [136] = {
    [ts_builtin_sym_end] = ACTIONS(618),
    [sym_identifier] = ACTIONS(620),
    [anon_sym_pragma] = ACTIONS(620),
    [anon_sym_import] = ACTIONS(620),
    [anon_sym_type] = ACTIONS(620),
    [anon_sym_abstract] = ACTIONS(620),
    [anon_sym_contract] = ACTIONS(620),
    [anon_sym_error] = ACTIONS(620),
    [anon_sym_interface] = ACTIONS(620),
    [anon_sym_library] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(620),
    [anon_sym_enum] = ACTIONS(620),
    [anon_sym_event] = ACTIONS(620),
    [anon_sym_function] = ACTIONS(620),
    [anon_sym_byte] = ACTIONS(620),
    [anon_sym_address] = ACTIONS(620),
    [anon_sym_var] = ACTIONS(620),
    [anon_sym_mapping] = ACTIONS(620),
    [anon_sym_bool] = ACTIONS(620),
    [anon_sym_string] = ACTIONS(620),
    [anon_sym_int] = ACTIONS(620),
    [anon_sym_int8] = ACTIONS(620),
    [anon_sym_int16] = ACTIONS(620),
    [anon_sym_int24] = ACTIONS(620),
    [anon_sym_int32] = ACTIONS(620),
    [anon_sym_int40] = ACTIONS(620),
    [anon_sym_int48] = ACTIONS(620),
    [anon_sym_int56] = ACTIONS(620),
    [anon_sym_int64] = ACTIONS(620),
    [anon_sym_int72] = ACTIONS(620),
    [anon_sym_int80] = ACTIONS(620),
    [anon_sym_int88] = ACTIONS(620),
    [anon_sym_int96] = ACTIONS(620),
    [anon_sym_int104] = ACTIONS(620),
    [anon_sym_int112] = ACTIONS(620),
    [anon_sym_int120] = ACTIONS(620),
    [anon_sym_int128] = ACTIONS(620),
    [anon_sym_int136] = ACTIONS(620),
    [anon_sym_int144] = ACTIONS(620),
    [anon_sym_int152] = ACTIONS(620),
    [anon_sym_int160] = ACTIONS(620),
    [anon_sym_int168] = ACTIONS(620),
    [anon_sym_int176] = ACTIONS(620),
    [anon_sym_int184] = ACTIONS(620),
    [anon_sym_int192] = ACTIONS(620),
    [anon_sym_int200] = ACTIONS(620),
    [anon_sym_int208] = ACTIONS(620),
    [anon_sym_int216] = ACTIONS(620),
    [anon_sym_int224] = ACTIONS(620),
    [anon_sym_int232] = ACTIONS(620),
    [anon_sym_int240] = ACTIONS(620),
    [anon_sym_int248] = ACTIONS(620),
    [anon_sym_int256] = ACTIONS(620),
    [anon_sym_uint] = ACTIONS(620),
    [anon_sym_uint8] = ACTIONS(620),
    [anon_sym_uint16] = ACTIONS(620),
    [anon_sym_uint24] = ACTIONS(620),
    [anon_sym_uint32] = ACTIONS(620),
    [anon_sym_uint40] = ACTIONS(620),
    [anon_sym_uint48] = ACTIONS(620),
    [anon_sym_uint56] = ACTIONS(620),
    [anon_sym_uint64] = ACTIONS(620),
    [anon_sym_uint72] = ACTIONS(620),
    [anon_sym_uint80] = ACTIONS(620),
    [anon_sym_uint88] = ACTIONS(620),
    [anon_sym_uint96] = ACTIONS(620),
    [anon_sym_uint104] = ACTIONS(620),
    [anon_sym_uint112] = ACTIONS(620),
    [anon_sym_uint120] = ACTIONS(620),
    [anon_sym_uint128] = ACTIONS(620),
    [anon_sym_uint136] = ACTIONS(620),
    [anon_sym_uint144] = ACTIONS(620),
    [anon_sym_uint152] = ACTIONS(620),
    [anon_sym_uint160] = ACTIONS(620),
    [anon_sym_uint168] = ACTIONS(620),
    [anon_sym_uint176] = ACTIONS(620),
    [anon_sym_uint184] = ACTIONS(620),
    [anon_sym_uint192] = ACTIONS(620),
    [anon_sym_uint200] = ACTIONS(620),
    [anon_sym_uint208] = ACTIONS(620),
    [anon_sym_uint216] = ACTIONS(620),
    [anon_sym_uint224] = ACTIONS(620),
    [anon_sym_uint232] = ACTIONS(620),
    [anon_sym_uint240] = ACTIONS(620),
    [anon_sym_uint248] = ACTIONS(620),
    [anon_sym_uint256] = ACTIONS(620),
    [anon_sym_bytes] = ACTIONS(620),
    [anon_sym_bytes1] = ACTIONS(620),
    [anon_sym_bytes2] = ACTIONS(620),
    [anon_sym_bytes3] = ACTIONS(620),
    [anon_sym_bytes4] = ACTIONS(620),
    [anon_sym_bytes5] = ACTIONS(620),
    [anon_sym_bytes6] = ACTIONS(620),
    [anon_sym_bytes7] = ACTIONS(620),
    [anon_sym_bytes8] = ACTIONS(620),
    [anon_sym_bytes9] = ACTIONS(620),
    [anon_sym_bytes10] = ACTIONS(620),
    [anon_sym_bytes11] = ACTIONS(620),
    [anon_sym_bytes12] = ACTIONS(620),
    [anon_sym_bytes13] = ACTIONS(620),
    [anon_sym_bytes14] = ACTIONS(620),
    [anon_sym_bytes15] = ACTIONS(620),
    [anon_sym_bytes16] = ACTIONS(620),
    [anon_sym_bytes17] = ACTIONS(620),
    [anon_sym_bytes18] = ACTIONS(620),
    [anon_sym_bytes19] = ACTIONS(620),
    [anon_sym_bytes20] = ACTIONS(620),
    [anon_sym_bytes21] = ACTIONS(620),
    [anon_sym_bytes22] = ACTIONS(620),
    [anon_sym_bytes23] = ACTIONS(620),
    [anon_sym_bytes24] = ACTIONS(620),
    [anon_sym_bytes25] = ACTIONS(620),
    [anon_sym_bytes26] = ACTIONS(620),
    [anon_sym_bytes27] = ACTIONS(620),
    [anon_sym_bytes28] = ACTIONS(620),
    [anon_sym_bytes29] = ACTIONS(620),
    [anon_sym_bytes30] = ACTIONS(620),
    [anon_sym_bytes31] = ACTIONS(620),
    [anon_sym_bytes32] = ACTIONS(620),
    [anon_sym_fixed] = ACTIONS(620),
    [aux_sym__fixed_token1] = ACTIONS(620),
    [anon_sym_ufixed] = ACTIONS(620),
    [aux_sym__ufixed_token1] = ACTIONS(620),
    [sym_comment] = ACTIONS(3),
  },
  [137] = {
    [ts_builtin_sym_end] = ACTIONS(622),
    [sym_identifier] = ACTIONS(624),
    [anon_sym_pragma] = ACTIONS(624),
    [anon_sym_import] = ACTIONS(624),
    [anon_sym_type] = ACTIONS(624),
    [anon_sym_abstract] = ACTIONS(624),
    [anon_sym_contract] = ACTIONS(624),
    [anon_sym_error] = ACTIONS(624),
    [anon_sym_interface] = ACTIONS(624),
    [anon_sym_library] = ACTIONS(624),
    [anon_sym_struct] = ACTIONS(624),
    [anon_sym_enum] = ACTIONS(624),
    [anon_sym_event] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(624),
    [anon_sym_byte] = ACTIONS(624),
    [anon_sym_address] = ACTIONS(624),
    [anon_sym_var] = ACTIONS(624),
    [anon_sym_mapping] = ACTIONS(624),
    [anon_sym_bool] = ACTIONS(624),
    [anon_sym_string] = ACTIONS(624),
    [anon_sym_int] = ACTIONS(624),
    [anon_sym_int8] = ACTIONS(624),
    [anon_sym_int16] = ACTIONS(624),
    [anon_sym_int24] = ACTIONS(624),
    [anon_sym_int32] = ACTIONS(624),
    [anon_sym_int40] = ACTIONS(624),
    [anon_sym_int48] = ACTIONS(624),
    [anon_sym_int56] = ACTIONS(624),
    [anon_sym_int64] = ACTIONS(624),
    [anon_sym_int72] = ACTIONS(624),
    [anon_sym_int80] = ACTIONS(624),
    [anon_sym_int88] = ACTIONS(624),
    [anon_sym_int96] = ACTIONS(624),
    [anon_sym_int104] = ACTIONS(624),
    [anon_sym_int112] = ACTIONS(624),
    [anon_sym_int120] = ACTIONS(624),
    [anon_sym_int128] = ACTIONS(624),
    [anon_sym_int136] = ACTIONS(624),
    [anon_sym_int144] = ACTIONS(624),
    [anon_sym_int152] = ACTIONS(624),
    [anon_sym_int160] = ACTIONS(624),
    [anon_sym_int168] = ACTIONS(624),
    [anon_sym_int176] = ACTIONS(624),
    [anon_sym_int184] = ACTIONS(624),
    [anon_sym_int192] = ACTIONS(624),
    [anon_sym_int200] = ACTIONS(624),
    [anon_sym_int208] = ACTIONS(624),
    [anon_sym_int216] = ACTIONS(624),
    [anon_sym_int224] = ACTIONS(624),
    [anon_sym_int232] = ACTIONS(624),
    [anon_sym_int240] = ACTIONS(624),
    [anon_sym_int248] = ACTIONS(624),
    [anon_sym_int256] = ACTIONS(624),
    [anon_sym_uint] = ACTIONS(624),
    [anon_sym_uint8] = ACTIONS(624),
    [anon_sym_uint16] = ACTIONS(624),
    [anon_sym_uint24] = ACTIONS(624),
    [anon_sym_uint32] = ACTIONS(624),
    [anon_sym_uint40] = ACTIONS(624),
    [anon_sym_uint48] = ACTIONS(624),
    [anon_sym_uint56] = ACTIONS(624),
    [anon_sym_uint64] = ACTIONS(624),
    [anon_sym_uint72] = ACTIONS(624),
    [anon_sym_uint80] = ACTIONS(624),
    [anon_sym_uint88] = ACTIONS(624),
    [anon_sym_uint96] = ACTIONS(624),
    [anon_sym_uint104] = ACTIONS(624),
    [anon_sym_uint112] = ACTIONS(624),
    [anon_sym_uint120] = ACTIONS(624),
    [anon_sym_uint128] = ACTIONS(624),
    [anon_sym_uint136] = ACTIONS(624),
    [anon_sym_uint144] = ACTIONS(624),
    [anon_sym_uint152] = ACTIONS(624),
    [anon_sym_uint160] = ACTIONS(624),
    [anon_sym_uint168] = ACTIONS(624),
    [anon_sym_uint176] = ACTIONS(624),
    [anon_sym_uint184] = ACTIONS(624),
    [anon_sym_uint192] = ACTIONS(624),
    [anon_sym_uint200] = ACTIONS(624),
    [anon_sym_uint208] = ACTIONS(624),
    [anon_sym_uint216] = ACTIONS(624),
    [anon_sym_uint224] = ACTIONS(624),
    [anon_sym_uint232] = ACTIONS(624),
    [anon_sym_uint240] = ACTIONS(624),
    [anon_sym_uint248] = ACTIONS(624),
    [anon_sym_uint256] = ACTIONS(624),
    [anon_sym_bytes] = ACTIONS(624),
    [anon_sym_bytes1] = ACTIONS(624),
    [anon_sym_bytes2] = ACTIONS(624),
    [anon_sym_bytes3] = ACTIONS(624),
    [anon_sym_bytes4] = ACTIONS(624),
    [anon_sym_bytes5] = ACTIONS(624),
    [anon_sym_bytes6] = ACTIONS(624),
    [anon_sym_bytes7] = ACTIONS(624),
    [anon_sym_bytes8] = ACTIONS(624),
    [anon_sym_bytes9] = ACTIONS(624),
    [anon_sym_bytes10] = ACTIONS(624),
    [anon_sym_bytes11] = ACTIONS(624),
    [anon_sym_bytes12] = ACTIONS(624),
    [anon_sym_bytes13] = ACTIONS(624),
    [anon_sym_bytes14] = ACTIONS(624),
    [anon_sym_bytes15] = ACTIONS(624),
    [anon_sym_bytes16] = ACTIONS(624),
    [anon_sym_bytes17] = ACTIONS(624),
    [anon_sym_bytes18] = ACTIONS(624),
    [anon_sym_bytes19] = ACTIONS(624),
    [anon_sym_bytes20] = ACTIONS(624),
    [anon_sym_bytes21] = ACTIONS(624),
    [anon_sym_bytes22] = ACTIONS(624),
    [anon_sym_bytes23] = ACTIONS(624),
    [anon_sym_bytes24] = ACTIONS(624),
    [anon_sym_bytes25] = ACTIONS(624),
    [anon_sym_bytes26] = ACTIONS(624),
    [anon_sym_bytes27] = ACTIONS(624),
    [anon_sym_bytes28] = ACTIONS(624),
    [anon_sym_bytes29] = ACTIONS(624),
    [anon_sym_bytes30] = ACTIONS(624),
    [anon_sym_bytes31] = ACTIONS(624),
    [anon_sym_bytes32] = ACTIONS(624),
    [anon_sym_fixed] = ACTIONS(624),
    [aux_sym__fixed_token1] = ACTIONS(624),
    [anon_sym_ufixed] = ACTIONS(624),
    [aux_sym__ufixed_token1] = ACTIONS(624),
    [sym_comment] = ACTIONS(3),
  },
  [138] = {
    [ts_builtin_sym_end] = ACTIONS(626),
    [sym_identifier] = ACTIONS(628),
    [anon_sym_pragma] = ACTIONS(628),
    [anon_sym_import] = ACTIONS(628),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_abstract] = ACTIONS(628),
    [anon_sym_contract] = ACTIONS(628),
    [anon_sym_error] = ACTIONS(628),
    [anon_sym_interface] = ACTIONS(628),
    [anon_sym_library] = ACTIONS(628),
    [anon_sym_struct] = ACTIONS(628),
    [anon_sym_enum] = ACTIONS(628),
    [anon_sym_event] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(628),
    [anon_sym_byte] = ACTIONS(628),
    [anon_sym_address] = ACTIONS(628),
    [anon_sym_var] = ACTIONS(628),
    [anon_sym_mapping] = ACTIONS(628),
    [anon_sym_bool] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_int] = ACTIONS(628),
    [anon_sym_int8] = ACTIONS(628),
    [anon_sym_int16] = ACTIONS(628),
    [anon_sym_int24] = ACTIONS(628),
    [anon_sym_int32] = ACTIONS(628),
    [anon_sym_int40] = ACTIONS(628),
    [anon_sym_int48] = ACTIONS(628),
    [anon_sym_int56] = ACTIONS(628),
    [anon_sym_int64] = ACTIONS(628),
    [anon_sym_int72] = ACTIONS(628),
    [anon_sym_int80] = ACTIONS(628),
    [anon_sym_int88] = ACTIONS(628),
    [anon_sym_int96] = ACTIONS(628),
    [anon_sym_int104] = ACTIONS(628),
    [anon_sym_int112] = ACTIONS(628),
    [anon_sym_int120] = ACTIONS(628),
    [anon_sym_int128] = ACTIONS(628),
    [anon_sym_int136] = ACTIONS(628),
    [anon_sym_int144] = ACTIONS(628),
    [anon_sym_int152] = ACTIONS(628),
    [anon_sym_int160] = ACTIONS(628),
    [anon_sym_int168] = ACTIONS(628),
    [anon_sym_int176] = ACTIONS(628),
    [anon_sym_int184] = ACTIONS(628),
    [anon_sym_int192] = ACTIONS(628),
    [anon_sym_int200] = ACTIONS(628),
    [anon_sym_int208] = ACTIONS(628),
    [anon_sym_int216] = ACTIONS(628),
    [anon_sym_int224] = ACTIONS(628),
    [anon_sym_int232] = ACTIONS(628),
    [anon_sym_int240] = ACTIONS(628),
    [anon_sym_int248] = ACTIONS(628),
    [anon_sym_int256] = ACTIONS(628),
    [anon_sym_uint] = ACTIONS(628),
    [anon_sym_uint8] = ACTIONS(628),
    [anon_sym_uint16] = ACTIONS(628),
    [anon_sym_uint24] = ACTIONS(628),
    [anon_sym_uint32] = ACTIONS(628),
    [anon_sym_uint40] = ACTIONS(628),
    [anon_sym_uint48] = ACTIONS(628),
    [anon_sym_uint56] = ACTIONS(628),
    [anon_sym_uint64] = ACTIONS(628),
    [anon_sym_uint72] = ACTIONS(628),
    [anon_sym_uint80] = ACTIONS(628),
    [anon_sym_uint88] = ACTIONS(628),
    [anon_sym_uint96] = ACTIONS(628),
    [anon_sym_uint104] = ACTIONS(628),
    [anon_sym_uint112] = ACTIONS(628),
    [anon_sym_uint120] = ACTIONS(628),
    [anon_sym_uint128] = ACTIONS(628),
    [anon_sym_uint136] = ACTIONS(628),
    [anon_sym_uint144] = ACTIONS(628),
    [anon_sym_uint152] = ACTIONS(628),
    [anon_sym_uint160] = ACTIONS(628),
    [anon_sym_uint168] = ACTIONS(628),
    [anon_sym_uint176] = ACTIONS(628),
    [anon_sym_uint184] = ACTIONS(628),
    [anon_sym_uint192] = ACTIONS(628),
    [anon_sym_uint200] = ACTIONS(628),
    [anon_sym_uint208] = ACTIONS(628),
    [anon_sym_uint216] = ACTIONS(628),
    [anon_sym_uint224] = ACTIONS(628),
    [anon_sym_uint232] = ACTIONS(628),
    [anon_sym_uint240] = ACTIONS(628),
    [anon_sym_uint248] = ACTIONS(628),
    [anon_sym_uint256] = ACTIONS(628),
    [anon_sym_bytes] = ACTIONS(628),
    [anon_sym_bytes1] = ACTIONS(628),
    [anon_sym_bytes2] = ACTIONS(628),
    [anon_sym_bytes3] = ACTIONS(628),
    [anon_sym_bytes4] = ACTIONS(628),
    [anon_sym_bytes5] = ACTIONS(628),
    [anon_sym_bytes6] = ACTIONS(628),
    [anon_sym_bytes7] = ACTIONS(628),
    [anon_sym_bytes8] = ACTIONS(628),
    [anon_sym_bytes9] = ACTIONS(628),
    [anon_sym_bytes10] = ACTIONS(628),
    [anon_sym_bytes11] = ACTIONS(628),
    [anon_sym_bytes12] = ACTIONS(628),
    [anon_sym_bytes13] = ACTIONS(628),
    [anon_sym_bytes14] = ACTIONS(628),
    [anon_sym_bytes15] = ACTIONS(628),
    [anon_sym_bytes16] = ACTIONS(628),
    [anon_sym_bytes17] = ACTIONS(628),
    [anon_sym_bytes18] = ACTIONS(628),
    [anon_sym_bytes19] = ACTIONS(628),
    [anon_sym_bytes20] = ACTIONS(628),
    [anon_sym_bytes21] = ACTIONS(628),
    [anon_sym_bytes22] = ACTIONS(628),
    [anon_sym_bytes23] = ACTIONS(628),
    [anon_sym_bytes24] = ACTIONS(628),
    [anon_sym_bytes25] = ACTIONS(628),
    [anon_sym_bytes26] = ACTIONS(628),
    [anon_sym_bytes27] = ACTIONS(628),
    [anon_sym_bytes28] = ACTIONS(628),
    [anon_sym_bytes29] = ACTIONS(628),
    [anon_sym_bytes30] = ACTIONS(628),
    [anon_sym_bytes31] = ACTIONS(628),
    [anon_sym_bytes32] = ACTIONS(628),
    [anon_sym_fixed] = ACTIONS(628),
    [aux_sym__fixed_token1] = ACTIONS(628),
    [anon_sym_ufixed] = ACTIONS(628),
    [aux_sym__ufixed_token1] = ACTIONS(628),
    [sym_comment] = ACTIONS(3),
  },
  [139] = {
    [ts_builtin_sym_end] = ACTIONS(630),
    [sym_identifier] = ACTIONS(632),
    [anon_sym_pragma] = ACTIONS(632),
    [anon_sym_import] = ACTIONS(632),
    [anon_sym_type] = ACTIONS(632),
    [anon_sym_abstract] = ACTIONS(632),
    [anon_sym_contract] = ACTIONS(632),
    [anon_sym_error] = ACTIONS(632),
    [anon_sym_interface] = ACTIONS(632),
    [anon_sym_library] = ACTIONS(632),
    [anon_sym_struct] = ACTIONS(632),
    [anon_sym_enum] = ACTIONS(632),
    [anon_sym_event] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(632),
    [anon_sym_byte] = ACTIONS(632),
    [anon_sym_address] = ACTIONS(632),
    [anon_sym_var] = ACTIONS(632),
    [anon_sym_mapping] = ACTIONS(632),
    [anon_sym_bool] = ACTIONS(632),
    [anon_sym_string] = ACTIONS(632),
    [anon_sym_int] = ACTIONS(632),
    [anon_sym_int8] = ACTIONS(632),
    [anon_sym_int16] = ACTIONS(632),
    [anon_sym_int24] = ACTIONS(632),
    [anon_sym_int32] = ACTIONS(632),
    [anon_sym_int40] = ACTIONS(632),
    [anon_sym_int48] = ACTIONS(632),
    [anon_sym_int56] = ACTIONS(632),
    [anon_sym_int64] = ACTIONS(632),
    [anon_sym_int72] = ACTIONS(632),
    [anon_sym_int80] = ACTIONS(632),
    [anon_sym_int88] = ACTIONS(632),
    [anon_sym_int96] = ACTIONS(632),
    [anon_sym_int104] = ACTIONS(632),
    [anon_sym_int112] = ACTIONS(632),
    [anon_sym_int120] = ACTIONS(632),
    [anon_sym_int128] = ACTIONS(632),
    [anon_sym_int136] = ACTIONS(632),
    [anon_sym_int144] = ACTIONS(632),
    [anon_sym_int152] = ACTIONS(632),
    [anon_sym_int160] = ACTIONS(632),
    [anon_sym_int168] = ACTIONS(632),
    [anon_sym_int176] = ACTIONS(632),
    [anon_sym_int184] = ACTIONS(632),
    [anon_sym_int192] = ACTIONS(632),
    [anon_sym_int200] = ACTIONS(632),
    [anon_sym_int208] = ACTIONS(632),
    [anon_sym_int216] = ACTIONS(632),
    [anon_sym_int224] = ACTIONS(632),
    [anon_sym_int232] = ACTIONS(632),
    [anon_sym_int240] = ACTIONS(632),
    [anon_sym_int248] = ACTIONS(632),
    [anon_sym_int256] = ACTIONS(632),
    [anon_sym_uint] = ACTIONS(632),
    [anon_sym_uint8] = ACTIONS(632),
    [anon_sym_uint16] = ACTIONS(632),
    [anon_sym_uint24] = ACTIONS(632),
    [anon_sym_uint32] = ACTIONS(632),
    [anon_sym_uint40] = ACTIONS(632),
    [anon_sym_uint48] = ACTIONS(632),
    [anon_sym_uint56] = ACTIONS(632),
    [anon_sym_uint64] = ACTIONS(632),
    [anon_sym_uint72] = ACTIONS(632),
    [anon_sym_uint80] = ACTIONS(632),
    [anon_sym_uint88] = ACTIONS(632),
    [anon_sym_uint96] = ACTIONS(632),
    [anon_sym_uint104] = ACTIONS(632),
    [anon_sym_uint112] = ACTIONS(632),
    [anon_sym_uint120] = ACTIONS(632),
    [anon_sym_uint128] = ACTIONS(632),
    [anon_sym_uint136] = ACTIONS(632),
    [anon_sym_uint144] = ACTIONS(632),
    [anon_sym_uint152] = ACTIONS(632),
    [anon_sym_uint160] = ACTIONS(632),
    [anon_sym_uint168] = ACTIONS(632),
    [anon_sym_uint176] = ACTIONS(632),
    [anon_sym_uint184] = ACTIONS(632),
    [anon_sym_uint192] = ACTIONS(632),
    [anon_sym_uint200] = ACTIONS(632),
    [anon_sym_uint208] = ACTIONS(632),
    [anon_sym_uint216] = ACTIONS(632),
    [anon_sym_uint224] = ACTIONS(632),
    [anon_sym_uint232] = ACTIONS(632),
    [anon_sym_uint240] = ACTIONS(632),
    [anon_sym_uint248] = ACTIONS(632),
    [anon_sym_uint256] = ACTIONS(632),
    [anon_sym_bytes] = ACTIONS(632),
    [anon_sym_bytes1] = ACTIONS(632),
    [anon_sym_bytes2] = ACTIONS(632),
    [anon_sym_bytes3] = ACTIONS(632),
    [anon_sym_bytes4] = ACTIONS(632),
    [anon_sym_bytes5] = ACTIONS(632),
    [anon_sym_bytes6] = ACTIONS(632),
    [anon_sym_bytes7] = ACTIONS(632),
    [anon_sym_bytes8] = ACTIONS(632),
    [anon_sym_bytes9] = ACTIONS(632),
    [anon_sym_bytes10] = ACTIONS(632),
    [anon_sym_bytes11] = ACTIONS(632),
    [anon_sym_bytes12] = ACTIONS(632),
    [anon_sym_bytes13] = ACTIONS(632),
    [anon_sym_bytes14] = ACTIONS(632),
    [anon_sym_bytes15] = ACTIONS(632),
    [anon_sym_bytes16] = ACTIONS(632),
    [anon_sym_bytes17] = ACTIONS(632),
    [anon_sym_bytes18] = ACTIONS(632),
    [anon_sym_bytes19] = ACTIONS(632),
    [anon_sym_bytes20] = ACTIONS(632),
    [anon_sym_bytes21] = ACTIONS(632),
    [anon_sym_bytes22] = ACTIONS(632),
    [anon_sym_bytes23] = ACTIONS(632),
    [anon_sym_bytes24] = ACTIONS(632),
    [anon_sym_bytes25] = ACTIONS(632),
    [anon_sym_bytes26] = ACTIONS(632),
    [anon_sym_bytes27] = ACTIONS(632),
    [anon_sym_bytes28] = ACTIONS(632),
    [anon_sym_bytes29] = ACTIONS(632),
    [anon_sym_bytes30] = ACTIONS(632),
    [anon_sym_bytes31] = ACTIONS(632),
    [anon_sym_bytes32] = ACTIONS(632),
    [anon_sym_fixed] = ACTIONS(632),
    [aux_sym__fixed_token1] = ACTIONS(632),
    [anon_sym_ufixed] = ACTIONS(632),
    [aux_sym__ufixed_token1] = ACTIONS(632),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [ts_builtin_sym_end] = ACTIONS(634),
    [sym_identifier] = ACTIONS(636),
    [anon_sym_pragma] = ACTIONS(636),
    [anon_sym_import] = ACTIONS(636),
    [anon_sym_type] = ACTIONS(636),
    [anon_sym_abstract] = ACTIONS(636),
    [anon_sym_contract] = ACTIONS(636),
    [anon_sym_error] = ACTIONS(636),
    [anon_sym_interface] = ACTIONS(636),
    [anon_sym_library] = ACTIONS(636),
    [anon_sym_struct] = ACTIONS(636),
    [anon_sym_enum] = ACTIONS(636),
    [anon_sym_event] = ACTIONS(636),
    [anon_sym_function] = ACTIONS(636),
    [anon_sym_byte] = ACTIONS(636),
    [anon_sym_address] = ACTIONS(636),
    [anon_sym_var] = ACTIONS(636),
    [anon_sym_mapping] = ACTIONS(636),
    [anon_sym_bool] = ACTIONS(636),
    [anon_sym_string] = ACTIONS(636),
    [anon_sym_int] = ACTIONS(636),
    [anon_sym_int8] = ACTIONS(636),
    [anon_sym_int16] = ACTIONS(636),
    [anon_sym_int24] = ACTIONS(636),
    [anon_sym_int32] = ACTIONS(636),
    [anon_sym_int40] = ACTIONS(636),
    [anon_sym_int48] = ACTIONS(636),
    [anon_sym_int56] = ACTIONS(636),
    [anon_sym_int64] = ACTIONS(636),
    [anon_sym_int72] = ACTIONS(636),
    [anon_sym_int80] = ACTIONS(636),
    [anon_sym_int88] = ACTIONS(636),
    [anon_sym_int96] = ACTIONS(636),
    [anon_sym_int104] = ACTIONS(636),
    [anon_sym_int112] = ACTIONS(636),
    [anon_sym_int120] = ACTIONS(636),
    [anon_sym_int128] = ACTIONS(636),
    [anon_sym_int136] = ACTIONS(636),
    [anon_sym_int144] = ACTIONS(636),
    [anon_sym_int152] = ACTIONS(636),
    [anon_sym_int160] = ACTIONS(636),
    [anon_sym_int168] = ACTIONS(636),
    [anon_sym_int176] = ACTIONS(636),
    [anon_sym_int184] = ACTIONS(636),
    [anon_sym_int192] = ACTIONS(636),
    [anon_sym_int200] = ACTIONS(636),
    [anon_sym_int208] = ACTIONS(636),
    [anon_sym_int216] = ACTIONS(636),
    [anon_sym_int224] = ACTIONS(636),
    [anon_sym_int232] = ACTIONS(636),
    [anon_sym_int240] = ACTIONS(636),
    [anon_sym_int248] = ACTIONS(636),
    [anon_sym_int256] = ACTIONS(636),
    [anon_sym_uint] = ACTIONS(636),
    [anon_sym_uint8] = ACTIONS(636),
    [anon_sym_uint16] = ACTIONS(636),
    [anon_sym_uint24] = ACTIONS(636),
    [anon_sym_uint32] = ACTIONS(636),
    [anon_sym_uint40] = ACTIONS(636),
    [anon_sym_uint48] = ACTIONS(636),
    [anon_sym_uint56] = ACTIONS(636),
    [anon_sym_uint64] = ACTIONS(636),
    [anon_sym_uint72] = ACTIONS(636),
    [anon_sym_uint80] = ACTIONS(636),
    [anon_sym_uint88] = ACTIONS(636),
    [anon_sym_uint96] = ACTIONS(636),
    [anon_sym_uint104] = ACTIONS(636),
    [anon_sym_uint112] = ACTIONS(636),
    [anon_sym_uint120] = ACTIONS(636),
    [anon_sym_uint128] = ACTIONS(636),
    [anon_sym_uint136] = ACTIONS(636),
    [anon_sym_uint144] = ACTIONS(636),
    [anon_sym_uint152] = ACTIONS(636),
    [anon_sym_uint160] = ACTIONS(636),
    [anon_sym_uint168] = ACTIONS(636),
    [anon_sym_uint176] = ACTIONS(636),
    [anon_sym_uint184] = ACTIONS(636),
    [anon_sym_uint192] = ACTIONS(636),
    [anon_sym_uint200] = ACTIONS(636),
    [anon_sym_uint208] = ACTIONS(636),
    [anon_sym_uint216] = ACTIONS(636),
    [anon_sym_uint224] = ACTIONS(636),
    [anon_sym_uint232] = ACTIONS(636),
    [anon_sym_uint240] = ACTIONS(636),
    [anon_sym_uint248] = ACTIONS(636),
    [anon_sym_uint256] = ACTIONS(636),
    [anon_sym_bytes] = ACTIONS(636),
    [anon_sym_bytes1] = ACTIONS(636),
    [anon_sym_bytes2] = ACTIONS(636),
    [anon_sym_bytes3] = ACTIONS(636),
    [anon_sym_bytes4] = ACTIONS(636),
    [anon_sym_bytes5] = ACTIONS(636),
    [anon_sym_bytes6] = ACTIONS(636),
    [anon_sym_bytes7] = ACTIONS(636),
    [anon_sym_bytes8] = ACTIONS(636),
    [anon_sym_bytes9] = ACTIONS(636),
    [anon_sym_bytes10] = ACTIONS(636),
    [anon_sym_bytes11] = ACTIONS(636),
    [anon_sym_bytes12] = ACTIONS(636),
    [anon_sym_bytes13] = ACTIONS(636),
    [anon_sym_bytes14] = ACTIONS(636),
    [anon_sym_bytes15] = ACTIONS(636),
    [anon_sym_bytes16] = ACTIONS(636),
    [anon_sym_bytes17] = ACTIONS(636),
    [anon_sym_bytes18] = ACTIONS(636),
    [anon_sym_bytes19] = ACTIONS(636),
    [anon_sym_bytes20] = ACTIONS(636),
    [anon_sym_bytes21] = ACTIONS(636),
    [anon_sym_bytes22] = ACTIONS(636),
    [anon_sym_bytes23] = ACTIONS(636),
    [anon_sym_bytes24] = ACTIONS(636),
    [anon_sym_bytes25] = ACTIONS(636),
    [anon_sym_bytes26] = ACTIONS(636),
    [anon_sym_bytes27] = ACTIONS(636),
    [anon_sym_bytes28] = ACTIONS(636),
    [anon_sym_bytes29] = ACTIONS(636),
    [anon_sym_bytes30] = ACTIONS(636),
    [anon_sym_bytes31] = ACTIONS(636),
    [anon_sym_bytes32] = ACTIONS(636),
    [anon_sym_fixed] = ACTIONS(636),
    [aux_sym__fixed_token1] = ACTIONS(636),
    [anon_sym_ufixed] = ACTIONS(636),
    [aux_sym__ufixed_token1] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [ts_builtin_sym_end] = ACTIONS(638),
    [sym_identifier] = ACTIONS(640),
    [anon_sym_pragma] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(640),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_abstract] = ACTIONS(640),
    [anon_sym_contract] = ACTIONS(640),
    [anon_sym_error] = ACTIONS(640),
    [anon_sym_interface] = ACTIONS(640),
    [anon_sym_library] = ACTIONS(640),
    [anon_sym_struct] = ACTIONS(640),
    [anon_sym_enum] = ACTIONS(640),
    [anon_sym_event] = ACTIONS(640),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_byte] = ACTIONS(640),
    [anon_sym_address] = ACTIONS(640),
    [anon_sym_var] = ACTIONS(640),
    [anon_sym_mapping] = ACTIONS(640),
    [anon_sym_bool] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_int] = ACTIONS(640),
    [anon_sym_int8] = ACTIONS(640),
    [anon_sym_int16] = ACTIONS(640),
    [anon_sym_int24] = ACTIONS(640),
    [anon_sym_int32] = ACTIONS(640),
    [anon_sym_int40] = ACTIONS(640),
    [anon_sym_int48] = ACTIONS(640),
    [anon_sym_int56] = ACTIONS(640),
    [anon_sym_int64] = ACTIONS(640),
    [anon_sym_int72] = ACTIONS(640),
    [anon_sym_int80] = ACTIONS(640),
    [anon_sym_int88] = ACTIONS(640),
    [anon_sym_int96] = ACTIONS(640),
    [anon_sym_int104] = ACTIONS(640),
    [anon_sym_int112] = ACTIONS(640),
    [anon_sym_int120] = ACTIONS(640),
    [anon_sym_int128] = ACTIONS(640),
    [anon_sym_int136] = ACTIONS(640),
    [anon_sym_int144] = ACTIONS(640),
    [anon_sym_int152] = ACTIONS(640),
    [anon_sym_int160] = ACTIONS(640),
    [anon_sym_int168] = ACTIONS(640),
    [anon_sym_int176] = ACTIONS(640),
    [anon_sym_int184] = ACTIONS(640),
    [anon_sym_int192] = ACTIONS(640),
    [anon_sym_int200] = ACTIONS(640),
    [anon_sym_int208] = ACTIONS(640),
    [anon_sym_int216] = ACTIONS(640),
    [anon_sym_int224] = ACTIONS(640),
    [anon_sym_int232] = ACTIONS(640),
    [anon_sym_int240] = ACTIONS(640),
    [anon_sym_int248] = ACTIONS(640),
    [anon_sym_int256] = ACTIONS(640),
    [anon_sym_uint] = ACTIONS(640),
    [anon_sym_uint8] = ACTIONS(640),
    [anon_sym_uint16] = ACTIONS(640),
    [anon_sym_uint24] = ACTIONS(640),
    [anon_sym_uint32] = ACTIONS(640),
    [anon_sym_uint40] = ACTIONS(640),
    [anon_sym_uint48] = ACTIONS(640),
    [anon_sym_uint56] = ACTIONS(640),
    [anon_sym_uint64] = ACTIONS(640),
    [anon_sym_uint72] = ACTIONS(640),
    [anon_sym_uint80] = ACTIONS(640),
    [anon_sym_uint88] = ACTIONS(640),
    [anon_sym_uint96] = ACTIONS(640),
    [anon_sym_uint104] = ACTIONS(640),
    [anon_sym_uint112] = ACTIONS(640),
    [anon_sym_uint120] = ACTIONS(640),
    [anon_sym_uint128] = ACTIONS(640),
    [anon_sym_uint136] = ACTIONS(640),
    [anon_sym_uint144] = ACTIONS(640),
    [anon_sym_uint152] = ACTIONS(640),
    [anon_sym_uint160] = ACTIONS(640),
    [anon_sym_uint168] = ACTIONS(640),
    [anon_sym_uint176] = ACTIONS(640),
    [anon_sym_uint184] = ACTIONS(640),
    [anon_sym_uint192] = ACTIONS(640),
    [anon_sym_uint200] = ACTIONS(640),
    [anon_sym_uint208] = ACTIONS(640),
    [anon_sym_uint216] = ACTIONS(640),
    [anon_sym_uint224] = ACTIONS(640),
    [anon_sym_uint232] = ACTIONS(640),
    [anon_sym_uint240] = ACTIONS(640),
    [anon_sym_uint248] = ACTIONS(640),
    [anon_sym_uint256] = ACTIONS(640),
    [anon_sym_bytes] = ACTIONS(640),
    [anon_sym_bytes1] = ACTIONS(640),
    [anon_sym_bytes2] = ACTIONS(640),
    [anon_sym_bytes3] = ACTIONS(640),
    [anon_sym_bytes4] = ACTIONS(640),
    [anon_sym_bytes5] = ACTIONS(640),
    [anon_sym_bytes6] = ACTIONS(640),
    [anon_sym_bytes7] = ACTIONS(640),
    [anon_sym_bytes8] = ACTIONS(640),
    [anon_sym_bytes9] = ACTIONS(640),
    [anon_sym_bytes10] = ACTIONS(640),
    [anon_sym_bytes11] = ACTIONS(640),
    [anon_sym_bytes12] = ACTIONS(640),
    [anon_sym_bytes13] = ACTIONS(640),
    [anon_sym_bytes14] = ACTIONS(640),
    [anon_sym_bytes15] = ACTIONS(640),
    [anon_sym_bytes16] = ACTIONS(640),
    [anon_sym_bytes17] = ACTIONS(640),
    [anon_sym_bytes18] = ACTIONS(640),
    [anon_sym_bytes19] = ACTIONS(640),
    [anon_sym_bytes20] = ACTIONS(640),
    [anon_sym_bytes21] = ACTIONS(640),
    [anon_sym_bytes22] = ACTIONS(640),
    [anon_sym_bytes23] = ACTIONS(640),
    [anon_sym_bytes24] = ACTIONS(640),
    [anon_sym_bytes25] = ACTIONS(640),
    [anon_sym_bytes26] = ACTIONS(640),
    [anon_sym_bytes27] = ACTIONS(640),
    [anon_sym_bytes28] = ACTIONS(640),
    [anon_sym_bytes29] = ACTIONS(640),
    [anon_sym_bytes30] = ACTIONS(640),
    [anon_sym_bytes31] = ACTIONS(640),
    [anon_sym_bytes32] = ACTIONS(640),
    [anon_sym_fixed] = ACTIONS(640),
    [aux_sym__fixed_token1] = ACTIONS(640),
    [anon_sym_ufixed] = ACTIONS(640),
    [aux_sym__ufixed_token1] = ACTIONS(640),
    [sym_comment] = ACTIONS(3),
  },
  [142] = {
    [ts_builtin_sym_end] = ACTIONS(642),
    [sym_identifier] = ACTIONS(644),
    [anon_sym_pragma] = ACTIONS(644),
    [anon_sym_import] = ACTIONS(644),
    [anon_sym_type] = ACTIONS(644),
    [anon_sym_abstract] = ACTIONS(644),
    [anon_sym_contract] = ACTIONS(644),
    [anon_sym_error] = ACTIONS(644),
    [anon_sym_interface] = ACTIONS(644),
    [anon_sym_library] = ACTIONS(644),
    [anon_sym_struct] = ACTIONS(644),
    [anon_sym_enum] = ACTIONS(644),
    [anon_sym_event] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(644),
    [anon_sym_byte] = ACTIONS(644),
    [anon_sym_address] = ACTIONS(644),
    [anon_sym_var] = ACTIONS(644),
    [anon_sym_mapping] = ACTIONS(644),
    [anon_sym_bool] = ACTIONS(644),
    [anon_sym_string] = ACTIONS(644),
    [anon_sym_int] = ACTIONS(644),
    [anon_sym_int8] = ACTIONS(644),
    [anon_sym_int16] = ACTIONS(644),
    [anon_sym_int24] = ACTIONS(644),
    [anon_sym_int32] = ACTIONS(644),
    [anon_sym_int40] = ACTIONS(644),
    [anon_sym_int48] = ACTIONS(644),
    [anon_sym_int56] = ACTIONS(644),
    [anon_sym_int64] = ACTIONS(644),
    [anon_sym_int72] = ACTIONS(644),
    [anon_sym_int80] = ACTIONS(644),
    [anon_sym_int88] = ACTIONS(644),
    [anon_sym_int96] = ACTIONS(644),
    [anon_sym_int104] = ACTIONS(644),
    [anon_sym_int112] = ACTIONS(644),
    [anon_sym_int120] = ACTIONS(644),
    [anon_sym_int128] = ACTIONS(644),
    [anon_sym_int136] = ACTIONS(644),
    [anon_sym_int144] = ACTIONS(644),
    [anon_sym_int152] = ACTIONS(644),
    [anon_sym_int160] = ACTIONS(644),
    [anon_sym_int168] = ACTIONS(644),
    [anon_sym_int176] = ACTIONS(644),
    [anon_sym_int184] = ACTIONS(644),
    [anon_sym_int192] = ACTIONS(644),
    [anon_sym_int200] = ACTIONS(644),
    [anon_sym_int208] = ACTIONS(644),
    [anon_sym_int216] = ACTIONS(644),
    [anon_sym_int224] = ACTIONS(644),
    [anon_sym_int232] = ACTIONS(644),
    [anon_sym_int240] = ACTIONS(644),
    [anon_sym_int248] = ACTIONS(644),
    [anon_sym_int256] = ACTIONS(644),
    [anon_sym_uint] = ACTIONS(644),
    [anon_sym_uint8] = ACTIONS(644),
    [anon_sym_uint16] = ACTIONS(644),
    [anon_sym_uint24] = ACTIONS(644),
    [anon_sym_uint32] = ACTIONS(644),
    [anon_sym_uint40] = ACTIONS(644),
    [anon_sym_uint48] = ACTIONS(644),
    [anon_sym_uint56] = ACTIONS(644),
    [anon_sym_uint64] = ACTIONS(644),
    [anon_sym_uint72] = ACTIONS(644),
    [anon_sym_uint80] = ACTIONS(644),
    [anon_sym_uint88] = ACTIONS(644),
    [anon_sym_uint96] = ACTIONS(644),
    [anon_sym_uint104] = ACTIONS(644),
    [anon_sym_uint112] = ACTIONS(644),
    [anon_sym_uint120] = ACTIONS(644),
    [anon_sym_uint128] = ACTIONS(644),
    [anon_sym_uint136] = ACTIONS(644),
    [anon_sym_uint144] = ACTIONS(644),
    [anon_sym_uint152] = ACTIONS(644),
    [anon_sym_uint160] = ACTIONS(644),
    [anon_sym_uint168] = ACTIONS(644),
    [anon_sym_uint176] = ACTIONS(644),
    [anon_sym_uint184] = ACTIONS(644),
    [anon_sym_uint192] = ACTIONS(644),
    [anon_sym_uint200] = ACTIONS(644),
    [anon_sym_uint208] = ACTIONS(644),
    [anon_sym_uint216] = ACTIONS(644),
    [anon_sym_uint224] = ACTIONS(644),
    [anon_sym_uint232] = ACTIONS(644),
    [anon_sym_uint240] = ACTIONS(644),
    [anon_sym_uint248] = ACTIONS(644),
    [anon_sym_uint256] = ACTIONS(644),
    [anon_sym_bytes] = ACTIONS(644),
    [anon_sym_bytes1] = ACTIONS(644),
    [anon_sym_bytes2] = ACTIONS(644),
    [anon_sym_bytes3] = ACTIONS(644),
    [anon_sym_bytes4] = ACTIONS(644),
    [anon_sym_bytes5] = ACTIONS(644),
    [anon_sym_bytes6] = ACTIONS(644),
    [anon_sym_bytes7] = ACTIONS(644),
    [anon_sym_bytes8] = ACTIONS(644),
    [anon_sym_bytes9] = ACTIONS(644),
    [anon_sym_bytes10] = ACTIONS(644),
    [anon_sym_bytes11] = ACTIONS(644),
    [anon_sym_bytes12] = ACTIONS(644),
    [anon_sym_bytes13] = ACTIONS(644),
    [anon_sym_bytes14] = ACTIONS(644),
    [anon_sym_bytes15] = ACTIONS(644),
    [anon_sym_bytes16] = ACTIONS(644),
    [anon_sym_bytes17] = ACTIONS(644),
    [anon_sym_bytes18] = ACTIONS(644),
    [anon_sym_bytes19] = ACTIONS(644),
    [anon_sym_bytes20] = ACTIONS(644),
    [anon_sym_bytes21] = ACTIONS(644),
    [anon_sym_bytes22] = ACTIONS(644),
    [anon_sym_bytes23] = ACTIONS(644),
    [anon_sym_bytes24] = ACTIONS(644),
    [anon_sym_bytes25] = ACTIONS(644),
    [anon_sym_bytes26] = ACTIONS(644),
    [anon_sym_bytes27] = ACTIONS(644),
    [anon_sym_bytes28] = ACTIONS(644),
    [anon_sym_bytes29] = ACTIONS(644),
    [anon_sym_bytes30] = ACTIONS(644),
    [anon_sym_bytes31] = ACTIONS(644),
    [anon_sym_bytes32] = ACTIONS(644),
    [anon_sym_fixed] = ACTIONS(644),
    [aux_sym__fixed_token1] = ACTIONS(644),
    [anon_sym_ufixed] = ACTIONS(644),
    [aux_sym__ufixed_token1] = ACTIONS(644),
    [sym_comment] = ACTIONS(3),
  },
  [143] = {
    [ts_builtin_sym_end] = ACTIONS(646),
    [sym_identifier] = ACTIONS(648),
    [anon_sym_pragma] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_type] = ACTIONS(648),
    [anon_sym_abstract] = ACTIONS(648),
    [anon_sym_contract] = ACTIONS(648),
    [anon_sym_error] = ACTIONS(648),
    [anon_sym_interface] = ACTIONS(648),
    [anon_sym_library] = ACTIONS(648),
    [anon_sym_struct] = ACTIONS(648),
    [anon_sym_enum] = ACTIONS(648),
    [anon_sym_event] = ACTIONS(648),
    [anon_sym_function] = ACTIONS(648),
    [anon_sym_byte] = ACTIONS(648),
    [anon_sym_address] = ACTIONS(648),
    [anon_sym_var] = ACTIONS(648),
    [anon_sym_mapping] = ACTIONS(648),
    [anon_sym_bool] = ACTIONS(648),
    [anon_sym_string] = ACTIONS(648),
    [anon_sym_int] = ACTIONS(648),
    [anon_sym_int8] = ACTIONS(648),
    [anon_sym_int16] = ACTIONS(648),
    [anon_sym_int24] = ACTIONS(648),
    [anon_sym_int32] = ACTIONS(648),
    [anon_sym_int40] = ACTIONS(648),
    [anon_sym_int48] = ACTIONS(648),
    [anon_sym_int56] = ACTIONS(648),
    [anon_sym_int64] = ACTIONS(648),
    [anon_sym_int72] = ACTIONS(648),
    [anon_sym_int80] = ACTIONS(648),
    [anon_sym_int88] = ACTIONS(648),
    [anon_sym_int96] = ACTIONS(648),
    [anon_sym_int104] = ACTIONS(648),
    [anon_sym_int112] = ACTIONS(648),
    [anon_sym_int120] = ACTIONS(648),
    [anon_sym_int128] = ACTIONS(648),
    [anon_sym_int136] = ACTIONS(648),
    [anon_sym_int144] = ACTIONS(648),
    [anon_sym_int152] = ACTIONS(648),
    [anon_sym_int160] = ACTIONS(648),
    [anon_sym_int168] = ACTIONS(648),
    [anon_sym_int176] = ACTIONS(648),
    [anon_sym_int184] = ACTIONS(648),
    [anon_sym_int192] = ACTIONS(648),
    [anon_sym_int200] = ACTIONS(648),
    [anon_sym_int208] = ACTIONS(648),
    [anon_sym_int216] = ACTIONS(648),
    [anon_sym_int224] = ACTIONS(648),
    [anon_sym_int232] = ACTIONS(648),
    [anon_sym_int240] = ACTIONS(648),
    [anon_sym_int248] = ACTIONS(648),
    [anon_sym_int256] = ACTIONS(648),
    [anon_sym_uint] = ACTIONS(648),
    [anon_sym_uint8] = ACTIONS(648),
    [anon_sym_uint16] = ACTIONS(648),
    [anon_sym_uint24] = ACTIONS(648),
    [anon_sym_uint32] = ACTIONS(648),
    [anon_sym_uint40] = ACTIONS(648),
    [anon_sym_uint48] = ACTIONS(648),
    [anon_sym_uint56] = ACTIONS(648),
    [anon_sym_uint64] = ACTIONS(648),
    [anon_sym_uint72] = ACTIONS(648),
    [anon_sym_uint80] = ACTIONS(648),
    [anon_sym_uint88] = ACTIONS(648),
    [anon_sym_uint96] = ACTIONS(648),
    [anon_sym_uint104] = ACTIONS(648),
    [anon_sym_uint112] = ACTIONS(648),
    [anon_sym_uint120] = ACTIONS(648),
    [anon_sym_uint128] = ACTIONS(648),
    [anon_sym_uint136] = ACTIONS(648),
    [anon_sym_uint144] = ACTIONS(648),
    [anon_sym_uint152] = ACTIONS(648),
    [anon_sym_uint160] = ACTIONS(648),
    [anon_sym_uint168] = ACTIONS(648),
    [anon_sym_uint176] = ACTIONS(648),
    [anon_sym_uint184] = ACTIONS(648),
    [anon_sym_uint192] = ACTIONS(648),
    [anon_sym_uint200] = ACTIONS(648),
    [anon_sym_uint208] = ACTIONS(648),
    [anon_sym_uint216] = ACTIONS(648),
    [anon_sym_uint224] = ACTIONS(648),
    [anon_sym_uint232] = ACTIONS(648),
    [anon_sym_uint240] = ACTIONS(648),
    [anon_sym_uint248] = ACTIONS(648),
    [anon_sym_uint256] = ACTIONS(648),
    [anon_sym_bytes] = ACTIONS(648),
    [anon_sym_bytes1] = ACTIONS(648),
    [anon_sym_bytes2] = ACTIONS(648),
    [anon_sym_bytes3] = ACTIONS(648),
    [anon_sym_bytes4] = ACTIONS(648),
    [anon_sym_bytes5] = ACTIONS(648),
    [anon_sym_bytes6] = ACTIONS(648),
    [anon_sym_bytes7] = ACTIONS(648),
    [anon_sym_bytes8] = ACTIONS(648),
    [anon_sym_bytes9] = ACTIONS(648),
    [anon_sym_bytes10] = ACTIONS(648),
    [anon_sym_bytes11] = ACTIONS(648),
    [anon_sym_bytes12] = ACTIONS(648),
    [anon_sym_bytes13] = ACTIONS(648),
    [anon_sym_bytes14] = ACTIONS(648),
    [anon_sym_bytes15] = ACTIONS(648),
    [anon_sym_bytes16] = ACTIONS(648),
    [anon_sym_bytes17] = ACTIONS(648),
    [anon_sym_bytes18] = ACTIONS(648),
    [anon_sym_bytes19] = ACTIONS(648),
    [anon_sym_bytes20] = ACTIONS(648),
    [anon_sym_bytes21] = ACTIONS(648),
    [anon_sym_bytes22] = ACTIONS(648),
    [anon_sym_bytes23] = ACTIONS(648),
    [anon_sym_bytes24] = ACTIONS(648),
    [anon_sym_bytes25] = ACTIONS(648),
    [anon_sym_bytes26] = ACTIONS(648),
    [anon_sym_bytes27] = ACTIONS(648),
    [anon_sym_bytes28] = ACTIONS(648),
    [anon_sym_bytes29] = ACTIONS(648),
    [anon_sym_bytes30] = ACTIONS(648),
    [anon_sym_bytes31] = ACTIONS(648),
    [anon_sym_bytes32] = ACTIONS(648),
    [anon_sym_fixed] = ACTIONS(648),
    [aux_sym__fixed_token1] = ACTIONS(648),
    [anon_sym_ufixed] = ACTIONS(648),
    [aux_sym__ufixed_token1] = ACTIONS(648),
    [sym_comment] = ACTIONS(3),
  },
  [144] = {
    [ts_builtin_sym_end] = ACTIONS(650),
    [sym_identifier] = ACTIONS(652),
    [anon_sym_pragma] = ACTIONS(652),
    [anon_sym_import] = ACTIONS(652),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_abstract] = ACTIONS(652),
    [anon_sym_contract] = ACTIONS(652),
    [anon_sym_error] = ACTIONS(652),
    [anon_sym_interface] = ACTIONS(652),
    [anon_sym_library] = ACTIONS(652),
    [anon_sym_struct] = ACTIONS(652),
    [anon_sym_enum] = ACTIONS(652),
    [anon_sym_event] = ACTIONS(652),
    [anon_sym_function] = ACTIONS(652),
    [anon_sym_byte] = ACTIONS(652),
    [anon_sym_address] = ACTIONS(652),
    [anon_sym_var] = ACTIONS(652),
    [anon_sym_mapping] = ACTIONS(652),
    [anon_sym_bool] = ACTIONS(652),
    [anon_sym_string] = ACTIONS(652),
    [anon_sym_int] = ACTIONS(652),
    [anon_sym_int8] = ACTIONS(652),
    [anon_sym_int16] = ACTIONS(652),
    [anon_sym_int24] = ACTIONS(652),
    [anon_sym_int32] = ACTIONS(652),
    [anon_sym_int40] = ACTIONS(652),
    [anon_sym_int48] = ACTIONS(652),
    [anon_sym_int56] = ACTIONS(652),
    [anon_sym_int64] = ACTIONS(652),
    [anon_sym_int72] = ACTIONS(652),
    [anon_sym_int80] = ACTIONS(652),
    [anon_sym_int88] = ACTIONS(652),
    [anon_sym_int96] = ACTIONS(652),
    [anon_sym_int104] = ACTIONS(652),
    [anon_sym_int112] = ACTIONS(652),
    [anon_sym_int120] = ACTIONS(652),
    [anon_sym_int128] = ACTIONS(652),
    [anon_sym_int136] = ACTIONS(652),
    [anon_sym_int144] = ACTIONS(652),
    [anon_sym_int152] = ACTIONS(652),
    [anon_sym_int160] = ACTIONS(652),
    [anon_sym_int168] = ACTIONS(652),
    [anon_sym_int176] = ACTIONS(652),
    [anon_sym_int184] = ACTIONS(652),
    [anon_sym_int192] = ACTIONS(652),
    [anon_sym_int200] = ACTIONS(652),
    [anon_sym_int208] = ACTIONS(652),
    [anon_sym_int216] = ACTIONS(652),
    [anon_sym_int224] = ACTIONS(652),
    [anon_sym_int232] = ACTIONS(652),
    [anon_sym_int240] = ACTIONS(652),
    [anon_sym_int248] = ACTIONS(652),
    [anon_sym_int256] = ACTIONS(652),
    [anon_sym_uint] = ACTIONS(652),
    [anon_sym_uint8] = ACTIONS(652),
    [anon_sym_uint16] = ACTIONS(652),
    [anon_sym_uint24] = ACTIONS(652),
    [anon_sym_uint32] = ACTIONS(652),
    [anon_sym_uint40] = ACTIONS(652),
    [anon_sym_uint48] = ACTIONS(652),
    [anon_sym_uint56] = ACTIONS(652),
    [anon_sym_uint64] = ACTIONS(652),
    [anon_sym_uint72] = ACTIONS(652),
    [anon_sym_uint80] = ACTIONS(652),
    [anon_sym_uint88] = ACTIONS(652),
    [anon_sym_uint96] = ACTIONS(652),
    [anon_sym_uint104] = ACTIONS(652),
    [anon_sym_uint112] = ACTIONS(652),
    [anon_sym_uint120] = ACTIONS(652),
    [anon_sym_uint128] = ACTIONS(652),
    [anon_sym_uint136] = ACTIONS(652),
    [anon_sym_uint144] = ACTIONS(652),
    [anon_sym_uint152] = ACTIONS(652),
    [anon_sym_uint160] = ACTIONS(652),
    [anon_sym_uint168] = ACTIONS(652),
    [anon_sym_uint176] = ACTIONS(652),
    [anon_sym_uint184] = ACTIONS(652),
    [anon_sym_uint192] = ACTIONS(652),
    [anon_sym_uint200] = ACTIONS(652),
    [anon_sym_uint208] = ACTIONS(652),
    [anon_sym_uint216] = ACTIONS(652),
    [anon_sym_uint224] = ACTIONS(652),
    [anon_sym_uint232] = ACTIONS(652),
    [anon_sym_uint240] = ACTIONS(652),
    [anon_sym_uint248] = ACTIONS(652),
    [anon_sym_uint256] = ACTIONS(652),
    [anon_sym_bytes] = ACTIONS(652),
    [anon_sym_bytes1] = ACTIONS(652),
    [anon_sym_bytes2] = ACTIONS(652),
    [anon_sym_bytes3] = ACTIONS(652),
    [anon_sym_bytes4] = ACTIONS(652),
    [anon_sym_bytes5] = ACTIONS(652),
    [anon_sym_bytes6] = ACTIONS(652),
    [anon_sym_bytes7] = ACTIONS(652),
    [anon_sym_bytes8] = ACTIONS(652),
    [anon_sym_bytes9] = ACTIONS(652),
    [anon_sym_bytes10] = ACTIONS(652),
    [anon_sym_bytes11] = ACTIONS(652),
    [anon_sym_bytes12] = ACTIONS(652),
    [anon_sym_bytes13] = ACTIONS(652),
    [anon_sym_bytes14] = ACTIONS(652),
    [anon_sym_bytes15] = ACTIONS(652),
    [anon_sym_bytes16] = ACTIONS(652),
    [anon_sym_bytes17] = ACTIONS(652),
    [anon_sym_bytes18] = ACTIONS(652),
    [anon_sym_bytes19] = ACTIONS(652),
    [anon_sym_bytes20] = ACTIONS(652),
    [anon_sym_bytes21] = ACTIONS(652),
    [anon_sym_bytes22] = ACTIONS(652),
    [anon_sym_bytes23] = ACTIONS(652),
    [anon_sym_bytes24] = ACTIONS(652),
    [anon_sym_bytes25] = ACTIONS(652),
    [anon_sym_bytes26] = ACTIONS(652),
    [anon_sym_bytes27] = ACTIONS(652),
    [anon_sym_bytes28] = ACTIONS(652),
    [anon_sym_bytes29] = ACTIONS(652),
    [anon_sym_bytes30] = ACTIONS(652),
    [anon_sym_bytes31] = ACTIONS(652),
    [anon_sym_bytes32] = ACTIONS(652),
    [anon_sym_fixed] = ACTIONS(652),
    [aux_sym__fixed_token1] = ACTIONS(652),
    [anon_sym_ufixed] = ACTIONS(652),
    [aux_sym__ufixed_token1] = ACTIONS(652),
    [sym_comment] = ACTIONS(3),
  },
  [145] = {
    [ts_builtin_sym_end] = ACTIONS(654),
    [sym_identifier] = ACTIONS(656),
    [anon_sym_pragma] = ACTIONS(656),
    [anon_sym_import] = ACTIONS(656),
    [anon_sym_type] = ACTIONS(656),
    [anon_sym_abstract] = ACTIONS(656),
    [anon_sym_contract] = ACTIONS(656),
    [anon_sym_error] = ACTIONS(656),
    [anon_sym_interface] = ACTIONS(656),
    [anon_sym_library] = ACTIONS(656),
    [anon_sym_struct] = ACTIONS(656),
    [anon_sym_enum] = ACTIONS(656),
    [anon_sym_event] = ACTIONS(656),
    [anon_sym_function] = ACTIONS(656),
    [anon_sym_byte] = ACTIONS(656),
    [anon_sym_address] = ACTIONS(656),
    [anon_sym_var] = ACTIONS(656),
    [anon_sym_mapping] = ACTIONS(656),
    [anon_sym_bool] = ACTIONS(656),
    [anon_sym_string] = ACTIONS(656),
    [anon_sym_int] = ACTIONS(656),
    [anon_sym_int8] = ACTIONS(656),
    [anon_sym_int16] = ACTIONS(656),
    [anon_sym_int24] = ACTIONS(656),
    [anon_sym_int32] = ACTIONS(656),
    [anon_sym_int40] = ACTIONS(656),
    [anon_sym_int48] = ACTIONS(656),
    [anon_sym_int56] = ACTIONS(656),
    [anon_sym_int64] = ACTIONS(656),
    [anon_sym_int72] = ACTIONS(656),
    [anon_sym_int80] = ACTIONS(656),
    [anon_sym_int88] = ACTIONS(656),
    [anon_sym_int96] = ACTIONS(656),
    [anon_sym_int104] = ACTIONS(656),
    [anon_sym_int112] = ACTIONS(656),
    [anon_sym_int120] = ACTIONS(656),
    [anon_sym_int128] = ACTIONS(656),
    [anon_sym_int136] = ACTIONS(656),
    [anon_sym_int144] = ACTIONS(656),
    [anon_sym_int152] = ACTIONS(656),
    [anon_sym_int160] = ACTIONS(656),
    [anon_sym_int168] = ACTIONS(656),
    [anon_sym_int176] = ACTIONS(656),
    [anon_sym_int184] = ACTIONS(656),
    [anon_sym_int192] = ACTIONS(656),
    [anon_sym_int200] = ACTIONS(656),
    [anon_sym_int208] = ACTIONS(656),
    [anon_sym_int216] = ACTIONS(656),
    [anon_sym_int224] = ACTIONS(656),
    [anon_sym_int232] = ACTIONS(656),
    [anon_sym_int240] = ACTIONS(656),
    [anon_sym_int248] = ACTIONS(656),
    [anon_sym_int256] = ACTIONS(656),
    [anon_sym_uint] = ACTIONS(656),
    [anon_sym_uint8] = ACTIONS(656),
    [anon_sym_uint16] = ACTIONS(656),
    [anon_sym_uint24] = ACTIONS(656),
    [anon_sym_uint32] = ACTIONS(656),
    [anon_sym_uint40] = ACTIONS(656),
    [anon_sym_uint48] = ACTIONS(656),
    [anon_sym_uint56] = ACTIONS(656),
    [anon_sym_uint64] = ACTIONS(656),
    [anon_sym_uint72] = ACTIONS(656),
    [anon_sym_uint80] = ACTIONS(656),
    [anon_sym_uint88] = ACTIONS(656),
    [anon_sym_uint96] = ACTIONS(656),
    [anon_sym_uint104] = ACTIONS(656),
    [anon_sym_uint112] = ACTIONS(656),
    [anon_sym_uint120] = ACTIONS(656),
    [anon_sym_uint128] = ACTIONS(656),
    [anon_sym_uint136] = ACTIONS(656),
    [anon_sym_uint144] = ACTIONS(656),
    [anon_sym_uint152] = ACTIONS(656),
    [anon_sym_uint160] = ACTIONS(656),
    [anon_sym_uint168] = ACTIONS(656),
    [anon_sym_uint176] = ACTIONS(656),
    [anon_sym_uint184] = ACTIONS(656),
    [anon_sym_uint192] = ACTIONS(656),
    [anon_sym_uint200] = ACTIONS(656),
    [anon_sym_uint208] = ACTIONS(656),
    [anon_sym_uint216] = ACTIONS(656),
    [anon_sym_uint224] = ACTIONS(656),
    [anon_sym_uint232] = ACTIONS(656),
    [anon_sym_uint240] = ACTIONS(656),
    [anon_sym_uint248] = ACTIONS(656),
    [anon_sym_uint256] = ACTIONS(656),
    [anon_sym_bytes] = ACTIONS(656),
    [anon_sym_bytes1] = ACTIONS(656),
    [anon_sym_bytes2] = ACTIONS(656),
    [anon_sym_bytes3] = ACTIONS(656),
    [anon_sym_bytes4] = ACTIONS(656),
    [anon_sym_bytes5] = ACTIONS(656),
    [anon_sym_bytes6] = ACTIONS(656),
    [anon_sym_bytes7] = ACTIONS(656),
    [anon_sym_bytes8] = ACTIONS(656),
    [anon_sym_bytes9] = ACTIONS(656),
    [anon_sym_bytes10] = ACTIONS(656),
    [anon_sym_bytes11] = ACTIONS(656),
    [anon_sym_bytes12] = ACTIONS(656),
    [anon_sym_bytes13] = ACTIONS(656),
    [anon_sym_bytes14] = ACTIONS(656),
    [anon_sym_bytes15] = ACTIONS(656),
    [anon_sym_bytes16] = ACTIONS(656),
    [anon_sym_bytes17] = ACTIONS(656),
    [anon_sym_bytes18] = ACTIONS(656),
    [anon_sym_bytes19] = ACTIONS(656),
    [anon_sym_bytes20] = ACTIONS(656),
    [anon_sym_bytes21] = ACTIONS(656),
    [anon_sym_bytes22] = ACTIONS(656),
    [anon_sym_bytes23] = ACTIONS(656),
    [anon_sym_bytes24] = ACTIONS(656),
    [anon_sym_bytes25] = ACTIONS(656),
    [anon_sym_bytes26] = ACTIONS(656),
    [anon_sym_bytes27] = ACTIONS(656),
    [anon_sym_bytes28] = ACTIONS(656),
    [anon_sym_bytes29] = ACTIONS(656),
    [anon_sym_bytes30] = ACTIONS(656),
    [anon_sym_bytes31] = ACTIONS(656),
    [anon_sym_bytes32] = ACTIONS(656),
    [anon_sym_fixed] = ACTIONS(656),
    [aux_sym__fixed_token1] = ACTIONS(656),
    [anon_sym_ufixed] = ACTIONS(656),
    [aux_sym__ufixed_token1] = ACTIONS(656),
    [sym_comment] = ACTIONS(3),
  },
  [146] = {
    [ts_builtin_sym_end] = ACTIONS(658),
    [sym_identifier] = ACTIONS(660),
    [anon_sym_pragma] = ACTIONS(660),
    [anon_sym_import] = ACTIONS(660),
    [anon_sym_type] = ACTIONS(660),
    [anon_sym_abstract] = ACTIONS(660),
    [anon_sym_contract] = ACTIONS(660),
    [anon_sym_error] = ACTIONS(660),
    [anon_sym_interface] = ACTIONS(660),
    [anon_sym_library] = ACTIONS(660),
    [anon_sym_struct] = ACTIONS(660),
    [anon_sym_enum] = ACTIONS(660),
    [anon_sym_event] = ACTIONS(660),
    [anon_sym_function] = ACTIONS(660),
    [anon_sym_byte] = ACTIONS(660),
    [anon_sym_address] = ACTIONS(660),
    [anon_sym_var] = ACTIONS(660),
    [anon_sym_mapping] = ACTIONS(660),
    [anon_sym_bool] = ACTIONS(660),
    [anon_sym_string] = ACTIONS(660),
    [anon_sym_int] = ACTIONS(660),
    [anon_sym_int8] = ACTIONS(660),
    [anon_sym_int16] = ACTIONS(660),
    [anon_sym_int24] = ACTIONS(660),
    [anon_sym_int32] = ACTIONS(660),
    [anon_sym_int40] = ACTIONS(660),
    [anon_sym_int48] = ACTIONS(660),
    [anon_sym_int56] = ACTIONS(660),
    [anon_sym_int64] = ACTIONS(660),
    [anon_sym_int72] = ACTIONS(660),
    [anon_sym_int80] = ACTIONS(660),
    [anon_sym_int88] = ACTIONS(660),
    [anon_sym_int96] = ACTIONS(660),
    [anon_sym_int104] = ACTIONS(660),
    [anon_sym_int112] = ACTIONS(660),
    [anon_sym_int120] = ACTIONS(660),
    [anon_sym_int128] = ACTIONS(660),
    [anon_sym_int136] = ACTIONS(660),
    [anon_sym_int144] = ACTIONS(660),
    [anon_sym_int152] = ACTIONS(660),
    [anon_sym_int160] = ACTIONS(660),
    [anon_sym_int168] = ACTIONS(660),
    [anon_sym_int176] = ACTIONS(660),
    [anon_sym_int184] = ACTIONS(660),
    [anon_sym_int192] = ACTIONS(660),
    [anon_sym_int200] = ACTIONS(660),
    [anon_sym_int208] = ACTIONS(660),
    [anon_sym_int216] = ACTIONS(660),
    [anon_sym_int224] = ACTIONS(660),
    [anon_sym_int232] = ACTIONS(660),
    [anon_sym_int240] = ACTIONS(660),
    [anon_sym_int248] = ACTIONS(660),
    [anon_sym_int256] = ACTIONS(660),
    [anon_sym_uint] = ACTIONS(660),
    [anon_sym_uint8] = ACTIONS(660),
    [anon_sym_uint16] = ACTIONS(660),
    [anon_sym_uint24] = ACTIONS(660),
    [anon_sym_uint32] = ACTIONS(660),
    [anon_sym_uint40] = ACTIONS(660),
    [anon_sym_uint48] = ACTIONS(660),
    [anon_sym_uint56] = ACTIONS(660),
    [anon_sym_uint64] = ACTIONS(660),
    [anon_sym_uint72] = ACTIONS(660),
    [anon_sym_uint80] = ACTIONS(660),
    [anon_sym_uint88] = ACTIONS(660),
    [anon_sym_uint96] = ACTIONS(660),
    [anon_sym_uint104] = ACTIONS(660),
    [anon_sym_uint112] = ACTIONS(660),
    [anon_sym_uint120] = ACTIONS(660),
    [anon_sym_uint128] = ACTIONS(660),
    [anon_sym_uint136] = ACTIONS(660),
    [anon_sym_uint144] = ACTIONS(660),
    [anon_sym_uint152] = ACTIONS(660),
    [anon_sym_uint160] = ACTIONS(660),
    [anon_sym_uint168] = ACTIONS(660),
    [anon_sym_uint176] = ACTIONS(660),
    [anon_sym_uint184] = ACTIONS(660),
    [anon_sym_uint192] = ACTIONS(660),
    [anon_sym_uint200] = ACTIONS(660),
    [anon_sym_uint208] = ACTIONS(660),
    [anon_sym_uint216] = ACTIONS(660),
    [anon_sym_uint224] = ACTIONS(660),
    [anon_sym_uint232] = ACTIONS(660),
    [anon_sym_uint240] = ACTIONS(660),
    [anon_sym_uint248] = ACTIONS(660),
    [anon_sym_uint256] = ACTIONS(660),
    [anon_sym_bytes] = ACTIONS(660),
    [anon_sym_bytes1] = ACTIONS(660),
    [anon_sym_bytes2] = ACTIONS(660),
    [anon_sym_bytes3] = ACTIONS(660),
    [anon_sym_bytes4] = ACTIONS(660),
    [anon_sym_bytes5] = ACTIONS(660),
    [anon_sym_bytes6] = ACTIONS(660),
    [anon_sym_bytes7] = ACTIONS(660),
    [anon_sym_bytes8] = ACTIONS(660),
    [anon_sym_bytes9] = ACTIONS(660),
    [anon_sym_bytes10] = ACTIONS(660),
    [anon_sym_bytes11] = ACTIONS(660),
    [anon_sym_bytes12] = ACTIONS(660),
    [anon_sym_bytes13] = ACTIONS(660),
    [anon_sym_bytes14] = ACTIONS(660),
    [anon_sym_bytes15] = ACTIONS(660),
    [anon_sym_bytes16] = ACTIONS(660),
    [anon_sym_bytes17] = ACTIONS(660),
    [anon_sym_bytes18] = ACTIONS(660),
    [anon_sym_bytes19] = ACTIONS(660),
    [anon_sym_bytes20] = ACTIONS(660),
    [anon_sym_bytes21] = ACTIONS(660),
    [anon_sym_bytes22] = ACTIONS(660),
    [anon_sym_bytes23] = ACTIONS(660),
    [anon_sym_bytes24] = ACTIONS(660),
    [anon_sym_bytes25] = ACTIONS(660),
    [anon_sym_bytes26] = ACTIONS(660),
    [anon_sym_bytes27] = ACTIONS(660),
    [anon_sym_bytes28] = ACTIONS(660),
    [anon_sym_bytes29] = ACTIONS(660),
    [anon_sym_bytes30] = ACTIONS(660),
    [anon_sym_bytes31] = ACTIONS(660),
    [anon_sym_bytes32] = ACTIONS(660),
    [anon_sym_fixed] = ACTIONS(660),
    [aux_sym__fixed_token1] = ACTIONS(660),
    [anon_sym_ufixed] = ACTIONS(660),
    [aux_sym__ufixed_token1] = ACTIONS(660),
    [sym_comment] = ACTIONS(3),
  },
  [147] = {
    [ts_builtin_sym_end] = ACTIONS(662),
    [sym_identifier] = ACTIONS(664),
    [anon_sym_pragma] = ACTIONS(664),
    [anon_sym_import] = ACTIONS(664),
    [anon_sym_type] = ACTIONS(664),
    [anon_sym_abstract] = ACTIONS(664),
    [anon_sym_contract] = ACTIONS(664),
    [anon_sym_error] = ACTIONS(664),
    [anon_sym_interface] = ACTIONS(664),
    [anon_sym_library] = ACTIONS(664),
    [anon_sym_struct] = ACTIONS(664),
    [anon_sym_enum] = ACTIONS(664),
    [anon_sym_event] = ACTIONS(664),
    [anon_sym_function] = ACTIONS(664),
    [anon_sym_byte] = ACTIONS(664),
    [anon_sym_address] = ACTIONS(664),
    [anon_sym_var] = ACTIONS(664),
    [anon_sym_mapping] = ACTIONS(664),
    [anon_sym_bool] = ACTIONS(664),
    [anon_sym_string] = ACTIONS(664),
    [anon_sym_int] = ACTIONS(664),
    [anon_sym_int8] = ACTIONS(664),
    [anon_sym_int16] = ACTIONS(664),
    [anon_sym_int24] = ACTIONS(664),
    [anon_sym_int32] = ACTIONS(664),
    [anon_sym_int40] = ACTIONS(664),
    [anon_sym_int48] = ACTIONS(664),
    [anon_sym_int56] = ACTIONS(664),
    [anon_sym_int64] = ACTIONS(664),
    [anon_sym_int72] = ACTIONS(664),
    [anon_sym_int80] = ACTIONS(664),
    [anon_sym_int88] = ACTIONS(664),
    [anon_sym_int96] = ACTIONS(664),
    [anon_sym_int104] = ACTIONS(664),
    [anon_sym_int112] = ACTIONS(664),
    [anon_sym_int120] = ACTIONS(664),
    [anon_sym_int128] = ACTIONS(664),
    [anon_sym_int136] = ACTIONS(664),
    [anon_sym_int144] = ACTIONS(664),
    [anon_sym_int152] = ACTIONS(664),
    [anon_sym_int160] = ACTIONS(664),
    [anon_sym_int168] = ACTIONS(664),
    [anon_sym_int176] = ACTIONS(664),
    [anon_sym_int184] = ACTIONS(664),
    [anon_sym_int192] = ACTIONS(664),
    [anon_sym_int200] = ACTIONS(664),
    [anon_sym_int208] = ACTIONS(664),
    [anon_sym_int216] = ACTIONS(664),
    [anon_sym_int224] = ACTIONS(664),
    [anon_sym_int232] = ACTIONS(664),
    [anon_sym_int240] = ACTIONS(664),
    [anon_sym_int248] = ACTIONS(664),
    [anon_sym_int256] = ACTIONS(664),
    [anon_sym_uint] = ACTIONS(664),
    [anon_sym_uint8] = ACTIONS(664),
    [anon_sym_uint16] = ACTIONS(664),
    [anon_sym_uint24] = ACTIONS(664),
    [anon_sym_uint32] = ACTIONS(664),
    [anon_sym_uint40] = ACTIONS(664),
    [anon_sym_uint48] = ACTIONS(664),
    [anon_sym_uint56] = ACTIONS(664),
    [anon_sym_uint64] = ACTIONS(664),
    [anon_sym_uint72] = ACTIONS(664),
    [anon_sym_uint80] = ACTIONS(664),
    [anon_sym_uint88] = ACTIONS(664),
    [anon_sym_uint96] = ACTIONS(664),
    [anon_sym_uint104] = ACTIONS(664),
    [anon_sym_uint112] = ACTIONS(664),
    [anon_sym_uint120] = ACTIONS(664),
    [anon_sym_uint128] = ACTIONS(664),
    [anon_sym_uint136] = ACTIONS(664),
    [anon_sym_uint144] = ACTIONS(664),
    [anon_sym_uint152] = ACTIONS(664),
    [anon_sym_uint160] = ACTIONS(664),
    [anon_sym_uint168] = ACTIONS(664),
    [anon_sym_uint176] = ACTIONS(664),
    [anon_sym_uint184] = ACTIONS(664),
    [anon_sym_uint192] = ACTIONS(664),
    [anon_sym_uint200] = ACTIONS(664),
    [anon_sym_uint208] = ACTIONS(664),
    [anon_sym_uint216] = ACTIONS(664),
    [anon_sym_uint224] = ACTIONS(664),
    [anon_sym_uint232] = ACTIONS(664),
    [anon_sym_uint240] = ACTIONS(664),
    [anon_sym_uint248] = ACTIONS(664),
    [anon_sym_uint256] = ACTIONS(664),
    [anon_sym_bytes] = ACTIONS(664),
    [anon_sym_bytes1] = ACTIONS(664),
    [anon_sym_bytes2] = ACTIONS(664),
    [anon_sym_bytes3] = ACTIONS(664),
    [anon_sym_bytes4] = ACTIONS(664),
    [anon_sym_bytes5] = ACTIONS(664),
    [anon_sym_bytes6] = ACTIONS(664),
    [anon_sym_bytes7] = ACTIONS(664),
    [anon_sym_bytes8] = ACTIONS(664),
    [anon_sym_bytes9] = ACTIONS(664),
    [anon_sym_bytes10] = ACTIONS(664),
    [anon_sym_bytes11] = ACTIONS(664),
    [anon_sym_bytes12] = ACTIONS(664),
    [anon_sym_bytes13] = ACTIONS(664),
    [anon_sym_bytes14] = ACTIONS(664),
    [anon_sym_bytes15] = ACTIONS(664),
    [anon_sym_bytes16] = ACTIONS(664),
    [anon_sym_bytes17] = ACTIONS(664),
    [anon_sym_bytes18] = ACTIONS(664),
    [anon_sym_bytes19] = ACTIONS(664),
    [anon_sym_bytes20] = ACTIONS(664),
    [anon_sym_bytes21] = ACTIONS(664),
    [anon_sym_bytes22] = ACTIONS(664),
    [anon_sym_bytes23] = ACTIONS(664),
    [anon_sym_bytes24] = ACTIONS(664),
    [anon_sym_bytes25] = ACTIONS(664),
    [anon_sym_bytes26] = ACTIONS(664),
    [anon_sym_bytes27] = ACTIONS(664),
    [anon_sym_bytes28] = ACTIONS(664),
    [anon_sym_bytes29] = ACTIONS(664),
    [anon_sym_bytes30] = ACTIONS(664),
    [anon_sym_bytes31] = ACTIONS(664),
    [anon_sym_bytes32] = ACTIONS(664),
    [anon_sym_fixed] = ACTIONS(664),
    [aux_sym__fixed_token1] = ACTIONS(664),
    [anon_sym_ufixed] = ACTIONS(664),
    [aux_sym__ufixed_token1] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
  },
  [148] = {
    [ts_builtin_sym_end] = ACTIONS(666),
    [sym_identifier] = ACTIONS(668),
    [anon_sym_pragma] = ACTIONS(668),
    [anon_sym_import] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_abstract] = ACTIONS(668),
    [anon_sym_contract] = ACTIONS(668),
    [anon_sym_error] = ACTIONS(668),
    [anon_sym_interface] = ACTIONS(668),
    [anon_sym_library] = ACTIONS(668),
    [anon_sym_struct] = ACTIONS(668),
    [anon_sym_enum] = ACTIONS(668),
    [anon_sym_event] = ACTIONS(668),
    [anon_sym_function] = ACTIONS(668),
    [anon_sym_byte] = ACTIONS(668),
    [anon_sym_address] = ACTIONS(668),
    [anon_sym_var] = ACTIONS(668),
    [anon_sym_mapping] = ACTIONS(668),
    [anon_sym_bool] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_int] = ACTIONS(668),
    [anon_sym_int8] = ACTIONS(668),
    [anon_sym_int16] = ACTIONS(668),
    [anon_sym_int24] = ACTIONS(668),
    [anon_sym_int32] = ACTIONS(668),
    [anon_sym_int40] = ACTIONS(668),
    [anon_sym_int48] = ACTIONS(668),
    [anon_sym_int56] = ACTIONS(668),
    [anon_sym_int64] = ACTIONS(668),
    [anon_sym_int72] = ACTIONS(668),
    [anon_sym_int80] = ACTIONS(668),
    [anon_sym_int88] = ACTIONS(668),
    [anon_sym_int96] = ACTIONS(668),
    [anon_sym_int104] = ACTIONS(668),
    [anon_sym_int112] = ACTIONS(668),
    [anon_sym_int120] = ACTIONS(668),
    [anon_sym_int128] = ACTIONS(668),
    [anon_sym_int136] = ACTIONS(668),
    [anon_sym_int144] = ACTIONS(668),
    [anon_sym_int152] = ACTIONS(668),
    [anon_sym_int160] = ACTIONS(668),
    [anon_sym_int168] = ACTIONS(668),
    [anon_sym_int176] = ACTIONS(668),
    [anon_sym_int184] = ACTIONS(668),
    [anon_sym_int192] = ACTIONS(668),
    [anon_sym_int200] = ACTIONS(668),
    [anon_sym_int208] = ACTIONS(668),
    [anon_sym_int216] = ACTIONS(668),
    [anon_sym_int224] = ACTIONS(668),
    [anon_sym_int232] = ACTIONS(668),
    [anon_sym_int240] = ACTIONS(668),
    [anon_sym_int248] = ACTIONS(668),
    [anon_sym_int256] = ACTIONS(668),
    [anon_sym_uint] = ACTIONS(668),
    [anon_sym_uint8] = ACTIONS(668),
    [anon_sym_uint16] = ACTIONS(668),
    [anon_sym_uint24] = ACTIONS(668),
    [anon_sym_uint32] = ACTIONS(668),
    [anon_sym_uint40] = ACTIONS(668),
    [anon_sym_uint48] = ACTIONS(668),
    [anon_sym_uint56] = ACTIONS(668),
    [anon_sym_uint64] = ACTIONS(668),
    [anon_sym_uint72] = ACTIONS(668),
    [anon_sym_uint80] = ACTIONS(668),
    [anon_sym_uint88] = ACTIONS(668),
    [anon_sym_uint96] = ACTIONS(668),
    [anon_sym_uint104] = ACTIONS(668),
    [anon_sym_uint112] = ACTIONS(668),
    [anon_sym_uint120] = ACTIONS(668),
    [anon_sym_uint128] = ACTIONS(668),
    [anon_sym_uint136] = ACTIONS(668),
    [anon_sym_uint144] = ACTIONS(668),
    [anon_sym_uint152] = ACTIONS(668),
    [anon_sym_uint160] = ACTIONS(668),
    [anon_sym_uint168] = ACTIONS(668),
    [anon_sym_uint176] = ACTIONS(668),
    [anon_sym_uint184] = ACTIONS(668),
    [anon_sym_uint192] = ACTIONS(668),
    [anon_sym_uint200] = ACTIONS(668),
    [anon_sym_uint208] = ACTIONS(668),
    [anon_sym_uint216] = ACTIONS(668),
    [anon_sym_uint224] = ACTIONS(668),
    [anon_sym_uint232] = ACTIONS(668),
    [anon_sym_uint240] = ACTIONS(668),
    [anon_sym_uint248] = ACTIONS(668),
    [anon_sym_uint256] = ACTIONS(668),
    [anon_sym_bytes] = ACTIONS(668),
    [anon_sym_bytes1] = ACTIONS(668),
    [anon_sym_bytes2] = ACTIONS(668),
    [anon_sym_bytes3] = ACTIONS(668),
    [anon_sym_bytes4] = ACTIONS(668),
    [anon_sym_bytes5] = ACTIONS(668),
    [anon_sym_bytes6] = ACTIONS(668),
    [anon_sym_bytes7] = ACTIONS(668),
    [anon_sym_bytes8] = ACTIONS(668),
    [anon_sym_bytes9] = ACTIONS(668),
    [anon_sym_bytes10] = ACTIONS(668),
    [anon_sym_bytes11] = ACTIONS(668),
    [anon_sym_bytes12] = ACTIONS(668),
    [anon_sym_bytes13] = ACTIONS(668),
    [anon_sym_bytes14] = ACTIONS(668),
    [anon_sym_bytes15] = ACTIONS(668),
    [anon_sym_bytes16] = ACTIONS(668),
    [anon_sym_bytes17] = ACTIONS(668),
    [anon_sym_bytes18] = ACTIONS(668),
    [anon_sym_bytes19] = ACTIONS(668),
    [anon_sym_bytes20] = ACTIONS(668),
    [anon_sym_bytes21] = ACTIONS(668),
    [anon_sym_bytes22] = ACTIONS(668),
    [anon_sym_bytes23] = ACTIONS(668),
    [anon_sym_bytes24] = ACTIONS(668),
    [anon_sym_bytes25] = ACTIONS(668),
    [anon_sym_bytes26] = ACTIONS(668),
    [anon_sym_bytes27] = ACTIONS(668),
    [anon_sym_bytes28] = ACTIONS(668),
    [anon_sym_bytes29] = ACTIONS(668),
    [anon_sym_bytes30] = ACTIONS(668),
    [anon_sym_bytes31] = ACTIONS(668),
    [anon_sym_bytes32] = ACTIONS(668),
    [anon_sym_fixed] = ACTIONS(668),
    [aux_sym__fixed_token1] = ACTIONS(668),
    [anon_sym_ufixed] = ACTIONS(668),
    [aux_sym__ufixed_token1] = ACTIONS(668),
    [sym_comment] = ACTIONS(3),
  },
  [149] = {
    [ts_builtin_sym_end] = ACTIONS(670),
    [sym_identifier] = ACTIONS(672),
    [anon_sym_pragma] = ACTIONS(672),
    [anon_sym_import] = ACTIONS(672),
    [anon_sym_type] = ACTIONS(672),
    [anon_sym_abstract] = ACTIONS(672),
    [anon_sym_contract] = ACTIONS(672),
    [anon_sym_error] = ACTIONS(672),
    [anon_sym_interface] = ACTIONS(672),
    [anon_sym_library] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(672),
    [anon_sym_enum] = ACTIONS(672),
    [anon_sym_event] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(672),
    [anon_sym_byte] = ACTIONS(672),
    [anon_sym_address] = ACTIONS(672),
    [anon_sym_var] = ACTIONS(672),
    [anon_sym_mapping] = ACTIONS(672),
    [anon_sym_bool] = ACTIONS(672),
    [anon_sym_string] = ACTIONS(672),
    [anon_sym_int] = ACTIONS(672),
    [anon_sym_int8] = ACTIONS(672),
    [anon_sym_int16] = ACTIONS(672),
    [anon_sym_int24] = ACTIONS(672),
    [anon_sym_int32] = ACTIONS(672),
    [anon_sym_int40] = ACTIONS(672),
    [anon_sym_int48] = ACTIONS(672),
    [anon_sym_int56] = ACTIONS(672),
    [anon_sym_int64] = ACTIONS(672),
    [anon_sym_int72] = ACTIONS(672),
    [anon_sym_int80] = ACTIONS(672),
    [anon_sym_int88] = ACTIONS(672),
    [anon_sym_int96] = ACTIONS(672),
    [anon_sym_int104] = ACTIONS(672),
    [anon_sym_int112] = ACTIONS(672),
    [anon_sym_int120] = ACTIONS(672),
    [anon_sym_int128] = ACTIONS(672),
    [anon_sym_int136] = ACTIONS(672),
    [anon_sym_int144] = ACTIONS(672),
    [anon_sym_int152] = ACTIONS(672),
    [anon_sym_int160] = ACTIONS(672),
    [anon_sym_int168] = ACTIONS(672),
    [anon_sym_int176] = ACTIONS(672),
    [anon_sym_int184] = ACTIONS(672),
    [anon_sym_int192] = ACTIONS(672),
    [anon_sym_int200] = ACTIONS(672),
    [anon_sym_int208] = ACTIONS(672),
    [anon_sym_int216] = ACTIONS(672),
    [anon_sym_int224] = ACTIONS(672),
    [anon_sym_int232] = ACTIONS(672),
    [anon_sym_int240] = ACTIONS(672),
    [anon_sym_int248] = ACTIONS(672),
    [anon_sym_int256] = ACTIONS(672),
    [anon_sym_uint] = ACTIONS(672),
    [anon_sym_uint8] = ACTIONS(672),
    [anon_sym_uint16] = ACTIONS(672),
    [anon_sym_uint24] = ACTIONS(672),
    [anon_sym_uint32] = ACTIONS(672),
    [anon_sym_uint40] = ACTIONS(672),
    [anon_sym_uint48] = ACTIONS(672),
    [anon_sym_uint56] = ACTIONS(672),
    [anon_sym_uint64] = ACTIONS(672),
    [anon_sym_uint72] = ACTIONS(672),
    [anon_sym_uint80] = ACTIONS(672),
    [anon_sym_uint88] = ACTIONS(672),
    [anon_sym_uint96] = ACTIONS(672),
    [anon_sym_uint104] = ACTIONS(672),
    [anon_sym_uint112] = ACTIONS(672),
    [anon_sym_uint120] = ACTIONS(672),
    [anon_sym_uint128] = ACTIONS(672),
    [anon_sym_uint136] = ACTIONS(672),
    [anon_sym_uint144] = ACTIONS(672),
    [anon_sym_uint152] = ACTIONS(672),
    [anon_sym_uint160] = ACTIONS(672),
    [anon_sym_uint168] = ACTIONS(672),
    [anon_sym_uint176] = ACTIONS(672),
    [anon_sym_uint184] = ACTIONS(672),
    [anon_sym_uint192] = ACTIONS(672),
    [anon_sym_uint200] = ACTIONS(672),
    [anon_sym_uint208] = ACTIONS(672),
    [anon_sym_uint216] = ACTIONS(672),
    [anon_sym_uint224] = ACTIONS(672),
    [anon_sym_uint232] = ACTIONS(672),
    [anon_sym_uint240] = ACTIONS(672),
    [anon_sym_uint248] = ACTIONS(672),
    [anon_sym_uint256] = ACTIONS(672),
    [anon_sym_bytes] = ACTIONS(672),
    [anon_sym_bytes1] = ACTIONS(672),
    [anon_sym_bytes2] = ACTIONS(672),
    [anon_sym_bytes3] = ACTIONS(672),
    [anon_sym_bytes4] = ACTIONS(672),
    [anon_sym_bytes5] = ACTIONS(672),
    [anon_sym_bytes6] = ACTIONS(672),
    [anon_sym_bytes7] = ACTIONS(672),
    [anon_sym_bytes8] = ACTIONS(672),
    [anon_sym_bytes9] = ACTIONS(672),
    [anon_sym_bytes10] = ACTIONS(672),
    [anon_sym_bytes11] = ACTIONS(672),
    [anon_sym_bytes12] = ACTIONS(672),
    [anon_sym_bytes13] = ACTIONS(672),
    [anon_sym_bytes14] = ACTIONS(672),
    [anon_sym_bytes15] = ACTIONS(672),
    [anon_sym_bytes16] = ACTIONS(672),
    [anon_sym_bytes17] = ACTIONS(672),
    [anon_sym_bytes18] = ACTIONS(672),
    [anon_sym_bytes19] = ACTIONS(672),
    [anon_sym_bytes20] = ACTIONS(672),
    [anon_sym_bytes21] = ACTIONS(672),
    [anon_sym_bytes22] = ACTIONS(672),
    [anon_sym_bytes23] = ACTIONS(672),
    [anon_sym_bytes24] = ACTIONS(672),
    [anon_sym_bytes25] = ACTIONS(672),
    [anon_sym_bytes26] = ACTIONS(672),
    [anon_sym_bytes27] = ACTIONS(672),
    [anon_sym_bytes28] = ACTIONS(672),
    [anon_sym_bytes29] = ACTIONS(672),
    [anon_sym_bytes30] = ACTIONS(672),
    [anon_sym_bytes31] = ACTIONS(672),
    [anon_sym_bytes32] = ACTIONS(672),
    [anon_sym_fixed] = ACTIONS(672),
    [aux_sym__fixed_token1] = ACTIONS(672),
    [anon_sym_ufixed] = ACTIONS(672),
    [aux_sym__ufixed_token1] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
  },
  [150] = {
    [ts_builtin_sym_end] = ACTIONS(674),
    [sym_identifier] = ACTIONS(676),
    [anon_sym_pragma] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(676),
    [anon_sym_type] = ACTIONS(676),
    [anon_sym_abstract] = ACTIONS(676),
    [anon_sym_contract] = ACTIONS(676),
    [anon_sym_error] = ACTIONS(676),
    [anon_sym_interface] = ACTIONS(676),
    [anon_sym_library] = ACTIONS(676),
    [anon_sym_struct] = ACTIONS(676),
    [anon_sym_enum] = ACTIONS(676),
    [anon_sym_event] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(676),
    [anon_sym_byte] = ACTIONS(676),
    [anon_sym_address] = ACTIONS(676),
    [anon_sym_var] = ACTIONS(676),
    [anon_sym_mapping] = ACTIONS(676),
    [anon_sym_bool] = ACTIONS(676),
    [anon_sym_string] = ACTIONS(676),
    [anon_sym_int] = ACTIONS(676),
    [anon_sym_int8] = ACTIONS(676),
    [anon_sym_int16] = ACTIONS(676),
    [anon_sym_int24] = ACTIONS(676),
    [anon_sym_int32] = ACTIONS(676),
    [anon_sym_int40] = ACTIONS(676),
    [anon_sym_int48] = ACTIONS(676),
    [anon_sym_int56] = ACTIONS(676),
    [anon_sym_int64] = ACTIONS(676),
    [anon_sym_int72] = ACTIONS(676),
    [anon_sym_int80] = ACTIONS(676),
    [anon_sym_int88] = ACTIONS(676),
    [anon_sym_int96] = ACTIONS(676),
    [anon_sym_int104] = ACTIONS(676),
    [anon_sym_int112] = ACTIONS(676),
    [anon_sym_int120] = ACTIONS(676),
    [anon_sym_int128] = ACTIONS(676),
    [anon_sym_int136] = ACTIONS(676),
    [anon_sym_int144] = ACTIONS(676),
    [anon_sym_int152] = ACTIONS(676),
    [anon_sym_int160] = ACTIONS(676),
    [anon_sym_int168] = ACTIONS(676),
    [anon_sym_int176] = ACTIONS(676),
    [anon_sym_int184] = ACTIONS(676),
    [anon_sym_int192] = ACTIONS(676),
    [anon_sym_int200] = ACTIONS(676),
    [anon_sym_int208] = ACTIONS(676),
    [anon_sym_int216] = ACTIONS(676),
    [anon_sym_int224] = ACTIONS(676),
    [anon_sym_int232] = ACTIONS(676),
    [anon_sym_int240] = ACTIONS(676),
    [anon_sym_int248] = ACTIONS(676),
    [anon_sym_int256] = ACTIONS(676),
    [anon_sym_uint] = ACTIONS(676),
    [anon_sym_uint8] = ACTIONS(676),
    [anon_sym_uint16] = ACTIONS(676),
    [anon_sym_uint24] = ACTIONS(676),
    [anon_sym_uint32] = ACTIONS(676),
    [anon_sym_uint40] = ACTIONS(676),
    [anon_sym_uint48] = ACTIONS(676),
    [anon_sym_uint56] = ACTIONS(676),
    [anon_sym_uint64] = ACTIONS(676),
    [anon_sym_uint72] = ACTIONS(676),
    [anon_sym_uint80] = ACTIONS(676),
    [anon_sym_uint88] = ACTIONS(676),
    [anon_sym_uint96] = ACTIONS(676),
    [anon_sym_uint104] = ACTIONS(676),
    [anon_sym_uint112] = ACTIONS(676),
    [anon_sym_uint120] = ACTIONS(676),
    [anon_sym_uint128] = ACTIONS(676),
    [anon_sym_uint136] = ACTIONS(676),
    [anon_sym_uint144] = ACTIONS(676),
    [anon_sym_uint152] = ACTIONS(676),
    [anon_sym_uint160] = ACTIONS(676),
    [anon_sym_uint168] = ACTIONS(676),
    [anon_sym_uint176] = ACTIONS(676),
    [anon_sym_uint184] = ACTIONS(676),
    [anon_sym_uint192] = ACTIONS(676),
    [anon_sym_uint200] = ACTIONS(676),
    [anon_sym_uint208] = ACTIONS(676),
    [anon_sym_uint216] = ACTIONS(676),
    [anon_sym_uint224] = ACTIONS(676),
    [anon_sym_uint232] = ACTIONS(676),
    [anon_sym_uint240] = ACTIONS(676),
    [anon_sym_uint248] = ACTIONS(676),
    [anon_sym_uint256] = ACTIONS(676),
    [anon_sym_bytes] = ACTIONS(676),
    [anon_sym_bytes1] = ACTIONS(676),
    [anon_sym_bytes2] = ACTIONS(676),
    [anon_sym_bytes3] = ACTIONS(676),
    [anon_sym_bytes4] = ACTIONS(676),
    [anon_sym_bytes5] = ACTIONS(676),
    [anon_sym_bytes6] = ACTIONS(676),
    [anon_sym_bytes7] = ACTIONS(676),
    [anon_sym_bytes8] = ACTIONS(676),
    [anon_sym_bytes9] = ACTIONS(676),
    [anon_sym_bytes10] = ACTIONS(676),
    [anon_sym_bytes11] = ACTIONS(676),
    [anon_sym_bytes12] = ACTIONS(676),
    [anon_sym_bytes13] = ACTIONS(676),
    [anon_sym_bytes14] = ACTIONS(676),
    [anon_sym_bytes15] = ACTIONS(676),
    [anon_sym_bytes16] = ACTIONS(676),
    [anon_sym_bytes17] = ACTIONS(676),
    [anon_sym_bytes18] = ACTIONS(676),
    [anon_sym_bytes19] = ACTIONS(676),
    [anon_sym_bytes20] = ACTIONS(676),
    [anon_sym_bytes21] = ACTIONS(676),
    [anon_sym_bytes22] = ACTIONS(676),
    [anon_sym_bytes23] = ACTIONS(676),
    [anon_sym_bytes24] = ACTIONS(676),
    [anon_sym_bytes25] = ACTIONS(676),
    [anon_sym_bytes26] = ACTIONS(676),
    [anon_sym_bytes27] = ACTIONS(676),
    [anon_sym_bytes28] = ACTIONS(676),
    [anon_sym_bytes29] = ACTIONS(676),
    [anon_sym_bytes30] = ACTIONS(676),
    [anon_sym_bytes31] = ACTIONS(676),
    [anon_sym_bytes32] = ACTIONS(676),
    [anon_sym_fixed] = ACTIONS(676),
    [aux_sym__fixed_token1] = ACTIONS(676),
    [anon_sym_ufixed] = ACTIONS(676),
    [aux_sym__ufixed_token1] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [ts_builtin_sym_end] = ACTIONS(678),
    [sym_identifier] = ACTIONS(680),
    [anon_sym_pragma] = ACTIONS(680),
    [anon_sym_import] = ACTIONS(680),
    [anon_sym_type] = ACTIONS(680),
    [anon_sym_abstract] = ACTIONS(680),
    [anon_sym_contract] = ACTIONS(680),
    [anon_sym_error] = ACTIONS(680),
    [anon_sym_interface] = ACTIONS(680),
    [anon_sym_library] = ACTIONS(680),
    [anon_sym_struct] = ACTIONS(680),
    [anon_sym_enum] = ACTIONS(680),
    [anon_sym_event] = ACTIONS(680),
    [anon_sym_function] = ACTIONS(680),
    [anon_sym_byte] = ACTIONS(680),
    [anon_sym_address] = ACTIONS(680),
    [anon_sym_var] = ACTIONS(680),
    [anon_sym_mapping] = ACTIONS(680),
    [anon_sym_bool] = ACTIONS(680),
    [anon_sym_string] = ACTIONS(680),
    [anon_sym_int] = ACTIONS(680),
    [anon_sym_int8] = ACTIONS(680),
    [anon_sym_int16] = ACTIONS(680),
    [anon_sym_int24] = ACTIONS(680),
    [anon_sym_int32] = ACTIONS(680),
    [anon_sym_int40] = ACTIONS(680),
    [anon_sym_int48] = ACTIONS(680),
    [anon_sym_int56] = ACTIONS(680),
    [anon_sym_int64] = ACTIONS(680),
    [anon_sym_int72] = ACTIONS(680),
    [anon_sym_int80] = ACTIONS(680),
    [anon_sym_int88] = ACTIONS(680),
    [anon_sym_int96] = ACTIONS(680),
    [anon_sym_int104] = ACTIONS(680),
    [anon_sym_int112] = ACTIONS(680),
    [anon_sym_int120] = ACTIONS(680),
    [anon_sym_int128] = ACTIONS(680),
    [anon_sym_int136] = ACTIONS(680),
    [anon_sym_int144] = ACTIONS(680),
    [anon_sym_int152] = ACTIONS(680),
    [anon_sym_int160] = ACTIONS(680),
    [anon_sym_int168] = ACTIONS(680),
    [anon_sym_int176] = ACTIONS(680),
    [anon_sym_int184] = ACTIONS(680),
    [anon_sym_int192] = ACTIONS(680),
    [anon_sym_int200] = ACTIONS(680),
    [anon_sym_int208] = ACTIONS(680),
    [anon_sym_int216] = ACTIONS(680),
    [anon_sym_int224] = ACTIONS(680),
    [anon_sym_int232] = ACTIONS(680),
    [anon_sym_int240] = ACTIONS(680),
    [anon_sym_int248] = ACTIONS(680),
    [anon_sym_int256] = ACTIONS(680),
    [anon_sym_uint] = ACTIONS(680),
    [anon_sym_uint8] = ACTIONS(680),
    [anon_sym_uint16] = ACTIONS(680),
    [anon_sym_uint24] = ACTIONS(680),
    [anon_sym_uint32] = ACTIONS(680),
    [anon_sym_uint40] = ACTIONS(680),
    [anon_sym_uint48] = ACTIONS(680),
    [anon_sym_uint56] = ACTIONS(680),
    [anon_sym_uint64] = ACTIONS(680),
    [anon_sym_uint72] = ACTIONS(680),
    [anon_sym_uint80] = ACTIONS(680),
    [anon_sym_uint88] = ACTIONS(680),
    [anon_sym_uint96] = ACTIONS(680),
    [anon_sym_uint104] = ACTIONS(680),
    [anon_sym_uint112] = ACTIONS(680),
    [anon_sym_uint120] = ACTIONS(680),
    [anon_sym_uint128] = ACTIONS(680),
    [anon_sym_uint136] = ACTIONS(680),
    [anon_sym_uint144] = ACTIONS(680),
    [anon_sym_uint152] = ACTIONS(680),
    [anon_sym_uint160] = ACTIONS(680),
    [anon_sym_uint168] = ACTIONS(680),
    [anon_sym_uint176] = ACTIONS(680),
    [anon_sym_uint184] = ACTIONS(680),
    [anon_sym_uint192] = ACTIONS(680),
    [anon_sym_uint200] = ACTIONS(680),
    [anon_sym_uint208] = ACTIONS(680),
    [anon_sym_uint216] = ACTIONS(680),
    [anon_sym_uint224] = ACTIONS(680),
    [anon_sym_uint232] = ACTIONS(680),
    [anon_sym_uint240] = ACTIONS(680),
    [anon_sym_uint248] = ACTIONS(680),
    [anon_sym_uint256] = ACTIONS(680),
    [anon_sym_bytes] = ACTIONS(680),
    [anon_sym_bytes1] = ACTIONS(680),
    [anon_sym_bytes2] = ACTIONS(680),
    [anon_sym_bytes3] = ACTIONS(680),
    [anon_sym_bytes4] = ACTIONS(680),
    [anon_sym_bytes5] = ACTIONS(680),
    [anon_sym_bytes6] = ACTIONS(680),
    [anon_sym_bytes7] = ACTIONS(680),
    [anon_sym_bytes8] = ACTIONS(680),
    [anon_sym_bytes9] = ACTIONS(680),
    [anon_sym_bytes10] = ACTIONS(680),
    [anon_sym_bytes11] = ACTIONS(680),
    [anon_sym_bytes12] = ACTIONS(680),
    [anon_sym_bytes13] = ACTIONS(680),
    [anon_sym_bytes14] = ACTIONS(680),
    [anon_sym_bytes15] = ACTIONS(680),
    [anon_sym_bytes16] = ACTIONS(680),
    [anon_sym_bytes17] = ACTIONS(680),
    [anon_sym_bytes18] = ACTIONS(680),
    [anon_sym_bytes19] = ACTIONS(680),
    [anon_sym_bytes20] = ACTIONS(680),
    [anon_sym_bytes21] = ACTIONS(680),
    [anon_sym_bytes22] = ACTIONS(680),
    [anon_sym_bytes23] = ACTIONS(680),
    [anon_sym_bytes24] = ACTIONS(680),
    [anon_sym_bytes25] = ACTIONS(680),
    [anon_sym_bytes26] = ACTIONS(680),
    [anon_sym_bytes27] = ACTIONS(680),
    [anon_sym_bytes28] = ACTIONS(680),
    [anon_sym_bytes29] = ACTIONS(680),
    [anon_sym_bytes30] = ACTIONS(680),
    [anon_sym_bytes31] = ACTIONS(680),
    [anon_sym_bytes32] = ACTIONS(680),
    [anon_sym_fixed] = ACTIONS(680),
    [aux_sym__fixed_token1] = ACTIONS(680),
    [anon_sym_ufixed] = ACTIONS(680),
    [aux_sym__ufixed_token1] = ACTIONS(680),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [ts_builtin_sym_end] = ACTIONS(682),
    [sym_identifier] = ACTIONS(684),
    [anon_sym_pragma] = ACTIONS(684),
    [anon_sym_import] = ACTIONS(684),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_abstract] = ACTIONS(684),
    [anon_sym_contract] = ACTIONS(684),
    [anon_sym_error] = ACTIONS(684),
    [anon_sym_interface] = ACTIONS(684),
    [anon_sym_library] = ACTIONS(684),
    [anon_sym_struct] = ACTIONS(684),
    [anon_sym_enum] = ACTIONS(684),
    [anon_sym_event] = ACTIONS(684),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_byte] = ACTIONS(684),
    [anon_sym_address] = ACTIONS(684),
    [anon_sym_var] = ACTIONS(684),
    [anon_sym_mapping] = ACTIONS(684),
    [anon_sym_bool] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_int] = ACTIONS(684),
    [anon_sym_int8] = ACTIONS(684),
    [anon_sym_int16] = ACTIONS(684),
    [anon_sym_int24] = ACTIONS(684),
    [anon_sym_int32] = ACTIONS(684),
    [anon_sym_int40] = ACTIONS(684),
    [anon_sym_int48] = ACTIONS(684),
    [anon_sym_int56] = ACTIONS(684),
    [anon_sym_int64] = ACTIONS(684),
    [anon_sym_int72] = ACTIONS(684),
    [anon_sym_int80] = ACTIONS(684),
    [anon_sym_int88] = ACTIONS(684),
    [anon_sym_int96] = ACTIONS(684),
    [anon_sym_int104] = ACTIONS(684),
    [anon_sym_int112] = ACTIONS(684),
    [anon_sym_int120] = ACTIONS(684),
    [anon_sym_int128] = ACTIONS(684),
    [anon_sym_int136] = ACTIONS(684),
    [anon_sym_int144] = ACTIONS(684),
    [anon_sym_int152] = ACTIONS(684),
    [anon_sym_int160] = ACTIONS(684),
    [anon_sym_int168] = ACTIONS(684),
    [anon_sym_int176] = ACTIONS(684),
    [anon_sym_int184] = ACTIONS(684),
    [anon_sym_int192] = ACTIONS(684),
    [anon_sym_int200] = ACTIONS(684),
    [anon_sym_int208] = ACTIONS(684),
    [anon_sym_int216] = ACTIONS(684),
    [anon_sym_int224] = ACTIONS(684),
    [anon_sym_int232] = ACTIONS(684),
    [anon_sym_int240] = ACTIONS(684),
    [anon_sym_int248] = ACTIONS(684),
    [anon_sym_int256] = ACTIONS(684),
    [anon_sym_uint] = ACTIONS(684),
    [anon_sym_uint8] = ACTIONS(684),
    [anon_sym_uint16] = ACTIONS(684),
    [anon_sym_uint24] = ACTIONS(684),
    [anon_sym_uint32] = ACTIONS(684),
    [anon_sym_uint40] = ACTIONS(684),
    [anon_sym_uint48] = ACTIONS(684),
    [anon_sym_uint56] = ACTIONS(684),
    [anon_sym_uint64] = ACTIONS(684),
    [anon_sym_uint72] = ACTIONS(684),
    [anon_sym_uint80] = ACTIONS(684),
    [anon_sym_uint88] = ACTIONS(684),
    [anon_sym_uint96] = ACTIONS(684),
    [anon_sym_uint104] = ACTIONS(684),
    [anon_sym_uint112] = ACTIONS(684),
    [anon_sym_uint120] = ACTIONS(684),
    [anon_sym_uint128] = ACTIONS(684),
    [anon_sym_uint136] = ACTIONS(684),
    [anon_sym_uint144] = ACTIONS(684),
    [anon_sym_uint152] = ACTIONS(684),
    [anon_sym_uint160] = ACTIONS(684),
    [anon_sym_uint168] = ACTIONS(684),
    [anon_sym_uint176] = ACTIONS(684),
    [anon_sym_uint184] = ACTIONS(684),
    [anon_sym_uint192] = ACTIONS(684),
    [anon_sym_uint200] = ACTIONS(684),
    [anon_sym_uint208] = ACTIONS(684),
    [anon_sym_uint216] = ACTIONS(684),
    [anon_sym_uint224] = ACTIONS(684),
    [anon_sym_uint232] = ACTIONS(684),
    [anon_sym_uint240] = ACTIONS(684),
    [anon_sym_uint248] = ACTIONS(684),
    [anon_sym_uint256] = ACTIONS(684),
    [anon_sym_bytes] = ACTIONS(684),
    [anon_sym_bytes1] = ACTIONS(684),
    [anon_sym_bytes2] = ACTIONS(684),
    [anon_sym_bytes3] = ACTIONS(684),
    [anon_sym_bytes4] = ACTIONS(684),
    [anon_sym_bytes5] = ACTIONS(684),
    [anon_sym_bytes6] = ACTIONS(684),
    [anon_sym_bytes7] = ACTIONS(684),
    [anon_sym_bytes8] = ACTIONS(684),
    [anon_sym_bytes9] = ACTIONS(684),
    [anon_sym_bytes10] = ACTIONS(684),
    [anon_sym_bytes11] = ACTIONS(684),
    [anon_sym_bytes12] = ACTIONS(684),
    [anon_sym_bytes13] = ACTIONS(684),
    [anon_sym_bytes14] = ACTIONS(684),
    [anon_sym_bytes15] = ACTIONS(684),
    [anon_sym_bytes16] = ACTIONS(684),
    [anon_sym_bytes17] = ACTIONS(684),
    [anon_sym_bytes18] = ACTIONS(684),
    [anon_sym_bytes19] = ACTIONS(684),
    [anon_sym_bytes20] = ACTIONS(684),
    [anon_sym_bytes21] = ACTIONS(684),
    [anon_sym_bytes22] = ACTIONS(684),
    [anon_sym_bytes23] = ACTIONS(684),
    [anon_sym_bytes24] = ACTIONS(684),
    [anon_sym_bytes25] = ACTIONS(684),
    [anon_sym_bytes26] = ACTIONS(684),
    [anon_sym_bytes27] = ACTIONS(684),
    [anon_sym_bytes28] = ACTIONS(684),
    [anon_sym_bytes29] = ACTIONS(684),
    [anon_sym_bytes30] = ACTIONS(684),
    [anon_sym_bytes31] = ACTIONS(684),
    [anon_sym_bytes32] = ACTIONS(684),
    [anon_sym_fixed] = ACTIONS(684),
    [aux_sym__fixed_token1] = ACTIONS(684),
    [anon_sym_ufixed] = ACTIONS(684),
    [aux_sym__ufixed_token1] = ACTIONS(684),
    [sym_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_type_name] = STATE(360),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(686),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [154] = {
    [ts_builtin_sym_end] = ACTIONS(688),
    [sym_identifier] = ACTIONS(690),
    [anon_sym_pragma] = ACTIONS(690),
    [anon_sym_import] = ACTIONS(690),
    [anon_sym_type] = ACTIONS(690),
    [anon_sym_abstract] = ACTIONS(690),
    [anon_sym_contract] = ACTIONS(690),
    [anon_sym_error] = ACTIONS(690),
    [anon_sym_interface] = ACTIONS(690),
    [anon_sym_library] = ACTIONS(690),
    [anon_sym_struct] = ACTIONS(690),
    [anon_sym_enum] = ACTIONS(690),
    [anon_sym_event] = ACTIONS(690),
    [anon_sym_function] = ACTIONS(690),
    [anon_sym_byte] = ACTIONS(690),
    [anon_sym_address] = ACTIONS(690),
    [anon_sym_var] = ACTIONS(690),
    [anon_sym_mapping] = ACTIONS(690),
    [anon_sym_bool] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_int] = ACTIONS(690),
    [anon_sym_int8] = ACTIONS(690),
    [anon_sym_int16] = ACTIONS(690),
    [anon_sym_int24] = ACTIONS(690),
    [anon_sym_int32] = ACTIONS(690),
    [anon_sym_int40] = ACTIONS(690),
    [anon_sym_int48] = ACTIONS(690),
    [anon_sym_int56] = ACTIONS(690),
    [anon_sym_int64] = ACTIONS(690),
    [anon_sym_int72] = ACTIONS(690),
    [anon_sym_int80] = ACTIONS(690),
    [anon_sym_int88] = ACTIONS(690),
    [anon_sym_int96] = ACTIONS(690),
    [anon_sym_int104] = ACTIONS(690),
    [anon_sym_int112] = ACTIONS(690),
    [anon_sym_int120] = ACTIONS(690),
    [anon_sym_int128] = ACTIONS(690),
    [anon_sym_int136] = ACTIONS(690),
    [anon_sym_int144] = ACTIONS(690),
    [anon_sym_int152] = ACTIONS(690),
    [anon_sym_int160] = ACTIONS(690),
    [anon_sym_int168] = ACTIONS(690),
    [anon_sym_int176] = ACTIONS(690),
    [anon_sym_int184] = ACTIONS(690),
    [anon_sym_int192] = ACTIONS(690),
    [anon_sym_int200] = ACTIONS(690),
    [anon_sym_int208] = ACTIONS(690),
    [anon_sym_int216] = ACTIONS(690),
    [anon_sym_int224] = ACTIONS(690),
    [anon_sym_int232] = ACTIONS(690),
    [anon_sym_int240] = ACTIONS(690),
    [anon_sym_int248] = ACTIONS(690),
    [anon_sym_int256] = ACTIONS(690),
    [anon_sym_uint] = ACTIONS(690),
    [anon_sym_uint8] = ACTIONS(690),
    [anon_sym_uint16] = ACTIONS(690),
    [anon_sym_uint24] = ACTIONS(690),
    [anon_sym_uint32] = ACTIONS(690),
    [anon_sym_uint40] = ACTIONS(690),
    [anon_sym_uint48] = ACTIONS(690),
    [anon_sym_uint56] = ACTIONS(690),
    [anon_sym_uint64] = ACTIONS(690),
    [anon_sym_uint72] = ACTIONS(690),
    [anon_sym_uint80] = ACTIONS(690),
    [anon_sym_uint88] = ACTIONS(690),
    [anon_sym_uint96] = ACTIONS(690),
    [anon_sym_uint104] = ACTIONS(690),
    [anon_sym_uint112] = ACTIONS(690),
    [anon_sym_uint120] = ACTIONS(690),
    [anon_sym_uint128] = ACTIONS(690),
    [anon_sym_uint136] = ACTIONS(690),
    [anon_sym_uint144] = ACTIONS(690),
    [anon_sym_uint152] = ACTIONS(690),
    [anon_sym_uint160] = ACTIONS(690),
    [anon_sym_uint168] = ACTIONS(690),
    [anon_sym_uint176] = ACTIONS(690),
    [anon_sym_uint184] = ACTIONS(690),
    [anon_sym_uint192] = ACTIONS(690),
    [anon_sym_uint200] = ACTIONS(690),
    [anon_sym_uint208] = ACTIONS(690),
    [anon_sym_uint216] = ACTIONS(690),
    [anon_sym_uint224] = ACTIONS(690),
    [anon_sym_uint232] = ACTIONS(690),
    [anon_sym_uint240] = ACTIONS(690),
    [anon_sym_uint248] = ACTIONS(690),
    [anon_sym_uint256] = ACTIONS(690),
    [anon_sym_bytes] = ACTIONS(690),
    [anon_sym_bytes1] = ACTIONS(690),
    [anon_sym_bytes2] = ACTIONS(690),
    [anon_sym_bytes3] = ACTIONS(690),
    [anon_sym_bytes4] = ACTIONS(690),
    [anon_sym_bytes5] = ACTIONS(690),
    [anon_sym_bytes6] = ACTIONS(690),
    [anon_sym_bytes7] = ACTIONS(690),
    [anon_sym_bytes8] = ACTIONS(690),
    [anon_sym_bytes9] = ACTIONS(690),
    [anon_sym_bytes10] = ACTIONS(690),
    [anon_sym_bytes11] = ACTIONS(690),
    [anon_sym_bytes12] = ACTIONS(690),
    [anon_sym_bytes13] = ACTIONS(690),
    [anon_sym_bytes14] = ACTIONS(690),
    [anon_sym_bytes15] = ACTIONS(690),
    [anon_sym_bytes16] = ACTIONS(690),
    [anon_sym_bytes17] = ACTIONS(690),
    [anon_sym_bytes18] = ACTIONS(690),
    [anon_sym_bytes19] = ACTIONS(690),
    [anon_sym_bytes20] = ACTIONS(690),
    [anon_sym_bytes21] = ACTIONS(690),
    [anon_sym_bytes22] = ACTIONS(690),
    [anon_sym_bytes23] = ACTIONS(690),
    [anon_sym_bytes24] = ACTIONS(690),
    [anon_sym_bytes25] = ACTIONS(690),
    [anon_sym_bytes26] = ACTIONS(690),
    [anon_sym_bytes27] = ACTIONS(690),
    [anon_sym_bytes28] = ACTIONS(690),
    [anon_sym_bytes29] = ACTIONS(690),
    [anon_sym_bytes30] = ACTIONS(690),
    [anon_sym_bytes31] = ACTIONS(690),
    [anon_sym_bytes32] = ACTIONS(690),
    [anon_sym_fixed] = ACTIONS(690),
    [aux_sym__fixed_token1] = ACTIONS(690),
    [anon_sym_ufixed] = ACTIONS(690),
    [aux_sym__ufixed_token1] = ACTIONS(690),
    [sym_comment] = ACTIONS(3),
  },
  [155] = {
    [ts_builtin_sym_end] = ACTIONS(692),
    [sym_identifier] = ACTIONS(694),
    [anon_sym_pragma] = ACTIONS(694),
    [anon_sym_import] = ACTIONS(694),
    [anon_sym_type] = ACTIONS(694),
    [anon_sym_abstract] = ACTIONS(694),
    [anon_sym_contract] = ACTIONS(694),
    [anon_sym_error] = ACTIONS(694),
    [anon_sym_interface] = ACTIONS(694),
    [anon_sym_library] = ACTIONS(694),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_enum] = ACTIONS(694),
    [anon_sym_event] = ACTIONS(694),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_byte] = ACTIONS(694),
    [anon_sym_address] = ACTIONS(694),
    [anon_sym_var] = ACTIONS(694),
    [anon_sym_mapping] = ACTIONS(694),
    [anon_sym_bool] = ACTIONS(694),
    [anon_sym_string] = ACTIONS(694),
    [anon_sym_int] = ACTIONS(694),
    [anon_sym_int8] = ACTIONS(694),
    [anon_sym_int16] = ACTIONS(694),
    [anon_sym_int24] = ACTIONS(694),
    [anon_sym_int32] = ACTIONS(694),
    [anon_sym_int40] = ACTIONS(694),
    [anon_sym_int48] = ACTIONS(694),
    [anon_sym_int56] = ACTIONS(694),
    [anon_sym_int64] = ACTIONS(694),
    [anon_sym_int72] = ACTIONS(694),
    [anon_sym_int80] = ACTIONS(694),
    [anon_sym_int88] = ACTIONS(694),
    [anon_sym_int96] = ACTIONS(694),
    [anon_sym_int104] = ACTIONS(694),
    [anon_sym_int112] = ACTIONS(694),
    [anon_sym_int120] = ACTIONS(694),
    [anon_sym_int128] = ACTIONS(694),
    [anon_sym_int136] = ACTIONS(694),
    [anon_sym_int144] = ACTIONS(694),
    [anon_sym_int152] = ACTIONS(694),
    [anon_sym_int160] = ACTIONS(694),
    [anon_sym_int168] = ACTIONS(694),
    [anon_sym_int176] = ACTIONS(694),
    [anon_sym_int184] = ACTIONS(694),
    [anon_sym_int192] = ACTIONS(694),
    [anon_sym_int200] = ACTIONS(694),
    [anon_sym_int208] = ACTIONS(694),
    [anon_sym_int216] = ACTIONS(694),
    [anon_sym_int224] = ACTIONS(694),
    [anon_sym_int232] = ACTIONS(694),
    [anon_sym_int240] = ACTIONS(694),
    [anon_sym_int248] = ACTIONS(694),
    [anon_sym_int256] = ACTIONS(694),
    [anon_sym_uint] = ACTIONS(694),
    [anon_sym_uint8] = ACTIONS(694),
    [anon_sym_uint16] = ACTIONS(694),
    [anon_sym_uint24] = ACTIONS(694),
    [anon_sym_uint32] = ACTIONS(694),
    [anon_sym_uint40] = ACTIONS(694),
    [anon_sym_uint48] = ACTIONS(694),
    [anon_sym_uint56] = ACTIONS(694),
    [anon_sym_uint64] = ACTIONS(694),
    [anon_sym_uint72] = ACTIONS(694),
    [anon_sym_uint80] = ACTIONS(694),
    [anon_sym_uint88] = ACTIONS(694),
    [anon_sym_uint96] = ACTIONS(694),
    [anon_sym_uint104] = ACTIONS(694),
    [anon_sym_uint112] = ACTIONS(694),
    [anon_sym_uint120] = ACTIONS(694),
    [anon_sym_uint128] = ACTIONS(694),
    [anon_sym_uint136] = ACTIONS(694),
    [anon_sym_uint144] = ACTIONS(694),
    [anon_sym_uint152] = ACTIONS(694),
    [anon_sym_uint160] = ACTIONS(694),
    [anon_sym_uint168] = ACTIONS(694),
    [anon_sym_uint176] = ACTIONS(694),
    [anon_sym_uint184] = ACTIONS(694),
    [anon_sym_uint192] = ACTIONS(694),
    [anon_sym_uint200] = ACTIONS(694),
    [anon_sym_uint208] = ACTIONS(694),
    [anon_sym_uint216] = ACTIONS(694),
    [anon_sym_uint224] = ACTIONS(694),
    [anon_sym_uint232] = ACTIONS(694),
    [anon_sym_uint240] = ACTIONS(694),
    [anon_sym_uint248] = ACTIONS(694),
    [anon_sym_uint256] = ACTIONS(694),
    [anon_sym_bytes] = ACTIONS(694),
    [anon_sym_bytes1] = ACTIONS(694),
    [anon_sym_bytes2] = ACTIONS(694),
    [anon_sym_bytes3] = ACTIONS(694),
    [anon_sym_bytes4] = ACTIONS(694),
    [anon_sym_bytes5] = ACTIONS(694),
    [anon_sym_bytes6] = ACTIONS(694),
    [anon_sym_bytes7] = ACTIONS(694),
    [anon_sym_bytes8] = ACTIONS(694),
    [anon_sym_bytes9] = ACTIONS(694),
    [anon_sym_bytes10] = ACTIONS(694),
    [anon_sym_bytes11] = ACTIONS(694),
    [anon_sym_bytes12] = ACTIONS(694),
    [anon_sym_bytes13] = ACTIONS(694),
    [anon_sym_bytes14] = ACTIONS(694),
    [anon_sym_bytes15] = ACTIONS(694),
    [anon_sym_bytes16] = ACTIONS(694),
    [anon_sym_bytes17] = ACTIONS(694),
    [anon_sym_bytes18] = ACTIONS(694),
    [anon_sym_bytes19] = ACTIONS(694),
    [anon_sym_bytes20] = ACTIONS(694),
    [anon_sym_bytes21] = ACTIONS(694),
    [anon_sym_bytes22] = ACTIONS(694),
    [anon_sym_bytes23] = ACTIONS(694),
    [anon_sym_bytes24] = ACTIONS(694),
    [anon_sym_bytes25] = ACTIONS(694),
    [anon_sym_bytes26] = ACTIONS(694),
    [anon_sym_bytes27] = ACTIONS(694),
    [anon_sym_bytes28] = ACTIONS(694),
    [anon_sym_bytes29] = ACTIONS(694),
    [anon_sym_bytes30] = ACTIONS(694),
    [anon_sym_bytes31] = ACTIONS(694),
    [anon_sym_bytes32] = ACTIONS(694),
    [anon_sym_fixed] = ACTIONS(694),
    [aux_sym__fixed_token1] = ACTIONS(694),
    [anon_sym_ufixed] = ACTIONS(694),
    [aux_sym__ufixed_token1] = ACTIONS(694),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [ts_builtin_sym_end] = ACTIONS(696),
    [sym_identifier] = ACTIONS(698),
    [anon_sym_pragma] = ACTIONS(698),
    [anon_sym_import] = ACTIONS(698),
    [anon_sym_type] = ACTIONS(698),
    [anon_sym_abstract] = ACTIONS(698),
    [anon_sym_contract] = ACTIONS(698),
    [anon_sym_error] = ACTIONS(698),
    [anon_sym_interface] = ACTIONS(698),
    [anon_sym_library] = ACTIONS(698),
    [anon_sym_struct] = ACTIONS(698),
    [anon_sym_enum] = ACTIONS(698),
    [anon_sym_event] = ACTIONS(698),
    [anon_sym_function] = ACTIONS(698),
    [anon_sym_byte] = ACTIONS(698),
    [anon_sym_address] = ACTIONS(698),
    [anon_sym_var] = ACTIONS(698),
    [anon_sym_mapping] = ACTIONS(698),
    [anon_sym_bool] = ACTIONS(698),
    [anon_sym_string] = ACTIONS(698),
    [anon_sym_int] = ACTIONS(698),
    [anon_sym_int8] = ACTIONS(698),
    [anon_sym_int16] = ACTIONS(698),
    [anon_sym_int24] = ACTIONS(698),
    [anon_sym_int32] = ACTIONS(698),
    [anon_sym_int40] = ACTIONS(698),
    [anon_sym_int48] = ACTIONS(698),
    [anon_sym_int56] = ACTIONS(698),
    [anon_sym_int64] = ACTIONS(698),
    [anon_sym_int72] = ACTIONS(698),
    [anon_sym_int80] = ACTIONS(698),
    [anon_sym_int88] = ACTIONS(698),
    [anon_sym_int96] = ACTIONS(698),
    [anon_sym_int104] = ACTIONS(698),
    [anon_sym_int112] = ACTIONS(698),
    [anon_sym_int120] = ACTIONS(698),
    [anon_sym_int128] = ACTIONS(698),
    [anon_sym_int136] = ACTIONS(698),
    [anon_sym_int144] = ACTIONS(698),
    [anon_sym_int152] = ACTIONS(698),
    [anon_sym_int160] = ACTIONS(698),
    [anon_sym_int168] = ACTIONS(698),
    [anon_sym_int176] = ACTIONS(698),
    [anon_sym_int184] = ACTIONS(698),
    [anon_sym_int192] = ACTIONS(698),
    [anon_sym_int200] = ACTIONS(698),
    [anon_sym_int208] = ACTIONS(698),
    [anon_sym_int216] = ACTIONS(698),
    [anon_sym_int224] = ACTIONS(698),
    [anon_sym_int232] = ACTIONS(698),
    [anon_sym_int240] = ACTIONS(698),
    [anon_sym_int248] = ACTIONS(698),
    [anon_sym_int256] = ACTIONS(698),
    [anon_sym_uint] = ACTIONS(698),
    [anon_sym_uint8] = ACTIONS(698),
    [anon_sym_uint16] = ACTIONS(698),
    [anon_sym_uint24] = ACTIONS(698),
    [anon_sym_uint32] = ACTIONS(698),
    [anon_sym_uint40] = ACTIONS(698),
    [anon_sym_uint48] = ACTIONS(698),
    [anon_sym_uint56] = ACTIONS(698),
    [anon_sym_uint64] = ACTIONS(698),
    [anon_sym_uint72] = ACTIONS(698),
    [anon_sym_uint80] = ACTIONS(698),
    [anon_sym_uint88] = ACTIONS(698),
    [anon_sym_uint96] = ACTIONS(698),
    [anon_sym_uint104] = ACTIONS(698),
    [anon_sym_uint112] = ACTIONS(698),
    [anon_sym_uint120] = ACTIONS(698),
    [anon_sym_uint128] = ACTIONS(698),
    [anon_sym_uint136] = ACTIONS(698),
    [anon_sym_uint144] = ACTIONS(698),
    [anon_sym_uint152] = ACTIONS(698),
    [anon_sym_uint160] = ACTIONS(698),
    [anon_sym_uint168] = ACTIONS(698),
    [anon_sym_uint176] = ACTIONS(698),
    [anon_sym_uint184] = ACTIONS(698),
    [anon_sym_uint192] = ACTIONS(698),
    [anon_sym_uint200] = ACTIONS(698),
    [anon_sym_uint208] = ACTIONS(698),
    [anon_sym_uint216] = ACTIONS(698),
    [anon_sym_uint224] = ACTIONS(698),
    [anon_sym_uint232] = ACTIONS(698),
    [anon_sym_uint240] = ACTIONS(698),
    [anon_sym_uint248] = ACTIONS(698),
    [anon_sym_uint256] = ACTIONS(698),
    [anon_sym_bytes] = ACTIONS(698),
    [anon_sym_bytes1] = ACTIONS(698),
    [anon_sym_bytes2] = ACTIONS(698),
    [anon_sym_bytes3] = ACTIONS(698),
    [anon_sym_bytes4] = ACTIONS(698),
    [anon_sym_bytes5] = ACTIONS(698),
    [anon_sym_bytes6] = ACTIONS(698),
    [anon_sym_bytes7] = ACTIONS(698),
    [anon_sym_bytes8] = ACTIONS(698),
    [anon_sym_bytes9] = ACTIONS(698),
    [anon_sym_bytes10] = ACTIONS(698),
    [anon_sym_bytes11] = ACTIONS(698),
    [anon_sym_bytes12] = ACTIONS(698),
    [anon_sym_bytes13] = ACTIONS(698),
    [anon_sym_bytes14] = ACTIONS(698),
    [anon_sym_bytes15] = ACTIONS(698),
    [anon_sym_bytes16] = ACTIONS(698),
    [anon_sym_bytes17] = ACTIONS(698),
    [anon_sym_bytes18] = ACTIONS(698),
    [anon_sym_bytes19] = ACTIONS(698),
    [anon_sym_bytes20] = ACTIONS(698),
    [anon_sym_bytes21] = ACTIONS(698),
    [anon_sym_bytes22] = ACTIONS(698),
    [anon_sym_bytes23] = ACTIONS(698),
    [anon_sym_bytes24] = ACTIONS(698),
    [anon_sym_bytes25] = ACTIONS(698),
    [anon_sym_bytes26] = ACTIONS(698),
    [anon_sym_bytes27] = ACTIONS(698),
    [anon_sym_bytes28] = ACTIONS(698),
    [anon_sym_bytes29] = ACTIONS(698),
    [anon_sym_bytes30] = ACTIONS(698),
    [anon_sym_bytes31] = ACTIONS(698),
    [anon_sym_bytes32] = ACTIONS(698),
    [anon_sym_fixed] = ACTIONS(698),
    [aux_sym__fixed_token1] = ACTIONS(698),
    [anon_sym_ufixed] = ACTIONS(698),
    [aux_sym__ufixed_token1] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [ts_builtin_sym_end] = ACTIONS(700),
    [sym_identifier] = ACTIONS(702),
    [anon_sym_pragma] = ACTIONS(702),
    [anon_sym_import] = ACTIONS(702),
    [anon_sym_type] = ACTIONS(702),
    [anon_sym_abstract] = ACTIONS(702),
    [anon_sym_contract] = ACTIONS(702),
    [anon_sym_error] = ACTIONS(702),
    [anon_sym_interface] = ACTIONS(702),
    [anon_sym_library] = ACTIONS(702),
    [anon_sym_struct] = ACTIONS(702),
    [anon_sym_enum] = ACTIONS(702),
    [anon_sym_event] = ACTIONS(702),
    [anon_sym_function] = ACTIONS(702),
    [anon_sym_byte] = ACTIONS(702),
    [anon_sym_address] = ACTIONS(702),
    [anon_sym_var] = ACTIONS(702),
    [anon_sym_mapping] = ACTIONS(702),
    [anon_sym_bool] = ACTIONS(702),
    [anon_sym_string] = ACTIONS(702),
    [anon_sym_int] = ACTIONS(702),
    [anon_sym_int8] = ACTIONS(702),
    [anon_sym_int16] = ACTIONS(702),
    [anon_sym_int24] = ACTIONS(702),
    [anon_sym_int32] = ACTIONS(702),
    [anon_sym_int40] = ACTIONS(702),
    [anon_sym_int48] = ACTIONS(702),
    [anon_sym_int56] = ACTIONS(702),
    [anon_sym_int64] = ACTIONS(702),
    [anon_sym_int72] = ACTIONS(702),
    [anon_sym_int80] = ACTIONS(702),
    [anon_sym_int88] = ACTIONS(702),
    [anon_sym_int96] = ACTIONS(702),
    [anon_sym_int104] = ACTIONS(702),
    [anon_sym_int112] = ACTIONS(702),
    [anon_sym_int120] = ACTIONS(702),
    [anon_sym_int128] = ACTIONS(702),
    [anon_sym_int136] = ACTIONS(702),
    [anon_sym_int144] = ACTIONS(702),
    [anon_sym_int152] = ACTIONS(702),
    [anon_sym_int160] = ACTIONS(702),
    [anon_sym_int168] = ACTIONS(702),
    [anon_sym_int176] = ACTIONS(702),
    [anon_sym_int184] = ACTIONS(702),
    [anon_sym_int192] = ACTIONS(702),
    [anon_sym_int200] = ACTIONS(702),
    [anon_sym_int208] = ACTIONS(702),
    [anon_sym_int216] = ACTIONS(702),
    [anon_sym_int224] = ACTIONS(702),
    [anon_sym_int232] = ACTIONS(702),
    [anon_sym_int240] = ACTIONS(702),
    [anon_sym_int248] = ACTIONS(702),
    [anon_sym_int256] = ACTIONS(702),
    [anon_sym_uint] = ACTIONS(702),
    [anon_sym_uint8] = ACTIONS(702),
    [anon_sym_uint16] = ACTIONS(702),
    [anon_sym_uint24] = ACTIONS(702),
    [anon_sym_uint32] = ACTIONS(702),
    [anon_sym_uint40] = ACTIONS(702),
    [anon_sym_uint48] = ACTIONS(702),
    [anon_sym_uint56] = ACTIONS(702),
    [anon_sym_uint64] = ACTIONS(702),
    [anon_sym_uint72] = ACTIONS(702),
    [anon_sym_uint80] = ACTIONS(702),
    [anon_sym_uint88] = ACTIONS(702),
    [anon_sym_uint96] = ACTIONS(702),
    [anon_sym_uint104] = ACTIONS(702),
    [anon_sym_uint112] = ACTIONS(702),
    [anon_sym_uint120] = ACTIONS(702),
    [anon_sym_uint128] = ACTIONS(702),
    [anon_sym_uint136] = ACTIONS(702),
    [anon_sym_uint144] = ACTIONS(702),
    [anon_sym_uint152] = ACTIONS(702),
    [anon_sym_uint160] = ACTIONS(702),
    [anon_sym_uint168] = ACTIONS(702),
    [anon_sym_uint176] = ACTIONS(702),
    [anon_sym_uint184] = ACTIONS(702),
    [anon_sym_uint192] = ACTIONS(702),
    [anon_sym_uint200] = ACTIONS(702),
    [anon_sym_uint208] = ACTIONS(702),
    [anon_sym_uint216] = ACTIONS(702),
    [anon_sym_uint224] = ACTIONS(702),
    [anon_sym_uint232] = ACTIONS(702),
    [anon_sym_uint240] = ACTIONS(702),
    [anon_sym_uint248] = ACTIONS(702),
    [anon_sym_uint256] = ACTIONS(702),
    [anon_sym_bytes] = ACTIONS(702),
    [anon_sym_bytes1] = ACTIONS(702),
    [anon_sym_bytes2] = ACTIONS(702),
    [anon_sym_bytes3] = ACTIONS(702),
    [anon_sym_bytes4] = ACTIONS(702),
    [anon_sym_bytes5] = ACTIONS(702),
    [anon_sym_bytes6] = ACTIONS(702),
    [anon_sym_bytes7] = ACTIONS(702),
    [anon_sym_bytes8] = ACTIONS(702),
    [anon_sym_bytes9] = ACTIONS(702),
    [anon_sym_bytes10] = ACTIONS(702),
    [anon_sym_bytes11] = ACTIONS(702),
    [anon_sym_bytes12] = ACTIONS(702),
    [anon_sym_bytes13] = ACTIONS(702),
    [anon_sym_bytes14] = ACTIONS(702),
    [anon_sym_bytes15] = ACTIONS(702),
    [anon_sym_bytes16] = ACTIONS(702),
    [anon_sym_bytes17] = ACTIONS(702),
    [anon_sym_bytes18] = ACTIONS(702),
    [anon_sym_bytes19] = ACTIONS(702),
    [anon_sym_bytes20] = ACTIONS(702),
    [anon_sym_bytes21] = ACTIONS(702),
    [anon_sym_bytes22] = ACTIONS(702),
    [anon_sym_bytes23] = ACTIONS(702),
    [anon_sym_bytes24] = ACTIONS(702),
    [anon_sym_bytes25] = ACTIONS(702),
    [anon_sym_bytes26] = ACTIONS(702),
    [anon_sym_bytes27] = ACTIONS(702),
    [anon_sym_bytes28] = ACTIONS(702),
    [anon_sym_bytes29] = ACTIONS(702),
    [anon_sym_bytes30] = ACTIONS(702),
    [anon_sym_bytes31] = ACTIONS(702),
    [anon_sym_bytes32] = ACTIONS(702),
    [anon_sym_fixed] = ACTIONS(702),
    [aux_sym__fixed_token1] = ACTIONS(702),
    [anon_sym_ufixed] = ACTIONS(702),
    [aux_sym__ufixed_token1] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
  },
  [158] = {
    [ts_builtin_sym_end] = ACTIONS(704),
    [sym_identifier] = ACTIONS(706),
    [anon_sym_pragma] = ACTIONS(706),
    [anon_sym_import] = ACTIONS(706),
    [anon_sym_type] = ACTIONS(706),
    [anon_sym_abstract] = ACTIONS(706),
    [anon_sym_contract] = ACTIONS(706),
    [anon_sym_error] = ACTIONS(706),
    [anon_sym_interface] = ACTIONS(706),
    [anon_sym_library] = ACTIONS(706),
    [anon_sym_struct] = ACTIONS(706),
    [anon_sym_enum] = ACTIONS(706),
    [anon_sym_event] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(706),
    [anon_sym_byte] = ACTIONS(706),
    [anon_sym_address] = ACTIONS(706),
    [anon_sym_var] = ACTIONS(706),
    [anon_sym_mapping] = ACTIONS(706),
    [anon_sym_bool] = ACTIONS(706),
    [anon_sym_string] = ACTIONS(706),
    [anon_sym_int] = ACTIONS(706),
    [anon_sym_int8] = ACTIONS(706),
    [anon_sym_int16] = ACTIONS(706),
    [anon_sym_int24] = ACTIONS(706),
    [anon_sym_int32] = ACTIONS(706),
    [anon_sym_int40] = ACTIONS(706),
    [anon_sym_int48] = ACTIONS(706),
    [anon_sym_int56] = ACTIONS(706),
    [anon_sym_int64] = ACTIONS(706),
    [anon_sym_int72] = ACTIONS(706),
    [anon_sym_int80] = ACTIONS(706),
    [anon_sym_int88] = ACTIONS(706),
    [anon_sym_int96] = ACTIONS(706),
    [anon_sym_int104] = ACTIONS(706),
    [anon_sym_int112] = ACTIONS(706),
    [anon_sym_int120] = ACTIONS(706),
    [anon_sym_int128] = ACTIONS(706),
    [anon_sym_int136] = ACTIONS(706),
    [anon_sym_int144] = ACTIONS(706),
    [anon_sym_int152] = ACTIONS(706),
    [anon_sym_int160] = ACTIONS(706),
    [anon_sym_int168] = ACTIONS(706),
    [anon_sym_int176] = ACTIONS(706),
    [anon_sym_int184] = ACTIONS(706),
    [anon_sym_int192] = ACTIONS(706),
    [anon_sym_int200] = ACTIONS(706),
    [anon_sym_int208] = ACTIONS(706),
    [anon_sym_int216] = ACTIONS(706),
    [anon_sym_int224] = ACTIONS(706),
    [anon_sym_int232] = ACTIONS(706),
    [anon_sym_int240] = ACTIONS(706),
    [anon_sym_int248] = ACTIONS(706),
    [anon_sym_int256] = ACTIONS(706),
    [anon_sym_uint] = ACTIONS(706),
    [anon_sym_uint8] = ACTIONS(706),
    [anon_sym_uint16] = ACTIONS(706),
    [anon_sym_uint24] = ACTIONS(706),
    [anon_sym_uint32] = ACTIONS(706),
    [anon_sym_uint40] = ACTIONS(706),
    [anon_sym_uint48] = ACTIONS(706),
    [anon_sym_uint56] = ACTIONS(706),
    [anon_sym_uint64] = ACTIONS(706),
    [anon_sym_uint72] = ACTIONS(706),
    [anon_sym_uint80] = ACTIONS(706),
    [anon_sym_uint88] = ACTIONS(706),
    [anon_sym_uint96] = ACTIONS(706),
    [anon_sym_uint104] = ACTIONS(706),
    [anon_sym_uint112] = ACTIONS(706),
    [anon_sym_uint120] = ACTIONS(706),
    [anon_sym_uint128] = ACTIONS(706),
    [anon_sym_uint136] = ACTIONS(706),
    [anon_sym_uint144] = ACTIONS(706),
    [anon_sym_uint152] = ACTIONS(706),
    [anon_sym_uint160] = ACTIONS(706),
    [anon_sym_uint168] = ACTIONS(706),
    [anon_sym_uint176] = ACTIONS(706),
    [anon_sym_uint184] = ACTIONS(706),
    [anon_sym_uint192] = ACTIONS(706),
    [anon_sym_uint200] = ACTIONS(706),
    [anon_sym_uint208] = ACTIONS(706),
    [anon_sym_uint216] = ACTIONS(706),
    [anon_sym_uint224] = ACTIONS(706),
    [anon_sym_uint232] = ACTIONS(706),
    [anon_sym_uint240] = ACTIONS(706),
    [anon_sym_uint248] = ACTIONS(706),
    [anon_sym_uint256] = ACTIONS(706),
    [anon_sym_bytes] = ACTIONS(706),
    [anon_sym_bytes1] = ACTIONS(706),
    [anon_sym_bytes2] = ACTIONS(706),
    [anon_sym_bytes3] = ACTIONS(706),
    [anon_sym_bytes4] = ACTIONS(706),
    [anon_sym_bytes5] = ACTIONS(706),
    [anon_sym_bytes6] = ACTIONS(706),
    [anon_sym_bytes7] = ACTIONS(706),
    [anon_sym_bytes8] = ACTIONS(706),
    [anon_sym_bytes9] = ACTIONS(706),
    [anon_sym_bytes10] = ACTIONS(706),
    [anon_sym_bytes11] = ACTIONS(706),
    [anon_sym_bytes12] = ACTIONS(706),
    [anon_sym_bytes13] = ACTIONS(706),
    [anon_sym_bytes14] = ACTIONS(706),
    [anon_sym_bytes15] = ACTIONS(706),
    [anon_sym_bytes16] = ACTIONS(706),
    [anon_sym_bytes17] = ACTIONS(706),
    [anon_sym_bytes18] = ACTIONS(706),
    [anon_sym_bytes19] = ACTIONS(706),
    [anon_sym_bytes20] = ACTIONS(706),
    [anon_sym_bytes21] = ACTIONS(706),
    [anon_sym_bytes22] = ACTIONS(706),
    [anon_sym_bytes23] = ACTIONS(706),
    [anon_sym_bytes24] = ACTIONS(706),
    [anon_sym_bytes25] = ACTIONS(706),
    [anon_sym_bytes26] = ACTIONS(706),
    [anon_sym_bytes27] = ACTIONS(706),
    [anon_sym_bytes28] = ACTIONS(706),
    [anon_sym_bytes29] = ACTIONS(706),
    [anon_sym_bytes30] = ACTIONS(706),
    [anon_sym_bytes31] = ACTIONS(706),
    [anon_sym_bytes32] = ACTIONS(706),
    [anon_sym_fixed] = ACTIONS(706),
    [aux_sym__fixed_token1] = ACTIONS(706),
    [anon_sym_ufixed] = ACTIONS(706),
    [aux_sym__ufixed_token1] = ACTIONS(706),
    [sym_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_type_name] = STATE(627),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [ts_builtin_sym_end] = ACTIONS(708),
    [sym_identifier] = ACTIONS(710),
    [anon_sym_pragma] = ACTIONS(710),
    [anon_sym_import] = ACTIONS(710),
    [anon_sym_type] = ACTIONS(710),
    [anon_sym_abstract] = ACTIONS(710),
    [anon_sym_contract] = ACTIONS(710),
    [anon_sym_error] = ACTIONS(710),
    [anon_sym_interface] = ACTIONS(710),
    [anon_sym_library] = ACTIONS(710),
    [anon_sym_struct] = ACTIONS(710),
    [anon_sym_enum] = ACTIONS(710),
    [anon_sym_event] = ACTIONS(710),
    [anon_sym_function] = ACTIONS(710),
    [anon_sym_byte] = ACTIONS(710),
    [anon_sym_address] = ACTIONS(710),
    [anon_sym_var] = ACTIONS(710),
    [anon_sym_mapping] = ACTIONS(710),
    [anon_sym_bool] = ACTIONS(710),
    [anon_sym_string] = ACTIONS(710),
    [anon_sym_int] = ACTIONS(710),
    [anon_sym_int8] = ACTIONS(710),
    [anon_sym_int16] = ACTIONS(710),
    [anon_sym_int24] = ACTIONS(710),
    [anon_sym_int32] = ACTIONS(710),
    [anon_sym_int40] = ACTIONS(710),
    [anon_sym_int48] = ACTIONS(710),
    [anon_sym_int56] = ACTIONS(710),
    [anon_sym_int64] = ACTIONS(710),
    [anon_sym_int72] = ACTIONS(710),
    [anon_sym_int80] = ACTIONS(710),
    [anon_sym_int88] = ACTIONS(710),
    [anon_sym_int96] = ACTIONS(710),
    [anon_sym_int104] = ACTIONS(710),
    [anon_sym_int112] = ACTIONS(710),
    [anon_sym_int120] = ACTIONS(710),
    [anon_sym_int128] = ACTIONS(710),
    [anon_sym_int136] = ACTIONS(710),
    [anon_sym_int144] = ACTIONS(710),
    [anon_sym_int152] = ACTIONS(710),
    [anon_sym_int160] = ACTIONS(710),
    [anon_sym_int168] = ACTIONS(710),
    [anon_sym_int176] = ACTIONS(710),
    [anon_sym_int184] = ACTIONS(710),
    [anon_sym_int192] = ACTIONS(710),
    [anon_sym_int200] = ACTIONS(710),
    [anon_sym_int208] = ACTIONS(710),
    [anon_sym_int216] = ACTIONS(710),
    [anon_sym_int224] = ACTIONS(710),
    [anon_sym_int232] = ACTIONS(710),
    [anon_sym_int240] = ACTIONS(710),
    [anon_sym_int248] = ACTIONS(710),
    [anon_sym_int256] = ACTIONS(710),
    [anon_sym_uint] = ACTIONS(710),
    [anon_sym_uint8] = ACTIONS(710),
    [anon_sym_uint16] = ACTIONS(710),
    [anon_sym_uint24] = ACTIONS(710),
    [anon_sym_uint32] = ACTIONS(710),
    [anon_sym_uint40] = ACTIONS(710),
    [anon_sym_uint48] = ACTIONS(710),
    [anon_sym_uint56] = ACTIONS(710),
    [anon_sym_uint64] = ACTIONS(710),
    [anon_sym_uint72] = ACTIONS(710),
    [anon_sym_uint80] = ACTIONS(710),
    [anon_sym_uint88] = ACTIONS(710),
    [anon_sym_uint96] = ACTIONS(710),
    [anon_sym_uint104] = ACTIONS(710),
    [anon_sym_uint112] = ACTIONS(710),
    [anon_sym_uint120] = ACTIONS(710),
    [anon_sym_uint128] = ACTIONS(710),
    [anon_sym_uint136] = ACTIONS(710),
    [anon_sym_uint144] = ACTIONS(710),
    [anon_sym_uint152] = ACTIONS(710),
    [anon_sym_uint160] = ACTIONS(710),
    [anon_sym_uint168] = ACTIONS(710),
    [anon_sym_uint176] = ACTIONS(710),
    [anon_sym_uint184] = ACTIONS(710),
    [anon_sym_uint192] = ACTIONS(710),
    [anon_sym_uint200] = ACTIONS(710),
    [anon_sym_uint208] = ACTIONS(710),
    [anon_sym_uint216] = ACTIONS(710),
    [anon_sym_uint224] = ACTIONS(710),
    [anon_sym_uint232] = ACTIONS(710),
    [anon_sym_uint240] = ACTIONS(710),
    [anon_sym_uint248] = ACTIONS(710),
    [anon_sym_uint256] = ACTIONS(710),
    [anon_sym_bytes] = ACTIONS(710),
    [anon_sym_bytes1] = ACTIONS(710),
    [anon_sym_bytes2] = ACTIONS(710),
    [anon_sym_bytes3] = ACTIONS(710),
    [anon_sym_bytes4] = ACTIONS(710),
    [anon_sym_bytes5] = ACTIONS(710),
    [anon_sym_bytes6] = ACTIONS(710),
    [anon_sym_bytes7] = ACTIONS(710),
    [anon_sym_bytes8] = ACTIONS(710),
    [anon_sym_bytes9] = ACTIONS(710),
    [anon_sym_bytes10] = ACTIONS(710),
    [anon_sym_bytes11] = ACTIONS(710),
    [anon_sym_bytes12] = ACTIONS(710),
    [anon_sym_bytes13] = ACTIONS(710),
    [anon_sym_bytes14] = ACTIONS(710),
    [anon_sym_bytes15] = ACTIONS(710),
    [anon_sym_bytes16] = ACTIONS(710),
    [anon_sym_bytes17] = ACTIONS(710),
    [anon_sym_bytes18] = ACTIONS(710),
    [anon_sym_bytes19] = ACTIONS(710),
    [anon_sym_bytes20] = ACTIONS(710),
    [anon_sym_bytes21] = ACTIONS(710),
    [anon_sym_bytes22] = ACTIONS(710),
    [anon_sym_bytes23] = ACTIONS(710),
    [anon_sym_bytes24] = ACTIONS(710),
    [anon_sym_bytes25] = ACTIONS(710),
    [anon_sym_bytes26] = ACTIONS(710),
    [anon_sym_bytes27] = ACTIONS(710),
    [anon_sym_bytes28] = ACTIONS(710),
    [anon_sym_bytes29] = ACTIONS(710),
    [anon_sym_bytes30] = ACTIONS(710),
    [anon_sym_bytes31] = ACTIONS(710),
    [anon_sym_bytes32] = ACTIONS(710),
    [anon_sym_fixed] = ACTIONS(710),
    [aux_sym__fixed_token1] = ACTIONS(710),
    [anon_sym_ufixed] = ACTIONS(710),
    [aux_sym__ufixed_token1] = ACTIONS(710),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [ts_builtin_sym_end] = ACTIONS(712),
    [sym_identifier] = ACTIONS(714),
    [anon_sym_pragma] = ACTIONS(714),
    [anon_sym_import] = ACTIONS(714),
    [anon_sym_type] = ACTIONS(714),
    [anon_sym_abstract] = ACTIONS(714),
    [anon_sym_contract] = ACTIONS(714),
    [anon_sym_error] = ACTIONS(714),
    [anon_sym_interface] = ACTIONS(714),
    [anon_sym_library] = ACTIONS(714),
    [anon_sym_struct] = ACTIONS(714),
    [anon_sym_enum] = ACTIONS(714),
    [anon_sym_event] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(714),
    [anon_sym_byte] = ACTIONS(714),
    [anon_sym_address] = ACTIONS(714),
    [anon_sym_var] = ACTIONS(714),
    [anon_sym_mapping] = ACTIONS(714),
    [anon_sym_bool] = ACTIONS(714),
    [anon_sym_string] = ACTIONS(714),
    [anon_sym_int] = ACTIONS(714),
    [anon_sym_int8] = ACTIONS(714),
    [anon_sym_int16] = ACTIONS(714),
    [anon_sym_int24] = ACTIONS(714),
    [anon_sym_int32] = ACTIONS(714),
    [anon_sym_int40] = ACTIONS(714),
    [anon_sym_int48] = ACTIONS(714),
    [anon_sym_int56] = ACTIONS(714),
    [anon_sym_int64] = ACTIONS(714),
    [anon_sym_int72] = ACTIONS(714),
    [anon_sym_int80] = ACTIONS(714),
    [anon_sym_int88] = ACTIONS(714),
    [anon_sym_int96] = ACTIONS(714),
    [anon_sym_int104] = ACTIONS(714),
    [anon_sym_int112] = ACTIONS(714),
    [anon_sym_int120] = ACTIONS(714),
    [anon_sym_int128] = ACTIONS(714),
    [anon_sym_int136] = ACTIONS(714),
    [anon_sym_int144] = ACTIONS(714),
    [anon_sym_int152] = ACTIONS(714),
    [anon_sym_int160] = ACTIONS(714),
    [anon_sym_int168] = ACTIONS(714),
    [anon_sym_int176] = ACTIONS(714),
    [anon_sym_int184] = ACTIONS(714),
    [anon_sym_int192] = ACTIONS(714),
    [anon_sym_int200] = ACTIONS(714),
    [anon_sym_int208] = ACTIONS(714),
    [anon_sym_int216] = ACTIONS(714),
    [anon_sym_int224] = ACTIONS(714),
    [anon_sym_int232] = ACTIONS(714),
    [anon_sym_int240] = ACTIONS(714),
    [anon_sym_int248] = ACTIONS(714),
    [anon_sym_int256] = ACTIONS(714),
    [anon_sym_uint] = ACTIONS(714),
    [anon_sym_uint8] = ACTIONS(714),
    [anon_sym_uint16] = ACTIONS(714),
    [anon_sym_uint24] = ACTIONS(714),
    [anon_sym_uint32] = ACTIONS(714),
    [anon_sym_uint40] = ACTIONS(714),
    [anon_sym_uint48] = ACTIONS(714),
    [anon_sym_uint56] = ACTIONS(714),
    [anon_sym_uint64] = ACTIONS(714),
    [anon_sym_uint72] = ACTIONS(714),
    [anon_sym_uint80] = ACTIONS(714),
    [anon_sym_uint88] = ACTIONS(714),
    [anon_sym_uint96] = ACTIONS(714),
    [anon_sym_uint104] = ACTIONS(714),
    [anon_sym_uint112] = ACTIONS(714),
    [anon_sym_uint120] = ACTIONS(714),
    [anon_sym_uint128] = ACTIONS(714),
    [anon_sym_uint136] = ACTIONS(714),
    [anon_sym_uint144] = ACTIONS(714),
    [anon_sym_uint152] = ACTIONS(714),
    [anon_sym_uint160] = ACTIONS(714),
    [anon_sym_uint168] = ACTIONS(714),
    [anon_sym_uint176] = ACTIONS(714),
    [anon_sym_uint184] = ACTIONS(714),
    [anon_sym_uint192] = ACTIONS(714),
    [anon_sym_uint200] = ACTIONS(714),
    [anon_sym_uint208] = ACTIONS(714),
    [anon_sym_uint216] = ACTIONS(714),
    [anon_sym_uint224] = ACTIONS(714),
    [anon_sym_uint232] = ACTIONS(714),
    [anon_sym_uint240] = ACTIONS(714),
    [anon_sym_uint248] = ACTIONS(714),
    [anon_sym_uint256] = ACTIONS(714),
    [anon_sym_bytes] = ACTIONS(714),
    [anon_sym_bytes1] = ACTIONS(714),
    [anon_sym_bytes2] = ACTIONS(714),
    [anon_sym_bytes3] = ACTIONS(714),
    [anon_sym_bytes4] = ACTIONS(714),
    [anon_sym_bytes5] = ACTIONS(714),
    [anon_sym_bytes6] = ACTIONS(714),
    [anon_sym_bytes7] = ACTIONS(714),
    [anon_sym_bytes8] = ACTIONS(714),
    [anon_sym_bytes9] = ACTIONS(714),
    [anon_sym_bytes10] = ACTIONS(714),
    [anon_sym_bytes11] = ACTIONS(714),
    [anon_sym_bytes12] = ACTIONS(714),
    [anon_sym_bytes13] = ACTIONS(714),
    [anon_sym_bytes14] = ACTIONS(714),
    [anon_sym_bytes15] = ACTIONS(714),
    [anon_sym_bytes16] = ACTIONS(714),
    [anon_sym_bytes17] = ACTIONS(714),
    [anon_sym_bytes18] = ACTIONS(714),
    [anon_sym_bytes19] = ACTIONS(714),
    [anon_sym_bytes20] = ACTIONS(714),
    [anon_sym_bytes21] = ACTIONS(714),
    [anon_sym_bytes22] = ACTIONS(714),
    [anon_sym_bytes23] = ACTIONS(714),
    [anon_sym_bytes24] = ACTIONS(714),
    [anon_sym_bytes25] = ACTIONS(714),
    [anon_sym_bytes26] = ACTIONS(714),
    [anon_sym_bytes27] = ACTIONS(714),
    [anon_sym_bytes28] = ACTIONS(714),
    [anon_sym_bytes29] = ACTIONS(714),
    [anon_sym_bytes30] = ACTIONS(714),
    [anon_sym_bytes31] = ACTIONS(714),
    [anon_sym_bytes32] = ACTIONS(714),
    [anon_sym_fixed] = ACTIONS(714),
    [aux_sym__fixed_token1] = ACTIONS(714),
    [anon_sym_ufixed] = ACTIONS(714),
    [aux_sym__ufixed_token1] = ACTIONS(714),
    [sym_comment] = ACTIONS(3),
  },
  [162] = {
    [ts_builtin_sym_end] = ACTIONS(716),
    [sym_identifier] = ACTIONS(718),
    [anon_sym_pragma] = ACTIONS(718),
    [anon_sym_import] = ACTIONS(718),
    [anon_sym_type] = ACTIONS(718),
    [anon_sym_abstract] = ACTIONS(718),
    [anon_sym_contract] = ACTIONS(718),
    [anon_sym_error] = ACTIONS(718),
    [anon_sym_interface] = ACTIONS(718),
    [anon_sym_library] = ACTIONS(718),
    [anon_sym_struct] = ACTIONS(718),
    [anon_sym_enum] = ACTIONS(718),
    [anon_sym_event] = ACTIONS(718),
    [anon_sym_function] = ACTIONS(718),
    [anon_sym_byte] = ACTIONS(718),
    [anon_sym_address] = ACTIONS(718),
    [anon_sym_var] = ACTIONS(718),
    [anon_sym_mapping] = ACTIONS(718),
    [anon_sym_bool] = ACTIONS(718),
    [anon_sym_string] = ACTIONS(718),
    [anon_sym_int] = ACTIONS(718),
    [anon_sym_int8] = ACTIONS(718),
    [anon_sym_int16] = ACTIONS(718),
    [anon_sym_int24] = ACTIONS(718),
    [anon_sym_int32] = ACTIONS(718),
    [anon_sym_int40] = ACTIONS(718),
    [anon_sym_int48] = ACTIONS(718),
    [anon_sym_int56] = ACTIONS(718),
    [anon_sym_int64] = ACTIONS(718),
    [anon_sym_int72] = ACTIONS(718),
    [anon_sym_int80] = ACTIONS(718),
    [anon_sym_int88] = ACTIONS(718),
    [anon_sym_int96] = ACTIONS(718),
    [anon_sym_int104] = ACTIONS(718),
    [anon_sym_int112] = ACTIONS(718),
    [anon_sym_int120] = ACTIONS(718),
    [anon_sym_int128] = ACTIONS(718),
    [anon_sym_int136] = ACTIONS(718),
    [anon_sym_int144] = ACTIONS(718),
    [anon_sym_int152] = ACTIONS(718),
    [anon_sym_int160] = ACTIONS(718),
    [anon_sym_int168] = ACTIONS(718),
    [anon_sym_int176] = ACTIONS(718),
    [anon_sym_int184] = ACTIONS(718),
    [anon_sym_int192] = ACTIONS(718),
    [anon_sym_int200] = ACTIONS(718),
    [anon_sym_int208] = ACTIONS(718),
    [anon_sym_int216] = ACTIONS(718),
    [anon_sym_int224] = ACTIONS(718),
    [anon_sym_int232] = ACTIONS(718),
    [anon_sym_int240] = ACTIONS(718),
    [anon_sym_int248] = ACTIONS(718),
    [anon_sym_int256] = ACTIONS(718),
    [anon_sym_uint] = ACTIONS(718),
    [anon_sym_uint8] = ACTIONS(718),
    [anon_sym_uint16] = ACTIONS(718),
    [anon_sym_uint24] = ACTIONS(718),
    [anon_sym_uint32] = ACTIONS(718),
    [anon_sym_uint40] = ACTIONS(718),
    [anon_sym_uint48] = ACTIONS(718),
    [anon_sym_uint56] = ACTIONS(718),
    [anon_sym_uint64] = ACTIONS(718),
    [anon_sym_uint72] = ACTIONS(718),
    [anon_sym_uint80] = ACTIONS(718),
    [anon_sym_uint88] = ACTIONS(718),
    [anon_sym_uint96] = ACTIONS(718),
    [anon_sym_uint104] = ACTIONS(718),
    [anon_sym_uint112] = ACTIONS(718),
    [anon_sym_uint120] = ACTIONS(718),
    [anon_sym_uint128] = ACTIONS(718),
    [anon_sym_uint136] = ACTIONS(718),
    [anon_sym_uint144] = ACTIONS(718),
    [anon_sym_uint152] = ACTIONS(718),
    [anon_sym_uint160] = ACTIONS(718),
    [anon_sym_uint168] = ACTIONS(718),
    [anon_sym_uint176] = ACTIONS(718),
    [anon_sym_uint184] = ACTIONS(718),
    [anon_sym_uint192] = ACTIONS(718),
    [anon_sym_uint200] = ACTIONS(718),
    [anon_sym_uint208] = ACTIONS(718),
    [anon_sym_uint216] = ACTIONS(718),
    [anon_sym_uint224] = ACTIONS(718),
    [anon_sym_uint232] = ACTIONS(718),
    [anon_sym_uint240] = ACTIONS(718),
    [anon_sym_uint248] = ACTIONS(718),
    [anon_sym_uint256] = ACTIONS(718),
    [anon_sym_bytes] = ACTIONS(718),
    [anon_sym_bytes1] = ACTIONS(718),
    [anon_sym_bytes2] = ACTIONS(718),
    [anon_sym_bytes3] = ACTIONS(718),
    [anon_sym_bytes4] = ACTIONS(718),
    [anon_sym_bytes5] = ACTIONS(718),
    [anon_sym_bytes6] = ACTIONS(718),
    [anon_sym_bytes7] = ACTIONS(718),
    [anon_sym_bytes8] = ACTIONS(718),
    [anon_sym_bytes9] = ACTIONS(718),
    [anon_sym_bytes10] = ACTIONS(718),
    [anon_sym_bytes11] = ACTIONS(718),
    [anon_sym_bytes12] = ACTIONS(718),
    [anon_sym_bytes13] = ACTIONS(718),
    [anon_sym_bytes14] = ACTIONS(718),
    [anon_sym_bytes15] = ACTIONS(718),
    [anon_sym_bytes16] = ACTIONS(718),
    [anon_sym_bytes17] = ACTIONS(718),
    [anon_sym_bytes18] = ACTIONS(718),
    [anon_sym_bytes19] = ACTIONS(718),
    [anon_sym_bytes20] = ACTIONS(718),
    [anon_sym_bytes21] = ACTIONS(718),
    [anon_sym_bytes22] = ACTIONS(718),
    [anon_sym_bytes23] = ACTIONS(718),
    [anon_sym_bytes24] = ACTIONS(718),
    [anon_sym_bytes25] = ACTIONS(718),
    [anon_sym_bytes26] = ACTIONS(718),
    [anon_sym_bytes27] = ACTIONS(718),
    [anon_sym_bytes28] = ACTIONS(718),
    [anon_sym_bytes29] = ACTIONS(718),
    [anon_sym_bytes30] = ACTIONS(718),
    [anon_sym_bytes31] = ACTIONS(718),
    [anon_sym_bytes32] = ACTIONS(718),
    [anon_sym_fixed] = ACTIONS(718),
    [aux_sym__fixed_token1] = ACTIONS(718),
    [anon_sym_ufixed] = ACTIONS(718),
    [aux_sym__ufixed_token1] = ACTIONS(718),
    [sym_comment] = ACTIONS(3),
  },
  [163] = {
    [ts_builtin_sym_end] = ACTIONS(720),
    [sym_identifier] = ACTIONS(722),
    [anon_sym_pragma] = ACTIONS(722),
    [anon_sym_import] = ACTIONS(722),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_abstract] = ACTIONS(722),
    [anon_sym_contract] = ACTIONS(722),
    [anon_sym_error] = ACTIONS(722),
    [anon_sym_interface] = ACTIONS(722),
    [anon_sym_library] = ACTIONS(722),
    [anon_sym_struct] = ACTIONS(722),
    [anon_sym_enum] = ACTIONS(722),
    [anon_sym_event] = ACTIONS(722),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_byte] = ACTIONS(722),
    [anon_sym_address] = ACTIONS(722),
    [anon_sym_var] = ACTIONS(722),
    [anon_sym_mapping] = ACTIONS(722),
    [anon_sym_bool] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_int] = ACTIONS(722),
    [anon_sym_int8] = ACTIONS(722),
    [anon_sym_int16] = ACTIONS(722),
    [anon_sym_int24] = ACTIONS(722),
    [anon_sym_int32] = ACTIONS(722),
    [anon_sym_int40] = ACTIONS(722),
    [anon_sym_int48] = ACTIONS(722),
    [anon_sym_int56] = ACTIONS(722),
    [anon_sym_int64] = ACTIONS(722),
    [anon_sym_int72] = ACTIONS(722),
    [anon_sym_int80] = ACTIONS(722),
    [anon_sym_int88] = ACTIONS(722),
    [anon_sym_int96] = ACTIONS(722),
    [anon_sym_int104] = ACTIONS(722),
    [anon_sym_int112] = ACTIONS(722),
    [anon_sym_int120] = ACTIONS(722),
    [anon_sym_int128] = ACTIONS(722),
    [anon_sym_int136] = ACTIONS(722),
    [anon_sym_int144] = ACTIONS(722),
    [anon_sym_int152] = ACTIONS(722),
    [anon_sym_int160] = ACTIONS(722),
    [anon_sym_int168] = ACTIONS(722),
    [anon_sym_int176] = ACTIONS(722),
    [anon_sym_int184] = ACTIONS(722),
    [anon_sym_int192] = ACTIONS(722),
    [anon_sym_int200] = ACTIONS(722),
    [anon_sym_int208] = ACTIONS(722),
    [anon_sym_int216] = ACTIONS(722),
    [anon_sym_int224] = ACTIONS(722),
    [anon_sym_int232] = ACTIONS(722),
    [anon_sym_int240] = ACTIONS(722),
    [anon_sym_int248] = ACTIONS(722),
    [anon_sym_int256] = ACTIONS(722),
    [anon_sym_uint] = ACTIONS(722),
    [anon_sym_uint8] = ACTIONS(722),
    [anon_sym_uint16] = ACTIONS(722),
    [anon_sym_uint24] = ACTIONS(722),
    [anon_sym_uint32] = ACTIONS(722),
    [anon_sym_uint40] = ACTIONS(722),
    [anon_sym_uint48] = ACTIONS(722),
    [anon_sym_uint56] = ACTIONS(722),
    [anon_sym_uint64] = ACTIONS(722),
    [anon_sym_uint72] = ACTIONS(722),
    [anon_sym_uint80] = ACTIONS(722),
    [anon_sym_uint88] = ACTIONS(722),
    [anon_sym_uint96] = ACTIONS(722),
    [anon_sym_uint104] = ACTIONS(722),
    [anon_sym_uint112] = ACTIONS(722),
    [anon_sym_uint120] = ACTIONS(722),
    [anon_sym_uint128] = ACTIONS(722),
    [anon_sym_uint136] = ACTIONS(722),
    [anon_sym_uint144] = ACTIONS(722),
    [anon_sym_uint152] = ACTIONS(722),
    [anon_sym_uint160] = ACTIONS(722),
    [anon_sym_uint168] = ACTIONS(722),
    [anon_sym_uint176] = ACTIONS(722),
    [anon_sym_uint184] = ACTIONS(722),
    [anon_sym_uint192] = ACTIONS(722),
    [anon_sym_uint200] = ACTIONS(722),
    [anon_sym_uint208] = ACTIONS(722),
    [anon_sym_uint216] = ACTIONS(722),
    [anon_sym_uint224] = ACTIONS(722),
    [anon_sym_uint232] = ACTIONS(722),
    [anon_sym_uint240] = ACTIONS(722),
    [anon_sym_uint248] = ACTIONS(722),
    [anon_sym_uint256] = ACTIONS(722),
    [anon_sym_bytes] = ACTIONS(722),
    [anon_sym_bytes1] = ACTIONS(722),
    [anon_sym_bytes2] = ACTIONS(722),
    [anon_sym_bytes3] = ACTIONS(722),
    [anon_sym_bytes4] = ACTIONS(722),
    [anon_sym_bytes5] = ACTIONS(722),
    [anon_sym_bytes6] = ACTIONS(722),
    [anon_sym_bytes7] = ACTIONS(722),
    [anon_sym_bytes8] = ACTIONS(722),
    [anon_sym_bytes9] = ACTIONS(722),
    [anon_sym_bytes10] = ACTIONS(722),
    [anon_sym_bytes11] = ACTIONS(722),
    [anon_sym_bytes12] = ACTIONS(722),
    [anon_sym_bytes13] = ACTIONS(722),
    [anon_sym_bytes14] = ACTIONS(722),
    [anon_sym_bytes15] = ACTIONS(722),
    [anon_sym_bytes16] = ACTIONS(722),
    [anon_sym_bytes17] = ACTIONS(722),
    [anon_sym_bytes18] = ACTIONS(722),
    [anon_sym_bytes19] = ACTIONS(722),
    [anon_sym_bytes20] = ACTIONS(722),
    [anon_sym_bytes21] = ACTIONS(722),
    [anon_sym_bytes22] = ACTIONS(722),
    [anon_sym_bytes23] = ACTIONS(722),
    [anon_sym_bytes24] = ACTIONS(722),
    [anon_sym_bytes25] = ACTIONS(722),
    [anon_sym_bytes26] = ACTIONS(722),
    [anon_sym_bytes27] = ACTIONS(722),
    [anon_sym_bytes28] = ACTIONS(722),
    [anon_sym_bytes29] = ACTIONS(722),
    [anon_sym_bytes30] = ACTIONS(722),
    [anon_sym_bytes31] = ACTIONS(722),
    [anon_sym_bytes32] = ACTIONS(722),
    [anon_sym_fixed] = ACTIONS(722),
    [aux_sym__fixed_token1] = ACTIONS(722),
    [anon_sym_ufixed] = ACTIONS(722),
    [aux_sym__ufixed_token1] = ACTIONS(722),
    [sym_comment] = ACTIONS(3),
  },
  [164] = {
    [ts_builtin_sym_end] = ACTIONS(724),
    [sym_identifier] = ACTIONS(726),
    [anon_sym_pragma] = ACTIONS(726),
    [anon_sym_import] = ACTIONS(726),
    [anon_sym_type] = ACTIONS(726),
    [anon_sym_abstract] = ACTIONS(726),
    [anon_sym_contract] = ACTIONS(726),
    [anon_sym_error] = ACTIONS(726),
    [anon_sym_interface] = ACTIONS(726),
    [anon_sym_library] = ACTIONS(726),
    [anon_sym_struct] = ACTIONS(726),
    [anon_sym_enum] = ACTIONS(726),
    [anon_sym_event] = ACTIONS(726),
    [anon_sym_function] = ACTIONS(726),
    [anon_sym_byte] = ACTIONS(726),
    [anon_sym_address] = ACTIONS(726),
    [anon_sym_var] = ACTIONS(726),
    [anon_sym_mapping] = ACTIONS(726),
    [anon_sym_bool] = ACTIONS(726),
    [anon_sym_string] = ACTIONS(726),
    [anon_sym_int] = ACTIONS(726),
    [anon_sym_int8] = ACTIONS(726),
    [anon_sym_int16] = ACTIONS(726),
    [anon_sym_int24] = ACTIONS(726),
    [anon_sym_int32] = ACTIONS(726),
    [anon_sym_int40] = ACTIONS(726),
    [anon_sym_int48] = ACTIONS(726),
    [anon_sym_int56] = ACTIONS(726),
    [anon_sym_int64] = ACTIONS(726),
    [anon_sym_int72] = ACTIONS(726),
    [anon_sym_int80] = ACTIONS(726),
    [anon_sym_int88] = ACTIONS(726),
    [anon_sym_int96] = ACTIONS(726),
    [anon_sym_int104] = ACTIONS(726),
    [anon_sym_int112] = ACTIONS(726),
    [anon_sym_int120] = ACTIONS(726),
    [anon_sym_int128] = ACTIONS(726),
    [anon_sym_int136] = ACTIONS(726),
    [anon_sym_int144] = ACTIONS(726),
    [anon_sym_int152] = ACTIONS(726),
    [anon_sym_int160] = ACTIONS(726),
    [anon_sym_int168] = ACTIONS(726),
    [anon_sym_int176] = ACTIONS(726),
    [anon_sym_int184] = ACTIONS(726),
    [anon_sym_int192] = ACTIONS(726),
    [anon_sym_int200] = ACTIONS(726),
    [anon_sym_int208] = ACTIONS(726),
    [anon_sym_int216] = ACTIONS(726),
    [anon_sym_int224] = ACTIONS(726),
    [anon_sym_int232] = ACTIONS(726),
    [anon_sym_int240] = ACTIONS(726),
    [anon_sym_int248] = ACTIONS(726),
    [anon_sym_int256] = ACTIONS(726),
    [anon_sym_uint] = ACTIONS(726),
    [anon_sym_uint8] = ACTIONS(726),
    [anon_sym_uint16] = ACTIONS(726),
    [anon_sym_uint24] = ACTIONS(726),
    [anon_sym_uint32] = ACTIONS(726),
    [anon_sym_uint40] = ACTIONS(726),
    [anon_sym_uint48] = ACTIONS(726),
    [anon_sym_uint56] = ACTIONS(726),
    [anon_sym_uint64] = ACTIONS(726),
    [anon_sym_uint72] = ACTIONS(726),
    [anon_sym_uint80] = ACTIONS(726),
    [anon_sym_uint88] = ACTIONS(726),
    [anon_sym_uint96] = ACTIONS(726),
    [anon_sym_uint104] = ACTIONS(726),
    [anon_sym_uint112] = ACTIONS(726),
    [anon_sym_uint120] = ACTIONS(726),
    [anon_sym_uint128] = ACTIONS(726),
    [anon_sym_uint136] = ACTIONS(726),
    [anon_sym_uint144] = ACTIONS(726),
    [anon_sym_uint152] = ACTIONS(726),
    [anon_sym_uint160] = ACTIONS(726),
    [anon_sym_uint168] = ACTIONS(726),
    [anon_sym_uint176] = ACTIONS(726),
    [anon_sym_uint184] = ACTIONS(726),
    [anon_sym_uint192] = ACTIONS(726),
    [anon_sym_uint200] = ACTIONS(726),
    [anon_sym_uint208] = ACTIONS(726),
    [anon_sym_uint216] = ACTIONS(726),
    [anon_sym_uint224] = ACTIONS(726),
    [anon_sym_uint232] = ACTIONS(726),
    [anon_sym_uint240] = ACTIONS(726),
    [anon_sym_uint248] = ACTIONS(726),
    [anon_sym_uint256] = ACTIONS(726),
    [anon_sym_bytes] = ACTIONS(726),
    [anon_sym_bytes1] = ACTIONS(726),
    [anon_sym_bytes2] = ACTIONS(726),
    [anon_sym_bytes3] = ACTIONS(726),
    [anon_sym_bytes4] = ACTIONS(726),
    [anon_sym_bytes5] = ACTIONS(726),
    [anon_sym_bytes6] = ACTIONS(726),
    [anon_sym_bytes7] = ACTIONS(726),
    [anon_sym_bytes8] = ACTIONS(726),
    [anon_sym_bytes9] = ACTIONS(726),
    [anon_sym_bytes10] = ACTIONS(726),
    [anon_sym_bytes11] = ACTIONS(726),
    [anon_sym_bytes12] = ACTIONS(726),
    [anon_sym_bytes13] = ACTIONS(726),
    [anon_sym_bytes14] = ACTIONS(726),
    [anon_sym_bytes15] = ACTIONS(726),
    [anon_sym_bytes16] = ACTIONS(726),
    [anon_sym_bytes17] = ACTIONS(726),
    [anon_sym_bytes18] = ACTIONS(726),
    [anon_sym_bytes19] = ACTIONS(726),
    [anon_sym_bytes20] = ACTIONS(726),
    [anon_sym_bytes21] = ACTIONS(726),
    [anon_sym_bytes22] = ACTIONS(726),
    [anon_sym_bytes23] = ACTIONS(726),
    [anon_sym_bytes24] = ACTIONS(726),
    [anon_sym_bytes25] = ACTIONS(726),
    [anon_sym_bytes26] = ACTIONS(726),
    [anon_sym_bytes27] = ACTIONS(726),
    [anon_sym_bytes28] = ACTIONS(726),
    [anon_sym_bytes29] = ACTIONS(726),
    [anon_sym_bytes30] = ACTIONS(726),
    [anon_sym_bytes31] = ACTIONS(726),
    [anon_sym_bytes32] = ACTIONS(726),
    [anon_sym_fixed] = ACTIONS(726),
    [aux_sym__fixed_token1] = ACTIONS(726),
    [anon_sym_ufixed] = ACTIONS(726),
    [aux_sym__ufixed_token1] = ACTIONS(726),
    [sym_comment] = ACTIONS(3),
  },
  [165] = {
    [ts_builtin_sym_end] = ACTIONS(728),
    [sym_identifier] = ACTIONS(730),
    [anon_sym_pragma] = ACTIONS(730),
    [anon_sym_import] = ACTIONS(730),
    [anon_sym_type] = ACTIONS(730),
    [anon_sym_abstract] = ACTIONS(730),
    [anon_sym_contract] = ACTIONS(730),
    [anon_sym_error] = ACTIONS(730),
    [anon_sym_interface] = ACTIONS(730),
    [anon_sym_library] = ACTIONS(730),
    [anon_sym_struct] = ACTIONS(730),
    [anon_sym_enum] = ACTIONS(730),
    [anon_sym_event] = ACTIONS(730),
    [anon_sym_function] = ACTIONS(730),
    [anon_sym_byte] = ACTIONS(730),
    [anon_sym_address] = ACTIONS(730),
    [anon_sym_var] = ACTIONS(730),
    [anon_sym_mapping] = ACTIONS(730),
    [anon_sym_bool] = ACTIONS(730),
    [anon_sym_string] = ACTIONS(730),
    [anon_sym_int] = ACTIONS(730),
    [anon_sym_int8] = ACTIONS(730),
    [anon_sym_int16] = ACTIONS(730),
    [anon_sym_int24] = ACTIONS(730),
    [anon_sym_int32] = ACTIONS(730),
    [anon_sym_int40] = ACTIONS(730),
    [anon_sym_int48] = ACTIONS(730),
    [anon_sym_int56] = ACTIONS(730),
    [anon_sym_int64] = ACTIONS(730),
    [anon_sym_int72] = ACTIONS(730),
    [anon_sym_int80] = ACTIONS(730),
    [anon_sym_int88] = ACTIONS(730),
    [anon_sym_int96] = ACTIONS(730),
    [anon_sym_int104] = ACTIONS(730),
    [anon_sym_int112] = ACTIONS(730),
    [anon_sym_int120] = ACTIONS(730),
    [anon_sym_int128] = ACTIONS(730),
    [anon_sym_int136] = ACTIONS(730),
    [anon_sym_int144] = ACTIONS(730),
    [anon_sym_int152] = ACTIONS(730),
    [anon_sym_int160] = ACTIONS(730),
    [anon_sym_int168] = ACTIONS(730),
    [anon_sym_int176] = ACTIONS(730),
    [anon_sym_int184] = ACTIONS(730),
    [anon_sym_int192] = ACTIONS(730),
    [anon_sym_int200] = ACTIONS(730),
    [anon_sym_int208] = ACTIONS(730),
    [anon_sym_int216] = ACTIONS(730),
    [anon_sym_int224] = ACTIONS(730),
    [anon_sym_int232] = ACTIONS(730),
    [anon_sym_int240] = ACTIONS(730),
    [anon_sym_int248] = ACTIONS(730),
    [anon_sym_int256] = ACTIONS(730),
    [anon_sym_uint] = ACTIONS(730),
    [anon_sym_uint8] = ACTIONS(730),
    [anon_sym_uint16] = ACTIONS(730),
    [anon_sym_uint24] = ACTIONS(730),
    [anon_sym_uint32] = ACTIONS(730),
    [anon_sym_uint40] = ACTIONS(730),
    [anon_sym_uint48] = ACTIONS(730),
    [anon_sym_uint56] = ACTIONS(730),
    [anon_sym_uint64] = ACTIONS(730),
    [anon_sym_uint72] = ACTIONS(730),
    [anon_sym_uint80] = ACTIONS(730),
    [anon_sym_uint88] = ACTIONS(730),
    [anon_sym_uint96] = ACTIONS(730),
    [anon_sym_uint104] = ACTIONS(730),
    [anon_sym_uint112] = ACTIONS(730),
    [anon_sym_uint120] = ACTIONS(730),
    [anon_sym_uint128] = ACTIONS(730),
    [anon_sym_uint136] = ACTIONS(730),
    [anon_sym_uint144] = ACTIONS(730),
    [anon_sym_uint152] = ACTIONS(730),
    [anon_sym_uint160] = ACTIONS(730),
    [anon_sym_uint168] = ACTIONS(730),
    [anon_sym_uint176] = ACTIONS(730),
    [anon_sym_uint184] = ACTIONS(730),
    [anon_sym_uint192] = ACTIONS(730),
    [anon_sym_uint200] = ACTIONS(730),
    [anon_sym_uint208] = ACTIONS(730),
    [anon_sym_uint216] = ACTIONS(730),
    [anon_sym_uint224] = ACTIONS(730),
    [anon_sym_uint232] = ACTIONS(730),
    [anon_sym_uint240] = ACTIONS(730),
    [anon_sym_uint248] = ACTIONS(730),
    [anon_sym_uint256] = ACTIONS(730),
    [anon_sym_bytes] = ACTIONS(730),
    [anon_sym_bytes1] = ACTIONS(730),
    [anon_sym_bytes2] = ACTIONS(730),
    [anon_sym_bytes3] = ACTIONS(730),
    [anon_sym_bytes4] = ACTIONS(730),
    [anon_sym_bytes5] = ACTIONS(730),
    [anon_sym_bytes6] = ACTIONS(730),
    [anon_sym_bytes7] = ACTIONS(730),
    [anon_sym_bytes8] = ACTIONS(730),
    [anon_sym_bytes9] = ACTIONS(730),
    [anon_sym_bytes10] = ACTIONS(730),
    [anon_sym_bytes11] = ACTIONS(730),
    [anon_sym_bytes12] = ACTIONS(730),
    [anon_sym_bytes13] = ACTIONS(730),
    [anon_sym_bytes14] = ACTIONS(730),
    [anon_sym_bytes15] = ACTIONS(730),
    [anon_sym_bytes16] = ACTIONS(730),
    [anon_sym_bytes17] = ACTIONS(730),
    [anon_sym_bytes18] = ACTIONS(730),
    [anon_sym_bytes19] = ACTIONS(730),
    [anon_sym_bytes20] = ACTIONS(730),
    [anon_sym_bytes21] = ACTIONS(730),
    [anon_sym_bytes22] = ACTIONS(730),
    [anon_sym_bytes23] = ACTIONS(730),
    [anon_sym_bytes24] = ACTIONS(730),
    [anon_sym_bytes25] = ACTIONS(730),
    [anon_sym_bytes26] = ACTIONS(730),
    [anon_sym_bytes27] = ACTIONS(730),
    [anon_sym_bytes28] = ACTIONS(730),
    [anon_sym_bytes29] = ACTIONS(730),
    [anon_sym_bytes30] = ACTIONS(730),
    [anon_sym_bytes31] = ACTIONS(730),
    [anon_sym_bytes32] = ACTIONS(730),
    [anon_sym_fixed] = ACTIONS(730),
    [aux_sym__fixed_token1] = ACTIONS(730),
    [anon_sym_ufixed] = ACTIONS(730),
    [aux_sym__ufixed_token1] = ACTIONS(730),
    [sym_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_type_name] = STATE(596),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [167] = {
    [ts_builtin_sym_end] = ACTIONS(732),
    [sym_identifier] = ACTIONS(734),
    [anon_sym_pragma] = ACTIONS(734),
    [anon_sym_import] = ACTIONS(734),
    [anon_sym_type] = ACTIONS(734),
    [anon_sym_abstract] = ACTIONS(734),
    [anon_sym_contract] = ACTIONS(734),
    [anon_sym_error] = ACTIONS(734),
    [anon_sym_interface] = ACTIONS(734),
    [anon_sym_library] = ACTIONS(734),
    [anon_sym_struct] = ACTIONS(734),
    [anon_sym_enum] = ACTIONS(734),
    [anon_sym_event] = ACTIONS(734),
    [anon_sym_function] = ACTIONS(734),
    [anon_sym_byte] = ACTIONS(734),
    [anon_sym_address] = ACTIONS(734),
    [anon_sym_var] = ACTIONS(734),
    [anon_sym_mapping] = ACTIONS(734),
    [anon_sym_bool] = ACTIONS(734),
    [anon_sym_string] = ACTIONS(734),
    [anon_sym_int] = ACTIONS(734),
    [anon_sym_int8] = ACTIONS(734),
    [anon_sym_int16] = ACTIONS(734),
    [anon_sym_int24] = ACTIONS(734),
    [anon_sym_int32] = ACTIONS(734),
    [anon_sym_int40] = ACTIONS(734),
    [anon_sym_int48] = ACTIONS(734),
    [anon_sym_int56] = ACTIONS(734),
    [anon_sym_int64] = ACTIONS(734),
    [anon_sym_int72] = ACTIONS(734),
    [anon_sym_int80] = ACTIONS(734),
    [anon_sym_int88] = ACTIONS(734),
    [anon_sym_int96] = ACTIONS(734),
    [anon_sym_int104] = ACTIONS(734),
    [anon_sym_int112] = ACTIONS(734),
    [anon_sym_int120] = ACTIONS(734),
    [anon_sym_int128] = ACTIONS(734),
    [anon_sym_int136] = ACTIONS(734),
    [anon_sym_int144] = ACTIONS(734),
    [anon_sym_int152] = ACTIONS(734),
    [anon_sym_int160] = ACTIONS(734),
    [anon_sym_int168] = ACTIONS(734),
    [anon_sym_int176] = ACTIONS(734),
    [anon_sym_int184] = ACTIONS(734),
    [anon_sym_int192] = ACTIONS(734),
    [anon_sym_int200] = ACTIONS(734),
    [anon_sym_int208] = ACTIONS(734),
    [anon_sym_int216] = ACTIONS(734),
    [anon_sym_int224] = ACTIONS(734),
    [anon_sym_int232] = ACTIONS(734),
    [anon_sym_int240] = ACTIONS(734),
    [anon_sym_int248] = ACTIONS(734),
    [anon_sym_int256] = ACTIONS(734),
    [anon_sym_uint] = ACTIONS(734),
    [anon_sym_uint8] = ACTIONS(734),
    [anon_sym_uint16] = ACTIONS(734),
    [anon_sym_uint24] = ACTIONS(734),
    [anon_sym_uint32] = ACTIONS(734),
    [anon_sym_uint40] = ACTIONS(734),
    [anon_sym_uint48] = ACTIONS(734),
    [anon_sym_uint56] = ACTIONS(734),
    [anon_sym_uint64] = ACTIONS(734),
    [anon_sym_uint72] = ACTIONS(734),
    [anon_sym_uint80] = ACTIONS(734),
    [anon_sym_uint88] = ACTIONS(734),
    [anon_sym_uint96] = ACTIONS(734),
    [anon_sym_uint104] = ACTIONS(734),
    [anon_sym_uint112] = ACTIONS(734),
    [anon_sym_uint120] = ACTIONS(734),
    [anon_sym_uint128] = ACTIONS(734),
    [anon_sym_uint136] = ACTIONS(734),
    [anon_sym_uint144] = ACTIONS(734),
    [anon_sym_uint152] = ACTIONS(734),
    [anon_sym_uint160] = ACTIONS(734),
    [anon_sym_uint168] = ACTIONS(734),
    [anon_sym_uint176] = ACTIONS(734),
    [anon_sym_uint184] = ACTIONS(734),
    [anon_sym_uint192] = ACTIONS(734),
    [anon_sym_uint200] = ACTIONS(734),
    [anon_sym_uint208] = ACTIONS(734),
    [anon_sym_uint216] = ACTIONS(734),
    [anon_sym_uint224] = ACTIONS(734),
    [anon_sym_uint232] = ACTIONS(734),
    [anon_sym_uint240] = ACTIONS(734),
    [anon_sym_uint248] = ACTIONS(734),
    [anon_sym_uint256] = ACTIONS(734),
    [anon_sym_bytes] = ACTIONS(734),
    [anon_sym_bytes1] = ACTIONS(734),
    [anon_sym_bytes2] = ACTIONS(734),
    [anon_sym_bytes3] = ACTIONS(734),
    [anon_sym_bytes4] = ACTIONS(734),
    [anon_sym_bytes5] = ACTIONS(734),
    [anon_sym_bytes6] = ACTIONS(734),
    [anon_sym_bytes7] = ACTIONS(734),
    [anon_sym_bytes8] = ACTIONS(734),
    [anon_sym_bytes9] = ACTIONS(734),
    [anon_sym_bytes10] = ACTIONS(734),
    [anon_sym_bytes11] = ACTIONS(734),
    [anon_sym_bytes12] = ACTIONS(734),
    [anon_sym_bytes13] = ACTIONS(734),
    [anon_sym_bytes14] = ACTIONS(734),
    [anon_sym_bytes15] = ACTIONS(734),
    [anon_sym_bytes16] = ACTIONS(734),
    [anon_sym_bytes17] = ACTIONS(734),
    [anon_sym_bytes18] = ACTIONS(734),
    [anon_sym_bytes19] = ACTIONS(734),
    [anon_sym_bytes20] = ACTIONS(734),
    [anon_sym_bytes21] = ACTIONS(734),
    [anon_sym_bytes22] = ACTIONS(734),
    [anon_sym_bytes23] = ACTIONS(734),
    [anon_sym_bytes24] = ACTIONS(734),
    [anon_sym_bytes25] = ACTIONS(734),
    [anon_sym_bytes26] = ACTIONS(734),
    [anon_sym_bytes27] = ACTIONS(734),
    [anon_sym_bytes28] = ACTIONS(734),
    [anon_sym_bytes29] = ACTIONS(734),
    [anon_sym_bytes30] = ACTIONS(734),
    [anon_sym_bytes31] = ACTIONS(734),
    [anon_sym_bytes32] = ACTIONS(734),
    [anon_sym_fixed] = ACTIONS(734),
    [aux_sym__fixed_token1] = ACTIONS(734),
    [anon_sym_ufixed] = ACTIONS(734),
    [aux_sym__ufixed_token1] = ACTIONS(734),
    [sym_comment] = ACTIONS(3),
  },
  [168] = {
    [ts_builtin_sym_end] = ACTIONS(736),
    [sym_identifier] = ACTIONS(738),
    [anon_sym_pragma] = ACTIONS(738),
    [anon_sym_import] = ACTIONS(738),
    [anon_sym_type] = ACTIONS(738),
    [anon_sym_abstract] = ACTIONS(738),
    [anon_sym_contract] = ACTIONS(738),
    [anon_sym_error] = ACTIONS(738),
    [anon_sym_interface] = ACTIONS(738),
    [anon_sym_library] = ACTIONS(738),
    [anon_sym_struct] = ACTIONS(738),
    [anon_sym_enum] = ACTIONS(738),
    [anon_sym_event] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(738),
    [anon_sym_byte] = ACTIONS(738),
    [anon_sym_address] = ACTIONS(738),
    [anon_sym_var] = ACTIONS(738),
    [anon_sym_mapping] = ACTIONS(738),
    [anon_sym_bool] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_int] = ACTIONS(738),
    [anon_sym_int8] = ACTIONS(738),
    [anon_sym_int16] = ACTIONS(738),
    [anon_sym_int24] = ACTIONS(738),
    [anon_sym_int32] = ACTIONS(738),
    [anon_sym_int40] = ACTIONS(738),
    [anon_sym_int48] = ACTIONS(738),
    [anon_sym_int56] = ACTIONS(738),
    [anon_sym_int64] = ACTIONS(738),
    [anon_sym_int72] = ACTIONS(738),
    [anon_sym_int80] = ACTIONS(738),
    [anon_sym_int88] = ACTIONS(738),
    [anon_sym_int96] = ACTIONS(738),
    [anon_sym_int104] = ACTIONS(738),
    [anon_sym_int112] = ACTIONS(738),
    [anon_sym_int120] = ACTIONS(738),
    [anon_sym_int128] = ACTIONS(738),
    [anon_sym_int136] = ACTIONS(738),
    [anon_sym_int144] = ACTIONS(738),
    [anon_sym_int152] = ACTIONS(738),
    [anon_sym_int160] = ACTIONS(738),
    [anon_sym_int168] = ACTIONS(738),
    [anon_sym_int176] = ACTIONS(738),
    [anon_sym_int184] = ACTIONS(738),
    [anon_sym_int192] = ACTIONS(738),
    [anon_sym_int200] = ACTIONS(738),
    [anon_sym_int208] = ACTIONS(738),
    [anon_sym_int216] = ACTIONS(738),
    [anon_sym_int224] = ACTIONS(738),
    [anon_sym_int232] = ACTIONS(738),
    [anon_sym_int240] = ACTIONS(738),
    [anon_sym_int248] = ACTIONS(738),
    [anon_sym_int256] = ACTIONS(738),
    [anon_sym_uint] = ACTIONS(738),
    [anon_sym_uint8] = ACTIONS(738),
    [anon_sym_uint16] = ACTIONS(738),
    [anon_sym_uint24] = ACTIONS(738),
    [anon_sym_uint32] = ACTIONS(738),
    [anon_sym_uint40] = ACTIONS(738),
    [anon_sym_uint48] = ACTIONS(738),
    [anon_sym_uint56] = ACTIONS(738),
    [anon_sym_uint64] = ACTIONS(738),
    [anon_sym_uint72] = ACTIONS(738),
    [anon_sym_uint80] = ACTIONS(738),
    [anon_sym_uint88] = ACTIONS(738),
    [anon_sym_uint96] = ACTIONS(738),
    [anon_sym_uint104] = ACTIONS(738),
    [anon_sym_uint112] = ACTIONS(738),
    [anon_sym_uint120] = ACTIONS(738),
    [anon_sym_uint128] = ACTIONS(738),
    [anon_sym_uint136] = ACTIONS(738),
    [anon_sym_uint144] = ACTIONS(738),
    [anon_sym_uint152] = ACTIONS(738),
    [anon_sym_uint160] = ACTIONS(738),
    [anon_sym_uint168] = ACTIONS(738),
    [anon_sym_uint176] = ACTIONS(738),
    [anon_sym_uint184] = ACTIONS(738),
    [anon_sym_uint192] = ACTIONS(738),
    [anon_sym_uint200] = ACTIONS(738),
    [anon_sym_uint208] = ACTIONS(738),
    [anon_sym_uint216] = ACTIONS(738),
    [anon_sym_uint224] = ACTIONS(738),
    [anon_sym_uint232] = ACTIONS(738),
    [anon_sym_uint240] = ACTIONS(738),
    [anon_sym_uint248] = ACTIONS(738),
    [anon_sym_uint256] = ACTIONS(738),
    [anon_sym_bytes] = ACTIONS(738),
    [anon_sym_bytes1] = ACTIONS(738),
    [anon_sym_bytes2] = ACTIONS(738),
    [anon_sym_bytes3] = ACTIONS(738),
    [anon_sym_bytes4] = ACTIONS(738),
    [anon_sym_bytes5] = ACTIONS(738),
    [anon_sym_bytes6] = ACTIONS(738),
    [anon_sym_bytes7] = ACTIONS(738),
    [anon_sym_bytes8] = ACTIONS(738),
    [anon_sym_bytes9] = ACTIONS(738),
    [anon_sym_bytes10] = ACTIONS(738),
    [anon_sym_bytes11] = ACTIONS(738),
    [anon_sym_bytes12] = ACTIONS(738),
    [anon_sym_bytes13] = ACTIONS(738),
    [anon_sym_bytes14] = ACTIONS(738),
    [anon_sym_bytes15] = ACTIONS(738),
    [anon_sym_bytes16] = ACTIONS(738),
    [anon_sym_bytes17] = ACTIONS(738),
    [anon_sym_bytes18] = ACTIONS(738),
    [anon_sym_bytes19] = ACTIONS(738),
    [anon_sym_bytes20] = ACTIONS(738),
    [anon_sym_bytes21] = ACTIONS(738),
    [anon_sym_bytes22] = ACTIONS(738),
    [anon_sym_bytes23] = ACTIONS(738),
    [anon_sym_bytes24] = ACTIONS(738),
    [anon_sym_bytes25] = ACTIONS(738),
    [anon_sym_bytes26] = ACTIONS(738),
    [anon_sym_bytes27] = ACTIONS(738),
    [anon_sym_bytes28] = ACTIONS(738),
    [anon_sym_bytes29] = ACTIONS(738),
    [anon_sym_bytes30] = ACTIONS(738),
    [anon_sym_bytes31] = ACTIONS(738),
    [anon_sym_bytes32] = ACTIONS(738),
    [anon_sym_fixed] = ACTIONS(738),
    [aux_sym__fixed_token1] = ACTIONS(738),
    [anon_sym_ufixed] = ACTIONS(738),
    [aux_sym__ufixed_token1] = ACTIONS(738),
    [sym_comment] = ACTIONS(3),
  },
  [169] = {
    [ts_builtin_sym_end] = ACTIONS(740),
    [sym_identifier] = ACTIONS(742),
    [anon_sym_pragma] = ACTIONS(742),
    [anon_sym_import] = ACTIONS(742),
    [anon_sym_type] = ACTIONS(742),
    [anon_sym_abstract] = ACTIONS(742),
    [anon_sym_contract] = ACTIONS(742),
    [anon_sym_error] = ACTIONS(742),
    [anon_sym_interface] = ACTIONS(742),
    [anon_sym_library] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_event] = ACTIONS(742),
    [anon_sym_function] = ACTIONS(742),
    [anon_sym_byte] = ACTIONS(742),
    [anon_sym_address] = ACTIONS(742),
    [anon_sym_var] = ACTIONS(742),
    [anon_sym_mapping] = ACTIONS(742),
    [anon_sym_bool] = ACTIONS(742),
    [anon_sym_string] = ACTIONS(742),
    [anon_sym_int] = ACTIONS(742),
    [anon_sym_int8] = ACTIONS(742),
    [anon_sym_int16] = ACTIONS(742),
    [anon_sym_int24] = ACTIONS(742),
    [anon_sym_int32] = ACTIONS(742),
    [anon_sym_int40] = ACTIONS(742),
    [anon_sym_int48] = ACTIONS(742),
    [anon_sym_int56] = ACTIONS(742),
    [anon_sym_int64] = ACTIONS(742),
    [anon_sym_int72] = ACTIONS(742),
    [anon_sym_int80] = ACTIONS(742),
    [anon_sym_int88] = ACTIONS(742),
    [anon_sym_int96] = ACTIONS(742),
    [anon_sym_int104] = ACTIONS(742),
    [anon_sym_int112] = ACTIONS(742),
    [anon_sym_int120] = ACTIONS(742),
    [anon_sym_int128] = ACTIONS(742),
    [anon_sym_int136] = ACTIONS(742),
    [anon_sym_int144] = ACTIONS(742),
    [anon_sym_int152] = ACTIONS(742),
    [anon_sym_int160] = ACTIONS(742),
    [anon_sym_int168] = ACTIONS(742),
    [anon_sym_int176] = ACTIONS(742),
    [anon_sym_int184] = ACTIONS(742),
    [anon_sym_int192] = ACTIONS(742),
    [anon_sym_int200] = ACTIONS(742),
    [anon_sym_int208] = ACTIONS(742),
    [anon_sym_int216] = ACTIONS(742),
    [anon_sym_int224] = ACTIONS(742),
    [anon_sym_int232] = ACTIONS(742),
    [anon_sym_int240] = ACTIONS(742),
    [anon_sym_int248] = ACTIONS(742),
    [anon_sym_int256] = ACTIONS(742),
    [anon_sym_uint] = ACTIONS(742),
    [anon_sym_uint8] = ACTIONS(742),
    [anon_sym_uint16] = ACTIONS(742),
    [anon_sym_uint24] = ACTIONS(742),
    [anon_sym_uint32] = ACTIONS(742),
    [anon_sym_uint40] = ACTIONS(742),
    [anon_sym_uint48] = ACTIONS(742),
    [anon_sym_uint56] = ACTIONS(742),
    [anon_sym_uint64] = ACTIONS(742),
    [anon_sym_uint72] = ACTIONS(742),
    [anon_sym_uint80] = ACTIONS(742),
    [anon_sym_uint88] = ACTIONS(742),
    [anon_sym_uint96] = ACTIONS(742),
    [anon_sym_uint104] = ACTIONS(742),
    [anon_sym_uint112] = ACTIONS(742),
    [anon_sym_uint120] = ACTIONS(742),
    [anon_sym_uint128] = ACTIONS(742),
    [anon_sym_uint136] = ACTIONS(742),
    [anon_sym_uint144] = ACTIONS(742),
    [anon_sym_uint152] = ACTIONS(742),
    [anon_sym_uint160] = ACTIONS(742),
    [anon_sym_uint168] = ACTIONS(742),
    [anon_sym_uint176] = ACTIONS(742),
    [anon_sym_uint184] = ACTIONS(742),
    [anon_sym_uint192] = ACTIONS(742),
    [anon_sym_uint200] = ACTIONS(742),
    [anon_sym_uint208] = ACTIONS(742),
    [anon_sym_uint216] = ACTIONS(742),
    [anon_sym_uint224] = ACTIONS(742),
    [anon_sym_uint232] = ACTIONS(742),
    [anon_sym_uint240] = ACTIONS(742),
    [anon_sym_uint248] = ACTIONS(742),
    [anon_sym_uint256] = ACTIONS(742),
    [anon_sym_bytes] = ACTIONS(742),
    [anon_sym_bytes1] = ACTIONS(742),
    [anon_sym_bytes2] = ACTIONS(742),
    [anon_sym_bytes3] = ACTIONS(742),
    [anon_sym_bytes4] = ACTIONS(742),
    [anon_sym_bytes5] = ACTIONS(742),
    [anon_sym_bytes6] = ACTIONS(742),
    [anon_sym_bytes7] = ACTIONS(742),
    [anon_sym_bytes8] = ACTIONS(742),
    [anon_sym_bytes9] = ACTIONS(742),
    [anon_sym_bytes10] = ACTIONS(742),
    [anon_sym_bytes11] = ACTIONS(742),
    [anon_sym_bytes12] = ACTIONS(742),
    [anon_sym_bytes13] = ACTIONS(742),
    [anon_sym_bytes14] = ACTIONS(742),
    [anon_sym_bytes15] = ACTIONS(742),
    [anon_sym_bytes16] = ACTIONS(742),
    [anon_sym_bytes17] = ACTIONS(742),
    [anon_sym_bytes18] = ACTIONS(742),
    [anon_sym_bytes19] = ACTIONS(742),
    [anon_sym_bytes20] = ACTIONS(742),
    [anon_sym_bytes21] = ACTIONS(742),
    [anon_sym_bytes22] = ACTIONS(742),
    [anon_sym_bytes23] = ACTIONS(742),
    [anon_sym_bytes24] = ACTIONS(742),
    [anon_sym_bytes25] = ACTIONS(742),
    [anon_sym_bytes26] = ACTIONS(742),
    [anon_sym_bytes27] = ACTIONS(742),
    [anon_sym_bytes28] = ACTIONS(742),
    [anon_sym_bytes29] = ACTIONS(742),
    [anon_sym_bytes30] = ACTIONS(742),
    [anon_sym_bytes31] = ACTIONS(742),
    [anon_sym_bytes32] = ACTIONS(742),
    [anon_sym_fixed] = ACTIONS(742),
    [aux_sym__fixed_token1] = ACTIONS(742),
    [anon_sym_ufixed] = ACTIONS(742),
    [aux_sym__ufixed_token1] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
  },
  [170] = {
    [ts_builtin_sym_end] = ACTIONS(744),
    [sym_identifier] = ACTIONS(746),
    [anon_sym_pragma] = ACTIONS(746),
    [anon_sym_import] = ACTIONS(746),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_abstract] = ACTIONS(746),
    [anon_sym_contract] = ACTIONS(746),
    [anon_sym_error] = ACTIONS(746),
    [anon_sym_interface] = ACTIONS(746),
    [anon_sym_library] = ACTIONS(746),
    [anon_sym_struct] = ACTIONS(746),
    [anon_sym_enum] = ACTIONS(746),
    [anon_sym_event] = ACTIONS(746),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_byte] = ACTIONS(746),
    [anon_sym_address] = ACTIONS(746),
    [anon_sym_var] = ACTIONS(746),
    [anon_sym_mapping] = ACTIONS(746),
    [anon_sym_bool] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_int] = ACTIONS(746),
    [anon_sym_int8] = ACTIONS(746),
    [anon_sym_int16] = ACTIONS(746),
    [anon_sym_int24] = ACTIONS(746),
    [anon_sym_int32] = ACTIONS(746),
    [anon_sym_int40] = ACTIONS(746),
    [anon_sym_int48] = ACTIONS(746),
    [anon_sym_int56] = ACTIONS(746),
    [anon_sym_int64] = ACTIONS(746),
    [anon_sym_int72] = ACTIONS(746),
    [anon_sym_int80] = ACTIONS(746),
    [anon_sym_int88] = ACTIONS(746),
    [anon_sym_int96] = ACTIONS(746),
    [anon_sym_int104] = ACTIONS(746),
    [anon_sym_int112] = ACTIONS(746),
    [anon_sym_int120] = ACTIONS(746),
    [anon_sym_int128] = ACTIONS(746),
    [anon_sym_int136] = ACTIONS(746),
    [anon_sym_int144] = ACTIONS(746),
    [anon_sym_int152] = ACTIONS(746),
    [anon_sym_int160] = ACTIONS(746),
    [anon_sym_int168] = ACTIONS(746),
    [anon_sym_int176] = ACTIONS(746),
    [anon_sym_int184] = ACTIONS(746),
    [anon_sym_int192] = ACTIONS(746),
    [anon_sym_int200] = ACTIONS(746),
    [anon_sym_int208] = ACTIONS(746),
    [anon_sym_int216] = ACTIONS(746),
    [anon_sym_int224] = ACTIONS(746),
    [anon_sym_int232] = ACTIONS(746),
    [anon_sym_int240] = ACTIONS(746),
    [anon_sym_int248] = ACTIONS(746),
    [anon_sym_int256] = ACTIONS(746),
    [anon_sym_uint] = ACTIONS(746),
    [anon_sym_uint8] = ACTIONS(746),
    [anon_sym_uint16] = ACTIONS(746),
    [anon_sym_uint24] = ACTIONS(746),
    [anon_sym_uint32] = ACTIONS(746),
    [anon_sym_uint40] = ACTIONS(746),
    [anon_sym_uint48] = ACTIONS(746),
    [anon_sym_uint56] = ACTIONS(746),
    [anon_sym_uint64] = ACTIONS(746),
    [anon_sym_uint72] = ACTIONS(746),
    [anon_sym_uint80] = ACTIONS(746),
    [anon_sym_uint88] = ACTIONS(746),
    [anon_sym_uint96] = ACTIONS(746),
    [anon_sym_uint104] = ACTIONS(746),
    [anon_sym_uint112] = ACTIONS(746),
    [anon_sym_uint120] = ACTIONS(746),
    [anon_sym_uint128] = ACTIONS(746),
    [anon_sym_uint136] = ACTIONS(746),
    [anon_sym_uint144] = ACTIONS(746),
    [anon_sym_uint152] = ACTIONS(746),
    [anon_sym_uint160] = ACTIONS(746),
    [anon_sym_uint168] = ACTIONS(746),
    [anon_sym_uint176] = ACTIONS(746),
    [anon_sym_uint184] = ACTIONS(746),
    [anon_sym_uint192] = ACTIONS(746),
    [anon_sym_uint200] = ACTIONS(746),
    [anon_sym_uint208] = ACTIONS(746),
    [anon_sym_uint216] = ACTIONS(746),
    [anon_sym_uint224] = ACTIONS(746),
    [anon_sym_uint232] = ACTIONS(746),
    [anon_sym_uint240] = ACTIONS(746),
    [anon_sym_uint248] = ACTIONS(746),
    [anon_sym_uint256] = ACTIONS(746),
    [anon_sym_bytes] = ACTIONS(746),
    [anon_sym_bytes1] = ACTIONS(746),
    [anon_sym_bytes2] = ACTIONS(746),
    [anon_sym_bytes3] = ACTIONS(746),
    [anon_sym_bytes4] = ACTIONS(746),
    [anon_sym_bytes5] = ACTIONS(746),
    [anon_sym_bytes6] = ACTIONS(746),
    [anon_sym_bytes7] = ACTIONS(746),
    [anon_sym_bytes8] = ACTIONS(746),
    [anon_sym_bytes9] = ACTIONS(746),
    [anon_sym_bytes10] = ACTIONS(746),
    [anon_sym_bytes11] = ACTIONS(746),
    [anon_sym_bytes12] = ACTIONS(746),
    [anon_sym_bytes13] = ACTIONS(746),
    [anon_sym_bytes14] = ACTIONS(746),
    [anon_sym_bytes15] = ACTIONS(746),
    [anon_sym_bytes16] = ACTIONS(746),
    [anon_sym_bytes17] = ACTIONS(746),
    [anon_sym_bytes18] = ACTIONS(746),
    [anon_sym_bytes19] = ACTIONS(746),
    [anon_sym_bytes20] = ACTIONS(746),
    [anon_sym_bytes21] = ACTIONS(746),
    [anon_sym_bytes22] = ACTIONS(746),
    [anon_sym_bytes23] = ACTIONS(746),
    [anon_sym_bytes24] = ACTIONS(746),
    [anon_sym_bytes25] = ACTIONS(746),
    [anon_sym_bytes26] = ACTIONS(746),
    [anon_sym_bytes27] = ACTIONS(746),
    [anon_sym_bytes28] = ACTIONS(746),
    [anon_sym_bytes29] = ACTIONS(746),
    [anon_sym_bytes30] = ACTIONS(746),
    [anon_sym_bytes31] = ACTIONS(746),
    [anon_sym_bytes32] = ACTIONS(746),
    [anon_sym_fixed] = ACTIONS(746),
    [aux_sym__fixed_token1] = ACTIONS(746),
    [anon_sym_ufixed] = ACTIONS(746),
    [aux_sym__ufixed_token1] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_type_name] = STATE(712),
    [sym__array_type] = STATE(331),
    [sym__function_type] = STATE(321),
    [sym_user_defined_type] = STATE(331),
    [sym__identifier_path] = STATE(318),
    [sym__mapping] = STATE(335),
    [sym_primitive_type] = STATE(331),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_function] = ACTIONS(67),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_mapping] = ACTIONS(37),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [172] = {
    [ts_builtin_sym_end] = ACTIONS(748),
    [sym_identifier] = ACTIONS(750),
    [anon_sym_pragma] = ACTIONS(750),
    [anon_sym_import] = ACTIONS(750),
    [anon_sym_type] = ACTIONS(750),
    [anon_sym_abstract] = ACTIONS(750),
    [anon_sym_contract] = ACTIONS(750),
    [anon_sym_error] = ACTIONS(750),
    [anon_sym_interface] = ACTIONS(750),
    [anon_sym_library] = ACTIONS(750),
    [anon_sym_struct] = ACTIONS(750),
    [anon_sym_enum] = ACTIONS(750),
    [anon_sym_event] = ACTIONS(750),
    [anon_sym_function] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(750),
    [anon_sym_address] = ACTIONS(750),
    [anon_sym_var] = ACTIONS(750),
    [anon_sym_mapping] = ACTIONS(750),
    [anon_sym_bool] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_int] = ACTIONS(750),
    [anon_sym_int8] = ACTIONS(750),
    [anon_sym_int16] = ACTIONS(750),
    [anon_sym_int24] = ACTIONS(750),
    [anon_sym_int32] = ACTIONS(750),
    [anon_sym_int40] = ACTIONS(750),
    [anon_sym_int48] = ACTIONS(750),
    [anon_sym_int56] = ACTIONS(750),
    [anon_sym_int64] = ACTIONS(750),
    [anon_sym_int72] = ACTIONS(750),
    [anon_sym_int80] = ACTIONS(750),
    [anon_sym_int88] = ACTIONS(750),
    [anon_sym_int96] = ACTIONS(750),
    [anon_sym_int104] = ACTIONS(750),
    [anon_sym_int112] = ACTIONS(750),
    [anon_sym_int120] = ACTIONS(750),
    [anon_sym_int128] = ACTIONS(750),
    [anon_sym_int136] = ACTIONS(750),
    [anon_sym_int144] = ACTIONS(750),
    [anon_sym_int152] = ACTIONS(750),
    [anon_sym_int160] = ACTIONS(750),
    [anon_sym_int168] = ACTIONS(750),
    [anon_sym_int176] = ACTIONS(750),
    [anon_sym_int184] = ACTIONS(750),
    [anon_sym_int192] = ACTIONS(750),
    [anon_sym_int200] = ACTIONS(750),
    [anon_sym_int208] = ACTIONS(750),
    [anon_sym_int216] = ACTIONS(750),
    [anon_sym_int224] = ACTIONS(750),
    [anon_sym_int232] = ACTIONS(750),
    [anon_sym_int240] = ACTIONS(750),
    [anon_sym_int248] = ACTIONS(750),
    [anon_sym_int256] = ACTIONS(750),
    [anon_sym_uint] = ACTIONS(750),
    [anon_sym_uint8] = ACTIONS(750),
    [anon_sym_uint16] = ACTIONS(750),
    [anon_sym_uint24] = ACTIONS(750),
    [anon_sym_uint32] = ACTIONS(750),
    [anon_sym_uint40] = ACTIONS(750),
    [anon_sym_uint48] = ACTIONS(750),
    [anon_sym_uint56] = ACTIONS(750),
    [anon_sym_uint64] = ACTIONS(750),
    [anon_sym_uint72] = ACTIONS(750),
    [anon_sym_uint80] = ACTIONS(750),
    [anon_sym_uint88] = ACTIONS(750),
    [anon_sym_uint96] = ACTIONS(750),
    [anon_sym_uint104] = ACTIONS(750),
    [anon_sym_uint112] = ACTIONS(750),
    [anon_sym_uint120] = ACTIONS(750),
    [anon_sym_uint128] = ACTIONS(750),
    [anon_sym_uint136] = ACTIONS(750),
    [anon_sym_uint144] = ACTIONS(750),
    [anon_sym_uint152] = ACTIONS(750),
    [anon_sym_uint160] = ACTIONS(750),
    [anon_sym_uint168] = ACTIONS(750),
    [anon_sym_uint176] = ACTIONS(750),
    [anon_sym_uint184] = ACTIONS(750),
    [anon_sym_uint192] = ACTIONS(750),
    [anon_sym_uint200] = ACTIONS(750),
    [anon_sym_uint208] = ACTIONS(750),
    [anon_sym_uint216] = ACTIONS(750),
    [anon_sym_uint224] = ACTIONS(750),
    [anon_sym_uint232] = ACTIONS(750),
    [anon_sym_uint240] = ACTIONS(750),
    [anon_sym_uint248] = ACTIONS(750),
    [anon_sym_uint256] = ACTIONS(750),
    [anon_sym_bytes] = ACTIONS(750),
    [anon_sym_bytes1] = ACTIONS(750),
    [anon_sym_bytes2] = ACTIONS(750),
    [anon_sym_bytes3] = ACTIONS(750),
    [anon_sym_bytes4] = ACTIONS(750),
    [anon_sym_bytes5] = ACTIONS(750),
    [anon_sym_bytes6] = ACTIONS(750),
    [anon_sym_bytes7] = ACTIONS(750),
    [anon_sym_bytes8] = ACTIONS(750),
    [anon_sym_bytes9] = ACTIONS(750),
    [anon_sym_bytes10] = ACTIONS(750),
    [anon_sym_bytes11] = ACTIONS(750),
    [anon_sym_bytes12] = ACTIONS(750),
    [anon_sym_bytes13] = ACTIONS(750),
    [anon_sym_bytes14] = ACTIONS(750),
    [anon_sym_bytes15] = ACTIONS(750),
    [anon_sym_bytes16] = ACTIONS(750),
    [anon_sym_bytes17] = ACTIONS(750),
    [anon_sym_bytes18] = ACTIONS(750),
    [anon_sym_bytes19] = ACTIONS(750),
    [anon_sym_bytes20] = ACTIONS(750),
    [anon_sym_bytes21] = ACTIONS(750),
    [anon_sym_bytes22] = ACTIONS(750),
    [anon_sym_bytes23] = ACTIONS(750),
    [anon_sym_bytes24] = ACTIONS(750),
    [anon_sym_bytes25] = ACTIONS(750),
    [anon_sym_bytes26] = ACTIONS(750),
    [anon_sym_bytes27] = ACTIONS(750),
    [anon_sym_bytes28] = ACTIONS(750),
    [anon_sym_bytes29] = ACTIONS(750),
    [anon_sym_bytes30] = ACTIONS(750),
    [anon_sym_bytes31] = ACTIONS(750),
    [anon_sym_bytes32] = ACTIONS(750),
    [anon_sym_fixed] = ACTIONS(750),
    [aux_sym__fixed_token1] = ACTIONS(750),
    [anon_sym_ufixed] = ACTIONS(750),
    [aux_sym__ufixed_token1] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [173] = {
    [ts_builtin_sym_end] = ACTIONS(752),
    [sym_identifier] = ACTIONS(754),
    [anon_sym_pragma] = ACTIONS(754),
    [anon_sym_import] = ACTIONS(754),
    [anon_sym_type] = ACTIONS(754),
    [anon_sym_abstract] = ACTIONS(754),
    [anon_sym_contract] = ACTIONS(754),
    [anon_sym_error] = ACTIONS(754),
    [anon_sym_interface] = ACTIONS(754),
    [anon_sym_library] = ACTIONS(754),
    [anon_sym_struct] = ACTIONS(754),
    [anon_sym_enum] = ACTIONS(754),
    [anon_sym_event] = ACTIONS(754),
    [anon_sym_function] = ACTIONS(754),
    [anon_sym_byte] = ACTIONS(754),
    [anon_sym_address] = ACTIONS(754),
    [anon_sym_var] = ACTIONS(754),
    [anon_sym_mapping] = ACTIONS(754),
    [anon_sym_bool] = ACTIONS(754),
    [anon_sym_string] = ACTIONS(754),
    [anon_sym_int] = ACTIONS(754),
    [anon_sym_int8] = ACTIONS(754),
    [anon_sym_int16] = ACTIONS(754),
    [anon_sym_int24] = ACTIONS(754),
    [anon_sym_int32] = ACTIONS(754),
    [anon_sym_int40] = ACTIONS(754),
    [anon_sym_int48] = ACTIONS(754),
    [anon_sym_int56] = ACTIONS(754),
    [anon_sym_int64] = ACTIONS(754),
    [anon_sym_int72] = ACTIONS(754),
    [anon_sym_int80] = ACTIONS(754),
    [anon_sym_int88] = ACTIONS(754),
    [anon_sym_int96] = ACTIONS(754),
    [anon_sym_int104] = ACTIONS(754),
    [anon_sym_int112] = ACTIONS(754),
    [anon_sym_int120] = ACTIONS(754),
    [anon_sym_int128] = ACTIONS(754),
    [anon_sym_int136] = ACTIONS(754),
    [anon_sym_int144] = ACTIONS(754),
    [anon_sym_int152] = ACTIONS(754),
    [anon_sym_int160] = ACTIONS(754),
    [anon_sym_int168] = ACTIONS(754),
    [anon_sym_int176] = ACTIONS(754),
    [anon_sym_int184] = ACTIONS(754),
    [anon_sym_int192] = ACTIONS(754),
    [anon_sym_int200] = ACTIONS(754),
    [anon_sym_int208] = ACTIONS(754),
    [anon_sym_int216] = ACTIONS(754),
    [anon_sym_int224] = ACTIONS(754),
    [anon_sym_int232] = ACTIONS(754),
    [anon_sym_int240] = ACTIONS(754),
    [anon_sym_int248] = ACTIONS(754),
    [anon_sym_int256] = ACTIONS(754),
    [anon_sym_uint] = ACTIONS(754),
    [anon_sym_uint8] = ACTIONS(754),
    [anon_sym_uint16] = ACTIONS(754),
    [anon_sym_uint24] = ACTIONS(754),
    [anon_sym_uint32] = ACTIONS(754),
    [anon_sym_uint40] = ACTIONS(754),
    [anon_sym_uint48] = ACTIONS(754),
    [anon_sym_uint56] = ACTIONS(754),
    [anon_sym_uint64] = ACTIONS(754),
    [anon_sym_uint72] = ACTIONS(754),
    [anon_sym_uint80] = ACTIONS(754),
    [anon_sym_uint88] = ACTIONS(754),
    [anon_sym_uint96] = ACTIONS(754),
    [anon_sym_uint104] = ACTIONS(754),
    [anon_sym_uint112] = ACTIONS(754),
    [anon_sym_uint120] = ACTIONS(754),
    [anon_sym_uint128] = ACTIONS(754),
    [anon_sym_uint136] = ACTIONS(754),
    [anon_sym_uint144] = ACTIONS(754),
    [anon_sym_uint152] = ACTIONS(754),
    [anon_sym_uint160] = ACTIONS(754),
    [anon_sym_uint168] = ACTIONS(754),
    [anon_sym_uint176] = ACTIONS(754),
    [anon_sym_uint184] = ACTIONS(754),
    [anon_sym_uint192] = ACTIONS(754),
    [anon_sym_uint200] = ACTIONS(754),
    [anon_sym_uint208] = ACTIONS(754),
    [anon_sym_uint216] = ACTIONS(754),
    [anon_sym_uint224] = ACTIONS(754),
    [anon_sym_uint232] = ACTIONS(754),
    [anon_sym_uint240] = ACTIONS(754),
    [anon_sym_uint248] = ACTIONS(754),
    [anon_sym_uint256] = ACTIONS(754),
    [anon_sym_bytes] = ACTIONS(754),
    [anon_sym_bytes1] = ACTIONS(754),
    [anon_sym_bytes2] = ACTIONS(754),
    [anon_sym_bytes3] = ACTIONS(754),
    [anon_sym_bytes4] = ACTIONS(754),
    [anon_sym_bytes5] = ACTIONS(754),
    [anon_sym_bytes6] = ACTIONS(754),
    [anon_sym_bytes7] = ACTIONS(754),
    [anon_sym_bytes8] = ACTIONS(754),
    [anon_sym_bytes9] = ACTIONS(754),
    [anon_sym_bytes10] = ACTIONS(754),
    [anon_sym_bytes11] = ACTIONS(754),
    [anon_sym_bytes12] = ACTIONS(754),
    [anon_sym_bytes13] = ACTIONS(754),
    [anon_sym_bytes14] = ACTIONS(754),
    [anon_sym_bytes15] = ACTIONS(754),
    [anon_sym_bytes16] = ACTIONS(754),
    [anon_sym_bytes17] = ACTIONS(754),
    [anon_sym_bytes18] = ACTIONS(754),
    [anon_sym_bytes19] = ACTIONS(754),
    [anon_sym_bytes20] = ACTIONS(754),
    [anon_sym_bytes21] = ACTIONS(754),
    [anon_sym_bytes22] = ACTIONS(754),
    [anon_sym_bytes23] = ACTIONS(754),
    [anon_sym_bytes24] = ACTIONS(754),
    [anon_sym_bytes25] = ACTIONS(754),
    [anon_sym_bytes26] = ACTIONS(754),
    [anon_sym_bytes27] = ACTIONS(754),
    [anon_sym_bytes28] = ACTIONS(754),
    [anon_sym_bytes29] = ACTIONS(754),
    [anon_sym_bytes30] = ACTIONS(754),
    [anon_sym_bytes31] = ACTIONS(754),
    [anon_sym_bytes32] = ACTIONS(754),
    [anon_sym_fixed] = ACTIONS(754),
    [aux_sym__fixed_token1] = ACTIONS(754),
    [anon_sym_ufixed] = ACTIONS(754),
    [aux_sym__ufixed_token1] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_identifier] = ACTIONS(750),
    [anon_sym_RBRACE] = ACTIONS(748),
    [anon_sym_type] = ACTIONS(750),
    [anon_sym_error] = ACTIONS(750),
    [anon_sym_struct] = ACTIONS(750),
    [anon_sym_enum] = ACTIONS(750),
    [anon_sym_event] = ACTIONS(750),
    [anon_sym_using] = ACTIONS(750),
    [anon_sym_function] = ACTIONS(750),
    [anon_sym_byte] = ACTIONS(750),
    [anon_sym_address] = ACTIONS(750),
    [anon_sym_var] = ACTIONS(750),
    [anon_sym_modifier] = ACTIONS(750),
    [anon_sym_constructor] = ACTIONS(750),
    [anon_sym_fallback] = ACTIONS(750),
    [anon_sym_receive] = ACTIONS(750),
    [anon_sym_mapping] = ACTIONS(750),
    [anon_sym_bool] = ACTIONS(750),
    [anon_sym_string] = ACTIONS(750),
    [anon_sym_int] = ACTIONS(750),
    [anon_sym_int8] = ACTIONS(750),
    [anon_sym_int16] = ACTIONS(750),
    [anon_sym_int24] = ACTIONS(750),
    [anon_sym_int32] = ACTIONS(750),
    [anon_sym_int40] = ACTIONS(750),
    [anon_sym_int48] = ACTIONS(750),
    [anon_sym_int56] = ACTIONS(750),
    [anon_sym_int64] = ACTIONS(750),
    [anon_sym_int72] = ACTIONS(750),
    [anon_sym_int80] = ACTIONS(750),
    [anon_sym_int88] = ACTIONS(750),
    [anon_sym_int96] = ACTIONS(750),
    [anon_sym_int104] = ACTIONS(750),
    [anon_sym_int112] = ACTIONS(750),
    [anon_sym_int120] = ACTIONS(750),
    [anon_sym_int128] = ACTIONS(750),
    [anon_sym_int136] = ACTIONS(750),
    [anon_sym_int144] = ACTIONS(750),
    [anon_sym_int152] = ACTIONS(750),
    [anon_sym_int160] = ACTIONS(750),
    [anon_sym_int168] = ACTIONS(750),
    [anon_sym_int176] = ACTIONS(750),
    [anon_sym_int184] = ACTIONS(750),
    [anon_sym_int192] = ACTIONS(750),
    [anon_sym_int200] = ACTIONS(750),
    [anon_sym_int208] = ACTIONS(750),
    [anon_sym_int216] = ACTIONS(750),
    [anon_sym_int224] = ACTIONS(750),
    [anon_sym_int232] = ACTIONS(750),
    [anon_sym_int240] = ACTIONS(750),
    [anon_sym_int248] = ACTIONS(750),
    [anon_sym_int256] = ACTIONS(750),
    [anon_sym_uint] = ACTIONS(750),
    [anon_sym_uint8] = ACTIONS(750),
    [anon_sym_uint16] = ACTIONS(750),
    [anon_sym_uint24] = ACTIONS(750),
    [anon_sym_uint32] = ACTIONS(750),
    [anon_sym_uint40] = ACTIONS(750),
    [anon_sym_uint48] = ACTIONS(750),
    [anon_sym_uint56] = ACTIONS(750),
    [anon_sym_uint64] = ACTIONS(750),
    [anon_sym_uint72] = ACTIONS(750),
    [anon_sym_uint80] = ACTIONS(750),
    [anon_sym_uint88] = ACTIONS(750),
    [anon_sym_uint96] = ACTIONS(750),
    [anon_sym_uint104] = ACTIONS(750),
    [anon_sym_uint112] = ACTIONS(750),
    [anon_sym_uint120] = ACTIONS(750),
    [anon_sym_uint128] = ACTIONS(750),
    [anon_sym_uint136] = ACTIONS(750),
    [anon_sym_uint144] = ACTIONS(750),
    [anon_sym_uint152] = ACTIONS(750),
    [anon_sym_uint160] = ACTIONS(750),
    [anon_sym_uint168] = ACTIONS(750),
    [anon_sym_uint176] = ACTIONS(750),
    [anon_sym_uint184] = ACTIONS(750),
    [anon_sym_uint192] = ACTIONS(750),
    [anon_sym_uint200] = ACTIONS(750),
    [anon_sym_uint208] = ACTIONS(750),
    [anon_sym_uint216] = ACTIONS(750),
    [anon_sym_uint224] = ACTIONS(750),
    [anon_sym_uint232] = ACTIONS(750),
    [anon_sym_uint240] = ACTIONS(750),
    [anon_sym_uint248] = ACTIONS(750),
    [anon_sym_uint256] = ACTIONS(750),
    [anon_sym_bytes] = ACTIONS(750),
    [anon_sym_bytes1] = ACTIONS(750),
    [anon_sym_bytes2] = ACTIONS(750),
    [anon_sym_bytes3] = ACTIONS(750),
    [anon_sym_bytes4] = ACTIONS(750),
    [anon_sym_bytes5] = ACTIONS(750),
    [anon_sym_bytes6] = ACTIONS(750),
    [anon_sym_bytes7] = ACTIONS(750),
    [anon_sym_bytes8] = ACTIONS(750),
    [anon_sym_bytes9] = ACTIONS(750),
    [anon_sym_bytes10] = ACTIONS(750),
    [anon_sym_bytes11] = ACTIONS(750),
    [anon_sym_bytes12] = ACTIONS(750),
    [anon_sym_bytes13] = ACTIONS(750),
    [anon_sym_bytes14] = ACTIONS(750),
    [anon_sym_bytes15] = ACTIONS(750),
    [anon_sym_bytes16] = ACTIONS(750),
    [anon_sym_bytes17] = ACTIONS(750),
    [anon_sym_bytes18] = ACTIONS(750),
    [anon_sym_bytes19] = ACTIONS(750),
    [anon_sym_bytes20] = ACTIONS(750),
    [anon_sym_bytes21] = ACTIONS(750),
    [anon_sym_bytes22] = ACTIONS(750),
    [anon_sym_bytes23] = ACTIONS(750),
    [anon_sym_bytes24] = ACTIONS(750),
    [anon_sym_bytes25] = ACTIONS(750),
    [anon_sym_bytes26] = ACTIONS(750),
    [anon_sym_bytes27] = ACTIONS(750),
    [anon_sym_bytes28] = ACTIONS(750),
    [anon_sym_bytes29] = ACTIONS(750),
    [anon_sym_bytes30] = ACTIONS(750),
    [anon_sym_bytes31] = ACTIONS(750),
    [anon_sym_bytes32] = ACTIONS(750),
    [anon_sym_fixed] = ACTIONS(750),
    [aux_sym__fixed_token1] = ACTIONS(750),
    [anon_sym_ufixed] = ACTIONS(750),
    [aux_sym__ufixed_token1] = ACTIONS(750),
    [sym_comment] = ACTIONS(3),
  },
  [175] = {
    [sym_identifier] = ACTIONS(714),
    [anon_sym_RBRACE] = ACTIONS(712),
    [anon_sym_type] = ACTIONS(714),
    [anon_sym_error] = ACTIONS(714),
    [anon_sym_struct] = ACTIONS(714),
    [anon_sym_enum] = ACTIONS(714),
    [anon_sym_event] = ACTIONS(714),
    [anon_sym_using] = ACTIONS(714),
    [anon_sym_function] = ACTIONS(714),
    [anon_sym_byte] = ACTIONS(714),
    [anon_sym_address] = ACTIONS(714),
    [anon_sym_var] = ACTIONS(714),
    [anon_sym_modifier] = ACTIONS(714),
    [anon_sym_constructor] = ACTIONS(714),
    [anon_sym_fallback] = ACTIONS(714),
    [anon_sym_receive] = ACTIONS(714),
    [anon_sym_mapping] = ACTIONS(714),
    [anon_sym_bool] = ACTIONS(714),
    [anon_sym_string] = ACTIONS(714),
    [anon_sym_int] = ACTIONS(714),
    [anon_sym_int8] = ACTIONS(714),
    [anon_sym_int16] = ACTIONS(714),
    [anon_sym_int24] = ACTIONS(714),
    [anon_sym_int32] = ACTIONS(714),
    [anon_sym_int40] = ACTIONS(714),
    [anon_sym_int48] = ACTIONS(714),
    [anon_sym_int56] = ACTIONS(714),
    [anon_sym_int64] = ACTIONS(714),
    [anon_sym_int72] = ACTIONS(714),
    [anon_sym_int80] = ACTIONS(714),
    [anon_sym_int88] = ACTIONS(714),
    [anon_sym_int96] = ACTIONS(714),
    [anon_sym_int104] = ACTIONS(714),
    [anon_sym_int112] = ACTIONS(714),
    [anon_sym_int120] = ACTIONS(714),
    [anon_sym_int128] = ACTIONS(714),
    [anon_sym_int136] = ACTIONS(714),
    [anon_sym_int144] = ACTIONS(714),
    [anon_sym_int152] = ACTIONS(714),
    [anon_sym_int160] = ACTIONS(714),
    [anon_sym_int168] = ACTIONS(714),
    [anon_sym_int176] = ACTIONS(714),
    [anon_sym_int184] = ACTIONS(714),
    [anon_sym_int192] = ACTIONS(714),
    [anon_sym_int200] = ACTIONS(714),
    [anon_sym_int208] = ACTIONS(714),
    [anon_sym_int216] = ACTIONS(714),
    [anon_sym_int224] = ACTIONS(714),
    [anon_sym_int232] = ACTIONS(714),
    [anon_sym_int240] = ACTIONS(714),
    [anon_sym_int248] = ACTIONS(714),
    [anon_sym_int256] = ACTIONS(714),
    [anon_sym_uint] = ACTIONS(714),
    [anon_sym_uint8] = ACTIONS(714),
    [anon_sym_uint16] = ACTIONS(714),
    [anon_sym_uint24] = ACTIONS(714),
    [anon_sym_uint32] = ACTIONS(714),
    [anon_sym_uint40] = ACTIONS(714),
    [anon_sym_uint48] = ACTIONS(714),
    [anon_sym_uint56] = ACTIONS(714),
    [anon_sym_uint64] = ACTIONS(714),
    [anon_sym_uint72] = ACTIONS(714),
    [anon_sym_uint80] = ACTIONS(714),
    [anon_sym_uint88] = ACTIONS(714),
    [anon_sym_uint96] = ACTIONS(714),
    [anon_sym_uint104] = ACTIONS(714),
    [anon_sym_uint112] = ACTIONS(714),
    [anon_sym_uint120] = ACTIONS(714),
    [anon_sym_uint128] = ACTIONS(714),
    [anon_sym_uint136] = ACTIONS(714),
    [anon_sym_uint144] = ACTIONS(714),
    [anon_sym_uint152] = ACTIONS(714),
    [anon_sym_uint160] = ACTIONS(714),
    [anon_sym_uint168] = ACTIONS(714),
    [anon_sym_uint176] = ACTIONS(714),
    [anon_sym_uint184] = ACTIONS(714),
    [anon_sym_uint192] = ACTIONS(714),
    [anon_sym_uint200] = ACTIONS(714),
    [anon_sym_uint208] = ACTIONS(714),
    [anon_sym_uint216] = ACTIONS(714),
    [anon_sym_uint224] = ACTIONS(714),
    [anon_sym_uint232] = ACTIONS(714),
    [anon_sym_uint240] = ACTIONS(714),
    [anon_sym_uint248] = ACTIONS(714),
    [anon_sym_uint256] = ACTIONS(714),
    [anon_sym_bytes] = ACTIONS(714),
    [anon_sym_bytes1] = ACTIONS(714),
    [anon_sym_bytes2] = ACTIONS(714),
    [anon_sym_bytes3] = ACTIONS(714),
    [anon_sym_bytes4] = ACTIONS(714),
    [anon_sym_bytes5] = ACTIONS(714),
    [anon_sym_bytes6] = ACTIONS(714),
    [anon_sym_bytes7] = ACTIONS(714),
    [anon_sym_bytes8] = ACTIONS(714),
    [anon_sym_bytes9] = ACTIONS(714),
    [anon_sym_bytes10] = ACTIONS(714),
    [anon_sym_bytes11] = ACTIONS(714),
    [anon_sym_bytes12] = ACTIONS(714),
    [anon_sym_bytes13] = ACTIONS(714),
    [anon_sym_bytes14] = ACTIONS(714),
    [anon_sym_bytes15] = ACTIONS(714),
    [anon_sym_bytes16] = ACTIONS(714),
    [anon_sym_bytes17] = ACTIONS(714),
    [anon_sym_bytes18] = ACTIONS(714),
    [anon_sym_bytes19] = ACTIONS(714),
    [anon_sym_bytes20] = ACTIONS(714),
    [anon_sym_bytes21] = ACTIONS(714),
    [anon_sym_bytes22] = ACTIONS(714),
    [anon_sym_bytes23] = ACTIONS(714),
    [anon_sym_bytes24] = ACTIONS(714),
    [anon_sym_bytes25] = ACTIONS(714),
    [anon_sym_bytes26] = ACTIONS(714),
    [anon_sym_bytes27] = ACTIONS(714),
    [anon_sym_bytes28] = ACTIONS(714),
    [anon_sym_bytes29] = ACTIONS(714),
    [anon_sym_bytes30] = ACTIONS(714),
    [anon_sym_bytes31] = ACTIONS(714),
    [anon_sym_bytes32] = ACTIONS(714),
    [anon_sym_fixed] = ACTIONS(714),
    [aux_sym__fixed_token1] = ACTIONS(714),
    [anon_sym_ufixed] = ACTIONS(714),
    [aux_sym__ufixed_token1] = ACTIONS(714),
    [sym_comment] = ACTIONS(3),
  },
  [176] = {
    [sym_identifier] = ACTIONS(702),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_type] = ACTIONS(702),
    [anon_sym_error] = ACTIONS(702),
    [anon_sym_struct] = ACTIONS(702),
    [anon_sym_enum] = ACTIONS(702),
    [anon_sym_event] = ACTIONS(702),
    [anon_sym_using] = ACTIONS(702),
    [anon_sym_function] = ACTIONS(702),
    [anon_sym_byte] = ACTIONS(702),
    [anon_sym_address] = ACTIONS(702),
    [anon_sym_var] = ACTIONS(702),
    [anon_sym_modifier] = ACTIONS(702),
    [anon_sym_constructor] = ACTIONS(702),
    [anon_sym_fallback] = ACTIONS(702),
    [anon_sym_receive] = ACTIONS(702),
    [anon_sym_mapping] = ACTIONS(702),
    [anon_sym_bool] = ACTIONS(702),
    [anon_sym_string] = ACTIONS(702),
    [anon_sym_int] = ACTIONS(702),
    [anon_sym_int8] = ACTIONS(702),
    [anon_sym_int16] = ACTIONS(702),
    [anon_sym_int24] = ACTIONS(702),
    [anon_sym_int32] = ACTIONS(702),
    [anon_sym_int40] = ACTIONS(702),
    [anon_sym_int48] = ACTIONS(702),
    [anon_sym_int56] = ACTIONS(702),
    [anon_sym_int64] = ACTIONS(702),
    [anon_sym_int72] = ACTIONS(702),
    [anon_sym_int80] = ACTIONS(702),
    [anon_sym_int88] = ACTIONS(702),
    [anon_sym_int96] = ACTIONS(702),
    [anon_sym_int104] = ACTIONS(702),
    [anon_sym_int112] = ACTIONS(702),
    [anon_sym_int120] = ACTIONS(702),
    [anon_sym_int128] = ACTIONS(702),
    [anon_sym_int136] = ACTIONS(702),
    [anon_sym_int144] = ACTIONS(702),
    [anon_sym_int152] = ACTIONS(702),
    [anon_sym_int160] = ACTIONS(702),
    [anon_sym_int168] = ACTIONS(702),
    [anon_sym_int176] = ACTIONS(702),
    [anon_sym_int184] = ACTIONS(702),
    [anon_sym_int192] = ACTIONS(702),
    [anon_sym_int200] = ACTIONS(702),
    [anon_sym_int208] = ACTIONS(702),
    [anon_sym_int216] = ACTIONS(702),
    [anon_sym_int224] = ACTIONS(702),
    [anon_sym_int232] = ACTIONS(702),
    [anon_sym_int240] = ACTIONS(702),
    [anon_sym_int248] = ACTIONS(702),
    [anon_sym_int256] = ACTIONS(702),
    [anon_sym_uint] = ACTIONS(702),
    [anon_sym_uint8] = ACTIONS(702),
    [anon_sym_uint16] = ACTIONS(702),
    [anon_sym_uint24] = ACTIONS(702),
    [anon_sym_uint32] = ACTIONS(702),
    [anon_sym_uint40] = ACTIONS(702),
    [anon_sym_uint48] = ACTIONS(702),
    [anon_sym_uint56] = ACTIONS(702),
    [anon_sym_uint64] = ACTIONS(702),
    [anon_sym_uint72] = ACTIONS(702),
    [anon_sym_uint80] = ACTIONS(702),
    [anon_sym_uint88] = ACTIONS(702),
    [anon_sym_uint96] = ACTIONS(702),
    [anon_sym_uint104] = ACTIONS(702),
    [anon_sym_uint112] = ACTIONS(702),
    [anon_sym_uint120] = ACTIONS(702),
    [anon_sym_uint128] = ACTIONS(702),
    [anon_sym_uint136] = ACTIONS(702),
    [anon_sym_uint144] = ACTIONS(702),
    [anon_sym_uint152] = ACTIONS(702),
    [anon_sym_uint160] = ACTIONS(702),
    [anon_sym_uint168] = ACTIONS(702),
    [anon_sym_uint176] = ACTIONS(702),
    [anon_sym_uint184] = ACTIONS(702),
    [anon_sym_uint192] = ACTIONS(702),
    [anon_sym_uint200] = ACTIONS(702),
    [anon_sym_uint208] = ACTIONS(702),
    [anon_sym_uint216] = ACTIONS(702),
    [anon_sym_uint224] = ACTIONS(702),
    [anon_sym_uint232] = ACTIONS(702),
    [anon_sym_uint240] = ACTIONS(702),
    [anon_sym_uint248] = ACTIONS(702),
    [anon_sym_uint256] = ACTIONS(702),
    [anon_sym_bytes] = ACTIONS(702),
    [anon_sym_bytes1] = ACTIONS(702),
    [anon_sym_bytes2] = ACTIONS(702),
    [anon_sym_bytes3] = ACTIONS(702),
    [anon_sym_bytes4] = ACTIONS(702),
    [anon_sym_bytes5] = ACTIONS(702),
    [anon_sym_bytes6] = ACTIONS(702),
    [anon_sym_bytes7] = ACTIONS(702),
    [anon_sym_bytes8] = ACTIONS(702),
    [anon_sym_bytes9] = ACTIONS(702),
    [anon_sym_bytes10] = ACTIONS(702),
    [anon_sym_bytes11] = ACTIONS(702),
    [anon_sym_bytes12] = ACTIONS(702),
    [anon_sym_bytes13] = ACTIONS(702),
    [anon_sym_bytes14] = ACTIONS(702),
    [anon_sym_bytes15] = ACTIONS(702),
    [anon_sym_bytes16] = ACTIONS(702),
    [anon_sym_bytes17] = ACTIONS(702),
    [anon_sym_bytes18] = ACTIONS(702),
    [anon_sym_bytes19] = ACTIONS(702),
    [anon_sym_bytes20] = ACTIONS(702),
    [anon_sym_bytes21] = ACTIONS(702),
    [anon_sym_bytes22] = ACTIONS(702),
    [anon_sym_bytes23] = ACTIONS(702),
    [anon_sym_bytes24] = ACTIONS(702),
    [anon_sym_bytes25] = ACTIONS(702),
    [anon_sym_bytes26] = ACTIONS(702),
    [anon_sym_bytes27] = ACTIONS(702),
    [anon_sym_bytes28] = ACTIONS(702),
    [anon_sym_bytes29] = ACTIONS(702),
    [anon_sym_bytes30] = ACTIONS(702),
    [anon_sym_bytes31] = ACTIONS(702),
    [anon_sym_bytes32] = ACTIONS(702),
    [anon_sym_fixed] = ACTIONS(702),
    [aux_sym__fixed_token1] = ACTIONS(702),
    [anon_sym_ufixed] = ACTIONS(702),
    [aux_sym__ufixed_token1] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
  },
  [177] = {
    [sym_identifier] = ACTIONS(694),
    [anon_sym_RBRACE] = ACTIONS(692),
    [anon_sym_type] = ACTIONS(694),
    [anon_sym_error] = ACTIONS(694),
    [anon_sym_struct] = ACTIONS(694),
    [anon_sym_enum] = ACTIONS(694),
    [anon_sym_event] = ACTIONS(694),
    [anon_sym_using] = ACTIONS(694),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_byte] = ACTIONS(694),
    [anon_sym_address] = ACTIONS(694),
    [anon_sym_var] = ACTIONS(694),
    [anon_sym_modifier] = ACTIONS(694),
    [anon_sym_constructor] = ACTIONS(694),
    [anon_sym_fallback] = ACTIONS(694),
    [anon_sym_receive] = ACTIONS(694),
    [anon_sym_mapping] = ACTIONS(694),
    [anon_sym_bool] = ACTIONS(694),
    [anon_sym_string] = ACTIONS(694),
    [anon_sym_int] = ACTIONS(694),
    [anon_sym_int8] = ACTIONS(694),
    [anon_sym_int16] = ACTIONS(694),
    [anon_sym_int24] = ACTIONS(694),
    [anon_sym_int32] = ACTIONS(694),
    [anon_sym_int40] = ACTIONS(694),
    [anon_sym_int48] = ACTIONS(694),
    [anon_sym_int56] = ACTIONS(694),
    [anon_sym_int64] = ACTIONS(694),
    [anon_sym_int72] = ACTIONS(694),
    [anon_sym_int80] = ACTIONS(694),
    [anon_sym_int88] = ACTIONS(694),
    [anon_sym_int96] = ACTIONS(694),
    [anon_sym_int104] = ACTIONS(694),
    [anon_sym_int112] = ACTIONS(694),
    [anon_sym_int120] = ACTIONS(694),
    [anon_sym_int128] = ACTIONS(694),
    [anon_sym_int136] = ACTIONS(694),
    [anon_sym_int144] = ACTIONS(694),
    [anon_sym_int152] = ACTIONS(694),
    [anon_sym_int160] = ACTIONS(694),
    [anon_sym_int168] = ACTIONS(694),
    [anon_sym_int176] = ACTIONS(694),
    [anon_sym_int184] = ACTIONS(694),
    [anon_sym_int192] = ACTIONS(694),
    [anon_sym_int200] = ACTIONS(694),
    [anon_sym_int208] = ACTIONS(694),
    [anon_sym_int216] = ACTIONS(694),
    [anon_sym_int224] = ACTIONS(694),
    [anon_sym_int232] = ACTIONS(694),
    [anon_sym_int240] = ACTIONS(694),
    [anon_sym_int248] = ACTIONS(694),
    [anon_sym_int256] = ACTIONS(694),
    [anon_sym_uint] = ACTIONS(694),
    [anon_sym_uint8] = ACTIONS(694),
    [anon_sym_uint16] = ACTIONS(694),
    [anon_sym_uint24] = ACTIONS(694),
    [anon_sym_uint32] = ACTIONS(694),
    [anon_sym_uint40] = ACTIONS(694),
    [anon_sym_uint48] = ACTIONS(694),
    [anon_sym_uint56] = ACTIONS(694),
    [anon_sym_uint64] = ACTIONS(694),
    [anon_sym_uint72] = ACTIONS(694),
    [anon_sym_uint80] = ACTIONS(694),
    [anon_sym_uint88] = ACTIONS(694),
    [anon_sym_uint96] = ACTIONS(694),
    [anon_sym_uint104] = ACTIONS(694),
    [anon_sym_uint112] = ACTIONS(694),
    [anon_sym_uint120] = ACTIONS(694),
    [anon_sym_uint128] = ACTIONS(694),
    [anon_sym_uint136] = ACTIONS(694),
    [anon_sym_uint144] = ACTIONS(694),
    [anon_sym_uint152] = ACTIONS(694),
    [anon_sym_uint160] = ACTIONS(694),
    [anon_sym_uint168] = ACTIONS(694),
    [anon_sym_uint176] = ACTIONS(694),
    [anon_sym_uint184] = ACTIONS(694),
    [anon_sym_uint192] = ACTIONS(694),
    [anon_sym_uint200] = ACTIONS(694),
    [anon_sym_uint208] = ACTIONS(694),
    [anon_sym_uint216] = ACTIONS(694),
    [anon_sym_uint224] = ACTIONS(694),
    [anon_sym_uint232] = ACTIONS(694),
    [anon_sym_uint240] = ACTIONS(694),
    [anon_sym_uint248] = ACTIONS(694),
    [anon_sym_uint256] = ACTIONS(694),
    [anon_sym_bytes] = ACTIONS(694),
    [anon_sym_bytes1] = ACTIONS(694),
    [anon_sym_bytes2] = ACTIONS(694),
    [anon_sym_bytes3] = ACTIONS(694),
    [anon_sym_bytes4] = ACTIONS(694),
    [anon_sym_bytes5] = ACTIONS(694),
    [anon_sym_bytes6] = ACTIONS(694),
    [anon_sym_bytes7] = ACTIONS(694),
    [anon_sym_bytes8] = ACTIONS(694),
    [anon_sym_bytes9] = ACTIONS(694),
    [anon_sym_bytes10] = ACTIONS(694),
    [anon_sym_bytes11] = ACTIONS(694),
    [anon_sym_bytes12] = ACTIONS(694),
    [anon_sym_bytes13] = ACTIONS(694),
    [anon_sym_bytes14] = ACTIONS(694),
    [anon_sym_bytes15] = ACTIONS(694),
    [anon_sym_bytes16] = ACTIONS(694),
    [anon_sym_bytes17] = ACTIONS(694),
    [anon_sym_bytes18] = ACTIONS(694),
    [anon_sym_bytes19] = ACTIONS(694),
    [anon_sym_bytes20] = ACTIONS(694),
    [anon_sym_bytes21] = ACTIONS(694),
    [anon_sym_bytes22] = ACTIONS(694),
    [anon_sym_bytes23] = ACTIONS(694),
    [anon_sym_bytes24] = ACTIONS(694),
    [anon_sym_bytes25] = ACTIONS(694),
    [anon_sym_bytes26] = ACTIONS(694),
    [anon_sym_bytes27] = ACTIONS(694),
    [anon_sym_bytes28] = ACTIONS(694),
    [anon_sym_bytes29] = ACTIONS(694),
    [anon_sym_bytes30] = ACTIONS(694),
    [anon_sym_bytes31] = ACTIONS(694),
    [anon_sym_bytes32] = ACTIONS(694),
    [anon_sym_fixed] = ACTIONS(694),
    [aux_sym__fixed_token1] = ACTIONS(694),
    [anon_sym_ufixed] = ACTIONS(694),
    [aux_sym__ufixed_token1] = ACTIONS(694),
    [sym_comment] = ACTIONS(3),
  },
  [178] = {
    [sym_identifier] = ACTIONS(756),
    [anon_sym_RBRACE] = ACTIONS(758),
    [anon_sym_type] = ACTIONS(756),
    [anon_sym_error] = ACTIONS(756),
    [anon_sym_struct] = ACTIONS(756),
    [anon_sym_enum] = ACTIONS(756),
    [anon_sym_event] = ACTIONS(756),
    [anon_sym_using] = ACTIONS(756),
    [anon_sym_function] = ACTIONS(756),
    [anon_sym_byte] = ACTIONS(756),
    [anon_sym_address] = ACTIONS(756),
    [anon_sym_var] = ACTIONS(756),
    [anon_sym_modifier] = ACTIONS(756),
    [anon_sym_constructor] = ACTIONS(756),
    [anon_sym_fallback] = ACTIONS(756),
    [anon_sym_receive] = ACTIONS(756),
    [anon_sym_mapping] = ACTIONS(756),
    [anon_sym_bool] = ACTIONS(756),
    [anon_sym_string] = ACTIONS(756),
    [anon_sym_int] = ACTIONS(756),
    [anon_sym_int8] = ACTIONS(756),
    [anon_sym_int16] = ACTIONS(756),
    [anon_sym_int24] = ACTIONS(756),
    [anon_sym_int32] = ACTIONS(756),
    [anon_sym_int40] = ACTIONS(756),
    [anon_sym_int48] = ACTIONS(756),
    [anon_sym_int56] = ACTIONS(756),
    [anon_sym_int64] = ACTIONS(756),
    [anon_sym_int72] = ACTIONS(756),
    [anon_sym_int80] = ACTIONS(756),
    [anon_sym_int88] = ACTIONS(756),
    [anon_sym_int96] = ACTIONS(756),
    [anon_sym_int104] = ACTIONS(756),
    [anon_sym_int112] = ACTIONS(756),
    [anon_sym_int120] = ACTIONS(756),
    [anon_sym_int128] = ACTIONS(756),
    [anon_sym_int136] = ACTIONS(756),
    [anon_sym_int144] = ACTIONS(756),
    [anon_sym_int152] = ACTIONS(756),
    [anon_sym_int160] = ACTIONS(756),
    [anon_sym_int168] = ACTIONS(756),
    [anon_sym_int176] = ACTIONS(756),
    [anon_sym_int184] = ACTIONS(756),
    [anon_sym_int192] = ACTIONS(756),
    [anon_sym_int200] = ACTIONS(756),
    [anon_sym_int208] = ACTIONS(756),
    [anon_sym_int216] = ACTIONS(756),
    [anon_sym_int224] = ACTIONS(756),
    [anon_sym_int232] = ACTIONS(756),
    [anon_sym_int240] = ACTIONS(756),
    [anon_sym_int248] = ACTIONS(756),
    [anon_sym_int256] = ACTIONS(756),
    [anon_sym_uint] = ACTIONS(756),
    [anon_sym_uint8] = ACTIONS(756),
    [anon_sym_uint16] = ACTIONS(756),
    [anon_sym_uint24] = ACTIONS(756),
    [anon_sym_uint32] = ACTIONS(756),
    [anon_sym_uint40] = ACTIONS(756),
    [anon_sym_uint48] = ACTIONS(756),
    [anon_sym_uint56] = ACTIONS(756),
    [anon_sym_uint64] = ACTIONS(756),
    [anon_sym_uint72] = ACTIONS(756),
    [anon_sym_uint80] = ACTIONS(756),
    [anon_sym_uint88] = ACTIONS(756),
    [anon_sym_uint96] = ACTIONS(756),
    [anon_sym_uint104] = ACTIONS(756),
    [anon_sym_uint112] = ACTIONS(756),
    [anon_sym_uint120] = ACTIONS(756),
    [anon_sym_uint128] = ACTIONS(756),
    [anon_sym_uint136] = ACTIONS(756),
    [anon_sym_uint144] = ACTIONS(756),
    [anon_sym_uint152] = ACTIONS(756),
    [anon_sym_uint160] = ACTIONS(756),
    [anon_sym_uint168] = ACTIONS(756),
    [anon_sym_uint176] = ACTIONS(756),
    [anon_sym_uint184] = ACTIONS(756),
    [anon_sym_uint192] = ACTIONS(756),
    [anon_sym_uint200] = ACTIONS(756),
    [anon_sym_uint208] = ACTIONS(756),
    [anon_sym_uint216] = ACTIONS(756),
    [anon_sym_uint224] = ACTIONS(756),
    [anon_sym_uint232] = ACTIONS(756),
    [anon_sym_uint240] = ACTIONS(756),
    [anon_sym_uint248] = ACTIONS(756),
    [anon_sym_uint256] = ACTIONS(756),
    [anon_sym_bytes] = ACTIONS(756),
    [anon_sym_bytes1] = ACTIONS(756),
    [anon_sym_bytes2] = ACTIONS(756),
    [anon_sym_bytes3] = ACTIONS(756),
    [anon_sym_bytes4] = ACTIONS(756),
    [anon_sym_bytes5] = ACTIONS(756),
    [anon_sym_bytes6] = ACTIONS(756),
    [anon_sym_bytes7] = ACTIONS(756),
    [anon_sym_bytes8] = ACTIONS(756),
    [anon_sym_bytes9] = ACTIONS(756),
    [anon_sym_bytes10] = ACTIONS(756),
    [anon_sym_bytes11] = ACTIONS(756),
    [anon_sym_bytes12] = ACTIONS(756),
    [anon_sym_bytes13] = ACTIONS(756),
    [anon_sym_bytes14] = ACTIONS(756),
    [anon_sym_bytes15] = ACTIONS(756),
    [anon_sym_bytes16] = ACTIONS(756),
    [anon_sym_bytes17] = ACTIONS(756),
    [anon_sym_bytes18] = ACTIONS(756),
    [anon_sym_bytes19] = ACTIONS(756),
    [anon_sym_bytes20] = ACTIONS(756),
    [anon_sym_bytes21] = ACTIONS(756),
    [anon_sym_bytes22] = ACTIONS(756),
    [anon_sym_bytes23] = ACTIONS(756),
    [anon_sym_bytes24] = ACTIONS(756),
    [anon_sym_bytes25] = ACTIONS(756),
    [anon_sym_bytes26] = ACTIONS(756),
    [anon_sym_bytes27] = ACTIONS(756),
    [anon_sym_bytes28] = ACTIONS(756),
    [anon_sym_bytes29] = ACTIONS(756),
    [anon_sym_bytes30] = ACTIONS(756),
    [anon_sym_bytes31] = ACTIONS(756),
    [anon_sym_bytes32] = ACTIONS(756),
    [anon_sym_fixed] = ACTIONS(756),
    [aux_sym__fixed_token1] = ACTIONS(756),
    [anon_sym_ufixed] = ACTIONS(756),
    [aux_sym__ufixed_token1] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_identifier] = ACTIONS(690),
    [anon_sym_RBRACE] = ACTIONS(688),
    [anon_sym_type] = ACTIONS(690),
    [anon_sym_error] = ACTIONS(690),
    [anon_sym_struct] = ACTIONS(690),
    [anon_sym_enum] = ACTIONS(690),
    [anon_sym_event] = ACTIONS(690),
    [anon_sym_using] = ACTIONS(690),
    [anon_sym_function] = ACTIONS(690),
    [anon_sym_byte] = ACTIONS(690),
    [anon_sym_address] = ACTIONS(690),
    [anon_sym_var] = ACTIONS(690),
    [anon_sym_modifier] = ACTIONS(690),
    [anon_sym_constructor] = ACTIONS(690),
    [anon_sym_fallback] = ACTIONS(690),
    [anon_sym_receive] = ACTIONS(690),
    [anon_sym_mapping] = ACTIONS(690),
    [anon_sym_bool] = ACTIONS(690),
    [anon_sym_string] = ACTIONS(690),
    [anon_sym_int] = ACTIONS(690),
    [anon_sym_int8] = ACTIONS(690),
    [anon_sym_int16] = ACTIONS(690),
    [anon_sym_int24] = ACTIONS(690),
    [anon_sym_int32] = ACTIONS(690),
    [anon_sym_int40] = ACTIONS(690),
    [anon_sym_int48] = ACTIONS(690),
    [anon_sym_int56] = ACTIONS(690),
    [anon_sym_int64] = ACTIONS(690),
    [anon_sym_int72] = ACTIONS(690),
    [anon_sym_int80] = ACTIONS(690),
    [anon_sym_int88] = ACTIONS(690),
    [anon_sym_int96] = ACTIONS(690),
    [anon_sym_int104] = ACTIONS(690),
    [anon_sym_int112] = ACTIONS(690),
    [anon_sym_int120] = ACTIONS(690),
    [anon_sym_int128] = ACTIONS(690),
    [anon_sym_int136] = ACTIONS(690),
    [anon_sym_int144] = ACTIONS(690),
    [anon_sym_int152] = ACTIONS(690),
    [anon_sym_int160] = ACTIONS(690),
    [anon_sym_int168] = ACTIONS(690),
    [anon_sym_int176] = ACTIONS(690),
    [anon_sym_int184] = ACTIONS(690),
    [anon_sym_int192] = ACTIONS(690),
    [anon_sym_int200] = ACTIONS(690),
    [anon_sym_int208] = ACTIONS(690),
    [anon_sym_int216] = ACTIONS(690),
    [anon_sym_int224] = ACTIONS(690),
    [anon_sym_int232] = ACTIONS(690),
    [anon_sym_int240] = ACTIONS(690),
    [anon_sym_int248] = ACTIONS(690),
    [anon_sym_int256] = ACTIONS(690),
    [anon_sym_uint] = ACTIONS(690),
    [anon_sym_uint8] = ACTIONS(690),
    [anon_sym_uint16] = ACTIONS(690),
    [anon_sym_uint24] = ACTIONS(690),
    [anon_sym_uint32] = ACTIONS(690),
    [anon_sym_uint40] = ACTIONS(690),
    [anon_sym_uint48] = ACTIONS(690),
    [anon_sym_uint56] = ACTIONS(690),
    [anon_sym_uint64] = ACTIONS(690),
    [anon_sym_uint72] = ACTIONS(690),
    [anon_sym_uint80] = ACTIONS(690),
    [anon_sym_uint88] = ACTIONS(690),
    [anon_sym_uint96] = ACTIONS(690),
    [anon_sym_uint104] = ACTIONS(690),
    [anon_sym_uint112] = ACTIONS(690),
    [anon_sym_uint120] = ACTIONS(690),
    [anon_sym_uint128] = ACTIONS(690),
    [anon_sym_uint136] = ACTIONS(690),
    [anon_sym_uint144] = ACTIONS(690),
    [anon_sym_uint152] = ACTIONS(690),
    [anon_sym_uint160] = ACTIONS(690),
    [anon_sym_uint168] = ACTIONS(690),
    [anon_sym_uint176] = ACTIONS(690),
    [anon_sym_uint184] = ACTIONS(690),
    [anon_sym_uint192] = ACTIONS(690),
    [anon_sym_uint200] = ACTIONS(690),
    [anon_sym_uint208] = ACTIONS(690),
    [anon_sym_uint216] = ACTIONS(690),
    [anon_sym_uint224] = ACTIONS(690),
    [anon_sym_uint232] = ACTIONS(690),
    [anon_sym_uint240] = ACTIONS(690),
    [anon_sym_uint248] = ACTIONS(690),
    [anon_sym_uint256] = ACTIONS(690),
    [anon_sym_bytes] = ACTIONS(690),
    [anon_sym_bytes1] = ACTIONS(690),
    [anon_sym_bytes2] = ACTIONS(690),
    [anon_sym_bytes3] = ACTIONS(690),
    [anon_sym_bytes4] = ACTIONS(690),
    [anon_sym_bytes5] = ACTIONS(690),
    [anon_sym_bytes6] = ACTIONS(690),
    [anon_sym_bytes7] = ACTIONS(690),
    [anon_sym_bytes8] = ACTIONS(690),
    [anon_sym_bytes9] = ACTIONS(690),
    [anon_sym_bytes10] = ACTIONS(690),
    [anon_sym_bytes11] = ACTIONS(690),
    [anon_sym_bytes12] = ACTIONS(690),
    [anon_sym_bytes13] = ACTIONS(690),
    [anon_sym_bytes14] = ACTIONS(690),
    [anon_sym_bytes15] = ACTIONS(690),
    [anon_sym_bytes16] = ACTIONS(690),
    [anon_sym_bytes17] = ACTIONS(690),
    [anon_sym_bytes18] = ACTIONS(690),
    [anon_sym_bytes19] = ACTIONS(690),
    [anon_sym_bytes20] = ACTIONS(690),
    [anon_sym_bytes21] = ACTIONS(690),
    [anon_sym_bytes22] = ACTIONS(690),
    [anon_sym_bytes23] = ACTIONS(690),
    [anon_sym_bytes24] = ACTIONS(690),
    [anon_sym_bytes25] = ACTIONS(690),
    [anon_sym_bytes26] = ACTIONS(690),
    [anon_sym_bytes27] = ACTIONS(690),
    [anon_sym_bytes28] = ACTIONS(690),
    [anon_sym_bytes29] = ACTIONS(690),
    [anon_sym_bytes30] = ACTIONS(690),
    [anon_sym_bytes31] = ACTIONS(690),
    [anon_sym_bytes32] = ACTIONS(690),
    [anon_sym_fixed] = ACTIONS(690),
    [aux_sym__fixed_token1] = ACTIONS(690),
    [anon_sym_ufixed] = ACTIONS(690),
    [aux_sym__ufixed_token1] = ACTIONS(690),
    [sym_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_identifier] = ACTIONS(676),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_type] = ACTIONS(676),
    [anon_sym_error] = ACTIONS(676),
    [anon_sym_struct] = ACTIONS(676),
    [anon_sym_enum] = ACTIONS(676),
    [anon_sym_event] = ACTIONS(676),
    [anon_sym_using] = ACTIONS(676),
    [anon_sym_function] = ACTIONS(676),
    [anon_sym_byte] = ACTIONS(676),
    [anon_sym_address] = ACTIONS(676),
    [anon_sym_var] = ACTIONS(676),
    [anon_sym_modifier] = ACTIONS(676),
    [anon_sym_constructor] = ACTIONS(676),
    [anon_sym_fallback] = ACTIONS(676),
    [anon_sym_receive] = ACTIONS(676),
    [anon_sym_mapping] = ACTIONS(676),
    [anon_sym_bool] = ACTIONS(676),
    [anon_sym_string] = ACTIONS(676),
    [anon_sym_int] = ACTIONS(676),
    [anon_sym_int8] = ACTIONS(676),
    [anon_sym_int16] = ACTIONS(676),
    [anon_sym_int24] = ACTIONS(676),
    [anon_sym_int32] = ACTIONS(676),
    [anon_sym_int40] = ACTIONS(676),
    [anon_sym_int48] = ACTIONS(676),
    [anon_sym_int56] = ACTIONS(676),
    [anon_sym_int64] = ACTIONS(676),
    [anon_sym_int72] = ACTIONS(676),
    [anon_sym_int80] = ACTIONS(676),
    [anon_sym_int88] = ACTIONS(676),
    [anon_sym_int96] = ACTIONS(676),
    [anon_sym_int104] = ACTIONS(676),
    [anon_sym_int112] = ACTIONS(676),
    [anon_sym_int120] = ACTIONS(676),
    [anon_sym_int128] = ACTIONS(676),
    [anon_sym_int136] = ACTIONS(676),
    [anon_sym_int144] = ACTIONS(676),
    [anon_sym_int152] = ACTIONS(676),
    [anon_sym_int160] = ACTIONS(676),
    [anon_sym_int168] = ACTIONS(676),
    [anon_sym_int176] = ACTIONS(676),
    [anon_sym_int184] = ACTIONS(676),
    [anon_sym_int192] = ACTIONS(676),
    [anon_sym_int200] = ACTIONS(676),
    [anon_sym_int208] = ACTIONS(676),
    [anon_sym_int216] = ACTIONS(676),
    [anon_sym_int224] = ACTIONS(676),
    [anon_sym_int232] = ACTIONS(676),
    [anon_sym_int240] = ACTIONS(676),
    [anon_sym_int248] = ACTIONS(676),
    [anon_sym_int256] = ACTIONS(676),
    [anon_sym_uint] = ACTIONS(676),
    [anon_sym_uint8] = ACTIONS(676),
    [anon_sym_uint16] = ACTIONS(676),
    [anon_sym_uint24] = ACTIONS(676),
    [anon_sym_uint32] = ACTIONS(676),
    [anon_sym_uint40] = ACTIONS(676),
    [anon_sym_uint48] = ACTIONS(676),
    [anon_sym_uint56] = ACTIONS(676),
    [anon_sym_uint64] = ACTIONS(676),
    [anon_sym_uint72] = ACTIONS(676),
    [anon_sym_uint80] = ACTIONS(676),
    [anon_sym_uint88] = ACTIONS(676),
    [anon_sym_uint96] = ACTIONS(676),
    [anon_sym_uint104] = ACTIONS(676),
    [anon_sym_uint112] = ACTIONS(676),
    [anon_sym_uint120] = ACTIONS(676),
    [anon_sym_uint128] = ACTIONS(676),
    [anon_sym_uint136] = ACTIONS(676),
    [anon_sym_uint144] = ACTIONS(676),
    [anon_sym_uint152] = ACTIONS(676),
    [anon_sym_uint160] = ACTIONS(676),
    [anon_sym_uint168] = ACTIONS(676),
    [anon_sym_uint176] = ACTIONS(676),
    [anon_sym_uint184] = ACTIONS(676),
    [anon_sym_uint192] = ACTIONS(676),
    [anon_sym_uint200] = ACTIONS(676),
    [anon_sym_uint208] = ACTIONS(676),
    [anon_sym_uint216] = ACTIONS(676),
    [anon_sym_uint224] = ACTIONS(676),
    [anon_sym_uint232] = ACTIONS(676),
    [anon_sym_uint240] = ACTIONS(676),
    [anon_sym_uint248] = ACTIONS(676),
    [anon_sym_uint256] = ACTIONS(676),
    [anon_sym_bytes] = ACTIONS(676),
    [anon_sym_bytes1] = ACTIONS(676),
    [anon_sym_bytes2] = ACTIONS(676),
    [anon_sym_bytes3] = ACTIONS(676),
    [anon_sym_bytes4] = ACTIONS(676),
    [anon_sym_bytes5] = ACTIONS(676),
    [anon_sym_bytes6] = ACTIONS(676),
    [anon_sym_bytes7] = ACTIONS(676),
    [anon_sym_bytes8] = ACTIONS(676),
    [anon_sym_bytes9] = ACTIONS(676),
    [anon_sym_bytes10] = ACTIONS(676),
    [anon_sym_bytes11] = ACTIONS(676),
    [anon_sym_bytes12] = ACTIONS(676),
    [anon_sym_bytes13] = ACTIONS(676),
    [anon_sym_bytes14] = ACTIONS(676),
    [anon_sym_bytes15] = ACTIONS(676),
    [anon_sym_bytes16] = ACTIONS(676),
    [anon_sym_bytes17] = ACTIONS(676),
    [anon_sym_bytes18] = ACTIONS(676),
    [anon_sym_bytes19] = ACTIONS(676),
    [anon_sym_bytes20] = ACTIONS(676),
    [anon_sym_bytes21] = ACTIONS(676),
    [anon_sym_bytes22] = ACTIONS(676),
    [anon_sym_bytes23] = ACTIONS(676),
    [anon_sym_bytes24] = ACTIONS(676),
    [anon_sym_bytes25] = ACTIONS(676),
    [anon_sym_bytes26] = ACTIONS(676),
    [anon_sym_bytes27] = ACTIONS(676),
    [anon_sym_bytes28] = ACTIONS(676),
    [anon_sym_bytes29] = ACTIONS(676),
    [anon_sym_bytes30] = ACTIONS(676),
    [anon_sym_bytes31] = ACTIONS(676),
    [anon_sym_bytes32] = ACTIONS(676),
    [anon_sym_fixed] = ACTIONS(676),
    [aux_sym__fixed_token1] = ACTIONS(676),
    [anon_sym_ufixed] = ACTIONS(676),
    [aux_sym__ufixed_token1] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_identifier] = ACTIONS(616),
    [anon_sym_RBRACE] = ACTIONS(614),
    [anon_sym_type] = ACTIONS(616),
    [anon_sym_error] = ACTIONS(616),
    [anon_sym_struct] = ACTIONS(616),
    [anon_sym_enum] = ACTIONS(616),
    [anon_sym_event] = ACTIONS(616),
    [anon_sym_using] = ACTIONS(616),
    [anon_sym_function] = ACTIONS(616),
    [anon_sym_byte] = ACTIONS(616),
    [anon_sym_address] = ACTIONS(616),
    [anon_sym_var] = ACTIONS(616),
    [anon_sym_modifier] = ACTIONS(616),
    [anon_sym_constructor] = ACTIONS(616),
    [anon_sym_fallback] = ACTIONS(616),
    [anon_sym_receive] = ACTIONS(616),
    [anon_sym_mapping] = ACTIONS(616),
    [anon_sym_bool] = ACTIONS(616),
    [anon_sym_string] = ACTIONS(616),
    [anon_sym_int] = ACTIONS(616),
    [anon_sym_int8] = ACTIONS(616),
    [anon_sym_int16] = ACTIONS(616),
    [anon_sym_int24] = ACTIONS(616),
    [anon_sym_int32] = ACTIONS(616),
    [anon_sym_int40] = ACTIONS(616),
    [anon_sym_int48] = ACTIONS(616),
    [anon_sym_int56] = ACTIONS(616),
    [anon_sym_int64] = ACTIONS(616),
    [anon_sym_int72] = ACTIONS(616),
    [anon_sym_int80] = ACTIONS(616),
    [anon_sym_int88] = ACTIONS(616),
    [anon_sym_int96] = ACTIONS(616),
    [anon_sym_int104] = ACTIONS(616),
    [anon_sym_int112] = ACTIONS(616),
    [anon_sym_int120] = ACTIONS(616),
    [anon_sym_int128] = ACTIONS(616),
    [anon_sym_int136] = ACTIONS(616),
    [anon_sym_int144] = ACTIONS(616),
    [anon_sym_int152] = ACTIONS(616),
    [anon_sym_int160] = ACTIONS(616),
    [anon_sym_int168] = ACTIONS(616),
    [anon_sym_int176] = ACTIONS(616),
    [anon_sym_int184] = ACTIONS(616),
    [anon_sym_int192] = ACTIONS(616),
    [anon_sym_int200] = ACTIONS(616),
    [anon_sym_int208] = ACTIONS(616),
    [anon_sym_int216] = ACTIONS(616),
    [anon_sym_int224] = ACTIONS(616),
    [anon_sym_int232] = ACTIONS(616),
    [anon_sym_int240] = ACTIONS(616),
    [anon_sym_int248] = ACTIONS(616),
    [anon_sym_int256] = ACTIONS(616),
    [anon_sym_uint] = ACTIONS(616),
    [anon_sym_uint8] = ACTIONS(616),
    [anon_sym_uint16] = ACTIONS(616),
    [anon_sym_uint24] = ACTIONS(616),
    [anon_sym_uint32] = ACTIONS(616),
    [anon_sym_uint40] = ACTIONS(616),
    [anon_sym_uint48] = ACTIONS(616),
    [anon_sym_uint56] = ACTIONS(616),
    [anon_sym_uint64] = ACTIONS(616),
    [anon_sym_uint72] = ACTIONS(616),
    [anon_sym_uint80] = ACTIONS(616),
    [anon_sym_uint88] = ACTIONS(616),
    [anon_sym_uint96] = ACTIONS(616),
    [anon_sym_uint104] = ACTIONS(616),
    [anon_sym_uint112] = ACTIONS(616),
    [anon_sym_uint120] = ACTIONS(616),
    [anon_sym_uint128] = ACTIONS(616),
    [anon_sym_uint136] = ACTIONS(616),
    [anon_sym_uint144] = ACTIONS(616),
    [anon_sym_uint152] = ACTIONS(616),
    [anon_sym_uint160] = ACTIONS(616),
    [anon_sym_uint168] = ACTIONS(616),
    [anon_sym_uint176] = ACTIONS(616),
    [anon_sym_uint184] = ACTIONS(616),
    [anon_sym_uint192] = ACTIONS(616),
    [anon_sym_uint200] = ACTIONS(616),
    [anon_sym_uint208] = ACTIONS(616),
    [anon_sym_uint216] = ACTIONS(616),
    [anon_sym_uint224] = ACTIONS(616),
    [anon_sym_uint232] = ACTIONS(616),
    [anon_sym_uint240] = ACTIONS(616),
    [anon_sym_uint248] = ACTIONS(616),
    [anon_sym_uint256] = ACTIONS(616),
    [anon_sym_bytes] = ACTIONS(616),
    [anon_sym_bytes1] = ACTIONS(616),
    [anon_sym_bytes2] = ACTIONS(616),
    [anon_sym_bytes3] = ACTIONS(616),
    [anon_sym_bytes4] = ACTIONS(616),
    [anon_sym_bytes5] = ACTIONS(616),
    [anon_sym_bytes6] = ACTIONS(616),
    [anon_sym_bytes7] = ACTIONS(616),
    [anon_sym_bytes8] = ACTIONS(616),
    [anon_sym_bytes9] = ACTIONS(616),
    [anon_sym_bytes10] = ACTIONS(616),
    [anon_sym_bytes11] = ACTIONS(616),
    [anon_sym_bytes12] = ACTIONS(616),
    [anon_sym_bytes13] = ACTIONS(616),
    [anon_sym_bytes14] = ACTIONS(616),
    [anon_sym_bytes15] = ACTIONS(616),
    [anon_sym_bytes16] = ACTIONS(616),
    [anon_sym_bytes17] = ACTIONS(616),
    [anon_sym_bytes18] = ACTIONS(616),
    [anon_sym_bytes19] = ACTIONS(616),
    [anon_sym_bytes20] = ACTIONS(616),
    [anon_sym_bytes21] = ACTIONS(616),
    [anon_sym_bytes22] = ACTIONS(616),
    [anon_sym_bytes23] = ACTIONS(616),
    [anon_sym_bytes24] = ACTIONS(616),
    [anon_sym_bytes25] = ACTIONS(616),
    [anon_sym_bytes26] = ACTIONS(616),
    [anon_sym_bytes27] = ACTIONS(616),
    [anon_sym_bytes28] = ACTIONS(616),
    [anon_sym_bytes29] = ACTIONS(616),
    [anon_sym_bytes30] = ACTIONS(616),
    [anon_sym_bytes31] = ACTIONS(616),
    [anon_sym_bytes32] = ACTIONS(616),
    [anon_sym_fixed] = ACTIONS(616),
    [aux_sym__fixed_token1] = ACTIONS(616),
    [anon_sym_ufixed] = ACTIONS(616),
    [aux_sym__ufixed_token1] = ACTIONS(616),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_identifier] = ACTIONS(760),
    [anon_sym_RBRACE] = ACTIONS(762),
    [anon_sym_type] = ACTIONS(760),
    [anon_sym_error] = ACTIONS(760),
    [anon_sym_struct] = ACTIONS(760),
    [anon_sym_enum] = ACTIONS(760),
    [anon_sym_event] = ACTIONS(760),
    [anon_sym_using] = ACTIONS(760),
    [anon_sym_function] = ACTIONS(760),
    [anon_sym_byte] = ACTIONS(760),
    [anon_sym_address] = ACTIONS(760),
    [anon_sym_var] = ACTIONS(760),
    [anon_sym_modifier] = ACTIONS(760),
    [anon_sym_constructor] = ACTIONS(760),
    [anon_sym_fallback] = ACTIONS(760),
    [anon_sym_receive] = ACTIONS(760),
    [anon_sym_mapping] = ACTIONS(760),
    [anon_sym_bool] = ACTIONS(760),
    [anon_sym_string] = ACTIONS(760),
    [anon_sym_int] = ACTIONS(760),
    [anon_sym_int8] = ACTIONS(760),
    [anon_sym_int16] = ACTIONS(760),
    [anon_sym_int24] = ACTIONS(760),
    [anon_sym_int32] = ACTIONS(760),
    [anon_sym_int40] = ACTIONS(760),
    [anon_sym_int48] = ACTIONS(760),
    [anon_sym_int56] = ACTIONS(760),
    [anon_sym_int64] = ACTIONS(760),
    [anon_sym_int72] = ACTIONS(760),
    [anon_sym_int80] = ACTIONS(760),
    [anon_sym_int88] = ACTIONS(760),
    [anon_sym_int96] = ACTIONS(760),
    [anon_sym_int104] = ACTIONS(760),
    [anon_sym_int112] = ACTIONS(760),
    [anon_sym_int120] = ACTIONS(760),
    [anon_sym_int128] = ACTIONS(760),
    [anon_sym_int136] = ACTIONS(760),
    [anon_sym_int144] = ACTIONS(760),
    [anon_sym_int152] = ACTIONS(760),
    [anon_sym_int160] = ACTIONS(760),
    [anon_sym_int168] = ACTIONS(760),
    [anon_sym_int176] = ACTIONS(760),
    [anon_sym_int184] = ACTIONS(760),
    [anon_sym_int192] = ACTIONS(760),
    [anon_sym_int200] = ACTIONS(760),
    [anon_sym_int208] = ACTIONS(760),
    [anon_sym_int216] = ACTIONS(760),
    [anon_sym_int224] = ACTIONS(760),
    [anon_sym_int232] = ACTIONS(760),
    [anon_sym_int240] = ACTIONS(760),
    [anon_sym_int248] = ACTIONS(760),
    [anon_sym_int256] = ACTIONS(760),
    [anon_sym_uint] = ACTIONS(760),
    [anon_sym_uint8] = ACTIONS(760),
    [anon_sym_uint16] = ACTIONS(760),
    [anon_sym_uint24] = ACTIONS(760),
    [anon_sym_uint32] = ACTIONS(760),
    [anon_sym_uint40] = ACTIONS(760),
    [anon_sym_uint48] = ACTIONS(760),
    [anon_sym_uint56] = ACTIONS(760),
    [anon_sym_uint64] = ACTIONS(760),
    [anon_sym_uint72] = ACTIONS(760),
    [anon_sym_uint80] = ACTIONS(760),
    [anon_sym_uint88] = ACTIONS(760),
    [anon_sym_uint96] = ACTIONS(760),
    [anon_sym_uint104] = ACTIONS(760),
    [anon_sym_uint112] = ACTIONS(760),
    [anon_sym_uint120] = ACTIONS(760),
    [anon_sym_uint128] = ACTIONS(760),
    [anon_sym_uint136] = ACTIONS(760),
    [anon_sym_uint144] = ACTIONS(760),
    [anon_sym_uint152] = ACTIONS(760),
    [anon_sym_uint160] = ACTIONS(760),
    [anon_sym_uint168] = ACTIONS(760),
    [anon_sym_uint176] = ACTIONS(760),
    [anon_sym_uint184] = ACTIONS(760),
    [anon_sym_uint192] = ACTIONS(760),
    [anon_sym_uint200] = ACTIONS(760),
    [anon_sym_uint208] = ACTIONS(760),
    [anon_sym_uint216] = ACTIONS(760),
    [anon_sym_uint224] = ACTIONS(760),
    [anon_sym_uint232] = ACTIONS(760),
    [anon_sym_uint240] = ACTIONS(760),
    [anon_sym_uint248] = ACTIONS(760),
    [anon_sym_uint256] = ACTIONS(760),
    [anon_sym_bytes] = ACTIONS(760),
    [anon_sym_bytes1] = ACTIONS(760),
    [anon_sym_bytes2] = ACTIONS(760),
    [anon_sym_bytes3] = ACTIONS(760),
    [anon_sym_bytes4] = ACTIONS(760),
    [anon_sym_bytes5] = ACTIONS(760),
    [anon_sym_bytes6] = ACTIONS(760),
    [anon_sym_bytes7] = ACTIONS(760),
    [anon_sym_bytes8] = ACTIONS(760),
    [anon_sym_bytes9] = ACTIONS(760),
    [anon_sym_bytes10] = ACTIONS(760),
    [anon_sym_bytes11] = ACTIONS(760),
    [anon_sym_bytes12] = ACTIONS(760),
    [anon_sym_bytes13] = ACTIONS(760),
    [anon_sym_bytes14] = ACTIONS(760),
    [anon_sym_bytes15] = ACTIONS(760),
    [anon_sym_bytes16] = ACTIONS(760),
    [anon_sym_bytes17] = ACTIONS(760),
    [anon_sym_bytes18] = ACTIONS(760),
    [anon_sym_bytes19] = ACTIONS(760),
    [anon_sym_bytes20] = ACTIONS(760),
    [anon_sym_bytes21] = ACTIONS(760),
    [anon_sym_bytes22] = ACTIONS(760),
    [anon_sym_bytes23] = ACTIONS(760),
    [anon_sym_bytes24] = ACTIONS(760),
    [anon_sym_bytes25] = ACTIONS(760),
    [anon_sym_bytes26] = ACTIONS(760),
    [anon_sym_bytes27] = ACTIONS(760),
    [anon_sym_bytes28] = ACTIONS(760),
    [anon_sym_bytes29] = ACTIONS(760),
    [anon_sym_bytes30] = ACTIONS(760),
    [anon_sym_bytes31] = ACTIONS(760),
    [anon_sym_bytes32] = ACTIONS(760),
    [anon_sym_fixed] = ACTIONS(760),
    [aux_sym__fixed_token1] = ACTIONS(760),
    [anon_sym_ufixed] = ACTIONS(760),
    [aux_sym__ufixed_token1] = ACTIONS(760),
    [sym_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_identifier] = ACTIONS(620),
    [anon_sym_RBRACE] = ACTIONS(618),
    [anon_sym_type] = ACTIONS(620),
    [anon_sym_error] = ACTIONS(620),
    [anon_sym_struct] = ACTIONS(620),
    [anon_sym_enum] = ACTIONS(620),
    [anon_sym_event] = ACTIONS(620),
    [anon_sym_using] = ACTIONS(620),
    [anon_sym_function] = ACTIONS(620),
    [anon_sym_byte] = ACTIONS(620),
    [anon_sym_address] = ACTIONS(620),
    [anon_sym_var] = ACTIONS(620),
    [anon_sym_modifier] = ACTIONS(620),
    [anon_sym_constructor] = ACTIONS(620),
    [anon_sym_fallback] = ACTIONS(620),
    [anon_sym_receive] = ACTIONS(620),
    [anon_sym_mapping] = ACTIONS(620),
    [anon_sym_bool] = ACTIONS(620),
    [anon_sym_string] = ACTIONS(620),
    [anon_sym_int] = ACTIONS(620),
    [anon_sym_int8] = ACTIONS(620),
    [anon_sym_int16] = ACTIONS(620),
    [anon_sym_int24] = ACTIONS(620),
    [anon_sym_int32] = ACTIONS(620),
    [anon_sym_int40] = ACTIONS(620),
    [anon_sym_int48] = ACTIONS(620),
    [anon_sym_int56] = ACTIONS(620),
    [anon_sym_int64] = ACTIONS(620),
    [anon_sym_int72] = ACTIONS(620),
    [anon_sym_int80] = ACTIONS(620),
    [anon_sym_int88] = ACTIONS(620),
    [anon_sym_int96] = ACTIONS(620),
    [anon_sym_int104] = ACTIONS(620),
    [anon_sym_int112] = ACTIONS(620),
    [anon_sym_int120] = ACTIONS(620),
    [anon_sym_int128] = ACTIONS(620),
    [anon_sym_int136] = ACTIONS(620),
    [anon_sym_int144] = ACTIONS(620),
    [anon_sym_int152] = ACTIONS(620),
    [anon_sym_int160] = ACTIONS(620),
    [anon_sym_int168] = ACTIONS(620),
    [anon_sym_int176] = ACTIONS(620),
    [anon_sym_int184] = ACTIONS(620),
    [anon_sym_int192] = ACTIONS(620),
    [anon_sym_int200] = ACTIONS(620),
    [anon_sym_int208] = ACTIONS(620),
    [anon_sym_int216] = ACTIONS(620),
    [anon_sym_int224] = ACTIONS(620),
    [anon_sym_int232] = ACTIONS(620),
    [anon_sym_int240] = ACTIONS(620),
    [anon_sym_int248] = ACTIONS(620),
    [anon_sym_int256] = ACTIONS(620),
    [anon_sym_uint] = ACTIONS(620),
    [anon_sym_uint8] = ACTIONS(620),
    [anon_sym_uint16] = ACTIONS(620),
    [anon_sym_uint24] = ACTIONS(620),
    [anon_sym_uint32] = ACTIONS(620),
    [anon_sym_uint40] = ACTIONS(620),
    [anon_sym_uint48] = ACTIONS(620),
    [anon_sym_uint56] = ACTIONS(620),
    [anon_sym_uint64] = ACTIONS(620),
    [anon_sym_uint72] = ACTIONS(620),
    [anon_sym_uint80] = ACTIONS(620),
    [anon_sym_uint88] = ACTIONS(620),
    [anon_sym_uint96] = ACTIONS(620),
    [anon_sym_uint104] = ACTIONS(620),
    [anon_sym_uint112] = ACTIONS(620),
    [anon_sym_uint120] = ACTIONS(620),
    [anon_sym_uint128] = ACTIONS(620),
    [anon_sym_uint136] = ACTIONS(620),
    [anon_sym_uint144] = ACTIONS(620),
    [anon_sym_uint152] = ACTIONS(620),
    [anon_sym_uint160] = ACTIONS(620),
    [anon_sym_uint168] = ACTIONS(620),
    [anon_sym_uint176] = ACTIONS(620),
    [anon_sym_uint184] = ACTIONS(620),
    [anon_sym_uint192] = ACTIONS(620),
    [anon_sym_uint200] = ACTIONS(620),
    [anon_sym_uint208] = ACTIONS(620),
    [anon_sym_uint216] = ACTIONS(620),
    [anon_sym_uint224] = ACTIONS(620),
    [anon_sym_uint232] = ACTIONS(620),
    [anon_sym_uint240] = ACTIONS(620),
    [anon_sym_uint248] = ACTIONS(620),
    [anon_sym_uint256] = ACTIONS(620),
    [anon_sym_bytes] = ACTIONS(620),
    [anon_sym_bytes1] = ACTIONS(620),
    [anon_sym_bytes2] = ACTIONS(620),
    [anon_sym_bytes3] = ACTIONS(620),
    [anon_sym_bytes4] = ACTIONS(620),
    [anon_sym_bytes5] = ACTIONS(620),
    [anon_sym_bytes6] = ACTIONS(620),
    [anon_sym_bytes7] = ACTIONS(620),
    [anon_sym_bytes8] = ACTIONS(620),
    [anon_sym_bytes9] = ACTIONS(620),
    [anon_sym_bytes10] = ACTIONS(620),
    [anon_sym_bytes11] = ACTIONS(620),
    [anon_sym_bytes12] = ACTIONS(620),
    [anon_sym_bytes13] = ACTIONS(620),
    [anon_sym_bytes14] = ACTIONS(620),
    [anon_sym_bytes15] = ACTIONS(620),
    [anon_sym_bytes16] = ACTIONS(620),
    [anon_sym_bytes17] = ACTIONS(620),
    [anon_sym_bytes18] = ACTIONS(620),
    [anon_sym_bytes19] = ACTIONS(620),
    [anon_sym_bytes20] = ACTIONS(620),
    [anon_sym_bytes21] = ACTIONS(620),
    [anon_sym_bytes22] = ACTIONS(620),
    [anon_sym_bytes23] = ACTIONS(620),
    [anon_sym_bytes24] = ACTIONS(620),
    [anon_sym_bytes25] = ACTIONS(620),
    [anon_sym_bytes26] = ACTIONS(620),
    [anon_sym_bytes27] = ACTIONS(620),
    [anon_sym_bytes28] = ACTIONS(620),
    [anon_sym_bytes29] = ACTIONS(620),
    [anon_sym_bytes30] = ACTIONS(620),
    [anon_sym_bytes31] = ACTIONS(620),
    [anon_sym_bytes32] = ACTIONS(620),
    [anon_sym_fixed] = ACTIONS(620),
    [aux_sym__fixed_token1] = ACTIONS(620),
    [anon_sym_ufixed] = ACTIONS(620),
    [aux_sym__ufixed_token1] = ACTIONS(620),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_identifier] = ACTIONS(764),
    [anon_sym_RBRACE] = ACTIONS(766),
    [anon_sym_type] = ACTIONS(764),
    [anon_sym_error] = ACTIONS(764),
    [anon_sym_struct] = ACTIONS(764),
    [anon_sym_enum] = ACTIONS(764),
    [anon_sym_event] = ACTIONS(764),
    [anon_sym_using] = ACTIONS(764),
    [anon_sym_function] = ACTIONS(764),
    [anon_sym_byte] = ACTIONS(764),
    [anon_sym_address] = ACTIONS(764),
    [anon_sym_var] = ACTIONS(764),
    [anon_sym_modifier] = ACTIONS(764),
    [anon_sym_constructor] = ACTIONS(764),
    [anon_sym_fallback] = ACTIONS(764),
    [anon_sym_receive] = ACTIONS(764),
    [anon_sym_mapping] = ACTIONS(764),
    [anon_sym_bool] = ACTIONS(764),
    [anon_sym_string] = ACTIONS(764),
    [anon_sym_int] = ACTIONS(764),
    [anon_sym_int8] = ACTIONS(764),
    [anon_sym_int16] = ACTIONS(764),
    [anon_sym_int24] = ACTIONS(764),
    [anon_sym_int32] = ACTIONS(764),
    [anon_sym_int40] = ACTIONS(764),
    [anon_sym_int48] = ACTIONS(764),
    [anon_sym_int56] = ACTIONS(764),
    [anon_sym_int64] = ACTIONS(764),
    [anon_sym_int72] = ACTIONS(764),
    [anon_sym_int80] = ACTIONS(764),
    [anon_sym_int88] = ACTIONS(764),
    [anon_sym_int96] = ACTIONS(764),
    [anon_sym_int104] = ACTIONS(764),
    [anon_sym_int112] = ACTIONS(764),
    [anon_sym_int120] = ACTIONS(764),
    [anon_sym_int128] = ACTIONS(764),
    [anon_sym_int136] = ACTIONS(764),
    [anon_sym_int144] = ACTIONS(764),
    [anon_sym_int152] = ACTIONS(764),
    [anon_sym_int160] = ACTIONS(764),
    [anon_sym_int168] = ACTIONS(764),
    [anon_sym_int176] = ACTIONS(764),
    [anon_sym_int184] = ACTIONS(764),
    [anon_sym_int192] = ACTIONS(764),
    [anon_sym_int200] = ACTIONS(764),
    [anon_sym_int208] = ACTIONS(764),
    [anon_sym_int216] = ACTIONS(764),
    [anon_sym_int224] = ACTIONS(764),
    [anon_sym_int232] = ACTIONS(764),
    [anon_sym_int240] = ACTIONS(764),
    [anon_sym_int248] = ACTIONS(764),
    [anon_sym_int256] = ACTIONS(764),
    [anon_sym_uint] = ACTIONS(764),
    [anon_sym_uint8] = ACTIONS(764),
    [anon_sym_uint16] = ACTIONS(764),
    [anon_sym_uint24] = ACTIONS(764),
    [anon_sym_uint32] = ACTIONS(764),
    [anon_sym_uint40] = ACTIONS(764),
    [anon_sym_uint48] = ACTIONS(764),
    [anon_sym_uint56] = ACTIONS(764),
    [anon_sym_uint64] = ACTIONS(764),
    [anon_sym_uint72] = ACTIONS(764),
    [anon_sym_uint80] = ACTIONS(764),
    [anon_sym_uint88] = ACTIONS(764),
    [anon_sym_uint96] = ACTIONS(764),
    [anon_sym_uint104] = ACTIONS(764),
    [anon_sym_uint112] = ACTIONS(764),
    [anon_sym_uint120] = ACTIONS(764),
    [anon_sym_uint128] = ACTIONS(764),
    [anon_sym_uint136] = ACTIONS(764),
    [anon_sym_uint144] = ACTIONS(764),
    [anon_sym_uint152] = ACTIONS(764),
    [anon_sym_uint160] = ACTIONS(764),
    [anon_sym_uint168] = ACTIONS(764),
    [anon_sym_uint176] = ACTIONS(764),
    [anon_sym_uint184] = ACTIONS(764),
    [anon_sym_uint192] = ACTIONS(764),
    [anon_sym_uint200] = ACTIONS(764),
    [anon_sym_uint208] = ACTIONS(764),
    [anon_sym_uint216] = ACTIONS(764),
    [anon_sym_uint224] = ACTIONS(764),
    [anon_sym_uint232] = ACTIONS(764),
    [anon_sym_uint240] = ACTIONS(764),
    [anon_sym_uint248] = ACTIONS(764),
    [anon_sym_uint256] = ACTIONS(764),
    [anon_sym_bytes] = ACTIONS(764),
    [anon_sym_bytes1] = ACTIONS(764),
    [anon_sym_bytes2] = ACTIONS(764),
    [anon_sym_bytes3] = ACTIONS(764),
    [anon_sym_bytes4] = ACTIONS(764),
    [anon_sym_bytes5] = ACTIONS(764),
    [anon_sym_bytes6] = ACTIONS(764),
    [anon_sym_bytes7] = ACTIONS(764),
    [anon_sym_bytes8] = ACTIONS(764),
    [anon_sym_bytes9] = ACTIONS(764),
    [anon_sym_bytes10] = ACTIONS(764),
    [anon_sym_bytes11] = ACTIONS(764),
    [anon_sym_bytes12] = ACTIONS(764),
    [anon_sym_bytes13] = ACTIONS(764),
    [anon_sym_bytes14] = ACTIONS(764),
    [anon_sym_bytes15] = ACTIONS(764),
    [anon_sym_bytes16] = ACTIONS(764),
    [anon_sym_bytes17] = ACTIONS(764),
    [anon_sym_bytes18] = ACTIONS(764),
    [anon_sym_bytes19] = ACTIONS(764),
    [anon_sym_bytes20] = ACTIONS(764),
    [anon_sym_bytes21] = ACTIONS(764),
    [anon_sym_bytes22] = ACTIONS(764),
    [anon_sym_bytes23] = ACTIONS(764),
    [anon_sym_bytes24] = ACTIONS(764),
    [anon_sym_bytes25] = ACTIONS(764),
    [anon_sym_bytes26] = ACTIONS(764),
    [anon_sym_bytes27] = ACTIONS(764),
    [anon_sym_bytes28] = ACTIONS(764),
    [anon_sym_bytes29] = ACTIONS(764),
    [anon_sym_bytes30] = ACTIONS(764),
    [anon_sym_bytes31] = ACTIONS(764),
    [anon_sym_bytes32] = ACTIONS(764),
    [anon_sym_fixed] = ACTIONS(764),
    [aux_sym__fixed_token1] = ACTIONS(764),
    [anon_sym_ufixed] = ACTIONS(764),
    [aux_sym__ufixed_token1] = ACTIONS(764),
    [sym_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_identifier] = ACTIONS(624),
    [anon_sym_RBRACE] = ACTIONS(622),
    [anon_sym_type] = ACTIONS(624),
    [anon_sym_error] = ACTIONS(624),
    [anon_sym_struct] = ACTIONS(624),
    [anon_sym_enum] = ACTIONS(624),
    [anon_sym_event] = ACTIONS(624),
    [anon_sym_using] = ACTIONS(624),
    [anon_sym_function] = ACTIONS(624),
    [anon_sym_byte] = ACTIONS(624),
    [anon_sym_address] = ACTIONS(624),
    [anon_sym_var] = ACTIONS(624),
    [anon_sym_modifier] = ACTIONS(624),
    [anon_sym_constructor] = ACTIONS(624),
    [anon_sym_fallback] = ACTIONS(624),
    [anon_sym_receive] = ACTIONS(624),
    [anon_sym_mapping] = ACTIONS(624),
    [anon_sym_bool] = ACTIONS(624),
    [anon_sym_string] = ACTIONS(624),
    [anon_sym_int] = ACTIONS(624),
    [anon_sym_int8] = ACTIONS(624),
    [anon_sym_int16] = ACTIONS(624),
    [anon_sym_int24] = ACTIONS(624),
    [anon_sym_int32] = ACTIONS(624),
    [anon_sym_int40] = ACTIONS(624),
    [anon_sym_int48] = ACTIONS(624),
    [anon_sym_int56] = ACTIONS(624),
    [anon_sym_int64] = ACTIONS(624),
    [anon_sym_int72] = ACTIONS(624),
    [anon_sym_int80] = ACTIONS(624),
    [anon_sym_int88] = ACTIONS(624),
    [anon_sym_int96] = ACTIONS(624),
    [anon_sym_int104] = ACTIONS(624),
    [anon_sym_int112] = ACTIONS(624),
    [anon_sym_int120] = ACTIONS(624),
    [anon_sym_int128] = ACTIONS(624),
    [anon_sym_int136] = ACTIONS(624),
    [anon_sym_int144] = ACTIONS(624),
    [anon_sym_int152] = ACTIONS(624),
    [anon_sym_int160] = ACTIONS(624),
    [anon_sym_int168] = ACTIONS(624),
    [anon_sym_int176] = ACTIONS(624),
    [anon_sym_int184] = ACTIONS(624),
    [anon_sym_int192] = ACTIONS(624),
    [anon_sym_int200] = ACTIONS(624),
    [anon_sym_int208] = ACTIONS(624),
    [anon_sym_int216] = ACTIONS(624),
    [anon_sym_int224] = ACTIONS(624),
    [anon_sym_int232] = ACTIONS(624),
    [anon_sym_int240] = ACTIONS(624),
    [anon_sym_int248] = ACTIONS(624),
    [anon_sym_int256] = ACTIONS(624),
    [anon_sym_uint] = ACTIONS(624),
    [anon_sym_uint8] = ACTIONS(624),
    [anon_sym_uint16] = ACTIONS(624),
    [anon_sym_uint24] = ACTIONS(624),
    [anon_sym_uint32] = ACTIONS(624),
    [anon_sym_uint40] = ACTIONS(624),
    [anon_sym_uint48] = ACTIONS(624),
    [anon_sym_uint56] = ACTIONS(624),
    [anon_sym_uint64] = ACTIONS(624),
    [anon_sym_uint72] = ACTIONS(624),
    [anon_sym_uint80] = ACTIONS(624),
    [anon_sym_uint88] = ACTIONS(624),
    [anon_sym_uint96] = ACTIONS(624),
    [anon_sym_uint104] = ACTIONS(624),
    [anon_sym_uint112] = ACTIONS(624),
    [anon_sym_uint120] = ACTIONS(624),
    [anon_sym_uint128] = ACTIONS(624),
    [anon_sym_uint136] = ACTIONS(624),
    [anon_sym_uint144] = ACTIONS(624),
    [anon_sym_uint152] = ACTIONS(624),
    [anon_sym_uint160] = ACTIONS(624),
    [anon_sym_uint168] = ACTIONS(624),
    [anon_sym_uint176] = ACTIONS(624),
    [anon_sym_uint184] = ACTIONS(624),
    [anon_sym_uint192] = ACTIONS(624),
    [anon_sym_uint200] = ACTIONS(624),
    [anon_sym_uint208] = ACTIONS(624),
    [anon_sym_uint216] = ACTIONS(624),
    [anon_sym_uint224] = ACTIONS(624),
    [anon_sym_uint232] = ACTIONS(624),
    [anon_sym_uint240] = ACTIONS(624),
    [anon_sym_uint248] = ACTIONS(624),
    [anon_sym_uint256] = ACTIONS(624),
    [anon_sym_bytes] = ACTIONS(624),
    [anon_sym_bytes1] = ACTIONS(624),
    [anon_sym_bytes2] = ACTIONS(624),
    [anon_sym_bytes3] = ACTIONS(624),
    [anon_sym_bytes4] = ACTIONS(624),
    [anon_sym_bytes5] = ACTIONS(624),
    [anon_sym_bytes6] = ACTIONS(624),
    [anon_sym_bytes7] = ACTIONS(624),
    [anon_sym_bytes8] = ACTIONS(624),
    [anon_sym_bytes9] = ACTIONS(624),
    [anon_sym_bytes10] = ACTIONS(624),
    [anon_sym_bytes11] = ACTIONS(624),
    [anon_sym_bytes12] = ACTIONS(624),
    [anon_sym_bytes13] = ACTIONS(624),
    [anon_sym_bytes14] = ACTIONS(624),
    [anon_sym_bytes15] = ACTIONS(624),
    [anon_sym_bytes16] = ACTIONS(624),
    [anon_sym_bytes17] = ACTIONS(624),
    [anon_sym_bytes18] = ACTIONS(624),
    [anon_sym_bytes19] = ACTIONS(624),
    [anon_sym_bytes20] = ACTIONS(624),
    [anon_sym_bytes21] = ACTIONS(624),
    [anon_sym_bytes22] = ACTIONS(624),
    [anon_sym_bytes23] = ACTIONS(624),
    [anon_sym_bytes24] = ACTIONS(624),
    [anon_sym_bytes25] = ACTIONS(624),
    [anon_sym_bytes26] = ACTIONS(624),
    [anon_sym_bytes27] = ACTIONS(624),
    [anon_sym_bytes28] = ACTIONS(624),
    [anon_sym_bytes29] = ACTIONS(624),
    [anon_sym_bytes30] = ACTIONS(624),
    [anon_sym_bytes31] = ACTIONS(624),
    [anon_sym_bytes32] = ACTIONS(624),
    [anon_sym_fixed] = ACTIONS(624),
    [aux_sym__fixed_token1] = ACTIONS(624),
    [anon_sym_ufixed] = ACTIONS(624),
    [aux_sym__ufixed_token1] = ACTIONS(624),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_identifier] = ACTIONS(768),
    [anon_sym_RBRACE] = ACTIONS(770),
    [anon_sym_type] = ACTIONS(768),
    [anon_sym_error] = ACTIONS(768),
    [anon_sym_struct] = ACTIONS(768),
    [anon_sym_enum] = ACTIONS(768),
    [anon_sym_event] = ACTIONS(768),
    [anon_sym_using] = ACTIONS(768),
    [anon_sym_function] = ACTIONS(768),
    [anon_sym_byte] = ACTIONS(768),
    [anon_sym_address] = ACTIONS(768),
    [anon_sym_var] = ACTIONS(768),
    [anon_sym_modifier] = ACTIONS(768),
    [anon_sym_constructor] = ACTIONS(768),
    [anon_sym_fallback] = ACTIONS(768),
    [anon_sym_receive] = ACTIONS(768),
    [anon_sym_mapping] = ACTIONS(768),
    [anon_sym_bool] = ACTIONS(768),
    [anon_sym_string] = ACTIONS(768),
    [anon_sym_int] = ACTIONS(768),
    [anon_sym_int8] = ACTIONS(768),
    [anon_sym_int16] = ACTIONS(768),
    [anon_sym_int24] = ACTIONS(768),
    [anon_sym_int32] = ACTIONS(768),
    [anon_sym_int40] = ACTIONS(768),
    [anon_sym_int48] = ACTIONS(768),
    [anon_sym_int56] = ACTIONS(768),
    [anon_sym_int64] = ACTIONS(768),
    [anon_sym_int72] = ACTIONS(768),
    [anon_sym_int80] = ACTIONS(768),
    [anon_sym_int88] = ACTIONS(768),
    [anon_sym_int96] = ACTIONS(768),
    [anon_sym_int104] = ACTIONS(768),
    [anon_sym_int112] = ACTIONS(768),
    [anon_sym_int120] = ACTIONS(768),
    [anon_sym_int128] = ACTIONS(768),
    [anon_sym_int136] = ACTIONS(768),
    [anon_sym_int144] = ACTIONS(768),
    [anon_sym_int152] = ACTIONS(768),
    [anon_sym_int160] = ACTIONS(768),
    [anon_sym_int168] = ACTIONS(768),
    [anon_sym_int176] = ACTIONS(768),
    [anon_sym_int184] = ACTIONS(768),
    [anon_sym_int192] = ACTIONS(768),
    [anon_sym_int200] = ACTIONS(768),
    [anon_sym_int208] = ACTIONS(768),
    [anon_sym_int216] = ACTIONS(768),
    [anon_sym_int224] = ACTIONS(768),
    [anon_sym_int232] = ACTIONS(768),
    [anon_sym_int240] = ACTIONS(768),
    [anon_sym_int248] = ACTIONS(768),
    [anon_sym_int256] = ACTIONS(768),
    [anon_sym_uint] = ACTIONS(768),
    [anon_sym_uint8] = ACTIONS(768),
    [anon_sym_uint16] = ACTIONS(768),
    [anon_sym_uint24] = ACTIONS(768),
    [anon_sym_uint32] = ACTIONS(768),
    [anon_sym_uint40] = ACTIONS(768),
    [anon_sym_uint48] = ACTIONS(768),
    [anon_sym_uint56] = ACTIONS(768),
    [anon_sym_uint64] = ACTIONS(768),
    [anon_sym_uint72] = ACTIONS(768),
    [anon_sym_uint80] = ACTIONS(768),
    [anon_sym_uint88] = ACTIONS(768),
    [anon_sym_uint96] = ACTIONS(768),
    [anon_sym_uint104] = ACTIONS(768),
    [anon_sym_uint112] = ACTIONS(768),
    [anon_sym_uint120] = ACTIONS(768),
    [anon_sym_uint128] = ACTIONS(768),
    [anon_sym_uint136] = ACTIONS(768),
    [anon_sym_uint144] = ACTIONS(768),
    [anon_sym_uint152] = ACTIONS(768),
    [anon_sym_uint160] = ACTIONS(768),
    [anon_sym_uint168] = ACTIONS(768),
    [anon_sym_uint176] = ACTIONS(768),
    [anon_sym_uint184] = ACTIONS(768),
    [anon_sym_uint192] = ACTIONS(768),
    [anon_sym_uint200] = ACTIONS(768),
    [anon_sym_uint208] = ACTIONS(768),
    [anon_sym_uint216] = ACTIONS(768),
    [anon_sym_uint224] = ACTIONS(768),
    [anon_sym_uint232] = ACTIONS(768),
    [anon_sym_uint240] = ACTIONS(768),
    [anon_sym_uint248] = ACTIONS(768),
    [anon_sym_uint256] = ACTIONS(768),
    [anon_sym_bytes] = ACTIONS(768),
    [anon_sym_bytes1] = ACTIONS(768),
    [anon_sym_bytes2] = ACTIONS(768),
    [anon_sym_bytes3] = ACTIONS(768),
    [anon_sym_bytes4] = ACTIONS(768),
    [anon_sym_bytes5] = ACTIONS(768),
    [anon_sym_bytes6] = ACTIONS(768),
    [anon_sym_bytes7] = ACTIONS(768),
    [anon_sym_bytes8] = ACTIONS(768),
    [anon_sym_bytes9] = ACTIONS(768),
    [anon_sym_bytes10] = ACTIONS(768),
    [anon_sym_bytes11] = ACTIONS(768),
    [anon_sym_bytes12] = ACTIONS(768),
    [anon_sym_bytes13] = ACTIONS(768),
    [anon_sym_bytes14] = ACTIONS(768),
    [anon_sym_bytes15] = ACTIONS(768),
    [anon_sym_bytes16] = ACTIONS(768),
    [anon_sym_bytes17] = ACTIONS(768),
    [anon_sym_bytes18] = ACTIONS(768),
    [anon_sym_bytes19] = ACTIONS(768),
    [anon_sym_bytes20] = ACTIONS(768),
    [anon_sym_bytes21] = ACTIONS(768),
    [anon_sym_bytes22] = ACTIONS(768),
    [anon_sym_bytes23] = ACTIONS(768),
    [anon_sym_bytes24] = ACTIONS(768),
    [anon_sym_bytes25] = ACTIONS(768),
    [anon_sym_bytes26] = ACTIONS(768),
    [anon_sym_bytes27] = ACTIONS(768),
    [anon_sym_bytes28] = ACTIONS(768),
    [anon_sym_bytes29] = ACTIONS(768),
    [anon_sym_bytes30] = ACTIONS(768),
    [anon_sym_bytes31] = ACTIONS(768),
    [anon_sym_bytes32] = ACTIONS(768),
    [anon_sym_fixed] = ACTIONS(768),
    [aux_sym__fixed_token1] = ACTIONS(768),
    [anon_sym_ufixed] = ACTIONS(768),
    [aux_sym__ufixed_token1] = ACTIONS(768),
    [sym_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_identifier] = ACTIONS(636),
    [anon_sym_RBRACE] = ACTIONS(634),
    [anon_sym_type] = ACTIONS(636),
    [anon_sym_error] = ACTIONS(636),
    [anon_sym_struct] = ACTIONS(636),
    [anon_sym_enum] = ACTIONS(636),
    [anon_sym_event] = ACTIONS(636),
    [anon_sym_using] = ACTIONS(636),
    [anon_sym_function] = ACTIONS(636),
    [anon_sym_byte] = ACTIONS(636),
    [anon_sym_address] = ACTIONS(636),
    [anon_sym_var] = ACTIONS(636),
    [anon_sym_modifier] = ACTIONS(636),
    [anon_sym_constructor] = ACTIONS(636),
    [anon_sym_fallback] = ACTIONS(636),
    [anon_sym_receive] = ACTIONS(636),
    [anon_sym_mapping] = ACTIONS(636),
    [anon_sym_bool] = ACTIONS(636),
    [anon_sym_string] = ACTIONS(636),
    [anon_sym_int] = ACTIONS(636),
    [anon_sym_int8] = ACTIONS(636),
    [anon_sym_int16] = ACTIONS(636),
    [anon_sym_int24] = ACTIONS(636),
    [anon_sym_int32] = ACTIONS(636),
    [anon_sym_int40] = ACTIONS(636),
    [anon_sym_int48] = ACTIONS(636),
    [anon_sym_int56] = ACTIONS(636),
    [anon_sym_int64] = ACTIONS(636),
    [anon_sym_int72] = ACTIONS(636),
    [anon_sym_int80] = ACTIONS(636),
    [anon_sym_int88] = ACTIONS(636),
    [anon_sym_int96] = ACTIONS(636),
    [anon_sym_int104] = ACTIONS(636),
    [anon_sym_int112] = ACTIONS(636),
    [anon_sym_int120] = ACTIONS(636),
    [anon_sym_int128] = ACTIONS(636),
    [anon_sym_int136] = ACTIONS(636),
    [anon_sym_int144] = ACTIONS(636),
    [anon_sym_int152] = ACTIONS(636),
    [anon_sym_int160] = ACTIONS(636),
    [anon_sym_int168] = ACTIONS(636),
    [anon_sym_int176] = ACTIONS(636),
    [anon_sym_int184] = ACTIONS(636),
    [anon_sym_int192] = ACTIONS(636),
    [anon_sym_int200] = ACTIONS(636),
    [anon_sym_int208] = ACTIONS(636),
    [anon_sym_int216] = ACTIONS(636),
    [anon_sym_int224] = ACTIONS(636),
    [anon_sym_int232] = ACTIONS(636),
    [anon_sym_int240] = ACTIONS(636),
    [anon_sym_int248] = ACTIONS(636),
    [anon_sym_int256] = ACTIONS(636),
    [anon_sym_uint] = ACTIONS(636),
    [anon_sym_uint8] = ACTIONS(636),
    [anon_sym_uint16] = ACTIONS(636),
    [anon_sym_uint24] = ACTIONS(636),
    [anon_sym_uint32] = ACTIONS(636),
    [anon_sym_uint40] = ACTIONS(636),
    [anon_sym_uint48] = ACTIONS(636),
    [anon_sym_uint56] = ACTIONS(636),
    [anon_sym_uint64] = ACTIONS(636),
    [anon_sym_uint72] = ACTIONS(636),
    [anon_sym_uint80] = ACTIONS(636),
    [anon_sym_uint88] = ACTIONS(636),
    [anon_sym_uint96] = ACTIONS(636),
    [anon_sym_uint104] = ACTIONS(636),
    [anon_sym_uint112] = ACTIONS(636),
    [anon_sym_uint120] = ACTIONS(636),
    [anon_sym_uint128] = ACTIONS(636),
    [anon_sym_uint136] = ACTIONS(636),
    [anon_sym_uint144] = ACTIONS(636),
    [anon_sym_uint152] = ACTIONS(636),
    [anon_sym_uint160] = ACTIONS(636),
    [anon_sym_uint168] = ACTIONS(636),
    [anon_sym_uint176] = ACTIONS(636),
    [anon_sym_uint184] = ACTIONS(636),
    [anon_sym_uint192] = ACTIONS(636),
    [anon_sym_uint200] = ACTIONS(636),
    [anon_sym_uint208] = ACTIONS(636),
    [anon_sym_uint216] = ACTIONS(636),
    [anon_sym_uint224] = ACTIONS(636),
    [anon_sym_uint232] = ACTIONS(636),
    [anon_sym_uint240] = ACTIONS(636),
    [anon_sym_uint248] = ACTIONS(636),
    [anon_sym_uint256] = ACTIONS(636),
    [anon_sym_bytes] = ACTIONS(636),
    [anon_sym_bytes1] = ACTIONS(636),
    [anon_sym_bytes2] = ACTIONS(636),
    [anon_sym_bytes3] = ACTIONS(636),
    [anon_sym_bytes4] = ACTIONS(636),
    [anon_sym_bytes5] = ACTIONS(636),
    [anon_sym_bytes6] = ACTIONS(636),
    [anon_sym_bytes7] = ACTIONS(636),
    [anon_sym_bytes8] = ACTIONS(636),
    [anon_sym_bytes9] = ACTIONS(636),
    [anon_sym_bytes10] = ACTIONS(636),
    [anon_sym_bytes11] = ACTIONS(636),
    [anon_sym_bytes12] = ACTIONS(636),
    [anon_sym_bytes13] = ACTIONS(636),
    [anon_sym_bytes14] = ACTIONS(636),
    [anon_sym_bytes15] = ACTIONS(636),
    [anon_sym_bytes16] = ACTIONS(636),
    [anon_sym_bytes17] = ACTIONS(636),
    [anon_sym_bytes18] = ACTIONS(636),
    [anon_sym_bytes19] = ACTIONS(636),
    [anon_sym_bytes20] = ACTIONS(636),
    [anon_sym_bytes21] = ACTIONS(636),
    [anon_sym_bytes22] = ACTIONS(636),
    [anon_sym_bytes23] = ACTIONS(636),
    [anon_sym_bytes24] = ACTIONS(636),
    [anon_sym_bytes25] = ACTIONS(636),
    [anon_sym_bytes26] = ACTIONS(636),
    [anon_sym_bytes27] = ACTIONS(636),
    [anon_sym_bytes28] = ACTIONS(636),
    [anon_sym_bytes29] = ACTIONS(636),
    [anon_sym_bytes30] = ACTIONS(636),
    [anon_sym_bytes31] = ACTIONS(636),
    [anon_sym_bytes32] = ACTIONS(636),
    [anon_sym_fixed] = ACTIONS(636),
    [aux_sym__fixed_token1] = ACTIONS(636),
    [anon_sym_ufixed] = ACTIONS(636),
    [aux_sym__ufixed_token1] = ACTIONS(636),
    [sym_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_identifier] = ACTIONS(772),
    [anon_sym_RBRACE] = ACTIONS(774),
    [anon_sym_type] = ACTIONS(772),
    [anon_sym_error] = ACTIONS(772),
    [anon_sym_struct] = ACTIONS(772),
    [anon_sym_enum] = ACTIONS(772),
    [anon_sym_event] = ACTIONS(772),
    [anon_sym_using] = ACTIONS(772),
    [anon_sym_function] = ACTIONS(772),
    [anon_sym_byte] = ACTIONS(772),
    [anon_sym_address] = ACTIONS(772),
    [anon_sym_var] = ACTIONS(772),
    [anon_sym_modifier] = ACTIONS(772),
    [anon_sym_constructor] = ACTIONS(772),
    [anon_sym_fallback] = ACTIONS(772),
    [anon_sym_receive] = ACTIONS(772),
    [anon_sym_mapping] = ACTIONS(772),
    [anon_sym_bool] = ACTIONS(772),
    [anon_sym_string] = ACTIONS(772),
    [anon_sym_int] = ACTIONS(772),
    [anon_sym_int8] = ACTIONS(772),
    [anon_sym_int16] = ACTIONS(772),
    [anon_sym_int24] = ACTIONS(772),
    [anon_sym_int32] = ACTIONS(772),
    [anon_sym_int40] = ACTIONS(772),
    [anon_sym_int48] = ACTIONS(772),
    [anon_sym_int56] = ACTIONS(772),
    [anon_sym_int64] = ACTIONS(772),
    [anon_sym_int72] = ACTIONS(772),
    [anon_sym_int80] = ACTIONS(772),
    [anon_sym_int88] = ACTIONS(772),
    [anon_sym_int96] = ACTIONS(772),
    [anon_sym_int104] = ACTIONS(772),
    [anon_sym_int112] = ACTIONS(772),
    [anon_sym_int120] = ACTIONS(772),
    [anon_sym_int128] = ACTIONS(772),
    [anon_sym_int136] = ACTIONS(772),
    [anon_sym_int144] = ACTIONS(772),
    [anon_sym_int152] = ACTIONS(772),
    [anon_sym_int160] = ACTIONS(772),
    [anon_sym_int168] = ACTIONS(772),
    [anon_sym_int176] = ACTIONS(772),
    [anon_sym_int184] = ACTIONS(772),
    [anon_sym_int192] = ACTIONS(772),
    [anon_sym_int200] = ACTIONS(772),
    [anon_sym_int208] = ACTIONS(772),
    [anon_sym_int216] = ACTIONS(772),
    [anon_sym_int224] = ACTIONS(772),
    [anon_sym_int232] = ACTIONS(772),
    [anon_sym_int240] = ACTIONS(772),
    [anon_sym_int248] = ACTIONS(772),
    [anon_sym_int256] = ACTIONS(772),
    [anon_sym_uint] = ACTIONS(772),
    [anon_sym_uint8] = ACTIONS(772),
    [anon_sym_uint16] = ACTIONS(772),
    [anon_sym_uint24] = ACTIONS(772),
    [anon_sym_uint32] = ACTIONS(772),
    [anon_sym_uint40] = ACTIONS(772),
    [anon_sym_uint48] = ACTIONS(772),
    [anon_sym_uint56] = ACTIONS(772),
    [anon_sym_uint64] = ACTIONS(772),
    [anon_sym_uint72] = ACTIONS(772),
    [anon_sym_uint80] = ACTIONS(772),
    [anon_sym_uint88] = ACTIONS(772),
    [anon_sym_uint96] = ACTIONS(772),
    [anon_sym_uint104] = ACTIONS(772),
    [anon_sym_uint112] = ACTIONS(772),
    [anon_sym_uint120] = ACTIONS(772),
    [anon_sym_uint128] = ACTIONS(772),
    [anon_sym_uint136] = ACTIONS(772),
    [anon_sym_uint144] = ACTIONS(772),
    [anon_sym_uint152] = ACTIONS(772),
    [anon_sym_uint160] = ACTIONS(772),
    [anon_sym_uint168] = ACTIONS(772),
    [anon_sym_uint176] = ACTIONS(772),
    [anon_sym_uint184] = ACTIONS(772),
    [anon_sym_uint192] = ACTIONS(772),
    [anon_sym_uint200] = ACTIONS(772),
    [anon_sym_uint208] = ACTIONS(772),
    [anon_sym_uint216] = ACTIONS(772),
    [anon_sym_uint224] = ACTIONS(772),
    [anon_sym_uint232] = ACTIONS(772),
    [anon_sym_uint240] = ACTIONS(772),
    [anon_sym_uint248] = ACTIONS(772),
    [anon_sym_uint256] = ACTIONS(772),
    [anon_sym_bytes] = ACTIONS(772),
    [anon_sym_bytes1] = ACTIONS(772),
    [anon_sym_bytes2] = ACTIONS(772),
    [anon_sym_bytes3] = ACTIONS(772),
    [anon_sym_bytes4] = ACTIONS(772),
    [anon_sym_bytes5] = ACTIONS(772),
    [anon_sym_bytes6] = ACTIONS(772),
    [anon_sym_bytes7] = ACTIONS(772),
    [anon_sym_bytes8] = ACTIONS(772),
    [anon_sym_bytes9] = ACTIONS(772),
    [anon_sym_bytes10] = ACTIONS(772),
    [anon_sym_bytes11] = ACTIONS(772),
    [anon_sym_bytes12] = ACTIONS(772),
    [anon_sym_bytes13] = ACTIONS(772),
    [anon_sym_bytes14] = ACTIONS(772),
    [anon_sym_bytes15] = ACTIONS(772),
    [anon_sym_bytes16] = ACTIONS(772),
    [anon_sym_bytes17] = ACTIONS(772),
    [anon_sym_bytes18] = ACTIONS(772),
    [anon_sym_bytes19] = ACTIONS(772),
    [anon_sym_bytes20] = ACTIONS(772),
    [anon_sym_bytes21] = ACTIONS(772),
    [anon_sym_bytes22] = ACTIONS(772),
    [anon_sym_bytes23] = ACTIONS(772),
    [anon_sym_bytes24] = ACTIONS(772),
    [anon_sym_bytes25] = ACTIONS(772),
    [anon_sym_bytes26] = ACTIONS(772),
    [anon_sym_bytes27] = ACTIONS(772),
    [anon_sym_bytes28] = ACTIONS(772),
    [anon_sym_bytes29] = ACTIONS(772),
    [anon_sym_bytes30] = ACTIONS(772),
    [anon_sym_bytes31] = ACTIONS(772),
    [anon_sym_bytes32] = ACTIONS(772),
    [anon_sym_fixed] = ACTIONS(772),
    [aux_sym__fixed_token1] = ACTIONS(772),
    [anon_sym_ufixed] = ACTIONS(772),
    [aux_sym__ufixed_token1] = ACTIONS(772),
    [sym_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_identifier] = ACTIONS(776),
    [anon_sym_RBRACE] = ACTIONS(778),
    [anon_sym_type] = ACTIONS(776),
    [anon_sym_error] = ACTIONS(776),
    [anon_sym_struct] = ACTIONS(776),
    [anon_sym_enum] = ACTIONS(776),
    [anon_sym_event] = ACTIONS(776),
    [anon_sym_using] = ACTIONS(776),
    [anon_sym_function] = ACTIONS(776),
    [anon_sym_byte] = ACTIONS(776),
    [anon_sym_address] = ACTIONS(776),
    [anon_sym_var] = ACTIONS(776),
    [anon_sym_modifier] = ACTIONS(776),
    [anon_sym_constructor] = ACTIONS(776),
    [anon_sym_fallback] = ACTIONS(776),
    [anon_sym_receive] = ACTIONS(776),
    [anon_sym_mapping] = ACTIONS(776),
    [anon_sym_bool] = ACTIONS(776),
    [anon_sym_string] = ACTIONS(776),
    [anon_sym_int] = ACTIONS(776),
    [anon_sym_int8] = ACTIONS(776),
    [anon_sym_int16] = ACTIONS(776),
    [anon_sym_int24] = ACTIONS(776),
    [anon_sym_int32] = ACTIONS(776),
    [anon_sym_int40] = ACTIONS(776),
    [anon_sym_int48] = ACTIONS(776),
    [anon_sym_int56] = ACTIONS(776),
    [anon_sym_int64] = ACTIONS(776),
    [anon_sym_int72] = ACTIONS(776),
    [anon_sym_int80] = ACTIONS(776),
    [anon_sym_int88] = ACTIONS(776),
    [anon_sym_int96] = ACTIONS(776),
    [anon_sym_int104] = ACTIONS(776),
    [anon_sym_int112] = ACTIONS(776),
    [anon_sym_int120] = ACTIONS(776),
    [anon_sym_int128] = ACTIONS(776),
    [anon_sym_int136] = ACTIONS(776),
    [anon_sym_int144] = ACTIONS(776),
    [anon_sym_int152] = ACTIONS(776),
    [anon_sym_int160] = ACTIONS(776),
    [anon_sym_int168] = ACTIONS(776),
    [anon_sym_int176] = ACTIONS(776),
    [anon_sym_int184] = ACTIONS(776),
    [anon_sym_int192] = ACTIONS(776),
    [anon_sym_int200] = ACTIONS(776),
    [anon_sym_int208] = ACTIONS(776),
    [anon_sym_int216] = ACTIONS(776),
    [anon_sym_int224] = ACTIONS(776),
    [anon_sym_int232] = ACTIONS(776),
    [anon_sym_int240] = ACTIONS(776),
    [anon_sym_int248] = ACTIONS(776),
    [anon_sym_int256] = ACTIONS(776),
    [anon_sym_uint] = ACTIONS(776),
    [anon_sym_uint8] = ACTIONS(776),
    [anon_sym_uint16] = ACTIONS(776),
    [anon_sym_uint24] = ACTIONS(776),
    [anon_sym_uint32] = ACTIONS(776),
    [anon_sym_uint40] = ACTIONS(776),
    [anon_sym_uint48] = ACTIONS(776),
    [anon_sym_uint56] = ACTIONS(776),
    [anon_sym_uint64] = ACTIONS(776),
    [anon_sym_uint72] = ACTIONS(776),
    [anon_sym_uint80] = ACTIONS(776),
    [anon_sym_uint88] = ACTIONS(776),
    [anon_sym_uint96] = ACTIONS(776),
    [anon_sym_uint104] = ACTIONS(776),
    [anon_sym_uint112] = ACTIONS(776),
    [anon_sym_uint120] = ACTIONS(776),
    [anon_sym_uint128] = ACTIONS(776),
    [anon_sym_uint136] = ACTIONS(776),
    [anon_sym_uint144] = ACTIONS(776),
    [anon_sym_uint152] = ACTIONS(776),
    [anon_sym_uint160] = ACTIONS(776),
    [anon_sym_uint168] = ACTIONS(776),
    [anon_sym_uint176] = ACTIONS(776),
    [anon_sym_uint184] = ACTIONS(776),
    [anon_sym_uint192] = ACTIONS(776),
    [anon_sym_uint200] = ACTIONS(776),
    [anon_sym_uint208] = ACTIONS(776),
    [anon_sym_uint216] = ACTIONS(776),
    [anon_sym_uint224] = ACTIONS(776),
    [anon_sym_uint232] = ACTIONS(776),
    [anon_sym_uint240] = ACTIONS(776),
    [anon_sym_uint248] = ACTIONS(776),
    [anon_sym_uint256] = ACTIONS(776),
    [anon_sym_bytes] = ACTIONS(776),
    [anon_sym_bytes1] = ACTIONS(776),
    [anon_sym_bytes2] = ACTIONS(776),
    [anon_sym_bytes3] = ACTIONS(776),
    [anon_sym_bytes4] = ACTIONS(776),
    [anon_sym_bytes5] = ACTIONS(776),
    [anon_sym_bytes6] = ACTIONS(776),
    [anon_sym_bytes7] = ACTIONS(776),
    [anon_sym_bytes8] = ACTIONS(776),
    [anon_sym_bytes9] = ACTIONS(776),
    [anon_sym_bytes10] = ACTIONS(776),
    [anon_sym_bytes11] = ACTIONS(776),
    [anon_sym_bytes12] = ACTIONS(776),
    [anon_sym_bytes13] = ACTIONS(776),
    [anon_sym_bytes14] = ACTIONS(776),
    [anon_sym_bytes15] = ACTIONS(776),
    [anon_sym_bytes16] = ACTIONS(776),
    [anon_sym_bytes17] = ACTIONS(776),
    [anon_sym_bytes18] = ACTIONS(776),
    [anon_sym_bytes19] = ACTIONS(776),
    [anon_sym_bytes20] = ACTIONS(776),
    [anon_sym_bytes21] = ACTIONS(776),
    [anon_sym_bytes22] = ACTIONS(776),
    [anon_sym_bytes23] = ACTIONS(776),
    [anon_sym_bytes24] = ACTIONS(776),
    [anon_sym_bytes25] = ACTIONS(776),
    [anon_sym_bytes26] = ACTIONS(776),
    [anon_sym_bytes27] = ACTIONS(776),
    [anon_sym_bytes28] = ACTIONS(776),
    [anon_sym_bytes29] = ACTIONS(776),
    [anon_sym_bytes30] = ACTIONS(776),
    [anon_sym_bytes31] = ACTIONS(776),
    [anon_sym_bytes32] = ACTIONS(776),
    [anon_sym_fixed] = ACTIONS(776),
    [aux_sym__fixed_token1] = ACTIONS(776),
    [anon_sym_ufixed] = ACTIONS(776),
    [aux_sym__ufixed_token1] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_identifier] = ACTIONS(652),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_type] = ACTIONS(652),
    [anon_sym_error] = ACTIONS(652),
    [anon_sym_struct] = ACTIONS(652),
    [anon_sym_enum] = ACTIONS(652),
    [anon_sym_event] = ACTIONS(652),
    [anon_sym_using] = ACTIONS(652),
    [anon_sym_function] = ACTIONS(652),
    [anon_sym_byte] = ACTIONS(652),
    [anon_sym_address] = ACTIONS(652),
    [anon_sym_var] = ACTIONS(652),
    [anon_sym_modifier] = ACTIONS(652),
    [anon_sym_constructor] = ACTIONS(652),
    [anon_sym_fallback] = ACTIONS(652),
    [anon_sym_receive] = ACTIONS(652),
    [anon_sym_mapping] = ACTIONS(652),
    [anon_sym_bool] = ACTIONS(652),
    [anon_sym_string] = ACTIONS(652),
    [anon_sym_int] = ACTIONS(652),
    [anon_sym_int8] = ACTIONS(652),
    [anon_sym_int16] = ACTIONS(652),
    [anon_sym_int24] = ACTIONS(652),
    [anon_sym_int32] = ACTIONS(652),
    [anon_sym_int40] = ACTIONS(652),
    [anon_sym_int48] = ACTIONS(652),
    [anon_sym_int56] = ACTIONS(652),
    [anon_sym_int64] = ACTIONS(652),
    [anon_sym_int72] = ACTIONS(652),
    [anon_sym_int80] = ACTIONS(652),
    [anon_sym_int88] = ACTIONS(652),
    [anon_sym_int96] = ACTIONS(652),
    [anon_sym_int104] = ACTIONS(652),
    [anon_sym_int112] = ACTIONS(652),
    [anon_sym_int120] = ACTIONS(652),
    [anon_sym_int128] = ACTIONS(652),
    [anon_sym_int136] = ACTIONS(652),
    [anon_sym_int144] = ACTIONS(652),
    [anon_sym_int152] = ACTIONS(652),
    [anon_sym_int160] = ACTIONS(652),
    [anon_sym_int168] = ACTIONS(652),
    [anon_sym_int176] = ACTIONS(652),
    [anon_sym_int184] = ACTIONS(652),
    [anon_sym_int192] = ACTIONS(652),
    [anon_sym_int200] = ACTIONS(652),
    [anon_sym_int208] = ACTIONS(652),
    [anon_sym_int216] = ACTIONS(652),
    [anon_sym_int224] = ACTIONS(652),
    [anon_sym_int232] = ACTIONS(652),
    [anon_sym_int240] = ACTIONS(652),
    [anon_sym_int248] = ACTIONS(652),
    [anon_sym_int256] = ACTIONS(652),
    [anon_sym_uint] = ACTIONS(652),
    [anon_sym_uint8] = ACTIONS(652),
    [anon_sym_uint16] = ACTIONS(652),
    [anon_sym_uint24] = ACTIONS(652),
    [anon_sym_uint32] = ACTIONS(652),
    [anon_sym_uint40] = ACTIONS(652),
    [anon_sym_uint48] = ACTIONS(652),
    [anon_sym_uint56] = ACTIONS(652),
    [anon_sym_uint64] = ACTIONS(652),
    [anon_sym_uint72] = ACTIONS(652),
    [anon_sym_uint80] = ACTIONS(652),
    [anon_sym_uint88] = ACTIONS(652),
    [anon_sym_uint96] = ACTIONS(652),
    [anon_sym_uint104] = ACTIONS(652),
    [anon_sym_uint112] = ACTIONS(652),
    [anon_sym_uint120] = ACTIONS(652),
    [anon_sym_uint128] = ACTIONS(652),
    [anon_sym_uint136] = ACTIONS(652),
    [anon_sym_uint144] = ACTIONS(652),
    [anon_sym_uint152] = ACTIONS(652),
    [anon_sym_uint160] = ACTIONS(652),
    [anon_sym_uint168] = ACTIONS(652),
    [anon_sym_uint176] = ACTIONS(652),
    [anon_sym_uint184] = ACTIONS(652),
    [anon_sym_uint192] = ACTIONS(652),
    [anon_sym_uint200] = ACTIONS(652),
    [anon_sym_uint208] = ACTIONS(652),
    [anon_sym_uint216] = ACTIONS(652),
    [anon_sym_uint224] = ACTIONS(652),
    [anon_sym_uint232] = ACTIONS(652),
    [anon_sym_uint240] = ACTIONS(652),
    [anon_sym_uint248] = ACTIONS(652),
    [anon_sym_uint256] = ACTIONS(652),
    [anon_sym_bytes] = ACTIONS(652),
    [anon_sym_bytes1] = ACTIONS(652),
    [anon_sym_bytes2] = ACTIONS(652),
    [anon_sym_bytes3] = ACTIONS(652),
    [anon_sym_bytes4] = ACTIONS(652),
    [anon_sym_bytes5] = ACTIONS(652),
    [anon_sym_bytes6] = ACTIONS(652),
    [anon_sym_bytes7] = ACTIONS(652),
    [anon_sym_bytes8] = ACTIONS(652),
    [anon_sym_bytes9] = ACTIONS(652),
    [anon_sym_bytes10] = ACTIONS(652),
    [anon_sym_bytes11] = ACTIONS(652),
    [anon_sym_bytes12] = ACTIONS(652),
    [anon_sym_bytes13] = ACTIONS(652),
    [anon_sym_bytes14] = ACTIONS(652),
    [anon_sym_bytes15] = ACTIONS(652),
    [anon_sym_bytes16] = ACTIONS(652),
    [anon_sym_bytes17] = ACTIONS(652),
    [anon_sym_bytes18] = ACTIONS(652),
    [anon_sym_bytes19] = ACTIONS(652),
    [anon_sym_bytes20] = ACTIONS(652),
    [anon_sym_bytes21] = ACTIONS(652),
    [anon_sym_bytes22] = ACTIONS(652),
    [anon_sym_bytes23] = ACTIONS(652),
    [anon_sym_bytes24] = ACTIONS(652),
    [anon_sym_bytes25] = ACTIONS(652),
    [anon_sym_bytes26] = ACTIONS(652),
    [anon_sym_bytes27] = ACTIONS(652),
    [anon_sym_bytes28] = ACTIONS(652),
    [anon_sym_bytes29] = ACTIONS(652),
    [anon_sym_bytes30] = ACTIONS(652),
    [anon_sym_bytes31] = ACTIONS(652),
    [anon_sym_bytes32] = ACTIONS(652),
    [anon_sym_fixed] = ACTIONS(652),
    [aux_sym__fixed_token1] = ACTIONS(652),
    [anon_sym_ufixed] = ACTIONS(652),
    [aux_sym__ufixed_token1] = ACTIONS(652),
    [sym_comment] = ACTIONS(3),
  },
  [191] = {
    [sym_identifier] = ACTIONS(780),
    [anon_sym_RBRACE] = ACTIONS(782),
    [anon_sym_type] = ACTIONS(780),
    [anon_sym_error] = ACTIONS(780),
    [anon_sym_struct] = ACTIONS(780),
    [anon_sym_enum] = ACTIONS(780),
    [anon_sym_event] = ACTIONS(780),
    [anon_sym_using] = ACTIONS(780),
    [anon_sym_function] = ACTIONS(780),
    [anon_sym_byte] = ACTIONS(780),
    [anon_sym_address] = ACTIONS(780),
    [anon_sym_var] = ACTIONS(780),
    [anon_sym_modifier] = ACTIONS(780),
    [anon_sym_constructor] = ACTIONS(780),
    [anon_sym_fallback] = ACTIONS(780),
    [anon_sym_receive] = ACTIONS(780),
    [anon_sym_mapping] = ACTIONS(780),
    [anon_sym_bool] = ACTIONS(780),
    [anon_sym_string] = ACTIONS(780),
    [anon_sym_int] = ACTIONS(780),
    [anon_sym_int8] = ACTIONS(780),
    [anon_sym_int16] = ACTIONS(780),
    [anon_sym_int24] = ACTIONS(780),
    [anon_sym_int32] = ACTIONS(780),
    [anon_sym_int40] = ACTIONS(780),
    [anon_sym_int48] = ACTIONS(780),
    [anon_sym_int56] = ACTIONS(780),
    [anon_sym_int64] = ACTIONS(780),
    [anon_sym_int72] = ACTIONS(780),
    [anon_sym_int80] = ACTIONS(780),
    [anon_sym_int88] = ACTIONS(780),
    [anon_sym_int96] = ACTIONS(780),
    [anon_sym_int104] = ACTIONS(780),
    [anon_sym_int112] = ACTIONS(780),
    [anon_sym_int120] = ACTIONS(780),
    [anon_sym_int128] = ACTIONS(780),
    [anon_sym_int136] = ACTIONS(780),
    [anon_sym_int144] = ACTIONS(780),
    [anon_sym_int152] = ACTIONS(780),
    [anon_sym_int160] = ACTIONS(780),
    [anon_sym_int168] = ACTIONS(780),
    [anon_sym_int176] = ACTIONS(780),
    [anon_sym_int184] = ACTIONS(780),
    [anon_sym_int192] = ACTIONS(780),
    [anon_sym_int200] = ACTIONS(780),
    [anon_sym_int208] = ACTIONS(780),
    [anon_sym_int216] = ACTIONS(780),
    [anon_sym_int224] = ACTIONS(780),
    [anon_sym_int232] = ACTIONS(780),
    [anon_sym_int240] = ACTIONS(780),
    [anon_sym_int248] = ACTIONS(780),
    [anon_sym_int256] = ACTIONS(780),
    [anon_sym_uint] = ACTIONS(780),
    [anon_sym_uint8] = ACTIONS(780),
    [anon_sym_uint16] = ACTIONS(780),
    [anon_sym_uint24] = ACTIONS(780),
    [anon_sym_uint32] = ACTIONS(780),
    [anon_sym_uint40] = ACTIONS(780),
    [anon_sym_uint48] = ACTIONS(780),
    [anon_sym_uint56] = ACTIONS(780),
    [anon_sym_uint64] = ACTIONS(780),
    [anon_sym_uint72] = ACTIONS(780),
    [anon_sym_uint80] = ACTIONS(780),
    [anon_sym_uint88] = ACTIONS(780),
    [anon_sym_uint96] = ACTIONS(780),
    [anon_sym_uint104] = ACTIONS(780),
    [anon_sym_uint112] = ACTIONS(780),
    [anon_sym_uint120] = ACTIONS(780),
    [anon_sym_uint128] = ACTIONS(780),
    [anon_sym_uint136] = ACTIONS(780),
    [anon_sym_uint144] = ACTIONS(780),
    [anon_sym_uint152] = ACTIONS(780),
    [anon_sym_uint160] = ACTIONS(780),
    [anon_sym_uint168] = ACTIONS(780),
    [anon_sym_uint176] = ACTIONS(780),
    [anon_sym_uint184] = ACTIONS(780),
    [anon_sym_uint192] = ACTIONS(780),
    [anon_sym_uint200] = ACTIONS(780),
    [anon_sym_uint208] = ACTIONS(780),
    [anon_sym_uint216] = ACTIONS(780),
    [anon_sym_uint224] = ACTIONS(780),
    [anon_sym_uint232] = ACTIONS(780),
    [anon_sym_uint240] = ACTIONS(780),
    [anon_sym_uint248] = ACTIONS(780),
    [anon_sym_uint256] = ACTIONS(780),
    [anon_sym_bytes] = ACTIONS(780),
    [anon_sym_bytes1] = ACTIONS(780),
    [anon_sym_bytes2] = ACTIONS(780),
    [anon_sym_bytes3] = ACTIONS(780),
    [anon_sym_bytes4] = ACTIONS(780),
    [anon_sym_bytes5] = ACTIONS(780),
    [anon_sym_bytes6] = ACTIONS(780),
    [anon_sym_bytes7] = ACTIONS(780),
    [anon_sym_bytes8] = ACTIONS(780),
    [anon_sym_bytes9] = ACTIONS(780),
    [anon_sym_bytes10] = ACTIONS(780),
    [anon_sym_bytes11] = ACTIONS(780),
    [anon_sym_bytes12] = ACTIONS(780),
    [anon_sym_bytes13] = ACTIONS(780),
    [anon_sym_bytes14] = ACTIONS(780),
    [anon_sym_bytes15] = ACTIONS(780),
    [anon_sym_bytes16] = ACTIONS(780),
    [anon_sym_bytes17] = ACTIONS(780),
    [anon_sym_bytes18] = ACTIONS(780),
    [anon_sym_bytes19] = ACTIONS(780),
    [anon_sym_bytes20] = ACTIONS(780),
    [anon_sym_bytes21] = ACTIONS(780),
    [anon_sym_bytes22] = ACTIONS(780),
    [anon_sym_bytes23] = ACTIONS(780),
    [anon_sym_bytes24] = ACTIONS(780),
    [anon_sym_bytes25] = ACTIONS(780),
    [anon_sym_bytes26] = ACTIONS(780),
    [anon_sym_bytes27] = ACTIONS(780),
    [anon_sym_bytes28] = ACTIONS(780),
    [anon_sym_bytes29] = ACTIONS(780),
    [anon_sym_bytes30] = ACTIONS(780),
    [anon_sym_bytes31] = ACTIONS(780),
    [anon_sym_bytes32] = ACTIONS(780),
    [anon_sym_fixed] = ACTIONS(780),
    [aux_sym__fixed_token1] = ACTIONS(780),
    [anon_sym_ufixed] = ACTIONS(780),
    [aux_sym__ufixed_token1] = ACTIONS(780),
    [sym_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_identifier] = ACTIONS(784),
    [anon_sym_RBRACE] = ACTIONS(786),
    [anon_sym_type] = ACTIONS(784),
    [anon_sym_error] = ACTIONS(784),
    [anon_sym_struct] = ACTIONS(784),
    [anon_sym_enum] = ACTIONS(784),
    [anon_sym_event] = ACTIONS(784),
    [anon_sym_using] = ACTIONS(784),
    [anon_sym_function] = ACTIONS(784),
    [anon_sym_byte] = ACTIONS(784),
    [anon_sym_address] = ACTIONS(784),
    [anon_sym_var] = ACTIONS(784),
    [anon_sym_modifier] = ACTIONS(784),
    [anon_sym_constructor] = ACTIONS(784),
    [anon_sym_fallback] = ACTIONS(784),
    [anon_sym_receive] = ACTIONS(784),
    [anon_sym_mapping] = ACTIONS(784),
    [anon_sym_bool] = ACTIONS(784),
    [anon_sym_string] = ACTIONS(784),
    [anon_sym_int] = ACTIONS(784),
    [anon_sym_int8] = ACTIONS(784),
    [anon_sym_int16] = ACTIONS(784),
    [anon_sym_int24] = ACTIONS(784),
    [anon_sym_int32] = ACTIONS(784),
    [anon_sym_int40] = ACTIONS(784),
    [anon_sym_int48] = ACTIONS(784),
    [anon_sym_int56] = ACTIONS(784),
    [anon_sym_int64] = ACTIONS(784),
    [anon_sym_int72] = ACTIONS(784),
    [anon_sym_int80] = ACTIONS(784),
    [anon_sym_int88] = ACTIONS(784),
    [anon_sym_int96] = ACTIONS(784),
    [anon_sym_int104] = ACTIONS(784),
    [anon_sym_int112] = ACTIONS(784),
    [anon_sym_int120] = ACTIONS(784),
    [anon_sym_int128] = ACTIONS(784),
    [anon_sym_int136] = ACTIONS(784),
    [anon_sym_int144] = ACTIONS(784),
    [anon_sym_int152] = ACTIONS(784),
    [anon_sym_int160] = ACTIONS(784),
    [anon_sym_int168] = ACTIONS(784),
    [anon_sym_int176] = ACTIONS(784),
    [anon_sym_int184] = ACTIONS(784),
    [anon_sym_int192] = ACTIONS(784),
    [anon_sym_int200] = ACTIONS(784),
    [anon_sym_int208] = ACTIONS(784),
    [anon_sym_int216] = ACTIONS(784),
    [anon_sym_int224] = ACTIONS(784),
    [anon_sym_int232] = ACTIONS(784),
    [anon_sym_int240] = ACTIONS(784),
    [anon_sym_int248] = ACTIONS(784),
    [anon_sym_int256] = ACTIONS(784),
    [anon_sym_uint] = ACTIONS(784),
    [anon_sym_uint8] = ACTIONS(784),
    [anon_sym_uint16] = ACTIONS(784),
    [anon_sym_uint24] = ACTIONS(784),
    [anon_sym_uint32] = ACTIONS(784),
    [anon_sym_uint40] = ACTIONS(784),
    [anon_sym_uint48] = ACTIONS(784),
    [anon_sym_uint56] = ACTIONS(784),
    [anon_sym_uint64] = ACTIONS(784),
    [anon_sym_uint72] = ACTIONS(784),
    [anon_sym_uint80] = ACTIONS(784),
    [anon_sym_uint88] = ACTIONS(784),
    [anon_sym_uint96] = ACTIONS(784),
    [anon_sym_uint104] = ACTIONS(784),
    [anon_sym_uint112] = ACTIONS(784),
    [anon_sym_uint120] = ACTIONS(784),
    [anon_sym_uint128] = ACTIONS(784),
    [anon_sym_uint136] = ACTIONS(784),
    [anon_sym_uint144] = ACTIONS(784),
    [anon_sym_uint152] = ACTIONS(784),
    [anon_sym_uint160] = ACTIONS(784),
    [anon_sym_uint168] = ACTIONS(784),
    [anon_sym_uint176] = ACTIONS(784),
    [anon_sym_uint184] = ACTIONS(784),
    [anon_sym_uint192] = ACTIONS(784),
    [anon_sym_uint200] = ACTIONS(784),
    [anon_sym_uint208] = ACTIONS(784),
    [anon_sym_uint216] = ACTIONS(784),
    [anon_sym_uint224] = ACTIONS(784),
    [anon_sym_uint232] = ACTIONS(784),
    [anon_sym_uint240] = ACTIONS(784),
    [anon_sym_uint248] = ACTIONS(784),
    [anon_sym_uint256] = ACTIONS(784),
    [anon_sym_bytes] = ACTIONS(784),
    [anon_sym_bytes1] = ACTIONS(784),
    [anon_sym_bytes2] = ACTIONS(784),
    [anon_sym_bytes3] = ACTIONS(784),
    [anon_sym_bytes4] = ACTIONS(784),
    [anon_sym_bytes5] = ACTIONS(784),
    [anon_sym_bytes6] = ACTIONS(784),
    [anon_sym_bytes7] = ACTIONS(784),
    [anon_sym_bytes8] = ACTIONS(784),
    [anon_sym_bytes9] = ACTIONS(784),
    [anon_sym_bytes10] = ACTIONS(784),
    [anon_sym_bytes11] = ACTIONS(784),
    [anon_sym_bytes12] = ACTIONS(784),
    [anon_sym_bytes13] = ACTIONS(784),
    [anon_sym_bytes14] = ACTIONS(784),
    [anon_sym_bytes15] = ACTIONS(784),
    [anon_sym_bytes16] = ACTIONS(784),
    [anon_sym_bytes17] = ACTIONS(784),
    [anon_sym_bytes18] = ACTIONS(784),
    [anon_sym_bytes19] = ACTIONS(784),
    [anon_sym_bytes20] = ACTIONS(784),
    [anon_sym_bytes21] = ACTIONS(784),
    [anon_sym_bytes22] = ACTIONS(784),
    [anon_sym_bytes23] = ACTIONS(784),
    [anon_sym_bytes24] = ACTIONS(784),
    [anon_sym_bytes25] = ACTIONS(784),
    [anon_sym_bytes26] = ACTIONS(784),
    [anon_sym_bytes27] = ACTIONS(784),
    [anon_sym_bytes28] = ACTIONS(784),
    [anon_sym_bytes29] = ACTIONS(784),
    [anon_sym_bytes30] = ACTIONS(784),
    [anon_sym_bytes31] = ACTIONS(784),
    [anon_sym_bytes32] = ACTIONS(784),
    [anon_sym_fixed] = ACTIONS(784),
    [aux_sym__fixed_token1] = ACTIONS(784),
    [anon_sym_ufixed] = ACTIONS(784),
    [aux_sym__ufixed_token1] = ACTIONS(784),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_identifier] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(736),
    [anon_sym_type] = ACTIONS(738),
    [anon_sym_error] = ACTIONS(738),
    [anon_sym_struct] = ACTIONS(738),
    [anon_sym_enum] = ACTIONS(738),
    [anon_sym_event] = ACTIONS(738),
    [anon_sym_using] = ACTIONS(738),
    [anon_sym_function] = ACTIONS(738),
    [anon_sym_byte] = ACTIONS(738),
    [anon_sym_address] = ACTIONS(738),
    [anon_sym_var] = ACTIONS(738),
    [anon_sym_modifier] = ACTIONS(738),
    [anon_sym_constructor] = ACTIONS(738),
    [anon_sym_fallback] = ACTIONS(738),
    [anon_sym_receive] = ACTIONS(738),
    [anon_sym_mapping] = ACTIONS(738),
    [anon_sym_bool] = ACTIONS(738),
    [anon_sym_string] = ACTIONS(738),
    [anon_sym_int] = ACTIONS(738),
    [anon_sym_int8] = ACTIONS(738),
    [anon_sym_int16] = ACTIONS(738),
    [anon_sym_int24] = ACTIONS(738),
    [anon_sym_int32] = ACTIONS(738),
    [anon_sym_int40] = ACTIONS(738),
    [anon_sym_int48] = ACTIONS(738),
    [anon_sym_int56] = ACTIONS(738),
    [anon_sym_int64] = ACTIONS(738),
    [anon_sym_int72] = ACTIONS(738),
    [anon_sym_int80] = ACTIONS(738),
    [anon_sym_int88] = ACTIONS(738),
    [anon_sym_int96] = ACTIONS(738),
    [anon_sym_int104] = ACTIONS(738),
    [anon_sym_int112] = ACTIONS(738),
    [anon_sym_int120] = ACTIONS(738),
    [anon_sym_int128] = ACTIONS(738),
    [anon_sym_int136] = ACTIONS(738),
    [anon_sym_int144] = ACTIONS(738),
    [anon_sym_int152] = ACTIONS(738),
    [anon_sym_int160] = ACTIONS(738),
    [anon_sym_int168] = ACTIONS(738),
    [anon_sym_int176] = ACTIONS(738),
    [anon_sym_int184] = ACTIONS(738),
    [anon_sym_int192] = ACTIONS(738),
    [anon_sym_int200] = ACTIONS(738),
    [anon_sym_int208] = ACTIONS(738),
    [anon_sym_int216] = ACTIONS(738),
    [anon_sym_int224] = ACTIONS(738),
    [anon_sym_int232] = ACTIONS(738),
    [anon_sym_int240] = ACTIONS(738),
    [anon_sym_int248] = ACTIONS(738),
    [anon_sym_int256] = ACTIONS(738),
    [anon_sym_uint] = ACTIONS(738),
    [anon_sym_uint8] = ACTIONS(738),
    [anon_sym_uint16] = ACTIONS(738),
    [anon_sym_uint24] = ACTIONS(738),
    [anon_sym_uint32] = ACTIONS(738),
    [anon_sym_uint40] = ACTIONS(738),
    [anon_sym_uint48] = ACTIONS(738),
    [anon_sym_uint56] = ACTIONS(738),
    [anon_sym_uint64] = ACTIONS(738),
    [anon_sym_uint72] = ACTIONS(738),
    [anon_sym_uint80] = ACTIONS(738),
    [anon_sym_uint88] = ACTIONS(738),
    [anon_sym_uint96] = ACTIONS(738),
    [anon_sym_uint104] = ACTIONS(738),
    [anon_sym_uint112] = ACTIONS(738),
    [anon_sym_uint120] = ACTIONS(738),
    [anon_sym_uint128] = ACTIONS(738),
    [anon_sym_uint136] = ACTIONS(738),
    [anon_sym_uint144] = ACTIONS(738),
    [anon_sym_uint152] = ACTIONS(738),
    [anon_sym_uint160] = ACTIONS(738),
    [anon_sym_uint168] = ACTIONS(738),
    [anon_sym_uint176] = ACTIONS(738),
    [anon_sym_uint184] = ACTIONS(738),
    [anon_sym_uint192] = ACTIONS(738),
    [anon_sym_uint200] = ACTIONS(738),
    [anon_sym_uint208] = ACTIONS(738),
    [anon_sym_uint216] = ACTIONS(738),
    [anon_sym_uint224] = ACTIONS(738),
    [anon_sym_uint232] = ACTIONS(738),
    [anon_sym_uint240] = ACTIONS(738),
    [anon_sym_uint248] = ACTIONS(738),
    [anon_sym_uint256] = ACTIONS(738),
    [anon_sym_bytes] = ACTIONS(738),
    [anon_sym_bytes1] = ACTIONS(738),
    [anon_sym_bytes2] = ACTIONS(738),
    [anon_sym_bytes3] = ACTIONS(738),
    [anon_sym_bytes4] = ACTIONS(738),
    [anon_sym_bytes5] = ACTIONS(738),
    [anon_sym_bytes6] = ACTIONS(738),
    [anon_sym_bytes7] = ACTIONS(738),
    [anon_sym_bytes8] = ACTIONS(738),
    [anon_sym_bytes9] = ACTIONS(738),
    [anon_sym_bytes10] = ACTIONS(738),
    [anon_sym_bytes11] = ACTIONS(738),
    [anon_sym_bytes12] = ACTIONS(738),
    [anon_sym_bytes13] = ACTIONS(738),
    [anon_sym_bytes14] = ACTIONS(738),
    [anon_sym_bytes15] = ACTIONS(738),
    [anon_sym_bytes16] = ACTIONS(738),
    [anon_sym_bytes17] = ACTIONS(738),
    [anon_sym_bytes18] = ACTIONS(738),
    [anon_sym_bytes19] = ACTIONS(738),
    [anon_sym_bytes20] = ACTIONS(738),
    [anon_sym_bytes21] = ACTIONS(738),
    [anon_sym_bytes22] = ACTIONS(738),
    [anon_sym_bytes23] = ACTIONS(738),
    [anon_sym_bytes24] = ACTIONS(738),
    [anon_sym_bytes25] = ACTIONS(738),
    [anon_sym_bytes26] = ACTIONS(738),
    [anon_sym_bytes27] = ACTIONS(738),
    [anon_sym_bytes28] = ACTIONS(738),
    [anon_sym_bytes29] = ACTIONS(738),
    [anon_sym_bytes30] = ACTIONS(738),
    [anon_sym_bytes31] = ACTIONS(738),
    [anon_sym_bytes32] = ACTIONS(738),
    [anon_sym_fixed] = ACTIONS(738),
    [aux_sym__fixed_token1] = ACTIONS(738),
    [anon_sym_ufixed] = ACTIONS(738),
    [aux_sym__ufixed_token1] = ACTIONS(738),
    [sym_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_identifier] = ACTIONS(788),
    [anon_sym_RBRACE] = ACTIONS(790),
    [anon_sym_type] = ACTIONS(788),
    [anon_sym_error] = ACTIONS(788),
    [anon_sym_struct] = ACTIONS(788),
    [anon_sym_enum] = ACTIONS(788),
    [anon_sym_event] = ACTIONS(788),
    [anon_sym_using] = ACTIONS(788),
    [anon_sym_function] = ACTIONS(788),
    [anon_sym_byte] = ACTIONS(788),
    [anon_sym_address] = ACTIONS(788),
    [anon_sym_var] = ACTIONS(788),
    [anon_sym_modifier] = ACTIONS(788),
    [anon_sym_constructor] = ACTIONS(788),
    [anon_sym_fallback] = ACTIONS(788),
    [anon_sym_receive] = ACTIONS(788),
    [anon_sym_mapping] = ACTIONS(788),
    [anon_sym_bool] = ACTIONS(788),
    [anon_sym_string] = ACTIONS(788),
    [anon_sym_int] = ACTIONS(788),
    [anon_sym_int8] = ACTIONS(788),
    [anon_sym_int16] = ACTIONS(788),
    [anon_sym_int24] = ACTIONS(788),
    [anon_sym_int32] = ACTIONS(788),
    [anon_sym_int40] = ACTIONS(788),
    [anon_sym_int48] = ACTIONS(788),
    [anon_sym_int56] = ACTIONS(788),
    [anon_sym_int64] = ACTIONS(788),
    [anon_sym_int72] = ACTIONS(788),
    [anon_sym_int80] = ACTIONS(788),
    [anon_sym_int88] = ACTIONS(788),
    [anon_sym_int96] = ACTIONS(788),
    [anon_sym_int104] = ACTIONS(788),
    [anon_sym_int112] = ACTIONS(788),
    [anon_sym_int120] = ACTIONS(788),
    [anon_sym_int128] = ACTIONS(788),
    [anon_sym_int136] = ACTIONS(788),
    [anon_sym_int144] = ACTIONS(788),
    [anon_sym_int152] = ACTIONS(788),
    [anon_sym_int160] = ACTIONS(788),
    [anon_sym_int168] = ACTIONS(788),
    [anon_sym_int176] = ACTIONS(788),
    [anon_sym_int184] = ACTIONS(788),
    [anon_sym_int192] = ACTIONS(788),
    [anon_sym_int200] = ACTIONS(788),
    [anon_sym_int208] = ACTIONS(788),
    [anon_sym_int216] = ACTIONS(788),
    [anon_sym_int224] = ACTIONS(788),
    [anon_sym_int232] = ACTIONS(788),
    [anon_sym_int240] = ACTIONS(788),
    [anon_sym_int248] = ACTIONS(788),
    [anon_sym_int256] = ACTIONS(788),
    [anon_sym_uint] = ACTIONS(788),
    [anon_sym_uint8] = ACTIONS(788),
    [anon_sym_uint16] = ACTIONS(788),
    [anon_sym_uint24] = ACTIONS(788),
    [anon_sym_uint32] = ACTIONS(788),
    [anon_sym_uint40] = ACTIONS(788),
    [anon_sym_uint48] = ACTIONS(788),
    [anon_sym_uint56] = ACTIONS(788),
    [anon_sym_uint64] = ACTIONS(788),
    [anon_sym_uint72] = ACTIONS(788),
    [anon_sym_uint80] = ACTIONS(788),
    [anon_sym_uint88] = ACTIONS(788),
    [anon_sym_uint96] = ACTIONS(788),
    [anon_sym_uint104] = ACTIONS(788),
    [anon_sym_uint112] = ACTIONS(788),
    [anon_sym_uint120] = ACTIONS(788),
    [anon_sym_uint128] = ACTIONS(788),
    [anon_sym_uint136] = ACTIONS(788),
    [anon_sym_uint144] = ACTIONS(788),
    [anon_sym_uint152] = ACTIONS(788),
    [anon_sym_uint160] = ACTIONS(788),
    [anon_sym_uint168] = ACTIONS(788),
    [anon_sym_uint176] = ACTIONS(788),
    [anon_sym_uint184] = ACTIONS(788),
    [anon_sym_uint192] = ACTIONS(788),
    [anon_sym_uint200] = ACTIONS(788),
    [anon_sym_uint208] = ACTIONS(788),
    [anon_sym_uint216] = ACTIONS(788),
    [anon_sym_uint224] = ACTIONS(788),
    [anon_sym_uint232] = ACTIONS(788),
    [anon_sym_uint240] = ACTIONS(788),
    [anon_sym_uint248] = ACTIONS(788),
    [anon_sym_uint256] = ACTIONS(788),
    [anon_sym_bytes] = ACTIONS(788),
    [anon_sym_bytes1] = ACTIONS(788),
    [anon_sym_bytes2] = ACTIONS(788),
    [anon_sym_bytes3] = ACTIONS(788),
    [anon_sym_bytes4] = ACTIONS(788),
    [anon_sym_bytes5] = ACTIONS(788),
    [anon_sym_bytes6] = ACTIONS(788),
    [anon_sym_bytes7] = ACTIONS(788),
    [anon_sym_bytes8] = ACTIONS(788),
    [anon_sym_bytes9] = ACTIONS(788),
    [anon_sym_bytes10] = ACTIONS(788),
    [anon_sym_bytes11] = ACTIONS(788),
    [anon_sym_bytes12] = ACTIONS(788),
    [anon_sym_bytes13] = ACTIONS(788),
    [anon_sym_bytes14] = ACTIONS(788),
    [anon_sym_bytes15] = ACTIONS(788),
    [anon_sym_bytes16] = ACTIONS(788),
    [anon_sym_bytes17] = ACTIONS(788),
    [anon_sym_bytes18] = ACTIONS(788),
    [anon_sym_bytes19] = ACTIONS(788),
    [anon_sym_bytes20] = ACTIONS(788),
    [anon_sym_bytes21] = ACTIONS(788),
    [anon_sym_bytes22] = ACTIONS(788),
    [anon_sym_bytes23] = ACTIONS(788),
    [anon_sym_bytes24] = ACTIONS(788),
    [anon_sym_bytes25] = ACTIONS(788),
    [anon_sym_bytes26] = ACTIONS(788),
    [anon_sym_bytes27] = ACTIONS(788),
    [anon_sym_bytes28] = ACTIONS(788),
    [anon_sym_bytes29] = ACTIONS(788),
    [anon_sym_bytes30] = ACTIONS(788),
    [anon_sym_bytes31] = ACTIONS(788),
    [anon_sym_bytes32] = ACTIONS(788),
    [anon_sym_fixed] = ACTIONS(788),
    [aux_sym__fixed_token1] = ACTIONS(788),
    [anon_sym_ufixed] = ACTIONS(788),
    [aux_sym__ufixed_token1] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_identifier] = ACTIONS(672),
    [anon_sym_RBRACE] = ACTIONS(670),
    [anon_sym_type] = ACTIONS(672),
    [anon_sym_error] = ACTIONS(672),
    [anon_sym_struct] = ACTIONS(672),
    [anon_sym_enum] = ACTIONS(672),
    [anon_sym_event] = ACTIONS(672),
    [anon_sym_using] = ACTIONS(672),
    [anon_sym_function] = ACTIONS(672),
    [anon_sym_byte] = ACTIONS(672),
    [anon_sym_address] = ACTIONS(672),
    [anon_sym_var] = ACTIONS(672),
    [anon_sym_modifier] = ACTIONS(672),
    [anon_sym_constructor] = ACTIONS(672),
    [anon_sym_fallback] = ACTIONS(672),
    [anon_sym_receive] = ACTIONS(672),
    [anon_sym_mapping] = ACTIONS(672),
    [anon_sym_bool] = ACTIONS(672),
    [anon_sym_string] = ACTIONS(672),
    [anon_sym_int] = ACTIONS(672),
    [anon_sym_int8] = ACTIONS(672),
    [anon_sym_int16] = ACTIONS(672),
    [anon_sym_int24] = ACTIONS(672),
    [anon_sym_int32] = ACTIONS(672),
    [anon_sym_int40] = ACTIONS(672),
    [anon_sym_int48] = ACTIONS(672),
    [anon_sym_int56] = ACTIONS(672),
    [anon_sym_int64] = ACTIONS(672),
    [anon_sym_int72] = ACTIONS(672),
    [anon_sym_int80] = ACTIONS(672),
    [anon_sym_int88] = ACTIONS(672),
    [anon_sym_int96] = ACTIONS(672),
    [anon_sym_int104] = ACTIONS(672),
    [anon_sym_int112] = ACTIONS(672),
    [anon_sym_int120] = ACTIONS(672),
    [anon_sym_int128] = ACTIONS(672),
    [anon_sym_int136] = ACTIONS(672),
    [anon_sym_int144] = ACTIONS(672),
    [anon_sym_int152] = ACTIONS(672),
    [anon_sym_int160] = ACTIONS(672),
    [anon_sym_int168] = ACTIONS(672),
    [anon_sym_int176] = ACTIONS(672),
    [anon_sym_int184] = ACTIONS(672),
    [anon_sym_int192] = ACTIONS(672),
    [anon_sym_int200] = ACTIONS(672),
    [anon_sym_int208] = ACTIONS(672),
    [anon_sym_int216] = ACTIONS(672),
    [anon_sym_int224] = ACTIONS(672),
    [anon_sym_int232] = ACTIONS(672),
    [anon_sym_int240] = ACTIONS(672),
    [anon_sym_int248] = ACTIONS(672),
    [anon_sym_int256] = ACTIONS(672),
    [anon_sym_uint] = ACTIONS(672),
    [anon_sym_uint8] = ACTIONS(672),
    [anon_sym_uint16] = ACTIONS(672),
    [anon_sym_uint24] = ACTIONS(672),
    [anon_sym_uint32] = ACTIONS(672),
    [anon_sym_uint40] = ACTIONS(672),
    [anon_sym_uint48] = ACTIONS(672),
    [anon_sym_uint56] = ACTIONS(672),
    [anon_sym_uint64] = ACTIONS(672),
    [anon_sym_uint72] = ACTIONS(672),
    [anon_sym_uint80] = ACTIONS(672),
    [anon_sym_uint88] = ACTIONS(672),
    [anon_sym_uint96] = ACTIONS(672),
    [anon_sym_uint104] = ACTIONS(672),
    [anon_sym_uint112] = ACTIONS(672),
    [anon_sym_uint120] = ACTIONS(672),
    [anon_sym_uint128] = ACTIONS(672),
    [anon_sym_uint136] = ACTIONS(672),
    [anon_sym_uint144] = ACTIONS(672),
    [anon_sym_uint152] = ACTIONS(672),
    [anon_sym_uint160] = ACTIONS(672),
    [anon_sym_uint168] = ACTIONS(672),
    [anon_sym_uint176] = ACTIONS(672),
    [anon_sym_uint184] = ACTIONS(672),
    [anon_sym_uint192] = ACTIONS(672),
    [anon_sym_uint200] = ACTIONS(672),
    [anon_sym_uint208] = ACTIONS(672),
    [anon_sym_uint216] = ACTIONS(672),
    [anon_sym_uint224] = ACTIONS(672),
    [anon_sym_uint232] = ACTIONS(672),
    [anon_sym_uint240] = ACTIONS(672),
    [anon_sym_uint248] = ACTIONS(672),
    [anon_sym_uint256] = ACTIONS(672),
    [anon_sym_bytes] = ACTIONS(672),
    [anon_sym_bytes1] = ACTIONS(672),
    [anon_sym_bytes2] = ACTIONS(672),
    [anon_sym_bytes3] = ACTIONS(672),
    [anon_sym_bytes4] = ACTIONS(672),
    [anon_sym_bytes5] = ACTIONS(672),
    [anon_sym_bytes6] = ACTIONS(672),
    [anon_sym_bytes7] = ACTIONS(672),
    [anon_sym_bytes8] = ACTIONS(672),
    [anon_sym_bytes9] = ACTIONS(672),
    [anon_sym_bytes10] = ACTIONS(672),
    [anon_sym_bytes11] = ACTIONS(672),
    [anon_sym_bytes12] = ACTIONS(672),
    [anon_sym_bytes13] = ACTIONS(672),
    [anon_sym_bytes14] = ACTIONS(672),
    [anon_sym_bytes15] = ACTIONS(672),
    [anon_sym_bytes16] = ACTIONS(672),
    [anon_sym_bytes17] = ACTIONS(672),
    [anon_sym_bytes18] = ACTIONS(672),
    [anon_sym_bytes19] = ACTIONS(672),
    [anon_sym_bytes20] = ACTIONS(672),
    [anon_sym_bytes21] = ACTIONS(672),
    [anon_sym_bytes22] = ACTIONS(672),
    [anon_sym_bytes23] = ACTIONS(672),
    [anon_sym_bytes24] = ACTIONS(672),
    [anon_sym_bytes25] = ACTIONS(672),
    [anon_sym_bytes26] = ACTIONS(672),
    [anon_sym_bytes27] = ACTIONS(672),
    [anon_sym_bytes28] = ACTIONS(672),
    [anon_sym_bytes29] = ACTIONS(672),
    [anon_sym_bytes30] = ACTIONS(672),
    [anon_sym_bytes31] = ACTIONS(672),
    [anon_sym_bytes32] = ACTIONS(672),
    [anon_sym_fixed] = ACTIONS(672),
    [aux_sym__fixed_token1] = ACTIONS(672),
    [anon_sym_ufixed] = ACTIONS(672),
    [aux_sym__ufixed_token1] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_identifier] = ACTIONS(706),
    [anon_sym_RBRACE] = ACTIONS(704),
    [anon_sym_type] = ACTIONS(706),
    [anon_sym_error] = ACTIONS(706),
    [anon_sym_struct] = ACTIONS(706),
    [anon_sym_enum] = ACTIONS(706),
    [anon_sym_event] = ACTIONS(706),
    [anon_sym_using] = ACTIONS(706),
    [anon_sym_function] = ACTIONS(706),
    [anon_sym_byte] = ACTIONS(706),
    [anon_sym_address] = ACTIONS(706),
    [anon_sym_var] = ACTIONS(706),
    [anon_sym_modifier] = ACTIONS(706),
    [anon_sym_constructor] = ACTIONS(706),
    [anon_sym_fallback] = ACTIONS(706),
    [anon_sym_receive] = ACTIONS(706),
    [anon_sym_mapping] = ACTIONS(706),
    [anon_sym_bool] = ACTIONS(706),
    [anon_sym_string] = ACTIONS(706),
    [anon_sym_int] = ACTIONS(706),
    [anon_sym_int8] = ACTIONS(706),
    [anon_sym_int16] = ACTIONS(706),
    [anon_sym_int24] = ACTIONS(706),
    [anon_sym_int32] = ACTIONS(706),
    [anon_sym_int40] = ACTIONS(706),
    [anon_sym_int48] = ACTIONS(706),
    [anon_sym_int56] = ACTIONS(706),
    [anon_sym_int64] = ACTIONS(706),
    [anon_sym_int72] = ACTIONS(706),
    [anon_sym_int80] = ACTIONS(706),
    [anon_sym_int88] = ACTIONS(706),
    [anon_sym_int96] = ACTIONS(706),
    [anon_sym_int104] = ACTIONS(706),
    [anon_sym_int112] = ACTIONS(706),
    [anon_sym_int120] = ACTIONS(706),
    [anon_sym_int128] = ACTIONS(706),
    [anon_sym_int136] = ACTIONS(706),
    [anon_sym_int144] = ACTIONS(706),
    [anon_sym_int152] = ACTIONS(706),
    [anon_sym_int160] = ACTIONS(706),
    [anon_sym_int168] = ACTIONS(706),
    [anon_sym_int176] = ACTIONS(706),
    [anon_sym_int184] = ACTIONS(706),
    [anon_sym_int192] = ACTIONS(706),
    [anon_sym_int200] = ACTIONS(706),
    [anon_sym_int208] = ACTIONS(706),
    [anon_sym_int216] = ACTIONS(706),
    [anon_sym_int224] = ACTIONS(706),
    [anon_sym_int232] = ACTIONS(706),
    [anon_sym_int240] = ACTIONS(706),
    [anon_sym_int248] = ACTIONS(706),
    [anon_sym_int256] = ACTIONS(706),
    [anon_sym_uint] = ACTIONS(706),
    [anon_sym_uint8] = ACTIONS(706),
    [anon_sym_uint16] = ACTIONS(706),
    [anon_sym_uint24] = ACTIONS(706),
    [anon_sym_uint32] = ACTIONS(706),
    [anon_sym_uint40] = ACTIONS(706),
    [anon_sym_uint48] = ACTIONS(706),
    [anon_sym_uint56] = ACTIONS(706),
    [anon_sym_uint64] = ACTIONS(706),
    [anon_sym_uint72] = ACTIONS(706),
    [anon_sym_uint80] = ACTIONS(706),
    [anon_sym_uint88] = ACTIONS(706),
    [anon_sym_uint96] = ACTIONS(706),
    [anon_sym_uint104] = ACTIONS(706),
    [anon_sym_uint112] = ACTIONS(706),
    [anon_sym_uint120] = ACTIONS(706),
    [anon_sym_uint128] = ACTIONS(706),
    [anon_sym_uint136] = ACTIONS(706),
    [anon_sym_uint144] = ACTIONS(706),
    [anon_sym_uint152] = ACTIONS(706),
    [anon_sym_uint160] = ACTIONS(706),
    [anon_sym_uint168] = ACTIONS(706),
    [anon_sym_uint176] = ACTIONS(706),
    [anon_sym_uint184] = ACTIONS(706),
    [anon_sym_uint192] = ACTIONS(706),
    [anon_sym_uint200] = ACTIONS(706),
    [anon_sym_uint208] = ACTIONS(706),
    [anon_sym_uint216] = ACTIONS(706),
    [anon_sym_uint224] = ACTIONS(706),
    [anon_sym_uint232] = ACTIONS(706),
    [anon_sym_uint240] = ACTIONS(706),
    [anon_sym_uint248] = ACTIONS(706),
    [anon_sym_uint256] = ACTIONS(706),
    [anon_sym_bytes] = ACTIONS(706),
    [anon_sym_bytes1] = ACTIONS(706),
    [anon_sym_bytes2] = ACTIONS(706),
    [anon_sym_bytes3] = ACTIONS(706),
    [anon_sym_bytes4] = ACTIONS(706),
    [anon_sym_bytes5] = ACTIONS(706),
    [anon_sym_bytes6] = ACTIONS(706),
    [anon_sym_bytes7] = ACTIONS(706),
    [anon_sym_bytes8] = ACTIONS(706),
    [anon_sym_bytes9] = ACTIONS(706),
    [anon_sym_bytes10] = ACTIONS(706),
    [anon_sym_bytes11] = ACTIONS(706),
    [anon_sym_bytes12] = ACTIONS(706),
    [anon_sym_bytes13] = ACTIONS(706),
    [anon_sym_bytes14] = ACTIONS(706),
    [anon_sym_bytes15] = ACTIONS(706),
    [anon_sym_bytes16] = ACTIONS(706),
    [anon_sym_bytes17] = ACTIONS(706),
    [anon_sym_bytes18] = ACTIONS(706),
    [anon_sym_bytes19] = ACTIONS(706),
    [anon_sym_bytes20] = ACTIONS(706),
    [anon_sym_bytes21] = ACTIONS(706),
    [anon_sym_bytes22] = ACTIONS(706),
    [anon_sym_bytes23] = ACTIONS(706),
    [anon_sym_bytes24] = ACTIONS(706),
    [anon_sym_bytes25] = ACTIONS(706),
    [anon_sym_bytes26] = ACTIONS(706),
    [anon_sym_bytes27] = ACTIONS(706),
    [anon_sym_bytes28] = ACTIONS(706),
    [anon_sym_bytes29] = ACTIONS(706),
    [anon_sym_bytes30] = ACTIONS(706),
    [anon_sym_bytes31] = ACTIONS(706),
    [anon_sym_bytes32] = ACTIONS(706),
    [anon_sym_fixed] = ACTIONS(706),
    [aux_sym__fixed_token1] = ACTIONS(706),
    [anon_sym_ufixed] = ACTIONS(706),
    [aux_sym__ufixed_token1] = ACTIONS(706),
    [sym_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_identifier] = ACTIONS(792),
    [anon_sym_RBRACE] = ACTIONS(794),
    [anon_sym_type] = ACTIONS(792),
    [anon_sym_error] = ACTIONS(792),
    [anon_sym_struct] = ACTIONS(792),
    [anon_sym_enum] = ACTIONS(792),
    [anon_sym_event] = ACTIONS(792),
    [anon_sym_using] = ACTIONS(792),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_byte] = ACTIONS(792),
    [anon_sym_address] = ACTIONS(792),
    [anon_sym_var] = ACTIONS(792),
    [anon_sym_modifier] = ACTIONS(792),
    [anon_sym_constructor] = ACTIONS(792),
    [anon_sym_fallback] = ACTIONS(792),
    [anon_sym_receive] = ACTIONS(792),
    [anon_sym_mapping] = ACTIONS(792),
    [anon_sym_bool] = ACTIONS(792),
    [anon_sym_string] = ACTIONS(792),
    [anon_sym_int] = ACTIONS(792),
    [anon_sym_int8] = ACTIONS(792),
    [anon_sym_int16] = ACTIONS(792),
    [anon_sym_int24] = ACTIONS(792),
    [anon_sym_int32] = ACTIONS(792),
    [anon_sym_int40] = ACTIONS(792),
    [anon_sym_int48] = ACTIONS(792),
    [anon_sym_int56] = ACTIONS(792),
    [anon_sym_int64] = ACTIONS(792),
    [anon_sym_int72] = ACTIONS(792),
    [anon_sym_int80] = ACTIONS(792),
    [anon_sym_int88] = ACTIONS(792),
    [anon_sym_int96] = ACTIONS(792),
    [anon_sym_int104] = ACTIONS(792),
    [anon_sym_int112] = ACTIONS(792),
    [anon_sym_int120] = ACTIONS(792),
    [anon_sym_int128] = ACTIONS(792),
    [anon_sym_int136] = ACTIONS(792),
    [anon_sym_int144] = ACTIONS(792),
    [anon_sym_int152] = ACTIONS(792),
    [anon_sym_int160] = ACTIONS(792),
    [anon_sym_int168] = ACTIONS(792),
    [anon_sym_int176] = ACTIONS(792),
    [anon_sym_int184] = ACTIONS(792),
    [anon_sym_int192] = ACTIONS(792),
    [anon_sym_int200] = ACTIONS(792),
    [anon_sym_int208] = ACTIONS(792),
    [anon_sym_int216] = ACTIONS(792),
    [anon_sym_int224] = ACTIONS(792),
    [anon_sym_int232] = ACTIONS(792),
    [anon_sym_int240] = ACTIONS(792),
    [anon_sym_int248] = ACTIONS(792),
    [anon_sym_int256] = ACTIONS(792),
    [anon_sym_uint] = ACTIONS(792),
    [anon_sym_uint8] = ACTIONS(792),
    [anon_sym_uint16] = ACTIONS(792),
    [anon_sym_uint24] = ACTIONS(792),
    [anon_sym_uint32] = ACTIONS(792),
    [anon_sym_uint40] = ACTIONS(792),
    [anon_sym_uint48] = ACTIONS(792),
    [anon_sym_uint56] = ACTIONS(792),
    [anon_sym_uint64] = ACTIONS(792),
    [anon_sym_uint72] = ACTIONS(792),
    [anon_sym_uint80] = ACTIONS(792),
    [anon_sym_uint88] = ACTIONS(792),
    [anon_sym_uint96] = ACTIONS(792),
    [anon_sym_uint104] = ACTIONS(792),
    [anon_sym_uint112] = ACTIONS(792),
    [anon_sym_uint120] = ACTIONS(792),
    [anon_sym_uint128] = ACTIONS(792),
    [anon_sym_uint136] = ACTIONS(792),
    [anon_sym_uint144] = ACTIONS(792),
    [anon_sym_uint152] = ACTIONS(792),
    [anon_sym_uint160] = ACTIONS(792),
    [anon_sym_uint168] = ACTIONS(792),
    [anon_sym_uint176] = ACTIONS(792),
    [anon_sym_uint184] = ACTIONS(792),
    [anon_sym_uint192] = ACTIONS(792),
    [anon_sym_uint200] = ACTIONS(792),
    [anon_sym_uint208] = ACTIONS(792),
    [anon_sym_uint216] = ACTIONS(792),
    [anon_sym_uint224] = ACTIONS(792),
    [anon_sym_uint232] = ACTIONS(792),
    [anon_sym_uint240] = ACTIONS(792),
    [anon_sym_uint248] = ACTIONS(792),
    [anon_sym_uint256] = ACTIONS(792),
    [anon_sym_bytes] = ACTIONS(792),
    [anon_sym_bytes1] = ACTIONS(792),
    [anon_sym_bytes2] = ACTIONS(792),
    [anon_sym_bytes3] = ACTIONS(792),
    [anon_sym_bytes4] = ACTIONS(792),
    [anon_sym_bytes5] = ACTIONS(792),
    [anon_sym_bytes6] = ACTIONS(792),
    [anon_sym_bytes7] = ACTIONS(792),
    [anon_sym_bytes8] = ACTIONS(792),
    [anon_sym_bytes9] = ACTIONS(792),
    [anon_sym_bytes10] = ACTIONS(792),
    [anon_sym_bytes11] = ACTIONS(792),
    [anon_sym_bytes12] = ACTIONS(792),
    [anon_sym_bytes13] = ACTIONS(792),
    [anon_sym_bytes14] = ACTIONS(792),
    [anon_sym_bytes15] = ACTIONS(792),
    [anon_sym_bytes16] = ACTIONS(792),
    [anon_sym_bytes17] = ACTIONS(792),
    [anon_sym_bytes18] = ACTIONS(792),
    [anon_sym_bytes19] = ACTIONS(792),
    [anon_sym_bytes20] = ACTIONS(792),
    [anon_sym_bytes21] = ACTIONS(792),
    [anon_sym_bytes22] = ACTIONS(792),
    [anon_sym_bytes23] = ACTIONS(792),
    [anon_sym_bytes24] = ACTIONS(792),
    [anon_sym_bytes25] = ACTIONS(792),
    [anon_sym_bytes26] = ACTIONS(792),
    [anon_sym_bytes27] = ACTIONS(792),
    [anon_sym_bytes28] = ACTIONS(792),
    [anon_sym_bytes29] = ACTIONS(792),
    [anon_sym_bytes30] = ACTIONS(792),
    [anon_sym_bytes31] = ACTIONS(792),
    [anon_sym_bytes32] = ACTIONS(792),
    [anon_sym_fixed] = ACTIONS(792),
    [aux_sym__fixed_token1] = ACTIONS(792),
    [anon_sym_ufixed] = ACTIONS(792),
    [aux_sym__ufixed_token1] = ACTIONS(792),
    [sym_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_identifier] = ACTIONS(796),
    [anon_sym_RBRACE] = ACTIONS(798),
    [anon_sym_type] = ACTIONS(796),
    [anon_sym_error] = ACTIONS(796),
    [anon_sym_struct] = ACTIONS(796),
    [anon_sym_enum] = ACTIONS(796),
    [anon_sym_event] = ACTIONS(796),
    [anon_sym_using] = ACTIONS(796),
    [anon_sym_function] = ACTIONS(796),
    [anon_sym_byte] = ACTIONS(796),
    [anon_sym_address] = ACTIONS(796),
    [anon_sym_var] = ACTIONS(796),
    [anon_sym_modifier] = ACTIONS(796),
    [anon_sym_constructor] = ACTIONS(796),
    [anon_sym_fallback] = ACTIONS(796),
    [anon_sym_receive] = ACTIONS(796),
    [anon_sym_mapping] = ACTIONS(796),
    [anon_sym_bool] = ACTIONS(796),
    [anon_sym_string] = ACTIONS(796),
    [anon_sym_int] = ACTIONS(796),
    [anon_sym_int8] = ACTIONS(796),
    [anon_sym_int16] = ACTIONS(796),
    [anon_sym_int24] = ACTIONS(796),
    [anon_sym_int32] = ACTIONS(796),
    [anon_sym_int40] = ACTIONS(796),
    [anon_sym_int48] = ACTIONS(796),
    [anon_sym_int56] = ACTIONS(796),
    [anon_sym_int64] = ACTIONS(796),
    [anon_sym_int72] = ACTIONS(796),
    [anon_sym_int80] = ACTIONS(796),
    [anon_sym_int88] = ACTIONS(796),
    [anon_sym_int96] = ACTIONS(796),
    [anon_sym_int104] = ACTIONS(796),
    [anon_sym_int112] = ACTIONS(796),
    [anon_sym_int120] = ACTIONS(796),
    [anon_sym_int128] = ACTIONS(796),
    [anon_sym_int136] = ACTIONS(796),
    [anon_sym_int144] = ACTIONS(796),
    [anon_sym_int152] = ACTIONS(796),
    [anon_sym_int160] = ACTIONS(796),
    [anon_sym_int168] = ACTIONS(796),
    [anon_sym_int176] = ACTIONS(796),
    [anon_sym_int184] = ACTIONS(796),
    [anon_sym_int192] = ACTIONS(796),
    [anon_sym_int200] = ACTIONS(796),
    [anon_sym_int208] = ACTIONS(796),
    [anon_sym_int216] = ACTIONS(796),
    [anon_sym_int224] = ACTIONS(796),
    [anon_sym_int232] = ACTIONS(796),
    [anon_sym_int240] = ACTIONS(796),
    [anon_sym_int248] = ACTIONS(796),
    [anon_sym_int256] = ACTIONS(796),
    [anon_sym_uint] = ACTIONS(796),
    [anon_sym_uint8] = ACTIONS(796),
    [anon_sym_uint16] = ACTIONS(796),
    [anon_sym_uint24] = ACTIONS(796),
    [anon_sym_uint32] = ACTIONS(796),
    [anon_sym_uint40] = ACTIONS(796),
    [anon_sym_uint48] = ACTIONS(796),
    [anon_sym_uint56] = ACTIONS(796),
    [anon_sym_uint64] = ACTIONS(796),
    [anon_sym_uint72] = ACTIONS(796),
    [anon_sym_uint80] = ACTIONS(796),
    [anon_sym_uint88] = ACTIONS(796),
    [anon_sym_uint96] = ACTIONS(796),
    [anon_sym_uint104] = ACTIONS(796),
    [anon_sym_uint112] = ACTIONS(796),
    [anon_sym_uint120] = ACTIONS(796),
    [anon_sym_uint128] = ACTIONS(796),
    [anon_sym_uint136] = ACTIONS(796),
    [anon_sym_uint144] = ACTIONS(796),
    [anon_sym_uint152] = ACTIONS(796),
    [anon_sym_uint160] = ACTIONS(796),
    [anon_sym_uint168] = ACTIONS(796),
    [anon_sym_uint176] = ACTIONS(796),
    [anon_sym_uint184] = ACTIONS(796),
    [anon_sym_uint192] = ACTIONS(796),
    [anon_sym_uint200] = ACTIONS(796),
    [anon_sym_uint208] = ACTIONS(796),
    [anon_sym_uint216] = ACTIONS(796),
    [anon_sym_uint224] = ACTIONS(796),
    [anon_sym_uint232] = ACTIONS(796),
    [anon_sym_uint240] = ACTIONS(796),
    [anon_sym_uint248] = ACTIONS(796),
    [anon_sym_uint256] = ACTIONS(796),
    [anon_sym_bytes] = ACTIONS(796),
    [anon_sym_bytes1] = ACTIONS(796),
    [anon_sym_bytes2] = ACTIONS(796),
    [anon_sym_bytes3] = ACTIONS(796),
    [anon_sym_bytes4] = ACTIONS(796),
    [anon_sym_bytes5] = ACTIONS(796),
    [anon_sym_bytes6] = ACTIONS(796),
    [anon_sym_bytes7] = ACTIONS(796),
    [anon_sym_bytes8] = ACTIONS(796),
    [anon_sym_bytes9] = ACTIONS(796),
    [anon_sym_bytes10] = ACTIONS(796),
    [anon_sym_bytes11] = ACTIONS(796),
    [anon_sym_bytes12] = ACTIONS(796),
    [anon_sym_bytes13] = ACTIONS(796),
    [anon_sym_bytes14] = ACTIONS(796),
    [anon_sym_bytes15] = ACTIONS(796),
    [anon_sym_bytes16] = ACTIONS(796),
    [anon_sym_bytes17] = ACTIONS(796),
    [anon_sym_bytes18] = ACTIONS(796),
    [anon_sym_bytes19] = ACTIONS(796),
    [anon_sym_bytes20] = ACTIONS(796),
    [anon_sym_bytes21] = ACTIONS(796),
    [anon_sym_bytes22] = ACTIONS(796),
    [anon_sym_bytes23] = ACTIONS(796),
    [anon_sym_bytes24] = ACTIONS(796),
    [anon_sym_bytes25] = ACTIONS(796),
    [anon_sym_bytes26] = ACTIONS(796),
    [anon_sym_bytes27] = ACTIONS(796),
    [anon_sym_bytes28] = ACTIONS(796),
    [anon_sym_bytes29] = ACTIONS(796),
    [anon_sym_bytes30] = ACTIONS(796),
    [anon_sym_bytes31] = ACTIONS(796),
    [anon_sym_bytes32] = ACTIONS(796),
    [anon_sym_fixed] = ACTIONS(796),
    [aux_sym__fixed_token1] = ACTIONS(796),
    [anon_sym_ufixed] = ACTIONS(796),
    [aux_sym__ufixed_token1] = ACTIONS(796),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_identifier] = ACTIONS(800),
    [anon_sym_RBRACE] = ACTIONS(802),
    [anon_sym_type] = ACTIONS(800),
    [anon_sym_error] = ACTIONS(800),
    [anon_sym_struct] = ACTIONS(800),
    [anon_sym_enum] = ACTIONS(800),
    [anon_sym_event] = ACTIONS(800),
    [anon_sym_using] = ACTIONS(800),
    [anon_sym_function] = ACTIONS(800),
    [anon_sym_byte] = ACTIONS(800),
    [anon_sym_address] = ACTIONS(800),
    [anon_sym_var] = ACTIONS(800),
    [anon_sym_modifier] = ACTIONS(800),
    [anon_sym_constructor] = ACTIONS(800),
    [anon_sym_fallback] = ACTIONS(800),
    [anon_sym_receive] = ACTIONS(800),
    [anon_sym_mapping] = ACTIONS(800),
    [anon_sym_bool] = ACTIONS(800),
    [anon_sym_string] = ACTIONS(800),
    [anon_sym_int] = ACTIONS(800),
    [anon_sym_int8] = ACTIONS(800),
    [anon_sym_int16] = ACTIONS(800),
    [anon_sym_int24] = ACTIONS(800),
    [anon_sym_int32] = ACTIONS(800),
    [anon_sym_int40] = ACTIONS(800),
    [anon_sym_int48] = ACTIONS(800),
    [anon_sym_int56] = ACTIONS(800),
    [anon_sym_int64] = ACTIONS(800),
    [anon_sym_int72] = ACTIONS(800),
    [anon_sym_int80] = ACTIONS(800),
    [anon_sym_int88] = ACTIONS(800),
    [anon_sym_int96] = ACTIONS(800),
    [anon_sym_int104] = ACTIONS(800),
    [anon_sym_int112] = ACTIONS(800),
    [anon_sym_int120] = ACTIONS(800),
    [anon_sym_int128] = ACTIONS(800),
    [anon_sym_int136] = ACTIONS(800),
    [anon_sym_int144] = ACTIONS(800),
    [anon_sym_int152] = ACTIONS(800),
    [anon_sym_int160] = ACTIONS(800),
    [anon_sym_int168] = ACTIONS(800),
    [anon_sym_int176] = ACTIONS(800),
    [anon_sym_int184] = ACTIONS(800),
    [anon_sym_int192] = ACTIONS(800),
    [anon_sym_int200] = ACTIONS(800),
    [anon_sym_int208] = ACTIONS(800),
    [anon_sym_int216] = ACTIONS(800),
    [anon_sym_int224] = ACTIONS(800),
    [anon_sym_int232] = ACTIONS(800),
    [anon_sym_int240] = ACTIONS(800),
    [anon_sym_int248] = ACTIONS(800),
    [anon_sym_int256] = ACTIONS(800),
    [anon_sym_uint] = ACTIONS(800),
    [anon_sym_uint8] = ACTIONS(800),
    [anon_sym_uint16] = ACTIONS(800),
    [anon_sym_uint24] = ACTIONS(800),
    [anon_sym_uint32] = ACTIONS(800),
    [anon_sym_uint40] = ACTIONS(800),
    [anon_sym_uint48] = ACTIONS(800),
    [anon_sym_uint56] = ACTIONS(800),
    [anon_sym_uint64] = ACTIONS(800),
    [anon_sym_uint72] = ACTIONS(800),
    [anon_sym_uint80] = ACTIONS(800),
    [anon_sym_uint88] = ACTIONS(800),
    [anon_sym_uint96] = ACTIONS(800),
    [anon_sym_uint104] = ACTIONS(800),
    [anon_sym_uint112] = ACTIONS(800),
    [anon_sym_uint120] = ACTIONS(800),
    [anon_sym_uint128] = ACTIONS(800),
    [anon_sym_uint136] = ACTIONS(800),
    [anon_sym_uint144] = ACTIONS(800),
    [anon_sym_uint152] = ACTIONS(800),
    [anon_sym_uint160] = ACTIONS(800),
    [anon_sym_uint168] = ACTIONS(800),
    [anon_sym_uint176] = ACTIONS(800),
    [anon_sym_uint184] = ACTIONS(800),
    [anon_sym_uint192] = ACTIONS(800),
    [anon_sym_uint200] = ACTIONS(800),
    [anon_sym_uint208] = ACTIONS(800),
    [anon_sym_uint216] = ACTIONS(800),
    [anon_sym_uint224] = ACTIONS(800),
    [anon_sym_uint232] = ACTIONS(800),
    [anon_sym_uint240] = ACTIONS(800),
    [anon_sym_uint248] = ACTIONS(800),
    [anon_sym_uint256] = ACTIONS(800),
    [anon_sym_bytes] = ACTIONS(800),
    [anon_sym_bytes1] = ACTIONS(800),
    [anon_sym_bytes2] = ACTIONS(800),
    [anon_sym_bytes3] = ACTIONS(800),
    [anon_sym_bytes4] = ACTIONS(800),
    [anon_sym_bytes5] = ACTIONS(800),
    [anon_sym_bytes6] = ACTIONS(800),
    [anon_sym_bytes7] = ACTIONS(800),
    [anon_sym_bytes8] = ACTIONS(800),
    [anon_sym_bytes9] = ACTIONS(800),
    [anon_sym_bytes10] = ACTIONS(800),
    [anon_sym_bytes11] = ACTIONS(800),
    [anon_sym_bytes12] = ACTIONS(800),
    [anon_sym_bytes13] = ACTIONS(800),
    [anon_sym_bytes14] = ACTIONS(800),
    [anon_sym_bytes15] = ACTIONS(800),
    [anon_sym_bytes16] = ACTIONS(800),
    [anon_sym_bytes17] = ACTIONS(800),
    [anon_sym_bytes18] = ACTIONS(800),
    [anon_sym_bytes19] = ACTIONS(800),
    [anon_sym_bytes20] = ACTIONS(800),
    [anon_sym_bytes21] = ACTIONS(800),
    [anon_sym_bytes22] = ACTIONS(800),
    [anon_sym_bytes23] = ACTIONS(800),
    [anon_sym_bytes24] = ACTIONS(800),
    [anon_sym_bytes25] = ACTIONS(800),
    [anon_sym_bytes26] = ACTIONS(800),
    [anon_sym_bytes27] = ACTIONS(800),
    [anon_sym_bytes28] = ACTIONS(800),
    [anon_sym_bytes29] = ACTIONS(800),
    [anon_sym_bytes30] = ACTIONS(800),
    [anon_sym_bytes31] = ACTIONS(800),
    [anon_sym_bytes32] = ACTIONS(800),
    [anon_sym_fixed] = ACTIONS(800),
    [aux_sym__fixed_token1] = ACTIONS(800),
    [anon_sym_ufixed] = ACTIONS(800),
    [aux_sym__ufixed_token1] = ACTIONS(800),
    [sym_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_identifier] = ACTIONS(684),
    [anon_sym_RBRACE] = ACTIONS(682),
    [anon_sym_type] = ACTIONS(684),
    [anon_sym_error] = ACTIONS(684),
    [anon_sym_struct] = ACTIONS(684),
    [anon_sym_enum] = ACTIONS(684),
    [anon_sym_event] = ACTIONS(684),
    [anon_sym_using] = ACTIONS(684),
    [anon_sym_function] = ACTIONS(684),
    [anon_sym_byte] = ACTIONS(684),
    [anon_sym_address] = ACTIONS(684),
    [anon_sym_var] = ACTIONS(684),
    [anon_sym_modifier] = ACTIONS(684),
    [anon_sym_constructor] = ACTIONS(684),
    [anon_sym_fallback] = ACTIONS(684),
    [anon_sym_receive] = ACTIONS(684),
    [anon_sym_mapping] = ACTIONS(684),
    [anon_sym_bool] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(684),
    [anon_sym_int] = ACTIONS(684),
    [anon_sym_int8] = ACTIONS(684),
    [anon_sym_int16] = ACTIONS(684),
    [anon_sym_int24] = ACTIONS(684),
    [anon_sym_int32] = ACTIONS(684),
    [anon_sym_int40] = ACTIONS(684),
    [anon_sym_int48] = ACTIONS(684),
    [anon_sym_int56] = ACTIONS(684),
    [anon_sym_int64] = ACTIONS(684),
    [anon_sym_int72] = ACTIONS(684),
    [anon_sym_int80] = ACTIONS(684),
    [anon_sym_int88] = ACTIONS(684),
    [anon_sym_int96] = ACTIONS(684),
    [anon_sym_int104] = ACTIONS(684),
    [anon_sym_int112] = ACTIONS(684),
    [anon_sym_int120] = ACTIONS(684),
    [anon_sym_int128] = ACTIONS(684),
    [anon_sym_int136] = ACTIONS(684),
    [anon_sym_int144] = ACTIONS(684),
    [anon_sym_int152] = ACTIONS(684),
    [anon_sym_int160] = ACTIONS(684),
    [anon_sym_int168] = ACTIONS(684),
    [anon_sym_int176] = ACTIONS(684),
    [anon_sym_int184] = ACTIONS(684),
    [anon_sym_int192] = ACTIONS(684),
    [anon_sym_int200] = ACTIONS(684),
    [anon_sym_int208] = ACTIONS(684),
    [anon_sym_int216] = ACTIONS(684),
    [anon_sym_int224] = ACTIONS(684),
    [anon_sym_int232] = ACTIONS(684),
    [anon_sym_int240] = ACTIONS(684),
    [anon_sym_int248] = ACTIONS(684),
    [anon_sym_int256] = ACTIONS(684),
    [anon_sym_uint] = ACTIONS(684),
    [anon_sym_uint8] = ACTIONS(684),
    [anon_sym_uint16] = ACTIONS(684),
    [anon_sym_uint24] = ACTIONS(684),
    [anon_sym_uint32] = ACTIONS(684),
    [anon_sym_uint40] = ACTIONS(684),
    [anon_sym_uint48] = ACTIONS(684),
    [anon_sym_uint56] = ACTIONS(684),
    [anon_sym_uint64] = ACTIONS(684),
    [anon_sym_uint72] = ACTIONS(684),
    [anon_sym_uint80] = ACTIONS(684),
    [anon_sym_uint88] = ACTIONS(684),
    [anon_sym_uint96] = ACTIONS(684),
    [anon_sym_uint104] = ACTIONS(684),
    [anon_sym_uint112] = ACTIONS(684),
    [anon_sym_uint120] = ACTIONS(684),
    [anon_sym_uint128] = ACTIONS(684),
    [anon_sym_uint136] = ACTIONS(684),
    [anon_sym_uint144] = ACTIONS(684),
    [anon_sym_uint152] = ACTIONS(684),
    [anon_sym_uint160] = ACTIONS(684),
    [anon_sym_uint168] = ACTIONS(684),
    [anon_sym_uint176] = ACTIONS(684),
    [anon_sym_uint184] = ACTIONS(684),
    [anon_sym_uint192] = ACTIONS(684),
    [anon_sym_uint200] = ACTIONS(684),
    [anon_sym_uint208] = ACTIONS(684),
    [anon_sym_uint216] = ACTIONS(684),
    [anon_sym_uint224] = ACTIONS(684),
    [anon_sym_uint232] = ACTIONS(684),
    [anon_sym_uint240] = ACTIONS(684),
    [anon_sym_uint248] = ACTIONS(684),
    [anon_sym_uint256] = ACTIONS(684),
    [anon_sym_bytes] = ACTIONS(684),
    [anon_sym_bytes1] = ACTIONS(684),
    [anon_sym_bytes2] = ACTIONS(684),
    [anon_sym_bytes3] = ACTIONS(684),
    [anon_sym_bytes4] = ACTIONS(684),
    [anon_sym_bytes5] = ACTIONS(684),
    [anon_sym_bytes6] = ACTIONS(684),
    [anon_sym_bytes7] = ACTIONS(684),
    [anon_sym_bytes8] = ACTIONS(684),
    [anon_sym_bytes9] = ACTIONS(684),
    [anon_sym_bytes10] = ACTIONS(684),
    [anon_sym_bytes11] = ACTIONS(684),
    [anon_sym_bytes12] = ACTIONS(684),
    [anon_sym_bytes13] = ACTIONS(684),
    [anon_sym_bytes14] = ACTIONS(684),
    [anon_sym_bytes15] = ACTIONS(684),
    [anon_sym_bytes16] = ACTIONS(684),
    [anon_sym_bytes17] = ACTIONS(684),
    [anon_sym_bytes18] = ACTIONS(684),
    [anon_sym_bytes19] = ACTIONS(684),
    [anon_sym_bytes20] = ACTIONS(684),
    [anon_sym_bytes21] = ACTIONS(684),
    [anon_sym_bytes22] = ACTIONS(684),
    [anon_sym_bytes23] = ACTIONS(684),
    [anon_sym_bytes24] = ACTIONS(684),
    [anon_sym_bytes25] = ACTIONS(684),
    [anon_sym_bytes26] = ACTIONS(684),
    [anon_sym_bytes27] = ACTIONS(684),
    [anon_sym_bytes28] = ACTIONS(684),
    [anon_sym_bytes29] = ACTIONS(684),
    [anon_sym_bytes30] = ACTIONS(684),
    [anon_sym_bytes31] = ACTIONS(684),
    [anon_sym_bytes32] = ACTIONS(684),
    [anon_sym_fixed] = ACTIONS(684),
    [aux_sym__fixed_token1] = ACTIONS(684),
    [anon_sym_ufixed] = ACTIONS(684),
    [aux_sym__ufixed_token1] = ACTIONS(684),
    [sym_comment] = ACTIONS(3),
  },
  [201] = {
    [sym_identifier] = ACTIONS(804),
    [anon_sym_RBRACE] = ACTIONS(806),
    [anon_sym_type] = ACTIONS(804),
    [anon_sym_error] = ACTIONS(804),
    [anon_sym_struct] = ACTIONS(804),
    [anon_sym_enum] = ACTIONS(804),
    [anon_sym_event] = ACTIONS(804),
    [anon_sym_using] = ACTIONS(804),
    [anon_sym_function] = ACTIONS(804),
    [anon_sym_byte] = ACTIONS(804),
    [anon_sym_address] = ACTIONS(804),
    [anon_sym_var] = ACTIONS(804),
    [anon_sym_modifier] = ACTIONS(804),
    [anon_sym_constructor] = ACTIONS(804),
    [anon_sym_fallback] = ACTIONS(804),
    [anon_sym_receive] = ACTIONS(804),
    [anon_sym_mapping] = ACTIONS(804),
    [anon_sym_bool] = ACTIONS(804),
    [anon_sym_string] = ACTIONS(804),
    [anon_sym_int] = ACTIONS(804),
    [anon_sym_int8] = ACTIONS(804),
    [anon_sym_int16] = ACTIONS(804),
    [anon_sym_int24] = ACTIONS(804),
    [anon_sym_int32] = ACTIONS(804),
    [anon_sym_int40] = ACTIONS(804),
    [anon_sym_int48] = ACTIONS(804),
    [anon_sym_int56] = ACTIONS(804),
    [anon_sym_int64] = ACTIONS(804),
    [anon_sym_int72] = ACTIONS(804),
    [anon_sym_int80] = ACTIONS(804),
    [anon_sym_int88] = ACTIONS(804),
    [anon_sym_int96] = ACTIONS(804),
    [anon_sym_int104] = ACTIONS(804),
    [anon_sym_int112] = ACTIONS(804),
    [anon_sym_int120] = ACTIONS(804),
    [anon_sym_int128] = ACTIONS(804),
    [anon_sym_int136] = ACTIONS(804),
    [anon_sym_int144] = ACTIONS(804),
    [anon_sym_int152] = ACTIONS(804),
    [anon_sym_int160] = ACTIONS(804),
    [anon_sym_int168] = ACTIONS(804),
    [anon_sym_int176] = ACTIONS(804),
    [anon_sym_int184] = ACTIONS(804),
    [anon_sym_int192] = ACTIONS(804),
    [anon_sym_int200] = ACTIONS(804),
    [anon_sym_int208] = ACTIONS(804),
    [anon_sym_int216] = ACTIONS(804),
    [anon_sym_int224] = ACTIONS(804),
    [anon_sym_int232] = ACTIONS(804),
    [anon_sym_int240] = ACTIONS(804),
    [anon_sym_int248] = ACTIONS(804),
    [anon_sym_int256] = ACTIONS(804),
    [anon_sym_uint] = ACTIONS(804),
    [anon_sym_uint8] = ACTIONS(804),
    [anon_sym_uint16] = ACTIONS(804),
    [anon_sym_uint24] = ACTIONS(804),
    [anon_sym_uint32] = ACTIONS(804),
    [anon_sym_uint40] = ACTIONS(804),
    [anon_sym_uint48] = ACTIONS(804),
    [anon_sym_uint56] = ACTIONS(804),
    [anon_sym_uint64] = ACTIONS(804),
    [anon_sym_uint72] = ACTIONS(804),
    [anon_sym_uint80] = ACTIONS(804),
    [anon_sym_uint88] = ACTIONS(804),
    [anon_sym_uint96] = ACTIONS(804),
    [anon_sym_uint104] = ACTIONS(804),
    [anon_sym_uint112] = ACTIONS(804),
    [anon_sym_uint120] = ACTIONS(804),
    [anon_sym_uint128] = ACTIONS(804),
    [anon_sym_uint136] = ACTIONS(804),
    [anon_sym_uint144] = ACTIONS(804),
    [anon_sym_uint152] = ACTIONS(804),
    [anon_sym_uint160] = ACTIONS(804),
    [anon_sym_uint168] = ACTIONS(804),
    [anon_sym_uint176] = ACTIONS(804),
    [anon_sym_uint184] = ACTIONS(804),
    [anon_sym_uint192] = ACTIONS(804),
    [anon_sym_uint200] = ACTIONS(804),
    [anon_sym_uint208] = ACTIONS(804),
    [anon_sym_uint216] = ACTIONS(804),
    [anon_sym_uint224] = ACTIONS(804),
    [anon_sym_uint232] = ACTIONS(804),
    [anon_sym_uint240] = ACTIONS(804),
    [anon_sym_uint248] = ACTIONS(804),
    [anon_sym_uint256] = ACTIONS(804),
    [anon_sym_bytes] = ACTIONS(804),
    [anon_sym_bytes1] = ACTIONS(804),
    [anon_sym_bytes2] = ACTIONS(804),
    [anon_sym_bytes3] = ACTIONS(804),
    [anon_sym_bytes4] = ACTIONS(804),
    [anon_sym_bytes5] = ACTIONS(804),
    [anon_sym_bytes6] = ACTIONS(804),
    [anon_sym_bytes7] = ACTIONS(804),
    [anon_sym_bytes8] = ACTIONS(804),
    [anon_sym_bytes9] = ACTIONS(804),
    [anon_sym_bytes10] = ACTIONS(804),
    [anon_sym_bytes11] = ACTIONS(804),
    [anon_sym_bytes12] = ACTIONS(804),
    [anon_sym_bytes13] = ACTIONS(804),
    [anon_sym_bytes14] = ACTIONS(804),
    [anon_sym_bytes15] = ACTIONS(804),
    [anon_sym_bytes16] = ACTIONS(804),
    [anon_sym_bytes17] = ACTIONS(804),
    [anon_sym_bytes18] = ACTIONS(804),
    [anon_sym_bytes19] = ACTIONS(804),
    [anon_sym_bytes20] = ACTIONS(804),
    [anon_sym_bytes21] = ACTIONS(804),
    [anon_sym_bytes22] = ACTIONS(804),
    [anon_sym_bytes23] = ACTIONS(804),
    [anon_sym_bytes24] = ACTIONS(804),
    [anon_sym_bytes25] = ACTIONS(804),
    [anon_sym_bytes26] = ACTIONS(804),
    [anon_sym_bytes27] = ACTIONS(804),
    [anon_sym_bytes28] = ACTIONS(804),
    [anon_sym_bytes29] = ACTIONS(804),
    [anon_sym_bytes30] = ACTIONS(804),
    [anon_sym_bytes31] = ACTIONS(804),
    [anon_sym_bytes32] = ACTIONS(804),
    [anon_sym_fixed] = ACTIONS(804),
    [aux_sym__fixed_token1] = ACTIONS(804),
    [anon_sym_ufixed] = ACTIONS(804),
    [aux_sym__ufixed_token1] = ACTIONS(804),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [sym_identifier] = ACTIONS(808),
    [anon_sym_RBRACE] = ACTIONS(810),
    [anon_sym_type] = ACTIONS(808),
    [anon_sym_error] = ACTIONS(808),
    [anon_sym_struct] = ACTIONS(808),
    [anon_sym_enum] = ACTIONS(808),
    [anon_sym_event] = ACTIONS(808),
    [anon_sym_using] = ACTIONS(808),
    [anon_sym_function] = ACTIONS(808),
    [anon_sym_byte] = ACTIONS(808),
    [anon_sym_address] = ACTIONS(808),
    [anon_sym_var] = ACTIONS(808),
    [anon_sym_modifier] = ACTIONS(808),
    [anon_sym_constructor] = ACTIONS(808),
    [anon_sym_fallback] = ACTIONS(808),
    [anon_sym_receive] = ACTIONS(808),
    [anon_sym_mapping] = ACTIONS(808),
    [anon_sym_bool] = ACTIONS(808),
    [anon_sym_string] = ACTIONS(808),
    [anon_sym_int] = ACTIONS(808),
    [anon_sym_int8] = ACTIONS(808),
    [anon_sym_int16] = ACTIONS(808),
    [anon_sym_int24] = ACTIONS(808),
    [anon_sym_int32] = ACTIONS(808),
    [anon_sym_int40] = ACTIONS(808),
    [anon_sym_int48] = ACTIONS(808),
    [anon_sym_int56] = ACTIONS(808),
    [anon_sym_int64] = ACTIONS(808),
    [anon_sym_int72] = ACTIONS(808),
    [anon_sym_int80] = ACTIONS(808),
    [anon_sym_int88] = ACTIONS(808),
    [anon_sym_int96] = ACTIONS(808),
    [anon_sym_int104] = ACTIONS(808),
    [anon_sym_int112] = ACTIONS(808),
    [anon_sym_int120] = ACTIONS(808),
    [anon_sym_int128] = ACTIONS(808),
    [anon_sym_int136] = ACTIONS(808),
    [anon_sym_int144] = ACTIONS(808),
    [anon_sym_int152] = ACTIONS(808),
    [anon_sym_int160] = ACTIONS(808),
    [anon_sym_int168] = ACTIONS(808),
    [anon_sym_int176] = ACTIONS(808),
    [anon_sym_int184] = ACTIONS(808),
    [anon_sym_int192] = ACTIONS(808),
    [anon_sym_int200] = ACTIONS(808),
    [anon_sym_int208] = ACTIONS(808),
    [anon_sym_int216] = ACTIONS(808),
    [anon_sym_int224] = ACTIONS(808),
    [anon_sym_int232] = ACTIONS(808),
    [anon_sym_int240] = ACTIONS(808),
    [anon_sym_int248] = ACTIONS(808),
    [anon_sym_int256] = ACTIONS(808),
    [anon_sym_uint] = ACTIONS(808),
    [anon_sym_uint8] = ACTIONS(808),
    [anon_sym_uint16] = ACTIONS(808),
    [anon_sym_uint24] = ACTIONS(808),
    [anon_sym_uint32] = ACTIONS(808),
    [anon_sym_uint40] = ACTIONS(808),
    [anon_sym_uint48] = ACTIONS(808),
    [anon_sym_uint56] = ACTIONS(808),
    [anon_sym_uint64] = ACTIONS(808),
    [anon_sym_uint72] = ACTIONS(808),
    [anon_sym_uint80] = ACTIONS(808),
    [anon_sym_uint88] = ACTIONS(808),
    [anon_sym_uint96] = ACTIONS(808),
    [anon_sym_uint104] = ACTIONS(808),
    [anon_sym_uint112] = ACTIONS(808),
    [anon_sym_uint120] = ACTIONS(808),
    [anon_sym_uint128] = ACTIONS(808),
    [anon_sym_uint136] = ACTIONS(808),
    [anon_sym_uint144] = ACTIONS(808),
    [anon_sym_uint152] = ACTIONS(808),
    [anon_sym_uint160] = ACTIONS(808),
    [anon_sym_uint168] = ACTIONS(808),
    [anon_sym_uint176] = ACTIONS(808),
    [anon_sym_uint184] = ACTIONS(808),
    [anon_sym_uint192] = ACTIONS(808),
    [anon_sym_uint200] = ACTIONS(808),
    [anon_sym_uint208] = ACTIONS(808),
    [anon_sym_uint216] = ACTIONS(808),
    [anon_sym_uint224] = ACTIONS(808),
    [anon_sym_uint232] = ACTIONS(808),
    [anon_sym_uint240] = ACTIONS(808),
    [anon_sym_uint248] = ACTIONS(808),
    [anon_sym_uint256] = ACTIONS(808),
    [anon_sym_bytes] = ACTIONS(808),
    [anon_sym_bytes1] = ACTIONS(808),
    [anon_sym_bytes2] = ACTIONS(808),
    [anon_sym_bytes3] = ACTIONS(808),
    [anon_sym_bytes4] = ACTIONS(808),
    [anon_sym_bytes5] = ACTIONS(808),
    [anon_sym_bytes6] = ACTIONS(808),
    [anon_sym_bytes7] = ACTIONS(808),
    [anon_sym_bytes8] = ACTIONS(808),
    [anon_sym_bytes9] = ACTIONS(808),
    [anon_sym_bytes10] = ACTIONS(808),
    [anon_sym_bytes11] = ACTIONS(808),
    [anon_sym_bytes12] = ACTIONS(808),
    [anon_sym_bytes13] = ACTIONS(808),
    [anon_sym_bytes14] = ACTIONS(808),
    [anon_sym_bytes15] = ACTIONS(808),
    [anon_sym_bytes16] = ACTIONS(808),
    [anon_sym_bytes17] = ACTIONS(808),
    [anon_sym_bytes18] = ACTIONS(808),
    [anon_sym_bytes19] = ACTIONS(808),
    [anon_sym_bytes20] = ACTIONS(808),
    [anon_sym_bytes21] = ACTIONS(808),
    [anon_sym_bytes22] = ACTIONS(808),
    [anon_sym_bytes23] = ACTIONS(808),
    [anon_sym_bytes24] = ACTIONS(808),
    [anon_sym_bytes25] = ACTIONS(808),
    [anon_sym_bytes26] = ACTIONS(808),
    [anon_sym_bytes27] = ACTIONS(808),
    [anon_sym_bytes28] = ACTIONS(808),
    [anon_sym_bytes29] = ACTIONS(808),
    [anon_sym_bytes30] = ACTIONS(808),
    [anon_sym_bytes31] = ACTIONS(808),
    [anon_sym_bytes32] = ACTIONS(808),
    [anon_sym_fixed] = ACTIONS(808),
    [aux_sym__fixed_token1] = ACTIONS(808),
    [anon_sym_ufixed] = ACTIONS(808),
    [aux_sym__ufixed_token1] = ACTIONS(808),
    [sym_comment] = ACTIONS(3),
  },
  [203] = {
    [sym_identifier] = ACTIONS(746),
    [anon_sym_RBRACE] = ACTIONS(744),
    [anon_sym_type] = ACTIONS(746),
    [anon_sym_error] = ACTIONS(746),
    [anon_sym_struct] = ACTIONS(746),
    [anon_sym_enum] = ACTIONS(746),
    [anon_sym_event] = ACTIONS(746),
    [anon_sym_using] = ACTIONS(746),
    [anon_sym_function] = ACTIONS(746),
    [anon_sym_byte] = ACTIONS(746),
    [anon_sym_address] = ACTIONS(746),
    [anon_sym_var] = ACTIONS(746),
    [anon_sym_modifier] = ACTIONS(746),
    [anon_sym_constructor] = ACTIONS(746),
    [anon_sym_fallback] = ACTIONS(746),
    [anon_sym_receive] = ACTIONS(746),
    [anon_sym_mapping] = ACTIONS(746),
    [anon_sym_bool] = ACTIONS(746),
    [anon_sym_string] = ACTIONS(746),
    [anon_sym_int] = ACTIONS(746),
    [anon_sym_int8] = ACTIONS(746),
    [anon_sym_int16] = ACTIONS(746),
    [anon_sym_int24] = ACTIONS(746),
    [anon_sym_int32] = ACTIONS(746),
    [anon_sym_int40] = ACTIONS(746),
    [anon_sym_int48] = ACTIONS(746),
    [anon_sym_int56] = ACTIONS(746),
    [anon_sym_int64] = ACTIONS(746),
    [anon_sym_int72] = ACTIONS(746),
    [anon_sym_int80] = ACTIONS(746),
    [anon_sym_int88] = ACTIONS(746),
    [anon_sym_int96] = ACTIONS(746),
    [anon_sym_int104] = ACTIONS(746),
    [anon_sym_int112] = ACTIONS(746),
    [anon_sym_int120] = ACTIONS(746),
    [anon_sym_int128] = ACTIONS(746),
    [anon_sym_int136] = ACTIONS(746),
    [anon_sym_int144] = ACTIONS(746),
    [anon_sym_int152] = ACTIONS(746),
    [anon_sym_int160] = ACTIONS(746),
    [anon_sym_int168] = ACTIONS(746),
    [anon_sym_int176] = ACTIONS(746),
    [anon_sym_int184] = ACTIONS(746),
    [anon_sym_int192] = ACTIONS(746),
    [anon_sym_int200] = ACTIONS(746),
    [anon_sym_int208] = ACTIONS(746),
    [anon_sym_int216] = ACTIONS(746),
    [anon_sym_int224] = ACTIONS(746),
    [anon_sym_int232] = ACTIONS(746),
    [anon_sym_int240] = ACTIONS(746),
    [anon_sym_int248] = ACTIONS(746),
    [anon_sym_int256] = ACTIONS(746),
    [anon_sym_uint] = ACTIONS(746),
    [anon_sym_uint8] = ACTIONS(746),
    [anon_sym_uint16] = ACTIONS(746),
    [anon_sym_uint24] = ACTIONS(746),
    [anon_sym_uint32] = ACTIONS(746),
    [anon_sym_uint40] = ACTIONS(746),
    [anon_sym_uint48] = ACTIONS(746),
    [anon_sym_uint56] = ACTIONS(746),
    [anon_sym_uint64] = ACTIONS(746),
    [anon_sym_uint72] = ACTIONS(746),
    [anon_sym_uint80] = ACTIONS(746),
    [anon_sym_uint88] = ACTIONS(746),
    [anon_sym_uint96] = ACTIONS(746),
    [anon_sym_uint104] = ACTIONS(746),
    [anon_sym_uint112] = ACTIONS(746),
    [anon_sym_uint120] = ACTIONS(746),
    [anon_sym_uint128] = ACTIONS(746),
    [anon_sym_uint136] = ACTIONS(746),
    [anon_sym_uint144] = ACTIONS(746),
    [anon_sym_uint152] = ACTIONS(746),
    [anon_sym_uint160] = ACTIONS(746),
    [anon_sym_uint168] = ACTIONS(746),
    [anon_sym_uint176] = ACTIONS(746),
    [anon_sym_uint184] = ACTIONS(746),
    [anon_sym_uint192] = ACTIONS(746),
    [anon_sym_uint200] = ACTIONS(746),
    [anon_sym_uint208] = ACTIONS(746),
    [anon_sym_uint216] = ACTIONS(746),
    [anon_sym_uint224] = ACTIONS(746),
    [anon_sym_uint232] = ACTIONS(746),
    [anon_sym_uint240] = ACTIONS(746),
    [anon_sym_uint248] = ACTIONS(746),
    [anon_sym_uint256] = ACTIONS(746),
    [anon_sym_bytes] = ACTIONS(746),
    [anon_sym_bytes1] = ACTIONS(746),
    [anon_sym_bytes2] = ACTIONS(746),
    [anon_sym_bytes3] = ACTIONS(746),
    [anon_sym_bytes4] = ACTIONS(746),
    [anon_sym_bytes5] = ACTIONS(746),
    [anon_sym_bytes6] = ACTIONS(746),
    [anon_sym_bytes7] = ACTIONS(746),
    [anon_sym_bytes8] = ACTIONS(746),
    [anon_sym_bytes9] = ACTIONS(746),
    [anon_sym_bytes10] = ACTIONS(746),
    [anon_sym_bytes11] = ACTIONS(746),
    [anon_sym_bytes12] = ACTIONS(746),
    [anon_sym_bytes13] = ACTIONS(746),
    [anon_sym_bytes14] = ACTIONS(746),
    [anon_sym_bytes15] = ACTIONS(746),
    [anon_sym_bytes16] = ACTIONS(746),
    [anon_sym_bytes17] = ACTIONS(746),
    [anon_sym_bytes18] = ACTIONS(746),
    [anon_sym_bytes19] = ACTIONS(746),
    [anon_sym_bytes20] = ACTIONS(746),
    [anon_sym_bytes21] = ACTIONS(746),
    [anon_sym_bytes22] = ACTIONS(746),
    [anon_sym_bytes23] = ACTIONS(746),
    [anon_sym_bytes24] = ACTIONS(746),
    [anon_sym_bytes25] = ACTIONS(746),
    [anon_sym_bytes26] = ACTIONS(746),
    [anon_sym_bytes27] = ACTIONS(746),
    [anon_sym_bytes28] = ACTIONS(746),
    [anon_sym_bytes29] = ACTIONS(746),
    [anon_sym_bytes30] = ACTIONS(746),
    [anon_sym_bytes31] = ACTIONS(746),
    [anon_sym_bytes32] = ACTIONS(746),
    [anon_sym_fixed] = ACTIONS(746),
    [aux_sym__fixed_token1] = ACTIONS(746),
    [anon_sym_ufixed] = ACTIONS(746),
    [aux_sym__ufixed_token1] = ACTIONS(746),
    [sym_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_identifier] = ACTIONS(734),
    [anon_sym_RBRACE] = ACTIONS(732),
    [anon_sym_type] = ACTIONS(734),
    [anon_sym_error] = ACTIONS(734),
    [anon_sym_struct] = ACTIONS(734),
    [anon_sym_enum] = ACTIONS(734),
    [anon_sym_event] = ACTIONS(734),
    [anon_sym_using] = ACTIONS(734),
    [anon_sym_function] = ACTIONS(734),
    [anon_sym_byte] = ACTIONS(734),
    [anon_sym_address] = ACTIONS(734),
    [anon_sym_var] = ACTIONS(734),
    [anon_sym_modifier] = ACTIONS(734),
    [anon_sym_constructor] = ACTIONS(734),
    [anon_sym_fallback] = ACTIONS(734),
    [anon_sym_receive] = ACTIONS(734),
    [anon_sym_mapping] = ACTIONS(734),
    [anon_sym_bool] = ACTIONS(734),
    [anon_sym_string] = ACTIONS(734),
    [anon_sym_int] = ACTIONS(734),
    [anon_sym_int8] = ACTIONS(734),
    [anon_sym_int16] = ACTIONS(734),
    [anon_sym_int24] = ACTIONS(734),
    [anon_sym_int32] = ACTIONS(734),
    [anon_sym_int40] = ACTIONS(734),
    [anon_sym_int48] = ACTIONS(734),
    [anon_sym_int56] = ACTIONS(734),
    [anon_sym_int64] = ACTIONS(734),
    [anon_sym_int72] = ACTIONS(734),
    [anon_sym_int80] = ACTIONS(734),
    [anon_sym_int88] = ACTIONS(734),
    [anon_sym_int96] = ACTIONS(734),
    [anon_sym_int104] = ACTIONS(734),
    [anon_sym_int112] = ACTIONS(734),
    [anon_sym_int120] = ACTIONS(734),
    [anon_sym_int128] = ACTIONS(734),
    [anon_sym_int136] = ACTIONS(734),
    [anon_sym_int144] = ACTIONS(734),
    [anon_sym_int152] = ACTIONS(734),
    [anon_sym_int160] = ACTIONS(734),
    [anon_sym_int168] = ACTIONS(734),
    [anon_sym_int176] = ACTIONS(734),
    [anon_sym_int184] = ACTIONS(734),
    [anon_sym_int192] = ACTIONS(734),
    [anon_sym_int200] = ACTIONS(734),
    [anon_sym_int208] = ACTIONS(734),
    [anon_sym_int216] = ACTIONS(734),
    [anon_sym_int224] = ACTIONS(734),
    [anon_sym_int232] = ACTIONS(734),
    [anon_sym_int240] = ACTIONS(734),
    [anon_sym_int248] = ACTIONS(734),
    [anon_sym_int256] = ACTIONS(734),
    [anon_sym_uint] = ACTIONS(734),
    [anon_sym_uint8] = ACTIONS(734),
    [anon_sym_uint16] = ACTIONS(734),
    [anon_sym_uint24] = ACTIONS(734),
    [anon_sym_uint32] = ACTIONS(734),
    [anon_sym_uint40] = ACTIONS(734),
    [anon_sym_uint48] = ACTIONS(734),
    [anon_sym_uint56] = ACTIONS(734),
    [anon_sym_uint64] = ACTIONS(734),
    [anon_sym_uint72] = ACTIONS(734),
    [anon_sym_uint80] = ACTIONS(734),
    [anon_sym_uint88] = ACTIONS(734),
    [anon_sym_uint96] = ACTIONS(734),
    [anon_sym_uint104] = ACTIONS(734),
    [anon_sym_uint112] = ACTIONS(734),
    [anon_sym_uint120] = ACTIONS(734),
    [anon_sym_uint128] = ACTIONS(734),
    [anon_sym_uint136] = ACTIONS(734),
    [anon_sym_uint144] = ACTIONS(734),
    [anon_sym_uint152] = ACTIONS(734),
    [anon_sym_uint160] = ACTIONS(734),
    [anon_sym_uint168] = ACTIONS(734),
    [anon_sym_uint176] = ACTIONS(734),
    [anon_sym_uint184] = ACTIONS(734),
    [anon_sym_uint192] = ACTIONS(734),
    [anon_sym_uint200] = ACTIONS(734),
    [anon_sym_uint208] = ACTIONS(734),
    [anon_sym_uint216] = ACTIONS(734),
    [anon_sym_uint224] = ACTIONS(734),
    [anon_sym_uint232] = ACTIONS(734),
    [anon_sym_uint240] = ACTIONS(734),
    [anon_sym_uint248] = ACTIONS(734),
    [anon_sym_uint256] = ACTIONS(734),
    [anon_sym_bytes] = ACTIONS(734),
    [anon_sym_bytes1] = ACTIONS(734),
    [anon_sym_bytes2] = ACTIONS(734),
    [anon_sym_bytes3] = ACTIONS(734),
    [anon_sym_bytes4] = ACTIONS(734),
    [anon_sym_bytes5] = ACTIONS(734),
    [anon_sym_bytes6] = ACTIONS(734),
    [anon_sym_bytes7] = ACTIONS(734),
    [anon_sym_bytes8] = ACTIONS(734),
    [anon_sym_bytes9] = ACTIONS(734),
    [anon_sym_bytes10] = ACTIONS(734),
    [anon_sym_bytes11] = ACTIONS(734),
    [anon_sym_bytes12] = ACTIONS(734),
    [anon_sym_bytes13] = ACTIONS(734),
    [anon_sym_bytes14] = ACTIONS(734),
    [anon_sym_bytes15] = ACTIONS(734),
    [anon_sym_bytes16] = ACTIONS(734),
    [anon_sym_bytes17] = ACTIONS(734),
    [anon_sym_bytes18] = ACTIONS(734),
    [anon_sym_bytes19] = ACTIONS(734),
    [anon_sym_bytes20] = ACTIONS(734),
    [anon_sym_bytes21] = ACTIONS(734),
    [anon_sym_bytes22] = ACTIONS(734),
    [anon_sym_bytes23] = ACTIONS(734),
    [anon_sym_bytes24] = ACTIONS(734),
    [anon_sym_bytes25] = ACTIONS(734),
    [anon_sym_bytes26] = ACTIONS(734),
    [anon_sym_bytes27] = ACTIONS(734),
    [anon_sym_bytes28] = ACTIONS(734),
    [anon_sym_bytes29] = ACTIONS(734),
    [anon_sym_bytes30] = ACTIONS(734),
    [anon_sym_bytes31] = ACTIONS(734),
    [anon_sym_bytes32] = ACTIONS(734),
    [anon_sym_fixed] = ACTIONS(734),
    [aux_sym__fixed_token1] = ACTIONS(734),
    [anon_sym_ufixed] = ACTIONS(734),
    [aux_sym__ufixed_token1] = ACTIONS(734),
    [sym_comment] = ACTIONS(3),
  },
  [205] = {
    [sym_identifier] = ACTIONS(742),
    [anon_sym_RBRACE] = ACTIONS(740),
    [anon_sym_type] = ACTIONS(742),
    [anon_sym_error] = ACTIONS(742),
    [anon_sym_struct] = ACTIONS(742),
    [anon_sym_enum] = ACTIONS(742),
    [anon_sym_event] = ACTIONS(742),
    [anon_sym_using] = ACTIONS(742),
    [anon_sym_function] = ACTIONS(742),
    [anon_sym_byte] = ACTIONS(742),
    [anon_sym_address] = ACTIONS(742),
    [anon_sym_var] = ACTIONS(742),
    [anon_sym_modifier] = ACTIONS(742),
    [anon_sym_constructor] = ACTIONS(742),
    [anon_sym_fallback] = ACTIONS(742),
    [anon_sym_receive] = ACTIONS(742),
    [anon_sym_mapping] = ACTIONS(742),
    [anon_sym_bool] = ACTIONS(742),
    [anon_sym_string] = ACTIONS(742),
    [anon_sym_int] = ACTIONS(742),
    [anon_sym_int8] = ACTIONS(742),
    [anon_sym_int16] = ACTIONS(742),
    [anon_sym_int24] = ACTIONS(742),
    [anon_sym_int32] = ACTIONS(742),
    [anon_sym_int40] = ACTIONS(742),
    [anon_sym_int48] = ACTIONS(742),
    [anon_sym_int56] = ACTIONS(742),
    [anon_sym_int64] = ACTIONS(742),
    [anon_sym_int72] = ACTIONS(742),
    [anon_sym_int80] = ACTIONS(742),
    [anon_sym_int88] = ACTIONS(742),
    [anon_sym_int96] = ACTIONS(742),
    [anon_sym_int104] = ACTIONS(742),
    [anon_sym_int112] = ACTIONS(742),
    [anon_sym_int120] = ACTIONS(742),
    [anon_sym_int128] = ACTIONS(742),
    [anon_sym_int136] = ACTIONS(742),
    [anon_sym_int144] = ACTIONS(742),
    [anon_sym_int152] = ACTIONS(742),
    [anon_sym_int160] = ACTIONS(742),
    [anon_sym_int168] = ACTIONS(742),
    [anon_sym_int176] = ACTIONS(742),
    [anon_sym_int184] = ACTIONS(742),
    [anon_sym_int192] = ACTIONS(742),
    [anon_sym_int200] = ACTIONS(742),
    [anon_sym_int208] = ACTIONS(742),
    [anon_sym_int216] = ACTIONS(742),
    [anon_sym_int224] = ACTIONS(742),
    [anon_sym_int232] = ACTIONS(742),
    [anon_sym_int240] = ACTIONS(742),
    [anon_sym_int248] = ACTIONS(742),
    [anon_sym_int256] = ACTIONS(742),
    [anon_sym_uint] = ACTIONS(742),
    [anon_sym_uint8] = ACTIONS(742),
    [anon_sym_uint16] = ACTIONS(742),
    [anon_sym_uint24] = ACTIONS(742),
    [anon_sym_uint32] = ACTIONS(742),
    [anon_sym_uint40] = ACTIONS(742),
    [anon_sym_uint48] = ACTIONS(742),
    [anon_sym_uint56] = ACTIONS(742),
    [anon_sym_uint64] = ACTIONS(742),
    [anon_sym_uint72] = ACTIONS(742),
    [anon_sym_uint80] = ACTIONS(742),
    [anon_sym_uint88] = ACTIONS(742),
    [anon_sym_uint96] = ACTIONS(742),
    [anon_sym_uint104] = ACTIONS(742),
    [anon_sym_uint112] = ACTIONS(742),
    [anon_sym_uint120] = ACTIONS(742),
    [anon_sym_uint128] = ACTIONS(742),
    [anon_sym_uint136] = ACTIONS(742),
    [anon_sym_uint144] = ACTIONS(742),
    [anon_sym_uint152] = ACTIONS(742),
    [anon_sym_uint160] = ACTIONS(742),
    [anon_sym_uint168] = ACTIONS(742),
    [anon_sym_uint176] = ACTIONS(742),
    [anon_sym_uint184] = ACTIONS(742),
    [anon_sym_uint192] = ACTIONS(742),
    [anon_sym_uint200] = ACTIONS(742),
    [anon_sym_uint208] = ACTIONS(742),
    [anon_sym_uint216] = ACTIONS(742),
    [anon_sym_uint224] = ACTIONS(742),
    [anon_sym_uint232] = ACTIONS(742),
    [anon_sym_uint240] = ACTIONS(742),
    [anon_sym_uint248] = ACTIONS(742),
    [anon_sym_uint256] = ACTIONS(742),
    [anon_sym_bytes] = ACTIONS(742),
    [anon_sym_bytes1] = ACTIONS(742),
    [anon_sym_bytes2] = ACTIONS(742),
    [anon_sym_bytes3] = ACTIONS(742),
    [anon_sym_bytes4] = ACTIONS(742),
    [anon_sym_bytes5] = ACTIONS(742),
    [anon_sym_bytes6] = ACTIONS(742),
    [anon_sym_bytes7] = ACTIONS(742),
    [anon_sym_bytes8] = ACTIONS(742),
    [anon_sym_bytes9] = ACTIONS(742),
    [anon_sym_bytes10] = ACTIONS(742),
    [anon_sym_bytes11] = ACTIONS(742),
    [anon_sym_bytes12] = ACTIONS(742),
    [anon_sym_bytes13] = ACTIONS(742),
    [anon_sym_bytes14] = ACTIONS(742),
    [anon_sym_bytes15] = ACTIONS(742),
    [anon_sym_bytes16] = ACTIONS(742),
    [anon_sym_bytes17] = ACTIONS(742),
    [anon_sym_bytes18] = ACTIONS(742),
    [anon_sym_bytes19] = ACTIONS(742),
    [anon_sym_bytes20] = ACTIONS(742),
    [anon_sym_bytes21] = ACTIONS(742),
    [anon_sym_bytes22] = ACTIONS(742),
    [anon_sym_bytes23] = ACTIONS(742),
    [anon_sym_bytes24] = ACTIONS(742),
    [anon_sym_bytes25] = ACTIONS(742),
    [anon_sym_bytes26] = ACTIONS(742),
    [anon_sym_bytes27] = ACTIONS(742),
    [anon_sym_bytes28] = ACTIONS(742),
    [anon_sym_bytes29] = ACTIONS(742),
    [anon_sym_bytes30] = ACTIONS(742),
    [anon_sym_bytes31] = ACTIONS(742),
    [anon_sym_bytes32] = ACTIONS(742),
    [anon_sym_fixed] = ACTIONS(742),
    [aux_sym__fixed_token1] = ACTIONS(742),
    [anon_sym_ufixed] = ACTIONS(742),
    [aux_sym__ufixed_token1] = ACTIONS(742),
    [sym_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_identifier] = ACTIONS(812),
    [anon_sym_RBRACE] = ACTIONS(814),
    [anon_sym_type] = ACTIONS(812),
    [anon_sym_error] = ACTIONS(812),
    [anon_sym_struct] = ACTIONS(812),
    [anon_sym_enum] = ACTIONS(812),
    [anon_sym_event] = ACTIONS(812),
    [anon_sym_using] = ACTIONS(812),
    [anon_sym_function] = ACTIONS(812),
    [anon_sym_byte] = ACTIONS(812),
    [anon_sym_address] = ACTIONS(812),
    [anon_sym_var] = ACTIONS(812),
    [anon_sym_modifier] = ACTIONS(812),
    [anon_sym_constructor] = ACTIONS(812),
    [anon_sym_fallback] = ACTIONS(812),
    [anon_sym_receive] = ACTIONS(812),
    [anon_sym_mapping] = ACTIONS(812),
    [anon_sym_bool] = ACTIONS(812),
    [anon_sym_string] = ACTIONS(812),
    [anon_sym_int] = ACTIONS(812),
    [anon_sym_int8] = ACTIONS(812),
    [anon_sym_int16] = ACTIONS(812),
    [anon_sym_int24] = ACTIONS(812),
    [anon_sym_int32] = ACTIONS(812),
    [anon_sym_int40] = ACTIONS(812),
    [anon_sym_int48] = ACTIONS(812),
    [anon_sym_int56] = ACTIONS(812),
    [anon_sym_int64] = ACTIONS(812),
    [anon_sym_int72] = ACTIONS(812),
    [anon_sym_int80] = ACTIONS(812),
    [anon_sym_int88] = ACTIONS(812),
    [anon_sym_int96] = ACTIONS(812),
    [anon_sym_int104] = ACTIONS(812),
    [anon_sym_int112] = ACTIONS(812),
    [anon_sym_int120] = ACTIONS(812),
    [anon_sym_int128] = ACTIONS(812),
    [anon_sym_int136] = ACTIONS(812),
    [anon_sym_int144] = ACTIONS(812),
    [anon_sym_int152] = ACTIONS(812),
    [anon_sym_int160] = ACTIONS(812),
    [anon_sym_int168] = ACTIONS(812),
    [anon_sym_int176] = ACTIONS(812),
    [anon_sym_int184] = ACTIONS(812),
    [anon_sym_int192] = ACTIONS(812),
    [anon_sym_int200] = ACTIONS(812),
    [anon_sym_int208] = ACTIONS(812),
    [anon_sym_int216] = ACTIONS(812),
    [anon_sym_int224] = ACTIONS(812),
    [anon_sym_int232] = ACTIONS(812),
    [anon_sym_int240] = ACTIONS(812),
    [anon_sym_int248] = ACTIONS(812),
    [anon_sym_int256] = ACTIONS(812),
    [anon_sym_uint] = ACTIONS(812),
    [anon_sym_uint8] = ACTIONS(812),
    [anon_sym_uint16] = ACTIONS(812),
    [anon_sym_uint24] = ACTIONS(812),
    [anon_sym_uint32] = ACTIONS(812),
    [anon_sym_uint40] = ACTIONS(812),
    [anon_sym_uint48] = ACTIONS(812),
    [anon_sym_uint56] = ACTIONS(812),
    [anon_sym_uint64] = ACTIONS(812),
    [anon_sym_uint72] = ACTIONS(812),
    [anon_sym_uint80] = ACTIONS(812),
    [anon_sym_uint88] = ACTIONS(812),
    [anon_sym_uint96] = ACTIONS(812),
    [anon_sym_uint104] = ACTIONS(812),
    [anon_sym_uint112] = ACTIONS(812),
    [anon_sym_uint120] = ACTIONS(812),
    [anon_sym_uint128] = ACTIONS(812),
    [anon_sym_uint136] = ACTIONS(812),
    [anon_sym_uint144] = ACTIONS(812),
    [anon_sym_uint152] = ACTIONS(812),
    [anon_sym_uint160] = ACTIONS(812),
    [anon_sym_uint168] = ACTIONS(812),
    [anon_sym_uint176] = ACTIONS(812),
    [anon_sym_uint184] = ACTIONS(812),
    [anon_sym_uint192] = ACTIONS(812),
    [anon_sym_uint200] = ACTIONS(812),
    [anon_sym_uint208] = ACTIONS(812),
    [anon_sym_uint216] = ACTIONS(812),
    [anon_sym_uint224] = ACTIONS(812),
    [anon_sym_uint232] = ACTIONS(812),
    [anon_sym_uint240] = ACTIONS(812),
    [anon_sym_uint248] = ACTIONS(812),
    [anon_sym_uint256] = ACTIONS(812),
    [anon_sym_bytes] = ACTIONS(812),
    [anon_sym_bytes1] = ACTIONS(812),
    [anon_sym_bytes2] = ACTIONS(812),
    [anon_sym_bytes3] = ACTIONS(812),
    [anon_sym_bytes4] = ACTIONS(812),
    [anon_sym_bytes5] = ACTIONS(812),
    [anon_sym_bytes6] = ACTIONS(812),
    [anon_sym_bytes7] = ACTIONS(812),
    [anon_sym_bytes8] = ACTIONS(812),
    [anon_sym_bytes9] = ACTIONS(812),
    [anon_sym_bytes10] = ACTIONS(812),
    [anon_sym_bytes11] = ACTIONS(812),
    [anon_sym_bytes12] = ACTIONS(812),
    [anon_sym_bytes13] = ACTIONS(812),
    [anon_sym_bytes14] = ACTIONS(812),
    [anon_sym_bytes15] = ACTIONS(812),
    [anon_sym_bytes16] = ACTIONS(812),
    [anon_sym_bytes17] = ACTIONS(812),
    [anon_sym_bytes18] = ACTIONS(812),
    [anon_sym_bytes19] = ACTIONS(812),
    [anon_sym_bytes20] = ACTIONS(812),
    [anon_sym_bytes21] = ACTIONS(812),
    [anon_sym_bytes22] = ACTIONS(812),
    [anon_sym_bytes23] = ACTIONS(812),
    [anon_sym_bytes24] = ACTIONS(812),
    [anon_sym_bytes25] = ACTIONS(812),
    [anon_sym_bytes26] = ACTIONS(812),
    [anon_sym_bytes27] = ACTIONS(812),
    [anon_sym_bytes28] = ACTIONS(812),
    [anon_sym_bytes29] = ACTIONS(812),
    [anon_sym_bytes30] = ACTIONS(812),
    [anon_sym_bytes31] = ACTIONS(812),
    [anon_sym_bytes32] = ACTIONS(812),
    [anon_sym_fixed] = ACTIONS(812),
    [aux_sym__fixed_token1] = ACTIONS(812),
    [anon_sym_ufixed] = ACTIONS(812),
    [aux_sym__ufixed_token1] = ACTIONS(812),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_identifier] = ACTIONS(816),
    [anon_sym_RBRACE] = ACTIONS(818),
    [anon_sym_type] = ACTIONS(816),
    [anon_sym_error] = ACTIONS(816),
    [anon_sym_struct] = ACTIONS(816),
    [anon_sym_enum] = ACTIONS(816),
    [anon_sym_event] = ACTIONS(816),
    [anon_sym_using] = ACTIONS(816),
    [anon_sym_function] = ACTIONS(816),
    [anon_sym_byte] = ACTIONS(816),
    [anon_sym_address] = ACTIONS(816),
    [anon_sym_var] = ACTIONS(816),
    [anon_sym_modifier] = ACTIONS(816),
    [anon_sym_constructor] = ACTIONS(816),
    [anon_sym_fallback] = ACTIONS(816),
    [anon_sym_receive] = ACTIONS(816),
    [anon_sym_mapping] = ACTIONS(816),
    [anon_sym_bool] = ACTIONS(816),
    [anon_sym_string] = ACTIONS(816),
    [anon_sym_int] = ACTIONS(816),
    [anon_sym_int8] = ACTIONS(816),
    [anon_sym_int16] = ACTIONS(816),
    [anon_sym_int24] = ACTIONS(816),
    [anon_sym_int32] = ACTIONS(816),
    [anon_sym_int40] = ACTIONS(816),
    [anon_sym_int48] = ACTIONS(816),
    [anon_sym_int56] = ACTIONS(816),
    [anon_sym_int64] = ACTIONS(816),
    [anon_sym_int72] = ACTIONS(816),
    [anon_sym_int80] = ACTIONS(816),
    [anon_sym_int88] = ACTIONS(816),
    [anon_sym_int96] = ACTIONS(816),
    [anon_sym_int104] = ACTIONS(816),
    [anon_sym_int112] = ACTIONS(816),
    [anon_sym_int120] = ACTIONS(816),
    [anon_sym_int128] = ACTIONS(816),
    [anon_sym_int136] = ACTIONS(816),
    [anon_sym_int144] = ACTIONS(816),
    [anon_sym_int152] = ACTIONS(816),
    [anon_sym_int160] = ACTIONS(816),
    [anon_sym_int168] = ACTIONS(816),
    [anon_sym_int176] = ACTIONS(816),
    [anon_sym_int184] = ACTIONS(816),
    [anon_sym_int192] = ACTIONS(816),
    [anon_sym_int200] = ACTIONS(816),
    [anon_sym_int208] = ACTIONS(816),
    [anon_sym_int216] = ACTIONS(816),
    [anon_sym_int224] = ACTIONS(816),
    [anon_sym_int232] = ACTIONS(816),
    [anon_sym_int240] = ACTIONS(816),
    [anon_sym_int248] = ACTIONS(816),
    [anon_sym_int256] = ACTIONS(816),
    [anon_sym_uint] = ACTIONS(816),
    [anon_sym_uint8] = ACTIONS(816),
    [anon_sym_uint16] = ACTIONS(816),
    [anon_sym_uint24] = ACTIONS(816),
    [anon_sym_uint32] = ACTIONS(816),
    [anon_sym_uint40] = ACTIONS(816),
    [anon_sym_uint48] = ACTIONS(816),
    [anon_sym_uint56] = ACTIONS(816),
    [anon_sym_uint64] = ACTIONS(816),
    [anon_sym_uint72] = ACTIONS(816),
    [anon_sym_uint80] = ACTIONS(816),
    [anon_sym_uint88] = ACTIONS(816),
    [anon_sym_uint96] = ACTIONS(816),
    [anon_sym_uint104] = ACTIONS(816),
    [anon_sym_uint112] = ACTIONS(816),
    [anon_sym_uint120] = ACTIONS(816),
    [anon_sym_uint128] = ACTIONS(816),
    [anon_sym_uint136] = ACTIONS(816),
    [anon_sym_uint144] = ACTIONS(816),
    [anon_sym_uint152] = ACTIONS(816),
    [anon_sym_uint160] = ACTIONS(816),
    [anon_sym_uint168] = ACTIONS(816),
    [anon_sym_uint176] = ACTIONS(816),
    [anon_sym_uint184] = ACTIONS(816),
    [anon_sym_uint192] = ACTIONS(816),
    [anon_sym_uint200] = ACTIONS(816),
    [anon_sym_uint208] = ACTIONS(816),
    [anon_sym_uint216] = ACTIONS(816),
    [anon_sym_uint224] = ACTIONS(816),
    [anon_sym_uint232] = ACTIONS(816),
    [anon_sym_uint240] = ACTIONS(816),
    [anon_sym_uint248] = ACTIONS(816),
    [anon_sym_uint256] = ACTIONS(816),
    [anon_sym_bytes] = ACTIONS(816),
    [anon_sym_bytes1] = ACTIONS(816),
    [anon_sym_bytes2] = ACTIONS(816),
    [anon_sym_bytes3] = ACTIONS(816),
    [anon_sym_bytes4] = ACTIONS(816),
    [anon_sym_bytes5] = ACTIONS(816),
    [anon_sym_bytes6] = ACTIONS(816),
    [anon_sym_bytes7] = ACTIONS(816),
    [anon_sym_bytes8] = ACTIONS(816),
    [anon_sym_bytes9] = ACTIONS(816),
    [anon_sym_bytes10] = ACTIONS(816),
    [anon_sym_bytes11] = ACTIONS(816),
    [anon_sym_bytes12] = ACTIONS(816),
    [anon_sym_bytes13] = ACTIONS(816),
    [anon_sym_bytes14] = ACTIONS(816),
    [anon_sym_bytes15] = ACTIONS(816),
    [anon_sym_bytes16] = ACTIONS(816),
    [anon_sym_bytes17] = ACTIONS(816),
    [anon_sym_bytes18] = ACTIONS(816),
    [anon_sym_bytes19] = ACTIONS(816),
    [anon_sym_bytes20] = ACTIONS(816),
    [anon_sym_bytes21] = ACTIONS(816),
    [anon_sym_bytes22] = ACTIONS(816),
    [anon_sym_bytes23] = ACTIONS(816),
    [anon_sym_bytes24] = ACTIONS(816),
    [anon_sym_bytes25] = ACTIONS(816),
    [anon_sym_bytes26] = ACTIONS(816),
    [anon_sym_bytes27] = ACTIONS(816),
    [anon_sym_bytes28] = ACTIONS(816),
    [anon_sym_bytes29] = ACTIONS(816),
    [anon_sym_bytes30] = ACTIONS(816),
    [anon_sym_bytes31] = ACTIONS(816),
    [anon_sym_bytes32] = ACTIONS(816),
    [anon_sym_fixed] = ACTIONS(816),
    [aux_sym__fixed_token1] = ACTIONS(816),
    [anon_sym_ufixed] = ACTIONS(816),
    [aux_sym__ufixed_token1] = ACTIONS(816),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_identifier] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(638),
    [anon_sym_type] = ACTIONS(640),
    [anon_sym_error] = ACTIONS(640),
    [anon_sym_struct] = ACTIONS(640),
    [anon_sym_enum] = ACTIONS(640),
    [anon_sym_event] = ACTIONS(640),
    [anon_sym_using] = ACTIONS(640),
    [anon_sym_function] = ACTIONS(640),
    [anon_sym_byte] = ACTIONS(640),
    [anon_sym_address] = ACTIONS(640),
    [anon_sym_var] = ACTIONS(640),
    [anon_sym_modifier] = ACTIONS(640),
    [anon_sym_constructor] = ACTIONS(640),
    [anon_sym_fallback] = ACTIONS(640),
    [anon_sym_receive] = ACTIONS(640),
    [anon_sym_mapping] = ACTIONS(640),
    [anon_sym_bool] = ACTIONS(640),
    [anon_sym_string] = ACTIONS(640),
    [anon_sym_int] = ACTIONS(640),
    [anon_sym_int8] = ACTIONS(640),
    [anon_sym_int16] = ACTIONS(640),
    [anon_sym_int24] = ACTIONS(640),
    [anon_sym_int32] = ACTIONS(640),
    [anon_sym_int40] = ACTIONS(640),
    [anon_sym_int48] = ACTIONS(640),
    [anon_sym_int56] = ACTIONS(640),
    [anon_sym_int64] = ACTIONS(640),
    [anon_sym_int72] = ACTIONS(640),
    [anon_sym_int80] = ACTIONS(640),
    [anon_sym_int88] = ACTIONS(640),
    [anon_sym_int96] = ACTIONS(640),
    [anon_sym_int104] = ACTIONS(640),
    [anon_sym_int112] = ACTIONS(640),
    [anon_sym_int120] = ACTIONS(640),
    [anon_sym_int128] = ACTIONS(640),
    [anon_sym_int136] = ACTIONS(640),
    [anon_sym_int144] = ACTIONS(640),
    [anon_sym_int152] = ACTIONS(640),
    [anon_sym_int160] = ACTIONS(640),
    [anon_sym_int168] = ACTIONS(640),
    [anon_sym_int176] = ACTIONS(640),
    [anon_sym_int184] = ACTIONS(640),
    [anon_sym_int192] = ACTIONS(640),
    [anon_sym_int200] = ACTIONS(640),
    [anon_sym_int208] = ACTIONS(640),
    [anon_sym_int216] = ACTIONS(640),
    [anon_sym_int224] = ACTIONS(640),
    [anon_sym_int232] = ACTIONS(640),
    [anon_sym_int240] = ACTIONS(640),
    [anon_sym_int248] = ACTIONS(640),
    [anon_sym_int256] = ACTIONS(640),
    [anon_sym_uint] = ACTIONS(640),
    [anon_sym_uint8] = ACTIONS(640),
    [anon_sym_uint16] = ACTIONS(640),
    [anon_sym_uint24] = ACTIONS(640),
    [anon_sym_uint32] = ACTIONS(640),
    [anon_sym_uint40] = ACTIONS(640),
    [anon_sym_uint48] = ACTIONS(640),
    [anon_sym_uint56] = ACTIONS(640),
    [anon_sym_uint64] = ACTIONS(640),
    [anon_sym_uint72] = ACTIONS(640),
    [anon_sym_uint80] = ACTIONS(640),
    [anon_sym_uint88] = ACTIONS(640),
    [anon_sym_uint96] = ACTIONS(640),
    [anon_sym_uint104] = ACTIONS(640),
    [anon_sym_uint112] = ACTIONS(640),
    [anon_sym_uint120] = ACTIONS(640),
    [anon_sym_uint128] = ACTIONS(640),
    [anon_sym_uint136] = ACTIONS(640),
    [anon_sym_uint144] = ACTIONS(640),
    [anon_sym_uint152] = ACTIONS(640),
    [anon_sym_uint160] = ACTIONS(640),
    [anon_sym_uint168] = ACTIONS(640),
    [anon_sym_uint176] = ACTIONS(640),
    [anon_sym_uint184] = ACTIONS(640),
    [anon_sym_uint192] = ACTIONS(640),
    [anon_sym_uint200] = ACTIONS(640),
    [anon_sym_uint208] = ACTIONS(640),
    [anon_sym_uint216] = ACTIONS(640),
    [anon_sym_uint224] = ACTIONS(640),
    [anon_sym_uint232] = ACTIONS(640),
    [anon_sym_uint240] = ACTIONS(640),
    [anon_sym_uint248] = ACTIONS(640),
    [anon_sym_uint256] = ACTIONS(640),
    [anon_sym_bytes] = ACTIONS(640),
    [anon_sym_bytes1] = ACTIONS(640),
    [anon_sym_bytes2] = ACTIONS(640),
    [anon_sym_bytes3] = ACTIONS(640),
    [anon_sym_bytes4] = ACTIONS(640),
    [anon_sym_bytes5] = ACTIONS(640),
    [anon_sym_bytes6] = ACTIONS(640),
    [anon_sym_bytes7] = ACTIONS(640),
    [anon_sym_bytes8] = ACTIONS(640),
    [anon_sym_bytes9] = ACTIONS(640),
    [anon_sym_bytes10] = ACTIONS(640),
    [anon_sym_bytes11] = ACTIONS(640),
    [anon_sym_bytes12] = ACTIONS(640),
    [anon_sym_bytes13] = ACTIONS(640),
    [anon_sym_bytes14] = ACTIONS(640),
    [anon_sym_bytes15] = ACTIONS(640),
    [anon_sym_bytes16] = ACTIONS(640),
    [anon_sym_bytes17] = ACTIONS(640),
    [anon_sym_bytes18] = ACTIONS(640),
    [anon_sym_bytes19] = ACTIONS(640),
    [anon_sym_bytes20] = ACTIONS(640),
    [anon_sym_bytes21] = ACTIONS(640),
    [anon_sym_bytes22] = ACTIONS(640),
    [anon_sym_bytes23] = ACTIONS(640),
    [anon_sym_bytes24] = ACTIONS(640),
    [anon_sym_bytes25] = ACTIONS(640),
    [anon_sym_bytes26] = ACTIONS(640),
    [anon_sym_bytes27] = ACTIONS(640),
    [anon_sym_bytes28] = ACTIONS(640),
    [anon_sym_bytes29] = ACTIONS(640),
    [anon_sym_bytes30] = ACTIONS(640),
    [anon_sym_bytes31] = ACTIONS(640),
    [anon_sym_bytes32] = ACTIONS(640),
    [anon_sym_fixed] = ACTIONS(640),
    [aux_sym__fixed_token1] = ACTIONS(640),
    [anon_sym_ufixed] = ACTIONS(640),
    [aux_sym__ufixed_token1] = ACTIONS(640),
    [sym_comment] = ACTIONS(3),
  },
  [209] = {
    [sym_identifier] = ACTIONS(632),
    [anon_sym_RBRACE] = ACTIONS(630),
    [anon_sym_type] = ACTIONS(632),
    [anon_sym_error] = ACTIONS(632),
    [anon_sym_struct] = ACTIONS(632),
    [anon_sym_enum] = ACTIONS(632),
    [anon_sym_event] = ACTIONS(632),
    [anon_sym_using] = ACTIONS(632),
    [anon_sym_function] = ACTIONS(632),
    [anon_sym_byte] = ACTIONS(632),
    [anon_sym_address] = ACTIONS(632),
    [anon_sym_var] = ACTIONS(632),
    [anon_sym_modifier] = ACTIONS(632),
    [anon_sym_constructor] = ACTIONS(632),
    [anon_sym_fallback] = ACTIONS(632),
    [anon_sym_receive] = ACTIONS(632),
    [anon_sym_mapping] = ACTIONS(632),
    [anon_sym_bool] = ACTIONS(632),
    [anon_sym_string] = ACTIONS(632),
    [anon_sym_int] = ACTIONS(632),
    [anon_sym_int8] = ACTIONS(632),
    [anon_sym_int16] = ACTIONS(632),
    [anon_sym_int24] = ACTIONS(632),
    [anon_sym_int32] = ACTIONS(632),
    [anon_sym_int40] = ACTIONS(632),
    [anon_sym_int48] = ACTIONS(632),
    [anon_sym_int56] = ACTIONS(632),
    [anon_sym_int64] = ACTIONS(632),
    [anon_sym_int72] = ACTIONS(632),
    [anon_sym_int80] = ACTIONS(632),
    [anon_sym_int88] = ACTIONS(632),
    [anon_sym_int96] = ACTIONS(632),
    [anon_sym_int104] = ACTIONS(632),
    [anon_sym_int112] = ACTIONS(632),
    [anon_sym_int120] = ACTIONS(632),
    [anon_sym_int128] = ACTIONS(632),
    [anon_sym_int136] = ACTIONS(632),
    [anon_sym_int144] = ACTIONS(632),
    [anon_sym_int152] = ACTIONS(632),
    [anon_sym_int160] = ACTIONS(632),
    [anon_sym_int168] = ACTIONS(632),
    [anon_sym_int176] = ACTIONS(632),
    [anon_sym_int184] = ACTIONS(632),
    [anon_sym_int192] = ACTIONS(632),
    [anon_sym_int200] = ACTIONS(632),
    [anon_sym_int208] = ACTIONS(632),
    [anon_sym_int216] = ACTIONS(632),
    [anon_sym_int224] = ACTIONS(632),
    [anon_sym_int232] = ACTIONS(632),
    [anon_sym_int240] = ACTIONS(632),
    [anon_sym_int248] = ACTIONS(632),
    [anon_sym_int256] = ACTIONS(632),
    [anon_sym_uint] = ACTIONS(632),
    [anon_sym_uint8] = ACTIONS(632),
    [anon_sym_uint16] = ACTIONS(632),
    [anon_sym_uint24] = ACTIONS(632),
    [anon_sym_uint32] = ACTIONS(632),
    [anon_sym_uint40] = ACTIONS(632),
    [anon_sym_uint48] = ACTIONS(632),
    [anon_sym_uint56] = ACTIONS(632),
    [anon_sym_uint64] = ACTIONS(632),
    [anon_sym_uint72] = ACTIONS(632),
    [anon_sym_uint80] = ACTIONS(632),
    [anon_sym_uint88] = ACTIONS(632),
    [anon_sym_uint96] = ACTIONS(632),
    [anon_sym_uint104] = ACTIONS(632),
    [anon_sym_uint112] = ACTIONS(632),
    [anon_sym_uint120] = ACTIONS(632),
    [anon_sym_uint128] = ACTIONS(632),
    [anon_sym_uint136] = ACTIONS(632),
    [anon_sym_uint144] = ACTIONS(632),
    [anon_sym_uint152] = ACTIONS(632),
    [anon_sym_uint160] = ACTIONS(632),
    [anon_sym_uint168] = ACTIONS(632),
    [anon_sym_uint176] = ACTIONS(632),
    [anon_sym_uint184] = ACTIONS(632),
    [anon_sym_uint192] = ACTIONS(632),
    [anon_sym_uint200] = ACTIONS(632),
    [anon_sym_uint208] = ACTIONS(632),
    [anon_sym_uint216] = ACTIONS(632),
    [anon_sym_uint224] = ACTIONS(632),
    [anon_sym_uint232] = ACTIONS(632),
    [anon_sym_uint240] = ACTIONS(632),
    [anon_sym_uint248] = ACTIONS(632),
    [anon_sym_uint256] = ACTIONS(632),
    [anon_sym_bytes] = ACTIONS(632),
    [anon_sym_bytes1] = ACTIONS(632),
    [anon_sym_bytes2] = ACTIONS(632),
    [anon_sym_bytes3] = ACTIONS(632),
    [anon_sym_bytes4] = ACTIONS(632),
    [anon_sym_bytes5] = ACTIONS(632),
    [anon_sym_bytes6] = ACTIONS(632),
    [anon_sym_bytes7] = ACTIONS(632),
    [anon_sym_bytes8] = ACTIONS(632),
    [anon_sym_bytes9] = ACTIONS(632),
    [anon_sym_bytes10] = ACTIONS(632),
    [anon_sym_bytes11] = ACTIONS(632),
    [anon_sym_bytes12] = ACTIONS(632),
    [anon_sym_bytes13] = ACTIONS(632),
    [anon_sym_bytes14] = ACTIONS(632),
    [anon_sym_bytes15] = ACTIONS(632),
    [anon_sym_bytes16] = ACTIONS(632),
    [anon_sym_bytes17] = ACTIONS(632),
    [anon_sym_bytes18] = ACTIONS(632),
    [anon_sym_bytes19] = ACTIONS(632),
    [anon_sym_bytes20] = ACTIONS(632),
    [anon_sym_bytes21] = ACTIONS(632),
    [anon_sym_bytes22] = ACTIONS(632),
    [anon_sym_bytes23] = ACTIONS(632),
    [anon_sym_bytes24] = ACTIONS(632),
    [anon_sym_bytes25] = ACTIONS(632),
    [anon_sym_bytes26] = ACTIONS(632),
    [anon_sym_bytes27] = ACTIONS(632),
    [anon_sym_bytes28] = ACTIONS(632),
    [anon_sym_bytes29] = ACTIONS(632),
    [anon_sym_bytes30] = ACTIONS(632),
    [anon_sym_bytes31] = ACTIONS(632),
    [anon_sym_bytes32] = ACTIONS(632),
    [anon_sym_fixed] = ACTIONS(632),
    [aux_sym__fixed_token1] = ACTIONS(632),
    [anon_sym_ufixed] = ACTIONS(632),
    [aux_sym__ufixed_token1] = ACTIONS(632),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_identifier] = ACTIONS(820),
    [anon_sym_RBRACE] = ACTIONS(822),
    [anon_sym_type] = ACTIONS(820),
    [anon_sym_error] = ACTIONS(820),
    [anon_sym_struct] = ACTIONS(820),
    [anon_sym_enum] = ACTIONS(820),
    [anon_sym_event] = ACTIONS(820),
    [anon_sym_using] = ACTIONS(820),
    [anon_sym_function] = ACTIONS(820),
    [anon_sym_byte] = ACTIONS(820),
    [anon_sym_address] = ACTIONS(820),
    [anon_sym_var] = ACTIONS(820),
    [anon_sym_modifier] = ACTIONS(820),
    [anon_sym_constructor] = ACTIONS(820),
    [anon_sym_fallback] = ACTIONS(820),
    [anon_sym_receive] = ACTIONS(820),
    [anon_sym_mapping] = ACTIONS(820),
    [anon_sym_bool] = ACTIONS(820),
    [anon_sym_string] = ACTIONS(820),
    [anon_sym_int] = ACTIONS(820),
    [anon_sym_int8] = ACTIONS(820),
    [anon_sym_int16] = ACTIONS(820),
    [anon_sym_int24] = ACTIONS(820),
    [anon_sym_int32] = ACTIONS(820),
    [anon_sym_int40] = ACTIONS(820),
    [anon_sym_int48] = ACTIONS(820),
    [anon_sym_int56] = ACTIONS(820),
    [anon_sym_int64] = ACTIONS(820),
    [anon_sym_int72] = ACTIONS(820),
    [anon_sym_int80] = ACTIONS(820),
    [anon_sym_int88] = ACTIONS(820),
    [anon_sym_int96] = ACTIONS(820),
    [anon_sym_int104] = ACTIONS(820),
    [anon_sym_int112] = ACTIONS(820),
    [anon_sym_int120] = ACTIONS(820),
    [anon_sym_int128] = ACTIONS(820),
    [anon_sym_int136] = ACTIONS(820),
    [anon_sym_int144] = ACTIONS(820),
    [anon_sym_int152] = ACTIONS(820),
    [anon_sym_int160] = ACTIONS(820),
    [anon_sym_int168] = ACTIONS(820),
    [anon_sym_int176] = ACTIONS(820),
    [anon_sym_int184] = ACTIONS(820),
    [anon_sym_int192] = ACTIONS(820),
    [anon_sym_int200] = ACTIONS(820),
    [anon_sym_int208] = ACTIONS(820),
    [anon_sym_int216] = ACTIONS(820),
    [anon_sym_int224] = ACTIONS(820),
    [anon_sym_int232] = ACTIONS(820),
    [anon_sym_int240] = ACTIONS(820),
    [anon_sym_int248] = ACTIONS(820),
    [anon_sym_int256] = ACTIONS(820),
    [anon_sym_uint] = ACTIONS(820),
    [anon_sym_uint8] = ACTIONS(820),
    [anon_sym_uint16] = ACTIONS(820),
    [anon_sym_uint24] = ACTIONS(820),
    [anon_sym_uint32] = ACTIONS(820),
    [anon_sym_uint40] = ACTIONS(820),
    [anon_sym_uint48] = ACTIONS(820),
    [anon_sym_uint56] = ACTIONS(820),
    [anon_sym_uint64] = ACTIONS(820),
    [anon_sym_uint72] = ACTIONS(820),
    [anon_sym_uint80] = ACTIONS(820),
    [anon_sym_uint88] = ACTIONS(820),
    [anon_sym_uint96] = ACTIONS(820),
    [anon_sym_uint104] = ACTIONS(820),
    [anon_sym_uint112] = ACTIONS(820),
    [anon_sym_uint120] = ACTIONS(820),
    [anon_sym_uint128] = ACTIONS(820),
    [anon_sym_uint136] = ACTIONS(820),
    [anon_sym_uint144] = ACTIONS(820),
    [anon_sym_uint152] = ACTIONS(820),
    [anon_sym_uint160] = ACTIONS(820),
    [anon_sym_uint168] = ACTIONS(820),
    [anon_sym_uint176] = ACTIONS(820),
    [anon_sym_uint184] = ACTIONS(820),
    [anon_sym_uint192] = ACTIONS(820),
    [anon_sym_uint200] = ACTIONS(820),
    [anon_sym_uint208] = ACTIONS(820),
    [anon_sym_uint216] = ACTIONS(820),
    [anon_sym_uint224] = ACTIONS(820),
    [anon_sym_uint232] = ACTIONS(820),
    [anon_sym_uint240] = ACTIONS(820),
    [anon_sym_uint248] = ACTIONS(820),
    [anon_sym_uint256] = ACTIONS(820),
    [anon_sym_bytes] = ACTIONS(820),
    [anon_sym_bytes1] = ACTIONS(820),
    [anon_sym_bytes2] = ACTIONS(820),
    [anon_sym_bytes3] = ACTIONS(820),
    [anon_sym_bytes4] = ACTIONS(820),
    [anon_sym_bytes5] = ACTIONS(820),
    [anon_sym_bytes6] = ACTIONS(820),
    [anon_sym_bytes7] = ACTIONS(820),
    [anon_sym_bytes8] = ACTIONS(820),
    [anon_sym_bytes9] = ACTIONS(820),
    [anon_sym_bytes10] = ACTIONS(820),
    [anon_sym_bytes11] = ACTIONS(820),
    [anon_sym_bytes12] = ACTIONS(820),
    [anon_sym_bytes13] = ACTIONS(820),
    [anon_sym_bytes14] = ACTIONS(820),
    [anon_sym_bytes15] = ACTIONS(820),
    [anon_sym_bytes16] = ACTIONS(820),
    [anon_sym_bytes17] = ACTIONS(820),
    [anon_sym_bytes18] = ACTIONS(820),
    [anon_sym_bytes19] = ACTIONS(820),
    [anon_sym_bytes20] = ACTIONS(820),
    [anon_sym_bytes21] = ACTIONS(820),
    [anon_sym_bytes22] = ACTIONS(820),
    [anon_sym_bytes23] = ACTIONS(820),
    [anon_sym_bytes24] = ACTIONS(820),
    [anon_sym_bytes25] = ACTIONS(820),
    [anon_sym_bytes26] = ACTIONS(820),
    [anon_sym_bytes27] = ACTIONS(820),
    [anon_sym_bytes28] = ACTIONS(820),
    [anon_sym_bytes29] = ACTIONS(820),
    [anon_sym_bytes30] = ACTIONS(820),
    [anon_sym_bytes31] = ACTIONS(820),
    [anon_sym_bytes32] = ACTIONS(820),
    [anon_sym_fixed] = ACTIONS(820),
    [aux_sym__fixed_token1] = ACTIONS(820),
    [anon_sym_ufixed] = ACTIONS(820),
    [aux_sym__ufixed_token1] = ACTIONS(820),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_identifier] = ACTIONS(628),
    [anon_sym_RBRACE] = ACTIONS(626),
    [anon_sym_type] = ACTIONS(628),
    [anon_sym_error] = ACTIONS(628),
    [anon_sym_struct] = ACTIONS(628),
    [anon_sym_enum] = ACTIONS(628),
    [anon_sym_event] = ACTIONS(628),
    [anon_sym_using] = ACTIONS(628),
    [anon_sym_function] = ACTIONS(628),
    [anon_sym_byte] = ACTIONS(628),
    [anon_sym_address] = ACTIONS(628),
    [anon_sym_var] = ACTIONS(628),
    [anon_sym_modifier] = ACTIONS(628),
    [anon_sym_constructor] = ACTIONS(628),
    [anon_sym_fallback] = ACTIONS(628),
    [anon_sym_receive] = ACTIONS(628),
    [anon_sym_mapping] = ACTIONS(628),
    [anon_sym_bool] = ACTIONS(628),
    [anon_sym_string] = ACTIONS(628),
    [anon_sym_int] = ACTIONS(628),
    [anon_sym_int8] = ACTIONS(628),
    [anon_sym_int16] = ACTIONS(628),
    [anon_sym_int24] = ACTIONS(628),
    [anon_sym_int32] = ACTIONS(628),
    [anon_sym_int40] = ACTIONS(628),
    [anon_sym_int48] = ACTIONS(628),
    [anon_sym_int56] = ACTIONS(628),
    [anon_sym_int64] = ACTIONS(628),
    [anon_sym_int72] = ACTIONS(628),
    [anon_sym_int80] = ACTIONS(628),
    [anon_sym_int88] = ACTIONS(628),
    [anon_sym_int96] = ACTIONS(628),
    [anon_sym_int104] = ACTIONS(628),
    [anon_sym_int112] = ACTIONS(628),
    [anon_sym_int120] = ACTIONS(628),
    [anon_sym_int128] = ACTIONS(628),
    [anon_sym_int136] = ACTIONS(628),
    [anon_sym_int144] = ACTIONS(628),
    [anon_sym_int152] = ACTIONS(628),
    [anon_sym_int160] = ACTIONS(628),
    [anon_sym_int168] = ACTIONS(628),
    [anon_sym_int176] = ACTIONS(628),
    [anon_sym_int184] = ACTIONS(628),
    [anon_sym_int192] = ACTIONS(628),
    [anon_sym_int200] = ACTIONS(628),
    [anon_sym_int208] = ACTIONS(628),
    [anon_sym_int216] = ACTIONS(628),
    [anon_sym_int224] = ACTIONS(628),
    [anon_sym_int232] = ACTIONS(628),
    [anon_sym_int240] = ACTIONS(628),
    [anon_sym_int248] = ACTIONS(628),
    [anon_sym_int256] = ACTIONS(628),
    [anon_sym_uint] = ACTIONS(628),
    [anon_sym_uint8] = ACTIONS(628),
    [anon_sym_uint16] = ACTIONS(628),
    [anon_sym_uint24] = ACTIONS(628),
    [anon_sym_uint32] = ACTIONS(628),
    [anon_sym_uint40] = ACTIONS(628),
    [anon_sym_uint48] = ACTIONS(628),
    [anon_sym_uint56] = ACTIONS(628),
    [anon_sym_uint64] = ACTIONS(628),
    [anon_sym_uint72] = ACTIONS(628),
    [anon_sym_uint80] = ACTIONS(628),
    [anon_sym_uint88] = ACTIONS(628),
    [anon_sym_uint96] = ACTIONS(628),
    [anon_sym_uint104] = ACTIONS(628),
    [anon_sym_uint112] = ACTIONS(628),
    [anon_sym_uint120] = ACTIONS(628),
    [anon_sym_uint128] = ACTIONS(628),
    [anon_sym_uint136] = ACTIONS(628),
    [anon_sym_uint144] = ACTIONS(628),
    [anon_sym_uint152] = ACTIONS(628),
    [anon_sym_uint160] = ACTIONS(628),
    [anon_sym_uint168] = ACTIONS(628),
    [anon_sym_uint176] = ACTIONS(628),
    [anon_sym_uint184] = ACTIONS(628),
    [anon_sym_uint192] = ACTIONS(628),
    [anon_sym_uint200] = ACTIONS(628),
    [anon_sym_uint208] = ACTIONS(628),
    [anon_sym_uint216] = ACTIONS(628),
    [anon_sym_uint224] = ACTIONS(628),
    [anon_sym_uint232] = ACTIONS(628),
    [anon_sym_uint240] = ACTIONS(628),
    [anon_sym_uint248] = ACTIONS(628),
    [anon_sym_uint256] = ACTIONS(628),
    [anon_sym_bytes] = ACTIONS(628),
    [anon_sym_bytes1] = ACTIONS(628),
    [anon_sym_bytes2] = ACTIONS(628),
    [anon_sym_bytes3] = ACTIONS(628),
    [anon_sym_bytes4] = ACTIONS(628),
    [anon_sym_bytes5] = ACTIONS(628),
    [anon_sym_bytes6] = ACTIONS(628),
    [anon_sym_bytes7] = ACTIONS(628),
    [anon_sym_bytes8] = ACTIONS(628),
    [anon_sym_bytes9] = ACTIONS(628),
    [anon_sym_bytes10] = ACTIONS(628),
    [anon_sym_bytes11] = ACTIONS(628),
    [anon_sym_bytes12] = ACTIONS(628),
    [anon_sym_bytes13] = ACTIONS(628),
    [anon_sym_bytes14] = ACTIONS(628),
    [anon_sym_bytes15] = ACTIONS(628),
    [anon_sym_bytes16] = ACTIONS(628),
    [anon_sym_bytes17] = ACTIONS(628),
    [anon_sym_bytes18] = ACTIONS(628),
    [anon_sym_bytes19] = ACTIONS(628),
    [anon_sym_bytes20] = ACTIONS(628),
    [anon_sym_bytes21] = ACTIONS(628),
    [anon_sym_bytes22] = ACTIONS(628),
    [anon_sym_bytes23] = ACTIONS(628),
    [anon_sym_bytes24] = ACTIONS(628),
    [anon_sym_bytes25] = ACTIONS(628),
    [anon_sym_bytes26] = ACTIONS(628),
    [anon_sym_bytes27] = ACTIONS(628),
    [anon_sym_bytes28] = ACTIONS(628),
    [anon_sym_bytes29] = ACTIONS(628),
    [anon_sym_bytes30] = ACTIONS(628),
    [anon_sym_bytes31] = ACTIONS(628),
    [anon_sym_bytes32] = ACTIONS(628),
    [anon_sym_fixed] = ACTIONS(628),
    [aux_sym__fixed_token1] = ACTIONS(628),
    [anon_sym_ufixed] = ACTIONS(628),
    [aux_sym__ufixed_token1] = ACTIONS(628),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_identifier] = ACTIONS(608),
    [anon_sym_RBRACE] = ACTIONS(606),
    [anon_sym_type] = ACTIONS(608),
    [anon_sym_error] = ACTIONS(608),
    [anon_sym_struct] = ACTIONS(608),
    [anon_sym_enum] = ACTIONS(608),
    [anon_sym_event] = ACTIONS(608),
    [anon_sym_using] = ACTIONS(608),
    [anon_sym_function] = ACTIONS(608),
    [anon_sym_byte] = ACTIONS(608),
    [anon_sym_address] = ACTIONS(608),
    [anon_sym_var] = ACTIONS(608),
    [anon_sym_modifier] = ACTIONS(608),
    [anon_sym_constructor] = ACTIONS(608),
    [anon_sym_fallback] = ACTIONS(608),
    [anon_sym_receive] = ACTIONS(608),
    [anon_sym_mapping] = ACTIONS(608),
    [anon_sym_bool] = ACTIONS(608),
    [anon_sym_string] = ACTIONS(608),
    [anon_sym_int] = ACTIONS(608),
    [anon_sym_int8] = ACTIONS(608),
    [anon_sym_int16] = ACTIONS(608),
    [anon_sym_int24] = ACTIONS(608),
    [anon_sym_int32] = ACTIONS(608),
    [anon_sym_int40] = ACTIONS(608),
    [anon_sym_int48] = ACTIONS(608),
    [anon_sym_int56] = ACTIONS(608),
    [anon_sym_int64] = ACTIONS(608),
    [anon_sym_int72] = ACTIONS(608),
    [anon_sym_int80] = ACTIONS(608),
    [anon_sym_int88] = ACTIONS(608),
    [anon_sym_int96] = ACTIONS(608),
    [anon_sym_int104] = ACTIONS(608),
    [anon_sym_int112] = ACTIONS(608),
    [anon_sym_int120] = ACTIONS(608),
    [anon_sym_int128] = ACTIONS(608),
    [anon_sym_int136] = ACTIONS(608),
    [anon_sym_int144] = ACTIONS(608),
    [anon_sym_int152] = ACTIONS(608),
    [anon_sym_int160] = ACTIONS(608),
    [anon_sym_int168] = ACTIONS(608),
    [anon_sym_int176] = ACTIONS(608),
    [anon_sym_int184] = ACTIONS(608),
    [anon_sym_int192] = ACTIONS(608),
    [anon_sym_int200] = ACTIONS(608),
    [anon_sym_int208] = ACTIONS(608),
    [anon_sym_int216] = ACTIONS(608),
    [anon_sym_int224] = ACTIONS(608),
    [anon_sym_int232] = ACTIONS(608),
    [anon_sym_int240] = ACTIONS(608),
    [anon_sym_int248] = ACTIONS(608),
    [anon_sym_int256] = ACTIONS(608),
    [anon_sym_uint] = ACTIONS(608),
    [anon_sym_uint8] = ACTIONS(608),
    [anon_sym_uint16] = ACTIONS(608),
    [anon_sym_uint24] = ACTIONS(608),
    [anon_sym_uint32] = ACTIONS(608),
    [anon_sym_uint40] = ACTIONS(608),
    [anon_sym_uint48] = ACTIONS(608),
    [anon_sym_uint56] = ACTIONS(608),
    [anon_sym_uint64] = ACTIONS(608),
    [anon_sym_uint72] = ACTIONS(608),
    [anon_sym_uint80] = ACTIONS(608),
    [anon_sym_uint88] = ACTIONS(608),
    [anon_sym_uint96] = ACTIONS(608),
    [anon_sym_uint104] = ACTIONS(608),
    [anon_sym_uint112] = ACTIONS(608),
    [anon_sym_uint120] = ACTIONS(608),
    [anon_sym_uint128] = ACTIONS(608),
    [anon_sym_uint136] = ACTIONS(608),
    [anon_sym_uint144] = ACTIONS(608),
    [anon_sym_uint152] = ACTIONS(608),
    [anon_sym_uint160] = ACTIONS(608),
    [anon_sym_uint168] = ACTIONS(608),
    [anon_sym_uint176] = ACTIONS(608),
    [anon_sym_uint184] = ACTIONS(608),
    [anon_sym_uint192] = ACTIONS(608),
    [anon_sym_uint200] = ACTIONS(608),
    [anon_sym_uint208] = ACTIONS(608),
    [anon_sym_uint216] = ACTIONS(608),
    [anon_sym_uint224] = ACTIONS(608),
    [anon_sym_uint232] = ACTIONS(608),
    [anon_sym_uint240] = ACTIONS(608),
    [anon_sym_uint248] = ACTIONS(608),
    [anon_sym_uint256] = ACTIONS(608),
    [anon_sym_bytes] = ACTIONS(608),
    [anon_sym_bytes1] = ACTIONS(608),
    [anon_sym_bytes2] = ACTIONS(608),
    [anon_sym_bytes3] = ACTIONS(608),
    [anon_sym_bytes4] = ACTIONS(608),
    [anon_sym_bytes5] = ACTIONS(608),
    [anon_sym_bytes6] = ACTIONS(608),
    [anon_sym_bytes7] = ACTIONS(608),
    [anon_sym_bytes8] = ACTIONS(608),
    [anon_sym_bytes9] = ACTIONS(608),
    [anon_sym_bytes10] = ACTIONS(608),
    [anon_sym_bytes11] = ACTIONS(608),
    [anon_sym_bytes12] = ACTIONS(608),
    [anon_sym_bytes13] = ACTIONS(608),
    [anon_sym_bytes14] = ACTIONS(608),
    [anon_sym_bytes15] = ACTIONS(608),
    [anon_sym_bytes16] = ACTIONS(608),
    [anon_sym_bytes17] = ACTIONS(608),
    [anon_sym_bytes18] = ACTIONS(608),
    [anon_sym_bytes19] = ACTIONS(608),
    [anon_sym_bytes20] = ACTIONS(608),
    [anon_sym_bytes21] = ACTIONS(608),
    [anon_sym_bytes22] = ACTIONS(608),
    [anon_sym_bytes23] = ACTIONS(608),
    [anon_sym_bytes24] = ACTIONS(608),
    [anon_sym_bytes25] = ACTIONS(608),
    [anon_sym_bytes26] = ACTIONS(608),
    [anon_sym_bytes27] = ACTIONS(608),
    [anon_sym_bytes28] = ACTIONS(608),
    [anon_sym_bytes29] = ACTIONS(608),
    [anon_sym_bytes30] = ACTIONS(608),
    [anon_sym_bytes31] = ACTIONS(608),
    [anon_sym_bytes32] = ACTIONS(608),
    [anon_sym_fixed] = ACTIONS(608),
    [aux_sym__fixed_token1] = ACTIONS(608),
    [anon_sym_ufixed] = ACTIONS(608),
    [aux_sym__ufixed_token1] = ACTIONS(608),
    [sym_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_identifier] = ACTIONS(722),
    [anon_sym_RBRACE] = ACTIONS(720),
    [anon_sym_type] = ACTIONS(722),
    [anon_sym_error] = ACTIONS(722),
    [anon_sym_struct] = ACTIONS(722),
    [anon_sym_enum] = ACTIONS(722),
    [anon_sym_event] = ACTIONS(722),
    [anon_sym_using] = ACTIONS(722),
    [anon_sym_function] = ACTIONS(722),
    [anon_sym_byte] = ACTIONS(722),
    [anon_sym_address] = ACTIONS(722),
    [anon_sym_var] = ACTIONS(722),
    [anon_sym_modifier] = ACTIONS(722),
    [anon_sym_constructor] = ACTIONS(722),
    [anon_sym_fallback] = ACTIONS(722),
    [anon_sym_receive] = ACTIONS(722),
    [anon_sym_mapping] = ACTIONS(722),
    [anon_sym_bool] = ACTIONS(722),
    [anon_sym_string] = ACTIONS(722),
    [anon_sym_int] = ACTIONS(722),
    [anon_sym_int8] = ACTIONS(722),
    [anon_sym_int16] = ACTIONS(722),
    [anon_sym_int24] = ACTIONS(722),
    [anon_sym_int32] = ACTIONS(722),
    [anon_sym_int40] = ACTIONS(722),
    [anon_sym_int48] = ACTIONS(722),
    [anon_sym_int56] = ACTIONS(722),
    [anon_sym_int64] = ACTIONS(722),
    [anon_sym_int72] = ACTIONS(722),
    [anon_sym_int80] = ACTIONS(722),
    [anon_sym_int88] = ACTIONS(722),
    [anon_sym_int96] = ACTIONS(722),
    [anon_sym_int104] = ACTIONS(722),
    [anon_sym_int112] = ACTIONS(722),
    [anon_sym_int120] = ACTIONS(722),
    [anon_sym_int128] = ACTIONS(722),
    [anon_sym_int136] = ACTIONS(722),
    [anon_sym_int144] = ACTIONS(722),
    [anon_sym_int152] = ACTIONS(722),
    [anon_sym_int160] = ACTIONS(722),
    [anon_sym_int168] = ACTIONS(722),
    [anon_sym_int176] = ACTIONS(722),
    [anon_sym_int184] = ACTIONS(722),
    [anon_sym_int192] = ACTIONS(722),
    [anon_sym_int200] = ACTIONS(722),
    [anon_sym_int208] = ACTIONS(722),
    [anon_sym_int216] = ACTIONS(722),
    [anon_sym_int224] = ACTIONS(722),
    [anon_sym_int232] = ACTIONS(722),
    [anon_sym_int240] = ACTIONS(722),
    [anon_sym_int248] = ACTIONS(722),
    [anon_sym_int256] = ACTIONS(722),
    [anon_sym_uint] = ACTIONS(722),
    [anon_sym_uint8] = ACTIONS(722),
    [anon_sym_uint16] = ACTIONS(722),
    [anon_sym_uint24] = ACTIONS(722),
    [anon_sym_uint32] = ACTIONS(722),
    [anon_sym_uint40] = ACTIONS(722),
    [anon_sym_uint48] = ACTIONS(722),
    [anon_sym_uint56] = ACTIONS(722),
    [anon_sym_uint64] = ACTIONS(722),
    [anon_sym_uint72] = ACTIONS(722),
    [anon_sym_uint80] = ACTIONS(722),
    [anon_sym_uint88] = ACTIONS(722),
    [anon_sym_uint96] = ACTIONS(722),
    [anon_sym_uint104] = ACTIONS(722),
    [anon_sym_uint112] = ACTIONS(722),
    [anon_sym_uint120] = ACTIONS(722),
    [anon_sym_uint128] = ACTIONS(722),
    [anon_sym_uint136] = ACTIONS(722),
    [anon_sym_uint144] = ACTIONS(722),
    [anon_sym_uint152] = ACTIONS(722),
    [anon_sym_uint160] = ACTIONS(722),
    [anon_sym_uint168] = ACTIONS(722),
    [anon_sym_uint176] = ACTIONS(722),
    [anon_sym_uint184] = ACTIONS(722),
    [anon_sym_uint192] = ACTIONS(722),
    [anon_sym_uint200] = ACTIONS(722),
    [anon_sym_uint208] = ACTIONS(722),
    [anon_sym_uint216] = ACTIONS(722),
    [anon_sym_uint224] = ACTIONS(722),
    [anon_sym_uint232] = ACTIONS(722),
    [anon_sym_uint240] = ACTIONS(722),
    [anon_sym_uint248] = ACTIONS(722),
    [anon_sym_uint256] = ACTIONS(722),
    [anon_sym_bytes] = ACTIONS(722),
    [anon_sym_bytes1] = ACTIONS(722),
    [anon_sym_bytes2] = ACTIONS(722),
    [anon_sym_bytes3] = ACTIONS(722),
    [anon_sym_bytes4] = ACTIONS(722),
    [anon_sym_bytes5] = ACTIONS(722),
    [anon_sym_bytes6] = ACTIONS(722),
    [anon_sym_bytes7] = ACTIONS(722),
    [anon_sym_bytes8] = ACTIONS(722),
    [anon_sym_bytes9] = ACTIONS(722),
    [anon_sym_bytes10] = ACTIONS(722),
    [anon_sym_bytes11] = ACTIONS(722),
    [anon_sym_bytes12] = ACTIONS(722),
    [anon_sym_bytes13] = ACTIONS(722),
    [anon_sym_bytes14] = ACTIONS(722),
    [anon_sym_bytes15] = ACTIONS(722),
    [anon_sym_bytes16] = ACTIONS(722),
    [anon_sym_bytes17] = ACTIONS(722),
    [anon_sym_bytes18] = ACTIONS(722),
    [anon_sym_bytes19] = ACTIONS(722),
    [anon_sym_bytes20] = ACTIONS(722),
    [anon_sym_bytes21] = ACTIONS(722),
    [anon_sym_bytes22] = ACTIONS(722),
    [anon_sym_bytes23] = ACTIONS(722),
    [anon_sym_bytes24] = ACTIONS(722),
    [anon_sym_bytes25] = ACTIONS(722),
    [anon_sym_bytes26] = ACTIONS(722),
    [anon_sym_bytes27] = ACTIONS(722),
    [anon_sym_bytes28] = ACTIONS(722),
    [anon_sym_bytes29] = ACTIONS(722),
    [anon_sym_bytes30] = ACTIONS(722),
    [anon_sym_bytes31] = ACTIONS(722),
    [anon_sym_bytes32] = ACTIONS(722),
    [anon_sym_fixed] = ACTIONS(722),
    [aux_sym__fixed_token1] = ACTIONS(722),
    [anon_sym_ufixed] = ACTIONS(722),
    [aux_sym__ufixed_token1] = ACTIONS(722),
    [sym_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_identifier] = ACTIONS(754),
    [anon_sym_RBRACE] = ACTIONS(752),
    [anon_sym_type] = ACTIONS(754),
    [anon_sym_error] = ACTIONS(754),
    [anon_sym_struct] = ACTIONS(754),
    [anon_sym_enum] = ACTIONS(754),
    [anon_sym_event] = ACTIONS(754),
    [anon_sym_using] = ACTIONS(754),
    [anon_sym_function] = ACTIONS(754),
    [anon_sym_byte] = ACTIONS(754),
    [anon_sym_address] = ACTIONS(754),
    [anon_sym_var] = ACTIONS(754),
    [anon_sym_modifier] = ACTIONS(754),
    [anon_sym_constructor] = ACTIONS(754),
    [anon_sym_fallback] = ACTIONS(754),
    [anon_sym_receive] = ACTIONS(754),
    [anon_sym_mapping] = ACTIONS(754),
    [anon_sym_bool] = ACTIONS(754),
    [anon_sym_string] = ACTIONS(754),
    [anon_sym_int] = ACTIONS(754),
    [anon_sym_int8] = ACTIONS(754),
    [anon_sym_int16] = ACTIONS(754),
    [anon_sym_int24] = ACTIONS(754),
    [anon_sym_int32] = ACTIONS(754),
    [anon_sym_int40] = ACTIONS(754),
    [anon_sym_int48] = ACTIONS(754),
    [anon_sym_int56] = ACTIONS(754),
    [anon_sym_int64] = ACTIONS(754),
    [anon_sym_int72] = ACTIONS(754),
    [anon_sym_int80] = ACTIONS(754),
    [anon_sym_int88] = ACTIONS(754),
    [anon_sym_int96] = ACTIONS(754),
    [anon_sym_int104] = ACTIONS(754),
    [anon_sym_int112] = ACTIONS(754),
    [anon_sym_int120] = ACTIONS(754),
    [anon_sym_int128] = ACTIONS(754),
    [anon_sym_int136] = ACTIONS(754),
    [anon_sym_int144] = ACTIONS(754),
    [anon_sym_int152] = ACTIONS(754),
    [anon_sym_int160] = ACTIONS(754),
    [anon_sym_int168] = ACTIONS(754),
    [anon_sym_int176] = ACTIONS(754),
    [anon_sym_int184] = ACTIONS(754),
    [anon_sym_int192] = ACTIONS(754),
    [anon_sym_int200] = ACTIONS(754),
    [anon_sym_int208] = ACTIONS(754),
    [anon_sym_int216] = ACTIONS(754),
    [anon_sym_int224] = ACTIONS(754),
    [anon_sym_int232] = ACTIONS(754),
    [anon_sym_int240] = ACTIONS(754),
    [anon_sym_int248] = ACTIONS(754),
    [anon_sym_int256] = ACTIONS(754),
    [anon_sym_uint] = ACTIONS(754),
    [anon_sym_uint8] = ACTIONS(754),
    [anon_sym_uint16] = ACTIONS(754),
    [anon_sym_uint24] = ACTIONS(754),
    [anon_sym_uint32] = ACTIONS(754),
    [anon_sym_uint40] = ACTIONS(754),
    [anon_sym_uint48] = ACTIONS(754),
    [anon_sym_uint56] = ACTIONS(754),
    [anon_sym_uint64] = ACTIONS(754),
    [anon_sym_uint72] = ACTIONS(754),
    [anon_sym_uint80] = ACTIONS(754),
    [anon_sym_uint88] = ACTIONS(754),
    [anon_sym_uint96] = ACTIONS(754),
    [anon_sym_uint104] = ACTIONS(754),
    [anon_sym_uint112] = ACTIONS(754),
    [anon_sym_uint120] = ACTIONS(754),
    [anon_sym_uint128] = ACTIONS(754),
    [anon_sym_uint136] = ACTIONS(754),
    [anon_sym_uint144] = ACTIONS(754),
    [anon_sym_uint152] = ACTIONS(754),
    [anon_sym_uint160] = ACTIONS(754),
    [anon_sym_uint168] = ACTIONS(754),
    [anon_sym_uint176] = ACTIONS(754),
    [anon_sym_uint184] = ACTIONS(754),
    [anon_sym_uint192] = ACTIONS(754),
    [anon_sym_uint200] = ACTIONS(754),
    [anon_sym_uint208] = ACTIONS(754),
    [anon_sym_uint216] = ACTIONS(754),
    [anon_sym_uint224] = ACTIONS(754),
    [anon_sym_uint232] = ACTIONS(754),
    [anon_sym_uint240] = ACTIONS(754),
    [anon_sym_uint248] = ACTIONS(754),
    [anon_sym_uint256] = ACTIONS(754),
    [anon_sym_bytes] = ACTIONS(754),
    [anon_sym_bytes1] = ACTIONS(754),
    [anon_sym_bytes2] = ACTIONS(754),
    [anon_sym_bytes3] = ACTIONS(754),
    [anon_sym_bytes4] = ACTIONS(754),
    [anon_sym_bytes5] = ACTIONS(754),
    [anon_sym_bytes6] = ACTIONS(754),
    [anon_sym_bytes7] = ACTIONS(754),
    [anon_sym_bytes8] = ACTIONS(754),
    [anon_sym_bytes9] = ACTIONS(754),
    [anon_sym_bytes10] = ACTIONS(754),
    [anon_sym_bytes11] = ACTIONS(754),
    [anon_sym_bytes12] = ACTIONS(754),
    [anon_sym_bytes13] = ACTIONS(754),
    [anon_sym_bytes14] = ACTIONS(754),
    [anon_sym_bytes15] = ACTIONS(754),
    [anon_sym_bytes16] = ACTIONS(754),
    [anon_sym_bytes17] = ACTIONS(754),
    [anon_sym_bytes18] = ACTIONS(754),
    [anon_sym_bytes19] = ACTIONS(754),
    [anon_sym_bytes20] = ACTIONS(754),
    [anon_sym_bytes21] = ACTIONS(754),
    [anon_sym_bytes22] = ACTIONS(754),
    [anon_sym_bytes23] = ACTIONS(754),
    [anon_sym_bytes24] = ACTIONS(754),
    [anon_sym_bytes25] = ACTIONS(754),
    [anon_sym_bytes26] = ACTIONS(754),
    [anon_sym_bytes27] = ACTIONS(754),
    [anon_sym_bytes28] = ACTIONS(754),
    [anon_sym_bytes29] = ACTIONS(754),
    [anon_sym_bytes30] = ACTIONS(754),
    [anon_sym_bytes31] = ACTIONS(754),
    [anon_sym_bytes32] = ACTIONS(754),
    [anon_sym_fixed] = ACTIONS(754),
    [aux_sym__fixed_token1] = ACTIONS(754),
    [anon_sym_ufixed] = ACTIONS(754),
    [aux_sym__ufixed_token1] = ACTIONS(754),
    [sym_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_user_defined_type] = STATE(734),
    [sym__identifier_path] = STATE(318),
    [sym__mapping_key] = STATE(734),
    [sym_primitive_type] = STATE(734),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(35),
    [anon_sym_var] = ACTIONS(33),
    [anon_sym_bool] = ACTIONS(33),
    [anon_sym_string] = ACTIONS(33),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(33),
    [anon_sym_int40] = ACTIONS(33),
    [anon_sym_int48] = ACTIONS(33),
    [anon_sym_int56] = ACTIONS(33),
    [anon_sym_int64] = ACTIONS(33),
    [anon_sym_int72] = ACTIONS(33),
    [anon_sym_int80] = ACTIONS(33),
    [anon_sym_int88] = ACTIONS(33),
    [anon_sym_int96] = ACTIONS(33),
    [anon_sym_int104] = ACTIONS(33),
    [anon_sym_int112] = ACTIONS(33),
    [anon_sym_int120] = ACTIONS(33),
    [anon_sym_int128] = ACTIONS(33),
    [anon_sym_int136] = ACTIONS(33),
    [anon_sym_int144] = ACTIONS(33),
    [anon_sym_int152] = ACTIONS(33),
    [anon_sym_int160] = ACTIONS(33),
    [anon_sym_int168] = ACTIONS(33),
    [anon_sym_int176] = ACTIONS(33),
    [anon_sym_int184] = ACTIONS(33),
    [anon_sym_int192] = ACTIONS(33),
    [anon_sym_int200] = ACTIONS(33),
    [anon_sym_int208] = ACTIONS(33),
    [anon_sym_int216] = ACTIONS(33),
    [anon_sym_int224] = ACTIONS(33),
    [anon_sym_int232] = ACTIONS(33),
    [anon_sym_int240] = ACTIONS(33),
    [anon_sym_int248] = ACTIONS(33),
    [anon_sym_int256] = ACTIONS(33),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(33),
    [anon_sym_uint40] = ACTIONS(33),
    [anon_sym_uint48] = ACTIONS(33),
    [anon_sym_uint56] = ACTIONS(33),
    [anon_sym_uint64] = ACTIONS(33),
    [anon_sym_uint72] = ACTIONS(33),
    [anon_sym_uint80] = ACTIONS(33),
    [anon_sym_uint88] = ACTIONS(33),
    [anon_sym_uint96] = ACTIONS(33),
    [anon_sym_uint104] = ACTIONS(33),
    [anon_sym_uint112] = ACTIONS(33),
    [anon_sym_uint120] = ACTIONS(33),
    [anon_sym_uint128] = ACTIONS(33),
    [anon_sym_uint136] = ACTIONS(33),
    [anon_sym_uint144] = ACTIONS(33),
    [anon_sym_uint152] = ACTIONS(33),
    [anon_sym_uint160] = ACTIONS(33),
    [anon_sym_uint168] = ACTIONS(33),
    [anon_sym_uint176] = ACTIONS(33),
    [anon_sym_uint184] = ACTIONS(33),
    [anon_sym_uint192] = ACTIONS(33),
    [anon_sym_uint200] = ACTIONS(33),
    [anon_sym_uint208] = ACTIONS(33),
    [anon_sym_uint216] = ACTIONS(33),
    [anon_sym_uint224] = ACTIONS(33),
    [anon_sym_uint232] = ACTIONS(33),
    [anon_sym_uint240] = ACTIONS(33),
    [anon_sym_uint248] = ACTIONS(33),
    [anon_sym_uint256] = ACTIONS(33),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(33),
    [anon_sym_bytes5] = ACTIONS(33),
    [anon_sym_bytes6] = ACTIONS(33),
    [anon_sym_bytes7] = ACTIONS(33),
    [anon_sym_bytes8] = ACTIONS(33),
    [anon_sym_bytes9] = ACTIONS(33),
    [anon_sym_bytes10] = ACTIONS(33),
    [anon_sym_bytes11] = ACTIONS(33),
    [anon_sym_bytes12] = ACTIONS(33),
    [anon_sym_bytes13] = ACTIONS(33),
    [anon_sym_bytes14] = ACTIONS(33),
    [anon_sym_bytes15] = ACTIONS(33),
    [anon_sym_bytes16] = ACTIONS(33),
    [anon_sym_bytes17] = ACTIONS(33),
    [anon_sym_bytes18] = ACTIONS(33),
    [anon_sym_bytes19] = ACTIONS(33),
    [anon_sym_bytes20] = ACTIONS(33),
    [anon_sym_bytes21] = ACTIONS(33),
    [anon_sym_bytes22] = ACTIONS(33),
    [anon_sym_bytes23] = ACTIONS(33),
    [anon_sym_bytes24] = ACTIONS(33),
    [anon_sym_bytes25] = ACTIONS(33),
    [anon_sym_bytes26] = ACTIONS(33),
    [anon_sym_bytes27] = ACTIONS(33),
    [anon_sym_bytes28] = ACTIONS(33),
    [anon_sym_bytes29] = ACTIONS(33),
    [anon_sym_bytes30] = ACTIONS(33),
    [anon_sym_bytes31] = ACTIONS(33),
    [anon_sym_bytes32] = ACTIONS(33),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(33),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(33),
    [sym_comment] = ACTIONS(3),
  },
  [216] = {
    [sym__yul_statement] = STATE(222),
    [sym_yul_label] = STATE(222),
    [sym_yul_break] = STATE(222),
    [sym_yul_continue] = STATE(222),
    [sym_yul_identifier] = STATE(228),
    [sym_yul_path] = STATE(237),
    [sym__yul_literal] = STATE(222),
    [sym_yul_string_literal] = STATE(222),
    [sym_yul_boolean] = STATE(222),
    [sym_yul_block] = STATE(222),
    [sym_yul_variable_declaration] = STATE(222),
    [sym_yul_assignment] = STATE(222),
    [sym_yul_function_call] = STATE(222),
    [sym_yul_if_statement] = STATE(222),
    [sym_yul_for_statement] = STATE(222),
    [sym_yul_switch_statement] = STATE(222),
    [sym_yul_function_definition] = STATE(222),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [aux_sym_assembly_statement_repeat1] = STATE(222),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(828),
    [anon_sym_for] = ACTIONS(830),
    [sym_yul_leave] = ACTIONS(832),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(836),
    [sym_yul_decimal_number] = ACTIONS(832),
    [sym_yul_hex_number] = ACTIONS(838),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_function] = ACTIONS(848),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [217] = {
    [sym__yul_statement] = STATE(224),
    [sym_yul_label] = STATE(224),
    [sym_yul_break] = STATE(224),
    [sym_yul_continue] = STATE(224),
    [sym_yul_identifier] = STATE(228),
    [sym_yul_path] = STATE(237),
    [sym__yul_literal] = STATE(224),
    [sym_yul_string_literal] = STATE(224),
    [sym_yul_boolean] = STATE(224),
    [sym_yul_block] = STATE(224),
    [sym_yul_variable_declaration] = STATE(224),
    [sym_yul_assignment] = STATE(224),
    [sym_yul_function_call] = STATE(224),
    [sym_yul_if_statement] = STATE(224),
    [sym_yul_for_statement] = STATE(224),
    [sym_yul_switch_statement] = STATE(224),
    [sym_yul_function_definition] = STATE(224),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [aux_sym_assembly_statement_repeat1] = STATE(224),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(856),
    [anon_sym_for] = ACTIONS(830),
    [sym_yul_leave] = ACTIONS(858),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(836),
    [sym_yul_decimal_number] = ACTIONS(858),
    [sym_yul_hex_number] = ACTIONS(860),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_function] = ACTIONS(848),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [218] = {
    [sym__yul_statement] = STATE(223),
    [sym_yul_label] = STATE(223),
    [sym_yul_break] = STATE(223),
    [sym_yul_continue] = STATE(223),
    [sym_yul_identifier] = STATE(228),
    [sym_yul_path] = STATE(237),
    [sym__yul_literal] = STATE(223),
    [sym_yul_string_literal] = STATE(223),
    [sym_yul_boolean] = STATE(223),
    [sym_yul_block] = STATE(223),
    [sym_yul_variable_declaration] = STATE(223),
    [sym_yul_assignment] = STATE(223),
    [sym_yul_function_call] = STATE(223),
    [sym_yul_if_statement] = STATE(223),
    [sym_yul_for_statement] = STATE(223),
    [sym_yul_switch_statement] = STATE(223),
    [sym_yul_function_definition] = STATE(223),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [aux_sym_assembly_statement_repeat1] = STATE(223),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(862),
    [anon_sym_for] = ACTIONS(830),
    [sym_yul_leave] = ACTIONS(864),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(836),
    [sym_yul_decimal_number] = ACTIONS(864),
    [sym_yul_hex_number] = ACTIONS(866),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_function] = ACTIONS(848),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [219] = {
    [sym__yul_statement] = STATE(220),
    [sym_yul_label] = STATE(220),
    [sym_yul_break] = STATE(220),
    [sym_yul_continue] = STATE(220),
    [sym_yul_identifier] = STATE(228),
    [sym_yul_path] = STATE(237),
    [sym__yul_literal] = STATE(220),
    [sym_yul_string_literal] = STATE(220),
    [sym_yul_boolean] = STATE(220),
    [sym_yul_block] = STATE(220),
    [sym_yul_variable_declaration] = STATE(220),
    [sym_yul_assignment] = STATE(220),
    [sym_yul_function_call] = STATE(220),
    [sym_yul_if_statement] = STATE(220),
    [sym_yul_for_statement] = STATE(220),
    [sym_yul_switch_statement] = STATE(220),
    [sym_yul_function_definition] = STATE(220),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [aux_sym_assembly_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(856),
    [anon_sym_for] = ACTIONS(830),
    [sym_yul_leave] = ACTIONS(868),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(836),
    [sym_yul_decimal_number] = ACTIONS(868),
    [sym_yul_hex_number] = ACTIONS(870),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_function] = ACTIONS(848),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [220] = {
    [sym__yul_statement] = STATE(220),
    [sym_yul_label] = STATE(220),
    [sym_yul_break] = STATE(220),
    [sym_yul_continue] = STATE(220),
    [sym_yul_identifier] = STATE(228),
    [sym_yul_path] = STATE(237),
    [sym__yul_literal] = STATE(220),
    [sym_yul_string_literal] = STATE(220),
    [sym_yul_boolean] = STATE(220),
    [sym_yul_block] = STATE(220),
    [sym_yul_variable_declaration] = STATE(220),
    [sym_yul_assignment] = STATE(220),
    [sym_yul_function_call] = STATE(220),
    [sym_yul_if_statement] = STATE(220),
    [sym_yul_for_statement] = STATE(220),
    [sym_yul_switch_statement] = STATE(220),
    [sym_yul_function_definition] = STATE(220),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [aux_sym_assembly_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(872),
    [anon_sym_LBRACE] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(878),
    [anon_sym_for] = ACTIONS(880),
    [sym_yul_leave] = ACTIONS(883),
    [anon_sym_break] = ACTIONS(886),
    [anon_sym_continue] = ACTIONS(889),
    [sym_yul_decimal_number] = ACTIONS(883),
    [sym_yul_hex_number] = ACTIONS(892),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_let] = ACTIONS(898),
    [anon_sym_if] = ACTIONS(901),
    [anon_sym_switch] = ACTIONS(904),
    [anon_sym_function] = ACTIONS(907),
    [anon_sym_stop] = ACTIONS(910),
    [anon_sym_add] = ACTIONS(910),
    [anon_sym_sub] = ACTIONS(910),
    [anon_sym_mul] = ACTIONS(910),
    [anon_sym_div] = ACTIONS(910),
    [anon_sym_sdiv] = ACTIONS(910),
    [anon_sym_mod] = ACTIONS(910),
    [anon_sym_smod] = ACTIONS(910),
    [anon_sym_exp] = ACTIONS(910),
    [anon_sym_not] = ACTIONS(910),
    [anon_sym_lt] = ACTIONS(910),
    [anon_sym_gt] = ACTIONS(910),
    [anon_sym_slt] = ACTIONS(910),
    [anon_sym_sgt] = ACTIONS(910),
    [anon_sym_eq] = ACTIONS(910),
    [anon_sym_iszero] = ACTIONS(910),
    [anon_sym_and] = ACTIONS(910),
    [anon_sym_or] = ACTIONS(910),
    [anon_sym_xor] = ACTIONS(910),
    [anon_sym_byte] = ACTIONS(910),
    [anon_sym_shl] = ACTIONS(910),
    [anon_sym_shr] = ACTIONS(910),
    [anon_sym_sar] = ACTIONS(910),
    [anon_sym_addmod] = ACTIONS(910),
    [anon_sym_mulmod] = ACTIONS(910),
    [anon_sym_signextend] = ACTIONS(910),
    [anon_sym_keccak256] = ACTIONS(910),
    [anon_sym_pop] = ACTIONS(910),
    [anon_sym_mload] = ACTIONS(910),
    [anon_sym_mcopy] = ACTIONS(910),
    [anon_sym_tload] = ACTIONS(910),
    [anon_sym_tstore] = ACTIONS(910),
    [anon_sym_mstore] = ACTIONS(910),
    [anon_sym_mstore8] = ACTIONS(910),
    [anon_sym_sload] = ACTIONS(910),
    [anon_sym_sstore] = ACTIONS(910),
    [anon_sym_msize] = ACTIONS(910),
    [anon_sym_gas] = ACTIONS(910),
    [anon_sym_address] = ACTIONS(910),
    [anon_sym_balance] = ACTIONS(910),
    [anon_sym_selfbalance] = ACTIONS(910),
    [anon_sym_caller] = ACTIONS(910),
    [anon_sym_callvalue] = ACTIONS(910),
    [anon_sym_calldataload] = ACTIONS(910),
    [anon_sym_calldatasize] = ACTIONS(910),
    [anon_sym_calldatacopy] = ACTIONS(910),
    [anon_sym_extcodesize] = ACTIONS(910),
    [anon_sym_extcodecopy] = ACTIONS(910),
    [anon_sym_returndatasize] = ACTIONS(910),
    [anon_sym_returndatacopy] = ACTIONS(910),
    [anon_sym_extcodehash] = ACTIONS(910),
    [anon_sym_create] = ACTIONS(910),
    [anon_sym_create2] = ACTIONS(910),
    [anon_sym_call] = ACTIONS(910),
    [anon_sym_callcode] = ACTIONS(910),
    [anon_sym_delegatecall] = ACTIONS(910),
    [anon_sym_staticcall] = ACTIONS(910),
    [anon_sym_return] = ACTIONS(910),
    [anon_sym_revert] = ACTIONS(910),
    [anon_sym_selfdestruct] = ACTIONS(910),
    [anon_sym_invalid] = ACTIONS(910),
    [anon_sym_log0] = ACTIONS(910),
    [anon_sym_log1] = ACTIONS(910),
    [anon_sym_log2] = ACTIONS(910),
    [anon_sym_log3] = ACTIONS(910),
    [anon_sym_log4] = ACTIONS(910),
    [anon_sym_chainid] = ACTIONS(910),
    [anon_sym_origin] = ACTIONS(910),
    [anon_sym_gasprice] = ACTIONS(910),
    [anon_sym_blockhash] = ACTIONS(910),
    [anon_sym_blobhash] = ACTIONS(910),
    [anon_sym_basefee] = ACTIONS(910),
    [anon_sym_blobfee] = ACTIONS(910),
    [anon_sym_coinbase] = ACTIONS(910),
    [anon_sym_timestamp] = ACTIONS(910),
    [anon_sym_number] = ACTIONS(910),
    [anon_sym_difficulty] = ACTIONS(910),
    [anon_sym_gaslimit] = ACTIONS(910),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_SQUOTE] = ACTIONS(916),
    [sym_comment] = ACTIONS(3),
  },
  [221] = {
    [sym__yul_statement] = STATE(219),
    [sym_yul_label] = STATE(219),
    [sym_yul_break] = STATE(219),
    [sym_yul_continue] = STATE(219),
    [sym_yul_identifier] = STATE(228),
    [sym_yul_path] = STATE(237),
    [sym__yul_literal] = STATE(219),
    [sym_yul_string_literal] = STATE(219),
    [sym_yul_boolean] = STATE(219),
    [sym_yul_block] = STATE(219),
    [sym_yul_variable_declaration] = STATE(219),
    [sym_yul_assignment] = STATE(219),
    [sym_yul_function_call] = STATE(219),
    [sym_yul_if_statement] = STATE(219),
    [sym_yul_for_statement] = STATE(219),
    [sym_yul_switch_statement] = STATE(219),
    [sym_yul_function_definition] = STATE(219),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [aux_sym_assembly_statement_repeat1] = STATE(219),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_for] = ACTIONS(830),
    [sym_yul_leave] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(836),
    [sym_yul_decimal_number] = ACTIONS(921),
    [sym_yul_hex_number] = ACTIONS(923),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_function] = ACTIONS(848),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [222] = {
    [sym__yul_statement] = STATE(220),
    [sym_yul_label] = STATE(220),
    [sym_yul_break] = STATE(220),
    [sym_yul_continue] = STATE(220),
    [sym_yul_identifier] = STATE(228),
    [sym_yul_path] = STATE(237),
    [sym__yul_literal] = STATE(220),
    [sym_yul_string_literal] = STATE(220),
    [sym_yul_boolean] = STATE(220),
    [sym_yul_block] = STATE(220),
    [sym_yul_variable_declaration] = STATE(220),
    [sym_yul_assignment] = STATE(220),
    [sym_yul_function_call] = STATE(220),
    [sym_yul_if_statement] = STATE(220),
    [sym_yul_for_statement] = STATE(220),
    [sym_yul_switch_statement] = STATE(220),
    [sym_yul_function_definition] = STATE(220),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [aux_sym_assembly_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym_for] = ACTIONS(830),
    [sym_yul_leave] = ACTIONS(868),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(836),
    [sym_yul_decimal_number] = ACTIONS(868),
    [sym_yul_hex_number] = ACTIONS(870),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_function] = ACTIONS(848),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [223] = {
    [sym__yul_statement] = STATE(220),
    [sym_yul_label] = STATE(220),
    [sym_yul_break] = STATE(220),
    [sym_yul_continue] = STATE(220),
    [sym_yul_identifier] = STATE(228),
    [sym_yul_path] = STATE(237),
    [sym__yul_literal] = STATE(220),
    [sym_yul_string_literal] = STATE(220),
    [sym_yul_boolean] = STATE(220),
    [sym_yul_block] = STATE(220),
    [sym_yul_variable_declaration] = STATE(220),
    [sym_yul_assignment] = STATE(220),
    [sym_yul_function_call] = STATE(220),
    [sym_yul_if_statement] = STATE(220),
    [sym_yul_for_statement] = STATE(220),
    [sym_yul_switch_statement] = STATE(220),
    [sym_yul_function_definition] = STATE(220),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [aux_sym_assembly_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym_for] = ACTIONS(830),
    [sym_yul_leave] = ACTIONS(868),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(836),
    [sym_yul_decimal_number] = ACTIONS(868),
    [sym_yul_hex_number] = ACTIONS(870),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_function] = ACTIONS(848),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [224] = {
    [sym__yul_statement] = STATE(220),
    [sym_yul_label] = STATE(220),
    [sym_yul_break] = STATE(220),
    [sym_yul_continue] = STATE(220),
    [sym_yul_identifier] = STATE(228),
    [sym_yul_path] = STATE(237),
    [sym__yul_literal] = STATE(220),
    [sym_yul_string_literal] = STATE(220),
    [sym_yul_boolean] = STATE(220),
    [sym_yul_block] = STATE(220),
    [sym_yul_variable_declaration] = STATE(220),
    [sym_yul_assignment] = STATE(220),
    [sym_yul_function_call] = STATE(220),
    [sym_yul_if_statement] = STATE(220),
    [sym_yul_for_statement] = STATE(220),
    [sym_yul_switch_statement] = STATE(220),
    [sym_yul_function_definition] = STATE(220),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [aux_sym_assembly_statement_repeat1] = STATE(220),
    [sym_identifier] = ACTIONS(824),
    [anon_sym_LBRACE] = ACTIONS(826),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_for] = ACTIONS(830),
    [sym_yul_leave] = ACTIONS(868),
    [anon_sym_break] = ACTIONS(834),
    [anon_sym_continue] = ACTIONS(836),
    [sym_yul_decimal_number] = ACTIONS(868),
    [sym_yul_hex_number] = ACTIONS(870),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_let] = ACTIONS(842),
    [anon_sym_if] = ACTIONS(844),
    [anon_sym_switch] = ACTIONS(846),
    [anon_sym_function] = ACTIONS(848),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_primitive_type] = STATE(802),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(929),
    [anon_sym_var] = ACTIONS(931),
    [anon_sym_bool] = ACTIONS(931),
    [anon_sym_string] = ACTIONS(931),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(931),
    [anon_sym_int40] = ACTIONS(931),
    [anon_sym_int48] = ACTIONS(931),
    [anon_sym_int56] = ACTIONS(931),
    [anon_sym_int64] = ACTIONS(931),
    [anon_sym_int72] = ACTIONS(931),
    [anon_sym_int80] = ACTIONS(931),
    [anon_sym_int88] = ACTIONS(931),
    [anon_sym_int96] = ACTIONS(931),
    [anon_sym_int104] = ACTIONS(931),
    [anon_sym_int112] = ACTIONS(931),
    [anon_sym_int120] = ACTIONS(931),
    [anon_sym_int128] = ACTIONS(931),
    [anon_sym_int136] = ACTIONS(931),
    [anon_sym_int144] = ACTIONS(931),
    [anon_sym_int152] = ACTIONS(931),
    [anon_sym_int160] = ACTIONS(931),
    [anon_sym_int168] = ACTIONS(931),
    [anon_sym_int176] = ACTIONS(931),
    [anon_sym_int184] = ACTIONS(931),
    [anon_sym_int192] = ACTIONS(931),
    [anon_sym_int200] = ACTIONS(931),
    [anon_sym_int208] = ACTIONS(931),
    [anon_sym_int216] = ACTIONS(931),
    [anon_sym_int224] = ACTIONS(931),
    [anon_sym_int232] = ACTIONS(931),
    [anon_sym_int240] = ACTIONS(931),
    [anon_sym_int248] = ACTIONS(931),
    [anon_sym_int256] = ACTIONS(931),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(931),
    [anon_sym_uint40] = ACTIONS(931),
    [anon_sym_uint48] = ACTIONS(931),
    [anon_sym_uint56] = ACTIONS(931),
    [anon_sym_uint64] = ACTIONS(931),
    [anon_sym_uint72] = ACTIONS(931),
    [anon_sym_uint80] = ACTIONS(931),
    [anon_sym_uint88] = ACTIONS(931),
    [anon_sym_uint96] = ACTIONS(931),
    [anon_sym_uint104] = ACTIONS(931),
    [anon_sym_uint112] = ACTIONS(931),
    [anon_sym_uint120] = ACTIONS(931),
    [anon_sym_uint128] = ACTIONS(931),
    [anon_sym_uint136] = ACTIONS(931),
    [anon_sym_uint144] = ACTIONS(931),
    [anon_sym_uint152] = ACTIONS(931),
    [anon_sym_uint160] = ACTIONS(931),
    [anon_sym_uint168] = ACTIONS(931),
    [anon_sym_uint176] = ACTIONS(931),
    [anon_sym_uint184] = ACTIONS(931),
    [anon_sym_uint192] = ACTIONS(931),
    [anon_sym_uint200] = ACTIONS(931),
    [anon_sym_uint208] = ACTIONS(931),
    [anon_sym_uint216] = ACTIONS(931),
    [anon_sym_uint224] = ACTIONS(931),
    [anon_sym_uint232] = ACTIONS(931),
    [anon_sym_uint240] = ACTIONS(931),
    [anon_sym_uint248] = ACTIONS(931),
    [anon_sym_uint256] = ACTIONS(931),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(931),
    [anon_sym_bytes5] = ACTIONS(931),
    [anon_sym_bytes6] = ACTIONS(931),
    [anon_sym_bytes7] = ACTIONS(931),
    [anon_sym_bytes8] = ACTIONS(931),
    [anon_sym_bytes9] = ACTIONS(931),
    [anon_sym_bytes10] = ACTIONS(931),
    [anon_sym_bytes11] = ACTIONS(931),
    [anon_sym_bytes12] = ACTIONS(931),
    [anon_sym_bytes13] = ACTIONS(931),
    [anon_sym_bytes14] = ACTIONS(931),
    [anon_sym_bytes15] = ACTIONS(931),
    [anon_sym_bytes16] = ACTIONS(931),
    [anon_sym_bytes17] = ACTIONS(931),
    [anon_sym_bytes18] = ACTIONS(931),
    [anon_sym_bytes19] = ACTIONS(931),
    [anon_sym_bytes20] = ACTIONS(931),
    [anon_sym_bytes21] = ACTIONS(931),
    [anon_sym_bytes22] = ACTIONS(931),
    [anon_sym_bytes23] = ACTIONS(931),
    [anon_sym_bytes24] = ACTIONS(931),
    [anon_sym_bytes25] = ACTIONS(931),
    [anon_sym_bytes26] = ACTIONS(931),
    [anon_sym_bytes27] = ACTIONS(931),
    [anon_sym_bytes28] = ACTIONS(931),
    [anon_sym_bytes29] = ACTIONS(931),
    [anon_sym_bytes30] = ACTIONS(931),
    [anon_sym_bytes31] = ACTIONS(931),
    [anon_sym_bytes32] = ACTIONS(931),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(931),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(931),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_primitive_type] = STATE(803),
    [sym__int] = STATE(319),
    [sym__uint] = STATE(319),
    [sym__bytes] = STATE(319),
    [sym__fixed] = STATE(319),
    [sym__ufixed] = STATE(319),
    [anon_sym_byte] = ACTIONS(33),
    [anon_sym_address] = ACTIONS(929),
    [anon_sym_var] = ACTIONS(931),
    [anon_sym_bool] = ACTIONS(931),
    [anon_sym_string] = ACTIONS(931),
    [anon_sym_int] = ACTIONS(33),
    [anon_sym_int8] = ACTIONS(33),
    [anon_sym_int16] = ACTIONS(33),
    [anon_sym_int24] = ACTIONS(33),
    [anon_sym_int32] = ACTIONS(931),
    [anon_sym_int40] = ACTIONS(931),
    [anon_sym_int48] = ACTIONS(931),
    [anon_sym_int56] = ACTIONS(931),
    [anon_sym_int64] = ACTIONS(931),
    [anon_sym_int72] = ACTIONS(931),
    [anon_sym_int80] = ACTIONS(931),
    [anon_sym_int88] = ACTIONS(931),
    [anon_sym_int96] = ACTIONS(931),
    [anon_sym_int104] = ACTIONS(931),
    [anon_sym_int112] = ACTIONS(931),
    [anon_sym_int120] = ACTIONS(931),
    [anon_sym_int128] = ACTIONS(931),
    [anon_sym_int136] = ACTIONS(931),
    [anon_sym_int144] = ACTIONS(931),
    [anon_sym_int152] = ACTIONS(931),
    [anon_sym_int160] = ACTIONS(931),
    [anon_sym_int168] = ACTIONS(931),
    [anon_sym_int176] = ACTIONS(931),
    [anon_sym_int184] = ACTIONS(931),
    [anon_sym_int192] = ACTIONS(931),
    [anon_sym_int200] = ACTIONS(931),
    [anon_sym_int208] = ACTIONS(931),
    [anon_sym_int216] = ACTIONS(931),
    [anon_sym_int224] = ACTIONS(931),
    [anon_sym_int232] = ACTIONS(931),
    [anon_sym_int240] = ACTIONS(931),
    [anon_sym_int248] = ACTIONS(931),
    [anon_sym_int256] = ACTIONS(931),
    [anon_sym_uint] = ACTIONS(33),
    [anon_sym_uint8] = ACTIONS(33),
    [anon_sym_uint16] = ACTIONS(33),
    [anon_sym_uint24] = ACTIONS(33),
    [anon_sym_uint32] = ACTIONS(931),
    [anon_sym_uint40] = ACTIONS(931),
    [anon_sym_uint48] = ACTIONS(931),
    [anon_sym_uint56] = ACTIONS(931),
    [anon_sym_uint64] = ACTIONS(931),
    [anon_sym_uint72] = ACTIONS(931),
    [anon_sym_uint80] = ACTIONS(931),
    [anon_sym_uint88] = ACTIONS(931),
    [anon_sym_uint96] = ACTIONS(931),
    [anon_sym_uint104] = ACTIONS(931),
    [anon_sym_uint112] = ACTIONS(931),
    [anon_sym_uint120] = ACTIONS(931),
    [anon_sym_uint128] = ACTIONS(931),
    [anon_sym_uint136] = ACTIONS(931),
    [anon_sym_uint144] = ACTIONS(931),
    [anon_sym_uint152] = ACTIONS(931),
    [anon_sym_uint160] = ACTIONS(931),
    [anon_sym_uint168] = ACTIONS(931),
    [anon_sym_uint176] = ACTIONS(931),
    [anon_sym_uint184] = ACTIONS(931),
    [anon_sym_uint192] = ACTIONS(931),
    [anon_sym_uint200] = ACTIONS(931),
    [anon_sym_uint208] = ACTIONS(931),
    [anon_sym_uint216] = ACTIONS(931),
    [anon_sym_uint224] = ACTIONS(931),
    [anon_sym_uint232] = ACTIONS(931),
    [anon_sym_uint240] = ACTIONS(931),
    [anon_sym_uint248] = ACTIONS(931),
    [anon_sym_uint256] = ACTIONS(931),
    [anon_sym_bytes] = ACTIONS(33),
    [anon_sym_bytes1] = ACTIONS(33),
    [anon_sym_bytes2] = ACTIONS(33),
    [anon_sym_bytes3] = ACTIONS(33),
    [anon_sym_bytes4] = ACTIONS(931),
    [anon_sym_bytes5] = ACTIONS(931),
    [anon_sym_bytes6] = ACTIONS(931),
    [anon_sym_bytes7] = ACTIONS(931),
    [anon_sym_bytes8] = ACTIONS(931),
    [anon_sym_bytes9] = ACTIONS(931),
    [anon_sym_bytes10] = ACTIONS(931),
    [anon_sym_bytes11] = ACTIONS(931),
    [anon_sym_bytes12] = ACTIONS(931),
    [anon_sym_bytes13] = ACTIONS(931),
    [anon_sym_bytes14] = ACTIONS(931),
    [anon_sym_bytes15] = ACTIONS(931),
    [anon_sym_bytes16] = ACTIONS(931),
    [anon_sym_bytes17] = ACTIONS(931),
    [anon_sym_bytes18] = ACTIONS(931),
    [anon_sym_bytes19] = ACTIONS(931),
    [anon_sym_bytes20] = ACTIONS(931),
    [anon_sym_bytes21] = ACTIONS(931),
    [anon_sym_bytes22] = ACTIONS(931),
    [anon_sym_bytes23] = ACTIONS(931),
    [anon_sym_bytes24] = ACTIONS(931),
    [anon_sym_bytes25] = ACTIONS(931),
    [anon_sym_bytes26] = ACTIONS(931),
    [anon_sym_bytes27] = ACTIONS(931),
    [anon_sym_bytes28] = ACTIONS(931),
    [anon_sym_bytes29] = ACTIONS(931),
    [anon_sym_bytes30] = ACTIONS(931),
    [anon_sym_bytes31] = ACTIONS(931),
    [anon_sym_bytes32] = ACTIONS(931),
    [anon_sym_fixed] = ACTIONS(33),
    [aux_sym__fixed_token1] = ACTIONS(931),
    [anon_sym_ufixed] = ACTIONS(33),
    [aux_sym__ufixed_token1] = ACTIONS(931),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_identifier] = ACTIONS(933),
    [anon_sym_RBRACE] = ACTIONS(935),
    [anon_sym_function] = ACTIONS(933),
    [anon_sym_byte] = ACTIONS(933),
    [anon_sym_address] = ACTIONS(933),
    [anon_sym_var] = ACTIONS(933),
    [anon_sym_mapping] = ACTIONS(933),
    [anon_sym_bool] = ACTIONS(933),
    [anon_sym_string] = ACTIONS(933),
    [anon_sym_int] = ACTIONS(933),
    [anon_sym_int8] = ACTIONS(933),
    [anon_sym_int16] = ACTIONS(933),
    [anon_sym_int24] = ACTIONS(933),
    [anon_sym_int32] = ACTIONS(933),
    [anon_sym_int40] = ACTIONS(933),
    [anon_sym_int48] = ACTIONS(933),
    [anon_sym_int56] = ACTIONS(933),
    [anon_sym_int64] = ACTIONS(933),
    [anon_sym_int72] = ACTIONS(933),
    [anon_sym_int80] = ACTIONS(933),
    [anon_sym_int88] = ACTIONS(933),
    [anon_sym_int96] = ACTIONS(933),
    [anon_sym_int104] = ACTIONS(933),
    [anon_sym_int112] = ACTIONS(933),
    [anon_sym_int120] = ACTIONS(933),
    [anon_sym_int128] = ACTIONS(933),
    [anon_sym_int136] = ACTIONS(933),
    [anon_sym_int144] = ACTIONS(933),
    [anon_sym_int152] = ACTIONS(933),
    [anon_sym_int160] = ACTIONS(933),
    [anon_sym_int168] = ACTIONS(933),
    [anon_sym_int176] = ACTIONS(933),
    [anon_sym_int184] = ACTIONS(933),
    [anon_sym_int192] = ACTIONS(933),
    [anon_sym_int200] = ACTIONS(933),
    [anon_sym_int208] = ACTIONS(933),
    [anon_sym_int216] = ACTIONS(933),
    [anon_sym_int224] = ACTIONS(933),
    [anon_sym_int232] = ACTIONS(933),
    [anon_sym_int240] = ACTIONS(933),
    [anon_sym_int248] = ACTIONS(933),
    [anon_sym_int256] = ACTIONS(933),
    [anon_sym_uint] = ACTIONS(933),
    [anon_sym_uint8] = ACTIONS(933),
    [anon_sym_uint16] = ACTIONS(933),
    [anon_sym_uint24] = ACTIONS(933),
    [anon_sym_uint32] = ACTIONS(933),
    [anon_sym_uint40] = ACTIONS(933),
    [anon_sym_uint48] = ACTIONS(933),
    [anon_sym_uint56] = ACTIONS(933),
    [anon_sym_uint64] = ACTIONS(933),
    [anon_sym_uint72] = ACTIONS(933),
    [anon_sym_uint80] = ACTIONS(933),
    [anon_sym_uint88] = ACTIONS(933),
    [anon_sym_uint96] = ACTIONS(933),
    [anon_sym_uint104] = ACTIONS(933),
    [anon_sym_uint112] = ACTIONS(933),
    [anon_sym_uint120] = ACTIONS(933),
    [anon_sym_uint128] = ACTIONS(933),
    [anon_sym_uint136] = ACTIONS(933),
    [anon_sym_uint144] = ACTIONS(933),
    [anon_sym_uint152] = ACTIONS(933),
    [anon_sym_uint160] = ACTIONS(933),
    [anon_sym_uint168] = ACTIONS(933),
    [anon_sym_uint176] = ACTIONS(933),
    [anon_sym_uint184] = ACTIONS(933),
    [anon_sym_uint192] = ACTIONS(933),
    [anon_sym_uint200] = ACTIONS(933),
    [anon_sym_uint208] = ACTIONS(933),
    [anon_sym_uint216] = ACTIONS(933),
    [anon_sym_uint224] = ACTIONS(933),
    [anon_sym_uint232] = ACTIONS(933),
    [anon_sym_uint240] = ACTIONS(933),
    [anon_sym_uint248] = ACTIONS(933),
    [anon_sym_uint256] = ACTIONS(933),
    [anon_sym_bytes] = ACTIONS(933),
    [anon_sym_bytes1] = ACTIONS(933),
    [anon_sym_bytes2] = ACTIONS(933),
    [anon_sym_bytes3] = ACTIONS(933),
    [anon_sym_bytes4] = ACTIONS(933),
    [anon_sym_bytes5] = ACTIONS(933),
    [anon_sym_bytes6] = ACTIONS(933),
    [anon_sym_bytes7] = ACTIONS(933),
    [anon_sym_bytes8] = ACTIONS(933),
    [anon_sym_bytes9] = ACTIONS(933),
    [anon_sym_bytes10] = ACTIONS(933),
    [anon_sym_bytes11] = ACTIONS(933),
    [anon_sym_bytes12] = ACTIONS(933),
    [anon_sym_bytes13] = ACTIONS(933),
    [anon_sym_bytes14] = ACTIONS(933),
    [anon_sym_bytes15] = ACTIONS(933),
    [anon_sym_bytes16] = ACTIONS(933),
    [anon_sym_bytes17] = ACTIONS(933),
    [anon_sym_bytes18] = ACTIONS(933),
    [anon_sym_bytes19] = ACTIONS(933),
    [anon_sym_bytes20] = ACTIONS(933),
    [anon_sym_bytes21] = ACTIONS(933),
    [anon_sym_bytes22] = ACTIONS(933),
    [anon_sym_bytes23] = ACTIONS(933),
    [anon_sym_bytes24] = ACTIONS(933),
    [anon_sym_bytes25] = ACTIONS(933),
    [anon_sym_bytes26] = ACTIONS(933),
    [anon_sym_bytes27] = ACTIONS(933),
    [anon_sym_bytes28] = ACTIONS(933),
    [anon_sym_bytes29] = ACTIONS(933),
    [anon_sym_bytes30] = ACTIONS(933),
    [anon_sym_bytes31] = ACTIONS(933),
    [anon_sym_bytes32] = ACTIONS(933),
    [anon_sym_fixed] = ACTIONS(933),
    [aux_sym__fixed_token1] = ACTIONS(933),
    [anon_sym_ufixed] = ACTIONS(933),
    [aux_sym__ufixed_token1] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
  },
  [228] = {
    [aux_sym_yul_path_repeat1] = STATE(230),
    [sym_identifier] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [sym_yul_leave] = ACTIONS(937),
    [anon_sym_break] = ACTIONS(937),
    [anon_sym_continue] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(943),
    [sym_yul_decimal_number] = ACTIONS(937),
    [sym_yul_hex_number] = ACTIONS(939),
    [anon_sym_true] = ACTIONS(937),
    [anon_sym_false] = ACTIONS(937),
    [anon_sym_let] = ACTIONS(937),
    [anon_sym_COLON_EQ] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(937),
    [anon_sym_switch] = ACTIONS(937),
    [anon_sym_default] = ACTIONS(937),
    [anon_sym_case] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_stop] = ACTIONS(937),
    [anon_sym_add] = ACTIONS(937),
    [anon_sym_sub] = ACTIONS(937),
    [anon_sym_mul] = ACTIONS(937),
    [anon_sym_div] = ACTIONS(937),
    [anon_sym_sdiv] = ACTIONS(937),
    [anon_sym_mod] = ACTIONS(937),
    [anon_sym_smod] = ACTIONS(937),
    [anon_sym_exp] = ACTIONS(937),
    [anon_sym_not] = ACTIONS(937),
    [anon_sym_lt] = ACTIONS(937),
    [anon_sym_gt] = ACTIONS(937),
    [anon_sym_slt] = ACTIONS(937),
    [anon_sym_sgt] = ACTIONS(937),
    [anon_sym_eq] = ACTIONS(937),
    [anon_sym_iszero] = ACTIONS(937),
    [anon_sym_and] = ACTIONS(937),
    [anon_sym_or] = ACTIONS(937),
    [anon_sym_xor] = ACTIONS(937),
    [anon_sym_byte] = ACTIONS(937),
    [anon_sym_shl] = ACTIONS(937),
    [anon_sym_shr] = ACTIONS(937),
    [anon_sym_sar] = ACTIONS(937),
    [anon_sym_addmod] = ACTIONS(937),
    [anon_sym_mulmod] = ACTIONS(937),
    [anon_sym_signextend] = ACTIONS(937),
    [anon_sym_keccak256] = ACTIONS(937),
    [anon_sym_pop] = ACTIONS(937),
    [anon_sym_mload] = ACTIONS(937),
    [anon_sym_mcopy] = ACTIONS(937),
    [anon_sym_tload] = ACTIONS(937),
    [anon_sym_tstore] = ACTIONS(937),
    [anon_sym_mstore] = ACTIONS(937),
    [anon_sym_mstore8] = ACTIONS(937),
    [anon_sym_sload] = ACTIONS(937),
    [anon_sym_sstore] = ACTIONS(937),
    [anon_sym_msize] = ACTIONS(937),
    [anon_sym_gas] = ACTIONS(937),
    [anon_sym_address] = ACTIONS(937),
    [anon_sym_balance] = ACTIONS(937),
    [anon_sym_selfbalance] = ACTIONS(937),
    [anon_sym_caller] = ACTIONS(937),
    [anon_sym_callvalue] = ACTIONS(937),
    [anon_sym_calldataload] = ACTIONS(937),
    [anon_sym_calldatasize] = ACTIONS(937),
    [anon_sym_calldatacopy] = ACTIONS(937),
    [anon_sym_extcodesize] = ACTIONS(937),
    [anon_sym_extcodecopy] = ACTIONS(937),
    [anon_sym_returndatasize] = ACTIONS(937),
    [anon_sym_returndatacopy] = ACTIONS(937),
    [anon_sym_extcodehash] = ACTIONS(937),
    [anon_sym_create] = ACTIONS(937),
    [anon_sym_create2] = ACTIONS(937),
    [anon_sym_call] = ACTIONS(937),
    [anon_sym_callcode] = ACTIONS(937),
    [anon_sym_delegatecall] = ACTIONS(937),
    [anon_sym_staticcall] = ACTIONS(937),
    [anon_sym_return] = ACTIONS(937),
    [anon_sym_revert] = ACTIONS(937),
    [anon_sym_selfdestruct] = ACTIONS(937),
    [anon_sym_invalid] = ACTIONS(937),
    [anon_sym_log0] = ACTIONS(937),
    [anon_sym_log1] = ACTIONS(937),
    [anon_sym_log2] = ACTIONS(937),
    [anon_sym_log3] = ACTIONS(937),
    [anon_sym_log4] = ACTIONS(937),
    [anon_sym_chainid] = ACTIONS(937),
    [anon_sym_origin] = ACTIONS(937),
    [anon_sym_gasprice] = ACTIONS(937),
    [anon_sym_blockhash] = ACTIONS(937),
    [anon_sym_blobhash] = ACTIONS(937),
    [anon_sym_basefee] = ACTIONS(937),
    [anon_sym_blobfee] = ACTIONS(937),
    [anon_sym_coinbase] = ACTIONS(937),
    [anon_sym_timestamp] = ACTIONS(937),
    [anon_sym_number] = ACTIONS(937),
    [anon_sym_difficulty] = ACTIONS(937),
    [anon_sym_gaslimit] = ACTIONS(937),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_SQUOTE] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [aux_sym_yul_path_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(945),
    [anon_sym_COLON] = ACTIONS(945),
    [sym_yul_leave] = ACTIONS(945),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_continue] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(949),
    [sym_yul_decimal_number] = ACTIONS(945),
    [sym_yul_hex_number] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(945),
    [anon_sym_false] = ACTIONS(945),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_COLON_EQ] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(945),
    [anon_sym_switch] = ACTIONS(945),
    [anon_sym_default] = ACTIONS(945),
    [anon_sym_case] = ACTIONS(945),
    [anon_sym_function] = ACTIONS(945),
    [anon_sym_stop] = ACTIONS(945),
    [anon_sym_add] = ACTIONS(945),
    [anon_sym_sub] = ACTIONS(945),
    [anon_sym_mul] = ACTIONS(945),
    [anon_sym_div] = ACTIONS(945),
    [anon_sym_sdiv] = ACTIONS(945),
    [anon_sym_mod] = ACTIONS(945),
    [anon_sym_smod] = ACTIONS(945),
    [anon_sym_exp] = ACTIONS(945),
    [anon_sym_not] = ACTIONS(945),
    [anon_sym_lt] = ACTIONS(945),
    [anon_sym_gt] = ACTIONS(945),
    [anon_sym_slt] = ACTIONS(945),
    [anon_sym_sgt] = ACTIONS(945),
    [anon_sym_eq] = ACTIONS(945),
    [anon_sym_iszero] = ACTIONS(945),
    [anon_sym_and] = ACTIONS(945),
    [anon_sym_or] = ACTIONS(945),
    [anon_sym_xor] = ACTIONS(945),
    [anon_sym_byte] = ACTIONS(945),
    [anon_sym_shl] = ACTIONS(945),
    [anon_sym_shr] = ACTIONS(945),
    [anon_sym_sar] = ACTIONS(945),
    [anon_sym_addmod] = ACTIONS(945),
    [anon_sym_mulmod] = ACTIONS(945),
    [anon_sym_signextend] = ACTIONS(945),
    [anon_sym_keccak256] = ACTIONS(945),
    [anon_sym_pop] = ACTIONS(945),
    [anon_sym_mload] = ACTIONS(945),
    [anon_sym_mcopy] = ACTIONS(945),
    [anon_sym_tload] = ACTIONS(945),
    [anon_sym_tstore] = ACTIONS(945),
    [anon_sym_mstore] = ACTIONS(945),
    [anon_sym_mstore8] = ACTIONS(945),
    [anon_sym_sload] = ACTIONS(945),
    [anon_sym_sstore] = ACTIONS(945),
    [anon_sym_msize] = ACTIONS(945),
    [anon_sym_gas] = ACTIONS(945),
    [anon_sym_address] = ACTIONS(945),
    [anon_sym_balance] = ACTIONS(945),
    [anon_sym_selfbalance] = ACTIONS(945),
    [anon_sym_caller] = ACTIONS(945),
    [anon_sym_callvalue] = ACTIONS(945),
    [anon_sym_calldataload] = ACTIONS(945),
    [anon_sym_calldatasize] = ACTIONS(945),
    [anon_sym_calldatacopy] = ACTIONS(945),
    [anon_sym_extcodesize] = ACTIONS(945),
    [anon_sym_extcodecopy] = ACTIONS(945),
    [anon_sym_returndatasize] = ACTIONS(945),
    [anon_sym_returndatacopy] = ACTIONS(945),
    [anon_sym_extcodehash] = ACTIONS(945),
    [anon_sym_create] = ACTIONS(945),
    [anon_sym_create2] = ACTIONS(945),
    [anon_sym_call] = ACTIONS(945),
    [anon_sym_callcode] = ACTIONS(945),
    [anon_sym_delegatecall] = ACTIONS(945),
    [anon_sym_staticcall] = ACTIONS(945),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_revert] = ACTIONS(945),
    [anon_sym_selfdestruct] = ACTIONS(945),
    [anon_sym_invalid] = ACTIONS(945),
    [anon_sym_log0] = ACTIONS(945),
    [anon_sym_log1] = ACTIONS(945),
    [anon_sym_log2] = ACTIONS(945),
    [anon_sym_log3] = ACTIONS(945),
    [anon_sym_log4] = ACTIONS(945),
    [anon_sym_chainid] = ACTIONS(945),
    [anon_sym_origin] = ACTIONS(945),
    [anon_sym_gasprice] = ACTIONS(945),
    [anon_sym_blockhash] = ACTIONS(945),
    [anon_sym_blobhash] = ACTIONS(945),
    [anon_sym_basefee] = ACTIONS(945),
    [anon_sym_blobfee] = ACTIONS(945),
    [anon_sym_coinbase] = ACTIONS(945),
    [anon_sym_timestamp] = ACTIONS(945),
    [anon_sym_number] = ACTIONS(945),
    [anon_sym_difficulty] = ACTIONS(945),
    [anon_sym_gaslimit] = ACTIONS(945),
    [anon_sym_DQUOTE] = ACTIONS(947),
    [anon_sym_SQUOTE] = ACTIONS(947),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [aux_sym_yul_path_repeat1] = STATE(229),
    [sym_identifier] = ACTIONS(952),
    [anon_sym_LBRACE] = ACTIONS(954),
    [anon_sym_COMMA] = ACTIONS(954),
    [anon_sym_RBRACE] = ACTIONS(954),
    [anon_sym_RPAREN] = ACTIONS(954),
    [anon_sym_for] = ACTIONS(952),
    [anon_sym_COLON] = ACTIONS(952),
    [sym_yul_leave] = ACTIONS(952),
    [anon_sym_break] = ACTIONS(952),
    [anon_sym_continue] = ACTIONS(952),
    [anon_sym_DOT] = ACTIONS(943),
    [sym_yul_decimal_number] = ACTIONS(952),
    [sym_yul_hex_number] = ACTIONS(954),
    [anon_sym_true] = ACTIONS(952),
    [anon_sym_false] = ACTIONS(952),
    [anon_sym_let] = ACTIONS(952),
    [anon_sym_COLON_EQ] = ACTIONS(954),
    [anon_sym_if] = ACTIONS(952),
    [anon_sym_switch] = ACTIONS(952),
    [anon_sym_default] = ACTIONS(952),
    [anon_sym_case] = ACTIONS(952),
    [anon_sym_function] = ACTIONS(952),
    [anon_sym_stop] = ACTIONS(952),
    [anon_sym_add] = ACTIONS(952),
    [anon_sym_sub] = ACTIONS(952),
    [anon_sym_mul] = ACTIONS(952),
    [anon_sym_div] = ACTIONS(952),
    [anon_sym_sdiv] = ACTIONS(952),
    [anon_sym_mod] = ACTIONS(952),
    [anon_sym_smod] = ACTIONS(952),
    [anon_sym_exp] = ACTIONS(952),
    [anon_sym_not] = ACTIONS(952),
    [anon_sym_lt] = ACTIONS(952),
    [anon_sym_gt] = ACTIONS(952),
    [anon_sym_slt] = ACTIONS(952),
    [anon_sym_sgt] = ACTIONS(952),
    [anon_sym_eq] = ACTIONS(952),
    [anon_sym_iszero] = ACTIONS(952),
    [anon_sym_and] = ACTIONS(952),
    [anon_sym_or] = ACTIONS(952),
    [anon_sym_xor] = ACTIONS(952),
    [anon_sym_byte] = ACTIONS(952),
    [anon_sym_shl] = ACTIONS(952),
    [anon_sym_shr] = ACTIONS(952),
    [anon_sym_sar] = ACTIONS(952),
    [anon_sym_addmod] = ACTIONS(952),
    [anon_sym_mulmod] = ACTIONS(952),
    [anon_sym_signextend] = ACTIONS(952),
    [anon_sym_keccak256] = ACTIONS(952),
    [anon_sym_pop] = ACTIONS(952),
    [anon_sym_mload] = ACTIONS(952),
    [anon_sym_mcopy] = ACTIONS(952),
    [anon_sym_tload] = ACTIONS(952),
    [anon_sym_tstore] = ACTIONS(952),
    [anon_sym_mstore] = ACTIONS(952),
    [anon_sym_mstore8] = ACTIONS(952),
    [anon_sym_sload] = ACTIONS(952),
    [anon_sym_sstore] = ACTIONS(952),
    [anon_sym_msize] = ACTIONS(952),
    [anon_sym_gas] = ACTIONS(952),
    [anon_sym_address] = ACTIONS(952),
    [anon_sym_balance] = ACTIONS(952),
    [anon_sym_selfbalance] = ACTIONS(952),
    [anon_sym_caller] = ACTIONS(952),
    [anon_sym_callvalue] = ACTIONS(952),
    [anon_sym_calldataload] = ACTIONS(952),
    [anon_sym_calldatasize] = ACTIONS(952),
    [anon_sym_calldatacopy] = ACTIONS(952),
    [anon_sym_extcodesize] = ACTIONS(952),
    [anon_sym_extcodecopy] = ACTIONS(952),
    [anon_sym_returndatasize] = ACTIONS(952),
    [anon_sym_returndatacopy] = ACTIONS(952),
    [anon_sym_extcodehash] = ACTIONS(952),
    [anon_sym_create] = ACTIONS(952),
    [anon_sym_create2] = ACTIONS(952),
    [anon_sym_call] = ACTIONS(952),
    [anon_sym_callcode] = ACTIONS(952),
    [anon_sym_delegatecall] = ACTIONS(952),
    [anon_sym_staticcall] = ACTIONS(952),
    [anon_sym_return] = ACTIONS(952),
    [anon_sym_revert] = ACTIONS(952),
    [anon_sym_selfdestruct] = ACTIONS(952),
    [anon_sym_invalid] = ACTIONS(952),
    [anon_sym_log0] = ACTIONS(952),
    [anon_sym_log1] = ACTIONS(952),
    [anon_sym_log2] = ACTIONS(952),
    [anon_sym_log3] = ACTIONS(952),
    [anon_sym_log4] = ACTIONS(952),
    [anon_sym_chainid] = ACTIONS(952),
    [anon_sym_origin] = ACTIONS(952),
    [anon_sym_gasprice] = ACTIONS(952),
    [anon_sym_blockhash] = ACTIONS(952),
    [anon_sym_blobhash] = ACTIONS(952),
    [anon_sym_basefee] = ACTIONS(952),
    [anon_sym_blobfee] = ACTIONS(952),
    [anon_sym_coinbase] = ACTIONS(952),
    [anon_sym_timestamp] = ACTIONS(952),
    [anon_sym_number] = ACTIONS(952),
    [anon_sym_difficulty] = ACTIONS(952),
    [anon_sym_gaslimit] = ACTIONS(952),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [anon_sym_SQUOTE] = ACTIONS(954),
    [sym_comment] = ACTIONS(3),
  },
  [231] = {
    [sym_identifier] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_COMMA] = ACTIONS(958),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(958),
    [anon_sym_RPAREN] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_COLON] = ACTIONS(956),
    [sym_yul_leave] = ACTIONS(956),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_DOT] = ACTIONS(958),
    [sym_yul_decimal_number] = ACTIONS(956),
    [sym_yul_hex_number] = ACTIONS(958),
    [anon_sym_true] = ACTIONS(956),
    [anon_sym_false] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_COLON_EQ] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_default] = ACTIONS(956),
    [anon_sym_case] = ACTIONS(956),
    [anon_sym_function] = ACTIONS(956),
    [anon_sym_stop] = ACTIONS(956),
    [anon_sym_add] = ACTIONS(956),
    [anon_sym_sub] = ACTIONS(956),
    [anon_sym_mul] = ACTIONS(956),
    [anon_sym_div] = ACTIONS(956),
    [anon_sym_sdiv] = ACTIONS(956),
    [anon_sym_mod] = ACTIONS(956),
    [anon_sym_smod] = ACTIONS(956),
    [anon_sym_exp] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(956),
    [anon_sym_lt] = ACTIONS(956),
    [anon_sym_gt] = ACTIONS(956),
    [anon_sym_slt] = ACTIONS(956),
    [anon_sym_sgt] = ACTIONS(956),
    [anon_sym_eq] = ACTIONS(956),
    [anon_sym_iszero] = ACTIONS(956),
    [anon_sym_and] = ACTIONS(956),
    [anon_sym_or] = ACTIONS(956),
    [anon_sym_xor] = ACTIONS(956),
    [anon_sym_byte] = ACTIONS(956),
    [anon_sym_shl] = ACTIONS(956),
    [anon_sym_shr] = ACTIONS(956),
    [anon_sym_sar] = ACTIONS(956),
    [anon_sym_addmod] = ACTIONS(956),
    [anon_sym_mulmod] = ACTIONS(956),
    [anon_sym_signextend] = ACTIONS(956),
    [anon_sym_keccak256] = ACTIONS(956),
    [anon_sym_pop] = ACTIONS(956),
    [anon_sym_mload] = ACTIONS(956),
    [anon_sym_mcopy] = ACTIONS(956),
    [anon_sym_tload] = ACTIONS(956),
    [anon_sym_tstore] = ACTIONS(956),
    [anon_sym_mstore] = ACTIONS(956),
    [anon_sym_mstore8] = ACTIONS(956),
    [anon_sym_sload] = ACTIONS(956),
    [anon_sym_sstore] = ACTIONS(956),
    [anon_sym_msize] = ACTIONS(956),
    [anon_sym_gas] = ACTIONS(956),
    [anon_sym_address] = ACTIONS(956),
    [anon_sym_balance] = ACTIONS(956),
    [anon_sym_selfbalance] = ACTIONS(956),
    [anon_sym_caller] = ACTIONS(956),
    [anon_sym_callvalue] = ACTIONS(956),
    [anon_sym_calldataload] = ACTIONS(956),
    [anon_sym_calldatasize] = ACTIONS(956),
    [anon_sym_calldatacopy] = ACTIONS(956),
    [anon_sym_extcodesize] = ACTIONS(956),
    [anon_sym_extcodecopy] = ACTIONS(956),
    [anon_sym_returndatasize] = ACTIONS(956),
    [anon_sym_returndatacopy] = ACTIONS(956),
    [anon_sym_extcodehash] = ACTIONS(956),
    [anon_sym_create] = ACTIONS(956),
    [anon_sym_create2] = ACTIONS(956),
    [anon_sym_call] = ACTIONS(956),
    [anon_sym_callcode] = ACTIONS(956),
    [anon_sym_delegatecall] = ACTIONS(956),
    [anon_sym_staticcall] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_revert] = ACTIONS(956),
    [anon_sym_selfdestruct] = ACTIONS(956),
    [anon_sym_invalid] = ACTIONS(956),
    [anon_sym_log0] = ACTIONS(956),
    [anon_sym_log1] = ACTIONS(956),
    [anon_sym_log2] = ACTIONS(956),
    [anon_sym_log3] = ACTIONS(956),
    [anon_sym_log4] = ACTIONS(956),
    [anon_sym_chainid] = ACTIONS(956),
    [anon_sym_origin] = ACTIONS(956),
    [anon_sym_gasprice] = ACTIONS(956),
    [anon_sym_blockhash] = ACTIONS(956),
    [anon_sym_blobhash] = ACTIONS(956),
    [anon_sym_basefee] = ACTIONS(956),
    [anon_sym_blobfee] = ACTIONS(956),
    [anon_sym_coinbase] = ACTIONS(956),
    [anon_sym_timestamp] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_difficulty] = ACTIONS(956),
    [anon_sym_gaslimit] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_identifier] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(947),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_for] = ACTIONS(945),
    [anon_sym_COLON] = ACTIONS(945),
    [sym_yul_leave] = ACTIONS(945),
    [anon_sym_break] = ACTIONS(945),
    [anon_sym_continue] = ACTIONS(945),
    [anon_sym_DOT] = ACTIONS(947),
    [sym_yul_decimal_number] = ACTIONS(945),
    [sym_yul_hex_number] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(945),
    [anon_sym_false] = ACTIONS(945),
    [anon_sym_let] = ACTIONS(945),
    [anon_sym_COLON_EQ] = ACTIONS(947),
    [anon_sym_if] = ACTIONS(945),
    [anon_sym_switch] = ACTIONS(945),
    [anon_sym_default] = ACTIONS(945),
    [anon_sym_case] = ACTIONS(945),
    [anon_sym_function] = ACTIONS(945),
    [anon_sym_stop] = ACTIONS(945),
    [anon_sym_add] = ACTIONS(945),
    [anon_sym_sub] = ACTIONS(945),
    [anon_sym_mul] = ACTIONS(945),
    [anon_sym_div] = ACTIONS(945),
    [anon_sym_sdiv] = ACTIONS(945),
    [anon_sym_mod] = ACTIONS(945),
    [anon_sym_smod] = ACTIONS(945),
    [anon_sym_exp] = ACTIONS(945),
    [anon_sym_not] = ACTIONS(945),
    [anon_sym_lt] = ACTIONS(945),
    [anon_sym_gt] = ACTIONS(945),
    [anon_sym_slt] = ACTIONS(945),
    [anon_sym_sgt] = ACTIONS(945),
    [anon_sym_eq] = ACTIONS(945),
    [anon_sym_iszero] = ACTIONS(945),
    [anon_sym_and] = ACTIONS(945),
    [anon_sym_or] = ACTIONS(945),
    [anon_sym_xor] = ACTIONS(945),
    [anon_sym_byte] = ACTIONS(945),
    [anon_sym_shl] = ACTIONS(945),
    [anon_sym_shr] = ACTIONS(945),
    [anon_sym_sar] = ACTIONS(945),
    [anon_sym_addmod] = ACTIONS(945),
    [anon_sym_mulmod] = ACTIONS(945),
    [anon_sym_signextend] = ACTIONS(945),
    [anon_sym_keccak256] = ACTIONS(945),
    [anon_sym_pop] = ACTIONS(945),
    [anon_sym_mload] = ACTIONS(945),
    [anon_sym_mcopy] = ACTIONS(945),
    [anon_sym_tload] = ACTIONS(945),
    [anon_sym_tstore] = ACTIONS(945),
    [anon_sym_mstore] = ACTIONS(945),
    [anon_sym_mstore8] = ACTIONS(945),
    [anon_sym_sload] = ACTIONS(945),
    [anon_sym_sstore] = ACTIONS(945),
    [anon_sym_msize] = ACTIONS(945),
    [anon_sym_gas] = ACTIONS(945),
    [anon_sym_address] = ACTIONS(945),
    [anon_sym_balance] = ACTIONS(945),
    [anon_sym_selfbalance] = ACTIONS(945),
    [anon_sym_caller] = ACTIONS(945),
    [anon_sym_callvalue] = ACTIONS(945),
    [anon_sym_calldataload] = ACTIONS(945),
    [anon_sym_calldatasize] = ACTIONS(945),
    [anon_sym_calldatacopy] = ACTIONS(945),
    [anon_sym_extcodesize] = ACTIONS(945),
    [anon_sym_extcodecopy] = ACTIONS(945),
    [anon_sym_returndatasize] = ACTIONS(945),
    [anon_sym_returndatacopy] = ACTIONS(945),
    [anon_sym_extcodehash] = ACTIONS(945),
    [anon_sym_create] = ACTIONS(945),
    [anon_sym_create2] = ACTIONS(945),
    [anon_sym_call] = ACTIONS(945),
    [anon_sym_callcode] = ACTIONS(945),
    [anon_sym_delegatecall] = ACTIONS(945),
    [anon_sym_staticcall] = ACTIONS(945),
    [anon_sym_return] = ACTIONS(945),
    [anon_sym_revert] = ACTIONS(945),
    [anon_sym_selfdestruct] = ACTIONS(945),
    [anon_sym_invalid] = ACTIONS(945),
    [anon_sym_log0] = ACTIONS(945),
    [anon_sym_log1] = ACTIONS(945),
    [anon_sym_log2] = ACTIONS(945),
    [anon_sym_log3] = ACTIONS(945),
    [anon_sym_log4] = ACTIONS(945),
    [anon_sym_chainid] = ACTIONS(945),
    [anon_sym_origin] = ACTIONS(945),
    [anon_sym_gasprice] = ACTIONS(945),
    [anon_sym_blockhash] = ACTIONS(945),
    [anon_sym_blobhash] = ACTIONS(945),
    [anon_sym_basefee] = ACTIONS(945),
    [anon_sym_blobfee] = ACTIONS(945),
    [anon_sym_coinbase] = ACTIONS(945),
    [anon_sym_timestamp] = ACTIONS(945),
    [anon_sym_number] = ACTIONS(945),
    [anon_sym_difficulty] = ACTIONS(945),
    [anon_sym_gaslimit] = ACTIONS(945),
    [anon_sym_DQUOTE] = ACTIONS(947),
    [anon_sym_SQUOTE] = ACTIONS(947),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_identifier] = ACTIONS(956),
    [anon_sym_LBRACE] = ACTIONS(958),
    [anon_sym_COMMA] = ACTIONS(958),
    [anon_sym_RBRACE] = ACTIONS(958),
    [anon_sym_LPAREN] = ACTIONS(958),
    [anon_sym_for] = ACTIONS(956),
    [anon_sym_COLON] = ACTIONS(960),
    [sym_yul_leave] = ACTIONS(956),
    [anon_sym_break] = ACTIONS(956),
    [anon_sym_continue] = ACTIONS(956),
    [anon_sym_DOT] = ACTIONS(958),
    [sym_yul_decimal_number] = ACTIONS(956),
    [sym_yul_hex_number] = ACTIONS(958),
    [anon_sym_true] = ACTIONS(956),
    [anon_sym_false] = ACTIONS(956),
    [anon_sym_let] = ACTIONS(956),
    [anon_sym_COLON_EQ] = ACTIONS(958),
    [anon_sym_if] = ACTIONS(956),
    [anon_sym_switch] = ACTIONS(956),
    [anon_sym_function] = ACTIONS(956),
    [anon_sym_stop] = ACTIONS(956),
    [anon_sym_add] = ACTIONS(956),
    [anon_sym_sub] = ACTIONS(956),
    [anon_sym_mul] = ACTIONS(956),
    [anon_sym_div] = ACTIONS(956),
    [anon_sym_sdiv] = ACTIONS(956),
    [anon_sym_mod] = ACTIONS(956),
    [anon_sym_smod] = ACTIONS(956),
    [anon_sym_exp] = ACTIONS(956),
    [anon_sym_not] = ACTIONS(956),
    [anon_sym_lt] = ACTIONS(956),
    [anon_sym_gt] = ACTIONS(956),
    [anon_sym_slt] = ACTIONS(956),
    [anon_sym_sgt] = ACTIONS(956),
    [anon_sym_eq] = ACTIONS(956),
    [anon_sym_iszero] = ACTIONS(956),
    [anon_sym_and] = ACTIONS(956),
    [anon_sym_or] = ACTIONS(956),
    [anon_sym_xor] = ACTIONS(956),
    [anon_sym_byte] = ACTIONS(956),
    [anon_sym_shl] = ACTIONS(956),
    [anon_sym_shr] = ACTIONS(956),
    [anon_sym_sar] = ACTIONS(956),
    [anon_sym_addmod] = ACTIONS(956),
    [anon_sym_mulmod] = ACTIONS(956),
    [anon_sym_signextend] = ACTIONS(956),
    [anon_sym_keccak256] = ACTIONS(956),
    [anon_sym_pop] = ACTIONS(956),
    [anon_sym_mload] = ACTIONS(956),
    [anon_sym_mcopy] = ACTIONS(956),
    [anon_sym_tload] = ACTIONS(956),
    [anon_sym_tstore] = ACTIONS(956),
    [anon_sym_mstore] = ACTIONS(956),
    [anon_sym_mstore8] = ACTIONS(956),
    [anon_sym_sload] = ACTIONS(956),
    [anon_sym_sstore] = ACTIONS(956),
    [anon_sym_msize] = ACTIONS(956),
    [anon_sym_gas] = ACTIONS(956),
    [anon_sym_address] = ACTIONS(956),
    [anon_sym_balance] = ACTIONS(956),
    [anon_sym_selfbalance] = ACTIONS(956),
    [anon_sym_caller] = ACTIONS(956),
    [anon_sym_callvalue] = ACTIONS(956),
    [anon_sym_calldataload] = ACTIONS(956),
    [anon_sym_calldatasize] = ACTIONS(956),
    [anon_sym_calldatacopy] = ACTIONS(956),
    [anon_sym_extcodesize] = ACTIONS(956),
    [anon_sym_extcodecopy] = ACTIONS(956),
    [anon_sym_returndatasize] = ACTIONS(956),
    [anon_sym_returndatacopy] = ACTIONS(956),
    [anon_sym_extcodehash] = ACTIONS(956),
    [anon_sym_create] = ACTIONS(956),
    [anon_sym_create2] = ACTIONS(956),
    [anon_sym_call] = ACTIONS(956),
    [anon_sym_callcode] = ACTIONS(956),
    [anon_sym_delegatecall] = ACTIONS(956),
    [anon_sym_staticcall] = ACTIONS(956),
    [anon_sym_return] = ACTIONS(956),
    [anon_sym_revert] = ACTIONS(956),
    [anon_sym_selfdestruct] = ACTIONS(956),
    [anon_sym_invalid] = ACTIONS(956),
    [anon_sym_log0] = ACTIONS(956),
    [anon_sym_log1] = ACTIONS(956),
    [anon_sym_log2] = ACTIONS(956),
    [anon_sym_log3] = ACTIONS(956),
    [anon_sym_log4] = ACTIONS(956),
    [anon_sym_chainid] = ACTIONS(956),
    [anon_sym_origin] = ACTIONS(956),
    [anon_sym_gasprice] = ACTIONS(956),
    [anon_sym_blockhash] = ACTIONS(956),
    [anon_sym_blobhash] = ACTIONS(956),
    [anon_sym_basefee] = ACTIONS(956),
    [anon_sym_blobfee] = ACTIONS(956),
    [anon_sym_coinbase] = ACTIONS(956),
    [anon_sym_timestamp] = ACTIONS(956),
    [anon_sym_number] = ACTIONS(956),
    [anon_sym_difficulty] = ACTIONS(956),
    [anon_sym_gaslimit] = ACTIONS(956),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [anon_sym_SQUOTE] = ACTIONS(958),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_identifier] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_COMMA] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym_LPAREN] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_for] = ACTIONS(963),
    [sym_yul_leave] = ACTIONS(963),
    [anon_sym_break] = ACTIONS(963),
    [anon_sym_continue] = ACTIONS(963),
    [sym_yul_decimal_number] = ACTIONS(963),
    [sym_yul_hex_number] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(963),
    [anon_sym_false] = ACTIONS(963),
    [anon_sym_let] = ACTIONS(963),
    [anon_sym_if] = ACTIONS(963),
    [anon_sym_switch] = ACTIONS(963),
    [anon_sym_default] = ACTIONS(963),
    [anon_sym_case] = ACTIONS(963),
    [anon_sym_function] = ACTIONS(963),
    [anon_sym_stop] = ACTIONS(963),
    [anon_sym_add] = ACTIONS(963),
    [anon_sym_sub] = ACTIONS(963),
    [anon_sym_mul] = ACTIONS(963),
    [anon_sym_div] = ACTIONS(963),
    [anon_sym_sdiv] = ACTIONS(963),
    [anon_sym_mod] = ACTIONS(963),
    [anon_sym_smod] = ACTIONS(963),
    [anon_sym_exp] = ACTIONS(963),
    [anon_sym_not] = ACTIONS(963),
    [anon_sym_lt] = ACTIONS(963),
    [anon_sym_gt] = ACTIONS(963),
    [anon_sym_slt] = ACTIONS(963),
    [anon_sym_sgt] = ACTIONS(963),
    [anon_sym_eq] = ACTIONS(963),
    [anon_sym_iszero] = ACTIONS(963),
    [anon_sym_and] = ACTIONS(963),
    [anon_sym_or] = ACTIONS(963),
    [anon_sym_xor] = ACTIONS(963),
    [anon_sym_byte] = ACTIONS(963),
    [anon_sym_shl] = ACTIONS(963),
    [anon_sym_shr] = ACTIONS(963),
    [anon_sym_sar] = ACTIONS(963),
    [anon_sym_addmod] = ACTIONS(963),
    [anon_sym_mulmod] = ACTIONS(963),
    [anon_sym_signextend] = ACTIONS(963),
    [anon_sym_keccak256] = ACTIONS(963),
    [anon_sym_pop] = ACTIONS(963),
    [anon_sym_mload] = ACTIONS(963),
    [anon_sym_mcopy] = ACTIONS(963),
    [anon_sym_tload] = ACTIONS(963),
    [anon_sym_tstore] = ACTIONS(963),
    [anon_sym_mstore] = ACTIONS(963),
    [anon_sym_mstore8] = ACTIONS(963),
    [anon_sym_sload] = ACTIONS(963),
    [anon_sym_sstore] = ACTIONS(963),
    [anon_sym_msize] = ACTIONS(963),
    [anon_sym_gas] = ACTIONS(963),
    [anon_sym_address] = ACTIONS(963),
    [anon_sym_balance] = ACTIONS(963),
    [anon_sym_selfbalance] = ACTIONS(963),
    [anon_sym_caller] = ACTIONS(963),
    [anon_sym_callvalue] = ACTIONS(963),
    [anon_sym_calldataload] = ACTIONS(963),
    [anon_sym_calldatasize] = ACTIONS(963),
    [anon_sym_calldatacopy] = ACTIONS(963),
    [anon_sym_extcodesize] = ACTIONS(963),
    [anon_sym_extcodecopy] = ACTIONS(963),
    [anon_sym_returndatasize] = ACTIONS(963),
    [anon_sym_returndatacopy] = ACTIONS(963),
    [anon_sym_extcodehash] = ACTIONS(963),
    [anon_sym_create] = ACTIONS(963),
    [anon_sym_create2] = ACTIONS(963),
    [anon_sym_call] = ACTIONS(963),
    [anon_sym_callcode] = ACTIONS(963),
    [anon_sym_delegatecall] = ACTIONS(963),
    [anon_sym_staticcall] = ACTIONS(963),
    [anon_sym_return] = ACTIONS(963),
    [anon_sym_revert] = ACTIONS(963),
    [anon_sym_selfdestruct] = ACTIONS(963),
    [anon_sym_invalid] = ACTIONS(963),
    [anon_sym_log0] = ACTIONS(963),
    [anon_sym_log1] = ACTIONS(963),
    [anon_sym_log2] = ACTIONS(963),
    [anon_sym_log3] = ACTIONS(963),
    [anon_sym_log4] = ACTIONS(963),
    [anon_sym_chainid] = ACTIONS(963),
    [anon_sym_origin] = ACTIONS(963),
    [anon_sym_gasprice] = ACTIONS(963),
    [anon_sym_blockhash] = ACTIONS(963),
    [anon_sym_blobhash] = ACTIONS(963),
    [anon_sym_basefee] = ACTIONS(963),
    [anon_sym_blobfee] = ACTIONS(963),
    [anon_sym_coinbase] = ACTIONS(963),
    [anon_sym_timestamp] = ACTIONS(963),
    [anon_sym_number] = ACTIONS(963),
    [anon_sym_difficulty] = ACTIONS(963),
    [anon_sym_gaslimit] = ACTIONS(963),
    [anon_sym_DQUOTE] = ACTIONS(965),
    [anon_sym_SQUOTE] = ACTIONS(965),
    [sym_comment] = ACTIONS(3),
  },
  [235] = {
    [aux_sym_yul_path_repeat1] = STATE(230),
    [sym_identifier] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_for] = ACTIONS(937),
    [anon_sym_COLON] = ACTIONS(937),
    [sym_yul_leave] = ACTIONS(937),
    [anon_sym_break] = ACTIONS(937),
    [anon_sym_continue] = ACTIONS(937),
    [anon_sym_DOT] = ACTIONS(943),
    [sym_yul_decimal_number] = ACTIONS(937),
    [sym_yul_hex_number] = ACTIONS(939),
    [anon_sym_true] = ACTIONS(937),
    [anon_sym_false] = ACTIONS(937),
    [anon_sym_let] = ACTIONS(937),
    [anon_sym_COLON_EQ] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(937),
    [anon_sym_switch] = ACTIONS(937),
    [anon_sym_function] = ACTIONS(937),
    [anon_sym_stop] = ACTIONS(937),
    [anon_sym_add] = ACTIONS(937),
    [anon_sym_sub] = ACTIONS(937),
    [anon_sym_mul] = ACTIONS(937),
    [anon_sym_div] = ACTIONS(937),
    [anon_sym_sdiv] = ACTIONS(937),
    [anon_sym_mod] = ACTIONS(937),
    [anon_sym_smod] = ACTIONS(937),
    [anon_sym_exp] = ACTIONS(937),
    [anon_sym_not] = ACTIONS(937),
    [anon_sym_lt] = ACTIONS(937),
    [anon_sym_gt] = ACTIONS(937),
    [anon_sym_slt] = ACTIONS(937),
    [anon_sym_sgt] = ACTIONS(937),
    [anon_sym_eq] = ACTIONS(937),
    [anon_sym_iszero] = ACTIONS(937),
    [anon_sym_and] = ACTIONS(937),
    [anon_sym_or] = ACTIONS(937),
    [anon_sym_xor] = ACTIONS(937),
    [anon_sym_byte] = ACTIONS(937),
    [anon_sym_shl] = ACTIONS(937),
    [anon_sym_shr] = ACTIONS(937),
    [anon_sym_sar] = ACTIONS(937),
    [anon_sym_addmod] = ACTIONS(937),
    [anon_sym_mulmod] = ACTIONS(937),
    [anon_sym_signextend] = ACTIONS(937),
    [anon_sym_keccak256] = ACTIONS(937),
    [anon_sym_pop] = ACTIONS(937),
    [anon_sym_mload] = ACTIONS(937),
    [anon_sym_mcopy] = ACTIONS(937),
    [anon_sym_tload] = ACTIONS(937),
    [anon_sym_tstore] = ACTIONS(937),
    [anon_sym_mstore] = ACTIONS(937),
    [anon_sym_mstore8] = ACTIONS(937),
    [anon_sym_sload] = ACTIONS(937),
    [anon_sym_sstore] = ACTIONS(937),
    [anon_sym_msize] = ACTIONS(937),
    [anon_sym_gas] = ACTIONS(937),
    [anon_sym_address] = ACTIONS(937),
    [anon_sym_balance] = ACTIONS(937),
    [anon_sym_selfbalance] = ACTIONS(937),
    [anon_sym_caller] = ACTIONS(937),
    [anon_sym_callvalue] = ACTIONS(937),
    [anon_sym_calldataload] = ACTIONS(937),
    [anon_sym_calldatasize] = ACTIONS(937),
    [anon_sym_calldatacopy] = ACTIONS(937),
    [anon_sym_extcodesize] = ACTIONS(937),
    [anon_sym_extcodecopy] = ACTIONS(937),
    [anon_sym_returndatasize] = ACTIONS(937),
    [anon_sym_returndatacopy] = ACTIONS(937),
    [anon_sym_extcodehash] = ACTIONS(937),
    [anon_sym_create] = ACTIONS(937),
    [anon_sym_create2] = ACTIONS(937),
    [anon_sym_call] = ACTIONS(937),
    [anon_sym_callcode] = ACTIONS(937),
    [anon_sym_delegatecall] = ACTIONS(937),
    [anon_sym_staticcall] = ACTIONS(937),
    [anon_sym_return] = ACTIONS(937),
    [anon_sym_revert] = ACTIONS(937),
    [anon_sym_selfdestruct] = ACTIONS(937),
    [anon_sym_invalid] = ACTIONS(937),
    [anon_sym_log0] = ACTIONS(937),
    [anon_sym_log1] = ACTIONS(937),
    [anon_sym_log2] = ACTIONS(937),
    [anon_sym_log3] = ACTIONS(937),
    [anon_sym_log4] = ACTIONS(937),
    [anon_sym_chainid] = ACTIONS(937),
    [anon_sym_origin] = ACTIONS(937),
    [anon_sym_gasprice] = ACTIONS(937),
    [anon_sym_blockhash] = ACTIONS(937),
    [anon_sym_blobhash] = ACTIONS(937),
    [anon_sym_basefee] = ACTIONS(937),
    [anon_sym_blobfee] = ACTIONS(937),
    [anon_sym_coinbase] = ACTIONS(937),
    [anon_sym_timestamp] = ACTIONS(937),
    [anon_sym_number] = ACTIONS(937),
    [anon_sym_difficulty] = ACTIONS(937),
    [anon_sym_gaslimit] = ACTIONS(937),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_SQUOTE] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [sym_identifier] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(969),
    [anon_sym_COMMA] = ACTIONS(969),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym_LPAREN] = ACTIONS(969),
    [anon_sym_RPAREN] = ACTIONS(969),
    [anon_sym_for] = ACTIONS(967),
    [sym_yul_leave] = ACTIONS(967),
    [anon_sym_break] = ACTIONS(967),
    [anon_sym_continue] = ACTIONS(967),
    [sym_yul_decimal_number] = ACTIONS(967),
    [sym_yul_hex_number] = ACTIONS(969),
    [anon_sym_true] = ACTIONS(967),
    [anon_sym_false] = ACTIONS(967),
    [anon_sym_let] = ACTIONS(967),
    [anon_sym_if] = ACTIONS(967),
    [anon_sym_switch] = ACTIONS(967),
    [anon_sym_default] = ACTIONS(967),
    [anon_sym_case] = ACTIONS(967),
    [anon_sym_function] = ACTIONS(967),
    [anon_sym_stop] = ACTIONS(967),
    [anon_sym_add] = ACTIONS(967),
    [anon_sym_sub] = ACTIONS(967),
    [anon_sym_mul] = ACTIONS(967),
    [anon_sym_div] = ACTIONS(967),
    [anon_sym_sdiv] = ACTIONS(967),
    [anon_sym_mod] = ACTIONS(967),
    [anon_sym_smod] = ACTIONS(967),
    [anon_sym_exp] = ACTIONS(967),
    [anon_sym_not] = ACTIONS(967),
    [anon_sym_lt] = ACTIONS(967),
    [anon_sym_gt] = ACTIONS(967),
    [anon_sym_slt] = ACTIONS(967),
    [anon_sym_sgt] = ACTIONS(967),
    [anon_sym_eq] = ACTIONS(967),
    [anon_sym_iszero] = ACTIONS(967),
    [anon_sym_and] = ACTIONS(967),
    [anon_sym_or] = ACTIONS(967),
    [anon_sym_xor] = ACTIONS(967),
    [anon_sym_byte] = ACTIONS(967),
    [anon_sym_shl] = ACTIONS(967),
    [anon_sym_shr] = ACTIONS(967),
    [anon_sym_sar] = ACTIONS(967),
    [anon_sym_addmod] = ACTIONS(967),
    [anon_sym_mulmod] = ACTIONS(967),
    [anon_sym_signextend] = ACTIONS(967),
    [anon_sym_keccak256] = ACTIONS(967),
    [anon_sym_pop] = ACTIONS(967),
    [anon_sym_mload] = ACTIONS(967),
    [anon_sym_mcopy] = ACTIONS(967),
    [anon_sym_tload] = ACTIONS(967),
    [anon_sym_tstore] = ACTIONS(967),
    [anon_sym_mstore] = ACTIONS(967),
    [anon_sym_mstore8] = ACTIONS(967),
    [anon_sym_sload] = ACTIONS(967),
    [anon_sym_sstore] = ACTIONS(967),
    [anon_sym_msize] = ACTIONS(967),
    [anon_sym_gas] = ACTIONS(967),
    [anon_sym_address] = ACTIONS(967),
    [anon_sym_balance] = ACTIONS(967),
    [anon_sym_selfbalance] = ACTIONS(967),
    [anon_sym_caller] = ACTIONS(967),
    [anon_sym_callvalue] = ACTIONS(967),
    [anon_sym_calldataload] = ACTIONS(967),
    [anon_sym_calldatasize] = ACTIONS(967),
    [anon_sym_calldatacopy] = ACTIONS(967),
    [anon_sym_extcodesize] = ACTIONS(967),
    [anon_sym_extcodecopy] = ACTIONS(967),
    [anon_sym_returndatasize] = ACTIONS(967),
    [anon_sym_returndatacopy] = ACTIONS(967),
    [anon_sym_extcodehash] = ACTIONS(967),
    [anon_sym_create] = ACTIONS(967),
    [anon_sym_create2] = ACTIONS(967),
    [anon_sym_call] = ACTIONS(967),
    [anon_sym_callcode] = ACTIONS(967),
    [anon_sym_delegatecall] = ACTIONS(967),
    [anon_sym_staticcall] = ACTIONS(967),
    [anon_sym_return] = ACTIONS(967),
    [anon_sym_revert] = ACTIONS(967),
    [anon_sym_selfdestruct] = ACTIONS(967),
    [anon_sym_invalid] = ACTIONS(967),
    [anon_sym_log0] = ACTIONS(967),
    [anon_sym_log1] = ACTIONS(967),
    [anon_sym_log2] = ACTIONS(967),
    [anon_sym_log3] = ACTIONS(967),
    [anon_sym_log4] = ACTIONS(967),
    [anon_sym_chainid] = ACTIONS(967),
    [anon_sym_origin] = ACTIONS(967),
    [anon_sym_gasprice] = ACTIONS(967),
    [anon_sym_blockhash] = ACTIONS(967),
    [anon_sym_blobhash] = ACTIONS(967),
    [anon_sym_basefee] = ACTIONS(967),
    [anon_sym_blobfee] = ACTIONS(967),
    [anon_sym_coinbase] = ACTIONS(967),
    [anon_sym_timestamp] = ACTIONS(967),
    [anon_sym_number] = ACTIONS(967),
    [anon_sym_difficulty] = ACTIONS(967),
    [anon_sym_gaslimit] = ACTIONS(967),
    [anon_sym_DQUOTE] = ACTIONS(969),
    [anon_sym_SQUOTE] = ACTIONS(969),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [sym__yul_assignment_operator] = STATE(294),
    [aux_sym_yul_assignment_repeat1] = STATE(240),
    [sym_identifier] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(975),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_COLON] = ACTIONS(977),
    [sym_yul_leave] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [anon_sym_continue] = ACTIONS(971),
    [sym_yul_decimal_number] = ACTIONS(971),
    [sym_yul_hex_number] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(971),
    [anon_sym_false] = ACTIONS(971),
    [anon_sym_let] = ACTIONS(971),
    [anon_sym_COLON_EQ] = ACTIONS(979),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_switch] = ACTIONS(971),
    [anon_sym_function] = ACTIONS(971),
    [anon_sym_stop] = ACTIONS(971),
    [anon_sym_add] = ACTIONS(971),
    [anon_sym_sub] = ACTIONS(971),
    [anon_sym_mul] = ACTIONS(971),
    [anon_sym_div] = ACTIONS(971),
    [anon_sym_sdiv] = ACTIONS(971),
    [anon_sym_mod] = ACTIONS(971),
    [anon_sym_smod] = ACTIONS(971),
    [anon_sym_exp] = ACTIONS(971),
    [anon_sym_not] = ACTIONS(971),
    [anon_sym_lt] = ACTIONS(971),
    [anon_sym_gt] = ACTIONS(971),
    [anon_sym_slt] = ACTIONS(971),
    [anon_sym_sgt] = ACTIONS(971),
    [anon_sym_eq] = ACTIONS(971),
    [anon_sym_iszero] = ACTIONS(971),
    [anon_sym_and] = ACTIONS(971),
    [anon_sym_or] = ACTIONS(971),
    [anon_sym_xor] = ACTIONS(971),
    [anon_sym_byte] = ACTIONS(971),
    [anon_sym_shl] = ACTIONS(971),
    [anon_sym_shr] = ACTIONS(971),
    [anon_sym_sar] = ACTIONS(971),
    [anon_sym_addmod] = ACTIONS(971),
    [anon_sym_mulmod] = ACTIONS(971),
    [anon_sym_signextend] = ACTIONS(971),
    [anon_sym_keccak256] = ACTIONS(971),
    [anon_sym_pop] = ACTIONS(971),
    [anon_sym_mload] = ACTIONS(971),
    [anon_sym_mcopy] = ACTIONS(971),
    [anon_sym_tload] = ACTIONS(971),
    [anon_sym_tstore] = ACTIONS(971),
    [anon_sym_mstore] = ACTIONS(971),
    [anon_sym_mstore8] = ACTIONS(971),
    [anon_sym_sload] = ACTIONS(971),
    [anon_sym_sstore] = ACTIONS(971),
    [anon_sym_msize] = ACTIONS(971),
    [anon_sym_gas] = ACTIONS(971),
    [anon_sym_address] = ACTIONS(971),
    [anon_sym_balance] = ACTIONS(971),
    [anon_sym_selfbalance] = ACTIONS(971),
    [anon_sym_caller] = ACTIONS(971),
    [anon_sym_callvalue] = ACTIONS(971),
    [anon_sym_calldataload] = ACTIONS(971),
    [anon_sym_calldatasize] = ACTIONS(971),
    [anon_sym_calldatacopy] = ACTIONS(971),
    [anon_sym_extcodesize] = ACTIONS(971),
    [anon_sym_extcodecopy] = ACTIONS(971),
    [anon_sym_returndatasize] = ACTIONS(971),
    [anon_sym_returndatacopy] = ACTIONS(971),
    [anon_sym_extcodehash] = ACTIONS(971),
    [anon_sym_create] = ACTIONS(971),
    [anon_sym_create2] = ACTIONS(971),
    [anon_sym_call] = ACTIONS(971),
    [anon_sym_callcode] = ACTIONS(971),
    [anon_sym_delegatecall] = ACTIONS(971),
    [anon_sym_staticcall] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_revert] = ACTIONS(971),
    [anon_sym_selfdestruct] = ACTIONS(971),
    [anon_sym_invalid] = ACTIONS(971),
    [anon_sym_log0] = ACTIONS(971),
    [anon_sym_log1] = ACTIONS(971),
    [anon_sym_log2] = ACTIONS(971),
    [anon_sym_log3] = ACTIONS(971),
    [anon_sym_log4] = ACTIONS(971),
    [anon_sym_chainid] = ACTIONS(971),
    [anon_sym_origin] = ACTIONS(971),
    [anon_sym_gasprice] = ACTIONS(971),
    [anon_sym_blockhash] = ACTIONS(971),
    [anon_sym_blobhash] = ACTIONS(971),
    [anon_sym_basefee] = ACTIONS(971),
    [anon_sym_blobfee] = ACTIONS(971),
    [anon_sym_coinbase] = ACTIONS(971),
    [anon_sym_timestamp] = ACTIONS(971),
    [anon_sym_number] = ACTIONS(971),
    [anon_sym_difficulty] = ACTIONS(971),
    [anon_sym_gaslimit] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_yul_identifier] = STATE(235),
    [sym_yul_path] = STATE(252),
    [sym__yul_assignment_operator] = STATE(302),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_COLON] = ACTIONS(977),
    [sym_yul_leave] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_continue] = ACTIONS(981),
    [sym_yul_decimal_number] = ACTIONS(981),
    [sym_yul_hex_number] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_COLON_EQ] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_switch] = ACTIONS(981),
    [anon_sym_function] = ACTIONS(981),
    [anon_sym_stop] = ACTIONS(981),
    [anon_sym_add] = ACTIONS(981),
    [anon_sym_sub] = ACTIONS(981),
    [anon_sym_mul] = ACTIONS(981),
    [anon_sym_div] = ACTIONS(981),
    [anon_sym_sdiv] = ACTIONS(981),
    [anon_sym_mod] = ACTIONS(981),
    [anon_sym_smod] = ACTIONS(981),
    [anon_sym_exp] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(981),
    [anon_sym_lt] = ACTIONS(981),
    [anon_sym_gt] = ACTIONS(981),
    [anon_sym_slt] = ACTIONS(981),
    [anon_sym_sgt] = ACTIONS(981),
    [anon_sym_eq] = ACTIONS(981),
    [anon_sym_iszero] = ACTIONS(981),
    [anon_sym_and] = ACTIONS(981),
    [anon_sym_or] = ACTIONS(981),
    [anon_sym_xor] = ACTIONS(981),
    [anon_sym_byte] = ACTIONS(981),
    [anon_sym_shl] = ACTIONS(981),
    [anon_sym_shr] = ACTIONS(981),
    [anon_sym_sar] = ACTIONS(981),
    [anon_sym_addmod] = ACTIONS(981),
    [anon_sym_mulmod] = ACTIONS(981),
    [anon_sym_signextend] = ACTIONS(981),
    [anon_sym_keccak256] = ACTIONS(981),
    [anon_sym_pop] = ACTIONS(981),
    [anon_sym_mload] = ACTIONS(981),
    [anon_sym_mcopy] = ACTIONS(981),
    [anon_sym_tload] = ACTIONS(981),
    [anon_sym_tstore] = ACTIONS(981),
    [anon_sym_mstore] = ACTIONS(981),
    [anon_sym_mstore8] = ACTIONS(981),
    [anon_sym_sload] = ACTIONS(981),
    [anon_sym_sstore] = ACTIONS(981),
    [anon_sym_msize] = ACTIONS(981),
    [anon_sym_gas] = ACTIONS(981),
    [anon_sym_address] = ACTIONS(981),
    [anon_sym_balance] = ACTIONS(981),
    [anon_sym_selfbalance] = ACTIONS(981),
    [anon_sym_caller] = ACTIONS(981),
    [anon_sym_callvalue] = ACTIONS(981),
    [anon_sym_calldataload] = ACTIONS(981),
    [anon_sym_calldatasize] = ACTIONS(981),
    [anon_sym_calldatacopy] = ACTIONS(981),
    [anon_sym_extcodesize] = ACTIONS(981),
    [anon_sym_extcodecopy] = ACTIONS(981),
    [anon_sym_returndatasize] = ACTIONS(981),
    [anon_sym_returndatacopy] = ACTIONS(981),
    [anon_sym_extcodehash] = ACTIONS(981),
    [anon_sym_create] = ACTIONS(981),
    [anon_sym_create2] = ACTIONS(981),
    [anon_sym_call] = ACTIONS(981),
    [anon_sym_callcode] = ACTIONS(981),
    [anon_sym_delegatecall] = ACTIONS(981),
    [anon_sym_staticcall] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_revert] = ACTIONS(981),
    [anon_sym_selfdestruct] = ACTIONS(981),
    [anon_sym_invalid] = ACTIONS(981),
    [anon_sym_log0] = ACTIONS(981),
    [anon_sym_log1] = ACTIONS(981),
    [anon_sym_log2] = ACTIONS(981),
    [anon_sym_log3] = ACTIONS(981),
    [anon_sym_log4] = ACTIONS(981),
    [anon_sym_chainid] = ACTIONS(981),
    [anon_sym_origin] = ACTIONS(981),
    [anon_sym_gasprice] = ACTIONS(981),
    [anon_sym_blockhash] = ACTIONS(981),
    [anon_sym_blobhash] = ACTIONS(981),
    [anon_sym_basefee] = ACTIONS(981),
    [anon_sym_blobfee] = ACTIONS(981),
    [anon_sym_coinbase] = ACTIONS(981),
    [anon_sym_timestamp] = ACTIONS(981),
    [anon_sym_number] = ACTIONS(981),
    [anon_sym_difficulty] = ACTIONS(981),
    [anon_sym_gaslimit] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [sym_yul_identifier] = STATE(235),
    [sym_yul_path] = STATE(252),
    [sym__yul_assignment_operator] = STATE(304),
    [sym_identifier] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_for] = ACTIONS(987),
    [anon_sym_COLON] = ACTIONS(977),
    [sym_yul_leave] = ACTIONS(987),
    [anon_sym_break] = ACTIONS(987),
    [anon_sym_continue] = ACTIONS(987),
    [sym_yul_decimal_number] = ACTIONS(987),
    [sym_yul_hex_number] = ACTIONS(989),
    [anon_sym_true] = ACTIONS(987),
    [anon_sym_false] = ACTIONS(987),
    [anon_sym_let] = ACTIONS(987),
    [anon_sym_COLON_EQ] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_switch] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_stop] = ACTIONS(987),
    [anon_sym_add] = ACTIONS(987),
    [anon_sym_sub] = ACTIONS(987),
    [anon_sym_mul] = ACTIONS(987),
    [anon_sym_div] = ACTIONS(987),
    [anon_sym_sdiv] = ACTIONS(987),
    [anon_sym_mod] = ACTIONS(987),
    [anon_sym_smod] = ACTIONS(987),
    [anon_sym_exp] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(987),
    [anon_sym_lt] = ACTIONS(987),
    [anon_sym_gt] = ACTIONS(987),
    [anon_sym_slt] = ACTIONS(987),
    [anon_sym_sgt] = ACTIONS(987),
    [anon_sym_eq] = ACTIONS(987),
    [anon_sym_iszero] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(987),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_xor] = ACTIONS(987),
    [anon_sym_byte] = ACTIONS(987),
    [anon_sym_shl] = ACTIONS(987),
    [anon_sym_shr] = ACTIONS(987),
    [anon_sym_sar] = ACTIONS(987),
    [anon_sym_addmod] = ACTIONS(987),
    [anon_sym_mulmod] = ACTIONS(987),
    [anon_sym_signextend] = ACTIONS(987),
    [anon_sym_keccak256] = ACTIONS(987),
    [anon_sym_pop] = ACTIONS(987),
    [anon_sym_mload] = ACTIONS(987),
    [anon_sym_mcopy] = ACTIONS(987),
    [anon_sym_tload] = ACTIONS(987),
    [anon_sym_tstore] = ACTIONS(987),
    [anon_sym_mstore] = ACTIONS(987),
    [anon_sym_mstore8] = ACTIONS(987),
    [anon_sym_sload] = ACTIONS(987),
    [anon_sym_sstore] = ACTIONS(987),
    [anon_sym_msize] = ACTIONS(987),
    [anon_sym_gas] = ACTIONS(987),
    [anon_sym_address] = ACTIONS(987),
    [anon_sym_balance] = ACTIONS(987),
    [anon_sym_selfbalance] = ACTIONS(987),
    [anon_sym_caller] = ACTIONS(987),
    [anon_sym_callvalue] = ACTIONS(987),
    [anon_sym_calldataload] = ACTIONS(987),
    [anon_sym_calldatasize] = ACTIONS(987),
    [anon_sym_calldatacopy] = ACTIONS(987),
    [anon_sym_extcodesize] = ACTIONS(987),
    [anon_sym_extcodecopy] = ACTIONS(987),
    [anon_sym_returndatasize] = ACTIONS(987),
    [anon_sym_returndatacopy] = ACTIONS(987),
    [anon_sym_extcodehash] = ACTIONS(987),
    [anon_sym_create] = ACTIONS(987),
    [anon_sym_create2] = ACTIONS(987),
    [anon_sym_call] = ACTIONS(987),
    [anon_sym_callcode] = ACTIONS(987),
    [anon_sym_delegatecall] = ACTIONS(987),
    [anon_sym_staticcall] = ACTIONS(987),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_revert] = ACTIONS(987),
    [anon_sym_selfdestruct] = ACTIONS(987),
    [anon_sym_invalid] = ACTIONS(987),
    [anon_sym_log0] = ACTIONS(987),
    [anon_sym_log1] = ACTIONS(987),
    [anon_sym_log2] = ACTIONS(987),
    [anon_sym_log3] = ACTIONS(987),
    [anon_sym_log4] = ACTIONS(987),
    [anon_sym_chainid] = ACTIONS(987),
    [anon_sym_origin] = ACTIONS(987),
    [anon_sym_gasprice] = ACTIONS(987),
    [anon_sym_blockhash] = ACTIONS(987),
    [anon_sym_blobhash] = ACTIONS(987),
    [anon_sym_basefee] = ACTIONS(987),
    [anon_sym_blobfee] = ACTIONS(987),
    [anon_sym_coinbase] = ACTIONS(987),
    [anon_sym_timestamp] = ACTIONS(987),
    [anon_sym_number] = ACTIONS(987),
    [anon_sym_difficulty] = ACTIONS(987),
    [anon_sym_gaslimit] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym__yul_assignment_operator] = STATE(302),
    [aux_sym_yul_assignment_repeat1] = STATE(246),
    [sym_identifier] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(983),
    [anon_sym_COMMA] = ACTIONS(993),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym_for] = ACTIONS(981),
    [anon_sym_COLON] = ACTIONS(977),
    [sym_yul_leave] = ACTIONS(981),
    [anon_sym_break] = ACTIONS(981),
    [anon_sym_continue] = ACTIONS(981),
    [sym_yul_decimal_number] = ACTIONS(981),
    [sym_yul_hex_number] = ACTIONS(983),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [anon_sym_let] = ACTIONS(981),
    [anon_sym_COLON_EQ] = ACTIONS(985),
    [anon_sym_if] = ACTIONS(981),
    [anon_sym_switch] = ACTIONS(981),
    [anon_sym_function] = ACTIONS(981),
    [anon_sym_stop] = ACTIONS(981),
    [anon_sym_add] = ACTIONS(981),
    [anon_sym_sub] = ACTIONS(981),
    [anon_sym_mul] = ACTIONS(981),
    [anon_sym_div] = ACTIONS(981),
    [anon_sym_sdiv] = ACTIONS(981),
    [anon_sym_mod] = ACTIONS(981),
    [anon_sym_smod] = ACTIONS(981),
    [anon_sym_exp] = ACTIONS(981),
    [anon_sym_not] = ACTIONS(981),
    [anon_sym_lt] = ACTIONS(981),
    [anon_sym_gt] = ACTIONS(981),
    [anon_sym_slt] = ACTIONS(981),
    [anon_sym_sgt] = ACTIONS(981),
    [anon_sym_eq] = ACTIONS(981),
    [anon_sym_iszero] = ACTIONS(981),
    [anon_sym_and] = ACTIONS(981),
    [anon_sym_or] = ACTIONS(981),
    [anon_sym_xor] = ACTIONS(981),
    [anon_sym_byte] = ACTIONS(981),
    [anon_sym_shl] = ACTIONS(981),
    [anon_sym_shr] = ACTIONS(981),
    [anon_sym_sar] = ACTIONS(981),
    [anon_sym_addmod] = ACTIONS(981),
    [anon_sym_mulmod] = ACTIONS(981),
    [anon_sym_signextend] = ACTIONS(981),
    [anon_sym_keccak256] = ACTIONS(981),
    [anon_sym_pop] = ACTIONS(981),
    [anon_sym_mload] = ACTIONS(981),
    [anon_sym_mcopy] = ACTIONS(981),
    [anon_sym_tload] = ACTIONS(981),
    [anon_sym_tstore] = ACTIONS(981),
    [anon_sym_mstore] = ACTIONS(981),
    [anon_sym_mstore8] = ACTIONS(981),
    [anon_sym_sload] = ACTIONS(981),
    [anon_sym_sstore] = ACTIONS(981),
    [anon_sym_msize] = ACTIONS(981),
    [anon_sym_gas] = ACTIONS(981),
    [anon_sym_address] = ACTIONS(981),
    [anon_sym_balance] = ACTIONS(981),
    [anon_sym_selfbalance] = ACTIONS(981),
    [anon_sym_caller] = ACTIONS(981),
    [anon_sym_callvalue] = ACTIONS(981),
    [anon_sym_calldataload] = ACTIONS(981),
    [anon_sym_calldatasize] = ACTIONS(981),
    [anon_sym_calldatacopy] = ACTIONS(981),
    [anon_sym_extcodesize] = ACTIONS(981),
    [anon_sym_extcodecopy] = ACTIONS(981),
    [anon_sym_returndatasize] = ACTIONS(981),
    [anon_sym_returndatacopy] = ACTIONS(981),
    [anon_sym_extcodehash] = ACTIONS(981),
    [anon_sym_create] = ACTIONS(981),
    [anon_sym_create2] = ACTIONS(981),
    [anon_sym_call] = ACTIONS(981),
    [anon_sym_callcode] = ACTIONS(981),
    [anon_sym_delegatecall] = ACTIONS(981),
    [anon_sym_staticcall] = ACTIONS(981),
    [anon_sym_return] = ACTIONS(981),
    [anon_sym_revert] = ACTIONS(981),
    [anon_sym_selfdestruct] = ACTIONS(981),
    [anon_sym_invalid] = ACTIONS(981),
    [anon_sym_log0] = ACTIONS(981),
    [anon_sym_log1] = ACTIONS(981),
    [anon_sym_log2] = ACTIONS(981),
    [anon_sym_log3] = ACTIONS(981),
    [anon_sym_log4] = ACTIONS(981),
    [anon_sym_chainid] = ACTIONS(981),
    [anon_sym_origin] = ACTIONS(981),
    [anon_sym_gasprice] = ACTIONS(981),
    [anon_sym_blockhash] = ACTIONS(981),
    [anon_sym_blobhash] = ACTIONS(981),
    [anon_sym_basefee] = ACTIONS(981),
    [anon_sym_blobfee] = ACTIONS(981),
    [anon_sym_coinbase] = ACTIONS(981),
    [anon_sym_timestamp] = ACTIONS(981),
    [anon_sym_number] = ACTIONS(981),
    [anon_sym_difficulty] = ACTIONS(981),
    [anon_sym_gaslimit] = ACTIONS(981),
    [anon_sym_DQUOTE] = ACTIONS(983),
    [anon_sym_SQUOTE] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_identifier] = ACTIONS(995),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_for] = ACTIONS(995),
    [sym_yul_leave] = ACTIONS(995),
    [anon_sym_break] = ACTIONS(995),
    [anon_sym_continue] = ACTIONS(995),
    [sym_yul_decimal_number] = ACTIONS(995),
    [sym_yul_hex_number] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(995),
    [anon_sym_false] = ACTIONS(995),
    [anon_sym_let] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_switch] = ACTIONS(995),
    [anon_sym_default] = ACTIONS(995),
    [anon_sym_case] = ACTIONS(995),
    [anon_sym_function] = ACTIONS(995),
    [anon_sym_stop] = ACTIONS(995),
    [anon_sym_add] = ACTIONS(995),
    [anon_sym_sub] = ACTIONS(995),
    [anon_sym_mul] = ACTIONS(995),
    [anon_sym_div] = ACTIONS(995),
    [anon_sym_sdiv] = ACTIONS(995),
    [anon_sym_mod] = ACTIONS(995),
    [anon_sym_smod] = ACTIONS(995),
    [anon_sym_exp] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_lt] = ACTIONS(995),
    [anon_sym_gt] = ACTIONS(995),
    [anon_sym_slt] = ACTIONS(995),
    [anon_sym_sgt] = ACTIONS(995),
    [anon_sym_eq] = ACTIONS(995),
    [anon_sym_iszero] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_xor] = ACTIONS(995),
    [anon_sym_byte] = ACTIONS(995),
    [anon_sym_shl] = ACTIONS(995),
    [anon_sym_shr] = ACTIONS(995),
    [anon_sym_sar] = ACTIONS(995),
    [anon_sym_addmod] = ACTIONS(995),
    [anon_sym_mulmod] = ACTIONS(995),
    [anon_sym_signextend] = ACTIONS(995),
    [anon_sym_keccak256] = ACTIONS(995),
    [anon_sym_pop] = ACTIONS(995),
    [anon_sym_mload] = ACTIONS(995),
    [anon_sym_mcopy] = ACTIONS(995),
    [anon_sym_tload] = ACTIONS(995),
    [anon_sym_tstore] = ACTIONS(995),
    [anon_sym_mstore] = ACTIONS(995),
    [anon_sym_mstore8] = ACTIONS(995),
    [anon_sym_sload] = ACTIONS(995),
    [anon_sym_sstore] = ACTIONS(995),
    [anon_sym_msize] = ACTIONS(995),
    [anon_sym_gas] = ACTIONS(995),
    [anon_sym_address] = ACTIONS(995),
    [anon_sym_balance] = ACTIONS(995),
    [anon_sym_selfbalance] = ACTIONS(995),
    [anon_sym_caller] = ACTIONS(995),
    [anon_sym_callvalue] = ACTIONS(995),
    [anon_sym_calldataload] = ACTIONS(995),
    [anon_sym_calldatasize] = ACTIONS(995),
    [anon_sym_calldatacopy] = ACTIONS(995),
    [anon_sym_extcodesize] = ACTIONS(995),
    [anon_sym_extcodecopy] = ACTIONS(995),
    [anon_sym_returndatasize] = ACTIONS(995),
    [anon_sym_returndatacopy] = ACTIONS(995),
    [anon_sym_extcodehash] = ACTIONS(995),
    [anon_sym_create] = ACTIONS(995),
    [anon_sym_create2] = ACTIONS(995),
    [anon_sym_call] = ACTIONS(995),
    [anon_sym_callcode] = ACTIONS(995),
    [anon_sym_delegatecall] = ACTIONS(995),
    [anon_sym_staticcall] = ACTIONS(995),
    [anon_sym_return] = ACTIONS(995),
    [anon_sym_revert] = ACTIONS(995),
    [anon_sym_selfdestruct] = ACTIONS(995),
    [anon_sym_invalid] = ACTIONS(995),
    [anon_sym_log0] = ACTIONS(995),
    [anon_sym_log1] = ACTIONS(995),
    [anon_sym_log2] = ACTIONS(995),
    [anon_sym_log3] = ACTIONS(995),
    [anon_sym_log4] = ACTIONS(995),
    [anon_sym_chainid] = ACTIONS(995),
    [anon_sym_origin] = ACTIONS(995),
    [anon_sym_gasprice] = ACTIONS(995),
    [anon_sym_blockhash] = ACTIONS(995),
    [anon_sym_blobhash] = ACTIONS(995),
    [anon_sym_basefee] = ACTIONS(995),
    [anon_sym_blobfee] = ACTIONS(995),
    [anon_sym_coinbase] = ACTIONS(995),
    [anon_sym_timestamp] = ACTIONS(995),
    [anon_sym_number] = ACTIONS(995),
    [anon_sym_difficulty] = ACTIONS(995),
    [anon_sym_gaslimit] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(997),
    [anon_sym_SQUOTE] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym_identifier] = ACTIONS(999),
    [anon_sym_LBRACE] = ACTIONS(1001),
    [anon_sym_COMMA] = ACTIONS(1001),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [anon_sym_RPAREN] = ACTIONS(1001),
    [anon_sym_for] = ACTIONS(999),
    [sym_yul_leave] = ACTIONS(999),
    [anon_sym_break] = ACTIONS(999),
    [anon_sym_continue] = ACTIONS(999),
    [sym_yul_decimal_number] = ACTIONS(999),
    [sym_yul_hex_number] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(999),
    [anon_sym_false] = ACTIONS(999),
    [anon_sym_let] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(999),
    [anon_sym_switch] = ACTIONS(999),
    [anon_sym_default] = ACTIONS(999),
    [anon_sym_case] = ACTIONS(999),
    [anon_sym_function] = ACTIONS(999),
    [anon_sym_stop] = ACTIONS(999),
    [anon_sym_add] = ACTIONS(999),
    [anon_sym_sub] = ACTIONS(999),
    [anon_sym_mul] = ACTIONS(999),
    [anon_sym_div] = ACTIONS(999),
    [anon_sym_sdiv] = ACTIONS(999),
    [anon_sym_mod] = ACTIONS(999),
    [anon_sym_smod] = ACTIONS(999),
    [anon_sym_exp] = ACTIONS(999),
    [anon_sym_not] = ACTIONS(999),
    [anon_sym_lt] = ACTIONS(999),
    [anon_sym_gt] = ACTIONS(999),
    [anon_sym_slt] = ACTIONS(999),
    [anon_sym_sgt] = ACTIONS(999),
    [anon_sym_eq] = ACTIONS(999),
    [anon_sym_iszero] = ACTIONS(999),
    [anon_sym_and] = ACTIONS(999),
    [anon_sym_or] = ACTIONS(999),
    [anon_sym_xor] = ACTIONS(999),
    [anon_sym_byte] = ACTIONS(999),
    [anon_sym_shl] = ACTIONS(999),
    [anon_sym_shr] = ACTIONS(999),
    [anon_sym_sar] = ACTIONS(999),
    [anon_sym_addmod] = ACTIONS(999),
    [anon_sym_mulmod] = ACTIONS(999),
    [anon_sym_signextend] = ACTIONS(999),
    [anon_sym_keccak256] = ACTIONS(999),
    [anon_sym_pop] = ACTIONS(999),
    [anon_sym_mload] = ACTIONS(999),
    [anon_sym_mcopy] = ACTIONS(999),
    [anon_sym_tload] = ACTIONS(999),
    [anon_sym_tstore] = ACTIONS(999),
    [anon_sym_mstore] = ACTIONS(999),
    [anon_sym_mstore8] = ACTIONS(999),
    [anon_sym_sload] = ACTIONS(999),
    [anon_sym_sstore] = ACTIONS(999),
    [anon_sym_msize] = ACTIONS(999),
    [anon_sym_gas] = ACTIONS(999),
    [anon_sym_address] = ACTIONS(999),
    [anon_sym_balance] = ACTIONS(999),
    [anon_sym_selfbalance] = ACTIONS(999),
    [anon_sym_caller] = ACTIONS(999),
    [anon_sym_callvalue] = ACTIONS(999),
    [anon_sym_calldataload] = ACTIONS(999),
    [anon_sym_calldatasize] = ACTIONS(999),
    [anon_sym_calldatacopy] = ACTIONS(999),
    [anon_sym_extcodesize] = ACTIONS(999),
    [anon_sym_extcodecopy] = ACTIONS(999),
    [anon_sym_returndatasize] = ACTIONS(999),
    [anon_sym_returndatacopy] = ACTIONS(999),
    [anon_sym_extcodehash] = ACTIONS(999),
    [anon_sym_create] = ACTIONS(999),
    [anon_sym_create2] = ACTIONS(999),
    [anon_sym_call] = ACTIONS(999),
    [anon_sym_callcode] = ACTIONS(999),
    [anon_sym_delegatecall] = ACTIONS(999),
    [anon_sym_staticcall] = ACTIONS(999),
    [anon_sym_return] = ACTIONS(999),
    [anon_sym_revert] = ACTIONS(999),
    [anon_sym_selfdestruct] = ACTIONS(999),
    [anon_sym_invalid] = ACTIONS(999),
    [anon_sym_log0] = ACTIONS(999),
    [anon_sym_log1] = ACTIONS(999),
    [anon_sym_log2] = ACTIONS(999),
    [anon_sym_log3] = ACTIONS(999),
    [anon_sym_log4] = ACTIONS(999),
    [anon_sym_chainid] = ACTIONS(999),
    [anon_sym_origin] = ACTIONS(999),
    [anon_sym_gasprice] = ACTIONS(999),
    [anon_sym_blockhash] = ACTIONS(999),
    [anon_sym_blobhash] = ACTIONS(999),
    [anon_sym_basefee] = ACTIONS(999),
    [anon_sym_blobfee] = ACTIONS(999),
    [anon_sym_coinbase] = ACTIONS(999),
    [anon_sym_timestamp] = ACTIONS(999),
    [anon_sym_number] = ACTIONS(999),
    [anon_sym_difficulty] = ACTIONS(999),
    [anon_sym_gaslimit] = ACTIONS(999),
    [anon_sym_DQUOTE] = ACTIONS(1001),
    [anon_sym_SQUOTE] = ACTIONS(1001),
    [sym_comment] = ACTIONS(3),
  },
  [243] = {
    [aux_sym_yul_variable_declaration_repeat1] = STATE(243),
    [sym_identifier] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_COMMA] = ACTIONS(1007),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(1005),
    [anon_sym_for] = ACTIONS(1003),
    [sym_yul_leave] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [anon_sym_continue] = ACTIONS(1003),
    [sym_yul_decimal_number] = ACTIONS(1003),
    [sym_yul_hex_number] = ACTIONS(1005),
    [anon_sym_true] = ACTIONS(1003),
    [anon_sym_false] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(1003),
    [anon_sym_COLON_EQ] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(1003),
    [anon_sym_stop] = ACTIONS(1003),
    [anon_sym_add] = ACTIONS(1003),
    [anon_sym_sub] = ACTIONS(1003),
    [anon_sym_mul] = ACTIONS(1003),
    [anon_sym_div] = ACTIONS(1003),
    [anon_sym_sdiv] = ACTIONS(1003),
    [anon_sym_mod] = ACTIONS(1003),
    [anon_sym_smod] = ACTIONS(1003),
    [anon_sym_exp] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_lt] = ACTIONS(1003),
    [anon_sym_gt] = ACTIONS(1003),
    [anon_sym_slt] = ACTIONS(1003),
    [anon_sym_sgt] = ACTIONS(1003),
    [anon_sym_eq] = ACTIONS(1003),
    [anon_sym_iszero] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_xor] = ACTIONS(1003),
    [anon_sym_byte] = ACTIONS(1003),
    [anon_sym_shl] = ACTIONS(1003),
    [anon_sym_shr] = ACTIONS(1003),
    [anon_sym_sar] = ACTIONS(1003),
    [anon_sym_addmod] = ACTIONS(1003),
    [anon_sym_mulmod] = ACTIONS(1003),
    [anon_sym_signextend] = ACTIONS(1003),
    [anon_sym_keccak256] = ACTIONS(1003),
    [anon_sym_pop] = ACTIONS(1003),
    [anon_sym_mload] = ACTIONS(1003),
    [anon_sym_mcopy] = ACTIONS(1003),
    [anon_sym_tload] = ACTIONS(1003),
    [anon_sym_tstore] = ACTIONS(1003),
    [anon_sym_mstore] = ACTIONS(1003),
    [anon_sym_mstore8] = ACTIONS(1003),
    [anon_sym_sload] = ACTIONS(1003),
    [anon_sym_sstore] = ACTIONS(1003),
    [anon_sym_msize] = ACTIONS(1003),
    [anon_sym_gas] = ACTIONS(1003),
    [anon_sym_address] = ACTIONS(1003),
    [anon_sym_balance] = ACTIONS(1003),
    [anon_sym_selfbalance] = ACTIONS(1003),
    [anon_sym_caller] = ACTIONS(1003),
    [anon_sym_callvalue] = ACTIONS(1003),
    [anon_sym_calldataload] = ACTIONS(1003),
    [anon_sym_calldatasize] = ACTIONS(1003),
    [anon_sym_calldatacopy] = ACTIONS(1003),
    [anon_sym_extcodesize] = ACTIONS(1003),
    [anon_sym_extcodecopy] = ACTIONS(1003),
    [anon_sym_returndatasize] = ACTIONS(1003),
    [anon_sym_returndatacopy] = ACTIONS(1003),
    [anon_sym_extcodehash] = ACTIONS(1003),
    [anon_sym_create] = ACTIONS(1003),
    [anon_sym_create2] = ACTIONS(1003),
    [anon_sym_call] = ACTIONS(1003),
    [anon_sym_callcode] = ACTIONS(1003),
    [anon_sym_delegatecall] = ACTIONS(1003),
    [anon_sym_staticcall] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_revert] = ACTIONS(1003),
    [anon_sym_selfdestruct] = ACTIONS(1003),
    [anon_sym_invalid] = ACTIONS(1003),
    [anon_sym_log0] = ACTIONS(1003),
    [anon_sym_log1] = ACTIONS(1003),
    [anon_sym_log2] = ACTIONS(1003),
    [anon_sym_log3] = ACTIONS(1003),
    [anon_sym_log4] = ACTIONS(1003),
    [anon_sym_chainid] = ACTIONS(1003),
    [anon_sym_origin] = ACTIONS(1003),
    [anon_sym_gasprice] = ACTIONS(1003),
    [anon_sym_blockhash] = ACTIONS(1003),
    [anon_sym_blobhash] = ACTIONS(1003),
    [anon_sym_basefee] = ACTIONS(1003),
    [anon_sym_blobfee] = ACTIONS(1003),
    [anon_sym_coinbase] = ACTIONS(1003),
    [anon_sym_timestamp] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_difficulty] = ACTIONS(1003),
    [anon_sym_gaslimit] = ACTIONS(1003),
    [anon_sym_DQUOTE] = ACTIONS(1005),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
  },
  [244] = {
    [sym_identifier] = ACTIONS(1010),
    [anon_sym_LBRACE] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(1012),
    [anon_sym_RPAREN] = ACTIONS(1012),
    [anon_sym_for] = ACTIONS(1010),
    [sym_yul_leave] = ACTIONS(1010),
    [anon_sym_break] = ACTIONS(1010),
    [anon_sym_continue] = ACTIONS(1010),
    [sym_yul_decimal_number] = ACTIONS(1010),
    [sym_yul_hex_number] = ACTIONS(1012),
    [anon_sym_true] = ACTIONS(1010),
    [anon_sym_false] = ACTIONS(1010),
    [anon_sym_let] = ACTIONS(1010),
    [anon_sym_if] = ACTIONS(1010),
    [anon_sym_switch] = ACTIONS(1010),
    [anon_sym_default] = ACTIONS(1010),
    [anon_sym_case] = ACTIONS(1010),
    [anon_sym_function] = ACTIONS(1010),
    [anon_sym_stop] = ACTIONS(1010),
    [anon_sym_add] = ACTIONS(1010),
    [anon_sym_sub] = ACTIONS(1010),
    [anon_sym_mul] = ACTIONS(1010),
    [anon_sym_div] = ACTIONS(1010),
    [anon_sym_sdiv] = ACTIONS(1010),
    [anon_sym_mod] = ACTIONS(1010),
    [anon_sym_smod] = ACTIONS(1010),
    [anon_sym_exp] = ACTIONS(1010),
    [anon_sym_not] = ACTIONS(1010),
    [anon_sym_lt] = ACTIONS(1010),
    [anon_sym_gt] = ACTIONS(1010),
    [anon_sym_slt] = ACTIONS(1010),
    [anon_sym_sgt] = ACTIONS(1010),
    [anon_sym_eq] = ACTIONS(1010),
    [anon_sym_iszero] = ACTIONS(1010),
    [anon_sym_and] = ACTIONS(1010),
    [anon_sym_or] = ACTIONS(1010),
    [anon_sym_xor] = ACTIONS(1010),
    [anon_sym_byte] = ACTIONS(1010),
    [anon_sym_shl] = ACTIONS(1010),
    [anon_sym_shr] = ACTIONS(1010),
    [anon_sym_sar] = ACTIONS(1010),
    [anon_sym_addmod] = ACTIONS(1010),
    [anon_sym_mulmod] = ACTIONS(1010),
    [anon_sym_signextend] = ACTIONS(1010),
    [anon_sym_keccak256] = ACTIONS(1010),
    [anon_sym_pop] = ACTIONS(1010),
    [anon_sym_mload] = ACTIONS(1010),
    [anon_sym_mcopy] = ACTIONS(1010),
    [anon_sym_tload] = ACTIONS(1010),
    [anon_sym_tstore] = ACTIONS(1010),
    [anon_sym_mstore] = ACTIONS(1010),
    [anon_sym_mstore8] = ACTIONS(1010),
    [anon_sym_sload] = ACTIONS(1010),
    [anon_sym_sstore] = ACTIONS(1010),
    [anon_sym_msize] = ACTIONS(1010),
    [anon_sym_gas] = ACTIONS(1010),
    [anon_sym_address] = ACTIONS(1010),
    [anon_sym_balance] = ACTIONS(1010),
    [anon_sym_selfbalance] = ACTIONS(1010),
    [anon_sym_caller] = ACTIONS(1010),
    [anon_sym_callvalue] = ACTIONS(1010),
    [anon_sym_calldataload] = ACTIONS(1010),
    [anon_sym_calldatasize] = ACTIONS(1010),
    [anon_sym_calldatacopy] = ACTIONS(1010),
    [anon_sym_extcodesize] = ACTIONS(1010),
    [anon_sym_extcodecopy] = ACTIONS(1010),
    [anon_sym_returndatasize] = ACTIONS(1010),
    [anon_sym_returndatacopy] = ACTIONS(1010),
    [anon_sym_extcodehash] = ACTIONS(1010),
    [anon_sym_create] = ACTIONS(1010),
    [anon_sym_create2] = ACTIONS(1010),
    [anon_sym_call] = ACTIONS(1010),
    [anon_sym_callcode] = ACTIONS(1010),
    [anon_sym_delegatecall] = ACTIONS(1010),
    [anon_sym_staticcall] = ACTIONS(1010),
    [anon_sym_return] = ACTIONS(1010),
    [anon_sym_revert] = ACTIONS(1010),
    [anon_sym_selfdestruct] = ACTIONS(1010),
    [anon_sym_invalid] = ACTIONS(1010),
    [anon_sym_log0] = ACTIONS(1010),
    [anon_sym_log1] = ACTIONS(1010),
    [anon_sym_log2] = ACTIONS(1010),
    [anon_sym_log3] = ACTIONS(1010),
    [anon_sym_log4] = ACTIONS(1010),
    [anon_sym_chainid] = ACTIONS(1010),
    [anon_sym_origin] = ACTIONS(1010),
    [anon_sym_gasprice] = ACTIONS(1010),
    [anon_sym_blockhash] = ACTIONS(1010),
    [anon_sym_blobhash] = ACTIONS(1010),
    [anon_sym_basefee] = ACTIONS(1010),
    [anon_sym_blobfee] = ACTIONS(1010),
    [anon_sym_coinbase] = ACTIONS(1010),
    [anon_sym_timestamp] = ACTIONS(1010),
    [anon_sym_number] = ACTIONS(1010),
    [anon_sym_difficulty] = ACTIONS(1010),
    [anon_sym_gaslimit] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1012),
    [anon_sym_SQUOTE] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
  },
  [245] = {
    [sym_identifier] = ACTIONS(1014),
    [anon_sym_LBRACE] = ACTIONS(1016),
    [anon_sym_COMMA] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(1016),
    [anon_sym_RPAREN] = ACTIONS(1016),
    [anon_sym_for] = ACTIONS(1014),
    [sym_yul_leave] = ACTIONS(1014),
    [anon_sym_break] = ACTIONS(1014),
    [anon_sym_continue] = ACTIONS(1014),
    [sym_yul_decimal_number] = ACTIONS(1014),
    [sym_yul_hex_number] = ACTIONS(1016),
    [anon_sym_true] = ACTIONS(1014),
    [anon_sym_false] = ACTIONS(1014),
    [anon_sym_let] = ACTIONS(1014),
    [anon_sym_if] = ACTIONS(1014),
    [anon_sym_switch] = ACTIONS(1014),
    [anon_sym_default] = ACTIONS(1014),
    [anon_sym_case] = ACTIONS(1014),
    [anon_sym_function] = ACTIONS(1014),
    [anon_sym_stop] = ACTIONS(1014),
    [anon_sym_add] = ACTIONS(1014),
    [anon_sym_sub] = ACTIONS(1014),
    [anon_sym_mul] = ACTIONS(1014),
    [anon_sym_div] = ACTIONS(1014),
    [anon_sym_sdiv] = ACTIONS(1014),
    [anon_sym_mod] = ACTIONS(1014),
    [anon_sym_smod] = ACTIONS(1014),
    [anon_sym_exp] = ACTIONS(1014),
    [anon_sym_not] = ACTIONS(1014),
    [anon_sym_lt] = ACTIONS(1014),
    [anon_sym_gt] = ACTIONS(1014),
    [anon_sym_slt] = ACTIONS(1014),
    [anon_sym_sgt] = ACTIONS(1014),
    [anon_sym_eq] = ACTIONS(1014),
    [anon_sym_iszero] = ACTIONS(1014),
    [anon_sym_and] = ACTIONS(1014),
    [anon_sym_or] = ACTIONS(1014),
    [anon_sym_xor] = ACTIONS(1014),
    [anon_sym_byte] = ACTIONS(1014),
    [anon_sym_shl] = ACTIONS(1014),
    [anon_sym_shr] = ACTIONS(1014),
    [anon_sym_sar] = ACTIONS(1014),
    [anon_sym_addmod] = ACTIONS(1014),
    [anon_sym_mulmod] = ACTIONS(1014),
    [anon_sym_signextend] = ACTIONS(1014),
    [anon_sym_keccak256] = ACTIONS(1014),
    [anon_sym_pop] = ACTIONS(1014),
    [anon_sym_mload] = ACTIONS(1014),
    [anon_sym_mcopy] = ACTIONS(1014),
    [anon_sym_tload] = ACTIONS(1014),
    [anon_sym_tstore] = ACTIONS(1014),
    [anon_sym_mstore] = ACTIONS(1014),
    [anon_sym_mstore8] = ACTIONS(1014),
    [anon_sym_sload] = ACTIONS(1014),
    [anon_sym_sstore] = ACTIONS(1014),
    [anon_sym_msize] = ACTIONS(1014),
    [anon_sym_gas] = ACTIONS(1014),
    [anon_sym_address] = ACTIONS(1014),
    [anon_sym_balance] = ACTIONS(1014),
    [anon_sym_selfbalance] = ACTIONS(1014),
    [anon_sym_caller] = ACTIONS(1014),
    [anon_sym_callvalue] = ACTIONS(1014),
    [anon_sym_calldataload] = ACTIONS(1014),
    [anon_sym_calldatasize] = ACTIONS(1014),
    [anon_sym_calldatacopy] = ACTIONS(1014),
    [anon_sym_extcodesize] = ACTIONS(1014),
    [anon_sym_extcodecopy] = ACTIONS(1014),
    [anon_sym_returndatasize] = ACTIONS(1014),
    [anon_sym_returndatacopy] = ACTIONS(1014),
    [anon_sym_extcodehash] = ACTIONS(1014),
    [anon_sym_create] = ACTIONS(1014),
    [anon_sym_create2] = ACTIONS(1014),
    [anon_sym_call] = ACTIONS(1014),
    [anon_sym_callcode] = ACTIONS(1014),
    [anon_sym_delegatecall] = ACTIONS(1014),
    [anon_sym_staticcall] = ACTIONS(1014),
    [anon_sym_return] = ACTIONS(1014),
    [anon_sym_revert] = ACTIONS(1014),
    [anon_sym_selfdestruct] = ACTIONS(1014),
    [anon_sym_invalid] = ACTIONS(1014),
    [anon_sym_log0] = ACTIONS(1014),
    [anon_sym_log1] = ACTIONS(1014),
    [anon_sym_log2] = ACTIONS(1014),
    [anon_sym_log3] = ACTIONS(1014),
    [anon_sym_log4] = ACTIONS(1014),
    [anon_sym_chainid] = ACTIONS(1014),
    [anon_sym_origin] = ACTIONS(1014),
    [anon_sym_gasprice] = ACTIONS(1014),
    [anon_sym_blockhash] = ACTIONS(1014),
    [anon_sym_blobhash] = ACTIONS(1014),
    [anon_sym_basefee] = ACTIONS(1014),
    [anon_sym_blobfee] = ACTIONS(1014),
    [anon_sym_coinbase] = ACTIONS(1014),
    [anon_sym_timestamp] = ACTIONS(1014),
    [anon_sym_number] = ACTIONS(1014),
    [anon_sym_difficulty] = ACTIONS(1014),
    [anon_sym_gaslimit] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1016),
    [anon_sym_SQUOTE] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [aux_sym_yul_assignment_repeat1] = STATE(246),
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_COMMA] = ACTIONS(1022),
    [anon_sym_RBRACE] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1018),
    [anon_sym_COLON] = ACTIONS(1018),
    [sym_yul_leave] = ACTIONS(1018),
    [anon_sym_break] = ACTIONS(1018),
    [anon_sym_continue] = ACTIONS(1018),
    [sym_yul_decimal_number] = ACTIONS(1018),
    [sym_yul_hex_number] = ACTIONS(1020),
    [anon_sym_true] = ACTIONS(1018),
    [anon_sym_false] = ACTIONS(1018),
    [anon_sym_let] = ACTIONS(1018),
    [anon_sym_COLON_EQ] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_switch] = ACTIONS(1018),
    [anon_sym_function] = ACTIONS(1018),
    [anon_sym_stop] = ACTIONS(1018),
    [anon_sym_add] = ACTIONS(1018),
    [anon_sym_sub] = ACTIONS(1018),
    [anon_sym_mul] = ACTIONS(1018),
    [anon_sym_div] = ACTIONS(1018),
    [anon_sym_sdiv] = ACTIONS(1018),
    [anon_sym_mod] = ACTIONS(1018),
    [anon_sym_smod] = ACTIONS(1018),
    [anon_sym_exp] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1018),
    [anon_sym_lt] = ACTIONS(1018),
    [anon_sym_gt] = ACTIONS(1018),
    [anon_sym_slt] = ACTIONS(1018),
    [anon_sym_sgt] = ACTIONS(1018),
    [anon_sym_eq] = ACTIONS(1018),
    [anon_sym_iszero] = ACTIONS(1018),
    [anon_sym_and] = ACTIONS(1018),
    [anon_sym_or] = ACTIONS(1018),
    [anon_sym_xor] = ACTIONS(1018),
    [anon_sym_byte] = ACTIONS(1018),
    [anon_sym_shl] = ACTIONS(1018),
    [anon_sym_shr] = ACTIONS(1018),
    [anon_sym_sar] = ACTIONS(1018),
    [anon_sym_addmod] = ACTIONS(1018),
    [anon_sym_mulmod] = ACTIONS(1018),
    [anon_sym_signextend] = ACTIONS(1018),
    [anon_sym_keccak256] = ACTIONS(1018),
    [anon_sym_pop] = ACTIONS(1018),
    [anon_sym_mload] = ACTIONS(1018),
    [anon_sym_mcopy] = ACTIONS(1018),
    [anon_sym_tload] = ACTIONS(1018),
    [anon_sym_tstore] = ACTIONS(1018),
    [anon_sym_mstore] = ACTIONS(1018),
    [anon_sym_mstore8] = ACTIONS(1018),
    [anon_sym_sload] = ACTIONS(1018),
    [anon_sym_sstore] = ACTIONS(1018),
    [anon_sym_msize] = ACTIONS(1018),
    [anon_sym_gas] = ACTIONS(1018),
    [anon_sym_address] = ACTIONS(1018),
    [anon_sym_balance] = ACTIONS(1018),
    [anon_sym_selfbalance] = ACTIONS(1018),
    [anon_sym_caller] = ACTIONS(1018),
    [anon_sym_callvalue] = ACTIONS(1018),
    [anon_sym_calldataload] = ACTIONS(1018),
    [anon_sym_calldatasize] = ACTIONS(1018),
    [anon_sym_calldatacopy] = ACTIONS(1018),
    [anon_sym_extcodesize] = ACTIONS(1018),
    [anon_sym_extcodecopy] = ACTIONS(1018),
    [anon_sym_returndatasize] = ACTIONS(1018),
    [anon_sym_returndatacopy] = ACTIONS(1018),
    [anon_sym_extcodehash] = ACTIONS(1018),
    [anon_sym_create] = ACTIONS(1018),
    [anon_sym_create2] = ACTIONS(1018),
    [anon_sym_call] = ACTIONS(1018),
    [anon_sym_callcode] = ACTIONS(1018),
    [anon_sym_delegatecall] = ACTIONS(1018),
    [anon_sym_staticcall] = ACTIONS(1018),
    [anon_sym_return] = ACTIONS(1018),
    [anon_sym_revert] = ACTIONS(1018),
    [anon_sym_selfdestruct] = ACTIONS(1018),
    [anon_sym_invalid] = ACTIONS(1018),
    [anon_sym_log0] = ACTIONS(1018),
    [anon_sym_log1] = ACTIONS(1018),
    [anon_sym_log2] = ACTIONS(1018),
    [anon_sym_log3] = ACTIONS(1018),
    [anon_sym_log4] = ACTIONS(1018),
    [anon_sym_chainid] = ACTIONS(1018),
    [anon_sym_origin] = ACTIONS(1018),
    [anon_sym_gasprice] = ACTIONS(1018),
    [anon_sym_blockhash] = ACTIONS(1018),
    [anon_sym_blobhash] = ACTIONS(1018),
    [anon_sym_basefee] = ACTIONS(1018),
    [anon_sym_blobfee] = ACTIONS(1018),
    [anon_sym_coinbase] = ACTIONS(1018),
    [anon_sym_timestamp] = ACTIONS(1018),
    [anon_sym_number] = ACTIONS(1018),
    [anon_sym_difficulty] = ACTIONS(1018),
    [anon_sym_gaslimit] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [247] = {
    [sym_identifier] = ACTIONS(1025),
    [anon_sym_LBRACE] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_for] = ACTIONS(1025),
    [sym_yul_leave] = ACTIONS(1025),
    [anon_sym_break] = ACTIONS(1025),
    [anon_sym_continue] = ACTIONS(1025),
    [sym_yul_decimal_number] = ACTIONS(1025),
    [sym_yul_hex_number] = ACTIONS(1027),
    [anon_sym_true] = ACTIONS(1025),
    [anon_sym_false] = ACTIONS(1025),
    [anon_sym_let] = ACTIONS(1025),
    [anon_sym_if] = ACTIONS(1025),
    [anon_sym_switch] = ACTIONS(1025),
    [anon_sym_default] = ACTIONS(1025),
    [anon_sym_case] = ACTIONS(1025),
    [anon_sym_function] = ACTIONS(1025),
    [anon_sym_stop] = ACTIONS(1025),
    [anon_sym_add] = ACTIONS(1025),
    [anon_sym_sub] = ACTIONS(1025),
    [anon_sym_mul] = ACTIONS(1025),
    [anon_sym_div] = ACTIONS(1025),
    [anon_sym_sdiv] = ACTIONS(1025),
    [anon_sym_mod] = ACTIONS(1025),
    [anon_sym_smod] = ACTIONS(1025),
    [anon_sym_exp] = ACTIONS(1025),
    [anon_sym_not] = ACTIONS(1025),
    [anon_sym_lt] = ACTIONS(1025),
    [anon_sym_gt] = ACTIONS(1025),
    [anon_sym_slt] = ACTIONS(1025),
    [anon_sym_sgt] = ACTIONS(1025),
    [anon_sym_eq] = ACTIONS(1025),
    [anon_sym_iszero] = ACTIONS(1025),
    [anon_sym_and] = ACTIONS(1025),
    [anon_sym_or] = ACTIONS(1025),
    [anon_sym_xor] = ACTIONS(1025),
    [anon_sym_byte] = ACTIONS(1025),
    [anon_sym_shl] = ACTIONS(1025),
    [anon_sym_shr] = ACTIONS(1025),
    [anon_sym_sar] = ACTIONS(1025),
    [anon_sym_addmod] = ACTIONS(1025),
    [anon_sym_mulmod] = ACTIONS(1025),
    [anon_sym_signextend] = ACTIONS(1025),
    [anon_sym_keccak256] = ACTIONS(1025),
    [anon_sym_pop] = ACTIONS(1025),
    [anon_sym_mload] = ACTIONS(1025),
    [anon_sym_mcopy] = ACTIONS(1025),
    [anon_sym_tload] = ACTIONS(1025),
    [anon_sym_tstore] = ACTIONS(1025),
    [anon_sym_mstore] = ACTIONS(1025),
    [anon_sym_mstore8] = ACTIONS(1025),
    [anon_sym_sload] = ACTIONS(1025),
    [anon_sym_sstore] = ACTIONS(1025),
    [anon_sym_msize] = ACTIONS(1025),
    [anon_sym_gas] = ACTIONS(1025),
    [anon_sym_address] = ACTIONS(1025),
    [anon_sym_balance] = ACTIONS(1025),
    [anon_sym_selfbalance] = ACTIONS(1025),
    [anon_sym_caller] = ACTIONS(1025),
    [anon_sym_callvalue] = ACTIONS(1025),
    [anon_sym_calldataload] = ACTIONS(1025),
    [anon_sym_calldatasize] = ACTIONS(1025),
    [anon_sym_calldatacopy] = ACTIONS(1025),
    [anon_sym_extcodesize] = ACTIONS(1025),
    [anon_sym_extcodecopy] = ACTIONS(1025),
    [anon_sym_returndatasize] = ACTIONS(1025),
    [anon_sym_returndatacopy] = ACTIONS(1025),
    [anon_sym_extcodehash] = ACTIONS(1025),
    [anon_sym_create] = ACTIONS(1025),
    [anon_sym_create2] = ACTIONS(1025),
    [anon_sym_call] = ACTIONS(1025),
    [anon_sym_callcode] = ACTIONS(1025),
    [anon_sym_delegatecall] = ACTIONS(1025),
    [anon_sym_staticcall] = ACTIONS(1025),
    [anon_sym_return] = ACTIONS(1025),
    [anon_sym_revert] = ACTIONS(1025),
    [anon_sym_selfdestruct] = ACTIONS(1025),
    [anon_sym_invalid] = ACTIONS(1025),
    [anon_sym_log0] = ACTIONS(1025),
    [anon_sym_log1] = ACTIONS(1025),
    [anon_sym_log2] = ACTIONS(1025),
    [anon_sym_log3] = ACTIONS(1025),
    [anon_sym_log4] = ACTIONS(1025),
    [anon_sym_chainid] = ACTIONS(1025),
    [anon_sym_origin] = ACTIONS(1025),
    [anon_sym_gasprice] = ACTIONS(1025),
    [anon_sym_blockhash] = ACTIONS(1025),
    [anon_sym_blobhash] = ACTIONS(1025),
    [anon_sym_basefee] = ACTIONS(1025),
    [anon_sym_blobfee] = ACTIONS(1025),
    [anon_sym_coinbase] = ACTIONS(1025),
    [anon_sym_timestamp] = ACTIONS(1025),
    [anon_sym_number] = ACTIONS(1025),
    [anon_sym_difficulty] = ACTIONS(1025),
    [anon_sym_gaslimit] = ACTIONS(1025),
    [anon_sym_DQUOTE] = ACTIONS(1027),
    [anon_sym_SQUOTE] = ACTIONS(1027),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1031),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1031),
    [anon_sym_for] = ACTIONS(1029),
    [sym_yul_leave] = ACTIONS(1029),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [sym_yul_decimal_number] = ACTIONS(1029),
    [sym_yul_hex_number] = ACTIONS(1031),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_let] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_switch] = ACTIONS(1029),
    [anon_sym_default] = ACTIONS(1029),
    [anon_sym_case] = ACTIONS(1029),
    [anon_sym_function] = ACTIONS(1029),
    [anon_sym_stop] = ACTIONS(1029),
    [anon_sym_add] = ACTIONS(1029),
    [anon_sym_sub] = ACTIONS(1029),
    [anon_sym_mul] = ACTIONS(1029),
    [anon_sym_div] = ACTIONS(1029),
    [anon_sym_sdiv] = ACTIONS(1029),
    [anon_sym_mod] = ACTIONS(1029),
    [anon_sym_smod] = ACTIONS(1029),
    [anon_sym_exp] = ACTIONS(1029),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_lt] = ACTIONS(1029),
    [anon_sym_gt] = ACTIONS(1029),
    [anon_sym_slt] = ACTIONS(1029),
    [anon_sym_sgt] = ACTIONS(1029),
    [anon_sym_eq] = ACTIONS(1029),
    [anon_sym_iszero] = ACTIONS(1029),
    [anon_sym_and] = ACTIONS(1029),
    [anon_sym_or] = ACTIONS(1029),
    [anon_sym_xor] = ACTIONS(1029),
    [anon_sym_byte] = ACTIONS(1029),
    [anon_sym_shl] = ACTIONS(1029),
    [anon_sym_shr] = ACTIONS(1029),
    [anon_sym_sar] = ACTIONS(1029),
    [anon_sym_addmod] = ACTIONS(1029),
    [anon_sym_mulmod] = ACTIONS(1029),
    [anon_sym_signextend] = ACTIONS(1029),
    [anon_sym_keccak256] = ACTIONS(1029),
    [anon_sym_pop] = ACTIONS(1029),
    [anon_sym_mload] = ACTIONS(1029),
    [anon_sym_mcopy] = ACTIONS(1029),
    [anon_sym_tload] = ACTIONS(1029),
    [anon_sym_tstore] = ACTIONS(1029),
    [anon_sym_mstore] = ACTIONS(1029),
    [anon_sym_mstore8] = ACTIONS(1029),
    [anon_sym_sload] = ACTIONS(1029),
    [anon_sym_sstore] = ACTIONS(1029),
    [anon_sym_msize] = ACTIONS(1029),
    [anon_sym_gas] = ACTIONS(1029),
    [anon_sym_address] = ACTIONS(1029),
    [anon_sym_balance] = ACTIONS(1029),
    [anon_sym_selfbalance] = ACTIONS(1029),
    [anon_sym_caller] = ACTIONS(1029),
    [anon_sym_callvalue] = ACTIONS(1029),
    [anon_sym_calldataload] = ACTIONS(1029),
    [anon_sym_calldatasize] = ACTIONS(1029),
    [anon_sym_calldatacopy] = ACTIONS(1029),
    [anon_sym_extcodesize] = ACTIONS(1029),
    [anon_sym_extcodecopy] = ACTIONS(1029),
    [anon_sym_returndatasize] = ACTIONS(1029),
    [anon_sym_returndatacopy] = ACTIONS(1029),
    [anon_sym_extcodehash] = ACTIONS(1029),
    [anon_sym_create] = ACTIONS(1029),
    [anon_sym_create2] = ACTIONS(1029),
    [anon_sym_call] = ACTIONS(1029),
    [anon_sym_callcode] = ACTIONS(1029),
    [anon_sym_delegatecall] = ACTIONS(1029),
    [anon_sym_staticcall] = ACTIONS(1029),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_revert] = ACTIONS(1029),
    [anon_sym_selfdestruct] = ACTIONS(1029),
    [anon_sym_invalid] = ACTIONS(1029),
    [anon_sym_log0] = ACTIONS(1029),
    [anon_sym_log1] = ACTIONS(1029),
    [anon_sym_log2] = ACTIONS(1029),
    [anon_sym_log3] = ACTIONS(1029),
    [anon_sym_log4] = ACTIONS(1029),
    [anon_sym_chainid] = ACTIONS(1029),
    [anon_sym_origin] = ACTIONS(1029),
    [anon_sym_gasprice] = ACTIONS(1029),
    [anon_sym_blockhash] = ACTIONS(1029),
    [anon_sym_blobhash] = ACTIONS(1029),
    [anon_sym_basefee] = ACTIONS(1029),
    [anon_sym_blobfee] = ACTIONS(1029),
    [anon_sym_coinbase] = ACTIONS(1029),
    [anon_sym_timestamp] = ACTIONS(1029),
    [anon_sym_number] = ACTIONS(1029),
    [anon_sym_difficulty] = ACTIONS(1029),
    [anon_sym_gaslimit] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1031),
    [anon_sym_SQUOTE] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
  },
  [249] = {
    [sym_identifier] = ACTIONS(1003),
    [anon_sym_LBRACE] = ACTIONS(1005),
    [anon_sym_COMMA] = ACTIONS(1005),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym_RPAREN] = ACTIONS(1005),
    [anon_sym_for] = ACTIONS(1003),
    [sym_yul_leave] = ACTIONS(1003),
    [anon_sym_break] = ACTIONS(1003),
    [anon_sym_continue] = ACTIONS(1003),
    [sym_yul_decimal_number] = ACTIONS(1003),
    [sym_yul_hex_number] = ACTIONS(1005),
    [anon_sym_true] = ACTIONS(1003),
    [anon_sym_false] = ACTIONS(1003),
    [anon_sym_let] = ACTIONS(1003),
    [anon_sym_COLON_EQ] = ACTIONS(1005),
    [anon_sym_if] = ACTIONS(1003),
    [anon_sym_switch] = ACTIONS(1003),
    [anon_sym_function] = ACTIONS(1003),
    [anon_sym_stop] = ACTIONS(1003),
    [anon_sym_add] = ACTIONS(1003),
    [anon_sym_sub] = ACTIONS(1003),
    [anon_sym_mul] = ACTIONS(1003),
    [anon_sym_div] = ACTIONS(1003),
    [anon_sym_sdiv] = ACTIONS(1003),
    [anon_sym_mod] = ACTIONS(1003),
    [anon_sym_smod] = ACTIONS(1003),
    [anon_sym_exp] = ACTIONS(1003),
    [anon_sym_not] = ACTIONS(1003),
    [anon_sym_lt] = ACTIONS(1003),
    [anon_sym_gt] = ACTIONS(1003),
    [anon_sym_slt] = ACTIONS(1003),
    [anon_sym_sgt] = ACTIONS(1003),
    [anon_sym_eq] = ACTIONS(1003),
    [anon_sym_iszero] = ACTIONS(1003),
    [anon_sym_and] = ACTIONS(1003),
    [anon_sym_or] = ACTIONS(1003),
    [anon_sym_xor] = ACTIONS(1003),
    [anon_sym_byte] = ACTIONS(1003),
    [anon_sym_shl] = ACTIONS(1003),
    [anon_sym_shr] = ACTIONS(1003),
    [anon_sym_sar] = ACTIONS(1003),
    [anon_sym_addmod] = ACTIONS(1003),
    [anon_sym_mulmod] = ACTIONS(1003),
    [anon_sym_signextend] = ACTIONS(1003),
    [anon_sym_keccak256] = ACTIONS(1003),
    [anon_sym_pop] = ACTIONS(1003),
    [anon_sym_mload] = ACTIONS(1003),
    [anon_sym_mcopy] = ACTIONS(1003),
    [anon_sym_tload] = ACTIONS(1003),
    [anon_sym_tstore] = ACTIONS(1003),
    [anon_sym_mstore] = ACTIONS(1003),
    [anon_sym_mstore8] = ACTIONS(1003),
    [anon_sym_sload] = ACTIONS(1003),
    [anon_sym_sstore] = ACTIONS(1003),
    [anon_sym_msize] = ACTIONS(1003),
    [anon_sym_gas] = ACTIONS(1003),
    [anon_sym_address] = ACTIONS(1003),
    [anon_sym_balance] = ACTIONS(1003),
    [anon_sym_selfbalance] = ACTIONS(1003),
    [anon_sym_caller] = ACTIONS(1003),
    [anon_sym_callvalue] = ACTIONS(1003),
    [anon_sym_calldataload] = ACTIONS(1003),
    [anon_sym_calldatasize] = ACTIONS(1003),
    [anon_sym_calldatacopy] = ACTIONS(1003),
    [anon_sym_extcodesize] = ACTIONS(1003),
    [anon_sym_extcodecopy] = ACTIONS(1003),
    [anon_sym_returndatasize] = ACTIONS(1003),
    [anon_sym_returndatacopy] = ACTIONS(1003),
    [anon_sym_extcodehash] = ACTIONS(1003),
    [anon_sym_create] = ACTIONS(1003),
    [anon_sym_create2] = ACTIONS(1003),
    [anon_sym_call] = ACTIONS(1003),
    [anon_sym_callcode] = ACTIONS(1003),
    [anon_sym_delegatecall] = ACTIONS(1003),
    [anon_sym_staticcall] = ACTIONS(1003),
    [anon_sym_return] = ACTIONS(1003),
    [anon_sym_revert] = ACTIONS(1003),
    [anon_sym_selfdestruct] = ACTIONS(1003),
    [anon_sym_invalid] = ACTIONS(1003),
    [anon_sym_log0] = ACTIONS(1003),
    [anon_sym_log1] = ACTIONS(1003),
    [anon_sym_log2] = ACTIONS(1003),
    [anon_sym_log3] = ACTIONS(1003),
    [anon_sym_log4] = ACTIONS(1003),
    [anon_sym_chainid] = ACTIONS(1003),
    [anon_sym_origin] = ACTIONS(1003),
    [anon_sym_gasprice] = ACTIONS(1003),
    [anon_sym_blockhash] = ACTIONS(1003),
    [anon_sym_blobhash] = ACTIONS(1003),
    [anon_sym_basefee] = ACTIONS(1003),
    [anon_sym_blobfee] = ACTIONS(1003),
    [anon_sym_coinbase] = ACTIONS(1003),
    [anon_sym_timestamp] = ACTIONS(1003),
    [anon_sym_number] = ACTIONS(1003),
    [anon_sym_difficulty] = ACTIONS(1003),
    [anon_sym_gaslimit] = ACTIONS(1003),
    [anon_sym_DQUOTE] = ACTIONS(1005),
    [anon_sym_SQUOTE] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
  },
  [250] = {
    [aux_sym_yul_switch_statement_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1033),
    [anon_sym_LBRACE] = ACTIONS(1035),
    [anon_sym_RBRACE] = ACTIONS(1035),
    [anon_sym_for] = ACTIONS(1033),
    [sym_yul_leave] = ACTIONS(1033),
    [anon_sym_break] = ACTIONS(1033),
    [anon_sym_continue] = ACTIONS(1033),
    [sym_yul_decimal_number] = ACTIONS(1033),
    [sym_yul_hex_number] = ACTIONS(1035),
    [anon_sym_true] = ACTIONS(1033),
    [anon_sym_false] = ACTIONS(1033),
    [anon_sym_let] = ACTIONS(1033),
    [anon_sym_if] = ACTIONS(1033),
    [anon_sym_switch] = ACTIONS(1033),
    [anon_sym_default] = ACTIONS(1033),
    [anon_sym_case] = ACTIONS(1037),
    [anon_sym_function] = ACTIONS(1033),
    [anon_sym_stop] = ACTIONS(1033),
    [anon_sym_add] = ACTIONS(1033),
    [anon_sym_sub] = ACTIONS(1033),
    [anon_sym_mul] = ACTIONS(1033),
    [anon_sym_div] = ACTIONS(1033),
    [anon_sym_sdiv] = ACTIONS(1033),
    [anon_sym_mod] = ACTIONS(1033),
    [anon_sym_smod] = ACTIONS(1033),
    [anon_sym_exp] = ACTIONS(1033),
    [anon_sym_not] = ACTIONS(1033),
    [anon_sym_lt] = ACTIONS(1033),
    [anon_sym_gt] = ACTIONS(1033),
    [anon_sym_slt] = ACTIONS(1033),
    [anon_sym_sgt] = ACTIONS(1033),
    [anon_sym_eq] = ACTIONS(1033),
    [anon_sym_iszero] = ACTIONS(1033),
    [anon_sym_and] = ACTIONS(1033),
    [anon_sym_or] = ACTIONS(1033),
    [anon_sym_xor] = ACTIONS(1033),
    [anon_sym_byte] = ACTIONS(1033),
    [anon_sym_shl] = ACTIONS(1033),
    [anon_sym_shr] = ACTIONS(1033),
    [anon_sym_sar] = ACTIONS(1033),
    [anon_sym_addmod] = ACTIONS(1033),
    [anon_sym_mulmod] = ACTIONS(1033),
    [anon_sym_signextend] = ACTIONS(1033),
    [anon_sym_keccak256] = ACTIONS(1033),
    [anon_sym_pop] = ACTIONS(1033),
    [anon_sym_mload] = ACTIONS(1033),
    [anon_sym_mcopy] = ACTIONS(1033),
    [anon_sym_tload] = ACTIONS(1033),
    [anon_sym_tstore] = ACTIONS(1033),
    [anon_sym_mstore] = ACTIONS(1033),
    [anon_sym_mstore8] = ACTIONS(1033),
    [anon_sym_sload] = ACTIONS(1033),
    [anon_sym_sstore] = ACTIONS(1033),
    [anon_sym_msize] = ACTIONS(1033),
    [anon_sym_gas] = ACTIONS(1033),
    [anon_sym_address] = ACTIONS(1033),
    [anon_sym_balance] = ACTIONS(1033),
    [anon_sym_selfbalance] = ACTIONS(1033),
    [anon_sym_caller] = ACTIONS(1033),
    [anon_sym_callvalue] = ACTIONS(1033),
    [anon_sym_calldataload] = ACTIONS(1033),
    [anon_sym_calldatasize] = ACTIONS(1033),
    [anon_sym_calldatacopy] = ACTIONS(1033),
    [anon_sym_extcodesize] = ACTIONS(1033),
    [anon_sym_extcodecopy] = ACTIONS(1033),
    [anon_sym_returndatasize] = ACTIONS(1033),
    [anon_sym_returndatacopy] = ACTIONS(1033),
    [anon_sym_extcodehash] = ACTIONS(1033),
    [anon_sym_create] = ACTIONS(1033),
    [anon_sym_create2] = ACTIONS(1033),
    [anon_sym_call] = ACTIONS(1033),
    [anon_sym_callcode] = ACTIONS(1033),
    [anon_sym_delegatecall] = ACTIONS(1033),
    [anon_sym_staticcall] = ACTIONS(1033),
    [anon_sym_return] = ACTIONS(1033),
    [anon_sym_revert] = ACTIONS(1033),
    [anon_sym_selfdestruct] = ACTIONS(1033),
    [anon_sym_invalid] = ACTIONS(1033),
    [anon_sym_log0] = ACTIONS(1033),
    [anon_sym_log1] = ACTIONS(1033),
    [anon_sym_log2] = ACTIONS(1033),
    [anon_sym_log3] = ACTIONS(1033),
    [anon_sym_log4] = ACTIONS(1033),
    [anon_sym_chainid] = ACTIONS(1033),
    [anon_sym_origin] = ACTIONS(1033),
    [anon_sym_gasprice] = ACTIONS(1033),
    [anon_sym_blockhash] = ACTIONS(1033),
    [anon_sym_blobhash] = ACTIONS(1033),
    [anon_sym_basefee] = ACTIONS(1033),
    [anon_sym_blobfee] = ACTIONS(1033),
    [anon_sym_coinbase] = ACTIONS(1033),
    [anon_sym_timestamp] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1033),
    [anon_sym_difficulty] = ACTIONS(1033),
    [anon_sym_gaslimit] = ACTIONS(1033),
    [anon_sym_DQUOTE] = ACTIONS(1035),
    [anon_sym_SQUOTE] = ACTIONS(1035),
    [sym_comment] = ACTIONS(3),
  },
  [251] = {
    [aux_sym_yul_switch_statement_repeat1] = STATE(250),
    [sym_identifier] = ACTIONS(1040),
    [anon_sym_LBRACE] = ACTIONS(1042),
    [anon_sym_RBRACE] = ACTIONS(1042),
    [anon_sym_for] = ACTIONS(1040),
    [sym_yul_leave] = ACTIONS(1040),
    [anon_sym_break] = ACTIONS(1040),
    [anon_sym_continue] = ACTIONS(1040),
    [sym_yul_decimal_number] = ACTIONS(1040),
    [sym_yul_hex_number] = ACTIONS(1042),
    [anon_sym_true] = ACTIONS(1040),
    [anon_sym_false] = ACTIONS(1040),
    [anon_sym_let] = ACTIONS(1040),
    [anon_sym_if] = ACTIONS(1040),
    [anon_sym_switch] = ACTIONS(1040),
    [anon_sym_default] = ACTIONS(1044),
    [anon_sym_case] = ACTIONS(1046),
    [anon_sym_function] = ACTIONS(1040),
    [anon_sym_stop] = ACTIONS(1040),
    [anon_sym_add] = ACTIONS(1040),
    [anon_sym_sub] = ACTIONS(1040),
    [anon_sym_mul] = ACTIONS(1040),
    [anon_sym_div] = ACTIONS(1040),
    [anon_sym_sdiv] = ACTIONS(1040),
    [anon_sym_mod] = ACTIONS(1040),
    [anon_sym_smod] = ACTIONS(1040),
    [anon_sym_exp] = ACTIONS(1040),
    [anon_sym_not] = ACTIONS(1040),
    [anon_sym_lt] = ACTIONS(1040),
    [anon_sym_gt] = ACTIONS(1040),
    [anon_sym_slt] = ACTIONS(1040),
    [anon_sym_sgt] = ACTIONS(1040),
    [anon_sym_eq] = ACTIONS(1040),
    [anon_sym_iszero] = ACTIONS(1040),
    [anon_sym_and] = ACTIONS(1040),
    [anon_sym_or] = ACTIONS(1040),
    [anon_sym_xor] = ACTIONS(1040),
    [anon_sym_byte] = ACTIONS(1040),
    [anon_sym_shl] = ACTIONS(1040),
    [anon_sym_shr] = ACTIONS(1040),
    [anon_sym_sar] = ACTIONS(1040),
    [anon_sym_addmod] = ACTIONS(1040),
    [anon_sym_mulmod] = ACTIONS(1040),
    [anon_sym_signextend] = ACTIONS(1040),
    [anon_sym_keccak256] = ACTIONS(1040),
    [anon_sym_pop] = ACTIONS(1040),
    [anon_sym_mload] = ACTIONS(1040),
    [anon_sym_mcopy] = ACTIONS(1040),
    [anon_sym_tload] = ACTIONS(1040),
    [anon_sym_tstore] = ACTIONS(1040),
    [anon_sym_mstore] = ACTIONS(1040),
    [anon_sym_mstore8] = ACTIONS(1040),
    [anon_sym_sload] = ACTIONS(1040),
    [anon_sym_sstore] = ACTIONS(1040),
    [anon_sym_msize] = ACTIONS(1040),
    [anon_sym_gas] = ACTIONS(1040),
    [anon_sym_address] = ACTIONS(1040),
    [anon_sym_balance] = ACTIONS(1040),
    [anon_sym_selfbalance] = ACTIONS(1040),
    [anon_sym_caller] = ACTIONS(1040),
    [anon_sym_callvalue] = ACTIONS(1040),
    [anon_sym_calldataload] = ACTIONS(1040),
    [anon_sym_calldatasize] = ACTIONS(1040),
    [anon_sym_calldatacopy] = ACTIONS(1040),
    [anon_sym_extcodesize] = ACTIONS(1040),
    [anon_sym_extcodecopy] = ACTIONS(1040),
    [anon_sym_returndatasize] = ACTIONS(1040),
    [anon_sym_returndatacopy] = ACTIONS(1040),
    [anon_sym_extcodehash] = ACTIONS(1040),
    [anon_sym_create] = ACTIONS(1040),
    [anon_sym_create2] = ACTIONS(1040),
    [anon_sym_call] = ACTIONS(1040),
    [anon_sym_callcode] = ACTIONS(1040),
    [anon_sym_delegatecall] = ACTIONS(1040),
    [anon_sym_staticcall] = ACTIONS(1040),
    [anon_sym_return] = ACTIONS(1040),
    [anon_sym_revert] = ACTIONS(1040),
    [anon_sym_selfdestruct] = ACTIONS(1040),
    [anon_sym_invalid] = ACTIONS(1040),
    [anon_sym_log0] = ACTIONS(1040),
    [anon_sym_log1] = ACTIONS(1040),
    [anon_sym_log2] = ACTIONS(1040),
    [anon_sym_log3] = ACTIONS(1040),
    [anon_sym_log4] = ACTIONS(1040),
    [anon_sym_chainid] = ACTIONS(1040),
    [anon_sym_origin] = ACTIONS(1040),
    [anon_sym_gasprice] = ACTIONS(1040),
    [anon_sym_blockhash] = ACTIONS(1040),
    [anon_sym_blobhash] = ACTIONS(1040),
    [anon_sym_basefee] = ACTIONS(1040),
    [anon_sym_blobfee] = ACTIONS(1040),
    [anon_sym_coinbase] = ACTIONS(1040),
    [anon_sym_timestamp] = ACTIONS(1040),
    [anon_sym_number] = ACTIONS(1040),
    [anon_sym_difficulty] = ACTIONS(1040),
    [anon_sym_gaslimit] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_SQUOTE] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
  },
  [252] = {
    [sym_identifier] = ACTIONS(1018),
    [anon_sym_LBRACE] = ACTIONS(1020),
    [anon_sym_COMMA] = ACTIONS(1020),
    [anon_sym_RBRACE] = ACTIONS(1020),
    [anon_sym_for] = ACTIONS(1018),
    [anon_sym_COLON] = ACTIONS(1018),
    [sym_yul_leave] = ACTIONS(1018),
    [anon_sym_break] = ACTIONS(1018),
    [anon_sym_continue] = ACTIONS(1018),
    [sym_yul_decimal_number] = ACTIONS(1018),
    [sym_yul_hex_number] = ACTIONS(1020),
    [anon_sym_true] = ACTIONS(1018),
    [anon_sym_false] = ACTIONS(1018),
    [anon_sym_let] = ACTIONS(1018),
    [anon_sym_COLON_EQ] = ACTIONS(1020),
    [anon_sym_if] = ACTIONS(1018),
    [anon_sym_switch] = ACTIONS(1018),
    [anon_sym_function] = ACTIONS(1018),
    [anon_sym_stop] = ACTIONS(1018),
    [anon_sym_add] = ACTIONS(1018),
    [anon_sym_sub] = ACTIONS(1018),
    [anon_sym_mul] = ACTIONS(1018),
    [anon_sym_div] = ACTIONS(1018),
    [anon_sym_sdiv] = ACTIONS(1018),
    [anon_sym_mod] = ACTIONS(1018),
    [anon_sym_smod] = ACTIONS(1018),
    [anon_sym_exp] = ACTIONS(1018),
    [anon_sym_not] = ACTIONS(1018),
    [anon_sym_lt] = ACTIONS(1018),
    [anon_sym_gt] = ACTIONS(1018),
    [anon_sym_slt] = ACTIONS(1018),
    [anon_sym_sgt] = ACTIONS(1018),
    [anon_sym_eq] = ACTIONS(1018),
    [anon_sym_iszero] = ACTIONS(1018),
    [anon_sym_and] = ACTIONS(1018),
    [anon_sym_or] = ACTIONS(1018),
    [anon_sym_xor] = ACTIONS(1018),
    [anon_sym_byte] = ACTIONS(1018),
    [anon_sym_shl] = ACTIONS(1018),
    [anon_sym_shr] = ACTIONS(1018),
    [anon_sym_sar] = ACTIONS(1018),
    [anon_sym_addmod] = ACTIONS(1018),
    [anon_sym_mulmod] = ACTIONS(1018),
    [anon_sym_signextend] = ACTIONS(1018),
    [anon_sym_keccak256] = ACTIONS(1018),
    [anon_sym_pop] = ACTIONS(1018),
    [anon_sym_mload] = ACTIONS(1018),
    [anon_sym_mcopy] = ACTIONS(1018),
    [anon_sym_tload] = ACTIONS(1018),
    [anon_sym_tstore] = ACTIONS(1018),
    [anon_sym_mstore] = ACTIONS(1018),
    [anon_sym_mstore8] = ACTIONS(1018),
    [anon_sym_sload] = ACTIONS(1018),
    [anon_sym_sstore] = ACTIONS(1018),
    [anon_sym_msize] = ACTIONS(1018),
    [anon_sym_gas] = ACTIONS(1018),
    [anon_sym_address] = ACTIONS(1018),
    [anon_sym_balance] = ACTIONS(1018),
    [anon_sym_selfbalance] = ACTIONS(1018),
    [anon_sym_caller] = ACTIONS(1018),
    [anon_sym_callvalue] = ACTIONS(1018),
    [anon_sym_calldataload] = ACTIONS(1018),
    [anon_sym_calldatasize] = ACTIONS(1018),
    [anon_sym_calldatacopy] = ACTIONS(1018),
    [anon_sym_extcodesize] = ACTIONS(1018),
    [anon_sym_extcodecopy] = ACTIONS(1018),
    [anon_sym_returndatasize] = ACTIONS(1018),
    [anon_sym_returndatacopy] = ACTIONS(1018),
    [anon_sym_extcodehash] = ACTIONS(1018),
    [anon_sym_create] = ACTIONS(1018),
    [anon_sym_create2] = ACTIONS(1018),
    [anon_sym_call] = ACTIONS(1018),
    [anon_sym_callcode] = ACTIONS(1018),
    [anon_sym_delegatecall] = ACTIONS(1018),
    [anon_sym_staticcall] = ACTIONS(1018),
    [anon_sym_return] = ACTIONS(1018),
    [anon_sym_revert] = ACTIONS(1018),
    [anon_sym_selfdestruct] = ACTIONS(1018),
    [anon_sym_invalid] = ACTIONS(1018),
    [anon_sym_log0] = ACTIONS(1018),
    [anon_sym_log1] = ACTIONS(1018),
    [anon_sym_log2] = ACTIONS(1018),
    [anon_sym_log3] = ACTIONS(1018),
    [anon_sym_log4] = ACTIONS(1018),
    [anon_sym_chainid] = ACTIONS(1018),
    [anon_sym_origin] = ACTIONS(1018),
    [anon_sym_gasprice] = ACTIONS(1018),
    [anon_sym_blockhash] = ACTIONS(1018),
    [anon_sym_blobhash] = ACTIONS(1018),
    [anon_sym_basefee] = ACTIONS(1018),
    [anon_sym_blobfee] = ACTIONS(1018),
    [anon_sym_coinbase] = ACTIONS(1018),
    [anon_sym_timestamp] = ACTIONS(1018),
    [anon_sym_number] = ACTIONS(1018),
    [anon_sym_difficulty] = ACTIONS(1018),
    [anon_sym_gaslimit] = ACTIONS(1018),
    [anon_sym_DQUOTE] = ACTIONS(1020),
    [anon_sym_SQUOTE] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
  },
  [253] = {
    [aux_sym_yul_variable_declaration_repeat1] = STATE(254),
    [sym_identifier] = ACTIONS(1048),
    [anon_sym_LBRACE] = ACTIONS(1050),
    [anon_sym_COMMA] = ACTIONS(1052),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [anon_sym_for] = ACTIONS(1048),
    [sym_yul_leave] = ACTIONS(1048),
    [anon_sym_break] = ACTIONS(1048),
    [anon_sym_continue] = ACTIONS(1048),
    [sym_yul_decimal_number] = ACTIONS(1048),
    [sym_yul_hex_number] = ACTIONS(1050),
    [anon_sym_true] = ACTIONS(1048),
    [anon_sym_false] = ACTIONS(1048),
    [anon_sym_let] = ACTIONS(1048),
    [anon_sym_COLON_EQ] = ACTIONS(1054),
    [anon_sym_if] = ACTIONS(1048),
    [anon_sym_switch] = ACTIONS(1048),
    [anon_sym_function] = ACTIONS(1048),
    [anon_sym_stop] = ACTIONS(1048),
    [anon_sym_add] = ACTIONS(1048),
    [anon_sym_sub] = ACTIONS(1048),
    [anon_sym_mul] = ACTIONS(1048),
    [anon_sym_div] = ACTIONS(1048),
    [anon_sym_sdiv] = ACTIONS(1048),
    [anon_sym_mod] = ACTIONS(1048),
    [anon_sym_smod] = ACTIONS(1048),
    [anon_sym_exp] = ACTIONS(1048),
    [anon_sym_not] = ACTIONS(1048),
    [anon_sym_lt] = ACTIONS(1048),
    [anon_sym_gt] = ACTIONS(1048),
    [anon_sym_slt] = ACTIONS(1048),
    [anon_sym_sgt] = ACTIONS(1048),
    [anon_sym_eq] = ACTIONS(1048),
    [anon_sym_iszero] = ACTIONS(1048),
    [anon_sym_and] = ACTIONS(1048),
    [anon_sym_or] = ACTIONS(1048),
    [anon_sym_xor] = ACTIONS(1048),
    [anon_sym_byte] = ACTIONS(1048),
    [anon_sym_shl] = ACTIONS(1048),
    [anon_sym_shr] = ACTIONS(1048),
    [anon_sym_sar] = ACTIONS(1048),
    [anon_sym_addmod] = ACTIONS(1048),
    [anon_sym_mulmod] = ACTIONS(1048),
    [anon_sym_signextend] = ACTIONS(1048),
    [anon_sym_keccak256] = ACTIONS(1048),
    [anon_sym_pop] = ACTIONS(1048),
    [anon_sym_mload] = ACTIONS(1048),
    [anon_sym_mcopy] = ACTIONS(1048),
    [anon_sym_tload] = ACTIONS(1048),
    [anon_sym_tstore] = ACTIONS(1048),
    [anon_sym_mstore] = ACTIONS(1048),
    [anon_sym_mstore8] = ACTIONS(1048),
    [anon_sym_sload] = ACTIONS(1048),
    [anon_sym_sstore] = ACTIONS(1048),
    [anon_sym_msize] = ACTIONS(1048),
    [anon_sym_gas] = ACTIONS(1048),
    [anon_sym_address] = ACTIONS(1048),
    [anon_sym_balance] = ACTIONS(1048),
    [anon_sym_selfbalance] = ACTIONS(1048),
    [anon_sym_caller] = ACTIONS(1048),
    [anon_sym_callvalue] = ACTIONS(1048),
    [anon_sym_calldataload] = ACTIONS(1048),
    [anon_sym_calldatasize] = ACTIONS(1048),
    [anon_sym_calldatacopy] = ACTIONS(1048),
    [anon_sym_extcodesize] = ACTIONS(1048),
    [anon_sym_extcodecopy] = ACTIONS(1048),
    [anon_sym_returndatasize] = ACTIONS(1048),
    [anon_sym_returndatacopy] = ACTIONS(1048),
    [anon_sym_extcodehash] = ACTIONS(1048),
    [anon_sym_create] = ACTIONS(1048),
    [anon_sym_create2] = ACTIONS(1048),
    [anon_sym_call] = ACTIONS(1048),
    [anon_sym_callcode] = ACTIONS(1048),
    [anon_sym_delegatecall] = ACTIONS(1048),
    [anon_sym_staticcall] = ACTIONS(1048),
    [anon_sym_return] = ACTIONS(1048),
    [anon_sym_revert] = ACTIONS(1048),
    [anon_sym_selfdestruct] = ACTIONS(1048),
    [anon_sym_invalid] = ACTIONS(1048),
    [anon_sym_log0] = ACTIONS(1048),
    [anon_sym_log1] = ACTIONS(1048),
    [anon_sym_log2] = ACTIONS(1048),
    [anon_sym_log3] = ACTIONS(1048),
    [anon_sym_log4] = ACTIONS(1048),
    [anon_sym_chainid] = ACTIONS(1048),
    [anon_sym_origin] = ACTIONS(1048),
    [anon_sym_gasprice] = ACTIONS(1048),
    [anon_sym_blockhash] = ACTIONS(1048),
    [anon_sym_blobhash] = ACTIONS(1048),
    [anon_sym_basefee] = ACTIONS(1048),
    [anon_sym_blobfee] = ACTIONS(1048),
    [anon_sym_coinbase] = ACTIONS(1048),
    [anon_sym_timestamp] = ACTIONS(1048),
    [anon_sym_number] = ACTIONS(1048),
    [anon_sym_difficulty] = ACTIONS(1048),
    [anon_sym_gaslimit] = ACTIONS(1048),
    [anon_sym_DQUOTE] = ACTIONS(1050),
    [anon_sym_SQUOTE] = ACTIONS(1050),
    [sym_comment] = ACTIONS(3),
  },
  [254] = {
    [aux_sym_yul_variable_declaration_repeat1] = STATE(243),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_COMMA] = ACTIONS(1060),
    [anon_sym_RBRACE] = ACTIONS(1058),
    [anon_sym_for] = ACTIONS(1056),
    [sym_yul_leave] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [sym_yul_decimal_number] = ACTIONS(1056),
    [sym_yul_hex_number] = ACTIONS(1058),
    [anon_sym_true] = ACTIONS(1056),
    [anon_sym_false] = ACTIONS(1056),
    [anon_sym_let] = ACTIONS(1056),
    [anon_sym_COLON_EQ] = ACTIONS(1062),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(1056),
    [anon_sym_stop] = ACTIONS(1056),
    [anon_sym_add] = ACTIONS(1056),
    [anon_sym_sub] = ACTIONS(1056),
    [anon_sym_mul] = ACTIONS(1056),
    [anon_sym_div] = ACTIONS(1056),
    [anon_sym_sdiv] = ACTIONS(1056),
    [anon_sym_mod] = ACTIONS(1056),
    [anon_sym_smod] = ACTIONS(1056),
    [anon_sym_exp] = ACTIONS(1056),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_lt] = ACTIONS(1056),
    [anon_sym_gt] = ACTIONS(1056),
    [anon_sym_slt] = ACTIONS(1056),
    [anon_sym_sgt] = ACTIONS(1056),
    [anon_sym_eq] = ACTIONS(1056),
    [anon_sym_iszero] = ACTIONS(1056),
    [anon_sym_and] = ACTIONS(1056),
    [anon_sym_or] = ACTIONS(1056),
    [anon_sym_xor] = ACTIONS(1056),
    [anon_sym_byte] = ACTIONS(1056),
    [anon_sym_shl] = ACTIONS(1056),
    [anon_sym_shr] = ACTIONS(1056),
    [anon_sym_sar] = ACTIONS(1056),
    [anon_sym_addmod] = ACTIONS(1056),
    [anon_sym_mulmod] = ACTIONS(1056),
    [anon_sym_signextend] = ACTIONS(1056),
    [anon_sym_keccak256] = ACTIONS(1056),
    [anon_sym_pop] = ACTIONS(1056),
    [anon_sym_mload] = ACTIONS(1056),
    [anon_sym_mcopy] = ACTIONS(1056),
    [anon_sym_tload] = ACTIONS(1056),
    [anon_sym_tstore] = ACTIONS(1056),
    [anon_sym_mstore] = ACTIONS(1056),
    [anon_sym_mstore8] = ACTIONS(1056),
    [anon_sym_sload] = ACTIONS(1056),
    [anon_sym_sstore] = ACTIONS(1056),
    [anon_sym_msize] = ACTIONS(1056),
    [anon_sym_gas] = ACTIONS(1056),
    [anon_sym_address] = ACTIONS(1056),
    [anon_sym_balance] = ACTIONS(1056),
    [anon_sym_selfbalance] = ACTIONS(1056),
    [anon_sym_caller] = ACTIONS(1056),
    [anon_sym_callvalue] = ACTIONS(1056),
    [anon_sym_calldataload] = ACTIONS(1056),
    [anon_sym_calldatasize] = ACTIONS(1056),
    [anon_sym_calldatacopy] = ACTIONS(1056),
    [anon_sym_extcodesize] = ACTIONS(1056),
    [anon_sym_extcodecopy] = ACTIONS(1056),
    [anon_sym_returndatasize] = ACTIONS(1056),
    [anon_sym_returndatacopy] = ACTIONS(1056),
    [anon_sym_extcodehash] = ACTIONS(1056),
    [anon_sym_create] = ACTIONS(1056),
    [anon_sym_create2] = ACTIONS(1056),
    [anon_sym_call] = ACTIONS(1056),
    [anon_sym_callcode] = ACTIONS(1056),
    [anon_sym_delegatecall] = ACTIONS(1056),
    [anon_sym_staticcall] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_revert] = ACTIONS(1056),
    [anon_sym_selfdestruct] = ACTIONS(1056),
    [anon_sym_invalid] = ACTIONS(1056),
    [anon_sym_log0] = ACTIONS(1056),
    [anon_sym_log1] = ACTIONS(1056),
    [anon_sym_log2] = ACTIONS(1056),
    [anon_sym_log3] = ACTIONS(1056),
    [anon_sym_log4] = ACTIONS(1056),
    [anon_sym_chainid] = ACTIONS(1056),
    [anon_sym_origin] = ACTIONS(1056),
    [anon_sym_gasprice] = ACTIONS(1056),
    [anon_sym_blockhash] = ACTIONS(1056),
    [anon_sym_blobhash] = ACTIONS(1056),
    [anon_sym_basefee] = ACTIONS(1056),
    [anon_sym_blobfee] = ACTIONS(1056),
    [anon_sym_coinbase] = ACTIONS(1056),
    [anon_sym_timestamp] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_difficulty] = ACTIONS(1056),
    [anon_sym_gaslimit] = ACTIONS(1056),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [sym_comment] = ACTIONS(3),
  },
  [255] = {
    [sym_identifier] = ACTIONS(1064),
    [anon_sym_LBRACE] = ACTIONS(1066),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [anon_sym_for] = ACTIONS(1064),
    [sym_yul_leave] = ACTIONS(1064),
    [anon_sym_break] = ACTIONS(1064),
    [anon_sym_continue] = ACTIONS(1064),
    [sym_yul_decimal_number] = ACTIONS(1064),
    [sym_yul_hex_number] = ACTIONS(1066),
    [anon_sym_true] = ACTIONS(1064),
    [anon_sym_false] = ACTIONS(1064),
    [anon_sym_let] = ACTIONS(1064),
    [anon_sym_if] = ACTIONS(1064),
    [anon_sym_switch] = ACTIONS(1064),
    [anon_sym_default] = ACTIONS(1064),
    [anon_sym_case] = ACTIONS(1064),
    [anon_sym_function] = ACTIONS(1064),
    [anon_sym_stop] = ACTIONS(1064),
    [anon_sym_add] = ACTIONS(1064),
    [anon_sym_sub] = ACTIONS(1064),
    [anon_sym_mul] = ACTIONS(1064),
    [anon_sym_div] = ACTIONS(1064),
    [anon_sym_sdiv] = ACTIONS(1064),
    [anon_sym_mod] = ACTIONS(1064),
    [anon_sym_smod] = ACTIONS(1064),
    [anon_sym_exp] = ACTIONS(1064),
    [anon_sym_not] = ACTIONS(1064),
    [anon_sym_lt] = ACTIONS(1064),
    [anon_sym_gt] = ACTIONS(1064),
    [anon_sym_slt] = ACTIONS(1064),
    [anon_sym_sgt] = ACTIONS(1064),
    [anon_sym_eq] = ACTIONS(1064),
    [anon_sym_iszero] = ACTIONS(1064),
    [anon_sym_and] = ACTIONS(1064),
    [anon_sym_or] = ACTIONS(1064),
    [anon_sym_xor] = ACTIONS(1064),
    [anon_sym_byte] = ACTIONS(1064),
    [anon_sym_shl] = ACTIONS(1064),
    [anon_sym_shr] = ACTIONS(1064),
    [anon_sym_sar] = ACTIONS(1064),
    [anon_sym_addmod] = ACTIONS(1064),
    [anon_sym_mulmod] = ACTIONS(1064),
    [anon_sym_signextend] = ACTIONS(1064),
    [anon_sym_keccak256] = ACTIONS(1064),
    [anon_sym_pop] = ACTIONS(1064),
    [anon_sym_mload] = ACTIONS(1064),
    [anon_sym_mcopy] = ACTIONS(1064),
    [anon_sym_tload] = ACTIONS(1064),
    [anon_sym_tstore] = ACTIONS(1064),
    [anon_sym_mstore] = ACTIONS(1064),
    [anon_sym_mstore8] = ACTIONS(1064),
    [anon_sym_sload] = ACTIONS(1064),
    [anon_sym_sstore] = ACTIONS(1064),
    [anon_sym_msize] = ACTIONS(1064),
    [anon_sym_gas] = ACTIONS(1064),
    [anon_sym_address] = ACTIONS(1064),
    [anon_sym_balance] = ACTIONS(1064),
    [anon_sym_selfbalance] = ACTIONS(1064),
    [anon_sym_caller] = ACTIONS(1064),
    [anon_sym_callvalue] = ACTIONS(1064),
    [anon_sym_calldataload] = ACTIONS(1064),
    [anon_sym_calldatasize] = ACTIONS(1064),
    [anon_sym_calldatacopy] = ACTIONS(1064),
    [anon_sym_extcodesize] = ACTIONS(1064),
    [anon_sym_extcodecopy] = ACTIONS(1064),
    [anon_sym_returndatasize] = ACTIONS(1064),
    [anon_sym_returndatacopy] = ACTIONS(1064),
    [anon_sym_extcodehash] = ACTIONS(1064),
    [anon_sym_create] = ACTIONS(1064),
    [anon_sym_create2] = ACTIONS(1064),
    [anon_sym_call] = ACTIONS(1064),
    [anon_sym_callcode] = ACTIONS(1064),
    [anon_sym_delegatecall] = ACTIONS(1064),
    [anon_sym_staticcall] = ACTIONS(1064),
    [anon_sym_return] = ACTIONS(1064),
    [anon_sym_revert] = ACTIONS(1064),
    [anon_sym_selfdestruct] = ACTIONS(1064),
    [anon_sym_invalid] = ACTIONS(1064),
    [anon_sym_log0] = ACTIONS(1064),
    [anon_sym_log1] = ACTIONS(1064),
    [anon_sym_log2] = ACTIONS(1064),
    [anon_sym_log3] = ACTIONS(1064),
    [anon_sym_log4] = ACTIONS(1064),
    [anon_sym_chainid] = ACTIONS(1064),
    [anon_sym_origin] = ACTIONS(1064),
    [anon_sym_gasprice] = ACTIONS(1064),
    [anon_sym_blockhash] = ACTIONS(1064),
    [anon_sym_blobhash] = ACTIONS(1064),
    [anon_sym_basefee] = ACTIONS(1064),
    [anon_sym_blobfee] = ACTIONS(1064),
    [anon_sym_coinbase] = ACTIONS(1064),
    [anon_sym_timestamp] = ACTIONS(1064),
    [anon_sym_number] = ACTIONS(1064),
    [anon_sym_difficulty] = ACTIONS(1064),
    [anon_sym_gaslimit] = ACTIONS(1064),
    [anon_sym_DQUOTE] = ACTIONS(1066),
    [anon_sym_SQUOTE] = ACTIONS(1066),
    [sym_comment] = ACTIONS(3),
  },
  [256] = {
    [sym_yul_identifier] = STATE(249),
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_for] = ACTIONS(1068),
    [sym_yul_leave] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [sym_yul_decimal_number] = ACTIONS(1068),
    [sym_yul_hex_number] = ACTIONS(1070),
    [anon_sym_true] = ACTIONS(1068),
    [anon_sym_false] = ACTIONS(1068),
    [anon_sym_let] = ACTIONS(1068),
    [anon_sym_COLON_EQ] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_stop] = ACTIONS(1068),
    [anon_sym_add] = ACTIONS(1068),
    [anon_sym_sub] = ACTIONS(1068),
    [anon_sym_mul] = ACTIONS(1068),
    [anon_sym_div] = ACTIONS(1068),
    [anon_sym_sdiv] = ACTIONS(1068),
    [anon_sym_mod] = ACTIONS(1068),
    [anon_sym_smod] = ACTIONS(1068),
    [anon_sym_exp] = ACTIONS(1068),
    [anon_sym_not] = ACTIONS(1068),
    [anon_sym_lt] = ACTIONS(1068),
    [anon_sym_gt] = ACTIONS(1068),
    [anon_sym_slt] = ACTIONS(1068),
    [anon_sym_sgt] = ACTIONS(1068),
    [anon_sym_eq] = ACTIONS(1068),
    [anon_sym_iszero] = ACTIONS(1068),
    [anon_sym_and] = ACTIONS(1068),
    [anon_sym_or] = ACTIONS(1068),
    [anon_sym_xor] = ACTIONS(1068),
    [anon_sym_byte] = ACTIONS(1068),
    [anon_sym_shl] = ACTIONS(1068),
    [anon_sym_shr] = ACTIONS(1068),
    [anon_sym_sar] = ACTIONS(1068),
    [anon_sym_addmod] = ACTIONS(1068),
    [anon_sym_mulmod] = ACTIONS(1068),
    [anon_sym_signextend] = ACTIONS(1068),
    [anon_sym_keccak256] = ACTIONS(1068),
    [anon_sym_pop] = ACTIONS(1068),
    [anon_sym_mload] = ACTIONS(1068),
    [anon_sym_mcopy] = ACTIONS(1068),
    [anon_sym_tload] = ACTIONS(1068),
    [anon_sym_tstore] = ACTIONS(1068),
    [anon_sym_mstore] = ACTIONS(1068),
    [anon_sym_mstore8] = ACTIONS(1068),
    [anon_sym_sload] = ACTIONS(1068),
    [anon_sym_sstore] = ACTIONS(1068),
    [anon_sym_msize] = ACTIONS(1068),
    [anon_sym_gas] = ACTIONS(1068),
    [anon_sym_address] = ACTIONS(1068),
    [anon_sym_balance] = ACTIONS(1068),
    [anon_sym_selfbalance] = ACTIONS(1068),
    [anon_sym_caller] = ACTIONS(1068),
    [anon_sym_callvalue] = ACTIONS(1068),
    [anon_sym_calldataload] = ACTIONS(1068),
    [anon_sym_calldatasize] = ACTIONS(1068),
    [anon_sym_calldatacopy] = ACTIONS(1068),
    [anon_sym_extcodesize] = ACTIONS(1068),
    [anon_sym_extcodecopy] = ACTIONS(1068),
    [anon_sym_returndatasize] = ACTIONS(1068),
    [anon_sym_returndatacopy] = ACTIONS(1068),
    [anon_sym_extcodehash] = ACTIONS(1068),
    [anon_sym_create] = ACTIONS(1068),
    [anon_sym_create2] = ACTIONS(1068),
    [anon_sym_call] = ACTIONS(1068),
    [anon_sym_callcode] = ACTIONS(1068),
    [anon_sym_delegatecall] = ACTIONS(1068),
    [anon_sym_staticcall] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_revert] = ACTIONS(1068),
    [anon_sym_selfdestruct] = ACTIONS(1068),
    [anon_sym_invalid] = ACTIONS(1068),
    [anon_sym_log0] = ACTIONS(1068),
    [anon_sym_log1] = ACTIONS(1068),
    [anon_sym_log2] = ACTIONS(1068),
    [anon_sym_log3] = ACTIONS(1068),
    [anon_sym_log4] = ACTIONS(1068),
    [anon_sym_chainid] = ACTIONS(1068),
    [anon_sym_origin] = ACTIONS(1068),
    [anon_sym_gasprice] = ACTIONS(1068),
    [anon_sym_blockhash] = ACTIONS(1068),
    [anon_sym_blobhash] = ACTIONS(1068),
    [anon_sym_basefee] = ACTIONS(1068),
    [anon_sym_blobfee] = ACTIONS(1068),
    [anon_sym_coinbase] = ACTIONS(1068),
    [anon_sym_timestamp] = ACTIONS(1068),
    [anon_sym_number] = ACTIONS(1068),
    [anon_sym_difficulty] = ACTIONS(1068),
    [anon_sym_gaslimit] = ACTIONS(1068),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym_identifier] = ACTIONS(1074),
    [anon_sym_LBRACE] = ACTIONS(1076),
    [anon_sym_RBRACE] = ACTIONS(1076),
    [anon_sym_for] = ACTIONS(1074),
    [sym_yul_leave] = ACTIONS(1074),
    [anon_sym_break] = ACTIONS(1074),
    [anon_sym_continue] = ACTIONS(1074),
    [sym_yul_decimal_number] = ACTIONS(1074),
    [sym_yul_hex_number] = ACTIONS(1076),
    [anon_sym_true] = ACTIONS(1074),
    [anon_sym_false] = ACTIONS(1074),
    [anon_sym_let] = ACTIONS(1074),
    [anon_sym_if] = ACTIONS(1074),
    [anon_sym_switch] = ACTIONS(1074),
    [anon_sym_default] = ACTIONS(1074),
    [anon_sym_case] = ACTIONS(1074),
    [anon_sym_function] = ACTIONS(1074),
    [anon_sym_stop] = ACTIONS(1074),
    [anon_sym_add] = ACTIONS(1074),
    [anon_sym_sub] = ACTIONS(1074),
    [anon_sym_mul] = ACTIONS(1074),
    [anon_sym_div] = ACTIONS(1074),
    [anon_sym_sdiv] = ACTIONS(1074),
    [anon_sym_mod] = ACTIONS(1074),
    [anon_sym_smod] = ACTIONS(1074),
    [anon_sym_exp] = ACTIONS(1074),
    [anon_sym_not] = ACTIONS(1074),
    [anon_sym_lt] = ACTIONS(1074),
    [anon_sym_gt] = ACTIONS(1074),
    [anon_sym_slt] = ACTIONS(1074),
    [anon_sym_sgt] = ACTIONS(1074),
    [anon_sym_eq] = ACTIONS(1074),
    [anon_sym_iszero] = ACTIONS(1074),
    [anon_sym_and] = ACTIONS(1074),
    [anon_sym_or] = ACTIONS(1074),
    [anon_sym_xor] = ACTIONS(1074),
    [anon_sym_byte] = ACTIONS(1074),
    [anon_sym_shl] = ACTIONS(1074),
    [anon_sym_shr] = ACTIONS(1074),
    [anon_sym_sar] = ACTIONS(1074),
    [anon_sym_addmod] = ACTIONS(1074),
    [anon_sym_mulmod] = ACTIONS(1074),
    [anon_sym_signextend] = ACTIONS(1074),
    [anon_sym_keccak256] = ACTIONS(1074),
    [anon_sym_pop] = ACTIONS(1074),
    [anon_sym_mload] = ACTIONS(1074),
    [anon_sym_mcopy] = ACTIONS(1074),
    [anon_sym_tload] = ACTIONS(1074),
    [anon_sym_tstore] = ACTIONS(1074),
    [anon_sym_mstore] = ACTIONS(1074),
    [anon_sym_mstore8] = ACTIONS(1074),
    [anon_sym_sload] = ACTIONS(1074),
    [anon_sym_sstore] = ACTIONS(1074),
    [anon_sym_msize] = ACTIONS(1074),
    [anon_sym_gas] = ACTIONS(1074),
    [anon_sym_address] = ACTIONS(1074),
    [anon_sym_balance] = ACTIONS(1074),
    [anon_sym_selfbalance] = ACTIONS(1074),
    [anon_sym_caller] = ACTIONS(1074),
    [anon_sym_callvalue] = ACTIONS(1074),
    [anon_sym_calldataload] = ACTIONS(1074),
    [anon_sym_calldatasize] = ACTIONS(1074),
    [anon_sym_calldatacopy] = ACTIONS(1074),
    [anon_sym_extcodesize] = ACTIONS(1074),
    [anon_sym_extcodecopy] = ACTIONS(1074),
    [anon_sym_returndatasize] = ACTIONS(1074),
    [anon_sym_returndatacopy] = ACTIONS(1074),
    [anon_sym_extcodehash] = ACTIONS(1074),
    [anon_sym_create] = ACTIONS(1074),
    [anon_sym_create2] = ACTIONS(1074),
    [anon_sym_call] = ACTIONS(1074),
    [anon_sym_callcode] = ACTIONS(1074),
    [anon_sym_delegatecall] = ACTIONS(1074),
    [anon_sym_staticcall] = ACTIONS(1074),
    [anon_sym_return] = ACTIONS(1074),
    [anon_sym_revert] = ACTIONS(1074),
    [anon_sym_selfdestruct] = ACTIONS(1074),
    [anon_sym_invalid] = ACTIONS(1074),
    [anon_sym_log0] = ACTIONS(1074),
    [anon_sym_log1] = ACTIONS(1074),
    [anon_sym_log2] = ACTIONS(1074),
    [anon_sym_log3] = ACTIONS(1074),
    [anon_sym_log4] = ACTIONS(1074),
    [anon_sym_chainid] = ACTIONS(1074),
    [anon_sym_origin] = ACTIONS(1074),
    [anon_sym_gasprice] = ACTIONS(1074),
    [anon_sym_blockhash] = ACTIONS(1074),
    [anon_sym_blobhash] = ACTIONS(1074),
    [anon_sym_basefee] = ACTIONS(1074),
    [anon_sym_blobfee] = ACTIONS(1074),
    [anon_sym_coinbase] = ACTIONS(1074),
    [anon_sym_timestamp] = ACTIONS(1074),
    [anon_sym_number] = ACTIONS(1074),
    [anon_sym_difficulty] = ACTIONS(1074),
    [anon_sym_gaslimit] = ACTIONS(1074),
    [anon_sym_DQUOTE] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(1076),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_identifier] = ACTIONS(1078),
    [anon_sym_LBRACE] = ACTIONS(1080),
    [anon_sym_RBRACE] = ACTIONS(1080),
    [anon_sym_for] = ACTIONS(1078),
    [sym_yul_leave] = ACTIONS(1078),
    [anon_sym_break] = ACTIONS(1078),
    [anon_sym_continue] = ACTIONS(1078),
    [sym_yul_decimal_number] = ACTIONS(1078),
    [sym_yul_hex_number] = ACTIONS(1080),
    [anon_sym_true] = ACTIONS(1078),
    [anon_sym_false] = ACTIONS(1078),
    [anon_sym_let] = ACTIONS(1078),
    [anon_sym_if] = ACTIONS(1078),
    [anon_sym_switch] = ACTIONS(1078),
    [anon_sym_default] = ACTIONS(1078),
    [anon_sym_case] = ACTIONS(1078),
    [anon_sym_function] = ACTIONS(1078),
    [anon_sym_stop] = ACTIONS(1078),
    [anon_sym_add] = ACTIONS(1078),
    [anon_sym_sub] = ACTIONS(1078),
    [anon_sym_mul] = ACTIONS(1078),
    [anon_sym_div] = ACTIONS(1078),
    [anon_sym_sdiv] = ACTIONS(1078),
    [anon_sym_mod] = ACTIONS(1078),
    [anon_sym_smod] = ACTIONS(1078),
    [anon_sym_exp] = ACTIONS(1078),
    [anon_sym_not] = ACTIONS(1078),
    [anon_sym_lt] = ACTIONS(1078),
    [anon_sym_gt] = ACTIONS(1078),
    [anon_sym_slt] = ACTIONS(1078),
    [anon_sym_sgt] = ACTIONS(1078),
    [anon_sym_eq] = ACTIONS(1078),
    [anon_sym_iszero] = ACTIONS(1078),
    [anon_sym_and] = ACTIONS(1078),
    [anon_sym_or] = ACTIONS(1078),
    [anon_sym_xor] = ACTIONS(1078),
    [anon_sym_byte] = ACTIONS(1078),
    [anon_sym_shl] = ACTIONS(1078),
    [anon_sym_shr] = ACTIONS(1078),
    [anon_sym_sar] = ACTIONS(1078),
    [anon_sym_addmod] = ACTIONS(1078),
    [anon_sym_mulmod] = ACTIONS(1078),
    [anon_sym_signextend] = ACTIONS(1078),
    [anon_sym_keccak256] = ACTIONS(1078),
    [anon_sym_pop] = ACTIONS(1078),
    [anon_sym_mload] = ACTIONS(1078),
    [anon_sym_mcopy] = ACTIONS(1078),
    [anon_sym_tload] = ACTIONS(1078),
    [anon_sym_tstore] = ACTIONS(1078),
    [anon_sym_mstore] = ACTIONS(1078),
    [anon_sym_mstore8] = ACTIONS(1078),
    [anon_sym_sload] = ACTIONS(1078),
    [anon_sym_sstore] = ACTIONS(1078),
    [anon_sym_msize] = ACTIONS(1078),
    [anon_sym_gas] = ACTIONS(1078),
    [anon_sym_address] = ACTIONS(1078),
    [anon_sym_balance] = ACTIONS(1078),
    [anon_sym_selfbalance] = ACTIONS(1078),
    [anon_sym_caller] = ACTIONS(1078),
    [anon_sym_callvalue] = ACTIONS(1078),
    [anon_sym_calldataload] = ACTIONS(1078),
    [anon_sym_calldatasize] = ACTIONS(1078),
    [anon_sym_calldatacopy] = ACTIONS(1078),
    [anon_sym_extcodesize] = ACTIONS(1078),
    [anon_sym_extcodecopy] = ACTIONS(1078),
    [anon_sym_returndatasize] = ACTIONS(1078),
    [anon_sym_returndatacopy] = ACTIONS(1078),
    [anon_sym_extcodehash] = ACTIONS(1078),
    [anon_sym_create] = ACTIONS(1078),
    [anon_sym_create2] = ACTIONS(1078),
    [anon_sym_call] = ACTIONS(1078),
    [anon_sym_callcode] = ACTIONS(1078),
    [anon_sym_delegatecall] = ACTIONS(1078),
    [anon_sym_staticcall] = ACTIONS(1078),
    [anon_sym_return] = ACTIONS(1078),
    [anon_sym_revert] = ACTIONS(1078),
    [anon_sym_selfdestruct] = ACTIONS(1078),
    [anon_sym_invalid] = ACTIONS(1078),
    [anon_sym_log0] = ACTIONS(1078),
    [anon_sym_log1] = ACTIONS(1078),
    [anon_sym_log2] = ACTIONS(1078),
    [anon_sym_log3] = ACTIONS(1078),
    [anon_sym_log4] = ACTIONS(1078),
    [anon_sym_chainid] = ACTIONS(1078),
    [anon_sym_origin] = ACTIONS(1078),
    [anon_sym_gasprice] = ACTIONS(1078),
    [anon_sym_blockhash] = ACTIONS(1078),
    [anon_sym_blobhash] = ACTIONS(1078),
    [anon_sym_basefee] = ACTIONS(1078),
    [anon_sym_blobfee] = ACTIONS(1078),
    [anon_sym_coinbase] = ACTIONS(1078),
    [anon_sym_timestamp] = ACTIONS(1078),
    [anon_sym_number] = ACTIONS(1078),
    [anon_sym_difficulty] = ACTIONS(1078),
    [anon_sym_gaslimit] = ACTIONS(1078),
    [anon_sym_DQUOTE] = ACTIONS(1080),
    [anon_sym_SQUOTE] = ACTIONS(1080),
    [sym_comment] = ACTIONS(3),
  },
  [259] = {
    [sym_yul_identifier] = STATE(249),
    [sym_identifier] = ACTIONS(1056),
    [anon_sym_LBRACE] = ACTIONS(1058),
    [anon_sym_RBRACE] = ACTIONS(1058),
    [anon_sym_for] = ACTIONS(1056),
    [sym_yul_leave] = ACTIONS(1056),
    [anon_sym_break] = ACTIONS(1056),
    [anon_sym_continue] = ACTIONS(1056),
    [sym_yul_decimal_number] = ACTIONS(1056),
    [sym_yul_hex_number] = ACTIONS(1058),
    [anon_sym_true] = ACTIONS(1056),
    [anon_sym_false] = ACTIONS(1056),
    [anon_sym_let] = ACTIONS(1056),
    [anon_sym_COLON_EQ] = ACTIONS(1062),
    [anon_sym_if] = ACTIONS(1056),
    [anon_sym_switch] = ACTIONS(1056),
    [anon_sym_function] = ACTIONS(1056),
    [anon_sym_stop] = ACTIONS(1056),
    [anon_sym_add] = ACTIONS(1056),
    [anon_sym_sub] = ACTIONS(1056),
    [anon_sym_mul] = ACTIONS(1056),
    [anon_sym_div] = ACTIONS(1056),
    [anon_sym_sdiv] = ACTIONS(1056),
    [anon_sym_mod] = ACTIONS(1056),
    [anon_sym_smod] = ACTIONS(1056),
    [anon_sym_exp] = ACTIONS(1056),
    [anon_sym_not] = ACTIONS(1056),
    [anon_sym_lt] = ACTIONS(1056),
    [anon_sym_gt] = ACTIONS(1056),
    [anon_sym_slt] = ACTIONS(1056),
    [anon_sym_sgt] = ACTIONS(1056),
    [anon_sym_eq] = ACTIONS(1056),
    [anon_sym_iszero] = ACTIONS(1056),
    [anon_sym_and] = ACTIONS(1056),
    [anon_sym_or] = ACTIONS(1056),
    [anon_sym_xor] = ACTIONS(1056),
    [anon_sym_byte] = ACTIONS(1056),
    [anon_sym_shl] = ACTIONS(1056),
    [anon_sym_shr] = ACTIONS(1056),
    [anon_sym_sar] = ACTIONS(1056),
    [anon_sym_addmod] = ACTIONS(1056),
    [anon_sym_mulmod] = ACTIONS(1056),
    [anon_sym_signextend] = ACTIONS(1056),
    [anon_sym_keccak256] = ACTIONS(1056),
    [anon_sym_pop] = ACTIONS(1056),
    [anon_sym_mload] = ACTIONS(1056),
    [anon_sym_mcopy] = ACTIONS(1056),
    [anon_sym_tload] = ACTIONS(1056),
    [anon_sym_tstore] = ACTIONS(1056),
    [anon_sym_mstore] = ACTIONS(1056),
    [anon_sym_mstore8] = ACTIONS(1056),
    [anon_sym_sload] = ACTIONS(1056),
    [anon_sym_sstore] = ACTIONS(1056),
    [anon_sym_msize] = ACTIONS(1056),
    [anon_sym_gas] = ACTIONS(1056),
    [anon_sym_address] = ACTIONS(1056),
    [anon_sym_balance] = ACTIONS(1056),
    [anon_sym_selfbalance] = ACTIONS(1056),
    [anon_sym_caller] = ACTIONS(1056),
    [anon_sym_callvalue] = ACTIONS(1056),
    [anon_sym_calldataload] = ACTIONS(1056),
    [anon_sym_calldatasize] = ACTIONS(1056),
    [anon_sym_calldatacopy] = ACTIONS(1056),
    [anon_sym_extcodesize] = ACTIONS(1056),
    [anon_sym_extcodecopy] = ACTIONS(1056),
    [anon_sym_returndatasize] = ACTIONS(1056),
    [anon_sym_returndatacopy] = ACTIONS(1056),
    [anon_sym_extcodehash] = ACTIONS(1056),
    [anon_sym_create] = ACTIONS(1056),
    [anon_sym_create2] = ACTIONS(1056),
    [anon_sym_call] = ACTIONS(1056),
    [anon_sym_callcode] = ACTIONS(1056),
    [anon_sym_delegatecall] = ACTIONS(1056),
    [anon_sym_staticcall] = ACTIONS(1056),
    [anon_sym_return] = ACTIONS(1056),
    [anon_sym_revert] = ACTIONS(1056),
    [anon_sym_selfdestruct] = ACTIONS(1056),
    [anon_sym_invalid] = ACTIONS(1056),
    [anon_sym_log0] = ACTIONS(1056),
    [anon_sym_log1] = ACTIONS(1056),
    [anon_sym_log2] = ACTIONS(1056),
    [anon_sym_log3] = ACTIONS(1056),
    [anon_sym_log4] = ACTIONS(1056),
    [anon_sym_chainid] = ACTIONS(1056),
    [anon_sym_origin] = ACTIONS(1056),
    [anon_sym_gasprice] = ACTIONS(1056),
    [anon_sym_blockhash] = ACTIONS(1056),
    [anon_sym_blobhash] = ACTIONS(1056),
    [anon_sym_basefee] = ACTIONS(1056),
    [anon_sym_blobfee] = ACTIONS(1056),
    [anon_sym_coinbase] = ACTIONS(1056),
    [anon_sym_timestamp] = ACTIONS(1056),
    [anon_sym_number] = ACTIONS(1056),
    [anon_sym_difficulty] = ACTIONS(1056),
    [anon_sym_gaslimit] = ACTIONS(1056),
    [anon_sym_DQUOTE] = ACTIONS(1058),
    [anon_sym_SQUOTE] = ACTIONS(1058),
    [sym_comment] = ACTIONS(3),
  },
  [260] = {
    [sym_identifier] = ACTIONS(1082),
    [anon_sym_LBRACE] = ACTIONS(1084),
    [anon_sym_RBRACE] = ACTIONS(1084),
    [anon_sym_for] = ACTIONS(1082),
    [sym_yul_leave] = ACTIONS(1082),
    [anon_sym_break] = ACTIONS(1082),
    [anon_sym_continue] = ACTIONS(1082),
    [sym_yul_decimal_number] = ACTIONS(1082),
    [sym_yul_hex_number] = ACTIONS(1084),
    [anon_sym_true] = ACTIONS(1082),
    [anon_sym_false] = ACTIONS(1082),
    [anon_sym_let] = ACTIONS(1082),
    [anon_sym_COLON_EQ] = ACTIONS(1086),
    [anon_sym_if] = ACTIONS(1082),
    [anon_sym_switch] = ACTIONS(1082),
    [anon_sym_function] = ACTIONS(1082),
    [anon_sym_stop] = ACTIONS(1082),
    [anon_sym_add] = ACTIONS(1082),
    [anon_sym_sub] = ACTIONS(1082),
    [anon_sym_mul] = ACTIONS(1082),
    [anon_sym_div] = ACTIONS(1082),
    [anon_sym_sdiv] = ACTIONS(1082),
    [anon_sym_mod] = ACTIONS(1082),
    [anon_sym_smod] = ACTIONS(1082),
    [anon_sym_exp] = ACTIONS(1082),
    [anon_sym_not] = ACTIONS(1082),
    [anon_sym_lt] = ACTIONS(1082),
    [anon_sym_gt] = ACTIONS(1082),
    [anon_sym_slt] = ACTIONS(1082),
    [anon_sym_sgt] = ACTIONS(1082),
    [anon_sym_eq] = ACTIONS(1082),
    [anon_sym_iszero] = ACTIONS(1082),
    [anon_sym_and] = ACTIONS(1082),
    [anon_sym_or] = ACTIONS(1082),
    [anon_sym_xor] = ACTIONS(1082),
    [anon_sym_byte] = ACTIONS(1082),
    [anon_sym_shl] = ACTIONS(1082),
    [anon_sym_shr] = ACTIONS(1082),
    [anon_sym_sar] = ACTIONS(1082),
    [anon_sym_addmod] = ACTIONS(1082),
    [anon_sym_mulmod] = ACTIONS(1082),
    [anon_sym_signextend] = ACTIONS(1082),
    [anon_sym_keccak256] = ACTIONS(1082),
    [anon_sym_pop] = ACTIONS(1082),
    [anon_sym_mload] = ACTIONS(1082),
    [anon_sym_mcopy] = ACTIONS(1082),
    [anon_sym_tload] = ACTIONS(1082),
    [anon_sym_tstore] = ACTIONS(1082),
    [anon_sym_mstore] = ACTIONS(1082),
    [anon_sym_mstore8] = ACTIONS(1082),
    [anon_sym_sload] = ACTIONS(1082),
    [anon_sym_sstore] = ACTIONS(1082),
    [anon_sym_msize] = ACTIONS(1082),
    [anon_sym_gas] = ACTIONS(1082),
    [anon_sym_address] = ACTIONS(1082),
    [anon_sym_balance] = ACTIONS(1082),
    [anon_sym_selfbalance] = ACTIONS(1082),
    [anon_sym_caller] = ACTIONS(1082),
    [anon_sym_callvalue] = ACTIONS(1082),
    [anon_sym_calldataload] = ACTIONS(1082),
    [anon_sym_calldatasize] = ACTIONS(1082),
    [anon_sym_calldatacopy] = ACTIONS(1082),
    [anon_sym_extcodesize] = ACTIONS(1082),
    [anon_sym_extcodecopy] = ACTIONS(1082),
    [anon_sym_returndatasize] = ACTIONS(1082),
    [anon_sym_returndatacopy] = ACTIONS(1082),
    [anon_sym_extcodehash] = ACTIONS(1082),
    [anon_sym_create] = ACTIONS(1082),
    [anon_sym_create2] = ACTIONS(1082),
    [anon_sym_call] = ACTIONS(1082),
    [anon_sym_callcode] = ACTIONS(1082),
    [anon_sym_delegatecall] = ACTIONS(1082),
    [anon_sym_staticcall] = ACTIONS(1082),
    [anon_sym_return] = ACTIONS(1082),
    [anon_sym_revert] = ACTIONS(1082),
    [anon_sym_selfdestruct] = ACTIONS(1082),
    [anon_sym_invalid] = ACTIONS(1082),
    [anon_sym_log0] = ACTIONS(1082),
    [anon_sym_log1] = ACTIONS(1082),
    [anon_sym_log2] = ACTIONS(1082),
    [anon_sym_log3] = ACTIONS(1082),
    [anon_sym_log4] = ACTIONS(1082),
    [anon_sym_chainid] = ACTIONS(1082),
    [anon_sym_origin] = ACTIONS(1082),
    [anon_sym_gasprice] = ACTIONS(1082),
    [anon_sym_blockhash] = ACTIONS(1082),
    [anon_sym_blobhash] = ACTIONS(1082),
    [anon_sym_basefee] = ACTIONS(1082),
    [anon_sym_blobfee] = ACTIONS(1082),
    [anon_sym_coinbase] = ACTIONS(1082),
    [anon_sym_timestamp] = ACTIONS(1082),
    [anon_sym_number] = ACTIONS(1082),
    [anon_sym_difficulty] = ACTIONS(1082),
    [anon_sym_gaslimit] = ACTIONS(1082),
    [anon_sym_DQUOTE] = ACTIONS(1084),
    [anon_sym_SQUOTE] = ACTIONS(1084),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_identifier] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1090),
    [anon_sym_RBRACE] = ACTIONS(1090),
    [anon_sym_for] = ACTIONS(1088),
    [sym_yul_leave] = ACTIONS(1088),
    [anon_sym_break] = ACTIONS(1088),
    [anon_sym_continue] = ACTIONS(1088),
    [sym_yul_decimal_number] = ACTIONS(1088),
    [sym_yul_hex_number] = ACTIONS(1090),
    [anon_sym_true] = ACTIONS(1088),
    [anon_sym_false] = ACTIONS(1088),
    [anon_sym_let] = ACTIONS(1088),
    [anon_sym_COLON_EQ] = ACTIONS(1092),
    [anon_sym_if] = ACTIONS(1088),
    [anon_sym_switch] = ACTIONS(1088),
    [anon_sym_function] = ACTIONS(1088),
    [anon_sym_stop] = ACTIONS(1088),
    [anon_sym_add] = ACTIONS(1088),
    [anon_sym_sub] = ACTIONS(1088),
    [anon_sym_mul] = ACTIONS(1088),
    [anon_sym_div] = ACTIONS(1088),
    [anon_sym_sdiv] = ACTIONS(1088),
    [anon_sym_mod] = ACTIONS(1088),
    [anon_sym_smod] = ACTIONS(1088),
    [anon_sym_exp] = ACTIONS(1088),
    [anon_sym_not] = ACTIONS(1088),
    [anon_sym_lt] = ACTIONS(1088),
    [anon_sym_gt] = ACTIONS(1088),
    [anon_sym_slt] = ACTIONS(1088),
    [anon_sym_sgt] = ACTIONS(1088),
    [anon_sym_eq] = ACTIONS(1088),
    [anon_sym_iszero] = ACTIONS(1088),
    [anon_sym_and] = ACTIONS(1088),
    [anon_sym_or] = ACTIONS(1088),
    [anon_sym_xor] = ACTIONS(1088),
    [anon_sym_byte] = ACTIONS(1088),
    [anon_sym_shl] = ACTIONS(1088),
    [anon_sym_shr] = ACTIONS(1088),
    [anon_sym_sar] = ACTIONS(1088),
    [anon_sym_addmod] = ACTIONS(1088),
    [anon_sym_mulmod] = ACTIONS(1088),
    [anon_sym_signextend] = ACTIONS(1088),
    [anon_sym_keccak256] = ACTIONS(1088),
    [anon_sym_pop] = ACTIONS(1088),
    [anon_sym_mload] = ACTIONS(1088),
    [anon_sym_mcopy] = ACTIONS(1088),
    [anon_sym_tload] = ACTIONS(1088),
    [anon_sym_tstore] = ACTIONS(1088),
    [anon_sym_mstore] = ACTIONS(1088),
    [anon_sym_mstore8] = ACTIONS(1088),
    [anon_sym_sload] = ACTIONS(1088),
    [anon_sym_sstore] = ACTIONS(1088),
    [anon_sym_msize] = ACTIONS(1088),
    [anon_sym_gas] = ACTIONS(1088),
    [anon_sym_address] = ACTIONS(1088),
    [anon_sym_balance] = ACTIONS(1088),
    [anon_sym_selfbalance] = ACTIONS(1088),
    [anon_sym_caller] = ACTIONS(1088),
    [anon_sym_callvalue] = ACTIONS(1088),
    [anon_sym_calldataload] = ACTIONS(1088),
    [anon_sym_calldatasize] = ACTIONS(1088),
    [anon_sym_calldatacopy] = ACTIONS(1088),
    [anon_sym_extcodesize] = ACTIONS(1088),
    [anon_sym_extcodecopy] = ACTIONS(1088),
    [anon_sym_returndatasize] = ACTIONS(1088),
    [anon_sym_returndatacopy] = ACTIONS(1088),
    [anon_sym_extcodehash] = ACTIONS(1088),
    [anon_sym_create] = ACTIONS(1088),
    [anon_sym_create2] = ACTIONS(1088),
    [anon_sym_call] = ACTIONS(1088),
    [anon_sym_callcode] = ACTIONS(1088),
    [anon_sym_delegatecall] = ACTIONS(1088),
    [anon_sym_staticcall] = ACTIONS(1088),
    [anon_sym_return] = ACTIONS(1088),
    [anon_sym_revert] = ACTIONS(1088),
    [anon_sym_selfdestruct] = ACTIONS(1088),
    [anon_sym_invalid] = ACTIONS(1088),
    [anon_sym_log0] = ACTIONS(1088),
    [anon_sym_log1] = ACTIONS(1088),
    [anon_sym_log2] = ACTIONS(1088),
    [anon_sym_log3] = ACTIONS(1088),
    [anon_sym_log4] = ACTIONS(1088),
    [anon_sym_chainid] = ACTIONS(1088),
    [anon_sym_origin] = ACTIONS(1088),
    [anon_sym_gasprice] = ACTIONS(1088),
    [anon_sym_blockhash] = ACTIONS(1088),
    [anon_sym_blobhash] = ACTIONS(1088),
    [anon_sym_basefee] = ACTIONS(1088),
    [anon_sym_blobfee] = ACTIONS(1088),
    [anon_sym_coinbase] = ACTIONS(1088),
    [anon_sym_timestamp] = ACTIONS(1088),
    [anon_sym_number] = ACTIONS(1088),
    [anon_sym_difficulty] = ACTIONS(1088),
    [anon_sym_gaslimit] = ACTIONS(1088),
    [anon_sym_DQUOTE] = ACTIONS(1090),
    [anon_sym_SQUOTE] = ACTIONS(1090),
    [sym_comment] = ACTIONS(3),
  },
  [262] = {
    [sym_identifier] = ACTIONS(1068),
    [anon_sym_LBRACE] = ACTIONS(1070),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_for] = ACTIONS(1068),
    [sym_yul_leave] = ACTIONS(1068),
    [anon_sym_break] = ACTIONS(1068),
    [anon_sym_continue] = ACTIONS(1068),
    [sym_yul_decimal_number] = ACTIONS(1068),
    [sym_yul_hex_number] = ACTIONS(1070),
    [anon_sym_true] = ACTIONS(1068),
    [anon_sym_false] = ACTIONS(1068),
    [anon_sym_let] = ACTIONS(1068),
    [anon_sym_COLON_EQ] = ACTIONS(1072),
    [anon_sym_if] = ACTIONS(1068),
    [anon_sym_switch] = ACTIONS(1068),
    [anon_sym_function] = ACTIONS(1068),
    [anon_sym_stop] = ACTIONS(1068),
    [anon_sym_add] = ACTIONS(1068),
    [anon_sym_sub] = ACTIONS(1068),
    [anon_sym_mul] = ACTIONS(1068),
    [anon_sym_div] = ACTIONS(1068),
    [anon_sym_sdiv] = ACTIONS(1068),
    [anon_sym_mod] = ACTIONS(1068),
    [anon_sym_smod] = ACTIONS(1068),
    [anon_sym_exp] = ACTIONS(1068),
    [anon_sym_not] = ACTIONS(1068),
    [anon_sym_lt] = ACTIONS(1068),
    [anon_sym_gt] = ACTIONS(1068),
    [anon_sym_slt] = ACTIONS(1068),
    [anon_sym_sgt] = ACTIONS(1068),
    [anon_sym_eq] = ACTIONS(1068),
    [anon_sym_iszero] = ACTIONS(1068),
    [anon_sym_and] = ACTIONS(1068),
    [anon_sym_or] = ACTIONS(1068),
    [anon_sym_xor] = ACTIONS(1068),
    [anon_sym_byte] = ACTIONS(1068),
    [anon_sym_shl] = ACTIONS(1068),
    [anon_sym_shr] = ACTIONS(1068),
    [anon_sym_sar] = ACTIONS(1068),
    [anon_sym_addmod] = ACTIONS(1068),
    [anon_sym_mulmod] = ACTIONS(1068),
    [anon_sym_signextend] = ACTIONS(1068),
    [anon_sym_keccak256] = ACTIONS(1068),
    [anon_sym_pop] = ACTIONS(1068),
    [anon_sym_mload] = ACTIONS(1068),
    [anon_sym_mcopy] = ACTIONS(1068),
    [anon_sym_tload] = ACTIONS(1068),
    [anon_sym_tstore] = ACTIONS(1068),
    [anon_sym_mstore] = ACTIONS(1068),
    [anon_sym_mstore8] = ACTIONS(1068),
    [anon_sym_sload] = ACTIONS(1068),
    [anon_sym_sstore] = ACTIONS(1068),
    [anon_sym_msize] = ACTIONS(1068),
    [anon_sym_gas] = ACTIONS(1068),
    [anon_sym_address] = ACTIONS(1068),
    [anon_sym_balance] = ACTIONS(1068),
    [anon_sym_selfbalance] = ACTIONS(1068),
    [anon_sym_caller] = ACTIONS(1068),
    [anon_sym_callvalue] = ACTIONS(1068),
    [anon_sym_calldataload] = ACTIONS(1068),
    [anon_sym_calldatasize] = ACTIONS(1068),
    [anon_sym_calldatacopy] = ACTIONS(1068),
    [anon_sym_extcodesize] = ACTIONS(1068),
    [anon_sym_extcodecopy] = ACTIONS(1068),
    [anon_sym_returndatasize] = ACTIONS(1068),
    [anon_sym_returndatacopy] = ACTIONS(1068),
    [anon_sym_extcodehash] = ACTIONS(1068),
    [anon_sym_create] = ACTIONS(1068),
    [anon_sym_create2] = ACTIONS(1068),
    [anon_sym_call] = ACTIONS(1068),
    [anon_sym_callcode] = ACTIONS(1068),
    [anon_sym_delegatecall] = ACTIONS(1068),
    [anon_sym_staticcall] = ACTIONS(1068),
    [anon_sym_return] = ACTIONS(1068),
    [anon_sym_revert] = ACTIONS(1068),
    [anon_sym_selfdestruct] = ACTIONS(1068),
    [anon_sym_invalid] = ACTIONS(1068),
    [anon_sym_log0] = ACTIONS(1068),
    [anon_sym_log1] = ACTIONS(1068),
    [anon_sym_log2] = ACTIONS(1068),
    [anon_sym_log3] = ACTIONS(1068),
    [anon_sym_log4] = ACTIONS(1068),
    [anon_sym_chainid] = ACTIONS(1068),
    [anon_sym_origin] = ACTIONS(1068),
    [anon_sym_gasprice] = ACTIONS(1068),
    [anon_sym_blockhash] = ACTIONS(1068),
    [anon_sym_blobhash] = ACTIONS(1068),
    [anon_sym_basefee] = ACTIONS(1068),
    [anon_sym_blobfee] = ACTIONS(1068),
    [anon_sym_coinbase] = ACTIONS(1068),
    [anon_sym_timestamp] = ACTIONS(1068),
    [anon_sym_number] = ACTIONS(1068),
    [anon_sym_difficulty] = ACTIONS(1068),
    [anon_sym_gaslimit] = ACTIONS(1068),
    [anon_sym_DQUOTE] = ACTIONS(1070),
    [anon_sym_SQUOTE] = ACTIONS(1070),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [sym_identifier] = ACTIONS(1094),
    [anon_sym_LBRACE] = ACTIONS(1096),
    [anon_sym_RBRACE] = ACTIONS(1096),
    [anon_sym_for] = ACTIONS(1094),
    [sym_yul_leave] = ACTIONS(1094),
    [anon_sym_break] = ACTIONS(1094),
    [anon_sym_continue] = ACTIONS(1094),
    [sym_yul_decimal_number] = ACTIONS(1094),
    [sym_yul_hex_number] = ACTIONS(1096),
    [anon_sym_true] = ACTIONS(1094),
    [anon_sym_false] = ACTIONS(1094),
    [anon_sym_let] = ACTIONS(1094),
    [anon_sym_if] = ACTIONS(1094),
    [anon_sym_switch] = ACTIONS(1094),
    [anon_sym_function] = ACTIONS(1094),
    [anon_sym_stop] = ACTIONS(1094),
    [anon_sym_add] = ACTIONS(1094),
    [anon_sym_sub] = ACTIONS(1094),
    [anon_sym_mul] = ACTIONS(1094),
    [anon_sym_div] = ACTIONS(1094),
    [anon_sym_sdiv] = ACTIONS(1094),
    [anon_sym_mod] = ACTIONS(1094),
    [anon_sym_smod] = ACTIONS(1094),
    [anon_sym_exp] = ACTIONS(1094),
    [anon_sym_not] = ACTIONS(1094),
    [anon_sym_lt] = ACTIONS(1094),
    [anon_sym_gt] = ACTIONS(1094),
    [anon_sym_slt] = ACTIONS(1094),
    [anon_sym_sgt] = ACTIONS(1094),
    [anon_sym_eq] = ACTIONS(1094),
    [anon_sym_iszero] = ACTIONS(1094),
    [anon_sym_and] = ACTIONS(1094),
    [anon_sym_or] = ACTIONS(1094),
    [anon_sym_xor] = ACTIONS(1094),
    [anon_sym_byte] = ACTIONS(1094),
    [anon_sym_shl] = ACTIONS(1094),
    [anon_sym_shr] = ACTIONS(1094),
    [anon_sym_sar] = ACTIONS(1094),
    [anon_sym_addmod] = ACTIONS(1094),
    [anon_sym_mulmod] = ACTIONS(1094),
    [anon_sym_signextend] = ACTIONS(1094),
    [anon_sym_keccak256] = ACTIONS(1094),
    [anon_sym_pop] = ACTIONS(1094),
    [anon_sym_mload] = ACTIONS(1094),
    [anon_sym_mcopy] = ACTIONS(1094),
    [anon_sym_tload] = ACTIONS(1094),
    [anon_sym_tstore] = ACTIONS(1094),
    [anon_sym_mstore] = ACTIONS(1094),
    [anon_sym_mstore8] = ACTIONS(1094),
    [anon_sym_sload] = ACTIONS(1094),
    [anon_sym_sstore] = ACTIONS(1094),
    [anon_sym_msize] = ACTIONS(1094),
    [anon_sym_gas] = ACTIONS(1094),
    [anon_sym_address] = ACTIONS(1094),
    [anon_sym_balance] = ACTIONS(1094),
    [anon_sym_selfbalance] = ACTIONS(1094),
    [anon_sym_caller] = ACTIONS(1094),
    [anon_sym_callvalue] = ACTIONS(1094),
    [anon_sym_calldataload] = ACTIONS(1094),
    [anon_sym_calldatasize] = ACTIONS(1094),
    [anon_sym_calldatacopy] = ACTIONS(1094),
    [anon_sym_extcodesize] = ACTIONS(1094),
    [anon_sym_extcodecopy] = ACTIONS(1094),
    [anon_sym_returndatasize] = ACTIONS(1094),
    [anon_sym_returndatacopy] = ACTIONS(1094),
    [anon_sym_extcodehash] = ACTIONS(1094),
    [anon_sym_create] = ACTIONS(1094),
    [anon_sym_create2] = ACTIONS(1094),
    [anon_sym_call] = ACTIONS(1094),
    [anon_sym_callcode] = ACTIONS(1094),
    [anon_sym_delegatecall] = ACTIONS(1094),
    [anon_sym_staticcall] = ACTIONS(1094),
    [anon_sym_return] = ACTIONS(1094),
    [anon_sym_revert] = ACTIONS(1094),
    [anon_sym_selfdestruct] = ACTIONS(1094),
    [anon_sym_invalid] = ACTIONS(1094),
    [anon_sym_log0] = ACTIONS(1094),
    [anon_sym_log1] = ACTIONS(1094),
    [anon_sym_log2] = ACTIONS(1094),
    [anon_sym_log3] = ACTIONS(1094),
    [anon_sym_log4] = ACTIONS(1094),
    [anon_sym_chainid] = ACTIONS(1094),
    [anon_sym_origin] = ACTIONS(1094),
    [anon_sym_gasprice] = ACTIONS(1094),
    [anon_sym_blockhash] = ACTIONS(1094),
    [anon_sym_blobhash] = ACTIONS(1094),
    [anon_sym_basefee] = ACTIONS(1094),
    [anon_sym_blobfee] = ACTIONS(1094),
    [anon_sym_coinbase] = ACTIONS(1094),
    [anon_sym_timestamp] = ACTIONS(1094),
    [anon_sym_number] = ACTIONS(1094),
    [anon_sym_difficulty] = ACTIONS(1094),
    [anon_sym_gaslimit] = ACTIONS(1094),
    [anon_sym_DQUOTE] = ACTIONS(1096),
    [anon_sym_SQUOTE] = ACTIONS(1096),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_identifier] = ACTIONS(1098),
    [anon_sym_LBRACE] = ACTIONS(1100),
    [anon_sym_RBRACE] = ACTIONS(1100),
    [anon_sym_for] = ACTIONS(1098),
    [sym_yul_leave] = ACTIONS(1098),
    [anon_sym_break] = ACTIONS(1098),
    [anon_sym_continue] = ACTIONS(1098),
    [sym_yul_decimal_number] = ACTIONS(1098),
    [sym_yul_hex_number] = ACTIONS(1100),
    [anon_sym_true] = ACTIONS(1098),
    [anon_sym_false] = ACTIONS(1098),
    [anon_sym_let] = ACTIONS(1098),
    [anon_sym_if] = ACTIONS(1098),
    [anon_sym_switch] = ACTIONS(1098),
    [anon_sym_function] = ACTIONS(1098),
    [anon_sym_stop] = ACTIONS(1098),
    [anon_sym_add] = ACTIONS(1098),
    [anon_sym_sub] = ACTIONS(1098),
    [anon_sym_mul] = ACTIONS(1098),
    [anon_sym_div] = ACTIONS(1098),
    [anon_sym_sdiv] = ACTIONS(1098),
    [anon_sym_mod] = ACTIONS(1098),
    [anon_sym_smod] = ACTIONS(1098),
    [anon_sym_exp] = ACTIONS(1098),
    [anon_sym_not] = ACTIONS(1098),
    [anon_sym_lt] = ACTIONS(1098),
    [anon_sym_gt] = ACTIONS(1098),
    [anon_sym_slt] = ACTIONS(1098),
    [anon_sym_sgt] = ACTIONS(1098),
    [anon_sym_eq] = ACTIONS(1098),
    [anon_sym_iszero] = ACTIONS(1098),
    [anon_sym_and] = ACTIONS(1098),
    [anon_sym_or] = ACTIONS(1098),
    [anon_sym_xor] = ACTIONS(1098),
    [anon_sym_byte] = ACTIONS(1098),
    [anon_sym_shl] = ACTIONS(1098),
    [anon_sym_shr] = ACTIONS(1098),
    [anon_sym_sar] = ACTIONS(1098),
    [anon_sym_addmod] = ACTIONS(1098),
    [anon_sym_mulmod] = ACTIONS(1098),
    [anon_sym_signextend] = ACTIONS(1098),
    [anon_sym_keccak256] = ACTIONS(1098),
    [anon_sym_pop] = ACTIONS(1098),
    [anon_sym_mload] = ACTIONS(1098),
    [anon_sym_mcopy] = ACTIONS(1098),
    [anon_sym_tload] = ACTIONS(1098),
    [anon_sym_tstore] = ACTIONS(1098),
    [anon_sym_mstore] = ACTIONS(1098),
    [anon_sym_mstore8] = ACTIONS(1098),
    [anon_sym_sload] = ACTIONS(1098),
    [anon_sym_sstore] = ACTIONS(1098),
    [anon_sym_msize] = ACTIONS(1098),
    [anon_sym_gas] = ACTIONS(1098),
    [anon_sym_address] = ACTIONS(1098),
    [anon_sym_balance] = ACTIONS(1098),
    [anon_sym_selfbalance] = ACTIONS(1098),
    [anon_sym_caller] = ACTIONS(1098),
    [anon_sym_callvalue] = ACTIONS(1098),
    [anon_sym_calldataload] = ACTIONS(1098),
    [anon_sym_calldatasize] = ACTIONS(1098),
    [anon_sym_calldatacopy] = ACTIONS(1098),
    [anon_sym_extcodesize] = ACTIONS(1098),
    [anon_sym_extcodecopy] = ACTIONS(1098),
    [anon_sym_returndatasize] = ACTIONS(1098),
    [anon_sym_returndatacopy] = ACTIONS(1098),
    [anon_sym_extcodehash] = ACTIONS(1098),
    [anon_sym_create] = ACTIONS(1098),
    [anon_sym_create2] = ACTIONS(1098),
    [anon_sym_call] = ACTIONS(1098),
    [anon_sym_callcode] = ACTIONS(1098),
    [anon_sym_delegatecall] = ACTIONS(1098),
    [anon_sym_staticcall] = ACTIONS(1098),
    [anon_sym_return] = ACTIONS(1098),
    [anon_sym_revert] = ACTIONS(1098),
    [anon_sym_selfdestruct] = ACTIONS(1098),
    [anon_sym_invalid] = ACTIONS(1098),
    [anon_sym_log0] = ACTIONS(1098),
    [anon_sym_log1] = ACTIONS(1098),
    [anon_sym_log2] = ACTIONS(1098),
    [anon_sym_log3] = ACTIONS(1098),
    [anon_sym_log4] = ACTIONS(1098),
    [anon_sym_chainid] = ACTIONS(1098),
    [anon_sym_origin] = ACTIONS(1098),
    [anon_sym_gasprice] = ACTIONS(1098),
    [anon_sym_blockhash] = ACTIONS(1098),
    [anon_sym_blobhash] = ACTIONS(1098),
    [anon_sym_basefee] = ACTIONS(1098),
    [anon_sym_blobfee] = ACTIONS(1098),
    [anon_sym_coinbase] = ACTIONS(1098),
    [anon_sym_timestamp] = ACTIONS(1098),
    [anon_sym_number] = ACTIONS(1098),
    [anon_sym_difficulty] = ACTIONS(1098),
    [anon_sym_gaslimit] = ACTIONS(1098),
    [anon_sym_DQUOTE] = ACTIONS(1100),
    [anon_sym_SQUOTE] = ACTIONS(1100),
    [sym_comment] = ACTIONS(3),
  },
  [265] = {
    [sym_identifier] = ACTIONS(1102),
    [anon_sym_LBRACE] = ACTIONS(1104),
    [anon_sym_RBRACE] = ACTIONS(1104),
    [anon_sym_for] = ACTIONS(1102),
    [sym_yul_leave] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [sym_yul_decimal_number] = ACTIONS(1102),
    [sym_yul_hex_number] = ACTIONS(1104),
    [anon_sym_true] = ACTIONS(1102),
    [anon_sym_false] = ACTIONS(1102),
    [anon_sym_let] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1102),
    [anon_sym_switch] = ACTIONS(1102),
    [anon_sym_function] = ACTIONS(1102),
    [anon_sym_stop] = ACTIONS(1102),
    [anon_sym_add] = ACTIONS(1102),
    [anon_sym_sub] = ACTIONS(1102),
    [anon_sym_mul] = ACTIONS(1102),
    [anon_sym_div] = ACTIONS(1102),
    [anon_sym_sdiv] = ACTIONS(1102),
    [anon_sym_mod] = ACTIONS(1102),
    [anon_sym_smod] = ACTIONS(1102),
    [anon_sym_exp] = ACTIONS(1102),
    [anon_sym_not] = ACTIONS(1102),
    [anon_sym_lt] = ACTIONS(1102),
    [anon_sym_gt] = ACTIONS(1102),
    [anon_sym_slt] = ACTIONS(1102),
    [anon_sym_sgt] = ACTIONS(1102),
    [anon_sym_eq] = ACTIONS(1102),
    [anon_sym_iszero] = ACTIONS(1102),
    [anon_sym_and] = ACTIONS(1102),
    [anon_sym_or] = ACTIONS(1102),
    [anon_sym_xor] = ACTIONS(1102),
    [anon_sym_byte] = ACTIONS(1102),
    [anon_sym_shl] = ACTIONS(1102),
    [anon_sym_shr] = ACTIONS(1102),
    [anon_sym_sar] = ACTIONS(1102),
    [anon_sym_addmod] = ACTIONS(1102),
    [anon_sym_mulmod] = ACTIONS(1102),
    [anon_sym_signextend] = ACTIONS(1102),
    [anon_sym_keccak256] = ACTIONS(1102),
    [anon_sym_pop] = ACTIONS(1102),
    [anon_sym_mload] = ACTIONS(1102),
    [anon_sym_mcopy] = ACTIONS(1102),
    [anon_sym_tload] = ACTIONS(1102),
    [anon_sym_tstore] = ACTIONS(1102),
    [anon_sym_mstore] = ACTIONS(1102),
    [anon_sym_mstore8] = ACTIONS(1102),
    [anon_sym_sload] = ACTIONS(1102),
    [anon_sym_sstore] = ACTIONS(1102),
    [anon_sym_msize] = ACTIONS(1102),
    [anon_sym_gas] = ACTIONS(1102),
    [anon_sym_address] = ACTIONS(1102),
    [anon_sym_balance] = ACTIONS(1102),
    [anon_sym_selfbalance] = ACTIONS(1102),
    [anon_sym_caller] = ACTIONS(1102),
    [anon_sym_callvalue] = ACTIONS(1102),
    [anon_sym_calldataload] = ACTIONS(1102),
    [anon_sym_calldatasize] = ACTIONS(1102),
    [anon_sym_calldatacopy] = ACTIONS(1102),
    [anon_sym_extcodesize] = ACTIONS(1102),
    [anon_sym_extcodecopy] = ACTIONS(1102),
    [anon_sym_returndatasize] = ACTIONS(1102),
    [anon_sym_returndatacopy] = ACTIONS(1102),
    [anon_sym_extcodehash] = ACTIONS(1102),
    [anon_sym_create] = ACTIONS(1102),
    [anon_sym_create2] = ACTIONS(1102),
    [anon_sym_call] = ACTIONS(1102),
    [anon_sym_callcode] = ACTIONS(1102),
    [anon_sym_delegatecall] = ACTIONS(1102),
    [anon_sym_staticcall] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_revert] = ACTIONS(1102),
    [anon_sym_selfdestruct] = ACTIONS(1102),
    [anon_sym_invalid] = ACTIONS(1102),
    [anon_sym_log0] = ACTIONS(1102),
    [anon_sym_log1] = ACTIONS(1102),
    [anon_sym_log2] = ACTIONS(1102),
    [anon_sym_log3] = ACTIONS(1102),
    [anon_sym_log4] = ACTIONS(1102),
    [anon_sym_chainid] = ACTIONS(1102),
    [anon_sym_origin] = ACTIONS(1102),
    [anon_sym_gasprice] = ACTIONS(1102),
    [anon_sym_blockhash] = ACTIONS(1102),
    [anon_sym_blobhash] = ACTIONS(1102),
    [anon_sym_basefee] = ACTIONS(1102),
    [anon_sym_blobfee] = ACTIONS(1102),
    [anon_sym_coinbase] = ACTIONS(1102),
    [anon_sym_timestamp] = ACTIONS(1102),
    [anon_sym_number] = ACTIONS(1102),
    [anon_sym_difficulty] = ACTIONS(1102),
    [anon_sym_gaslimit] = ACTIONS(1102),
    [anon_sym_DQUOTE] = ACTIONS(1104),
    [anon_sym_SQUOTE] = ACTIONS(1104),
    [sym_comment] = ACTIONS(3),
  },
  [266] = {
    [sym_identifier] = ACTIONS(1106),
    [anon_sym_LBRACE] = ACTIONS(1108),
    [anon_sym_RBRACE] = ACTIONS(1108),
    [anon_sym_for] = ACTIONS(1106),
    [sym_yul_leave] = ACTIONS(1106),
    [anon_sym_break] = ACTIONS(1106),
    [anon_sym_continue] = ACTIONS(1106),
    [sym_yul_decimal_number] = ACTIONS(1106),
    [sym_yul_hex_number] = ACTIONS(1108),
    [anon_sym_true] = ACTIONS(1106),
    [anon_sym_false] = ACTIONS(1106),
    [anon_sym_let] = ACTIONS(1106),
    [anon_sym_if] = ACTIONS(1106),
    [anon_sym_switch] = ACTIONS(1106),
    [anon_sym_function] = ACTIONS(1106),
    [anon_sym_stop] = ACTIONS(1106),
    [anon_sym_add] = ACTIONS(1106),
    [anon_sym_sub] = ACTIONS(1106),
    [anon_sym_mul] = ACTIONS(1106),
    [anon_sym_div] = ACTIONS(1106),
    [anon_sym_sdiv] = ACTIONS(1106),
    [anon_sym_mod] = ACTIONS(1106),
    [anon_sym_smod] = ACTIONS(1106),
    [anon_sym_exp] = ACTIONS(1106),
    [anon_sym_not] = ACTIONS(1106),
    [anon_sym_lt] = ACTIONS(1106),
    [anon_sym_gt] = ACTIONS(1106),
    [anon_sym_slt] = ACTIONS(1106),
    [anon_sym_sgt] = ACTIONS(1106),
    [anon_sym_eq] = ACTIONS(1106),
    [anon_sym_iszero] = ACTIONS(1106),
    [anon_sym_and] = ACTIONS(1106),
    [anon_sym_or] = ACTIONS(1106),
    [anon_sym_xor] = ACTIONS(1106),
    [anon_sym_byte] = ACTIONS(1106),
    [anon_sym_shl] = ACTIONS(1106),
    [anon_sym_shr] = ACTIONS(1106),
    [anon_sym_sar] = ACTIONS(1106),
    [anon_sym_addmod] = ACTIONS(1106),
    [anon_sym_mulmod] = ACTIONS(1106),
    [anon_sym_signextend] = ACTIONS(1106),
    [anon_sym_keccak256] = ACTIONS(1106),
    [anon_sym_pop] = ACTIONS(1106),
    [anon_sym_mload] = ACTIONS(1106),
    [anon_sym_mcopy] = ACTIONS(1106),
    [anon_sym_tload] = ACTIONS(1106),
    [anon_sym_tstore] = ACTIONS(1106),
    [anon_sym_mstore] = ACTIONS(1106),
    [anon_sym_mstore8] = ACTIONS(1106),
    [anon_sym_sload] = ACTIONS(1106),
    [anon_sym_sstore] = ACTIONS(1106),
    [anon_sym_msize] = ACTIONS(1106),
    [anon_sym_gas] = ACTIONS(1106),
    [anon_sym_address] = ACTIONS(1106),
    [anon_sym_balance] = ACTIONS(1106),
    [anon_sym_selfbalance] = ACTIONS(1106),
    [anon_sym_caller] = ACTIONS(1106),
    [anon_sym_callvalue] = ACTIONS(1106),
    [anon_sym_calldataload] = ACTIONS(1106),
    [anon_sym_calldatasize] = ACTIONS(1106),
    [anon_sym_calldatacopy] = ACTIONS(1106),
    [anon_sym_extcodesize] = ACTIONS(1106),
    [anon_sym_extcodecopy] = ACTIONS(1106),
    [anon_sym_returndatasize] = ACTIONS(1106),
    [anon_sym_returndatacopy] = ACTIONS(1106),
    [anon_sym_extcodehash] = ACTIONS(1106),
    [anon_sym_create] = ACTIONS(1106),
    [anon_sym_create2] = ACTIONS(1106),
    [anon_sym_call] = ACTIONS(1106),
    [anon_sym_callcode] = ACTIONS(1106),
    [anon_sym_delegatecall] = ACTIONS(1106),
    [anon_sym_staticcall] = ACTIONS(1106),
    [anon_sym_return] = ACTIONS(1106),
    [anon_sym_revert] = ACTIONS(1106),
    [anon_sym_selfdestruct] = ACTIONS(1106),
    [anon_sym_invalid] = ACTIONS(1106),
    [anon_sym_log0] = ACTIONS(1106),
    [anon_sym_log1] = ACTIONS(1106),
    [anon_sym_log2] = ACTIONS(1106),
    [anon_sym_log3] = ACTIONS(1106),
    [anon_sym_log4] = ACTIONS(1106),
    [anon_sym_chainid] = ACTIONS(1106),
    [anon_sym_origin] = ACTIONS(1106),
    [anon_sym_gasprice] = ACTIONS(1106),
    [anon_sym_blockhash] = ACTIONS(1106),
    [anon_sym_blobhash] = ACTIONS(1106),
    [anon_sym_basefee] = ACTIONS(1106),
    [anon_sym_blobfee] = ACTIONS(1106),
    [anon_sym_coinbase] = ACTIONS(1106),
    [anon_sym_timestamp] = ACTIONS(1106),
    [anon_sym_number] = ACTIONS(1106),
    [anon_sym_difficulty] = ACTIONS(1106),
    [anon_sym_gaslimit] = ACTIONS(1106),
    [anon_sym_DQUOTE] = ACTIONS(1108),
    [anon_sym_SQUOTE] = ACTIONS(1108),
    [sym_comment] = ACTIONS(3),
  },
  [267] = {
    [sym_identifier] = ACTIONS(1110),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1110),
    [sym_yul_leave] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [sym_yul_decimal_number] = ACTIONS(1110),
    [sym_yul_hex_number] = ACTIONS(1112),
    [anon_sym_true] = ACTIONS(1110),
    [anon_sym_false] = ACTIONS(1110),
    [anon_sym_let] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1110),
    [anon_sym_switch] = ACTIONS(1110),
    [anon_sym_function] = ACTIONS(1110),
    [anon_sym_stop] = ACTIONS(1110),
    [anon_sym_add] = ACTIONS(1110),
    [anon_sym_sub] = ACTIONS(1110),
    [anon_sym_mul] = ACTIONS(1110),
    [anon_sym_div] = ACTIONS(1110),
    [anon_sym_sdiv] = ACTIONS(1110),
    [anon_sym_mod] = ACTIONS(1110),
    [anon_sym_smod] = ACTIONS(1110),
    [anon_sym_exp] = ACTIONS(1110),
    [anon_sym_not] = ACTIONS(1110),
    [anon_sym_lt] = ACTIONS(1110),
    [anon_sym_gt] = ACTIONS(1110),
    [anon_sym_slt] = ACTIONS(1110),
    [anon_sym_sgt] = ACTIONS(1110),
    [anon_sym_eq] = ACTIONS(1110),
    [anon_sym_iszero] = ACTIONS(1110),
    [anon_sym_and] = ACTIONS(1110),
    [anon_sym_or] = ACTIONS(1110),
    [anon_sym_xor] = ACTIONS(1110),
    [anon_sym_byte] = ACTIONS(1110),
    [anon_sym_shl] = ACTIONS(1110),
    [anon_sym_shr] = ACTIONS(1110),
    [anon_sym_sar] = ACTIONS(1110),
    [anon_sym_addmod] = ACTIONS(1110),
    [anon_sym_mulmod] = ACTIONS(1110),
    [anon_sym_signextend] = ACTIONS(1110),
    [anon_sym_keccak256] = ACTIONS(1110),
    [anon_sym_pop] = ACTIONS(1110),
    [anon_sym_mload] = ACTIONS(1110),
    [anon_sym_mcopy] = ACTIONS(1110),
    [anon_sym_tload] = ACTIONS(1110),
    [anon_sym_tstore] = ACTIONS(1110),
    [anon_sym_mstore] = ACTIONS(1110),
    [anon_sym_mstore8] = ACTIONS(1110),
    [anon_sym_sload] = ACTIONS(1110),
    [anon_sym_sstore] = ACTIONS(1110),
    [anon_sym_msize] = ACTIONS(1110),
    [anon_sym_gas] = ACTIONS(1110),
    [anon_sym_address] = ACTIONS(1110),
    [anon_sym_balance] = ACTIONS(1110),
    [anon_sym_selfbalance] = ACTIONS(1110),
    [anon_sym_caller] = ACTIONS(1110),
    [anon_sym_callvalue] = ACTIONS(1110),
    [anon_sym_calldataload] = ACTIONS(1110),
    [anon_sym_calldatasize] = ACTIONS(1110),
    [anon_sym_calldatacopy] = ACTIONS(1110),
    [anon_sym_extcodesize] = ACTIONS(1110),
    [anon_sym_extcodecopy] = ACTIONS(1110),
    [anon_sym_returndatasize] = ACTIONS(1110),
    [anon_sym_returndatacopy] = ACTIONS(1110),
    [anon_sym_extcodehash] = ACTIONS(1110),
    [anon_sym_create] = ACTIONS(1110),
    [anon_sym_create2] = ACTIONS(1110),
    [anon_sym_call] = ACTIONS(1110),
    [anon_sym_callcode] = ACTIONS(1110),
    [anon_sym_delegatecall] = ACTIONS(1110),
    [anon_sym_staticcall] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_revert] = ACTIONS(1110),
    [anon_sym_selfdestruct] = ACTIONS(1110),
    [anon_sym_invalid] = ACTIONS(1110),
    [anon_sym_log0] = ACTIONS(1110),
    [anon_sym_log1] = ACTIONS(1110),
    [anon_sym_log2] = ACTIONS(1110),
    [anon_sym_log3] = ACTIONS(1110),
    [anon_sym_log4] = ACTIONS(1110),
    [anon_sym_chainid] = ACTIONS(1110),
    [anon_sym_origin] = ACTIONS(1110),
    [anon_sym_gasprice] = ACTIONS(1110),
    [anon_sym_blockhash] = ACTIONS(1110),
    [anon_sym_blobhash] = ACTIONS(1110),
    [anon_sym_basefee] = ACTIONS(1110),
    [anon_sym_blobfee] = ACTIONS(1110),
    [anon_sym_coinbase] = ACTIONS(1110),
    [anon_sym_timestamp] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_difficulty] = ACTIONS(1110),
    [anon_sym_gaslimit] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [sym_comment] = ACTIONS(3),
  },
  [268] = {
    [sym_identifier] = ACTIONS(1110),
    [anon_sym_LBRACE] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(1112),
    [anon_sym_for] = ACTIONS(1110),
    [sym_yul_leave] = ACTIONS(1110),
    [anon_sym_break] = ACTIONS(1110),
    [anon_sym_continue] = ACTIONS(1110),
    [sym_yul_decimal_number] = ACTIONS(1110),
    [sym_yul_hex_number] = ACTIONS(1112),
    [anon_sym_true] = ACTIONS(1110),
    [anon_sym_false] = ACTIONS(1110),
    [anon_sym_let] = ACTIONS(1110),
    [anon_sym_if] = ACTIONS(1110),
    [anon_sym_switch] = ACTIONS(1110),
    [anon_sym_function] = ACTIONS(1110),
    [anon_sym_stop] = ACTIONS(1110),
    [anon_sym_add] = ACTIONS(1110),
    [anon_sym_sub] = ACTIONS(1110),
    [anon_sym_mul] = ACTIONS(1110),
    [anon_sym_div] = ACTIONS(1110),
    [anon_sym_sdiv] = ACTIONS(1110),
    [anon_sym_mod] = ACTIONS(1110),
    [anon_sym_smod] = ACTIONS(1110),
    [anon_sym_exp] = ACTIONS(1110),
    [anon_sym_not] = ACTIONS(1110),
    [anon_sym_lt] = ACTIONS(1110),
    [anon_sym_gt] = ACTIONS(1110),
    [anon_sym_slt] = ACTIONS(1110),
    [anon_sym_sgt] = ACTIONS(1110),
    [anon_sym_eq] = ACTIONS(1110),
    [anon_sym_iszero] = ACTIONS(1110),
    [anon_sym_and] = ACTIONS(1110),
    [anon_sym_or] = ACTIONS(1110),
    [anon_sym_xor] = ACTIONS(1110),
    [anon_sym_byte] = ACTIONS(1110),
    [anon_sym_shl] = ACTIONS(1110),
    [anon_sym_shr] = ACTIONS(1110),
    [anon_sym_sar] = ACTIONS(1110),
    [anon_sym_addmod] = ACTIONS(1110),
    [anon_sym_mulmod] = ACTIONS(1110),
    [anon_sym_signextend] = ACTIONS(1110),
    [anon_sym_keccak256] = ACTIONS(1110),
    [anon_sym_pop] = ACTIONS(1110),
    [anon_sym_mload] = ACTIONS(1110),
    [anon_sym_mcopy] = ACTIONS(1110),
    [anon_sym_tload] = ACTIONS(1110),
    [anon_sym_tstore] = ACTIONS(1110),
    [anon_sym_mstore] = ACTIONS(1110),
    [anon_sym_mstore8] = ACTIONS(1110),
    [anon_sym_sload] = ACTIONS(1110),
    [anon_sym_sstore] = ACTIONS(1110),
    [anon_sym_msize] = ACTIONS(1110),
    [anon_sym_gas] = ACTIONS(1110),
    [anon_sym_address] = ACTIONS(1110),
    [anon_sym_balance] = ACTIONS(1110),
    [anon_sym_selfbalance] = ACTIONS(1110),
    [anon_sym_caller] = ACTIONS(1110),
    [anon_sym_callvalue] = ACTIONS(1110),
    [anon_sym_calldataload] = ACTIONS(1110),
    [anon_sym_calldatasize] = ACTIONS(1110),
    [anon_sym_calldatacopy] = ACTIONS(1110),
    [anon_sym_extcodesize] = ACTIONS(1110),
    [anon_sym_extcodecopy] = ACTIONS(1110),
    [anon_sym_returndatasize] = ACTIONS(1110),
    [anon_sym_returndatacopy] = ACTIONS(1110),
    [anon_sym_extcodehash] = ACTIONS(1110),
    [anon_sym_create] = ACTIONS(1110),
    [anon_sym_create2] = ACTIONS(1110),
    [anon_sym_call] = ACTIONS(1110),
    [anon_sym_callcode] = ACTIONS(1110),
    [anon_sym_delegatecall] = ACTIONS(1110),
    [anon_sym_staticcall] = ACTIONS(1110),
    [anon_sym_return] = ACTIONS(1110),
    [anon_sym_revert] = ACTIONS(1110),
    [anon_sym_selfdestruct] = ACTIONS(1110),
    [anon_sym_invalid] = ACTIONS(1110),
    [anon_sym_log0] = ACTIONS(1110),
    [anon_sym_log1] = ACTIONS(1110),
    [anon_sym_log2] = ACTIONS(1110),
    [anon_sym_log3] = ACTIONS(1110),
    [anon_sym_log4] = ACTIONS(1110),
    [anon_sym_chainid] = ACTIONS(1110),
    [anon_sym_origin] = ACTIONS(1110),
    [anon_sym_gasprice] = ACTIONS(1110),
    [anon_sym_blockhash] = ACTIONS(1110),
    [anon_sym_blobhash] = ACTIONS(1110),
    [anon_sym_basefee] = ACTIONS(1110),
    [anon_sym_blobfee] = ACTIONS(1110),
    [anon_sym_coinbase] = ACTIONS(1110),
    [anon_sym_timestamp] = ACTIONS(1110),
    [anon_sym_number] = ACTIONS(1110),
    [anon_sym_difficulty] = ACTIONS(1110),
    [anon_sym_gaslimit] = ACTIONS(1110),
    [anon_sym_DQUOTE] = ACTIONS(1112),
    [anon_sym_SQUOTE] = ACTIONS(1112),
    [sym_comment] = ACTIONS(3),
  },
  [269] = {
    [sym_identifier] = ACTIONS(1114),
    [anon_sym_LBRACE] = ACTIONS(1116),
    [anon_sym_RBRACE] = ACTIONS(1116),
    [anon_sym_for] = ACTIONS(1114),
    [sym_yul_leave] = ACTIONS(1114),
    [anon_sym_break] = ACTIONS(1114),
    [anon_sym_continue] = ACTIONS(1114),
    [sym_yul_decimal_number] = ACTIONS(1114),
    [sym_yul_hex_number] = ACTIONS(1116),
    [anon_sym_true] = ACTIONS(1114),
    [anon_sym_false] = ACTIONS(1114),
    [anon_sym_let] = ACTIONS(1114),
    [anon_sym_if] = ACTIONS(1114),
    [anon_sym_switch] = ACTIONS(1114),
    [anon_sym_function] = ACTIONS(1114),
    [anon_sym_stop] = ACTIONS(1114),
    [anon_sym_add] = ACTIONS(1114),
    [anon_sym_sub] = ACTIONS(1114),
    [anon_sym_mul] = ACTIONS(1114),
    [anon_sym_div] = ACTIONS(1114),
    [anon_sym_sdiv] = ACTIONS(1114),
    [anon_sym_mod] = ACTIONS(1114),
    [anon_sym_smod] = ACTIONS(1114),
    [anon_sym_exp] = ACTIONS(1114),
    [anon_sym_not] = ACTIONS(1114),
    [anon_sym_lt] = ACTIONS(1114),
    [anon_sym_gt] = ACTIONS(1114),
    [anon_sym_slt] = ACTIONS(1114),
    [anon_sym_sgt] = ACTIONS(1114),
    [anon_sym_eq] = ACTIONS(1114),
    [anon_sym_iszero] = ACTIONS(1114),
    [anon_sym_and] = ACTIONS(1114),
    [anon_sym_or] = ACTIONS(1114),
    [anon_sym_xor] = ACTIONS(1114),
    [anon_sym_byte] = ACTIONS(1114),
    [anon_sym_shl] = ACTIONS(1114),
    [anon_sym_shr] = ACTIONS(1114),
    [anon_sym_sar] = ACTIONS(1114),
    [anon_sym_addmod] = ACTIONS(1114),
    [anon_sym_mulmod] = ACTIONS(1114),
    [anon_sym_signextend] = ACTIONS(1114),
    [anon_sym_keccak256] = ACTIONS(1114),
    [anon_sym_pop] = ACTIONS(1114),
    [anon_sym_mload] = ACTIONS(1114),
    [anon_sym_mcopy] = ACTIONS(1114),
    [anon_sym_tload] = ACTIONS(1114),
    [anon_sym_tstore] = ACTIONS(1114),
    [anon_sym_mstore] = ACTIONS(1114),
    [anon_sym_mstore8] = ACTIONS(1114),
    [anon_sym_sload] = ACTIONS(1114),
    [anon_sym_sstore] = ACTIONS(1114),
    [anon_sym_msize] = ACTIONS(1114),
    [anon_sym_gas] = ACTIONS(1114),
    [anon_sym_address] = ACTIONS(1114),
    [anon_sym_balance] = ACTIONS(1114),
    [anon_sym_selfbalance] = ACTIONS(1114),
    [anon_sym_caller] = ACTIONS(1114),
    [anon_sym_callvalue] = ACTIONS(1114),
    [anon_sym_calldataload] = ACTIONS(1114),
    [anon_sym_calldatasize] = ACTIONS(1114),
    [anon_sym_calldatacopy] = ACTIONS(1114),
    [anon_sym_extcodesize] = ACTIONS(1114),
    [anon_sym_extcodecopy] = ACTIONS(1114),
    [anon_sym_returndatasize] = ACTIONS(1114),
    [anon_sym_returndatacopy] = ACTIONS(1114),
    [anon_sym_extcodehash] = ACTIONS(1114),
    [anon_sym_create] = ACTIONS(1114),
    [anon_sym_create2] = ACTIONS(1114),
    [anon_sym_call] = ACTIONS(1114),
    [anon_sym_callcode] = ACTIONS(1114),
    [anon_sym_delegatecall] = ACTIONS(1114),
    [anon_sym_staticcall] = ACTIONS(1114),
    [anon_sym_return] = ACTIONS(1114),
    [anon_sym_revert] = ACTIONS(1114),
    [anon_sym_selfdestruct] = ACTIONS(1114),
    [anon_sym_invalid] = ACTIONS(1114),
    [anon_sym_log0] = ACTIONS(1114),
    [anon_sym_log1] = ACTIONS(1114),
    [anon_sym_log2] = ACTIONS(1114),
    [anon_sym_log3] = ACTIONS(1114),
    [anon_sym_log4] = ACTIONS(1114),
    [anon_sym_chainid] = ACTIONS(1114),
    [anon_sym_origin] = ACTIONS(1114),
    [anon_sym_gasprice] = ACTIONS(1114),
    [anon_sym_blockhash] = ACTIONS(1114),
    [anon_sym_blobhash] = ACTIONS(1114),
    [anon_sym_basefee] = ACTIONS(1114),
    [anon_sym_blobfee] = ACTIONS(1114),
    [anon_sym_coinbase] = ACTIONS(1114),
    [anon_sym_timestamp] = ACTIONS(1114),
    [anon_sym_number] = ACTIONS(1114),
    [anon_sym_difficulty] = ACTIONS(1114),
    [anon_sym_gaslimit] = ACTIONS(1114),
    [anon_sym_DQUOTE] = ACTIONS(1116),
    [anon_sym_SQUOTE] = ACTIONS(1116),
    [sym_comment] = ACTIONS(3),
  },
  [270] = {
    [sym_identifier] = ACTIONS(1118),
    [anon_sym_LBRACE] = ACTIONS(1120),
    [anon_sym_RBRACE] = ACTIONS(1120),
    [anon_sym_for] = ACTIONS(1118),
    [sym_yul_leave] = ACTIONS(1118),
    [anon_sym_break] = ACTIONS(1118),
    [anon_sym_continue] = ACTIONS(1118),
    [sym_yul_decimal_number] = ACTIONS(1118),
    [sym_yul_hex_number] = ACTIONS(1120),
    [anon_sym_true] = ACTIONS(1118),
    [anon_sym_false] = ACTIONS(1118),
    [anon_sym_let] = ACTIONS(1118),
    [anon_sym_if] = ACTIONS(1118),
    [anon_sym_switch] = ACTIONS(1118),
    [anon_sym_function] = ACTIONS(1118),
    [anon_sym_stop] = ACTIONS(1118),
    [anon_sym_add] = ACTIONS(1118),
    [anon_sym_sub] = ACTIONS(1118),
    [anon_sym_mul] = ACTIONS(1118),
    [anon_sym_div] = ACTIONS(1118),
    [anon_sym_sdiv] = ACTIONS(1118),
    [anon_sym_mod] = ACTIONS(1118),
    [anon_sym_smod] = ACTIONS(1118),
    [anon_sym_exp] = ACTIONS(1118),
    [anon_sym_not] = ACTIONS(1118),
    [anon_sym_lt] = ACTIONS(1118),
    [anon_sym_gt] = ACTIONS(1118),
    [anon_sym_slt] = ACTIONS(1118),
    [anon_sym_sgt] = ACTIONS(1118),
    [anon_sym_eq] = ACTIONS(1118),
    [anon_sym_iszero] = ACTIONS(1118),
    [anon_sym_and] = ACTIONS(1118),
    [anon_sym_or] = ACTIONS(1118),
    [anon_sym_xor] = ACTIONS(1118),
    [anon_sym_byte] = ACTIONS(1118),
    [anon_sym_shl] = ACTIONS(1118),
    [anon_sym_shr] = ACTIONS(1118),
    [anon_sym_sar] = ACTIONS(1118),
    [anon_sym_addmod] = ACTIONS(1118),
    [anon_sym_mulmod] = ACTIONS(1118),
    [anon_sym_signextend] = ACTIONS(1118),
    [anon_sym_keccak256] = ACTIONS(1118),
    [anon_sym_pop] = ACTIONS(1118),
    [anon_sym_mload] = ACTIONS(1118),
    [anon_sym_mcopy] = ACTIONS(1118),
    [anon_sym_tload] = ACTIONS(1118),
    [anon_sym_tstore] = ACTIONS(1118),
    [anon_sym_mstore] = ACTIONS(1118),
    [anon_sym_mstore8] = ACTIONS(1118),
    [anon_sym_sload] = ACTIONS(1118),
    [anon_sym_sstore] = ACTIONS(1118),
    [anon_sym_msize] = ACTIONS(1118),
    [anon_sym_gas] = ACTIONS(1118),
    [anon_sym_address] = ACTIONS(1118),
    [anon_sym_balance] = ACTIONS(1118),
    [anon_sym_selfbalance] = ACTIONS(1118),
    [anon_sym_caller] = ACTIONS(1118),
    [anon_sym_callvalue] = ACTIONS(1118),
    [anon_sym_calldataload] = ACTIONS(1118),
    [anon_sym_calldatasize] = ACTIONS(1118),
    [anon_sym_calldatacopy] = ACTIONS(1118),
    [anon_sym_extcodesize] = ACTIONS(1118),
    [anon_sym_extcodecopy] = ACTIONS(1118),
    [anon_sym_returndatasize] = ACTIONS(1118),
    [anon_sym_returndatacopy] = ACTIONS(1118),
    [anon_sym_extcodehash] = ACTIONS(1118),
    [anon_sym_create] = ACTIONS(1118),
    [anon_sym_create2] = ACTIONS(1118),
    [anon_sym_call] = ACTIONS(1118),
    [anon_sym_callcode] = ACTIONS(1118),
    [anon_sym_delegatecall] = ACTIONS(1118),
    [anon_sym_staticcall] = ACTIONS(1118),
    [anon_sym_return] = ACTIONS(1118),
    [anon_sym_revert] = ACTIONS(1118),
    [anon_sym_selfdestruct] = ACTIONS(1118),
    [anon_sym_invalid] = ACTIONS(1118),
    [anon_sym_log0] = ACTIONS(1118),
    [anon_sym_log1] = ACTIONS(1118),
    [anon_sym_log2] = ACTIONS(1118),
    [anon_sym_log3] = ACTIONS(1118),
    [anon_sym_log4] = ACTIONS(1118),
    [anon_sym_chainid] = ACTIONS(1118),
    [anon_sym_origin] = ACTIONS(1118),
    [anon_sym_gasprice] = ACTIONS(1118),
    [anon_sym_blockhash] = ACTIONS(1118),
    [anon_sym_blobhash] = ACTIONS(1118),
    [anon_sym_basefee] = ACTIONS(1118),
    [anon_sym_blobfee] = ACTIONS(1118),
    [anon_sym_coinbase] = ACTIONS(1118),
    [anon_sym_timestamp] = ACTIONS(1118),
    [anon_sym_number] = ACTIONS(1118),
    [anon_sym_difficulty] = ACTIONS(1118),
    [anon_sym_gaslimit] = ACTIONS(1118),
    [anon_sym_DQUOTE] = ACTIONS(1120),
    [anon_sym_SQUOTE] = ACTIONS(1120),
    [sym_comment] = ACTIONS(3),
  },
  [271] = {
    [sym_identifier] = ACTIONS(1122),
    [anon_sym_LBRACE] = ACTIONS(1124),
    [anon_sym_RBRACE] = ACTIONS(1124),
    [anon_sym_for] = ACTIONS(1122),
    [sym_yul_leave] = ACTIONS(1122),
    [anon_sym_break] = ACTIONS(1122),
    [anon_sym_continue] = ACTIONS(1122),
    [sym_yul_decimal_number] = ACTIONS(1122),
    [sym_yul_hex_number] = ACTIONS(1124),
    [anon_sym_true] = ACTIONS(1122),
    [anon_sym_false] = ACTIONS(1122),
    [anon_sym_let] = ACTIONS(1122),
    [anon_sym_if] = ACTIONS(1122),
    [anon_sym_switch] = ACTIONS(1122),
    [anon_sym_function] = ACTIONS(1122),
    [anon_sym_stop] = ACTIONS(1122),
    [anon_sym_add] = ACTIONS(1122),
    [anon_sym_sub] = ACTIONS(1122),
    [anon_sym_mul] = ACTIONS(1122),
    [anon_sym_div] = ACTIONS(1122),
    [anon_sym_sdiv] = ACTIONS(1122),
    [anon_sym_mod] = ACTIONS(1122),
    [anon_sym_smod] = ACTIONS(1122),
    [anon_sym_exp] = ACTIONS(1122),
    [anon_sym_not] = ACTIONS(1122),
    [anon_sym_lt] = ACTIONS(1122),
    [anon_sym_gt] = ACTIONS(1122),
    [anon_sym_slt] = ACTIONS(1122),
    [anon_sym_sgt] = ACTIONS(1122),
    [anon_sym_eq] = ACTIONS(1122),
    [anon_sym_iszero] = ACTIONS(1122),
    [anon_sym_and] = ACTIONS(1122),
    [anon_sym_or] = ACTIONS(1122),
    [anon_sym_xor] = ACTIONS(1122),
    [anon_sym_byte] = ACTIONS(1122),
    [anon_sym_shl] = ACTIONS(1122),
    [anon_sym_shr] = ACTIONS(1122),
    [anon_sym_sar] = ACTIONS(1122),
    [anon_sym_addmod] = ACTIONS(1122),
    [anon_sym_mulmod] = ACTIONS(1122),
    [anon_sym_signextend] = ACTIONS(1122),
    [anon_sym_keccak256] = ACTIONS(1122),
    [anon_sym_pop] = ACTIONS(1122),
    [anon_sym_mload] = ACTIONS(1122),
    [anon_sym_mcopy] = ACTIONS(1122),
    [anon_sym_tload] = ACTIONS(1122),
    [anon_sym_tstore] = ACTIONS(1122),
    [anon_sym_mstore] = ACTIONS(1122),
    [anon_sym_mstore8] = ACTIONS(1122),
    [anon_sym_sload] = ACTIONS(1122),
    [anon_sym_sstore] = ACTIONS(1122),
    [anon_sym_msize] = ACTIONS(1122),
    [anon_sym_gas] = ACTIONS(1122),
    [anon_sym_address] = ACTIONS(1122),
    [anon_sym_balance] = ACTIONS(1122),
    [anon_sym_selfbalance] = ACTIONS(1122),
    [anon_sym_caller] = ACTIONS(1122),
    [anon_sym_callvalue] = ACTIONS(1122),
    [anon_sym_calldataload] = ACTIONS(1122),
    [anon_sym_calldatasize] = ACTIONS(1122),
    [anon_sym_calldatacopy] = ACTIONS(1122),
    [anon_sym_extcodesize] = ACTIONS(1122),
    [anon_sym_extcodecopy] = ACTIONS(1122),
    [anon_sym_returndatasize] = ACTIONS(1122),
    [anon_sym_returndatacopy] = ACTIONS(1122),
    [anon_sym_extcodehash] = ACTIONS(1122),
    [anon_sym_create] = ACTIONS(1122),
    [anon_sym_create2] = ACTIONS(1122),
    [anon_sym_call] = ACTIONS(1122),
    [anon_sym_callcode] = ACTIONS(1122),
    [anon_sym_delegatecall] = ACTIONS(1122),
    [anon_sym_staticcall] = ACTIONS(1122),
    [anon_sym_return] = ACTIONS(1122),
    [anon_sym_revert] = ACTIONS(1122),
    [anon_sym_selfdestruct] = ACTIONS(1122),
    [anon_sym_invalid] = ACTIONS(1122),
    [anon_sym_log0] = ACTIONS(1122),
    [anon_sym_log1] = ACTIONS(1122),
    [anon_sym_log2] = ACTIONS(1122),
    [anon_sym_log3] = ACTIONS(1122),
    [anon_sym_log4] = ACTIONS(1122),
    [anon_sym_chainid] = ACTIONS(1122),
    [anon_sym_origin] = ACTIONS(1122),
    [anon_sym_gasprice] = ACTIONS(1122),
    [anon_sym_blockhash] = ACTIONS(1122),
    [anon_sym_blobhash] = ACTIONS(1122),
    [anon_sym_basefee] = ACTIONS(1122),
    [anon_sym_blobfee] = ACTIONS(1122),
    [anon_sym_coinbase] = ACTIONS(1122),
    [anon_sym_timestamp] = ACTIONS(1122),
    [anon_sym_number] = ACTIONS(1122),
    [anon_sym_difficulty] = ACTIONS(1122),
    [anon_sym_gaslimit] = ACTIONS(1122),
    [anon_sym_DQUOTE] = ACTIONS(1124),
    [anon_sym_SQUOTE] = ACTIONS(1124),
    [sym_comment] = ACTIONS(3),
  },
  [272] = {
    [sym_identifier] = ACTIONS(1126),
    [anon_sym_LBRACE] = ACTIONS(1128),
    [anon_sym_RBRACE] = ACTIONS(1128),
    [anon_sym_for] = ACTIONS(1126),
    [sym_yul_leave] = ACTIONS(1126),
    [anon_sym_break] = ACTIONS(1126),
    [anon_sym_continue] = ACTIONS(1126),
    [sym_yul_decimal_number] = ACTIONS(1126),
    [sym_yul_hex_number] = ACTIONS(1128),
    [anon_sym_true] = ACTIONS(1126),
    [anon_sym_false] = ACTIONS(1126),
    [anon_sym_let] = ACTIONS(1126),
    [anon_sym_if] = ACTIONS(1126),
    [anon_sym_switch] = ACTIONS(1126),
    [anon_sym_function] = ACTIONS(1126),
    [anon_sym_stop] = ACTIONS(1126),
    [anon_sym_add] = ACTIONS(1126),
    [anon_sym_sub] = ACTIONS(1126),
    [anon_sym_mul] = ACTIONS(1126),
    [anon_sym_div] = ACTIONS(1126),
    [anon_sym_sdiv] = ACTIONS(1126),
    [anon_sym_mod] = ACTIONS(1126),
    [anon_sym_smod] = ACTIONS(1126),
    [anon_sym_exp] = ACTIONS(1126),
    [anon_sym_not] = ACTIONS(1126),
    [anon_sym_lt] = ACTIONS(1126),
    [anon_sym_gt] = ACTIONS(1126),
    [anon_sym_slt] = ACTIONS(1126),
    [anon_sym_sgt] = ACTIONS(1126),
    [anon_sym_eq] = ACTIONS(1126),
    [anon_sym_iszero] = ACTIONS(1126),
    [anon_sym_and] = ACTIONS(1126),
    [anon_sym_or] = ACTIONS(1126),
    [anon_sym_xor] = ACTIONS(1126),
    [anon_sym_byte] = ACTIONS(1126),
    [anon_sym_shl] = ACTIONS(1126),
    [anon_sym_shr] = ACTIONS(1126),
    [anon_sym_sar] = ACTIONS(1126),
    [anon_sym_addmod] = ACTIONS(1126),
    [anon_sym_mulmod] = ACTIONS(1126),
    [anon_sym_signextend] = ACTIONS(1126),
    [anon_sym_keccak256] = ACTIONS(1126),
    [anon_sym_pop] = ACTIONS(1126),
    [anon_sym_mload] = ACTIONS(1126),
    [anon_sym_mcopy] = ACTIONS(1126),
    [anon_sym_tload] = ACTIONS(1126),
    [anon_sym_tstore] = ACTIONS(1126),
    [anon_sym_mstore] = ACTIONS(1126),
    [anon_sym_mstore8] = ACTIONS(1126),
    [anon_sym_sload] = ACTIONS(1126),
    [anon_sym_sstore] = ACTIONS(1126),
    [anon_sym_msize] = ACTIONS(1126),
    [anon_sym_gas] = ACTIONS(1126),
    [anon_sym_address] = ACTIONS(1126),
    [anon_sym_balance] = ACTIONS(1126),
    [anon_sym_selfbalance] = ACTIONS(1126),
    [anon_sym_caller] = ACTIONS(1126),
    [anon_sym_callvalue] = ACTIONS(1126),
    [anon_sym_calldataload] = ACTIONS(1126),
    [anon_sym_calldatasize] = ACTIONS(1126),
    [anon_sym_calldatacopy] = ACTIONS(1126),
    [anon_sym_extcodesize] = ACTIONS(1126),
    [anon_sym_extcodecopy] = ACTIONS(1126),
    [anon_sym_returndatasize] = ACTIONS(1126),
    [anon_sym_returndatacopy] = ACTIONS(1126),
    [anon_sym_extcodehash] = ACTIONS(1126),
    [anon_sym_create] = ACTIONS(1126),
    [anon_sym_create2] = ACTIONS(1126),
    [anon_sym_call] = ACTIONS(1126),
    [anon_sym_callcode] = ACTIONS(1126),
    [anon_sym_delegatecall] = ACTIONS(1126),
    [anon_sym_staticcall] = ACTIONS(1126),
    [anon_sym_return] = ACTIONS(1126),
    [anon_sym_revert] = ACTIONS(1126),
    [anon_sym_selfdestruct] = ACTIONS(1126),
    [anon_sym_invalid] = ACTIONS(1126),
    [anon_sym_log0] = ACTIONS(1126),
    [anon_sym_log1] = ACTIONS(1126),
    [anon_sym_log2] = ACTIONS(1126),
    [anon_sym_log3] = ACTIONS(1126),
    [anon_sym_log4] = ACTIONS(1126),
    [anon_sym_chainid] = ACTIONS(1126),
    [anon_sym_origin] = ACTIONS(1126),
    [anon_sym_gasprice] = ACTIONS(1126),
    [anon_sym_blockhash] = ACTIONS(1126),
    [anon_sym_blobhash] = ACTIONS(1126),
    [anon_sym_basefee] = ACTIONS(1126),
    [anon_sym_blobfee] = ACTIONS(1126),
    [anon_sym_coinbase] = ACTIONS(1126),
    [anon_sym_timestamp] = ACTIONS(1126),
    [anon_sym_number] = ACTIONS(1126),
    [anon_sym_difficulty] = ACTIONS(1126),
    [anon_sym_gaslimit] = ACTIONS(1126),
    [anon_sym_DQUOTE] = ACTIONS(1128),
    [anon_sym_SQUOTE] = ACTIONS(1128),
    [sym_comment] = ACTIONS(3),
  },
  [273] = {
    [sym_identifier] = ACTIONS(1130),
    [anon_sym_LBRACE] = ACTIONS(1132),
    [anon_sym_RBRACE] = ACTIONS(1132),
    [anon_sym_for] = ACTIONS(1130),
    [sym_yul_leave] = ACTIONS(1130),
    [anon_sym_break] = ACTIONS(1130),
    [anon_sym_continue] = ACTIONS(1130),
    [sym_yul_decimal_number] = ACTIONS(1130),
    [sym_yul_hex_number] = ACTIONS(1132),
    [anon_sym_true] = ACTIONS(1130),
    [anon_sym_false] = ACTIONS(1130),
    [anon_sym_let] = ACTIONS(1130),
    [anon_sym_if] = ACTIONS(1130),
    [anon_sym_switch] = ACTIONS(1130),
    [anon_sym_function] = ACTIONS(1130),
    [anon_sym_stop] = ACTIONS(1130),
    [anon_sym_add] = ACTIONS(1130),
    [anon_sym_sub] = ACTIONS(1130),
    [anon_sym_mul] = ACTIONS(1130),
    [anon_sym_div] = ACTIONS(1130),
    [anon_sym_sdiv] = ACTIONS(1130),
    [anon_sym_mod] = ACTIONS(1130),
    [anon_sym_smod] = ACTIONS(1130),
    [anon_sym_exp] = ACTIONS(1130),
    [anon_sym_not] = ACTIONS(1130),
    [anon_sym_lt] = ACTIONS(1130),
    [anon_sym_gt] = ACTIONS(1130),
    [anon_sym_slt] = ACTIONS(1130),
    [anon_sym_sgt] = ACTIONS(1130),
    [anon_sym_eq] = ACTIONS(1130),
    [anon_sym_iszero] = ACTIONS(1130),
    [anon_sym_and] = ACTIONS(1130),
    [anon_sym_or] = ACTIONS(1130),
    [anon_sym_xor] = ACTIONS(1130),
    [anon_sym_byte] = ACTIONS(1130),
    [anon_sym_shl] = ACTIONS(1130),
    [anon_sym_shr] = ACTIONS(1130),
    [anon_sym_sar] = ACTIONS(1130),
    [anon_sym_addmod] = ACTIONS(1130),
    [anon_sym_mulmod] = ACTIONS(1130),
    [anon_sym_signextend] = ACTIONS(1130),
    [anon_sym_keccak256] = ACTIONS(1130),
    [anon_sym_pop] = ACTIONS(1130),
    [anon_sym_mload] = ACTIONS(1130),
    [anon_sym_mcopy] = ACTIONS(1130),
    [anon_sym_tload] = ACTIONS(1130),
    [anon_sym_tstore] = ACTIONS(1130),
    [anon_sym_mstore] = ACTIONS(1130),
    [anon_sym_mstore8] = ACTIONS(1130),
    [anon_sym_sload] = ACTIONS(1130),
    [anon_sym_sstore] = ACTIONS(1130),
    [anon_sym_msize] = ACTIONS(1130),
    [anon_sym_gas] = ACTIONS(1130),
    [anon_sym_address] = ACTIONS(1130),
    [anon_sym_balance] = ACTIONS(1130),
    [anon_sym_selfbalance] = ACTIONS(1130),
    [anon_sym_caller] = ACTIONS(1130),
    [anon_sym_callvalue] = ACTIONS(1130),
    [anon_sym_calldataload] = ACTIONS(1130),
    [anon_sym_calldatasize] = ACTIONS(1130),
    [anon_sym_calldatacopy] = ACTIONS(1130),
    [anon_sym_extcodesize] = ACTIONS(1130),
    [anon_sym_extcodecopy] = ACTIONS(1130),
    [anon_sym_returndatasize] = ACTIONS(1130),
    [anon_sym_returndatacopy] = ACTIONS(1130),
    [anon_sym_extcodehash] = ACTIONS(1130),
    [anon_sym_create] = ACTIONS(1130),
    [anon_sym_create2] = ACTIONS(1130),
    [anon_sym_call] = ACTIONS(1130),
    [anon_sym_callcode] = ACTIONS(1130),
    [anon_sym_delegatecall] = ACTIONS(1130),
    [anon_sym_staticcall] = ACTIONS(1130),
    [anon_sym_return] = ACTIONS(1130),
    [anon_sym_revert] = ACTIONS(1130),
    [anon_sym_selfdestruct] = ACTIONS(1130),
    [anon_sym_invalid] = ACTIONS(1130),
    [anon_sym_log0] = ACTIONS(1130),
    [anon_sym_log1] = ACTIONS(1130),
    [anon_sym_log2] = ACTIONS(1130),
    [anon_sym_log3] = ACTIONS(1130),
    [anon_sym_log4] = ACTIONS(1130),
    [anon_sym_chainid] = ACTIONS(1130),
    [anon_sym_origin] = ACTIONS(1130),
    [anon_sym_gasprice] = ACTIONS(1130),
    [anon_sym_blockhash] = ACTIONS(1130),
    [anon_sym_blobhash] = ACTIONS(1130),
    [anon_sym_basefee] = ACTIONS(1130),
    [anon_sym_blobfee] = ACTIONS(1130),
    [anon_sym_coinbase] = ACTIONS(1130),
    [anon_sym_timestamp] = ACTIONS(1130),
    [anon_sym_number] = ACTIONS(1130),
    [anon_sym_difficulty] = ACTIONS(1130),
    [anon_sym_gaslimit] = ACTIONS(1130),
    [anon_sym_DQUOTE] = ACTIONS(1132),
    [anon_sym_SQUOTE] = ACTIONS(1132),
    [sym_comment] = ACTIONS(3),
  },
  [274] = {
    [sym_identifier] = ACTIONS(1134),
    [anon_sym_LBRACE] = ACTIONS(1136),
    [anon_sym_RBRACE] = ACTIONS(1136),
    [anon_sym_for] = ACTIONS(1134),
    [sym_yul_leave] = ACTIONS(1134),
    [anon_sym_break] = ACTIONS(1134),
    [anon_sym_continue] = ACTIONS(1134),
    [sym_yul_decimal_number] = ACTIONS(1134),
    [sym_yul_hex_number] = ACTIONS(1136),
    [anon_sym_true] = ACTIONS(1134),
    [anon_sym_false] = ACTIONS(1134),
    [anon_sym_let] = ACTIONS(1134),
    [anon_sym_if] = ACTIONS(1134),
    [anon_sym_switch] = ACTIONS(1134),
    [anon_sym_function] = ACTIONS(1134),
    [anon_sym_stop] = ACTIONS(1134),
    [anon_sym_add] = ACTIONS(1134),
    [anon_sym_sub] = ACTIONS(1134),
    [anon_sym_mul] = ACTIONS(1134),
    [anon_sym_div] = ACTIONS(1134),
    [anon_sym_sdiv] = ACTIONS(1134),
    [anon_sym_mod] = ACTIONS(1134),
    [anon_sym_smod] = ACTIONS(1134),
    [anon_sym_exp] = ACTIONS(1134),
    [anon_sym_not] = ACTIONS(1134),
    [anon_sym_lt] = ACTIONS(1134),
    [anon_sym_gt] = ACTIONS(1134),
    [anon_sym_slt] = ACTIONS(1134),
    [anon_sym_sgt] = ACTIONS(1134),
    [anon_sym_eq] = ACTIONS(1134),
    [anon_sym_iszero] = ACTIONS(1134),
    [anon_sym_and] = ACTIONS(1134),
    [anon_sym_or] = ACTIONS(1134),
    [anon_sym_xor] = ACTIONS(1134),
    [anon_sym_byte] = ACTIONS(1134),
    [anon_sym_shl] = ACTIONS(1134),
    [anon_sym_shr] = ACTIONS(1134),
    [anon_sym_sar] = ACTIONS(1134),
    [anon_sym_addmod] = ACTIONS(1134),
    [anon_sym_mulmod] = ACTIONS(1134),
    [anon_sym_signextend] = ACTIONS(1134),
    [anon_sym_keccak256] = ACTIONS(1134),
    [anon_sym_pop] = ACTIONS(1134),
    [anon_sym_mload] = ACTIONS(1134),
    [anon_sym_mcopy] = ACTIONS(1134),
    [anon_sym_tload] = ACTIONS(1134),
    [anon_sym_tstore] = ACTIONS(1134),
    [anon_sym_mstore] = ACTIONS(1134),
    [anon_sym_mstore8] = ACTIONS(1134),
    [anon_sym_sload] = ACTIONS(1134),
    [anon_sym_sstore] = ACTIONS(1134),
    [anon_sym_msize] = ACTIONS(1134),
    [anon_sym_gas] = ACTIONS(1134),
    [anon_sym_address] = ACTIONS(1134),
    [anon_sym_balance] = ACTIONS(1134),
    [anon_sym_selfbalance] = ACTIONS(1134),
    [anon_sym_caller] = ACTIONS(1134),
    [anon_sym_callvalue] = ACTIONS(1134),
    [anon_sym_calldataload] = ACTIONS(1134),
    [anon_sym_calldatasize] = ACTIONS(1134),
    [anon_sym_calldatacopy] = ACTIONS(1134),
    [anon_sym_extcodesize] = ACTIONS(1134),
    [anon_sym_extcodecopy] = ACTIONS(1134),
    [anon_sym_returndatasize] = ACTIONS(1134),
    [anon_sym_returndatacopy] = ACTIONS(1134),
    [anon_sym_extcodehash] = ACTIONS(1134),
    [anon_sym_create] = ACTIONS(1134),
    [anon_sym_create2] = ACTIONS(1134),
    [anon_sym_call] = ACTIONS(1134),
    [anon_sym_callcode] = ACTIONS(1134),
    [anon_sym_delegatecall] = ACTIONS(1134),
    [anon_sym_staticcall] = ACTIONS(1134),
    [anon_sym_return] = ACTIONS(1134),
    [anon_sym_revert] = ACTIONS(1134),
    [anon_sym_selfdestruct] = ACTIONS(1134),
    [anon_sym_invalid] = ACTIONS(1134),
    [anon_sym_log0] = ACTIONS(1134),
    [anon_sym_log1] = ACTIONS(1134),
    [anon_sym_log2] = ACTIONS(1134),
    [anon_sym_log3] = ACTIONS(1134),
    [anon_sym_log4] = ACTIONS(1134),
    [anon_sym_chainid] = ACTIONS(1134),
    [anon_sym_origin] = ACTIONS(1134),
    [anon_sym_gasprice] = ACTIONS(1134),
    [anon_sym_blockhash] = ACTIONS(1134),
    [anon_sym_blobhash] = ACTIONS(1134),
    [anon_sym_basefee] = ACTIONS(1134),
    [anon_sym_blobfee] = ACTIONS(1134),
    [anon_sym_coinbase] = ACTIONS(1134),
    [anon_sym_timestamp] = ACTIONS(1134),
    [anon_sym_number] = ACTIONS(1134),
    [anon_sym_difficulty] = ACTIONS(1134),
    [anon_sym_gaslimit] = ACTIONS(1134),
    [anon_sym_DQUOTE] = ACTIONS(1136),
    [anon_sym_SQUOTE] = ACTIONS(1136),
    [sym_comment] = ACTIONS(3),
  },
  [275] = {
    [sym_identifier] = ACTIONS(1138),
    [anon_sym_LBRACE] = ACTIONS(1140),
    [anon_sym_RBRACE] = ACTIONS(1140),
    [anon_sym_for] = ACTIONS(1138),
    [sym_yul_leave] = ACTIONS(1138),
    [anon_sym_break] = ACTIONS(1138),
    [anon_sym_continue] = ACTIONS(1138),
    [sym_yul_decimal_number] = ACTIONS(1138),
    [sym_yul_hex_number] = ACTIONS(1140),
    [anon_sym_true] = ACTIONS(1138),
    [anon_sym_false] = ACTIONS(1138),
    [anon_sym_let] = ACTIONS(1138),
    [anon_sym_if] = ACTIONS(1138),
    [anon_sym_switch] = ACTIONS(1138),
    [anon_sym_function] = ACTIONS(1138),
    [anon_sym_stop] = ACTIONS(1138),
    [anon_sym_add] = ACTIONS(1138),
    [anon_sym_sub] = ACTIONS(1138),
    [anon_sym_mul] = ACTIONS(1138),
    [anon_sym_div] = ACTIONS(1138),
    [anon_sym_sdiv] = ACTIONS(1138),
    [anon_sym_mod] = ACTIONS(1138),
    [anon_sym_smod] = ACTIONS(1138),
    [anon_sym_exp] = ACTIONS(1138),
    [anon_sym_not] = ACTIONS(1138),
    [anon_sym_lt] = ACTIONS(1138),
    [anon_sym_gt] = ACTIONS(1138),
    [anon_sym_slt] = ACTIONS(1138),
    [anon_sym_sgt] = ACTIONS(1138),
    [anon_sym_eq] = ACTIONS(1138),
    [anon_sym_iszero] = ACTIONS(1138),
    [anon_sym_and] = ACTIONS(1138),
    [anon_sym_or] = ACTIONS(1138),
    [anon_sym_xor] = ACTIONS(1138),
    [anon_sym_byte] = ACTIONS(1138),
    [anon_sym_shl] = ACTIONS(1138),
    [anon_sym_shr] = ACTIONS(1138),
    [anon_sym_sar] = ACTIONS(1138),
    [anon_sym_addmod] = ACTIONS(1138),
    [anon_sym_mulmod] = ACTIONS(1138),
    [anon_sym_signextend] = ACTIONS(1138),
    [anon_sym_keccak256] = ACTIONS(1138),
    [anon_sym_pop] = ACTIONS(1138),
    [anon_sym_mload] = ACTIONS(1138),
    [anon_sym_mcopy] = ACTIONS(1138),
    [anon_sym_tload] = ACTIONS(1138),
    [anon_sym_tstore] = ACTIONS(1138),
    [anon_sym_mstore] = ACTIONS(1138),
    [anon_sym_mstore8] = ACTIONS(1138),
    [anon_sym_sload] = ACTIONS(1138),
    [anon_sym_sstore] = ACTIONS(1138),
    [anon_sym_msize] = ACTIONS(1138),
    [anon_sym_gas] = ACTIONS(1138),
    [anon_sym_address] = ACTIONS(1138),
    [anon_sym_balance] = ACTIONS(1138),
    [anon_sym_selfbalance] = ACTIONS(1138),
    [anon_sym_caller] = ACTIONS(1138),
    [anon_sym_callvalue] = ACTIONS(1138),
    [anon_sym_calldataload] = ACTIONS(1138),
    [anon_sym_calldatasize] = ACTIONS(1138),
    [anon_sym_calldatacopy] = ACTIONS(1138),
    [anon_sym_extcodesize] = ACTIONS(1138),
    [anon_sym_extcodecopy] = ACTIONS(1138),
    [anon_sym_returndatasize] = ACTIONS(1138),
    [anon_sym_returndatacopy] = ACTIONS(1138),
    [anon_sym_extcodehash] = ACTIONS(1138),
    [anon_sym_create] = ACTIONS(1138),
    [anon_sym_create2] = ACTIONS(1138),
    [anon_sym_call] = ACTIONS(1138),
    [anon_sym_callcode] = ACTIONS(1138),
    [anon_sym_delegatecall] = ACTIONS(1138),
    [anon_sym_staticcall] = ACTIONS(1138),
    [anon_sym_return] = ACTIONS(1138),
    [anon_sym_revert] = ACTIONS(1138),
    [anon_sym_selfdestruct] = ACTIONS(1138),
    [anon_sym_invalid] = ACTIONS(1138),
    [anon_sym_log0] = ACTIONS(1138),
    [anon_sym_log1] = ACTIONS(1138),
    [anon_sym_log2] = ACTIONS(1138),
    [anon_sym_log3] = ACTIONS(1138),
    [anon_sym_log4] = ACTIONS(1138),
    [anon_sym_chainid] = ACTIONS(1138),
    [anon_sym_origin] = ACTIONS(1138),
    [anon_sym_gasprice] = ACTIONS(1138),
    [anon_sym_blockhash] = ACTIONS(1138),
    [anon_sym_blobhash] = ACTIONS(1138),
    [anon_sym_basefee] = ACTIONS(1138),
    [anon_sym_blobfee] = ACTIONS(1138),
    [anon_sym_coinbase] = ACTIONS(1138),
    [anon_sym_timestamp] = ACTIONS(1138),
    [anon_sym_number] = ACTIONS(1138),
    [anon_sym_difficulty] = ACTIONS(1138),
    [anon_sym_gaslimit] = ACTIONS(1138),
    [anon_sym_DQUOTE] = ACTIONS(1140),
    [anon_sym_SQUOTE] = ACTIONS(1140),
    [sym_comment] = ACTIONS(3),
  },
  [276] = {
    [sym_identifier] = ACTIONS(1142),
    [anon_sym_LBRACE] = ACTIONS(1144),
    [anon_sym_RBRACE] = ACTIONS(1144),
    [anon_sym_for] = ACTIONS(1142),
    [sym_yul_leave] = ACTIONS(1142),
    [anon_sym_break] = ACTIONS(1142),
    [anon_sym_continue] = ACTIONS(1142),
    [sym_yul_decimal_number] = ACTIONS(1142),
    [sym_yul_hex_number] = ACTIONS(1144),
    [anon_sym_true] = ACTIONS(1142),
    [anon_sym_false] = ACTIONS(1142),
    [anon_sym_let] = ACTIONS(1142),
    [anon_sym_if] = ACTIONS(1142),
    [anon_sym_switch] = ACTIONS(1142),
    [anon_sym_function] = ACTIONS(1142),
    [anon_sym_stop] = ACTIONS(1142),
    [anon_sym_add] = ACTIONS(1142),
    [anon_sym_sub] = ACTIONS(1142),
    [anon_sym_mul] = ACTIONS(1142),
    [anon_sym_div] = ACTIONS(1142),
    [anon_sym_sdiv] = ACTIONS(1142),
    [anon_sym_mod] = ACTIONS(1142),
    [anon_sym_smod] = ACTIONS(1142),
    [anon_sym_exp] = ACTIONS(1142),
    [anon_sym_not] = ACTIONS(1142),
    [anon_sym_lt] = ACTIONS(1142),
    [anon_sym_gt] = ACTIONS(1142),
    [anon_sym_slt] = ACTIONS(1142),
    [anon_sym_sgt] = ACTIONS(1142),
    [anon_sym_eq] = ACTIONS(1142),
    [anon_sym_iszero] = ACTIONS(1142),
    [anon_sym_and] = ACTIONS(1142),
    [anon_sym_or] = ACTIONS(1142),
    [anon_sym_xor] = ACTIONS(1142),
    [anon_sym_byte] = ACTIONS(1142),
    [anon_sym_shl] = ACTIONS(1142),
    [anon_sym_shr] = ACTIONS(1142),
    [anon_sym_sar] = ACTIONS(1142),
    [anon_sym_addmod] = ACTIONS(1142),
    [anon_sym_mulmod] = ACTIONS(1142),
    [anon_sym_signextend] = ACTIONS(1142),
    [anon_sym_keccak256] = ACTIONS(1142),
    [anon_sym_pop] = ACTIONS(1142),
    [anon_sym_mload] = ACTIONS(1142),
    [anon_sym_mcopy] = ACTIONS(1142),
    [anon_sym_tload] = ACTIONS(1142),
    [anon_sym_tstore] = ACTIONS(1142),
    [anon_sym_mstore] = ACTIONS(1142),
    [anon_sym_mstore8] = ACTIONS(1142),
    [anon_sym_sload] = ACTIONS(1142),
    [anon_sym_sstore] = ACTIONS(1142),
    [anon_sym_msize] = ACTIONS(1142),
    [anon_sym_gas] = ACTIONS(1142),
    [anon_sym_address] = ACTIONS(1142),
    [anon_sym_balance] = ACTIONS(1142),
    [anon_sym_selfbalance] = ACTIONS(1142),
    [anon_sym_caller] = ACTIONS(1142),
    [anon_sym_callvalue] = ACTIONS(1142),
    [anon_sym_calldataload] = ACTIONS(1142),
    [anon_sym_calldatasize] = ACTIONS(1142),
    [anon_sym_calldatacopy] = ACTIONS(1142),
    [anon_sym_extcodesize] = ACTIONS(1142),
    [anon_sym_extcodecopy] = ACTIONS(1142),
    [anon_sym_returndatasize] = ACTIONS(1142),
    [anon_sym_returndatacopy] = ACTIONS(1142),
    [anon_sym_extcodehash] = ACTIONS(1142),
    [anon_sym_create] = ACTIONS(1142),
    [anon_sym_create2] = ACTIONS(1142),
    [anon_sym_call] = ACTIONS(1142),
    [anon_sym_callcode] = ACTIONS(1142),
    [anon_sym_delegatecall] = ACTIONS(1142),
    [anon_sym_staticcall] = ACTIONS(1142),
    [anon_sym_return] = ACTIONS(1142),
    [anon_sym_revert] = ACTIONS(1142),
    [anon_sym_selfdestruct] = ACTIONS(1142),
    [anon_sym_invalid] = ACTIONS(1142),
    [anon_sym_log0] = ACTIONS(1142),
    [anon_sym_log1] = ACTIONS(1142),
    [anon_sym_log2] = ACTIONS(1142),
    [anon_sym_log3] = ACTIONS(1142),
    [anon_sym_log4] = ACTIONS(1142),
    [anon_sym_chainid] = ACTIONS(1142),
    [anon_sym_origin] = ACTIONS(1142),
    [anon_sym_gasprice] = ACTIONS(1142),
    [anon_sym_blockhash] = ACTIONS(1142),
    [anon_sym_blobhash] = ACTIONS(1142),
    [anon_sym_basefee] = ACTIONS(1142),
    [anon_sym_blobfee] = ACTIONS(1142),
    [anon_sym_coinbase] = ACTIONS(1142),
    [anon_sym_timestamp] = ACTIONS(1142),
    [anon_sym_number] = ACTIONS(1142),
    [anon_sym_difficulty] = ACTIONS(1142),
    [anon_sym_gaslimit] = ACTIONS(1142),
    [anon_sym_DQUOTE] = ACTIONS(1144),
    [anon_sym_SQUOTE] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
  },
  [277] = {
    [sym_identifier] = ACTIONS(1146),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym_for] = ACTIONS(1146),
    [sym_yul_leave] = ACTIONS(1146),
    [anon_sym_break] = ACTIONS(1146),
    [anon_sym_continue] = ACTIONS(1146),
    [sym_yul_decimal_number] = ACTIONS(1146),
    [sym_yul_hex_number] = ACTIONS(1149),
    [anon_sym_true] = ACTIONS(1146),
    [anon_sym_false] = ACTIONS(1146),
    [anon_sym_let] = ACTIONS(1146),
    [anon_sym_if] = ACTIONS(1146),
    [anon_sym_switch] = ACTIONS(1146),
    [anon_sym_function] = ACTIONS(1146),
    [anon_sym_stop] = ACTIONS(1146),
    [anon_sym_add] = ACTIONS(1146),
    [anon_sym_sub] = ACTIONS(1146),
    [anon_sym_mul] = ACTIONS(1146),
    [anon_sym_div] = ACTIONS(1146),
    [anon_sym_sdiv] = ACTIONS(1146),
    [anon_sym_mod] = ACTIONS(1146),
    [anon_sym_smod] = ACTIONS(1146),
    [anon_sym_exp] = ACTIONS(1146),
    [anon_sym_not] = ACTIONS(1146),
    [anon_sym_lt] = ACTIONS(1146),
    [anon_sym_gt] = ACTIONS(1146),
    [anon_sym_slt] = ACTIONS(1146),
    [anon_sym_sgt] = ACTIONS(1146),
    [anon_sym_eq] = ACTIONS(1146),
    [anon_sym_iszero] = ACTIONS(1146),
    [anon_sym_and] = ACTIONS(1146),
    [anon_sym_or] = ACTIONS(1146),
    [anon_sym_xor] = ACTIONS(1146),
    [anon_sym_byte] = ACTIONS(1146),
    [anon_sym_shl] = ACTIONS(1146),
    [anon_sym_shr] = ACTIONS(1146),
    [anon_sym_sar] = ACTIONS(1146),
    [anon_sym_addmod] = ACTIONS(1146),
    [anon_sym_mulmod] = ACTIONS(1146),
    [anon_sym_signextend] = ACTIONS(1146),
    [anon_sym_keccak256] = ACTIONS(1146),
    [anon_sym_pop] = ACTIONS(1146),
    [anon_sym_mload] = ACTIONS(1146),
    [anon_sym_mcopy] = ACTIONS(1146),
    [anon_sym_tload] = ACTIONS(1146),
    [anon_sym_tstore] = ACTIONS(1146),
    [anon_sym_mstore] = ACTIONS(1146),
    [anon_sym_mstore8] = ACTIONS(1146),
    [anon_sym_sload] = ACTIONS(1146),
    [anon_sym_sstore] = ACTIONS(1146),
    [anon_sym_msize] = ACTIONS(1146),
    [anon_sym_gas] = ACTIONS(1146),
    [anon_sym_address] = ACTIONS(1146),
    [anon_sym_balance] = ACTIONS(1146),
    [anon_sym_selfbalance] = ACTIONS(1146),
    [anon_sym_caller] = ACTIONS(1146),
    [anon_sym_callvalue] = ACTIONS(1146),
    [anon_sym_calldataload] = ACTIONS(1146),
    [anon_sym_calldatasize] = ACTIONS(1146),
    [anon_sym_calldatacopy] = ACTIONS(1146),
    [anon_sym_extcodesize] = ACTIONS(1146),
    [anon_sym_extcodecopy] = ACTIONS(1146),
    [anon_sym_returndatasize] = ACTIONS(1146),
    [anon_sym_returndatacopy] = ACTIONS(1146),
    [anon_sym_extcodehash] = ACTIONS(1146),
    [anon_sym_create] = ACTIONS(1146),
    [anon_sym_create2] = ACTIONS(1146),
    [anon_sym_call] = ACTIONS(1146),
    [anon_sym_callcode] = ACTIONS(1146),
    [anon_sym_delegatecall] = ACTIONS(1146),
    [anon_sym_staticcall] = ACTIONS(1146),
    [anon_sym_return] = ACTIONS(1146),
    [anon_sym_revert] = ACTIONS(1146),
    [anon_sym_selfdestruct] = ACTIONS(1146),
    [anon_sym_invalid] = ACTIONS(1146),
    [anon_sym_log0] = ACTIONS(1146),
    [anon_sym_log1] = ACTIONS(1146),
    [anon_sym_log2] = ACTIONS(1146),
    [anon_sym_log3] = ACTIONS(1146),
    [anon_sym_log4] = ACTIONS(1146),
    [anon_sym_chainid] = ACTIONS(1146),
    [anon_sym_origin] = ACTIONS(1146),
    [anon_sym_gasprice] = ACTIONS(1146),
    [anon_sym_blockhash] = ACTIONS(1146),
    [anon_sym_blobhash] = ACTIONS(1146),
    [anon_sym_basefee] = ACTIONS(1146),
    [anon_sym_blobfee] = ACTIONS(1146),
    [anon_sym_coinbase] = ACTIONS(1146),
    [anon_sym_timestamp] = ACTIONS(1146),
    [anon_sym_number] = ACTIONS(1146),
    [anon_sym_difficulty] = ACTIONS(1146),
    [anon_sym_gaslimit] = ACTIONS(1146),
    [anon_sym_DQUOTE] = ACTIONS(1149),
    [anon_sym_SQUOTE] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
  },
  [278] = {
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_LBRACE] = ACTIONS(1154),
    [anon_sym_RBRACE] = ACTIONS(1154),
    [anon_sym_for] = ACTIONS(1152),
    [sym_yul_leave] = ACTIONS(1152),
    [anon_sym_break] = ACTIONS(1152),
    [anon_sym_continue] = ACTIONS(1152),
    [sym_yul_decimal_number] = ACTIONS(1152),
    [sym_yul_hex_number] = ACTIONS(1154),
    [anon_sym_true] = ACTIONS(1152),
    [anon_sym_false] = ACTIONS(1152),
    [anon_sym_let] = ACTIONS(1152),
    [anon_sym_if] = ACTIONS(1152),
    [anon_sym_switch] = ACTIONS(1152),
    [anon_sym_function] = ACTIONS(1152),
    [anon_sym_stop] = ACTIONS(1152),
    [anon_sym_add] = ACTIONS(1152),
    [anon_sym_sub] = ACTIONS(1152),
    [anon_sym_mul] = ACTIONS(1152),
    [anon_sym_div] = ACTIONS(1152),
    [anon_sym_sdiv] = ACTIONS(1152),
    [anon_sym_mod] = ACTIONS(1152),
    [anon_sym_smod] = ACTIONS(1152),
    [anon_sym_exp] = ACTIONS(1152),
    [anon_sym_not] = ACTIONS(1152),
    [anon_sym_lt] = ACTIONS(1152),
    [anon_sym_gt] = ACTIONS(1152),
    [anon_sym_slt] = ACTIONS(1152),
    [anon_sym_sgt] = ACTIONS(1152),
    [anon_sym_eq] = ACTIONS(1152),
    [anon_sym_iszero] = ACTIONS(1152),
    [anon_sym_and] = ACTIONS(1152),
    [anon_sym_or] = ACTIONS(1152),
    [anon_sym_xor] = ACTIONS(1152),
    [anon_sym_byte] = ACTIONS(1152),
    [anon_sym_shl] = ACTIONS(1152),
    [anon_sym_shr] = ACTIONS(1152),
    [anon_sym_sar] = ACTIONS(1152),
    [anon_sym_addmod] = ACTIONS(1152),
    [anon_sym_mulmod] = ACTIONS(1152),
    [anon_sym_signextend] = ACTIONS(1152),
    [anon_sym_keccak256] = ACTIONS(1152),
    [anon_sym_pop] = ACTIONS(1152),
    [anon_sym_mload] = ACTIONS(1152),
    [anon_sym_mcopy] = ACTIONS(1152),
    [anon_sym_tload] = ACTIONS(1152),
    [anon_sym_tstore] = ACTIONS(1152),
    [anon_sym_mstore] = ACTIONS(1152),
    [anon_sym_mstore8] = ACTIONS(1152),
    [anon_sym_sload] = ACTIONS(1152),
    [anon_sym_sstore] = ACTIONS(1152),
    [anon_sym_msize] = ACTIONS(1152),
    [anon_sym_gas] = ACTIONS(1152),
    [anon_sym_address] = ACTIONS(1152),
    [anon_sym_balance] = ACTIONS(1152),
    [anon_sym_selfbalance] = ACTIONS(1152),
    [anon_sym_caller] = ACTIONS(1152),
    [anon_sym_callvalue] = ACTIONS(1152),
    [anon_sym_calldataload] = ACTIONS(1152),
    [anon_sym_calldatasize] = ACTIONS(1152),
    [anon_sym_calldatacopy] = ACTIONS(1152),
    [anon_sym_extcodesize] = ACTIONS(1152),
    [anon_sym_extcodecopy] = ACTIONS(1152),
    [anon_sym_returndatasize] = ACTIONS(1152),
    [anon_sym_returndatacopy] = ACTIONS(1152),
    [anon_sym_extcodehash] = ACTIONS(1152),
    [anon_sym_create] = ACTIONS(1152),
    [anon_sym_create2] = ACTIONS(1152),
    [anon_sym_call] = ACTIONS(1152),
    [anon_sym_callcode] = ACTIONS(1152),
    [anon_sym_delegatecall] = ACTIONS(1152),
    [anon_sym_staticcall] = ACTIONS(1152),
    [anon_sym_return] = ACTIONS(1152),
    [anon_sym_revert] = ACTIONS(1152),
    [anon_sym_selfdestruct] = ACTIONS(1152),
    [anon_sym_invalid] = ACTIONS(1152),
    [anon_sym_log0] = ACTIONS(1152),
    [anon_sym_log1] = ACTIONS(1152),
    [anon_sym_log2] = ACTIONS(1152),
    [anon_sym_log3] = ACTIONS(1152),
    [anon_sym_log4] = ACTIONS(1152),
    [anon_sym_chainid] = ACTIONS(1152),
    [anon_sym_origin] = ACTIONS(1152),
    [anon_sym_gasprice] = ACTIONS(1152),
    [anon_sym_blockhash] = ACTIONS(1152),
    [anon_sym_blobhash] = ACTIONS(1152),
    [anon_sym_basefee] = ACTIONS(1152),
    [anon_sym_blobfee] = ACTIONS(1152),
    [anon_sym_coinbase] = ACTIONS(1152),
    [anon_sym_timestamp] = ACTIONS(1152),
    [anon_sym_number] = ACTIONS(1152),
    [anon_sym_difficulty] = ACTIONS(1152),
    [anon_sym_gaslimit] = ACTIONS(1152),
    [anon_sym_DQUOTE] = ACTIONS(1154),
    [anon_sym_SQUOTE] = ACTIONS(1154),
    [sym_comment] = ACTIONS(3),
  },
  [279] = {
    [sym_yul_identifier] = STATE(228),
    [sym__yul_expression] = STATE(726),
    [sym_yul_path] = STATE(726),
    [sym__yul_literal] = STATE(726),
    [sym_yul_string_literal] = STATE(726),
    [sym_yul_boolean] = STATE(726),
    [sym_yul_function_call] = STATE(726),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_RPAREN] = ACTIONS(1158),
    [sym_yul_decimal_number] = ACTIONS(1160),
    [sym_yul_hex_number] = ACTIONS(1162),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [280] = {
    [sym_identifier] = ACTIONS(1164),
    [anon_sym_LBRACE] = ACTIONS(1166),
    [anon_sym_RBRACE] = ACTIONS(1166),
    [anon_sym_for] = ACTIONS(1164),
    [sym_yul_leave] = ACTIONS(1164),
    [anon_sym_break] = ACTIONS(1164),
    [anon_sym_continue] = ACTIONS(1164),
    [sym_yul_decimal_number] = ACTIONS(1164),
    [sym_yul_hex_number] = ACTIONS(1166),
    [anon_sym_true] = ACTIONS(1164),
    [anon_sym_false] = ACTIONS(1164),
    [anon_sym_let] = ACTIONS(1164),
    [anon_sym_if] = ACTIONS(1164),
    [anon_sym_switch] = ACTIONS(1164),
    [anon_sym_function] = ACTIONS(1164),
    [anon_sym_stop] = ACTIONS(1164),
    [anon_sym_add] = ACTIONS(1164),
    [anon_sym_sub] = ACTIONS(1164),
    [anon_sym_mul] = ACTIONS(1164),
    [anon_sym_div] = ACTIONS(1164),
    [anon_sym_sdiv] = ACTIONS(1164),
    [anon_sym_mod] = ACTIONS(1164),
    [anon_sym_smod] = ACTIONS(1164),
    [anon_sym_exp] = ACTIONS(1164),
    [anon_sym_not] = ACTIONS(1164),
    [anon_sym_lt] = ACTIONS(1164),
    [anon_sym_gt] = ACTIONS(1164),
    [anon_sym_slt] = ACTIONS(1164),
    [anon_sym_sgt] = ACTIONS(1164),
    [anon_sym_eq] = ACTIONS(1164),
    [anon_sym_iszero] = ACTIONS(1164),
    [anon_sym_and] = ACTIONS(1164),
    [anon_sym_or] = ACTIONS(1164),
    [anon_sym_xor] = ACTIONS(1164),
    [anon_sym_byte] = ACTIONS(1164),
    [anon_sym_shl] = ACTIONS(1164),
    [anon_sym_shr] = ACTIONS(1164),
    [anon_sym_sar] = ACTIONS(1164),
    [anon_sym_addmod] = ACTIONS(1164),
    [anon_sym_mulmod] = ACTIONS(1164),
    [anon_sym_signextend] = ACTIONS(1164),
    [anon_sym_keccak256] = ACTIONS(1164),
    [anon_sym_pop] = ACTIONS(1164),
    [anon_sym_mload] = ACTIONS(1164),
    [anon_sym_mcopy] = ACTIONS(1164),
    [anon_sym_tload] = ACTIONS(1164),
    [anon_sym_tstore] = ACTIONS(1164),
    [anon_sym_mstore] = ACTIONS(1164),
    [anon_sym_mstore8] = ACTIONS(1164),
    [anon_sym_sload] = ACTIONS(1164),
    [anon_sym_sstore] = ACTIONS(1164),
    [anon_sym_msize] = ACTIONS(1164),
    [anon_sym_gas] = ACTIONS(1164),
    [anon_sym_address] = ACTIONS(1164),
    [anon_sym_balance] = ACTIONS(1164),
    [anon_sym_selfbalance] = ACTIONS(1164),
    [anon_sym_caller] = ACTIONS(1164),
    [anon_sym_callvalue] = ACTIONS(1164),
    [anon_sym_calldataload] = ACTIONS(1164),
    [anon_sym_calldatasize] = ACTIONS(1164),
    [anon_sym_calldatacopy] = ACTIONS(1164),
    [anon_sym_extcodesize] = ACTIONS(1164),
    [anon_sym_extcodecopy] = ACTIONS(1164),
    [anon_sym_returndatasize] = ACTIONS(1164),
    [anon_sym_returndatacopy] = ACTIONS(1164),
    [anon_sym_extcodehash] = ACTIONS(1164),
    [anon_sym_create] = ACTIONS(1164),
    [anon_sym_create2] = ACTIONS(1164),
    [anon_sym_call] = ACTIONS(1164),
    [anon_sym_callcode] = ACTIONS(1164),
    [anon_sym_delegatecall] = ACTIONS(1164),
    [anon_sym_staticcall] = ACTIONS(1164),
    [anon_sym_return] = ACTIONS(1164),
    [anon_sym_revert] = ACTIONS(1164),
    [anon_sym_selfdestruct] = ACTIONS(1164),
    [anon_sym_invalid] = ACTIONS(1164),
    [anon_sym_log0] = ACTIONS(1164),
    [anon_sym_log1] = ACTIONS(1164),
    [anon_sym_log2] = ACTIONS(1164),
    [anon_sym_log3] = ACTIONS(1164),
    [anon_sym_log4] = ACTIONS(1164),
    [anon_sym_chainid] = ACTIONS(1164),
    [anon_sym_origin] = ACTIONS(1164),
    [anon_sym_gasprice] = ACTIONS(1164),
    [anon_sym_blockhash] = ACTIONS(1164),
    [anon_sym_blobhash] = ACTIONS(1164),
    [anon_sym_basefee] = ACTIONS(1164),
    [anon_sym_blobfee] = ACTIONS(1164),
    [anon_sym_coinbase] = ACTIONS(1164),
    [anon_sym_timestamp] = ACTIONS(1164),
    [anon_sym_number] = ACTIONS(1164),
    [anon_sym_difficulty] = ACTIONS(1164),
    [anon_sym_gaslimit] = ACTIONS(1164),
    [anon_sym_DQUOTE] = ACTIONS(1166),
    [anon_sym_SQUOTE] = ACTIONS(1166),
    [sym_comment] = ACTIONS(3),
  },
  [281] = {
    [sym_identifier] = ACTIONS(1168),
    [anon_sym_LBRACE] = ACTIONS(1170),
    [anon_sym_RBRACE] = ACTIONS(1170),
    [anon_sym_for] = ACTIONS(1168),
    [sym_yul_leave] = ACTIONS(1168),
    [anon_sym_break] = ACTIONS(1168),
    [anon_sym_continue] = ACTIONS(1168),
    [sym_yul_decimal_number] = ACTIONS(1168),
    [sym_yul_hex_number] = ACTIONS(1170),
    [anon_sym_true] = ACTIONS(1168),
    [anon_sym_false] = ACTIONS(1168),
    [anon_sym_let] = ACTIONS(1168),
    [anon_sym_if] = ACTIONS(1168),
    [anon_sym_switch] = ACTIONS(1168),
    [anon_sym_function] = ACTIONS(1168),
    [anon_sym_stop] = ACTIONS(1168),
    [anon_sym_add] = ACTIONS(1168),
    [anon_sym_sub] = ACTIONS(1168),
    [anon_sym_mul] = ACTIONS(1168),
    [anon_sym_div] = ACTIONS(1168),
    [anon_sym_sdiv] = ACTIONS(1168),
    [anon_sym_mod] = ACTIONS(1168),
    [anon_sym_smod] = ACTIONS(1168),
    [anon_sym_exp] = ACTIONS(1168),
    [anon_sym_not] = ACTIONS(1168),
    [anon_sym_lt] = ACTIONS(1168),
    [anon_sym_gt] = ACTIONS(1168),
    [anon_sym_slt] = ACTIONS(1168),
    [anon_sym_sgt] = ACTIONS(1168),
    [anon_sym_eq] = ACTIONS(1168),
    [anon_sym_iszero] = ACTIONS(1168),
    [anon_sym_and] = ACTIONS(1168),
    [anon_sym_or] = ACTIONS(1168),
    [anon_sym_xor] = ACTIONS(1168),
    [anon_sym_byte] = ACTIONS(1168),
    [anon_sym_shl] = ACTIONS(1168),
    [anon_sym_shr] = ACTIONS(1168),
    [anon_sym_sar] = ACTIONS(1168),
    [anon_sym_addmod] = ACTIONS(1168),
    [anon_sym_mulmod] = ACTIONS(1168),
    [anon_sym_signextend] = ACTIONS(1168),
    [anon_sym_keccak256] = ACTIONS(1168),
    [anon_sym_pop] = ACTIONS(1168),
    [anon_sym_mload] = ACTIONS(1168),
    [anon_sym_mcopy] = ACTIONS(1168),
    [anon_sym_tload] = ACTIONS(1168),
    [anon_sym_tstore] = ACTIONS(1168),
    [anon_sym_mstore] = ACTIONS(1168),
    [anon_sym_mstore8] = ACTIONS(1168),
    [anon_sym_sload] = ACTIONS(1168),
    [anon_sym_sstore] = ACTIONS(1168),
    [anon_sym_msize] = ACTIONS(1168),
    [anon_sym_gas] = ACTIONS(1168),
    [anon_sym_address] = ACTIONS(1168),
    [anon_sym_balance] = ACTIONS(1168),
    [anon_sym_selfbalance] = ACTIONS(1168),
    [anon_sym_caller] = ACTIONS(1168),
    [anon_sym_callvalue] = ACTIONS(1168),
    [anon_sym_calldataload] = ACTIONS(1168),
    [anon_sym_calldatasize] = ACTIONS(1168),
    [anon_sym_calldatacopy] = ACTIONS(1168),
    [anon_sym_extcodesize] = ACTIONS(1168),
    [anon_sym_extcodecopy] = ACTIONS(1168),
    [anon_sym_returndatasize] = ACTIONS(1168),
    [anon_sym_returndatacopy] = ACTIONS(1168),
    [anon_sym_extcodehash] = ACTIONS(1168),
    [anon_sym_create] = ACTIONS(1168),
    [anon_sym_create2] = ACTIONS(1168),
    [anon_sym_call] = ACTIONS(1168),
    [anon_sym_callcode] = ACTIONS(1168),
    [anon_sym_delegatecall] = ACTIONS(1168),
    [anon_sym_staticcall] = ACTIONS(1168),
    [anon_sym_return] = ACTIONS(1168),
    [anon_sym_revert] = ACTIONS(1168),
    [anon_sym_selfdestruct] = ACTIONS(1168),
    [anon_sym_invalid] = ACTIONS(1168),
    [anon_sym_log0] = ACTIONS(1168),
    [anon_sym_log1] = ACTIONS(1168),
    [anon_sym_log2] = ACTIONS(1168),
    [anon_sym_log3] = ACTIONS(1168),
    [anon_sym_log4] = ACTIONS(1168),
    [anon_sym_chainid] = ACTIONS(1168),
    [anon_sym_origin] = ACTIONS(1168),
    [anon_sym_gasprice] = ACTIONS(1168),
    [anon_sym_blockhash] = ACTIONS(1168),
    [anon_sym_blobhash] = ACTIONS(1168),
    [anon_sym_basefee] = ACTIONS(1168),
    [anon_sym_blobfee] = ACTIONS(1168),
    [anon_sym_coinbase] = ACTIONS(1168),
    [anon_sym_timestamp] = ACTIONS(1168),
    [anon_sym_number] = ACTIONS(1168),
    [anon_sym_difficulty] = ACTIONS(1168),
    [anon_sym_gaslimit] = ACTIONS(1168),
    [anon_sym_DQUOTE] = ACTIONS(1170),
    [anon_sym_SQUOTE] = ACTIONS(1170),
    [sym_comment] = ACTIONS(3),
  },
  [282] = {
    [sym_identifier] = ACTIONS(1172),
    [anon_sym_LBRACE] = ACTIONS(1174),
    [anon_sym_RBRACE] = ACTIONS(1174),
    [anon_sym_for] = ACTIONS(1172),
    [sym_yul_leave] = ACTIONS(1172),
    [anon_sym_break] = ACTIONS(1172),
    [anon_sym_continue] = ACTIONS(1172),
    [sym_yul_decimal_number] = ACTIONS(1172),
    [sym_yul_hex_number] = ACTIONS(1174),
    [anon_sym_true] = ACTIONS(1172),
    [anon_sym_false] = ACTIONS(1172),
    [anon_sym_let] = ACTIONS(1172),
    [anon_sym_if] = ACTIONS(1172),
    [anon_sym_switch] = ACTIONS(1172),
    [anon_sym_function] = ACTIONS(1172),
    [anon_sym_stop] = ACTIONS(1172),
    [anon_sym_add] = ACTIONS(1172),
    [anon_sym_sub] = ACTIONS(1172),
    [anon_sym_mul] = ACTIONS(1172),
    [anon_sym_div] = ACTIONS(1172),
    [anon_sym_sdiv] = ACTIONS(1172),
    [anon_sym_mod] = ACTIONS(1172),
    [anon_sym_smod] = ACTIONS(1172),
    [anon_sym_exp] = ACTIONS(1172),
    [anon_sym_not] = ACTIONS(1172),
    [anon_sym_lt] = ACTIONS(1172),
    [anon_sym_gt] = ACTIONS(1172),
    [anon_sym_slt] = ACTIONS(1172),
    [anon_sym_sgt] = ACTIONS(1172),
    [anon_sym_eq] = ACTIONS(1172),
    [anon_sym_iszero] = ACTIONS(1172),
    [anon_sym_and] = ACTIONS(1172),
    [anon_sym_or] = ACTIONS(1172),
    [anon_sym_xor] = ACTIONS(1172),
    [anon_sym_byte] = ACTIONS(1172),
    [anon_sym_shl] = ACTIONS(1172),
    [anon_sym_shr] = ACTIONS(1172),
    [anon_sym_sar] = ACTIONS(1172),
    [anon_sym_addmod] = ACTIONS(1172),
    [anon_sym_mulmod] = ACTIONS(1172),
    [anon_sym_signextend] = ACTIONS(1172),
    [anon_sym_keccak256] = ACTIONS(1172),
    [anon_sym_pop] = ACTIONS(1172),
    [anon_sym_mload] = ACTIONS(1172),
    [anon_sym_mcopy] = ACTIONS(1172),
    [anon_sym_tload] = ACTIONS(1172),
    [anon_sym_tstore] = ACTIONS(1172),
    [anon_sym_mstore] = ACTIONS(1172),
    [anon_sym_mstore8] = ACTIONS(1172),
    [anon_sym_sload] = ACTIONS(1172),
    [anon_sym_sstore] = ACTIONS(1172),
    [anon_sym_msize] = ACTIONS(1172),
    [anon_sym_gas] = ACTIONS(1172),
    [anon_sym_address] = ACTIONS(1172),
    [anon_sym_balance] = ACTIONS(1172),
    [anon_sym_selfbalance] = ACTIONS(1172),
    [anon_sym_caller] = ACTIONS(1172),
    [anon_sym_callvalue] = ACTIONS(1172),
    [anon_sym_calldataload] = ACTIONS(1172),
    [anon_sym_calldatasize] = ACTIONS(1172),
    [anon_sym_calldatacopy] = ACTIONS(1172),
    [anon_sym_extcodesize] = ACTIONS(1172),
    [anon_sym_extcodecopy] = ACTIONS(1172),
    [anon_sym_returndatasize] = ACTIONS(1172),
    [anon_sym_returndatacopy] = ACTIONS(1172),
    [anon_sym_extcodehash] = ACTIONS(1172),
    [anon_sym_create] = ACTIONS(1172),
    [anon_sym_create2] = ACTIONS(1172),
    [anon_sym_call] = ACTIONS(1172),
    [anon_sym_callcode] = ACTIONS(1172),
    [anon_sym_delegatecall] = ACTIONS(1172),
    [anon_sym_staticcall] = ACTIONS(1172),
    [anon_sym_return] = ACTIONS(1172),
    [anon_sym_revert] = ACTIONS(1172),
    [anon_sym_selfdestruct] = ACTIONS(1172),
    [anon_sym_invalid] = ACTIONS(1172),
    [anon_sym_log0] = ACTIONS(1172),
    [anon_sym_log1] = ACTIONS(1172),
    [anon_sym_log2] = ACTIONS(1172),
    [anon_sym_log3] = ACTIONS(1172),
    [anon_sym_log4] = ACTIONS(1172),
    [anon_sym_chainid] = ACTIONS(1172),
    [anon_sym_origin] = ACTIONS(1172),
    [anon_sym_gasprice] = ACTIONS(1172),
    [anon_sym_blockhash] = ACTIONS(1172),
    [anon_sym_blobhash] = ACTIONS(1172),
    [anon_sym_basefee] = ACTIONS(1172),
    [anon_sym_blobfee] = ACTIONS(1172),
    [anon_sym_coinbase] = ACTIONS(1172),
    [anon_sym_timestamp] = ACTIONS(1172),
    [anon_sym_number] = ACTIONS(1172),
    [anon_sym_difficulty] = ACTIONS(1172),
    [anon_sym_gaslimit] = ACTIONS(1172),
    [anon_sym_DQUOTE] = ACTIONS(1174),
    [anon_sym_SQUOTE] = ACTIONS(1174),
    [sym_comment] = ACTIONS(3),
  },
  [283] = {
    [sym_yul_identifier] = STATE(228),
    [sym__yul_expression] = STATE(726),
    [sym_yul_path] = STATE(726),
    [sym__yul_literal] = STATE(726),
    [sym_yul_string_literal] = STATE(726),
    [sym_yul_boolean] = STATE(726),
    [sym_yul_function_call] = STATE(726),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_RPAREN] = ACTIONS(1176),
    [sym_yul_decimal_number] = ACTIONS(1160),
    [sym_yul_hex_number] = ACTIONS(1162),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [284] = {
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_LBRACE] = ACTIONS(1180),
    [anon_sym_RBRACE] = ACTIONS(1180),
    [anon_sym_for] = ACTIONS(1178),
    [sym_yul_leave] = ACTIONS(1178),
    [anon_sym_break] = ACTIONS(1178),
    [anon_sym_continue] = ACTIONS(1178),
    [sym_yul_decimal_number] = ACTIONS(1178),
    [sym_yul_hex_number] = ACTIONS(1180),
    [anon_sym_true] = ACTIONS(1178),
    [anon_sym_false] = ACTIONS(1178),
    [anon_sym_let] = ACTIONS(1178),
    [anon_sym_if] = ACTIONS(1178),
    [anon_sym_switch] = ACTIONS(1178),
    [anon_sym_function] = ACTIONS(1178),
    [anon_sym_stop] = ACTIONS(1178),
    [anon_sym_add] = ACTIONS(1178),
    [anon_sym_sub] = ACTIONS(1178),
    [anon_sym_mul] = ACTIONS(1178),
    [anon_sym_div] = ACTIONS(1178),
    [anon_sym_sdiv] = ACTIONS(1178),
    [anon_sym_mod] = ACTIONS(1178),
    [anon_sym_smod] = ACTIONS(1178),
    [anon_sym_exp] = ACTIONS(1178),
    [anon_sym_not] = ACTIONS(1178),
    [anon_sym_lt] = ACTIONS(1178),
    [anon_sym_gt] = ACTIONS(1178),
    [anon_sym_slt] = ACTIONS(1178),
    [anon_sym_sgt] = ACTIONS(1178),
    [anon_sym_eq] = ACTIONS(1178),
    [anon_sym_iszero] = ACTIONS(1178),
    [anon_sym_and] = ACTIONS(1178),
    [anon_sym_or] = ACTIONS(1178),
    [anon_sym_xor] = ACTIONS(1178),
    [anon_sym_byte] = ACTIONS(1178),
    [anon_sym_shl] = ACTIONS(1178),
    [anon_sym_shr] = ACTIONS(1178),
    [anon_sym_sar] = ACTIONS(1178),
    [anon_sym_addmod] = ACTIONS(1178),
    [anon_sym_mulmod] = ACTIONS(1178),
    [anon_sym_signextend] = ACTIONS(1178),
    [anon_sym_keccak256] = ACTIONS(1178),
    [anon_sym_pop] = ACTIONS(1178),
    [anon_sym_mload] = ACTIONS(1178),
    [anon_sym_mcopy] = ACTIONS(1178),
    [anon_sym_tload] = ACTIONS(1178),
    [anon_sym_tstore] = ACTIONS(1178),
    [anon_sym_mstore] = ACTIONS(1178),
    [anon_sym_mstore8] = ACTIONS(1178),
    [anon_sym_sload] = ACTIONS(1178),
    [anon_sym_sstore] = ACTIONS(1178),
    [anon_sym_msize] = ACTIONS(1178),
    [anon_sym_gas] = ACTIONS(1178),
    [anon_sym_address] = ACTIONS(1178),
    [anon_sym_balance] = ACTIONS(1178),
    [anon_sym_selfbalance] = ACTIONS(1178),
    [anon_sym_caller] = ACTIONS(1178),
    [anon_sym_callvalue] = ACTIONS(1178),
    [anon_sym_calldataload] = ACTIONS(1178),
    [anon_sym_calldatasize] = ACTIONS(1178),
    [anon_sym_calldatacopy] = ACTIONS(1178),
    [anon_sym_extcodesize] = ACTIONS(1178),
    [anon_sym_extcodecopy] = ACTIONS(1178),
    [anon_sym_returndatasize] = ACTIONS(1178),
    [anon_sym_returndatacopy] = ACTIONS(1178),
    [anon_sym_extcodehash] = ACTIONS(1178),
    [anon_sym_create] = ACTIONS(1178),
    [anon_sym_create2] = ACTIONS(1178),
    [anon_sym_call] = ACTIONS(1178),
    [anon_sym_callcode] = ACTIONS(1178),
    [anon_sym_delegatecall] = ACTIONS(1178),
    [anon_sym_staticcall] = ACTIONS(1178),
    [anon_sym_return] = ACTIONS(1178),
    [anon_sym_revert] = ACTIONS(1178),
    [anon_sym_selfdestruct] = ACTIONS(1178),
    [anon_sym_invalid] = ACTIONS(1178),
    [anon_sym_log0] = ACTIONS(1178),
    [anon_sym_log1] = ACTIONS(1178),
    [anon_sym_log2] = ACTIONS(1178),
    [anon_sym_log3] = ACTIONS(1178),
    [anon_sym_log4] = ACTIONS(1178),
    [anon_sym_chainid] = ACTIONS(1178),
    [anon_sym_origin] = ACTIONS(1178),
    [anon_sym_gasprice] = ACTIONS(1178),
    [anon_sym_blockhash] = ACTIONS(1178),
    [anon_sym_blobhash] = ACTIONS(1178),
    [anon_sym_basefee] = ACTIONS(1178),
    [anon_sym_blobfee] = ACTIONS(1178),
    [anon_sym_coinbase] = ACTIONS(1178),
    [anon_sym_timestamp] = ACTIONS(1178),
    [anon_sym_number] = ACTIONS(1178),
    [anon_sym_difficulty] = ACTIONS(1178),
    [anon_sym_gaslimit] = ACTIONS(1178),
    [anon_sym_DQUOTE] = ACTIONS(1180),
    [anon_sym_SQUOTE] = ACTIONS(1180),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_identifier] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_RBRACE] = ACTIONS(989),
    [anon_sym_for] = ACTIONS(987),
    [sym_yul_leave] = ACTIONS(987),
    [anon_sym_break] = ACTIONS(987),
    [anon_sym_continue] = ACTIONS(987),
    [sym_yul_decimal_number] = ACTIONS(987),
    [sym_yul_hex_number] = ACTIONS(989),
    [anon_sym_true] = ACTIONS(987),
    [anon_sym_false] = ACTIONS(987),
    [anon_sym_let] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_switch] = ACTIONS(987),
    [anon_sym_function] = ACTIONS(987),
    [anon_sym_stop] = ACTIONS(987),
    [anon_sym_add] = ACTIONS(987),
    [anon_sym_sub] = ACTIONS(987),
    [anon_sym_mul] = ACTIONS(987),
    [anon_sym_div] = ACTIONS(987),
    [anon_sym_sdiv] = ACTIONS(987),
    [anon_sym_mod] = ACTIONS(987),
    [anon_sym_smod] = ACTIONS(987),
    [anon_sym_exp] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(987),
    [anon_sym_lt] = ACTIONS(987),
    [anon_sym_gt] = ACTIONS(987),
    [anon_sym_slt] = ACTIONS(987),
    [anon_sym_sgt] = ACTIONS(987),
    [anon_sym_eq] = ACTIONS(987),
    [anon_sym_iszero] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(987),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_xor] = ACTIONS(987),
    [anon_sym_byte] = ACTIONS(987),
    [anon_sym_shl] = ACTIONS(987),
    [anon_sym_shr] = ACTIONS(987),
    [anon_sym_sar] = ACTIONS(987),
    [anon_sym_addmod] = ACTIONS(987),
    [anon_sym_mulmod] = ACTIONS(987),
    [anon_sym_signextend] = ACTIONS(987),
    [anon_sym_keccak256] = ACTIONS(987),
    [anon_sym_pop] = ACTIONS(987),
    [anon_sym_mload] = ACTIONS(987),
    [anon_sym_mcopy] = ACTIONS(987),
    [anon_sym_tload] = ACTIONS(987),
    [anon_sym_tstore] = ACTIONS(987),
    [anon_sym_mstore] = ACTIONS(987),
    [anon_sym_mstore8] = ACTIONS(987),
    [anon_sym_sload] = ACTIONS(987),
    [anon_sym_sstore] = ACTIONS(987),
    [anon_sym_msize] = ACTIONS(987),
    [anon_sym_gas] = ACTIONS(987),
    [anon_sym_address] = ACTIONS(987),
    [anon_sym_balance] = ACTIONS(987),
    [anon_sym_selfbalance] = ACTIONS(987),
    [anon_sym_caller] = ACTIONS(987),
    [anon_sym_callvalue] = ACTIONS(987),
    [anon_sym_calldataload] = ACTIONS(987),
    [anon_sym_calldatasize] = ACTIONS(987),
    [anon_sym_calldatacopy] = ACTIONS(987),
    [anon_sym_extcodesize] = ACTIONS(987),
    [anon_sym_extcodecopy] = ACTIONS(987),
    [anon_sym_returndatasize] = ACTIONS(987),
    [anon_sym_returndatacopy] = ACTIONS(987),
    [anon_sym_extcodehash] = ACTIONS(987),
    [anon_sym_create] = ACTIONS(987),
    [anon_sym_create2] = ACTIONS(987),
    [anon_sym_call] = ACTIONS(987),
    [anon_sym_callcode] = ACTIONS(987),
    [anon_sym_delegatecall] = ACTIONS(987),
    [anon_sym_staticcall] = ACTIONS(987),
    [anon_sym_return] = ACTIONS(987),
    [anon_sym_revert] = ACTIONS(987),
    [anon_sym_selfdestruct] = ACTIONS(987),
    [anon_sym_invalid] = ACTIONS(987),
    [anon_sym_log0] = ACTIONS(987),
    [anon_sym_log1] = ACTIONS(987),
    [anon_sym_log2] = ACTIONS(987),
    [anon_sym_log3] = ACTIONS(987),
    [anon_sym_log4] = ACTIONS(987),
    [anon_sym_chainid] = ACTIONS(987),
    [anon_sym_origin] = ACTIONS(987),
    [anon_sym_gasprice] = ACTIONS(987),
    [anon_sym_blockhash] = ACTIONS(987),
    [anon_sym_blobhash] = ACTIONS(987),
    [anon_sym_basefee] = ACTIONS(987),
    [anon_sym_blobfee] = ACTIONS(987),
    [anon_sym_coinbase] = ACTIONS(987),
    [anon_sym_timestamp] = ACTIONS(987),
    [anon_sym_number] = ACTIONS(987),
    [anon_sym_difficulty] = ACTIONS(987),
    [anon_sym_gaslimit] = ACTIONS(987),
    [anon_sym_DQUOTE] = ACTIONS(989),
    [anon_sym_SQUOTE] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
  },
  [286] = {
    [sym_identifier] = ACTIONS(1182),
    [anon_sym_LBRACE] = ACTIONS(1184),
    [anon_sym_RBRACE] = ACTIONS(1184),
    [anon_sym_for] = ACTIONS(1182),
    [sym_yul_leave] = ACTIONS(1182),
    [anon_sym_break] = ACTIONS(1182),
    [anon_sym_continue] = ACTIONS(1182),
    [sym_yul_decimal_number] = ACTIONS(1182),
    [sym_yul_hex_number] = ACTIONS(1184),
    [anon_sym_true] = ACTIONS(1182),
    [anon_sym_false] = ACTIONS(1182),
    [anon_sym_let] = ACTIONS(1182),
    [anon_sym_if] = ACTIONS(1182),
    [anon_sym_switch] = ACTIONS(1182),
    [anon_sym_function] = ACTIONS(1182),
    [anon_sym_stop] = ACTIONS(1182),
    [anon_sym_add] = ACTIONS(1182),
    [anon_sym_sub] = ACTIONS(1182),
    [anon_sym_mul] = ACTIONS(1182),
    [anon_sym_div] = ACTIONS(1182),
    [anon_sym_sdiv] = ACTIONS(1182),
    [anon_sym_mod] = ACTIONS(1182),
    [anon_sym_smod] = ACTIONS(1182),
    [anon_sym_exp] = ACTIONS(1182),
    [anon_sym_not] = ACTIONS(1182),
    [anon_sym_lt] = ACTIONS(1182),
    [anon_sym_gt] = ACTIONS(1182),
    [anon_sym_slt] = ACTIONS(1182),
    [anon_sym_sgt] = ACTIONS(1182),
    [anon_sym_eq] = ACTIONS(1182),
    [anon_sym_iszero] = ACTIONS(1182),
    [anon_sym_and] = ACTIONS(1182),
    [anon_sym_or] = ACTIONS(1182),
    [anon_sym_xor] = ACTIONS(1182),
    [anon_sym_byte] = ACTIONS(1182),
    [anon_sym_shl] = ACTIONS(1182),
    [anon_sym_shr] = ACTIONS(1182),
    [anon_sym_sar] = ACTIONS(1182),
    [anon_sym_addmod] = ACTIONS(1182),
    [anon_sym_mulmod] = ACTIONS(1182),
    [anon_sym_signextend] = ACTIONS(1182),
    [anon_sym_keccak256] = ACTIONS(1182),
    [anon_sym_pop] = ACTIONS(1182),
    [anon_sym_mload] = ACTIONS(1182),
    [anon_sym_mcopy] = ACTIONS(1182),
    [anon_sym_tload] = ACTIONS(1182),
    [anon_sym_tstore] = ACTIONS(1182),
    [anon_sym_mstore] = ACTIONS(1182),
    [anon_sym_mstore8] = ACTIONS(1182),
    [anon_sym_sload] = ACTIONS(1182),
    [anon_sym_sstore] = ACTIONS(1182),
    [anon_sym_msize] = ACTIONS(1182),
    [anon_sym_gas] = ACTIONS(1182),
    [anon_sym_address] = ACTIONS(1182),
    [anon_sym_balance] = ACTIONS(1182),
    [anon_sym_selfbalance] = ACTIONS(1182),
    [anon_sym_caller] = ACTIONS(1182),
    [anon_sym_callvalue] = ACTIONS(1182),
    [anon_sym_calldataload] = ACTIONS(1182),
    [anon_sym_calldatasize] = ACTIONS(1182),
    [anon_sym_calldatacopy] = ACTIONS(1182),
    [anon_sym_extcodesize] = ACTIONS(1182),
    [anon_sym_extcodecopy] = ACTIONS(1182),
    [anon_sym_returndatasize] = ACTIONS(1182),
    [anon_sym_returndatacopy] = ACTIONS(1182),
    [anon_sym_extcodehash] = ACTIONS(1182),
    [anon_sym_create] = ACTIONS(1182),
    [anon_sym_create2] = ACTIONS(1182),
    [anon_sym_call] = ACTIONS(1182),
    [anon_sym_callcode] = ACTIONS(1182),
    [anon_sym_delegatecall] = ACTIONS(1182),
    [anon_sym_staticcall] = ACTIONS(1182),
    [anon_sym_return] = ACTIONS(1182),
    [anon_sym_revert] = ACTIONS(1182),
    [anon_sym_selfdestruct] = ACTIONS(1182),
    [anon_sym_invalid] = ACTIONS(1182),
    [anon_sym_log0] = ACTIONS(1182),
    [anon_sym_log1] = ACTIONS(1182),
    [anon_sym_log2] = ACTIONS(1182),
    [anon_sym_log3] = ACTIONS(1182),
    [anon_sym_log4] = ACTIONS(1182),
    [anon_sym_chainid] = ACTIONS(1182),
    [anon_sym_origin] = ACTIONS(1182),
    [anon_sym_gasprice] = ACTIONS(1182),
    [anon_sym_blockhash] = ACTIONS(1182),
    [anon_sym_blobhash] = ACTIONS(1182),
    [anon_sym_basefee] = ACTIONS(1182),
    [anon_sym_blobfee] = ACTIONS(1182),
    [anon_sym_coinbase] = ACTIONS(1182),
    [anon_sym_timestamp] = ACTIONS(1182),
    [anon_sym_number] = ACTIONS(1182),
    [anon_sym_difficulty] = ACTIONS(1182),
    [anon_sym_gaslimit] = ACTIONS(1182),
    [anon_sym_DQUOTE] = ACTIONS(1184),
    [anon_sym_SQUOTE] = ACTIONS(1184),
    [sym_comment] = ACTIONS(3),
  },
  [287] = {
    [sym_yul_identifier] = STATE(228),
    [sym__yul_expression] = STATE(646),
    [sym_yul_path] = STATE(646),
    [sym__yul_literal] = STATE(646),
    [sym_yul_string_literal] = STATE(646),
    [sym_yul_boolean] = STATE(646),
    [sym_yul_function_call] = STATE(646),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_RPAREN] = ACTIONS(1186),
    [sym_yul_decimal_number] = ACTIONS(1188),
    [sym_yul_hex_number] = ACTIONS(1190),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [288] = {
    [sym_identifier] = ACTIONS(1192),
    [anon_sym_LBRACE] = ACTIONS(1194),
    [anon_sym_RBRACE] = ACTIONS(1194),
    [anon_sym_for] = ACTIONS(1192),
    [sym_yul_leave] = ACTIONS(1192),
    [anon_sym_break] = ACTIONS(1192),
    [anon_sym_continue] = ACTIONS(1192),
    [sym_yul_decimal_number] = ACTIONS(1192),
    [sym_yul_hex_number] = ACTIONS(1194),
    [anon_sym_true] = ACTIONS(1192),
    [anon_sym_false] = ACTIONS(1192),
    [anon_sym_let] = ACTIONS(1192),
    [anon_sym_if] = ACTIONS(1192),
    [anon_sym_switch] = ACTIONS(1192),
    [anon_sym_function] = ACTIONS(1192),
    [anon_sym_stop] = ACTIONS(1192),
    [anon_sym_add] = ACTIONS(1192),
    [anon_sym_sub] = ACTIONS(1192),
    [anon_sym_mul] = ACTIONS(1192),
    [anon_sym_div] = ACTIONS(1192),
    [anon_sym_sdiv] = ACTIONS(1192),
    [anon_sym_mod] = ACTIONS(1192),
    [anon_sym_smod] = ACTIONS(1192),
    [anon_sym_exp] = ACTIONS(1192),
    [anon_sym_not] = ACTIONS(1192),
    [anon_sym_lt] = ACTIONS(1192),
    [anon_sym_gt] = ACTIONS(1192),
    [anon_sym_slt] = ACTIONS(1192),
    [anon_sym_sgt] = ACTIONS(1192),
    [anon_sym_eq] = ACTIONS(1192),
    [anon_sym_iszero] = ACTIONS(1192),
    [anon_sym_and] = ACTIONS(1192),
    [anon_sym_or] = ACTIONS(1192),
    [anon_sym_xor] = ACTIONS(1192),
    [anon_sym_byte] = ACTIONS(1192),
    [anon_sym_shl] = ACTIONS(1192),
    [anon_sym_shr] = ACTIONS(1192),
    [anon_sym_sar] = ACTIONS(1192),
    [anon_sym_addmod] = ACTIONS(1192),
    [anon_sym_mulmod] = ACTIONS(1192),
    [anon_sym_signextend] = ACTIONS(1192),
    [anon_sym_keccak256] = ACTIONS(1192),
    [anon_sym_pop] = ACTIONS(1192),
    [anon_sym_mload] = ACTIONS(1192),
    [anon_sym_mcopy] = ACTIONS(1192),
    [anon_sym_tload] = ACTIONS(1192),
    [anon_sym_tstore] = ACTIONS(1192),
    [anon_sym_mstore] = ACTIONS(1192),
    [anon_sym_mstore8] = ACTIONS(1192),
    [anon_sym_sload] = ACTIONS(1192),
    [anon_sym_sstore] = ACTIONS(1192),
    [anon_sym_msize] = ACTIONS(1192),
    [anon_sym_gas] = ACTIONS(1192),
    [anon_sym_address] = ACTIONS(1192),
    [anon_sym_balance] = ACTIONS(1192),
    [anon_sym_selfbalance] = ACTIONS(1192),
    [anon_sym_caller] = ACTIONS(1192),
    [anon_sym_callvalue] = ACTIONS(1192),
    [anon_sym_calldataload] = ACTIONS(1192),
    [anon_sym_calldatasize] = ACTIONS(1192),
    [anon_sym_calldatacopy] = ACTIONS(1192),
    [anon_sym_extcodesize] = ACTIONS(1192),
    [anon_sym_extcodecopy] = ACTIONS(1192),
    [anon_sym_returndatasize] = ACTIONS(1192),
    [anon_sym_returndatacopy] = ACTIONS(1192),
    [anon_sym_extcodehash] = ACTIONS(1192),
    [anon_sym_create] = ACTIONS(1192),
    [anon_sym_create2] = ACTIONS(1192),
    [anon_sym_call] = ACTIONS(1192),
    [anon_sym_callcode] = ACTIONS(1192),
    [anon_sym_delegatecall] = ACTIONS(1192),
    [anon_sym_staticcall] = ACTIONS(1192),
    [anon_sym_return] = ACTIONS(1192),
    [anon_sym_revert] = ACTIONS(1192),
    [anon_sym_selfdestruct] = ACTIONS(1192),
    [anon_sym_invalid] = ACTIONS(1192),
    [anon_sym_log0] = ACTIONS(1192),
    [anon_sym_log1] = ACTIONS(1192),
    [anon_sym_log2] = ACTIONS(1192),
    [anon_sym_log3] = ACTIONS(1192),
    [anon_sym_log4] = ACTIONS(1192),
    [anon_sym_chainid] = ACTIONS(1192),
    [anon_sym_origin] = ACTIONS(1192),
    [anon_sym_gasprice] = ACTIONS(1192),
    [anon_sym_blockhash] = ACTIONS(1192),
    [anon_sym_blobhash] = ACTIONS(1192),
    [anon_sym_basefee] = ACTIONS(1192),
    [anon_sym_blobfee] = ACTIONS(1192),
    [anon_sym_coinbase] = ACTIONS(1192),
    [anon_sym_timestamp] = ACTIONS(1192),
    [anon_sym_number] = ACTIONS(1192),
    [anon_sym_difficulty] = ACTIONS(1192),
    [anon_sym_gaslimit] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1194),
    [anon_sym_SQUOTE] = ACTIONS(1194),
    [sym_comment] = ACTIONS(3),
  },
  [289] = {
    [sym_identifier] = ACTIONS(1196),
    [anon_sym_LBRACE] = ACTIONS(1198),
    [anon_sym_RBRACE] = ACTIONS(1198),
    [anon_sym_for] = ACTIONS(1196),
    [sym_yul_leave] = ACTIONS(1196),
    [anon_sym_break] = ACTIONS(1196),
    [anon_sym_continue] = ACTIONS(1196),
    [sym_yul_decimal_number] = ACTIONS(1196),
    [sym_yul_hex_number] = ACTIONS(1198),
    [anon_sym_true] = ACTIONS(1196),
    [anon_sym_false] = ACTIONS(1196),
    [anon_sym_let] = ACTIONS(1196),
    [anon_sym_if] = ACTIONS(1196),
    [anon_sym_switch] = ACTIONS(1196),
    [anon_sym_function] = ACTIONS(1196),
    [anon_sym_stop] = ACTIONS(1196),
    [anon_sym_add] = ACTIONS(1196),
    [anon_sym_sub] = ACTIONS(1196),
    [anon_sym_mul] = ACTIONS(1196),
    [anon_sym_div] = ACTIONS(1196),
    [anon_sym_sdiv] = ACTIONS(1196),
    [anon_sym_mod] = ACTIONS(1196),
    [anon_sym_smod] = ACTIONS(1196),
    [anon_sym_exp] = ACTIONS(1196),
    [anon_sym_not] = ACTIONS(1196),
    [anon_sym_lt] = ACTIONS(1196),
    [anon_sym_gt] = ACTIONS(1196),
    [anon_sym_slt] = ACTIONS(1196),
    [anon_sym_sgt] = ACTIONS(1196),
    [anon_sym_eq] = ACTIONS(1196),
    [anon_sym_iszero] = ACTIONS(1196),
    [anon_sym_and] = ACTIONS(1196),
    [anon_sym_or] = ACTIONS(1196),
    [anon_sym_xor] = ACTIONS(1196),
    [anon_sym_byte] = ACTIONS(1196),
    [anon_sym_shl] = ACTIONS(1196),
    [anon_sym_shr] = ACTIONS(1196),
    [anon_sym_sar] = ACTIONS(1196),
    [anon_sym_addmod] = ACTIONS(1196),
    [anon_sym_mulmod] = ACTIONS(1196),
    [anon_sym_signextend] = ACTIONS(1196),
    [anon_sym_keccak256] = ACTIONS(1196),
    [anon_sym_pop] = ACTIONS(1196),
    [anon_sym_mload] = ACTIONS(1196),
    [anon_sym_mcopy] = ACTIONS(1196),
    [anon_sym_tload] = ACTIONS(1196),
    [anon_sym_tstore] = ACTIONS(1196),
    [anon_sym_mstore] = ACTIONS(1196),
    [anon_sym_mstore8] = ACTIONS(1196),
    [anon_sym_sload] = ACTIONS(1196),
    [anon_sym_sstore] = ACTIONS(1196),
    [anon_sym_msize] = ACTIONS(1196),
    [anon_sym_gas] = ACTIONS(1196),
    [anon_sym_address] = ACTIONS(1196),
    [anon_sym_balance] = ACTIONS(1196),
    [anon_sym_selfbalance] = ACTIONS(1196),
    [anon_sym_caller] = ACTIONS(1196),
    [anon_sym_callvalue] = ACTIONS(1196),
    [anon_sym_calldataload] = ACTIONS(1196),
    [anon_sym_calldatasize] = ACTIONS(1196),
    [anon_sym_calldatacopy] = ACTIONS(1196),
    [anon_sym_extcodesize] = ACTIONS(1196),
    [anon_sym_extcodecopy] = ACTIONS(1196),
    [anon_sym_returndatasize] = ACTIONS(1196),
    [anon_sym_returndatacopy] = ACTIONS(1196),
    [anon_sym_extcodehash] = ACTIONS(1196),
    [anon_sym_create] = ACTIONS(1196),
    [anon_sym_create2] = ACTIONS(1196),
    [anon_sym_call] = ACTIONS(1196),
    [anon_sym_callcode] = ACTIONS(1196),
    [anon_sym_delegatecall] = ACTIONS(1196),
    [anon_sym_staticcall] = ACTIONS(1196),
    [anon_sym_return] = ACTIONS(1196),
    [anon_sym_revert] = ACTIONS(1196),
    [anon_sym_selfdestruct] = ACTIONS(1196),
    [anon_sym_invalid] = ACTIONS(1196),
    [anon_sym_log0] = ACTIONS(1196),
    [anon_sym_log1] = ACTIONS(1196),
    [anon_sym_log2] = ACTIONS(1196),
    [anon_sym_log3] = ACTIONS(1196),
    [anon_sym_log4] = ACTIONS(1196),
    [anon_sym_chainid] = ACTIONS(1196),
    [anon_sym_origin] = ACTIONS(1196),
    [anon_sym_gasprice] = ACTIONS(1196),
    [anon_sym_blockhash] = ACTIONS(1196),
    [anon_sym_blobhash] = ACTIONS(1196),
    [anon_sym_basefee] = ACTIONS(1196),
    [anon_sym_blobfee] = ACTIONS(1196),
    [anon_sym_coinbase] = ACTIONS(1196),
    [anon_sym_timestamp] = ACTIONS(1196),
    [anon_sym_number] = ACTIONS(1196),
    [anon_sym_difficulty] = ACTIONS(1196),
    [anon_sym_gaslimit] = ACTIONS(1196),
    [anon_sym_DQUOTE] = ACTIONS(1198),
    [anon_sym_SQUOTE] = ACTIONS(1198),
    [sym_comment] = ACTIONS(3),
  },
  [290] = {
    [sym_identifier] = ACTIONS(1200),
    [anon_sym_LBRACE] = ACTIONS(1202),
    [anon_sym_RBRACE] = ACTIONS(1202),
    [anon_sym_for] = ACTIONS(1200),
    [sym_yul_leave] = ACTIONS(1200),
    [anon_sym_break] = ACTIONS(1200),
    [anon_sym_continue] = ACTIONS(1200),
    [sym_yul_decimal_number] = ACTIONS(1200),
    [sym_yul_hex_number] = ACTIONS(1202),
    [anon_sym_true] = ACTIONS(1200),
    [anon_sym_false] = ACTIONS(1200),
    [anon_sym_let] = ACTIONS(1200),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_switch] = ACTIONS(1200),
    [anon_sym_function] = ACTIONS(1200),
    [anon_sym_stop] = ACTIONS(1200),
    [anon_sym_add] = ACTIONS(1200),
    [anon_sym_sub] = ACTIONS(1200),
    [anon_sym_mul] = ACTIONS(1200),
    [anon_sym_div] = ACTIONS(1200),
    [anon_sym_sdiv] = ACTIONS(1200),
    [anon_sym_mod] = ACTIONS(1200),
    [anon_sym_smod] = ACTIONS(1200),
    [anon_sym_exp] = ACTIONS(1200),
    [anon_sym_not] = ACTIONS(1200),
    [anon_sym_lt] = ACTIONS(1200),
    [anon_sym_gt] = ACTIONS(1200),
    [anon_sym_slt] = ACTIONS(1200),
    [anon_sym_sgt] = ACTIONS(1200),
    [anon_sym_eq] = ACTIONS(1200),
    [anon_sym_iszero] = ACTIONS(1200),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1200),
    [anon_sym_xor] = ACTIONS(1200),
    [anon_sym_byte] = ACTIONS(1200),
    [anon_sym_shl] = ACTIONS(1200),
    [anon_sym_shr] = ACTIONS(1200),
    [anon_sym_sar] = ACTIONS(1200),
    [anon_sym_addmod] = ACTIONS(1200),
    [anon_sym_mulmod] = ACTIONS(1200),
    [anon_sym_signextend] = ACTIONS(1200),
    [anon_sym_keccak256] = ACTIONS(1200),
    [anon_sym_pop] = ACTIONS(1200),
    [anon_sym_mload] = ACTIONS(1200),
    [anon_sym_mcopy] = ACTIONS(1200),
    [anon_sym_tload] = ACTIONS(1200),
    [anon_sym_tstore] = ACTIONS(1200),
    [anon_sym_mstore] = ACTIONS(1200),
    [anon_sym_mstore8] = ACTIONS(1200),
    [anon_sym_sload] = ACTIONS(1200),
    [anon_sym_sstore] = ACTIONS(1200),
    [anon_sym_msize] = ACTIONS(1200),
    [anon_sym_gas] = ACTIONS(1200),
    [anon_sym_address] = ACTIONS(1200),
    [anon_sym_balance] = ACTIONS(1200),
    [anon_sym_selfbalance] = ACTIONS(1200),
    [anon_sym_caller] = ACTIONS(1200),
    [anon_sym_callvalue] = ACTIONS(1200),
    [anon_sym_calldataload] = ACTIONS(1200),
    [anon_sym_calldatasize] = ACTIONS(1200),
    [anon_sym_calldatacopy] = ACTIONS(1200),
    [anon_sym_extcodesize] = ACTIONS(1200),
    [anon_sym_extcodecopy] = ACTIONS(1200),
    [anon_sym_returndatasize] = ACTIONS(1200),
    [anon_sym_returndatacopy] = ACTIONS(1200),
    [anon_sym_extcodehash] = ACTIONS(1200),
    [anon_sym_create] = ACTIONS(1200),
    [anon_sym_create2] = ACTIONS(1200),
    [anon_sym_call] = ACTIONS(1200),
    [anon_sym_callcode] = ACTIONS(1200),
    [anon_sym_delegatecall] = ACTIONS(1200),
    [anon_sym_staticcall] = ACTIONS(1200),
    [anon_sym_return] = ACTIONS(1200),
    [anon_sym_revert] = ACTIONS(1200),
    [anon_sym_selfdestruct] = ACTIONS(1200),
    [anon_sym_invalid] = ACTIONS(1200),
    [anon_sym_log0] = ACTIONS(1200),
    [anon_sym_log1] = ACTIONS(1200),
    [anon_sym_log2] = ACTIONS(1200),
    [anon_sym_log3] = ACTIONS(1200),
    [anon_sym_log4] = ACTIONS(1200),
    [anon_sym_chainid] = ACTIONS(1200),
    [anon_sym_origin] = ACTIONS(1200),
    [anon_sym_gasprice] = ACTIONS(1200),
    [anon_sym_blockhash] = ACTIONS(1200),
    [anon_sym_blobhash] = ACTIONS(1200),
    [anon_sym_basefee] = ACTIONS(1200),
    [anon_sym_blobfee] = ACTIONS(1200),
    [anon_sym_coinbase] = ACTIONS(1200),
    [anon_sym_timestamp] = ACTIONS(1200),
    [anon_sym_number] = ACTIONS(1200),
    [anon_sym_difficulty] = ACTIONS(1200),
    [anon_sym_gaslimit] = ACTIONS(1200),
    [anon_sym_DQUOTE] = ACTIONS(1202),
    [anon_sym_SQUOTE] = ACTIONS(1202),
    [sym_comment] = ACTIONS(3),
  },
  [291] = {
    [sym_identifier] = ACTIONS(1204),
    [anon_sym_LBRACE] = ACTIONS(1206),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_for] = ACTIONS(1204),
    [sym_yul_leave] = ACTIONS(1204),
    [anon_sym_break] = ACTIONS(1204),
    [anon_sym_continue] = ACTIONS(1204),
    [sym_yul_decimal_number] = ACTIONS(1204),
    [sym_yul_hex_number] = ACTIONS(1206),
    [anon_sym_true] = ACTIONS(1204),
    [anon_sym_false] = ACTIONS(1204),
    [anon_sym_let] = ACTIONS(1204),
    [anon_sym_if] = ACTIONS(1204),
    [anon_sym_switch] = ACTIONS(1204),
    [anon_sym_function] = ACTIONS(1204),
    [anon_sym_stop] = ACTIONS(1204),
    [anon_sym_add] = ACTIONS(1204),
    [anon_sym_sub] = ACTIONS(1204),
    [anon_sym_mul] = ACTIONS(1204),
    [anon_sym_div] = ACTIONS(1204),
    [anon_sym_sdiv] = ACTIONS(1204),
    [anon_sym_mod] = ACTIONS(1204),
    [anon_sym_smod] = ACTIONS(1204),
    [anon_sym_exp] = ACTIONS(1204),
    [anon_sym_not] = ACTIONS(1204),
    [anon_sym_lt] = ACTIONS(1204),
    [anon_sym_gt] = ACTIONS(1204),
    [anon_sym_slt] = ACTIONS(1204),
    [anon_sym_sgt] = ACTIONS(1204),
    [anon_sym_eq] = ACTIONS(1204),
    [anon_sym_iszero] = ACTIONS(1204),
    [anon_sym_and] = ACTIONS(1204),
    [anon_sym_or] = ACTIONS(1204),
    [anon_sym_xor] = ACTIONS(1204),
    [anon_sym_byte] = ACTIONS(1204),
    [anon_sym_shl] = ACTIONS(1204),
    [anon_sym_shr] = ACTIONS(1204),
    [anon_sym_sar] = ACTIONS(1204),
    [anon_sym_addmod] = ACTIONS(1204),
    [anon_sym_mulmod] = ACTIONS(1204),
    [anon_sym_signextend] = ACTIONS(1204),
    [anon_sym_keccak256] = ACTIONS(1204),
    [anon_sym_pop] = ACTIONS(1204),
    [anon_sym_mload] = ACTIONS(1204),
    [anon_sym_mcopy] = ACTIONS(1204),
    [anon_sym_tload] = ACTIONS(1204),
    [anon_sym_tstore] = ACTIONS(1204),
    [anon_sym_mstore] = ACTIONS(1204),
    [anon_sym_mstore8] = ACTIONS(1204),
    [anon_sym_sload] = ACTIONS(1204),
    [anon_sym_sstore] = ACTIONS(1204),
    [anon_sym_msize] = ACTIONS(1204),
    [anon_sym_gas] = ACTIONS(1204),
    [anon_sym_address] = ACTIONS(1204),
    [anon_sym_balance] = ACTIONS(1204),
    [anon_sym_selfbalance] = ACTIONS(1204),
    [anon_sym_caller] = ACTIONS(1204),
    [anon_sym_callvalue] = ACTIONS(1204),
    [anon_sym_calldataload] = ACTIONS(1204),
    [anon_sym_calldatasize] = ACTIONS(1204),
    [anon_sym_calldatacopy] = ACTIONS(1204),
    [anon_sym_extcodesize] = ACTIONS(1204),
    [anon_sym_extcodecopy] = ACTIONS(1204),
    [anon_sym_returndatasize] = ACTIONS(1204),
    [anon_sym_returndatacopy] = ACTIONS(1204),
    [anon_sym_extcodehash] = ACTIONS(1204),
    [anon_sym_create] = ACTIONS(1204),
    [anon_sym_create2] = ACTIONS(1204),
    [anon_sym_call] = ACTIONS(1204),
    [anon_sym_callcode] = ACTIONS(1204),
    [anon_sym_delegatecall] = ACTIONS(1204),
    [anon_sym_staticcall] = ACTIONS(1204),
    [anon_sym_return] = ACTIONS(1204),
    [anon_sym_revert] = ACTIONS(1204),
    [anon_sym_selfdestruct] = ACTIONS(1204),
    [anon_sym_invalid] = ACTIONS(1204),
    [anon_sym_log0] = ACTIONS(1204),
    [anon_sym_log1] = ACTIONS(1204),
    [anon_sym_log2] = ACTIONS(1204),
    [anon_sym_log3] = ACTIONS(1204),
    [anon_sym_log4] = ACTIONS(1204),
    [anon_sym_chainid] = ACTIONS(1204),
    [anon_sym_origin] = ACTIONS(1204),
    [anon_sym_gasprice] = ACTIONS(1204),
    [anon_sym_blockhash] = ACTIONS(1204),
    [anon_sym_blobhash] = ACTIONS(1204),
    [anon_sym_basefee] = ACTIONS(1204),
    [anon_sym_blobfee] = ACTIONS(1204),
    [anon_sym_coinbase] = ACTIONS(1204),
    [anon_sym_timestamp] = ACTIONS(1204),
    [anon_sym_number] = ACTIONS(1204),
    [anon_sym_difficulty] = ACTIONS(1204),
    [anon_sym_gaslimit] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [anon_sym_SQUOTE] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
  },
  [292] = {
    [sym_identifier] = ACTIONS(1208),
    [anon_sym_LBRACE] = ACTIONS(1210),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [anon_sym_for] = ACTIONS(1208),
    [sym_yul_leave] = ACTIONS(1208),
    [anon_sym_break] = ACTIONS(1208),
    [anon_sym_continue] = ACTIONS(1208),
    [sym_yul_decimal_number] = ACTIONS(1208),
    [sym_yul_hex_number] = ACTIONS(1210),
    [anon_sym_true] = ACTIONS(1208),
    [anon_sym_false] = ACTIONS(1208),
    [anon_sym_let] = ACTIONS(1208),
    [anon_sym_if] = ACTIONS(1208),
    [anon_sym_switch] = ACTIONS(1208),
    [anon_sym_function] = ACTIONS(1208),
    [anon_sym_stop] = ACTIONS(1208),
    [anon_sym_add] = ACTIONS(1208),
    [anon_sym_sub] = ACTIONS(1208),
    [anon_sym_mul] = ACTIONS(1208),
    [anon_sym_div] = ACTIONS(1208),
    [anon_sym_sdiv] = ACTIONS(1208),
    [anon_sym_mod] = ACTIONS(1208),
    [anon_sym_smod] = ACTIONS(1208),
    [anon_sym_exp] = ACTIONS(1208),
    [anon_sym_not] = ACTIONS(1208),
    [anon_sym_lt] = ACTIONS(1208),
    [anon_sym_gt] = ACTIONS(1208),
    [anon_sym_slt] = ACTIONS(1208),
    [anon_sym_sgt] = ACTIONS(1208),
    [anon_sym_eq] = ACTIONS(1208),
    [anon_sym_iszero] = ACTIONS(1208),
    [anon_sym_and] = ACTIONS(1208),
    [anon_sym_or] = ACTIONS(1208),
    [anon_sym_xor] = ACTIONS(1208),
    [anon_sym_byte] = ACTIONS(1208),
    [anon_sym_shl] = ACTIONS(1208),
    [anon_sym_shr] = ACTIONS(1208),
    [anon_sym_sar] = ACTIONS(1208),
    [anon_sym_addmod] = ACTIONS(1208),
    [anon_sym_mulmod] = ACTIONS(1208),
    [anon_sym_signextend] = ACTIONS(1208),
    [anon_sym_keccak256] = ACTIONS(1208),
    [anon_sym_pop] = ACTIONS(1208),
    [anon_sym_mload] = ACTIONS(1208),
    [anon_sym_mcopy] = ACTIONS(1208),
    [anon_sym_tload] = ACTIONS(1208),
    [anon_sym_tstore] = ACTIONS(1208),
    [anon_sym_mstore] = ACTIONS(1208),
    [anon_sym_mstore8] = ACTIONS(1208),
    [anon_sym_sload] = ACTIONS(1208),
    [anon_sym_sstore] = ACTIONS(1208),
    [anon_sym_msize] = ACTIONS(1208),
    [anon_sym_gas] = ACTIONS(1208),
    [anon_sym_address] = ACTIONS(1208),
    [anon_sym_balance] = ACTIONS(1208),
    [anon_sym_selfbalance] = ACTIONS(1208),
    [anon_sym_caller] = ACTIONS(1208),
    [anon_sym_callvalue] = ACTIONS(1208),
    [anon_sym_calldataload] = ACTIONS(1208),
    [anon_sym_calldatasize] = ACTIONS(1208),
    [anon_sym_calldatacopy] = ACTIONS(1208),
    [anon_sym_extcodesize] = ACTIONS(1208),
    [anon_sym_extcodecopy] = ACTIONS(1208),
    [anon_sym_returndatasize] = ACTIONS(1208),
    [anon_sym_returndatacopy] = ACTIONS(1208),
    [anon_sym_extcodehash] = ACTIONS(1208),
    [anon_sym_create] = ACTIONS(1208),
    [anon_sym_create2] = ACTIONS(1208),
    [anon_sym_call] = ACTIONS(1208),
    [anon_sym_callcode] = ACTIONS(1208),
    [anon_sym_delegatecall] = ACTIONS(1208),
    [anon_sym_staticcall] = ACTIONS(1208),
    [anon_sym_return] = ACTIONS(1208),
    [anon_sym_revert] = ACTIONS(1208),
    [anon_sym_selfdestruct] = ACTIONS(1208),
    [anon_sym_invalid] = ACTIONS(1208),
    [anon_sym_log0] = ACTIONS(1208),
    [anon_sym_log1] = ACTIONS(1208),
    [anon_sym_log2] = ACTIONS(1208),
    [anon_sym_log3] = ACTIONS(1208),
    [anon_sym_log4] = ACTIONS(1208),
    [anon_sym_chainid] = ACTIONS(1208),
    [anon_sym_origin] = ACTIONS(1208),
    [anon_sym_gasprice] = ACTIONS(1208),
    [anon_sym_blockhash] = ACTIONS(1208),
    [anon_sym_blobhash] = ACTIONS(1208),
    [anon_sym_basefee] = ACTIONS(1208),
    [anon_sym_blobfee] = ACTIONS(1208),
    [anon_sym_coinbase] = ACTIONS(1208),
    [anon_sym_timestamp] = ACTIONS(1208),
    [anon_sym_number] = ACTIONS(1208),
    [anon_sym_difficulty] = ACTIONS(1208),
    [anon_sym_gaslimit] = ACTIONS(1208),
    [anon_sym_DQUOTE] = ACTIONS(1210),
    [anon_sym_SQUOTE] = ACTIONS(1210),
    [sym_comment] = ACTIONS(3),
  },
  [293] = {
    [sym_yul_identifier] = STATE(228),
    [sym__yul_expression] = STATE(671),
    [sym_yul_path] = STATE(671),
    [sym__yul_literal] = STATE(671),
    [sym_yul_string_literal] = STATE(671),
    [sym_yul_boolean] = STATE(671),
    [sym_yul_function_call] = STATE(671),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [sym_identifier] = ACTIONS(1156),
    [sym_yul_decimal_number] = ACTIONS(1212),
    [sym_yul_hex_number] = ACTIONS(1214),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [294] = {
    [sym_yul_identifier] = STATE(228),
    [sym__yul_expression] = STATE(285),
    [sym_yul_path] = STATE(285),
    [sym__yul_literal] = STATE(285),
    [sym_yul_string_literal] = STATE(285),
    [sym_yul_boolean] = STATE(285),
    [sym_yul_function_call] = STATE(277),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [sym_identifier] = ACTIONS(1156),
    [sym_yul_decimal_number] = ACTIONS(1216),
    [sym_yul_hex_number] = ACTIONS(1218),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [295] = {
    [sym_yul_identifier] = STATE(228),
    [sym__yul_expression] = STATE(724),
    [sym_yul_path] = STATE(724),
    [sym__yul_literal] = STATE(724),
    [sym_yul_string_literal] = STATE(724),
    [sym_yul_boolean] = STATE(724),
    [sym_yul_function_call] = STATE(724),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [sym_identifier] = ACTIONS(1156),
    [sym_yul_decimal_number] = ACTIONS(1220),
    [sym_yul_hex_number] = ACTIONS(1222),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [sym_yul_identifier] = STATE(228),
    [sym__yul_expression] = STATE(580),
    [sym_yul_path] = STATE(580),
    [sym__yul_literal] = STATE(580),
    [sym_yul_string_literal] = STATE(580),
    [sym_yul_boolean] = STATE(580),
    [sym_yul_function_call] = STATE(580),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [sym_identifier] = ACTIONS(1156),
    [sym_yul_decimal_number] = ACTIONS(1224),
    [sym_yul_hex_number] = ACTIONS(1226),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [297] = {
    [sym_yul_identifier] = STATE(228),
    [sym__yul_expression] = STATE(726),
    [sym_yul_path] = STATE(726),
    [sym__yul_literal] = STATE(726),
    [sym_yul_string_literal] = STATE(726),
    [sym_yul_boolean] = STATE(726),
    [sym_yul_function_call] = STATE(726),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [sym_identifier] = ACTIONS(1156),
    [sym_yul_decimal_number] = ACTIONS(1160),
    [sym_yul_hex_number] = ACTIONS(1162),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(103),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [sym_yul_identifier] = STATE(228),
    [sym__yul_expression] = STATE(267),
    [sym_yul_path] = STATE(267),
    [sym__yul_literal] = STATE(267),
    [sym_yul_string_literal] = STATE(267),
    [sym_yul_boolean] = STATE(267),
    [sym_yul_function_call] = STATE(268),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_string] = STATE(242),
    [sym_identifier] = ACTIONS(1156),
    [sym_yul_decimal_number] = ACTIONS(1228),
    [sym_yul_hex_number] = ACTIONS(1230),
    [anon_sym_true] = ACTIONS(840),
    [anon_sym_false] = ACTIONS(840),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [anon_sym_DQUOTE] = ACTIONS(852),
    [anon_sym_SQUOTE] = ACTIONS(854),
    [sym_comment] = ACTIONS(3),
  },
  [299] = {
    [sym_identifier] = ACTIONS(1232),
    [sym_yul_decimal_number] = ACTIONS(1232),
    [sym_yul_hex_number] = ACTIONS(1234),
    [anon_sym_true] = ACTIONS(1232),
    [anon_sym_false] = ACTIONS(1232),
    [anon_sym_stop] = ACTIONS(1232),
    [anon_sym_add] = ACTIONS(1232),
    [anon_sym_sub] = ACTIONS(1232),
    [anon_sym_mul] = ACTIONS(1232),
    [anon_sym_div] = ACTIONS(1232),
    [anon_sym_sdiv] = ACTIONS(1232),
    [anon_sym_mod] = ACTIONS(1232),
    [anon_sym_smod] = ACTIONS(1232),
    [anon_sym_exp] = ACTIONS(1232),
    [anon_sym_not] = ACTIONS(1232),
    [anon_sym_lt] = ACTIONS(1232),
    [anon_sym_gt] = ACTIONS(1232),
    [anon_sym_slt] = ACTIONS(1232),
    [anon_sym_sgt] = ACTIONS(1232),
    [anon_sym_eq] = ACTIONS(1232),
    [anon_sym_iszero] = ACTIONS(1232),
    [anon_sym_and] = ACTIONS(1232),
    [anon_sym_or] = ACTIONS(1232),
    [anon_sym_xor] = ACTIONS(1232),
    [anon_sym_byte] = ACTIONS(1232),
    [anon_sym_shl] = ACTIONS(1232),
    [anon_sym_shr] = ACTIONS(1232),
    [anon_sym_sar] = ACTIONS(1232),
    [anon_sym_addmod] = ACTIONS(1232),
    [anon_sym_mulmod] = ACTIONS(1232),
    [anon_sym_signextend] = ACTIONS(1232),
    [anon_sym_keccak256] = ACTIONS(1232),
    [anon_sym_pop] = ACTIONS(1232),
    [anon_sym_mload] = ACTIONS(1232),
    [anon_sym_mcopy] = ACTIONS(1232),
    [anon_sym_tload] = ACTIONS(1232),
    [anon_sym_tstore] = ACTIONS(1232),
    [anon_sym_mstore] = ACTIONS(1232),
    [anon_sym_mstore8] = ACTIONS(1232),
    [anon_sym_sload] = ACTIONS(1232),
    [anon_sym_sstore] = ACTIONS(1232),
    [anon_sym_msize] = ACTIONS(1232),
    [anon_sym_gas] = ACTIONS(1232),
    [anon_sym_address] = ACTIONS(1232),
    [anon_sym_balance] = ACTIONS(1232),
    [anon_sym_selfbalance] = ACTIONS(1232),
    [anon_sym_caller] = ACTIONS(1232),
    [anon_sym_callvalue] = ACTIONS(1232),
    [anon_sym_calldataload] = ACTIONS(1232),
    [anon_sym_calldatasize] = ACTIONS(1232),
    [anon_sym_calldatacopy] = ACTIONS(1232),
    [anon_sym_extcodesize] = ACTIONS(1232),
    [anon_sym_extcodecopy] = ACTIONS(1232),
    [anon_sym_returndatasize] = ACTIONS(1232),
    [anon_sym_returndatacopy] = ACTIONS(1232),
    [anon_sym_extcodehash] = ACTIONS(1232),
    [anon_sym_create] = ACTIONS(1232),
    [anon_sym_create2] = ACTIONS(1232),
    [anon_sym_call] = ACTIONS(1232),
    [anon_sym_callcode] = ACTIONS(1232),
    [anon_sym_delegatecall] = ACTIONS(1232),
    [anon_sym_staticcall] = ACTIONS(1232),
    [anon_sym_return] = ACTIONS(1232),
    [anon_sym_revert] = ACTIONS(1232),
    [anon_sym_selfdestruct] = ACTIONS(1232),
    [anon_sym_invalid] = ACTIONS(1232),
    [anon_sym_log0] = ACTIONS(1232),
    [anon_sym_log1] = ACTIONS(1232),
    [anon_sym_log2] = ACTIONS(1232),
    [anon_sym_log3] = ACTIONS(1232),
    [anon_sym_log4] = ACTIONS(1232),
    [anon_sym_chainid] = ACTIONS(1232),
    [anon_sym_origin] = ACTIONS(1232),
    [anon_sym_gasprice] = ACTIONS(1232),
    [anon_sym_blockhash] = ACTIONS(1232),
    [anon_sym_blobhash] = ACTIONS(1232),
    [anon_sym_basefee] = ACTIONS(1232),
    [anon_sym_blobfee] = ACTIONS(1232),
    [anon_sym_coinbase] = ACTIONS(1232),
    [anon_sym_timestamp] = ACTIONS(1232),
    [anon_sym_number] = ACTIONS(1232),
    [anon_sym_difficulty] = ACTIONS(1232),
    [anon_sym_gaslimit] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
  },
  [300] = {
    [sym_yul_identifier] = STATE(789),
    [sym_yul_function_call] = STATE(278),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [sym_comment] = ACTIONS(3),
  },
  [301] = {
    [sym_yul_identifier] = STATE(789),
    [sym_yul_function_call] = STATE(280),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [sym_comment] = ACTIONS(3),
  },
  [302] = {
    [sym_yul_identifier] = STATE(789),
    [sym_yul_function_call] = STATE(284),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [sym_yul_identifier] = STATE(789),
    [sym_yul_function_call] = STATE(273),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [sym_comment] = ACTIONS(3),
  },
  [304] = {
    [sym_yul_identifier] = STATE(789),
    [sym_yul_function_call] = STATE(281),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [sym_yul_identifier] = STATE(789),
    [sym_yul_function_call] = STATE(269),
    [sym_yul_evm_builtin] = STATE(234),
    [sym_identifier] = ACTIONS(1156),
    [anon_sym_stop] = ACTIONS(850),
    [anon_sym_add] = ACTIONS(850),
    [anon_sym_sub] = ACTIONS(850),
    [anon_sym_mul] = ACTIONS(850),
    [anon_sym_div] = ACTIONS(850),
    [anon_sym_sdiv] = ACTIONS(850),
    [anon_sym_mod] = ACTIONS(850),
    [anon_sym_smod] = ACTIONS(850),
    [anon_sym_exp] = ACTIONS(850),
    [anon_sym_not] = ACTIONS(850),
    [anon_sym_lt] = ACTIONS(850),
    [anon_sym_gt] = ACTIONS(850),
    [anon_sym_slt] = ACTIONS(850),
    [anon_sym_sgt] = ACTIONS(850),
    [anon_sym_eq] = ACTIONS(850),
    [anon_sym_iszero] = ACTIONS(850),
    [anon_sym_and] = ACTIONS(850),
    [anon_sym_or] = ACTIONS(850),
    [anon_sym_xor] = ACTIONS(850),
    [anon_sym_byte] = ACTIONS(850),
    [anon_sym_shl] = ACTIONS(850),
    [anon_sym_shr] = ACTIONS(850),
    [anon_sym_sar] = ACTIONS(850),
    [anon_sym_addmod] = ACTIONS(850),
    [anon_sym_mulmod] = ACTIONS(850),
    [anon_sym_signextend] = ACTIONS(850),
    [anon_sym_keccak256] = ACTIONS(850),
    [anon_sym_pop] = ACTIONS(850),
    [anon_sym_mload] = ACTIONS(850),
    [anon_sym_mcopy] = ACTIONS(850),
    [anon_sym_tload] = ACTIONS(850),
    [anon_sym_tstore] = ACTIONS(850),
    [anon_sym_mstore] = ACTIONS(850),
    [anon_sym_mstore8] = ACTIONS(850),
    [anon_sym_sload] = ACTIONS(850),
    [anon_sym_sstore] = ACTIONS(850),
    [anon_sym_msize] = ACTIONS(850),
    [anon_sym_gas] = ACTIONS(850),
    [anon_sym_address] = ACTIONS(850),
    [anon_sym_balance] = ACTIONS(850),
    [anon_sym_selfbalance] = ACTIONS(850),
    [anon_sym_caller] = ACTIONS(850),
    [anon_sym_callvalue] = ACTIONS(850),
    [anon_sym_calldataload] = ACTIONS(850),
    [anon_sym_calldatasize] = ACTIONS(850),
    [anon_sym_calldatacopy] = ACTIONS(850),
    [anon_sym_extcodesize] = ACTIONS(850),
    [anon_sym_extcodecopy] = ACTIONS(850),
    [anon_sym_returndatasize] = ACTIONS(850),
    [anon_sym_returndatacopy] = ACTIONS(850),
    [anon_sym_extcodehash] = ACTIONS(850),
    [anon_sym_create] = ACTIONS(850),
    [anon_sym_create2] = ACTIONS(850),
    [anon_sym_call] = ACTIONS(850),
    [anon_sym_callcode] = ACTIONS(850),
    [anon_sym_delegatecall] = ACTIONS(850),
    [anon_sym_staticcall] = ACTIONS(850),
    [anon_sym_return] = ACTIONS(850),
    [anon_sym_revert] = ACTIONS(850),
    [anon_sym_selfdestruct] = ACTIONS(850),
    [anon_sym_invalid] = ACTIONS(850),
    [anon_sym_log0] = ACTIONS(850),
    [anon_sym_log1] = ACTIONS(850),
    [anon_sym_log2] = ACTIONS(850),
    [anon_sym_log3] = ACTIONS(850),
    [anon_sym_log4] = ACTIONS(850),
    [anon_sym_chainid] = ACTIONS(850),
    [anon_sym_origin] = ACTIONS(850),
    [anon_sym_gasprice] = ACTIONS(850),
    [anon_sym_blockhash] = ACTIONS(850),
    [anon_sym_blobhash] = ACTIONS(850),
    [anon_sym_basefee] = ACTIONS(850),
    [anon_sym_blobfee] = ACTIONS(850),
    [anon_sym_coinbase] = ACTIONS(850),
    [anon_sym_timestamp] = ACTIONS(850),
    [anon_sym_number] = ACTIONS(850),
    [anon_sym_difficulty] = ACTIONS(850),
    [anon_sym_gaslimit] = ACTIONS(850),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [sym_visibility] = STATE(309),
    [sym_state_mutability] = STATE(309),
    [sym__return_parameters] = STATE(330),
    [aux_sym__function_type_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(1236),
    [anon_sym_PIPE_PIPE] = ACTIONS(1238),
    [anon_sym_DASH] = ACTIONS(1236),
    [anon_sym_LT_EQ] = ACTIONS(1238),
    [anon_sym_LT] = ACTIONS(1236),
    [anon_sym_CARET] = ACTIONS(1236),
    [anon_sym_GT] = ACTIONS(1236),
    [anon_sym_GT_EQ] = ACTIONS(1238),
    [anon_sym_EQ] = ACTIONS(1236),
    [anon_sym_STAR] = ACTIONS(1236),
    [anon_sym_LBRACE] = ACTIONS(1238),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_RBRACE] = ACTIONS(1238),
    [anon_sym_constant] = ACTIONS(1236),
    [anon_sym_LPAREN] = ACTIONS(1238),
    [anon_sym_RPAREN] = ACTIONS(1238),
    [anon_sym_indexed] = ACTIONS(1236),
    [anon_sym_COLON] = ACTIONS(1238),
    [anon_sym_DOT] = ACTIONS(1238),
    [sym_unchecked] = ACTIONS(1236),
    [anon_sym_memory] = ACTIONS(1236),
    [anon_sym_storage] = ACTIONS(1236),
    [anon_sym_calldata] = ACTIONS(1236),
    [anon_sym_returns] = ACTIONS(1240),
    [anon_sym_public] = ACTIONS(1242),
    [anon_sym_internal] = ACTIONS(1242),
    [anon_sym_private] = ACTIONS(1242),
    [anon_sym_external] = ACTIONS(1242),
    [anon_sym_pure] = ACTIONS(1244),
    [anon_sym_view] = ACTIONS(1244),
    [anon_sym_payable] = ACTIONS(1244),
    [sym_immutable] = ACTIONS(1236),
    [anon_sym_override] = ACTIONS(1236),
    [anon_sym_QMARK] = ACTIONS(1238),
    [anon_sym_LBRACK] = ACTIONS(1238),
    [anon_sym_RBRACK] = ACTIONS(1238),
    [anon_sym_AMP_AMP] = ACTIONS(1238),
    [anon_sym_GT_GT] = ACTIONS(1236),
    [anon_sym_GT_GT_GT] = ACTIONS(1236),
    [anon_sym_LT_LT] = ACTIONS(1236),
    [anon_sym_AMP] = ACTIONS(1236),
    [anon_sym_PIPE] = ACTIONS(1236),
    [anon_sym_PLUS] = ACTIONS(1236),
    [anon_sym_SLASH] = ACTIONS(1236),
    [anon_sym_PERCENT] = ACTIONS(1236),
    [anon_sym_STAR_STAR] = ACTIONS(1238),
    [anon_sym_EQ_EQ] = ACTIONS(1238),
    [anon_sym_BANG_EQ] = ACTIONS(1236),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1238),
    [anon_sym_PLUS_PLUS] = ACTIONS(1238),
    [anon_sym_DASH_DASH] = ACTIONS(1238),
    [anon_sym_PLUS_EQ] = ACTIONS(1238),
    [anon_sym_DASH_EQ] = ACTIONS(1238),
    [anon_sym_STAR_EQ] = ACTIONS(1238),
    [anon_sym_SLASH_EQ] = ACTIONS(1238),
    [anon_sym_PERCENT_EQ] = ACTIONS(1238),
    [anon_sym_CARET_EQ] = ACTIONS(1238),
    [anon_sym_AMP_EQ] = ACTIONS(1238),
    [anon_sym_PIPE_EQ] = ACTIONS(1238),
    [anon_sym_GT_GT_EQ] = ACTIONS(1238),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1238),
    [anon_sym_LT_LT_EQ] = ACTIONS(1238),
    [sym__semicolon] = ACTIONS(1238),
    [sym_comment] = ACTIONS(3),
  },
  [307] = {
    [aux_sym__identifier_path_repeat1] = STATE(307),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_constant] = ACTIONS(1246),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_indexed] = ACTIONS(1246),
    [anon_sym_for] = ACTIONS(1246),
    [anon_sym_COLON] = ACTIONS(1248),
    [anon_sym_DOT] = ACTIONS(1250),
    [sym_unchecked] = ACTIONS(1246),
    [anon_sym_memory] = ACTIONS(1246),
    [anon_sym_storage] = ACTIONS(1246),
    [anon_sym_calldata] = ACTIONS(1246),
    [anon_sym_returns] = ACTIONS(1246),
    [anon_sym_public] = ACTIONS(1246),
    [anon_sym_internal] = ACTIONS(1246),
    [anon_sym_private] = ACTIONS(1246),
    [anon_sym_external] = ACTIONS(1246),
    [anon_sym_pure] = ACTIONS(1246),
    [anon_sym_view] = ACTIONS(1246),
    [anon_sym_payable] = ACTIONS(1246),
    [sym_immutable] = ACTIONS(1246),
    [anon_sym_override] = ACTIONS(1246),
    [sym_virtual] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACK] = ACTIONS(1248),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_GT_GT_GT] = ACTIONS(1246),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_STAR_STAR] = ACTIONS(1248),
    [anon_sym_EQ_EQ] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1246),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1248),
    [anon_sym_PLUS_PLUS] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1248),
    [anon_sym_PLUS_EQ] = ACTIONS(1248),
    [anon_sym_DASH_EQ] = ACTIONS(1248),
    [anon_sym_STAR_EQ] = ACTIONS(1248),
    [anon_sym_SLASH_EQ] = ACTIONS(1248),
    [anon_sym_PERCENT_EQ] = ACTIONS(1248),
    [anon_sym_CARET_EQ] = ACTIONS(1248),
    [anon_sym_AMP_EQ] = ACTIONS(1248),
    [anon_sym_PIPE_EQ] = ACTIONS(1248),
    [anon_sym_GT_GT_EQ] = ACTIONS(1248),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1248),
    [anon_sym_LT_LT_EQ] = ACTIONS(1248),
    [anon_sym_EQ_GT] = ACTIONS(1248),
    [sym__semicolon] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
  },
  [308] = {
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_CARET] = ACTIONS(1246),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_constant] = ACTIONS(1246),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_indexed] = ACTIONS(1246),
    [anon_sym_for] = ACTIONS(1246),
    [anon_sym_COLON] = ACTIONS(1248),
    [anon_sym_DOT] = ACTIONS(1248),
    [sym_unchecked] = ACTIONS(1246),
    [anon_sym_memory] = ACTIONS(1246),
    [anon_sym_storage] = ACTIONS(1246),
    [anon_sym_calldata] = ACTIONS(1246),
    [anon_sym_returns] = ACTIONS(1246),
    [anon_sym_public] = ACTIONS(1246),
    [anon_sym_internal] = ACTIONS(1246),
    [anon_sym_private] = ACTIONS(1246),
    [anon_sym_external] = ACTIONS(1246),
    [anon_sym_pure] = ACTIONS(1246),
    [anon_sym_view] = ACTIONS(1246),
    [anon_sym_payable] = ACTIONS(1246),
    [sym_immutable] = ACTIONS(1246),
    [anon_sym_override] = ACTIONS(1246),
    [sym_virtual] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_RBRACK] = ACTIONS(1248),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_GT_GT_GT] = ACTIONS(1246),
    [anon_sym_LT_LT] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [anon_sym_PERCENT] = ACTIONS(1246),
    [anon_sym_STAR_STAR] = ACTIONS(1248),
    [anon_sym_EQ_EQ] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1246),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1248),
    [anon_sym_PLUS_PLUS] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1248),
    [anon_sym_PLUS_EQ] = ACTIONS(1248),
    [anon_sym_DASH_EQ] = ACTIONS(1248),
    [anon_sym_STAR_EQ] = ACTIONS(1248),
    [anon_sym_SLASH_EQ] = ACTIONS(1248),
    [anon_sym_PERCENT_EQ] = ACTIONS(1248),
    [anon_sym_CARET_EQ] = ACTIONS(1248),
    [anon_sym_AMP_EQ] = ACTIONS(1248),
    [anon_sym_PIPE_EQ] = ACTIONS(1248),
    [anon_sym_GT_GT_EQ] = ACTIONS(1248),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1248),
    [anon_sym_LT_LT_EQ] = ACTIONS(1248),
    [anon_sym_EQ_GT] = ACTIONS(1248),
    [sym__semicolon] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
  },
  [309] = {
    [sym_visibility] = STATE(309),
    [sym_state_mutability] = STATE(309),
    [aux_sym__function_type_repeat1] = STATE(309),
    [sym_identifier] = ACTIONS(1253),
    [anon_sym_PIPE_PIPE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_LT_EQ] = ACTIONS(1255),
    [anon_sym_LT] = ACTIONS(1253),
    [anon_sym_CARET] = ACTIONS(1253),
    [anon_sym_GT] = ACTIONS(1253),
    [anon_sym_GT_EQ] = ACTIONS(1255),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_STAR] = ACTIONS(1253),
    [anon_sym_LBRACE] = ACTIONS(1255),
    [anon_sym_COMMA] = ACTIONS(1255),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_constant] = ACTIONS(1253),
    [anon_sym_LPAREN] = ACTIONS(1255),
    [anon_sym_RPAREN] = ACTIONS(1255),
    [anon_sym_indexed] = ACTIONS(1253),
    [anon_sym_COLON] = ACTIONS(1255),
    [anon_sym_DOT] = ACTIONS(1255),
    [sym_unchecked] = ACTIONS(1253),
    [anon_sym_memory] = ACTIONS(1253),
    [anon_sym_storage] = ACTIONS(1253),
    [anon_sym_calldata] = ACTIONS(1253),
    [anon_sym_returns] = ACTIONS(1253),
    [anon_sym_public] = ACTIONS(1257),
    [anon_sym_internal] = ACTIONS(1257),
    [anon_sym_private] = ACTIONS(1257),
    [anon_sym_external] = ACTIONS(1257),
    [anon_sym_pure] = ACTIONS(1260),
    [anon_sym_view] = ACTIONS(1260),
    [anon_sym_payable] = ACTIONS(1260),
    [sym_immutable] = ACTIONS(1253),
    [anon_sym_override] = ACTIONS(1253),
    [anon_sym_QMARK] = ACTIONS(1255),
    [anon_sym_LBRACK] = ACTIONS(1255),
    [anon_sym_RBRACK] = ACTIONS(1255),
    [anon_sym_AMP_AMP] = ACTIONS(1255),
    [anon_sym_GT_GT] = ACTIONS(1253),
    [anon_sym_GT_GT_GT] = ACTIONS(1253),
    [anon_sym_LT_LT] = ACTIONS(1253),
    [anon_sym_AMP] = ACTIONS(1253),
    [anon_sym_PIPE] = ACTIONS(1253),
    [anon_sym_PLUS] = ACTIONS(1253),
    [anon_sym_SLASH] = ACTIONS(1253),
    [anon_sym_PERCENT] = ACTIONS(1253),
    [anon_sym_STAR_STAR] = ACTIONS(1255),
    [anon_sym_EQ_EQ] = ACTIONS(1255),
    [anon_sym_BANG_EQ] = ACTIONS(1253),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_PLUS_EQ] = ACTIONS(1255),
    [anon_sym_DASH_EQ] = ACTIONS(1255),
    [anon_sym_STAR_EQ] = ACTIONS(1255),
    [anon_sym_SLASH_EQ] = ACTIONS(1255),
    [anon_sym_PERCENT_EQ] = ACTIONS(1255),
    [anon_sym_CARET_EQ] = ACTIONS(1255),
    [anon_sym_AMP_EQ] = ACTIONS(1255),
    [anon_sym_PIPE_EQ] = ACTIONS(1255),
    [anon_sym_GT_GT_EQ] = ACTIONS(1255),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1255),
    [anon_sym_LT_LT_EQ] = ACTIONS(1255),
    [sym__semicolon] = ACTIONS(1255),
    [sym_comment] = ACTIONS(3),
  },
  [310] = {
    [sym_visibility] = STATE(306),
    [sym_state_mutability] = STATE(306),
    [sym__return_parameters] = STATE(336),
    [aux_sym__function_type_repeat1] = STATE(306),
    [sym_identifier] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1265),
    [anon_sym_DASH] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(1263),
    [anon_sym_CARET] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1263),
    [anon_sym_GT_EQ] = ACTIONS(1265),
    [anon_sym_EQ] = ACTIONS(1263),
    [anon_sym_STAR] = ACTIONS(1263),
    [anon_sym_LBRACE] = ACTIONS(1265),
    [anon_sym_COMMA] = ACTIONS(1265),
    [anon_sym_RBRACE] = ACTIONS(1265),
    [anon_sym_constant] = ACTIONS(1263),
    [anon_sym_LPAREN] = ACTIONS(1265),
    [anon_sym_RPAREN] = ACTIONS(1265),
    [anon_sym_indexed] = ACTIONS(1263),
    [anon_sym_COLON] = ACTIONS(1265),
    [anon_sym_DOT] = ACTIONS(1265),
    [sym_unchecked] = ACTIONS(1263),
    [anon_sym_memory] = ACTIONS(1263),
    [anon_sym_storage] = ACTIONS(1263),
    [anon_sym_calldata] = ACTIONS(1263),
    [anon_sym_returns] = ACTIONS(1240),
    [anon_sym_public] = ACTIONS(1242),
    [anon_sym_internal] = ACTIONS(1242),
    [anon_sym_private] = ACTIONS(1242),
    [anon_sym_external] = ACTIONS(1242),
    [anon_sym_pure] = ACTIONS(1244),
    [anon_sym_view] = ACTIONS(1244),
    [anon_sym_payable] = ACTIONS(1244),
    [anon_sym_QMARK] = ACTIONS(1265),
    [anon_sym_LBRACK] = ACTIONS(1265),
    [anon_sym_RBRACK] = ACTIONS(1265),
    [anon_sym_AMP_AMP] = ACTIONS(1265),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [anon_sym_GT_GT_GT] = ACTIONS(1263),
    [anon_sym_LT_LT] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1263),
    [anon_sym_SLASH] = ACTIONS(1263),
    [anon_sym_PERCENT] = ACTIONS(1263),
    [anon_sym_STAR_STAR] = ACTIONS(1265),
    [anon_sym_EQ_EQ] = ACTIONS(1265),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1265),
    [anon_sym_PLUS_PLUS] = ACTIONS(1265),
    [anon_sym_DASH_DASH] = ACTIONS(1265),
    [anon_sym_PLUS_EQ] = ACTIONS(1265),
    [anon_sym_DASH_EQ] = ACTIONS(1265),
    [anon_sym_STAR_EQ] = ACTIONS(1265),
    [anon_sym_SLASH_EQ] = ACTIONS(1265),
    [anon_sym_PERCENT_EQ] = ACTIONS(1265),
    [anon_sym_CARET_EQ] = ACTIONS(1265),
    [anon_sym_AMP_EQ] = ACTIONS(1265),
    [anon_sym_PIPE_EQ] = ACTIONS(1265),
    [anon_sym_GT_GT_EQ] = ACTIONS(1265),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1265),
    [anon_sym_LT_LT_EQ] = ACTIONS(1265),
    [sym__semicolon] = ACTIONS(1265),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym_identifier] = ACTIONS(1267),
    [anon_sym_PIPE_PIPE] = ACTIONS(1269),
    [anon_sym_DASH] = ACTIONS(1267),
    [anon_sym_LT_EQ] = ACTIONS(1269),
    [anon_sym_LT] = ACTIONS(1267),
    [anon_sym_CARET] = ACTIONS(1267),
    [anon_sym_GT] = ACTIONS(1267),
    [anon_sym_GT_EQ] = ACTIONS(1269),
    [anon_sym_EQ] = ACTIONS(1267),
    [anon_sym_STAR] = ACTIONS(1267),
    [anon_sym_LBRACE] = ACTIONS(1269),
    [anon_sym_COMMA] = ACTIONS(1269),
    [anon_sym_RBRACE] = ACTIONS(1269),
    [anon_sym_constant] = ACTIONS(1267),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [anon_sym_indexed] = ACTIONS(1267),
    [anon_sym_COLON] = ACTIONS(1269),
    [anon_sym_DOT] = ACTIONS(1269),
    [sym_unchecked] = ACTIONS(1267),
    [anon_sym_memory] = ACTIONS(1267),
    [anon_sym_storage] = ACTIONS(1267),
    [anon_sym_calldata] = ACTIONS(1267),
    [anon_sym_returns] = ACTIONS(1267),
    [anon_sym_public] = ACTIONS(1267),
    [anon_sym_internal] = ACTIONS(1267),
    [anon_sym_private] = ACTIONS(1267),
    [anon_sym_external] = ACTIONS(1267),
    [anon_sym_pure] = ACTIONS(1267),
    [anon_sym_view] = ACTIONS(1267),
    [anon_sym_payable] = ACTIONS(1267),
    [sym_immutable] = ACTIONS(1267),
    [anon_sym_override] = ACTIONS(1267),
    [sym_virtual] = ACTIONS(1267),
    [anon_sym_QMARK] = ACTIONS(1269),
    [anon_sym_LBRACK] = ACTIONS(1269),
    [anon_sym_RBRACK] = ACTIONS(1269),
    [anon_sym_AMP_AMP] = ACTIONS(1269),
    [anon_sym_GT_GT] = ACTIONS(1267),
    [anon_sym_GT_GT_GT] = ACTIONS(1267),
    [anon_sym_LT_LT] = ACTIONS(1267),
    [anon_sym_AMP] = ACTIONS(1267),
    [anon_sym_PIPE] = ACTIONS(1267),
    [anon_sym_PLUS] = ACTIONS(1267),
    [anon_sym_SLASH] = ACTIONS(1267),
    [anon_sym_PERCENT] = ACTIONS(1267),
    [anon_sym_STAR_STAR] = ACTIONS(1269),
    [anon_sym_EQ_EQ] = ACTIONS(1269),
    [anon_sym_BANG_EQ] = ACTIONS(1267),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1269),
    [anon_sym_PLUS_PLUS] = ACTIONS(1269),
    [anon_sym_DASH_DASH] = ACTIONS(1269),
    [anon_sym_PLUS_EQ] = ACTIONS(1269),
    [anon_sym_DASH_EQ] = ACTIONS(1269),
    [anon_sym_STAR_EQ] = ACTIONS(1269),
    [anon_sym_SLASH_EQ] = ACTIONS(1269),
    [anon_sym_PERCENT_EQ] = ACTIONS(1269),
    [anon_sym_CARET_EQ] = ACTIONS(1269),
    [anon_sym_AMP_EQ] = ACTIONS(1269),
    [anon_sym_PIPE_EQ] = ACTIONS(1269),
    [anon_sym_GT_GT_EQ] = ACTIONS(1269),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1269),
    [anon_sym_LT_LT_EQ] = ACTIONS(1269),
    [sym__semicolon] = ACTIONS(1269),
    [sym_comment] = ACTIONS(3),
  },
  [312] = {
    [sym_identifier] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1271),
    [anon_sym_LT_EQ] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_CARET] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_EQ] = ACTIONS(1271),
    [anon_sym_STAR] = ACTIONS(1271),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_constant] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_indexed] = ACTIONS(1271),
    [anon_sym_COLON] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1273),
    [sym_unchecked] = ACTIONS(1271),
    [anon_sym_memory] = ACTIONS(1271),
    [anon_sym_storage] = ACTIONS(1271),
    [anon_sym_calldata] = ACTIONS(1271),
    [anon_sym_returns] = ACTIONS(1271),
    [anon_sym_public] = ACTIONS(1271),
    [anon_sym_internal] = ACTIONS(1271),
    [anon_sym_private] = ACTIONS(1271),
    [anon_sym_external] = ACTIONS(1271),
    [anon_sym_pure] = ACTIONS(1271),
    [anon_sym_view] = ACTIONS(1271),
    [anon_sym_payable] = ACTIONS(1271),
    [sym_immutable] = ACTIONS(1271),
    [anon_sym_override] = ACTIONS(1271),
    [sym_virtual] = ACTIONS(1271),
    [anon_sym_QMARK] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_GT_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_PLUS] = ACTIONS(1271),
    [anon_sym_SLASH] = ACTIONS(1271),
    [anon_sym_PERCENT] = ACTIONS(1271),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_BANG_EQ] = ACTIONS(1271),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1273),
    [anon_sym_PLUS_PLUS] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [sym__semicolon] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_identifier] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1277),
    [anon_sym_DASH] = ACTIONS(1275),
    [anon_sym_LT_EQ] = ACTIONS(1277),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1277),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(1277),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_constant] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_RPAREN] = ACTIONS(1277),
    [anon_sym_indexed] = ACTIONS(1275),
    [anon_sym_COLON] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1277),
    [sym_unchecked] = ACTIONS(1275),
    [anon_sym_memory] = ACTIONS(1275),
    [anon_sym_storage] = ACTIONS(1275),
    [anon_sym_calldata] = ACTIONS(1275),
    [anon_sym_returns] = ACTIONS(1275),
    [anon_sym_public] = ACTIONS(1275),
    [anon_sym_internal] = ACTIONS(1275),
    [anon_sym_private] = ACTIONS(1275),
    [anon_sym_external] = ACTIONS(1275),
    [anon_sym_pure] = ACTIONS(1275),
    [anon_sym_view] = ACTIONS(1275),
    [anon_sym_payable] = ACTIONS(1275),
    [sym_immutable] = ACTIONS(1275),
    [anon_sym_override] = ACTIONS(1275),
    [sym_virtual] = ACTIONS(1275),
    [anon_sym_QMARK] = ACTIONS(1277),
    [anon_sym_LBRACK] = ACTIONS(1277),
    [anon_sym_RBRACK] = ACTIONS(1277),
    [anon_sym_AMP_AMP] = ACTIONS(1277),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_GT_GT_GT] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_EQ_EQ] = ACTIONS(1277),
    [anon_sym_BANG_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_PLUS_EQ] = ACTIONS(1277),
    [anon_sym_DASH_EQ] = ACTIONS(1277),
    [anon_sym_STAR_EQ] = ACTIONS(1277),
    [anon_sym_SLASH_EQ] = ACTIONS(1277),
    [anon_sym_PERCENT_EQ] = ACTIONS(1277),
    [anon_sym_CARET_EQ] = ACTIONS(1277),
    [anon_sym_AMP_EQ] = ACTIONS(1277),
    [anon_sym_PIPE_EQ] = ACTIONS(1277),
    [anon_sym_GT_GT_EQ] = ACTIONS(1277),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1277),
    [anon_sym_LT_LT_EQ] = ACTIONS(1277),
    [sym__semicolon] = ACTIONS(1277),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_identifier] = ACTIONS(1279),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_LT_EQ] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1279),
    [anon_sym_CARET] = ACTIONS(1279),
    [anon_sym_GT] = ACTIONS(1279),
    [anon_sym_GT_EQ] = ACTIONS(1281),
    [anon_sym_EQ] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_LBRACE] = ACTIONS(1281),
    [anon_sym_COMMA] = ACTIONS(1281),
    [anon_sym_RBRACE] = ACTIONS(1281),
    [anon_sym_constant] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_RPAREN] = ACTIONS(1281),
    [anon_sym_indexed] = ACTIONS(1279),
    [anon_sym_COLON] = ACTIONS(1281),
    [anon_sym_DOT] = ACTIONS(1281),
    [sym_unchecked] = ACTIONS(1279),
    [anon_sym_memory] = ACTIONS(1279),
    [anon_sym_storage] = ACTIONS(1279),
    [anon_sym_calldata] = ACTIONS(1279),
    [anon_sym_returns] = ACTIONS(1279),
    [anon_sym_public] = ACTIONS(1279),
    [anon_sym_internal] = ACTIONS(1279),
    [anon_sym_private] = ACTIONS(1279),
    [anon_sym_external] = ACTIONS(1279),
    [anon_sym_pure] = ACTIONS(1279),
    [anon_sym_view] = ACTIONS(1279),
    [anon_sym_payable] = ACTIONS(1279),
    [sym_immutable] = ACTIONS(1279),
    [anon_sym_override] = ACTIONS(1279),
    [sym_virtual] = ACTIONS(1279),
    [anon_sym_QMARK] = ACTIONS(1281),
    [anon_sym_LBRACK] = ACTIONS(1281),
    [anon_sym_RBRACK] = ACTIONS(1281),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1279),
    [anon_sym_GT_GT_GT] = ACTIONS(1279),
    [anon_sym_LT_LT] = ACTIONS(1279),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_PIPE] = ACTIONS(1279),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_SLASH] = ACTIONS(1279),
    [anon_sym_PERCENT] = ACTIONS(1279),
    [anon_sym_STAR_STAR] = ACTIONS(1281),
    [anon_sym_EQ_EQ] = ACTIONS(1281),
    [anon_sym_BANG_EQ] = ACTIONS(1279),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1281),
    [anon_sym_PLUS_PLUS] = ACTIONS(1281),
    [anon_sym_DASH_DASH] = ACTIONS(1281),
    [anon_sym_PLUS_EQ] = ACTIONS(1281),
    [anon_sym_DASH_EQ] = ACTIONS(1281),
    [anon_sym_STAR_EQ] = ACTIONS(1281),
    [anon_sym_SLASH_EQ] = ACTIONS(1281),
    [anon_sym_PERCENT_EQ] = ACTIONS(1281),
    [anon_sym_CARET_EQ] = ACTIONS(1281),
    [anon_sym_AMP_EQ] = ACTIONS(1281),
    [anon_sym_PIPE_EQ] = ACTIONS(1281),
    [anon_sym_GT_GT_EQ] = ACTIONS(1281),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1281),
    [anon_sym_LT_LT_EQ] = ACTIONS(1281),
    [sym__semicolon] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1283),
    [anon_sym_GT_EQ] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1283),
    [anon_sym_STAR] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1285),
    [anon_sym_RBRACE] = ACTIONS(1285),
    [anon_sym_constant] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_indexed] = ACTIONS(1283),
    [anon_sym_COLON] = ACTIONS(1285),
    [anon_sym_DOT] = ACTIONS(1285),
    [sym_unchecked] = ACTIONS(1283),
    [anon_sym_memory] = ACTIONS(1283),
    [anon_sym_storage] = ACTIONS(1283),
    [anon_sym_calldata] = ACTIONS(1283),
    [anon_sym_returns] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1283),
    [anon_sym_internal] = ACTIONS(1283),
    [anon_sym_private] = ACTIONS(1283),
    [anon_sym_external] = ACTIONS(1283),
    [anon_sym_pure] = ACTIONS(1283),
    [anon_sym_view] = ACTIONS(1283),
    [anon_sym_payable] = ACTIONS(1283),
    [sym_immutable] = ACTIONS(1283),
    [anon_sym_override] = ACTIONS(1283),
    [sym_virtual] = ACTIONS(1283),
    [anon_sym_QMARK] = ACTIONS(1285),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [anon_sym_RBRACK] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_GT_GT_GT] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1283),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_PERCENT] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1283),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_PLUS_EQ] = ACTIONS(1285),
    [anon_sym_DASH_EQ] = ACTIONS(1285),
    [anon_sym_STAR_EQ] = ACTIONS(1285),
    [anon_sym_SLASH_EQ] = ACTIONS(1285),
    [anon_sym_PERCENT_EQ] = ACTIONS(1285),
    [anon_sym_CARET_EQ] = ACTIONS(1285),
    [anon_sym_AMP_EQ] = ACTIONS(1285),
    [anon_sym_PIPE_EQ] = ACTIONS(1285),
    [anon_sym_GT_GT_EQ] = ACTIONS(1285),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1285),
    [anon_sym_LT_LT_EQ] = ACTIONS(1285),
    [sym__semicolon] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
  },
  [316] = {
    [sym_identifier] = ACTIONS(1287),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_DASH] = ACTIONS(1287),
    [anon_sym_LT_EQ] = ACTIONS(1289),
    [anon_sym_LT] = ACTIONS(1287),
    [anon_sym_CARET] = ACTIONS(1287),
    [anon_sym_GT] = ACTIONS(1287),
    [anon_sym_GT_EQ] = ACTIONS(1289),
    [anon_sym_EQ] = ACTIONS(1287),
    [anon_sym_STAR] = ACTIONS(1287),
    [anon_sym_LBRACE] = ACTIONS(1289),
    [anon_sym_COMMA] = ACTIONS(1289),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_constant] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1289),
    [anon_sym_RPAREN] = ACTIONS(1289),
    [anon_sym_indexed] = ACTIONS(1287),
    [anon_sym_COLON] = ACTIONS(1289),
    [anon_sym_DOT] = ACTIONS(1289),
    [sym_unchecked] = ACTIONS(1287),
    [anon_sym_memory] = ACTIONS(1287),
    [anon_sym_storage] = ACTIONS(1287),
    [anon_sym_calldata] = ACTIONS(1287),
    [anon_sym_returns] = ACTIONS(1287),
    [anon_sym_public] = ACTIONS(1287),
    [anon_sym_internal] = ACTIONS(1287),
    [anon_sym_private] = ACTIONS(1287),
    [anon_sym_external] = ACTIONS(1287),
    [anon_sym_pure] = ACTIONS(1287),
    [anon_sym_view] = ACTIONS(1287),
    [anon_sym_payable] = ACTIONS(1287),
    [sym_immutable] = ACTIONS(1287),
    [anon_sym_override] = ACTIONS(1287),
    [sym_virtual] = ACTIONS(1287),
    [anon_sym_QMARK] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_RBRACK] = ACTIONS(1289),
    [anon_sym_AMP_AMP] = ACTIONS(1289),
    [anon_sym_GT_GT] = ACTIONS(1287),
    [anon_sym_GT_GT_GT] = ACTIONS(1287),
    [anon_sym_LT_LT] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_PIPE] = ACTIONS(1287),
    [anon_sym_PLUS] = ACTIONS(1287),
    [anon_sym_SLASH] = ACTIONS(1287),
    [anon_sym_PERCENT] = ACTIONS(1287),
    [anon_sym_STAR_STAR] = ACTIONS(1289),
    [anon_sym_EQ_EQ] = ACTIONS(1289),
    [anon_sym_BANG_EQ] = ACTIONS(1287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1289),
    [anon_sym_PLUS_PLUS] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1289),
    [anon_sym_PLUS_EQ] = ACTIONS(1289),
    [anon_sym_DASH_EQ] = ACTIONS(1289),
    [anon_sym_STAR_EQ] = ACTIONS(1289),
    [anon_sym_SLASH_EQ] = ACTIONS(1289),
    [anon_sym_PERCENT_EQ] = ACTIONS(1289),
    [anon_sym_CARET_EQ] = ACTIONS(1289),
    [anon_sym_AMP_EQ] = ACTIONS(1289),
    [anon_sym_PIPE_EQ] = ACTIONS(1289),
    [anon_sym_GT_GT_EQ] = ACTIONS(1289),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1289),
    [anon_sym_LT_LT_EQ] = ACTIONS(1289),
    [sym__semicolon] = ACTIONS(1289),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1295), 1,
      anon_sym_payable,
    ACTIONS(1291), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1293), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      sym__semicolon,
  [72] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1297), 30,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      anon_sym_for,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1299), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      sym__semicolon,
  [142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1291), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1293), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      sym__semicolon,
  [211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1301), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1303), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_EQ_GT,
      sym__semicolon,
  [280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1305), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1307), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1309), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1311), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1313), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1315), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1317), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1319), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1321), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1323), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1325), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1327), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1329), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1331), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1333), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1335), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1337), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1339), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [892] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1341), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1343), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1345), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1347), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1351), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1351), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1164] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(399), 1,
      sym_number_unit,
    ACTIONS(1357), 11,
      anon_sym_wei,
      anon_sym_szabo,
      anon_sym_finney,
      anon_sym_gwei,
      anon_sym_ether,
      anon_sym_seconds,
      anon_sym_minutes,
      anon_sym_hours,
      anon_sym_days,
      anon_sym_weeks,
      anon_sym_years,
    ACTIONS(1355), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1353), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1359), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1361), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1236), 29,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_constant,
      anon_sym_indexed,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1238), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1363), 27,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1365), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1438] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1367), 27,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1369), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 27,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1373), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1375), 27,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1377), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(307), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1379), 21,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1381), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1106), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1108), 38,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_case,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [1760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1144), 38,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_as,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_default,
      anon_sym_case,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [1821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 1,
      anon_sym_DOT,
    STATE(341), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1383), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1388), 17,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1385), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1398), 17,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1395), 31,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [1950] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1405), 1,
      anon_sym_DQUOTE,
    ACTIONS(1408), 1,
      anon_sym_SQUOTE,
    STATE(346), 2,
      sym_string,
      aux_sym_string_literal_repeat1,
    ACTIONS(1403), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1401), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_SQUOTE,
    STATE(346), 2,
      sym_string,
      aux_sym_string_literal_repeat1,
    ACTIONS(1413), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1411), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1419), 1,
      anon_sym_hex,
    STATE(348), 1,
      aux_sym_hex_string_literal_repeat2,
    ACTIONS(1417), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1415), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_hex,
    STATE(348), 1,
      aux_sym_hex_string_literal_repeat2,
    ACTIONS(1424), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1422), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2206] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_unicode,
    STATE(350), 1,
      aux_sym_unicode_string_literal_repeat3,
    ACTIONS(1430), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1428), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 1,
      anon_sym_unicode,
    STATE(350), 1,
      aux_sym_unicode_string_literal_repeat3,
    ACTIONS(1437), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1435), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1443), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1441), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2395] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1443), 4,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1441), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1461), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1459), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_unicode,
  [2525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1465), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1463), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_hex,
  [2582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_LPAREN,
    STATE(397), 1,
      sym__call_arguments,
    ACTIONS(1469), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1467), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2643] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1478), 1,
      anon_sym_EQ,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1480), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1488), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1486), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2785] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1492), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1490), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    STATE(391), 1,
      sym__call_arguments,
    ACTIONS(1496), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1494), 32,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1443), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1441), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [2972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1502), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1500), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_hex,
  [3029] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1508), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_RBRACK,
      sym__semicolon,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [3120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1518), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_unicode,
  [3177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1524), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1522), 34,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
      anon_sym_hex,
  [3234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1492), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1490), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3297] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1443), 3,
      anon_sym_CARET,
      anon_sym_EQ,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1441), 24,
      anon_sym_PIPE_PIPE,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3374] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1443), 9,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_BANG_EQ,
    ACTIONS(1441), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3441] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1443), 7,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_BANG_EQ,
    ACTIONS(1441), 29,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3510] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1526), 8,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_RBRACK,
      sym__semicolon,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [3601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1492), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1490), 30,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1530), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1528), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1534), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1532), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1536), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1540), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1544), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [3944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1548), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1552), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1556), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1566), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1564), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1568), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4280] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1572), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1578), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1576), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1580), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1584), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1590), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1588), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1594), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1592), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1598), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1596), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1602), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1600), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1606), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1604), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1608), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1614), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1612), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1616), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [4952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1622), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1620), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1626), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1624), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1628), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1634), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1632), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1638), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1636), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5232] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_LPAREN,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    STATE(397), 1,
      sym__call_arguments,
    ACTIONS(1345), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1469), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1467), 26,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1645), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1643), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1649), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1647), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1651), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1655), 33,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 1,
      anon_sym_LBRACK,
    ACTIONS(1345), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1469), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1467), 27,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5579] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 1,
      anon_sym_DOT,
    ACTIONS(1659), 1,
      anon_sym_COLON,
    STATE(341), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1383), 4,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      sym_identifier,
    ACTIONS(1388), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1385), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5642] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1661), 1,
      anon_sym_LPAREN,
    ACTIONS(1291), 19,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
      sym_identifier,
    ACTIONS(1293), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [5697] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1663), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      sym_unchecked,
    ACTIONS(1667), 1,
      anon_sym_returns,
    STATE(396), 1,
      sym__call_arguments,
    STATE(549), 1,
      sym_block_statement,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [5787] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1669), 1,
      anon_sym_COMMA,
    ACTIONS(1671), 1,
      anon_sym_RBRACK,
    STATE(396), 1,
      sym__call_arguments,
    STATE(621), 1,
      aux_sym_inline_array_expression_repeat1,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [5877] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1673), 1,
      anon_sym_COMMA,
    ACTIONS(1675), 1,
      anon_sym_RPAREN,
    STATE(396), 1,
      sym__call_arguments,
    STATE(600), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [5967] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1673), 1,
      anon_sym_COMMA,
    ACTIONS(1675), 1,
      anon_sym_RPAREN,
    STATE(396), 1,
      sym__call_arguments,
    STATE(600), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(393), 1,
      anon_sym_catch,
    ACTIONS(1550), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1548), 27,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      sym_unchecked,
      anon_sym_returns,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6110] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1677), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6195] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1679), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6280] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1681), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6365] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1683), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6450] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1685), 1,
      anon_sym_COLON,
    ACTIONS(1687), 1,
      anon_sym_RBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6537] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1689), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6622] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1691), 1,
      sym__semicolon,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6706] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1693), 1,
      anon_sym_RPAREN,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6790] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1695), 1,
      sym__semicolon,
    STATE(436), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6874] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1697), 1,
      anon_sym_COLON,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [6958] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1699), 1,
      anon_sym_RBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7042] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1701), 1,
      sym__semicolon,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7126] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1703), 1,
      sym__semicolon,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7210] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1705), 1,
      sym__semicolon,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7294] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1707), 1,
      anon_sym_RPAREN,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7378] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1709), 1,
      sym__semicolon,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7462] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1711), 1,
      anon_sym_RPAREN,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7546] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1713), 1,
      sym__semicolon,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7630] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1715), 1,
      anon_sym_RPAREN,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7714] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1717), 1,
      anon_sym_RBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7798] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    ACTIONS(1719), 1,
      anon_sym_RBRACK,
    STATE(396), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1721), 1,
      anon_sym_EQ,
    ACTIONS(1590), 14,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1588), 26,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [7933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1369), 1,
      sym__semicolon,
    ACTIONS(1578), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1576), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [7984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1723), 1,
      sym__semicolon,
    ACTIONS(1626), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1624), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1725), 1,
      sym__semicolon,
    ACTIONS(1626), 15,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_EQ,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1624), 25,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 1,
      anon_sym_EQ,
    ACTIONS(1578), 14,
      anon_sym_DASH,
      anon_sym_LT,
      anon_sym_CARET,
      anon_sym_GT,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_BANG_EQ,
    ACTIONS(1576), 26,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      sym__semicolon,
  [8137] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    ACTIONS(1447), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1474), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(1482), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1484), 1,
      anon_sym_AMP,
    ACTIONS(1504), 1,
      anon_sym_EQ,
    ACTIONS(1506), 1,
      anon_sym_LBRACE,
    ACTIONS(1510), 1,
      anon_sym_DOT,
    ACTIONS(1512), 1,
      anon_sym_QMARK,
    ACTIONS(1514), 1,
      anon_sym_LBRACK,
    STATE(437), 1,
      sym__call_arguments,
    ACTIONS(1449), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1451), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1476), 2,
      anon_sym_CARET,
      anon_sym_PIPE,
    ACTIONS(1455), 3,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG_EQ,
    ACTIONS(1453), 4,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
    ACTIONS(1457), 6,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(1516), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
  [8218] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_DOT,
    STATE(307), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1381), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      sym__semicolon,
    ACTIONS(1379), 18,
      anon_sym_constant,
      anon_sym_indexed,
      anon_sym_for,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1729), 1,
      anon_sym_DOT,
    STATE(440), 1,
      aux_sym__identifier_path_repeat1,
    ACTIONS(1731), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_EQ_GT,
      sym__semicolon,
    ACTIONS(1383), 18,
      anon_sym_constant,
      anon_sym_indexed,
      anon_sym_for,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8296] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1240), 1,
      anon_sym_returns,
    ACTIONS(1265), 1,
      anon_sym_LBRACK,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(1735), 1,
      anon_sym_override,
    ACTIONS(1737), 1,
      sym_virtual,
    ACTIONS(1739), 1,
      sym__semicolon,
    STATE(198), 1,
      sym_function_body,
    STATE(306), 1,
      aux_sym__function_type_repeat1,
    STATE(336), 1,
      sym__return_parameters,
    STATE(456), 1,
      sym__identifier_path,
    ACTIONS(1263), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(452), 2,
      sym_visibility,
      sym_state_mutability,
    ACTIONS(1244), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    STATE(448), 3,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
    ACTIONS(1242), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [8357] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1735), 1,
      anon_sym_override,
    ACTIONS(1741), 1,
      anon_sym_LBRACE,
    ACTIONS(1743), 1,
      anon_sym_returns,
    ACTIONS(1745), 1,
      sym_virtual,
    ACTIONS(1747), 1,
      sym__semicolon,
    STATE(170), 1,
      sym_function_body,
    STATE(456), 1,
      sym__identifier_path,
    STATE(568), 1,
      sym_return_type_definition,
    ACTIONS(1244), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1242), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(444), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8406] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1735), 1,
      anon_sym_override,
    ACTIONS(1741), 1,
      anon_sym_LBRACE,
    ACTIONS(1743), 1,
      anon_sym_returns,
    ACTIONS(1749), 1,
      sym_virtual,
    ACTIONS(1751), 1,
      sym__semicolon,
    STATE(157), 1,
      sym_function_body,
    STATE(456), 1,
      sym__identifier_path,
    STATE(592), 1,
      sym_return_type_definition,
    ACTIONS(1244), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1242), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(449), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8455] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(1735), 1,
      anon_sym_override,
    ACTIONS(1743), 1,
      anon_sym_returns,
    ACTIONS(1753), 1,
      sym_virtual,
    ACTIONS(1755), 1,
      sym__semicolon,
    STATE(203), 1,
      sym_function_body,
    STATE(456), 1,
      sym__identifier_path,
    STATE(551), 1,
      sym_return_type_definition,
    ACTIONS(1244), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1242), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(446), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8504] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(1735), 1,
      anon_sym_override,
    ACTIONS(1743), 1,
      anon_sym_returns,
    ACTIONS(1749), 1,
      sym_virtual,
    ACTIONS(1757), 1,
      sym__semicolon,
    STATE(176), 1,
      sym_function_body,
    STATE(456), 1,
      sym__identifier_path,
    STATE(546), 1,
      sym_return_type_definition,
    ACTIONS(1244), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1242), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(449), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8553] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(1735), 1,
      anon_sym_override,
    ACTIONS(1737), 1,
      sym_virtual,
    ACTIONS(1739), 1,
      sym__semicolon,
    STATE(198), 1,
      sym_function_body,
    STATE(456), 1,
      sym__identifier_path,
    ACTIONS(1244), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1242), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(448), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
  [8596] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(1735), 1,
      anon_sym_override,
    ACTIONS(1759), 1,
      sym_virtual,
    ACTIONS(1761), 1,
      sym__semicolon,
    STATE(188), 1,
      sym_function_body,
    STATE(456), 1,
      sym__identifier_path,
    ACTIONS(1244), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1242), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(450), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
  [8639] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1763), 1,
      sym_identifier,
    ACTIONS(1768), 1,
      anon_sym_returns,
    ACTIONS(1776), 1,
      anon_sym_override,
    ACTIONS(1779), 1,
      sym_virtual,
    STATE(456), 1,
      sym__identifier_path,
    ACTIONS(1766), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1773), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1770), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(449), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_function_definition_repeat1,
  [8680] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1782), 1,
      sym_identifier,
    ACTIONS(1793), 1,
      anon_sym_override,
    ACTIONS(1796), 1,
      sym_virtual,
    STATE(456), 1,
      sym__identifier_path,
    ACTIONS(1785), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1790), 3,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
    ACTIONS(1787), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
    STATE(450), 5,
      sym_visibility,
      sym_state_mutability,
      sym_override_specifier,
      sym_modifier_invocation,
      aux_sym_fallback_receive_definition_repeat1,
  [8718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1803), 1,
      anon_sym_LPAREN,
    ACTIONS(1801), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1799), 13,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8744] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1812), 1,
      sym_virtual,
    ACTIONS(1814), 1,
      anon_sym_LBRACK,
    ACTIONS(1808), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1810), 3,
      anon_sym_constant,
      anon_sym_returns,
      sym_immutable,
    ACTIONS(1805), 9,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_identifier,
  [8774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1818), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1816), 13,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1822), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1820), 13,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1824), 13,
      anon_sym_constant,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      sym_immutable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    STATE(457), 1,
      sym__call_arguments,
    ACTIONS(1830), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1828), 11,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1834), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    ACTIONS(1832), 11,
      anon_sym_returns,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      anon_sym_pure,
      anon_sym_view,
      anon_sym_payable,
      anon_sym_override,
      sym_virtual,
      sym_identifier,
  [8891] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 1,
      sym_solidity_version,
    ACTIONS(1842), 1,
      sym__semicolon,
    STATE(461), 1,
      aux_sym_solidity_pragma_token_repeat1,
    STATE(462), 1,
      sym__pragma_version_constraint,
    STATE(792), 1,
      sym_solidity_version_comparison_operator,
    ACTIONS(1840), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1838), 5,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
  [8921] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1844), 1,
      sym_solidity_version,
    ACTIONS(1853), 1,
      sym__semicolon,
    STATE(459), 1,
      aux_sym_solidity_pragma_token_repeat1,
    STATE(462), 1,
      sym__pragma_version_constraint,
    STATE(792), 1,
      sym_solidity_version_comparison_operator,
    ACTIONS(1850), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1847), 5,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
  [8951] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1735), 1,
      anon_sym_override,
    ACTIONS(1855), 1,
      sym_identifier,
    STATE(473), 1,
      sym_visibility,
    ACTIONS(1857), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(465), 2,
      sym_override_specifier,
      aux_sym_state_variable_declaration_repeat1,
    ACTIONS(1242), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [8981] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 1,
      sym_solidity_version,
    ACTIONS(1859), 1,
      sym__semicolon,
    STATE(459), 1,
      aux_sym_solidity_pragma_token_repeat1,
    STATE(462), 1,
      sym__pragma_version_constraint,
    STATE(792), 1,
      sym_solidity_version_comparison_operator,
    ACTIONS(1840), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1838), 5,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
  [9011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH,
    ACTIONS(1865), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1863), 7,
      sym_solidity_version,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
      sym__semicolon,
  [9032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1867), 9,
      anon_sym_PIPE_PIPE,
      anon_sym_DASH,
      sym_solidity_version,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
      sym__semicolon,
  [9051] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      sym_identifier,
    ACTIONS(1879), 1,
      anon_sym_override,
    STATE(473), 1,
      sym_visibility,
    ACTIONS(1873), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(464), 2,
      sym_override_specifier,
      aux_sym_state_variable_declaration_repeat1,
    ACTIONS(1876), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [9078] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 1,
      anon_sym_override,
    ACTIONS(1882), 1,
      sym_identifier,
    STATE(473), 1,
      sym_visibility,
    ACTIONS(1884), 2,
      anon_sym_constant,
      sym_immutable,
    STATE(464), 2,
      sym_override_specifier,
      aux_sym_state_variable_declaration_repeat1,
    ACTIONS(1242), 4,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
  [9105] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_SQUOTE,
    ACTIONS(1886), 1,
      sym_identifier,
    ACTIONS(1888), 1,
      anon_sym_STAR,
    ACTIONS(1890), 1,
      anon_sym_LBRACE,
    STATE(607), 1,
      sym_string,
    STATE(710), 1,
      sym__import_clause,
    STATE(771), 1,
      sym__multiple_import,
    STATE(774), 1,
      sym__single_import,
    STATE(775), 1,
      sym__source_import,
  [9139] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_SQUOTE,
    ACTIONS(1892), 1,
      sym_yul_decimal_number,
    ACTIONS(1894), 1,
      sym_yul_hex_number,
    STATE(242), 1,
      sym_string,
    ACTIONS(1896), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(690), 3,
      sym__yul_literal,
      sym_yul_string_literal,
      sym_yul_boolean,
  [9167] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    STATE(194), 1,
      sym_function_body,
    STATE(456), 1,
      sym__identifier_path,
    STATE(469), 2,
      sym_modifier_invocation,
      aux_sym_constructor_definition_repeat1,
    ACTIONS(1898), 3,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_payable,
  [9192] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    STATE(197), 1,
      sym_function_body,
    STATE(456), 1,
      sym__identifier_path,
    STATE(472), 2,
      sym_modifier_invocation,
      aux_sym_constructor_definition_repeat1,
    ACTIONS(1900), 3,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_payable,
  [9217] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    ACTIONS(1904), 1,
      anon_sym_override,
    ACTIONS(1906), 1,
      sym_virtual,
    ACTIONS(1908), 1,
      sym__semicolon,
    STATE(201), 1,
      sym_function_body,
    STATE(477), 1,
      sym__parameter_list,
    STATE(475), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1912), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1910), 7,
      sym_solidity_version,
      anon_sym_LT_EQ,
      anon_sym_CARET,
      anon_sym_GT_EQ,
      anon_sym_TILDE,
      anon_sym_EQ,
      sym__semicolon,
  [9263] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      sym_identifier,
    ACTIONS(1917), 1,
      anon_sym_LBRACE,
    STATE(456), 1,
      sym__identifier_path,
    STATE(472), 2,
      sym_modifier_invocation,
      aux_sym_constructor_definition_repeat1,
    ACTIONS(1919), 3,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_payable,
  [9285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 8,
      anon_sym_constant,
      anon_sym_public,
      anon_sym_internal,
      anon_sym_private,
      anon_sym_external,
      sym_immutable,
      anon_sym_override,
      sym_identifier,
  [9299] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1924), 1,
      sym_identifier,
    STATE(565), 1,
      sym__storage_location,
    ACTIONS(1926), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1928), 3,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
  [9321] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(1904), 1,
      anon_sym_override,
    ACTIONS(1930), 1,
      sym_virtual,
    ACTIONS(1932), 1,
      sym__semicolon,
    STATE(192), 1,
      sym_function_body,
    STATE(480), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9344] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(1904), 1,
      anon_sym_override,
    ACTIONS(1930), 1,
      sym_virtual,
    ACTIONS(1934), 1,
      sym__semicolon,
    STATE(206), 1,
      sym_function_body,
    STATE(480), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9367] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(1904), 1,
      anon_sym_override,
    ACTIONS(1932), 1,
      sym__semicolon,
    ACTIONS(1936), 1,
      sym_virtual,
    STATE(192), 1,
      sym_function_body,
    STATE(476), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9390] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    STATE(674), 1,
      sym__storage_location,
    ACTIONS(1938), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1940), 3,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
  [9409] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym_unchecked,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    ACTIONS(1942), 1,
      sym_identifier,
    STATE(79), 1,
      sym_block_statement,
    STATE(633), 1,
      sym__parameter_list,
  [9431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1946), 1,
      anon_sym_override,
    ACTIONS(1949), 1,
      sym_virtual,
    ACTIONS(1944), 2,
      anon_sym_LBRACE,
      sym__semicolon,
    STATE(480), 2,
      sym_override_specifier,
      aux_sym_modifier_definition_repeat1,
  [9449] = 5,
    ACTIONS(1952), 1,
      anon_sym_SQUOTE,
    ACTIONS(1954), 1,
      sym__escape_sequence,
    ACTIONS(1956), 1,
      aux_sym__single_quoted_unicode_char_token1,
    ACTIONS(1958), 1,
      sym_comment,
    STATE(484), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9466] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1960), 1,
      sym_identifier,
    ACTIONS(1964), 1,
      anon_sym_indexed,
    ACTIONS(1962), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1966), 1,
      sym__hex_digit,
    ACTIONS(1971), 1,
      anon_sym__,
    STATE(483), 1,
      aux_sym_hex_string_literal_repeat1,
    ACTIONS(1969), 2,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
  [9500] = 5,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(1974), 1,
      anon_sym_SQUOTE,
    ACTIONS(1976), 1,
      sym__escape_sequence,
    ACTIONS(1978), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(488), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9517] = 5,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(1974), 1,
      anon_sym_DQUOTE,
    ACTIONS(1980), 1,
      sym__escape_sequence,
    ACTIONS(1982), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(486), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9534] = 5,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_DQUOTE,
    ACTIONS(1986), 1,
      sym__escape_sequence,
    ACTIONS(1989), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(486), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9551] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(1992), 1,
      sym_identifier,
    ACTIONS(1994), 3,
      anon_sym_memory,
      anon_sym_storage,
      anon_sym_calldata,
  [9566] = 5,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(1996), 1,
      anon_sym_SQUOTE,
    ACTIONS(1998), 1,
      sym__escape_sequence,
    ACTIONS(2001), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(488), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9583] = 5,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(1976), 1,
      sym__escape_sequence,
    ACTIONS(1978), 1,
      aux_sym__single_quoted_unicode_char_token1,
    ACTIONS(2004), 1,
      anon_sym_SQUOTE,
    STATE(488), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9600] = 5,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(1980), 1,
      sym__escape_sequence,
    ACTIONS(1982), 1,
      aux_sym__double_quoted_unicode_char_token1,
    ACTIONS(2004), 1,
      anon_sym_DQUOTE,
    STATE(486), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9617] = 5,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2006), 1,
      anon_sym_SQUOTE,
    ACTIONS(2008), 1,
      sym__escape_sequence,
    ACTIONS(2010), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(489), 2,
      sym__string_immediate_elt_inside_quote,
      aux_sym_string_repeat2,
  [9634] = 5,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2006), 1,
      anon_sym_DQUOTE,
    ACTIONS(2012), 1,
      sym__escape_sequence,
    ACTIONS(2014), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(490), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9651] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    ACTIONS(2018), 1,
      anon_sym_LBRACE,
    STATE(318), 1,
      sym__identifier_path,
    STATE(508), 1,
      sym_user_defined_type,
    STATE(683), 1,
      sym_inheritance_specifier,
  [9670] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    STATE(318), 1,
      sym__identifier_path,
    STATE(508), 1,
      sym_user_defined_type,
    STATE(683), 1,
      sym_inheritance_specifier,
  [9689] = 5,
    ACTIONS(1952), 1,
      anon_sym_DQUOTE,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2022), 1,
      sym__escape_sequence,
    ACTIONS(2024), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(485), 2,
      sym__string_immediate_elt_inside_double_quote,
      aux_sym_string_repeat1,
  [9706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2026), 1,
      sym_identifier,
    ACTIONS(2028), 1,
      anon_sym_solidity,
    STATE(458), 1,
      sym__solidity,
    STATE(806), 2,
      sym_solidity_pragma_token,
      sym_any_pragma_token,
  [9723] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_SQUOTE,
    ACTIONS(2030), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_string,
  [9739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2032), 1,
      anon_sym_COMMA,
    STATE(271), 1,
      sym_yul_block,
    STATE(513), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [9755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    STATE(318), 1,
      sym__identifier_path,
    STATE(508), 1,
      sym_user_defined_type,
    STATE(560), 1,
      sym_inheritance_specifier,
  [9771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(282), 1,
      sym_yul_block,
  [9787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2036), 1,
      sym_identifier,
    ACTIONS(2038), 1,
      anon_sym_COMMA,
    ACTIONS(2040), 1,
      anon_sym_RPAREN,
    STATE(553), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [9803] = 4,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2042), 1,
      anon_sym_SQUOTE,
    ACTIONS(2044), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(502), 2,
      sym__single_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat2,
  [9817] = 4,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2047), 1,
      anon_sym_DQUOTE,
    ACTIONS(2049), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(503), 2,
      sym__double_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat1,
  [9831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2052), 4,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      sym__semicolon,
  [9841] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 1,
      sym__hex_digit,
    ACTIONS(2056), 1,
      anon_sym__,
    ACTIONS(2058), 1,
      anon_sym_SQUOTE,
    STATE(483), 1,
      aux_sym_hex_string_literal_repeat1,
  [9857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2054), 1,
      sym__hex_digit,
    ACTIONS(2056), 1,
      anon_sym__,
    ACTIONS(2058), 1,
      anon_sym_DQUOTE,
    STATE(483), 1,
      aux_sym_hex_string_literal_repeat1,
  [9873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(2060), 1,
      sym_identifier,
    ACTIONS(2062), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [9887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    STATE(723), 1,
      sym__call_arguments,
    ACTIONS(2064), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [9901] = 4,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2066), 1,
      anon_sym_SQUOTE,
    ACTIONS(2068), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(534), 2,
      sym__single_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat2,
  [9915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    ACTIONS(2070), 1,
      anon_sym_RPAREN,
    STATE(318), 1,
      sym__identifier_path,
    STATE(703), 1,
      sym_user_defined_type,
  [9931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2072), 1,
      anon_sym_COMMA,
    STATE(243), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(291), 1,
      sym_yul_block,
  [9947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2074), 1,
      anon_sym_COMMA,
    STATE(270), 1,
      sym_yul_block,
    STATE(511), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [9963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2074), 1,
      anon_sym_COMMA,
    STATE(243), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(270), 1,
      sym_yul_block,
  [9979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(292), 1,
      sym_yul_block,
  [9995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      anon_sym_is,
    STATE(134), 1,
      sym_contract_body,
    STATE(656), 1,
      sym__class_heritage,
  [10011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(270), 1,
      sym_yul_block,
  [10027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2032), 1,
      anon_sym_COMMA,
    STATE(243), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(271), 1,
      sym_yul_block,
  [10043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(291), 1,
      sym_yul_block,
  [10059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_as,
    STATE(664), 1,
      sym__import_alias,
    ACTIONS(2080), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [10073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
    STATE(271), 1,
      sym_yul_block,
  [10089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2084), 1,
      anon_sym_COMMA,
    STATE(282), 1,
      sym_yul_block,
    STATE(517), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [10105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2086), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__semicolon,
  [10115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    ACTIONS(2088), 1,
      anon_sym_RPAREN,
    STATE(318), 1,
      sym__identifier_path,
    STATE(703), 1,
      sym_user_defined_type,
  [10131] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2084), 1,
      anon_sym_COMMA,
    STATE(243), 1,
      aux_sym_yul_variable_declaration_repeat1,
    STATE(282), 1,
      sym_yul_block,
  [10147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    STATE(318), 1,
      sym__identifier_path,
    STATE(508), 1,
      sym_user_defined_type,
    STATE(683), 1,
      sym_inheritance_specifier,
  [10163] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2090), 4,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      sym__semicolon,
  [10173] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_SQUOTE,
    ACTIONS(2092), 1,
      anon_sym_RPAREN,
    STATE(662), 1,
      sym_string,
  [10189] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      anon_sym_is,
    STATE(145), 1,
      sym_contract_body,
    STATE(682), 1,
      sym__class_heritage,
  [10205] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2094), 1,
      anon_sym_LBRACE,
    ACTIONS(2096), 1,
      anon_sym_LPAREN,
    ACTIONS(2098), 1,
      anon_sym_DQUOTEevmasm_DQUOTE,
    STATE(821), 1,
      sym_assembly_flags,
  [10221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2100), 1,
      anon_sym_COMMA,
    STATE(265), 1,
      sym_yul_block,
    STATE(524), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [10237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    ACTIONS(2078), 1,
      anon_sym_is,
    STATE(162), 1,
      sym_contract_body,
    STATE(658), 1,
      sym__class_heritage,
  [10253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_SQUOTE,
    ACTIONS(2102), 1,
      anon_sym_RPAREN,
    STATE(566), 1,
      sym_string,
  [10269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1969), 4,
      sym__hex_digit,
      anon_sym_DQUOTE,
      anon_sym__,
      anon_sym_SQUOTE,
  [10279] = 4,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_SQUOTE,
    ACTIONS(2106), 1,
      aux_sym__single_quoted_unicode_char_token1,
    STATE(502), 2,
      sym__single_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat2,
  [10293] = 4,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2066), 1,
      anon_sym_DQUOTE,
    ACTIONS(2108), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(536), 2,
      sym__double_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat1,
  [10307] = 4,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2104), 1,
      anon_sym_DQUOTE,
    ACTIONS(2110), 1,
      aux_sym__double_quoted_unicode_char_token1,
    STATE(503), 2,
      sym__double_quoted_unicode_char,
      aux_sym_unicode_string_literal_repeat1,
  [10321] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2056), 1,
      anon_sym__,
    ACTIONS(2112), 1,
      sym__hex_digit,
    ACTIONS(2114), 1,
      anon_sym_SQUOTE,
    STATE(505), 1,
      aux_sym_hex_string_literal_repeat1,
  [10337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2056), 1,
      anon_sym__,
    ACTIONS(2114), 1,
      anon_sym_DQUOTE,
    ACTIONS(2116), 1,
      sym__hex_digit,
    STATE(506), 1,
      aux_sym_hex_string_literal_repeat1,
  [10353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2118), 1,
      anon_sym_COMMA,
    ACTIONS(2121), 1,
      anon_sym_RPAREN,
    STATE(539), 1,
      aux_sym_assembly_flags_repeat1,
  [10366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_COMMA,
    ACTIONS(2127), 1,
      anon_sym_RPAREN,
  [10379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(578), 1,
      anon_sym_RPAREN,
    ACTIONS(2129), 1,
      anon_sym_COMMA,
    STATE(635), 1,
      aux_sym_error_declaration_repeat1,
  [10392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 1,
      sym_identifier,
    ACTIONS(2133), 1,
      anon_sym_RBRACE,
    STATE(695), 1,
      sym_call_struct_argument,
  [10405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_COMMA,
    ACTIONS(2137), 1,
      anon_sym_RPAREN,
    STATE(541), 1,
      aux_sym_error_declaration_repeat1,
  [10418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_RBRACE,
    ACTIONS(2139), 1,
      anon_sym_COMMA,
    STATE(624), 1,
      aux_sym_call_argument_repeat1,
  [10431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 1,
      anon_sym_COMMA,
    ACTIONS(2143), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      aux_sym__multiple_import_repeat1,
  [10444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(2145), 1,
      sym__semicolon,
    STATE(209), 1,
      sym_function_body,
  [10457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_RPAREN,
    ACTIONS(2147), 1,
      anon_sym_COMMA,
    STATE(616), 1,
      aux_sym_override_specifier_repeat1,
  [10470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 1,
      anon_sym_COMMA,
    ACTIONS(2152), 1,
      anon_sym_RPAREN,
    STATE(548), 1,
      aux_sym__call_arguments_repeat1,
  [10483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_catch,
    STATE(70), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [10494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2156), 1,
      anon_sym_COMMA,
    ACTIONS(2158), 1,
      anon_sym_RBRACE,
    STATE(645), 1,
      aux_sym_enum_body_repeat1,
  [10507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1733), 1,
      anon_sym_LBRACE,
    ACTIONS(2160), 1,
      sym__semicolon,
    STATE(179), 1,
      sym_function_body,
  [10520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2162), 1,
      anon_sym_COMMA,
    ACTIONS(2164), 1,
      anon_sym_RBRACE,
    STATE(550), 1,
      aux_sym_enum_body_repeat1,
  [10533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_RPAREN,
    ACTIONS(2166), 1,
      anon_sym_COMMA,
    STATE(603), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [10546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2168), 1,
      anon_sym_COMMA,
    ACTIONS(2171), 1,
      anon_sym_RPAREN,
    STATE(554), 1,
      aux_sym__return_parameters_repeat1,
  [10559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_RPAREN,
    ACTIONS(2166), 1,
      anon_sym_COMMA,
    STATE(602), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [10572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    STATE(318), 1,
      sym__identifier_path,
    STATE(764), 1,
      sym_user_defined_type,
  [10585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 1,
      sym_identifier,
    ACTIONS(2175), 1,
      anon_sym_RBRACE,
    STATE(678), 1,
      sym_struct_field_assignment,
  [10598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2177), 1,
      anon_sym_COMMA,
    ACTIONS(2180), 1,
      anon_sym_RBRACE,
    STATE(558), 1,
      aux_sym_struct_expression_repeat1,
  [10611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    ACTIONS(2182), 1,
      sym_identifier,
    STATE(442), 1,
      sym__parameter_list,
  [10624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2184), 1,
      anon_sym_LBRACE,
    ACTIONS(2186), 1,
      anon_sym_COMMA,
    STATE(576), 1,
      aux_sym__class_heritage_repeat1,
  [10637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2188), 1,
      anon_sym_COMMA,
    ACTIONS(2190), 1,
      anon_sym_RPAREN,
    STATE(578), 1,
      aux_sym_error_declaration_repeat1,
  [10650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_RPAREN,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_COMMA,
  [10663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2192), 1,
      anon_sym_COMMA,
    ACTIONS(2194), 1,
      anon_sym_RBRACE,
    STATE(579), 1,
      aux_sym_enum_body_repeat1,
  [10676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_COMMA,
    ACTIONS(2198), 1,
      anon_sym_RPAREN,
    STATE(582), 1,
      aux_sym__event_parameter_list_repeat1,
  [10689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2200), 1,
      sym_identifier,
    ACTIONS(2202), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [10700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2204), 1,
      anon_sym_COMMA,
    ACTIONS(2206), 1,
      anon_sym_RPAREN,
    STATE(594), 1,
      aux_sym_assembly_flags_repeat1,
  [10713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(596), 1,
      anon_sym_RPAREN,
    ACTIONS(2208), 1,
      anon_sym_COMMA,
    STATE(584), 1,
      aux_sym__parameter_list_repeat1,
  [10726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 1,
      anon_sym_LBRACE,
    ACTIONS(2210), 1,
      sym__semicolon,
    STATE(154), 1,
      sym_function_body,
  [10739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(264), 1,
      anon_sym_RPAREN,
    ACTIONS(1673), 1,
      anon_sym_COMMA,
    STATE(639), 1,
      aux_sym_tuple_expression_repeat1,
  [10752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    ACTIONS(2212), 1,
      anon_sym_LPAREN,
    STATE(253), 1,
      sym_yul_identifier,
  [10765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 1,
      sym_identifier,
    ACTIONS(2214), 1,
      anon_sym_RBRACE,
    STATE(626), 1,
      sym_struct_field_assignment,
  [10778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2216), 1,
      sym_identifier,
    ACTIONS(2218), 1,
      anon_sym_RBRACE,
    STATE(714), 1,
      sym__import_declaration,
  [10791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2220), 1,
      anon_sym_COMMA,
    ACTIONS(2223), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      aux_sym__multiple_import_repeat1,
  [10804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 1,
      anon_sym_LPAREN,
    ACTIONS(2225), 1,
      anon_sym_LBRACE,
    STATE(785), 1,
      sym_assembly_flags,
  [10817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_COMMA,
    ACTIONS(2230), 1,
      anon_sym_RPAREN,
    STATE(575), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [10830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2020), 1,
      anon_sym_LBRACE,
    ACTIONS(2232), 1,
      anon_sym_COMMA,
    STATE(629), 1,
      aux_sym__class_heritage_repeat1,
  [10843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 1,
      anon_sym_RPAREN,
    ACTIONS(2234), 1,
      anon_sym_COMMA,
    STATE(575), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [10856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(586), 1,
      anon_sym_RPAREN,
    ACTIONS(2236), 1,
      anon_sym_COMMA,
    STATE(635), 1,
      aux_sym_error_declaration_repeat1,
  [10869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2238), 1,
      anon_sym_COMMA,
    ACTIONS(2240), 1,
      anon_sym_RBRACE,
    STATE(645), 1,
      aux_sym_enum_body_repeat1,
  [10882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2242), 1,
      anon_sym_default,
    ACTIONS(2244), 1,
      anon_sym_case,
    STATE(251), 1,
      aux_sym_yul_switch_statement_repeat1,
  [10895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2246), 1,
      anon_sym_DASH_GT,
    STATE(282), 1,
      sym_yul_block,
  [10908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_RPAREN,
    ACTIONS(2248), 1,
      anon_sym_COMMA,
    STATE(647), 1,
      aux_sym__event_parameter_list_repeat1,
  [10921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2216), 1,
      sym_identifier,
    ACTIONS(2250), 1,
      anon_sym_RBRACE,
    STATE(714), 1,
      sym__import_declaration,
  [10934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 1,
      anon_sym_COMMA,
    ACTIONS(2255), 1,
      anon_sym_RPAREN,
    STATE(584), 1,
      aux_sym__parameter_list_repeat1,
  [10947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    ACTIONS(2257), 1,
      anon_sym_RPAREN,
    STATE(249), 1,
      sym_yul_identifier,
  [10960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2259), 1,
      anon_sym_DASH_GT,
    STATE(265), 1,
      sym_yul_block,
  [10973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2261), 1,
      anon_sym_COMMA,
    ACTIONS(2264), 1,
      anon_sym_RPAREN,
    STATE(587), 1,
      aux_sym_yul_function_call_repeat1,
  [10986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2266), 1,
      anon_sym_COMMA,
    ACTIONS(2268), 1,
      anon_sym_RPAREN,
    STATE(243), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [10999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2270), 1,
      anon_sym_DASH_GT,
    STATE(274), 1,
      sym_yul_block,
  [11012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    ACTIONS(2268), 1,
      anon_sym_RPAREN,
    STATE(249), 1,
      sym_yul_identifier,
  [11025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    STATE(318), 1,
      sym__identifier_path,
    STATE(634), 1,
      sym_user_defined_type,
  [11038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1741), 1,
      anon_sym_LBRACE,
    ACTIONS(2272), 1,
      sym__semicolon,
    STATE(139), 1,
      sym_function_body,
  [11051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    ACTIONS(2274), 1,
      anon_sym_RPAREN,
    STATE(249), 1,
      sym_yul_identifier,
  [11064] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2030), 1,
      anon_sym_RPAREN,
    ACTIONS(2276), 1,
      anon_sym_COMMA,
    STATE(539), 1,
      aux_sym_assembly_flags_repeat1,
  [11077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 1,
      anon_sym_COMMA,
    ACTIONS(2280), 1,
      anon_sym_RPAREN,
    STATE(630), 1,
      aux_sym__return_parameters_repeat1,
  [11090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(2282), 1,
      sym_identifier,
    ACTIONS(2284), 1,
      anon_sym_RPAREN,
  [11103] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    ACTIONS(2286), 1,
      sym_identifier,
    STATE(310), 1,
      sym__parameter_list,
  [11116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2288), 1,
      anon_sym_COMMA,
    ACTIONS(2290), 1,
      anon_sym_RPAREN,
    STATE(567), 1,
      aux_sym__parameter_list_repeat1,
  [11129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      sym_unchecked,
    STATE(81), 1,
      sym_block_statement,
  [11142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(268), 1,
      anon_sym_RPAREN,
    ACTIONS(2292), 1,
      anon_sym_COMMA,
    STATE(639), 1,
      aux_sym_tuple_expression_repeat1,
  [11155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_RPAREN,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 1,
      anon_sym_COMMA,
  [11168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 1,
      anon_sym_RPAREN,
    ACTIONS(2294), 1,
      anon_sym_COMMA,
    STATE(603), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [11181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 1,
      anon_sym_COMMA,
    ACTIONS(2299), 1,
      anon_sym_RPAREN,
    STATE(603), 1,
      aux_sym_variable_declaration_tuple_repeat2,
  [11194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      sym_identifier,
    ACTIONS(2303), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11205] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 1,
      anon_sym_COMMA,
    ACTIONS(2307), 1,
      anon_sym_RBRACE,
    STATE(558), 1,
      aux_sym_struct_expression_repeat1,
  [11218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 1,
      sym_identifier,
    ACTIONS(2307), 1,
      anon_sym_RBRACE,
    STATE(678), 1,
      sym_struct_field_assignment,
  [11231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_as,
    ACTIONS(2309), 1,
      sym__semicolon,
    STATE(822), 1,
      sym__import_alias,
  [11244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      sym_unchecked,
    STATE(643), 1,
      sym_block_statement,
  [11257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_SQUOTE,
    STATE(662), 1,
      sym_string,
  [11270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 1,
      anon_sym_RBRACK,
    ACTIONS(2311), 1,
      anon_sym_COMMA,
    STATE(610), 1,
      aux_sym_inline_array_expression_repeat1,
  [11283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_as,
    ACTIONS(2314), 1,
      anon_sym_from,
    STATE(793), 1,
      sym__import_alias,
  [11296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2216), 1,
      sym_identifier,
    ACTIONS(2316), 1,
      anon_sym_RBRACE,
    STATE(637), 1,
      sym__import_declaration,
  [11309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(254), 1,
      anon_sym_RPAREN,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
    STATE(548), 1,
      aux_sym__call_arguments_repeat1,
  [11322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(235), 1,
      sym_yul_identifier,
    STATE(252), 1,
      sym_yul_path,
  [11335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 1,
      sym_identifier,
    ACTIONS(2320), 1,
      anon_sym_RBRACE,
    STATE(617), 1,
      sym_call_struct_argument,
  [11348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2322), 1,
      anon_sym_COMMA,
    ACTIONS(2325), 1,
      anon_sym_RPAREN,
    STATE(616), 1,
      aux_sym_override_specifier_repeat1,
  [11361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_COMMA,
    ACTIONS(2329), 1,
      anon_sym_RBRACE,
    STATE(544), 1,
      aux_sym_call_argument_repeat1,
  [11374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 1,
      anon_sym_as,
    ACTIONS(2331), 1,
      anon_sym_from,
    STATE(739), 1,
      sym__import_alias,
  [11387] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2333), 1,
      anon_sym_COMMA,
    ACTIONS(2335), 1,
      anon_sym_RPAREN,
    STATE(613), 1,
      aux_sym__call_arguments_repeat1,
  [11400] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1158), 1,
      anon_sym_RPAREN,
    ACTIONS(2337), 1,
      anon_sym_COMMA,
    STATE(587), 1,
      aux_sym_yul_function_call_repeat1,
  [11413] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(280), 1,
      anon_sym_RBRACK,
    ACTIONS(2339), 1,
      anon_sym_COMMA,
    STATE(610), 1,
      aux_sym_inline_array_expression_repeat1,
  [11426] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2341), 1,
      anon_sym_COMMA,
    ACTIONS(2343), 1,
      anon_sym_RPAREN,
    STATE(588), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [11439] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 1,
      sym_identifier,
    ACTIONS(2345), 1,
      anon_sym_RBRACE,
    STATE(695), 1,
      sym_call_struct_argument,
  [11452] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2347), 1,
      anon_sym_COMMA,
    ACTIONS(2350), 1,
      anon_sym_RBRACE,
    STATE(624), 1,
      aux_sym_call_argument_repeat1,
  [11465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    ACTIONS(2352), 1,
      anon_sym_DASH_GT,
    STATE(288), 1,
      sym_yul_block,
  [11478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2354), 1,
      anon_sym_COMMA,
    ACTIONS(2356), 1,
      anon_sym_RBRACE,
    STATE(605), 1,
      aux_sym_struct_expression_repeat1,
  [11491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(2358), 1,
      sym_identifier,
    ACTIONS(2360), 1,
      anon_sym_RPAREN,
  [11504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_COMMA,
    ACTIONS(2364), 1,
      anon_sym_RPAREN,
    STATE(243), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [11517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2366), 1,
      anon_sym_LBRACE,
    ACTIONS(2368), 1,
      anon_sym_COMMA,
    STATE(629), 1,
      aux_sym__class_heritage_repeat1,
  [11530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2371), 1,
      anon_sym_COMMA,
    ACTIONS(2373), 1,
      anon_sym_RPAREN,
    STATE(554), 1,
      aux_sym__return_parameters_repeat1,
  [11543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    ACTIONS(2364), 1,
      anon_sym_RPAREN,
    STATE(249), 1,
      sym_yul_identifier,
  [11556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2016), 1,
      sym_identifier,
    STATE(318), 1,
      sym__identifier_path,
    STATE(703), 1,
      sym_user_defined_type,
  [11569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(1665), 1,
      sym_unchecked,
    STATE(74), 1,
      sym_block_statement,
  [11582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 1,
      anon_sym_COMMA,
    ACTIONS(2377), 1,
      anon_sym_RPAREN,
    STATE(547), 1,
      aux_sym_override_specifier_repeat1,
  [11595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 1,
      anon_sym_COMMA,
    ACTIONS(2382), 1,
      anon_sym_RPAREN,
    STATE(635), 1,
      aux_sym_error_declaration_repeat1,
  [11608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2384), 1,
      anon_sym_COMMA,
    ACTIONS(2386), 1,
      anon_sym_RPAREN,
    STATE(628), 1,
      aux_sym_yul_variable_declaration_repeat1,
  [11621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2388), 1,
      anon_sym_COMMA,
    ACTIONS(2390), 1,
      anon_sym_RBRACE,
    STATE(545), 1,
      aux_sym__multiple_import_repeat1,
  [11634] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2123), 1,
      sym_identifier,
    ACTIONS(2125), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1683), 1,
      anon_sym_RPAREN,
    ACTIONS(2392), 1,
      anon_sym_COMMA,
    STATE(639), 1,
      aux_sym_tuple_expression_repeat1,
  [11658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_RPAREN,
    ACTIONS(2395), 1,
      anon_sym_COMMA,
    STATE(575), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [11671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_RPAREN,
    ACTIONS(2395), 1,
      anon_sym_COMMA,
    STATE(577), 1,
      aux_sym_variable_declaration_tuple_repeat1,
  [11684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_SQUOTE,
    STATE(810), 1,
      sym_string,
  [11697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2154), 1,
      anon_sym_catch,
    STATE(72), 2,
      sym_catch_clause,
      aux_sym_try_statement_repeat1,
  [11708] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    ACTIONS(2397), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      sym_yul_identifier,
  [11721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2399), 1,
      anon_sym_COMMA,
    ACTIONS(2402), 1,
      anon_sym_RBRACE,
    STATE(645), 1,
      aux_sym_enum_body_repeat1,
  [11734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2404), 1,
      anon_sym_COMMA,
    ACTIONS(2406), 1,
      anon_sym_RPAREN,
    STATE(620), 1,
      aux_sym_yul_function_call_repeat1,
  [11747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2408), 1,
      anon_sym_COMMA,
    ACTIONS(2411), 1,
      anon_sym_RPAREN,
    STATE(647), 1,
      aux_sym__event_parameter_list_repeat1,
  [11760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2216), 1,
      sym_identifier,
    STATE(714), 1,
      sym__import_declaration,
  [11770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2413), 2,
      anon_sym_anonymous,
      sym__semicolon,
  [11778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2415), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11786] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    STATE(608), 1,
      sym__parameter_list,
  [11796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    STATE(272), 1,
      sym_yul_block,
  [11806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    STATE(445), 1,
      sym__parameter_list,
  [11824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_LPAREN,
    STATE(680), 1,
      sym__event_parameter_list,
  [11834] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(156), 1,
      sym_contract_body,
  [11844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2419), 1,
      sym_identifier,
    ACTIONS(2421), 1,
      anon_sym_RBRACE,
  [11854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(160), 1,
      sym_contract_body,
  [11864] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2423), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2425), 1,
      sym_identifier,
    ACTIONS(2427), 1,
      anon_sym_RBRACE,
  [11882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2429), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11890] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2121), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11898] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2411), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [11914] = 3,
    ACTIONS(1958), 1,
      sym_comment,
    ACTIONS(2433), 1,
      aux_sym_pragma_value_token1,
    STATE(760), 1,
      sym_pragma_value,
  [11924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2435), 2,
      anon_sym_anonymous,
      sym__semicolon,
  [11932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2419), 1,
      sym_identifier,
    ACTIONS(2437), 1,
      anon_sym_RBRACE,
  [11942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2439), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [11950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    STATE(599), 1,
      sym__parameter_list,
  [11960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2158), 1,
      anon_sym_RBRACE,
    ACTIONS(2419), 1,
      sym_identifier,
  [11970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    STATE(679), 1,
      sym_yul_block,
  [11980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [11988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2441), 1,
      anon_sym_LBRACE,
    STATE(161), 1,
      sym_struct_body,
  [11998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2445), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 1,
      sym_identifier,
    STATE(695), 1,
      sym_call_struct_argument,
  [12024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(2447), 1,
      anon_sym_constant,
  [12034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2180), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [12042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    STATE(275), 1,
      sym_yul_block,
  [12052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2449), 1,
      anon_sym_anonymous,
    ACTIONS(2451), 1,
      sym__semicolon,
  [12062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2453), 1,
      sym_identifier,
    ACTIONS(2455), 1,
      anon_sym_RBRACE,
  [12072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(148), 1,
      sym_contract_body,
  [12082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2366), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [12090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2457), 1,
      anon_sym_EQ,
    ACTIONS(2459), 1,
      sym__semicolon,
  [12100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 1,
      anon_sym_anonymous,
    ACTIONS(2463), 1,
      sym__semicolon,
  [12110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2465), 1,
      anon_sym_LBRACE,
    STATE(173), 1,
      sym_enum_body,
  [12120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2467), 1,
      anon_sym_LBRACE,
    STATE(214), 1,
      sym_enum_body,
  [12130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    STATE(310), 1,
      sym__parameter_list,
  [12140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 1,
      sym_identifier,
    STATE(678), 1,
      sym_struct_field_assignment,
  [12150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    STATE(255), 1,
      sym_yul_block,
  [12160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    STATE(289), 1,
      sym_yul_block,
  [12170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 1,
      anon_sym_LBRACE,
    STATE(175), 1,
      sym_struct_body,
  [12180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    STATE(468), 1,
      sym__parameter_list,
  [12190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    STATE(447), 1,
      sym__parameter_list,
  [12200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2350), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [12208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2417), 1,
      anon_sym_LPAREN,
    STATE(685), 1,
      sym__event_parameter_list,
  [12218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2471), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(2473), 1,
      sym_identifier,
  [12236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2475), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    STATE(443), 1,
      sym__parameter_list,
  [12254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      anon_sym_LBRACE,
    STATE(165), 1,
      sym_contract_body,
  [12264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2477), 2,
      anon_sym_anonymous,
      sym__semicolon,
  [12272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2479), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(753), 1,
      sym_yul_identifier,
  [12298] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_LPAREN,
    STATE(719), 1,
      sym__parameter_list,
  [12308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2481), 1,
      sym__hex_digit,
    ACTIONS(2483), 1,
      anon_sym_DQUOTE,
  [12318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 1,
      anon_sym_SQUOTE,
    ACTIONS(2485), 1,
      sym__hex_digit,
  [12328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2487), 1,
      anon_sym_from,
    STATE(823), 1,
      sym__from_clause,
  [12346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2489), 1,
      anon_sym_DQUOTE,
    ACTIONS(2491), 1,
      anon_sym_SQUOTE,
  [12356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(2493), 1,
      anon_sym_RPAREN,
  [12366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2495), 1,
      anon_sym_DQUOTE,
    ACTIONS(2497), 1,
      anon_sym_SQUOTE,
  [12376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2499), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [12384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    STATE(293), 1,
      sym_yul_block,
  [12394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(636), 1,
      sym_yul_identifier,
  [12404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(249), 1,
      sym_yul_identifier,
  [12414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2501), 1,
      anon_sym_EQ,
    ACTIONS(2503), 1,
      sym__semicolon,
  [12424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2505), 2,
      anon_sym_LBRACE,
      sym__semicolon,
  [12432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(530), 1,
      sym_yul_identifier,
  [12442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1445), 1,
      anon_sym_LPAREN,
    STATE(372), 1,
      sym__call_arguments,
  [12452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_LBRACK,
    ACTIONS(2507), 1,
      sym__semicolon,
  [12462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2509), 2,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [12470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_LBRACE,
    STATE(290), 1,
      sym_yul_block,
  [12480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 1,
      anon_sym_EQ,
    ACTIONS(2513), 1,
      sym__semicolon,
  [12490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2264), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(512), 1,
      sym_yul_identifier,
  [12516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2240), 1,
      anon_sym_RBRACE,
    ACTIONS(2419), 1,
      sym_identifier,
  [12526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2517), 2,
      anon_sym_anonymous,
      sym__semicolon,
  [12534] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2230), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(498), 1,
      sym_yul_identifier,
  [12552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(232), 1,
      sym_yul_identifier,
  [12562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2519), 1,
      sym_identifier,
    ACTIONS(2521), 1,
      anon_sym_EQ_GT,
  [12572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2523), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2525), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [12596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2034), 1,
      sym_identifier,
    STATE(521), 1,
      sym_yul_identifier,
  [12606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2527), 1,
      anon_sym_from,
  [12613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2529), 1,
      sym__hex_digit,
  [12620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2531), 1,
      anon_sym_LPAREN,
  [12627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2533), 1,
      sym__semicolon,
  [12634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2535), 1,
      anon_sym_EQ,
  [12641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2537), 1,
      sym_identifier,
  [12648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2539), 1,
      anon_sym_EQ,
  [12655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2541), 1,
      sym__semicolon,
  [12662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2543), 1,
      anon_sym_LPAREN,
  [12669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2545), 1,
      anon_sym_LBRACE,
  [12676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2547), 1,
      sym_identifier,
  [12683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2549), 1,
      sym_identifier,
  [12690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2551), 1,
      sym_identifier,
  [12697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2553), 1,
      anon_sym_LPAREN,
  [12704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 1,
      anon_sym_LPAREN,
  [12711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 1,
      sym_identifier,
  [12718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2559), 1,
      sym__semicolon,
  [12725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      anon_sym_LPAREN,
  [12732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2419), 1,
      sym_identifier,
  [12739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2563), 1,
      anon_sym_LPAREN,
  [12746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2565), 1,
      sym__semicolon,
  [12753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2567), 1,
      sym__semicolon,
  [12760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_EQ,
  [12767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2571), 1,
      sym__semicolon,
  [12774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 1,
      anon_sym_EQ,
  [12781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      anon_sym_for,
  [12788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2507), 1,
      sym__semicolon,
  [12795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2575), 1,
      anon_sym_from,
  [12802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2577), 1,
      anon_sym_LBRACE,
  [12809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2579), 1,
      sym__semicolon,
  [12816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      anon_sym_from,
  [12823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2583), 1,
      sym_solidity_version,
  [12830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_from,
  [12837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2587), 1,
      sym_identifier,
  [12844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2589), 1,
      anon_sym_is,
  [12851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2585), 1,
      anon_sym_from,
  [12858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2591), 1,
      sym__semicolon,
  [12865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 1,
      sym_identifier,
  [12872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2595), 1,
      sym_identifier,
  [12879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_EQ_GT,
  [12886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2599), 1,
      anon_sym_EQ,
  [12893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2601), 1,
      sym__semicolon,
  [12900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2603), 1,
      anon_sym_EQ,
  [12907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_LBRACE,
  [12914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2607), 1,
      anon_sym_LPAREN,
  [12921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2609), 1,
      sym__semicolon,
  [12928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2611), 1,
      anon_sym_LBRACE,
  [12935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2613), 1,
      sym__semicolon,
  [12942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2615), 1,
      anon_sym_LBRACE,
  [12949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2617), 1,
      anon_sym_COLON,
  [12956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(941), 1,
      anon_sym_LPAREN,
  [12963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 1,
      sym__semicolon,
  [12970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      sym_identifier,
  [12977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2623), 1,
      sym_solidity_version,
  [12984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2625), 1,
      anon_sym_from,
  [12991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2627), 1,
      sym_identifier,
  [12998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2629), 1,
      anon_sym_RPAREN,
  [13005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2631), 1,
      anon_sym_from,
  [13012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1659), 1,
      anon_sym_COLON,
  [13019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2633), 1,
      anon_sym_LPAREN,
  [13026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2635), 1,
      anon_sym_from,
  [13033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2637), 1,
      anon_sym_RPAREN,
  [13040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2639), 1,
      anon_sym_EQ,
  [13047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2641), 1,
      sym__semicolon,
  [13054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2643), 1,
      sym__semicolon,
  [13061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2645), 1,
      sym__semicolon,
  [13068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 1,
      sym_identifier,
  [13075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2649), 1,
      sym__semicolon,
  [13082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2651), 1,
      sym__semicolon,
  [13089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2653), 1,
      sym_identifier,
  [13096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2655), 1,
      ts_builtin_sym_end,
  [13103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2657), 1,
      sym__semicolon,
  [13110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2659), 1,
      sym__semicolon,
  [13117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      sym__semicolon,
  [13124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2663), 1,
      sym_identifier,
  [13131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2665), 1,
      sym_identifier,
  [13138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2667), 1,
      anon_sym_LPAREN,
  [13145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2669), 1,
      sym__semicolon,
  [13152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_LBRACE,
  [13159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2673), 1,
      sym__semicolon,
  [13166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2675), 1,
      sym_identifier,
  [13173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2677), 1,
      sym_identifier,
  [13180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_LBRACE,
  [13187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 1,
      sym__semicolon,
  [13194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2681), 1,
      sym__semicolon,
  [13201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2683), 1,
      sym_identifier,
  [13208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2685), 1,
      anon_sym_contract,
  [13215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2687), 1,
      sym__semicolon,
  [13222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2689), 1,
      sym_identifier,
  [13229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_while,
  [13236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_from,
  [13243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2695), 1,
      sym_identifier,
  [13250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_is,
  [13257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2699), 1,
      anon_sym_LPAREN,
  [13264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2701), 1,
      sym_identifier,
  [13271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2703), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(317)] = 0,
  [SMALL_STATE(318)] = 72,
  [SMALL_STATE(319)] = 142,
  [SMALL_STATE(320)] = 211,
  [SMALL_STATE(321)] = 280,
  [SMALL_STATE(322)] = 348,
  [SMALL_STATE(323)] = 416,
  [SMALL_STATE(324)] = 484,
  [SMALL_STATE(325)] = 552,
  [SMALL_STATE(326)] = 620,
  [SMALL_STATE(327)] = 688,
  [SMALL_STATE(328)] = 756,
  [SMALL_STATE(329)] = 824,
  [SMALL_STATE(330)] = 892,
  [SMALL_STATE(331)] = 960,
  [SMALL_STATE(332)] = 1028,
  [SMALL_STATE(333)] = 1096,
  [SMALL_STATE(334)] = 1164,
  [SMALL_STATE(335)] = 1236,
  [SMALL_STATE(336)] = 1304,
  [SMALL_STATE(337)] = 1372,
  [SMALL_STATE(338)] = 1438,
  [SMALL_STATE(339)] = 1504,
  [SMALL_STATE(340)] = 1570,
  [SMALL_STATE(341)] = 1636,
  [SMALL_STATE(342)] = 1699,
  [SMALL_STATE(343)] = 1760,
  [SMALL_STATE(344)] = 1821,
  [SMALL_STATE(345)] = 1888,
  [SMALL_STATE(346)] = 1950,
  [SMALL_STATE(347)] = 2016,
  [SMALL_STATE(348)] = 2082,
  [SMALL_STATE(349)] = 2144,
  [SMALL_STATE(350)] = 2206,
  [SMALL_STATE(351)] = 2268,
  [SMALL_STATE(352)] = 2330,
  [SMALL_STATE(353)] = 2395,
  [SMALL_STATE(354)] = 2468,
  [SMALL_STATE(355)] = 2525,
  [SMALL_STATE(356)] = 2582,
  [SMALL_STATE(357)] = 2643,
  [SMALL_STATE(358)] = 2724,
  [SMALL_STATE(359)] = 2785,
  [SMALL_STATE(360)] = 2848,
  [SMALL_STATE(361)] = 2909,
  [SMALL_STATE(362)] = 2972,
  [SMALL_STATE(363)] = 3029,
  [SMALL_STATE(364)] = 3120,
  [SMALL_STATE(365)] = 3177,
  [SMALL_STATE(366)] = 3234,
  [SMALL_STATE(367)] = 3297,
  [SMALL_STATE(368)] = 3374,
  [SMALL_STATE(369)] = 3441,
  [SMALL_STATE(370)] = 3510,
  [SMALL_STATE(371)] = 3601,
  [SMALL_STATE(372)] = 3664,
  [SMALL_STATE(373)] = 3720,
  [SMALL_STATE(374)] = 3776,
  [SMALL_STATE(375)] = 3832,
  [SMALL_STATE(376)] = 3888,
  [SMALL_STATE(377)] = 3944,
  [SMALL_STATE(378)] = 4000,
  [SMALL_STATE(379)] = 4056,
  [SMALL_STATE(380)] = 4112,
  [SMALL_STATE(381)] = 4168,
  [SMALL_STATE(382)] = 4224,
  [SMALL_STATE(383)] = 4280,
  [SMALL_STATE(384)] = 4336,
  [SMALL_STATE(385)] = 4392,
  [SMALL_STATE(386)] = 4448,
  [SMALL_STATE(387)] = 4504,
  [SMALL_STATE(388)] = 4560,
  [SMALL_STATE(389)] = 4616,
  [SMALL_STATE(390)] = 4672,
  [SMALL_STATE(391)] = 4728,
  [SMALL_STATE(392)] = 4784,
  [SMALL_STATE(393)] = 4840,
  [SMALL_STATE(394)] = 4896,
  [SMALL_STATE(395)] = 4952,
  [SMALL_STATE(396)] = 5008,
  [SMALL_STATE(397)] = 5064,
  [SMALL_STATE(398)] = 5120,
  [SMALL_STATE(399)] = 5176,
  [SMALL_STATE(400)] = 5232,
  [SMALL_STATE(401)] = 5296,
  [SMALL_STATE(402)] = 5352,
  [SMALL_STATE(403)] = 5408,
  [SMALL_STATE(404)] = 5464,
  [SMALL_STATE(405)] = 5520,
  [SMALL_STATE(406)] = 5579,
  [SMALL_STATE(407)] = 5642,
  [SMALL_STATE(408)] = 5697,
  [SMALL_STATE(409)] = 5787,
  [SMALL_STATE(410)] = 5877,
  [SMALL_STATE(411)] = 5967,
  [SMALL_STATE(412)] = 6057,
  [SMALL_STATE(413)] = 6110,
  [SMALL_STATE(414)] = 6195,
  [SMALL_STATE(415)] = 6280,
  [SMALL_STATE(416)] = 6365,
  [SMALL_STATE(417)] = 6450,
  [SMALL_STATE(418)] = 6537,
  [SMALL_STATE(419)] = 6622,
  [SMALL_STATE(420)] = 6706,
  [SMALL_STATE(421)] = 6790,
  [SMALL_STATE(422)] = 6874,
  [SMALL_STATE(423)] = 6958,
  [SMALL_STATE(424)] = 7042,
  [SMALL_STATE(425)] = 7126,
  [SMALL_STATE(426)] = 7210,
  [SMALL_STATE(427)] = 7294,
  [SMALL_STATE(428)] = 7378,
  [SMALL_STATE(429)] = 7462,
  [SMALL_STATE(430)] = 7546,
  [SMALL_STATE(431)] = 7630,
  [SMALL_STATE(432)] = 7714,
  [SMALL_STATE(433)] = 7798,
  [SMALL_STATE(434)] = 7882,
  [SMALL_STATE(435)] = 7933,
  [SMALL_STATE(436)] = 7984,
  [SMALL_STATE(437)] = 8035,
  [SMALL_STATE(438)] = 8086,
  [SMALL_STATE(439)] = 8137,
  [SMALL_STATE(440)] = 8218,
  [SMALL_STATE(441)] = 8257,
  [SMALL_STATE(442)] = 8296,
  [SMALL_STATE(443)] = 8357,
  [SMALL_STATE(444)] = 8406,
  [SMALL_STATE(445)] = 8455,
  [SMALL_STATE(446)] = 8504,
  [SMALL_STATE(447)] = 8553,
  [SMALL_STATE(448)] = 8596,
  [SMALL_STATE(449)] = 8639,
  [SMALL_STATE(450)] = 8680,
  [SMALL_STATE(451)] = 8718,
  [SMALL_STATE(452)] = 8744,
  [SMALL_STATE(453)] = 8774,
  [SMALL_STATE(454)] = 8797,
  [SMALL_STATE(455)] = 8820,
  [SMALL_STATE(456)] = 8843,
  [SMALL_STATE(457)] = 8870,
  [SMALL_STATE(458)] = 8891,
  [SMALL_STATE(459)] = 8921,
  [SMALL_STATE(460)] = 8951,
  [SMALL_STATE(461)] = 8981,
  [SMALL_STATE(462)] = 9011,
  [SMALL_STATE(463)] = 9032,
  [SMALL_STATE(464)] = 9051,
  [SMALL_STATE(465)] = 9078,
  [SMALL_STATE(466)] = 9105,
  [SMALL_STATE(467)] = 9139,
  [SMALL_STATE(468)] = 9167,
  [SMALL_STATE(469)] = 9192,
  [SMALL_STATE(470)] = 9217,
  [SMALL_STATE(471)] = 9246,
  [SMALL_STATE(472)] = 9263,
  [SMALL_STATE(473)] = 9285,
  [SMALL_STATE(474)] = 9299,
  [SMALL_STATE(475)] = 9321,
  [SMALL_STATE(476)] = 9344,
  [SMALL_STATE(477)] = 9367,
  [SMALL_STATE(478)] = 9390,
  [SMALL_STATE(479)] = 9409,
  [SMALL_STATE(480)] = 9431,
  [SMALL_STATE(481)] = 9449,
  [SMALL_STATE(482)] = 9466,
  [SMALL_STATE(483)] = 9483,
  [SMALL_STATE(484)] = 9500,
  [SMALL_STATE(485)] = 9517,
  [SMALL_STATE(486)] = 9534,
  [SMALL_STATE(487)] = 9551,
  [SMALL_STATE(488)] = 9566,
  [SMALL_STATE(489)] = 9583,
  [SMALL_STATE(490)] = 9600,
  [SMALL_STATE(491)] = 9617,
  [SMALL_STATE(492)] = 9634,
  [SMALL_STATE(493)] = 9651,
  [SMALL_STATE(494)] = 9670,
  [SMALL_STATE(495)] = 9689,
  [SMALL_STATE(496)] = 9706,
  [SMALL_STATE(497)] = 9723,
  [SMALL_STATE(498)] = 9739,
  [SMALL_STATE(499)] = 9755,
  [SMALL_STATE(500)] = 9771,
  [SMALL_STATE(501)] = 9787,
  [SMALL_STATE(502)] = 9803,
  [SMALL_STATE(503)] = 9817,
  [SMALL_STATE(504)] = 9831,
  [SMALL_STATE(505)] = 9841,
  [SMALL_STATE(506)] = 9857,
  [SMALL_STATE(507)] = 9873,
  [SMALL_STATE(508)] = 9887,
  [SMALL_STATE(509)] = 9901,
  [SMALL_STATE(510)] = 9915,
  [SMALL_STATE(511)] = 9931,
  [SMALL_STATE(512)] = 9947,
  [SMALL_STATE(513)] = 9963,
  [SMALL_STATE(514)] = 9979,
  [SMALL_STATE(515)] = 9995,
  [SMALL_STATE(516)] = 10011,
  [SMALL_STATE(517)] = 10027,
  [SMALL_STATE(518)] = 10043,
  [SMALL_STATE(519)] = 10059,
  [SMALL_STATE(520)] = 10073,
  [SMALL_STATE(521)] = 10089,
  [SMALL_STATE(522)] = 10105,
  [SMALL_STATE(523)] = 10115,
  [SMALL_STATE(524)] = 10131,
  [SMALL_STATE(525)] = 10147,
  [SMALL_STATE(526)] = 10163,
  [SMALL_STATE(527)] = 10173,
  [SMALL_STATE(528)] = 10189,
  [SMALL_STATE(529)] = 10205,
  [SMALL_STATE(530)] = 10221,
  [SMALL_STATE(531)] = 10237,
  [SMALL_STATE(532)] = 10253,
  [SMALL_STATE(533)] = 10269,
  [SMALL_STATE(534)] = 10279,
  [SMALL_STATE(535)] = 10293,
  [SMALL_STATE(536)] = 10307,
  [SMALL_STATE(537)] = 10321,
  [SMALL_STATE(538)] = 10337,
  [SMALL_STATE(539)] = 10353,
  [SMALL_STATE(540)] = 10366,
  [SMALL_STATE(541)] = 10379,
  [SMALL_STATE(542)] = 10392,
  [SMALL_STATE(543)] = 10405,
  [SMALL_STATE(544)] = 10418,
  [SMALL_STATE(545)] = 10431,
  [SMALL_STATE(546)] = 10444,
  [SMALL_STATE(547)] = 10457,
  [SMALL_STATE(548)] = 10470,
  [SMALL_STATE(549)] = 10483,
  [SMALL_STATE(550)] = 10494,
  [SMALL_STATE(551)] = 10507,
  [SMALL_STATE(552)] = 10520,
  [SMALL_STATE(553)] = 10533,
  [SMALL_STATE(554)] = 10546,
  [SMALL_STATE(555)] = 10559,
  [SMALL_STATE(556)] = 10572,
  [SMALL_STATE(557)] = 10585,
  [SMALL_STATE(558)] = 10598,
  [SMALL_STATE(559)] = 10611,
  [SMALL_STATE(560)] = 10624,
  [SMALL_STATE(561)] = 10637,
  [SMALL_STATE(562)] = 10650,
  [SMALL_STATE(563)] = 10663,
  [SMALL_STATE(564)] = 10676,
  [SMALL_STATE(565)] = 10689,
  [SMALL_STATE(566)] = 10700,
  [SMALL_STATE(567)] = 10713,
  [SMALL_STATE(568)] = 10726,
  [SMALL_STATE(569)] = 10739,
  [SMALL_STATE(570)] = 10752,
  [SMALL_STATE(571)] = 10765,
  [SMALL_STATE(572)] = 10778,
  [SMALL_STATE(573)] = 10791,
  [SMALL_STATE(574)] = 10804,
  [SMALL_STATE(575)] = 10817,
  [SMALL_STATE(576)] = 10830,
  [SMALL_STATE(577)] = 10843,
  [SMALL_STATE(578)] = 10856,
  [SMALL_STATE(579)] = 10869,
  [SMALL_STATE(580)] = 10882,
  [SMALL_STATE(581)] = 10895,
  [SMALL_STATE(582)] = 10908,
  [SMALL_STATE(583)] = 10921,
  [SMALL_STATE(584)] = 10934,
  [SMALL_STATE(585)] = 10947,
  [SMALL_STATE(586)] = 10960,
  [SMALL_STATE(587)] = 10973,
  [SMALL_STATE(588)] = 10986,
  [SMALL_STATE(589)] = 10999,
  [SMALL_STATE(590)] = 11012,
  [SMALL_STATE(591)] = 11025,
  [SMALL_STATE(592)] = 11038,
  [SMALL_STATE(593)] = 11051,
  [SMALL_STATE(594)] = 11064,
  [SMALL_STATE(595)] = 11077,
  [SMALL_STATE(596)] = 11090,
  [SMALL_STATE(597)] = 11103,
  [SMALL_STATE(598)] = 11116,
  [SMALL_STATE(599)] = 11129,
  [SMALL_STATE(600)] = 11142,
  [SMALL_STATE(601)] = 11155,
  [SMALL_STATE(602)] = 11168,
  [SMALL_STATE(603)] = 11181,
  [SMALL_STATE(604)] = 11194,
  [SMALL_STATE(605)] = 11205,
  [SMALL_STATE(606)] = 11218,
  [SMALL_STATE(607)] = 11231,
  [SMALL_STATE(608)] = 11244,
  [SMALL_STATE(609)] = 11257,
  [SMALL_STATE(610)] = 11270,
  [SMALL_STATE(611)] = 11283,
  [SMALL_STATE(612)] = 11296,
  [SMALL_STATE(613)] = 11309,
  [SMALL_STATE(614)] = 11322,
  [SMALL_STATE(615)] = 11335,
  [SMALL_STATE(616)] = 11348,
  [SMALL_STATE(617)] = 11361,
  [SMALL_STATE(618)] = 11374,
  [SMALL_STATE(619)] = 11387,
  [SMALL_STATE(620)] = 11400,
  [SMALL_STATE(621)] = 11413,
  [SMALL_STATE(622)] = 11426,
  [SMALL_STATE(623)] = 11439,
  [SMALL_STATE(624)] = 11452,
  [SMALL_STATE(625)] = 11465,
  [SMALL_STATE(626)] = 11478,
  [SMALL_STATE(627)] = 11491,
  [SMALL_STATE(628)] = 11504,
  [SMALL_STATE(629)] = 11517,
  [SMALL_STATE(630)] = 11530,
  [SMALL_STATE(631)] = 11543,
  [SMALL_STATE(632)] = 11556,
  [SMALL_STATE(633)] = 11569,
  [SMALL_STATE(634)] = 11582,
  [SMALL_STATE(635)] = 11595,
  [SMALL_STATE(636)] = 11608,
  [SMALL_STATE(637)] = 11621,
  [SMALL_STATE(638)] = 11634,
  [SMALL_STATE(639)] = 11645,
  [SMALL_STATE(640)] = 11658,
  [SMALL_STATE(641)] = 11671,
  [SMALL_STATE(642)] = 11684,
  [SMALL_STATE(643)] = 11697,
  [SMALL_STATE(644)] = 11708,
  [SMALL_STATE(645)] = 11721,
  [SMALL_STATE(646)] = 11734,
  [SMALL_STATE(647)] = 11747,
  [SMALL_STATE(648)] = 11760,
  [SMALL_STATE(649)] = 11770,
  [SMALL_STATE(650)] = 11778,
  [SMALL_STATE(651)] = 11786,
  [SMALL_STATE(652)] = 11796,
  [SMALL_STATE(653)] = 11806,
  [SMALL_STATE(654)] = 11814,
  [SMALL_STATE(655)] = 11824,
  [SMALL_STATE(656)] = 11834,
  [SMALL_STATE(657)] = 11844,
  [SMALL_STATE(658)] = 11854,
  [SMALL_STATE(659)] = 11864,
  [SMALL_STATE(660)] = 11872,
  [SMALL_STATE(661)] = 11882,
  [SMALL_STATE(662)] = 11890,
  [SMALL_STATE(663)] = 11898,
  [SMALL_STATE(664)] = 11906,
  [SMALL_STATE(665)] = 11914,
  [SMALL_STATE(666)] = 11924,
  [SMALL_STATE(667)] = 11932,
  [SMALL_STATE(668)] = 11942,
  [SMALL_STATE(669)] = 11950,
  [SMALL_STATE(670)] = 11960,
  [SMALL_STATE(671)] = 11970,
  [SMALL_STATE(672)] = 11980,
  [SMALL_STATE(673)] = 11988,
  [SMALL_STATE(674)] = 11998,
  [SMALL_STATE(675)] = 12006,
  [SMALL_STATE(676)] = 12014,
  [SMALL_STATE(677)] = 12024,
  [SMALL_STATE(678)] = 12034,
  [SMALL_STATE(679)] = 12042,
  [SMALL_STATE(680)] = 12052,
  [SMALL_STATE(681)] = 12062,
  [SMALL_STATE(682)] = 12072,
  [SMALL_STATE(683)] = 12082,
  [SMALL_STATE(684)] = 12090,
  [SMALL_STATE(685)] = 12100,
  [SMALL_STATE(686)] = 12110,
  [SMALL_STATE(687)] = 12120,
  [SMALL_STATE(688)] = 12130,
  [SMALL_STATE(689)] = 12140,
  [SMALL_STATE(690)] = 12150,
  [SMALL_STATE(691)] = 12160,
  [SMALL_STATE(692)] = 12170,
  [SMALL_STATE(693)] = 12180,
  [SMALL_STATE(694)] = 12190,
  [SMALL_STATE(695)] = 12200,
  [SMALL_STATE(696)] = 12208,
  [SMALL_STATE(697)] = 12218,
  [SMALL_STATE(698)] = 12226,
  [SMALL_STATE(699)] = 12236,
  [SMALL_STATE(700)] = 12244,
  [SMALL_STATE(701)] = 12254,
  [SMALL_STATE(702)] = 12264,
  [SMALL_STATE(703)] = 12272,
  [SMALL_STATE(704)] = 12280,
  [SMALL_STATE(705)] = 12288,
  [SMALL_STATE(706)] = 12298,
  [SMALL_STATE(707)] = 12308,
  [SMALL_STATE(708)] = 12318,
  [SMALL_STATE(709)] = 12328,
  [SMALL_STATE(710)] = 12336,
  [SMALL_STATE(711)] = 12346,
  [SMALL_STATE(712)] = 12356,
  [SMALL_STATE(713)] = 12366,
  [SMALL_STATE(714)] = 12376,
  [SMALL_STATE(715)] = 12384,
  [SMALL_STATE(716)] = 12394,
  [SMALL_STATE(717)] = 12404,
  [SMALL_STATE(718)] = 12414,
  [SMALL_STATE(719)] = 12424,
  [SMALL_STATE(720)] = 12432,
  [SMALL_STATE(721)] = 12442,
  [SMALL_STATE(722)] = 12452,
  [SMALL_STATE(723)] = 12462,
  [SMALL_STATE(724)] = 12470,
  [SMALL_STATE(725)] = 12480,
  [SMALL_STATE(726)] = 12490,
  [SMALL_STATE(727)] = 12498,
  [SMALL_STATE(728)] = 12506,
  [SMALL_STATE(729)] = 12516,
  [SMALL_STATE(730)] = 12526,
  [SMALL_STATE(731)] = 12534,
  [SMALL_STATE(732)] = 12542,
  [SMALL_STATE(733)] = 12552,
  [SMALL_STATE(734)] = 12562,
  [SMALL_STATE(735)] = 12572,
  [SMALL_STATE(736)] = 12580,
  [SMALL_STATE(737)] = 12588,
  [SMALL_STATE(738)] = 12596,
  [SMALL_STATE(739)] = 12606,
  [SMALL_STATE(740)] = 12613,
  [SMALL_STATE(741)] = 12620,
  [SMALL_STATE(742)] = 12627,
  [SMALL_STATE(743)] = 12634,
  [SMALL_STATE(744)] = 12641,
  [SMALL_STATE(745)] = 12648,
  [SMALL_STATE(746)] = 12655,
  [SMALL_STATE(747)] = 12662,
  [SMALL_STATE(748)] = 12669,
  [SMALL_STATE(749)] = 12676,
  [SMALL_STATE(750)] = 12683,
  [SMALL_STATE(751)] = 12690,
  [SMALL_STATE(752)] = 12697,
  [SMALL_STATE(753)] = 12704,
  [SMALL_STATE(754)] = 12711,
  [SMALL_STATE(755)] = 12718,
  [SMALL_STATE(756)] = 12725,
  [SMALL_STATE(757)] = 12732,
  [SMALL_STATE(758)] = 12739,
  [SMALL_STATE(759)] = 12746,
  [SMALL_STATE(760)] = 12753,
  [SMALL_STATE(761)] = 12760,
  [SMALL_STATE(762)] = 12767,
  [SMALL_STATE(763)] = 12774,
  [SMALL_STATE(764)] = 12781,
  [SMALL_STATE(765)] = 12788,
  [SMALL_STATE(766)] = 12795,
  [SMALL_STATE(767)] = 12802,
  [SMALL_STATE(768)] = 12809,
  [SMALL_STATE(769)] = 12816,
  [SMALL_STATE(770)] = 12823,
  [SMALL_STATE(771)] = 12830,
  [SMALL_STATE(772)] = 12837,
  [SMALL_STATE(773)] = 12844,
  [SMALL_STATE(774)] = 12851,
  [SMALL_STATE(775)] = 12858,
  [SMALL_STATE(776)] = 12865,
  [SMALL_STATE(777)] = 12872,
  [SMALL_STATE(778)] = 12879,
  [SMALL_STATE(779)] = 12886,
  [SMALL_STATE(780)] = 12893,
  [SMALL_STATE(781)] = 12900,
  [SMALL_STATE(782)] = 12907,
  [SMALL_STATE(783)] = 12914,
  [SMALL_STATE(784)] = 12921,
  [SMALL_STATE(785)] = 12928,
  [SMALL_STATE(786)] = 12935,
  [SMALL_STATE(787)] = 12942,
  [SMALL_STATE(788)] = 12949,
  [SMALL_STATE(789)] = 12956,
  [SMALL_STATE(790)] = 12963,
  [SMALL_STATE(791)] = 12970,
  [SMALL_STATE(792)] = 12977,
  [SMALL_STATE(793)] = 12984,
  [SMALL_STATE(794)] = 12991,
  [SMALL_STATE(795)] = 12998,
  [SMALL_STATE(796)] = 13005,
  [SMALL_STATE(797)] = 13012,
  [SMALL_STATE(798)] = 13019,
  [SMALL_STATE(799)] = 13026,
  [SMALL_STATE(800)] = 13033,
  [SMALL_STATE(801)] = 13040,
  [SMALL_STATE(802)] = 13047,
  [SMALL_STATE(803)] = 13054,
  [SMALL_STATE(804)] = 13061,
  [SMALL_STATE(805)] = 13068,
  [SMALL_STATE(806)] = 13075,
  [SMALL_STATE(807)] = 13082,
  [SMALL_STATE(808)] = 13089,
  [SMALL_STATE(809)] = 13096,
  [SMALL_STATE(810)] = 13103,
  [SMALL_STATE(811)] = 13110,
  [SMALL_STATE(812)] = 13117,
  [SMALL_STATE(813)] = 13124,
  [SMALL_STATE(814)] = 13131,
  [SMALL_STATE(815)] = 13138,
  [SMALL_STATE(816)] = 13145,
  [SMALL_STATE(817)] = 13152,
  [SMALL_STATE(818)] = 13159,
  [SMALL_STATE(819)] = 13166,
  [SMALL_STATE(820)] = 13173,
  [SMALL_STATE(821)] = 13180,
  [SMALL_STATE(822)] = 13187,
  [SMALL_STATE(823)] = 13194,
  [SMALL_STATE(824)] = 13201,
  [SMALL_STATE(825)] = 13208,
  [SMALL_STATE(826)] = 13215,
  [SMALL_STATE(827)] = 13222,
  [SMALL_STATE(828)] = 13229,
  [SMALL_STATE(829)] = 13236,
  [SMALL_STATE(830)] = 13243,
  [SMALL_STATE(831)] = 13250,
  [SMALL_STATE(832)] = 13257,
  [SMALL_STATE(833)] = 13264,
  [SMALL_STATE(834)] = 13271,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(344),
  [114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(51),
  [117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(48),
  [120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(10),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(752),
  [128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(18),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(741),
  [134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(529),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(786),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(746),
  [143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(401),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(374),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(747),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(688),
  [155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(319),
  [158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(317),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(36),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(31),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(748),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(407),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(756),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(54),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(42),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(721),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(153),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(37),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(67),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(55),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(334),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(334),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(713),
  [212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(495),
  [215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(481),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(711),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 1, 0, 0), REDUCE(aux_sym_tuple_expression_repeat1, 1, 0, 0),
  [244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 1, 0, 0),
  [262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(496),
  [302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(466),
  [305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(827),
  [308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(825),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(824),
  [314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(814),
  [317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(808),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(805),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(750),
  [326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(751),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(754),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(597),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(319),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(317),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 66),
  [348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 66),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0),
  [356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(479),
  [359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 77),
  [361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 77),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 43),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 43),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_statement, 4, 0, 67),
  [373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_statement, 4, 0, 67),
  [375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_statement, 2, 0, 0),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_statement, 2, 0, 0),
  [379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 4, 0, 0),
  [381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 4, 0, 0),
  [383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 3, 0, 0),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 3, 0, 0),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 73),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 73),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block_statement, 2, 0, 0),
  [393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_statement, 2, 0, 0),
  [395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 4, 0, 52),
  [397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4, 0, 52),
  [399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 72),
  [409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 72),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2, 0, 0),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2, 0, 0),
  [417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2, 0, 0),
  [421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 5, 0, 0),
  [423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 5, 0, 0),
  [425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 4, 0, 65),
  [427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 4, 0, 65),
  [429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 2, 0, 0),
  [431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 2, 0, 0),
  [433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_emit_statement, 4, 0, 23),
  [435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_emit_statement, 4, 0, 23),
  [437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 72),
  [439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 72),
  [441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 4, 0, 0),
  [443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 4, 0, 0),
  [445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 3, 0, 0),
  [447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 3, 0, 0),
  [449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 74),
  [451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 74),
  [453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assembly_statement, 6, 0, 0),
  [459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_statement, 6, 0, 0),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 3, 0, 54),
  [485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 3, 0, 54),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 78),
  [491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 78),
  [493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 81),
  [495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 81),
  [497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_while_statement, 7, 0, 82),
  [499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_while_statement, 7, 0, 82),
  [501] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_revert_statement, 3, 0, 55),
  [503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_revert_statement, 3, 0, 55),
  [505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0),
  [510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(833),
  [513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(834),
  [516] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(819),
  [519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(820),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(830),
  [525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(556),
  [528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(559),
  [531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(319),
  [534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(317),
  [537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(794),
  [540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(693),
  [543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(694),
  [546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_contract_body_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0),
  [554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(688),
  [557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(319),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(317),
  [563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_body_repeat1, 2, 0, 0), SHIFT_REPEAT(783),
  [566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 1, 0, 0),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 3, 0, 0),
  [608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 3, 0, 0),
  [610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 3, 0, 13),
  [612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 3, 0, 13),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_body, 2, 0, 0),
  [616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_body, 2, 0, 0),
  [618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_definition, 5, 0, 23),
  [620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_definition, 5, 0, 23),
  [622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 34),
  [624] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 3, 0, 34),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 46),
  [628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 46),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 47),
  [632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 47),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_body, 3, 0, 0),
  [636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_body, 3, 0, 0),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 34),
  [640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 4, 0, 34),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 4, 0, 19),
  [644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_directive, 4, 0, 19),
  [646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_variable_declaration, 6, 0, 50),
  [648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_variable_declaration, 6, 0, 50),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 5, 0, 23),
  [652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 5, 0, 23),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 4, 0, 20),
  [656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 4, 0, 20),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_body, 2, 0, 0),
  [660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_body, 2, 0, 0),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_body, 3, 0, 0),
  [664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_body, 3, 0, 0),
  [666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 5, 0, 31),
  [668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 5, 0, 31),
  [670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_type_definition, 5, 0, 23),
  [672] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_type_definition, 5, 0, 23),
  [674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 36),
  [676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 36),
  [678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_directive, 3, 0, 0),
  [680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma_directive, 3, 0, 0),
  [682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 7, 0, 23),
  [684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 7, 0, 23),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 37),
  [690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 37),
  [692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 23),
  [694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 23),
  [696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_contract_declaration, 4, 0, 22),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_contract_declaration, 4, 0, 22),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 38),
  [702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 38),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 34),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 5, 0, 34),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, 0, 22),
  [710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, 0, 22),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 3, 0, 13),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 3, 0, 13),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, 0, 13),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, 0, 13),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2, 0, 0),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_body, 2, 0, 0),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_directive, 3, 0, 11),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_directive, 3, 0, 11),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_library_declaration, 3, 0, 13),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_library_declaration, 3, 0, 13),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 23),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 23),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 8, 0, 23),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 8, 0, 23),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_definition, 4, 0, 23),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_definition, 4, 0, 23),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 22),
  [746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 22),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_declaration, 6, 0, 23),
  [750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_error_declaration, 6, 0, 23),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, 0, 13),
  [754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, 0, 13),
  [756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5, 0, 62),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5, 0, 62),
  [760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 6, 0, 70),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 6, 0, 70),
  [764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 5, 0, 23),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 5, 0, 23),
  [768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 4, 0, 0),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 4, 0, 0),
  [772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 4, 0, 52),
  [774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 4, 0, 52),
  [776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 3, 0, 24),
  [778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 3, 0, 24),
  [780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 4, 0, 23),
  [782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 4, 0, 23),
  [784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 4, 0, 22),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 4, 0, 22),
  [788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 3, 0, 43),
  [790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 3, 0, 43),
  [792] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_definition, 4, 0, 52),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_definition, 4, 0, 52),
  [796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 3, 0, 43),
  [798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 3, 0, 43),
  [800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fallback_receive_definition, 3, 0, 0),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fallback_receive_definition, 3, 0, 0),
  [804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 3, 0, 13),
  [806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 3, 0, 13),
  [808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 4, 0, 53),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 4, 0, 53),
  [812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 5, 0, 38),
  [814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 5, 0, 38),
  [816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_definition, 3, 0, 23),
  [818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_definition, 3, 0, 23),
  [820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_variable_declaration, 5, 0, 63),
  [822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_variable_declaration, 5, 0, 63),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(233),
  [875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(216),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0),
  [880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(715),
  [883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(220),
  [886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(264),
  [889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(263),
  [892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(220),
  [895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(241),
  [898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(570),
  [901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(295),
  [904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(296),
  [907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(705),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(236),
  [913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(492),
  [916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(491),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_member, 3, 0, 24),
  [935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_member, 3, 0, 24),
  [937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_path, 1, 0, 0),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_path, 1, 0, 0),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_path_repeat1, 2, 0, 0),
  [947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_path_repeat1, 2, 0, 0),
  [949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_path_repeat1, 2, 0, 0), SHIFT_REPEAT(733),
  [952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_path, 2, 0, 0),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_path, 2, 0, 0),
  [956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_identifier, 1, 0, 0),
  [958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_identifier, 1, 0, 0),
  [960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_yul_identifier, 1, 0, 0), SHIFT(286),
  [963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 1, 0, 28),
  [965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 1, 0, 28),
  [967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_evm_builtin, 1, 0, 0),
  [969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_evm_builtin, 1, 0, 0),
  [971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 1, 0, 0),
  [973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 1, 0, 0),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 2, 0, 0),
  [983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 2, 0, 0),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 3, 0, 0),
  [989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 3, 0, 0),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_boolean, 1, 0, 0),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_boolean, 1, 0, 0),
  [999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_string_literal, 1, 0, 0),
  [1001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_string_literal, 1, 0, 0),
  [1003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_variable_declaration_repeat1, 2, 0, 0),
  [1005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_variable_declaration_repeat1, 2, 0, 0),
  [1007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_variable_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(717),
  [1010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 4, 0, 28),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 4, 0, 28),
  [1014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 5, 0, 28),
  [1016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 5, 0, 28),
  [1018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_assignment_repeat1, 2, 0, 0),
  [1020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_assignment_repeat1, 2, 0, 0),
  [1022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_assignment_repeat1, 2, 0, 0), SHIFT_REPEAT(614),
  [1025] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 3, 0, 28),
  [1027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 3, 0, 28),
  [1029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_call, 6, 0, 28),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_call, 6, 0, 28),
  [1033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 2, 0, 0),
  [1035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 2, 0, 0),
  [1037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [1040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_switch_statement, 3, 0, 0),
  [1042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_switch_statement, 3, 0, 0),
  [1044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [1046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [1048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 2, 0, 64),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 2, 0, 64),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 3, 0, 71),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 3, 0, 71),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 3, 0, 0),
  [1066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_switch_statement_repeat1, 3, 0, 0),
  [1068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 4, 0, 75),
  [1070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 4, 0, 75),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_block, 2, 0, 0),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_block, 2, 0, 0),
  [1078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_block, 3, 0, 0),
  [1080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_block, 3, 0, 0),
  [1082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 5, 0, 79),
  [1084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 5, 0, 79),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 6, 0, 84),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 6, 0, 84),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_continue, 1, 0, 0),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_continue, 1, 0, 0),
  [1098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_break, 1, 0, 0),
  [1100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_break, 1, 0, 0),
  [1102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 7, 0, 0),
  [1104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 7, 0, 0),
  [1106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [1108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [1110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 4, 0, 76),
  [1112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 4, 0, 76),
  [1114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 7, 0, 85),
  [1116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 7, 0, 85),
  [1118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 10, 0, 0),
  [1120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 10, 0, 0),
  [1122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 9, 0, 0),
  [1124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 9, 0, 0),
  [1126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_switch_statement, 4, 0, 0),
  [1128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_switch_statement, 4, 0, 0),
  [1130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 5, 0, 80),
  [1132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 5, 0, 80),
  [1134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 6, 0, 0),
  [1136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 6, 0, 0),
  [1138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_for_statement, 5, 0, 0),
  [1140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_for_statement, 5, 0, 0),
  [1142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [1144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [1146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__yul_expression, 1, 0, 0), REDUCE(sym_yul_assignment, 3, 0, 0),
  [1149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__yul_expression, 1, 0, 0), REDUCE(sym_yul_assignment, 3, 0, 0),
  [1152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 6, 0, 83),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 6, 0, 83),
  [1156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [1162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_variable_declaration, 8, 0, 86),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_variable_declaration, 8, 0, 86),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 5, 0, 0),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 5, 0, 0),
  [1172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 8, 0, 0),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 8, 0, 0),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_assignment, 4, 0, 0),
  [1180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_assignment, 4, 0, 0),
  [1182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_label, 2, 0, 0),
  [1184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_label, 2, 0, 0),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 5, 0, 0),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 5, 0, 0),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_switch_statement, 5, 0, 0),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_switch_statement, 5, 0, 0),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_if_statement, 3, 0, 0),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_if_statement, 3, 0, 0),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 11, 0, 0),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 11, 0, 0),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yul_function_definition, 12, 0, 0),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yul_function_definition, 12, 0, 0),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [1226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__yul_assignment_operator, 2, 0, 0),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__yul_assignment_operator, 2, 0, 0),
  [1236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 3, 0, 6),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 3, 0, 6),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [1246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0),
  [1248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0),
  [1250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0), SHIFT_REPEAT(791),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 2, 0, 0),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_repeat1, 2, 0, 0),
  [1257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [1260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 2, 0, 0), SHIFT_REPEAT(315),
  [1263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 2, 0, 6),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 2, 0, 6),
  [1267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility, 1, 0, 0),
  [1269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility, 1, 0, 0),
  [1271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 2, 0, 0),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 2, 0, 0),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 4, 0, 0),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 4, 0, 0),
  [1279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 5, 0, 0),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 5, 0, 0),
  [1283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_state_mutability, 1, 0, 0),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_state_mutability, 1, 0, 0),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameter_list, 3, 0, 0),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 3, 0, 0),
  [1291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 1, 0, 0),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 1, 0, 0),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [1297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_user_defined_type, 1, 0, 0),
  [1299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_user_defined_type, 1, 0, 0),
  [1301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_type, 2, 0, 0),
  [1303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_type, 2, 0, 0),
  [1305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, 0, 1),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, 0, 1),
  [1309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__return_parameters, 4, 0, 48),
  [1311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_parameters, 4, 0, 48),
  [1313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__return_parameters, 6, 0, 48),
  [1315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_parameters, 6, 0, 48),
  [1317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 6, 0, 49),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 6, 0, 49),
  [1321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 7, 0, 58),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 7, 0, 58),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_type, 4, 0, 0),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_type, 4, 0, 0),
  [1329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array_type, 3, 0, 0),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array_type, 3, 0, 0),
  [1333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 7, 0, 57),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 7, 0, 57),
  [1337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__mapping, 8, 0, 68),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__mapping, 8, 0, 68),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_type, 4, 0, 6),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_type, 4, 0, 6),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, 0, 0),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, 0, 0),
  [1349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__return_parameters, 5, 0, 48),
  [1351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__return_parameters, 5, 0, 48),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1, 0, 0),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1, 0, 0),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, 0, 2),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, 0, 2),
  [1363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 5, 0, 0),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 5, 0, 0),
  [1367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 2, 0, 0),
  [1369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 2, 0, 0),
  [1371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 3, 0, 0),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 3, 0, 0),
  [1375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__call_arguments, 4, 0, 0),
  [1377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__call_arguments, 4, 0, 0),
  [1379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_path, 2, 0, 0),
  [1381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_path, 2, 0, 0),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_path, 1, 0, 0),
  [1385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), REDUCE(sym__identifier_path, 1, 0, 0),
  [1388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), REDUCE(sym__identifier_path, 1, 0, 0),
  [1391] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), REDUCE(sym__identifier_path, 1, 0, 0), SHIFT(776),
  [1395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0), REDUCE(sym_member_expression, 3, 1, 39),
  [1398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__identifier_path_repeat1, 2, 0, 0), REDUCE(sym_member_expression, 3, 1, 39),
  [1401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [1403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [1405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(495),
  [1408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(481),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 1, 0, 0),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 1, 0, 0),
  [1415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 2, 0, 0),
  [1417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 2, 0, 0),
  [1419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(713),
  [1422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hex_string_literal, 1, 0, 0),
  [1424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hex_string_literal, 1, 0, 0),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 2, 0, 0),
  [1430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 2, 0, 0),
  [1432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 2, 0, 0), SHIFT_REPEAT(711),
  [1435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unicode_string_literal, 1, 0, 0),
  [1437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unicode_string_literal, 1, 0, 0),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 40),
  [1443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 40),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 4, 0, 0),
  [1461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 4, 0, 0),
  [1463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 4, 0, 0),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 4, 0, 0),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0),
  [1469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0),
  [1471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(25),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [1478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, 0, 0),
  [1480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, 0, 0),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 26),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 26),
  [1490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 26),
  [1492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 26),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, 0, 23),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, 0, 23),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 3, 0, 0),
  [1502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 3, 0, 0),
  [1504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, 0, 41),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 3, 0, 0),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat3, 3, 0, 0),
  [1522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat2, 5, 0, 0),
  [1524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_hex_string_literal_repeat2, 5, 0, 0),
  [1526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, 0, 41),
  [1528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_payable_conversion_expression, 2, 0, 0),
  [1530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_payable_conversion_expression, 2, 0, 0),
  [1532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, 0, 27),
  [1534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, 0, 27),
  [1536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_false, 1, 0, 0),
  [1538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_false, 1, 0, 0),
  [1540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 5, 0, 0),
  [1542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 5, 0, 0),
  [1544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 5, 0, 60),
  [1546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 5, 0, 60),
  [1548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 3, 0, 14),
  [1550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 3, 0, 14),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, 1, 39),
  [1554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, 1, 39),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [1558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 3, 0, 42),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 3, 0, 42),
  [1564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [1566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 5, 0, 61),
  [1570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 5, 0, 61),
  [1572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_type_expression, 4, 0, 0),
  [1574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_type_expression, 4, 0, 0),
  [1576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [1578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [1580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 6, 0, 14),
  [1582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 6, 0, 14),
  [1584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 6, 0, 69),
  [1586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 6, 0, 69),
  [1588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [1590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [1592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 2, 0, 0),
  [1594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 2, 0, 0),
  [1596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 4, 0, 0),
  [1598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 4, 0, 0),
  [1600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_array_expression, 3, 0, 0),
  [1602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_array_expression, 3, 0, 0),
  [1604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, 0, 23),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, 0, 23),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [1610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [1612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 5, 0, 14),
  [1622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 5, 0, 14),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, 0, 28),
  [1626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, 0, 28),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast_expression, 2, 0, 0),
  [1630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast_expression, 2, 0, 0),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_unit, 1, 0, 0),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_unit, 1, 0, 0),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 2, 0, 0),
  [1638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 2, 0, 0),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), REDUCE(sym_type_name, 1, 0, 0),
  [1643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_true, 1, 0, 0),
  [1645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_true, 1, 0, 0),
  [1647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_access, 4, 0, 51),
  [1649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_access, 4, 0, 51),
  [1651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_access, 4, 0, 42),
  [1653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_access, 4, 0, 42),
  [1655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 4, 0, 14),
  [1657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 4, 0, 14),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [1677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 1, 0, 0),
  [1679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_struct_argument, 3, 0, 59),
  [1681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inline_array_expression_repeat1, 2, 0, 0),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_field_assignment, 3, 0, 59),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_tuple, 3, 0, 0),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration_tuple, 2, 0, 0),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_path, 1, 0, 0),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [1766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [1768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0),
  [1770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [1773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(315),
  [1776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(451),
  [1779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_function_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(449),
  [1782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [1785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0),
  [1787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [1790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(315),
  [1793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(451),
  [1796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(450),
  [1799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 1, 0, 0),
  [1801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 1, 0, 0),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [1805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 1, 0, 0), REDUCE(aux_sym__function_type_repeat1, 1, 0, 0),
  [1808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 1, 0, 0),
  [1810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__function_type_repeat1, 1, 0, 0),
  [1812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_fallback_receive_definition_repeat1, 1, 0, 0),
  [1814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__function_type_repeat1, 1, 0, 0),
  [1816] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 5, 0, 0),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 5, 0, 0),
  [1820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 4, 0, 0),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 4, 0, 0),
  [1824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_override_specifier, 6, 0, 0),
  [1826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_override_specifier, 6, 0, 0),
  [1828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_invocation, 1, 0, 0),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_invocation, 1, 0, 0),
  [1832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier_invocation, 2, 0, 0),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier_invocation, 2, 0, 0),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_solidity_pragma_token, 1, 0, 0),
  [1844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 15), SHIFT_REPEAT(462),
  [1847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 15), SHIFT_REPEAT(770),
  [1850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 15), SHIFT_REPEAT(770),
  [1853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 15),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_solidity_pragma_token, 2, 0, 8),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 1, 0, 7),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 1, 0, 7),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pragma_version_constraint, 2, 0, 0),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pragma_version_constraint, 2, 0, 0),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, 0, 44),
  [1873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, 0, 44), SHIFT_REPEAT(464),
  [1876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, 0, 44), SHIFT_REPEAT(311),
  [1879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 2, 0, 44), SHIFT_REPEAT(451),
  [1882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [1884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [1900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 7),
  [1912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_solidity_pragma_token_repeat1, 2, 0, 7),
  [1914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructor_definition_repeat1, 2, 0, 0),
  [1919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_constructor_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(472),
  [1922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_state_variable_declaration_repeat1, 1, 0, 32),
  [1924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 14),
  [1928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [1930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [1936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [1938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nameless_parameter, 1, 0, 14),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [1944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_modifier_definition_repeat1, 2, 0, 0),
  [1946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifier_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(451),
  [1949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_modifier_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(480),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [1962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 1, 0, 14),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [1966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(483),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat1, 2, 0, 0),
  [1971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_hex_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(740),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [1986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(486),
  [1989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(486),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [1996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0),
  [1998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(488),
  [2001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2, 0, 0), SHIFT_REPEAT(488),
  [2004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [2006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_heritage, 4, 0, 0),
  [2020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_heritage, 3, 0, 0),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [2026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat2, 2, 0, 0),
  [2044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(502),
  [2047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_unicode_string_literal_repeat1, 2, 0, 0),
  [2049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unicode_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(503),
  [2052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_alias, 2, 0, 16),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [2062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_parameter, 1, 0, 14),
  [2064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inheritance_specifier, 1, 0, 21),
  [2066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [2080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_declaration, 1, 0, 3),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, 0, 35),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 24),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [2118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assembly_flags_repeat1, 2, 0, 0), SHIFT_REPEAT(609),
  [2121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assembly_flags_repeat1, 2, 0, 0),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat2, 1, 0, 0),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [2149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__call_arguments_repeat1, 2, 0, 0), SHIFT_REPEAT(27),
  [2152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__call_arguments_repeat1, 2, 0, 0),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [2168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__return_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(131),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__return_parameters_repeat1, 2, 0, 0),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [2177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(689),
  [2180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_expression_repeat1, 2, 0, 0),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__class_heritage, 2, 0, 0),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 25),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [2220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__multiple_import_repeat1, 2, 0, 30), SHIFT_REPEAT(648),
  [2223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__multiple_import_repeat1, 2, 0, 30),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(108),
  [2230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat1, 2, 0, 0),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [2252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(132),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_yul_function_call_repeat1, 2, 0, 0), SHIFT_REPEAT(297),
  [2264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_yul_function_call_repeat1, 2, 0, 0),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [2296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat2, 2, 0, 0), SHIFT_REPEAT(638),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_tuple_repeat2, 2, 0, 0),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [2303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 2, 0, 14),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [2309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__source_import, 1, 0, 5),
  [2311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_array_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 1, 0, 3),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [2322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_override_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(632),
  [2325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_override_specifier_repeat1, 2, 0, 0),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 1, 0, 0),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [2347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_call_argument_repeat1, 2, 0, 0), SHIFT_REPEAT(676),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_call_argument_repeat1, 2, 0, 0),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__class_heritage_repeat1, 2, 0, 0),
  [2368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__class_heritage_repeat1, 2, 0, 0), SHIFT_REPEAT(525),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [2379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_error_declaration_repeat1, 2, 0, 0), SHIFT_REPEAT(128),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_error_declaration_repeat1, 2, 0, 0),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [2392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(32),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0), SHIFT_REPEAT(757),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__event_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(130),
  [2411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__event_parameter_list_repeat1, 2, 0, 0),
  [2413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 5, 0, 0),
  [2415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 3, 0, 0),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 3, 0, 45),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__return_parameters_repeat1, 2, 0, 56),
  [2431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_declaration, 2, 0, 10),
  [2433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [2435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 4, 0, 0),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 34),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [2443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nameless_parameter, 2, 0, 25),
  [2445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 5, 0, 0),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [2471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 4, 0, 0),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [2475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_argument, 2, 0, 0),
  [2477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 2, 0, 0),
  [2479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, 0, 24),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [2497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [2499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__multiple_import_repeat1, 2, 0, 17),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_type_definition, 2, 0, 0),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inheritance_specifier, 2, 0, 33),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_parameter, 2, 0, 24),
  [2517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__event_parameter_list, 3, 0, 0),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_parameter, 2, 0, 24),
  [2525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 35),
  [2527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 2, 0, 9),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_value, 1, 0, 0),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [2567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_any_pragma_token, 2, 0, 0),
  [2569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 3, 0, 0),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [2575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 4, 0, 29),
  [2577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 3, 0, 0),
  [2579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_any_source_type, 1, 0, 0),
  [2581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 4, 0, 17),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_solidity_version_comparison_operator, 1, 0, 0),
  [2585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_clause, 1, 0, 4),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [2599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 4, 0, 0),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 6, 0, 0),
  [2605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 2, 0, 0),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 5, 0, 0),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__single_import, 2, 0, 10),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [2631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 2, 0, 0),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [2635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 5, 0, 29),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration_tuple, 5, 0, 0),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2655] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, 0, 18),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assembly_flags, 4, 0, 0),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__source_import, 2, 0, 12),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__multiple_import, 3, 0, 17),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_solidity(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
