#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 2260
#define LARGE_STATE_COUNT 95
#define SYMBOL_COUNT 253
#define ALIAS_COUNT 3
#define TOKEN_COUNT 116
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 29
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 115

enum ts_symbol_identifiers {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_import = 3,
  anon_sym_DOT = 4,
  anon_sym_from = 5,
  anon_sym___future__ = 6,
  anon_sym_LPAREN = 7,
  anon_sym_RPAREN = 8,
  anon_sym_COMMA = 9,
  anon_sym_as = 10,
  anon_sym_STAR = 11,
  anon_sym_print = 12,
  anon_sym_GT_GT = 13,
  anon_sym_assert = 14,
  anon_sym_eq = 15,
  anon_sym_ne = 16,
  anon_sym_contains = 17,
  anon_sym_fails = 18,
  anon_sym_assert_ = 19,
  anon_sym_assert_eq = 20,
  anon_sym_assert_ne = 21,
  anon_sym_assert_contains = 22,
  anon_sym_assert_fails = 23,
  anon_sym_COLON_EQ = 24,
  anon_sym_return = 25,
  anon_sym_del = 26,
  anon_sym_raise = 27,
  anon_sym_pass = 28,
  anon_sym_break = 29,
  anon_sym_continue = 30,
  anon_sym_if = 31,
  anon_sym_COLON = 32,
  anon_sym_elif = 33,
  anon_sym_else = 34,
  anon_sym_match = 35,
  anon_sym_case = 36,
  anon_sym_async = 37,
  anon_sym_for = 38,
  anon_sym_in = 39,
  anon_sym_while = 40,
  anon_sym_try = 41,
  anon_sym_except = 42,
  anon_sym_finally = 43,
  anon_sym_with = 44,
  anon_sym_def = 45,
  anon_sym_DASH_GT = 46,
  anon_sym_STAR_STAR = 47,
  anon_sym_global = 48,
  anon_sym_nonlocal = 49,
  anon_sym_exec = 50,
  anon_sym_type = 51,
  anon_sym_EQ = 52,
  anon_sym_class = 53,
  anon_sym_LBRACK = 54,
  anon_sym_RBRACK = 55,
  anon_sym_AT = 56,
  anon_sym_DASH = 57,
  anon_sym__ = 58,
  anon_sym_PIPE = 59,
  anon_sym_LBRACE = 60,
  anon_sym_RBRACE = 61,
  anon_sym_PLUS = 62,
  anon_sym_not = 63,
  anon_sym_and = 64,
  anon_sym_or = 65,
  anon_sym_SLASH = 66,
  anon_sym_PERCENT = 67,
  anon_sym_SLASH_SLASH = 68,
  anon_sym_AMP = 69,
  anon_sym_CARET = 70,
  anon_sym_LT_LT = 71,
  anon_sym_TILDE = 72,
  anon_sym_LT = 73,
  anon_sym_LT_EQ = 74,
  anon_sym_EQ_EQ = 75,
  anon_sym_BANG_EQ = 76,
  anon_sym_GT_EQ = 77,
  anon_sym_GT = 78,
  anon_sym_LT_GT = 79,
  anon_sym_lambda = 80,
  anon_sym_PLUS_EQ = 81,
  anon_sym_DASH_EQ = 82,
  anon_sym_STAR_EQ = 83,
  anon_sym_SLASH_EQ = 84,
  anon_sym_AT_EQ = 85,
  anon_sym_SLASH_SLASH_EQ = 86,
  anon_sym_PERCENT_EQ = 87,
  anon_sym_STAR_STAR_EQ = 88,
  anon_sym_GT_GT_EQ = 89,
  anon_sym_LT_LT_EQ = 90,
  anon_sym_AMP_EQ = 91,
  anon_sym_CARET_EQ = 92,
  anon_sym_PIPE_EQ = 93,
  anon_sym_yield = 94,
  sym_ellipsis = 95,
  sym_escape_sequence = 96,
  sym__not_escape_sequence = 97,
  aux_sym_format_specifier_token1 = 98,
  sym_type_conversion = 99,
  sym_integer = 100,
  sym_float = 101,
  anon_sym_await = 102,
  anon_sym_struct = 103,
  sym_true = 104,
  sym_false = 105,
  sym_none = 106,
  sym_comment = 107,
  sym_line_continuation = 108,
  sym__newline = 109,
  sym__indent = 110,
  sym__dedent = 111,
  sym_string_start = 112,
  sym__string_content = 113,
  sym_escape_interpolation = 114,
  sym_string_end = 115,
  sym_module = 116,
  sym__statement = 117,
  sym__simple_statements = 118,
  sym_print_statement = 119,
  sym_chevron = 120,
  sym_assert_statement = 121,
  sym_expression_statement = 122,
  sym_named_expression = 123,
  sym__named_expression_lhs = 124,
  sym_return_statement = 125,
  sym_delete_statement = 126,
  sym_pass_statement = 127,
  sym_break_statement = 128,
  sym_continue_statement = 129,
  sym_if_statement = 130,
  sym_elif_clause = 131,
  sym_else_clause = 132,
  sym_match_statement = 133,
  sym__match_block = 134,
  sym_case_clause = 135,
  sym_for_statement = 136,
  sym_while_statement = 137,
  sym_with_statement = 138,
  sym_with_clause = 139,
  sym_with_item = 140,
  sym_function_definition = 141,
  sym_parameters = 142,
  sym_lambda_parameters = 143,
  sym_list_splat = 144,
  sym_dictionary_splat = 145,
  sym_exec_statement = 146,
  sym_type_parameter = 147,
  sym_parenthesized_list_splat = 148,
  sym_argument_list = 149,
  sym_decorated_definition = 150,
  sym_decorator = 151,
  sym_block = 152,
  sym_expression_list = 153,
  sym_dotted_name = 154,
  sym_case_pattern = 155,
  sym__simple_pattern = 156,
  sym__as_pattern = 157,
  sym_union_pattern = 158,
  sym__list_pattern = 159,
  sym__tuple_pattern = 160,
  sym_dict_pattern = 161,
  sym__key_value_pattern = 162,
  sym_keyword_pattern = 163,
  sym_splat_pattern = 164,
  sym_class_pattern = 165,
  sym_complex_pattern = 166,
  sym__parameters = 167,
  sym__patterns = 168,
  sym_parameter = 169,
  sym_pattern = 170,
  sym_tuple_pattern = 171,
  sym_list_pattern = 172,
  sym_default_parameter = 173,
  sym_typed_default_parameter = 174,
  sym_list_splat_pattern = 175,
  sym_dictionary_splat_pattern = 176,
  sym_as_pattern = 177,
  sym__expression_within_for_in_clause = 178,
  sym_expression = 179,
  sym_primary_expression = 180,
  sym_not_operator = 181,
  sym_boolean_operator = 182,
  sym_binary_operator = 183,
  sym_unary_operator = 184,
  sym_comparison_operator = 185,
  sym_lambda = 186,
  sym_lambda_within_for_in_clause = 187,
  sym_assignment = 188,
  sym_augmented_assignment = 189,
  sym_pattern_list = 190,
  sym__right_hand_side = 191,
  sym_attribute = 192,
  sym_subscript = 193,
  sym_slice = 194,
  sym_call = 195,
  sym_typed_parameter = 196,
  sym_type = 197,
  sym_splat_type = 198,
  sym_generic_type = 199,
  sym_union_type = 200,
  sym_constrained_type = 201,
  sym_member_type = 202,
  sym_keyword_argument = 203,
  sym_list = 204,
  sym_set = 205,
  sym_tuple = 206,
  sym_dictionary = 207,
  sym_pair = 208,
  sym_list_comprehension = 209,
  sym_dictionary_comprehension = 210,
  sym_set_comprehension = 211,
  sym__comprehension_clauses = 212,
  sym_parenthesized_expression = 213,
  sym__collection_elements = 214,
  sym_for_in_clause = 215,
  sym_if_clause = 216,
  sym_conditional_expression = 217,
  sym_concatenated_string = 218,
  sym_string = 219,
  sym_string_content = 220,
  sym_interpolation = 221,
  sym__f_expression = 222,
  sym_format_specifier = 223,
  sym_positional_separator = 224,
  sym_keyword_separator = 225,
  aux_sym_module_repeat1 = 226,
  aux_sym__simple_statements_repeat1 = 227,
  aux_sym_print_statement_repeat1 = 228,
  aux_sym_assert_statement_repeat1 = 229,
  aux_sym_if_statement_repeat1 = 230,
  aux_sym_match_statement_repeat1 = 231,
  aux_sym__match_block_repeat1 = 232,
  aux_sym_case_clause_repeat1 = 233,
  aux_sym_with_clause_repeat1 = 234,
  aux_sym_type_parameter_repeat1 = 235,
  aux_sym_argument_list_repeat1 = 236,
  aux_sym_decorated_definition_repeat1 = 237,
  aux_sym_dotted_name_repeat1 = 238,
  aux_sym_union_pattern_repeat1 = 239,
  aux_sym_dict_pattern_repeat1 = 240,
  aux_sym__parameters_repeat1 = 241,
  aux_sym__patterns_repeat1 = 242,
  aux_sym_comparison_operator_repeat1 = 243,
  aux_sym_subscript_repeat1 = 244,
  aux_sym_dictionary_repeat1 = 245,
  aux_sym__comprehension_clauses_repeat1 = 246,
  aux_sym__collection_elements_repeat1 = 247,
  aux_sym_for_in_clause_repeat1 = 248,
  aux_sym_concatenated_string_repeat1 = 249,
  aux_sym_string_repeat1 = 250,
  aux_sym_string_content_repeat1 = 251,
  aux_sym_format_specifier_repeat1 = 252,
  alias_sym_as_pattern_target = 253,
  alias_sym_format_expression = 254,
  anon_alias_sym_notin = 255,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert_keyword",
  [anon_sym_eq] = "assert_builtin",
  [anon_sym_ne] = "assert_builtin",
  [anon_sym_contains] = "assert_builtin",
  [anon_sym_fails] = "assert_builtin",
  [anon_sym_assert_] = "assert_keyword",
  [anon_sym_assert_eq] = "assert_keyword",
  [anon_sym_assert_ne] = "assert_keyword",
  [anon_sym_assert_contains] = "assert_keyword",
  [anon_sym_assert_fails] = "assert_keyword",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_match] = "match",
  [anon_sym_case] = "case",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT] = "@",
  [anon_sym_DASH] = "-",
  [anon_sym__] = "_",
  [anon_sym_PIPE] = "|",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PLUS] = "+",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [sym_ellipsis] = "ellipsis",
  [sym_escape_sequence] = "escape_sequence",
  [sym__not_escape_sequence] = "_not_escape_sequence",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [anon_sym_await] = "await",
  [anon_sym_struct] = "identifier",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [sym_comment] = "comment",
  [sym_line_continuation] = "line_continuation",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym_string_start] = "string_start",
  [sym__string_content] = "_string_content",
  [sym_escape_interpolation] = "escape_interpolation",
  [sym_string_end] = "string_end",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym__named_expression_lhs] = "_named_expression_lhs",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_match_statement] = "match_statement",
  [sym__match_block] = "block",
  [sym_case_clause] = "case_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_with_statement] = "with_statement",
  [sym_with_clause] = "with_clause",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_exec_statement] = "exec_statement",
  [sym_type_parameter] = "type_parameter",
  [sym_parenthesized_list_splat] = "parenthesized_list_splat",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym_block] = "block",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym_case_pattern] = "case_pattern",
  [sym__simple_pattern] = "_simple_pattern",
  [sym__as_pattern] = "as_pattern",
  [sym_union_pattern] = "union_pattern",
  [sym__list_pattern] = "list_pattern",
  [sym__tuple_pattern] = "tuple_pattern",
  [sym_dict_pattern] = "dict_pattern",
  [sym__key_value_pattern] = "_key_value_pattern",
  [sym_keyword_pattern] = "keyword_pattern",
  [sym_splat_pattern] = "splat_pattern",
  [sym_class_pattern] = "class_pattern",
  [sym_complex_pattern] = "complex_pattern",
  [sym__parameters] = "_parameters",
  [sym__patterns] = "_patterns",
  [sym_parameter] = "parameter",
  [sym_pattern] = "pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_list_pattern] = "list_pattern",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat_pattern] = "list_splat_pattern",
  [sym_dictionary_splat_pattern] = "dictionary_splat_pattern",
  [sym_as_pattern] = "as_pattern",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym_expression] = "expression",
  [sym_primary_expression] = "primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym_pattern_list] = "pattern_list",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_splat_type] = "splat_type",
  [sym_generic_type] = "generic_type",
  [sym_union_type] = "union_type",
  [sym_constrained_type] = "constrained_type",
  [sym_member_type] = "member_type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym_set] = "set",
  [sym_tuple] = "tuple",
  [sym_dictionary] = "dictionary",
  [sym_pair] = "pair",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_set_comprehension] = "set_comprehension",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__collection_elements] = "_collection_elements",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_string_content] = "string_content",
  [sym_interpolation] = "interpolation",
  [sym__f_expression] = "_f_expression",
  [sym_format_specifier] = "format_specifier",
  [sym_positional_separator] = "positional_separator",
  [sym_keyword_separator] = "keyword_separator",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_match_statement_repeat1] = "match_statement_repeat1",
  [aux_sym__match_block_repeat1] = "_match_block_repeat1",
  [aux_sym_case_clause_repeat1] = "case_clause_repeat1",
  [aux_sym_with_clause_repeat1] = "with_clause_repeat1",
  [aux_sym_type_parameter_repeat1] = "type_parameter_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_union_pattern_repeat1] = "union_pattern_repeat1",
  [aux_sym_dict_pattern_repeat1] = "dict_pattern_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym__patterns_repeat1] = "_patterns_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym__collection_elements_repeat1] = "_collection_elements_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_content_repeat1] = "string_content_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
  [alias_sym_as_pattern_target] = "as_pattern_target",
  [alias_sym_format_expression] = "format_expression",
  [anon_alias_sym_notin] = "not in",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_from] = anon_sym_from,
  [anon_sym___future__] = anon_sym___future__,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_eq] = anon_sym_eq,
  [anon_sym_ne] = anon_sym_eq,
  [anon_sym_contains] = anon_sym_eq,
  [anon_sym_fails] = anon_sym_eq,
  [anon_sym_assert_] = anon_sym_assert,
  [anon_sym_assert_eq] = anon_sym_assert,
  [anon_sym_assert_ne] = anon_sym_assert,
  [anon_sym_assert_contains] = anon_sym_assert,
  [anon_sym_assert_fails] = anon_sym_assert,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_del] = anon_sym_del,
  [anon_sym_raise] = anon_sym_raise,
  [anon_sym_pass] = anon_sym_pass,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_except] = anon_sym_except,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_nonlocal] = anon_sym_nonlocal,
  [anon_sym_exec] = anon_sym_exec,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym__] = anon_sym__,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_lambda] = anon_sym_lambda,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AT_EQ] = anon_sym_AT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_yield] = anon_sym_yield,
  [sym_ellipsis] = sym_ellipsis,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__not_escape_sequence] = sym__not_escape_sequence,
  [aux_sym_format_specifier_token1] = aux_sym_format_specifier_token1,
  [sym_type_conversion] = sym_type_conversion,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_struct] = sym_identifier,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_none] = sym_none,
  [sym_comment] = sym_comment,
  [sym_line_continuation] = sym_line_continuation,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym_string_start] = sym_string_start,
  [sym__string_content] = sym__string_content,
  [sym_escape_interpolation] = sym_escape_interpolation,
  [sym_string_end] = sym_string_end,
  [sym_module] = sym_module,
  [sym__statement] = sym__statement,
  [sym__simple_statements] = sym__simple_statements,
  [sym_print_statement] = sym_print_statement,
  [sym_chevron] = sym_chevron,
  [sym_assert_statement] = sym_assert_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_named_expression] = sym_named_expression,
  [sym__named_expression_lhs] = sym__named_expression_lhs,
  [sym_return_statement] = sym_return_statement,
  [sym_delete_statement] = sym_delete_statement,
  [sym_pass_statement] = sym_pass_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elif_clause] = sym_elif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_match_statement] = sym_match_statement,
  [sym__match_block] = sym_block,
  [sym_case_clause] = sym_case_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_with_clause] = sym_with_clause,
  [sym_with_item] = sym_with_item,
  [sym_function_definition] = sym_function_definition,
  [sym_parameters] = sym_parameters,
  [sym_lambda_parameters] = sym_lambda_parameters,
  [sym_list_splat] = sym_list_splat,
  [sym_dictionary_splat] = sym_dictionary_splat,
  [sym_exec_statement] = sym_exec_statement,
  [sym_type_parameter] = sym_type_parameter,
  [sym_parenthesized_list_splat] = sym_parenthesized_list_splat,
  [sym_argument_list] = sym_argument_list,
  [sym_decorated_definition] = sym_decorated_definition,
  [sym_decorator] = sym_decorator,
  [sym_block] = sym_block,
  [sym_expression_list] = sym_expression_list,
  [sym_dotted_name] = sym_dotted_name,
  [sym_case_pattern] = sym_case_pattern,
  [sym__simple_pattern] = sym__simple_pattern,
  [sym__as_pattern] = sym_as_pattern,
  [sym_union_pattern] = sym_union_pattern,
  [sym__list_pattern] = sym_list_pattern,
  [sym__tuple_pattern] = sym_tuple_pattern,
  [sym_dict_pattern] = sym_dict_pattern,
  [sym__key_value_pattern] = sym__key_value_pattern,
  [sym_keyword_pattern] = sym_keyword_pattern,
  [sym_splat_pattern] = sym_splat_pattern,
  [sym_class_pattern] = sym_class_pattern,
  [sym_complex_pattern] = sym_complex_pattern,
  [sym__parameters] = sym__parameters,
  [sym__patterns] = sym__patterns,
  [sym_parameter] = sym_parameter,
  [sym_pattern] = sym_pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_list_pattern] = sym_list_pattern,
  [sym_default_parameter] = sym_default_parameter,
  [sym_typed_default_parameter] = sym_typed_default_parameter,
  [sym_list_splat_pattern] = sym_list_splat_pattern,
  [sym_dictionary_splat_pattern] = sym_dictionary_splat_pattern,
  [sym_as_pattern] = sym_as_pattern,
  [sym__expression_within_for_in_clause] = sym__expression_within_for_in_clause,
  [sym_expression] = sym_expression,
  [sym_primary_expression] = sym_primary_expression,
  [sym_not_operator] = sym_not_operator,
  [sym_boolean_operator] = sym_boolean_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_lambda] = sym_lambda,
  [sym_lambda_within_for_in_clause] = sym_lambda,
  [sym_assignment] = sym_assignment,
  [sym_augmented_assignment] = sym_augmented_assignment,
  [sym_pattern_list] = sym_pattern_list,
  [sym__right_hand_side] = sym__right_hand_side,
  [sym_attribute] = sym_attribute,
  [sym_subscript] = sym_subscript,
  [sym_slice] = sym_slice,
  [sym_call] = sym_call,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_type] = sym_type,
  [sym_splat_type] = sym_splat_type,
  [sym_generic_type] = sym_generic_type,
  [sym_union_type] = sym_union_type,
  [sym_constrained_type] = sym_constrained_type,
  [sym_member_type] = sym_member_type,
  [sym_keyword_argument] = sym_keyword_argument,
  [sym_list] = sym_list,
  [sym_set] = sym_set,
  [sym_tuple] = sym_tuple,
  [sym_dictionary] = sym_dictionary,
  [sym_pair] = sym_pair,
  [sym_list_comprehension] = sym_list_comprehension,
  [sym_dictionary_comprehension] = sym_dictionary_comprehension,
  [sym_set_comprehension] = sym_set_comprehension,
  [sym__comprehension_clauses] = sym__comprehension_clauses,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__collection_elements] = sym__collection_elements,
  [sym_for_in_clause] = sym_for_in_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string] = sym_string,
  [sym_string_content] = sym_string_content,
  [sym_interpolation] = sym_interpolation,
  [sym__f_expression] = sym__f_expression,
  [sym_format_specifier] = sym_format_specifier,
  [sym_positional_separator] = sym_positional_separator,
  [sym_keyword_separator] = sym_keyword_separator,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym__simple_statements_repeat1] = aux_sym__simple_statements_repeat1,
  [aux_sym_print_statement_repeat1] = aux_sym_print_statement_repeat1,
  [aux_sym_assert_statement_repeat1] = aux_sym_assert_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_match_statement_repeat1] = aux_sym_match_statement_repeat1,
  [aux_sym__match_block_repeat1] = aux_sym__match_block_repeat1,
  [aux_sym_case_clause_repeat1] = aux_sym_case_clause_repeat1,
  [aux_sym_with_clause_repeat1] = aux_sym_with_clause_repeat1,
  [aux_sym_type_parameter_repeat1] = aux_sym_type_parameter_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_decorated_definition_repeat1] = aux_sym_decorated_definition_repeat1,
  [aux_sym_dotted_name_repeat1] = aux_sym_dotted_name_repeat1,
  [aux_sym_union_pattern_repeat1] = aux_sym_union_pattern_repeat1,
  [aux_sym_dict_pattern_repeat1] = aux_sym_dict_pattern_repeat1,
  [aux_sym__parameters_repeat1] = aux_sym__parameters_repeat1,
  [aux_sym__patterns_repeat1] = aux_sym__patterns_repeat1,
  [aux_sym_comparison_operator_repeat1] = aux_sym_comparison_operator_repeat1,
  [aux_sym_subscript_repeat1] = aux_sym_subscript_repeat1,
  [aux_sym_dictionary_repeat1] = aux_sym_dictionary_repeat1,
  [aux_sym__comprehension_clauses_repeat1] = aux_sym__comprehension_clauses_repeat1,
  [aux_sym__collection_elements_repeat1] = aux_sym__collection_elements_repeat1,
  [aux_sym_for_in_clause_repeat1] = aux_sym_for_in_clause_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_content_repeat1] = aux_sym_string_content_repeat1,
  [aux_sym_format_specifier_repeat1] = aux_sym_format_specifier_repeat1,
  [alias_sym_as_pattern_target] = alias_sym_as_pattern_target,
  [alias_sym_format_expression] = alias_sym_format_expression,
  [anon_alias_sym_notin] = anon_alias_sym_notin,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_eq] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_ne] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_contains] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_fails] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_assert_] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_assert_eq] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_assert_ne] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_assert_contains] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_assert_fails] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__not_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_line_continuation] = {
    .visible = true,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym_string_start] = {
    .visible = true,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_escape_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string_end] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__named_expression_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_match_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_case_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym_case_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym__as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_union_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dict_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__key_value_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_keyword_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_class_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_complex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym__patterns] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_pattern] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_as_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_primary_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_list] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type] = {
    .visible = true,
    .named = true,
  },
  [sym_member_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__collection_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym__f_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_separator] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_separator] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_union_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dict_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__patterns_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__collection_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_as_pattern_target] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [anon_alias_sym_notin] = {
    .visible = true,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_code = 7,
  field_condition = 8,
  field_consequence = 9,
  field_definition = 10,
  field_expression = 11,
  field_format_specifier = 12,
  field_function = 13,
  field_guard = 14,
  field_key = 15,
  field_left = 16,
  field_name = 17,
  field_object = 18,
  field_operator = 19,
  field_operators = 20,
  field_parameters = 21,
  field_return_type = 22,
  field_right = 23,
  field_subject = 24,
  field_subscript = 25,
  field_type = 26,
  field_type_conversion = 27,
  field_type_parameters = 28,
  field_value = 29,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_definition] = "definition",
  [field_expression] = "expression",
  [field_format_specifier] = "format_specifier",
  [field_function] = "function",
  [field_guard] = "guard",
  [field_key] = "key",
  [field_left] = "left",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_operators] = "operators",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_subject] = "subject",
  [field_subscript] = "subscript",
  [field_type] = "type",
  [field_type_conversion] = "type_conversion",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [4] = {.index = 0, .length = 1},
  [5] = {.index = 1, .length = 1},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 3, .length = 2},
  [8] = {.index = 5, .length = 2},
  [9] = {.index = 7, .length = 1},
  [10] = {.index = 8, .length = 1},
  [11] = {.index = 9, .length = 1},
  [12] = {.index = 10, .length = 2},
  [13] = {.index = 12, .length = 1},
  [14] = {.index = 13, .length = 2},
  [15] = {.index = 15, .length = 2},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 3},
  [18] = {.index = 22, .length = 1},
  [19] = {.index = 23, .length = 2},
  [20] = {.index = 25, .length = 1},
  [21] = {.index = 26, .length = 2},
  [22] = {.index = 28, .length = 1},
  [24] = {.index = 29, .length = 2},
  [25] = {.index = 31, .length = 2},
  [26] = {.index = 33, .length = 1},
  [27] = {.index = 34, .length = 3},
  [28] = {.index = 37, .length = 2},
  [29] = {.index = 39, .length = 2},
  [30] = {.index = 41, .length = 1},
  [31] = {.index = 42, .length = 1},
  [32] = {.index = 43, .length = 2},
  [33] = {.index = 45, .length = 1},
  [34] = {.index = 46, .length = 2},
  [35] = {.index = 48, .length = 2},
  [36] = {.index = 50, .length = 2},
  [38] = {.index = 52, .length = 2},
  [39] = {.index = 54, .length = 2},
  [40] = {.index = 56, .length = 1},
  [41] = {.index = 57, .length = 3},
  [42] = {.index = 60, .length = 3},
  [43] = {.index = 63, .length = 3},
  [44] = {.index = 66, .length = 3},
  [45] = {.index = 69, .length = 4},
  [46] = {.index = 73, .length = 1},
  [47] = {.index = 74, .length = 3},
  [48] = {.index = 77, .length = 3},
  [49] = {.index = 80, .length = 2},
  [50] = {.index = 82, .length = 3},
  [51] = {.index = 85, .length = 3},
  [52] = {.index = 13, .length = 2},
  [53] = {.index = 88, .length = 1},
  [54] = {.index = 89, .length = 3},
  [55] = {.index = 92, .length = 2},
  [56] = {.index = 94, .length = 2},
  [57] = {.index = 96, .length = 2},
  [58] = {.index = 98, .length = 3},
  [59] = {.index = 101, .length = 4},
  [60] = {.index = 105, .length = 2},
  [61] = {.index = 107, .length = 4},
  [62] = {.index = 111, .length = 4},
  [63] = {.index = 115, .length = 1},
  [64] = {.index = 116, .length = 4},
  [65] = {.index = 120, .length = 2},
  [66] = {.index = 122, .length = 3},
  [67] = {.index = 125, .length = 3},
  [68] = {.index = 128, .length = 4},
  [69] = {.index = 132, .length = 4},
  [70] = {.index = 136, .length = 4},
  [71] = {.index = 140, .length = 2},
  [72] = {.index = 142, .length = 3},
  [73] = {.index = 145, .length = 3},
  [74] = {.index = 12, .length = 1},
  [75] = {.index = 148, .length = 5},
  [76] = {.index = 153, .length = 3},
  [77] = {.index = 156, .length = 4},
  [78] = {.index = 160, .length = 4},
  [79] = {.index = 164, .length = 4},
  [80] = {.index = 168, .length = 4},
  [81] = {.index = 172, .length = 4},
  [82] = {.index = 176, .length = 5},
  [83] = {.index = 181, .length = 2},
  [84] = {.index = 183, .length = 3},
  [85] = {.index = 186, .length = 2},
  [86] = {.index = 188, .length = 2},
  [87] = {.index = 190, .length = 1},
  [88] = {.index = 191, .length = 4},
  [89] = {.index = 195, .length = 4},
  [90] = {.index = 199, .length = 4},
  [91] = {.index = 203, .length = 5},
  [92] = {.index = 208, .length = 5},
  [93] = {.index = 213, .length = 5},
  [94] = {.index = 218, .length = 5},
  [95] = {.index = 223, .length = 3},
  [96] = {.index = 226, .length = 4},
  [97] = {.index = 230, .length = 4},
  [98] = {.index = 234, .length = 2},
  [99] = {.index = 236, .length = 1},
  [100] = {.index = 237, .length = 2},
  [101] = {.index = 239, .length = 2},
  [102] = {.index = 241, .length = 5},
  [103] = {.index = 246, .length = 5},
  [104] = {.index = 251, .length = 5},
  [105] = {.index = 256, .length = 6},
  [106] = {.index = 262, .length = 2},
  [107] = {.index = 264, .length = 2},
  [108] = {.index = 266, .length = 3},
  [109] = {.index = 269, .length = 1},
  [110] = {.index = 270, .length = 6},
  [111] = {.index = 276, .length = 3},
  [112] = {.index = 279, .length = 2},
  [113] = {.index = 281, .length = 2},
  [114] = {.index = 283, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_argument, 1},
  [1] =
    {field_value, 0},
  [2] =
    {field_code, 1},
  [3] =
    {field_argument, 1},
    {field_operator, 0},
  [5] =
    {field_arguments, 1},
    {field_function, 0},
  [7] =
    {field_operators, 1, .inherited = true},
  [8] =
    {field_definition, 1},
  [9] =
    {field_argument, 2, .inherited = true},
  [10] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [12] =
    {field_body, 2},
  [13] =
    {field_name, 0},
    {field_value, 2},
  [15] =
    {field_left, 0},
    {field_type, 2},
  [17] =
    {field_left, 0},
    {field_right, 2},
  [19] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [22] =
    {field_alias, 2},
  [23] =
    {field_attribute, 2},
    {field_object, 0},
  [25] =
    {field_operators, 0},
  [26] =
    {field_operators, 0, .inherited = true},
    {field_operators, 1, .inherited = true},
  [28] =
    {field_expression, 1},
  [29] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [31] =
    {field_condition, 1},
    {field_consequence, 3},
  [33] =
    {field_subject, 1},
  [34] =
    {field_alternative, 3, .inherited = true},
    {field_body, 3},
    {field_subject, 1},
  [37] =
    {field_subject, 0, .inherited = true},
    {field_subject, 1, .inherited = true},
  [39] =
    {field_body, 3},
    {field_condition, 1},
  [41] =
    {field_body, 3},
  [42] =
    {field_body, 1},
  [43] =
    {field_key, 0},
    {field_value, 2},
  [45] =
    {field_type, 2},
  [46] =
    {field_body, 3},
    {field_parameters, 1},
  [48] =
    {field_subscript, 2},
    {field_value, 0},
  [50] =
    {field_operators, 0},
    {field_operators, 1},
  [52] =
    {field_expression, 1},
    {field_type_conversion, 2},
  [54] =
    {field_expression, 1},
    {field_format_specifier, 2},
  [56] =
    {field_alternative, 0},
  [57] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [60] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [63] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [66] =
    {field_alternative, 4, .inherited = true},
    {field_body, 4},
    {field_subject, 1},
  [69] =
    {field_alternative, 4, .inherited = true},
    {field_body, 4},
    {field_subject, 1},
    {field_subject, 2, .inherited = true},
  [73] =
    {field_body, 4},
  [74] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [77] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [80] =
    {field_body, 3},
    {field_body, 4},
  [82] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [85] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [88] =
    {field_subscript, 1},
  [89] =
    {field_subscript, 2},
    {field_subscript, 3, .inherited = true},
    {field_value, 0},
  [92] =
    {field_subscript, 0, .inherited = true},
    {field_subscript, 1, .inherited = true},
  [94] =
    {field_expression, 1},
    {field_type_conversion, 3},
  [96] =
    {field_expression, 1},
    {field_format_specifier, 3},
  [98] =
    {field_expression, 1},
    {field_format_specifier, 3},
    {field_type_conversion, 2},
  [101] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [105] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [107] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [111] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [115] =
    {field_alternative, 1, .inherited = true},
  [116] =
    {field_alternative, 5, .inherited = true},
    {field_body, 5},
    {field_subject, 1},
    {field_subject, 2, .inherited = true},
  [120] =
    {field_body, 4},
    {field_body, 5},
  [122] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [125] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [128] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [132] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [136] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [140] =
    {field_left, 1},
    {field_right, 3},
  [142] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [145] =
    {field_expression, 1},
    {field_format_specifier, 4},
    {field_type_conversion, 3},
  [148] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [153] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [156] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
  [160] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [164] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [168] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [172] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [176] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [181] =
    {field_left, 2},
    {field_right, 4},
  [183] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [186] =
    {field_body, 2},
    {field_body, 3},
  [188] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [190] =
    {field_consequence, 3},
  [191] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [195] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [199] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [203] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [208] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [213] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [218] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [223] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [226] =
    {field_key, 1, .inherited = true},
    {field_key, 2, .inherited = true},
    {field_value, 1, .inherited = true},
    {field_value, 2, .inherited = true},
  [230] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [234] =
    {field_key, 2, .inherited = true},
    {field_value, 2, .inherited = true},
  [236] =
    {field_consequence, 4},
  [237] =
    {field_consequence, 3},
    {field_consequence, 4},
  [239] =
    {field_consequence, 4},
    {field_guard, 2},
  [241] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [246] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [251] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [256] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [262] =
    {field_consequence, 4},
    {field_consequence, 5},
  [264] =
    {field_consequence, 5},
    {field_guard, 3},
  [266] =
    {field_consequence, 4},
    {field_consequence, 5},
    {field_guard, 2},
  [269] =
    {field_consequence, 5},
  [270] =
    {field_body, 8},
    {field_body, 9},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [276] =
    {field_consequence, 5},
    {field_consequence, 6},
    {field_guard, 3},
  [279] =
    {field_consequence, 5},
    {field_consequence, 6},
  [281] =
    {field_consequence, 6},
    {field_guard, 4},
  [283] =
    {field_consequence, 6},
    {field_consequence, 7},
    {field_guard, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = sym_list_splat,
  },
  [3] = {
    [1] = sym_identifier,
  },
  [18] = {
    [2] = alias_sym_as_pattern_target,
  },
  [23] = {
    [1] = sym_parenthesized_expression,
  },
  [25] = {
    [3] = sym_block,
  },
  [29] = {
    [3] = sym_block,
  },
  [30] = {
    [3] = sym_block,
  },
  [36] = {
    [0] = anon_alias_sym_notin,
    [1] = anon_alias_sym_notin,
  },
  [37] = {
    [0] = alias_sym_format_expression,
  },
  [41] = {
    [3] = sym_block,
  },
  [42] = {
    [3] = sym_block,
  },
  [46] = {
    [4] = sym_block,
  },
  [47] = {
    [3] = sym_block,
  },
  [50] = {
    [4] = sym_block,
  },
  [52] = {
    [0] = sym_identifier,
  },
  [59] = {
    [3] = sym_block,
  },
  [66] = {
    [5] = sym_block,
  },
  [67] = {
    [5] = sym_block,
  },
  [70] = {
    [5] = sym_block,
  },
  [74] = {
    [2] = sym_block,
  },
  [76] = {
    [6] = sym_block,
  },
  [78] = {
    [6] = sym_block,
  },
  [79] = {
    [5] = sym_block,
  },
  [81] = {
    [6] = sym_block,
  },
  [87] = {
    [3] = sym_block,
  },
  [88] = {
    [6] = sym_block,
  },
  [90] = {
    [7] = sym_block,
  },
  [94] = {
    [7] = sym_block,
  },
  [99] = {
    [4] = sym_block,
  },
  [101] = {
    [4] = sym_block,
  },
  [104] = {
    [8] = sym_block,
  },
  [107] = {
    [5] = sym_block,
  },
  [109] = {
    [5] = sym_block,
  },
  [113] = {
    [6] = sym_block,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__simple_statements, 2,
    sym__simple_statements,
    sym_block,
  sym_parenthesized_list_splat, 2,
    sym_parenthesized_list_splat,
    sym_parenthesized_expression,
  sym_list_splat_pattern, 2,
    sym_list_splat_pattern,
    sym_list_splat,
  sym_expression, 2,
    sym_expression,
    alias_sym_as_pattern_target,
  sym_interpolation, 2,
    sym_interpolation,
    alias_sym_format_expression,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 2,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 20,
  [22] = 22,
  [23] = 23,
  [24] = 6,
  [25] = 25,
  [26] = 3,
  [27] = 22,
  [28] = 13,
  [29] = 23,
  [30] = 10,
  [31] = 18,
  [32] = 32,
  [33] = 32,
  [34] = 7,
  [35] = 19,
  [36] = 12,
  [37] = 17,
  [38] = 25,
  [39] = 16,
  [40] = 40,
  [41] = 41,
  [42] = 41,
  [43] = 40,
  [44] = 44,
  [45] = 40,
  [46] = 46,
  [47] = 46,
  [48] = 48,
  [49] = 48,
  [50] = 50,
  [51] = 51,
  [52] = 50,
  [53] = 53,
  [54] = 54,
  [55] = 54,
  [56] = 53,
  [57] = 51,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 58,
  [72] = 66,
  [73] = 70,
  [74] = 74,
  [75] = 62,
  [76] = 76,
  [77] = 77,
  [78] = 76,
  [79] = 74,
  [80] = 60,
  [81] = 77,
  [82] = 64,
  [83] = 83,
  [84] = 84,
  [85] = 61,
  [86] = 69,
  [87] = 68,
  [88] = 88,
  [89] = 89,
  [90] = 89,
  [91] = 88,
  [92] = 89,
  [93] = 88,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 98,
  [104] = 102,
  [105] = 97,
  [106] = 99,
  [107] = 99,
  [108] = 102,
  [109] = 101,
  [110] = 102,
  [111] = 97,
  [112] = 98,
  [113] = 100,
  [114] = 102,
  [115] = 102,
  [116] = 99,
  [117] = 97,
  [118] = 99,
  [119] = 102,
  [120] = 101,
  [121] = 99,
  [122] = 102,
  [123] = 102,
  [124] = 101,
  [125] = 101,
  [126] = 99,
  [127] = 127,
  [128] = 128,
  [129] = 102,
  [130] = 101,
  [131] = 99,
  [132] = 101,
  [133] = 99,
  [134] = 98,
  [135] = 102,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 138,
  [140] = 140,
  [141] = 141,
  [142] = 138,
  [143] = 140,
  [144] = 144,
  [145] = 145,
  [146] = 145,
  [147] = 140,
  [148] = 141,
  [149] = 144,
  [150] = 150,
  [151] = 150,
  [152] = 138,
  [153] = 96,
  [154] = 137,
  [155] = 137,
  [156] = 138,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 138,
  [162] = 141,
  [163] = 95,
  [164] = 138,
  [165] = 141,
  [166] = 140,
  [167] = 167,
  [168] = 167,
  [169] = 137,
  [170] = 170,
  [171] = 171,
  [172] = 170,
  [173] = 173,
  [174] = 174,
  [175] = 174,
  [176] = 171,
  [177] = 173,
  [178] = 178,
  [179] = 174,
  [180] = 171,
  [181] = 173,
  [182] = 170,
  [183] = 170,
  [184] = 170,
  [185] = 171,
  [186] = 171,
  [187] = 171,
  [188] = 173,
  [189] = 173,
  [190] = 174,
  [191] = 174,
  [192] = 170,
  [193] = 171,
  [194] = 173,
  [195] = 170,
  [196] = 178,
  [197] = 173,
  [198] = 174,
  [199] = 174,
  [200] = 200,
  [201] = 201,
  [202] = 201,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 200,
  [208] = 205,
  [209] = 206,
  [210] = 210,
  [211] = 211,
  [212] = 210,
  [213] = 213,
  [214] = 214,
  [215] = 214,
  [216] = 210,
  [217] = 213,
  [218] = 211,
  [219] = 219,
  [220] = 214,
  [221] = 221,
  [222] = 214,
  [223] = 211,
  [224] = 210,
  [225] = 210,
  [226] = 226,
  [227] = 226,
  [228] = 214,
  [229] = 213,
  [230] = 210,
  [231] = 226,
  [232] = 211,
  [233] = 214,
  [234] = 226,
  [235] = 213,
  [236] = 211,
  [237] = 226,
  [238] = 213,
  [239] = 226,
  [240] = 213,
  [241] = 210,
  [242] = 226,
  [243] = 214,
  [244] = 213,
  [245] = 245,
  [246] = 246,
  [247] = 245,
  [248] = 248,
  [249] = 248,
  [250] = 245,
  [251] = 251,
  [252] = 252,
  [253] = 245,
  [254] = 248,
  [255] = 251,
  [256] = 256,
  [257] = 256,
  [258] = 245,
  [259] = 252,
  [260] = 260,
  [261] = 248,
  [262] = 248,
  [263] = 248,
  [264] = 252,
  [265] = 245,
  [266] = 252,
  [267] = 267,
  [268] = 252,
  [269] = 248,
  [270] = 252,
  [271] = 245,
  [272] = 252,
  [273] = 252,
  [274] = 245,
  [275] = 245,
  [276] = 248,
  [277] = 277,
  [278] = 256,
  [279] = 248,
  [280] = 252,
  [281] = 251,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 284,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 221,
  [294] = 288,
  [295] = 295,
  [296] = 292,
  [297] = 297,
  [298] = 297,
  [299] = 286,
  [300] = 300,
  [301] = 284,
  [302] = 302,
  [303] = 290,
  [304] = 304,
  [305] = 305,
  [306] = 284,
  [307] = 284,
  [308] = 308,
  [309] = 285,
  [310] = 310,
  [311] = 310,
  [312] = 312,
  [313] = 313,
  [314] = 284,
  [315] = 284,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 284,
  [320] = 284,
  [321] = 291,
  [322] = 308,
  [323] = 295,
  [324] = 324,
  [325] = 310,
  [326] = 326,
  [327] = 219,
  [328] = 328,
  [329] = 329,
  [330] = 221,
  [331] = 329,
  [332] = 332,
  [333] = 328,
  [334] = 332,
  [335] = 335,
  [336] = 336,
  [337] = 335,
  [338] = 336,
  [339] = 219,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 346,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 343,
  [356] = 354,
  [357] = 357,
  [358] = 358,
  [359] = 354,
  [360] = 349,
  [361] = 361,
  [362] = 362,
  [363] = 342,
  [364] = 364,
  [365] = 357,
  [366] = 344,
  [367] = 350,
  [368] = 354,
  [369] = 353,
  [370] = 346,
  [371] = 352,
  [372] = 349,
  [373] = 373,
  [374] = 342,
  [375] = 353,
  [376] = 347,
  [377] = 377,
  [378] = 348,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 343,
  [383] = 353,
  [384] = 384,
  [385] = 343,
  [386] = 386,
  [387] = 342,
  [388] = 349,
  [389] = 357,
  [390] = 343,
  [391] = 350,
  [392] = 354,
  [393] = 393,
  [394] = 353,
  [395] = 350,
  [396] = 349,
  [397] = 346,
  [398] = 398,
  [399] = 353,
  [400] = 346,
  [401] = 401,
  [402] = 346,
  [403] = 344,
  [404] = 357,
  [405] = 386,
  [406] = 345,
  [407] = 345,
  [408] = 342,
  [409] = 349,
  [410] = 343,
  [411] = 344,
  [412] = 345,
  [413] = 344,
  [414] = 357,
  [415] = 349,
  [416] = 357,
  [417] = 344,
  [418] = 357,
  [419] = 346,
  [420] = 345,
  [421] = 421,
  [422] = 422,
  [423] = 345,
  [424] = 345,
  [425] = 398,
  [426] = 380,
  [427] = 344,
  [428] = 350,
  [429] = 373,
  [430] = 354,
  [431] = 353,
  [432] = 343,
  [433] = 377,
  [434] = 350,
  [435] = 379,
  [436] = 354,
  [437] = 352,
  [438] = 379,
  [439] = 350,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 440,
  [444] = 442,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 446,
  [456] = 456,
  [457] = 450,
  [458] = 458,
  [459] = 458,
  [460] = 460,
  [461] = 454,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 447,
  [467] = 452,
  [468] = 468,
  [469] = 460,
  [470] = 470,
  [471] = 456,
  [472] = 472,
  [473] = 472,
  [474] = 96,
  [475] = 95,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 479,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 485,
  [488] = 488,
  [489] = 489,
  [490] = 476,
  [491] = 491,
  [492] = 488,
  [493] = 489,
  [494] = 494,
  [495] = 483,
  [496] = 491,
  [497] = 478,
  [498] = 480,
  [499] = 484,
  [500] = 477,
  [501] = 494,
  [502] = 486,
  [503] = 481,
  [504] = 504,
  [505] = 504,
  [506] = 506,
  [507] = 507,
  [508] = 96,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 521,
  [526] = 513,
  [527] = 527,
  [528] = 520,
  [529] = 529,
  [530] = 523,
  [531] = 518,
  [532] = 532,
  [533] = 533,
  [534] = 517,
  [535] = 535,
  [536] = 536,
  [537] = 511,
  [538] = 538,
  [539] = 516,
  [540] = 510,
  [541] = 514,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 95,
  [549] = 506,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 533,
  [554] = 512,
  [555] = 555,
  [556] = 556,
  [557] = 532,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 515,
  [567] = 536,
  [568] = 552,
  [569] = 569,
  [570] = 564,
  [571] = 565,
  [572] = 535,
  [573] = 573,
  [574] = 559,
  [575] = 547,
  [576] = 551,
  [577] = 560,
  [578] = 558,
  [579] = 527,
  [580] = 561,
  [581] = 556,
  [582] = 555,
  [583] = 562,
  [584] = 550,
  [585] = 519,
  [586] = 538,
  [587] = 569,
  [588] = 507,
  [589] = 509,
  [590] = 544,
  [591] = 543,
  [592] = 545,
  [593] = 542,
  [594] = 546,
  [595] = 524,
  [596] = 529,
  [597] = 563,
  [598] = 573,
  [599] = 522,
  [600] = 600,
  [601] = 600,
  [602] = 600,
  [603] = 600,
  [604] = 600,
  [605] = 600,
  [606] = 606,
  [607] = 606,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 608,
  [615] = 609,
  [616] = 616,
  [617] = 612,
  [618] = 616,
  [619] = 619,
  [620] = 620,
  [621] = 616,
  [622] = 613,
  [623] = 619,
  [624] = 624,
  [625] = 609,
  [626] = 611,
  [627] = 627,
  [628] = 627,
  [629] = 612,
  [630] = 620,
  [631] = 631,
  [632] = 613,
  [633] = 631,
  [634] = 610,
  [635] = 608,
  [636] = 627,
  [637] = 608,
  [638] = 611,
  [639] = 610,
  [640] = 609,
  [641] = 616,
  [642] = 631,
  [643] = 613,
  [644] = 612,
  [645] = 620,
  [646] = 612,
  [647] = 613,
  [648] = 631,
  [649] = 610,
  [650] = 624,
  [651] = 631,
  [652] = 610,
  [653] = 608,
  [654] = 608,
  [655] = 627,
  [656] = 619,
  [657] = 611,
  [658] = 619,
  [659] = 609,
  [660] = 627,
  [661] = 627,
  [662] = 616,
  [663] = 611,
  [664] = 619,
  [665] = 609,
  [666] = 611,
  [667] = 624,
  [668] = 619,
  [669] = 616,
  [670] = 627,
  [671] = 608,
  [672] = 624,
  [673] = 624,
  [674] = 610,
  [675] = 616,
  [676] = 620,
  [677] = 631,
  [678] = 613,
  [679] = 612,
  [680] = 610,
  [681] = 616,
  [682] = 682,
  [683] = 616,
  [684] = 682,
  [685] = 619,
  [686] = 631,
  [687] = 613,
  [688] = 612,
  [689] = 616,
  [690] = 616,
  [691] = 611,
  [692] = 620,
  [693] = 620,
  [694] = 620,
  [695] = 609,
  [696] = 448,
  [697] = 449,
  [698] = 445,
  [699] = 451,
  [700] = 468,
  [701] = 462,
  [702] = 702,
  [703] = 702,
  [704] = 463,
  [705] = 702,
  [706] = 706,
  [707] = 702,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 712,
  [714] = 706,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 709,
  [720] = 720,
  [721] = 721,
  [722] = 722,
  [723] = 723,
  [724] = 724,
  [725] = 725,
  [726] = 710,
  [727] = 727,
  [728] = 711,
  [729] = 717,
  [730] = 715,
  [731] = 716,
  [732] = 725,
  [733] = 722,
  [734] = 708,
  [735] = 723,
  [736] = 724,
  [737] = 723,
  [738] = 708,
  [739] = 724,
  [740] = 702,
  [741] = 709,
  [742] = 722,
  [743] = 727,
  [744] = 702,
  [745] = 442,
  [746] = 441,
  [747] = 440,
  [748] = 702,
  [749] = 710,
  [750] = 727,
  [751] = 711,
  [752] = 717,
  [753] = 715,
  [754] = 706,
  [755] = 716,
  [756] = 725,
  [757] = 724,
  [758] = 709,
  [759] = 708,
  [760] = 723,
  [761] = 724,
  [762] = 465,
  [763] = 720,
  [764] = 721,
  [765] = 765,
  [766] = 709,
  [767] = 448,
  [768] = 449,
  [769] = 769,
  [770] = 710,
  [771] = 445,
  [772] = 451,
  [773] = 717,
  [774] = 468,
  [775] = 722,
  [776] = 711,
  [777] = 712,
  [778] = 462,
  [779] = 779,
  [780] = 727,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 718,
  [785] = 725,
  [786] = 716,
  [787] = 715,
  [788] = 706,
  [789] = 710,
  [790] = 727,
  [791] = 711,
  [792] = 717,
  [793] = 715,
  [794] = 706,
  [795] = 795,
  [796] = 716,
  [797] = 725,
  [798] = 715,
  [799] = 717,
  [800] = 711,
  [801] = 727,
  [802] = 710,
  [803] = 463,
  [804] = 706,
  [805] = 708,
  [806] = 723,
  [807] = 807,
  [808] = 724,
  [809] = 809,
  [810] = 716,
  [811] = 712,
  [812] = 725,
  [813] = 813,
  [814] = 722,
  [815] = 815,
  [816] = 816,
  [817] = 782,
  [818] = 781,
  [819] = 819,
  [820] = 820,
  [821] = 821,
  [822] = 458,
  [823] = 450,
  [824] = 824,
  [825] = 446,
  [826] = 470,
  [827] = 453,
  [828] = 723,
  [829] = 708,
  [830] = 454,
  [831] = 816,
  [832] = 815,
  [833] = 807,
  [834] = 834,
  [835] = 769,
  [836] = 702,
  [837] = 779,
  [838] = 765,
  [839] = 783,
  [840] = 722,
  [841] = 813,
  [842] = 819,
  [843] = 709,
  [844] = 821,
  [845] = 834,
  [846] = 846,
  [847] = 847,
  [848] = 795,
  [849] = 849,
  [850] = 850,
  [851] = 851,
  [852] = 852,
  [853] = 853,
  [854] = 854,
  [855] = 855,
  [856] = 856,
  [857] = 820,
  [858] = 824,
  [859] = 465,
  [860] = 860,
  [861] = 861,
  [862] = 809,
  [863] = 453,
  [864] = 470,
  [865] = 816,
  [866] = 442,
  [867] = 441,
  [868] = 440,
  [869] = 815,
  [870] = 807,
  [871] = 846,
  [872] = 824,
  [873] = 847,
  [874] = 465,
  [875] = 849,
  [876] = 850,
  [877] = 851,
  [878] = 769,
  [879] = 779,
  [880] = 765,
  [881] = 783,
  [882] = 813,
  [883] = 819,
  [884] = 821,
  [885] = 834,
  [886] = 846,
  [887] = 847,
  [888] = 795,
  [889] = 849,
  [890] = 850,
  [891] = 851,
  [892] = 856,
  [893] = 855,
  [894] = 852,
  [895] = 853,
  [896] = 854,
  [897] = 855,
  [898] = 856,
  [899] = 820,
  [900] = 809,
  [901] = 781,
  [902] = 782,
  [903] = 463,
  [904] = 462,
  [905] = 468,
  [906] = 451,
  [907] = 854,
  [908] = 445,
  [909] = 449,
  [910] = 448,
  [911] = 465,
  [912] = 853,
  [913] = 470,
  [914] = 453,
  [915] = 458,
  [916] = 450,
  [917] = 446,
  [918] = 454,
  [919] = 852,
  [920] = 856,
  [921] = 813,
  [922] = 855,
  [923] = 856,
  [924] = 449,
  [925] = 448,
  [926] = 809,
  [927] = 702,
  [928] = 781,
  [929] = 782,
  [930] = 930,
  [931] = 931,
  [932] = 932,
  [933] = 464,
  [934] = 465,
  [935] = 465,
  [936] = 453,
  [937] = 470,
  [938] = 722,
  [939] = 725,
  [940] = 716,
  [941] = 706,
  [942] = 715,
  [943] = 717,
  [944] = 711,
  [945] = 727,
  [946] = 710,
  [947] = 709,
  [948] = 708,
  [949] = 723,
  [950] = 724,
  [951] = 702,
  [952] = 453,
  [953] = 470,
  [954] = 448,
  [955] = 449,
  [956] = 445,
  [957] = 451,
  [958] = 468,
  [959] = 462,
  [960] = 463,
  [961] = 782,
  [962] = 781,
  [963] = 809,
  [964] = 465,
  [965] = 820,
  [966] = 824,
  [967] = 448,
  [968] = 449,
  [969] = 856,
  [970] = 855,
  [971] = 445,
  [972] = 451,
  [973] = 468,
  [974] = 854,
  [975] = 853,
  [976] = 852,
  [977] = 462,
  [978] = 851,
  [979] = 850,
  [980] = 470,
  [981] = 453,
  [982] = 464,
  [983] = 445,
  [984] = 451,
  [985] = 468,
  [986] = 849,
  [987] = 795,
  [988] = 847,
  [989] = 846,
  [990] = 816,
  [991] = 815,
  [992] = 807,
  [993] = 854,
  [994] = 834,
  [995] = 853,
  [996] = 820,
  [997] = 463,
  [998] = 821,
  [999] = 819,
  [1000] = 813,
  [1001] = 782,
  [1002] = 781,
  [1003] = 783,
  [1004] = 824,
  [1005] = 765,
  [1006] = 779,
  [1007] = 769,
  [1008] = 769,
  [1009] = 465,
  [1010] = 852,
  [1011] = 779,
  [1012] = 765,
  [1013] = 783,
  [1014] = 807,
  [1015] = 815,
  [1016] = 816,
  [1017] = 816,
  [1018] = 815,
  [1019] = 454,
  [1020] = 807,
  [1021] = 813,
  [1022] = 819,
  [1023] = 809,
  [1024] = 446,
  [1025] = 824,
  [1026] = 450,
  [1027] = 462,
  [1028] = 851,
  [1029] = 850,
  [1030] = 821,
  [1031] = 458,
  [1032] = 820,
  [1033] = 855,
  [1034] = 854,
  [1035] = 853,
  [1036] = 852,
  [1037] = 851,
  [1038] = 769,
  [1039] = 850,
  [1040] = 779,
  [1041] = 849,
  [1042] = 795,
  [1043] = 849,
  [1044] = 847,
  [1045] = 795,
  [1046] = 846,
  [1047] = 463,
  [1048] = 765,
  [1049] = 783,
  [1050] = 834,
  [1051] = 847,
  [1052] = 834,
  [1053] = 846,
  [1054] = 819,
  [1055] = 821,
  [1056] = 856,
  [1057] = 769,
  [1058] = 721,
  [1059] = 720,
  [1060] = 718,
  [1061] = 442,
  [1062] = 441,
  [1063] = 468,
  [1064] = 451,
  [1065] = 445,
  [1066] = 449,
  [1067] = 440,
  [1068] = 718,
  [1069] = 720,
  [1070] = 721,
  [1071] = 860,
  [1072] = 448,
  [1073] = 809,
  [1074] = 781,
  [1075] = 861,
  [1076] = 782,
  [1077] = 464,
  [1078] = 854,
  [1079] = 718,
  [1080] = 720,
  [1081] = 721,
  [1082] = 820,
  [1083] = 458,
  [1084] = 450,
  [1085] = 824,
  [1086] = 446,
  [1087] = 470,
  [1088] = 453,
  [1089] = 454,
  [1090] = 816,
  [1091] = 815,
  [1092] = 807,
  [1093] = 853,
  [1094] = 779,
  [1095] = 765,
  [1096] = 783,
  [1097] = 813,
  [1098] = 819,
  [1099] = 464,
  [1100] = 855,
  [1101] = 821,
  [1102] = 834,
  [1103] = 846,
  [1104] = 847,
  [1105] = 795,
  [1106] = 849,
  [1107] = 463,
  [1108] = 462,
  [1109] = 850,
  [1110] = 465,
  [1111] = 851,
  [1112] = 852,
  [1113] = 465,
  [1114] = 453,
  [1115] = 470,
  [1116] = 448,
  [1117] = 449,
  [1118] = 445,
  [1119] = 451,
  [1120] = 468,
  [1121] = 462,
  [1122] = 463,
  [1123] = 465,
  [1124] = 465,
  [1125] = 465,
  [1126] = 1126,
  [1127] = 1127,
  [1128] = 458,
  [1129] = 450,
  [1130] = 446,
  [1131] = 454,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1135,
  [1136] = 1132,
  [1137] = 1133,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1139,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1134,
  [1145] = 1135,
  [1146] = 1139,
  [1147] = 1134,
  [1148] = 1132,
  [1149] = 1143,
  [1150] = 1133,
  [1151] = 1135,
  [1152] = 1138,
  [1153] = 1142,
  [1154] = 1140,
  [1155] = 1133,
  [1156] = 1138,
  [1157] = 1138,
  [1158] = 1142,
  [1159] = 1143,
  [1160] = 1140,
  [1161] = 1140,
  [1162] = 1132,
  [1163] = 1143,
  [1164] = 1142,
  [1165] = 1139,
  [1166] = 1134,
  [1167] = 1135,
  [1168] = 1168,
  [1169] = 1168,
  [1170] = 1168,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1174,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1176,
  [1179] = 1174,
  [1180] = 1180,
  [1181] = 1173,
  [1182] = 1173,
  [1183] = 1177,
  [1184] = 1180,
  [1185] = 1177,
  [1186] = 1180,
  [1187] = 1176,
  [1188] = 1180,
  [1189] = 1174,
  [1190] = 1177,
  [1191] = 1173,
  [1192] = 1176,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1194,
  [1196] = 1196,
  [1197] = 1194,
  [1198] = 1196,
  [1199] = 1196,
  [1200] = 1194,
  [1201] = 1196,
  [1202] = 860,
  [1203] = 1203,
  [1204] = 454,
  [1205] = 446,
  [1206] = 450,
  [1207] = 1207,
  [1208] = 458,
  [1209] = 861,
  [1210] = 1207,
  [1211] = 1203,
  [1212] = 1207,
  [1213] = 1203,
  [1214] = 1207,
  [1215] = 1215,
  [1216] = 465,
  [1217] = 1217,
  [1218] = 1203,
  [1219] = 1219,
  [1220] = 1207,
  [1221] = 1221,
  [1222] = 1203,
  [1223] = 470,
  [1224] = 1203,
  [1225] = 1225,
  [1226] = 453,
  [1227] = 1207,
  [1228] = 446,
  [1229] = 470,
  [1230] = 450,
  [1231] = 446,
  [1232] = 465,
  [1233] = 458,
  [1234] = 860,
  [1235] = 861,
  [1236] = 1236,
  [1237] = 1203,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1225,
  [1241] = 1217,
  [1242] = 1215,
  [1243] = 1243,
  [1244] = 454,
  [1245] = 454,
  [1246] = 446,
  [1247] = 458,
  [1248] = 450,
  [1249] = 453,
  [1250] = 454,
  [1251] = 450,
  [1252] = 861,
  [1253] = 458,
  [1254] = 860,
  [1255] = 861,
  [1256] = 860,
  [1257] = 1207,
  [1258] = 1221,
  [1259] = 1243,
  [1260] = 1260,
  [1261] = 1239,
  [1262] = 1262,
  [1263] = 1263,
  [1264] = 1260,
  [1265] = 1238,
  [1266] = 1260,
  [1267] = 1262,
  [1268] = 1268,
  [1269] = 1260,
  [1270] = 1260,
  [1271] = 1268,
  [1272] = 1268,
  [1273] = 1268,
  [1274] = 1268,
  [1275] = 1268,
  [1276] = 1260,
  [1277] = 1268,
  [1278] = 1260,
  [1279] = 1279,
  [1280] = 1236,
  [1281] = 1268,
  [1282] = 1219,
  [1283] = 1268,
  [1284] = 1263,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1286,
  [1289] = 1289,
  [1290] = 1287,
  [1291] = 1291,
  [1292] = 1291,
  [1293] = 1293,
  [1294] = 1293,
  [1295] = 1293,
  [1296] = 1293,
  [1297] = 1293,
  [1298] = 1293,
  [1299] = 1293,
  [1300] = 1300,
  [1301] = 1301,
  [1302] = 1302,
  [1303] = 1302,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1302,
  [1307] = 1302,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1302,
  [1311] = 1311,
  [1312] = 1312,
  [1313] = 1302,
  [1314] = 1302,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1301,
  [1319] = 1311,
  [1320] = 1320,
  [1321] = 1317,
  [1322] = 1322,
  [1323] = 1305,
  [1324] = 1320,
  [1325] = 1320,
  [1326] = 1316,
  [1327] = 1308,
  [1328] = 1316,
  [1329] = 1329,
  [1330] = 1317,
  [1331] = 1331,
  [1332] = 1322,
  [1333] = 1312,
  [1334] = 1309,
  [1335] = 1317,
  [1336] = 1317,
  [1337] = 1320,
  [1338] = 1315,
  [1339] = 1308,
  [1340] = 1315,
  [1341] = 1317,
  [1342] = 1320,
  [1343] = 1305,
  [1344] = 1312,
  [1345] = 1317,
  [1346] = 1320,
  [1347] = 1317,
  [1348] = 1309,
  [1349] = 1301,
  [1350] = 1304,
  [1351] = 1311,
  [1352] = 1320,
  [1353] = 1317,
  [1354] = 1317,
  [1355] = 1317,
  [1356] = 1304,
  [1357] = 1320,
  [1358] = 1320,
  [1359] = 1320,
  [1360] = 1320,
  [1361] = 1311,
  [1362] = 1311,
  [1363] = 1301,
  [1364] = 1311,
  [1365] = 1316,
  [1366] = 1309,
  [1367] = 1304,
  [1368] = 1305,
  [1369] = 1308,
  [1370] = 1312,
  [1371] = 1371,
  [1372] = 1309,
  [1373] = 1315,
  [1374] = 1322,
  [1375] = 1315,
  [1376] = 1312,
  [1377] = 1308,
  [1378] = 1305,
  [1379] = 1304,
  [1380] = 1301,
  [1381] = 1309,
  [1382] = 1316,
  [1383] = 1383,
  [1384] = 1315,
  [1385] = 1322,
  [1386] = 1312,
  [1387] = 1316,
  [1388] = 1301,
  [1389] = 1308,
  [1390] = 1305,
  [1391] = 1304,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1315,
  [1395] = 1395,
  [1396] = 1395,
  [1397] = 1312,
  [1398] = 1309,
  [1399] = 1395,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1402,
  [1403] = 1395,
  [1404] = 1371,
  [1405] = 1395,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1301,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1395,
  [1416] = 1308,
  [1417] = 1371,
  [1418] = 1305,
  [1419] = 1419,
  [1420] = 1304,
  [1421] = 1421,
  [1422] = 1395,
  [1423] = 1423,
  [1424] = 1424,
  [1425] = 1371,
  [1426] = 1413,
  [1427] = 1411,
  [1428] = 1316,
  [1429] = 1395,
  [1430] = 1395,
  [1431] = 1431,
  [1432] = 1400,
  [1433] = 1311,
  [1434] = 1434,
  [1435] = 1392,
  [1436] = 1436,
  [1437] = 1414,
  [1438] = 1408,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1392,
  [1442] = 1442,
  [1443] = 1443,
  [1444] = 1444,
  [1445] = 1434,
  [1446] = 1414,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1434,
  [1450] = 1450,
  [1451] = 1393,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1444,
  [1455] = 1402,
  [1456] = 1450,
  [1457] = 1457,
  [1458] = 1393,
  [1459] = 1447,
  [1460] = 1408,
  [1461] = 1461,
  [1462] = 1442,
  [1463] = 1434,
  [1464] = 1464,
  [1465] = 1447,
  [1466] = 1447,
  [1467] = 1442,
  [1468] = 1414,
  [1469] = 1410,
  [1470] = 1470,
  [1471] = 1383,
  [1472] = 1457,
  [1473] = 1442,
  [1474] = 1453,
  [1475] = 1443,
  [1476] = 1442,
  [1477] = 1410,
  [1478] = 1402,
  [1479] = 1408,
  [1480] = 1410,
  [1481] = 1392,
  [1482] = 1482,
  [1483] = 1483,
  [1484] = 1448,
  [1485] = 1442,
  [1486] = 1486,
  [1487] = 1442,
  [1488] = 1488,
  [1489] = 1452,
  [1490] = 1490,
  [1491] = 1447,
  [1492] = 1434,
  [1493] = 1434,
  [1494] = 1434,
  [1495] = 1402,
  [1496] = 1393,
  [1497] = 1447,
  [1498] = 1447,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1502,
  [1503] = 1503,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1507,
  [1508] = 1221,
  [1509] = 1499,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1383,
  [1515] = 1515,
  [1516] = 1516,
  [1517] = 1517,
  [1518] = 1518,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1501,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1511,
  [1525] = 1470,
  [1526] = 1515,
  [1527] = 1527,
  [1528] = 1528,
  [1529] = 1423,
  [1530] = 1530,
  [1531] = 1531,
  [1532] = 1532,
  [1533] = 1533,
  [1534] = 1534,
  [1535] = 1507,
  [1536] = 1502,
  [1537] = 1470,
  [1538] = 1501,
  [1539] = 1539,
  [1540] = 1540,
  [1541] = 1488,
  [1542] = 1512,
  [1543] = 1513,
  [1544] = 1511,
  [1545] = 1545,
  [1546] = 1545,
  [1547] = 1520,
  [1548] = 1548,
  [1549] = 1549,
  [1550] = 1528,
  [1551] = 1504,
  [1552] = 1440,
  [1553] = 1553,
  [1554] = 1545,
  [1555] = 1555,
  [1556] = 1440,
  [1557] = 1511,
  [1558] = 1558,
  [1559] = 1559,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1499,
  [1564] = 1440,
  [1565] = 1565,
  [1566] = 1531,
  [1567] = 1558,
  [1568] = 1568,
  [1569] = 1510,
  [1570] = 1219,
  [1571] = 1516,
  [1572] = 1527,
  [1573] = 1516,
  [1574] = 1517,
  [1575] = 1518,
  [1576] = 1507,
  [1577] = 1568,
  [1578] = 824,
  [1579] = 1579,
  [1580] = 1519,
  [1581] = 1581,
  [1582] = 1470,
  [1583] = 1583,
  [1584] = 1584,
  [1585] = 779,
  [1586] = 1539,
  [1587] = 1587,
  [1588] = 1488,
  [1589] = 1488,
  [1590] = 1590,
  [1591] = 1591,
  [1592] = 1592,
  [1593] = 1593,
  [1594] = 1540,
  [1595] = 1595,
  [1596] = 1239,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1243,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1540,
  [1603] = 1603,
  [1604] = 1519,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1601,
  [1608] = 1608,
  [1609] = 1504,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1507,
  [1613] = 1613,
  [1614] = 1532,
  [1615] = 824,
  [1616] = 1534,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 779,
  [1620] = 1613,
  [1621] = 1598,
  [1622] = 1622,
  [1623] = 1601,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1627,
  [1628] = 824,
  [1629] = 1519,
  [1630] = 1518,
  [1631] = 1601,
  [1632] = 779,
  [1633] = 1579,
  [1634] = 1610,
  [1635] = 824,
  [1636] = 1636,
  [1637] = 1517,
  [1638] = 1545,
  [1639] = 1625,
  [1640] = 1640,
  [1641] = 779,
  [1642] = 1642,
  [1643] = 1453,
  [1644] = 1516,
  [1645] = 1532,
  [1646] = 1534,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1608,
  [1650] = 1534,
  [1651] = 1625,
  [1652] = 1601,
  [1653] = 1653,
  [1654] = 1654,
  [1655] = 1655,
  [1656] = 1532,
  [1657] = 1565,
  [1658] = 1658,
  [1659] = 1238,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1512,
  [1666] = 1504,
  [1667] = 1611,
  [1668] = 1605,
  [1669] = 1517,
  [1670] = 1236,
  [1671] = 1671,
  [1672] = 1584,
  [1673] = 1647,
  [1674] = 1540,
  [1675] = 1579,
  [1676] = 1513,
  [1677] = 1513,
  [1678] = 1512,
  [1679] = 1584,
  [1680] = 1581,
  [1681] = 1518,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1660,
  [1685] = 1685,
  [1686] = 1625,
  [1687] = 1581,
  [1688] = 1579,
  [1689] = 1601,
  [1690] = 1581,
  [1691] = 1601,
  [1692] = 1584,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1622,
  [1696] = 1618,
  [1697] = 1636,
  [1698] = 1627,
  [1699] = 1624,
  [1700] = 1597,
  [1701] = 1618,
  [1702] = 1595,
  [1703] = 1617,
  [1704] = 1683,
  [1705] = 1591,
  [1706] = 1654,
  [1707] = 1707,
  [1708] = 1597,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 1595,
  [1712] = 1712,
  [1713] = 1593,
  [1714] = 1655,
  [1715] = 1595,
  [1716] = 1694,
  [1717] = 1717,
  [1718] = 1693,
  [1719] = 1683,
  [1720] = 1709,
  [1721] = 1597,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1682,
  [1725] = 1605,
  [1726] = 1726,
  [1727] = 1648,
  [1728] = 1600,
  [1729] = 1661,
  [1730] = 1642,
  [1731] = 1663,
  [1732] = 1626,
  [1733] = 1694,
  [1734] = 1693,
  [1735] = 1593,
  [1736] = 1617,
  [1737] = 1617,
  [1738] = 1738,
  [1739] = 1658,
  [1740] = 1726,
  [1741] = 1694,
  [1742] = 1622,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1723,
  [1746] = 1693,
  [1747] = 1663,
  [1748] = 1748,
  [1749] = 1618,
  [1750] = 1640,
  [1751] = 1622,
  [1752] = 1624,
  [1753] = 1624,
  [1754] = 1627,
  [1755] = 1636,
  [1756] = 1756,
  [1757] = 1627,
  [1758] = 1709,
  [1759] = 1683,
  [1760] = 1707,
  [1761] = 1593,
  [1762] = 1738,
  [1763] = 1763,
  [1764] = 1590,
  [1765] = 1636,
  [1766] = 1707,
  [1767] = 1709,
  [1768] = 1640,
  [1769] = 1769,
  [1770] = 1640,
  [1771] = 1530,
  [1772] = 1772,
  [1773] = 1626,
  [1774] = 1591,
  [1775] = 1591,
  [1776] = 1776,
  [1777] = 1654,
  [1778] = 1655,
  [1779] = 1756,
  [1780] = 1707,
  [1781] = 1658,
  [1782] = 1626,
  [1783] = 1605,
  [1784] = 1654,
  [1785] = 1655,
  [1786] = 1723,
  [1787] = 1642,
  [1788] = 1788,
  [1789] = 1658,
  [1790] = 1600,
  [1791] = 1682,
  [1792] = 1661,
  [1793] = 1663,
  [1794] = 1712,
  [1795] = 1717,
  [1796] = 1642,
  [1797] = 1682,
  [1798] = 1661,
  [1799] = 1799,
  [1800] = 1800,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1600,
  [1806] = 1723,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1808,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1818,
  [1819] = 1819,
  [1820] = 1809,
  [1821] = 1821,
  [1822] = 1822,
  [1823] = 1823,
  [1824] = 1548,
  [1825] = 1825,
  [1826] = 1826,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1826,
  [1832] = 1823,
  [1833] = 1819,
  [1834] = 1834,
  [1835] = 1835,
  [1836] = 1221,
  [1837] = 1829,
  [1838] = 1530,
  [1839] = 1822,
  [1840] = 1821,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1816,
  [1844] = 1844,
  [1845] = 1842,
  [1846] = 1816,
  [1847] = 1847,
  [1848] = 1848,
  [1849] = 1849,
  [1850] = 1813,
  [1851] = 1821,
  [1852] = 1808,
  [1853] = 1822,
  [1854] = 1854,
  [1855] = 1855,
  [1856] = 1856,
  [1857] = 1848,
  [1858] = 1849,
  [1859] = 1859,
  [1860] = 1860,
  [1861] = 1855,
  [1862] = 1862,
  [1863] = 1854,
  [1864] = 1864,
  [1865] = 1827,
  [1866] = 1866,
  [1867] = 1808,
  [1868] = 1868,
  [1869] = 1828,
  [1870] = 1818,
  [1871] = 1813,
  [1872] = 1830,
  [1873] = 1830,
  [1874] = 1874,
  [1875] = 1505,
  [1876] = 1816,
  [1877] = 1877,
  [1878] = 1878,
  [1879] = 1849,
  [1880] = 1821,
  [1881] = 1848,
  [1882] = 1822,
  [1883] = 1855,
  [1884] = 1844,
  [1885] = 1885,
  [1886] = 1842,
  [1887] = 1802,
  [1888] = 1859,
  [1889] = 1889,
  [1890] = 1847,
  [1891] = 1826,
  [1892] = 1864,
  [1893] = 1835,
  [1894] = 1855,
  [1895] = 1854,
  [1896] = 1896,
  [1897] = 1897,
  [1898] = 1808,
  [1899] = 1743,
  [1900] = 1835,
  [1901] = 1813,
  [1902] = 1902,
  [1903] = 1903,
  [1904] = 1799,
  [1905] = 1221,
  [1906] = 1803,
  [1907] = 1808,
  [1908] = 1819,
  [1909] = 1834,
  [1910] = 1854,
  [1911] = 1816,
  [1912] = 1912,
  [1913] = 1819,
  [1914] = 1743,
  [1915] = 1819,
  [1916] = 1825,
  [1917] = 1902,
  [1918] = 1903,
  [1919] = 1804,
  [1920] = 1804,
  [1921] = 1847,
  [1922] = 1803,
  [1923] = 1816,
  [1924] = 1826,
  [1925] = 1799,
  [1926] = 1854,
  [1927] = 1821,
  [1928] = 1855,
  [1929] = 1822,
  [1930] = 1561,
  [1931] = 1822,
  [1932] = 1821,
  [1933] = 1933,
  [1934] = 1221,
  [1935] = 1816,
  [1936] = 1562,
  [1937] = 1937,
  [1938] = 1938,
  [1939] = 1844,
  [1940] = 1912,
  [1941] = 1813,
  [1942] = 1855,
  [1943] = 1808,
  [1944] = 1944,
  [1945] = 1854,
  [1946] = 1855,
  [1947] = 1947,
  [1948] = 1859,
  [1949] = 1949,
  [1950] = 1933,
  [1951] = 1807,
  [1952] = 1522,
  [1953] = 1860,
  [1954] = 1954,
  [1955] = 1826,
  [1956] = 1855,
  [1957] = 1236,
  [1958] = 1877,
  [1959] = 1897,
  [1960] = 1954,
  [1961] = 1830,
  [1962] = 1949,
  [1963] = 1854,
  [1964] = 1903,
  [1965] = 1828,
  [1966] = 1966,
  [1967] = 1827,
  [1968] = 1849,
  [1969] = 1969,
  [1970] = 1848,
  [1971] = 1812,
  [1972] = 1854,
  [1973] = 1844,
  [1974] = 1974,
  [1975] = 1842,
  [1976] = 1219,
  [1977] = 1823,
  [1978] = 1885,
  [1979] = 1813,
  [1980] = 1816,
  [1981] = 1819,
  [1982] = 1835,
  [1983] = 1938,
  [1984] = 1966,
  [1985] = 1826,
  [1986] = 1986,
  [1987] = 1987,
  [1988] = 1816,
  [1989] = 1814,
  [1990] = 1862,
  [1991] = 1815,
  [1992] = 1969,
  [1993] = 1993,
  [1994] = 1811,
  [1995] = 1559,
  [1996] = 1549,
  [1997] = 1866,
  [1998] = 1859,
  [1999] = 1821,
  [2000] = 1862,
  [2001] = 1743,
  [2002] = 1803,
  [2003] = 1560,
  [2004] = 1819,
  [2005] = 1822,
  [2006] = 2006,
  [2007] = 2007,
  [2008] = 1809,
  [2009] = 1813,
  [2010] = 1854,
  [2011] = 1855,
  [2012] = 1590,
  [2013] = 1826,
  [2014] = 2014,
  [2015] = 2015,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2020,
  [2021] = 1238,
  [2022] = 2019,
  [2023] = 2023,
  [2024] = 2024,
  [2025] = 2025,
  [2026] = 2026,
  [2027] = 2027,
  [2028] = 2028,
  [2029] = 2029,
  [2030] = 2030,
  [2031] = 2031,
  [2032] = 2032,
  [2033] = 1239,
  [2034] = 2034,
  [2035] = 2035,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2038,
  [2039] = 2039,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 480,
  [2043] = 2043,
  [2044] = 2044,
  [2045] = 2032,
  [2046] = 2031,
  [2047] = 1239,
  [2048] = 2048,
  [2049] = 2049,
  [2050] = 486,
  [2051] = 1243,
  [2052] = 2039,
  [2053] = 483,
  [2054] = 2054,
  [2055] = 2055,
  [2056] = 2056,
  [2057] = 476,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 2028,
  [2061] = 1236,
  [2062] = 1238,
  [2063] = 2049,
  [2064] = 2064,
  [2065] = 2025,
  [2066] = 2029,
  [2067] = 2067,
  [2068] = 2068,
  [2069] = 2069,
  [2070] = 2032,
  [2071] = 2030,
  [2072] = 2031,
  [2073] = 2073,
  [2074] = 2074,
  [2075] = 2031,
  [2076] = 2032,
  [2077] = 2030,
  [2078] = 2069,
  [2079] = 2030,
  [2080] = 2068,
  [2081] = 2081,
  [2082] = 2067,
  [2083] = 2083,
  [2084] = 2029,
  [2085] = 2023,
  [2086] = 2029,
  [2087] = 2020,
  [2088] = 2088,
  [2089] = 2089,
  [2090] = 1974,
  [2091] = 2083,
  [2092] = 2074,
  [2093] = 1243,
  [2094] = 494,
  [2095] = 2069,
  [2096] = 2096,
  [2097] = 2097,
  [2098] = 2024,
  [2099] = 2068,
  [2100] = 2067,
  [2101] = 2101,
  [2102] = 2102,
  [2103] = 2103,
  [2104] = 2104,
  [2105] = 2103,
  [2106] = 2106,
  [2107] = 2107,
  [2108] = 2108,
  [2109] = 2109,
  [2110] = 2110,
  [2111] = 2111,
  [2112] = 2112,
  [2113] = 2113,
  [2114] = 2114,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2117,
  [2118] = 2118,
  [2119] = 2119,
  [2120] = 2103,
  [2121] = 2121,
  [2122] = 2122,
  [2123] = 2123,
  [2124] = 2104,
  [2125] = 2106,
  [2126] = 2122,
  [2127] = 2112,
  [2128] = 2128,
  [2129] = 2110,
  [2130] = 2109,
  [2131] = 2121,
  [2132] = 2132,
  [2133] = 2103,
  [2134] = 2104,
  [2135] = 2104,
  [2136] = 2122,
  [2137] = 2121,
  [2138] = 2118,
  [2139] = 2117,
  [2140] = 2114,
  [2141] = 2118,
  [2142] = 2142,
  [2143] = 2108,
  [2144] = 2117,
  [2145] = 2145,
  [2146] = 2146,
  [2147] = 2147,
  [2148] = 2104,
  [2149] = 2149,
  [2150] = 2150,
  [2151] = 2151,
  [2152] = 2112,
  [2153] = 2110,
  [2154] = 2109,
  [2155] = 2106,
  [2156] = 2103,
  [2157] = 2104,
  [2158] = 2122,
  [2159] = 2121,
  [2160] = 2160,
  [2161] = 2118,
  [2162] = 2162,
  [2163] = 2163,
  [2164] = 2117,
  [2165] = 2146,
  [2166] = 2114,
  [2167] = 2167,
  [2168] = 2160,
  [2169] = 2167,
  [2170] = 2114,
  [2171] = 2108,
  [2172] = 2146,
  [2173] = 2173,
  [2174] = 2151,
  [2175] = 2175,
  [2176] = 2106,
  [2177] = 2117,
  [2178] = 2178,
  [2179] = 2179,
  [2180] = 2118,
  [2181] = 2121,
  [2182] = 2182,
  [2183] = 2147,
  [2184] = 2179,
  [2185] = 2122,
  [2186] = 2104,
  [2187] = 2182,
  [2188] = 2103,
  [2189] = 2149,
  [2190] = 2111,
  [2191] = 2107,
  [2192] = 2192,
  [2193] = 2109,
  [2194] = 2106,
  [2195] = 2113,
  [2196] = 2196,
  [2197] = 2110,
  [2198] = 2109,
  [2199] = 2110,
  [2200] = 2108,
  [2201] = 2201,
  [2202] = 2112,
  [2203] = 2112,
  [2204] = 2201,
  [2205] = 2108,
  [2206] = 2110,
  [2207] = 2109,
  [2208] = 2106,
  [2209] = 2201,
  [2210] = 2104,
  [2211] = 2122,
  [2212] = 2121,
  [2213] = 2118,
  [2214] = 2214,
  [2215] = 2117,
  [2216] = 2146,
  [2217] = 2114,
  [2218] = 2167,
  [2219] = 2132,
  [2220] = 2132,
  [2221] = 2108,
  [2222] = 2196,
  [2223] = 2192,
  [2224] = 2114,
  [2225] = 2145,
  [2226] = 2226,
  [2227] = 2111,
  [2228] = 2107,
  [2229] = 2167,
  [2230] = 2230,
  [2231] = 2107,
  [2232] = 2111,
  [2233] = 2112,
  [2234] = 2178,
  [2235] = 2132,
  [2236] = 2112,
  [2237] = 2201,
  [2238] = 2110,
  [2239] = 2109,
  [2240] = 2106,
  [2241] = 2103,
  [2242] = 2104,
  [2243] = 2108,
  [2244] = 2214,
  [2245] = 2122,
  [2246] = 2246,
  [2247] = 2121,
  [2248] = 2248,
  [2249] = 2118,
  [2250] = 2248,
  [2251] = 2175,
  [2252] = 2117,
  [2253] = 2163,
  [2254] = 2115,
  [2255] = 2146,
  [2256] = 2150,
  [2257] = 2173,
  [2258] = 2114,
  [2259] = 2167,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d},
  {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333},
  {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af},
  {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8},
  {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916},
  {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00},
  {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e},
  {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68},
  {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399},
  {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a},
  {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3},
  {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb},
  {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2},
  {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514},
  {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0},
  {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8},
  {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xece},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071},
  {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113},
  {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096},
  {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf},
  {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c}, {0xa840, 0xa873},
  {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c}, {0xa980, 0xa9c0},
  {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2}, {0xaadb, 0xaadd},
  {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a},
  {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d},
  {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41},
  {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f},
  {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f},
  {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9},
  {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595},
  {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785},
  {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855},
  {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf},
  {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075}, {0x1107f, 0x110ba},
  {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173}, {0x11176, 0x11176},
  {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303}, {0x11305, 0x1130c},
  {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348}, {0x1134b, 0x1134d},
  {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459}, {0x1145e, 0x11461},
  {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640}, {0x11644, 0x11644},
  {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746}, {0x11800, 0x1183a},
  {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938}, {0x1193b, 0x11943},
  {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47}, {0x11a50, 0x11a99},
  {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7},
  {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47}, {0x11d50, 0x11d59},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10},
  {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0},
  {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9},
  {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f},
  {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d},
  {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c},
  {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006}, {0x1e008, 0x1e018},
  {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe},
  {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739},
  {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(53);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '%') ADVANCE(91);
      if (lookahead == '&') ADVANCE(95);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(86);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(80);
      if (lookahead == '.') ADVANCE(56);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(133);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(101);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(109);
      if (lookahead == '@') ADVANCE(77);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(127);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(97);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '|') ADVANCE(82);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '~') ADVANCE(100);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(51);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(146);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(126);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(3);
      if (lookahead == '\r') ADVANCE(129);
      if (lookahead == '#') ADVANCE(130);
      if (lookahead == '\\') ADVANCE(128);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '}') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) ADVANCE(129);
      if (lookahead != 0) ADVANCE(130);
      END_STATE();
    case 4:
      if (lookahead == '\r') SKIP(4);
      if (lookahead == '!') ADVANCE(17);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '%') ADVANCE(91);
      if (lookahead == '&') ADVANCE(95);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(86);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '.') ADVANCE(56);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(133);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(101);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(109);
      if (lookahead == '@') ADVANCE(77);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == '^') ADVANCE(97);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '|') ADVANCE(82);
      if (lookahead == '~') ADVANCE(100);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(4);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 5:
      if (lookahead == '\r') SKIP(5);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(78);
      if (lookahead == '.') ADVANCE(13);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '0') ADVANCE(133);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '~') ADVANCE(100);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(5);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 6:
      if (lookahead == '\r') SKIP(6);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '%') ADVANCE(19);
      if (lookahead == '&') ADVANCE(20);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(86);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '.') ADVANCE(13);
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == '0') ADVANCE(133);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(16);
      if (lookahead == '=') ADVANCE(72);
      if (lookahead == '>') ADVANCE(29);
      if (lookahead == '@') ADVANCE(21);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == '^') ADVANCE(22);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '|') ADVANCE(23);
      if (lookahead == '~') ADVANCE(100);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(6);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 7:
      if (lookahead == '\r') SKIP(7);
      if (lookahead == '!') ADVANCE(17);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '%') ADVANCE(91);
      if (lookahead == '&') ADVANCE(95);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(86);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '.') ADVANCE(55);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(101);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(109);
      if (lookahead == '@') ADVANCE(77);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(97);
      if (lookahead == '|') ADVANCE(82);
      if (lookahead == '}') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(7);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 8:
      if (lookahead == '\r') SKIP(8);
      if (lookahead == '!') ADVANCE(17);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '%') ADVANCE(91);
      if (lookahead == '&') ADVANCE(95);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(86);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '.') ADVANCE(55);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(101);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(109);
      if (lookahead == '@') ADVANCE(77);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(97);
      if (lookahead == '|') ADVANCE(82);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(8);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 9:
      if (lookahead == '\r') SKIP(9);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '-') ADVANCE(28);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == '\\') ADVANCE(10);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(9);
      END_STATE();
    case 10:
      if (lookahead == '\r') ADVANCE(1);
      if ((!eof && lookahead == 00) ||
          lookahead == '\n') ADVANCE(146);
      END_STATE();
    case 11:
      if (lookahead == '\r') SKIP(11);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '%') ADVANCE(90);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(78);
      if (lookahead == '.') ADVANCE(55);
      if (lookahead == '/') ADVANCE(89);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(102);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '@') ADVANCE(76);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(96);
      if (lookahead == '|') ADVANCE(81);
      if (lookahead == '}') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(11);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 12:
      if (lookahead == '\r') SKIP(12);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '%') ADVANCE(90);
      if (lookahead == '&') ADVANCE(94);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(62);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(78);
      if (lookahead == '.') ADVANCE(55);
      if (lookahead == '/') ADVANCE(89);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(102);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(110);
      if (lookahead == '@') ADVANCE(76);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(96);
      if (lookahead == '|') ADVANCE(81);
      if (lookahead == '}') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(12);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 13:
      if (lookahead == '.') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      END_STATE();
    case 14:
      if (lookahead == '.') ADVANCE(125);
      END_STATE();
    case 15:
      if (lookahead == '/') ADVANCE(25);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 16:
      if (lookahead == '<') ADVANCE(26);
      END_STATE();
    case 17:
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(106);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(131);
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 21:
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 22:
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 26:
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 27:
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 28:
      if (lookahead == '>') ADVANCE(69);
      END_STATE();
    case 29:
      if (lookahead == '>') ADVANCE(27);
      END_STATE();
    case 30:
      if (lookahead == '_') ADVANCE(36);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(136);
      END_STATE();
    case 31:
      if (lookahead == '_') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(137);
      END_STATE();
    case 32:
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(138);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(50);
      END_STATE();
    case 34:
      if (lookahead == '}') ADVANCE(126);
      if (lookahead != 0) ADVANCE(34);
      END_STATE();
    case 35:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(141);
      END_STATE();
    case 36:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(136);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(137);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(141);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(38);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(126);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(138);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 50:
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(34);
      END_STATE();
    case 51:
      if (eof) ADVANCE(53);
      if (lookahead == '\r') SKIP(51);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '%') ADVANCE(91);
      if (lookahead == '&') ADVANCE(95);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(61);
      if (lookahead == '+') ADVANCE(86);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(80);
      if (lookahead == '.') ADVANCE(56);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(133);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(101);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(109);
      if (lookahead == '@') ADVANCE(77);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '^') ADVANCE(97);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '|') ADVANCE(82);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '~') ADVANCE(100);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(51);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 52:
      if (eof) ADVANCE(53);
      if (lookahead == '\r') SKIP(52);
      if (lookahead == '!') ADVANCE(18);
      if (lookahead == '#') ADVANCE(145);
      if (lookahead == '(') ADVANCE(57);
      if (lookahead == ')') ADVANCE(58);
      if (lookahead == '*') ADVANCE(60);
      if (lookahead == '+') ADVANCE(85);
      if (lookahead == ',') ADVANCE(59);
      if (lookahead == '-') ADVANCE(78);
      if (lookahead == '.') ADVANCE(56);
      if (lookahead == '0') ADVANCE(133);
      if (lookahead == ':') ADVANCE(67);
      if (lookahead == ';') ADVANCE(54);
      if (lookahead == '<') ADVANCE(103);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(108);
      if (lookahead == '@') ADVANCE(76);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(10);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == '{') ADVANCE(83);
      if (lookahead == '|') ADVANCE(81);
      if (lookahead == '}') ADVANCE(84);
      if (lookahead == '~') ADVANCE(100);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(52);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(134);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(144);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(71);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(70);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(24);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(66);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(113);
      if (lookahead == '>') ADVANCE(69);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(124);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(93);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(92);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(122);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(123);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(121);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(99);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(111);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(98);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(111);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(111);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(107);
      if (lookahead == '>') ADVANCE(65);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(107);
      if (lookahead == '>') ADVANCE(64);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym__not_escape_sequence);
      ADVANCE_MAP(
        0, 146,
        '\n', 126,
        '\r', 2,
        'N', 33,
        'U', 49,
        'u', 45,
        'x', 43,
        '"', 126,
        '\'', 126,
        '\\', 126,
        'a', 126,
        'b', 126,
        'f', 126,
        'n', 126,
        'r', 126,
        't', 126,
        'v', 126,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(40);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if ((!eof && lookahead == 00)) ADVANCE(130);
      if (lookahead == '\r') ADVANCE(130);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(130);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      ADVANCE_MAP(
        '\r', 129,
        '#', 130,
        '\\', 128,
        '\t', 129,
        0x0b, 129,
        '\f', 129,
        ' ', 129,
        0x200b, 129,
        0x2060, 129,
        0xfeff, 129,
      );
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(130);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '.', 142,
        '_', 135,
        'B', 30,
        'b', 30,
        'E', 35,
        'e', 35,
        'O', 31,
        'o', 31,
        'X', 32,
        'x', 32,
        'J', 132,
        'L', 132,
        'j', 132,
        'l', 132,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_integer);
      ADVANCE_MAP(
        '.', 142,
        '_', 135,
        'E', 35,
        'e', 35,
        'J', 132,
        'L', 132,
        'j', 132,
        'l', 132,
      );
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(35);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(134);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(36);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(132);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(142);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(35);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(143);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(141);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(35);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(140);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'j') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(141);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(145);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_line_continuation);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\r') SKIP(0);
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '_') ADVANCE(4);
      if (lookahead == 'a') ADVANCE(5);
      if (lookahead == 'b') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(7);
      if (lookahead == 'd') ADVANCE(8);
      if (lookahead == 'e') ADVANCE(9);
      if (lookahead == 'f') ADVANCE(10);
      if (lookahead == 'g') ADVANCE(11);
      if (lookahead == 'i') ADVANCE(12);
      if (lookahead == 'l') ADVANCE(13);
      if (lookahead == 'm') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 't') ADVANCE(20);
      if (lookahead == 'w') ADVANCE(21);
      if (lookahead == 'y') ADVANCE(22);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ' ||
          lookahead == 0x200b ||
          lookahead == 0x2060 ||
          lookahead == 0xfeff) SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'a') ADVANCE(23);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 3:
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '_') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'n') ADVANCE(27);
      if (lookahead == 's') ADVANCE(28);
      if (lookahead == 'w') ADVANCE(29);
      END_STATE();
    case 6:
      if (lookahead == 'r') ADVANCE(30);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(31);
      if (lookahead == 'l') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 9:
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'q') ADVANCE(36);
      if (lookahead == 'x') ADVANCE(37);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(38);
      if (lookahead == 'i') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      if (lookahead == 'r') ADVANCE(41);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(42);
      END_STATE();
    case 12:
      if (lookahead == 'f') ADVANCE(43);
      if (lookahead == 'm') ADVANCE(44);
      if (lookahead == 'n') ADVANCE(45);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(46);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(47);
      END_STATE();
    case 15:
      if (lookahead == 'e') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(50);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(51);
      if (lookahead == 'r') ADVANCE(52);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'e') ADVANCE(54);
      END_STATE();
    case 19:
      if (lookahead == 't') ADVANCE(55);
      END_STATE();
    case 20:
      if (lookahead == 'r') ADVANCE(56);
      if (lookahead == 'y') ADVANCE(57);
      END_STATE();
    case 21:
      if (lookahead == 'h') ADVANCE(58);
      if (lookahead == 'i') ADVANCE(59);
      END_STATE();
    case 22:
      if (lookahead == 'i') ADVANCE(60);
      END_STATE();
    case 23:
      if (lookahead == 'l') ADVANCE(61);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(62);
      END_STATE();
    case 25:
      if (lookahead == 'u') ADVANCE(63);
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(64);
      END_STATE();
    case 27:
      if (lookahead == 'd') ADVANCE(65);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(66);
      if (lookahead == 'y') ADVANCE(67);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(68);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(69);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(70);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(71);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(72);
      END_STATE();
    case 34:
      if (lookahead == 'f') ADVANCE(73);
      if (lookahead == 'l') ADVANCE(74);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(75);
      if (lookahead == 's') ADVANCE(76);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_eq);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(77);
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 38:
      if (lookahead == 'i') ADVANCE(79);
      END_STATE();
    case 39:
      if (lookahead == 'n') ADVANCE(80);
      END_STATE();
    case 40:
      if (lookahead == 'r') ADVANCE(81);
      END_STATE();
    case 41:
      if (lookahead == 'o') ADVANCE(82);
      END_STATE();
    case 42:
      if (lookahead == 'o') ADVANCE(83);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p') ADVANCE(84);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 46:
      if (lookahead == 'm') ADVANCE(85);
      END_STATE();
    case 47:
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_ne);
      END_STATE();
    case 49:
      if (lookahead == 'n') ADVANCE(87);
      if (lookahead == 't') ADVANCE(88);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 51:
      if (lookahead == 's') ADVANCE(89);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(90);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(91);
      END_STATE();
    case 54:
      if (lookahead == 't') ADVANCE(92);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 56:
      if (lookahead == 'y') ADVANCE(94);
      END_STATE();
    case 57:
      if (lookahead == 'p') ADVANCE(95);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(98);
      END_STATE();
    case 61:
      if (lookahead == 's') ADVANCE(99);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 63:
      if (lookahead == 'e') ADVANCE(101);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(102);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 67:
      if (lookahead == 'n') ADVANCE(104);
      END_STATE();
    case 68:
      if (lookahead == 'i') ADVANCE(105);
      END_STATE();
    case 69:
      if (lookahead == 'a') ADVANCE(106);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 71:
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(109);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 75:
      if (lookahead == 'f') ADVANCE(110);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(112);
      END_STATE();
    case 78:
      if (lookahead == 'c') ADVANCE(113);
      END_STATE();
    case 79:
      if (lookahead == 'l') ADVANCE(114);
      END_STATE();
    case 80:
      if (lookahead == 'a') ADVANCE(115);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 82:
      if (lookahead == 'm') ADVANCE(116);
      END_STATE();
    case 83:
      if (lookahead == 'b') ADVANCE(117);
      END_STATE();
    case 84:
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 85:
      if (lookahead == 'b') ADVANCE(119);
      END_STATE();
    case 86:
      if (lookahead == 'c') ADVANCE(120);
      END_STATE();
    case 87:
      if (lookahead == 'l') ADVANCE(121);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 89:
      if (lookahead == 's') ADVANCE(122);
      END_STATE();
    case 90:
      if (lookahead == 'n') ADVANCE(123);
      END_STATE();
    case 91:
      if (lookahead == 's') ADVANCE(124);
      END_STATE();
    case 92:
      if (lookahead == 'u') ADVANCE(125);
      END_STATE();
    case 93:
      if (lookahead == 'u') ADVANCE(126);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 95:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 96:
      if (lookahead == 'l') ADVANCE(128);
      END_STATE();
    case 97:
      if (lookahead == 'h') ADVANCE(129);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 99:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 102:
      if (lookahead == 't') ADVANCE(132);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 104:
      if (lookahead == 'c') ADVANCE(134);
      END_STATE();
    case 105:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 106:
      if (lookahead == 'k') ADVANCE(136);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 108:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 109:
      if (lookahead == 'a') ADVANCE(138);
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 112:
      if (lookahead == 'p') ADVANCE(140);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 114:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 115:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 118:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 119:
      if (lookahead == 'd') ADVANCE(145);
      END_STATE();
    case 120:
      if (lookahead == 'h') ADVANCE(146);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 125:
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 126:
      if (lookahead == 'c') ADVANCE(151);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 130:
      if (lookahead == 'd') ADVANCE(153);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 132:
      if (lookahead == 'u') ADVANCE(154);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(155);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 138:
      if (lookahead == 'i') ADVANCE(156);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(157);
      END_STATE();
    case 140:
      if (lookahead == 't') ADVANCE(158);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_fails);
      END_STATE();
    case 142:
      if (lookahead == 'l') ADVANCE(159);
      END_STATE();
    case 143:
      if (lookahead == 'l') ADVANCE(160);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(161);
      END_STATE();
    case 145:
      if (lookahead == 'a') ADVANCE(162);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 147:
      if (lookahead == 'c') ADVANCE(163);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(164);
      END_STATE();
    case 151:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 154:
      if (lookahead == 'r') ADVANCE(166);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_assert);
      if (lookahead == '_') ADVANCE(167);
      END_STATE();
    case 156:
      if (lookahead == 'n') ADVANCE(168);
      END_STATE();
    case 157:
      if (lookahead == 'u') ADVANCE(169);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_except);
      END_STATE();
    case 159:
      if (lookahead == 'y') ADVANCE(170);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 163:
      if (lookahead == 'a') ADVANCE(171);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 166:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_assert_);
      if (lookahead == 'c') ADVANCE(173);
      if (lookahead == 'e') ADVANCE(174);
      if (lookahead == 'f') ADVANCE(175);
      if (lookahead == 'n') ADVANCE(176);
      END_STATE();
    case 168:
      if (lookahead == 's') ADVANCE(177);
      END_STATE();
    case 169:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 171:
      if (lookahead == 'l') ADVANCE(179);
      END_STATE();
    case 172:
      if (lookahead == '_') ADVANCE(180);
      END_STATE();
    case 173:
      if (lookahead == 'o') ADVANCE(181);
      END_STATE();
    case 174:
      if (lookahead == 'q') ADVANCE(182);
      END_STATE();
    case 175:
      if (lookahead == 'a') ADVANCE(183);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_contains);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 180:
      if (lookahead == '_') ADVANCE(185);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(186);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_assert_eq);
      END_STATE();
    case 183:
      if (lookahead == 'i') ADVANCE(187);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_assert_ne);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    case 186:
      if (lookahead == 't') ADVANCE(188);
      END_STATE();
    case 187:
      if (lookahead == 'l') ADVANCE(189);
      END_STATE();
    case 188:
      if (lookahead == 'a') ADVANCE(190);
      END_STATE();
    case 189:
      if (lookahead == 's') ADVANCE(191);
      END_STATE();
    case 190:
      if (lookahead == 'i') ADVANCE(192);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_assert_fails);
      END_STATE();
    case 192:
      if (lookahead == 'n') ADVANCE(193);
      END_STATE();
    case 193:
      if (lookahead == 's') ADVANCE(194);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_assert_contains);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 52, .external_lex_state = 2},
  [2] = {.lex_state = 52, .external_lex_state = 3},
  [3] = {.lex_state = 52, .external_lex_state = 3},
  [4] = {.lex_state = 52, .external_lex_state = 3},
  [5] = {.lex_state = 52, .external_lex_state = 3},
  [6] = {.lex_state = 52, .external_lex_state = 3},
  [7] = {.lex_state = 52, .external_lex_state = 3},
  [8] = {.lex_state = 52, .external_lex_state = 3},
  [9] = {.lex_state = 52, .external_lex_state = 3},
  [10] = {.lex_state = 52, .external_lex_state = 3},
  [11] = {.lex_state = 52, .external_lex_state = 3},
  [12] = {.lex_state = 52, .external_lex_state = 3},
  [13] = {.lex_state = 52, .external_lex_state = 3},
  [14] = {.lex_state = 52, .external_lex_state = 3},
  [15] = {.lex_state = 52, .external_lex_state = 3},
  [16] = {.lex_state = 52, .external_lex_state = 3},
  [17] = {.lex_state = 52, .external_lex_state = 3},
  [18] = {.lex_state = 52, .external_lex_state = 3},
  [19] = {.lex_state = 52, .external_lex_state = 3},
  [20] = {.lex_state = 52, .external_lex_state = 3},
  [21] = {.lex_state = 52, .external_lex_state = 3},
  [22] = {.lex_state = 52, .external_lex_state = 3},
  [23] = {.lex_state = 52, .external_lex_state = 3},
  [24] = {.lex_state = 52, .external_lex_state = 3},
  [25] = {.lex_state = 52, .external_lex_state = 3},
  [26] = {.lex_state = 52, .external_lex_state = 3},
  [27] = {.lex_state = 52, .external_lex_state = 3},
  [28] = {.lex_state = 52, .external_lex_state = 3},
  [29] = {.lex_state = 52, .external_lex_state = 3},
  [30] = {.lex_state = 52, .external_lex_state = 3},
  [31] = {.lex_state = 52, .external_lex_state = 3},
  [32] = {.lex_state = 52, .external_lex_state = 3},
  [33] = {.lex_state = 52, .external_lex_state = 3},
  [34] = {.lex_state = 52, .external_lex_state = 3},
  [35] = {.lex_state = 52, .external_lex_state = 3},
  [36] = {.lex_state = 52, .external_lex_state = 3},
  [37] = {.lex_state = 52, .external_lex_state = 3},
  [38] = {.lex_state = 52, .external_lex_state = 3},
  [39] = {.lex_state = 52, .external_lex_state = 3},
  [40] = {.lex_state = 52, .external_lex_state = 3},
  [41] = {.lex_state = 52, .external_lex_state = 2},
  [42] = {.lex_state = 52, .external_lex_state = 3},
  [43] = {.lex_state = 52, .external_lex_state = 3},
  [44] = {.lex_state = 52, .external_lex_state = 2},
  [45] = {.lex_state = 52, .external_lex_state = 3},
  [46] = {.lex_state = 4, .external_lex_state = 4},
  [47] = {.lex_state = 4, .external_lex_state = 4},
  [48] = {.lex_state = 4, .external_lex_state = 4},
  [49] = {.lex_state = 4, .external_lex_state = 4},
  [50] = {.lex_state = 5, .external_lex_state = 5},
  [51] = {.lex_state = 5, .external_lex_state = 5},
  [52] = {.lex_state = 5, .external_lex_state = 5},
  [53] = {.lex_state = 5, .external_lex_state = 5},
  [54] = {.lex_state = 5, .external_lex_state = 5},
  [55] = {.lex_state = 5, .external_lex_state = 5},
  [56] = {.lex_state = 5, .external_lex_state = 5},
  [57] = {.lex_state = 5, .external_lex_state = 5},
  [58] = {.lex_state = 52, .external_lex_state = 5},
  [59] = {.lex_state = 52, .external_lex_state = 5},
  [60] = {.lex_state = 52, .external_lex_state = 5},
  [61] = {.lex_state = 52, .external_lex_state = 5},
  [62] = {.lex_state = 52, .external_lex_state = 5},
  [63] = {.lex_state = 52, .external_lex_state = 5},
  [64] = {.lex_state = 52, .external_lex_state = 5},
  [65] = {.lex_state = 52, .external_lex_state = 5},
  [66] = {.lex_state = 52, .external_lex_state = 5},
  [67] = {.lex_state = 52, .external_lex_state = 5},
  [68] = {.lex_state = 52, .external_lex_state = 5},
  [69] = {.lex_state = 52, .external_lex_state = 5},
  [70] = {.lex_state = 52, .external_lex_state = 5},
  [71] = {.lex_state = 52, .external_lex_state = 5},
  [72] = {.lex_state = 52, .external_lex_state = 5},
  [73] = {.lex_state = 52, .external_lex_state = 5},
  [74] = {.lex_state = 52, .external_lex_state = 5},
  [75] = {.lex_state = 52, .external_lex_state = 5},
  [76] = {.lex_state = 52, .external_lex_state = 5},
  [77] = {.lex_state = 52, .external_lex_state = 5},
  [78] = {.lex_state = 52, .external_lex_state = 5},
  [79] = {.lex_state = 52, .external_lex_state = 5},
  [80] = {.lex_state = 52, .external_lex_state = 5},
  [81] = {.lex_state = 52, .external_lex_state = 5},
  [82] = {.lex_state = 52, .external_lex_state = 5},
  [83] = {.lex_state = 52, .external_lex_state = 5},
  [84] = {.lex_state = 52, .external_lex_state = 5},
  [85] = {.lex_state = 52, .external_lex_state = 5},
  [86] = {.lex_state = 52, .external_lex_state = 5},
  [87] = {.lex_state = 52, .external_lex_state = 5},
  [88] = {.lex_state = 52, .external_lex_state = 4},
  [89] = {.lex_state = 52, .external_lex_state = 4},
  [90] = {.lex_state = 52, .external_lex_state = 4},
  [91] = {.lex_state = 52, .external_lex_state = 4},
  [92] = {.lex_state = 52, .external_lex_state = 4},
  [93] = {.lex_state = 52, .external_lex_state = 4},
  [94] = {.lex_state = 52, .external_lex_state = 2},
  [95] = {.lex_state = 6, .external_lex_state = 4},
  [96] = {.lex_state = 6, .external_lex_state = 4},
  [97] = {.lex_state = 5, .external_lex_state = 6},
  [98] = {.lex_state = 5, .external_lex_state = 6},
  [99] = {.lex_state = 52, .external_lex_state = 7},
  [100] = {.lex_state = 52, .external_lex_state = 7},
  [101] = {.lex_state = 5, .external_lex_state = 8},
  [102] = {.lex_state = 52, .external_lex_state = 6},
  [103] = {.lex_state = 5, .external_lex_state = 6},
  [104] = {.lex_state = 52, .external_lex_state = 6},
  [105] = {.lex_state = 5, .external_lex_state = 6},
  [106] = {.lex_state = 52, .external_lex_state = 7},
  [107] = {.lex_state = 52, .external_lex_state = 7},
  [108] = {.lex_state = 52, .external_lex_state = 6},
  [109] = {.lex_state = 5, .external_lex_state = 8},
  [110] = {.lex_state = 52, .external_lex_state = 6},
  [111] = {.lex_state = 5, .external_lex_state = 6},
  [112] = {.lex_state = 5, .external_lex_state = 6},
  [113] = {.lex_state = 52, .external_lex_state = 7},
  [114] = {.lex_state = 52, .external_lex_state = 6},
  [115] = {.lex_state = 52, .external_lex_state = 6},
  [116] = {.lex_state = 52, .external_lex_state = 7},
  [117] = {.lex_state = 5, .external_lex_state = 6},
  [118] = {.lex_state = 52, .external_lex_state = 7},
  [119] = {.lex_state = 52, .external_lex_state = 6},
  [120] = {.lex_state = 5, .external_lex_state = 8},
  [121] = {.lex_state = 52, .external_lex_state = 7},
  [122] = {.lex_state = 52, .external_lex_state = 6},
  [123] = {.lex_state = 52, .external_lex_state = 6},
  [124] = {.lex_state = 5, .external_lex_state = 8},
  [125] = {.lex_state = 5, .external_lex_state = 8},
  [126] = {.lex_state = 52, .external_lex_state = 7},
  [127] = {.lex_state = 52, .external_lex_state = 2},
  [128] = {.lex_state = 52, .external_lex_state = 2},
  [129] = {.lex_state = 52, .external_lex_state = 6},
  [130] = {.lex_state = 5, .external_lex_state = 8},
  [131] = {.lex_state = 52, .external_lex_state = 7},
  [132] = {.lex_state = 5, .external_lex_state = 8},
  [133] = {.lex_state = 52, .external_lex_state = 7},
  [134] = {.lex_state = 5, .external_lex_state = 6},
  [135] = {.lex_state = 52, .external_lex_state = 6},
  [136] = {.lex_state = 52, .external_lex_state = 2},
  [137] = {.lex_state = 5, .external_lex_state = 2},
  [138] = {.lex_state = 5, .external_lex_state = 7},
  [139] = {.lex_state = 5, .external_lex_state = 7},
  [140] = {.lex_state = 5, .external_lex_state = 2},
  [141] = {.lex_state = 5, .external_lex_state = 2},
  [142] = {.lex_state = 5, .external_lex_state = 7},
  [143] = {.lex_state = 5, .external_lex_state = 2},
  [144] = {.lex_state = 5, .external_lex_state = 2},
  [145] = {.lex_state = 5, .external_lex_state = 2},
  [146] = {.lex_state = 5, .external_lex_state = 2},
  [147] = {.lex_state = 5, .external_lex_state = 2},
  [148] = {.lex_state = 5, .external_lex_state = 2},
  [149] = {.lex_state = 5, .external_lex_state = 2},
  [150] = {.lex_state = 5, .external_lex_state = 2},
  [151] = {.lex_state = 5, .external_lex_state = 2},
  [152] = {.lex_state = 5, .external_lex_state = 7},
  [153] = {.lex_state = 6, .external_lex_state = 2},
  [154] = {.lex_state = 5, .external_lex_state = 2},
  [155] = {.lex_state = 5, .external_lex_state = 2},
  [156] = {.lex_state = 5, .external_lex_state = 7},
  [157] = {.lex_state = 5, .external_lex_state = 2},
  [158] = {.lex_state = 5, .external_lex_state = 2},
  [159] = {.lex_state = 5, .external_lex_state = 2},
  [160] = {.lex_state = 5, .external_lex_state = 2},
  [161] = {.lex_state = 5, .external_lex_state = 7},
  [162] = {.lex_state = 5, .external_lex_state = 2},
  [163] = {.lex_state = 6, .external_lex_state = 2},
  [164] = {.lex_state = 5, .external_lex_state = 7},
  [165] = {.lex_state = 5, .external_lex_state = 2},
  [166] = {.lex_state = 5, .external_lex_state = 2},
  [167] = {.lex_state = 5, .external_lex_state = 2},
  [168] = {.lex_state = 5, .external_lex_state = 2},
  [169] = {.lex_state = 5, .external_lex_state = 2},
  [170] = {.lex_state = 5, .external_lex_state = 7},
  [171] = {.lex_state = 5, .external_lex_state = 7},
  [172] = {.lex_state = 5, .external_lex_state = 7},
  [173] = {.lex_state = 5, .external_lex_state = 7},
  [174] = {.lex_state = 5, .external_lex_state = 7},
  [175] = {.lex_state = 5, .external_lex_state = 7},
  [176] = {.lex_state = 5, .external_lex_state = 7},
  [177] = {.lex_state = 5, .external_lex_state = 7},
  [178] = {.lex_state = 52, .external_lex_state = 2},
  [179] = {.lex_state = 5, .external_lex_state = 7},
  [180] = {.lex_state = 5, .external_lex_state = 7},
  [181] = {.lex_state = 5, .external_lex_state = 7},
  [182] = {.lex_state = 5, .external_lex_state = 7},
  [183] = {.lex_state = 5, .external_lex_state = 7},
  [184] = {.lex_state = 5, .external_lex_state = 7},
  [185] = {.lex_state = 5, .external_lex_state = 7},
  [186] = {.lex_state = 5, .external_lex_state = 7},
  [187] = {.lex_state = 5, .external_lex_state = 7},
  [188] = {.lex_state = 5, .external_lex_state = 7},
  [189] = {.lex_state = 5, .external_lex_state = 7},
  [190] = {.lex_state = 5, .external_lex_state = 7},
  [191] = {.lex_state = 5, .external_lex_state = 7},
  [192] = {.lex_state = 5, .external_lex_state = 7},
  [193] = {.lex_state = 5, .external_lex_state = 7},
  [194] = {.lex_state = 5, .external_lex_state = 7},
  [195] = {.lex_state = 5, .external_lex_state = 7},
  [196] = {.lex_state = 52, .external_lex_state = 2},
  [197] = {.lex_state = 5, .external_lex_state = 7},
  [198] = {.lex_state = 5, .external_lex_state = 7},
  [199] = {.lex_state = 5, .external_lex_state = 7},
  [200] = {.lex_state = 52, .external_lex_state = 8},
  [201] = {.lex_state = 52, .external_lex_state = 6},
  [202] = {.lex_state = 52, .external_lex_state = 8},
  [203] = {.lex_state = 5, .external_lex_state = 2},
  [204] = {.lex_state = 52, .external_lex_state = 7},
  [205] = {.lex_state = 52, .external_lex_state = 6},
  [206] = {.lex_state = 52, .external_lex_state = 8},
  [207] = {.lex_state = 52, .external_lex_state = 6},
  [208] = {.lex_state = 52, .external_lex_state = 8},
  [209] = {.lex_state = 52, .external_lex_state = 6},
  [210] = {.lex_state = 5, .external_lex_state = 8},
  [211] = {.lex_state = 52, .external_lex_state = 7},
  [212] = {.lex_state = 5, .external_lex_state = 8},
  [213] = {.lex_state = 52, .external_lex_state = 6},
  [214] = {.lex_state = 5, .external_lex_state = 8},
  [215] = {.lex_state = 5, .external_lex_state = 8},
  [216] = {.lex_state = 5, .external_lex_state = 8},
  [217] = {.lex_state = 52, .external_lex_state = 6},
  [218] = {.lex_state = 52, .external_lex_state = 7},
  [219] = {.lex_state = 52, .external_lex_state = 8},
  [220] = {.lex_state = 5, .external_lex_state = 8},
  [221] = {.lex_state = 52, .external_lex_state = 8},
  [222] = {.lex_state = 5, .external_lex_state = 8},
  [223] = {.lex_state = 52, .external_lex_state = 7},
  [224] = {.lex_state = 5, .external_lex_state = 8},
  [225] = {.lex_state = 5, .external_lex_state = 8},
  [226] = {.lex_state = 52, .external_lex_state = 7},
  [227] = {.lex_state = 52, .external_lex_state = 7},
  [228] = {.lex_state = 5, .external_lex_state = 8},
  [229] = {.lex_state = 52, .external_lex_state = 6},
  [230] = {.lex_state = 5, .external_lex_state = 8},
  [231] = {.lex_state = 52, .external_lex_state = 7},
  [232] = {.lex_state = 52, .external_lex_state = 7},
  [233] = {.lex_state = 5, .external_lex_state = 8},
  [234] = {.lex_state = 52, .external_lex_state = 7},
  [235] = {.lex_state = 52, .external_lex_state = 6},
  [236] = {.lex_state = 52, .external_lex_state = 7},
  [237] = {.lex_state = 52, .external_lex_state = 7},
  [238] = {.lex_state = 52, .external_lex_state = 6},
  [239] = {.lex_state = 52, .external_lex_state = 7},
  [240] = {.lex_state = 52, .external_lex_state = 6},
  [241] = {.lex_state = 5, .external_lex_state = 8},
  [242] = {.lex_state = 52, .external_lex_state = 7},
  [243] = {.lex_state = 5, .external_lex_state = 8},
  [244] = {.lex_state = 52, .external_lex_state = 6},
  [245] = {.lex_state = 52, .external_lex_state = 6},
  [246] = {.lex_state = 52, .external_lex_state = 4},
  [247] = {.lex_state = 52, .external_lex_state = 6},
  [248] = {.lex_state = 52, .external_lex_state = 6},
  [249] = {.lex_state = 52, .external_lex_state = 6},
  [250] = {.lex_state = 52, .external_lex_state = 6},
  [251] = {.lex_state = 52, .external_lex_state = 7},
  [252] = {.lex_state = 52, .external_lex_state = 6},
  [253] = {.lex_state = 52, .external_lex_state = 6},
  [254] = {.lex_state = 52, .external_lex_state = 6},
  [255] = {.lex_state = 52, .external_lex_state = 6},
  [256] = {.lex_state = 52, .external_lex_state = 8},
  [257] = {.lex_state = 52, .external_lex_state = 6},
  [258] = {.lex_state = 52, .external_lex_state = 6},
  [259] = {.lex_state = 52, .external_lex_state = 6},
  [260] = {.lex_state = 5, .external_lex_state = 2},
  [261] = {.lex_state = 52, .external_lex_state = 6},
  [262] = {.lex_state = 52, .external_lex_state = 6},
  [263] = {.lex_state = 52, .external_lex_state = 6},
  [264] = {.lex_state = 52, .external_lex_state = 6},
  [265] = {.lex_state = 52, .external_lex_state = 6},
  [266] = {.lex_state = 52, .external_lex_state = 6},
  [267] = {.lex_state = 52, .external_lex_state = 6},
  [268] = {.lex_state = 52, .external_lex_state = 6},
  [269] = {.lex_state = 52, .external_lex_state = 6},
  [270] = {.lex_state = 52, .external_lex_state = 6},
  [271] = {.lex_state = 52, .external_lex_state = 6},
  [272] = {.lex_state = 52, .external_lex_state = 6},
  [273] = {.lex_state = 52, .external_lex_state = 6},
  [274] = {.lex_state = 52, .external_lex_state = 6},
  [275] = {.lex_state = 52, .external_lex_state = 6},
  [276] = {.lex_state = 52, .external_lex_state = 6},
  [277] = {.lex_state = 52, .external_lex_state = 6},
  [278] = {.lex_state = 52, .external_lex_state = 7},
  [279] = {.lex_state = 52, .external_lex_state = 6},
  [280] = {.lex_state = 52, .external_lex_state = 6},
  [281] = {.lex_state = 52, .external_lex_state = 8},
  [282] = {.lex_state = 52, .external_lex_state = 4},
  [283] = {.lex_state = 52, .external_lex_state = 6},
  [284] = {.lex_state = 52, .external_lex_state = 2},
  [285] = {.lex_state = 52, .external_lex_state = 2},
  [286] = {.lex_state = 52, .external_lex_state = 2},
  [287] = {.lex_state = 52, .external_lex_state = 4},
  [288] = {.lex_state = 7, .external_lex_state = 9},
  [289] = {.lex_state = 52, .external_lex_state = 2},
  [290] = {.lex_state = 52, .external_lex_state = 2},
  [291] = {.lex_state = 52, .external_lex_state = 2},
  [292] = {.lex_state = 7, .external_lex_state = 4},
  [293] = {.lex_state = 52, .external_lex_state = 4},
  [294] = {.lex_state = 7, .external_lex_state = 9},
  [295] = {.lex_state = 52, .external_lex_state = 2},
  [296] = {.lex_state = 7, .external_lex_state = 4},
  [297] = {.lex_state = 52, .external_lex_state = 2},
  [298] = {.lex_state = 52, .external_lex_state = 2},
  [299] = {.lex_state = 52, .external_lex_state = 2},
  [300] = {.lex_state = 52, .external_lex_state = 6},
  [301] = {.lex_state = 52, .external_lex_state = 2},
  [302] = {.lex_state = 52, .external_lex_state = 2},
  [303] = {.lex_state = 52, .external_lex_state = 2},
  [304] = {.lex_state = 52, .external_lex_state = 6},
  [305] = {.lex_state = 52, .external_lex_state = 7},
  [306] = {.lex_state = 52, .external_lex_state = 2},
  [307] = {.lex_state = 52, .external_lex_state = 2},
  [308] = {.lex_state = 52, .external_lex_state = 2},
  [309] = {.lex_state = 52, .external_lex_state = 2},
  [310] = {.lex_state = 52, .external_lex_state = 2},
  [311] = {.lex_state = 52, .external_lex_state = 2},
  [312] = {.lex_state = 52, .external_lex_state = 2},
  [313] = {.lex_state = 52, .external_lex_state = 7},
  [314] = {.lex_state = 52, .external_lex_state = 2},
  [315] = {.lex_state = 52, .external_lex_state = 2},
  [316] = {.lex_state = 52, .external_lex_state = 4},
  [317] = {.lex_state = 52, .external_lex_state = 4},
  [318] = {.lex_state = 52, .external_lex_state = 2},
  [319] = {.lex_state = 52, .external_lex_state = 2},
  [320] = {.lex_state = 52, .external_lex_state = 2},
  [321] = {.lex_state = 52, .external_lex_state = 2},
  [322] = {.lex_state = 52, .external_lex_state = 2},
  [323] = {.lex_state = 52, .external_lex_state = 2},
  [324] = {.lex_state = 52, .external_lex_state = 4},
  [325] = {.lex_state = 52, .external_lex_state = 2},
  [326] = {.lex_state = 52, .external_lex_state = 4},
  [327] = {.lex_state = 52, .external_lex_state = 4},
  [328] = {.lex_state = 52, .external_lex_state = 2},
  [329] = {.lex_state = 52, .external_lex_state = 2},
  [330] = {.lex_state = 52, .external_lex_state = 2},
  [331] = {.lex_state = 52, .external_lex_state = 2},
  [332] = {.lex_state = 52, .external_lex_state = 2},
  [333] = {.lex_state = 52, .external_lex_state = 2},
  [334] = {.lex_state = 52, .external_lex_state = 2},
  [335] = {.lex_state = 52, .external_lex_state = 2},
  [336] = {.lex_state = 52, .external_lex_state = 2},
  [337] = {.lex_state = 52, .external_lex_state = 2},
  [338] = {.lex_state = 52, .external_lex_state = 2},
  [339] = {.lex_state = 52, .external_lex_state = 2},
  [340] = {.lex_state = 52, .external_lex_state = 2},
  [341] = {.lex_state = 52, .external_lex_state = 2},
  [342] = {.lex_state = 52, .external_lex_state = 2},
  [343] = {.lex_state = 52, .external_lex_state = 2},
  [344] = {.lex_state = 52, .external_lex_state = 2},
  [345] = {.lex_state = 52, .external_lex_state = 2},
  [346] = {.lex_state = 52, .external_lex_state = 2},
  [347] = {.lex_state = 52, .external_lex_state = 2},
  [348] = {.lex_state = 52, .external_lex_state = 2},
  [349] = {.lex_state = 52, .external_lex_state = 2},
  [350] = {.lex_state = 52, .external_lex_state = 2},
  [351] = {.lex_state = 52, .external_lex_state = 2},
  [352] = {.lex_state = 52, .external_lex_state = 2},
  [353] = {.lex_state = 52, .external_lex_state = 2},
  [354] = {.lex_state = 52, .external_lex_state = 2},
  [355] = {.lex_state = 52, .external_lex_state = 2},
  [356] = {.lex_state = 52, .external_lex_state = 2},
  [357] = {.lex_state = 52, .external_lex_state = 2},
  [358] = {.lex_state = 52, .external_lex_state = 2},
  [359] = {.lex_state = 52, .external_lex_state = 2},
  [360] = {.lex_state = 52, .external_lex_state = 2},
  [361] = {.lex_state = 52, .external_lex_state = 2},
  [362] = {.lex_state = 52, .external_lex_state = 2},
  [363] = {.lex_state = 52, .external_lex_state = 2},
  [364] = {.lex_state = 7, .external_lex_state = 9},
  [365] = {.lex_state = 52, .external_lex_state = 2},
  [366] = {.lex_state = 52, .external_lex_state = 2},
  [367] = {.lex_state = 52, .external_lex_state = 2},
  [368] = {.lex_state = 52, .external_lex_state = 2},
  [369] = {.lex_state = 52, .external_lex_state = 2},
  [370] = {.lex_state = 52, .external_lex_state = 2},
  [371] = {.lex_state = 52, .external_lex_state = 2},
  [372] = {.lex_state = 52, .external_lex_state = 2},
  [373] = {.lex_state = 52, .external_lex_state = 2},
  [374] = {.lex_state = 52, .external_lex_state = 2},
  [375] = {.lex_state = 52, .external_lex_state = 2},
  [376] = {.lex_state = 52, .external_lex_state = 2},
  [377] = {.lex_state = 52, .external_lex_state = 2},
  [378] = {.lex_state = 52, .external_lex_state = 2},
  [379] = {.lex_state = 52, .external_lex_state = 2},
  [380] = {.lex_state = 52, .external_lex_state = 2},
  [381] = {.lex_state = 52, .external_lex_state = 2},
  [382] = {.lex_state = 52, .external_lex_state = 2},
  [383] = {.lex_state = 52, .external_lex_state = 2},
  [384] = {.lex_state = 52, .external_lex_state = 2},
  [385] = {.lex_state = 52, .external_lex_state = 2},
  [386] = {.lex_state = 52, .external_lex_state = 2},
  [387] = {.lex_state = 52, .external_lex_state = 2},
  [388] = {.lex_state = 52, .external_lex_state = 2},
  [389] = {.lex_state = 52, .external_lex_state = 2},
  [390] = {.lex_state = 52, .external_lex_state = 2},
  [391] = {.lex_state = 52, .external_lex_state = 2},
  [392] = {.lex_state = 52, .external_lex_state = 2},
  [393] = {.lex_state = 52, .external_lex_state = 2},
  [394] = {.lex_state = 52, .external_lex_state = 2},
  [395] = {.lex_state = 52, .external_lex_state = 2},
  [396] = {.lex_state = 52, .external_lex_state = 2},
  [397] = {.lex_state = 52, .external_lex_state = 2},
  [398] = {.lex_state = 52, .external_lex_state = 2},
  [399] = {.lex_state = 52, .external_lex_state = 2},
  [400] = {.lex_state = 52, .external_lex_state = 2},
  [401] = {.lex_state = 52, .external_lex_state = 2},
  [402] = {.lex_state = 52, .external_lex_state = 2},
  [403] = {.lex_state = 52, .external_lex_state = 2},
  [404] = {.lex_state = 52, .external_lex_state = 2},
  [405] = {.lex_state = 52, .external_lex_state = 2},
  [406] = {.lex_state = 52, .external_lex_state = 2},
  [407] = {.lex_state = 52, .external_lex_state = 2},
  [408] = {.lex_state = 52, .external_lex_state = 2},
  [409] = {.lex_state = 52, .external_lex_state = 2},
  [410] = {.lex_state = 52, .external_lex_state = 2},
  [411] = {.lex_state = 52, .external_lex_state = 2},
  [412] = {.lex_state = 52, .external_lex_state = 2},
  [413] = {.lex_state = 52, .external_lex_state = 2},
  [414] = {.lex_state = 52, .external_lex_state = 2},
  [415] = {.lex_state = 52, .external_lex_state = 2},
  [416] = {.lex_state = 52, .external_lex_state = 2},
  [417] = {.lex_state = 52, .external_lex_state = 2},
  [418] = {.lex_state = 52, .external_lex_state = 2},
  [419] = {.lex_state = 52, .external_lex_state = 2},
  [420] = {.lex_state = 52, .external_lex_state = 2},
  [421] = {.lex_state = 52, .external_lex_state = 2},
  [422] = {.lex_state = 52, .external_lex_state = 2},
  [423] = {.lex_state = 52, .external_lex_state = 2},
  [424] = {.lex_state = 52, .external_lex_state = 2},
  [425] = {.lex_state = 52, .external_lex_state = 2},
  [426] = {.lex_state = 52, .external_lex_state = 2},
  [427] = {.lex_state = 52, .external_lex_state = 2},
  [428] = {.lex_state = 52, .external_lex_state = 2},
  [429] = {.lex_state = 52, .external_lex_state = 2},
  [430] = {.lex_state = 52, .external_lex_state = 2},
  [431] = {.lex_state = 52, .external_lex_state = 2},
  [432] = {.lex_state = 52, .external_lex_state = 2},
  [433] = {.lex_state = 52, .external_lex_state = 2},
  [434] = {.lex_state = 52, .external_lex_state = 2},
  [435] = {.lex_state = 52, .external_lex_state = 2},
  [436] = {.lex_state = 52, .external_lex_state = 2},
  [437] = {.lex_state = 52, .external_lex_state = 2},
  [438] = {.lex_state = 52, .external_lex_state = 2},
  [439] = {.lex_state = 52, .external_lex_state = 2},
  [440] = {.lex_state = 7, .external_lex_state = 9},
  [441] = {.lex_state = 7, .external_lex_state = 9},
  [442] = {.lex_state = 7, .external_lex_state = 9},
  [443] = {.lex_state = 7, .external_lex_state = 9},
  [444] = {.lex_state = 7, .external_lex_state = 9},
  [445] = {.lex_state = 8, .external_lex_state = 9},
  [446] = {.lex_state = 8, .external_lex_state = 9},
  [447] = {.lex_state = 52, .external_lex_state = 3},
  [448] = {.lex_state = 8, .external_lex_state = 9},
  [449] = {.lex_state = 8, .external_lex_state = 9},
  [450] = {.lex_state = 8, .external_lex_state = 9},
  [451] = {.lex_state = 8, .external_lex_state = 9},
  [452] = {.lex_state = 52, .external_lex_state = 3},
  [453] = {.lex_state = 8, .external_lex_state = 9},
  [454] = {.lex_state = 8, .external_lex_state = 9},
  [455] = {.lex_state = 8, .external_lex_state = 9},
  [456] = {.lex_state = 52, .external_lex_state = 2},
  [457] = {.lex_state = 8, .external_lex_state = 9},
  [458] = {.lex_state = 8, .external_lex_state = 9},
  [459] = {.lex_state = 8, .external_lex_state = 9},
  [460] = {.lex_state = 52, .external_lex_state = 2},
  [461] = {.lex_state = 8, .external_lex_state = 9},
  [462] = {.lex_state = 8, .external_lex_state = 9},
  [463] = {.lex_state = 8, .external_lex_state = 9},
  [464] = {.lex_state = 8, .external_lex_state = 9},
  [465] = {.lex_state = 8, .external_lex_state = 9},
  [466] = {.lex_state = 52, .external_lex_state = 2},
  [467] = {.lex_state = 52, .external_lex_state = 2},
  [468] = {.lex_state = 8, .external_lex_state = 9},
  [469] = {.lex_state = 52, .external_lex_state = 3},
  [470] = {.lex_state = 8, .external_lex_state = 9},
  [471] = {.lex_state = 52, .external_lex_state = 3},
  [472] = {.lex_state = 52, .external_lex_state = 2},
  [473] = {.lex_state = 52, .external_lex_state = 3},
  [474] = {.lex_state = 52, .external_lex_state = 8},
  [475] = {.lex_state = 52, .external_lex_state = 8},
  [476] = {.lex_state = 52, .external_lex_state = 3},
  [477] = {.lex_state = 52, .external_lex_state = 3},
  [478] = {.lex_state = 52, .external_lex_state = 2},
  [479] = {.lex_state = 52, .external_lex_state = 2},
  [480] = {.lex_state = 52, .external_lex_state = 2},
  [481] = {.lex_state = 52, .external_lex_state = 3},
  [482] = {.lex_state = 52, .external_lex_state = 3},
  [483] = {.lex_state = 52, .external_lex_state = 3},
  [484] = {.lex_state = 52, .external_lex_state = 2},
  [485] = {.lex_state = 52, .external_lex_state = 3},
  [486] = {.lex_state = 52, .external_lex_state = 2},
  [487] = {.lex_state = 52, .external_lex_state = 2},
  [488] = {.lex_state = 52, .external_lex_state = 3},
  [489] = {.lex_state = 52, .external_lex_state = 2},
  [490] = {.lex_state = 52, .external_lex_state = 2},
  [491] = {.lex_state = 52, .external_lex_state = 2},
  [492] = {.lex_state = 52, .external_lex_state = 2},
  [493] = {.lex_state = 52, .external_lex_state = 3},
  [494] = {.lex_state = 52, .external_lex_state = 2},
  [495] = {.lex_state = 52, .external_lex_state = 2},
  [496] = {.lex_state = 52, .external_lex_state = 3},
  [497] = {.lex_state = 52, .external_lex_state = 3},
  [498] = {.lex_state = 52, .external_lex_state = 3},
  [499] = {.lex_state = 52, .external_lex_state = 3},
  [500] = {.lex_state = 52, .external_lex_state = 2},
  [501] = {.lex_state = 52, .external_lex_state = 3},
  [502] = {.lex_state = 52, .external_lex_state = 3},
  [503] = {.lex_state = 52, .external_lex_state = 2},
  [504] = {.lex_state = 52, .external_lex_state = 7},
  [505] = {.lex_state = 52, .external_lex_state = 7},
  [506] = {.lex_state = 52, .external_lex_state = 3},
  [507] = {.lex_state = 52, .external_lex_state = 3},
  [508] = {.lex_state = 52, .external_lex_state = 2},
  [509] = {.lex_state = 52, .external_lex_state = 2},
  [510] = {.lex_state = 52, .external_lex_state = 3},
  [511] = {.lex_state = 52, .external_lex_state = 3},
  [512] = {.lex_state = 52, .external_lex_state = 2},
  [513] = {.lex_state = 52, .external_lex_state = 3},
  [514] = {.lex_state = 52, .external_lex_state = 2},
  [515] = {.lex_state = 52, .external_lex_state = 2},
  [516] = {.lex_state = 52, .external_lex_state = 2},
  [517] = {.lex_state = 52, .external_lex_state = 2},
  [518] = {.lex_state = 52, .external_lex_state = 2},
  [519] = {.lex_state = 52, .external_lex_state = 6},
  [520] = {.lex_state = 52, .external_lex_state = 2},
  [521] = {.lex_state = 52, .external_lex_state = 3},
  [522] = {.lex_state = 52, .external_lex_state = 3},
  [523] = {.lex_state = 52, .external_lex_state = 3},
  [524] = {.lex_state = 52, .external_lex_state = 3},
  [525] = {.lex_state = 52, .external_lex_state = 2},
  [526] = {.lex_state = 52, .external_lex_state = 2},
  [527] = {.lex_state = 52, .external_lex_state = 3},
  [528] = {.lex_state = 52, .external_lex_state = 3},
  [529] = {.lex_state = 52, .external_lex_state = 2},
  [530] = {.lex_state = 52, .external_lex_state = 2},
  [531] = {.lex_state = 52, .external_lex_state = 3},
  [532] = {.lex_state = 52, .external_lex_state = 3},
  [533] = {.lex_state = 52, .external_lex_state = 2},
  [534] = {.lex_state = 52, .external_lex_state = 3},
  [535] = {.lex_state = 52, .external_lex_state = 3},
  [536] = {.lex_state = 52, .external_lex_state = 2},
  [537] = {.lex_state = 52, .external_lex_state = 2},
  [538] = {.lex_state = 52, .external_lex_state = 2},
  [539] = {.lex_state = 52, .external_lex_state = 3},
  [540] = {.lex_state = 52, .external_lex_state = 2},
  [541] = {.lex_state = 52, .external_lex_state = 3},
  [542] = {.lex_state = 52, .external_lex_state = 3},
  [543] = {.lex_state = 52, .external_lex_state = 3},
  [544] = {.lex_state = 52, .external_lex_state = 3},
  [545] = {.lex_state = 52, .external_lex_state = 3},
  [546] = {.lex_state = 52, .external_lex_state = 2},
  [547] = {.lex_state = 52, .external_lex_state = 3},
  [548] = {.lex_state = 52, .external_lex_state = 2},
  [549] = {.lex_state = 52, .external_lex_state = 2},
  [550] = {.lex_state = 52, .external_lex_state = 2},
  [551] = {.lex_state = 52, .external_lex_state = 2},
  [552] = {.lex_state = 52, .external_lex_state = 3},
  [553] = {.lex_state = 52, .external_lex_state = 3},
  [554] = {.lex_state = 52, .external_lex_state = 2},
  [555] = {.lex_state = 52, .external_lex_state = 2},
  [556] = {.lex_state = 52, .external_lex_state = 2},
  [557] = {.lex_state = 52, .external_lex_state = 2},
  [558] = {.lex_state = 52, .external_lex_state = 2},
  [559] = {.lex_state = 52, .external_lex_state = 2},
  [560] = {.lex_state = 52, .external_lex_state = 2},
  [561] = {.lex_state = 52, .external_lex_state = 2},
  [562] = {.lex_state = 52, .external_lex_state = 2},
  [563] = {.lex_state = 52, .external_lex_state = 3},
  [564] = {.lex_state = 52, .external_lex_state = 2},
  [565] = {.lex_state = 52, .external_lex_state = 2},
  [566] = {.lex_state = 52, .external_lex_state = 2},
  [567] = {.lex_state = 52, .external_lex_state = 3},
  [568] = {.lex_state = 52, .external_lex_state = 2},
  [569] = {.lex_state = 52, .external_lex_state = 7},
  [570] = {.lex_state = 52, .external_lex_state = 3},
  [571] = {.lex_state = 52, .external_lex_state = 3},
  [572] = {.lex_state = 52, .external_lex_state = 2},
  [573] = {.lex_state = 52, .external_lex_state = 2},
  [574] = {.lex_state = 52, .external_lex_state = 3},
  [575] = {.lex_state = 52, .external_lex_state = 2},
  [576] = {.lex_state = 52, .external_lex_state = 2},
  [577] = {.lex_state = 52, .external_lex_state = 3},
  [578] = {.lex_state = 52, .external_lex_state = 3},
  [579] = {.lex_state = 52, .external_lex_state = 2},
  [580] = {.lex_state = 52, .external_lex_state = 3},
  [581] = {.lex_state = 52, .external_lex_state = 3},
  [582] = {.lex_state = 52, .external_lex_state = 3},
  [583] = {.lex_state = 52, .external_lex_state = 3},
  [584] = {.lex_state = 52, .external_lex_state = 3},
  [585] = {.lex_state = 52, .external_lex_state = 7},
  [586] = {.lex_state = 52, .external_lex_state = 3},
  [587] = {.lex_state = 52, .external_lex_state = 6},
  [588] = {.lex_state = 52, .external_lex_state = 2},
  [589] = {.lex_state = 52, .external_lex_state = 3},
  [590] = {.lex_state = 52, .external_lex_state = 2},
  [591] = {.lex_state = 52, .external_lex_state = 2},
  [592] = {.lex_state = 52, .external_lex_state = 2},
  [593] = {.lex_state = 52, .external_lex_state = 2},
  [594] = {.lex_state = 52, .external_lex_state = 3},
  [595] = {.lex_state = 52, .external_lex_state = 2},
  [596] = {.lex_state = 52, .external_lex_state = 2},
  [597] = {.lex_state = 52, .external_lex_state = 2},
  [598] = {.lex_state = 52, .external_lex_state = 3},
  [599] = {.lex_state = 52, .external_lex_state = 2},
  [600] = {.lex_state = 52, .external_lex_state = 2},
  [601] = {.lex_state = 52, .external_lex_state = 2},
  [602] = {.lex_state = 52, .external_lex_state = 2},
  [603] = {.lex_state = 52, .external_lex_state = 2},
  [604] = {.lex_state = 52, .external_lex_state = 2},
  [605] = {.lex_state = 52, .external_lex_state = 2},
  [606] = {.lex_state = 52, .external_lex_state = 2},
  [607] = {.lex_state = 52, .external_lex_state = 7},
  [608] = {.lex_state = 52, .external_lex_state = 2},
  [609] = {.lex_state = 52, .external_lex_state = 2},
  [610] = {.lex_state = 52, .external_lex_state = 2},
  [611] = {.lex_state = 52, .external_lex_state = 2},
  [612] = {.lex_state = 52, .external_lex_state = 2},
  [613] = {.lex_state = 52, .external_lex_state = 2},
  [614] = {.lex_state = 52, .external_lex_state = 2},
  [615] = {.lex_state = 52, .external_lex_state = 2},
  [616] = {.lex_state = 52, .external_lex_state = 2},
  [617] = {.lex_state = 52, .external_lex_state = 2},
  [618] = {.lex_state = 52, .external_lex_state = 2},
  [619] = {.lex_state = 52, .external_lex_state = 2},
  [620] = {.lex_state = 52, .external_lex_state = 2},
  [621] = {.lex_state = 52, .external_lex_state = 2},
  [622] = {.lex_state = 52, .external_lex_state = 2},
  [623] = {.lex_state = 52, .external_lex_state = 2},
  [624] = {.lex_state = 52, .external_lex_state = 2},
  [625] = {.lex_state = 52, .external_lex_state = 2},
  [626] = {.lex_state = 52, .external_lex_state = 2},
  [627] = {.lex_state = 52, .external_lex_state = 2},
  [628] = {.lex_state = 52, .external_lex_state = 2},
  [629] = {.lex_state = 52, .external_lex_state = 2},
  [630] = {.lex_state = 52, .external_lex_state = 2},
  [631] = {.lex_state = 52, .external_lex_state = 2},
  [632] = {.lex_state = 52, .external_lex_state = 2},
  [633] = {.lex_state = 52, .external_lex_state = 2},
  [634] = {.lex_state = 52, .external_lex_state = 2},
  [635] = {.lex_state = 52, .external_lex_state = 2},
  [636] = {.lex_state = 52, .external_lex_state = 2},
  [637] = {.lex_state = 52, .external_lex_state = 2},
  [638] = {.lex_state = 52, .external_lex_state = 2},
  [639] = {.lex_state = 52, .external_lex_state = 2},
  [640] = {.lex_state = 52, .external_lex_state = 2},
  [641] = {.lex_state = 52, .external_lex_state = 2},
  [642] = {.lex_state = 52, .external_lex_state = 2},
  [643] = {.lex_state = 52, .external_lex_state = 2},
  [644] = {.lex_state = 52, .external_lex_state = 2},
  [645] = {.lex_state = 52, .external_lex_state = 2},
  [646] = {.lex_state = 52, .external_lex_state = 2},
  [647] = {.lex_state = 52, .external_lex_state = 2},
  [648] = {.lex_state = 52, .external_lex_state = 2},
  [649] = {.lex_state = 52, .external_lex_state = 2},
  [650] = {.lex_state = 52, .external_lex_state = 2},
  [651] = {.lex_state = 52, .external_lex_state = 2},
  [652] = {.lex_state = 52, .external_lex_state = 2},
  [653] = {.lex_state = 52, .external_lex_state = 2},
  [654] = {.lex_state = 52, .external_lex_state = 2},
  [655] = {.lex_state = 52, .external_lex_state = 2},
  [656] = {.lex_state = 52, .external_lex_state = 2},
  [657] = {.lex_state = 52, .external_lex_state = 2},
  [658] = {.lex_state = 52, .external_lex_state = 2},
  [659] = {.lex_state = 52, .external_lex_state = 2},
  [660] = {.lex_state = 52, .external_lex_state = 2},
  [661] = {.lex_state = 52, .external_lex_state = 2},
  [662] = {.lex_state = 52, .external_lex_state = 2},
  [663] = {.lex_state = 52, .external_lex_state = 2},
  [664] = {.lex_state = 52, .external_lex_state = 2},
  [665] = {.lex_state = 52, .external_lex_state = 2},
  [666] = {.lex_state = 52, .external_lex_state = 2},
  [667] = {.lex_state = 52, .external_lex_state = 2},
  [668] = {.lex_state = 52, .external_lex_state = 2},
  [669] = {.lex_state = 52, .external_lex_state = 2},
  [670] = {.lex_state = 52, .external_lex_state = 2},
  [671] = {.lex_state = 52, .external_lex_state = 2},
  [672] = {.lex_state = 52, .external_lex_state = 2},
  [673] = {.lex_state = 52, .external_lex_state = 2},
  [674] = {.lex_state = 52, .external_lex_state = 2},
  [675] = {.lex_state = 52, .external_lex_state = 2},
  [676] = {.lex_state = 52, .external_lex_state = 2},
  [677] = {.lex_state = 52, .external_lex_state = 2},
  [678] = {.lex_state = 52, .external_lex_state = 2},
  [679] = {.lex_state = 52, .external_lex_state = 2},
  [680] = {.lex_state = 52, .external_lex_state = 2},
  [681] = {.lex_state = 52, .external_lex_state = 2},
  [682] = {.lex_state = 52, .external_lex_state = 2},
  [683] = {.lex_state = 52, .external_lex_state = 2},
  [684] = {.lex_state = 52, .external_lex_state = 2},
  [685] = {.lex_state = 52, .external_lex_state = 2},
  [686] = {.lex_state = 52, .external_lex_state = 2},
  [687] = {.lex_state = 52, .external_lex_state = 2},
  [688] = {.lex_state = 52, .external_lex_state = 2},
  [689] = {.lex_state = 52, .external_lex_state = 2},
  [690] = {.lex_state = 52, .external_lex_state = 2},
  [691] = {.lex_state = 52, .external_lex_state = 2},
  [692] = {.lex_state = 52, .external_lex_state = 2},
  [693] = {.lex_state = 52, .external_lex_state = 2},
  [694] = {.lex_state = 52, .external_lex_state = 2},
  [695] = {.lex_state = 52, .external_lex_state = 2},
  [696] = {.lex_state = 11, .external_lex_state = 10},
  [697] = {.lex_state = 11, .external_lex_state = 10},
  [698] = {.lex_state = 11, .external_lex_state = 10},
  [699] = {.lex_state = 11, .external_lex_state = 10},
  [700] = {.lex_state = 11, .external_lex_state = 10},
  [701] = {.lex_state = 11, .external_lex_state = 10},
  [702] = {.lex_state = 11, .external_lex_state = 10},
  [703] = {.lex_state = 11, .external_lex_state = 9},
  [704] = {.lex_state = 11, .external_lex_state = 10},
  [705] = {.lex_state = 11, .external_lex_state = 10},
  [706] = {.lex_state = 11, .external_lex_state = 10},
  [707] = {.lex_state = 11, .external_lex_state = 11},
  [708] = {.lex_state = 12, .external_lex_state = 9},
  [709] = {.lex_state = 11, .external_lex_state = 9},
  [710] = {.lex_state = 11, .external_lex_state = 9},
  [711] = {.lex_state = 11, .external_lex_state = 9},
  [712] = {.lex_state = 12, .external_lex_state = 11},
  [713] = {.lex_state = 12, .external_lex_state = 9},
  [714] = {.lex_state = 11, .external_lex_state = 9},
  [715] = {.lex_state = 11, .external_lex_state = 9},
  [716] = {.lex_state = 11, .external_lex_state = 9},
  [717] = {.lex_state = 11, .external_lex_state = 9},
  [718] = {.lex_state = 12, .external_lex_state = 10},
  [719] = {.lex_state = 11, .external_lex_state = 10},
  [720] = {.lex_state = 12, .external_lex_state = 10},
  [721] = {.lex_state = 12, .external_lex_state = 10},
  [722] = {.lex_state = 11, .external_lex_state = 10},
  [723] = {.lex_state = 12, .external_lex_state = 9},
  [724] = {.lex_state = 12, .external_lex_state = 9},
  [725] = {.lex_state = 11, .external_lex_state = 9},
  [726] = {.lex_state = 11, .external_lex_state = 10},
  [727] = {.lex_state = 11, .external_lex_state = 10},
  [728] = {.lex_state = 11, .external_lex_state = 10},
  [729] = {.lex_state = 11, .external_lex_state = 10},
  [730] = {.lex_state = 11, .external_lex_state = 10},
  [731] = {.lex_state = 11, .external_lex_state = 10},
  [732] = {.lex_state = 11, .external_lex_state = 10},
  [733] = {.lex_state = 11, .external_lex_state = 10},
  [734] = {.lex_state = 12, .external_lex_state = 10},
  [735] = {.lex_state = 12, .external_lex_state = 10},
  [736] = {.lex_state = 12, .external_lex_state = 10},
  [737] = {.lex_state = 12, .external_lex_state = 10},
  [738] = {.lex_state = 12, .external_lex_state = 10},
  [739] = {.lex_state = 12, .external_lex_state = 10},
  [740] = {.lex_state = 11, .external_lex_state = 12},
  [741] = {.lex_state = 11, .external_lex_state = 10},
  [742] = {.lex_state = 11, .external_lex_state = 9},
  [743] = {.lex_state = 11, .external_lex_state = 9},
  [744] = {.lex_state = 11, .external_lex_state = 13},
  [745] = {.lex_state = 12, .external_lex_state = 10},
  [746] = {.lex_state = 12, .external_lex_state = 10},
  [747] = {.lex_state = 12, .external_lex_state = 10},
  [748] = {.lex_state = 11, .external_lex_state = 9},
  [749] = {.lex_state = 11, .external_lex_state = 10},
  [750] = {.lex_state = 11, .external_lex_state = 10},
  [751] = {.lex_state = 11, .external_lex_state = 10},
  [752] = {.lex_state = 11, .external_lex_state = 10},
  [753] = {.lex_state = 11, .external_lex_state = 10},
  [754] = {.lex_state = 11, .external_lex_state = 10},
  [755] = {.lex_state = 11, .external_lex_state = 10},
  [756] = {.lex_state = 11, .external_lex_state = 10},
  [757] = {.lex_state = 12, .external_lex_state = 13},
  [758] = {.lex_state = 11, .external_lex_state = 13},
  [759] = {.lex_state = 12, .external_lex_state = 11},
  [760] = {.lex_state = 12, .external_lex_state = 11},
  [761] = {.lex_state = 12, .external_lex_state = 11},
  [762] = {.lex_state = 11, .external_lex_state = 9},
  [763] = {.lex_state = 12, .external_lex_state = 13},
  [764] = {.lex_state = 12, .external_lex_state = 13},
  [765] = {.lex_state = 11, .external_lex_state = 9},
  [766] = {.lex_state = 11, .external_lex_state = 11},
  [767] = {.lex_state = 11, .external_lex_state = 9},
  [768] = {.lex_state = 11, .external_lex_state = 9},
  [769] = {.lex_state = 11, .external_lex_state = 9},
  [770] = {.lex_state = 11, .external_lex_state = 13},
  [771] = {.lex_state = 11, .external_lex_state = 9},
  [772] = {.lex_state = 11, .external_lex_state = 9},
  [773] = {.lex_state = 11, .external_lex_state = 13},
  [774] = {.lex_state = 11, .external_lex_state = 9},
  [775] = {.lex_state = 11, .external_lex_state = 12},
  [776] = {.lex_state = 11, .external_lex_state = 13},
  [777] = {.lex_state = 12, .external_lex_state = 13},
  [778] = {.lex_state = 11, .external_lex_state = 9},
  [779] = {.lex_state = 11, .external_lex_state = 9},
  [780] = {.lex_state = 11, .external_lex_state = 13},
  [781] = {.lex_state = 11, .external_lex_state = 9},
  [782] = {.lex_state = 11, .external_lex_state = 9},
  [783] = {.lex_state = 11, .external_lex_state = 9},
  [784] = {.lex_state = 12, .external_lex_state = 13},
  [785] = {.lex_state = 11, .external_lex_state = 12},
  [786] = {.lex_state = 11, .external_lex_state = 12},
  [787] = {.lex_state = 11, .external_lex_state = 13},
  [788] = {.lex_state = 11, .external_lex_state = 12},
  [789] = {.lex_state = 11, .external_lex_state = 11},
  [790] = {.lex_state = 11, .external_lex_state = 11},
  [791] = {.lex_state = 11, .external_lex_state = 11},
  [792] = {.lex_state = 11, .external_lex_state = 11},
  [793] = {.lex_state = 11, .external_lex_state = 11},
  [794] = {.lex_state = 11, .external_lex_state = 11},
  [795] = {.lex_state = 11, .external_lex_state = 9},
  [796] = {.lex_state = 11, .external_lex_state = 11},
  [797] = {.lex_state = 11, .external_lex_state = 11},
  [798] = {.lex_state = 11, .external_lex_state = 12},
  [799] = {.lex_state = 11, .external_lex_state = 12},
  [800] = {.lex_state = 11, .external_lex_state = 12},
  [801] = {.lex_state = 11, .external_lex_state = 12},
  [802] = {.lex_state = 11, .external_lex_state = 12},
  [803] = {.lex_state = 11, .external_lex_state = 9},
  [804] = {.lex_state = 11, .external_lex_state = 13},
  [805] = {.lex_state = 12, .external_lex_state = 12},
  [806] = {.lex_state = 12, .external_lex_state = 12},
  [807] = {.lex_state = 11, .external_lex_state = 9},
  [808] = {.lex_state = 12, .external_lex_state = 12},
  [809] = {.lex_state = 11, .external_lex_state = 9},
  [810] = {.lex_state = 11, .external_lex_state = 13},
  [811] = {.lex_state = 12, .external_lex_state = 12},
  [812] = {.lex_state = 11, .external_lex_state = 13},
  [813] = {.lex_state = 11, .external_lex_state = 9},
  [814] = {.lex_state = 11, .external_lex_state = 13},
  [815] = {.lex_state = 11, .external_lex_state = 9},
  [816] = {.lex_state = 11, .external_lex_state = 9},
  [817] = {.lex_state = 11, .external_lex_state = 10},
  [818] = {.lex_state = 11, .external_lex_state = 10},
  [819] = {.lex_state = 11, .external_lex_state = 9},
  [820] = {.lex_state = 11, .external_lex_state = 10},
  [821] = {.lex_state = 11, .external_lex_state = 9},
  [822] = {.lex_state = 11, .external_lex_state = 10},
  [823] = {.lex_state = 11, .external_lex_state = 10},
  [824] = {.lex_state = 11, .external_lex_state = 10},
  [825] = {.lex_state = 11, .external_lex_state = 10},
  [826] = {.lex_state = 11, .external_lex_state = 10},
  [827] = {.lex_state = 11, .external_lex_state = 10},
  [828] = {.lex_state = 12, .external_lex_state = 13},
  [829] = {.lex_state = 12, .external_lex_state = 13},
  [830] = {.lex_state = 11, .external_lex_state = 10},
  [831] = {.lex_state = 11, .external_lex_state = 10},
  [832] = {.lex_state = 11, .external_lex_state = 10},
  [833] = {.lex_state = 11, .external_lex_state = 10},
  [834] = {.lex_state = 11, .external_lex_state = 9},
  [835] = {.lex_state = 11, .external_lex_state = 10},
  [836] = {.lex_state = 11, .external_lex_state = 13},
  [837] = {.lex_state = 11, .external_lex_state = 10},
  [838] = {.lex_state = 11, .external_lex_state = 10},
  [839] = {.lex_state = 11, .external_lex_state = 10},
  [840] = {.lex_state = 11, .external_lex_state = 11},
  [841] = {.lex_state = 11, .external_lex_state = 10},
  [842] = {.lex_state = 11, .external_lex_state = 10},
  [843] = {.lex_state = 11, .external_lex_state = 12},
  [844] = {.lex_state = 11, .external_lex_state = 10},
  [845] = {.lex_state = 11, .external_lex_state = 10},
  [846] = {.lex_state = 11, .external_lex_state = 10},
  [847] = {.lex_state = 11, .external_lex_state = 10},
  [848] = {.lex_state = 11, .external_lex_state = 10},
  [849] = {.lex_state = 11, .external_lex_state = 10},
  [850] = {.lex_state = 11, .external_lex_state = 10},
  [851] = {.lex_state = 11, .external_lex_state = 10},
  [852] = {.lex_state = 11, .external_lex_state = 10},
  [853] = {.lex_state = 11, .external_lex_state = 10},
  [854] = {.lex_state = 11, .external_lex_state = 10},
  [855] = {.lex_state = 11, .external_lex_state = 10},
  [856] = {.lex_state = 11, .external_lex_state = 10},
  [857] = {.lex_state = 11, .external_lex_state = 10},
  [858] = {.lex_state = 11, .external_lex_state = 10},
  [859] = {.lex_state = 11, .external_lex_state = 10},
  [860] = {.lex_state = 8, .external_lex_state = 9},
  [861] = {.lex_state = 8, .external_lex_state = 9},
  [862] = {.lex_state = 11, .external_lex_state = 10},
  [863] = {.lex_state = 11, .external_lex_state = 9},
  [864] = {.lex_state = 11, .external_lex_state = 9},
  [865] = {.lex_state = 11, .external_lex_state = 10},
  [866] = {.lex_state = 12, .external_lex_state = 13},
  [867] = {.lex_state = 12, .external_lex_state = 13},
  [868] = {.lex_state = 12, .external_lex_state = 13},
  [869] = {.lex_state = 11, .external_lex_state = 10},
  [870] = {.lex_state = 11, .external_lex_state = 10},
  [871] = {.lex_state = 11, .external_lex_state = 9},
  [872] = {.lex_state = 11, .external_lex_state = 9},
  [873] = {.lex_state = 11, .external_lex_state = 9},
  [874] = {.lex_state = 11, .external_lex_state = 10},
  [875] = {.lex_state = 11, .external_lex_state = 9},
  [876] = {.lex_state = 11, .external_lex_state = 9},
  [877] = {.lex_state = 11, .external_lex_state = 9},
  [878] = {.lex_state = 11, .external_lex_state = 10},
  [879] = {.lex_state = 11, .external_lex_state = 10},
  [880] = {.lex_state = 11, .external_lex_state = 10},
  [881] = {.lex_state = 11, .external_lex_state = 10},
  [882] = {.lex_state = 11, .external_lex_state = 10},
  [883] = {.lex_state = 11, .external_lex_state = 10},
  [884] = {.lex_state = 11, .external_lex_state = 10},
  [885] = {.lex_state = 11, .external_lex_state = 10},
  [886] = {.lex_state = 11, .external_lex_state = 10},
  [887] = {.lex_state = 11, .external_lex_state = 10},
  [888] = {.lex_state = 11, .external_lex_state = 10},
  [889] = {.lex_state = 11, .external_lex_state = 10},
  [890] = {.lex_state = 11, .external_lex_state = 10},
  [891] = {.lex_state = 11, .external_lex_state = 10},
  [892] = {.lex_state = 11, .external_lex_state = 9},
  [893] = {.lex_state = 11, .external_lex_state = 9},
  [894] = {.lex_state = 11, .external_lex_state = 10},
  [895] = {.lex_state = 11, .external_lex_state = 10},
  [896] = {.lex_state = 11, .external_lex_state = 10},
  [897] = {.lex_state = 11, .external_lex_state = 10},
  [898] = {.lex_state = 11, .external_lex_state = 10},
  [899] = {.lex_state = 11, .external_lex_state = 9},
  [900] = {.lex_state = 11, .external_lex_state = 10},
  [901] = {.lex_state = 11, .external_lex_state = 10},
  [902] = {.lex_state = 11, .external_lex_state = 10},
  [903] = {.lex_state = 11, .external_lex_state = 10},
  [904] = {.lex_state = 11, .external_lex_state = 10},
  [905] = {.lex_state = 11, .external_lex_state = 10},
  [906] = {.lex_state = 11, .external_lex_state = 10},
  [907] = {.lex_state = 11, .external_lex_state = 9},
  [908] = {.lex_state = 11, .external_lex_state = 10},
  [909] = {.lex_state = 11, .external_lex_state = 10},
  [910] = {.lex_state = 11, .external_lex_state = 10},
  [911] = {.lex_state = 11, .external_lex_state = 10},
  [912] = {.lex_state = 11, .external_lex_state = 9},
  [913] = {.lex_state = 11, .external_lex_state = 10},
  [914] = {.lex_state = 11, .external_lex_state = 10},
  [915] = {.lex_state = 8, .external_lex_state = 9},
  [916] = {.lex_state = 8, .external_lex_state = 9},
  [917] = {.lex_state = 8, .external_lex_state = 9},
  [918] = {.lex_state = 8, .external_lex_state = 9},
  [919] = {.lex_state = 11, .external_lex_state = 9},
  [920] = {.lex_state = 11, .external_lex_state = 12},
  [921] = {.lex_state = 11, .external_lex_state = 12},
  [922] = {.lex_state = 11, .external_lex_state = 11},
  [923] = {.lex_state = 11, .external_lex_state = 11},
  [924] = {.lex_state = 11, .external_lex_state = 11},
  [925] = {.lex_state = 11, .external_lex_state = 11},
  [926] = {.lex_state = 11, .external_lex_state = 12},
  [927] = {.lex_state = 11, .external_lex_state = 10},
  [928] = {.lex_state = 11, .external_lex_state = 12},
  [929] = {.lex_state = 11, .external_lex_state = 12},
  [930] = {.lex_state = 12, .external_lex_state = 11},
  [931] = {.lex_state = 12, .external_lex_state = 11},
  [932] = {.lex_state = 12, .external_lex_state = 11},
  [933] = {.lex_state = 11, .external_lex_state = 9},
  [934] = {.lex_state = 11, .external_lex_state = 13},
  [935] = {.lex_state = 11, .external_lex_state = 11},
  [936] = {.lex_state = 11, .external_lex_state = 13},
  [937] = {.lex_state = 11, .external_lex_state = 13},
  [938] = {.lex_state = 11, .external_lex_state = 13},
  [939] = {.lex_state = 11, .external_lex_state = 13},
  [940] = {.lex_state = 11, .external_lex_state = 13},
  [941] = {.lex_state = 11, .external_lex_state = 13},
  [942] = {.lex_state = 11, .external_lex_state = 13},
  [943] = {.lex_state = 11, .external_lex_state = 13},
  [944] = {.lex_state = 11, .external_lex_state = 13},
  [945] = {.lex_state = 11, .external_lex_state = 13},
  [946] = {.lex_state = 11, .external_lex_state = 13},
  [947] = {.lex_state = 11, .external_lex_state = 13},
  [948] = {.lex_state = 12, .external_lex_state = 13},
  [949] = {.lex_state = 12, .external_lex_state = 13},
  [950] = {.lex_state = 12, .external_lex_state = 13},
  [951] = {.lex_state = 11, .external_lex_state = 13},
  [952] = {.lex_state = 11, .external_lex_state = 11},
  [953] = {.lex_state = 11, .external_lex_state = 11},
  [954] = {.lex_state = 11, .external_lex_state = 13},
  [955] = {.lex_state = 11, .external_lex_state = 13},
  [956] = {.lex_state = 11, .external_lex_state = 13},
  [957] = {.lex_state = 11, .external_lex_state = 13},
  [958] = {.lex_state = 11, .external_lex_state = 13},
  [959] = {.lex_state = 11, .external_lex_state = 13},
  [960] = {.lex_state = 11, .external_lex_state = 13},
  [961] = {.lex_state = 11, .external_lex_state = 13},
  [962] = {.lex_state = 11, .external_lex_state = 13},
  [963] = {.lex_state = 11, .external_lex_state = 13},
  [964] = {.lex_state = 11, .external_lex_state = 13},
  [965] = {.lex_state = 11, .external_lex_state = 11},
  [966] = {.lex_state = 11, .external_lex_state = 11},
  [967] = {.lex_state = 11, .external_lex_state = 12},
  [968] = {.lex_state = 11, .external_lex_state = 12},
  [969] = {.lex_state = 11, .external_lex_state = 13},
  [970] = {.lex_state = 11, .external_lex_state = 13},
  [971] = {.lex_state = 11, .external_lex_state = 12},
  [972] = {.lex_state = 11, .external_lex_state = 12},
  [973] = {.lex_state = 11, .external_lex_state = 12},
  [974] = {.lex_state = 11, .external_lex_state = 13},
  [975] = {.lex_state = 11, .external_lex_state = 13},
  [976] = {.lex_state = 11, .external_lex_state = 13},
  [977] = {.lex_state = 11, .external_lex_state = 12},
  [978] = {.lex_state = 11, .external_lex_state = 13},
  [979] = {.lex_state = 11, .external_lex_state = 13},
  [980] = {.lex_state = 11, .external_lex_state = 12},
  [981] = {.lex_state = 11, .external_lex_state = 12},
  [982] = {.lex_state = 11, .external_lex_state = 11},
  [983] = {.lex_state = 11, .external_lex_state = 11},
  [984] = {.lex_state = 11, .external_lex_state = 11},
  [985] = {.lex_state = 11, .external_lex_state = 11},
  [986] = {.lex_state = 11, .external_lex_state = 13},
  [987] = {.lex_state = 11, .external_lex_state = 13},
  [988] = {.lex_state = 11, .external_lex_state = 13},
  [989] = {.lex_state = 11, .external_lex_state = 13},
  [990] = {.lex_state = 11, .external_lex_state = 11},
  [991] = {.lex_state = 11, .external_lex_state = 11},
  [992] = {.lex_state = 11, .external_lex_state = 11},
  [993] = {.lex_state = 11, .external_lex_state = 11},
  [994] = {.lex_state = 11, .external_lex_state = 13},
  [995] = {.lex_state = 11, .external_lex_state = 11},
  [996] = {.lex_state = 11, .external_lex_state = 12},
  [997] = {.lex_state = 11, .external_lex_state = 12},
  [998] = {.lex_state = 11, .external_lex_state = 13},
  [999] = {.lex_state = 11, .external_lex_state = 13},
  [1000] = {.lex_state = 11, .external_lex_state = 13},
  [1001] = {.lex_state = 11, .external_lex_state = 11},
  [1002] = {.lex_state = 11, .external_lex_state = 11},
  [1003] = {.lex_state = 11, .external_lex_state = 13},
  [1004] = {.lex_state = 11, .external_lex_state = 12},
  [1005] = {.lex_state = 11, .external_lex_state = 13},
  [1006] = {.lex_state = 11, .external_lex_state = 13},
  [1007] = {.lex_state = 11, .external_lex_state = 13},
  [1008] = {.lex_state = 11, .external_lex_state = 11},
  [1009] = {.lex_state = 11, .external_lex_state = 12},
  [1010] = {.lex_state = 11, .external_lex_state = 11},
  [1011] = {.lex_state = 11, .external_lex_state = 11},
  [1012] = {.lex_state = 11, .external_lex_state = 11},
  [1013] = {.lex_state = 11, .external_lex_state = 11},
  [1014] = {.lex_state = 11, .external_lex_state = 13},
  [1015] = {.lex_state = 11, .external_lex_state = 13},
  [1016] = {.lex_state = 11, .external_lex_state = 13},
  [1017] = {.lex_state = 11, .external_lex_state = 12},
  [1018] = {.lex_state = 11, .external_lex_state = 12},
  [1019] = {.lex_state = 11, .external_lex_state = 13},
  [1020] = {.lex_state = 11, .external_lex_state = 12},
  [1021] = {.lex_state = 11, .external_lex_state = 11},
  [1022] = {.lex_state = 11, .external_lex_state = 11},
  [1023] = {.lex_state = 11, .external_lex_state = 11},
  [1024] = {.lex_state = 11, .external_lex_state = 13},
  [1025] = {.lex_state = 11, .external_lex_state = 13},
  [1026] = {.lex_state = 11, .external_lex_state = 13},
  [1027] = {.lex_state = 11, .external_lex_state = 11},
  [1028] = {.lex_state = 11, .external_lex_state = 11},
  [1029] = {.lex_state = 11, .external_lex_state = 11},
  [1030] = {.lex_state = 11, .external_lex_state = 11},
  [1031] = {.lex_state = 11, .external_lex_state = 13},
  [1032] = {.lex_state = 11, .external_lex_state = 13},
  [1033] = {.lex_state = 11, .external_lex_state = 12},
  [1034] = {.lex_state = 11, .external_lex_state = 12},
  [1035] = {.lex_state = 11, .external_lex_state = 12},
  [1036] = {.lex_state = 11, .external_lex_state = 12},
  [1037] = {.lex_state = 11, .external_lex_state = 12},
  [1038] = {.lex_state = 11, .external_lex_state = 12},
  [1039] = {.lex_state = 11, .external_lex_state = 12},
  [1040] = {.lex_state = 11, .external_lex_state = 12},
  [1041] = {.lex_state = 11, .external_lex_state = 12},
  [1042] = {.lex_state = 11, .external_lex_state = 12},
  [1043] = {.lex_state = 11, .external_lex_state = 11},
  [1044] = {.lex_state = 11, .external_lex_state = 12},
  [1045] = {.lex_state = 11, .external_lex_state = 11},
  [1046] = {.lex_state = 11, .external_lex_state = 12},
  [1047] = {.lex_state = 11, .external_lex_state = 11},
  [1048] = {.lex_state = 11, .external_lex_state = 12},
  [1049] = {.lex_state = 11, .external_lex_state = 12},
  [1050] = {.lex_state = 11, .external_lex_state = 11},
  [1051] = {.lex_state = 11, .external_lex_state = 11},
  [1052] = {.lex_state = 11, .external_lex_state = 12},
  [1053] = {.lex_state = 11, .external_lex_state = 11},
  [1054] = {.lex_state = 11, .external_lex_state = 12},
  [1055] = {.lex_state = 11, .external_lex_state = 12},
  [1056] = {.lex_state = 11, .external_lex_state = 13},
  [1057] = {.lex_state = 11, .external_lex_state = 13},
  [1058] = {.lex_state = 12, .external_lex_state = 13},
  [1059] = {.lex_state = 12, .external_lex_state = 13},
  [1060] = {.lex_state = 12, .external_lex_state = 13},
  [1061] = {.lex_state = 12, .external_lex_state = 11},
  [1062] = {.lex_state = 12, .external_lex_state = 11},
  [1063] = {.lex_state = 8, .external_lex_state = 12},
  [1064] = {.lex_state = 8, .external_lex_state = 12},
  [1065] = {.lex_state = 8, .external_lex_state = 12},
  [1066] = {.lex_state = 8, .external_lex_state = 12},
  [1067] = {.lex_state = 12, .external_lex_state = 11},
  [1068] = {.lex_state = 12, .external_lex_state = 10},
  [1069] = {.lex_state = 12, .external_lex_state = 10},
  [1070] = {.lex_state = 12, .external_lex_state = 10},
  [1071] = {.lex_state = 8, .external_lex_state = 12},
  [1072] = {.lex_state = 8, .external_lex_state = 12},
  [1073] = {.lex_state = 11, .external_lex_state = 13},
  [1074] = {.lex_state = 11, .external_lex_state = 13},
  [1075] = {.lex_state = 8, .external_lex_state = 12},
  [1076] = {.lex_state = 11, .external_lex_state = 13},
  [1077] = {.lex_state = 11, .external_lex_state = 13},
  [1078] = {.lex_state = 11, .external_lex_state = 13},
  [1079] = {.lex_state = 12, .external_lex_state = 11},
  [1080] = {.lex_state = 12, .external_lex_state = 11},
  [1081] = {.lex_state = 12, .external_lex_state = 11},
  [1082] = {.lex_state = 11, .external_lex_state = 13},
  [1083] = {.lex_state = 8, .external_lex_state = 12},
  [1084] = {.lex_state = 8, .external_lex_state = 12},
  [1085] = {.lex_state = 11, .external_lex_state = 13},
  [1086] = {.lex_state = 8, .external_lex_state = 12},
  [1087] = {.lex_state = 11, .external_lex_state = 13},
  [1088] = {.lex_state = 11, .external_lex_state = 13},
  [1089] = {.lex_state = 8, .external_lex_state = 12},
  [1090] = {.lex_state = 11, .external_lex_state = 13},
  [1091] = {.lex_state = 11, .external_lex_state = 13},
  [1092] = {.lex_state = 11, .external_lex_state = 13},
  [1093] = {.lex_state = 11, .external_lex_state = 13},
  [1094] = {.lex_state = 11, .external_lex_state = 13},
  [1095] = {.lex_state = 11, .external_lex_state = 13},
  [1096] = {.lex_state = 11, .external_lex_state = 13},
  [1097] = {.lex_state = 11, .external_lex_state = 13},
  [1098] = {.lex_state = 11, .external_lex_state = 13},
  [1099] = {.lex_state = 11, .external_lex_state = 12},
  [1100] = {.lex_state = 11, .external_lex_state = 13},
  [1101] = {.lex_state = 11, .external_lex_state = 13},
  [1102] = {.lex_state = 11, .external_lex_state = 13},
  [1103] = {.lex_state = 11, .external_lex_state = 13},
  [1104] = {.lex_state = 11, .external_lex_state = 13},
  [1105] = {.lex_state = 11, .external_lex_state = 13},
  [1106] = {.lex_state = 11, .external_lex_state = 13},
  [1107] = {.lex_state = 8, .external_lex_state = 12},
  [1108] = {.lex_state = 8, .external_lex_state = 12},
  [1109] = {.lex_state = 11, .external_lex_state = 13},
  [1110] = {.lex_state = 8, .external_lex_state = 12},
  [1111] = {.lex_state = 11, .external_lex_state = 13},
  [1112] = {.lex_state = 11, .external_lex_state = 13},
  [1113] = {.lex_state = 11, .external_lex_state = 13},
  [1114] = {.lex_state = 8, .external_lex_state = 12},
  [1115] = {.lex_state = 8, .external_lex_state = 12},
  [1116] = {.lex_state = 11, .external_lex_state = 13},
  [1117] = {.lex_state = 11, .external_lex_state = 13},
  [1118] = {.lex_state = 11, .external_lex_state = 13},
  [1119] = {.lex_state = 11, .external_lex_state = 13},
  [1120] = {.lex_state = 11, .external_lex_state = 13},
  [1121] = {.lex_state = 11, .external_lex_state = 13},
  [1122] = {.lex_state = 11, .external_lex_state = 13},
  [1123] = {.lex_state = 11, .external_lex_state = 13},
  [1124] = {.lex_state = 11, .external_lex_state = 10},
  [1125] = {.lex_state = 11, .external_lex_state = 11},
  [1126] = {.lex_state = 5, .external_lex_state = 2},
  [1127] = {.lex_state = 5, .external_lex_state = 2},
  [1128] = {.lex_state = 11, .external_lex_state = 11},
  [1129] = {.lex_state = 11, .external_lex_state = 11},
  [1130] = {.lex_state = 11, .external_lex_state = 11},
  [1131] = {.lex_state = 11, .external_lex_state = 11},
  [1132] = {.lex_state = 5, .external_lex_state = 7},
  [1133] = {.lex_state = 5, .external_lex_state = 6},
  [1134] = {.lex_state = 5, .external_lex_state = 7},
  [1135] = {.lex_state = 5, .external_lex_state = 6},
  [1136] = {.lex_state = 5, .external_lex_state = 7},
  [1137] = {.lex_state = 5, .external_lex_state = 6},
  [1138] = {.lex_state = 5, .external_lex_state = 7},
  [1139] = {.lex_state = 5, .external_lex_state = 7},
  [1140] = {.lex_state = 5, .external_lex_state = 7},
  [1141] = {.lex_state = 5, .external_lex_state = 7},
  [1142] = {.lex_state = 5, .external_lex_state = 7},
  [1143] = {.lex_state = 5, .external_lex_state = 6},
  [1144] = {.lex_state = 5, .external_lex_state = 7},
  [1145] = {.lex_state = 5, .external_lex_state = 6},
  [1146] = {.lex_state = 5, .external_lex_state = 7},
  [1147] = {.lex_state = 5, .external_lex_state = 7},
  [1148] = {.lex_state = 5, .external_lex_state = 7},
  [1149] = {.lex_state = 5, .external_lex_state = 6},
  [1150] = {.lex_state = 5, .external_lex_state = 6},
  [1151] = {.lex_state = 5, .external_lex_state = 6},
  [1152] = {.lex_state = 5, .external_lex_state = 7},
  [1153] = {.lex_state = 5, .external_lex_state = 7},
  [1154] = {.lex_state = 5, .external_lex_state = 7},
  [1155] = {.lex_state = 5, .external_lex_state = 6},
  [1156] = {.lex_state = 5, .external_lex_state = 7},
  [1157] = {.lex_state = 5, .external_lex_state = 7},
  [1158] = {.lex_state = 5, .external_lex_state = 7},
  [1159] = {.lex_state = 5, .external_lex_state = 6},
  [1160] = {.lex_state = 5, .external_lex_state = 7},
  [1161] = {.lex_state = 5, .external_lex_state = 7},
  [1162] = {.lex_state = 5, .external_lex_state = 7},
  [1163] = {.lex_state = 5, .external_lex_state = 6},
  [1164] = {.lex_state = 5, .external_lex_state = 7},
  [1165] = {.lex_state = 5, .external_lex_state = 7},
  [1166] = {.lex_state = 5, .external_lex_state = 7},
  [1167] = {.lex_state = 5, .external_lex_state = 6},
  [1168] = {.lex_state = 5, .external_lex_state = 2},
  [1169] = {.lex_state = 5, .external_lex_state = 2},
  [1170] = {.lex_state = 5, .external_lex_state = 2},
  [1171] = {.lex_state = 5, .external_lex_state = 2},
  [1172] = {.lex_state = 5, .external_lex_state = 2},
  [1173] = {.lex_state = 5, .external_lex_state = 8},
  [1174] = {.lex_state = 5, .external_lex_state = 8},
  [1175] = {.lex_state = 5, .external_lex_state = 8},
  [1176] = {.lex_state = 5, .external_lex_state = 8},
  [1177] = {.lex_state = 5, .external_lex_state = 8},
  [1178] = {.lex_state = 5, .external_lex_state = 8},
  [1179] = {.lex_state = 5, .external_lex_state = 8},
  [1180] = {.lex_state = 5, .external_lex_state = 8},
  [1181] = {.lex_state = 5, .external_lex_state = 8},
  [1182] = {.lex_state = 5, .external_lex_state = 8},
  [1183] = {.lex_state = 5, .external_lex_state = 8},
  [1184] = {.lex_state = 5, .external_lex_state = 8},
  [1185] = {.lex_state = 5, .external_lex_state = 8},
  [1186] = {.lex_state = 5, .external_lex_state = 8},
  [1187] = {.lex_state = 5, .external_lex_state = 8},
  [1188] = {.lex_state = 5, .external_lex_state = 8},
  [1189] = {.lex_state = 5, .external_lex_state = 8},
  [1190] = {.lex_state = 5, .external_lex_state = 8},
  [1191] = {.lex_state = 5, .external_lex_state = 8},
  [1192] = {.lex_state = 5, .external_lex_state = 8},
  [1193] = {.lex_state = 5, .external_lex_state = 2},
  [1194] = {.lex_state = 5, .external_lex_state = 2},
  [1195] = {.lex_state = 5, .external_lex_state = 2},
  [1196] = {.lex_state = 5, .external_lex_state = 2},
  [1197] = {.lex_state = 5, .external_lex_state = 2},
  [1198] = {.lex_state = 5, .external_lex_state = 2},
  [1199] = {.lex_state = 5, .external_lex_state = 2},
  [1200] = {.lex_state = 5, .external_lex_state = 2},
  [1201] = {.lex_state = 5, .external_lex_state = 2},
  [1202] = {.lex_state = 11, .external_lex_state = 10},
  [1203] = {.lex_state = 8, .external_lex_state = 9},
  [1204] = {.lex_state = 11, .external_lex_state = 10},
  [1205] = {.lex_state = 11, .external_lex_state = 10},
  [1206] = {.lex_state = 11, .external_lex_state = 10},
  [1207] = {.lex_state = 8, .external_lex_state = 9},
  [1208] = {.lex_state = 11, .external_lex_state = 10},
  [1209] = {.lex_state = 11, .external_lex_state = 10},
  [1210] = {.lex_state = 8, .external_lex_state = 11},
  [1211] = {.lex_state = 8, .external_lex_state = 12},
  [1212] = {.lex_state = 8, .external_lex_state = 12},
  [1213] = {.lex_state = 8, .external_lex_state = 11},
  [1214] = {.lex_state = 52, .external_lex_state = 10},
  [1215] = {.lex_state = 11, .external_lex_state = 11},
  [1216] = {.lex_state = 11, .external_lex_state = 11},
  [1217] = {.lex_state = 11, .external_lex_state = 11},
  [1218] = {.lex_state = 52, .external_lex_state = 10},
  [1219] = {.lex_state = 6, .external_lex_state = 9},
  [1220] = {.lex_state = 8, .external_lex_state = 13},
  [1221] = {.lex_state = 6, .external_lex_state = 9},
  [1222] = {.lex_state = 8, .external_lex_state = 13},
  [1223] = {.lex_state = 11, .external_lex_state = 11},
  [1224] = {.lex_state = 52, .external_lex_state = 10},
  [1225] = {.lex_state = 11, .external_lex_state = 11},
  [1226] = {.lex_state = 11, .external_lex_state = 11},
  [1227] = {.lex_state = 52, .external_lex_state = 10},
  [1228] = {.lex_state = 11, .external_lex_state = 11},
  [1229] = {.lex_state = 11, .external_lex_state = 12},
  [1230] = {.lex_state = 11, .external_lex_state = 12},
  [1231] = {.lex_state = 11, .external_lex_state = 12},
  [1232] = {.lex_state = 11, .external_lex_state = 12},
  [1233] = {.lex_state = 11, .external_lex_state = 12},
  [1234] = {.lex_state = 11, .external_lex_state = 12},
  [1235] = {.lex_state = 11, .external_lex_state = 12},
  [1236] = {.lex_state = 6, .external_lex_state = 9},
  [1237] = {.lex_state = 52, .external_lex_state = 13},
  [1238] = {.lex_state = 6, .external_lex_state = 9},
  [1239] = {.lex_state = 6, .external_lex_state = 9},
  [1240] = {.lex_state = 11, .external_lex_state = 12},
  [1241] = {.lex_state = 11, .external_lex_state = 12},
  [1242] = {.lex_state = 11, .external_lex_state = 12},
  [1243] = {.lex_state = 6, .external_lex_state = 9},
  [1244] = {.lex_state = 11, .external_lex_state = 12},
  [1245] = {.lex_state = 11, .external_lex_state = 13},
  [1246] = {.lex_state = 11, .external_lex_state = 13},
  [1247] = {.lex_state = 11, .external_lex_state = 13},
  [1248] = {.lex_state = 11, .external_lex_state = 13},
  [1249] = {.lex_state = 11, .external_lex_state = 12},
  [1250] = {.lex_state = 11, .external_lex_state = 11},
  [1251] = {.lex_state = 11, .external_lex_state = 11},
  [1252] = {.lex_state = 11, .external_lex_state = 13},
  [1253] = {.lex_state = 11, .external_lex_state = 11},
  [1254] = {.lex_state = 11, .external_lex_state = 13},
  [1255] = {.lex_state = 11, .external_lex_state = 11},
  [1256] = {.lex_state = 11, .external_lex_state = 11},
  [1257] = {.lex_state = 52, .external_lex_state = 13},
  [1258] = {.lex_state = 6, .external_lex_state = 12},
  [1259] = {.lex_state = 6, .external_lex_state = 12},
  [1260] = {.lex_state = 5, .external_lex_state = 12},
  [1261] = {.lex_state = 6, .external_lex_state = 12},
  [1262] = {.lex_state = 5, .external_lex_state = 12},
  [1263] = {.lex_state = 6, .external_lex_state = 12},
  [1264] = {.lex_state = 5, .external_lex_state = 12},
  [1265] = {.lex_state = 6, .external_lex_state = 12},
  [1266] = {.lex_state = 5, .external_lex_state = 12},
  [1267] = {.lex_state = 5, .external_lex_state = 12},
  [1268] = {.lex_state = 11, .external_lex_state = 12},
  [1269] = {.lex_state = 5, .external_lex_state = 12},
  [1270] = {.lex_state = 5, .external_lex_state = 12},
  [1271] = {.lex_state = 11, .external_lex_state = 12},
  [1272] = {.lex_state = 11, .external_lex_state = 12},
  [1273] = {.lex_state = 11, .external_lex_state = 12},
  [1274] = {.lex_state = 11, .external_lex_state = 12},
  [1275] = {.lex_state = 11, .external_lex_state = 12},
  [1276] = {.lex_state = 5, .external_lex_state = 12},
  [1277] = {.lex_state = 11, .external_lex_state = 12},
  [1278] = {.lex_state = 5, .external_lex_state = 12},
  [1279] = {.lex_state = 6, .external_lex_state = 9},
  [1280] = {.lex_state = 6, .external_lex_state = 12},
  [1281] = {.lex_state = 11, .external_lex_state = 12},
  [1282] = {.lex_state = 6, .external_lex_state = 12},
  [1283] = {.lex_state = 11, .external_lex_state = 12},
  [1284] = {.lex_state = 6, .external_lex_state = 12},
  [1285] = {.lex_state = 5, .external_lex_state = 11},
  [1286] = {.lex_state = 5, .external_lex_state = 12},
  [1287] = {.lex_state = 5, .external_lex_state = 11},
  [1288] = {.lex_state = 5, .external_lex_state = 11},
  [1289] = {.lex_state = 6, .external_lex_state = 12},
  [1290] = {.lex_state = 5, .external_lex_state = 12},
  [1291] = {.lex_state = 5, .external_lex_state = 12},
  [1292] = {.lex_state = 5, .external_lex_state = 12},
  [1293] = {.lex_state = 52, .external_lex_state = 10},
  [1294] = {.lex_state = 52, .external_lex_state = 10},
  [1295] = {.lex_state = 52, .external_lex_state = 10},
  [1296] = {.lex_state = 52, .external_lex_state = 10},
  [1297] = {.lex_state = 52, .external_lex_state = 10},
  [1298] = {.lex_state = 52, .external_lex_state = 10},
  [1299] = {.lex_state = 52, .external_lex_state = 10},
  [1300] = {.lex_state = 8, .external_lex_state = 9},
  [1301] = {.lex_state = 8, .external_lex_state = 9},
  [1302] = {.lex_state = 52, .external_lex_state = 13},
  [1303] = {.lex_state = 52, .external_lex_state = 13},
  [1304] = {.lex_state = 8, .external_lex_state = 9},
  [1305] = {.lex_state = 8, .external_lex_state = 9},
  [1306] = {.lex_state = 52, .external_lex_state = 13},
  [1307] = {.lex_state = 52, .external_lex_state = 13},
  [1308] = {.lex_state = 8, .external_lex_state = 9},
  [1309] = {.lex_state = 8, .external_lex_state = 9},
  [1310] = {.lex_state = 52, .external_lex_state = 13},
  [1311] = {.lex_state = 8, .external_lex_state = 9},
  [1312] = {.lex_state = 8, .external_lex_state = 9},
  [1313] = {.lex_state = 52, .external_lex_state = 13},
  [1314] = {.lex_state = 52, .external_lex_state = 13},
  [1315] = {.lex_state = 8, .external_lex_state = 9},
  [1316] = {.lex_state = 8, .external_lex_state = 9},
  [1317] = {.lex_state = 0, .external_lex_state = 14},
  [1318] = {.lex_state = 8, .external_lex_state = 11},
  [1319] = {.lex_state = 8, .external_lex_state = 12},
  [1320] = {.lex_state = 0, .external_lex_state = 14},
  [1321] = {.lex_state = 0, .external_lex_state = 14},
  [1322] = {.lex_state = 8, .external_lex_state = 11},
  [1323] = {.lex_state = 8, .external_lex_state = 11},
  [1324] = {.lex_state = 0, .external_lex_state = 14},
  [1325] = {.lex_state = 0, .external_lex_state = 14},
  [1326] = {.lex_state = 8, .external_lex_state = 12},
  [1327] = {.lex_state = 8, .external_lex_state = 11},
  [1328] = {.lex_state = 8, .external_lex_state = 11},
  [1329] = {.lex_state = 0, .external_lex_state = 14},
  [1330] = {.lex_state = 0, .external_lex_state = 14},
  [1331] = {.lex_state = 52, .external_lex_state = 10},
  [1332] = {.lex_state = 8, .external_lex_state = 9},
  [1333] = {.lex_state = 8, .external_lex_state = 11},
  [1334] = {.lex_state = 8, .external_lex_state = 12},
  [1335] = {.lex_state = 0, .external_lex_state = 14},
  [1336] = {.lex_state = 0, .external_lex_state = 14},
  [1337] = {.lex_state = 0, .external_lex_state = 14},
  [1338] = {.lex_state = 8, .external_lex_state = 12},
  [1339] = {.lex_state = 8, .external_lex_state = 12},
  [1340] = {.lex_state = 8, .external_lex_state = 11},
  [1341] = {.lex_state = 0, .external_lex_state = 14},
  [1342] = {.lex_state = 0, .external_lex_state = 14},
  [1343] = {.lex_state = 8, .external_lex_state = 12},
  [1344] = {.lex_state = 8, .external_lex_state = 12},
  [1345] = {.lex_state = 0, .external_lex_state = 14},
  [1346] = {.lex_state = 0, .external_lex_state = 14},
  [1347] = {.lex_state = 0, .external_lex_state = 14},
  [1348] = {.lex_state = 8, .external_lex_state = 11},
  [1349] = {.lex_state = 8, .external_lex_state = 12},
  [1350] = {.lex_state = 8, .external_lex_state = 12},
  [1351] = {.lex_state = 8, .external_lex_state = 11},
  [1352] = {.lex_state = 0, .external_lex_state = 14},
  [1353] = {.lex_state = 0, .external_lex_state = 14},
  [1354] = {.lex_state = 0, .external_lex_state = 14},
  [1355] = {.lex_state = 0, .external_lex_state = 14},
  [1356] = {.lex_state = 8, .external_lex_state = 11},
  [1357] = {.lex_state = 0, .external_lex_state = 14},
  [1358] = {.lex_state = 0, .external_lex_state = 14},
  [1359] = {.lex_state = 0, .external_lex_state = 14},
  [1360] = {.lex_state = 0, .external_lex_state = 14},
  [1361] = {.lex_state = 8, .external_lex_state = 13},
  [1362] = {.lex_state = 52, .external_lex_state = 10},
  [1363] = {.lex_state = 8, .external_lex_state = 13},
  [1364] = {.lex_state = 52, .external_lex_state = 10},
  [1365] = {.lex_state = 52, .external_lex_state = 10},
  [1366] = {.lex_state = 8, .external_lex_state = 13},
  [1367] = {.lex_state = 52, .external_lex_state = 10},
  [1368] = {.lex_state = 52, .external_lex_state = 10},
  [1369] = {.lex_state = 52, .external_lex_state = 10},
  [1370] = {.lex_state = 52, .external_lex_state = 10},
  [1371] = {.lex_state = 8, .external_lex_state = 12},
  [1372] = {.lex_state = 52, .external_lex_state = 10},
  [1373] = {.lex_state = 52, .external_lex_state = 10},
  [1374] = {.lex_state = 8, .external_lex_state = 12},
  [1375] = {.lex_state = 8, .external_lex_state = 13},
  [1376] = {.lex_state = 8, .external_lex_state = 13},
  [1377] = {.lex_state = 8, .external_lex_state = 13},
  [1378] = {.lex_state = 8, .external_lex_state = 13},
  [1379] = {.lex_state = 8, .external_lex_state = 13},
  [1380] = {.lex_state = 52, .external_lex_state = 10},
  [1381] = {.lex_state = 52, .external_lex_state = 10},
  [1382] = {.lex_state = 8, .external_lex_state = 13},
  [1383] = {.lex_state = 52, .external_lex_state = 10},
  [1384] = {.lex_state = 52, .external_lex_state = 10},
  [1385] = {.lex_state = 8, .external_lex_state = 13},
  [1386] = {.lex_state = 52, .external_lex_state = 10},
  [1387] = {.lex_state = 52, .external_lex_state = 10},
  [1388] = {.lex_state = 52, .external_lex_state = 10},
  [1389] = {.lex_state = 52, .external_lex_state = 10},
  [1390] = {.lex_state = 52, .external_lex_state = 10},
  [1391] = {.lex_state = 52, .external_lex_state = 10},
  [1392] = {.lex_state = 52, .external_lex_state = 2},
  [1393] = {.lex_state = 8, .external_lex_state = 12},
  [1394] = {.lex_state = 52, .external_lex_state = 13},
  [1395] = {.lex_state = 52, .external_lex_state = 13},
  [1396] = {.lex_state = 52, .external_lex_state = 13},
  [1397] = {.lex_state = 52, .external_lex_state = 13},
  [1398] = {.lex_state = 52, .external_lex_state = 13},
  [1399] = {.lex_state = 52, .external_lex_state = 13},
  [1400] = {.lex_state = 52, .external_lex_state = 13},
  [1401] = {.lex_state = 52, .external_lex_state = 9},
  [1402] = {.lex_state = 8, .external_lex_state = 12},
  [1403] = {.lex_state = 52, .external_lex_state = 13},
  [1404] = {.lex_state = 7, .external_lex_state = 13},
  [1405] = {.lex_state = 52, .external_lex_state = 13},
  [1406] = {.lex_state = 52, .external_lex_state = 9},
  [1407] = {.lex_state = 52, .external_lex_state = 9},
  [1408] = {.lex_state = 8, .external_lex_state = 12},
  [1409] = {.lex_state = 52, .external_lex_state = 13},
  [1410] = {.lex_state = 52, .external_lex_state = 2},
  [1411] = {.lex_state = 52, .external_lex_state = 13},
  [1412] = {.lex_state = 52, .external_lex_state = 9},
  [1413] = {.lex_state = 52, .external_lex_state = 13},
  [1414] = {.lex_state = 52, .external_lex_state = 2},
  [1415] = {.lex_state = 52, .external_lex_state = 13},
  [1416] = {.lex_state = 52, .external_lex_state = 13},
  [1417] = {.lex_state = 7, .external_lex_state = 11},
  [1418] = {.lex_state = 52, .external_lex_state = 13},
  [1419] = {.lex_state = 52, .external_lex_state = 9},
  [1420] = {.lex_state = 52, .external_lex_state = 13},
  [1421] = {.lex_state = 52, .external_lex_state = 9},
  [1422] = {.lex_state = 52, .external_lex_state = 13},
  [1423] = {.lex_state = 52, .external_lex_state = 10},
  [1424] = {.lex_state = 52, .external_lex_state = 9},
  [1425] = {.lex_state = 7, .external_lex_state = 10},
  [1426] = {.lex_state = 52, .external_lex_state = 10},
  [1427] = {.lex_state = 52, .external_lex_state = 10},
  [1428] = {.lex_state = 52, .external_lex_state = 13},
  [1429] = {.lex_state = 52, .external_lex_state = 13},
  [1430] = {.lex_state = 52, .external_lex_state = 13},
  [1431] = {.lex_state = 52, .external_lex_state = 9},
  [1432] = {.lex_state = 52, .external_lex_state = 10},
  [1433] = {.lex_state = 52, .external_lex_state = 13},
  [1434] = {.lex_state = 52, .external_lex_state = 11},
  [1435] = {.lex_state = 52, .external_lex_state = 7},
  [1436] = {.lex_state = 0, .external_lex_state = 14},
  [1437] = {.lex_state = 52, .external_lex_state = 7},
  [1438] = {.lex_state = 7, .external_lex_state = 13},
  [1439] = {.lex_state = 52, .external_lex_state = 13},
  [1440] = {.lex_state = 8, .external_lex_state = 12},
  [1441] = {.lex_state = 52, .external_lex_state = 6},
  [1442] = {.lex_state = 52, .external_lex_state = 11},
  [1443] = {.lex_state = 52, .external_lex_state = 12},
  [1444] = {.lex_state = 52, .external_lex_state = 10},
  [1445] = {.lex_state = 52, .external_lex_state = 11},
  [1446] = {.lex_state = 52, .external_lex_state = 8},
  [1447] = {.lex_state = 52, .external_lex_state = 10},
  [1448] = {.lex_state = 52, .external_lex_state = 12},
  [1449] = {.lex_state = 52, .external_lex_state = 11},
  [1450] = {.lex_state = 52, .external_lex_state = 10},
  [1451] = {.lex_state = 7, .external_lex_state = 11},
  [1452] = {.lex_state = 52, .external_lex_state = 13},
  [1453] = {.lex_state = 52, .external_lex_state = 13},
  [1454] = {.lex_state = 52, .external_lex_state = 13},
  [1455] = {.lex_state = 7, .external_lex_state = 13},
  [1456] = {.lex_state = 52, .external_lex_state = 13},
  [1457] = {.lex_state = 52, .external_lex_state = 12},
  [1458] = {.lex_state = 7, .external_lex_state = 13},
  [1459] = {.lex_state = 52, .external_lex_state = 10},
  [1460] = {.lex_state = 7, .external_lex_state = 11},
  [1461] = {.lex_state = 52, .external_lex_state = 9},
  [1462] = {.lex_state = 52, .external_lex_state = 11},
  [1463] = {.lex_state = 52, .external_lex_state = 11},
  [1464] = {.lex_state = 52, .external_lex_state = 13},
  [1465] = {.lex_state = 52, .external_lex_state = 10},
  [1466] = {.lex_state = 52, .external_lex_state = 10},
  [1467] = {.lex_state = 52, .external_lex_state = 11},
  [1468] = {.lex_state = 52, .external_lex_state = 6},
  [1469] = {.lex_state = 52, .external_lex_state = 8},
  [1470] = {.lex_state = 52, .external_lex_state = 12},
  [1471] = {.lex_state = 52, .external_lex_state = 9},
  [1472] = {.lex_state = 52, .external_lex_state = 12},
  [1473] = {.lex_state = 52, .external_lex_state = 11},
  [1474] = {.lex_state = 52, .external_lex_state = 10},
  [1475] = {.lex_state = 52, .external_lex_state = 12},
  [1476] = {.lex_state = 52, .external_lex_state = 11},
  [1477] = {.lex_state = 52, .external_lex_state = 7},
  [1478] = {.lex_state = 7, .external_lex_state = 10},
  [1479] = {.lex_state = 7, .external_lex_state = 10},
  [1480] = {.lex_state = 52, .external_lex_state = 6},
  [1481] = {.lex_state = 52, .external_lex_state = 8},
  [1482] = {.lex_state = 0, .external_lex_state = 14},
  [1483] = {.lex_state = 52, .external_lex_state = 9},
  [1484] = {.lex_state = 52, .external_lex_state = 12},
  [1485] = {.lex_state = 52, .external_lex_state = 11},
  [1486] = {.lex_state = 52, .external_lex_state = 13},
  [1487] = {.lex_state = 52, .external_lex_state = 11},
  [1488] = {.lex_state = 52, .external_lex_state = 12},
  [1489] = {.lex_state = 52, .external_lex_state = 10},
  [1490] = {.lex_state = 52, .external_lex_state = 11},
  [1491] = {.lex_state = 52, .external_lex_state = 10},
  [1492] = {.lex_state = 52, .external_lex_state = 11},
  [1493] = {.lex_state = 52, .external_lex_state = 11},
  [1494] = {.lex_state = 52, .external_lex_state = 11},
  [1495] = {.lex_state = 7, .external_lex_state = 11},
  [1496] = {.lex_state = 7, .external_lex_state = 10},
  [1497] = {.lex_state = 52, .external_lex_state = 10},
  [1498] = {.lex_state = 52, .external_lex_state = 10},
  [1499] = {.lex_state = 52, .external_lex_state = 13},
  [1500] = {.lex_state = 52, .external_lex_state = 11},
  [1501] = {.lex_state = 52, .external_lex_state = 11},
  [1502] = {.lex_state = 52, .external_lex_state = 13},
  [1503] = {.lex_state = 52, .external_lex_state = 13},
  [1504] = {.lex_state = 8, .external_lex_state = 11},
  [1505] = {.lex_state = 0, .external_lex_state = 14},
  [1506] = {.lex_state = 52, .external_lex_state = 12},
  [1507] = {.lex_state = 8, .external_lex_state = 12},
  [1508] = {.lex_state = 52, .external_lex_state = 10},
  [1509] = {.lex_state = 52, .external_lex_state = 11},
  [1510] = {.lex_state = 52, .external_lex_state = 11},
  [1511] = {.lex_state = 8, .external_lex_state = 13},
  [1512] = {.lex_state = 8, .external_lex_state = 11},
  [1513] = {.lex_state = 8, .external_lex_state = 11},
  [1514] = {.lex_state = 52, .external_lex_state = 12},
  [1515] = {.lex_state = 52, .external_lex_state = 11},
  [1516] = {.lex_state = 8, .external_lex_state = 11},
  [1517] = {.lex_state = 8, .external_lex_state = 11},
  [1518] = {.lex_state = 8, .external_lex_state = 11},
  [1519] = {.lex_state = 8, .external_lex_state = 11},
  [1520] = {.lex_state = 52, .external_lex_state = 12},
  [1521] = {.lex_state = 52, .external_lex_state = 13},
  [1522] = {.lex_state = 0, .external_lex_state = 14},
  [1523] = {.lex_state = 52, .external_lex_state = 11},
  [1524] = {.lex_state = 8, .external_lex_state = 13},
  [1525] = {.lex_state = 52, .external_lex_state = 10},
  [1526] = {.lex_state = 52, .external_lex_state = 12},
  [1527] = {.lex_state = 52, .external_lex_state = 13},
  [1528] = {.lex_state = 52, .external_lex_state = 10},
  [1529] = {.lex_state = 52, .external_lex_state = 10},
  [1530] = {.lex_state = 52, .external_lex_state = 10},
  [1531] = {.lex_state = 52, .external_lex_state = 12},
  [1532] = {.lex_state = 52, .external_lex_state = 12},
  [1533] = {.lex_state = 52, .external_lex_state = 12},
  [1534] = {.lex_state = 52, .external_lex_state = 12},
  [1535] = {.lex_state = 8, .external_lex_state = 11},
  [1536] = {.lex_state = 52, .external_lex_state = 10},
  [1537] = {.lex_state = 52, .external_lex_state = 11},
  [1538] = {.lex_state = 52, .external_lex_state = 10},
  [1539] = {.lex_state = 52, .external_lex_state = 10},
  [1540] = {.lex_state = 52, .external_lex_state = 12},
  [1541] = {.lex_state = 52, .external_lex_state = 10},
  [1542] = {.lex_state = 8, .external_lex_state = 9},
  [1543] = {.lex_state = 8, .external_lex_state = 9},
  [1544] = {.lex_state = 8, .external_lex_state = 13},
  [1545] = {.lex_state = 8, .external_lex_state = 11},
  [1546] = {.lex_state = 8, .external_lex_state = 12},
  [1547] = {.lex_state = 52, .external_lex_state = 12},
  [1548] = {.lex_state = 0, .external_lex_state = 14},
  [1549] = {.lex_state = 0, .external_lex_state = 14},
  [1550] = {.lex_state = 52, .external_lex_state = 13},
  [1551] = {.lex_state = 8, .external_lex_state = 9},
  [1552] = {.lex_state = 7, .external_lex_state = 13},
  [1553] = {.lex_state = 8, .external_lex_state = 9},
  [1554] = {.lex_state = 8, .external_lex_state = 9},
  [1555] = {.lex_state = 52, .external_lex_state = 13},
  [1556] = {.lex_state = 7, .external_lex_state = 10},
  [1557] = {.lex_state = 8, .external_lex_state = 13},
  [1558] = {.lex_state = 52, .external_lex_state = 11},
  [1559] = {.lex_state = 0, .external_lex_state = 14},
  [1560] = {.lex_state = 0, .external_lex_state = 14},
  [1561] = {.lex_state = 0, .external_lex_state = 14},
  [1562] = {.lex_state = 0, .external_lex_state = 14},
  [1563] = {.lex_state = 52, .external_lex_state = 10},
  [1564] = {.lex_state = 7, .external_lex_state = 11},
  [1565] = {.lex_state = 8, .external_lex_state = 11},
  [1566] = {.lex_state = 52, .external_lex_state = 11},
  [1567] = {.lex_state = 52, .external_lex_state = 10},
  [1568] = {.lex_state = 52, .external_lex_state = 10},
  [1569] = {.lex_state = 52, .external_lex_state = 12},
  [1570] = {.lex_state = 52, .external_lex_state = 10},
  [1571] = {.lex_state = 8, .external_lex_state = 12},
  [1572] = {.lex_state = 52, .external_lex_state = 10},
  [1573] = {.lex_state = 8, .external_lex_state = 9},
  [1574] = {.lex_state = 8, .external_lex_state = 9},
  [1575] = {.lex_state = 8, .external_lex_state = 9},
  [1576] = {.lex_state = 8, .external_lex_state = 9},
  [1577] = {.lex_state = 52, .external_lex_state = 13},
  [1578] = {.lex_state = 52, .external_lex_state = 2},
  [1579] = {.lex_state = 52, .external_lex_state = 12},
  [1580] = {.lex_state = 8, .external_lex_state = 9},
  [1581] = {.lex_state = 52, .external_lex_state = 12},
  [1582] = {.lex_state = 52, .external_lex_state = 13},
  [1583] = {.lex_state = 52, .external_lex_state = 11},
  [1584] = {.lex_state = 52, .external_lex_state = 12},
  [1585] = {.lex_state = 52, .external_lex_state = 2},
  [1586] = {.lex_state = 52, .external_lex_state = 13},
  [1587] = {.lex_state = 52, .external_lex_state = 13},
  [1588] = {.lex_state = 52, .external_lex_state = 13},
  [1589] = {.lex_state = 52, .external_lex_state = 11},
  [1590] = {.lex_state = 52, .external_lex_state = 10},
  [1591] = {.lex_state = 52, .external_lex_state = 12},
  [1592] = {.lex_state = 3, .external_lex_state = 10},
  [1593] = {.lex_state = 52, .external_lex_state = 12},
  [1594] = {.lex_state = 52, .external_lex_state = 13},
  [1595] = {.lex_state = 52, .external_lex_state = 12},
  [1596] = {.lex_state = 52, .external_lex_state = 10},
  [1597] = {.lex_state = 52, .external_lex_state = 12},
  [1598] = {.lex_state = 52, .external_lex_state = 12},
  [1599] = {.lex_state = 52, .external_lex_state = 10},
  [1600] = {.lex_state = 52, .external_lex_state = 12},
  [1601] = {.lex_state = 52, .external_lex_state = 12},
  [1602] = {.lex_state = 52, .external_lex_state = 11},
  [1603] = {.lex_state = 8, .external_lex_state = 13},
  [1604] = {.lex_state = 8, .external_lex_state = 13},
  [1605] = {.lex_state = 52, .external_lex_state = 12},
  [1606] = {.lex_state = 3, .external_lex_state = 10},
  [1607] = {.lex_state = 52, .external_lex_state = 12},
  [1608] = {.lex_state = 52, .external_lex_state = 10},
  [1609] = {.lex_state = 8, .external_lex_state = 12},
  [1610] = {.lex_state = 52, .external_lex_state = 12},
  [1611] = {.lex_state = 52, .external_lex_state = 13},
  [1612] = {.lex_state = 8, .external_lex_state = 13},
  [1613] = {.lex_state = 52, .external_lex_state = 13},
  [1614] = {.lex_state = 52, .external_lex_state = 13},
  [1615] = {.lex_state = 52, .external_lex_state = 7},
  [1616] = {.lex_state = 52, .external_lex_state = 13},
  [1617] = {.lex_state = 52, .external_lex_state = 12},
  [1618] = {.lex_state = 52, .external_lex_state = 12},
  [1619] = {.lex_state = 52, .external_lex_state = 7},
  [1620] = {.lex_state = 52, .external_lex_state = 10},
  [1621] = {.lex_state = 52, .external_lex_state = 12},
  [1622] = {.lex_state = 52, .external_lex_state = 12},
  [1623] = {.lex_state = 52, .external_lex_state = 12},
  [1624] = {.lex_state = 52, .external_lex_state = 12},
  [1625] = {.lex_state = 52, .external_lex_state = 10},
  [1626] = {.lex_state = 52, .external_lex_state = 12},
  [1627] = {.lex_state = 52, .external_lex_state = 12},
  [1628] = {.lex_state = 52, .external_lex_state = 6},
  [1629] = {.lex_state = 8, .external_lex_state = 12},
  [1630] = {.lex_state = 8, .external_lex_state = 12},
  [1631] = {.lex_state = 52, .external_lex_state = 12},
  [1632] = {.lex_state = 52, .external_lex_state = 6},
  [1633] = {.lex_state = 52, .external_lex_state = 11},
  [1634] = {.lex_state = 52, .external_lex_state = 12},
  [1635] = {.lex_state = 52, .external_lex_state = 8},
  [1636] = {.lex_state = 52, .external_lex_state = 12},
  [1637] = {.lex_state = 8, .external_lex_state = 12},
  [1638] = {.lex_state = 8, .external_lex_state = 13},
  [1639] = {.lex_state = 52, .external_lex_state = 10},
  [1640] = {.lex_state = 52, .external_lex_state = 12},
  [1641] = {.lex_state = 52, .external_lex_state = 8},
  [1642] = {.lex_state = 52, .external_lex_state = 12},
  [1643] = {.lex_state = 52, .external_lex_state = 12},
  [1644] = {.lex_state = 8, .external_lex_state = 13},
  [1645] = {.lex_state = 52, .external_lex_state = 11},
  [1646] = {.lex_state = 52, .external_lex_state = 11},
  [1647] = {.lex_state = 52, .external_lex_state = 12},
  [1648] = {.lex_state = 8, .external_lex_state = 11},
  [1649] = {.lex_state = 52, .external_lex_state = 13},
  [1650] = {.lex_state = 52, .external_lex_state = 10},
  [1651] = {.lex_state = 52, .external_lex_state = 10},
  [1652] = {.lex_state = 52, .external_lex_state = 12},
  [1653] = {.lex_state = 52, .external_lex_state = 12},
  [1654] = {.lex_state = 52, .external_lex_state = 12},
  [1655] = {.lex_state = 52, .external_lex_state = 12},
  [1656] = {.lex_state = 52, .external_lex_state = 10},
  [1657] = {.lex_state = 8, .external_lex_state = 12},
  [1658] = {.lex_state = 52, .external_lex_state = 12},
  [1659] = {.lex_state = 52, .external_lex_state = 10},
  [1660] = {.lex_state = 52, .external_lex_state = 10},
  [1661] = {.lex_state = 52, .external_lex_state = 12},
  [1662] = {.lex_state = 52, .external_lex_state = 9},
  [1663] = {.lex_state = 52, .external_lex_state = 12},
  [1664] = {.lex_state = 52, .external_lex_state = 12},
  [1665] = {.lex_state = 8, .external_lex_state = 13},
  [1666] = {.lex_state = 8, .external_lex_state = 13},
  [1667] = {.lex_state = 52, .external_lex_state = 10},
  [1668] = {.lex_state = 52, .external_lex_state = 10},
  [1669] = {.lex_state = 8, .external_lex_state = 13},
  [1670] = {.lex_state = 52, .external_lex_state = 10},
  [1671] = {.lex_state = 3, .external_lex_state = 10},
  [1672] = {.lex_state = 52, .external_lex_state = 11},
  [1673] = {.lex_state = 52, .external_lex_state = 12},
  [1674] = {.lex_state = 52, .external_lex_state = 10},
  [1675] = {.lex_state = 52, .external_lex_state = 13},
  [1676] = {.lex_state = 8, .external_lex_state = 13},
  [1677] = {.lex_state = 8, .external_lex_state = 12},
  [1678] = {.lex_state = 8, .external_lex_state = 12},
  [1679] = {.lex_state = 52, .external_lex_state = 13},
  [1680] = {.lex_state = 52, .external_lex_state = 13},
  [1681] = {.lex_state = 8, .external_lex_state = 13},
  [1682] = {.lex_state = 52, .external_lex_state = 12},
  [1683] = {.lex_state = 52, .external_lex_state = 12},
  [1684] = {.lex_state = 52, .external_lex_state = 10},
  [1685] = {.lex_state = 52, .external_lex_state = 12},
  [1686] = {.lex_state = 52, .external_lex_state = 10},
  [1687] = {.lex_state = 52, .external_lex_state = 10},
  [1688] = {.lex_state = 52, .external_lex_state = 10},
  [1689] = {.lex_state = 52, .external_lex_state = 12},
  [1690] = {.lex_state = 52, .external_lex_state = 11},
  [1691] = {.lex_state = 52, .external_lex_state = 12},
  [1692] = {.lex_state = 52, .external_lex_state = 10},
  [1693] = {.lex_state = 52, .external_lex_state = 12},
  [1694] = {.lex_state = 52, .external_lex_state = 12},
  [1695] = {.lex_state = 52, .external_lex_state = 10},
  [1696] = {.lex_state = 52, .external_lex_state = 11},
  [1697] = {.lex_state = 52, .external_lex_state = 10},
  [1698] = {.lex_state = 52, .external_lex_state = 10},
  [1699] = {.lex_state = 52, .external_lex_state = 10},
  [1700] = {.lex_state = 52, .external_lex_state = 11},
  [1701] = {.lex_state = 52, .external_lex_state = 10},
  [1702] = {.lex_state = 52, .external_lex_state = 13},
  [1703] = {.lex_state = 52, .external_lex_state = 10},
  [1704] = {.lex_state = 52, .external_lex_state = 11},
  [1705] = {.lex_state = 52, .external_lex_state = 10},
  [1706] = {.lex_state = 52, .external_lex_state = 10},
  [1707] = {.lex_state = 52, .external_lex_state = 11},
  [1708] = {.lex_state = 52, .external_lex_state = 10},
  [1709] = {.lex_state = 52, .external_lex_state = 13},
  [1710] = {.lex_state = 52, .external_lex_state = 9},
  [1711] = {.lex_state = 52, .external_lex_state = 10},
  [1712] = {.lex_state = 52, .external_lex_state = 10},
  [1713] = {.lex_state = 52, .external_lex_state = 10},
  [1714] = {.lex_state = 52, .external_lex_state = 10},
  [1715] = {.lex_state = 52, .external_lex_state = 11},
  [1716] = {.lex_state = 52, .external_lex_state = 10},
  [1717] = {.lex_state = 52, .external_lex_state = 15},
  [1718] = {.lex_state = 52, .external_lex_state = 10},
  [1719] = {.lex_state = 52, .external_lex_state = 10},
  [1720] = {.lex_state = 52, .external_lex_state = 13},
  [1721] = {.lex_state = 52, .external_lex_state = 13},
  [1722] = {.lex_state = 52, .external_lex_state = 9},
  [1723] = {.lex_state = 52, .external_lex_state = 11},
  [1724] = {.lex_state = 52, .external_lex_state = 10},
  [1725] = {.lex_state = 52, .external_lex_state = 11},
  [1726] = {.lex_state = 52, .external_lex_state = 15},
  [1727] = {.lex_state = 8, .external_lex_state = 12},
  [1728] = {.lex_state = 52, .external_lex_state = 10},
  [1729] = {.lex_state = 52, .external_lex_state = 10},
  [1730] = {.lex_state = 52, .external_lex_state = 10},
  [1731] = {.lex_state = 52, .external_lex_state = 10},
  [1732] = {.lex_state = 52, .external_lex_state = 10},
  [1733] = {.lex_state = 52, .external_lex_state = 11},
  [1734] = {.lex_state = 52, .external_lex_state = 11},
  [1735] = {.lex_state = 52, .external_lex_state = 13},
  [1736] = {.lex_state = 52, .external_lex_state = 13},
  [1737] = {.lex_state = 52, .external_lex_state = 11},
  [1738] = {.lex_state = 52, .external_lex_state = 12},
  [1739] = {.lex_state = 52, .external_lex_state = 10},
  [1740] = {.lex_state = 52, .external_lex_state = 15},
  [1741] = {.lex_state = 52, .external_lex_state = 13},
  [1742] = {.lex_state = 52, .external_lex_state = 13},
  [1743] = {.lex_state = 52, .external_lex_state = 12},
  [1744] = {.lex_state = 52, .external_lex_state = 9},
  [1745] = {.lex_state = 52, .external_lex_state = 11},
  [1746] = {.lex_state = 52, .external_lex_state = 13},
  [1747] = {.lex_state = 52, .external_lex_state = 13},
  [1748] = {.lex_state = 52, .external_lex_state = 9},
  [1749] = {.lex_state = 52, .external_lex_state = 13},
  [1750] = {.lex_state = 52, .external_lex_state = 10},
  [1751] = {.lex_state = 52, .external_lex_state = 11},
  [1752] = {.lex_state = 52, .external_lex_state = 13},
  [1753] = {.lex_state = 52, .external_lex_state = 11},
  [1754] = {.lex_state = 52, .external_lex_state = 11},
  [1755] = {.lex_state = 52, .external_lex_state = 11},
  [1756] = {.lex_state = 52, .external_lex_state = 12},
  [1757] = {.lex_state = 52, .external_lex_state = 13},
  [1758] = {.lex_state = 52, .external_lex_state = 13},
  [1759] = {.lex_state = 52, .external_lex_state = 13},
  [1760] = {.lex_state = 52, .external_lex_state = 11},
  [1761] = {.lex_state = 52, .external_lex_state = 11},
  [1762] = {.lex_state = 52, .external_lex_state = 12},
  [1763] = {.lex_state = 52, .external_lex_state = 15},
  [1764] = {.lex_state = 52, .external_lex_state = 9},
  [1765] = {.lex_state = 52, .external_lex_state = 13},
  [1766] = {.lex_state = 52, .external_lex_state = 11},
  [1767] = {.lex_state = 52, .external_lex_state = 13},
  [1768] = {.lex_state = 52, .external_lex_state = 11},
  [1769] = {.lex_state = 52, .external_lex_state = 9},
  [1770] = {.lex_state = 52, .external_lex_state = 13},
  [1771] = {.lex_state = 52, .external_lex_state = 9},
  [1772] = {.lex_state = 52, .external_lex_state = 10},
  [1773] = {.lex_state = 52, .external_lex_state = 11},
  [1774] = {.lex_state = 52, .external_lex_state = 11},
  [1775] = {.lex_state = 52, .external_lex_state = 13},
  [1776] = {.lex_state = 52, .external_lex_state = 12},
  [1777] = {.lex_state = 52, .external_lex_state = 13},
  [1778] = {.lex_state = 52, .external_lex_state = 13},
  [1779] = {.lex_state = 52, .external_lex_state = 12},
  [1780] = {.lex_state = 52, .external_lex_state = 11},
  [1781] = {.lex_state = 52, .external_lex_state = 13},
  [1782] = {.lex_state = 52, .external_lex_state = 13},
  [1783] = {.lex_state = 52, .external_lex_state = 13},
  [1784] = {.lex_state = 52, .external_lex_state = 11},
  [1785] = {.lex_state = 52, .external_lex_state = 11},
  [1786] = {.lex_state = 52, .external_lex_state = 11},
  [1787] = {.lex_state = 52, .external_lex_state = 13},
  [1788] = {.lex_state = 52, .external_lex_state = 9},
  [1789] = {.lex_state = 52, .external_lex_state = 11},
  [1790] = {.lex_state = 52, .external_lex_state = 11},
  [1791] = {.lex_state = 52, .external_lex_state = 11},
  [1792] = {.lex_state = 52, .external_lex_state = 11},
  [1793] = {.lex_state = 52, .external_lex_state = 11},
  [1794] = {.lex_state = 52, .external_lex_state = 10},
  [1795] = {.lex_state = 52, .external_lex_state = 15},
  [1796] = {.lex_state = 52, .external_lex_state = 11},
  [1797] = {.lex_state = 52, .external_lex_state = 13},
  [1798] = {.lex_state = 52, .external_lex_state = 13},
  [1799] = {.lex_state = 52, .external_lex_state = 12},
  [1800] = {.lex_state = 52, .external_lex_state = 9},
  [1801] = {.lex_state = 52, .external_lex_state = 9},
  [1802] = {.lex_state = 52, .external_lex_state = 11},
  [1803] = {.lex_state = 52, .external_lex_state = 12},
  [1804] = {.lex_state = 52, .external_lex_state = 12},
  [1805] = {.lex_state = 52, .external_lex_state = 13},
  [1806] = {.lex_state = 52, .external_lex_state = 11},
  [1807] = {.lex_state = 52, .external_lex_state = 11},
  [1808] = {.lex_state = 52, .external_lex_state = 11},
  [1809] = {.lex_state = 52, .external_lex_state = 9},
  [1810] = {.lex_state = 52, .external_lex_state = 11},
  [1811] = {.lex_state = 52, .external_lex_state = 12},
  [1812] = {.lex_state = 52, .external_lex_state = 12},
  [1813] = {.lex_state = 52, .external_lex_state = 11},
  [1814] = {.lex_state = 52, .external_lex_state = 12},
  [1815] = {.lex_state = 52, .external_lex_state = 12},
  [1816] = {.lex_state = 52, .external_lex_state = 13},
  [1817] = {.lex_state = 52, .external_lex_state = 10},
  [1818] = {.lex_state = 52, .external_lex_state = 11},
  [1819] = {.lex_state = 52, .external_lex_state = 10},
  [1820] = {.lex_state = 52, .external_lex_state = 9},
  [1821] = {.lex_state = 52, .external_lex_state = 11},
  [1822] = {.lex_state = 52, .external_lex_state = 11},
  [1823] = {.lex_state = 52, .external_lex_state = 9},
  [1824] = {.lex_state = 3, .external_lex_state = 10},
  [1825] = {.lex_state = 52, .external_lex_state = 10},
  [1826] = {.lex_state = 52, .external_lex_state = 10},
  [1827] = {.lex_state = 52, .external_lex_state = 11},
  [1828] = {.lex_state = 52, .external_lex_state = 11},
  [1829] = {.lex_state = 52, .external_lex_state = 16},
  [1830] = {.lex_state = 52, .external_lex_state = 10},
  [1831] = {.lex_state = 52, .external_lex_state = 10},
  [1832] = {.lex_state = 52, .external_lex_state = 9},
  [1833] = {.lex_state = 52, .external_lex_state = 10},
  [1834] = {.lex_state = 52, .external_lex_state = 16},
  [1835] = {.lex_state = 52, .external_lex_state = 11},
  [1836] = {.lex_state = 52, .external_lex_state = 13},
  [1837] = {.lex_state = 52, .external_lex_state = 16},
  [1838] = {.lex_state = 52, .external_lex_state = 12},
  [1839] = {.lex_state = 52, .external_lex_state = 11},
  [1840] = {.lex_state = 52, .external_lex_state = 11},
  [1841] = {.lex_state = 52, .external_lex_state = 12},
  [1842] = {.lex_state = 52, .external_lex_state = 10},
  [1843] = {.lex_state = 52, .external_lex_state = 13},
  [1844] = {.lex_state = 52, .external_lex_state = 10},
  [1845] = {.lex_state = 52, .external_lex_state = 10},
  [1846] = {.lex_state = 52, .external_lex_state = 13},
  [1847] = {.lex_state = 52, .external_lex_state = 13},
  [1848] = {.lex_state = 52, .external_lex_state = 13},
  [1849] = {.lex_state = 52, .external_lex_state = 11},
  [1850] = {.lex_state = 52, .external_lex_state = 11},
  [1851] = {.lex_state = 52, .external_lex_state = 11},
  [1852] = {.lex_state = 52, .external_lex_state = 11},
  [1853] = {.lex_state = 52, .external_lex_state = 11},
  [1854] = {.lex_state = 52, .external_lex_state = 13},
  [1855] = {.lex_state = 52, .external_lex_state = 13},
  [1856] = {.lex_state = 52, .external_lex_state = 10},
  [1857] = {.lex_state = 52, .external_lex_state = 13},
  [1858] = {.lex_state = 52, .external_lex_state = 11},
  [1859] = {.lex_state = 52, .external_lex_state = 13},
  [1860] = {.lex_state = 8, .external_lex_state = 12},
  [1861] = {.lex_state = 52, .external_lex_state = 13},
  [1862] = {.lex_state = 52, .external_lex_state = 11},
  [1863] = {.lex_state = 52, .external_lex_state = 13},
  [1864] = {.lex_state = 52, .external_lex_state = 10},
  [1865] = {.lex_state = 52, .external_lex_state = 11},
  [1866] = {.lex_state = 52, .external_lex_state = 11},
  [1867] = {.lex_state = 52, .external_lex_state = 11},
  [1868] = {.lex_state = 52, .external_lex_state = 11},
  [1869] = {.lex_state = 52, .external_lex_state = 11},
  [1870] = {.lex_state = 52, .external_lex_state = 12},
  [1871] = {.lex_state = 52, .external_lex_state = 11},
  [1872] = {.lex_state = 52, .external_lex_state = 10},
  [1873] = {.lex_state = 52, .external_lex_state = 10},
  [1874] = {.lex_state = 52, .external_lex_state = 12},
  [1875] = {.lex_state = 3, .external_lex_state = 10},
  [1876] = {.lex_state = 52, .external_lex_state = 13},
  [1877] = {.lex_state = 8, .external_lex_state = 12},
  [1878] = {.lex_state = 52, .external_lex_state = 13},
  [1879] = {.lex_state = 52, .external_lex_state = 11},
  [1880] = {.lex_state = 52, .external_lex_state = 11},
  [1881] = {.lex_state = 52, .external_lex_state = 13},
  [1882] = {.lex_state = 52, .external_lex_state = 11},
  [1883] = {.lex_state = 52, .external_lex_state = 13},
  [1884] = {.lex_state = 52, .external_lex_state = 10},
  [1885] = {.lex_state = 52, .external_lex_state = 12},
  [1886] = {.lex_state = 52, .external_lex_state = 10},
  [1887] = {.lex_state = 52, .external_lex_state = 12},
  [1888] = {.lex_state = 52, .external_lex_state = 13},
  [1889] = {.lex_state = 52, .external_lex_state = 10},
  [1890] = {.lex_state = 52, .external_lex_state = 10},
  [1891] = {.lex_state = 52, .external_lex_state = 10},
  [1892] = {.lex_state = 52, .external_lex_state = 10},
  [1893] = {.lex_state = 52, .external_lex_state = 11},
  [1894] = {.lex_state = 52, .external_lex_state = 13},
  [1895] = {.lex_state = 52, .external_lex_state = 13},
  [1896] = {.lex_state = 52, .external_lex_state = 12},
  [1897] = {.lex_state = 8, .external_lex_state = 12},
  [1898] = {.lex_state = 52, .external_lex_state = 11},
  [1899] = {.lex_state = 52, .external_lex_state = 11},
  [1900] = {.lex_state = 52, .external_lex_state = 11},
  [1901] = {.lex_state = 52, .external_lex_state = 11},
  [1902] = {.lex_state = 52, .external_lex_state = 12},
  [1903] = {.lex_state = 52, .external_lex_state = 10},
  [1904] = {.lex_state = 52, .external_lex_state = 11},
  [1905] = {.lex_state = 52, .external_lex_state = 11},
  [1906] = {.lex_state = 52, .external_lex_state = 11},
  [1907] = {.lex_state = 52, .external_lex_state = 11},
  [1908] = {.lex_state = 52, .external_lex_state = 10},
  [1909] = {.lex_state = 52, .external_lex_state = 16},
  [1910] = {.lex_state = 52, .external_lex_state = 13},
  [1911] = {.lex_state = 52, .external_lex_state = 13},
  [1912] = {.lex_state = 52, .external_lex_state = 11},
  [1913] = {.lex_state = 52, .external_lex_state = 10},
  [1914] = {.lex_state = 52, .external_lex_state = 13},
  [1915] = {.lex_state = 52, .external_lex_state = 10},
  [1916] = {.lex_state = 52, .external_lex_state = 10},
  [1917] = {.lex_state = 52, .external_lex_state = 11},
  [1918] = {.lex_state = 52, .external_lex_state = 11},
  [1919] = {.lex_state = 52, .external_lex_state = 13},
  [1920] = {.lex_state = 52, .external_lex_state = 11},
  [1921] = {.lex_state = 52, .external_lex_state = 11},
  [1922] = {.lex_state = 52, .external_lex_state = 13},
  [1923] = {.lex_state = 52, .external_lex_state = 13},
  [1924] = {.lex_state = 52, .external_lex_state = 10},
  [1925] = {.lex_state = 52, .external_lex_state = 13},
  [1926] = {.lex_state = 52, .external_lex_state = 13},
  [1927] = {.lex_state = 52, .external_lex_state = 11},
  [1928] = {.lex_state = 52, .external_lex_state = 13},
  [1929] = {.lex_state = 52, .external_lex_state = 11},
  [1930] = {.lex_state = 3, .external_lex_state = 10},
  [1931] = {.lex_state = 52, .external_lex_state = 11},
  [1932] = {.lex_state = 52, .external_lex_state = 11},
  [1933] = {.lex_state = 52, .external_lex_state = 11},
  [1934] = {.lex_state = 52, .external_lex_state = 12},
  [1935] = {.lex_state = 52, .external_lex_state = 13},
  [1936] = {.lex_state = 3, .external_lex_state = 10},
  [1937] = {.lex_state = 52, .external_lex_state = 9},
  [1938] = {.lex_state = 52, .external_lex_state = 16},
  [1939] = {.lex_state = 52, .external_lex_state = 10},
  [1940] = {.lex_state = 52, .external_lex_state = 12},
  [1941] = {.lex_state = 52, .external_lex_state = 11},
  [1942] = {.lex_state = 52, .external_lex_state = 13},
  [1943] = {.lex_state = 52, .external_lex_state = 11},
  [1944] = {.lex_state = 3, .external_lex_state = 10},
  [1945] = {.lex_state = 52, .external_lex_state = 13},
  [1946] = {.lex_state = 52, .external_lex_state = 13},
  [1947] = {.lex_state = 52, .external_lex_state = 11},
  [1948] = {.lex_state = 52, .external_lex_state = 13},
  [1949] = {.lex_state = 52, .external_lex_state = 16},
  [1950] = {.lex_state = 52, .external_lex_state = 13},
  [1951] = {.lex_state = 52, .external_lex_state = 12},
  [1952] = {.lex_state = 3, .external_lex_state = 10},
  [1953] = {.lex_state = 8, .external_lex_state = 12},
  [1954] = {.lex_state = 52, .external_lex_state = 12},
  [1955] = {.lex_state = 52, .external_lex_state = 10},
  [1956] = {.lex_state = 52, .external_lex_state = 13},
  [1957] = {.lex_state = 52, .external_lex_state = 11},
  [1958] = {.lex_state = 8, .external_lex_state = 12},
  [1959] = {.lex_state = 8, .external_lex_state = 12},
  [1960] = {.lex_state = 52, .external_lex_state = 12},
  [1961] = {.lex_state = 52, .external_lex_state = 10},
  [1962] = {.lex_state = 52, .external_lex_state = 16},
  [1963] = {.lex_state = 52, .external_lex_state = 13},
  [1964] = {.lex_state = 52, .external_lex_state = 13},
  [1965] = {.lex_state = 52, .external_lex_state = 11},
  [1966] = {.lex_state = 52, .external_lex_state = 12},
  [1967] = {.lex_state = 52, .external_lex_state = 11},
  [1968] = {.lex_state = 52, .external_lex_state = 11},
  [1969] = {.lex_state = 8, .external_lex_state = 12},
  [1970] = {.lex_state = 52, .external_lex_state = 13},
  [1971] = {.lex_state = 52, .external_lex_state = 12},
  [1972] = {.lex_state = 52, .external_lex_state = 13},
  [1973] = {.lex_state = 52, .external_lex_state = 10},
  [1974] = {.lex_state = 52, .external_lex_state = 11},
  [1975] = {.lex_state = 52, .external_lex_state = 10},
  [1976] = {.lex_state = 52, .external_lex_state = 12},
  [1977] = {.lex_state = 52, .external_lex_state = 9},
  [1978] = {.lex_state = 52, .external_lex_state = 12},
  [1979] = {.lex_state = 52, .external_lex_state = 11},
  [1980] = {.lex_state = 52, .external_lex_state = 13},
  [1981] = {.lex_state = 52, .external_lex_state = 10},
  [1982] = {.lex_state = 52, .external_lex_state = 11},
  [1983] = {.lex_state = 52, .external_lex_state = 16},
  [1984] = {.lex_state = 52, .external_lex_state = 12},
  [1985] = {.lex_state = 52, .external_lex_state = 10},
  [1986] = {.lex_state = 52, .external_lex_state = 11},
  [1987] = {.lex_state = 52, .external_lex_state = 12},
  [1988] = {.lex_state = 52, .external_lex_state = 13},
  [1989] = {.lex_state = 52, .external_lex_state = 11},
  [1990] = {.lex_state = 52, .external_lex_state = 10},
  [1991] = {.lex_state = 52, .external_lex_state = 12},
  [1992] = {.lex_state = 8, .external_lex_state = 12},
  [1993] = {.lex_state = 52, .external_lex_state = 13},
  [1994] = {.lex_state = 52, .external_lex_state = 11},
  [1995] = {.lex_state = 3, .external_lex_state = 10},
  [1996] = {.lex_state = 3, .external_lex_state = 10},
  [1997] = {.lex_state = 52, .external_lex_state = 13},
  [1998] = {.lex_state = 52, .external_lex_state = 13},
  [1999] = {.lex_state = 52, .external_lex_state = 11},
  [2000] = {.lex_state = 52, .external_lex_state = 13},
  [2001] = {.lex_state = 52, .external_lex_state = 10},
  [2002] = {.lex_state = 52, .external_lex_state = 10},
  [2003] = {.lex_state = 3, .external_lex_state = 10},
  [2004] = {.lex_state = 52, .external_lex_state = 10},
  [2005] = {.lex_state = 52, .external_lex_state = 11},
  [2006] = {.lex_state = 52, .external_lex_state = 9},
  [2007] = {.lex_state = 52, .external_lex_state = 12},
  [2008] = {.lex_state = 52, .external_lex_state = 9},
  [2009] = {.lex_state = 52, .external_lex_state = 11},
  [2010] = {.lex_state = 52, .external_lex_state = 13},
  [2011] = {.lex_state = 52, .external_lex_state = 13},
  [2012] = {.lex_state = 52, .external_lex_state = 12},
  [2013] = {.lex_state = 52, .external_lex_state = 10},
  [2014] = {.lex_state = 52, .external_lex_state = 9},
  [2015] = {.lex_state = 52, .external_lex_state = 15},
  [2016] = {.lex_state = 52, .external_lex_state = 15},
  [2017] = {.lex_state = 52, .external_lex_state = 15},
  [2018] = {.lex_state = 9, .external_lex_state = 12},
  [2019] = {.lex_state = 9, .external_lex_state = 12},
  [2020] = {.lex_state = 52, .external_lex_state = 12},
  [2021] = {.lex_state = 52, .external_lex_state = 13},
  [2022] = {.lex_state = 9, .external_lex_state = 12},
  [2023] = {.lex_state = 9, .external_lex_state = 12},
  [2024] = {.lex_state = 52, .external_lex_state = 11},
  [2025] = {.lex_state = 9, .external_lex_state = 12},
  [2026] = {.lex_state = 52, .external_lex_state = 15},
  [2027] = {.lex_state = 52, .external_lex_state = 15},
  [2028] = {.lex_state = 9, .external_lex_state = 12},
  [2029] = {.lex_state = 52, .external_lex_state = 12},
  [2030] = {.lex_state = 52, .external_lex_state = 12},
  [2031] = {.lex_state = 52, .external_lex_state = 12},
  [2032] = {.lex_state = 52, .external_lex_state = 12},
  [2033] = {.lex_state = 52, .external_lex_state = 11},
  [2034] = {.lex_state = 52, .external_lex_state = 15},
  [2035] = {.lex_state = 52, .external_lex_state = 9},
  [2036] = {.lex_state = 52, .external_lex_state = 15},
  [2037] = {.lex_state = 52, .external_lex_state = 11},
  [2038] = {.lex_state = 52, .external_lex_state = 11},
  [2039] = {.lex_state = 52, .external_lex_state = 12},
  [2040] = {.lex_state = 52, .external_lex_state = 13},
  [2041] = {.lex_state = 52, .external_lex_state = 9},
  [2042] = {.lex_state = 52, .external_lex_state = 15},
  [2043] = {.lex_state = 52, .external_lex_state = 9},
  [2044] = {.lex_state = 52, .external_lex_state = 9},
  [2045] = {.lex_state = 52, .external_lex_state = 12},
  [2046] = {.lex_state = 52, .external_lex_state = 12},
  [2047] = {.lex_state = 52, .external_lex_state = 13},
  [2048] = {.lex_state = 52, .external_lex_state = 9},
  [2049] = {.lex_state = 52, .external_lex_state = 11},
  [2050] = {.lex_state = 52, .external_lex_state = 15},
  [2051] = {.lex_state = 52, .external_lex_state = 11},
  [2052] = {.lex_state = 52, .external_lex_state = 11},
  [2053] = {.lex_state = 52, .external_lex_state = 15},
  [2054] = {.lex_state = 52, .external_lex_state = 15},
  [2055] = {.lex_state = 52, .external_lex_state = 15},
  [2056] = {.lex_state = 52, .external_lex_state = 15},
  [2057] = {.lex_state = 52, .external_lex_state = 15},
  [2058] = {.lex_state = 52, .external_lex_state = 15},
  [2059] = {.lex_state = 52, .external_lex_state = 15},
  [2060] = {.lex_state = 9, .external_lex_state = 12},
  [2061] = {.lex_state = 52, .external_lex_state = 13},
  [2062] = {.lex_state = 52, .external_lex_state = 11},
  [2063] = {.lex_state = 52, .external_lex_state = 12},
  [2064] = {.lex_state = 52, .external_lex_state = 10},
  [2065] = {.lex_state = 9, .external_lex_state = 12},
  [2066] = {.lex_state = 52, .external_lex_state = 12},
  [2067] = {.lex_state = 52, .external_lex_state = 10},
  [2068] = {.lex_state = 52, .external_lex_state = 10},
  [2069] = {.lex_state = 52, .external_lex_state = 10},
  [2070] = {.lex_state = 52, .external_lex_state = 12},
  [2071] = {.lex_state = 52, .external_lex_state = 12},
  [2072] = {.lex_state = 52, .external_lex_state = 12},
  [2073] = {.lex_state = 9, .external_lex_state = 12},
  [2074] = {.lex_state = 52, .external_lex_state = 12},
  [2075] = {.lex_state = 52, .external_lex_state = 12},
  [2076] = {.lex_state = 52, .external_lex_state = 12},
  [2077] = {.lex_state = 52, .external_lex_state = 12},
  [2078] = {.lex_state = 52, .external_lex_state = 13},
  [2079] = {.lex_state = 52, .external_lex_state = 12},
  [2080] = {.lex_state = 52, .external_lex_state = 13},
  [2081] = {.lex_state = 52, .external_lex_state = 12},
  [2082] = {.lex_state = 52, .external_lex_state = 13},
  [2083] = {.lex_state = 52, .external_lex_state = 12},
  [2084] = {.lex_state = 52, .external_lex_state = 12},
  [2085] = {.lex_state = 9, .external_lex_state = 12},
  [2086] = {.lex_state = 52, .external_lex_state = 12},
  [2087] = {.lex_state = 52, .external_lex_state = 12},
  [2088] = {.lex_state = 52, .external_lex_state = 15},
  [2089] = {.lex_state = 52, .external_lex_state = 9},
  [2090] = {.lex_state = 52, .external_lex_state = 12},
  [2091] = {.lex_state = 52, .external_lex_state = 12},
  [2092] = {.lex_state = 52, .external_lex_state = 11},
  [2093] = {.lex_state = 52, .external_lex_state = 13},
  [2094] = {.lex_state = 52, .external_lex_state = 15},
  [2095] = {.lex_state = 52, .external_lex_state = 11},
  [2096] = {.lex_state = 52, .external_lex_state = 10},
  [2097] = {.lex_state = 52, .external_lex_state = 9},
  [2098] = {.lex_state = 52, .external_lex_state = 12},
  [2099] = {.lex_state = 52, .external_lex_state = 11},
  [2100] = {.lex_state = 52, .external_lex_state = 11},
  [2101] = {.lex_state = 52, .external_lex_state = 9},
  [2102] = {.lex_state = 52, .external_lex_state = 9},
  [2103] = {.lex_state = 52, .external_lex_state = 12},
  [2104] = {.lex_state = 52, .external_lex_state = 12},
  [2105] = {.lex_state = 52, .external_lex_state = 12},
  [2106] = {.lex_state = 52, .external_lex_state = 13},
  [2107] = {.lex_state = 52, .external_lex_state = 12},
  [2108] = {.lex_state = 4, .external_lex_state = 12},
  [2109] = {.lex_state = 52, .external_lex_state = 10},
  [2110] = {.lex_state = 52, .external_lex_state = 10},
  [2111] = {.lex_state = 52, .external_lex_state = 12},
  [2112] = {.lex_state = 52, .external_lex_state = 11},
  [2113] = {.lex_state = 52, .external_lex_state = 12},
  [2114] = {.lex_state = 52, .external_lex_state = 11},
  [2115] = {.lex_state = 52, .external_lex_state = 12},
  [2116] = {.lex_state = 52, .external_lex_state = 12},
  [2117] = {.lex_state = 52, .external_lex_state = 13},
  [2118] = {.lex_state = 52, .external_lex_state = 10},
  [2119] = {.lex_state = 52, .external_lex_state = 12},
  [2120] = {.lex_state = 52, .external_lex_state = 12},
  [2121] = {.lex_state = 52, .external_lex_state = 10},
  [2122] = {.lex_state = 52, .external_lex_state = 12},
  [2123] = {.lex_state = 52, .external_lex_state = 12},
  [2124] = {.lex_state = 52, .external_lex_state = 12},
  [2125] = {.lex_state = 52, .external_lex_state = 13},
  [2126] = {.lex_state = 52, .external_lex_state = 12},
  [2127] = {.lex_state = 52, .external_lex_state = 11},
  [2128] = {.lex_state = 52, .external_lex_state = 12},
  [2129] = {.lex_state = 52, .external_lex_state = 10},
  [2130] = {.lex_state = 52, .external_lex_state = 10},
  [2131] = {.lex_state = 52, .external_lex_state = 10},
  [2132] = {.lex_state = 52, .external_lex_state = 12},
  [2133] = {.lex_state = 52, .external_lex_state = 12},
  [2134] = {.lex_state = 52, .external_lex_state = 12},
  [2135] = {.lex_state = 52, .external_lex_state = 12},
  [2136] = {.lex_state = 52, .external_lex_state = 12},
  [2137] = {.lex_state = 52, .external_lex_state = 10},
  [2138] = {.lex_state = 52, .external_lex_state = 10},
  [2139] = {.lex_state = 52, .external_lex_state = 13},
  [2140] = {.lex_state = 52, .external_lex_state = 11},
  [2141] = {.lex_state = 52, .external_lex_state = 10},
  [2142] = {.lex_state = 52, .external_lex_state = 12},
  [2143] = {.lex_state = 4, .external_lex_state = 12},
  [2144] = {.lex_state = 52, .external_lex_state = 13},
  [2145] = {.lex_state = 52, .external_lex_state = 10},
  [2146] = {.lex_state = 52, .external_lex_state = 13},
  [2147] = {.lex_state = 52, .external_lex_state = 12},
  [2148] = {.lex_state = 52, .external_lex_state = 12},
  [2149] = {.lex_state = 52, .external_lex_state = 12},
  [2150] = {.lex_state = 52, .external_lex_state = 12},
  [2151] = {.lex_state = 52, .external_lex_state = 12},
  [2152] = {.lex_state = 52, .external_lex_state = 11},
  [2153] = {.lex_state = 52, .external_lex_state = 10},
  [2154] = {.lex_state = 52, .external_lex_state = 10},
  [2155] = {.lex_state = 52, .external_lex_state = 13},
  [2156] = {.lex_state = 52, .external_lex_state = 12},
  [2157] = {.lex_state = 52, .external_lex_state = 12},
  [2158] = {.lex_state = 52, .external_lex_state = 12},
  [2159] = {.lex_state = 52, .external_lex_state = 10},
  [2160] = {.lex_state = 52, .external_lex_state = 12},
  [2161] = {.lex_state = 52, .external_lex_state = 10},
  [2162] = {.lex_state = 52, .external_lex_state = 12},
  [2163] = {.lex_state = 52, .external_lex_state = 12},
  [2164] = {.lex_state = 52, .external_lex_state = 13},
  [2165] = {.lex_state = 52, .external_lex_state = 13},
  [2166] = {.lex_state = 52, .external_lex_state = 11},
  [2167] = {.lex_state = 52, .external_lex_state = 11},
  [2168] = {.lex_state = 52, .external_lex_state = 12},
  [2169] = {.lex_state = 52, .external_lex_state = 11},
  [2170] = {.lex_state = 52, .external_lex_state = 11},
  [2171] = {.lex_state = 4, .external_lex_state = 12},
  [2172] = {.lex_state = 52, .external_lex_state = 13},
  [2173] = {.lex_state = 52, .external_lex_state = 12},
  [2174] = {.lex_state = 52, .external_lex_state = 12},
  [2175] = {.lex_state = 52, .external_lex_state = 12},
  [2176] = {.lex_state = 52, .external_lex_state = 13},
  [2177] = {.lex_state = 52, .external_lex_state = 13},
  [2178] = {.lex_state = 52, .external_lex_state = 12},
  [2179] = {.lex_state = 52, .external_lex_state = 12},
  [2180] = {.lex_state = 52, .external_lex_state = 10},
  [2181] = {.lex_state = 52, .external_lex_state = 10},
  [2182] = {.lex_state = 52, .external_lex_state = 12},
  [2183] = {.lex_state = 52, .external_lex_state = 12},
  [2184] = {.lex_state = 52, .external_lex_state = 12},
  [2185] = {.lex_state = 52, .external_lex_state = 12},
  [2186] = {.lex_state = 52, .external_lex_state = 12},
  [2187] = {.lex_state = 52, .external_lex_state = 12},
  [2188] = {.lex_state = 52, .external_lex_state = 12},
  [2189] = {.lex_state = 52, .external_lex_state = 12},
  [2190] = {.lex_state = 52, .external_lex_state = 12},
  [2191] = {.lex_state = 52, .external_lex_state = 12},
  [2192] = {.lex_state = 52, .external_lex_state = 10},
  [2193] = {.lex_state = 52, .external_lex_state = 10},
  [2194] = {.lex_state = 52, .external_lex_state = 13},
  [2195] = {.lex_state = 52, .external_lex_state = 12},
  [2196] = {.lex_state = 52, .external_lex_state = 10},
  [2197] = {.lex_state = 52, .external_lex_state = 10},
  [2198] = {.lex_state = 52, .external_lex_state = 10},
  [2199] = {.lex_state = 52, .external_lex_state = 10},
  [2200] = {.lex_state = 4, .external_lex_state = 12},
  [2201] = {.lex_state = 52, .external_lex_state = 12},
  [2202] = {.lex_state = 52, .external_lex_state = 11},
  [2203] = {.lex_state = 52, .external_lex_state = 11},
  [2204] = {.lex_state = 52, .external_lex_state = 12},
  [2205] = {.lex_state = 4, .external_lex_state = 12},
  [2206] = {.lex_state = 52, .external_lex_state = 10},
  [2207] = {.lex_state = 52, .external_lex_state = 10},
  [2208] = {.lex_state = 52, .external_lex_state = 13},
  [2209] = {.lex_state = 52, .external_lex_state = 12},
  [2210] = {.lex_state = 52, .external_lex_state = 12},
  [2211] = {.lex_state = 52, .external_lex_state = 12},
  [2212] = {.lex_state = 52, .external_lex_state = 10},
  [2213] = {.lex_state = 52, .external_lex_state = 10},
  [2214] = {.lex_state = 52, .external_lex_state = 10},
  [2215] = {.lex_state = 52, .external_lex_state = 13},
  [2216] = {.lex_state = 52, .external_lex_state = 13},
  [2217] = {.lex_state = 52, .external_lex_state = 11},
  [2218] = {.lex_state = 52, .external_lex_state = 11},
  [2219] = {.lex_state = 52, .external_lex_state = 12},
  [2220] = {.lex_state = 52, .external_lex_state = 12},
  [2221] = {.lex_state = 4, .external_lex_state = 12},
  [2222] = {.lex_state = 52, .external_lex_state = 10},
  [2223] = {.lex_state = 52, .external_lex_state = 10},
  [2224] = {.lex_state = 52, .external_lex_state = 11},
  [2225] = {.lex_state = 52, .external_lex_state = 10},
  [2226] = {.lex_state = 52, .external_lex_state = 11},
  [2227] = {.lex_state = 52, .external_lex_state = 12},
  [2228] = {.lex_state = 52, .external_lex_state = 12},
  [2229] = {.lex_state = 52, .external_lex_state = 11},
  [2230] = {.lex_state = 52, .external_lex_state = 12},
  [2231] = {.lex_state = 52, .external_lex_state = 12},
  [2232] = {.lex_state = 52, .external_lex_state = 12},
  [2233] = {.lex_state = 52, .external_lex_state = 11},
  [2234] = {.lex_state = 52, .external_lex_state = 12},
  [2235] = {.lex_state = 52, .external_lex_state = 12},
  [2236] = {.lex_state = 52, .external_lex_state = 11},
  [2237] = {.lex_state = 52, .external_lex_state = 12},
  [2238] = {.lex_state = 52, .external_lex_state = 10},
  [2239] = {.lex_state = 52, .external_lex_state = 10},
  [2240] = {.lex_state = 52, .external_lex_state = 13},
  [2241] = {.lex_state = 52, .external_lex_state = 12},
  [2242] = {.lex_state = 52, .external_lex_state = 12},
  [2243] = {.lex_state = 4, .external_lex_state = 12},
  [2244] = {.lex_state = 52, .external_lex_state = 10},
  [2245] = {.lex_state = 52, .external_lex_state = 12},
  [2246] = {.lex_state = 52, .external_lex_state = 12},
  [2247] = {.lex_state = 52, .external_lex_state = 10},
  [2248] = {.lex_state = 52, .external_lex_state = 12},
  [2249] = {.lex_state = 52, .external_lex_state = 10},
  [2250] = {.lex_state = 52, .external_lex_state = 12},
  [2251] = {.lex_state = 52, .external_lex_state = 12},
  [2252] = {.lex_state = 52, .external_lex_state = 13},
  [2253] = {.lex_state = 52, .external_lex_state = 12},
  [2254] = {.lex_state = 52, .external_lex_state = 12},
  [2255] = {.lex_state = 52, .external_lex_state = 13},
  [2256] = {.lex_state = 52, .external_lex_state = 12},
  [2257] = {.lex_state = 52, .external_lex_state = 12},
  [2258] = {.lex_state = 52, .external_lex_state = 11},
  [2259] = {.lex_state = 52, .external_lex_state = 11},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_eq] = ACTIONS(1),
    [anon_sym_ne] = ACTIONS(1),
    [anon_sym_contains] = ACTIONS(1),
    [anon_sym_fails] = ACTIONS(1),
    [anon_sym_assert_] = ACTIONS(1),
    [anon_sym_assert_eq] = ACTIONS(1),
    [anon_sym_assert_ne] = ACTIONS(1),
    [anon_sym_assert_contains] = ACTIONS(1),
    [anon_sym_assert_fails] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym__not_escape_sequence] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(5),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym_string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym_escape_interpolation] = ACTIONS(1),
    [sym_string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(2246),
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_if_statement] = STATE(44),
    [sym_match_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_exec_statement] = STATE(1820),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(1520),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(1520),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_match] = ACTIONS(33),
    [anon_sym_async] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(67),
  },
  [2] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(561),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [3] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(525),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [4] = {
    [sym__statement] = STATE(40),
    [sym__simple_statements] = STATE(40),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(40),
    [sym_match_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_with_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(40),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(2017),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(40),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(85),
    [sym_string_start] = ACTIONS(67),
  },
  [5] = {
    [sym__statement] = STATE(40),
    [sym__simple_statements] = STATE(40),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(40),
    [sym_match_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_with_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(40),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(2058),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(40),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(85),
    [sym_string_start] = ACTIONS(67),
  },
  [6] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(568),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [7] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(558),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [8] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(580),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [9] = {
    [sym__statement] = STATE(40),
    [sym__simple_statements] = STATE(40),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(40),
    [sym_match_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_with_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(40),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(2059),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(40),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(85),
    [sym_string_start] = ACTIONS(67),
  },
  [10] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(543),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [11] = {
    [sym__statement] = STATE(40),
    [sym__simple_statements] = STATE(40),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(40),
    [sym_match_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_with_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(40),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(2055),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(40),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(85),
    [sym_string_start] = ACTIONS(67),
  },
  [12] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(522),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [13] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(487),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [14] = {
    [sym__statement] = STATE(40),
    [sym__simple_statements] = STATE(40),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(40),
    [sym_match_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_with_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(40),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(2034),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(40),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(85),
    [sym_string_start] = ACTIONS(67),
  },
  [15] = {
    [sym__statement] = STATE(40),
    [sym__simple_statements] = STATE(40),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(40),
    [sym_match_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_with_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(40),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(2015),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(40),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(85),
    [sym_string_start] = ACTIONS(67),
  },
  [16] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(496),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [17] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(555),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [18] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(456),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [19] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(547),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [20] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(499),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [21] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(484),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [22] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(550),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [23] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(503),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [24] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(552),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [25] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(546),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [26] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(521),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [27] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(584),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [28] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(485),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [29] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(481),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [30] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(591),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [31] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(471),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [32] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(517),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [33] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(534),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [34] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(578),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [35] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(575),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [36] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(599),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [37] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(582),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [38] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(45),
    [sym_match_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(594),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(87),
    [sym_string_start] = ACTIONS(67),
  },
  [39] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(43),
    [sym_match_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(1547),
    [sym_block] = STATE(491),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(83),
    [sym_string_start] = ACTIONS(67),
  },
  [40] = {
    [sym__statement] = STATE(42),
    [sym__simple_statements] = STATE(42),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(42),
    [sym_match_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_with_statement] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(42),
    [sym_decorator] = STATE(1547),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(42),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(89),
    [sym_string_start] = ACTIONS(67),
  },
  [41] = {
    [sym__statement] = STATE(41),
    [sym__simple_statements] = STATE(41),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_if_statement] = STATE(41),
    [sym_match_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_with_statement] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_exec_statement] = STATE(1820),
    [sym_decorated_definition] = STATE(41),
    [sym_decorator] = STATE(1520),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(41),
    [aux_sym_decorated_definition_repeat1] = STATE(1520),
    [ts_builtin_sym_end] = ACTIONS(91),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(96),
    [anon_sym_STAR] = ACTIONS(99),
    [anon_sym_print] = ACTIONS(102),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_assert_] = ACTIONS(108),
    [anon_sym_assert_eq] = ACTIONS(108),
    [anon_sym_assert_ne] = ACTIONS(108),
    [anon_sym_assert_contains] = ACTIONS(108),
    [anon_sym_assert_fails] = ACTIONS(108),
    [anon_sym_return] = ACTIONS(111),
    [anon_sym_del] = ACTIONS(114),
    [anon_sym_pass] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(120),
    [anon_sym_continue] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(126),
    [anon_sym_match] = ACTIONS(129),
    [anon_sym_async] = ACTIONS(132),
    [anon_sym_for] = ACTIONS(135),
    [anon_sym_while] = ACTIONS(138),
    [anon_sym_with] = ACTIONS(141),
    [anon_sym_def] = ACTIONS(144),
    [anon_sym_exec] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(156),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(159),
    [anon_sym_not] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_lambda] = ACTIONS(168),
    [sym_ellipsis] = ACTIONS(171),
    [sym_integer] = ACTIONS(174),
    [sym_float] = ACTIONS(171),
    [anon_sym_await] = ACTIONS(177),
    [anon_sym_struct] = ACTIONS(177),
    [sym_true] = ACTIONS(174),
    [sym_false] = ACTIONS(174),
    [sym_none] = ACTIONS(174),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(180),
  },
  [42] = {
    [sym__statement] = STATE(42),
    [sym__simple_statements] = STATE(42),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(42),
    [sym_match_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_with_statement] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(42),
    [sym_decorator] = STATE(1547),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(42),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(96),
    [anon_sym_STAR] = ACTIONS(99),
    [anon_sym_print] = ACTIONS(102),
    [anon_sym_assert] = ACTIONS(105),
    [anon_sym_assert_] = ACTIONS(108),
    [anon_sym_assert_eq] = ACTIONS(108),
    [anon_sym_assert_ne] = ACTIONS(108),
    [anon_sym_assert_contains] = ACTIONS(108),
    [anon_sym_assert_fails] = ACTIONS(108),
    [anon_sym_return] = ACTIONS(111),
    [anon_sym_del] = ACTIONS(114),
    [anon_sym_pass] = ACTIONS(117),
    [anon_sym_break] = ACTIONS(120),
    [anon_sym_continue] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(183),
    [anon_sym_match] = ACTIONS(186),
    [anon_sym_async] = ACTIONS(189),
    [anon_sym_for] = ACTIONS(192),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_with] = ACTIONS(198),
    [anon_sym_def] = ACTIONS(201),
    [anon_sym_exec] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(150),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_AT] = ACTIONS(156),
    [anon_sym_DASH] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(162),
    [anon_sym_PLUS] = ACTIONS(159),
    [anon_sym_not] = ACTIONS(165),
    [anon_sym_TILDE] = ACTIONS(159),
    [anon_sym_lambda] = ACTIONS(168),
    [sym_ellipsis] = ACTIONS(171),
    [sym_integer] = ACTIONS(174),
    [sym_float] = ACTIONS(171),
    [anon_sym_await] = ACTIONS(177),
    [anon_sym_struct] = ACTIONS(177),
    [sym_true] = ACTIONS(174),
    [sym_false] = ACTIONS(174),
    [sym_none] = ACTIONS(174),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym_string_start] = ACTIONS(180),
  },
  [43] = {
    [sym__statement] = STATE(42),
    [sym__simple_statements] = STATE(42),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(42),
    [sym_match_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_with_statement] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(42),
    [sym_decorator] = STATE(1547),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(42),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(204),
    [sym_string_start] = ACTIONS(67),
  },
  [44] = {
    [sym__statement] = STATE(41),
    [sym__simple_statements] = STATE(41),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_if_statement] = STATE(41),
    [sym_match_statement] = STATE(41),
    [sym_for_statement] = STATE(41),
    [sym_while_statement] = STATE(41),
    [sym_with_statement] = STATE(41),
    [sym_function_definition] = STATE(41),
    [sym_exec_statement] = STATE(1820),
    [sym_decorated_definition] = STATE(41),
    [sym_decorator] = STATE(1520),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(41),
    [aux_sym_decorated_definition_repeat1] = STATE(1520),
    [ts_builtin_sym_end] = ACTIONS(206),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_match] = ACTIONS(33),
    [anon_sym_async] = ACTIONS(35),
    [anon_sym_for] = ACTIONS(37),
    [anon_sym_while] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(67),
  },
  [45] = {
    [sym__statement] = STATE(42),
    [sym__simple_statements] = STATE(42),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_if_statement] = STATE(42),
    [sym_match_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_with_statement] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_exec_statement] = STATE(2008),
    [sym_decorated_definition] = STATE(42),
    [sym_decorator] = STATE(1547),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [aux_sym_module_repeat1] = STATE(42),
    [aux_sym_decorated_definition_repeat1] = STATE(1547),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(69),
    [anon_sym_match] = ACTIONS(71),
    [anon_sym_async] = ACTIONS(73),
    [anon_sym_for] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_with] = ACTIONS(79),
    [anon_sym_def] = ACTIONS(81),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_AT] = ACTIONS(51),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__dedent] = ACTIONS(208),
    [sym_string_start] = ACTIONS(67),
  },
  [46] = {
    [sym_chevron] = STATE(1722),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_list_splat_pattern] = STATE(809),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1401),
    [sym_primary_expression] = STATE(703),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_attribute] = STATE(899),
    [sym_subscript] = STATE(899),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(212),
    [anon_sym_DOT] = ACTIONS(214),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_COMMA] = ACTIONS(219),
    [anon_sym_as] = ACTIONS(214),
    [anon_sym_STAR] = ACTIONS(222),
    [anon_sym_print] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(214),
    [anon_sym_COLON] = ACTIONS(231),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_async] = ACTIONS(225),
    [anon_sym_in] = ACTIONS(214),
    [anon_sym_STAR_STAR] = ACTIONS(214),
    [anon_sym_exec] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(234),
    [anon_sym_EQ] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_AT] = ACTIONS(214),
    [anon_sym_DASH] = ACTIONS(241),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(241),
    [anon_sym_not] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(214),
    [anon_sym_or] = ACTIONS(214),
    [anon_sym_SLASH] = ACTIONS(214),
    [anon_sym_PERCENT] = ACTIONS(214),
    [anon_sym_SLASH_SLASH] = ACTIONS(214),
    [anon_sym_AMP] = ACTIONS(214),
    [anon_sym_CARET] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(214),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_LT_EQ] = ACTIONS(212),
    [anon_sym_EQ_EQ] = ACTIONS(212),
    [anon_sym_BANG_EQ] = ACTIONS(212),
    [anon_sym_GT_EQ] = ACTIONS(212),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_LT_GT] = ACTIONS(212),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(247),
    [anon_sym_DASH_EQ] = ACTIONS(247),
    [anon_sym_STAR_EQ] = ACTIONS(247),
    [anon_sym_SLASH_EQ] = ACTIONS(247),
    [anon_sym_AT_EQ] = ACTIONS(247),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(247),
    [anon_sym_PERCENT_EQ] = ACTIONS(247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(247),
    [anon_sym_GT_GT_EQ] = ACTIONS(247),
    [anon_sym_LT_LT_EQ] = ACTIONS(247),
    [anon_sym_AMP_EQ] = ACTIONS(247),
    [anon_sym_CARET_EQ] = ACTIONS(247),
    [anon_sym_PIPE_EQ] = ACTIONS(247),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(225),
    [anon_sym_struct] = ACTIONS(225),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(212),
    [sym_string_start] = ACTIONS(67),
  },
  [47] = {
    [sym_chevron] = STATE(1722),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_list_splat_pattern] = STATE(809),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1401),
    [sym_primary_expression] = STATE(703),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_attribute] = STATE(899),
    [sym_subscript] = STATE(899),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(210),
    [anon_sym_SEMI] = ACTIONS(212),
    [anon_sym_DOT] = ACTIONS(214),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_COMMA] = ACTIONS(219),
    [anon_sym_as] = ACTIONS(214),
    [anon_sym_STAR] = ACTIONS(222),
    [anon_sym_print] = ACTIONS(225),
    [anon_sym_GT_GT] = ACTIONS(227),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(214),
    [anon_sym_COLON] = ACTIONS(236),
    [anon_sym_match] = ACTIONS(225),
    [anon_sym_async] = ACTIONS(225),
    [anon_sym_in] = ACTIONS(214),
    [anon_sym_STAR_STAR] = ACTIONS(214),
    [anon_sym_exec] = ACTIONS(225),
    [anon_sym_type] = ACTIONS(234),
    [anon_sym_EQ] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(238),
    [anon_sym_AT] = ACTIONS(214),
    [anon_sym_DASH] = ACTIONS(241),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(241),
    [anon_sym_not] = ACTIONS(244),
    [anon_sym_and] = ACTIONS(214),
    [anon_sym_or] = ACTIONS(214),
    [anon_sym_SLASH] = ACTIONS(214),
    [anon_sym_PERCENT] = ACTIONS(214),
    [anon_sym_SLASH_SLASH] = ACTIONS(214),
    [anon_sym_AMP] = ACTIONS(214),
    [anon_sym_CARET] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(214),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_LT_EQ] = ACTIONS(212),
    [anon_sym_EQ_EQ] = ACTIONS(212),
    [anon_sym_BANG_EQ] = ACTIONS(212),
    [anon_sym_GT_EQ] = ACTIONS(212),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_LT_GT] = ACTIONS(212),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(247),
    [anon_sym_DASH_EQ] = ACTIONS(247),
    [anon_sym_STAR_EQ] = ACTIONS(247),
    [anon_sym_SLASH_EQ] = ACTIONS(247),
    [anon_sym_AT_EQ] = ACTIONS(247),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(247),
    [anon_sym_PERCENT_EQ] = ACTIONS(247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(247),
    [anon_sym_GT_GT_EQ] = ACTIONS(247),
    [anon_sym_LT_LT_EQ] = ACTIONS(247),
    [anon_sym_AMP_EQ] = ACTIONS(247),
    [anon_sym_CARET_EQ] = ACTIONS(247),
    [anon_sym_PIPE_EQ] = ACTIONS(247),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(225),
    [anon_sym_struct] = ACTIONS(225),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(212),
    [sym_string_start] = ACTIONS(67),
  },
  [48] = {
    [sym_named_expression] = STATE(1349),
    [sym__named_expression_lhs] = STATE(2200),
    [sym_list_splat_pattern] = STATE(926),
    [sym_as_pattern] = STATE(1349),
    [sym_expression] = STATE(1484),
    [sym_primary_expression] = STATE(740),
    [sym_not_operator] = STATE(1349),
    [sym_boolean_operator] = STATE(1349),
    [sym_binary_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [sym_comparison_operator] = STATE(1349),
    [sym_lambda] = STATE(1349),
    [sym_attribute] = STATE(996),
    [sym_subscript] = STATE(996),
    [sym_call] = STATE(996),
    [sym_list] = STATE(996),
    [sym_set] = STATE(996),
    [sym_tuple] = STATE(996),
    [sym_dictionary] = STATE(996),
    [sym_list_comprehension] = STATE(996),
    [sym_dictionary_comprehension] = STATE(996),
    [sym_set_comprehension] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym_conditional_expression] = STATE(1349),
    [sym_string] = STATE(996),
    [sym_identifier] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(212),
    [anon_sym_DOT] = ACTIONS(214),
    [anon_sym_LPAREN] = ACTIONS(251),
    [anon_sym_COMMA] = ACTIONS(219),
    [anon_sym_as] = ACTIONS(214),
    [anon_sym_STAR] = ACTIONS(253),
    [anon_sym_print] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(214),
    [anon_sym_COLON] = ACTIONS(236),
    [anon_sym_match] = ACTIONS(255),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_in] = ACTIONS(214),
    [anon_sym_STAR_STAR] = ACTIONS(214),
    [anon_sym_exec] = ACTIONS(255),
    [anon_sym_type] = ACTIONS(257),
    [anon_sym_EQ] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(259),
    [anon_sym_AT] = ACTIONS(214),
    [anon_sym_DASH] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(214),
    [anon_sym_or] = ACTIONS(214),
    [anon_sym_SLASH] = ACTIONS(214),
    [anon_sym_PERCENT] = ACTIONS(214),
    [anon_sym_SLASH_SLASH] = ACTIONS(214),
    [anon_sym_AMP] = ACTIONS(214),
    [anon_sym_CARET] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(214),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_LT_EQ] = ACTIONS(212),
    [anon_sym_EQ_EQ] = ACTIONS(212),
    [anon_sym_BANG_EQ] = ACTIONS(212),
    [anon_sym_GT_EQ] = ACTIONS(212),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_LT_GT] = ACTIONS(212),
    [anon_sym_lambda] = ACTIONS(269),
    [anon_sym_PLUS_EQ] = ACTIONS(247),
    [anon_sym_DASH_EQ] = ACTIONS(247),
    [anon_sym_STAR_EQ] = ACTIONS(247),
    [anon_sym_SLASH_EQ] = ACTIONS(247),
    [anon_sym_AT_EQ] = ACTIONS(247),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(247),
    [anon_sym_PERCENT_EQ] = ACTIONS(247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(247),
    [anon_sym_GT_GT_EQ] = ACTIONS(247),
    [anon_sym_LT_LT_EQ] = ACTIONS(247),
    [anon_sym_AMP_EQ] = ACTIONS(247),
    [anon_sym_CARET_EQ] = ACTIONS(247),
    [anon_sym_PIPE_EQ] = ACTIONS(247),
    [sym_ellipsis] = ACTIONS(271),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(271),
    [anon_sym_await] = ACTIONS(255),
    [anon_sym_struct] = ACTIONS(255),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(212),
    [sym_string_start] = ACTIONS(275),
  },
  [49] = {
    [sym_named_expression] = STATE(1349),
    [sym__named_expression_lhs] = STATE(2200),
    [sym_list_splat_pattern] = STATE(926),
    [sym_as_pattern] = STATE(1349),
    [sym_expression] = STATE(1448),
    [sym_primary_expression] = STATE(740),
    [sym_not_operator] = STATE(1349),
    [sym_boolean_operator] = STATE(1349),
    [sym_binary_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [sym_comparison_operator] = STATE(1349),
    [sym_lambda] = STATE(1349),
    [sym_attribute] = STATE(996),
    [sym_subscript] = STATE(996),
    [sym_call] = STATE(996),
    [sym_list] = STATE(996),
    [sym_set] = STATE(996),
    [sym_tuple] = STATE(996),
    [sym_dictionary] = STATE(996),
    [sym_list_comprehension] = STATE(996),
    [sym_dictionary_comprehension] = STATE(996),
    [sym_set_comprehension] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym_conditional_expression] = STATE(1349),
    [sym_string] = STATE(996),
    [sym_identifier] = ACTIONS(249),
    [anon_sym_SEMI] = ACTIONS(212),
    [anon_sym_DOT] = ACTIONS(214),
    [anon_sym_LPAREN] = ACTIONS(251),
    [anon_sym_COMMA] = ACTIONS(219),
    [anon_sym_as] = ACTIONS(214),
    [anon_sym_STAR] = ACTIONS(253),
    [anon_sym_print] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(214),
    [anon_sym_COLON_EQ] = ACTIONS(229),
    [anon_sym_if] = ACTIONS(214),
    [anon_sym_COLON] = ACTIONS(236),
    [anon_sym_match] = ACTIONS(255),
    [anon_sym_async] = ACTIONS(255),
    [anon_sym_in] = ACTIONS(214),
    [anon_sym_STAR_STAR] = ACTIONS(214),
    [anon_sym_exec] = ACTIONS(255),
    [anon_sym_type] = ACTIONS(257),
    [anon_sym_EQ] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(259),
    [anon_sym_AT] = ACTIONS(214),
    [anon_sym_DASH] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(265),
    [anon_sym_and] = ACTIONS(214),
    [anon_sym_or] = ACTIONS(214),
    [anon_sym_SLASH] = ACTIONS(214),
    [anon_sym_PERCENT] = ACTIONS(214),
    [anon_sym_SLASH_SLASH] = ACTIONS(214),
    [anon_sym_AMP] = ACTIONS(214),
    [anon_sym_CARET] = ACTIONS(214),
    [anon_sym_LT_LT] = ACTIONS(214),
    [anon_sym_TILDE] = ACTIONS(267),
    [anon_sym_LT] = ACTIONS(214),
    [anon_sym_LT_EQ] = ACTIONS(212),
    [anon_sym_EQ_EQ] = ACTIONS(212),
    [anon_sym_BANG_EQ] = ACTIONS(212),
    [anon_sym_GT_EQ] = ACTIONS(212),
    [anon_sym_GT] = ACTIONS(214),
    [anon_sym_LT_GT] = ACTIONS(212),
    [anon_sym_lambda] = ACTIONS(269),
    [anon_sym_PLUS_EQ] = ACTIONS(247),
    [anon_sym_DASH_EQ] = ACTIONS(247),
    [anon_sym_STAR_EQ] = ACTIONS(247),
    [anon_sym_SLASH_EQ] = ACTIONS(247),
    [anon_sym_AT_EQ] = ACTIONS(247),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(247),
    [anon_sym_PERCENT_EQ] = ACTIONS(247),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(247),
    [anon_sym_GT_GT_EQ] = ACTIONS(247),
    [anon_sym_LT_LT_EQ] = ACTIONS(247),
    [anon_sym_AMP_EQ] = ACTIONS(247),
    [anon_sym_CARET_EQ] = ACTIONS(247),
    [anon_sym_PIPE_EQ] = ACTIONS(247),
    [sym_ellipsis] = ACTIONS(271),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(271),
    [anon_sym_await] = ACTIONS(255),
    [anon_sym_struct] = ACTIONS(255),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(212),
    [sym_string_start] = ACTIONS(275),
  },
  [50] = {
    [sym__simple_statements] = STATE(523),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(458),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1300),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(457),
    [sym_subscript] = STATE(457),
    [sym_call] = STATE(899),
    [sym_type] = STATE(1630),
    [sym_splat_type] = STATE(1609),
    [sym_generic_type] = STATE(1609),
    [sym_union_type] = STATE(1609),
    [sym_constrained_type] = STATE(1609),
    [sym_member_type] = STATE(1609),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(281),
    [anon_sym_print] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_STAR_STAR] = ACTIONS(287),
    [anon_sym_exec] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(285),
    [anon_sym_struct] = ACTIONS(285),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(295),
    [sym__indent] = ACTIONS(297),
    [sym_string_start] = ACTIONS(67),
  },
  [51] = {
    [sym__simple_statements] = STATE(565),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(458),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1300),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(457),
    [sym_subscript] = STATE(457),
    [sym_call] = STATE(899),
    [sym_type] = STATE(1630),
    [sym_splat_type] = STATE(1609),
    [sym_generic_type] = STATE(1609),
    [sym_union_type] = STATE(1609),
    [sym_constrained_type] = STATE(1609),
    [sym_member_type] = STATE(1609),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(281),
    [anon_sym_print] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_STAR_STAR] = ACTIONS(287),
    [anon_sym_exec] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(285),
    [anon_sym_struct] = ACTIONS(285),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(299),
    [sym__indent] = ACTIONS(301),
    [sym_string_start] = ACTIONS(67),
  },
  [52] = {
    [sym__simple_statements] = STATE(530),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(458),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1300),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(457),
    [sym_subscript] = STATE(457),
    [sym_call] = STATE(899),
    [sym_type] = STATE(1630),
    [sym_splat_type] = STATE(1609),
    [sym_generic_type] = STATE(1609),
    [sym_union_type] = STATE(1609),
    [sym_constrained_type] = STATE(1609),
    [sym_member_type] = STATE(1609),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(281),
    [anon_sym_print] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_STAR_STAR] = ACTIONS(287),
    [anon_sym_exec] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(285),
    [anon_sym_struct] = ACTIONS(285),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(303),
    [sym__indent] = ACTIONS(305),
    [sym_string_start] = ACTIONS(67),
  },
  [53] = {
    [sym__simple_statements] = STATE(556),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(458),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1300),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(457),
    [sym_subscript] = STATE(457),
    [sym_call] = STATE(899),
    [sym_type] = STATE(1630),
    [sym_splat_type] = STATE(1609),
    [sym_generic_type] = STATE(1609),
    [sym_union_type] = STATE(1609),
    [sym_constrained_type] = STATE(1609),
    [sym_member_type] = STATE(1609),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(281),
    [anon_sym_print] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_STAR_STAR] = ACTIONS(287),
    [anon_sym_exec] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(285),
    [anon_sym_struct] = ACTIONS(285),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(307),
    [sym__indent] = ACTIONS(309),
    [sym_string_start] = ACTIONS(67),
  },
  [54] = {
    [sym__simple_statements] = STATE(590),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(458),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1300),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(457),
    [sym_subscript] = STATE(457),
    [sym_call] = STATE(899),
    [sym_type] = STATE(1630),
    [sym_splat_type] = STATE(1609),
    [sym_generic_type] = STATE(1609),
    [sym_union_type] = STATE(1609),
    [sym_constrained_type] = STATE(1609),
    [sym_member_type] = STATE(1609),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(281),
    [anon_sym_print] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_STAR_STAR] = ACTIONS(287),
    [anon_sym_exec] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(285),
    [anon_sym_struct] = ACTIONS(285),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(311),
    [sym__indent] = ACTIONS(313),
    [sym_string_start] = ACTIONS(67),
  },
  [55] = {
    [sym__simple_statements] = STATE(544),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(458),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1300),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(457),
    [sym_subscript] = STATE(457),
    [sym_call] = STATE(899),
    [sym_type] = STATE(1630),
    [sym_splat_type] = STATE(1609),
    [sym_generic_type] = STATE(1609),
    [sym_union_type] = STATE(1609),
    [sym_constrained_type] = STATE(1609),
    [sym_member_type] = STATE(1609),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(281),
    [anon_sym_print] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_STAR_STAR] = ACTIONS(287),
    [anon_sym_exec] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(285),
    [anon_sym_struct] = ACTIONS(285),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(315),
    [sym__indent] = ACTIONS(317),
    [sym_string_start] = ACTIONS(67),
  },
  [56] = {
    [sym__simple_statements] = STATE(581),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(458),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1300),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(457),
    [sym_subscript] = STATE(457),
    [sym_call] = STATE(899),
    [sym_type] = STATE(1630),
    [sym_splat_type] = STATE(1609),
    [sym_generic_type] = STATE(1609),
    [sym_union_type] = STATE(1609),
    [sym_constrained_type] = STATE(1609),
    [sym_member_type] = STATE(1609),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(281),
    [anon_sym_print] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_STAR_STAR] = ACTIONS(287),
    [anon_sym_exec] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(285),
    [anon_sym_struct] = ACTIONS(285),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(319),
    [sym__indent] = ACTIONS(321),
    [sym_string_start] = ACTIONS(67),
  },
  [57] = {
    [sym__simple_statements] = STATE(571),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(458),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1300),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(457),
    [sym_subscript] = STATE(457),
    [sym_call] = STATE(899),
    [sym_type] = STATE(1630),
    [sym_splat_type] = STATE(1609),
    [sym_generic_type] = STATE(1609),
    [sym_union_type] = STATE(1609),
    [sym_constrained_type] = STATE(1609),
    [sym_member_type] = STATE(1609),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(277),
    [anon_sym_LPAREN] = ACTIONS(279),
    [anon_sym_STAR] = ACTIONS(281),
    [anon_sym_print] = ACTIONS(283),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(285),
    [anon_sym_async] = ACTIONS(285),
    [anon_sym_STAR_STAR] = ACTIONS(287),
    [anon_sym_exec] = ACTIONS(289),
    [anon_sym_type] = ACTIONS(291),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(285),
    [anon_sym_struct] = ACTIONS(285),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(323),
    [sym__indent] = ACTIONS(325),
    [sym_string_start] = ACTIONS(67),
  },
  [58] = {
    [sym__simple_statements] = STATE(526),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(327),
    [sym__indent] = ACTIONS(329),
    [sym_string_start] = ACTIONS(67),
  },
  [59] = {
    [sym__simple_statements] = STATE(2056),
    [sym_print_statement] = STATE(1809),
    [sym_assert_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1809),
    [sym_delete_statement] = STATE(1809),
    [sym_pass_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_exec_statement] = STATE(1809),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(331),
    [sym__indent] = ACTIONS(333),
    [sym_string_start] = ACTIONS(67),
  },
  [60] = {
    [sym__simple_statements] = STATE(497),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(335),
    [sym__indent] = ACTIONS(337),
    [sym_string_start] = ACTIONS(67),
  },
  [61] = {
    [sym__simple_statements] = STATE(535),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(339),
    [sym__indent] = ACTIONS(341),
    [sym_string_start] = ACTIONS(67),
  },
  [62] = {
    [sym__simple_statements] = STATE(560),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(343),
    [sym__indent] = ACTIONS(345),
    [sym_string_start] = ACTIONS(67),
  },
  [63] = {
    [sym__simple_statements] = STATE(2036),
    [sym_print_statement] = STATE(1809),
    [sym_assert_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1809),
    [sym_delete_statement] = STATE(1809),
    [sym_pass_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_exec_statement] = STATE(1809),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(347),
    [sym__indent] = ACTIONS(349),
    [sym_string_start] = ACTIONS(67),
  },
  [64] = {
    [sym__simple_statements] = STATE(506),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(351),
    [sym__indent] = ACTIONS(353),
    [sym_string_start] = ACTIONS(67),
  },
  [65] = {
    [sym__simple_statements] = STATE(2027),
    [sym_print_statement] = STATE(1809),
    [sym_assert_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1809),
    [sym_delete_statement] = STATE(1809),
    [sym_pass_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_exec_statement] = STATE(1809),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(355),
    [sym__indent] = ACTIONS(357),
    [sym_string_start] = ACTIONS(67),
  },
  [66] = {
    [sym__simple_statements] = STATE(589),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(359),
    [sym__indent] = ACTIONS(361),
    [sym_string_start] = ACTIONS(67),
  },
  [67] = {
    [sym__simple_statements] = STATE(2088),
    [sym_print_statement] = STATE(1809),
    [sym_assert_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1809),
    [sym_delete_statement] = STATE(1809),
    [sym_pass_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_exec_statement] = STATE(1809),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(363),
    [sym__indent] = ACTIONS(365),
    [sym_string_start] = ACTIONS(67),
  },
  [68] = {
    [sym__simple_statements] = STATE(531),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(367),
    [sym__indent] = ACTIONS(369),
    [sym_string_start] = ACTIONS(67),
  },
  [69] = {
    [sym__simple_statements] = STATE(477),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(371),
    [sym__indent] = ACTIONS(373),
    [sym_string_start] = ACTIONS(67),
  },
  [70] = {
    [sym__simple_statements] = STATE(536),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(375),
    [sym__indent] = ACTIONS(377),
    [sym_string_start] = ACTIONS(67),
  },
  [71] = {
    [sym__simple_statements] = STATE(513),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(379),
    [sym__indent] = ACTIONS(381),
    [sym_string_start] = ACTIONS(67),
  },
  [72] = {
    [sym__simple_statements] = STATE(509),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(383),
    [sym__indent] = ACTIONS(385),
    [sym_string_start] = ACTIONS(67),
  },
  [73] = {
    [sym__simple_statements] = STATE(567),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(387),
    [sym__indent] = ACTIONS(389),
    [sym_string_start] = ACTIONS(67),
  },
  [74] = {
    [sym__simple_statements] = STATE(482),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(391),
    [sym__indent] = ACTIONS(393),
    [sym_string_start] = ACTIONS(67),
  },
  [75] = {
    [sym__simple_statements] = STATE(577),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(395),
    [sym__indent] = ACTIONS(397),
    [sym_string_start] = ACTIONS(67),
  },
  [76] = {
    [sym__simple_statements] = STATE(467),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(399),
    [sym__indent] = ACTIONS(401),
    [sym_string_start] = ACTIONS(67),
  },
  [77] = {
    [sym__simple_statements] = STATE(489),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(403),
    [sym__indent] = ACTIONS(405),
    [sym_string_start] = ACTIONS(67),
  },
  [78] = {
    [sym__simple_statements] = STATE(452),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(407),
    [sym__indent] = ACTIONS(409),
    [sym_string_start] = ACTIONS(67),
  },
  [79] = {
    [sym__simple_statements] = STATE(479),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(411),
    [sym__indent] = ACTIONS(413),
    [sym_string_start] = ACTIONS(67),
  },
  [80] = {
    [sym__simple_statements] = STATE(478),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(415),
    [sym__indent] = ACTIONS(417),
    [sym_string_start] = ACTIONS(67),
  },
  [81] = {
    [sym__simple_statements] = STATE(493),
    [sym_print_statement] = STATE(2008),
    [sym_assert_statement] = STATE(2008),
    [sym_expression_statement] = STATE(2008),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2008),
    [sym_delete_statement] = STATE(2008),
    [sym_pass_statement] = STATE(2008),
    [sym_break_statement] = STATE(2008),
    [sym_continue_statement] = STATE(2008),
    [sym_exec_statement] = STATE(2008),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(419),
    [sym__indent] = ACTIONS(421),
    [sym_string_start] = ACTIONS(67),
  },
  [82] = {
    [sym__simple_statements] = STATE(549),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(423),
    [sym__indent] = ACTIONS(425),
    [sym_string_start] = ACTIONS(67),
  },
  [83] = {
    [sym__simple_statements] = STATE(2054),
    [sym_print_statement] = STATE(1809),
    [sym_assert_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1809),
    [sym_delete_statement] = STATE(1809),
    [sym_pass_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_exec_statement] = STATE(1809),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(427),
    [sym__indent] = ACTIONS(429),
    [sym_string_start] = ACTIONS(67),
  },
  [84] = {
    [sym__simple_statements] = STATE(2016),
    [sym_print_statement] = STATE(1809),
    [sym_assert_statement] = STATE(1809),
    [sym_expression_statement] = STATE(1809),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1809),
    [sym_delete_statement] = STATE(1809),
    [sym_pass_statement] = STATE(1809),
    [sym_break_statement] = STATE(1809),
    [sym_continue_statement] = STATE(1809),
    [sym_exec_statement] = STATE(1809),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(431),
    [sym__indent] = ACTIONS(433),
    [sym_string_start] = ACTIONS(67),
  },
  [85] = {
    [sym__simple_statements] = STATE(572),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(435),
    [sym__indent] = ACTIONS(437),
    [sym_string_start] = ACTIONS(67),
  },
  [86] = {
    [sym__simple_statements] = STATE(500),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(439),
    [sym__indent] = ACTIONS(441),
    [sym_string_start] = ACTIONS(67),
  },
  [87] = {
    [sym__simple_statements] = STATE(518),
    [sym_print_statement] = STATE(1820),
    [sym_assert_statement] = STATE(1820),
    [sym_expression_statement] = STATE(1820),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(1820),
    [sym_delete_statement] = STATE(1820),
    [sym_pass_statement] = STATE(1820),
    [sym_break_statement] = STATE(1820),
    [sym_continue_statement] = STATE(1820),
    [sym_exec_statement] = STATE(1820),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(443),
    [sym__indent] = ACTIONS(445),
    [sym_string_start] = ACTIONS(67),
  },
  [88] = {
    [sym_print_statement] = STATE(2041),
    [sym_assert_statement] = STATE(2041),
    [sym_expression_statement] = STATE(2041),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2041),
    [sym_delete_statement] = STATE(2041),
    [sym_pass_statement] = STATE(2041),
    [sym_break_statement] = STATE(2041),
    [sym_continue_statement] = STATE(2041),
    [sym_exec_statement] = STATE(2041),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(447),
    [sym_string_start] = ACTIONS(67),
  },
  [89] = {
    [sym_print_statement] = STATE(2041),
    [sym_assert_statement] = STATE(2041),
    [sym_expression_statement] = STATE(2041),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2041),
    [sym_delete_statement] = STATE(2041),
    [sym_pass_statement] = STATE(2041),
    [sym_break_statement] = STATE(2041),
    [sym_continue_statement] = STATE(2041),
    [sym_exec_statement] = STATE(2041),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(449),
    [sym_string_start] = ACTIONS(67),
  },
  [90] = {
    [sym_print_statement] = STATE(2041),
    [sym_assert_statement] = STATE(2041),
    [sym_expression_statement] = STATE(2041),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2041),
    [sym_delete_statement] = STATE(2041),
    [sym_pass_statement] = STATE(2041),
    [sym_break_statement] = STATE(2041),
    [sym_continue_statement] = STATE(2041),
    [sym_exec_statement] = STATE(2041),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(451),
    [sym_string_start] = ACTIONS(67),
  },
  [91] = {
    [sym_print_statement] = STATE(2041),
    [sym_assert_statement] = STATE(2041),
    [sym_expression_statement] = STATE(2041),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2041),
    [sym_delete_statement] = STATE(2041),
    [sym_pass_statement] = STATE(2041),
    [sym_break_statement] = STATE(2041),
    [sym_continue_statement] = STATE(2041),
    [sym_exec_statement] = STATE(2041),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(453),
    [sym_string_start] = ACTIONS(67),
  },
  [92] = {
    [sym_print_statement] = STATE(2041),
    [sym_assert_statement] = STATE(2041),
    [sym_expression_statement] = STATE(2041),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2041),
    [sym_delete_statement] = STATE(2041),
    [sym_pass_statement] = STATE(2041),
    [sym_break_statement] = STATE(2041),
    [sym_continue_statement] = STATE(2041),
    [sym_exec_statement] = STATE(2041),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(455),
    [sym_string_start] = ACTIONS(67),
  },
  [93] = {
    [sym_print_statement] = STATE(2041),
    [sym_assert_statement] = STATE(2041),
    [sym_expression_statement] = STATE(2041),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2041),
    [sym_delete_statement] = STATE(2041),
    [sym_pass_statement] = STATE(2041),
    [sym_break_statement] = STATE(2041),
    [sym_continue_statement] = STATE(2041),
    [sym_exec_statement] = STATE(2041),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym__newline] = ACTIONS(457),
    [sym_string_start] = ACTIONS(67),
  },
  [94] = {
    [sym_print_statement] = STATE(2041),
    [sym_assert_statement] = STATE(2041),
    [sym_expression_statement] = STATE(2041),
    [sym_named_expression] = STATE(1301),
    [sym__named_expression_lhs] = STATE(2243),
    [sym_return_statement] = STATE(2041),
    [sym_delete_statement] = STATE(2041),
    [sym_pass_statement] = STATE(2041),
    [sym_break_statement] = STATE(2041),
    [sym_continue_statement] = STATE(2041),
    [sym_exec_statement] = STATE(2041),
    [sym_pattern] = STATE(1263),
    [sym_tuple_pattern] = STATE(1265),
    [sym_list_pattern] = STATE(1265),
    [sym_list_splat_pattern] = STATE(459),
    [sym_as_pattern] = STATE(1301),
    [sym_expression] = STATE(1421),
    [sym_primary_expression] = STATE(748),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(899),
    [sym_unary_operator] = STATE(899),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_assignment] = STATE(2089),
    [sym_augmented_assignment] = STATE(2089),
    [sym_pattern_list] = STATE(1289),
    [sym_attribute] = STATE(450),
    [sym_subscript] = STATE(450),
    [sym_call] = STATE(899),
    [sym_list] = STATE(899),
    [sym_set] = STATE(899),
    [sym_tuple] = STATE(899),
    [sym_dictionary] = STATE(899),
    [sym_list_comprehension] = STATE(899),
    [sym_dictionary_comprehension] = STATE(899),
    [sym_set_comprehension] = STATE(899),
    [sym_parenthesized_expression] = STATE(899),
    [sym_conditional_expression] = STATE(1301),
    [sym_string] = STATE(899),
    [sym_identifier] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_assert_] = ACTIONS(19),
    [anon_sym_assert_eq] = ACTIONS(19),
    [anon_sym_assert_ne] = ACTIONS(19),
    [anon_sym_assert_contains] = ACTIONS(19),
    [anon_sym_assert_fails] = ACTIONS(19),
    [anon_sym_return] = ACTIONS(21),
    [anon_sym_del] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_match] = ACTIONS(65),
    [anon_sym_async] = ACTIONS(65),
    [anon_sym_exec] = ACTIONS(45),
    [anon_sym_type] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(49),
    [anon_sym_DASH] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(53),
    [anon_sym_lambda] = ACTIONS(59),
    [sym_ellipsis] = ACTIONS(61),
    [sym_integer] = ACTIONS(63),
    [sym_float] = ACTIONS(61),
    [anon_sym_await] = ACTIONS(65),
    [anon_sym_struct] = ACTIONS(65),
    [sym_true] = ACTIONS(63),
    [sym_false] = ACTIONS(63),
    [sym_none] = ACTIONS(63),
    [sym_comment] = ACTIONS(3),
    [sym_line_continuation] = ACTIONS(3),
    [sym_string_start] = ACTIONS(67),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 20,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(267), 1,
      anon_sym_TILDE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(463), 1,
      anon_sym_LPAREN,
    ACTIONS(465), 1,
      anon_sym_STAR,
    ACTIONS(469), 1,
      anon_sym_type,
    ACTIONS(471), 1,
      anon_sym_LBRACK,
    STATE(915), 1,
      sym_list_splat_pattern,
    STATE(1243), 1,
      sym_pattern,
    STATE(1272), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(261), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(916), 2,
      sym_attribute,
      sym_subscript,
    STATE(1238), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(467), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
    ACTIONS(461), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [101] = 20,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(267), 1,
      anon_sym_TILDE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(463), 1,
      anon_sym_LPAREN,
    ACTIONS(465), 1,
      anon_sym_STAR,
    ACTIONS(469), 1,
      anon_sym_type,
    ACTIONS(471), 1,
      anon_sym_LBRACK,
    STATE(915), 1,
      sym_list_splat_pattern,
    STATE(1243), 1,
      sym_pattern,
    STATE(1272), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(261), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(916), 2,
      sym_attribute,
      sym_subscript,
    STATE(1238), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(467), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
    ACTIONS(473), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [202] = 24,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(489), 1,
      anon_sym_RBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1603), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [310] = 24,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(505), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1603), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [418] = 27,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(511), 1,
      anon_sym_RPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2229), 1,
      sym__patterns,
    STATE(2258), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [532] = 28,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(535), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1462), 1,
      sym_expression,
    STATE(1865), 1,
      sym_list_splat,
    STATE(1866), 1,
      sym_pattern,
    STATE(1869), 1,
      sym_parenthesized_list_splat,
    STATE(2167), 1,
      sym__patterns,
    STATE(2170), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [648] = 27,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(539), 1,
      anon_sym_LPAREN,
    ACTIONS(541), 1,
      anon_sym_COMMA,
    ACTIONS(543), 1,
      anon_sym_STAR,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(557), 1,
      anon_sym_RBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1296), 1,
      sym_expression,
    STATE(1498), 1,
      sym_pair,
    STATE(1819), 1,
      sym_dictionary_splat,
    STATE(2171), 1,
      sym__named_expression_lhs,
    STATE(2247), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1990), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [762] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(581), 1,
      anon_sym_RBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1313), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2146), 1,
      sym__patterns,
    STATE(2221), 1,
      sym__named_expression_lhs,
    STATE(2252), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [876] = 24,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(597), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1603), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [984] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(599), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1313), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2221), 1,
      sym__named_expression_lhs,
    STATE(2252), 1,
      sym__collection_elements,
    STATE(2255), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [1098] = 24,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(601), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1603), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [1206] = 27,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(603), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2169), 1,
      sym__patterns,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2258), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [1320] = 27,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(605), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2167), 1,
      sym__patterns,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2258), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [1434] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(607), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1306), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2215), 1,
      sym__collection_elements,
    STATE(2221), 1,
      sym__named_expression_lhs,
    STATE(2255), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [1548] = 27,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(539), 1,
      anon_sym_LPAREN,
    ACTIONS(543), 1,
      anon_sym_STAR,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(609), 1,
      anon_sym_COMMA,
    ACTIONS(611), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1297), 1,
      sym_expression,
    STATE(1491), 1,
      sym_pair,
    STATE(1915), 1,
      sym_dictionary_splat,
    STATE(2171), 1,
      sym__named_expression_lhs,
    STATE(2212), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1990), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [1662] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(613), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1313), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2216), 1,
      sym__patterns,
    STATE(2221), 1,
      sym__named_expression_lhs,
    STATE(2252), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [1776] = 24,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(615), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1603), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [1884] = 24,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(617), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1603), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [1992] = 28,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(619), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1487), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(1965), 1,
      sym_parenthesized_list_splat,
    STATE(1967), 1,
      sym_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2217), 1,
      sym__collection_elements,
    STATE(2259), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [2108] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(621), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1307), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2172), 1,
      sym__patterns,
    STATE(2177), 1,
      sym__collection_elements,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [2222] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(623), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1313), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2165), 1,
      sym__patterns,
    STATE(2221), 1,
      sym__named_expression_lhs,
    STATE(2252), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [2336] = 27,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(625), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1467), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2224), 1,
      sym__collection_elements,
    STATE(2229), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [2450] = 24,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(627), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1603), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [2558] = 27,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(629), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2229), 1,
      sym__patterns,
    STATE(2258), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [2672] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(631), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1302), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2139), 1,
      sym__collection_elements,
    STATE(2146), 1,
      sym__patterns,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [2786] = 27,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(539), 1,
      anon_sym_LPAREN,
    ACTIONS(543), 1,
      anon_sym_STAR,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(633), 1,
      anon_sym_COMMA,
    ACTIONS(635), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1298), 1,
      sym_expression,
    STATE(1465), 1,
      sym_pair,
    STATE(2004), 1,
      sym_dictionary_splat,
    STATE(2159), 1,
      sym__collection_elements,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1990), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [2900] = 27,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(637), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1485), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2140), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2229), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [3014] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(639), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1310), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2144), 1,
      sym__collection_elements,
    STATE(2146), 1,
      sym__patterns,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [3128] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(641), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1310), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2144), 1,
      sym__collection_elements,
    STATE(2146), 1,
      sym__patterns,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [3242] = 27,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(539), 1,
      anon_sym_LPAREN,
    ACTIONS(543), 1,
      anon_sym_STAR,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(643), 1,
      anon_sym_COMMA,
    ACTIONS(645), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1299), 1,
      sym_expression,
    STATE(1447), 1,
      sym_pair,
    STATE(1981), 1,
      sym_dictionary_splat,
    STATE(2171), 1,
      sym__named_expression_lhs,
    STATE(2181), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1990), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [3356] = 27,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(539), 1,
      anon_sym_LPAREN,
    ACTIONS(543), 1,
      anon_sym_STAR,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(647), 1,
      anon_sym_COMMA,
    ACTIONS(649), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1294), 1,
      sym_expression,
    STATE(1459), 1,
      sym_pair,
    STATE(1913), 1,
      sym_dictionary_splat,
    STATE(2131), 1,
      sym__collection_elements,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1990), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [3470] = 27,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(651), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2258), 1,
      sym__collection_elements,
    STATE(2259), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [3584] = 25,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      anon_sym_STAR,
    ACTIONS(47), 1,
      anon_sym_type,
    ACTIONS(49), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    STATE(459), 1,
      sym_list_splat_pattern,
    STATE(748), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_pattern_list,
    STATE(1284), 1,
      sym_pattern,
    STATE(1407), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    STATE(450), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2014), 4,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
    ACTIONS(65), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [3694] = 25,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      anon_sym_STAR,
    ACTIONS(47), 1,
      anon_sym_type,
    ACTIONS(49), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    STATE(459), 1,
      sym_list_splat_pattern,
    STATE(748), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_pattern_list,
    STATE(1284), 1,
      sym_pattern,
    STATE(1407), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    STATE(450), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2043), 4,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
    ACTIONS(65), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [3804] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(653), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1313), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2172), 1,
      sym__patterns,
    STATE(2221), 1,
      sym__named_expression_lhs,
    STATE(2252), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [3918] = 27,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(539), 1,
      anon_sym_LPAREN,
    ACTIONS(543), 1,
      anon_sym_STAR,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(655), 1,
      anon_sym_COMMA,
    ACTIONS(657), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1293), 1,
      sym_expression,
    STATE(1497), 1,
      sym_pair,
    STATE(1908), 1,
      sym_dictionary_splat,
    STATE(2137), 1,
      sym__collection_elements,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1990), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [4032] = 27,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(659), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2218), 1,
      sym__patterns,
    STATE(2258), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [4146] = 27,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(539), 1,
      anon_sym_LPAREN,
    ACTIONS(543), 1,
      anon_sym_STAR,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(661), 1,
      anon_sym_COMMA,
    ACTIONS(663), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1295), 1,
      sym_expression,
    STATE(1466), 1,
      sym_pair,
    STATE(1833), 1,
      sym_dictionary_splat,
    STATE(2121), 1,
      sym__collection_elements,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1990), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [4260] = 27,
    ACTIONS(507), 1,
      sym_identifier,
    ACTIONS(509), 1,
      anon_sym_LPAREN,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(517), 1,
      anon_sym_type,
    ACTIONS(519), 1,
      anon_sym_LBRACK,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(665), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1128), 1,
      sym_list_splat_pattern,
    STATE(1467), 1,
      sym_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2224), 1,
      sym__collection_elements,
    STATE(2229), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1129), 2,
      sym_attribute,
      sym_subscript,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(515), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [4374] = 24,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(667), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1603), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [4482] = 27,
    ACTIONS(569), 1,
      sym_identifier,
    ACTIONS(571), 1,
      anon_sym_LPAREN,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(577), 1,
      anon_sym_type,
    ACTIONS(579), 1,
      anon_sym_LBRACK,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(669), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(1031), 1,
      sym_list_splat_pattern,
    STATE(1313), 1,
      sym_expression,
    STATE(1997), 1,
      sym_pattern,
    STATE(2146), 1,
      sym__patterns,
    STATE(2221), 1,
      sym__named_expression_lhs,
    STATE(2252), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1026), 2,
      sym_attribute,
      sym_subscript,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(575), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [4596] = 25,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(11), 1,
      anon_sym_LPAREN,
    ACTIONS(13), 1,
      anon_sym_STAR,
    ACTIONS(47), 1,
      anon_sym_type,
    ACTIONS(49), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    STATE(459), 1,
      sym_list_splat_pattern,
    STATE(748), 1,
      sym_primary_expression,
    STATE(1279), 1,
      sym_pattern_list,
    STATE(1284), 1,
      sym_pattern,
    STATE(1407), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    STATE(450), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(2035), 4,
      sym_expression_list,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
    ACTIONS(65), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [4706] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1629), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [4811] = 25,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(679), 1,
      anon_sym_RPAREN,
    ACTIONS(681), 1,
      anon_sym_COMMA,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1445), 1,
      sym_expression,
    STATE(1932), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1931), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [4920] = 25,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(693), 1,
      anon_sym_RPAREN,
    ACTIONS(695), 1,
      anon_sym_COMMA,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1463), 1,
      sym_expression,
    STATE(1840), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1839), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5029] = 23,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(697), 1,
      sym_identifier,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(701), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_STAR_STAR,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1332), 1,
      sym_expression,
    STATE(1575), 1,
      sym_type,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1551), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5134] = 23,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1524), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5239] = 25,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(707), 1,
      anon_sym_RPAREN,
    ACTIONS(709), 1,
      anon_sym_COMMA,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1434), 1,
      sym_expression,
    STATE(1999), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2005), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5348] = 23,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1681), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5453] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1877), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5558] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1860), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5663] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1953), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5768] = 23,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(711), 1,
      sym_identifier,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(715), 1,
      anon_sym_STAR,
    ACTIONS(719), 1,
      anon_sym_STAR_STAR,
    ACTIONS(721), 1,
      anon_sym_type,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1322), 1,
      sym_expression,
    STATE(1518), 1,
      sym_type,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1504), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5873] = 23,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1544), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [5978] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1958), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [6083] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1897), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [6188] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1959), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [6293] = 25,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(723), 1,
      anon_sym_RPAREN,
    ACTIONS(725), 1,
      anon_sym_COMMA,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1449), 1,
      sym_expression,
    STATE(1851), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1853), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [6402] = 20,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(267), 1,
      anon_sym_TILDE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(727), 1,
      sym_identifier,
    ACTIONS(729), 1,
      anon_sym_LPAREN,
    ACTIONS(731), 1,
      anon_sym_STAR,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      anon_sym_LBRACK,
    STATE(1083), 1,
      sym_list_splat_pattern,
    STATE(1259), 1,
      sym_pattern,
    STATE(1277), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(261), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1084), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(733), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
    ACTIONS(473), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [6501] = 23,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(711), 1,
      sym_identifier,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(715), 1,
      anon_sym_STAR,
    ACTIONS(719), 1,
      anon_sym_STAR_STAR,
    ACTIONS(721), 1,
      anon_sym_type,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1322), 1,
      sym_expression,
    STATE(1519), 1,
      sym_type,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1504), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [6606] = 23,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1604), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [6711] = 25,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(739), 1,
      anon_sym_RPAREN,
    ACTIONS(741), 1,
      anon_sym_COMMA,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1492), 1,
      sym_expression,
    STATE(1821), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1822), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [6820] = 23,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1603), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [6925] = 23,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(697), 1,
      sym_identifier,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(701), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_STAR_STAR,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1332), 1,
      sym_expression,
    STATE(1553), 1,
      sym_type,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1551), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [7030] = 23,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(711), 1,
      sym_identifier,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(715), 1,
      anon_sym_STAR,
    ACTIONS(719), 1,
      anon_sym_STAR_STAR,
    ACTIONS(721), 1,
      anon_sym_type,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1322), 1,
      sym_expression,
    STATE(1648), 1,
      sym_type,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1504), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [7135] = 23,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(711), 1,
      sym_identifier,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(715), 1,
      anon_sym_STAR,
    ACTIONS(719), 1,
      anon_sym_STAR_STAR,
    ACTIONS(721), 1,
      anon_sym_type,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1322), 1,
      sym_expression,
    STATE(1565), 1,
      sym_type,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1504), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [7240] = 25,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(743), 1,
      anon_sym_RPAREN,
    ACTIONS(745), 1,
      anon_sym_COMMA,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1494), 1,
      sym_expression,
    STATE(1927), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1929), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [7349] = 23,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1511), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [7454] = 20,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(267), 1,
      anon_sym_TILDE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(727), 1,
      sym_identifier,
    ACTIONS(729), 1,
      anon_sym_LPAREN,
    ACTIONS(731), 1,
      anon_sym_STAR,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      anon_sym_LBRACK,
    STATE(1083), 1,
      sym_list_splat_pattern,
    STATE(1259), 1,
      sym_pattern,
    STATE(1277), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(261), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1084), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(733), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
    ACTIONS(461), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [7553] = 25,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(747), 1,
      anon_sym_RPAREN,
    ACTIONS(749), 1,
      anon_sym_COMMA,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1493), 1,
      sym_expression,
    STATE(1880), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1882), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [7662] = 23,
    ACTIONS(475), 1,
      sym_identifier,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(479), 1,
      anon_sym_STAR,
    ACTIONS(483), 1,
      anon_sym_STAR_STAR,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1385), 1,
      sym_expression,
    STATE(1557), 1,
      sym_type,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1666), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [7767] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1630), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [7872] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1992), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [7977] = 23,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(287), 1,
      anon_sym_STAR_STAR,
    ACTIONS(671), 1,
      sym_identifier,
    ACTIONS(673), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1374), 1,
      sym_expression,
    STATE(1969), 1,
      sym_type,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1609), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [8082] = 23,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(697), 1,
      sym_identifier,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(701), 1,
      anon_sym_STAR,
    ACTIONS(703), 1,
      anon_sym_STAR_STAR,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1332), 1,
      sym_expression,
    STATE(1580), 1,
      sym_type,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(1551), 5,
      sym_splat_type,
      sym_generic_type,
      sym_union_type,
      sym_constrained_type,
      sym_member_type,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [8187] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(751), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [8293] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(753), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [8399] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(755), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [8505] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(757), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [8611] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(759), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [8717] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(761), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [8823] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(763), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [8929] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(765), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9035] = 24,
    ACTIONS(767), 1,
      sym_identifier,
    ACTIONS(769), 1,
      anon_sym_LPAREN,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_LBRACK,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    STATE(705), 1,
      sym_primary_expression,
    STATE(822), 1,
      sym_list_splat_pattern,
    STATE(1331), 1,
      sym_expression,
    STATE(2081), 1,
      sym_pattern,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    STATE(823), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1660), 3,
      sym_expression_list,
      sym_pattern_list,
      sym__f_expression,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(773), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9141] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(793), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9247] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(795), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9353] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(797), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9459] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(799), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9565] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(801), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9671] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(803), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9777] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(805), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9883] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(807), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [9989] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(809), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [10095] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(811), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [10201] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(813), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [10307] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(815), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [10413] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(817), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [10519] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(819), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [10625] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(821), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [10731] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(823), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [10837] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(825), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [10943] = 24,
    ACTIONS(767), 1,
      sym_identifier,
    ACTIONS(769), 1,
      anon_sym_LPAREN,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(775), 1,
      anon_sym_type,
    ACTIONS(777), 1,
      anon_sym_LBRACK,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    STATE(705), 1,
      sym_primary_expression,
    STATE(822), 1,
      sym_list_splat_pattern,
    STATE(1331), 1,
      sym_expression,
    STATE(2081), 1,
      sym_pattern,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    STATE(823), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(1684), 3,
      sym_expression_list,
      sym_pattern_list,
      sym__f_expression,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(773), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11049] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(827), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11155] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(829), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11261] = 24,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(831), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11367] = 23,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(839), 1,
      anon_sym_RBRACE,
    ACTIONS(841), 1,
      anon_sym_lambda,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1432), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(837), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 5,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11470] = 23,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(857), 1,
      anon_sym_RBRACK,
    ACTIONS(859), 1,
      anon_sym_lambda,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1400), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1613), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(851), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 5,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11573] = 23,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_lambda,
    ACTIONS(857), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1432), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(851), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 5,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11676] = 23,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(675), 1,
      sym_identifier,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(683), 1,
      anon_sym_STAR,
    ACTIONS(687), 1,
      anon_sym_STAR_STAR,
    ACTIONS(689), 1,
      anon_sym_type,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1500), 1,
      sym_expression,
    STATE(2038), 1,
      sym_parenthesized_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    STATE(2037), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(685), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11779] = 24,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(863), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1490), 1,
      sym_expression,
    STATE(1986), 1,
      sym_with_item,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2258), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11884] = 23,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(859), 1,
      anon_sym_lambda,
    ACTIONS(867), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1400), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1613), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(865), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 5,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [11987] = 23,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1432), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(869), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 5,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [12090] = 23,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(839), 1,
      anon_sym_RBRACK,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(859), 1,
      anon_sym_lambda,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1400), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1613), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(837), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 5,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [12193] = 23,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_lambda,
    ACTIONS(867), 1,
      anon_sym_RBRACE,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1432), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(865), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 5,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [12296] = 23,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(859), 1,
      anon_sym_lambda,
    ACTIONS(871), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1400), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1613), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(869), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 5,
      anon_sym_print,
      anon_sym_match,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [12399] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(873), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [12501] = 24,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(875), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1485), 1,
      sym_expression,
    STATE(1827), 1,
      sym_list_splat,
    STATE(1828), 1,
      sym_parenthesized_list_splat,
    STATE(2140), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [12605] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(877), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [12707] = 23,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(879), 1,
      anon_sym_LPAREN,
    ACTIONS(881), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1314), 1,
      sym_expression,
    STATE(2117), 1,
      sym__collection_elements,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [12809] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(883), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [12911] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(885), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13013] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(887), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13115] = 23,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(879), 1,
      anon_sym_LPAREN,
    ACTIONS(889), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1303), 1,
      sym_expression,
    STATE(2164), 1,
      sym__collection_elements,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13217] = 24,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(891), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1487), 1,
      sym_expression,
    STATE(1965), 1,
      sym_parenthesized_list_splat,
    STATE(1967), 1,
      sym_list_splat,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2217), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13321] = 21,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1383), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(899), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13419] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(905), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13521] = 21,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1383), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(907), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13619] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(909), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13721] = 24,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(911), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_expression,
    STATE(1827), 1,
      sym_list_splat,
    STATE(1828), 1,
      sym_parenthesized_list_splat,
    STATE(2166), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13825] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(913), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [13927] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(915), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14029] = 23,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(911), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1476), 1,
      sym_expression,
    STATE(2166), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14131] = 23,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(917), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1462), 1,
      sym_expression,
    STATE(2170), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14233] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(919), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14335] = 23,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(879), 1,
      anon_sym_LPAREN,
    ACTIONS(921), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1313), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    STATE(2252), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14437] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(923), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14539] = 23,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(863), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1473), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2258), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14641] = 24,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(917), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1462), 1,
      sym_expression,
    STATE(1865), 1,
      sym_list_splat,
    STATE(1869), 1,
      sym_parenthesized_list_splat,
    STATE(2170), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14745] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(925), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14847] = 23,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(891), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1487), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2217), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [14949] = 23,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(879), 1,
      anon_sym_LPAREN,
    ACTIONS(927), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1310), 1,
      sym_expression,
    STATE(2144), 1,
      sym__collection_elements,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15051] = 24,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(929), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1442), 1,
      sym_expression,
    STATE(1965), 1,
      sym_parenthesized_list_splat,
    STATE(1967), 1,
      sym_list_splat,
    STATE(2114), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15155] = 23,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(931), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1467), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    STATE(2224), 1,
      sym__collection_elements,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15257] = 23,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(879), 1,
      anon_sym_LPAREN,
    ACTIONS(933), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1307), 1,
      sym_expression,
    STATE(2177), 1,
      sym__collection_elements,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15359] = 23,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(929), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1442), 1,
      sym_expression,
    STATE(2114), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15461] = 23,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(879), 1,
      anon_sym_LPAREN,
    ACTIONS(935), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1302), 1,
      sym_expression,
    STATE(2139), 1,
      sym__collection_elements,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15563] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(937), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15665] = 23,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(875), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1485), 1,
      sym_expression,
    STATE(2140), 1,
      sym__collection_elements,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1862), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15767] = 23,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    ACTIONS(939), 1,
      anon_sym_RBRACE,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15869] = 23,
    ACTIONS(573), 1,
      anon_sym_STAR,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(879), 1,
      anon_sym_LPAREN,
    ACTIONS(941), 1,
      anon_sym_RBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1306), 1,
      sym_expression,
    STATE(2215), 1,
      sym__collection_elements,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(2000), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [15971] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(949), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16072] = 22,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1424), 1,
      sym_expression,
    STATE(2048), 1,
      sym_expression_list,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(951), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16171] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(955), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16272] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(957), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16373] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(959), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16474] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(961), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16575] = 22,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(963), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1501), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(2100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16674] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(965), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16775] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(967), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16876] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(969), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [16977] = 22,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(963), 1,
      anon_sym_RBRACK,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(973), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1521), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    STATE(2082), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17076] = 22,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(975), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_RBRACE,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1538), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    STATE(2067), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17175] = 22,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(973), 1,
      anon_sym_STAR,
    ACTIONS(979), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1521), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    STATE(2082), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17274] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(981), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17375] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(983), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17476] = 22,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(253), 1,
      anon_sym_STAR,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(547), 1,
      anon_sym_STAR_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1653), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(2064), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17575] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(985), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17676] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(987), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17777] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(989), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17878] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(991), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [17979] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(993), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18080] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(995), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18181] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(999), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1486), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(997), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18280] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1001), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18381] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1003), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18482] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1005), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18583] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1007), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18684] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1009), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18785] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1011), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18886] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1013), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [18987] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1015), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19088] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1017), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19189] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1021), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1439), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1019), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19288] = 22,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(979), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1501), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(2100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19387] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1023), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19488] = 23,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    ACTIONS(1025), 1,
      anon_sym_RBRACK,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19589] = 22,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(963), 1,
      anon_sym_RBRACE,
    ACTIONS(975), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_STAR,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1538), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    STATE(2067), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19688] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1483), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1027), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19784] = 21,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1555), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1029), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19880] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1429), 1,
      sym_expression,
    STATE(1846), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [19978] = 21,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(859), 1,
      anon_sym_lambda,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1400), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1550), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [20074] = 21,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(859), 1,
      anon_sym_lambda,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1413), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1649), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [20170] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1483), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1031), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [20266] = 10,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1033), 1,
      anon_sym_for,
    ACTIONS(1035), 1,
      anon_sym_with,
    ACTIONS(1037), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(236), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(247), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(214), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [20340] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1403), 1,
      sym_expression,
    STATE(1876), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [20438] = 21,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(859), 1,
      anon_sym_lambda,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1411), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1611), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [20534] = 21,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(859), 1,
      anon_sym_lambda,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1400), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1502), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [20630] = 11,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(231), 1,
      anon_sym_COLON,
    ACTIONS(236), 1,
      anon_sym_EQ,
    ACTIONS(1039), 1,
      sym_identifier,
    STATE(2006), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(212), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(247), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(214), 21,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
  [20706] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1471), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(907), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [20802] = 10,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1041), 1,
      anon_sym_for,
    ACTIONS(1043), 1,
      anon_sym_with,
    ACTIONS(1045), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(236), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(247), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(214), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [20876] = 22,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1047), 1,
      anon_sym_LPAREN,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2007), 1,
      sym_with_item,
    STATE(2160), 1,
      sym_with_clause,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [20974] = 10,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1039), 1,
      sym_identifier,
    STATE(2006), 1,
      sym_string,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(236), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(212), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(247), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(214), 21,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
  [21048] = 21,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_lambda,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1432), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1620), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [21144] = 21,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(859), 1,
      anon_sym_lambda,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1400), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    STATE(1613), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [21240] = 21,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_lambda,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1426), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1608), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [21336] = 21,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1503), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1051), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [21432] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1396), 1,
      sym_expression,
    STATE(1816), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [21530] = 22,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1053), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2074), 1,
      sym_with_item,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [21628] = 21,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_lambda,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1427), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1667), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [21724] = 21,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1587), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1019), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [21820] = 22,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1055), 1,
      anon_sym_RPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1510), 1,
      sym_expression,
    STATE(2092), 1,
      sym_with_item,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [21918] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1399), 1,
      sym_expression,
    STATE(1923), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22016] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1405), 1,
      sym_expression,
    STATE(1911), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22114] = 22,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1047), 1,
      anon_sym_LPAREN,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2007), 1,
      sym_with_item,
    STATE(2151), 1,
      sym_with_clause,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22212] = 21,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_lambda,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1432), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1528), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22308] = 21,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(975), 1,
      anon_sym_LPAREN,
    ACTIONS(977), 1,
      anon_sym_STAR,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1538), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    STATE(2067), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22404] = 21,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(971), 1,
      anon_sym_LPAREN,
    ACTIONS(973), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1521), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    STATE(2082), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22500] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1464), 1,
      sym_expression,
    STATE(2040), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22598] = 22,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1059), 1,
      anon_sym_RPAREN,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1510), 1,
      sym_expression,
    STATE(2092), 1,
      sym_with_item,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22696] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1395), 1,
      sym_expression,
    STATE(1988), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22794] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1422), 1,
      sym_expression,
    STATE(1843), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22892] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1471), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1061), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [22988] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1471), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1063), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23084] = 22,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1065), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2074), 1,
      sym_with_item,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23182] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1430), 1,
      sym_expression,
    STATE(1935), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23280] = 22,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(947), 1,
      anon_sym_COLON,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1415), 1,
      sym_expression,
    STATE(1980), 1,
      sym_slice,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23378] = 21,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(841), 1,
      anon_sym_lambda,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1432), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    STATE(1536), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23474] = 22,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1047), 1,
      anon_sym_LPAREN,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2007), 1,
      sym_with_item,
    STATE(2174), 1,
      sym_with_clause,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23572] = 22,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1047), 1,
      anon_sym_LPAREN,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2007), 1,
      sym_with_item,
    STATE(2168), 1,
      sym_with_clause,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23670] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1483), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1067), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23766] = 21,
    ACTIONS(513), 1,
      anon_sym_STAR,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(677), 1,
      anon_sym_LPAREN,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1501), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(2100), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23862] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1483), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1069), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [23958] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1471), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(899), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24054] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1071), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1506), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24149] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1475), 1,
      sym_expression,
    STATE(2178), 1,
      sym_expression_list,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24244] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(907), 1,
      anon_sym_COLON,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1514), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24339] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1443), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    STATE(2234), 1,
      sym_expression_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24434] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1472), 1,
      sym_expression,
    STATE(2184), 1,
      sym_expression_list,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24529] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1073), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1506), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24624] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1457), 1,
      sym_expression,
    STATE(2179), 1,
      sym_expression_list,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24719] = 21,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1510), 1,
      sym_expression,
    STATE(2092), 1,
      sym_with_item,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24814] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1075), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1506), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [24909] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1569), 1,
      sym_expression,
    STATE(2074), 1,
      sym_with_item,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25004] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1077), 1,
      anon_sym_COLON,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1506), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25099] = 21,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(899), 1,
      anon_sym_COLON,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1514), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25194] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1419), 1,
      sym_expression,
    STATE(2044), 1,
      sym_expression_list,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25289] = 21,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1079), 1,
      anon_sym_DOT,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1412), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25384] = 21,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1081), 1,
      sym_identifier,
    ACTIONS(1085), 1,
      anon_sym_type,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1563), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    STATE(1124), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1083), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25478] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1384), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25570] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1368), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25662] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1367), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25754] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1339), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25846] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1531), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [25938] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1423), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26030] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1601), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26122] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1387), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26214] = 20,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1377), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26306] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1474), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26398] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1344), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26490] = 20,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1433), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26582] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1338), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26674] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1319), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26766] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1372), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26858] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1431), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [26950] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1311), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27042] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1623), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27134] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1523), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27226] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1583), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27318] = 21,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1087), 1,
      sym_identifier,
    ACTIONS(1091), 1,
      anon_sym_type,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(927), 1,
      sym_primary_expression,
    STATE(1563), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    STATE(859), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1089), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27412] = 10,
    ACTIONS(1095), 1,
      anon_sym_COMMA,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1102), 1,
      anon_sym_COLON,
    ACTIONS(1105), 1,
      anon_sym_EQ,
    ACTIONS(1107), 1,
      anon_sym_LBRACK,
    STATE(1677), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1093), 15,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
  [27484] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1334), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27576] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1343), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27668] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1316), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27760] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1351), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27852] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1312), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [27944] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1369), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28036] = 20,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1453), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28128] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1689), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28220] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1610), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28312] = 21,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1111), 1,
      sym_identifier,
    ACTIONS(1115), 1,
      anon_sym_type,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1509), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    STATE(1125), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1113), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28406] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1370), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28498] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1566), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28590] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1515), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28682] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1529), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28774] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1471), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28866] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1598), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [28958] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1406), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29050] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1373), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29142] = 20,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1376), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29234] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1483), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29326] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1315), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29418] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1673), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29510] = 21,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1117), 1,
      sym_identifier,
    ACTIONS(1121), 1,
      anon_sym_type,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1499), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    STATE(1123), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1119), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29604] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1652), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29696] = 20,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1398), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29788] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1340), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29880] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1365), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [29972] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1364), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30064] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1461), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30156] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1386), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30248] = 20,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1428), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30340] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1607), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30432] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1389), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30524] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1558), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30616] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1333), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30708] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1327), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30800] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1506), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30892] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1308), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [30984] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1323), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31076] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1381), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31168] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1647), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31260] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1356), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31352] = 20,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1420), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31444] = 21,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1123), 1,
      sym_identifier,
    ACTIONS(1127), 1,
      anon_sym_type,
    STATE(951), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1499), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    STATE(964), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1125), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31538] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1631), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31630] = 20,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1375), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31722] = 20,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1378), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31814] = 20,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1379), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31906] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1305), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [31998] = 20,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1366), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32090] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1691), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32182] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1348), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32274] = 20,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1418), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32366] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1309), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32458] = 20,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1416), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32550] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1391), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32642] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1662), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32734] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1412), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32826] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1350), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [32918] = 20,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(57), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(210), 1,
      sym_identifier,
    ACTIONS(234), 1,
      anon_sym_type,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    STATE(703), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    STATE(1304), 1,
      sym_expression,
    STATE(2243), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(225), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1301), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33010] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1567), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33102] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1621), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33194] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1390), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33286] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1326), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33378] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1634), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33470] = 20,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1361), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33562] = 20,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1397), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33654] = 20,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(587), 1,
      anon_sym_not,
    ACTIONS(589), 1,
      anon_sym_lambda,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(843), 1,
      sym_identifier,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(853), 1,
      anon_sym_type,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    STATE(744), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    STATE(1394), 1,
      sym_expression,
    STATE(2221), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(849), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1409), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33746] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1526), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33838] = 20,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(525), 1,
      anon_sym_not,
    ACTIONS(527), 1,
      anon_sym_lambda,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(721), 1,
      anon_sym_type,
    ACTIONS(861), 1,
      sym_identifier,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    STATE(707), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    STATE(1328), 1,
      sym_expression,
    STATE(2205), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(717), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1318), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [33930] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1514), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [34022] = 20,
    ACTIONS(537), 1,
      sym_identifier,
    ACTIONS(549), 1,
      anon_sym_type,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(559), 1,
      anon_sym_not,
    ACTIONS(561), 1,
      anon_sym_lambda,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    STATE(702), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    STATE(1362), 1,
      sym_expression,
    STATE(2171), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(545), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1380), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [34114] = 20,
    ACTIONS(249), 1,
      sym_identifier,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_type,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_not,
    ACTIONS(269), 1,
      anon_sym_lambda,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    STATE(740), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1643), 1,
      sym_expression,
    STATE(2200), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(255), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1349), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [34206] = 20,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(783), 1,
      anon_sym_not,
    ACTIONS(785), 1,
      anon_sym_lambda,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(893), 1,
      sym_identifier,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(901), 1,
      anon_sym_type,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    STATE(705), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    STATE(1383), 1,
      sym_expression,
    STATE(2143), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(897), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1388), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [34298] = 20,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(485), 1,
      anon_sym_type,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(495), 1,
      anon_sym_not,
    ACTIONS(497), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(943), 1,
      sym_identifier,
    ACTIONS(945), 1,
      anon_sym_STAR,
    STATE(836), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    STATE(1382), 1,
      sym_expression,
    STATE(2108), 1,
      sym__named_expression_lhs,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(481), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1363), 7,
      sym_named_expression,
      sym_as_pattern,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [34390] = 7,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(236), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(247), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(214), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [34455] = 7,
    ACTIONS(1095), 1,
      anon_sym_COMMA,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1105), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(1109), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [34520] = 7,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(236), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(247), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(214), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [34585] = 8,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(231), 1,
      anon_sym_COLON,
    ACTIONS(236), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(247), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(214), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [34652] = 8,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(231), 1,
      anon_sym_COLON,
    ACTIONS(236), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(247), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(214), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [34719] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34775] = 6,
    ACTIONS(1135), 1,
      anon_sym_COMMA,
    ACTIONS(1142), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1140), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1138), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [34837] = 8,
    ACTIONS(1148), 1,
      anon_sym_elif,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(473), 1,
      aux_sym_if_statement_repeat1,
    STATE(488), 1,
      sym_elif_clause,
    STATE(586), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1146), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1144), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [34903] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [34959] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35015] = 6,
    ACTIONS(1095), 1,
      anon_sym_COMMA,
    ACTIONS(1105), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [35077] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35133] = 8,
    ACTIONS(1148), 1,
      anon_sym_elif,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(469), 1,
      aux_sym_if_statement_repeat1,
    STATE(488), 1,
      sym_elif_clause,
    STATE(574), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1158), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1156), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [35199] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1162), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1165), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 28,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35259] = 6,
    ACTIONS(1177), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1172), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1179), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1175), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [35321] = 6,
    ACTIONS(1142), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1135), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1140), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1138), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [35383] = 8,
    ACTIONS(1185), 1,
      anon_sym_elif,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(466), 1,
      aux_sym_if_statement_repeat1,
    STATE(492), 1,
      sym_elif_clause,
    STATE(588), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1181), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1183), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [35449] = 6,
    ACTIONS(1105), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1095), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1109), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1098), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [35511] = 6,
    ACTIONS(1105), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1191), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1109), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1194), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [35573] = 6,
    ACTIONS(1105), 1,
      anon_sym_EQ,
    ACTIONS(1191), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1194), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [35635] = 8,
    ACTIONS(1185), 1,
      anon_sym_elif,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(472), 1,
      aux_sym_if_statement_repeat1,
    STATE(492), 1,
      sym_elif_clause,
    STATE(597), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1196), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1198), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [35701] = 6,
    ACTIONS(1172), 1,
      anon_sym_COMMA,
    ACTIONS(1177), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1179), 14,
      anon_sym_COLON,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    ACTIONS(1175), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [35763] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1202), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1200), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35819] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1206), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1204), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35875] = 7,
    ACTIONS(1220), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1210), 2,
      anon_sym_DOT,
      anon_sym_COLON,
    ACTIONS(1212), 2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1215), 12,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1208), 27,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35939] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1212), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1215), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1208), 28,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [35999] = 8,
    ACTIONS(1185), 1,
      anon_sym_elif,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(472), 1,
      aux_sym_if_statement_repeat1,
    STATE(492), 1,
      sym_elif_clause,
    STATE(538), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1146), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1144), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36065] = 8,
    ACTIONS(1185), 1,
      anon_sym_elif,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(460), 1,
      aux_sym_if_statement_repeat1,
    STATE(492), 1,
      sym_elif_clause,
    STATE(559), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1158), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1156), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36131] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1224), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1222), 31,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_LBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36187] = 8,
    ACTIONS(1148), 1,
      anon_sym_elif,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(473), 1,
      aux_sym_if_statement_repeat1,
    STATE(488), 1,
      sym_elif_clause,
    STATE(563), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1196), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1198), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36253] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1162), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1165), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 28,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [36313] = 8,
    ACTIONS(1148), 1,
      anon_sym_elif,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(447), 1,
      aux_sym_if_statement_repeat1,
    STATE(488), 1,
      sym_elif_clause,
    STATE(507), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1181), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1183), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36379] = 6,
    ACTIONS(1230), 1,
      anon_sym_elif,
    STATE(472), 1,
      aux_sym_if_statement_repeat1,
    STATE(492), 1,
      sym_elif_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1226), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1228), 31,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36440] = 6,
    ACTIONS(1233), 1,
      anon_sym_elif,
    STATE(473), 1,
      aux_sym_if_statement_repeat1,
    STATE(488), 1,
      sym_elif_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1226), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1228), 31,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36501] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1236), 1,
      sym_identifier,
    ACTIONS(1238), 1,
      anon_sym_LPAREN,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1244), 1,
      anon_sym_type,
    ACTIONS(1246), 1,
      anon_sym_LBRACK,
    STATE(1208), 1,
      sym_list_splat_pattern,
    STATE(1283), 1,
      sym_primary_expression,
    STATE(1599), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1206), 2,
      sym_attribute,
      sym_subscript,
    STATE(1659), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(473), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1242), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [36587] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1236), 1,
      sym_identifier,
    ACTIONS(1238), 1,
      anon_sym_LPAREN,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1244), 1,
      anon_sym_type,
    ACTIONS(1246), 1,
      anon_sym_LBRACK,
    STATE(1208), 1,
      sym_list_splat_pattern,
    STATE(1283), 1,
      sym_primary_expression,
    STATE(1599), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1206), 2,
      sym_attribute,
      sym_subscript,
    STATE(1659), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(461), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1242), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [36673] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1250), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1248), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36726] = 5,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(583), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1254), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1252), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36783] = 5,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(573), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1256), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1258), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36840] = 5,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(557), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1260), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1262), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36897] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1264), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1266), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [36950] = 5,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(528), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1270), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1268), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37007] = 5,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(532), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1260), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1262), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37064] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1274), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1272), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37117] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1276), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1278), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37170] = 5,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(542), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1282), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1280), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37227] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1284), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1286), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37280] = 5,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(593), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1282), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1280), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37337] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1290), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1288), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37390] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1292), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1294), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37443] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1250), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1248), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37496] = 5,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(564), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1296), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1298), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37553] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1290), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1288), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37606] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1292), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1294), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37659] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1300), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1302), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37712] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1274), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1272), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37765] = 5,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(570), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1296), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1298), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37822] = 5,
    ACTIONS(1150), 1,
      anon_sym_else,
    STATE(598), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1256), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1258), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37879] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1264), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1266), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37932] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1276), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1278), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [37985] = 5,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(562), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1254), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1252), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38042] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1300), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1302), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38095] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1284), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1286), 32,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38148] = 5,
    ACTIONS(1187), 1,
      anon_sym_else,
    STATE(520), 1,
      sym_else_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1270), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1268), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38205] = 20,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1304), 1,
      sym_identifier,
    ACTIONS(1306), 1,
      anon_sym_LPAREN,
    ACTIONS(1308), 1,
      anon_sym_RPAREN,
    ACTIONS(1312), 1,
      anon_sym_type,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    STATE(1253), 1,
      sym_list_splat_pattern,
    STATE(1268), 1,
      sym_primary_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2167), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1251), 2,
      sym_attribute,
      sym_subscript,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1310), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [38291] = 20,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1304), 1,
      sym_identifier,
    ACTIONS(1306), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_type,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1316), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      sym_list_splat_pattern,
    STATE(1268), 1,
      sym_primary_expression,
    STATE(1866), 1,
      sym_pattern,
    STATE(2229), 1,
      sym__patterns,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1251), 2,
      sym_attribute,
      sym_subscript,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1310), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [38377] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1320), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1318), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38428] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1324), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1322), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38479] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1332), 1,
      anon_sym_in,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1259), 1,
      sym_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [38562] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1338), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1340), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38613] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1344), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1342), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38664] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1348), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1346), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38715] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1885), 1,
      sym_pattern,
    STATE(2187), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [38798] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1352), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1350), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38849] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1354), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1356), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [38900] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1812), 1,
      sym_pattern,
    STATE(2256), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [38983] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1358), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1360), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39034] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1362), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1364), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39085] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1366), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1368), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39136] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1370), 1,
      sym_identifier,
    ACTIONS(1372), 1,
      anon_sym_LPAREN,
    ACTIONS(1374), 1,
      anon_sym_STAR,
    ACTIONS(1378), 1,
      anon_sym_type,
    ACTIONS(1380), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_RBRACK,
    STATE(1247), 1,
      sym_list_splat_pattern,
    STATE(1281), 1,
      sym_primary_expression,
    STATE(2093), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1248), 2,
      sym_attribute,
      sym_subscript,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1376), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [39219] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1384), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1386), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39270] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1390), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1388), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39321] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1394), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1392), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39372] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1398), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1396), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39423] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1402), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1400), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39474] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1390), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1388), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39525] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1352), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1350), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39576] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1406), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1404), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39627] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1384), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1386), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39678] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1966), 1,
      sym_pattern,
    STATE(2189), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [39761] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1398), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1396), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39812] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1366), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1368), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39863] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1410), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1408), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39914] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1412), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1414), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [39965] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1362), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1364), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40016] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1418), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1416), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40067] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1420), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1422), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40118] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1348), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1346), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40169] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1424), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1426), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40220] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1358), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1360), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40271] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1344), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1342), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40322] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1354), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1356), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40373] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1430), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1428), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40424] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1434), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1432), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40475] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1438), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1436), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40526] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1442), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1440), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40577] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1444), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1446), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40628] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1450), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1448), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40679] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    ACTIONS(1452), 1,
      anon_sym_in,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1259), 1,
      sym_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [40762] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1320), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1318), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40813] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1454), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1456), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40864] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1815), 1,
      sym_pattern,
    STATE(2253), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [40947] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1460), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1458), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [40998] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1412), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1414), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41049] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1978), 1,
      sym_pattern,
    STATE(2182), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [41132] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1462), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1464), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41183] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1466), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1468), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41234] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1410), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1408), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41285] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1470), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1472), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41336] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1474), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1476), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41387] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1478), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1480), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41438] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1482), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1484), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41489] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1486), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1488), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41540] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1492), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1490), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41591] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1494), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1496), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41642] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1498), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1500), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41693] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1971), 1,
      sym_pattern,
    STATE(2150), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [41776] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1420), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1422), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41827] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1460), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1458), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [41878] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1304), 1,
      sym_identifier,
    ACTIONS(1306), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_type,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1502), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      sym_list_splat_pattern,
    STATE(1268), 1,
      sym_primary_expression,
    STATE(2051), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1251), 2,
      sym_attribute,
      sym_subscript,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1310), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [41961] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1494), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1496), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42012] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1498), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1500), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42063] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1418), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1416), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42114] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1504), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1506), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42165] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1474), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1476), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42216] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1450), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1448), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42267] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1991), 1,
      sym_pattern,
    STATE(2163), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [42350] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1478), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1480), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42401] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1470), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1472), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42452] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1406), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1404), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42503] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1482), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1484), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42554] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1466), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1468), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42605] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1462), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1464), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42656] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1486), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1488), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42707] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1454), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1456), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42758] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1304), 1,
      sym_identifier,
    ACTIONS(1306), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_type,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    ACTIONS(1382), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      sym_list_splat_pattern,
    STATE(1268), 1,
      sym_primary_expression,
    STATE(2051), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1251), 2,
      sym_attribute,
      sym_subscript,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1310), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [42841] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1424), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1426), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [42892] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1370), 1,
      sym_identifier,
    ACTIONS(1372), 1,
      anon_sym_LPAREN,
    ACTIONS(1374), 1,
      anon_sym_STAR,
    ACTIONS(1378), 1,
      anon_sym_type,
    ACTIONS(1380), 1,
      anon_sym_LBRACK,
    ACTIONS(1502), 1,
      anon_sym_RBRACK,
    STATE(1247), 1,
      sym_list_splat_pattern,
    STATE(1281), 1,
      sym_primary_expression,
    STATE(2093), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1248), 2,
      sym_attribute,
      sym_subscript,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1376), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [42975] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1324), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1322), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43026] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1338), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1340), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43077] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1438), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1436), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43128] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1434), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1432), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43179] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1442), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1440), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1430), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1428), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43281] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1444), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1446), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43332] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1402), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1400), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43383] = 19,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    STATE(1984), 1,
      sym_pattern,
    STATE(2149), 1,
      sym_pattern_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [43466] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1492), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1490), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43517] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1504), 12,
      sym__dedent,
      sym_string_start,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1506), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43568] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1394), 12,
      sym_string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_TILDE,
      sym_ellipsis,
      sym_float,
    ACTIONS(1392), 30,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_assert_,
      anon_sym_assert_eq,
      anon_sym_assert_ne,
      anon_sym_assert_contains,
      anon_sym_assert_fails,
      anon_sym_return,
      anon_sym_del,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_match,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_with,
      anon_sym_def,
      anon_sym_exec,
      anon_sym_type,
      anon_sym_not,
      anon_sym_lambda,
      sym_integer,
      sym_identifier,
      anon_sym_await,
      anon_sym_struct,
      sym_true,
      sym_false,
      sym_none,
  [43619] = 18,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1304), 1,
      sym_identifier,
    ACTIONS(1306), 1,
      anon_sym_LPAREN,
    ACTIONS(1312), 1,
      anon_sym_type,
    ACTIONS(1314), 1,
      anon_sym_LBRACK,
    STATE(1253), 1,
      sym_list_splat_pattern,
    STATE(1268), 1,
      sym_primary_expression,
    STATE(2051), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1251), 2,
      sym_attribute,
      sym_subscript,
    STATE(2062), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1310), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [43699] = 18,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(727), 1,
      sym_identifier,
    ACTIONS(729), 1,
      anon_sym_LPAREN,
    ACTIONS(735), 1,
      anon_sym_type,
    ACTIONS(737), 1,
      anon_sym_LBRACK,
    ACTIONS(1508), 1,
      anon_sym_STAR,
    STATE(1083), 1,
      sym_list_splat_pattern,
    STATE(1259), 1,
      sym_pattern,
    STATE(1277), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1084), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(733), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [43779] = 18,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1326), 1,
      sym_identifier,
    ACTIONS(1328), 1,
      anon_sym_LPAREN,
    ACTIONS(1334), 1,
      anon_sym_type,
    ACTIONS(1336), 1,
      anon_sym_LBRACK,
    STATE(1233), 1,
      sym_list_splat_pattern,
    STATE(1259), 1,
      sym_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1230), 2,
      sym_attribute,
      sym_subscript,
    STATE(1265), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1330), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [43859] = 18,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1370), 1,
      sym_identifier,
    ACTIONS(1372), 1,
      anon_sym_LPAREN,
    ACTIONS(1374), 1,
      anon_sym_STAR,
    ACTIONS(1378), 1,
      anon_sym_type,
    ACTIONS(1380), 1,
      anon_sym_LBRACK,
    STATE(1247), 1,
      sym_list_splat_pattern,
    STATE(1281), 1,
      sym_primary_expression,
    STATE(2093), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1248), 2,
      sym_attribute,
      sym_subscript,
    STATE(2021), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1376), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [43939] = 18,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1236), 1,
      sym_identifier,
    ACTIONS(1238), 1,
      anon_sym_LPAREN,
    ACTIONS(1240), 1,
      anon_sym_STAR,
    ACTIONS(1244), 1,
      anon_sym_type,
    ACTIONS(1246), 1,
      anon_sym_LBRACK,
    STATE(1208), 1,
      sym_list_splat_pattern,
    STATE(1283), 1,
      sym_primary_expression,
    STATE(1599), 1,
      sym_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1206), 2,
      sym_attribute,
      sym_subscript,
    STATE(1659), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1242), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44019] = 18,
    ACTIONS(13), 1,
      anon_sym_STAR,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(463), 1,
      anon_sym_LPAREN,
    ACTIONS(469), 1,
      anon_sym_type,
    ACTIONS(471), 1,
      anon_sym_LBRACK,
    STATE(915), 1,
      sym_list_splat_pattern,
    STATE(1243), 1,
      sym_pattern,
    STATE(1272), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(916), 2,
      sym_attribute,
      sym_subscript,
    STATE(1238), 2,
      sym_tuple_pattern,
      sym_list_pattern,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(467), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44099] = 17,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1510), 1,
      sym_identifier,
    ACTIONS(1516), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1512), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    STATE(1232), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1514), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44176] = 17,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1518), 1,
      sym_identifier,
    ACTIONS(1522), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1268), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(1512), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(1216), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1520), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44253] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(717), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44322] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(726), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44391] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(942), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44460] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(780), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44529] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(939), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44598] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(940), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44667] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(943), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44736] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(770), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44805] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1540), 1,
      sym_identifier,
    ACTIONS(1544), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1281), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(934), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1542), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44878] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(725), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [44947] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1546), 1,
      sym_identifier,
    ACTIONS(1550), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1271), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(762), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1548), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45020] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(843), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45089] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(938), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45158] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1556), 1,
      sym_identifier,
    ACTIONS(1560), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1283), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(911), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1558), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45231] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(716), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45300] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(947), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45369] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1562), 1,
      sym_identifier,
    ACTIONS(1566), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1009), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1564), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45442] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(749), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45511] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(750), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45580] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(751), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45649] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(776), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45718] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(797), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45787] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(733), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45856] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(941), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45925] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(796), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [45994] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(794), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46063] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(793), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46132] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(792), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46201] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(791), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46270] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(752), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46339] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(790), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46408] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(753), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46477] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(789), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46546] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1576), 1,
      sym_identifier,
    ACTIONS(1580), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1281), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1113), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1578), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46619] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(754), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46688] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(755), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46757] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(756), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46826] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(742), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46895] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(732), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [46964] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(731), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47033] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(706), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47102] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(730), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47171] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1580), 1,
      anon_sym_type,
    ACTIONS(1582), 1,
      sym_identifier,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1273), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1113), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1578), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47244] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(714), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47313] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(715), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47382] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(773), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47451] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(729), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47520] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(728), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47589] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(741), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47658] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(727), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47727] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(709), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47796] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(710), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47865] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(944), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [47934] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(711), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48003] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1556), 1,
      sym_identifier,
    ACTIONS(1560), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1274), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(911), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1558), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48076] = 14,
    ACTIONS(55), 1,
      anon_sym_LBRACE,
    ACTIONS(67), 1,
      sym_string_start,
    ACTIONS(699), 1,
      anon_sym_LPAREN,
    ACTIONS(705), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_STAR,
    ACTIONS(1526), 1,
      anon_sym_type,
    STATE(743), 1,
      sym_primary_expression,
    STATE(809), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(61), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(53), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(63), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1524), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(899), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48145] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(758), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48214] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(802), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48283] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(801), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48352] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1550), 1,
      anon_sym_type,
    ACTIONS(1584), 1,
      sym_identifier,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1271), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(762), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1548), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48425] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(766), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48494] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1586), 1,
      sym_identifier,
    ACTIONS(1590), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1272), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(465), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48567] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(800), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48636] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(799), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48705] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1590), 1,
      anon_sym_type,
    ACTIONS(1592), 1,
      sym_identifier,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1272), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(465), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1588), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48778] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1594), 1,
      sym_identifier,
    ACTIONS(1598), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1268), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(935), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1596), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48851] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(798), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48920] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1600), 1,
      sym_identifier,
    ACTIONS(1604), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1283), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(874), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1602), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [48993] = 14,
    ACTIONS(771), 1,
      anon_sym_STAR,
    ACTIONS(781), 1,
      anon_sym_LBRACE,
    ACTIONS(791), 1,
      sym_string_start,
    ACTIONS(895), 1,
      anon_sym_LPAREN,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(1570), 1,
      anon_sym_type,
    STATE(722), 1,
      sym_primary_expression,
    STATE(900), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(787), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(779), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(789), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1568), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(857), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49062] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(788), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49131] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(786), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49200] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(785), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49269] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(787), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49338] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1606), 1,
      sym_identifier,
    ACTIONS(1610), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1277), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1110), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1608), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49411] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1612), 1,
      sym_identifier,
    ACTIONS(1616), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1242), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1614), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49484] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1598), 1,
      anon_sym_type,
    ACTIONS(1618), 1,
      sym_identifier,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1268), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(935), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1596), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49557] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1620), 1,
      sym_identifier,
    ACTIONS(1624), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1268), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1215), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1622), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49630] = 14,
    ACTIONS(551), 1,
      anon_sym_LBRACK,
    ACTIONS(555), 1,
      anon_sym_LBRACE,
    ACTIONS(567), 1,
      sym_string_start,
    ACTIONS(833), 1,
      anon_sym_LPAREN,
    ACTIONS(835), 1,
      anon_sym_STAR,
    ACTIONS(1530), 1,
      anon_sym_type,
    STATE(719), 1,
      sym_primary_expression,
    STATE(862), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(563), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(553), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(565), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1528), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(820), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49699] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(804), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49768] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(810), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49837] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(812), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49906] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1576), 1,
      sym_identifier,
    ACTIONS(1580), 1,
      anon_sym_type,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1273), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1113), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1578), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [49979] = 16,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1566), 1,
      anon_sym_type,
    ACTIONS(1626), 1,
      sym_identifier,
    STATE(926), 1,
      sym_list_splat_pattern,
    STATE(1275), 1,
      sym_primary_expression,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    STATE(1009), 2,
      sym_attribute,
      sym_subscript,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1564), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 12,
      sym_binary_operator,
      sym_unary_operator,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [50052] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(945), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [50121] = 14,
    ACTIONS(585), 1,
      anon_sym_LBRACE,
    ACTIONS(595), 1,
      sym_string_start,
    ACTIONS(845), 1,
      anon_sym_LPAREN,
    ACTIONS(847), 1,
      anon_sym_STAR,
    ACTIONS(855), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 1,
      anon_sym_type,
    STATE(814), 1,
      sym_primary_expression,
    STATE(963), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(591), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(583), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(593), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1536), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1032), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [50190] = 14,
    ACTIONS(523), 1,
      anon_sym_LBRACE,
    ACTIONS(533), 1,
      sym_string_start,
    ACTIONS(691), 1,
      anon_sym_LBRACK,
    ACTIONS(713), 1,
      anon_sym_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_STAR,
    ACTIONS(1574), 1,
      anon_sym_type,
    STATE(840), 1,
      sym_primary_expression,
    STATE(1023), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(529), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(521), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(531), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1572), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(965), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [50259] = 14,
    ACTIONS(251), 1,
      anon_sym_LPAREN,
    ACTIONS(259), 1,
      anon_sym_LBRACK,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(275), 1,
      sym_string_start,
    ACTIONS(1049), 1,
      anon_sym_STAR,
    ACTIONS(1554), 1,
      anon_sym_type,
    STATE(775), 1,
      sym_primary_expression,
    STATE(926), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(271), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(267), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(273), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1552), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(996), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [50328] = 14,
    ACTIONS(477), 1,
      anon_sym_LPAREN,
    ACTIONS(487), 1,
      anon_sym_LBRACK,
    ACTIONS(493), 1,
      anon_sym_LBRACE,
    ACTIONS(503), 1,
      sym_string_start,
    ACTIONS(945), 1,
      anon_sym_STAR,
    ACTIONS(1534), 1,
      anon_sym_type,
    STATE(946), 1,
      sym_primary_expression,
    STATE(1073), 1,
      sym_list_splat_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(499), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(491), 3,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_TILDE,
    ACTIONS(501), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    ACTIONS(1532), 6,
      anon_sym_print,
      anon_sym_match,
      anon_sym_async,
      anon_sym_exec,
      anon_sym_await,
      anon_sym_struct,
    STATE(1082), 14,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_set,
      sym_tuple,
      sym_dictionary,
      sym_list_comprehension,
      sym_dictionary_comprehension,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_string,
  [50397] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [50442] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [50487] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [50532] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [50577] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1224), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1222), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [50622] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1202), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1200), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [50667] = 19,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1634), 1,
      anon_sym_as,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    ACTIONS(1650), 1,
      anon_sym_PIPE,
    ACTIONS(1652), 1,
      anon_sym_not,
    ACTIONS(1654), 1,
      anon_sym_AMP,
    ACTIONS(1656), 1,
      anon_sym_CARET,
    STATE(835), 1,
      sym_argument_list,
    STATE(1224), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1636), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1648), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1646), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1640), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1632), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [50744] = 19,
    ACTIONS(1634), 1,
      anon_sym_EQ,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    ACTIONS(1678), 1,
      anon_sym_PIPE,
    ACTIONS(1680), 1,
      anon_sym_not,
    ACTIONS(1682), 1,
      anon_sym_AMP,
    ACTIONS(1684), 1,
      anon_sym_CARET,
    STATE(769), 1,
      sym_argument_list,
    STATE(1203), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1676), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1686), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1674), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1668), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1632), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [50821] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1206), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1204), 30,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [50866] = 19,
    ACTIONS(1634), 1,
      anon_sym_EQ,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    ACTIONS(1706), 1,
      anon_sym_PIPE,
    ACTIONS(1708), 1,
      anon_sym_not,
    ACTIONS(1710), 1,
      anon_sym_AMP,
    ACTIONS(1712), 1,
      anon_sym_CARET,
    STATE(878), 1,
      sym_argument_list,
    STATE(1218), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1692), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1694), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1704), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1714), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1702), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1696), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1632), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [50943] = 14,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    ACTIONS(1654), 1,
      anon_sym_AMP,
    ACTIONS(1656), 1,
      anon_sym_CARET,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1636), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1648), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1646), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51009] = 19,
    ACTIONS(1634), 1,
      anon_sym_EQ,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    ACTIONS(1738), 1,
      anon_sym_PIPE,
    ACTIONS(1740), 1,
      anon_sym_not,
    ACTIONS(1742), 1,
      anon_sym_AMP,
    ACTIONS(1744), 1,
      anon_sym_CARET,
    STATE(1008), 1,
      sym_argument_list,
    STATE(1213), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1724), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1726), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1736), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1746), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1734), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1728), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1632), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [51085] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 28,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51131] = 8,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1750), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1748), 25,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51185] = 8,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 25,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51239] = 15,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    ACTIONS(1678), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_AMP,
    ACTIONS(1684), 1,
      anon_sym_CARET,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1676), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1674), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1754), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1752), 15,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51307] = 6,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1756), 1,
      anon_sym_LBRACK,
    STATE(1513), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51357] = 6,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1758), 1,
      anon_sym_LBRACK,
    STATE(1543), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 26,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51407] = 14,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    ACTIONS(1682), 1,
      anon_sym_AMP,
    ACTIONS(1684), 1,
      anon_sym_CARET,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1676), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1674), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 16,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51473] = 10,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1674), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 22,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51531] = 13,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    ACTIONS(1684), 1,
      anon_sym_CARET,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1676), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1674), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51595] = 8,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 25,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51649] = 6,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1168), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1160), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1165), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51699] = 8,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1750), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1748), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51753] = 6,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1168), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1160), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1165), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51803] = 6,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1218), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1208), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1215), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51853] = 15,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    ACTIONS(1706), 1,
      anon_sym_PIPE,
    ACTIONS(1710), 1,
      anon_sym_AMP,
    ACTIONS(1712), 1,
      anon_sym_CARET,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1692), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1694), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1704), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1702), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1762), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1760), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [51921] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [51967] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52013] = 12,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1676), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1674), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52075] = 8,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52129] = 11,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1636), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1648), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1646), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 20,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52189] = 15,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    ACTIONS(1650), 1,
      anon_sym_PIPE,
    ACTIONS(1654), 1,
      anon_sym_AMP,
    ACTIONS(1656), 1,
      anon_sym_CARET,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1636), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1648), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1646), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1754), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1752), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52257] = 8,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 25,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52311] = 10,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1636), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1646), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 22,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52369] = 13,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    ACTIONS(1656), 1,
      anon_sym_CARET,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1636), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1648), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1646), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52433] = 12,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1636), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1648), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1646), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52495] = 15,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1630), 1,
      anon_sym_LPAREN,
    ACTIONS(1642), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    ACTIONS(1650), 1,
      anon_sym_PIPE,
    ACTIONS(1654), 1,
      anon_sym_AMP,
    ACTIONS(1656), 1,
      anon_sym_CARET,
    STATE(835), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1636), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1638), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1648), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1646), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1762), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1760), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52563] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52609] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52655] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [52701] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [52747] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [52793] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [52839] = 19,
    ACTIONS(1634), 1,
      anon_sym_EQ,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1784), 1,
      anon_sym_not,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    STATE(1211), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1790), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1772), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1632), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_and,
      anon_sym_or,
  [52915] = 8,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1750), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1748), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [52969] = 15,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    ACTIONS(1678), 1,
      anon_sym_PIPE,
    ACTIONS(1682), 1,
      anon_sym_AMP,
    ACTIONS(1684), 1,
      anon_sym_CARET,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1676), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1674), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1762), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1760), 15,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [53037] = 11,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    STATE(769), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1676), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1674), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 20,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [53097] = 19,
    ACTIONS(1634), 1,
      anon_sym_as,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_PIPE,
    ACTIONS(1812), 1,
      anon_sym_not,
    ACTIONS(1814), 1,
      anon_sym_AMP,
    ACTIONS(1816), 1,
      anon_sym_CARET,
    STATE(1007), 1,
      sym_argument_list,
    STATE(1237), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1796), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1798), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1808), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1818), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1806), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1800), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1632), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [53173] = 5,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53221] = 5,
    ACTIONS(1095), 1,
      anon_sym_COMMA,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53269] = 5,
    ACTIONS(219), 1,
      anon_sym_COMMA,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53317] = 18,
    ACTIONS(1662), 1,
      anon_sym_LPAREN,
    ACTIONS(1670), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1678), 1,
      anon_sym_PIPE,
    ACTIONS(1680), 1,
      anon_sym_not,
    ACTIONS(1682), 1,
      anon_sym_AMP,
    ACTIONS(1684), 1,
      anon_sym_CARET,
    ACTIONS(1820), 1,
      anon_sym_DOT,
    ACTIONS(1822), 1,
      anon_sym_LBRACK,
    STATE(769), 1,
      sym_argument_list,
    STATE(1203), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1664), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1666), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1676), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1686), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1674), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1668), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1632), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [53391] = 8,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53445] = 11,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1692), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1704), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1702), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 20,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53505] = 15,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    ACTIONS(1706), 1,
      anon_sym_PIPE,
    ACTIONS(1710), 1,
      anon_sym_AMP,
    ACTIONS(1712), 1,
      anon_sym_CARET,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1692), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1694), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1704), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1702), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1754), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1752), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53573] = 8,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53627] = 10,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1692), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1702), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 22,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53685] = 14,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    ACTIONS(1710), 1,
      anon_sym_AMP,
    ACTIONS(1712), 1,
      anon_sym_CARET,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1692), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1694), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1704), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1702), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53751] = 13,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    ACTIONS(1712), 1,
      anon_sym_CARET,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1692), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1694), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1704), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1702), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53815] = 12,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    STATE(878), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1692), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1694), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1704), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1702), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 18,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [53877] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [53922] = 8,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1750), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1748), 24,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [53975] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54020] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54065] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54110] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1208), 15,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54157] = 5,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1160), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1165), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54204] = 5,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1208), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1215), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54251] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1826), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1824), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54294] = 8,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1750), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1748), 24,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54347] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54390] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54433] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1830), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1828), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54476] = 8,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 24,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54529] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54572] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54615] = 8,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 24,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54668] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1224), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1222), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54711] = 15,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1762), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1760), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54778] = 15,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_PIPE,
    ACTIONS(1814), 1,
      anon_sym_AMP,
    ACTIONS(1816), 1,
      anon_sym_CARET,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1796), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1798), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1808), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1754), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1806), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1752), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54845] = 6,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1832), 1,
      anon_sym_LBRACK,
    STATE(1676), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54894] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1202), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1200), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54937] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1836), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1834), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [54980] = 11,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1796), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1808), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1806), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 19,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55039] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55082] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55125] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1840), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1838), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55168] = 5,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1160), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1165), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55215] = 12,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55276] = 13,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55339] = 10,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1796), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1806), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 21,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55396] = 14,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55461] = 8,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 24,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55514] = 11,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1724), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1736), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1734), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 19,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55573] = 15,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    ACTIONS(1738), 1,
      anon_sym_PIPE,
    ACTIONS(1742), 1,
      anon_sym_AMP,
    ACTIONS(1744), 1,
      anon_sym_CARET,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1724), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1726), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1736), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1734), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1754), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1752), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55640] = 8,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 24,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55693] = 10,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1724), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1734), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55750] = 14,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    ACTIONS(1742), 1,
      anon_sym_AMP,
    ACTIONS(1744), 1,
      anon_sym_CARET,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1724), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1726), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1736), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1734), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 15,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55815] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1844), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1842), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55858] = 13,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    ACTIONS(1744), 1,
      anon_sym_CARET,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1724), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1726), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1736), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1734), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 16,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55921] = 12,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1724), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1726), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1736), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1734), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 17,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [55982] = 10,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 21,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56039] = 8,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 24,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56092] = 15,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1754), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1752), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56159] = 11,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 19,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56218] = 8,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 24,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56271] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1206), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1204), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56314] = 14,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    ACTIONS(1814), 1,
      anon_sym_AMP,
    ACTIONS(1816), 1,
      anon_sym_CARET,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1796), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1798), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1808), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1806), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56379] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56424] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56469] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1848), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1846), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56512] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56557] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1194), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56600] = 13,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    ACTIONS(1816), 1,
      anon_sym_CARET,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1796), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1798), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1808), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1806), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56663] = 6,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1107), 1,
      anon_sym_LBRACK,
    STATE(1677), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 25,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56712] = 12,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1796), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1798), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1808), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1718), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1806), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1852), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1850), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56816] = 15,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1794), 1,
      anon_sym_LPAREN,
    ACTIONS(1802), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    ACTIONS(1810), 1,
      anon_sym_PIPE,
    ACTIONS(1814), 1,
      anon_sym_AMP,
    ACTIONS(1816), 1,
      anon_sym_CARET,
    STATE(1007), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1796), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1798), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1808), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1762), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1806), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1760), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56883] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56926] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [56969] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57012] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57055] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1856), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1854), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57098] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57141] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1860), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1858), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57184] = 4,
    ACTIONS(1191), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1194), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [57229] = 4,
    ACTIONS(1095), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [57274] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1864), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1862), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57317] = 4,
    ACTIONS(1135), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [57362] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [57409] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [57456] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57501] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57546] = 4,
    ACTIONS(1172), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [57591] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57634] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57677] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1848), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1846), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57720] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1868), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1866), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57763] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1830), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1828), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57806] = 18,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    ACTIONS(1888), 1,
      anon_sym_PIPE,
    ACTIONS(1890), 1,
      anon_sym_not,
    ACTIONS(1892), 1,
      anon_sym_AMP,
    ACTIONS(1894), 1,
      anon_sym_CARET,
    STATE(1057), 1,
      sym_argument_list,
    STATE(1222), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1874), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1876), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1886), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1896), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1884), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1878), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1632), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [57879] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1836), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1834), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57922] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1826), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1824), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [57965] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1840), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1838), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58008] = 15,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1722), 1,
      anon_sym_LPAREN,
    ACTIONS(1730), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    ACTIONS(1738), 1,
      anon_sym_PIPE,
    ACTIONS(1742), 1,
      anon_sym_AMP,
    ACTIONS(1744), 1,
      anon_sym_CARET,
    STATE(1008), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1724), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1726), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1736), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1734), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1762), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1760), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58075] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1852), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1850), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58118] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1856), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1854), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58161] = 8,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1750), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1748), 24,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58214] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1860), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1858), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58257] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1868), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1866), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58300] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1900), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1898), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58343] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1904), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1902), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58386] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1844), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1842), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58429] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1908), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1906), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58472] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1912), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1910), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58515] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1916), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1914), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58558] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1920), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1918), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58601] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1924), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1922), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58644] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1928), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1926), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58687] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1932), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1930), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58730] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1936), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1934), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58773] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [58816] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1864), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1862), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [58859] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1208), 3,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1215), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [58904] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(212), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(214), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(247), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [58949] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(212), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(214), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(247), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [58994] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1194), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59037] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 15,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59084] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 15,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59131] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [59174] = 5,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(219), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59221] = 5,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1095), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1098), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59268] = 5,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(219), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59315] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [59358] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1848), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1846), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [59401] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1900), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1898), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59444] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1864), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1862), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59487] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1904), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1902), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59530] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1208), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59577] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1908), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1906), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59620] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1912), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1910), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59663] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1916), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1914), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [59706] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1830), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1828), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [59749] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1836), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1834), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [59792] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1826), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1824), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [59835] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1840), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1838), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [59878] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1852), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1850), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [59921] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1856), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1854), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [59964] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1860), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1858), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60007] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1868), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1866), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60050] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1900), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1898), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60093] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1904), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1902), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60136] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1844), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1842), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60179] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1908), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1906), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60222] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1912), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1910), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60265] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1916), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1914), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60308] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1936), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1934), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [60351] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1932), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1930), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [60394] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1918), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60437] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1924), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1922), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60480] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1928), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1926), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60523] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1932), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1930), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60566] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1936), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1934), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60609] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [60652] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1194), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60695] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60738] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60781] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1206), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1204), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60824] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1202), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1200), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60867] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1224), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1222), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60910] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [60953] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1928), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1926), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [60996] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [61039] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [61082] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [61125] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1208), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      sym_type_conversion,
  [61172] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1924), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1922), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61215] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61262] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 15,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61309] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1189), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1194), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1109), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [61354] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1093), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1109), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [61399] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1133), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1138), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1140), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [61444] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1170), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1175), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1179), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [61489] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1918), 29,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61532] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1936), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1934), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61574] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1852), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1850), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61616] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1932), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1930), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61658] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1936), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1934), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61700] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61742] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61784] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1194), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61826] = 18,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    ACTIONS(1690), 1,
      anon_sym_LPAREN,
    ACTIONS(1698), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1706), 1,
      anon_sym_PIPE,
    ACTIONS(1708), 1,
      anon_sym_not,
    ACTIONS(1710), 1,
      anon_sym_AMP,
    ACTIONS(1712), 1,
      anon_sym_CARET,
    STATE(878), 1,
      sym_argument_list,
    STATE(1218), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1692), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1694), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1704), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1714), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1702), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1632), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(1696), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61898] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61940] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [61982] = 5,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62028] = 5,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1940), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62074] = 5,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1938), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62120] = 7,
    ACTIONS(1220), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1210), 5,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1208), 11,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1212), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [62170] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1208), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [62216] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1208), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [62262] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1160), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [62308] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_as,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1160), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [62354] = 15,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    ACTIONS(1888), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_AMP,
    ACTIONS(1894), 1,
      anon_sym_CARET,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1762), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1874), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1876), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1886), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1884), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1760), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62420] = 12,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1874), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1876), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1886), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1884), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62480] = 13,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    ACTIONS(1894), 1,
      anon_sym_CARET,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1874), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1876), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1886), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1884), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62542] = 14,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    ACTIONS(1892), 1,
      anon_sym_AMP,
    ACTIONS(1894), 1,
      anon_sym_CARET,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1874), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1876), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1886), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1884), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62606] = 10,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1874), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1884), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 21,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62662] = 8,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 24,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62714] = 15,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    ACTIONS(1888), 1,
      anon_sym_PIPE,
    ACTIONS(1892), 1,
      anon_sym_AMP,
    ACTIONS(1894), 1,
      anon_sym_CARET,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1754), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1874), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1876), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1886), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1884), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1752), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62780] = 11,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1874), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1886), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1884), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1716), 19,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62838] = 8,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1718), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1716), 24,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62890] = 8,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    STATE(1057), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1750), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1748), 24,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62942] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [62986] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63030] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63074] = 18,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    ACTIONS(1872), 1,
      anon_sym_LPAREN,
    ACTIONS(1880), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1888), 1,
      anon_sym_PIPE,
    ACTIONS(1890), 1,
      anon_sym_not,
    ACTIONS(1892), 1,
      anon_sym_AMP,
    ACTIONS(1894), 1,
      anon_sym_CARET,
    STATE(1057), 1,
      sym_argument_list,
    STATE(1222), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1874), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1876), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1886), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1896), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1884), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1632), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(1878), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63146] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1160), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [63192] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1160), 14,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [63238] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63280] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63322] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63364] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63406] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1224), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1222), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63448] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1202), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1200), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63490] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1206), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1204), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63532] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63574] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63616] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1194), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63658] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1208), 2,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(1215), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63702] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63744] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1864), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1862), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63786] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63828] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63870] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1936), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1934), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63912] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1932), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1930), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63954] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [63996] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64038] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1224), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1222), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64080] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1928), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1926), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64122] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1924), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1922), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64164] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1920), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1918), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64206] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1202), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1200), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64248] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1916), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1914), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64290] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1912), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1910), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64332] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1160), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [64378] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1160), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [64424] = 7,
    ACTIONS(1220), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1210), 5,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1208), 11,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1212), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [64474] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64516] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64558] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1224), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1222), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64600] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1908), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1906), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64642] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1844), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1842), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64684] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1904), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1902), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64726] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1900), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1898), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64768] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64810] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64852] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1848), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1846), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64894] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1928), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1926), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64936] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1868), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1866), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [64978] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1924), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1922), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65020] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65062] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1206), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1204), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65104] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1860), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1858), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65146] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1856), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1854), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65188] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1852), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1850), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65230] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65272] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65314] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1840), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1838), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65356] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1864), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1862), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65398] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1826), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1824), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65440] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1836), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1834), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65482] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1830), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1828), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65524] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1830), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1828), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65566] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1208), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [65612] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1918), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65654] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1836), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1834), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65696] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1826), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1824), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65738] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1840), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1838), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65780] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1848), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1846), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65822] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65864] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65906] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65948] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [65990] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1172), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1175), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66034] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1848), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1846), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66076] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1852), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1850), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66118] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1856), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1854), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66160] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1194), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66202] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1135), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1138), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66246] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1864), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1862), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66288] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1095), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1098), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66332] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1202), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1200), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66374] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1916), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1914), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66416] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1912), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1910), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66458] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1860), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1858), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66500] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1191), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1194), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 26,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66544] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 5,
      anon_sym_as,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66586] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1932), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1930), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66628] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1928), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1926), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66670] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1924), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1922), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66712] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1920), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1918), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66754] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1916), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1914), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66796] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1830), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1828), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66838] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1912), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1910), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66880] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1836), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1834), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66922] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1908), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1906), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [66964] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1844), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1842), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67006] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1908), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1906), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67048] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1904), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1902), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67090] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1844), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1842), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67132] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1900), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1898), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67174] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1206), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1204), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67216] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1826), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1824), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67258] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1840), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1838), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67300] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1868), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1866), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67342] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1904), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1902), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67384] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1868), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1866), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67426] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1900), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1898), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67468] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1856), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1854), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67510] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1860), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1858), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67552] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1936), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1934), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67593] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1830), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1828), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67634] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67677] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67720] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67763] = 5,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(219), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(214), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 25,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67808] = 5,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1095), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1098), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 25,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [67853] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1224), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1222), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [67894] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1129), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [67935] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1129), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [67976] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1152), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [68017] = 5,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(219), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(214), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 25,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68062] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68105] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68148] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68191] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(212), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(214), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(247), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [68234] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1152), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [68275] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1194), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68316] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68357] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(212), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(214), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(247), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [68400] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68441] = 6,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1210), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
    ACTIONS(1208), 11,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1212), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [68488] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1928), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1926), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68529] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68572] = 4,
    ACTIONS(229), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1162), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68615] = 4,
    ACTIONS(1100), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68658] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68699] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1189), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1194), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1109), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [68742] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1093), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1098), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1109), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [68785] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1864), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1862), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [68826] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1133), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1138), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1140), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [68869] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1160), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [68914] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1165), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1168), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1160), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1162), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [68959] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1170), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1175), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1179), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [69002] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69043] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(212), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69084] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1848), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1846), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69125] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1924), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1922), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69166] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1836), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1834), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69207] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1826), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1824), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69248] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1840), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1838), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69289] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1852), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1850), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69330] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1856), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1854), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69371] = 7,
    ACTIONS(1220), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1210), 4,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(1208), 11,
      anon_sym_as,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1212), 12,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [69420] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1932), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1930), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69461] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1860), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1858), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69502] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1868), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1866), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69543] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1900), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1898), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69584] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1904), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1902), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69625] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1844), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1842), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69666] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1908), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1906), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69707] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1206), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1204), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [69748] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1202), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1200), 19,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_LBRACK,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [69789] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1912), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1910), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69830] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1212), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1215), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1208), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [69873] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1916), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1914), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69914] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1920), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1918), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [69955] = 5,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1218), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1208), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_RBRACK,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [70000] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1162), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1165), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [70043] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1162), 3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
    ACTIONS(1165), 13,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
    ACTIONS(1160), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [70086] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70127] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1154), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1152), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70168] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70209] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1131), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1129), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70250] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1224), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1222), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70291] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1202), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1200), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70332] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1206), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1204), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70373] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70413] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70453] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1215), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1212), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70493] = 20,
    ACTIONS(1942), 1,
      sym_identifier,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1946), 1,
      anon_sym_STAR,
    ACTIONS(1948), 1,
      anon_sym_if,
    ACTIONS(1950), 1,
      anon_sym_COLON,
    ACTIONS(1952), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1804), 1,
      sym_case_pattern,
    STATE(2116), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1743), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1958), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1532), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [70567] = 20,
    ACTIONS(1942), 1,
      sym_identifier,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1946), 1,
      anon_sym_STAR,
    ACTIONS(1948), 1,
      anon_sym_if,
    ACTIONS(1952), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(1968), 1,
      anon_sym_COLON,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1804), 1,
      sym_case_pattern,
    STATE(2142), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1743), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1958), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1532), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [70641] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1191), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1194), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1189), 25,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70683] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1095), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1098), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1093), 25,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70725] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1135), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1138), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1133), 25,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70767] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1172), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1175), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1170), 25,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [70809] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1974), 1,
      anon_sym_RPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [70877] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2004), 1,
      anon_sym_RBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1919), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [70945] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2018), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71013] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2020), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1919), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71081] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2022), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71149] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2024), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1919), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71217] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2026), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71285] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2028), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71353] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2030), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1786), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71421] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2032), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71489] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2034), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1760), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71557] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2036), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1758), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71625] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2038), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71693] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2040), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1919), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71761] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2042), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71829] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2044), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71897] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2046), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [71965] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2048), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1767), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72033] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2050), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1919), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72101] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2052), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1919), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72169] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2054), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72237] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2056), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1766), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72305] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2058), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1745), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72373] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2060), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1919), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72441] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2062), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72509] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2064), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72577] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2066), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1780), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72645] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2068), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1720), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72713] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2070), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1806), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72781] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2072), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1723), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72849] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2074), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72917] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2076), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1709), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [72985] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2078), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1707), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73053] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2080), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73121] = 18,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2082), 1,
      anon_sym_RPAREN,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73189] = 18,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2084), 1,
      anon_sym_RBRACK,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1919), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73257] = 17,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    STATE(1920), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1899), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1984), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1645), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73322] = 17,
    ACTIONS(1994), 1,
      sym_identifier,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    STATE(1919), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1914), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2008), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1614), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73387] = 17,
    ACTIONS(1942), 1,
      sym_identifier,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1946), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1804), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1743), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1958), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1532), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73452] = 17,
    ACTIONS(2086), 1,
      sym_identifier,
    ACTIONS(2088), 1,
      anon_sym_LPAREN,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2094), 1,
      anon_sym_LBRACK,
    ACTIONS(2096), 1,
      anon_sym_DASH,
    ACTIONS(2100), 1,
      anon_sym_LBRACE,
    ACTIONS(2102), 1,
      sym_integer,
    ACTIONS(2104), 1,
      sym_float,
    ACTIONS(2106), 1,
      sym_string_start,
    STATE(1469), 1,
      sym_string,
    STATE(1650), 1,
      sym_dotted_name,
    STATE(1817), 1,
      sym_case_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2001), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(2098), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1656), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73517] = 17,
    ACTIONS(1942), 1,
      sym_identifier,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1946), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    STATE(1410), 1,
      sym_string,
    STATE(1533), 1,
      sym_case_pattern,
    STATE(1534), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1743), 2,
      sym__as_pattern,
      sym_keyword_pattern,
    ACTIONS(1958), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1532), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73582] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2112), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73648] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2114), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1625), 1,
      sym_splat_pattern,
    STATE(1830), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73714] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2116), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1639), 1,
      sym_splat_pattern,
    STATE(1872), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73780] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2118), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73846] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2120), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73912] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2122), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [73978] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2124), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1651), 1,
      sym_splat_pattern,
    STATE(1873), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74044] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2126), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74110] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2128), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74176] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74242] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2132), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74308] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2134), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74374] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2136), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74440] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2138), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74506] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2140), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74572] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2142), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74638] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2144), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1686), 1,
      sym_splat_pattern,
    STATE(1961), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74704] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2146), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74770] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2148), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74836] = 18,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_RBRACE,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74902] = 17,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2108), 1,
      sym_identifier,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    STATE(1772), 1,
      sym_splat_pattern,
    STATE(2096), 1,
      sym__key_value_pattern,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2110), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1874), 8,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [74965] = 15,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1946), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2108), 1,
      sym_identifier,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2152), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1579), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [75023] = 15,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2154), 1,
      sym_identifier,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2156), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1633), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [75081] = 15,
    ACTIONS(1972), 1,
      anon_sym_LPAREN,
    ACTIONS(1976), 1,
      anon_sym_STAR,
    ACTIONS(1978), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1980), 1,
      anon_sym_LBRACK,
    ACTIONS(1982), 1,
      anon_sym_DASH,
    ACTIONS(1986), 1,
      anon_sym_LBRACE,
    ACTIONS(1988), 1,
      sym_integer,
    ACTIONS(1990), 1,
      sym_float,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(2154), 1,
      sym_identifier,
    STATE(1477), 1,
      sym_string,
    STATE(1646), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2158), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1690), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [75139] = 15,
    ACTIONS(2088), 1,
      anon_sym_LPAREN,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2094), 1,
      anon_sym_LBRACK,
    ACTIONS(2096), 1,
      anon_sym_DASH,
    ACTIONS(2100), 1,
      anon_sym_LBRACE,
    ACTIONS(2102), 1,
      sym_integer,
    ACTIONS(2104), 1,
      sym_float,
    ACTIONS(2106), 1,
      sym_string_start,
    ACTIONS(2160), 1,
      sym_identifier,
    STATE(1469), 1,
      sym_string,
    STATE(1650), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2162), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1688), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [75197] = 15,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2164), 1,
      sym_identifier,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2166), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1680), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [75255] = 15,
    ACTIONS(2088), 1,
      anon_sym_LPAREN,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2094), 1,
      anon_sym_LBRACK,
    ACTIONS(2096), 1,
      anon_sym_DASH,
    ACTIONS(2100), 1,
      anon_sym_LBRACE,
    ACTIONS(2102), 1,
      sym_integer,
    ACTIONS(2104), 1,
      sym_float,
    ACTIONS(2106), 1,
      sym_string_start,
    ACTIONS(2160), 1,
      sym_identifier,
    STATE(1469), 1,
      sym_string,
    STATE(1650), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2168), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1687), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [75313] = 15,
    ACTIONS(1996), 1,
      anon_sym_LPAREN,
    ACTIONS(1998), 1,
      anon_sym_STAR,
    ACTIONS(2000), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2002), 1,
      anon_sym_LBRACK,
    ACTIONS(2006), 1,
      anon_sym_DASH,
    ACTIONS(2010), 1,
      anon_sym_LBRACE,
    ACTIONS(2012), 1,
      sym_integer,
    ACTIONS(2014), 1,
      sym_float,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(2164), 1,
      sym_identifier,
    STATE(1480), 1,
      sym_string,
    STATE(1616), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2170), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1675), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [75371] = 15,
    ACTIONS(1944), 1,
      anon_sym_LPAREN,
    ACTIONS(1946), 1,
      anon_sym_STAR,
    ACTIONS(1952), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1954), 1,
      anon_sym_LBRACK,
    ACTIONS(1956), 1,
      anon_sym_DASH,
    ACTIONS(1960), 1,
      anon_sym_LBRACE,
    ACTIONS(1962), 1,
      sym_integer,
    ACTIONS(1964), 1,
      sym_float,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(2108), 1,
      sym_identifier,
    STATE(1410), 1,
      sym_string,
    STATE(1534), 1,
      sym_dotted_name,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2172), 4,
      anon_sym__,
      sym_true,
      sym_false,
      sym_none,
    STATE(1581), 9,
      sym__simple_pattern,
      sym_union_pattern,
      sym__list_pattern,
      sym__tuple_pattern,
      sym_dict_pattern,
      sym_splat_pattern,
      sym_class_pattern,
      sym_complex_pattern,
      sym_concatenated_string,
  [75429] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(247), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [75461] = 7,
    ACTIONS(1680), 1,
      anon_sym_not,
    ACTIONS(2176), 1,
      anon_sym_EQ,
    STATE(1207), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1686), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1668), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2174), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [75499] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1179), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1170), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [75531] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1140), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1133), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [75563] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1109), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1093), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [75595] = 7,
    ACTIONS(2183), 1,
      anon_sym_EQ,
    ACTIONS(2185), 1,
      anon_sym_not,
    STATE(1207), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2188), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2180), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [75633] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1194), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1109), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(1189), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [75665] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(247), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [75697] = 7,
    ACTIONS(2183), 1,
      anon_sym_EQ,
    ACTIONS(2194), 1,
      anon_sym_not,
    STATE(1210), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2197), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2191), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [75734] = 7,
    ACTIONS(1784), 1,
      anon_sym_not,
    ACTIONS(2176), 1,
      anon_sym_EQ,
    STATE(1212), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1790), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1772), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2174), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [75771] = 7,
    ACTIONS(2183), 1,
      anon_sym_EQ,
    ACTIONS(2203), 1,
      anon_sym_not,
    STATE(1212), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2206), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2200), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [75808] = 7,
    ACTIONS(1740), 1,
      anon_sym_not,
    ACTIONS(2176), 1,
      anon_sym_EQ,
    STATE(1210), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1746), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1728), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2174), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [75845] = 7,
    ACTIONS(2183), 1,
      anon_sym_as,
    ACTIONS(2212), 1,
      anon_sym_not,
    STATE(1214), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2215), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2209), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [75881] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2218), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1093), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [75911] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1208), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1093), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [75941] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2220), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [75971] = 7,
    ACTIONS(1708), 1,
      anon_sym_not,
    ACTIONS(2176), 1,
      anon_sym_EQ,
    STATE(1227), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1714), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1696), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2174), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [76007] = 4,
    ACTIONS(2222), 1,
      anon_sym_COMMA,
    STATE(1221), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(473), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [76037] = 6,
    ACTIONS(2227), 1,
      anon_sym_not,
    STATE(1220), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2230), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2224), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [76071] = 4,
    ACTIONS(2235), 1,
      anon_sym_COMMA,
    STATE(1221), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2233), 17,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [76101] = 6,
    ACTIONS(1890), 1,
      anon_sym_not,
    STATE(1220), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1896), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1878), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2174), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [76135] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1160), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76165] = 7,
    ACTIONS(1652), 1,
      anon_sym_not,
    ACTIONS(2176), 1,
      anon_sym_as,
    STATE(1214), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1658), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1640), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2174), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [76201] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2220), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76231] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1160), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76261] = 7,
    ACTIONS(2183), 1,
      anon_sym_EQ,
    ACTIONS(2241), 1,
      anon_sym_not,
    STATE(1227), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2244), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2238), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [76297] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1140), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1133), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76326] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1160), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76355] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1109), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1093), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76384] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1140), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1133), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76413] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1208), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1093), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76442] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1194), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1189), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76471] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(247), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76500] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(247), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76529] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2247), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [76554] = 7,
    ACTIONS(1812), 1,
      anon_sym_not,
    ACTIONS(2176), 1,
      anon_sym_as,
    STATE(1257), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1818), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1800), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2174), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [76589] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [76614] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2249), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [76639] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2220), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76668] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2220), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76697] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(2218), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(1093), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76726] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2233), 18,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [76751] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1179), 2,
      anon_sym_COMMA,
      anon_sym_in,
    ACTIONS(1170), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76780] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1179), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1170), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76809] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1138), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1140), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1133), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76838] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1194), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1189), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76867] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1109), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(1093), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76896] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1160), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76925] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1175), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1179), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1170), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76954] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1098), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1109), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1093), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [76983] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(247), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [77012] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(1194), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1189), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [77041] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(247), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [77070] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(247), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [77099] = 4,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(214), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(247), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(212), 14,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_GT_GT,
      anon_sym_STAR_STAR,
      anon_sym_LBRACK,
      anon_sym_AT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
  [77128] = 7,
    ACTIONS(2183), 1,
      anon_sym_as,
    ACTIONS(2254), 1,
      anon_sym_not,
    STATE(1257), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2257), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2251), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(2178), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [77163] = 4,
    ACTIONS(2260), 1,
      anon_sym_COMMA,
    STATE(1258), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2233), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [77191] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2233), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [77215] = 13,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2269), 1,
      anon_sym_COLON,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    STATE(1811), 1,
      sym_parameter,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2123), 1,
      sym__parameters,
    STATE(2185), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [77261] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2249), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [77285] = 13,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2275), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_parameter,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2113), 1,
      sym_lambda_parameters,
    STATE(2123), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [77331] = 6,
    ACTIONS(2277), 1,
      anon_sym_COMMA,
    ACTIONS(2279), 1,
      anon_sym_COLON,
    ACTIONS(2281), 1,
      anon_sym_EQ,
    STATE(1282), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2283), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [77363] = 13,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2285), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_parameter,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2123), 1,
      sym__parameters,
    STATE(2158), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [77409] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [77433] = 13,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2287), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_parameter,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2123), 1,
      sym__parameters,
    STATE(2245), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [77479] = 13,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2289), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_parameter,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2123), 1,
      sym__parameters,
    STATE(2195), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [77525] = 13,
    ACTIONS(1720), 1,
      anon_sym_DOT,
    ACTIONS(1732), 1,
      anon_sym_LBRACK,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [77571] = 13,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2291), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_parameter,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2122), 1,
      sym_lambda_parameters,
    STATE(2123), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [77617] = 13,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2293), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_parameter,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2123), 1,
      sym__parameters,
    STATE(2126), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [77663] = 13,
    ACTIONS(1660), 1,
      anon_sym_DOT,
    ACTIONS(1672), 1,
      anon_sym_LBRACK,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [77709] = 13,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    ACTIONS(1820), 1,
      anon_sym_DOT,
    ACTIONS(1822), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [77755] = 13,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    ACTIONS(1870), 1,
      anon_sym_DOT,
    ACTIONS(1882), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [77801] = 13,
    ACTIONS(1688), 1,
      anon_sym_DOT,
    ACTIONS(1700), 1,
      anon_sym_LBRACK,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [77847] = 13,
    ACTIONS(1764), 1,
      anon_sym_DOT,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1776), 1,
      anon_sym_LBRACK,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [77893] = 13,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2295), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_parameter,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2123), 1,
      sym__parameters,
    STATE(2136), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [77939] = 13,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    ACTIONS(2297), 1,
      anon_sym_DOT,
    ACTIONS(2299), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [77985] = 13,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2301), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_parameter,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2123), 1,
      sym__parameters,
    STATE(2211), 1,
      sym_lambda_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [78031] = 5,
    ACTIONS(2279), 1,
      anon_sym_COLON,
    ACTIONS(2281), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2303), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(2283), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [78061] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2247), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [78085] = 13,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    ACTIONS(1792), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_LBRACK,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [78131] = 4,
    ACTIONS(2305), 1,
      anon_sym_COMMA,
    STATE(1258), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(473), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [78159] = 13,
    ACTIONS(1628), 1,
      anon_sym_DOT,
    ACTIONS(1644), 1,
      anon_sym_LBRACK,
    ACTIONS(1766), 1,
      anon_sym_LPAREN,
    ACTIONS(1774), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1782), 1,
      anon_sym_PIPE,
    ACTIONS(1786), 1,
      anon_sym_AMP,
    ACTIONS(1788), 1,
      anon_sym_CARET,
    STATE(1038), 1,
      sym_argument_list,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1768), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1770), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1780), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1778), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [78205] = 6,
    ACTIONS(2279), 1,
      anon_sym_COLON,
    ACTIONS(2281), 1,
      anon_sym_EQ,
    ACTIONS(2307), 1,
      anon_sym_COMMA,
    STATE(1219), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2283), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [78237] = 12,
    ACTIONS(2309), 1,
      sym_identifier,
    ACTIONS(2311), 1,
      anon_sym_LPAREN,
    ACTIONS(2313), 1,
      anon_sym_RPAREN,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2319), 1,
      anon_sym_SLASH,
    STATE(1989), 1,
      sym_tuple_pattern,
    STATE(1994), 1,
      sym_parameter,
    STATE(2226), 1,
      sym__parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1974), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2024), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [78280] = 11,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2321), 1,
      anon_sym_COLON,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2039), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [78320] = 11,
    ACTIONS(2309), 1,
      sym_identifier,
    ACTIONS(2311), 1,
      anon_sym_LPAREN,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2319), 1,
      anon_sym_SLASH,
    ACTIONS(2323), 1,
      anon_sym_RPAREN,
    STATE(1989), 1,
      sym_tuple_pattern,
    STATE(2052), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1974), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2024), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [78360] = 11,
    ACTIONS(2309), 1,
      sym_identifier,
    ACTIONS(2311), 1,
      anon_sym_LPAREN,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2319), 1,
      anon_sym_SLASH,
    ACTIONS(2321), 1,
      anon_sym_RPAREN,
    STATE(1989), 1,
      sym_tuple_pattern,
    STATE(2052), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1974), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2024), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [78400] = 4,
    ACTIONS(2279), 1,
      anon_sym_COLON,
    ACTIONS(2281), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2283), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [78426] = 11,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    ACTIONS(2323), 1,
      anon_sym_COLON,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2039), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [78466] = 10,
    ACTIONS(2263), 1,
      sym_identifier,
    ACTIONS(2265), 1,
      anon_sym_LPAREN,
    ACTIONS(2267), 1,
      anon_sym_STAR,
    ACTIONS(2271), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2273), 1,
      anon_sym_SLASH,
    STATE(1814), 1,
      sym_tuple_pattern,
    STATE(2039), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(2090), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2098), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [78503] = 10,
    ACTIONS(2309), 1,
      sym_identifier,
    ACTIONS(2311), 1,
      anon_sym_LPAREN,
    ACTIONS(2315), 1,
      anon_sym_STAR,
    ACTIONS(2317), 1,
      anon_sym_STAR_STAR,
    ACTIONS(2319), 1,
      anon_sym_SLASH,
    STATE(1989), 1,
      sym_tuple_pattern,
    STATE(2052), 1,
      sym_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1974), 2,
      sym_list_splat_pattern,
      sym_dictionary_splat_pattern,
    STATE(2024), 5,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_positional_separator,
      sym_keyword_separator,
  [78540] = 13,
    ACTIONS(2325), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2331), 1,
      anon_sym_COLON,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2337), 1,
      anon_sym_RBRACE,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1903), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2130), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [78581] = 13,
    ACTIONS(2325), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2331), 1,
      anon_sym_COLON,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2337), 1,
      anon_sym_RBRACE,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1903), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2193), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [78622] = 13,
    ACTIONS(2325), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2331), 1,
      anon_sym_COLON,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2337), 1,
      anon_sym_RBRACE,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1903), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2109), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [78663] = 13,
    ACTIONS(2325), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2331), 1,
      anon_sym_COLON,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2337), 1,
      anon_sym_RBRACE,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1903), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2239), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [78704] = 13,
    ACTIONS(2325), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2331), 1,
      anon_sym_COLON,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2337), 1,
      anon_sym_RBRACE,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1903), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2207), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [78745] = 13,
    ACTIONS(2325), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2331), 1,
      anon_sym_COLON,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2337), 1,
      anon_sym_RBRACE,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1903), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2154), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [78786] = 13,
    ACTIONS(2325), 1,
      anon_sym_COMMA,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2331), 1,
      anon_sym_COLON,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2337), 1,
      anon_sym_RBRACE,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1903), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2198), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [78827] = 9,
    ACTIONS(2347), 1,
      anon_sym_COMMA,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    STATE(1744), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2343), 2,
      sym__newline,
      anon_sym_SEMI,
    ACTIONS(2345), 3,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_PIPE,
  [78859] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1632), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [78877] = 12,
    ACTIONS(2337), 1,
      anon_sym_RBRACK,
    ACTIONS(2357), 1,
      anon_sym_COMMA,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2363), 1,
      anon_sym_async,
    ACTIONS(2365), 1,
      anon_sym_for,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    STATE(1454), 1,
      sym_for_in_clause,
    STATE(1964), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2125), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [78915] = 12,
    ACTIONS(2337), 1,
      anon_sym_RBRACK,
    ACTIONS(2357), 1,
      anon_sym_COMMA,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2363), 1,
      anon_sym_async,
    ACTIONS(2365), 1,
      anon_sym_for,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    STATE(1454), 1,
      sym_for_in_clause,
    STATE(1964), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2155), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [78953] = 3,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 10,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [78973] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [78991] = 12,
    ACTIONS(2337), 1,
      anon_sym_RBRACK,
    ACTIONS(2357), 1,
      anon_sym_COMMA,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2363), 1,
      anon_sym_async,
    ACTIONS(2365), 1,
      anon_sym_for,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    STATE(1454), 1,
      sym_for_in_clause,
    STATE(1964), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2208), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [79029] = 12,
    ACTIONS(2337), 1,
      anon_sym_RBRACK,
    ACTIONS(2357), 1,
      anon_sym_COMMA,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2363), 1,
      anon_sym_async,
    ACTIONS(2365), 1,
      anon_sym_for,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    STATE(1454), 1,
      sym_for_in_clause,
    STATE(1964), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2194), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [79067] = 4,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2373), 9,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79089] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2375), 11,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [79107] = 12,
    ACTIONS(2337), 1,
      anon_sym_RBRACK,
    ACTIONS(2357), 1,
      anon_sym_COMMA,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2363), 1,
      anon_sym_async,
    ACTIONS(2365), 1,
      anon_sym_for,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    STATE(1454), 1,
      sym_for_in_clause,
    STATE(1964), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2176), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [79145] = 6,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2377), 7,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79171] = 5,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(2381), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2379), 8,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79195] = 12,
    ACTIONS(2337), 1,
      anon_sym_RBRACK,
    ACTIONS(2357), 1,
      anon_sym_COMMA,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2363), 1,
      anon_sym_async,
    ACTIONS(2365), 1,
      anon_sym_for,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    STATE(1454), 1,
      sym_for_in_clause,
    STATE(1964), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2240), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [79233] = 12,
    ACTIONS(2337), 1,
      anon_sym_RBRACK,
    ACTIONS(2357), 1,
      anon_sym_COMMA,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2363), 1,
      anon_sym_async,
    ACTIONS(2365), 1,
      anon_sym_for,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    STATE(1454), 1,
      sym_for_in_clause,
    STATE(1964), 1,
      aux_sym__collection_elements_repeat1,
    STATE(2106), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [79271] = 6,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2384), 7,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79297] = 6,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2386), 7,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79323] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2394), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1320), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79352] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1632), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [79369] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2377), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79394] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2404), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79423] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2406), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1325), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79452] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2345), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79477] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [79494] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2416), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79523] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2418), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79552] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2386), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79577] = 4,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2373), 8,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79598] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2386), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79623] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2420), 1,
      anon_sym_LBRACE,
    ACTIONS(2426), 1,
      sym__not_escape_sequence,
    ACTIONS(2429), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2423), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79652] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2431), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1360), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79681] = 8,
    ACTIONS(2433), 1,
      anon_sym_COMMA,
    ACTIONS(2435), 1,
      anon_sym_as,
    ACTIONS(2437), 1,
      anon_sym_if,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    STATE(1590), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2439), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [79710] = 6,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2345), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79735] = 5,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2445), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2379), 7,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79758] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2375), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [79775] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2448), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1324), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79804] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2450), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1346), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79833] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2452), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79862] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2384), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79887] = 4,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2373), 8,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79908] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2384), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [79933] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2454), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1357), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79962] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2456), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [79991] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [80008] = 5,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2458), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2379), 7,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
  [80031] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2461), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1337), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80060] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2463), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80089] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2465), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1359), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80118] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2375), 10,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [80135] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1632), 10,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [80152] = 3,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [80171] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2377), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [80196] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2467), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80225] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2469), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1342), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80254] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2471), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1352), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80283] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2473), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1358), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80312] = 3,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 9,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_or,
  [80331] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2475), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80360] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2477), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80389] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2479), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80418] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2388), 1,
      anon_sym_LBRACE,
    ACTIONS(2392), 1,
      sym__not_escape_sequence,
    ACTIONS(2481), 1,
      sym_string_end,
    STATE(1436), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2390), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
    STATE(1329), 3,
      sym_string_content,
      sym_interpolation,
      aux_sym_string_repeat1,
  [80447] = 6,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2377), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [80471] = 6,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2377), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [80495] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1632), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [80511] = 6,
    ACTIONS(2435), 1,
      anon_sym_as,
    ACTIONS(2437), 1,
      anon_sym_if,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2377), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [80535] = 6,
    ACTIONS(2435), 1,
      anon_sym_as,
    ACTIONS(2437), 1,
      anon_sym_if,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2386), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [80559] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2375), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [80575] = 3,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 8,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_or,
      sym_type_conversion,
  [80593] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [80609] = 4,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2373), 7,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [80629] = 5,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(2491), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2379), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [80651] = 5,
    ACTIONS(2494), 1,
      anon_sym_DOT,
    ACTIONS(2498), 1,
      anon_sym_EQ,
    STATE(1408), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [80673] = 3,
    ACTIONS(2500), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2375), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [80691] = 6,
    ACTIONS(2435), 1,
      anon_sym_as,
    ACTIONS(2437), 1,
      anon_sym_if,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2384), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [80715] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2345), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [80739] = 6,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2384), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [80763] = 5,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2502), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2379), 6,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [80785] = 4,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2373), 7,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [80805] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 9,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_and,
      anon_sym_or,
  [80821] = 3,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 8,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_or,
  [80839] = 3,
    ACTIONS(1634), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1632), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [80857] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2375), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [80873] = 6,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2386), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [80897] = 6,
    ACTIONS(2435), 1,
      anon_sym_as,
    ACTIONS(2437), 1,
      anon_sym_if,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [80921] = 6,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2384), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [80945] = 6,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2345), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [80969] = 5,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(2507), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2379), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [80991] = 6,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2386), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [81015] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1632), 9,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      sym_type_conversion,
  [81031] = 5,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(2510), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2373), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [81053] = 3,
    ACTIONS(2512), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 8,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
  [81071] = 4,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2512), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
      anon_sym_or,
  [81091] = 4,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1414), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2514), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [81110] = 4,
    ACTIONS(2516), 1,
      anon_sym_DOT,
    STATE(1393), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [81129] = 6,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2384), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [81152] = 9,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2521), 1,
      anon_sym_COMMA,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(2525), 1,
      anon_sym_RBRACK,
    STATE(1963), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [81181] = 9,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(2527), 1,
      anon_sym_COMMA,
    ACTIONS(2529), 1,
      anon_sym_RBRACK,
    STATE(1972), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [81210] = 5,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    ACTIONS(2531), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2379), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [81231] = 3,
    ACTIONS(2500), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2375), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [81248] = 9,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(2534), 1,
      anon_sym_COMMA,
    ACTIONS(2536), 1,
      anon_sym_RBRACK,
    STATE(1895), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [81277] = 5,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [81298] = 8,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(2542), 1,
      anon_sym_COMMA,
    STATE(1788), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2540), 2,
      sym__newline,
      anon_sym_SEMI,
  [81325] = 4,
    ACTIONS(2494), 1,
      anon_sym_DOT,
    STATE(1408), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [81344] = 9,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(2544), 1,
      anon_sym_COMMA,
    ACTIONS(2546), 1,
      anon_sym_RBRACK,
    STATE(1863), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [81373] = 5,
    ACTIONS(2548), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_EQ,
    STATE(1438), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [81394] = 9,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(2552), 1,
      anon_sym_COMMA,
    ACTIONS(2554), 1,
      anon_sym_RBRACK,
    STATE(1926), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [81423] = 8,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(2558), 1,
      anon_sym_COMMA,
    STATE(1710), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2556), 2,
      sym__newline,
      anon_sym_SEMI,
  [81450] = 8,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(2560), 1,
      anon_sym_COMMA,
    STATE(1764), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2303), 2,
      sym__newline,
      anon_sym_SEMI,
  [81477] = 4,
    ACTIONS(2494), 1,
      anon_sym_DOT,
    STATE(1393), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2562), 6,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [81496] = 3,
    ACTIONS(1634), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1632), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [81513] = 4,
    ACTIONS(1966), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1392), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2564), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [81532] = 5,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [81553] = 8,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(2558), 1,
      anon_sym_COMMA,
    STATE(1769), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2566), 2,
      sym__newline,
      anon_sym_SEMI,
  [81580] = 5,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [81601] = 4,
    ACTIONS(2570), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1414), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2568), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [81620] = 9,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(2573), 1,
      anon_sym_COMMA,
    ACTIONS(2575), 1,
      anon_sym_RBRACK,
    STATE(2010), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [81649] = 5,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    ACTIONS(2510), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2373), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [81670] = 5,
    ACTIONS(2577), 1,
      anon_sym_DOT,
    ACTIONS(2579), 1,
      anon_sym_EQ,
    STATE(1460), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [81691] = 3,
    ACTIONS(2512), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_and,
      anon_sym_or,
  [81708] = 8,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(2560), 1,
      anon_sym_COMMA,
    STATE(1764), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2581), 2,
      sym__newline,
      anon_sym_SEMI,
  [81735] = 4,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2512), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2371), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_or,
  [81754] = 8,
    ACTIONS(2347), 1,
      anon_sym_COMMA,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    STATE(1744), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2343), 2,
      sym__newline,
      anon_sym_SEMI,
  [81781] = 9,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(2583), 1,
      anon_sym_COMMA,
    ACTIONS(2585), 1,
      anon_sym_RBRACK,
    STATE(1854), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [81810] = 6,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2329), 1,
      anon_sym_if,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2587), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [81833] = 8,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(2560), 1,
      anon_sym_COMMA,
    STATE(1764), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2589), 2,
      sym__newline,
      anon_sym_SEMI,
  [81860] = 5,
    ACTIONS(2591), 1,
      anon_sym_DOT,
    ACTIONS(2593), 1,
      anon_sym_EQ,
    STATE(1479), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [81881] = 5,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [81902] = 5,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [81923] = 6,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2386), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [81946] = 9,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(2595), 1,
      anon_sym_COMMA,
    ACTIONS(2597), 1,
      anon_sym_RBRACK,
    STATE(1910), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [81975] = 9,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(2599), 1,
      anon_sym_COMMA,
    ACTIONS(2601), 1,
      anon_sym_RBRACK,
    STATE(1945), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82004] = 8,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(2558), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2603), 2,
      sym__newline,
      anon_sym_SEMI,
  [82031] = 5,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2538), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [82052] = 6,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2361), 1,
      anon_sym_if,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2377), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [82075] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2605), 1,
      anon_sym_RPAREN,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    STATE(1979), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82101] = 4,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1437), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2514), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [82119] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2613), 1,
      sym__not_escape_sequence,
    STATE(1482), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2609), 2,
      sym_string_end,
      anon_sym_LBRACE,
    ACTIONS(2611), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [82141] = 4,
    ACTIONS(2615), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1437), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2568), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [82159] = 4,
    ACTIONS(2548), 1,
      anon_sym_DOT,
    STATE(1458), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2562), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [82177] = 7,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2618), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1051), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [82201] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 7,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [82215] = 4,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1468), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2514), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [82233] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2620), 1,
      anon_sym_RPAREN,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82259] = 8,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2624), 1,
      anon_sym_COMMA,
    ACTIONS(2626), 1,
      anon_sym_COLON,
    STATE(2012), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82285] = 6,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2628), 1,
      anon_sym_if,
    ACTIONS(2630), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1450), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [82307] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2632), 1,
      anon_sym_RPAREN,
    ACTIONS(2634), 1,
      anon_sym_COMMA,
    STATE(1941), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82333] = 4,
    ACTIONS(2636), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1446), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2568), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [82351] = 8,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2639), 1,
      anon_sym_COMMA,
    ACTIONS(2641), 1,
      anon_sym_RBRACE,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1955), 1,
      aux_sym_dictionary_repeat1,
    STATE(2199), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82377] = 8,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2643), 1,
      anon_sym_COMMA,
    ACTIONS(2645), 1,
      anon_sym_COLON,
    STATE(1960), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82403] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2647), 1,
      anon_sym_RPAREN,
    ACTIONS(2649), 1,
      anon_sym_COMMA,
    STATE(2009), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82429] = 6,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2628), 1,
      anon_sym_if,
    ACTIONS(2651), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1489), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [82451] = 4,
    ACTIONS(2653), 1,
      anon_sym_DOT,
    STATE(1451), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [82469] = 6,
    ACTIONS(2656), 1,
      anon_sym_if,
    ACTIONS(2659), 1,
      anon_sym_async,
    ACTIONS(2662), 1,
      anon_sym_for,
    ACTIONS(2665), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1452), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [82491] = 5,
    ACTIONS(2359), 1,
      anon_sym_as,
    ACTIONS(2367), 1,
      anon_sym_and,
    ACTIONS(2369), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2667), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [82511] = 6,
    ACTIONS(2363), 1,
      anon_sym_async,
    ACTIONS(2365), 1,
      anon_sym_for,
    ACTIONS(2630), 1,
      anon_sym_RBRACK,
    ACTIONS(2669), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1456), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [82533] = 4,
    ACTIONS(2548), 1,
      anon_sym_DOT,
    STATE(1438), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [82551] = 6,
    ACTIONS(2363), 1,
      anon_sym_async,
    ACTIONS(2365), 1,
      anon_sym_for,
    ACTIONS(2651), 1,
      anon_sym_RBRACK,
    ACTIONS(2669), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1452), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [82573] = 8,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2624), 1,
      anon_sym_COMMA,
    ACTIONS(2671), 1,
      anon_sym_COLON,
    STATE(2012), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82599] = 4,
    ACTIONS(2673), 1,
      anon_sym_DOT,
    STATE(1458), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [82617] = 8,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2676), 1,
      anon_sym_COMMA,
    ACTIONS(2678), 1,
      anon_sym_RBRACE,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1985), 1,
      aux_sym_dictionary_repeat1,
    STATE(2197), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82643] = 4,
    ACTIONS(2577), 1,
      anon_sym_DOT,
    STATE(1451), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2562), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [82661] = 6,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2680), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [82683] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(2682), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82709] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2684), 1,
      anon_sym_RPAREN,
    ACTIONS(2686), 1,
      anon_sym_COMMA,
    STATE(1850), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82735] = 7,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(2523), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2688), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [82759] = 8,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2690), 1,
      anon_sym_COMMA,
    ACTIONS(2692), 1,
      anon_sym_RBRACE,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(2013), 1,
      aux_sym_dictionary_repeat1,
    STATE(2153), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82785] = 8,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2694), 1,
      anon_sym_COMMA,
    ACTIONS(2696), 1,
      anon_sym_RBRACE,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1826), 1,
      aux_sym_dictionary_repeat1,
    STATE(2110), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82811] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(2698), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82837] = 4,
    ACTIONS(2700), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1468), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2568), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [82855] = 4,
    ACTIONS(2106), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1481), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2564), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [82873] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2703), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [82889] = 6,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [82911] = 8,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2624), 1,
      anon_sym_COMMA,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    STATE(2012), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82937] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(2707), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [82963] = 5,
    ACTIONS(2327), 1,
      anon_sym_as,
    ACTIONS(2339), 1,
      anon_sym_and,
    ACTIONS(2341), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2667), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [82983] = 8,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2624), 1,
      anon_sym_COMMA,
    ACTIONS(2709), 1,
      anon_sym_COLON,
    STATE(2012), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83009] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(2711), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83035] = 4,
    ACTIONS(1992), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1435), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2564), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [83053] = 4,
    ACTIONS(2591), 1,
      anon_sym_DOT,
    STATE(1479), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [83071] = 4,
    ACTIONS(2591), 1,
      anon_sym_DOT,
    STATE(1496), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2562), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [83089] = 4,
    ACTIONS(2016), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1441), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2564), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [83107] = 4,
    ACTIONS(2106), 1,
      sym_string_start,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1446), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(2514), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [83125] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2718), 1,
      sym__not_escape_sequence,
    STATE(1482), 1,
      aux_sym_string_content_repeat1,
    ACTIONS(2713), 2,
      sym_string_end,
      anon_sym_LBRACE,
    ACTIONS(2715), 3,
      sym__string_content,
      sym_escape_interpolation,
      sym_escape_sequence,
  [83147] = 6,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2721), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [83169] = 8,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2723), 1,
      anon_sym_COMMA,
    ACTIONS(2725), 1,
      anon_sym_COLON,
    STATE(1954), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83195] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(2727), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83221] = 7,
    ACTIONS(1021), 1,
      anon_sym_COLON,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1019), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [83245] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(2729), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83271] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2733), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2731), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [83287] = 6,
    ACTIONS(2665), 1,
      anon_sym_RBRACE,
    ACTIONS(2735), 1,
      anon_sym_if,
    ACTIONS(2738), 1,
      anon_sym_async,
    ACTIONS(2741), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1489), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [83309] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2707), 1,
      anon_sym_RPAREN,
    ACTIONS(2744), 1,
      anon_sym_COMMA,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83335] = 8,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2747), 1,
      anon_sym_COMMA,
    ACTIONS(2749), 1,
      anon_sym_RBRACE,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1924), 1,
      aux_sym_dictionary_repeat1,
    STATE(2206), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83361] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2751), 1,
      anon_sym_RPAREN,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    STATE(1813), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83387] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2755), 1,
      anon_sym_RPAREN,
    ACTIONS(2757), 1,
      anon_sym_COMMA,
    STATE(1871), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83413] = 8,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(2759), 1,
      anon_sym_RPAREN,
    ACTIONS(2761), 1,
      anon_sym_COMMA,
    STATE(1901), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83439] = 4,
    ACTIONS(2577), 1,
      anon_sym_DOT,
    STATE(1460), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2496), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [83457] = 4,
    ACTIONS(2763), 1,
      anon_sym_DOT,
    STATE(1496), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 5,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [83475] = 8,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    ACTIONS(2768), 1,
      anon_sym_RBRACE,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1891), 1,
      aux_sym_dictionary_repeat1,
    STATE(2129), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83501] = 8,
    ACTIONS(2333), 1,
      anon_sym_async,
    ACTIONS(2335), 1,
      anon_sym_for,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    ACTIONS(2772), 1,
      anon_sym_RBRACE,
    STATE(1444), 1,
      sym_for_in_clause,
    STATE(1831), 1,
      aux_sym_dictionary_repeat1,
    STATE(2238), 1,
      sym__comprehension_clauses,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83527] = 6,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2774), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [83548] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2776), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [83569] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2778), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [83590] = 4,
    ACTIONS(2780), 1,
      anon_sym_COMMA,
    STATE(1527), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2782), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [83607] = 6,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1029), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [83628] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2345), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [83641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2786), 1,
      sym__not_escape_sequence,
    ACTIONS(2784), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [83658] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2788), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [83679] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2790), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [83692] = 4,
    ACTIONS(2792), 1,
      anon_sym_COMMA,
    STATE(1508), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2233), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [83709] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2774), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [83730] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2795), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [83751] = 7,
    ACTIONS(2797), 1,
      anon_sym_DOT,
    ACTIONS(2799), 1,
      anon_sym_COMMA,
    ACTIONS(2801), 1,
      anon_sym_COLON,
    ACTIONS(2803), 1,
      anon_sym_RBRACK,
    ACTIONS(2805), 1,
      anon_sym_PIPE,
    STATE(1859), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [83774] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1210), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [83787] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2807), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [83800] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [83821] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2809), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [83842] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2811), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [83855] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2813), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [83868] = 5,
    ACTIONS(2815), 1,
      anon_sym_DOT,
    ACTIONS(2819), 1,
      anon_sym_COLON,
    ACTIONS(2821), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2817), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [83887] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2823), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [83900] = 6,
    ACTIONS(51), 1,
      anon_sym_AT,
    ACTIONS(2825), 1,
      anon_sym_async,
    ACTIONS(2827), 1,
      anon_sym_def,
    STATE(592), 1,
      sym_function_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1685), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [83921] = 6,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2778), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [83942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2831), 1,
      sym__not_escape_sequence,
    ACTIONS(2829), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [83959] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2833), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [83980] = 7,
    ACTIONS(2797), 1,
      anon_sym_DOT,
    ACTIONS(2801), 1,
      anon_sym_COLON,
    ACTIONS(2805), 1,
      anon_sym_PIPE,
    ACTIONS(2835), 1,
      anon_sym_COMMA,
    ACTIONS(2837), 1,
      anon_sym_RBRACK,
    STATE(1998), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [84003] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2839), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [84018] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2809), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [84039] = 4,
    ACTIONS(2841), 1,
      anon_sym_COMMA,
    STATE(1586), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2843), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [84056] = 4,
    ACTIONS(2845), 1,
      anon_sym_COMMA,
    STATE(1568), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2847), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [84073] = 6,
    ACTIONS(2435), 1,
      anon_sym_as,
    ACTIONS(2437), 1,
      anon_sym_if,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2587), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [84094] = 4,
    ACTIONS(2849), 1,
      anon_sym_COMMA,
    STATE(1530), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [84111] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2852), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [84132] = 4,
    ACTIONS(2856), 1,
      anon_sym_PIPE,
    STATE(1540), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2854), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [84149] = 7,
    ACTIONS(2858), 1,
      anon_sym_COMMA,
    ACTIONS(2860), 1,
      anon_sym_as,
    ACTIONS(2862), 1,
      anon_sym_if,
    ACTIONS(2864), 1,
      anon_sym_COLON,
    STATE(1664), 1,
      aux_sym_case_clause_repeat1,
    STATE(2119), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [84172] = 3,
    ACTIONS(2866), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [84187] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2790), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84200] = 4,
    ACTIONS(2868), 1,
      anon_sym_COMMA,
    STATE(1572), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2782), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [84217] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2870), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [84232] = 6,
    ACTIONS(2435), 1,
      anon_sym_as,
    ACTIONS(2437), 1,
      anon_sym_if,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2778), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [84253] = 4,
    ACTIONS(2872), 1,
      anon_sym_COMMA,
    STATE(1539), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2875), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [84270] = 4,
    ACTIONS(2856), 1,
      anon_sym_PIPE,
    STATE(1584), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2877), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [84287] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2879), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2731), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [84302] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1210), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84315] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2807), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84328] = 7,
    ACTIONS(2797), 1,
      anon_sym_DOT,
    ACTIONS(2801), 1,
      anon_sym_COLON,
    ACTIONS(2805), 1,
      anon_sym_PIPE,
    ACTIONS(2881), 1,
      anon_sym_COMMA,
    ACTIONS(2883), 1,
      anon_sym_RBRACK,
    STATE(1888), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [84351] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2885), 6,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84364] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2885), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84377] = 6,
    ACTIONS(51), 1,
      anon_sym_AT,
    ACTIONS(2887), 1,
      anon_sym_async,
    ACTIONS(2889), 1,
      anon_sym_def,
    STATE(545), 1,
      sym_function_definition,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    STATE(1685), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [84398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2893), 1,
      sym__not_escape_sequence,
    ACTIONS(2891), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [84415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2897), 1,
      sym__not_escape_sequence,
    ACTIONS(2895), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [84432] = 4,
    ACTIONS(2899), 1,
      anon_sym_COMMA,
    STATE(1577), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2847), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [84449] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2345), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84462] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [84475] = 6,
    ACTIONS(2903), 1,
      anon_sym_DOT,
    ACTIONS(2905), 1,
      anon_sym_COLON,
    ACTIONS(2907), 1,
      anon_sym_EQ,
    ACTIONS(2909), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2901), 2,
      sym__newline,
      anon_sym_SEMI,
  [84496] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2885), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84509] = 6,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2911), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [84530] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [84543] = 7,
    ACTIONS(2797), 1,
      anon_sym_DOT,
    ACTIONS(2801), 1,
      anon_sym_COLON,
    ACTIONS(2805), 1,
      anon_sym_PIPE,
    ACTIONS(2913), 1,
      anon_sym_COMMA,
    ACTIONS(2915), 1,
      anon_sym_RBRACK,
    STATE(1948), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [84566] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2917), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [84587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2921), 1,
      sym__not_escape_sequence,
    ACTIONS(2919), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [84604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2925), 1,
      sym__not_escape_sequence,
    ACTIONS(2923), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [84621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2929), 1,
      sym__not_escape_sequence,
    ACTIONS(2927), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [84638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym_line_continuation,
    ACTIONS(2933), 1,
      sym__not_escape_sequence,
    ACTIONS(2931), 5,
      sym__string_content,
      sym_escape_interpolation,
      sym_string_end,
      anon_sym_LBRACE,
      sym_escape_sequence,
  [84655] = 6,
    ACTIONS(2435), 1,
      anon_sym_as,
    ACTIONS(2437), 1,
      anon_sym_if,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2774), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [84676] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2519), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [84689] = 6,
    ACTIONS(2815), 1,
      anon_sym_DOT,
    ACTIONS(2819), 1,
      anon_sym_COLON,
    ACTIONS(2821), 1,
      anon_sym_PIPE,
    ACTIONS(2937), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [84710] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2852), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [84731] = 6,
    ACTIONS(2435), 1,
      anon_sym_as,
    ACTIONS(2437), 1,
      anon_sym_if,
    ACTIONS(2441), 1,
      anon_sym_and,
    ACTIONS(2443), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2917), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [84752] = 4,
    ACTIONS(2939), 1,
      anon_sym_COMMA,
    STATE(1539), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2941), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [84769] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2795), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [84790] = 4,
    ACTIONS(2943), 1,
      anon_sym_COMMA,
    STATE(1508), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(473), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [84807] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2811), 6,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84820] = 4,
    ACTIONS(2945), 1,
      anon_sym_COMMA,
    STATE(1539), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2843), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [84837] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2811), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84850] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2813), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84863] = 5,
    ACTIONS(2903), 1,
      anon_sym_DOT,
    ACTIONS(2905), 1,
      anon_sym_COLON,
    ACTIONS(2909), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2817), 3,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_EQ,
  [84882] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2790), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84895] = 4,
    ACTIONS(2947), 1,
      anon_sym_COMMA,
    STATE(1586), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2941), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [84912] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1862), 6,
      sym_string_start,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [84925] = 3,
    STATE(1540), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2949), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [84940] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2823), 6,
      sym__newline,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [84953] = 4,
    ACTIONS(2856), 1,
      anon_sym_PIPE,
    STATE(1540), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2951), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [84970] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2953), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2564), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [84985] = 6,
    ACTIONS(2408), 1,
      anon_sym_as,
    ACTIONS(2410), 1,
      anon_sym_if,
    ACTIONS(2412), 1,
      anon_sym_and,
    ACTIONS(2414), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2955), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [85006] = 4,
    ACTIONS(2957), 1,
      anon_sym_PIPE,
    STATE(1584), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2949), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [85023] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1834), 6,
      sym_string_start,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85036] = 4,
    ACTIONS(2960), 1,
      anon_sym_COMMA,
    STATE(1586), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2875), 4,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [85053] = 6,
    ACTIONS(2483), 1,
      anon_sym_as,
    ACTIONS(2485), 1,
      anon_sym_if,
    ACTIONS(2487), 1,
      anon_sym_and,
    ACTIONS(2489), 1,
      anon_sym_or,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1051), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [85074] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2963), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2731), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [85089] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2965), 2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2731), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [85104] = 4,
    ACTIONS(2967), 1,
      anon_sym_COMMA,
    STATE(1530), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(899), 4,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [85121] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2969), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85133] = 6,
    ACTIONS(2971), 1,
      anon_sym_LBRACE,
    ACTIONS(2973), 1,
      anon_sym_RBRACE,
    ACTIONS(2975), 1,
      aux_sym_format_specifier_token1,
    STATE(1671), 1,
      aux_sym_format_specifier_repeat1,
    STATE(1944), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [85153] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2977), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85165] = 4,
    ACTIONS(2979), 1,
      anon_sym_PIPE,
    STATE(1679), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2877), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [85181] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85193] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2249), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [85205] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85217] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2985), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85237] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2233), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [85249] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2987), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85261] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2989), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85281] = 4,
    ACTIONS(2991), 1,
      anon_sym_PIPE,
    STATE(1672), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2877), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [85297] = 5,
    ACTIONS(2797), 1,
      anon_sym_DOT,
    ACTIONS(2801), 1,
      anon_sym_COLON,
    ACTIONS(2805), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2993), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [85315] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2823), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [85327] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2995), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85339] = 6,
    ACTIONS(2971), 1,
      anon_sym_LBRACE,
    ACTIONS(2997), 1,
      anon_sym_RBRACE,
    ACTIONS(2999), 1,
      aux_sym_format_specifier_token1,
    STATE(1592), 1,
      aux_sym_format_specifier_repeat1,
    STATE(1944), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [85359] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3001), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85379] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3003), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [85391] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2345), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [85403] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3005), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85423] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [85435] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2790), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [85447] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2875), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [85459] = 4,
    ACTIONS(2979), 1,
      anon_sym_PIPE,
    STATE(1594), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2854), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [85475] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1862), 5,
      sym_string_start,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [85487] = 3,
    ACTIONS(3009), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [85501] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3011), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85513] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85525] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1834), 5,
      sym_string_start,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [85537] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2875), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [85549] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3015), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85569] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3017), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85581] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3019), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85601] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85613] = 5,
    ACTIONS(3023), 1,
      anon_sym_COMMA,
    ACTIONS(3025), 1,
      anon_sym_RBRACE,
    STATE(1842), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85631] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3027), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85643] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85655] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1862), 5,
      sym_string_start,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [85667] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2823), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [85679] = 5,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3033), 1,
      anon_sym_COLON,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2817), 2,
      anon_sym_COMMA,
      anon_sym_EQ,
  [85697] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3037), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85717] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1834), 5,
      sym_string_start,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [85729] = 3,
    STATE(1602), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2949), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [85743] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3039), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85763] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1862), 5,
      sym_string_start,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [85775] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3041), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85787] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2813), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [85799] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2885), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [85811] = 5,
    ACTIONS(3043), 1,
      anon_sym_COMMA,
    ACTIONS(3045), 1,
      anon_sym_RBRACE,
    STATE(1886), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85829] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3047), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85841] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1834), 5,
      sym_string_start,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [85853] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3049), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [85865] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(2667), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85885] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2811), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [85897] = 4,
    ACTIONS(2991), 1,
      anon_sym_PIPE,
    STATE(1602), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2854), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [85913] = 3,
    ACTIONS(3051), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [85927] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3053), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [85947] = 5,
    ACTIONS(2815), 1,
      anon_sym_DOT,
    ACTIONS(2819), 1,
      anon_sym_COLON,
    ACTIONS(2821), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2935), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [85965] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3003), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
  [85977] = 3,
    ACTIONS(3055), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [85991] = 5,
    ACTIONS(3057), 1,
      anon_sym_COMMA,
    ACTIONS(3059), 1,
      anon_sym_RBRACE,
    STATE(1845), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86009] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3061), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86029] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3063), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86049] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3065), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86061] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3067), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86073] = 4,
    ACTIONS(3069), 1,
      anon_sym_PIPE,
    STATE(1674), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2854), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [86089] = 6,
    ACTIONS(2935), 1,
      anon_sym_COMMA,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3033), 1,
      anon_sym_COLON,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3071), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86109] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3073), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86121] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [86133] = 6,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3077), 1,
      anon_sym_EQ,
    ACTIONS(3079), 1,
      anon_sym_RBRACE,
    ACTIONS(3081), 1,
      sym_type_conversion,
    STATE(2244), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86153] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3083), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86165] = 6,
    ACTIONS(2349), 1,
      anon_sym_as,
    ACTIONS(2351), 1,
      anon_sym_if,
    ACTIONS(2353), 1,
      anon_sym_and,
    ACTIONS(2355), 1,
      anon_sym_or,
    ACTIONS(3085), 1,
      sym__newline,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86185] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3087), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86197] = 6,
    ACTIONS(1950), 1,
      anon_sym_COLON,
    ACTIONS(2862), 1,
      anon_sym_if,
    ACTIONS(3089), 1,
      anon_sym_COMMA,
    STATE(1799), 1,
      aux_sym_case_clause_repeat1,
    STATE(2116), 1,
      sym_if_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86217] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1210), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [86229] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2345), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [86241] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3007), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [86253] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2995), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86265] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2813), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [86277] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2247), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      sym_type_conversion,
  [86289] = 6,
    ACTIONS(3091), 1,
      anon_sym_LBRACE,
    ACTIONS(3094), 1,
      anon_sym_RBRACE,
    ACTIONS(3096), 1,
      aux_sym_format_specifier_token1,
    STATE(1671), 1,
      aux_sym_format_specifier_repeat1,
    STATE(1944), 1,
      sym_interpolation,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
  [86309] = 4,
    ACTIONS(3099), 1,
      anon_sym_PIPE,
    STATE(1672), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2949), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [86325] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3102), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86345] = 4,
    ACTIONS(3069), 1,
      anon_sym_PIPE,
    STATE(1692), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2877), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [86361] = 3,
    STATE(1594), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2949), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [86375] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2807), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [86387] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2807), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [86399] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1210), 5,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PIPE,
  [86411] = 4,
    ACTIONS(3104), 1,
      anon_sym_PIPE,
    STATE(1679), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2949), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [86427] = 4,
    ACTIONS(2979), 1,
      anon_sym_PIPE,
    STATE(1594), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2951), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [86443] = 5,
    ACTIONS(2797), 1,
      anon_sym_DOT,
    ACTIONS(2801), 1,
      anon_sym_COLON,
    ACTIONS(2805), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2817), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [86461] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3107), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86473] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86485] = 6,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3111), 1,
      anon_sym_EQ,
    ACTIONS(3113), 1,
      anon_sym_RBRACE,
    ACTIONS(3115), 1,
      sym_type_conversion,
    STATE(2214), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86505] = 4,
    ACTIONS(3119), 1,
      anon_sym_AT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3117), 2,
      anon_sym_async,
      anon_sym_def,
    STATE(1685), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [86521] = 5,
    ACTIONS(3122), 1,
      anon_sym_COMMA,
    ACTIONS(3124), 1,
      anon_sym_RBRACE,
    STATE(1975), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86539] = 4,
    ACTIONS(3069), 1,
      anon_sym_PIPE,
    STATE(1674), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2951), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [86555] = 3,
    STATE(1674), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2949), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86569] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3126), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86589] = 4,
    ACTIONS(2991), 1,
      anon_sym_PIPE,
    STATE(1602), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2951), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [86605] = 6,
    ACTIONS(2396), 1,
      anon_sym_as,
    ACTIONS(2398), 1,
      anon_sym_if,
    ACTIONS(2400), 1,
      anon_sym_and,
    ACTIONS(2402), 1,
      anon_sym_or,
    ACTIONS(3128), 1,
      anon_sym_else,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86625] = 4,
    ACTIONS(3130), 1,
      anon_sym_PIPE,
    STATE(1692), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2949), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [86641] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86653] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3135), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_PIPE,
  [86665] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3017), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86676] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [86687] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3041), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86698] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86709] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86720] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [86731] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86742] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [86753] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3011), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86764] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [86775] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2969), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86786] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3065), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86797] = 5,
    ACTIONS(3137), 1,
      anon_sym_RPAREN,
    ACTIONS(3139), 1,
      anon_sym_COMMA,
    ACTIONS(3141), 1,
      anon_sym_as,
    STATE(1968), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86814] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86825] = 5,
    ACTIONS(3143), 1,
      anon_sym_COMMA,
    ACTIONS(3145), 1,
      anon_sym_as,
    ACTIONS(3147), 1,
      anon_sym_RBRACK,
    STATE(1970), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86842] = 4,
    ACTIONS(2558), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3149), 2,
      sym__newline,
      anon_sym_SEMI,
  [86857] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86868] = 5,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3151), 1,
      anon_sym_RBRACE,
    ACTIONS(3153), 1,
      sym_type_conversion,
    STATE(2222), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86885] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2977), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86896] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3067), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86907] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2981), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [86918] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3135), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86929] = 5,
    ACTIONS(3155), 1,
      anon_sym_case,
    ACTIONS(3157), 1,
      sym__dedent,
    STATE(1740), 1,
      aux_sym__match_block_repeat1,
    STATE(2026), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86946] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86957] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [86968] = 5,
    ACTIONS(3145), 1,
      anon_sym_as,
    ACTIONS(3159), 1,
      anon_sym_COMMA,
    ACTIONS(3161), 1,
      anon_sym_RBRACK,
    STATE(1857), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [86985] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2983), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [86996] = 4,
    ACTIONS(3165), 1,
      anon_sym_COMMA,
    STATE(1800), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3163), 2,
      sym__newline,
      anon_sym_SEMI,
  [87011] = 5,
    ACTIONS(3141), 1,
      anon_sym_as,
    ACTIONS(3167), 1,
      anon_sym_RPAREN,
    ACTIONS(3169), 1,
      anon_sym_COMMA,
    STATE(1982), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87028] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3107), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [87039] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2995), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87050] = 5,
    ACTIONS(3155), 1,
      anon_sym_case,
    ACTIONS(3171), 1,
      sym__dedent,
    STATE(1763), 1,
      aux_sym__match_block_repeat1,
    STATE(2026), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87067] = 5,
    ACTIONS(2935), 1,
      anon_sym_COMMA,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3033), 1,
      anon_sym_COLON,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87084] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2987), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [87095] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3083), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [87106] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3049), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [87117] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3087), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [87128] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3027), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [87139] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3135), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87150] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87161] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2977), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87172] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3011), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87183] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3011), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87194] = 5,
    ACTIONS(1107), 1,
      anon_sym_LBRACK,
    ACTIONS(3173), 1,
      anon_sym_LPAREN,
    STATE(2019), 1,
      sym_parameters,
    STATE(2020), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87211] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3073), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [87222] = 5,
    ACTIONS(3155), 1,
      anon_sym_case,
    ACTIONS(3175), 1,
      sym__dedent,
    STATE(1763), 1,
      aux_sym__match_block_repeat1,
    STATE(2026), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87239] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3135), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87250] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3017), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87261] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2854), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [87272] = 4,
    ACTIONS(3177), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1063), 2,
      sym__newline,
      anon_sym_SEMI,
  [87287] = 5,
    ACTIONS(3141), 1,
      anon_sym_as,
    ACTIONS(3179), 1,
      anon_sym_RPAREN,
    ACTIONS(3181), 1,
      anon_sym_COMMA,
    STATE(1893), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87304] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3133), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87315] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3087), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87326] = 4,
    ACTIONS(2558), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3183), 2,
      sym__newline,
      anon_sym_SEMI,
  [87341] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3013), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87352] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3047), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [87363] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3017), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87374] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87385] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3021), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87396] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87407] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3041), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87418] = 5,
    ACTIONS(1107), 1,
      anon_sym_LBRACK,
    ACTIONS(3173), 1,
      anon_sym_LPAREN,
    STATE(2083), 1,
      sym_type_parameter,
    STATE(2085), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87435] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3029), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87446] = 5,
    ACTIONS(3145), 1,
      anon_sym_as,
    ACTIONS(3185), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      anon_sym_RBRACK,
    STATE(1881), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87463] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3109), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87474] = 5,
    ACTIONS(3141), 1,
      anon_sym_as,
    ACTIONS(3189), 1,
      anon_sym_RPAREN,
    ACTIONS(3191), 1,
      anon_sym_COMMA,
    STATE(1879), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87491] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2977), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87502] = 5,
    ACTIONS(1107), 1,
      anon_sym_LBRACK,
    ACTIONS(3173), 1,
      anon_sym_LPAREN,
    STATE(2022), 1,
      sym_parameters,
    STATE(2087), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87519] = 5,
    ACTIONS(3193), 1,
      anon_sym_case,
    ACTIONS(3196), 1,
      sym__dedent,
    STATE(1763), 1,
      aux_sym__match_block_repeat1,
    STATE(2026), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87536] = 4,
    ACTIONS(3198), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(899), 2,
      sym__newline,
      anon_sym_SEMI,
  [87551] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3041), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87562] = 5,
    ACTIONS(3141), 1,
      anon_sym_as,
    ACTIONS(3200), 1,
      anon_sym_RPAREN,
    ACTIONS(3202), 1,
      anon_sym_COMMA,
    STATE(1849), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87579] = 5,
    ACTIONS(3145), 1,
      anon_sym_as,
    ACTIONS(3204), 1,
      anon_sym_COMMA,
    ACTIONS(3206), 1,
      anon_sym_RBRACK,
    STATE(1848), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87596] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3047), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87607] = 4,
    ACTIONS(2558), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3208), 2,
      sym__newline,
      anon_sym_SEMI,
  [87622] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3047), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87633] = 4,
    ACTIONS(3210), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2505), 2,
      sym__newline,
      anon_sym_SEMI,
  [87648] = 3,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2564), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(3213), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [87661] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3027), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87672] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2969), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87683] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2969), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87694] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3215), 4,
      anon_sym_eq,
      anon_sym_ne,
      anon_sym_contains,
      anon_sym_fails,
  [87705] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3065), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87716] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3067), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87727] = 5,
    ACTIONS(1107), 1,
      anon_sym_LBRACK,
    ACTIONS(3173), 1,
      anon_sym_LPAREN,
    STATE(2023), 1,
      sym_parameters,
    STATE(2091), 1,
      sym_type_parameter,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87744] = 5,
    ACTIONS(3141), 1,
      anon_sym_as,
    ACTIONS(3217), 1,
      anon_sym_RPAREN,
    ACTIONS(3219), 1,
      anon_sym_COMMA,
    STATE(1858), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87761] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3073), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87772] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3027), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87783] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2995), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87794] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3065), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87805] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3067), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87816] = 5,
    ACTIONS(3141), 1,
      anon_sym_as,
    ACTIONS(3221), 1,
      anon_sym_RPAREN,
    ACTIONS(3223), 1,
      anon_sym_COMMA,
    STATE(1835), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87833] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3049), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87844] = 4,
    ACTIONS(3227), 1,
      anon_sym_COMMA,
    STATE(1801), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3225), 2,
      sym__newline,
      anon_sym_SEMI,
  [87859] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3073), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87870] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2987), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87881] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3107), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87892] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3083), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87903] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3087), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87914] = 5,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3229), 1,
      anon_sym_RBRACE,
    ACTIONS(3231), 1,
      sym_type_conversion,
    STATE(2196), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87931] = 5,
    ACTIONS(3155), 1,
      anon_sym_case,
    ACTIONS(3233), 1,
      sym__dedent,
    STATE(1726), 1,
      aux_sym__match_block_repeat1,
    STATE(2026), 1,
      sym_case_clause,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [87948] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3049), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_PIPE,
  [87959] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3107), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87970] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3083), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [87981] = 4,
    ACTIONS(3235), 1,
      anon_sym_COMMA,
    STATE(1799), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3238), 2,
      anon_sym_if,
      anon_sym_COLON,
  [87996] = 4,
    ACTIONS(3242), 1,
      anon_sym_COMMA,
    STATE(1801), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3240), 2,
      sym__newline,
      anon_sym_SEMI,
  [88011] = 4,
    ACTIONS(3246), 1,
      anon_sym_COMMA,
    STATE(1801), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3244), 2,
      sym__newline,
      anon_sym_SEMI,
  [88026] = 4,
    ACTIONS(3251), 1,
      anon_sym_COLON,
    ACTIONS(3253), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3249), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [88041] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [88052] = 3,
    ACTIONS(2860), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3238), 3,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
  [88065] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2987), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
      anon_sym_PIPE,
  [88076] = 5,
    ACTIONS(3141), 1,
      anon_sym_as,
    ACTIONS(3257), 1,
      anon_sym_RPAREN,
    ACTIONS(3259), 1,
      anon_sym_COMMA,
    STATE(1900), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88093] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1140), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [88103] = 4,
    ACTIONS(813), 1,
      anon_sym_RPAREN,
    ACTIONS(3261), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88117] = 4,
    ACTIONS(3263), 1,
      anon_sym_SEMI,
    ACTIONS(3265), 1,
      sym__newline,
    STATE(1823), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88131] = 4,
    ACTIONS(757), 1,
      anon_sym_RPAREN,
    ACTIONS(3267), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88145] = 4,
    ACTIONS(3269), 1,
      anon_sym_COMMA,
    ACTIONS(3271), 1,
      anon_sym_COLON,
    STATE(1940), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88159] = 4,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    ACTIONS(3275), 1,
      anon_sym_in,
    STATE(1976), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88173] = 4,
    ACTIONS(793), 1,
      anon_sym_RPAREN,
    ACTIONS(3277), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88187] = 3,
    ACTIONS(3279), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [88199] = 4,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    ACTIONS(3281), 1,
      anon_sym_in,
    STATE(1976), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88213] = 4,
    ACTIONS(2527), 1,
      anon_sym_COMMA,
    ACTIONS(2529), 1,
      anon_sym_RBRACK,
    STATE(1883), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88227] = 3,
    ACTIONS(3285), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3283), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [88239] = 4,
    ACTIONS(3287), 1,
      anon_sym_RPAREN,
    ACTIONS(3289), 1,
      anon_sym_COMMA,
    STATE(1818), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88253] = 4,
    ACTIONS(2770), 1,
      anon_sym_COMMA,
    ACTIONS(2772), 1,
      anon_sym_RBRACE,
    STATE(1831), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88267] = 4,
    ACTIONS(3292), 1,
      anon_sym_SEMI,
    ACTIONS(3294), 1,
      sym__newline,
    STATE(1832), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88281] = 4,
    ACTIONS(3296), 1,
      anon_sym_RPAREN,
    ACTIONS(3298), 1,
      anon_sym_COMMA,
    STATE(1810), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88295] = 4,
    ACTIONS(2751), 1,
      anon_sym_RPAREN,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    STATE(1813), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88309] = 4,
    ACTIONS(455), 1,
      sym__newline,
    ACTIONS(3300), 1,
      anon_sym_SEMI,
    STATE(1937), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88323] = 3,
    ACTIONS(2891), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2893), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [88335] = 4,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3302), 1,
      anon_sym_RBRACE,
    STATE(2192), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88349] = 4,
    ACTIONS(883), 1,
      anon_sym_RBRACE,
    ACTIONS(3304), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88363] = 4,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(3306), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88377] = 4,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(3308), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88391] = 4,
    ACTIONS(3310), 1,
      sym__newline,
    ACTIONS(3312), 1,
      sym__indent,
    STATE(553), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88405] = 4,
    ACTIONS(3314), 1,
      anon_sym_COMMA,
    ACTIONS(3316), 1,
      anon_sym_RBRACE,
    STATE(1844), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88419] = 4,
    ACTIONS(905), 1,
      anon_sym_RBRACE,
    ACTIONS(3318), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88433] = 4,
    ACTIONS(449), 1,
      sym__newline,
    ACTIONS(3320), 1,
      anon_sym_SEMI,
    STATE(1937), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88447] = 4,
    ACTIONS(2694), 1,
      anon_sym_COMMA,
    ACTIONS(2696), 1,
      anon_sym_RBRACE,
    STATE(1826), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88461] = 4,
    ACTIONS(3322), 1,
      sym__newline,
    ACTIONS(3324), 1,
      sym__indent,
    STATE(540), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88475] = 4,
    ACTIONS(2018), 1,
      anon_sym_RPAREN,
    ACTIONS(3326), 1,
      anon_sym_COMMA,
    STATE(1904), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88489] = 4,
    ACTIONS(2233), 1,
      anon_sym_RBRACK,
    ACTIONS(3328), 1,
      anon_sym_COMMA,
    STATE(1836), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88503] = 4,
    ACTIONS(3322), 1,
      sym__newline,
    ACTIONS(3324), 1,
      sym__indent,
    STATE(533), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88517] = 4,
    ACTIONS(2505), 1,
      anon_sym_COLON,
    ACTIONS(3331), 1,
      anon_sym_COMMA,
    STATE(1838), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88531] = 4,
    ACTIONS(2684), 1,
      anon_sym_RPAREN,
    ACTIONS(2686), 1,
      anon_sym_COMMA,
    STATE(1850), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88545] = 4,
    ACTIONS(3334), 1,
      anon_sym_RPAREN,
    ACTIONS(3336), 1,
      anon_sym_COMMA,
    STATE(1852), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88559] = 4,
    ACTIONS(3338), 1,
      anon_sym_COMMA,
    ACTIONS(3341), 1,
      anon_sym_COLON,
    STATE(1841), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88573] = 4,
    ACTIONS(3343), 1,
      anon_sym_COMMA,
    ACTIONS(3345), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88587] = 4,
    ACTIONS(2583), 1,
      anon_sym_COMMA,
    ACTIONS(2585), 1,
      anon_sym_RBRACK,
    STATE(1855), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88601] = 4,
    ACTIONS(3347), 1,
      anon_sym_COMMA,
    ACTIONS(3349), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88615] = 4,
    ACTIONS(3351), 1,
      anon_sym_COMMA,
    ACTIONS(3353), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88629] = 4,
    ACTIONS(2595), 1,
      anon_sym_COMMA,
    ACTIONS(2597), 1,
      anon_sym_RBRACK,
    STATE(1942), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88643] = 4,
    ACTIONS(2778), 1,
      anon_sym_RBRACK,
    ACTIONS(3355), 1,
      anon_sym_COMMA,
    STATE(1847), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88657] = 4,
    ACTIONS(2024), 1,
      anon_sym_RBRACK,
    ACTIONS(3358), 1,
      anon_sym_COMMA,
    STATE(1925), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88671] = 4,
    ACTIONS(2026), 1,
      anon_sym_RPAREN,
    ACTIONS(3360), 1,
      anon_sym_COMMA,
    STATE(1904), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88685] = 4,
    ACTIONS(831), 1,
      anon_sym_RPAREN,
    ACTIONS(3362), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88699] = 4,
    ACTIONS(3364), 1,
      anon_sym_RPAREN,
    ACTIONS(3366), 1,
      anon_sym_COMMA,
    STATE(1907), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88713] = 4,
    ACTIONS(827), 1,
      anon_sym_RPAREN,
    ACTIONS(3368), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88727] = 4,
    ACTIONS(2647), 1,
      anon_sym_RPAREN,
    ACTIONS(2649), 1,
      anon_sym_COMMA,
    STATE(2009), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88741] = 4,
    ACTIONS(3370), 1,
      anon_sym_COMMA,
    ACTIONS(3372), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88755] = 4,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    ACTIONS(3376), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88769] = 4,
    ACTIONS(3378), 1,
      anon_sym_COMMA,
    ACTIONS(3381), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88783] = 4,
    ACTIONS(2050), 1,
      anon_sym_RBRACK,
    ACTIONS(3383), 1,
      anon_sym_COMMA,
    STATE(1925), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88797] = 4,
    ACTIONS(2054), 1,
      anon_sym_RPAREN,
    ACTIONS(3385), 1,
      anon_sym_COMMA,
    STATE(1904), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88811] = 4,
    ACTIONS(597), 1,
      anon_sym_RBRACK,
    ACTIONS(3387), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88825] = 4,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3389), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88839] = 4,
    ACTIONS(3391), 1,
      anon_sym_COMMA,
    ACTIONS(3393), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88853] = 4,
    ACTIONS(2337), 1,
      anon_sym_RPAREN,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88867] = 4,
    ACTIONS(3395), 1,
      anon_sym_COMMA,
    ACTIONS(3397), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88881] = 4,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3399), 1,
      anon_sym_RBRACE,
    STATE(2145), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88895] = 4,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(3401), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88909] = 4,
    ACTIONS(3403), 1,
      anon_sym_RPAREN,
    ACTIONS(3405), 1,
      anon_sym_COMMA,
    STATE(1933), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88923] = 4,
    ACTIONS(797), 1,
      anon_sym_RPAREN,
    ACTIONS(3407), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88937] = 4,
    ACTIONS(1059), 1,
      anon_sym_RPAREN,
    ACTIONS(3409), 1,
      anon_sym_COMMA,
    STATE(1818), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88951] = 4,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(3411), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88965] = 4,
    ACTIONS(3287), 1,
      anon_sym_COLON,
    ACTIONS(3413), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88979] = 4,
    ACTIONS(761), 1,
      anon_sym_RPAREN,
    ACTIONS(3416), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [88993] = 4,
    ACTIONS(3418), 1,
      anon_sym_COMMA,
    ACTIONS(3420), 1,
      anon_sym_RBRACE,
    STATE(1884), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89007] = 4,
    ACTIONS(3422), 1,
      anon_sym_COMMA,
    ACTIONS(3424), 1,
      anon_sym_RBRACE,
    STATE(1939), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89021] = 4,
    ACTIONS(2856), 1,
      anon_sym_PIPE,
    ACTIONS(3426), 1,
      anon_sym_COLON,
    STATE(1540), 1,
      aux_sym_union_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89035] = 3,
    ACTIONS(2784), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2786), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [89047] = 4,
    ACTIONS(2544), 1,
      anon_sym_COMMA,
    ACTIONS(2546), 1,
      anon_sym_RBRACK,
    STATE(1861), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89061] = 4,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3428), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89075] = 4,
    ACTIONS(2993), 1,
      anon_sym_RBRACK,
    ACTIONS(3430), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89089] = 4,
    ACTIONS(2062), 1,
      anon_sym_RPAREN,
    ACTIONS(3433), 1,
      anon_sym_COMMA,
    STATE(1904), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89103] = 4,
    ACTIONS(3435), 1,
      anon_sym_RPAREN,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    STATE(1867), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89117] = 4,
    ACTIONS(2004), 1,
      anon_sym_RBRACK,
    ACTIONS(3439), 1,
      anon_sym_COMMA,
    STATE(1925), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89131] = 4,
    ACTIONS(2755), 1,
      anon_sym_RPAREN,
    ACTIONS(2757), 1,
      anon_sym_COMMA,
    STATE(1871), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89145] = 4,
    ACTIONS(3441), 1,
      anon_sym_COMMA,
    ACTIONS(3443), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89159] = 4,
    ACTIONS(3445), 1,
      anon_sym_COMMA,
    ACTIONS(3447), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89173] = 4,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    ACTIONS(3449), 1,
      anon_sym_in,
    STATE(1976), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89187] = 4,
    ACTIONS(3451), 1,
      anon_sym_COMMA,
    ACTIONS(3453), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89201] = 3,
    ACTIONS(3279), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [89213] = 4,
    ACTIONS(667), 1,
      anon_sym_RBRACK,
    ACTIONS(3455), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89227] = 4,
    ACTIONS(3457), 1,
      anon_sym_COMMA,
    ACTIONS(3460), 1,
      anon_sym_RBRACE,
    STATE(1889), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89241] = 4,
    ACTIONS(2778), 1,
      anon_sym_RBRACE,
    ACTIONS(3462), 1,
      anon_sym_COMMA,
    STATE(1890), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89255] = 4,
    ACTIONS(939), 1,
      anon_sym_RBRACE,
    ACTIONS(3465), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89269] = 4,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3467), 1,
      anon_sym_RBRACE,
    STATE(2225), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89283] = 4,
    ACTIONS(2082), 1,
      anon_sym_RPAREN,
    ACTIONS(3469), 1,
      anon_sym_COMMA,
    STATE(1904), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89297] = 4,
    ACTIONS(3471), 1,
      anon_sym_COMMA,
    ACTIONS(3473), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89311] = 4,
    ACTIONS(3475), 1,
      anon_sym_COMMA,
    ACTIONS(3477), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89325] = 4,
    ACTIONS(1053), 1,
      anon_sym_COLON,
    ACTIONS(3479), 1,
      anon_sym_COMMA,
    STATE(1870), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89339] = 4,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3481), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89353] = 4,
    ACTIONS(811), 1,
      anon_sym_RPAREN,
    ACTIONS(3483), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89367] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2854), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [89377] = 4,
    ACTIONS(2038), 1,
      anon_sym_RPAREN,
    ACTIONS(3485), 1,
      anon_sym_COMMA,
    STATE(1904), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89391] = 4,
    ACTIONS(817), 1,
      anon_sym_RPAREN,
    ACTIONS(3487), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89405] = 4,
    ACTIONS(3489), 1,
      anon_sym_COMMA,
    ACTIONS(3492), 1,
      anon_sym_COLON,
    STATE(1902), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89419] = 4,
    ACTIONS(963), 1,
      anon_sym_RBRACE,
    ACTIONS(3494), 1,
      anon_sym_COMMA,
    STATE(1890), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89433] = 4,
    ACTIONS(3238), 1,
      anon_sym_RPAREN,
    ACTIONS(3496), 1,
      anon_sym_COMMA,
    STATE(1904), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89447] = 4,
    ACTIONS(2233), 1,
      anon_sym_RPAREN,
    ACTIONS(3499), 1,
      anon_sym_COMMA,
    STATE(1905), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89461] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [89471] = 4,
    ACTIONS(823), 1,
      anon_sym_RPAREN,
    ACTIONS(3502), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89485] = 4,
    ACTIONS(2766), 1,
      anon_sym_COMMA,
    ACTIONS(2768), 1,
      anon_sym_RBRACE,
    STATE(1891), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89499] = 4,
    ACTIONS(3310), 1,
      sym__newline,
    ACTIONS(3312), 1,
      sym__indent,
    STATE(510), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89513] = 4,
    ACTIONS(3504), 1,
      anon_sym_COMMA,
    ACTIONS(3506), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89527] = 4,
    ACTIONS(2552), 1,
      anon_sym_COMMA,
    ACTIONS(2554), 1,
      anon_sym_RBRACK,
    STATE(1928), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89541] = 4,
    ACTIONS(2321), 1,
      anon_sym_RPAREN,
    ACTIONS(3508), 1,
      anon_sym_COMMA,
    STATE(1917), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89555] = 4,
    ACTIONS(2676), 1,
      anon_sym_COMMA,
    ACTIONS(2678), 1,
      anon_sym_RBRACE,
    STATE(1985), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89569] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2854), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [89579] = 4,
    ACTIONS(2747), 1,
      anon_sym_COMMA,
    ACTIONS(2749), 1,
      anon_sym_RBRACE,
    STATE(1924), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89593] = 4,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    ACTIONS(3510), 1,
      anon_sym_RBRACE,
    STATE(2223), 1,
      sym_format_specifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89607] = 4,
    ACTIONS(3492), 1,
      anon_sym_RPAREN,
    ACTIONS(3512), 1,
      anon_sym_COMMA,
    STATE(1917), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89621] = 4,
    ACTIONS(963), 1,
      anon_sym_RPAREN,
    ACTIONS(3515), 1,
      anon_sym_COMMA,
    STATE(1921), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89635] = 3,
    ACTIONS(3145), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3238), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [89647] = 3,
    ACTIONS(3141), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3238), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [89659] = 4,
    ACTIONS(2778), 1,
      anon_sym_RPAREN,
    ACTIONS(3517), 1,
      anon_sym_COMMA,
    STATE(1921), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89673] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACK,
  [89683] = 4,
    ACTIONS(2534), 1,
      anon_sym_COMMA,
    ACTIONS(2536), 1,
      anon_sym_RBRACK,
    STATE(1894), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89697] = 4,
    ACTIONS(925), 1,
      anon_sym_RBRACE,
    ACTIONS(3520), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89711] = 4,
    ACTIONS(3238), 1,
      anon_sym_RBRACK,
    ACTIONS(3522), 1,
      anon_sym_COMMA,
    STATE(1925), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89725] = 4,
    ACTIONS(3525), 1,
      anon_sym_COMMA,
    ACTIONS(3527), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89739] = 4,
    ACTIONS(3529), 1,
      anon_sym_RPAREN,
    ACTIONS(3531), 1,
      anon_sym_COMMA,
    STATE(1898), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89753] = 4,
    ACTIONS(3533), 1,
      anon_sym_COMMA,
    ACTIONS(3535), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89767] = 4,
    ACTIONS(2759), 1,
      anon_sym_RPAREN,
    ACTIONS(2761), 1,
      anon_sym_COMMA,
    STATE(1901), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89781] = 3,
    ACTIONS(2927), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2929), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [89793] = 4,
    ACTIONS(2632), 1,
      anon_sym_RPAREN,
    ACTIONS(2634), 1,
      anon_sym_COMMA,
    STATE(1941), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89807] = 4,
    ACTIONS(3537), 1,
      anon_sym_RPAREN,
    ACTIONS(3539), 1,
      anon_sym_COMMA,
    STATE(1943), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89821] = 4,
    ACTIONS(1502), 1,
      anon_sym_RPAREN,
    ACTIONS(3541), 1,
      anon_sym_COMMA,
    STATE(1905), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89835] = 4,
    ACTIONS(2233), 1,
      anon_sym_in,
    ACTIONS(3543), 1,
      anon_sym_COMMA,
    STATE(1934), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89849] = 4,
    ACTIONS(2599), 1,
      anon_sym_COMMA,
    ACTIONS(2601), 1,
      anon_sym_RBRACK,
    STATE(1946), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89863] = 3,
    ACTIONS(2931), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2933), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [89875] = 4,
    ACTIONS(3546), 1,
      anon_sym_SEMI,
    ACTIONS(3549), 1,
      sym__newline,
    STATE(1937), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89889] = 4,
    ACTIONS(3310), 1,
      sym__newline,
    ACTIONS(3312), 1,
      sym__indent,
    STATE(539), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89903] = 4,
    ACTIONS(3551), 1,
      anon_sym_COMMA,
    ACTIONS(3553), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89917] = 4,
    ACTIONS(2321), 1,
      anon_sym_COLON,
    ACTIONS(3555), 1,
      anon_sym_COMMA,
    STATE(1902), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89931] = 4,
    ACTIONS(759), 1,
      anon_sym_RPAREN,
    ACTIONS(3557), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89945] = 4,
    ACTIONS(3559), 1,
      anon_sym_COMMA,
    ACTIONS(3561), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89959] = 4,
    ACTIONS(765), 1,
      anon_sym_RPAREN,
    ACTIONS(3563), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89973] = 3,
    ACTIONS(3567), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3565), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [89985] = 4,
    ACTIONS(3569), 1,
      anon_sym_COMMA,
    ACTIONS(3571), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [89999] = 4,
    ACTIONS(3573), 1,
      anon_sym_COMMA,
    ACTIONS(3575), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90013] = 4,
    ACTIONS(2776), 1,
      anon_sym_RPAREN,
    ACTIONS(3577), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90027] = 4,
    ACTIONS(505), 1,
      anon_sym_RBRACK,
    ACTIONS(3580), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90041] = 4,
    ACTIONS(3322), 1,
      sym__newline,
    ACTIONS(3324), 1,
      sym__indent,
    STATE(579), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90055] = 4,
    ACTIONS(1502), 1,
      anon_sym_RBRACK,
    ACTIONS(3582), 1,
      anon_sym_COMMA,
    STATE(1836), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90069] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1140), 3,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
  [90079] = 3,
    ACTIONS(2829), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2831), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [90091] = 4,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3584), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90105] = 4,
    ACTIONS(3586), 1,
      anon_sym_COMMA,
    ACTIONS(3588), 1,
      anon_sym_COLON,
    STATE(1841), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90119] = 4,
    ACTIONS(909), 1,
      anon_sym_RBRACE,
    ACTIONS(3590), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90133] = 4,
    ACTIONS(3592), 1,
      anon_sym_COMMA,
    ACTIONS(3594), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90147] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2247), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_EQ,
  [90157] = 4,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3596), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90171] = 4,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3598), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90185] = 4,
    ACTIONS(3600), 1,
      anon_sym_COMMA,
    ACTIONS(3602), 1,
      anon_sym_COLON,
    STATE(1841), 1,
      aux_sym_match_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90199] = 4,
    ACTIONS(3604), 1,
      anon_sym_COMMA,
    ACTIONS(3606), 1,
      anon_sym_RBRACE,
    STATE(1973), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90213] = 4,
    ACTIONS(3310), 1,
      sym__newline,
    ACTIONS(3312), 1,
      sym__indent,
    STATE(527), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90227] = 4,
    ACTIONS(3608), 1,
      anon_sym_COMMA,
    ACTIONS(3610), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90241] = 4,
    ACTIONS(963), 1,
      anon_sym_RBRACK,
    ACTIONS(3612), 1,
      anon_sym_COMMA,
    STATE(1847), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90255] = 4,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(3614), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90269] = 4,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    ACTIONS(3616), 1,
      anon_sym_in,
    STATE(1976), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90283] = 4,
    ACTIONS(2622), 1,
      anon_sym_COMMA,
    ACTIONS(3618), 1,
      anon_sym_RPAREN,
    STATE(1918), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90297] = 4,
    ACTIONS(2064), 1,
      anon_sym_RPAREN,
    ACTIONS(3620), 1,
      anon_sym_COMMA,
    STATE(1904), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90311] = 4,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3622), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90325] = 4,
    ACTIONS(2060), 1,
      anon_sym_RBRACK,
    ACTIONS(3624), 1,
      anon_sym_COMMA,
    STATE(1925), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90339] = 4,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    ACTIONS(3626), 1,
      anon_sym_in,
    STATE(1976), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90353] = 4,
    ACTIONS(3628), 1,
      anon_sym_COMMA,
    ACTIONS(3630), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90367] = 4,
    ACTIONS(3632), 1,
      anon_sym_COMMA,
    ACTIONS(3634), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90381] = 3,
    ACTIONS(3636), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3249), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [90393] = 4,
    ACTIONS(3638), 1,
      anon_sym_COMMA,
    ACTIONS(3640), 1,
      anon_sym_RBRACE,
    STATE(1856), 1,
      aux_sym_dict_pattern_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90407] = 4,
    ACTIONS(473), 1,
      anon_sym_in,
    ACTIONS(3642), 1,
      anon_sym_COMMA,
    STATE(1934), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90421] = 4,
    ACTIONS(451), 1,
      sym__newline,
    ACTIONS(3644), 1,
      anon_sym_SEMI,
    STATE(1937), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90435] = 4,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    ACTIONS(3646), 1,
      anon_sym_in,
    STATE(1976), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90449] = 4,
    ACTIONS(815), 1,
      anon_sym_RPAREN,
    ACTIONS(3648), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90463] = 4,
    ACTIONS(2573), 1,
      anon_sym_COMMA,
    ACTIONS(2575), 1,
      anon_sym_RBRACK,
    STATE(2011), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90477] = 4,
    ACTIONS(2639), 1,
      anon_sym_COMMA,
    ACTIONS(2641), 1,
      anon_sym_RBRACE,
    STATE(1955), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90491] = 4,
    ACTIONS(2044), 1,
      anon_sym_RPAREN,
    ACTIONS(3650), 1,
      anon_sym_COMMA,
    STATE(1904), 1,
      aux_sym_case_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90505] = 4,
    ACTIONS(3322), 1,
      sym__newline,
    ACTIONS(3324), 1,
      sym__indent,
    STATE(516), 1,
      sym__match_block,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90519] = 4,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    ACTIONS(3652), 1,
      anon_sym_in,
    STATE(1976), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90533] = 4,
    ACTIONS(885), 1,
      anon_sym_RBRACE,
    ACTIONS(3654), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90547] = 4,
    ACTIONS(3656), 1,
      anon_sym_RPAREN,
    ACTIONS(3658), 1,
      anon_sym_COMMA,
    STATE(1868), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90561] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3660), 3,
      anon_sym_async,
      anon_sym_def,
      anon_sym_AT,
  [90571] = 4,
    ACTIONS(2521), 1,
      anon_sym_COMMA,
    ACTIONS(2525), 1,
      anon_sym_RBRACK,
    STATE(1956), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90585] = 3,
    ACTIONS(3253), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3249), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [90597] = 4,
    ACTIONS(2325), 1,
      anon_sym_COMMA,
    ACTIONS(2337), 1,
      anon_sym_RBRACE,
    STATE(1903), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90611] = 4,
    ACTIONS(3273), 1,
      anon_sym_COMMA,
    ACTIONS(3662), 1,
      anon_sym_in,
    STATE(1976), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90625] = 4,
    ACTIONS(3031), 1,
      anon_sym_DOT,
    ACTIONS(3035), 1,
      anon_sym_PIPE,
    ACTIONS(3664), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90639] = 4,
    ACTIONS(3666), 1,
      anon_sym_COMMA,
    ACTIONS(3669), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90653] = 4,
    ACTIONS(3271), 1,
      anon_sym_RPAREN,
    ACTIONS(3671), 1,
      anon_sym_COMMA,
    STATE(1912), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90667] = 3,
    ACTIONS(2919), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2921), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [90679] = 3,
    ACTIONS(2895), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2897), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [90691] = 4,
    ACTIONS(3403), 1,
      anon_sym_RBRACK,
    ACTIONS(3673), 1,
      anon_sym_COMMA,
    STATE(1950), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90705] = 4,
    ACTIONS(617), 1,
      anon_sym_RBRACK,
    ACTIONS(3675), 1,
      anon_sym_COMMA,
    STATE(1878), 1,
      aux_sym_type_parameter_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90719] = 4,
    ACTIONS(3677), 1,
      anon_sym_RPAREN,
    ACTIONS(3679), 1,
      anon_sym_COMMA,
    STATE(1808), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90733] = 4,
    ACTIONS(2337), 1,
      anon_sym_RBRACK,
    ACTIONS(2357), 1,
      anon_sym_COMMA,
    STATE(1964), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90747] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2854), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [90757] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3255), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RBRACE,
  [90767] = 3,
    ACTIONS(2923), 1,
      aux_sym_format_specifier_token1,
    ACTIONS(5), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2925), 2,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
  [90779] = 4,
    ACTIONS(2690), 1,
      anon_sym_COMMA,
    ACTIONS(2692), 1,
      anon_sym_RBRACE,
    STATE(2013), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90793] = 4,
    ACTIONS(2605), 1,
      anon_sym_RPAREN,
    ACTIONS(2607), 1,
      anon_sym_COMMA,
    STATE(1979), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90807] = 3,
    ACTIONS(3683), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3681), 2,
      sym__newline,
      anon_sym_SEMI,
  [90819] = 4,
    ACTIONS(3685), 1,
      anon_sym_COMMA,
    ACTIONS(3687), 1,
      anon_sym_COLON,
    STATE(1896), 1,
      aux_sym_with_clause_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90833] = 4,
    ACTIONS(3689), 1,
      anon_sym_SEMI,
    ACTIONS(3691), 1,
      sym__newline,
    STATE(1977), 1,
      aux_sym__simple_statements_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90847] = 4,
    ACTIONS(829), 1,
      anon_sym_RPAREN,
    ACTIONS(3693), 1,
      anon_sym_COMMA,
    STATE(1947), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90861] = 4,
    ACTIONS(3695), 1,
      anon_sym_COMMA,
    ACTIONS(3697), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90875] = 4,
    ACTIONS(3699), 1,
      anon_sym_COMMA,
    ACTIONS(3701), 1,
      anon_sym_RBRACK,
    STATE(1993), 1,
      aux_sym_subscript_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90889] = 4,
    ACTIONS(899), 1,
      anon_sym_COLON,
    ACTIONS(3703), 1,
      anon_sym_COMMA,
    STATE(1838), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90903] = 4,
    ACTIONS(919), 1,
      anon_sym_RBRACE,
    ACTIONS(3705), 1,
      anon_sym_COMMA,
    STATE(1889), 1,
      aux_sym_dictionary_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90917] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3707), 2,
      sym__newline,
      anon_sym_SEMI,
  [90926] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3709), 2,
      sym__dedent,
      anon_sym_case,
  [90935] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3711), 2,
      sym__dedent,
      anon_sym_case,
  [90944] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3713), 2,
      sym__dedent,
      anon_sym_case,
  [90953] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3715), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [90962] = 3,
    ACTIONS(3717), 1,
      anon_sym_COLON,
    ACTIONS(3719), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90973] = 3,
    ACTIONS(3173), 1,
      anon_sym_LPAREN,
    STATE(2065), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [90984] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [90993] = 3,
    ACTIONS(3721), 1,
      anon_sym_COLON,
    ACTIONS(3723), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91004] = 3,
    ACTIONS(3725), 1,
      anon_sym_COLON,
    ACTIONS(3727), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91015] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3249), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91024] = 3,
    ACTIONS(3729), 1,
      anon_sym_COLON,
    ACTIONS(3731), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91035] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3733), 2,
      sym__dedent,
      anon_sym_case,
  [91044] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3735), 2,
      sym__dedent,
      anon_sym_case,
  [91053] = 3,
    ACTIONS(3737), 1,
      anon_sym_COLON,
    ACTIONS(3739), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91064] = 3,
    ACTIONS(3741), 1,
      sym_integer,
    ACTIONS(3743), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91075] = 3,
    ACTIONS(3745), 1,
      sym_integer,
    ACTIONS(3747), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91086] = 3,
    ACTIONS(3749), 1,
      sym_integer,
    ACTIONS(3751), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91097] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3753), 2,
      anon_sym__,
      sym_identifier,
  [91106] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2249), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91115] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3755), 2,
      sym__dedent,
      anon_sym_case,
  [91124] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3757), 2,
      sym__newline,
      anon_sym_SEMI,
  [91133] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3759), 2,
      sym__dedent,
      anon_sym_case,
  [91142] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2776), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91151] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3761), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91160] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3492), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [91169] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2688), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [91178] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3549), 2,
      sym__newline,
      anon_sym_SEMI,
  [91187] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1264), 2,
      sym__dedent,
      anon_sym_case,
  [91196] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3763), 2,
      sym__newline,
      anon_sym_SEMI,
  [91205] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2581), 2,
      sym__newline,
      anon_sym_SEMI,
  [91214] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3765), 2,
      anon_sym__,
      sym_identifier,
  [91223] = 3,
    ACTIONS(3767), 1,
      sym_integer,
    ACTIONS(3769), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91234] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2249), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [91243] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2589), 2,
      sym__newline,
      anon_sym_SEMI,
  [91252] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3771), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91261] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1284), 2,
      sym__dedent,
      anon_sym_case,
  [91270] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2233), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91279] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3492), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91288] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1274), 2,
      sym__dedent,
      anon_sym_case,
  [91297] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3773), 2,
      sym__dedent,
      anon_sym_case,
  [91306] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3775), 2,
      sym__dedent,
      anon_sym_case,
  [91315] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3777), 2,
      sym__dedent,
      anon_sym_case,
  [91324] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1250), 2,
      sym__dedent,
      anon_sym_case,
  [91333] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3779), 2,
      sym__dedent,
      anon_sym_case,
  [91342] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3781), 2,
      sym__dedent,
      anon_sym_case,
  [91351] = 3,
    ACTIONS(3783), 1,
      anon_sym_COLON,
    ACTIONS(3785), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91362] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2247), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [91371] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1109), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91380] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3771), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [91389] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3460), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [91398] = 3,
    ACTIONS(3787), 1,
      anon_sym_COLON,
    ACTIONS(3789), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91409] = 3,
    ACTIONS(3791), 1,
      sym_integer,
    ACTIONS(3793), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91420] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2778), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [91429] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3795), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [91438] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3797), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [91447] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3799), 2,
      anon_sym__,
      sym_identifier,
  [91456] = 3,
    ACTIONS(3801), 1,
      sym_integer,
    ACTIONS(3803), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91467] = 3,
    ACTIONS(3805), 1,
      sym_integer,
    ACTIONS(3807), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91478] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3809), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [91487] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3287), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [91496] = 3,
    ACTIONS(3811), 1,
      sym_integer,
    ACTIONS(3813), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91507] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3815), 2,
      anon_sym__,
      sym_identifier,
  [91516] = 3,
    ACTIONS(3817), 1,
      sym_integer,
    ACTIONS(3819), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91527] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3797), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [91536] = 3,
    ACTIONS(3821), 1,
      sym_integer,
    ACTIONS(3823), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91547] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3795), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [91556] = 3,
    ACTIONS(3825), 1,
      anon_sym_COMMA,
    STATE(1570), 1,
      aux_sym__patterns_repeat1,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91567] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2778), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [91576] = 3,
    ACTIONS(3173), 1,
      anon_sym_LPAREN,
    STATE(2060), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91587] = 3,
    ACTIONS(3827), 1,
      sym_integer,
    ACTIONS(3829), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91598] = 3,
    ACTIONS(3831), 1,
      anon_sym_COLON,
    ACTIONS(3833), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91609] = 3,
    ACTIONS(3835), 1,
      sym_integer,
    ACTIONS(3837), 1,
      sym_float,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91620] = 3,
    ACTIONS(3173), 1,
      anon_sym_LPAREN,
    STATE(2025), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91631] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3839), 2,
      sym__dedent,
      anon_sym_case,
  [91640] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2343), 2,
      sym__newline,
      anon_sym_SEMI,
  [91649] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [91658] = 3,
    ACTIONS(3173), 1,
      anon_sym_LPAREN,
    STATE(2028), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91669] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3287), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91678] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2233), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [91687] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(1300), 2,
      sym__dedent,
      anon_sym_case,
  [91696] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3797), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91705] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3841), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [91714] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3843), 2,
      sym__newline,
      anon_sym_SEMI,
  [91723] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3249), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [91732] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3795), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91741] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(2778), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [91750] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3845), 2,
      sym__newline,
      anon_sym_SEMI,
  [91759] = 2,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
    ACTIONS(3847), 2,
      sym__newline,
      anon_sym_SEMI,
  [91768] = 2,
    ACTIONS(3849), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91776] = 2,
    ACTIONS(3851), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91784] = 2,
    ACTIONS(3853), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91792] = 2,
    ACTIONS(3855), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91800] = 2,
    ACTIONS(3857), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91808] = 2,
    ACTIONS(3859), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91816] = 2,
    ACTIONS(3861), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91824] = 2,
    ACTIONS(3863), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91832] = 2,
    ACTIONS(3865), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91840] = 2,
    ACTIONS(2751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91848] = 2,
    ACTIONS(3867), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91856] = 2,
    ACTIONS(3869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91864] = 2,
    ACTIONS(1045), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91872] = 2,
    ACTIONS(3871), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91880] = 2,
    ACTIONS(3873), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91888] = 2,
    ACTIONS(2696), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91896] = 2,
    ACTIONS(3875), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91904] = 2,
    ACTIONS(3877), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91912] = 2,
    ACTIONS(3879), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91920] = 2,
    ACTIONS(3881), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91928] = 2,
    ACTIONS(3883), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91936] = 2,
    ACTIONS(3885), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91944] = 2,
    ACTIONS(3887), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91952] = 2,
    ACTIONS(3889), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91960] = 2,
    ACTIONS(2755), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91968] = 2,
    ACTIONS(3891), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91976] = 2,
    ACTIONS(3893), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91984] = 2,
    ACTIONS(3895), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [91992] = 2,
    ACTIONS(3897), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92000] = 2,
    ACTIONS(3899), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92008] = 2,
    ACTIONS(3901), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92016] = 2,
    ACTIONS(3903), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92024] = 2,
    ACTIONS(3905), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92032] = 2,
    ACTIONS(3907), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92040] = 2,
    ACTIONS(3909), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92048] = 2,
    ACTIONS(2768), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92056] = 2,
    ACTIONS(3911), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92064] = 2,
    ACTIONS(3913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92072] = 2,
    ACTIONS(2678), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92080] = 2,
    ACTIONS(3915), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92088] = 2,
    ACTIONS(3917), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92096] = 2,
    ACTIONS(3919), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92104] = 2,
    ACTIONS(3921), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92112] = 2,
    ACTIONS(3923), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92120] = 2,
    ACTIONS(3925), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92128] = 2,
    ACTIONS(3927), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92136] = 2,
    ACTIONS(3652), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92144] = 2,
    ACTIONS(3626), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92152] = 2,
    ACTIONS(3929), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92160] = 2,
    ACTIONS(2605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92168] = 2,
    ACTIONS(3931), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92176] = 2,
    ACTIONS(3933), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92184] = 2,
    ACTIONS(3935), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92192] = 2,
    ACTIONS(3937), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92200] = 2,
    ACTIONS(3939), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92208] = 2,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92216] = 2,
    ACTIONS(3943), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92224] = 2,
    ACTIONS(3945), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92232] = 2,
    ACTIONS(2692), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92240] = 2,
    ACTIONS(3947), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92248] = 2,
    ACTIONS(3662), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92256] = 2,
    ACTIONS(3949), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92264] = 2,
    ACTIONS(3951), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92272] = 2,
    ACTIONS(3953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92280] = 2,
    ACTIONS(3955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92288] = 2,
    ACTIONS(3957), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92296] = 2,
    ACTIONS(3959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92304] = 2,
    ACTIONS(3961), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92312] = 2,
    ACTIONS(3963), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92320] = 2,
    ACTIONS(3965), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92328] = 2,
    ACTIONS(3967), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92336] = 2,
    ACTIONS(3969), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92344] = 2,
    ACTIONS(3971), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92352] = 2,
    ACTIONS(3973), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92360] = 2,
    ACTIONS(3975), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92368] = 2,
    ACTIONS(2709), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92376] = 2,
    ACTIONS(2671), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92384] = 2,
    ACTIONS(2641), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92392] = 2,
    ACTIONS(3977), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92400] = 2,
    ACTIONS(3646), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92408] = 2,
    ACTIONS(3979), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92416] = 2,
    ACTIONS(2705), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92424] = 2,
    ACTIONS(3981), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92432] = 2,
    ACTIONS(3983), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92440] = 2,
    ACTIONS(3449), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92448] = 2,
    ACTIONS(3985), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92456] = 2,
    ACTIONS(3616), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92464] = 2,
    ACTIONS(3987), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92472] = 2,
    ACTIONS(3989), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92480] = 2,
    ACTIONS(3991), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92488] = 2,
    ACTIONS(3993), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92496] = 2,
    ACTIONS(3995), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92504] = 2,
    ACTIONS(3997), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92512] = 2,
    ACTIONS(3999), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92520] = 2,
    ACTIONS(4001), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92528] = 2,
    ACTIONS(4003), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92536] = 2,
    ACTIONS(4005), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92544] = 2,
    ACTIONS(4007), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92552] = 2,
    ACTIONS(4009), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92560] = 2,
    ACTIONS(2759), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92568] = 2,
    ACTIONS(2632), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92576] = 2,
    ACTIONS(4011), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92584] = 2,
    ACTIONS(4013), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92592] = 2,
    ACTIONS(4015), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92600] = 2,
    ACTIONS(4017), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92608] = 2,
    ACTIONS(4019), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92616] = 2,
    ACTIONS(4021), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92624] = 2,
    ACTIONS(4023), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92632] = 2,
    ACTIONS(4025), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92640] = 2,
    ACTIONS(4027), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92648] = 2,
    ACTIONS(2749), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92656] = 2,
    ACTIONS(4029), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92664] = 2,
    ACTIONS(4031), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92672] = 2,
    ACTIONS(4033), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92680] = 2,
    ACTIONS(4035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92688] = 2,
    ACTIONS(4037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92696] = 2,
    ACTIONS(4039), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92704] = 2,
    ACTIONS(4041), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92712] = 2,
    ACTIONS(4043), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92720] = 2,
    ACTIONS(4045), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92728] = 2,
    ACTIONS(4047), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92736] = 2,
    ACTIONS(4049), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92744] = 2,
    ACTIONS(4051), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92752] = 2,
    ACTIONS(4053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92760] = 2,
    ACTIONS(4055), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92768] = 2,
    ACTIONS(4057), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92776] = 2,
    ACTIONS(4059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92784] = 2,
    ACTIONS(1065), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92792] = 2,
    ACTIONS(4061), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92800] = 2,
    ACTIONS(4063), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92808] = 2,
    ACTIONS(2647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92816] = 2,
    ACTIONS(2626), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92824] = 2,
    ACTIONS(4065), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92832] = 2,
    ACTIONS(2684), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92840] = 2,
    ACTIONS(4067), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92848] = 2,
    ACTIONS(4069), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92856] = 2,
    ACTIONS(4071), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92864] = 2,
    ACTIONS(4073), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92872] = 2,
    ACTIONS(4075), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92880] = 2,
    ACTIONS(4077), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92888] = 2,
    ACTIONS(4079), 1,
      anon_sym_COLON_EQ,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92896] = 2,
    ACTIONS(4081), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92904] = 2,
    ACTIONS(4083), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92912] = 2,
    ACTIONS(4085), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92920] = 2,
    ACTIONS(4087), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92928] = 2,
    ACTIONS(4089), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92936] = 2,
    ACTIONS(2772), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92944] = 2,
    ACTIONS(4091), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92952] = 2,
    ACTIONS(4093), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92960] = 2,
    ACTIONS(4095), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92968] = 2,
    ACTIONS(3281), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92976] = 2,
    ACTIONS(1037), 1,
      anon_sym_def,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92984] = 2,
    ACTIONS(4097), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [92992] = 2,
    ACTIONS(3275), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [93000] = 2,
    ACTIONS(4099), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [93008] = 2,
    ACTIONS(4101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
  [93016] = 2,
    ACTIONS(4103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_comment,
      sym_line_continuation,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(95)] = 0,
  [SMALL_STATE(96)] = 101,
  [SMALL_STATE(97)] = 202,
  [SMALL_STATE(98)] = 310,
  [SMALL_STATE(99)] = 418,
  [SMALL_STATE(100)] = 532,
  [SMALL_STATE(101)] = 648,
  [SMALL_STATE(102)] = 762,
  [SMALL_STATE(103)] = 876,
  [SMALL_STATE(104)] = 984,
  [SMALL_STATE(105)] = 1098,
  [SMALL_STATE(106)] = 1206,
  [SMALL_STATE(107)] = 1320,
  [SMALL_STATE(108)] = 1434,
  [SMALL_STATE(109)] = 1548,
  [SMALL_STATE(110)] = 1662,
  [SMALL_STATE(111)] = 1776,
  [SMALL_STATE(112)] = 1884,
  [SMALL_STATE(113)] = 1992,
  [SMALL_STATE(114)] = 2108,
  [SMALL_STATE(115)] = 2222,
  [SMALL_STATE(116)] = 2336,
  [SMALL_STATE(117)] = 2450,
  [SMALL_STATE(118)] = 2558,
  [SMALL_STATE(119)] = 2672,
  [SMALL_STATE(120)] = 2786,
  [SMALL_STATE(121)] = 2900,
  [SMALL_STATE(122)] = 3014,
  [SMALL_STATE(123)] = 3128,
  [SMALL_STATE(124)] = 3242,
  [SMALL_STATE(125)] = 3356,
  [SMALL_STATE(126)] = 3470,
  [SMALL_STATE(127)] = 3584,
  [SMALL_STATE(128)] = 3694,
  [SMALL_STATE(129)] = 3804,
  [SMALL_STATE(130)] = 3918,
  [SMALL_STATE(131)] = 4032,
  [SMALL_STATE(132)] = 4146,
  [SMALL_STATE(133)] = 4260,
  [SMALL_STATE(134)] = 4374,
  [SMALL_STATE(135)] = 4482,
  [SMALL_STATE(136)] = 4596,
  [SMALL_STATE(137)] = 4706,
  [SMALL_STATE(138)] = 4811,
  [SMALL_STATE(139)] = 4920,
  [SMALL_STATE(140)] = 5029,
  [SMALL_STATE(141)] = 5134,
  [SMALL_STATE(142)] = 5239,
  [SMALL_STATE(143)] = 5348,
  [SMALL_STATE(144)] = 5453,
  [SMALL_STATE(145)] = 5558,
  [SMALL_STATE(146)] = 5663,
  [SMALL_STATE(147)] = 5768,
  [SMALL_STATE(148)] = 5873,
  [SMALL_STATE(149)] = 5978,
  [SMALL_STATE(150)] = 6083,
  [SMALL_STATE(151)] = 6188,
  [SMALL_STATE(152)] = 6293,
  [SMALL_STATE(153)] = 6402,
  [SMALL_STATE(154)] = 6501,
  [SMALL_STATE(155)] = 6606,
  [SMALL_STATE(156)] = 6711,
  [SMALL_STATE(157)] = 6820,
  [SMALL_STATE(158)] = 6925,
  [SMALL_STATE(159)] = 7030,
  [SMALL_STATE(160)] = 7135,
  [SMALL_STATE(161)] = 7240,
  [SMALL_STATE(162)] = 7349,
  [SMALL_STATE(163)] = 7454,
  [SMALL_STATE(164)] = 7553,
  [SMALL_STATE(165)] = 7662,
  [SMALL_STATE(166)] = 7767,
  [SMALL_STATE(167)] = 7872,
  [SMALL_STATE(168)] = 7977,
  [SMALL_STATE(169)] = 8082,
  [SMALL_STATE(170)] = 8187,
  [SMALL_STATE(171)] = 8293,
  [SMALL_STATE(172)] = 8399,
  [SMALL_STATE(173)] = 8505,
  [SMALL_STATE(174)] = 8611,
  [SMALL_STATE(175)] = 8717,
  [SMALL_STATE(176)] = 8823,
  [SMALL_STATE(177)] = 8929,
  [SMALL_STATE(178)] = 9035,
  [SMALL_STATE(179)] = 9141,
  [SMALL_STATE(180)] = 9247,
  [SMALL_STATE(181)] = 9353,
  [SMALL_STATE(182)] = 9459,
  [SMALL_STATE(183)] = 9565,
  [SMALL_STATE(184)] = 9671,
  [SMALL_STATE(185)] = 9777,
  [SMALL_STATE(186)] = 9883,
  [SMALL_STATE(187)] = 9989,
  [SMALL_STATE(188)] = 10095,
  [SMALL_STATE(189)] = 10201,
  [SMALL_STATE(190)] = 10307,
  [SMALL_STATE(191)] = 10413,
  [SMALL_STATE(192)] = 10519,
  [SMALL_STATE(193)] = 10625,
  [SMALL_STATE(194)] = 10731,
  [SMALL_STATE(195)] = 10837,
  [SMALL_STATE(196)] = 10943,
  [SMALL_STATE(197)] = 11049,
  [SMALL_STATE(198)] = 11155,
  [SMALL_STATE(199)] = 11261,
  [SMALL_STATE(200)] = 11367,
  [SMALL_STATE(201)] = 11470,
  [SMALL_STATE(202)] = 11573,
  [SMALL_STATE(203)] = 11676,
  [SMALL_STATE(204)] = 11779,
  [SMALL_STATE(205)] = 11884,
  [SMALL_STATE(206)] = 11987,
  [SMALL_STATE(207)] = 12090,
  [SMALL_STATE(208)] = 12193,
  [SMALL_STATE(209)] = 12296,
  [SMALL_STATE(210)] = 12399,
  [SMALL_STATE(211)] = 12501,
  [SMALL_STATE(212)] = 12605,
  [SMALL_STATE(213)] = 12707,
  [SMALL_STATE(214)] = 12809,
  [SMALL_STATE(215)] = 12911,
  [SMALL_STATE(216)] = 13013,
  [SMALL_STATE(217)] = 13115,
  [SMALL_STATE(218)] = 13217,
  [SMALL_STATE(219)] = 13321,
  [SMALL_STATE(220)] = 13419,
  [SMALL_STATE(221)] = 13521,
  [SMALL_STATE(222)] = 13619,
  [SMALL_STATE(223)] = 13721,
  [SMALL_STATE(224)] = 13825,
  [SMALL_STATE(225)] = 13927,
  [SMALL_STATE(226)] = 14029,
  [SMALL_STATE(227)] = 14131,
  [SMALL_STATE(228)] = 14233,
  [SMALL_STATE(229)] = 14335,
  [SMALL_STATE(230)] = 14437,
  [SMALL_STATE(231)] = 14539,
  [SMALL_STATE(232)] = 14641,
  [SMALL_STATE(233)] = 14745,
  [SMALL_STATE(234)] = 14847,
  [SMALL_STATE(235)] = 14949,
  [SMALL_STATE(236)] = 15051,
  [SMALL_STATE(237)] = 15155,
  [SMALL_STATE(238)] = 15257,
  [SMALL_STATE(239)] = 15359,
  [SMALL_STATE(240)] = 15461,
  [SMALL_STATE(241)] = 15563,
  [SMALL_STATE(242)] = 15665,
  [SMALL_STATE(243)] = 15767,
  [SMALL_STATE(244)] = 15869,
  [SMALL_STATE(245)] = 15971,
  [SMALL_STATE(246)] = 16072,
  [SMALL_STATE(247)] = 16171,
  [SMALL_STATE(248)] = 16272,
  [SMALL_STATE(249)] = 16373,
  [SMALL_STATE(250)] = 16474,
  [SMALL_STATE(251)] = 16575,
  [SMALL_STATE(252)] = 16674,
  [SMALL_STATE(253)] = 16775,
  [SMALL_STATE(254)] = 16876,
  [SMALL_STATE(255)] = 16977,
  [SMALL_STATE(256)] = 17076,
  [SMALL_STATE(257)] = 17175,
  [SMALL_STATE(258)] = 17274,
  [SMALL_STATE(259)] = 17375,
  [SMALL_STATE(260)] = 17476,
  [SMALL_STATE(261)] = 17575,
  [SMALL_STATE(262)] = 17676,
  [SMALL_STATE(263)] = 17777,
  [SMALL_STATE(264)] = 17878,
  [SMALL_STATE(265)] = 17979,
  [SMALL_STATE(266)] = 18080,
  [SMALL_STATE(267)] = 18181,
  [SMALL_STATE(268)] = 18280,
  [SMALL_STATE(269)] = 18381,
  [SMALL_STATE(270)] = 18482,
  [SMALL_STATE(271)] = 18583,
  [SMALL_STATE(272)] = 18684,
  [SMALL_STATE(273)] = 18785,
  [SMALL_STATE(274)] = 18886,
  [SMALL_STATE(275)] = 18987,
  [SMALL_STATE(276)] = 19088,
  [SMALL_STATE(277)] = 19189,
  [SMALL_STATE(278)] = 19288,
  [SMALL_STATE(279)] = 19387,
  [SMALL_STATE(280)] = 19488,
  [SMALL_STATE(281)] = 19589,
  [SMALL_STATE(282)] = 19688,
  [SMALL_STATE(283)] = 19784,
  [SMALL_STATE(284)] = 19880,
  [SMALL_STATE(285)] = 19978,
  [SMALL_STATE(286)] = 20074,
  [SMALL_STATE(287)] = 20170,
  [SMALL_STATE(288)] = 20266,
  [SMALL_STATE(289)] = 20340,
  [SMALL_STATE(290)] = 20438,
  [SMALL_STATE(291)] = 20534,
  [SMALL_STATE(292)] = 20630,
  [SMALL_STATE(293)] = 20706,
  [SMALL_STATE(294)] = 20802,
  [SMALL_STATE(295)] = 20876,
  [SMALL_STATE(296)] = 20974,
  [SMALL_STATE(297)] = 21048,
  [SMALL_STATE(298)] = 21144,
  [SMALL_STATE(299)] = 21240,
  [SMALL_STATE(300)] = 21336,
  [SMALL_STATE(301)] = 21432,
  [SMALL_STATE(302)] = 21530,
  [SMALL_STATE(303)] = 21628,
  [SMALL_STATE(304)] = 21724,
  [SMALL_STATE(305)] = 21820,
  [SMALL_STATE(306)] = 21918,
  [SMALL_STATE(307)] = 22016,
  [SMALL_STATE(308)] = 22114,
  [SMALL_STATE(309)] = 22212,
  [SMALL_STATE(310)] = 22308,
  [SMALL_STATE(311)] = 22404,
  [SMALL_STATE(312)] = 22500,
  [SMALL_STATE(313)] = 22598,
  [SMALL_STATE(314)] = 22696,
  [SMALL_STATE(315)] = 22794,
  [SMALL_STATE(316)] = 22892,
  [SMALL_STATE(317)] = 22988,
  [SMALL_STATE(318)] = 23084,
  [SMALL_STATE(319)] = 23182,
  [SMALL_STATE(320)] = 23280,
  [SMALL_STATE(321)] = 23378,
  [SMALL_STATE(322)] = 23474,
  [SMALL_STATE(323)] = 23572,
  [SMALL_STATE(324)] = 23670,
  [SMALL_STATE(325)] = 23766,
  [SMALL_STATE(326)] = 23862,
  [SMALL_STATE(327)] = 23958,
  [SMALL_STATE(328)] = 24054,
  [SMALL_STATE(329)] = 24149,
  [SMALL_STATE(330)] = 24244,
  [SMALL_STATE(331)] = 24339,
  [SMALL_STATE(332)] = 24434,
  [SMALL_STATE(333)] = 24529,
  [SMALL_STATE(334)] = 24624,
  [SMALL_STATE(335)] = 24719,
  [SMALL_STATE(336)] = 24814,
  [SMALL_STATE(337)] = 24909,
  [SMALL_STATE(338)] = 25004,
  [SMALL_STATE(339)] = 25099,
  [SMALL_STATE(340)] = 25194,
  [SMALL_STATE(341)] = 25289,
  [SMALL_STATE(342)] = 25384,
  [SMALL_STATE(343)] = 25478,
  [SMALL_STATE(344)] = 25570,
  [SMALL_STATE(345)] = 25662,
  [SMALL_STATE(346)] = 25754,
  [SMALL_STATE(347)] = 25846,
  [SMALL_STATE(348)] = 25938,
  [SMALL_STATE(349)] = 26030,
  [SMALL_STATE(350)] = 26122,
  [SMALL_STATE(351)] = 26214,
  [SMALL_STATE(352)] = 26306,
  [SMALL_STATE(353)] = 26398,
  [SMALL_STATE(354)] = 26490,
  [SMALL_STATE(355)] = 26582,
  [SMALL_STATE(356)] = 26674,
  [SMALL_STATE(357)] = 26766,
  [SMALL_STATE(358)] = 26858,
  [SMALL_STATE(359)] = 26950,
  [SMALL_STATE(360)] = 27042,
  [SMALL_STATE(361)] = 27134,
  [SMALL_STATE(362)] = 27226,
  [SMALL_STATE(363)] = 27318,
  [SMALL_STATE(364)] = 27412,
  [SMALL_STATE(365)] = 27484,
  [SMALL_STATE(366)] = 27576,
  [SMALL_STATE(367)] = 27668,
  [SMALL_STATE(368)] = 27760,
  [SMALL_STATE(369)] = 27852,
  [SMALL_STATE(370)] = 27944,
  [SMALL_STATE(371)] = 28036,
  [SMALL_STATE(372)] = 28128,
  [SMALL_STATE(373)] = 28220,
  [SMALL_STATE(374)] = 28312,
  [SMALL_STATE(375)] = 28406,
  [SMALL_STATE(376)] = 28498,
  [SMALL_STATE(377)] = 28590,
  [SMALL_STATE(378)] = 28682,
  [SMALL_STATE(379)] = 28774,
  [SMALL_STATE(380)] = 28866,
  [SMALL_STATE(381)] = 28958,
  [SMALL_STATE(382)] = 29050,
  [SMALL_STATE(383)] = 29142,
  [SMALL_STATE(384)] = 29234,
  [SMALL_STATE(385)] = 29326,
  [SMALL_STATE(386)] = 29418,
  [SMALL_STATE(387)] = 29510,
  [SMALL_STATE(388)] = 29604,
  [SMALL_STATE(389)] = 29696,
  [SMALL_STATE(390)] = 29788,
  [SMALL_STATE(391)] = 29880,
  [SMALL_STATE(392)] = 29972,
  [SMALL_STATE(393)] = 30064,
  [SMALL_STATE(394)] = 30156,
  [SMALL_STATE(395)] = 30248,
  [SMALL_STATE(396)] = 30340,
  [SMALL_STATE(397)] = 30432,
  [SMALL_STATE(398)] = 30524,
  [SMALL_STATE(399)] = 30616,
  [SMALL_STATE(400)] = 30708,
  [SMALL_STATE(401)] = 30800,
  [SMALL_STATE(402)] = 30892,
  [SMALL_STATE(403)] = 30984,
  [SMALL_STATE(404)] = 31076,
  [SMALL_STATE(405)] = 31168,
  [SMALL_STATE(406)] = 31260,
  [SMALL_STATE(407)] = 31352,
  [SMALL_STATE(408)] = 31444,
  [SMALL_STATE(409)] = 31538,
  [SMALL_STATE(410)] = 31630,
  [SMALL_STATE(411)] = 31722,
  [SMALL_STATE(412)] = 31814,
  [SMALL_STATE(413)] = 31906,
  [SMALL_STATE(414)] = 31998,
  [SMALL_STATE(415)] = 32090,
  [SMALL_STATE(416)] = 32182,
  [SMALL_STATE(417)] = 32274,
  [SMALL_STATE(418)] = 32366,
  [SMALL_STATE(419)] = 32458,
  [SMALL_STATE(420)] = 32550,
  [SMALL_STATE(421)] = 32642,
  [SMALL_STATE(422)] = 32734,
  [SMALL_STATE(423)] = 32826,
  [SMALL_STATE(424)] = 32918,
  [SMALL_STATE(425)] = 33010,
  [SMALL_STATE(426)] = 33102,
  [SMALL_STATE(427)] = 33194,
  [SMALL_STATE(428)] = 33286,
  [SMALL_STATE(429)] = 33378,
  [SMALL_STATE(430)] = 33470,
  [SMALL_STATE(431)] = 33562,
  [SMALL_STATE(432)] = 33654,
  [SMALL_STATE(433)] = 33746,
  [SMALL_STATE(434)] = 33838,
  [SMALL_STATE(435)] = 33930,
  [SMALL_STATE(436)] = 34022,
  [SMALL_STATE(437)] = 34114,
  [SMALL_STATE(438)] = 34206,
  [SMALL_STATE(439)] = 34298,
  [SMALL_STATE(440)] = 34390,
  [SMALL_STATE(441)] = 34455,
  [SMALL_STATE(442)] = 34520,
  [SMALL_STATE(443)] = 34585,
  [SMALL_STATE(444)] = 34652,
  [SMALL_STATE(445)] = 34719,
  [SMALL_STATE(446)] = 34775,
  [SMALL_STATE(447)] = 34837,
  [SMALL_STATE(448)] = 34903,
  [SMALL_STATE(449)] = 34959,
  [SMALL_STATE(450)] = 35015,
  [SMALL_STATE(451)] = 35077,
  [SMALL_STATE(452)] = 35133,
  [SMALL_STATE(453)] = 35199,
  [SMALL_STATE(454)] = 35259,
  [SMALL_STATE(455)] = 35321,
  [SMALL_STATE(456)] = 35383,
  [SMALL_STATE(457)] = 35449,
  [SMALL_STATE(458)] = 35511,
  [SMALL_STATE(459)] = 35573,
  [SMALL_STATE(460)] = 35635,
  [SMALL_STATE(461)] = 35701,
  [SMALL_STATE(462)] = 35763,
  [SMALL_STATE(463)] = 35819,
  [SMALL_STATE(464)] = 35875,
  [SMALL_STATE(465)] = 35939,
  [SMALL_STATE(466)] = 35999,
  [SMALL_STATE(467)] = 36065,
  [SMALL_STATE(468)] = 36131,
  [SMALL_STATE(469)] = 36187,
  [SMALL_STATE(470)] = 36253,
  [SMALL_STATE(471)] = 36313,
  [SMALL_STATE(472)] = 36379,
  [SMALL_STATE(473)] = 36440,
  [SMALL_STATE(474)] = 36501,
  [SMALL_STATE(475)] = 36587,
  [SMALL_STATE(476)] = 36673,
  [SMALL_STATE(477)] = 36726,
  [SMALL_STATE(478)] = 36783,
  [SMALL_STATE(479)] = 36840,
  [SMALL_STATE(480)] = 36897,
  [SMALL_STATE(481)] = 36950,
  [SMALL_STATE(482)] = 37007,
  [SMALL_STATE(483)] = 37064,
  [SMALL_STATE(484)] = 37117,
  [SMALL_STATE(485)] = 37170,
  [SMALL_STATE(486)] = 37227,
  [SMALL_STATE(487)] = 37280,
  [SMALL_STATE(488)] = 37337,
  [SMALL_STATE(489)] = 37390,
  [SMALL_STATE(490)] = 37443,
  [SMALL_STATE(491)] = 37496,
  [SMALL_STATE(492)] = 37553,
  [SMALL_STATE(493)] = 37606,
  [SMALL_STATE(494)] = 37659,
  [SMALL_STATE(495)] = 37712,
  [SMALL_STATE(496)] = 37765,
  [SMALL_STATE(497)] = 37822,
  [SMALL_STATE(498)] = 37879,
  [SMALL_STATE(499)] = 37932,
  [SMALL_STATE(500)] = 37985,
  [SMALL_STATE(501)] = 38042,
  [SMALL_STATE(502)] = 38095,
  [SMALL_STATE(503)] = 38148,
  [SMALL_STATE(504)] = 38205,
  [SMALL_STATE(505)] = 38291,
  [SMALL_STATE(506)] = 38377,
  [SMALL_STATE(507)] = 38428,
  [SMALL_STATE(508)] = 38479,
  [SMALL_STATE(509)] = 38562,
  [SMALL_STATE(510)] = 38613,
  [SMALL_STATE(511)] = 38664,
  [SMALL_STATE(512)] = 38715,
  [SMALL_STATE(513)] = 38798,
  [SMALL_STATE(514)] = 38849,
  [SMALL_STATE(515)] = 38900,
  [SMALL_STATE(516)] = 38983,
  [SMALL_STATE(517)] = 39034,
  [SMALL_STATE(518)] = 39085,
  [SMALL_STATE(519)] = 39136,
  [SMALL_STATE(520)] = 39219,
  [SMALL_STATE(521)] = 39270,
  [SMALL_STATE(522)] = 39321,
  [SMALL_STATE(523)] = 39372,
  [SMALL_STATE(524)] = 39423,
  [SMALL_STATE(525)] = 39474,
  [SMALL_STATE(526)] = 39525,
  [SMALL_STATE(527)] = 39576,
  [SMALL_STATE(528)] = 39627,
  [SMALL_STATE(529)] = 39678,
  [SMALL_STATE(530)] = 39761,
  [SMALL_STATE(531)] = 39812,
  [SMALL_STATE(532)] = 39863,
  [SMALL_STATE(533)] = 39914,
  [SMALL_STATE(534)] = 39965,
  [SMALL_STATE(535)] = 40016,
  [SMALL_STATE(536)] = 40067,
  [SMALL_STATE(537)] = 40118,
  [SMALL_STATE(538)] = 40169,
  [SMALL_STATE(539)] = 40220,
  [SMALL_STATE(540)] = 40271,
  [SMALL_STATE(541)] = 40322,
  [SMALL_STATE(542)] = 40373,
  [SMALL_STATE(543)] = 40424,
  [SMALL_STATE(544)] = 40475,
  [SMALL_STATE(545)] = 40526,
  [SMALL_STATE(546)] = 40577,
  [SMALL_STATE(547)] = 40628,
  [SMALL_STATE(548)] = 40679,
  [SMALL_STATE(549)] = 40762,
  [SMALL_STATE(550)] = 40813,
  [SMALL_STATE(551)] = 40864,
  [SMALL_STATE(552)] = 40947,
  [SMALL_STATE(553)] = 40998,
  [SMALL_STATE(554)] = 41049,
  [SMALL_STATE(555)] = 41132,
  [SMALL_STATE(556)] = 41183,
  [SMALL_STATE(557)] = 41234,
  [SMALL_STATE(558)] = 41285,
  [SMALL_STATE(559)] = 41336,
  [SMALL_STATE(560)] = 41387,
  [SMALL_STATE(561)] = 41438,
  [SMALL_STATE(562)] = 41489,
  [SMALL_STATE(563)] = 41540,
  [SMALL_STATE(564)] = 41591,
  [SMALL_STATE(565)] = 41642,
  [SMALL_STATE(566)] = 41693,
  [SMALL_STATE(567)] = 41776,
  [SMALL_STATE(568)] = 41827,
  [SMALL_STATE(569)] = 41878,
  [SMALL_STATE(570)] = 41961,
  [SMALL_STATE(571)] = 42012,
  [SMALL_STATE(572)] = 42063,
  [SMALL_STATE(573)] = 42114,
  [SMALL_STATE(574)] = 42165,
  [SMALL_STATE(575)] = 42216,
  [SMALL_STATE(576)] = 42267,
  [SMALL_STATE(577)] = 42350,
  [SMALL_STATE(578)] = 42401,
  [SMALL_STATE(579)] = 42452,
  [SMALL_STATE(580)] = 42503,
  [SMALL_STATE(581)] = 42554,
  [SMALL_STATE(582)] = 42605,
  [SMALL_STATE(583)] = 42656,
  [SMALL_STATE(584)] = 42707,
  [SMALL_STATE(585)] = 42758,
  [SMALL_STATE(586)] = 42841,
  [SMALL_STATE(587)] = 42892,
  [SMALL_STATE(588)] = 42975,
  [SMALL_STATE(589)] = 43026,
  [SMALL_STATE(590)] = 43077,
  [SMALL_STATE(591)] = 43128,
  [SMALL_STATE(592)] = 43179,
  [SMALL_STATE(593)] = 43230,
  [SMALL_STATE(594)] = 43281,
  [SMALL_STATE(595)] = 43332,
  [SMALL_STATE(596)] = 43383,
  [SMALL_STATE(597)] = 43466,
  [SMALL_STATE(598)] = 43517,
  [SMALL_STATE(599)] = 43568,
  [SMALL_STATE(600)] = 43619,
  [SMALL_STATE(601)] = 43699,
  [SMALL_STATE(602)] = 43779,
  [SMALL_STATE(603)] = 43859,
  [SMALL_STATE(604)] = 43939,
  [SMALL_STATE(605)] = 44019,
  [SMALL_STATE(606)] = 44099,
  [SMALL_STATE(607)] = 44176,
  [SMALL_STATE(608)] = 44253,
  [SMALL_STATE(609)] = 44322,
  [SMALL_STATE(610)] = 44391,
  [SMALL_STATE(611)] = 44460,
  [SMALL_STATE(612)] = 44529,
  [SMALL_STATE(613)] = 44598,
  [SMALL_STATE(614)] = 44667,
  [SMALL_STATE(615)] = 44736,
  [SMALL_STATE(616)] = 44805,
  [SMALL_STATE(617)] = 44878,
  [SMALL_STATE(618)] = 44947,
  [SMALL_STATE(619)] = 45020,
  [SMALL_STATE(620)] = 45089,
  [SMALL_STATE(621)] = 45158,
  [SMALL_STATE(622)] = 45231,
  [SMALL_STATE(623)] = 45300,
  [SMALL_STATE(624)] = 45369,
  [SMALL_STATE(625)] = 45442,
  [SMALL_STATE(626)] = 45511,
  [SMALL_STATE(627)] = 45580,
  [SMALL_STATE(628)] = 45649,
  [SMALL_STATE(629)] = 45718,
  [SMALL_STATE(630)] = 45787,
  [SMALL_STATE(631)] = 45856,
  [SMALL_STATE(632)] = 45925,
  [SMALL_STATE(633)] = 45994,
  [SMALL_STATE(634)] = 46063,
  [SMALL_STATE(635)] = 46132,
  [SMALL_STATE(636)] = 46201,
  [SMALL_STATE(637)] = 46270,
  [SMALL_STATE(638)] = 46339,
  [SMALL_STATE(639)] = 46408,
  [SMALL_STATE(640)] = 46477,
  [SMALL_STATE(641)] = 46546,
  [SMALL_STATE(642)] = 46619,
  [SMALL_STATE(643)] = 46688,
  [SMALL_STATE(644)] = 46757,
  [SMALL_STATE(645)] = 46826,
  [SMALL_STATE(646)] = 46895,
  [SMALL_STATE(647)] = 46964,
  [SMALL_STATE(648)] = 47033,
  [SMALL_STATE(649)] = 47102,
  [SMALL_STATE(650)] = 47171,
  [SMALL_STATE(651)] = 47244,
  [SMALL_STATE(652)] = 47313,
  [SMALL_STATE(653)] = 47382,
  [SMALL_STATE(654)] = 47451,
  [SMALL_STATE(655)] = 47520,
  [SMALL_STATE(656)] = 47589,
  [SMALL_STATE(657)] = 47658,
  [SMALL_STATE(658)] = 47727,
  [SMALL_STATE(659)] = 47796,
  [SMALL_STATE(660)] = 47865,
  [SMALL_STATE(661)] = 47934,
  [SMALL_STATE(662)] = 48003,
  [SMALL_STATE(663)] = 48076,
  [SMALL_STATE(664)] = 48145,
  [SMALL_STATE(665)] = 48214,
  [SMALL_STATE(666)] = 48283,
  [SMALL_STATE(667)] = 48352,
  [SMALL_STATE(668)] = 48425,
  [SMALL_STATE(669)] = 48494,
  [SMALL_STATE(670)] = 48567,
  [SMALL_STATE(671)] = 48636,
  [SMALL_STATE(672)] = 48705,
  [SMALL_STATE(673)] = 48778,
  [SMALL_STATE(674)] = 48851,
  [SMALL_STATE(675)] = 48920,
  [SMALL_STATE(676)] = 48993,
  [SMALL_STATE(677)] = 49062,
  [SMALL_STATE(678)] = 49131,
  [SMALL_STATE(679)] = 49200,
  [SMALL_STATE(680)] = 49269,
  [SMALL_STATE(681)] = 49338,
  [SMALL_STATE(682)] = 49411,
  [SMALL_STATE(683)] = 49484,
  [SMALL_STATE(684)] = 49557,
  [SMALL_STATE(685)] = 49630,
  [SMALL_STATE(686)] = 49699,
  [SMALL_STATE(687)] = 49768,
  [SMALL_STATE(688)] = 49837,
  [SMALL_STATE(689)] = 49906,
  [SMALL_STATE(690)] = 49979,
  [SMALL_STATE(691)] = 50052,
  [SMALL_STATE(692)] = 50121,
  [SMALL_STATE(693)] = 50190,
  [SMALL_STATE(694)] = 50259,
  [SMALL_STATE(695)] = 50328,
  [SMALL_STATE(696)] = 50397,
  [SMALL_STATE(697)] = 50442,
  [SMALL_STATE(698)] = 50487,
  [SMALL_STATE(699)] = 50532,
  [SMALL_STATE(700)] = 50577,
  [SMALL_STATE(701)] = 50622,
  [SMALL_STATE(702)] = 50667,
  [SMALL_STATE(703)] = 50744,
  [SMALL_STATE(704)] = 50821,
  [SMALL_STATE(705)] = 50866,
  [SMALL_STATE(706)] = 50943,
  [SMALL_STATE(707)] = 51009,
  [SMALL_STATE(708)] = 51085,
  [SMALL_STATE(709)] = 51131,
  [SMALL_STATE(710)] = 51185,
  [SMALL_STATE(711)] = 51239,
  [SMALL_STATE(712)] = 51307,
  [SMALL_STATE(713)] = 51357,
  [SMALL_STATE(714)] = 51407,
  [SMALL_STATE(715)] = 51473,
  [SMALL_STATE(716)] = 51531,
  [SMALL_STATE(717)] = 51595,
  [SMALL_STATE(718)] = 51649,
  [SMALL_STATE(719)] = 51699,
  [SMALL_STATE(720)] = 51753,
  [SMALL_STATE(721)] = 51803,
  [SMALL_STATE(722)] = 51853,
  [SMALL_STATE(723)] = 51921,
  [SMALL_STATE(724)] = 51967,
  [SMALL_STATE(725)] = 52013,
  [SMALL_STATE(726)] = 52075,
  [SMALL_STATE(727)] = 52129,
  [SMALL_STATE(728)] = 52189,
  [SMALL_STATE(729)] = 52257,
  [SMALL_STATE(730)] = 52311,
  [SMALL_STATE(731)] = 52369,
  [SMALL_STATE(732)] = 52433,
  [SMALL_STATE(733)] = 52495,
  [SMALL_STATE(734)] = 52563,
  [SMALL_STATE(735)] = 52609,
  [SMALL_STATE(736)] = 52655,
  [SMALL_STATE(737)] = 52701,
  [SMALL_STATE(738)] = 52747,
  [SMALL_STATE(739)] = 52793,
  [SMALL_STATE(740)] = 52839,
  [SMALL_STATE(741)] = 52915,
  [SMALL_STATE(742)] = 52969,
  [SMALL_STATE(743)] = 53037,
  [SMALL_STATE(744)] = 53097,
  [SMALL_STATE(745)] = 53173,
  [SMALL_STATE(746)] = 53221,
  [SMALL_STATE(747)] = 53269,
  [SMALL_STATE(748)] = 53317,
  [SMALL_STATE(749)] = 53391,
  [SMALL_STATE(750)] = 53445,
  [SMALL_STATE(751)] = 53505,
  [SMALL_STATE(752)] = 53573,
  [SMALL_STATE(753)] = 53627,
  [SMALL_STATE(754)] = 53685,
  [SMALL_STATE(755)] = 53751,
  [SMALL_STATE(756)] = 53815,
  [SMALL_STATE(757)] = 53877,
  [SMALL_STATE(758)] = 53922,
  [SMALL_STATE(759)] = 53975,
  [SMALL_STATE(760)] = 54020,
  [SMALL_STATE(761)] = 54065,
  [SMALL_STATE(762)] = 54110,
  [SMALL_STATE(763)] = 54157,
  [SMALL_STATE(764)] = 54204,
  [SMALL_STATE(765)] = 54251,
  [SMALL_STATE(766)] = 54294,
  [SMALL_STATE(767)] = 54347,
  [SMALL_STATE(768)] = 54390,
  [SMALL_STATE(769)] = 54433,
  [SMALL_STATE(770)] = 54476,
  [SMALL_STATE(771)] = 54529,
  [SMALL_STATE(772)] = 54572,
  [SMALL_STATE(773)] = 54615,
  [SMALL_STATE(774)] = 54668,
  [SMALL_STATE(775)] = 54711,
  [SMALL_STATE(776)] = 54778,
  [SMALL_STATE(777)] = 54845,
  [SMALL_STATE(778)] = 54894,
  [SMALL_STATE(779)] = 54937,
  [SMALL_STATE(780)] = 54980,
  [SMALL_STATE(781)] = 55039,
  [SMALL_STATE(782)] = 55082,
  [SMALL_STATE(783)] = 55125,
  [SMALL_STATE(784)] = 55168,
  [SMALL_STATE(785)] = 55215,
  [SMALL_STATE(786)] = 55276,
  [SMALL_STATE(787)] = 55339,
  [SMALL_STATE(788)] = 55396,
  [SMALL_STATE(789)] = 55461,
  [SMALL_STATE(790)] = 55514,
  [SMALL_STATE(791)] = 55573,
  [SMALL_STATE(792)] = 55640,
  [SMALL_STATE(793)] = 55693,
  [SMALL_STATE(794)] = 55750,
  [SMALL_STATE(795)] = 55815,
  [SMALL_STATE(796)] = 55858,
  [SMALL_STATE(797)] = 55921,
  [SMALL_STATE(798)] = 55982,
  [SMALL_STATE(799)] = 56039,
  [SMALL_STATE(800)] = 56092,
  [SMALL_STATE(801)] = 56159,
  [SMALL_STATE(802)] = 56218,
  [SMALL_STATE(803)] = 56271,
  [SMALL_STATE(804)] = 56314,
  [SMALL_STATE(805)] = 56379,
  [SMALL_STATE(806)] = 56424,
  [SMALL_STATE(807)] = 56469,
  [SMALL_STATE(808)] = 56512,
  [SMALL_STATE(809)] = 56557,
  [SMALL_STATE(810)] = 56600,
  [SMALL_STATE(811)] = 56663,
  [SMALL_STATE(812)] = 56712,
  [SMALL_STATE(813)] = 56773,
  [SMALL_STATE(814)] = 56816,
  [SMALL_STATE(815)] = 56883,
  [SMALL_STATE(816)] = 56926,
  [SMALL_STATE(817)] = 56969,
  [SMALL_STATE(818)] = 57012,
  [SMALL_STATE(819)] = 57055,
  [SMALL_STATE(820)] = 57098,
  [SMALL_STATE(821)] = 57141,
  [SMALL_STATE(822)] = 57184,
  [SMALL_STATE(823)] = 57229,
  [SMALL_STATE(824)] = 57274,
  [SMALL_STATE(825)] = 57317,
  [SMALL_STATE(826)] = 57362,
  [SMALL_STATE(827)] = 57409,
  [SMALL_STATE(828)] = 57456,
  [SMALL_STATE(829)] = 57501,
  [SMALL_STATE(830)] = 57546,
  [SMALL_STATE(831)] = 57591,
  [SMALL_STATE(832)] = 57634,
  [SMALL_STATE(833)] = 57677,
  [SMALL_STATE(834)] = 57720,
  [SMALL_STATE(835)] = 57763,
  [SMALL_STATE(836)] = 57806,
  [SMALL_STATE(837)] = 57879,
  [SMALL_STATE(838)] = 57922,
  [SMALL_STATE(839)] = 57965,
  [SMALL_STATE(840)] = 58008,
  [SMALL_STATE(841)] = 58075,
  [SMALL_STATE(842)] = 58118,
  [SMALL_STATE(843)] = 58161,
  [SMALL_STATE(844)] = 58214,
  [SMALL_STATE(845)] = 58257,
  [SMALL_STATE(846)] = 58300,
  [SMALL_STATE(847)] = 58343,
  [SMALL_STATE(848)] = 58386,
  [SMALL_STATE(849)] = 58429,
  [SMALL_STATE(850)] = 58472,
  [SMALL_STATE(851)] = 58515,
  [SMALL_STATE(852)] = 58558,
  [SMALL_STATE(853)] = 58601,
  [SMALL_STATE(854)] = 58644,
  [SMALL_STATE(855)] = 58687,
  [SMALL_STATE(856)] = 58730,
  [SMALL_STATE(857)] = 58773,
  [SMALL_STATE(858)] = 58816,
  [SMALL_STATE(859)] = 58859,
  [SMALL_STATE(860)] = 58904,
  [SMALL_STATE(861)] = 58949,
  [SMALL_STATE(862)] = 58994,
  [SMALL_STATE(863)] = 59037,
  [SMALL_STATE(864)] = 59084,
  [SMALL_STATE(865)] = 59131,
  [SMALL_STATE(866)] = 59174,
  [SMALL_STATE(867)] = 59221,
  [SMALL_STATE(868)] = 59268,
  [SMALL_STATE(869)] = 59315,
  [SMALL_STATE(870)] = 59358,
  [SMALL_STATE(871)] = 59401,
  [SMALL_STATE(872)] = 59444,
  [SMALL_STATE(873)] = 59487,
  [SMALL_STATE(874)] = 59530,
  [SMALL_STATE(875)] = 59577,
  [SMALL_STATE(876)] = 59620,
  [SMALL_STATE(877)] = 59663,
  [SMALL_STATE(878)] = 59706,
  [SMALL_STATE(879)] = 59749,
  [SMALL_STATE(880)] = 59792,
  [SMALL_STATE(881)] = 59835,
  [SMALL_STATE(882)] = 59878,
  [SMALL_STATE(883)] = 59921,
  [SMALL_STATE(884)] = 59964,
  [SMALL_STATE(885)] = 60007,
  [SMALL_STATE(886)] = 60050,
  [SMALL_STATE(887)] = 60093,
  [SMALL_STATE(888)] = 60136,
  [SMALL_STATE(889)] = 60179,
  [SMALL_STATE(890)] = 60222,
  [SMALL_STATE(891)] = 60265,
  [SMALL_STATE(892)] = 60308,
  [SMALL_STATE(893)] = 60351,
  [SMALL_STATE(894)] = 60394,
  [SMALL_STATE(895)] = 60437,
  [SMALL_STATE(896)] = 60480,
  [SMALL_STATE(897)] = 60523,
  [SMALL_STATE(898)] = 60566,
  [SMALL_STATE(899)] = 60609,
  [SMALL_STATE(900)] = 60652,
  [SMALL_STATE(901)] = 60695,
  [SMALL_STATE(902)] = 60738,
  [SMALL_STATE(903)] = 60781,
  [SMALL_STATE(904)] = 60824,
  [SMALL_STATE(905)] = 60867,
  [SMALL_STATE(906)] = 60910,
  [SMALL_STATE(907)] = 60953,
  [SMALL_STATE(908)] = 60996,
  [SMALL_STATE(909)] = 61039,
  [SMALL_STATE(910)] = 61082,
  [SMALL_STATE(911)] = 61125,
  [SMALL_STATE(912)] = 61172,
  [SMALL_STATE(913)] = 61215,
  [SMALL_STATE(914)] = 61262,
  [SMALL_STATE(915)] = 61309,
  [SMALL_STATE(916)] = 61354,
  [SMALL_STATE(917)] = 61399,
  [SMALL_STATE(918)] = 61444,
  [SMALL_STATE(919)] = 61489,
  [SMALL_STATE(920)] = 61532,
  [SMALL_STATE(921)] = 61574,
  [SMALL_STATE(922)] = 61616,
  [SMALL_STATE(923)] = 61658,
  [SMALL_STATE(924)] = 61700,
  [SMALL_STATE(925)] = 61742,
  [SMALL_STATE(926)] = 61784,
  [SMALL_STATE(927)] = 61826,
  [SMALL_STATE(928)] = 61898,
  [SMALL_STATE(929)] = 61940,
  [SMALL_STATE(930)] = 61982,
  [SMALL_STATE(931)] = 62028,
  [SMALL_STATE(932)] = 62074,
  [SMALL_STATE(933)] = 62120,
  [SMALL_STATE(934)] = 62170,
  [SMALL_STATE(935)] = 62216,
  [SMALL_STATE(936)] = 62262,
  [SMALL_STATE(937)] = 62308,
  [SMALL_STATE(938)] = 62354,
  [SMALL_STATE(939)] = 62420,
  [SMALL_STATE(940)] = 62480,
  [SMALL_STATE(941)] = 62542,
  [SMALL_STATE(942)] = 62606,
  [SMALL_STATE(943)] = 62662,
  [SMALL_STATE(944)] = 62714,
  [SMALL_STATE(945)] = 62780,
  [SMALL_STATE(946)] = 62838,
  [SMALL_STATE(947)] = 62890,
  [SMALL_STATE(948)] = 62942,
  [SMALL_STATE(949)] = 62986,
  [SMALL_STATE(950)] = 63030,
  [SMALL_STATE(951)] = 63074,
  [SMALL_STATE(952)] = 63146,
  [SMALL_STATE(953)] = 63192,
  [SMALL_STATE(954)] = 63238,
  [SMALL_STATE(955)] = 63280,
  [SMALL_STATE(956)] = 63322,
  [SMALL_STATE(957)] = 63364,
  [SMALL_STATE(958)] = 63406,
  [SMALL_STATE(959)] = 63448,
  [SMALL_STATE(960)] = 63490,
  [SMALL_STATE(961)] = 63532,
  [SMALL_STATE(962)] = 63574,
  [SMALL_STATE(963)] = 63616,
  [SMALL_STATE(964)] = 63658,
  [SMALL_STATE(965)] = 63702,
  [SMALL_STATE(966)] = 63744,
  [SMALL_STATE(967)] = 63786,
  [SMALL_STATE(968)] = 63828,
  [SMALL_STATE(969)] = 63870,
  [SMALL_STATE(970)] = 63912,
  [SMALL_STATE(971)] = 63954,
  [SMALL_STATE(972)] = 63996,
  [SMALL_STATE(973)] = 64038,
  [SMALL_STATE(974)] = 64080,
  [SMALL_STATE(975)] = 64122,
  [SMALL_STATE(976)] = 64164,
  [SMALL_STATE(977)] = 64206,
  [SMALL_STATE(978)] = 64248,
  [SMALL_STATE(979)] = 64290,
  [SMALL_STATE(980)] = 64332,
  [SMALL_STATE(981)] = 64378,
  [SMALL_STATE(982)] = 64424,
  [SMALL_STATE(983)] = 64474,
  [SMALL_STATE(984)] = 64516,
  [SMALL_STATE(985)] = 64558,
  [SMALL_STATE(986)] = 64600,
  [SMALL_STATE(987)] = 64642,
  [SMALL_STATE(988)] = 64684,
  [SMALL_STATE(989)] = 64726,
  [SMALL_STATE(990)] = 64768,
  [SMALL_STATE(991)] = 64810,
  [SMALL_STATE(992)] = 64852,
  [SMALL_STATE(993)] = 64894,
  [SMALL_STATE(994)] = 64936,
  [SMALL_STATE(995)] = 64978,
  [SMALL_STATE(996)] = 65020,
  [SMALL_STATE(997)] = 65062,
  [SMALL_STATE(998)] = 65104,
  [SMALL_STATE(999)] = 65146,
  [SMALL_STATE(1000)] = 65188,
  [SMALL_STATE(1001)] = 65230,
  [SMALL_STATE(1002)] = 65272,
  [SMALL_STATE(1003)] = 65314,
  [SMALL_STATE(1004)] = 65356,
  [SMALL_STATE(1005)] = 65398,
  [SMALL_STATE(1006)] = 65440,
  [SMALL_STATE(1007)] = 65482,
  [SMALL_STATE(1008)] = 65524,
  [SMALL_STATE(1009)] = 65566,
  [SMALL_STATE(1010)] = 65612,
  [SMALL_STATE(1011)] = 65654,
  [SMALL_STATE(1012)] = 65696,
  [SMALL_STATE(1013)] = 65738,
  [SMALL_STATE(1014)] = 65780,
  [SMALL_STATE(1015)] = 65822,
  [SMALL_STATE(1016)] = 65864,
  [SMALL_STATE(1017)] = 65906,
  [SMALL_STATE(1018)] = 65948,
  [SMALL_STATE(1019)] = 65990,
  [SMALL_STATE(1020)] = 66034,
  [SMALL_STATE(1021)] = 66076,
  [SMALL_STATE(1022)] = 66118,
  [SMALL_STATE(1023)] = 66160,
  [SMALL_STATE(1024)] = 66202,
  [SMALL_STATE(1025)] = 66246,
  [SMALL_STATE(1026)] = 66288,
  [SMALL_STATE(1027)] = 66332,
  [SMALL_STATE(1028)] = 66374,
  [SMALL_STATE(1029)] = 66416,
  [SMALL_STATE(1030)] = 66458,
  [SMALL_STATE(1031)] = 66500,
  [SMALL_STATE(1032)] = 66544,
  [SMALL_STATE(1033)] = 66586,
  [SMALL_STATE(1034)] = 66628,
  [SMALL_STATE(1035)] = 66670,
  [SMALL_STATE(1036)] = 66712,
  [SMALL_STATE(1037)] = 66754,
  [SMALL_STATE(1038)] = 66796,
  [SMALL_STATE(1039)] = 66838,
  [SMALL_STATE(1040)] = 66880,
  [SMALL_STATE(1041)] = 66922,
  [SMALL_STATE(1042)] = 66964,
  [SMALL_STATE(1043)] = 67006,
  [SMALL_STATE(1044)] = 67048,
  [SMALL_STATE(1045)] = 67090,
  [SMALL_STATE(1046)] = 67132,
  [SMALL_STATE(1047)] = 67174,
  [SMALL_STATE(1048)] = 67216,
  [SMALL_STATE(1049)] = 67258,
  [SMALL_STATE(1050)] = 67300,
  [SMALL_STATE(1051)] = 67342,
  [SMALL_STATE(1052)] = 67384,
  [SMALL_STATE(1053)] = 67426,
  [SMALL_STATE(1054)] = 67468,
  [SMALL_STATE(1055)] = 67510,
  [SMALL_STATE(1056)] = 67552,
  [SMALL_STATE(1057)] = 67593,
  [SMALL_STATE(1058)] = 67634,
  [SMALL_STATE(1059)] = 67677,
  [SMALL_STATE(1060)] = 67720,
  [SMALL_STATE(1061)] = 67763,
  [SMALL_STATE(1062)] = 67808,
  [SMALL_STATE(1063)] = 67853,
  [SMALL_STATE(1064)] = 67894,
  [SMALL_STATE(1065)] = 67935,
  [SMALL_STATE(1066)] = 67976,
  [SMALL_STATE(1067)] = 68017,
  [SMALL_STATE(1068)] = 68062,
  [SMALL_STATE(1069)] = 68105,
  [SMALL_STATE(1070)] = 68148,
  [SMALL_STATE(1071)] = 68191,
  [SMALL_STATE(1072)] = 68234,
  [SMALL_STATE(1073)] = 68275,
  [SMALL_STATE(1074)] = 68316,
  [SMALL_STATE(1075)] = 68357,
  [SMALL_STATE(1076)] = 68400,
  [SMALL_STATE(1077)] = 68441,
  [SMALL_STATE(1078)] = 68488,
  [SMALL_STATE(1079)] = 68529,
  [SMALL_STATE(1080)] = 68572,
  [SMALL_STATE(1081)] = 68615,
  [SMALL_STATE(1082)] = 68658,
  [SMALL_STATE(1083)] = 68699,
  [SMALL_STATE(1084)] = 68742,
  [SMALL_STATE(1085)] = 68785,
  [SMALL_STATE(1086)] = 68826,
  [SMALL_STATE(1087)] = 68869,
  [SMALL_STATE(1088)] = 68914,
  [SMALL_STATE(1089)] = 68959,
  [SMALL_STATE(1090)] = 69002,
  [SMALL_STATE(1091)] = 69043,
  [SMALL_STATE(1092)] = 69084,
  [SMALL_STATE(1093)] = 69125,
  [SMALL_STATE(1094)] = 69166,
  [SMALL_STATE(1095)] = 69207,
  [SMALL_STATE(1096)] = 69248,
  [SMALL_STATE(1097)] = 69289,
  [SMALL_STATE(1098)] = 69330,
  [SMALL_STATE(1099)] = 69371,
  [SMALL_STATE(1100)] = 69420,
  [SMALL_STATE(1101)] = 69461,
  [SMALL_STATE(1102)] = 69502,
  [SMALL_STATE(1103)] = 69543,
  [SMALL_STATE(1104)] = 69584,
  [SMALL_STATE(1105)] = 69625,
  [SMALL_STATE(1106)] = 69666,
  [SMALL_STATE(1107)] = 69707,
  [SMALL_STATE(1108)] = 69748,
  [SMALL_STATE(1109)] = 69789,
  [SMALL_STATE(1110)] = 69830,
  [SMALL_STATE(1111)] = 69873,
  [SMALL_STATE(1112)] = 69914,
  [SMALL_STATE(1113)] = 69955,
  [SMALL_STATE(1114)] = 70000,
  [SMALL_STATE(1115)] = 70043,
  [SMALL_STATE(1116)] = 70086,
  [SMALL_STATE(1117)] = 70127,
  [SMALL_STATE(1118)] = 70168,
  [SMALL_STATE(1119)] = 70209,
  [SMALL_STATE(1120)] = 70250,
  [SMALL_STATE(1121)] = 70291,
  [SMALL_STATE(1122)] = 70332,
  [SMALL_STATE(1123)] = 70373,
  [SMALL_STATE(1124)] = 70413,
  [SMALL_STATE(1125)] = 70453,
  [SMALL_STATE(1126)] = 70493,
  [SMALL_STATE(1127)] = 70567,
  [SMALL_STATE(1128)] = 70641,
  [SMALL_STATE(1129)] = 70683,
  [SMALL_STATE(1130)] = 70725,
  [SMALL_STATE(1131)] = 70767,
  [SMALL_STATE(1132)] = 70809,
  [SMALL_STATE(1133)] = 70877,
  [SMALL_STATE(1134)] = 70945,
  [SMALL_STATE(1135)] = 71013,
  [SMALL_STATE(1136)] = 71081,
  [SMALL_STATE(1137)] = 71149,
  [SMALL_STATE(1138)] = 71217,
  [SMALL_STATE(1139)] = 71285,
  [SMALL_STATE(1140)] = 71353,
  [SMALL_STATE(1141)] = 71421,
  [SMALL_STATE(1142)] = 71489,
  [SMALL_STATE(1143)] = 71557,
  [SMALL_STATE(1144)] = 71625,
  [SMALL_STATE(1145)] = 71693,
  [SMALL_STATE(1146)] = 71761,
  [SMALL_STATE(1147)] = 71829,
  [SMALL_STATE(1148)] = 71897,
  [SMALL_STATE(1149)] = 71965,
  [SMALL_STATE(1150)] = 72033,
  [SMALL_STATE(1151)] = 72101,
  [SMALL_STATE(1152)] = 72169,
  [SMALL_STATE(1153)] = 72237,
  [SMALL_STATE(1154)] = 72305,
  [SMALL_STATE(1155)] = 72373,
  [SMALL_STATE(1156)] = 72441,
  [SMALL_STATE(1157)] = 72509,
  [SMALL_STATE(1158)] = 72577,
  [SMALL_STATE(1159)] = 72645,
  [SMALL_STATE(1160)] = 72713,
  [SMALL_STATE(1161)] = 72781,
  [SMALL_STATE(1162)] = 72849,
  [SMALL_STATE(1163)] = 72917,
  [SMALL_STATE(1164)] = 72985,
  [SMALL_STATE(1165)] = 73053,
  [SMALL_STATE(1166)] = 73121,
  [SMALL_STATE(1167)] = 73189,
  [SMALL_STATE(1168)] = 73257,
  [SMALL_STATE(1169)] = 73322,
  [SMALL_STATE(1170)] = 73387,
  [SMALL_STATE(1171)] = 73452,
  [SMALL_STATE(1172)] = 73517,
  [SMALL_STATE(1173)] = 73582,
  [SMALL_STATE(1174)] = 73648,
  [SMALL_STATE(1175)] = 73714,
  [SMALL_STATE(1176)] = 73780,
  [SMALL_STATE(1177)] = 73846,
  [SMALL_STATE(1178)] = 73912,
  [SMALL_STATE(1179)] = 73978,
  [SMALL_STATE(1180)] = 74044,
  [SMALL_STATE(1181)] = 74110,
  [SMALL_STATE(1182)] = 74176,
  [SMALL_STATE(1183)] = 74242,
  [SMALL_STATE(1184)] = 74308,
  [SMALL_STATE(1185)] = 74374,
  [SMALL_STATE(1186)] = 74440,
  [SMALL_STATE(1187)] = 74506,
  [SMALL_STATE(1188)] = 74572,
  [SMALL_STATE(1189)] = 74638,
  [SMALL_STATE(1190)] = 74704,
  [SMALL_STATE(1191)] = 74770,
  [SMALL_STATE(1192)] = 74836,
  [SMALL_STATE(1193)] = 74902,
  [SMALL_STATE(1194)] = 74965,
  [SMALL_STATE(1195)] = 75023,
  [SMALL_STATE(1196)] = 75081,
  [SMALL_STATE(1197)] = 75139,
  [SMALL_STATE(1198)] = 75197,
  [SMALL_STATE(1199)] = 75255,
  [SMALL_STATE(1200)] = 75313,
  [SMALL_STATE(1201)] = 75371,
  [SMALL_STATE(1202)] = 75429,
  [SMALL_STATE(1203)] = 75461,
  [SMALL_STATE(1204)] = 75499,
  [SMALL_STATE(1205)] = 75531,
  [SMALL_STATE(1206)] = 75563,
  [SMALL_STATE(1207)] = 75595,
  [SMALL_STATE(1208)] = 75633,
  [SMALL_STATE(1209)] = 75665,
  [SMALL_STATE(1210)] = 75697,
  [SMALL_STATE(1211)] = 75734,
  [SMALL_STATE(1212)] = 75771,
  [SMALL_STATE(1213)] = 75808,
  [SMALL_STATE(1214)] = 75845,
  [SMALL_STATE(1215)] = 75881,
  [SMALL_STATE(1216)] = 75911,
  [SMALL_STATE(1217)] = 75941,
  [SMALL_STATE(1218)] = 75971,
  [SMALL_STATE(1219)] = 76007,
  [SMALL_STATE(1220)] = 76037,
  [SMALL_STATE(1221)] = 76071,
  [SMALL_STATE(1222)] = 76101,
  [SMALL_STATE(1223)] = 76135,
  [SMALL_STATE(1224)] = 76165,
  [SMALL_STATE(1225)] = 76201,
  [SMALL_STATE(1226)] = 76231,
  [SMALL_STATE(1227)] = 76261,
  [SMALL_STATE(1228)] = 76297,
  [SMALL_STATE(1229)] = 76326,
  [SMALL_STATE(1230)] = 76355,
  [SMALL_STATE(1231)] = 76384,
  [SMALL_STATE(1232)] = 76413,
  [SMALL_STATE(1233)] = 76442,
  [SMALL_STATE(1234)] = 76471,
  [SMALL_STATE(1235)] = 76500,
  [SMALL_STATE(1236)] = 76529,
  [SMALL_STATE(1237)] = 76554,
  [SMALL_STATE(1238)] = 76589,
  [SMALL_STATE(1239)] = 76614,
  [SMALL_STATE(1240)] = 76639,
  [SMALL_STATE(1241)] = 76668,
  [SMALL_STATE(1242)] = 76697,
  [SMALL_STATE(1243)] = 76726,
  [SMALL_STATE(1244)] = 76751,
  [SMALL_STATE(1245)] = 76780,
  [SMALL_STATE(1246)] = 76809,
  [SMALL_STATE(1247)] = 76838,
  [SMALL_STATE(1248)] = 76867,
  [SMALL_STATE(1249)] = 76896,
  [SMALL_STATE(1250)] = 76925,
  [SMALL_STATE(1251)] = 76954,
  [SMALL_STATE(1252)] = 76983,
  [SMALL_STATE(1253)] = 77012,
  [SMALL_STATE(1254)] = 77041,
  [SMALL_STATE(1255)] = 77070,
  [SMALL_STATE(1256)] = 77099,
  [SMALL_STATE(1257)] = 77128,
  [SMALL_STATE(1258)] = 77163,
  [SMALL_STATE(1259)] = 77191,
  [SMALL_STATE(1260)] = 77215,
  [SMALL_STATE(1261)] = 77261,
  [SMALL_STATE(1262)] = 77285,
  [SMALL_STATE(1263)] = 77331,
  [SMALL_STATE(1264)] = 77363,
  [SMALL_STATE(1265)] = 77409,
  [SMALL_STATE(1266)] = 77433,
  [SMALL_STATE(1267)] = 77479,
  [SMALL_STATE(1268)] = 77525,
  [SMALL_STATE(1269)] = 77571,
  [SMALL_STATE(1270)] = 77617,
  [SMALL_STATE(1271)] = 77663,
  [SMALL_STATE(1272)] = 77709,
  [SMALL_STATE(1273)] = 77755,
  [SMALL_STATE(1274)] = 77801,
  [SMALL_STATE(1275)] = 77847,
  [SMALL_STATE(1276)] = 77893,
  [SMALL_STATE(1277)] = 77939,
  [SMALL_STATE(1278)] = 77985,
  [SMALL_STATE(1279)] = 78031,
  [SMALL_STATE(1280)] = 78061,
  [SMALL_STATE(1281)] = 78085,
  [SMALL_STATE(1282)] = 78131,
  [SMALL_STATE(1283)] = 78159,
  [SMALL_STATE(1284)] = 78205,
  [SMALL_STATE(1285)] = 78237,
  [SMALL_STATE(1286)] = 78280,
  [SMALL_STATE(1287)] = 78320,
  [SMALL_STATE(1288)] = 78360,
  [SMALL_STATE(1289)] = 78400,
  [SMALL_STATE(1290)] = 78426,
  [SMALL_STATE(1291)] = 78466,
  [SMALL_STATE(1292)] = 78503,
  [SMALL_STATE(1293)] = 78540,
  [SMALL_STATE(1294)] = 78581,
  [SMALL_STATE(1295)] = 78622,
  [SMALL_STATE(1296)] = 78663,
  [SMALL_STATE(1297)] = 78704,
  [SMALL_STATE(1298)] = 78745,
  [SMALL_STATE(1299)] = 78786,
  [SMALL_STATE(1300)] = 78827,
  [SMALL_STATE(1301)] = 78859,
  [SMALL_STATE(1302)] = 78877,
  [SMALL_STATE(1303)] = 78915,
  [SMALL_STATE(1304)] = 78953,
  [SMALL_STATE(1305)] = 78973,
  [SMALL_STATE(1306)] = 78991,
  [SMALL_STATE(1307)] = 79029,
  [SMALL_STATE(1308)] = 79067,
  [SMALL_STATE(1309)] = 79089,
  [SMALL_STATE(1310)] = 79107,
  [SMALL_STATE(1311)] = 79145,
  [SMALL_STATE(1312)] = 79171,
  [SMALL_STATE(1313)] = 79195,
  [SMALL_STATE(1314)] = 79233,
  [SMALL_STATE(1315)] = 79271,
  [SMALL_STATE(1316)] = 79297,
  [SMALL_STATE(1317)] = 79323,
  [SMALL_STATE(1318)] = 79352,
  [SMALL_STATE(1319)] = 79369,
  [SMALL_STATE(1320)] = 79394,
  [SMALL_STATE(1321)] = 79423,
  [SMALL_STATE(1322)] = 79452,
  [SMALL_STATE(1323)] = 79477,
  [SMALL_STATE(1324)] = 79494,
  [SMALL_STATE(1325)] = 79523,
  [SMALL_STATE(1326)] = 79552,
  [SMALL_STATE(1327)] = 79577,
  [SMALL_STATE(1328)] = 79598,
  [SMALL_STATE(1329)] = 79623,
  [SMALL_STATE(1330)] = 79652,
  [SMALL_STATE(1331)] = 79681,
  [SMALL_STATE(1332)] = 79710,
  [SMALL_STATE(1333)] = 79735,
  [SMALL_STATE(1334)] = 79758,
  [SMALL_STATE(1335)] = 79775,
  [SMALL_STATE(1336)] = 79804,
  [SMALL_STATE(1337)] = 79833,
  [SMALL_STATE(1338)] = 79862,
  [SMALL_STATE(1339)] = 79887,
  [SMALL_STATE(1340)] = 79908,
  [SMALL_STATE(1341)] = 79933,
  [SMALL_STATE(1342)] = 79962,
  [SMALL_STATE(1343)] = 79991,
  [SMALL_STATE(1344)] = 80008,
  [SMALL_STATE(1345)] = 80031,
  [SMALL_STATE(1346)] = 80060,
  [SMALL_STATE(1347)] = 80089,
  [SMALL_STATE(1348)] = 80118,
  [SMALL_STATE(1349)] = 80135,
  [SMALL_STATE(1350)] = 80152,
  [SMALL_STATE(1351)] = 80171,
  [SMALL_STATE(1352)] = 80196,
  [SMALL_STATE(1353)] = 80225,
  [SMALL_STATE(1354)] = 80254,
  [SMALL_STATE(1355)] = 80283,
  [SMALL_STATE(1356)] = 80312,
  [SMALL_STATE(1357)] = 80331,
  [SMALL_STATE(1358)] = 80360,
  [SMALL_STATE(1359)] = 80389,
  [SMALL_STATE(1360)] = 80418,
  [SMALL_STATE(1361)] = 80447,
  [SMALL_STATE(1362)] = 80471,
  [SMALL_STATE(1363)] = 80495,
  [SMALL_STATE(1364)] = 80511,
  [SMALL_STATE(1365)] = 80535,
  [SMALL_STATE(1366)] = 80559,
  [SMALL_STATE(1367)] = 80575,
  [SMALL_STATE(1368)] = 80593,
  [SMALL_STATE(1369)] = 80609,
  [SMALL_STATE(1370)] = 80629,
  [SMALL_STATE(1371)] = 80651,
  [SMALL_STATE(1372)] = 80673,
  [SMALL_STATE(1373)] = 80691,
  [SMALL_STATE(1374)] = 80715,
  [SMALL_STATE(1375)] = 80739,
  [SMALL_STATE(1376)] = 80763,
  [SMALL_STATE(1377)] = 80785,
  [SMALL_STATE(1378)] = 80805,
  [SMALL_STATE(1379)] = 80821,
  [SMALL_STATE(1380)] = 80839,
  [SMALL_STATE(1381)] = 80857,
  [SMALL_STATE(1382)] = 80873,
  [SMALL_STATE(1383)] = 80897,
  [SMALL_STATE(1384)] = 80921,
  [SMALL_STATE(1385)] = 80945,
  [SMALL_STATE(1386)] = 80969,
  [SMALL_STATE(1387)] = 80991,
  [SMALL_STATE(1388)] = 81015,
  [SMALL_STATE(1389)] = 81031,
  [SMALL_STATE(1390)] = 81053,
  [SMALL_STATE(1391)] = 81071,
  [SMALL_STATE(1392)] = 81091,
  [SMALL_STATE(1393)] = 81110,
  [SMALL_STATE(1394)] = 81129,
  [SMALL_STATE(1395)] = 81152,
  [SMALL_STATE(1396)] = 81181,
  [SMALL_STATE(1397)] = 81210,
  [SMALL_STATE(1398)] = 81231,
  [SMALL_STATE(1399)] = 81248,
  [SMALL_STATE(1400)] = 81277,
  [SMALL_STATE(1401)] = 81298,
  [SMALL_STATE(1402)] = 81325,
  [SMALL_STATE(1403)] = 81344,
  [SMALL_STATE(1404)] = 81373,
  [SMALL_STATE(1405)] = 81394,
  [SMALL_STATE(1406)] = 81423,
  [SMALL_STATE(1407)] = 81450,
  [SMALL_STATE(1408)] = 81477,
  [SMALL_STATE(1409)] = 81496,
  [SMALL_STATE(1410)] = 81513,
  [SMALL_STATE(1411)] = 81532,
  [SMALL_STATE(1412)] = 81553,
  [SMALL_STATE(1413)] = 81580,
  [SMALL_STATE(1414)] = 81601,
  [SMALL_STATE(1415)] = 81620,
  [SMALL_STATE(1416)] = 81649,
  [SMALL_STATE(1417)] = 81670,
  [SMALL_STATE(1418)] = 81691,
  [SMALL_STATE(1419)] = 81708,
  [SMALL_STATE(1420)] = 81735,
  [SMALL_STATE(1421)] = 81754,
  [SMALL_STATE(1422)] = 81781,
  [SMALL_STATE(1423)] = 81810,
  [SMALL_STATE(1424)] = 81833,
  [SMALL_STATE(1425)] = 81860,
  [SMALL_STATE(1426)] = 81881,
  [SMALL_STATE(1427)] = 81902,
  [SMALL_STATE(1428)] = 81923,
  [SMALL_STATE(1429)] = 81946,
  [SMALL_STATE(1430)] = 81975,
  [SMALL_STATE(1431)] = 82004,
  [SMALL_STATE(1432)] = 82031,
  [SMALL_STATE(1433)] = 82052,
  [SMALL_STATE(1434)] = 82075,
  [SMALL_STATE(1435)] = 82101,
  [SMALL_STATE(1436)] = 82119,
  [SMALL_STATE(1437)] = 82141,
  [SMALL_STATE(1438)] = 82159,
  [SMALL_STATE(1439)] = 82177,
  [SMALL_STATE(1440)] = 82201,
  [SMALL_STATE(1441)] = 82215,
  [SMALL_STATE(1442)] = 82233,
  [SMALL_STATE(1443)] = 82259,
  [SMALL_STATE(1444)] = 82285,
  [SMALL_STATE(1445)] = 82307,
  [SMALL_STATE(1446)] = 82333,
  [SMALL_STATE(1447)] = 82351,
  [SMALL_STATE(1448)] = 82377,
  [SMALL_STATE(1449)] = 82403,
  [SMALL_STATE(1450)] = 82429,
  [SMALL_STATE(1451)] = 82451,
  [SMALL_STATE(1452)] = 82469,
  [SMALL_STATE(1453)] = 82491,
  [SMALL_STATE(1454)] = 82511,
  [SMALL_STATE(1455)] = 82533,
  [SMALL_STATE(1456)] = 82551,
  [SMALL_STATE(1457)] = 82573,
  [SMALL_STATE(1458)] = 82599,
  [SMALL_STATE(1459)] = 82617,
  [SMALL_STATE(1460)] = 82643,
  [SMALL_STATE(1461)] = 82661,
  [SMALL_STATE(1462)] = 82683,
  [SMALL_STATE(1463)] = 82709,
  [SMALL_STATE(1464)] = 82735,
  [SMALL_STATE(1465)] = 82759,
  [SMALL_STATE(1466)] = 82785,
  [SMALL_STATE(1467)] = 82811,
  [SMALL_STATE(1468)] = 82837,
  [SMALL_STATE(1469)] = 82855,
  [SMALL_STATE(1470)] = 82873,
  [SMALL_STATE(1471)] = 82889,
  [SMALL_STATE(1472)] = 82911,
  [SMALL_STATE(1473)] = 82937,
  [SMALL_STATE(1474)] = 82963,
  [SMALL_STATE(1475)] = 82983,
  [SMALL_STATE(1476)] = 83009,
  [SMALL_STATE(1477)] = 83035,
  [SMALL_STATE(1478)] = 83053,
  [SMALL_STATE(1479)] = 83071,
  [SMALL_STATE(1480)] = 83089,
  [SMALL_STATE(1481)] = 83107,
  [SMALL_STATE(1482)] = 83125,
  [SMALL_STATE(1483)] = 83147,
  [SMALL_STATE(1484)] = 83169,
  [SMALL_STATE(1485)] = 83195,
  [SMALL_STATE(1486)] = 83221,
  [SMALL_STATE(1487)] = 83245,
  [SMALL_STATE(1488)] = 83271,
  [SMALL_STATE(1489)] = 83287,
  [SMALL_STATE(1490)] = 83309,
  [SMALL_STATE(1491)] = 83335,
  [SMALL_STATE(1492)] = 83361,
  [SMALL_STATE(1493)] = 83387,
  [SMALL_STATE(1494)] = 83413,
  [SMALL_STATE(1495)] = 83439,
  [SMALL_STATE(1496)] = 83457,
  [SMALL_STATE(1497)] = 83475,
  [SMALL_STATE(1498)] = 83501,
  [SMALL_STATE(1499)] = 83527,
  [SMALL_STATE(1500)] = 83548,
  [SMALL_STATE(1501)] = 83569,
  [SMALL_STATE(1502)] = 83590,
  [SMALL_STATE(1503)] = 83607,
  [SMALL_STATE(1504)] = 83628,
  [SMALL_STATE(1505)] = 83641,
  [SMALL_STATE(1506)] = 83658,
  [SMALL_STATE(1507)] = 83679,
  [SMALL_STATE(1508)] = 83692,
  [SMALL_STATE(1509)] = 83709,
  [SMALL_STATE(1510)] = 83730,
  [SMALL_STATE(1511)] = 83751,
  [SMALL_STATE(1512)] = 83774,
  [SMALL_STATE(1513)] = 83787,
  [SMALL_STATE(1514)] = 83800,
  [SMALL_STATE(1515)] = 83821,
  [SMALL_STATE(1516)] = 83842,
  [SMALL_STATE(1517)] = 83855,
  [SMALL_STATE(1518)] = 83868,
  [SMALL_STATE(1519)] = 83887,
  [SMALL_STATE(1520)] = 83900,
  [SMALL_STATE(1521)] = 83921,
  [SMALL_STATE(1522)] = 83942,
  [SMALL_STATE(1523)] = 83959,
  [SMALL_STATE(1524)] = 83980,
  [SMALL_STATE(1525)] = 84003,
  [SMALL_STATE(1526)] = 84018,
  [SMALL_STATE(1527)] = 84039,
  [SMALL_STATE(1528)] = 84056,
  [SMALL_STATE(1529)] = 84073,
  [SMALL_STATE(1530)] = 84094,
  [SMALL_STATE(1531)] = 84111,
  [SMALL_STATE(1532)] = 84132,
  [SMALL_STATE(1533)] = 84149,
  [SMALL_STATE(1534)] = 84172,
  [SMALL_STATE(1535)] = 84187,
  [SMALL_STATE(1536)] = 84200,
  [SMALL_STATE(1537)] = 84217,
  [SMALL_STATE(1538)] = 84232,
  [SMALL_STATE(1539)] = 84253,
  [SMALL_STATE(1540)] = 84270,
  [SMALL_STATE(1541)] = 84287,
  [SMALL_STATE(1542)] = 84302,
  [SMALL_STATE(1543)] = 84315,
  [SMALL_STATE(1544)] = 84328,
  [SMALL_STATE(1545)] = 84351,
  [SMALL_STATE(1546)] = 84364,
  [SMALL_STATE(1547)] = 84377,
  [SMALL_STATE(1548)] = 84398,
  [SMALL_STATE(1549)] = 84415,
  [SMALL_STATE(1550)] = 84432,
  [SMALL_STATE(1551)] = 84449,
  [SMALL_STATE(1552)] = 84462,
  [SMALL_STATE(1553)] = 84475,
  [SMALL_STATE(1554)] = 84496,
  [SMALL_STATE(1555)] = 84509,
  [SMALL_STATE(1556)] = 84530,
  [SMALL_STATE(1557)] = 84543,
  [SMALL_STATE(1558)] = 84566,
  [SMALL_STATE(1559)] = 84587,
  [SMALL_STATE(1560)] = 84604,
  [SMALL_STATE(1561)] = 84621,
  [SMALL_STATE(1562)] = 84638,
  [SMALL_STATE(1563)] = 84655,
  [SMALL_STATE(1564)] = 84676,
  [SMALL_STATE(1565)] = 84689,
  [SMALL_STATE(1566)] = 84710,
  [SMALL_STATE(1567)] = 84731,
  [SMALL_STATE(1568)] = 84752,
  [SMALL_STATE(1569)] = 84769,
  [SMALL_STATE(1570)] = 84790,
  [SMALL_STATE(1571)] = 84807,
  [SMALL_STATE(1572)] = 84820,
  [SMALL_STATE(1573)] = 84837,
  [SMALL_STATE(1574)] = 84850,
  [SMALL_STATE(1575)] = 84863,
  [SMALL_STATE(1576)] = 84882,
  [SMALL_STATE(1577)] = 84895,
  [SMALL_STATE(1578)] = 84912,
  [SMALL_STATE(1579)] = 84925,
  [SMALL_STATE(1580)] = 84940,
  [SMALL_STATE(1581)] = 84953,
  [SMALL_STATE(1582)] = 84970,
  [SMALL_STATE(1583)] = 84985,
  [SMALL_STATE(1584)] = 85006,
  [SMALL_STATE(1585)] = 85023,
  [SMALL_STATE(1586)] = 85036,
  [SMALL_STATE(1587)] = 85053,
  [SMALL_STATE(1588)] = 85074,
  [SMALL_STATE(1589)] = 85089,
  [SMALL_STATE(1590)] = 85104,
  [SMALL_STATE(1591)] = 85121,
  [SMALL_STATE(1592)] = 85133,
  [SMALL_STATE(1593)] = 85153,
  [SMALL_STATE(1594)] = 85165,
  [SMALL_STATE(1595)] = 85181,
  [SMALL_STATE(1596)] = 85193,
  [SMALL_STATE(1597)] = 85205,
  [SMALL_STATE(1598)] = 85217,
  [SMALL_STATE(1599)] = 85237,
  [SMALL_STATE(1600)] = 85249,
  [SMALL_STATE(1601)] = 85261,
  [SMALL_STATE(1602)] = 85281,
  [SMALL_STATE(1603)] = 85297,
  [SMALL_STATE(1604)] = 85315,
  [SMALL_STATE(1605)] = 85327,
  [SMALL_STATE(1606)] = 85339,
  [SMALL_STATE(1607)] = 85359,
  [SMALL_STATE(1608)] = 85379,
  [SMALL_STATE(1609)] = 85391,
  [SMALL_STATE(1610)] = 85403,
  [SMALL_STATE(1611)] = 85423,
  [SMALL_STATE(1612)] = 85435,
  [SMALL_STATE(1613)] = 85447,
  [SMALL_STATE(1614)] = 85459,
  [SMALL_STATE(1615)] = 85475,
  [SMALL_STATE(1616)] = 85487,
  [SMALL_STATE(1617)] = 85501,
  [SMALL_STATE(1618)] = 85513,
  [SMALL_STATE(1619)] = 85525,
  [SMALL_STATE(1620)] = 85537,
  [SMALL_STATE(1621)] = 85549,
  [SMALL_STATE(1622)] = 85569,
  [SMALL_STATE(1623)] = 85581,
  [SMALL_STATE(1624)] = 85601,
  [SMALL_STATE(1625)] = 85613,
  [SMALL_STATE(1626)] = 85631,
  [SMALL_STATE(1627)] = 85643,
  [SMALL_STATE(1628)] = 85655,
  [SMALL_STATE(1629)] = 85667,
  [SMALL_STATE(1630)] = 85679,
  [SMALL_STATE(1631)] = 85697,
  [SMALL_STATE(1632)] = 85717,
  [SMALL_STATE(1633)] = 85729,
  [SMALL_STATE(1634)] = 85743,
  [SMALL_STATE(1635)] = 85763,
  [SMALL_STATE(1636)] = 85775,
  [SMALL_STATE(1637)] = 85787,
  [SMALL_STATE(1638)] = 85799,
  [SMALL_STATE(1639)] = 85811,
  [SMALL_STATE(1640)] = 85829,
  [SMALL_STATE(1641)] = 85841,
  [SMALL_STATE(1642)] = 85853,
  [SMALL_STATE(1643)] = 85865,
  [SMALL_STATE(1644)] = 85885,
  [SMALL_STATE(1645)] = 85897,
  [SMALL_STATE(1646)] = 85913,
  [SMALL_STATE(1647)] = 85927,
  [SMALL_STATE(1648)] = 85947,
  [SMALL_STATE(1649)] = 85965,
  [SMALL_STATE(1650)] = 85977,
  [SMALL_STATE(1651)] = 85991,
  [SMALL_STATE(1652)] = 86009,
  [SMALL_STATE(1653)] = 86029,
  [SMALL_STATE(1654)] = 86049,
  [SMALL_STATE(1655)] = 86061,
  [SMALL_STATE(1656)] = 86073,
  [SMALL_STATE(1657)] = 86089,
  [SMALL_STATE(1658)] = 86109,
  [SMALL_STATE(1659)] = 86121,
  [SMALL_STATE(1660)] = 86133,
  [SMALL_STATE(1661)] = 86153,
  [SMALL_STATE(1662)] = 86165,
  [SMALL_STATE(1663)] = 86185,
  [SMALL_STATE(1664)] = 86197,
  [SMALL_STATE(1665)] = 86217,
  [SMALL_STATE(1666)] = 86229,
  [SMALL_STATE(1667)] = 86241,
  [SMALL_STATE(1668)] = 86253,
  [SMALL_STATE(1669)] = 86265,
  [SMALL_STATE(1670)] = 86277,
  [SMALL_STATE(1671)] = 86289,
  [SMALL_STATE(1672)] = 86309,
  [SMALL_STATE(1673)] = 86325,
  [SMALL_STATE(1674)] = 86345,
  [SMALL_STATE(1675)] = 86361,
  [SMALL_STATE(1676)] = 86375,
  [SMALL_STATE(1677)] = 86387,
  [SMALL_STATE(1678)] = 86399,
  [SMALL_STATE(1679)] = 86411,
  [SMALL_STATE(1680)] = 86427,
  [SMALL_STATE(1681)] = 86443,
  [SMALL_STATE(1682)] = 86461,
  [SMALL_STATE(1683)] = 86473,
  [SMALL_STATE(1684)] = 86485,
  [SMALL_STATE(1685)] = 86505,
  [SMALL_STATE(1686)] = 86521,
  [SMALL_STATE(1687)] = 86539,
  [SMALL_STATE(1688)] = 86555,
  [SMALL_STATE(1689)] = 86569,
  [SMALL_STATE(1690)] = 86589,
  [SMALL_STATE(1691)] = 86605,
  [SMALL_STATE(1692)] = 86625,
  [SMALL_STATE(1693)] = 86641,
  [SMALL_STATE(1694)] = 86653,
  [SMALL_STATE(1695)] = 86665,
  [SMALL_STATE(1696)] = 86676,
  [SMALL_STATE(1697)] = 86687,
  [SMALL_STATE(1698)] = 86698,
  [SMALL_STATE(1699)] = 86709,
  [SMALL_STATE(1700)] = 86720,
  [SMALL_STATE(1701)] = 86731,
  [SMALL_STATE(1702)] = 86742,
  [SMALL_STATE(1703)] = 86753,
  [SMALL_STATE(1704)] = 86764,
  [SMALL_STATE(1705)] = 86775,
  [SMALL_STATE(1706)] = 86786,
  [SMALL_STATE(1707)] = 86797,
  [SMALL_STATE(1708)] = 86814,
  [SMALL_STATE(1709)] = 86825,
  [SMALL_STATE(1710)] = 86842,
  [SMALL_STATE(1711)] = 86857,
  [SMALL_STATE(1712)] = 86868,
  [SMALL_STATE(1713)] = 86885,
  [SMALL_STATE(1714)] = 86896,
  [SMALL_STATE(1715)] = 86907,
  [SMALL_STATE(1716)] = 86918,
  [SMALL_STATE(1717)] = 86929,
  [SMALL_STATE(1718)] = 86946,
  [SMALL_STATE(1719)] = 86957,
  [SMALL_STATE(1720)] = 86968,
  [SMALL_STATE(1721)] = 86985,
  [SMALL_STATE(1722)] = 86996,
  [SMALL_STATE(1723)] = 87011,
  [SMALL_STATE(1724)] = 87028,
  [SMALL_STATE(1725)] = 87039,
  [SMALL_STATE(1726)] = 87050,
  [SMALL_STATE(1727)] = 87067,
  [SMALL_STATE(1728)] = 87084,
  [SMALL_STATE(1729)] = 87095,
  [SMALL_STATE(1730)] = 87106,
  [SMALL_STATE(1731)] = 87117,
  [SMALL_STATE(1732)] = 87128,
  [SMALL_STATE(1733)] = 87139,
  [SMALL_STATE(1734)] = 87150,
  [SMALL_STATE(1735)] = 87161,
  [SMALL_STATE(1736)] = 87172,
  [SMALL_STATE(1737)] = 87183,
  [SMALL_STATE(1738)] = 87194,
  [SMALL_STATE(1739)] = 87211,
  [SMALL_STATE(1740)] = 87222,
  [SMALL_STATE(1741)] = 87239,
  [SMALL_STATE(1742)] = 87250,
  [SMALL_STATE(1743)] = 87261,
  [SMALL_STATE(1744)] = 87272,
  [SMALL_STATE(1745)] = 87287,
  [SMALL_STATE(1746)] = 87304,
  [SMALL_STATE(1747)] = 87315,
  [SMALL_STATE(1748)] = 87326,
  [SMALL_STATE(1749)] = 87341,
  [SMALL_STATE(1750)] = 87352,
  [SMALL_STATE(1751)] = 87363,
  [SMALL_STATE(1752)] = 87374,
  [SMALL_STATE(1753)] = 87385,
  [SMALL_STATE(1754)] = 87396,
  [SMALL_STATE(1755)] = 87407,
  [SMALL_STATE(1756)] = 87418,
  [SMALL_STATE(1757)] = 87435,
  [SMALL_STATE(1758)] = 87446,
  [SMALL_STATE(1759)] = 87463,
  [SMALL_STATE(1760)] = 87474,
  [SMALL_STATE(1761)] = 87491,
  [SMALL_STATE(1762)] = 87502,
  [SMALL_STATE(1763)] = 87519,
  [SMALL_STATE(1764)] = 87536,
  [SMALL_STATE(1765)] = 87551,
  [SMALL_STATE(1766)] = 87562,
  [SMALL_STATE(1767)] = 87579,
  [SMALL_STATE(1768)] = 87596,
  [SMALL_STATE(1769)] = 87607,
  [SMALL_STATE(1770)] = 87622,
  [SMALL_STATE(1771)] = 87633,
  [SMALL_STATE(1772)] = 87648,
  [SMALL_STATE(1773)] = 87661,
  [SMALL_STATE(1774)] = 87672,
  [SMALL_STATE(1775)] = 87683,
  [SMALL_STATE(1776)] = 87694,
  [SMALL_STATE(1777)] = 87705,
  [SMALL_STATE(1778)] = 87716,
  [SMALL_STATE(1779)] = 87727,
  [SMALL_STATE(1780)] = 87744,
  [SMALL_STATE(1781)] = 87761,
  [SMALL_STATE(1782)] = 87772,
  [SMALL_STATE(1783)] = 87783,
  [SMALL_STATE(1784)] = 87794,
  [SMALL_STATE(1785)] = 87805,
  [SMALL_STATE(1786)] = 87816,
  [SMALL_STATE(1787)] = 87833,
  [SMALL_STATE(1788)] = 87844,
  [SMALL_STATE(1789)] = 87859,
  [SMALL_STATE(1790)] = 87870,
  [SMALL_STATE(1791)] = 87881,
  [SMALL_STATE(1792)] = 87892,
  [SMALL_STATE(1793)] = 87903,
  [SMALL_STATE(1794)] = 87914,
  [SMALL_STATE(1795)] = 87931,
  [SMALL_STATE(1796)] = 87948,
  [SMALL_STATE(1797)] = 87959,
  [SMALL_STATE(1798)] = 87970,
  [SMALL_STATE(1799)] = 87981,
  [SMALL_STATE(1800)] = 87996,
  [SMALL_STATE(1801)] = 88011,
  [SMALL_STATE(1802)] = 88026,
  [SMALL_STATE(1803)] = 88041,
  [SMALL_STATE(1804)] = 88052,
  [SMALL_STATE(1805)] = 88065,
  [SMALL_STATE(1806)] = 88076,
  [SMALL_STATE(1807)] = 88093,
  [SMALL_STATE(1808)] = 88103,
  [SMALL_STATE(1809)] = 88117,
  [SMALL_STATE(1810)] = 88131,
  [SMALL_STATE(1811)] = 88145,
  [SMALL_STATE(1812)] = 88159,
  [SMALL_STATE(1813)] = 88173,
  [SMALL_STATE(1814)] = 88187,
  [SMALL_STATE(1815)] = 88199,
  [SMALL_STATE(1816)] = 88213,
  [SMALL_STATE(1817)] = 88227,
  [SMALL_STATE(1818)] = 88239,
  [SMALL_STATE(1819)] = 88253,
  [SMALL_STATE(1820)] = 88267,
  [SMALL_STATE(1821)] = 88281,
  [SMALL_STATE(1822)] = 88295,
  [SMALL_STATE(1823)] = 88309,
  [SMALL_STATE(1824)] = 88323,
  [SMALL_STATE(1825)] = 88335,
  [SMALL_STATE(1826)] = 88349,
  [SMALL_STATE(1827)] = 88363,
  [SMALL_STATE(1828)] = 88377,
  [SMALL_STATE(1829)] = 88391,
  [SMALL_STATE(1830)] = 88405,
  [SMALL_STATE(1831)] = 88419,
  [SMALL_STATE(1832)] = 88433,
  [SMALL_STATE(1833)] = 88447,
  [SMALL_STATE(1834)] = 88461,
  [SMALL_STATE(1835)] = 88475,
  [SMALL_STATE(1836)] = 88489,
  [SMALL_STATE(1837)] = 88503,
  [SMALL_STATE(1838)] = 88517,
  [SMALL_STATE(1839)] = 88531,
  [SMALL_STATE(1840)] = 88545,
  [SMALL_STATE(1841)] = 88559,
  [SMALL_STATE(1842)] = 88573,
  [SMALL_STATE(1843)] = 88587,
  [SMALL_STATE(1844)] = 88601,
  [SMALL_STATE(1845)] = 88615,
  [SMALL_STATE(1846)] = 88629,
  [SMALL_STATE(1847)] = 88643,
  [SMALL_STATE(1848)] = 88657,
  [SMALL_STATE(1849)] = 88671,
  [SMALL_STATE(1850)] = 88685,
  [SMALL_STATE(1851)] = 88699,
  [SMALL_STATE(1852)] = 88713,
  [SMALL_STATE(1853)] = 88727,
  [SMALL_STATE(1854)] = 88741,
  [SMALL_STATE(1855)] = 88755,
  [SMALL_STATE(1856)] = 88769,
  [SMALL_STATE(1857)] = 88783,
  [SMALL_STATE(1858)] = 88797,
  [SMALL_STATE(1859)] = 88811,
  [SMALL_STATE(1860)] = 88825,
  [SMALL_STATE(1861)] = 88839,
  [SMALL_STATE(1862)] = 88853,
  [SMALL_STATE(1863)] = 88867,
  [SMALL_STATE(1864)] = 88881,
  [SMALL_STATE(1865)] = 88895,
  [SMALL_STATE(1866)] = 88909,
  [SMALL_STATE(1867)] = 88923,
  [SMALL_STATE(1868)] = 88937,
  [SMALL_STATE(1869)] = 88951,
  [SMALL_STATE(1870)] = 88965,
  [SMALL_STATE(1871)] = 88979,
  [SMALL_STATE(1872)] = 88993,
  [SMALL_STATE(1873)] = 89007,
  [SMALL_STATE(1874)] = 89021,
  [SMALL_STATE(1875)] = 89035,
  [SMALL_STATE(1876)] = 89047,
  [SMALL_STATE(1877)] = 89061,
  [SMALL_STATE(1878)] = 89075,
  [SMALL_STATE(1879)] = 89089,
  [SMALL_STATE(1880)] = 89103,
  [SMALL_STATE(1881)] = 89117,
  [SMALL_STATE(1882)] = 89131,
  [SMALL_STATE(1883)] = 89145,
  [SMALL_STATE(1884)] = 89159,
  [SMALL_STATE(1885)] = 89173,
  [SMALL_STATE(1886)] = 89187,
  [SMALL_STATE(1887)] = 89201,
  [SMALL_STATE(1888)] = 89213,
  [SMALL_STATE(1889)] = 89227,
  [SMALL_STATE(1890)] = 89241,
  [SMALL_STATE(1891)] = 89255,
  [SMALL_STATE(1892)] = 89269,
  [SMALL_STATE(1893)] = 89283,
  [SMALL_STATE(1894)] = 89297,
  [SMALL_STATE(1895)] = 89311,
  [SMALL_STATE(1896)] = 89325,
  [SMALL_STATE(1897)] = 89339,
  [SMALL_STATE(1898)] = 89353,
  [SMALL_STATE(1899)] = 89367,
  [SMALL_STATE(1900)] = 89377,
  [SMALL_STATE(1901)] = 89391,
  [SMALL_STATE(1902)] = 89405,
  [SMALL_STATE(1903)] = 89419,
  [SMALL_STATE(1904)] = 89433,
  [SMALL_STATE(1905)] = 89447,
  [SMALL_STATE(1906)] = 89461,
  [SMALL_STATE(1907)] = 89471,
  [SMALL_STATE(1908)] = 89485,
  [SMALL_STATE(1909)] = 89499,
  [SMALL_STATE(1910)] = 89513,
  [SMALL_STATE(1911)] = 89527,
  [SMALL_STATE(1912)] = 89541,
  [SMALL_STATE(1913)] = 89555,
  [SMALL_STATE(1914)] = 89569,
  [SMALL_STATE(1915)] = 89579,
  [SMALL_STATE(1916)] = 89593,
  [SMALL_STATE(1917)] = 89607,
  [SMALL_STATE(1918)] = 89621,
  [SMALL_STATE(1919)] = 89635,
  [SMALL_STATE(1920)] = 89647,
  [SMALL_STATE(1921)] = 89659,
  [SMALL_STATE(1922)] = 89673,
  [SMALL_STATE(1923)] = 89683,
  [SMALL_STATE(1924)] = 89697,
  [SMALL_STATE(1925)] = 89711,
  [SMALL_STATE(1926)] = 89725,
  [SMALL_STATE(1927)] = 89739,
  [SMALL_STATE(1928)] = 89753,
  [SMALL_STATE(1929)] = 89767,
  [SMALL_STATE(1930)] = 89781,
  [SMALL_STATE(1931)] = 89793,
  [SMALL_STATE(1932)] = 89807,
  [SMALL_STATE(1933)] = 89821,
  [SMALL_STATE(1934)] = 89835,
  [SMALL_STATE(1935)] = 89849,
  [SMALL_STATE(1936)] = 89863,
  [SMALL_STATE(1937)] = 89875,
  [SMALL_STATE(1938)] = 89889,
  [SMALL_STATE(1939)] = 89903,
  [SMALL_STATE(1940)] = 89917,
  [SMALL_STATE(1941)] = 89931,
  [SMALL_STATE(1942)] = 89945,
  [SMALL_STATE(1943)] = 89959,
  [SMALL_STATE(1944)] = 89973,
  [SMALL_STATE(1945)] = 89985,
  [SMALL_STATE(1946)] = 89999,
  [SMALL_STATE(1947)] = 90013,
  [SMALL_STATE(1948)] = 90027,
  [SMALL_STATE(1949)] = 90041,
  [SMALL_STATE(1950)] = 90055,
  [SMALL_STATE(1951)] = 90069,
  [SMALL_STATE(1952)] = 90079,
  [SMALL_STATE(1953)] = 90091,
  [SMALL_STATE(1954)] = 90105,
  [SMALL_STATE(1955)] = 90119,
  [SMALL_STATE(1956)] = 90133,
  [SMALL_STATE(1957)] = 90147,
  [SMALL_STATE(1958)] = 90157,
  [SMALL_STATE(1959)] = 90171,
  [SMALL_STATE(1960)] = 90185,
  [SMALL_STATE(1961)] = 90199,
  [SMALL_STATE(1962)] = 90213,
  [SMALL_STATE(1963)] = 90227,
  [SMALL_STATE(1964)] = 90241,
  [SMALL_STATE(1965)] = 90255,
  [SMALL_STATE(1966)] = 90269,
  [SMALL_STATE(1967)] = 90283,
  [SMALL_STATE(1968)] = 90297,
  [SMALL_STATE(1969)] = 90311,
  [SMALL_STATE(1970)] = 90325,
  [SMALL_STATE(1971)] = 90339,
  [SMALL_STATE(1972)] = 90353,
  [SMALL_STATE(1973)] = 90367,
  [SMALL_STATE(1974)] = 90381,
  [SMALL_STATE(1975)] = 90393,
  [SMALL_STATE(1976)] = 90407,
  [SMALL_STATE(1977)] = 90421,
  [SMALL_STATE(1978)] = 90435,
  [SMALL_STATE(1979)] = 90449,
  [SMALL_STATE(1980)] = 90463,
  [SMALL_STATE(1981)] = 90477,
  [SMALL_STATE(1982)] = 90491,
  [SMALL_STATE(1983)] = 90505,
  [SMALL_STATE(1984)] = 90519,
  [SMALL_STATE(1985)] = 90533,
  [SMALL_STATE(1986)] = 90547,
  [SMALL_STATE(1987)] = 90561,
  [SMALL_STATE(1988)] = 90571,
  [SMALL_STATE(1989)] = 90585,
  [SMALL_STATE(1990)] = 90597,
  [SMALL_STATE(1991)] = 90611,
  [SMALL_STATE(1992)] = 90625,
  [SMALL_STATE(1993)] = 90639,
  [SMALL_STATE(1994)] = 90653,
  [SMALL_STATE(1995)] = 90667,
  [SMALL_STATE(1996)] = 90679,
  [SMALL_STATE(1997)] = 90691,
  [SMALL_STATE(1998)] = 90705,
  [SMALL_STATE(1999)] = 90719,
  [SMALL_STATE(2000)] = 90733,
  [SMALL_STATE(2001)] = 90747,
  [SMALL_STATE(2002)] = 90757,
  [SMALL_STATE(2003)] = 90767,
  [SMALL_STATE(2004)] = 90779,
  [SMALL_STATE(2005)] = 90793,
  [SMALL_STATE(2006)] = 90807,
  [SMALL_STATE(2007)] = 90819,
  [SMALL_STATE(2008)] = 90833,
  [SMALL_STATE(2009)] = 90847,
  [SMALL_STATE(2010)] = 90861,
  [SMALL_STATE(2011)] = 90875,
  [SMALL_STATE(2012)] = 90889,
  [SMALL_STATE(2013)] = 90903,
  [SMALL_STATE(2014)] = 90917,
  [SMALL_STATE(2015)] = 90926,
  [SMALL_STATE(2016)] = 90935,
  [SMALL_STATE(2017)] = 90944,
  [SMALL_STATE(2018)] = 90953,
  [SMALL_STATE(2019)] = 90962,
  [SMALL_STATE(2020)] = 90973,
  [SMALL_STATE(2021)] = 90984,
  [SMALL_STATE(2022)] = 90993,
  [SMALL_STATE(2023)] = 91004,
  [SMALL_STATE(2024)] = 91015,
  [SMALL_STATE(2025)] = 91024,
  [SMALL_STATE(2026)] = 91035,
  [SMALL_STATE(2027)] = 91044,
  [SMALL_STATE(2028)] = 91053,
  [SMALL_STATE(2029)] = 91064,
  [SMALL_STATE(2030)] = 91075,
  [SMALL_STATE(2031)] = 91086,
  [SMALL_STATE(2032)] = 91097,
  [SMALL_STATE(2033)] = 91106,
  [SMALL_STATE(2034)] = 91115,
  [SMALL_STATE(2035)] = 91124,
  [SMALL_STATE(2036)] = 91133,
  [SMALL_STATE(2037)] = 91142,
  [SMALL_STATE(2038)] = 91151,
  [SMALL_STATE(2039)] = 91160,
  [SMALL_STATE(2040)] = 91169,
  [SMALL_STATE(2041)] = 91178,
  [SMALL_STATE(2042)] = 91187,
  [SMALL_STATE(2043)] = 91196,
  [SMALL_STATE(2044)] = 91205,
  [SMALL_STATE(2045)] = 91214,
  [SMALL_STATE(2046)] = 91223,
  [SMALL_STATE(2047)] = 91234,
  [SMALL_STATE(2048)] = 91243,
  [SMALL_STATE(2049)] = 91252,
  [SMALL_STATE(2050)] = 91261,
  [SMALL_STATE(2051)] = 91270,
  [SMALL_STATE(2052)] = 91279,
  [SMALL_STATE(2053)] = 91288,
  [SMALL_STATE(2054)] = 91297,
  [SMALL_STATE(2055)] = 91306,
  [SMALL_STATE(2056)] = 91315,
  [SMALL_STATE(2057)] = 91324,
  [SMALL_STATE(2058)] = 91333,
  [SMALL_STATE(2059)] = 91342,
  [SMALL_STATE(2060)] = 91351,
  [SMALL_STATE(2061)] = 91362,
  [SMALL_STATE(2062)] = 91371,
  [SMALL_STATE(2063)] = 91380,
  [SMALL_STATE(2064)] = 91389,
  [SMALL_STATE(2065)] = 91398,
  [SMALL_STATE(2066)] = 91409,
  [SMALL_STATE(2067)] = 91420,
  [SMALL_STATE(2068)] = 91429,
  [SMALL_STATE(2069)] = 91438,
  [SMALL_STATE(2070)] = 91447,
  [SMALL_STATE(2071)] = 91456,
  [SMALL_STATE(2072)] = 91467,
  [SMALL_STATE(2073)] = 91478,
  [SMALL_STATE(2074)] = 91487,
  [SMALL_STATE(2075)] = 91496,
  [SMALL_STATE(2076)] = 91507,
  [SMALL_STATE(2077)] = 91516,
  [SMALL_STATE(2078)] = 91527,
  [SMALL_STATE(2079)] = 91536,
  [SMALL_STATE(2080)] = 91547,
  [SMALL_STATE(2081)] = 91556,
  [SMALL_STATE(2082)] = 91567,
  [SMALL_STATE(2083)] = 91576,
  [SMALL_STATE(2084)] = 91587,
  [SMALL_STATE(2085)] = 91598,
  [SMALL_STATE(2086)] = 91609,
  [SMALL_STATE(2087)] = 91620,
  [SMALL_STATE(2088)] = 91631,
  [SMALL_STATE(2089)] = 91640,
  [SMALL_STATE(2090)] = 91649,
  [SMALL_STATE(2091)] = 91658,
  [SMALL_STATE(2092)] = 91669,
  [SMALL_STATE(2093)] = 91678,
  [SMALL_STATE(2094)] = 91687,
  [SMALL_STATE(2095)] = 91696,
  [SMALL_STATE(2096)] = 91705,
  [SMALL_STATE(2097)] = 91714,
  [SMALL_STATE(2098)] = 91723,
  [SMALL_STATE(2099)] = 91732,
  [SMALL_STATE(2100)] = 91741,
  [SMALL_STATE(2101)] = 91750,
  [SMALL_STATE(2102)] = 91759,
  [SMALL_STATE(2103)] = 91768,
  [SMALL_STATE(2104)] = 91776,
  [SMALL_STATE(2105)] = 91784,
  [SMALL_STATE(2106)] = 91792,
  [SMALL_STATE(2107)] = 91800,
  [SMALL_STATE(2108)] = 91808,
  [SMALL_STATE(2109)] = 91816,
  [SMALL_STATE(2110)] = 91824,
  [SMALL_STATE(2111)] = 91832,
  [SMALL_STATE(2112)] = 91840,
  [SMALL_STATE(2113)] = 91848,
  [SMALL_STATE(2114)] = 91856,
  [SMALL_STATE(2115)] = 91864,
  [SMALL_STATE(2116)] = 91872,
  [SMALL_STATE(2117)] = 91880,
  [SMALL_STATE(2118)] = 91888,
  [SMALL_STATE(2119)] = 91896,
  [SMALL_STATE(2120)] = 91904,
  [SMALL_STATE(2121)] = 91912,
  [SMALL_STATE(2122)] = 91920,
  [SMALL_STATE(2123)] = 91928,
  [SMALL_STATE(2124)] = 91936,
  [SMALL_STATE(2125)] = 91944,
  [SMALL_STATE(2126)] = 91952,
  [SMALL_STATE(2127)] = 91960,
  [SMALL_STATE(2128)] = 91968,
  [SMALL_STATE(2129)] = 91976,
  [SMALL_STATE(2130)] = 91984,
  [SMALL_STATE(2131)] = 91992,
  [SMALL_STATE(2132)] = 92000,
  [SMALL_STATE(2133)] = 92008,
  [SMALL_STATE(2134)] = 92016,
  [SMALL_STATE(2135)] = 92024,
  [SMALL_STATE(2136)] = 92032,
  [SMALL_STATE(2137)] = 92040,
  [SMALL_STATE(2138)] = 92048,
  [SMALL_STATE(2139)] = 92056,
  [SMALL_STATE(2140)] = 92064,
  [SMALL_STATE(2141)] = 92072,
  [SMALL_STATE(2142)] = 92080,
  [SMALL_STATE(2143)] = 92088,
  [SMALL_STATE(2144)] = 92096,
  [SMALL_STATE(2145)] = 92104,
  [SMALL_STATE(2146)] = 92112,
  [SMALL_STATE(2147)] = 92120,
  [SMALL_STATE(2148)] = 92128,
  [SMALL_STATE(2149)] = 92136,
  [SMALL_STATE(2150)] = 92144,
  [SMALL_STATE(2151)] = 92152,
  [SMALL_STATE(2152)] = 92160,
  [SMALL_STATE(2153)] = 92168,
  [SMALL_STATE(2154)] = 92176,
  [SMALL_STATE(2155)] = 92184,
  [SMALL_STATE(2156)] = 92192,
  [SMALL_STATE(2157)] = 92200,
  [SMALL_STATE(2158)] = 92208,
  [SMALL_STATE(2159)] = 92216,
  [SMALL_STATE(2160)] = 92224,
  [SMALL_STATE(2161)] = 92232,
  [SMALL_STATE(2162)] = 92240,
  [SMALL_STATE(2163)] = 92248,
  [SMALL_STATE(2164)] = 92256,
  [SMALL_STATE(2165)] = 92264,
  [SMALL_STATE(2166)] = 92272,
  [SMALL_STATE(2167)] = 92280,
  [SMALL_STATE(2168)] = 92288,
  [SMALL_STATE(2169)] = 92296,
  [SMALL_STATE(2170)] = 92304,
  [SMALL_STATE(2171)] = 92312,
  [SMALL_STATE(2172)] = 92320,
  [SMALL_STATE(2173)] = 92328,
  [SMALL_STATE(2174)] = 92336,
  [SMALL_STATE(2175)] = 92344,
  [SMALL_STATE(2176)] = 92352,
  [SMALL_STATE(2177)] = 92360,
  [SMALL_STATE(2178)] = 92368,
  [SMALL_STATE(2179)] = 92376,
  [SMALL_STATE(2180)] = 92384,
  [SMALL_STATE(2181)] = 92392,
  [SMALL_STATE(2182)] = 92400,
  [SMALL_STATE(2183)] = 92408,
  [SMALL_STATE(2184)] = 92416,
  [SMALL_STATE(2185)] = 92424,
  [SMALL_STATE(2186)] = 92432,
  [SMALL_STATE(2187)] = 92440,
  [SMALL_STATE(2188)] = 92448,
  [SMALL_STATE(2189)] = 92456,
  [SMALL_STATE(2190)] = 92464,
  [SMALL_STATE(2191)] = 92472,
  [SMALL_STATE(2192)] = 92480,
  [SMALL_STATE(2193)] = 92488,
  [SMALL_STATE(2194)] = 92496,
  [SMALL_STATE(2195)] = 92504,
  [SMALL_STATE(2196)] = 92512,
  [SMALL_STATE(2197)] = 92520,
  [SMALL_STATE(2198)] = 92528,
  [SMALL_STATE(2199)] = 92536,
  [SMALL_STATE(2200)] = 92544,
  [SMALL_STATE(2201)] = 92552,
  [SMALL_STATE(2202)] = 92560,
  [SMALL_STATE(2203)] = 92568,
  [SMALL_STATE(2204)] = 92576,
  [SMALL_STATE(2205)] = 92584,
  [SMALL_STATE(2206)] = 92592,
  [SMALL_STATE(2207)] = 92600,
  [SMALL_STATE(2208)] = 92608,
  [SMALL_STATE(2209)] = 92616,
  [SMALL_STATE(2210)] = 92624,
  [SMALL_STATE(2211)] = 92632,
  [SMALL_STATE(2212)] = 92640,
  [SMALL_STATE(2213)] = 92648,
  [SMALL_STATE(2214)] = 92656,
  [SMALL_STATE(2215)] = 92664,
  [SMALL_STATE(2216)] = 92672,
  [SMALL_STATE(2217)] = 92680,
  [SMALL_STATE(2218)] = 92688,
  [SMALL_STATE(2219)] = 92696,
  [SMALL_STATE(2220)] = 92704,
  [SMALL_STATE(2221)] = 92712,
  [SMALL_STATE(2222)] = 92720,
  [SMALL_STATE(2223)] = 92728,
  [SMALL_STATE(2224)] = 92736,
  [SMALL_STATE(2225)] = 92744,
  [SMALL_STATE(2226)] = 92752,
  [SMALL_STATE(2227)] = 92760,
  [SMALL_STATE(2228)] = 92768,
  [SMALL_STATE(2229)] = 92776,
  [SMALL_STATE(2230)] = 92784,
  [SMALL_STATE(2231)] = 92792,
  [SMALL_STATE(2232)] = 92800,
  [SMALL_STATE(2233)] = 92808,
  [SMALL_STATE(2234)] = 92816,
  [SMALL_STATE(2235)] = 92824,
  [SMALL_STATE(2236)] = 92832,
  [SMALL_STATE(2237)] = 92840,
  [SMALL_STATE(2238)] = 92848,
  [SMALL_STATE(2239)] = 92856,
  [SMALL_STATE(2240)] = 92864,
  [SMALL_STATE(2241)] = 92872,
  [SMALL_STATE(2242)] = 92880,
  [SMALL_STATE(2243)] = 92888,
  [SMALL_STATE(2244)] = 92896,
  [SMALL_STATE(2245)] = 92904,
  [SMALL_STATE(2246)] = 92912,
  [SMALL_STATE(2247)] = 92920,
  [SMALL_STATE(2248)] = 92928,
  [SMALL_STATE(2249)] = 92936,
  [SMALL_STATE(2250)] = 92944,
  [SMALL_STATE(2251)] = 92952,
  [SMALL_STATE(2252)] = 92960,
  [SMALL_STATE(2253)] = 92968,
  [SMALL_STATE(2254)] = 92976,
  [SMALL_STATE(2255)] = 92984,
  [SMALL_STATE(2256)] = 92992,
  [SMALL_STATE(2257)] = 93000,
  [SMALL_STATE(2258)] = 93008,
  [SMALL_STATE(2259)] = 93016,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2101),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2248),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2250),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [91] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0),
  [93] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [96] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(133),
  [99] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(669),
  [102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(47),
  [105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(341),
  [108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(422),
  [111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(246),
  [114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(340),
  [117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2102),
  [120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2101),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2097),
  [126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(429),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(48),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(294),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(576),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(426),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(295),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2248),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(296),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(440),
  [153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(123),
  [156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(421),
  [159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(658),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(125),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(418),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1270),
  [171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(899),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(899),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(442),
  [180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(1355),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(373),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(49),
  [189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(288),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(551),
  [195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(380),
  [198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(323),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2, 0, 0), SHIFT_REPEAT(2250),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1, 0, 0),
  [208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1),
  [214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1),
  [216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(237),
  [219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 1), REDUCE(sym_primary_expression, 1, 0, 1),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(618),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1, 0, 1),
  [231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 1), REDUCE(sym_primary_expression, 1, 0, 1),
  [234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 1),
  [238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(235),
  [241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(658),
  [244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), SHIFT(418),
  [247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 1),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 3, 0, 0),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_list, 2, 0, 0),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1082),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(760),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, 0, 83),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, 0, 83),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 5, 0, 71),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, 0, 71),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 7, 0, 95),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 7, 0, 95),
  [869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, 0, 84),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, 0, 84),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2, 0, 0),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 3, 0, 0),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 2, 0, 0),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 3, 0, 0),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 1, 0, 0),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2, 0, 0),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [1027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, -1, 12),
  [1029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4, 0, 0),
  [1031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, 0, 11),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2006),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3, 0, 0),
  [1053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 2, 0, 0),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 3, 0, 0),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, 0, 0),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 3, 0, 0),
  [1067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, 0, 0),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, -1, 4),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [1095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0), REDUCE(sym_primary_expression, 1, 0, 0),
  [1098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0),
  [1100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_expression_lhs, 1, 0, 0),
  [1102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0), REDUCE(sym_primary_expression, 1, 0, 0),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 1, 0, 0),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [1129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, 0, 54),
  [1131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, 0, 54),
  [1133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2, 0, 0),
  [1135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0), REDUCE(sym_tuple, 2, 0, 0),
  [1138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2, 0, 0),
  [1140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [1142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 62),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 62),
  [1148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [1150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [1152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 6, 0, 54),
  [1154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 6, 0, 54),
  [1156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 25),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 25),
  [1160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, 0, 3),
  [1162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_list_splat_pattern, 2, 0, 3),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 1), REDUCE(sym_list_splat_pattern, 2, 0, 3),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, 0, 3),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2, 0, 0),
  [1172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0), REDUCE(sym_list, 2, 0, 0),
  [1175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2, 0, 0),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [1179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 2, 0, 0),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 43),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 43),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2147),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 2),
  [1191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pattern, 1, 0, 0), REDUCE(sym_primary_expression, 1, 0, 2),
  [1194] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 2),
  [1196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 42),
  [1198] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 42),
  [1200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, 0, 35),
  [1202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, 0, 35),
  [1204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, 0, 19),
  [1206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, 0, 19),
  [1208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_type, 2, 0, 0),
  [1212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_primary_expression, 1, 0, 0), REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_splat_pattern, 2, 0, 0),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_type, 2, 0, 0),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, 0, 35),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, 0, 35),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 60),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 60),
  [1230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 60), SHIFT_REPEAT(386),
  [1233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 60), SHIFT_REPEAT(405),
  [1236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [1244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1209),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 4, 0, 0),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 4, 0, 0),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 67),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 67),
  [1256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 29),
  [1258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 29),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 76),
  [1262] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 76),
  [1264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 2, 0, 0),
  [1266] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 2, 0, 0),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 48),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 48),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1, 0, 0),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1, 0, 0),
  [1276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 5, 0, 43),
  [1278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 5, 0, 43),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 80),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 80),
  [1284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [1286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 40),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 40),
  [1292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 4, 0, 25),
  [1294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 4, 0, 25),
  [1296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 89),
  [1298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 89),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 3, 0, 0),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 3, 0, 0),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [1310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [1318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, 0, 46),
  [1320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, 0, 46),
  [1322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 61),
  [1324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 61),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 2, 0, 0),
  [1334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 50),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 50),
  [1342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 5, 0, 44),
  [1344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 5, 0, 44),
  [1346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 2, 0, 0),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 2, 0, 0),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 70),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 70),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 3, 0, 63),
  [1356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 3, 0, 63),
  [1358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 6, 0, 64),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 6, 0, 64),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 6, 0, 65),
  [1364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 6, 0, 65),
  [1366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 66),
  [1368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 66),
  [1370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 3, 0, 0),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, 0, 68),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, 0, 68),
  [1388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, 0, 69),
  [1390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, 0, 69),
  [1392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 91),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 91),
  [1396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 90),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 90),
  [1400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_block, 1, 0, 0),
  [1402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_block, 1, 0, 0),
  [1404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 4, 0, 27),
  [1406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 4, 0, 27),
  [1408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 88),
  [1410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 88),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_statement, 5, 0, 45),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_statement, 5, 0, 45),
  [1416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 4, 0, 30),
  [1418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 4, 0, 30),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, 0, 74),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, 0, 74),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 75),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 75),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, 0, 92),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, 0, 92),
  [1432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 93),
  [1434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 93),
  [1436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, 0, 94),
  [1438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, 0, 94),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorated_definition, 2, 0, 10),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorated_definition, 2, 0, 10),
  [1444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, 0, 49),
  [1446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, 0, 49),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 4, 0, 85),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 4, 0, 85),
  [1452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern_list, 3, 0, 0),
  [1454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 10, 0, 110),
  [1456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 10, 0, 110),
  [1458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 82),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 82),
  [1462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, 0, 105),
  [1464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, 0, 105),
  [1466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, 0, 104),
  [1468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, 0, 104),
  [1470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 77),
  [1472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 77),
  [1474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 41),
  [1476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 41),
  [1478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 78),
  [1480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 78),
  [1482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, 0, 103),
  [1484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, 0, 103),
  [1486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, 0, 79),
  [1488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, 0, 79),
  [1490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 59),
  [1492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 59),
  [1494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, 0, 102),
  [1496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, 0, 102),
  [1498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, 0, 81),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, 0, 81),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 2, 0, 0),
  [1504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 47),
  [1506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 47),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [1512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_separator, 1, 0, 0),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [1516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [1518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1216),
  [1520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [1522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [1524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [1526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [1528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [1530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [1536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [1538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [1540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [1546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [1548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [1550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [1552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [1554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1018),
  [1556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [1558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [1560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [1562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1099),
  [1564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [1566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(981),
  [1568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [1570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [1574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [1576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [1578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [1580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [1582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [1584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [1586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [1590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [1592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(982),
  [1596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [1598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [1600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [1602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [1604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [1608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [1610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [1612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [1614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [1616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [1618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [1622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [1624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1217),
  [1626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [1634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(609),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [1690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(625),
  [1694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [1700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, 0, 17),
  [1718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, 0, 17),
  [1720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [1722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [1726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [1748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, 0, 7),
  [1750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, 0, 7),
  [1752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 20),
  [1754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 20),
  [1756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 36),
  [1762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3, 0, 36),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [1766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [1770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, 0, 8),
  [1830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, 0, 8),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3, 0, 0),
  [1836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3, 0, 0),
  [1838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3, 0, 0),
  [1840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3, 0, 0),
  [1842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_comprehension, 4, 0, 31),
  [1844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_comprehension, 4, 0, 31),
  [1846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 2, 0, 0),
  [1848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 2, 0, 0),
  [1850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, 0, 0),
  [1852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, 0, 0),
  [1854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3, 0, 0),
  [1856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3, 0, 0),
  [1858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 3, 0, 0),
  [1860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 3, 0, 0),
  [1862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2, 0, 0),
  [1864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2, 0, 0),
  [1866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [1868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_comprehension, 4, 0, 31),
  [1900] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_comprehension, 4, 0, 31),
  [1902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4, 0, 0),
  [1904] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4, 0, 0),
  [1906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_comprehension, 4, 0, 31),
  [1908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_comprehension, 4, 0, 31),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [1912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [1914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 23),
  [1916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 23),
  [1918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 5, 0, 0),
  [1920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 5, 0, 0),
  [1922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [1924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [1926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 23),
  [1928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 23),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [1932] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [1934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 23),
  [1936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 23),
  [1938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [1940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(362),
  [1942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [1948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1532),
  [1960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [1962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2070),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [1984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [1988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [1998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2076),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [2008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [2080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [2086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2032),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [2094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [2096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1656),
  [2100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [2152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1579),
  [2154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1633),
  [2158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1690),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1688),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [2168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1675),
  [2172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [2174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 2, 0, 9),
  [2176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 2, 0, 9),
  [2178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21),
  [2180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(661),
  [2183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21),
  [2185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(2120),
  [2188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(661),
  [2191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(636),
  [2194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(2188),
  [2197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(636),
  [2200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(670),
  [2203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(2241),
  [2206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(670),
  [2209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(655),
  [2212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(2156),
  [2215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(655),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, 0, 0),
  [2220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat_pattern, 2, 0, 3),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(660),
  [2227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(2105),
  [2230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(660),
  [2233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0),
  [2235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(605),
  [2238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(627),
  [2241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(2133),
  [2244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(627),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_pattern, 3, 0, 0),
  [2251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(628),
  [2254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(2103),
  [2257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2, 0, 21), SHIFT_REPEAT(628),
  [2260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(601),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [2267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [2303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__right_hand_side, 1, 0, 0),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [2315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [2321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2, 0, 0),
  [2323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3, 0, 0),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [2337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 1, 0, 0),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1, 0, 0),
  [2345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_operator, 3, 0, 17),
  [2373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_pattern, 3, 0, 18),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_operator, 2, 0, 4),
  [2377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, 0, 0),
  [2379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 14),
  [2381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 14), SHIFT(402),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, 0, 13),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, 0, 34),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [2392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [2420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(178),
  [2423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1436),
  [2426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1436),
  [2429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2, 0, 0),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [2439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__f_expression, 1, 0, 0),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 14), SHIFT(400),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [2458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 14), SHIFT(346),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [2483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [2491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 14), SHIFT(370),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 1, 0, 0),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [2500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_not_operator, 2, 0, 4),
  [2502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_named_expression, 3, 0, 14), SHIFT(351),
  [2505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0),
  [2507] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, 0, 14), SHIFT(397),
  [2510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_pattern, 3, 0, 18),
  [2512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_operator, 3, 0, 17),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2, 0, 0),
  [2516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2107),
  [2519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_named_expression, 3, 0, 14), SHIFT(419),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_within_for_in_clause, 1, 0, 0),
  [2540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, -1, 4),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [2556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 4, 0, 0),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [2562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 2, 0, 0),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_pattern, 1, 0, 0),
  [2566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2, 0, 0),
  [2568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0),
  [2570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1341),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [2581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_statement, 2, 0, 0),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [2587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, 0, 32),
  [2589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 4, 0, 6),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [2609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_content, 1, 0, 0),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1482),
  [2615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1354),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [2630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 1, 0, 0),
  [2632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1330),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 2, 0, 0),
  [2653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2231),
  [2656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(371),
  [2659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2173),
  [2662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(512),
  [2665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0),
  [2667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2, 0, 0),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [2673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2228),
  [2676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chevron, 2, 0, 0),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, 0, 53),
  [2690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [2700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2, 0, 0), SHIFT_REPEAT(1345),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [2713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2, 0, 0),
  [2715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2, 0, 0), SHIFT_REPEAT(1482),
  [2718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2, 0, 0), SHIFT_REPEAT(1482),
  [2721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, 0, 4),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [2731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_pattern, 2, 0, 0),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [2735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(352),
  [2738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(2257),
  [2741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2, 0, 0), SHIFT_REPEAT(554),
  [2744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_with_item, 1, 1, 5), SHIFT(251),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [2763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2, 0, 0), SHIFT_REPEAT(2191),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [2774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat, 2, 0, 0),
  [2776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [2778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0),
  [2780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [2782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 4, 0, 71),
  [2784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 22),
  [2786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 22),
  [2788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, 0, 26),
  [2790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 4, 0, 0),
  [2792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(604),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 1, 1, 5),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, 0, 0),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, 0, 72),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3, 0, 0),
  [2813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_type, 3, 0, 0),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type, 3, 0, 0),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3, 0, 0),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 6, 0, 73),
  [2831] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 6, 0, 73),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, 0, 52),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [2843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, 0, 84),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, 0, 83),
  [2849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(438),
  [2852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, 0, 14),
  [2854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_pattern, 1, 0, 0),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [2872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(297),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_pattern, 2, 0, 0),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [2885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 5, 0, 0),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [2891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 58),
  [2893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, 0, 58),
  [2895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 57),
  [2897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, 0, 57),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 15),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [2911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 5, 0, 0),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat, 2, 0, 0),
  [2919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5, 0, 56),
  [2921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5, 0, 56),
  [2923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 22),
  [2925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, 0, 22),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 38),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, 0, 38),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4, 0, 39),
  [2933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4, 0, 39),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, 0, 33),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [2941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, 0, 95),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [2949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_pattern, 3, 0, 0),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, 0, 14),
  [2957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1194),
  [2960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(298),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 4, 0, 0),
  [2971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [2973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 2, 0, 0),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [2977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 3, 0, 0),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_pattern, 3, 0, 0),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 3, 0, 0),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 2, 0, 0),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2, 0, 0),
  [2995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_pattern, 2, 0, 0),
  [2997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 1, 0, 0),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 4, 0, 34),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 3, 0, 13),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [3011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 4, 0, 0),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 4, 0, 0),
  [3015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_complex_pattern, 4, 0, 0),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, 0, 86),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [3025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [3027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 2, 0, 0),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, 0, 96),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [3039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [3041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, 0, 0),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [3047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 4, 0, 98),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 2, 0, 0),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 5, 0, 0),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 5, 0, 0),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [3071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [3073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 5, 0, 96),
  [3075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [3077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [3079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [3081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 5, 0, 0),
  [3085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_pattern, 6, 0, 0),
  [3089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [3091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(196),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2, 0, 0),
  [3096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 2, 0, 0), SHIFT_REPEAT(1671),
  [3099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1195),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [3104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1200),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 5, 0, 98),
  [3109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tuple_pattern, 3, 0, 0),
  [3111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [3113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [3117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2, 0, 0),
  [3119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2, 0, 0), SHIFT_REPEAT(421),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [3130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_union_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(1197),
  [3133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__list_pattern, 3, 0, 0),
  [3135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dict_pattern, 3, 0, 86),
  [3137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [3139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [3141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [3143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [3145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [3147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [3149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 5, 0, 0),
  [3151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [3153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [3155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [3157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [3159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [3163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, 0, 0),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [3167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [3169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [3171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [3177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [3179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [3181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [3183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 5, 0, 6),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [3193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 2, 0, 60), SHIFT_REPEAT(1172),
  [3196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 2, 0, 60),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [3208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3, 0, 0),
  [3210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(379),
  [3213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, 0, 0),
  [3215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [3219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [3223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [3225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, -1, 12),
  [3227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [3231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [3233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1170),
  [3238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2, 0, 0),
  [3240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, 0, 11),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [3244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, 0, 24),
  [3246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, 0, 24), SHIFT_REPEAT(384),
  [3249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [3251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [3253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [3255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__as_pattern, 3, 0, 0),
  [3257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [3259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [3261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [3263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [3265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [3267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [3269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1, 0, 0),
  [3273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__key_value_pattern, 3, 0, 32),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [3287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2, 0, 0),
  [3289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(335),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [3328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(603),
  [3331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(435),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [3338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, 0, 28), SHIFT_REPEAT(401),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_statement_repeat1, 2, 0, 28),
  [3343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [3345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [3347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [3349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [3351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [3353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [3355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, 0, 97), SHIFT_REPEAT(1193),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, 0, 97),
  [3383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [3403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__patterns, 1, 0, 0),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [3413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(337),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [3430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [3441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [3455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [3457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2, 0, 0), SHIFT_REPEAT(260),
  [3460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2, 0, 0),
  [3462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(310),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [3467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [3483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [3489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1291),
  [3492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, 0, 0),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [3496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1168),
  [3499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(600),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [3512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(1292),
  [3515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2, 0, 0), SHIFT_REPEAT(325),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [3522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_case_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1169),
  [3525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [3527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [3529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [3531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [3533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [3535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [3537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [3539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [3541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [3543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__patterns_repeat1, 2, 0, 0), SHIFT_REPEAT(602),
  [3546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2, 0, 0), SHIFT_REPEAT(94),
  [3549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2, 0, 0),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [3565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 1, 0, 37),
  [3567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_format_specifier_repeat1, 1, 0, 37),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [3577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(203),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [3660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 3, 0, 0),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, 0, 55), SHIFT_REPEAT(312),
  [3669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2, 0, 55),
  [3671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [3673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [3677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [3679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [3681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 2, 0, 6),
  [3683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [3685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [3687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 1, 0, 0),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [3691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [3693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [3697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [3699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [3705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [3707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 16),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, 0, 106),
  [3711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, 0, 113),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 8, 0, 114),
  [3715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [3719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [3721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [3725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [3727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [3729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [3731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__match_block_repeat1, 1, 0, 40),
  [3735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, 0, 109),
  [3737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [3741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1695),
  [3743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [3745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1711),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [3749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [3751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [3753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [3755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, 0, 108),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 5, 0, 51),
  [3759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 6, 0, 107),
  [3761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 23),
  [3763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment, 3, 0, 17),
  [3765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [3767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [3771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_separator, 1, 0, 0),
  [3773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, 0, 101),
  [3775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, 0, 100),
  [3777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 5, 0, 99),
  [3779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, 0, 112),
  [3781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 7, 0, 111),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [3791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [3795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, 0, 23),
  [3797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, 0, 0),
  [3799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1725),
  [3801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [3805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [3809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [3811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [3815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [3817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1715),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1595),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [3827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1622),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [3835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [3839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_clause, 4, 0, 87),
  [3841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dict_pattern_repeat1, 2, 0, 86),
  [3843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1, 0, 0),
  [3845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1, 0, 0),
  [3847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pass_statement, 1, 0, 0),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [3883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 1, 0, 0),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [3891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 5, 0, 0),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [3907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [3909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [3911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [3913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [3915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [3917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [3919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [3921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [3923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [3925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [3929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [3947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_clause, 4, 0, 0),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [3953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [3957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [3959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [3961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [3963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [3967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [3969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [3971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [3973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [3975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [3977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [3979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [3983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [3985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [3987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [3989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [3991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [3993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [3995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [3997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [3999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [4001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [4003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [4005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [4009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [4049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [4057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [4063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [4075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [4083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [4085] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [4095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [4099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token_string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token_escape_interpolation = 5,
  ts_external_token_string_end = 6,
  ts_external_token_comment = 7,
  ts_external_token_RBRACK = 8,
  ts_external_token_RPAREN = 9,
  ts_external_token_RBRACE = 10,
  ts_external_token_except = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token_string_start] = sym_string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token_escape_interpolation] = sym_escape_interpolation,
  [ts_external_token_string_end] = sym_string_end,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_RPAREN] = anon_sym_RPAREN,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_except] = anon_sym_except,
};

static const bool ts_external_scanner_states[17][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_RPAREN] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_except] = true,
  },
  [2] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
  },
  [6] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [7] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [8] = {
    [ts_external_token_string_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [9] = {
    [ts_external_token__newline] = true,
    [ts_external_token_comment] = true,
  },
  [10] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACE] = true,
  },
  [11] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RPAREN] = true,
  },
  [12] = {
    [ts_external_token_comment] = true,
  },
  [13] = {
    [ts_external_token_comment] = true,
    [ts_external_token_RBRACK] = true,
  },
  [14] = {
    [ts_external_token__string_content] = true,
    [ts_external_token_escape_interpolation] = true,
    [ts_external_token_string_end] = true,
    [ts_external_token_comment] = true,
  },
  [15] = {
    [ts_external_token__dedent] = true,
    [ts_external_token_comment] = true,
  },
  [16] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token_comment] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_starlark_external_scanner_create(void);
void tree_sitter_starlark_external_scanner_destroy(void *);
bool tree_sitter_starlark_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_starlark_external_scanner_serialize(void *, char *);
void tree_sitter_starlark_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_starlark(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_starlark_external_scanner_create,
      tree_sitter_starlark_external_scanner_destroy,
      tree_sitter_starlark_external_scanner_scan,
      tree_sitter_starlark_external_scanner_serialize,
      tree_sitter_starlark_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
